﻿--[[
$Id: LibBabble-SubZone-3.0.lua 154 2013-05-21 16:44:57Z arith $
Name: LibBabble-SubZone-3.0
Revision: $Rev: 154 $
Maintainers: arith, dynaletik
Last updated by: $Author: arith $
Website: http://www.wowace.com/addons/libbabble-subzone-3-0/
Dependencies: None
License: MIT
]]

local MAJOR_VERSION = "LibBabble-SubZone-3.0"
local MINOR_VERSION = 90000 + tonumber(("$Rev: 154 $"):match("%d+"))

if not LibStub then error(MAJOR_VERSION .. " requires LibStub.") end
local lib = LibStub("LibBabble-3.0"):New(MAJOR_VERSION, MINOR_VERSION)
if not lib then return end

local GAME_LOCALE = GetLocale()

-- Notes: Do not manually edit the translation here, as it may be overwritten by WoWAce localization automation tool
-- To revise translation, please visit: http://www.wowace.com/addons/libbabble-subzone-3-0/localization/

lib:SetBaseTranslations 
{
	["7th Legion Base Camp"] = "7th Legion Base Camp",
	["7th Legion Front"] = "7th Legion Front",
	["7th Legion Submarine"] = "7th Legion Submarine",
	["Abandoned Armory"] = "Abandoned Armory",
	["Abandoned Camp"] = "Abandoned Camp",
	["Abandoned Mine"] = "Abandoned Mine",
	["Abandoned Reef"] = "Abandoned Reef",
	["Above the Frozen Sea"] = "Above the Frozen Sea",
	["A Brewing Storm"] = "A Brewing Storm",
	["Abyssal Breach"] = "Abyssal Breach",
	["Abyssal Depths"] = "Abyssal Depths",
	["Abyssal Halls"] = "Abyssal Halls",
	["Abyssal Maw"] = "Abyssal Maw",
	["Abyssal Maw Exterior"] = "Abyssal Maw Exterior",
	["Abyssal Sands"] = "Abyssal Sands",
	["Abyssion's Lair"] = "Abyssion's Lair",
	["Access Shaft Zeon"] = "Access Shaft Zeon",
	["Acherus: The Ebon Hold"] = "Acherus: The Ebon Hold",
	["Addle's Stead"] = "Addle's Stead",
	["Aderic's Repose"] = "Aderic's Repose",
	["Aerie Peak"] = "Aerie Peak",
	["Aeris Landing"] = "Aeris Landing",
	["Agamand Family Crypt"] = "Agamand Family Crypt",
	["Agamand Mills"] = "Agamand Mills",
	["Agmar's Hammer"] = "Agmar's Hammer",
	["Agmond's End"] = "Agmond's End",
	["Agol'watha"] = "Agol'watha",
	["A Hero's Welcome"] = "A Hero's Welcome",
	["Ahn'kahet: The Old Kingdom"] = "Ahn'kahet: The Old Kingdom",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Ahn'kahet: The Old Kingdom Entrance",
	["Ahn Qiraj"] = "Ahn Qiraj",
	["Ahn'Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj Temple"] = "Ahn'Qiraj Temple",
	["Ahn'Qiraj Terrace"] = "Ahn'Qiraj Terrace",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ahn'Qiraj: The Fallen Kingdom",
	["Akhenet Fields"] = "Akhenet Fields",
	["Aku'mai's Lair"] = "Aku'mai's Lair",
	["Alabaster Shelf"] = "Alabaster Shelf",
	["Alcaz Island"] = "Alcaz Island",
	["Aldor Rise"] = "Aldor Rise",
	Aldrassil = "Aldrassil",
	["Aldur'thar: The Desolation Gate"] = "Aldur'thar: The Desolation Gate",
	["Alexston Farmstead"] = "Alexston Farmstead",
	["Algaz Gate"] = "Algaz Gate",
	["Algaz Station"] = "Algaz Station",
	["A Little Patience"] = "A Little Patience",
	["Allen Farmstead"] = "Allen Farmstead",
	["Allerian Post"] = "Allerian Post",
	["Allerian Stronghold"] = "Allerian Stronghold",
	["Alliance Base"] = "Alliance Base",
	["Alliance Beach Daily Area"] = "Alliance Beach Daily Area",
	["Alliance Beachhead"] = "Alliance Beachhead",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Alliance Hub - Mogu Island Progression Scenario",
	["Alliance Keep"] = "Alliance Keep",
	["Alliance Mercenary Ship to Vashj'ir"] = "Alliance Mercenary Ship to Vashj'ir",
	["Alliance PVP Barracks"] = "Alliance PVP Barracks",
	["All That Glitters Prospecting Co."] = "All That Glitters Prospecting Co.",
	["Alonsus Chapel"] = "Alonsus Chapel",
	["Altar of Ascension"] = "Altar of Ascension",
	["Altar of Har'koa"] = "Altar of Har'koa",
	["Altar of Mam'toth"] = "Altar of Mam'toth",
	["Altar of Quetz'lun"] = "Altar of Quetz'lun",
	["Altar of Rhunok"] = "Altar of Rhunok",
	["Altar of Sha'tar"] = "Altar of Sha'tar",
	["Altar of Sseratus"] = "Altar of Sseratus",
	["Altar of Storms"] = "Altar of Storms",
	["Altar of the Blood God"] = "Altar of the Blood God",
	["Altar of Twilight"] = "Altar of Twilight",
	["Alterac Mountains"] = "Alterac Mountains",
	["Alterac Valley"] = "Alterac Valley",
	["Alther's Mill"] = "Alther's Mill",
	["Amani Catacombs"] = "Amani Catacombs",
	["Amani Mountains"] = "Amani Mountains",
	["Amani Pass"] = "Amani Pass",
	["Amberfly Bog"] = "Amberfly Bog",
	["Amberglow Hollow"] = "Amberglow Hollow",
	["Amber Ledge"] = "Amber Ledge",
	Ambermarsh = "Ambermarsh",
	Ambermill = "Ambermill",
	["Amberpine Lodge"] = "Amberpine Lodge",
	["Amber Quarry"] = "Amber Quarry",
	["Amber Research Sanctum"] = "Amber Research Sanctum",
	["Ambershard Cavern"] = "Ambershard Cavern",
	["Amberstill Ranch"] = "Amberstill Ranch",
	["Amberweb Pass"] = "Amberweb Pass",
	["Ameth'Aran"] = "Ameth'Aran",
	["Ammen Fields"] = "Ammen Fields",
	["Ammen Ford"] = "Ammen Ford",
	["Ammen Vale"] = "Ammen Vale",
	["Amphitheater of Anguish"] = "Amphitheater of Anguish",
	["Ampitheater of Anguish"] = "Ampitheater of Anguish",
	["Ancestral Grounds"] = "Ancestral Grounds",
	["Ancestral Rise"] = "Ancestral Rise",
	["Ancient Courtyard"] = "Ancient Courtyard",
	["Ancient Zul'Gurub"] = "Ancient Zul'Gurub",
	["An'daroth"] = "An'daroth",
	["Andilien Estate"] = "Andilien Estate",
	Andorhal = "Andorhal",
	Andruk = "Andruk",
	["Angerfang Encampment"] = "Angerfang Encampment",
	["Angkhal Pavilion"] = "Angkhal Pavilion",
	["Anglers Expedition"] = "Anglers Expedition",
	["Anglers Wharf"] = "Anglers Wharf",
	["Angor Fortress"] = "Angor Fortress",
	["Ango'rosh Grounds"] = "Ango'rosh Grounds",
	["Ango'rosh Stronghold"] = "Ango'rosh Stronghold",
	["Angrathar the Wrathgate"] = "Angrathar the Wrathgate",
	["Angrathar the Wrath Gate"] = "Angrathar the Wrath Gate",
	["An'owyn"] = "An'owyn",
	["An'telas"] = "An'telas",
	["Antonidas Memorial"] = "Antonidas Memorial",
	Anvilmar = "Anvilmar",
	["Anvil of Conflagration"] = "Anvil of Conflagration",
	["Apex Point"] = "Apex Point",
	["Apocryphan's Rest"] = "Apocryphan's Rest",
	["Apothecary Camp"] = "Apothecary Camp",
	["Applebloom Tavern"] = "Applebloom Tavern",
	["Arathi Basin"] = "Arathi Basin",
	["Arathi Highlands"] = "Arathi Highlands",
	["Arcane Pinnacle"] = "Arcane Pinnacle",
	["Archmage Vargoth's Retreat"] = "Archmage Vargoth's Retreat",
	["Area 52"] = "Area 52",
	["Arena Floor"] = "Arena Floor",
	["Arena of Annihilation"] = "Arena of Annihilation",
	["Argent Pavilion"] = "Argent Pavilion",
	["Argent Stand"] = "Argent Stand",
	["Argent Tournament Grounds"] = "Argent Tournament Grounds",
	["Argent Vanguard"] = "Argent Vanguard",
	["Ariden's Camp"] = "Ariden's Camp",
	["Arikara's Needle"] = "Arikara's Needle",
	["Arklonis Ridge"] = "Arklonis Ridge",
	["Arklon Ruins"] = "Arklon Ruins",
	["Arriga Footbridge"] = "Arriga Footbridge",
	["Arsad Trade Post"] = "Arsad Trade Post",
	["Ascendant's Rise"] = "Ascendant's Rise",
	["Ascent of Swirling Winds"] = "Ascent of Swirling Winds",
	["Ashen Fields"] = "Ashen Fields",
	["Ashen Lake"] = "Ashen Lake",
	Ashenvale = "Ashenvale",
	["Ashwood Lake"] = "Ashwood Lake",
	["Ashwood Post"] = "Ashwood Post",
	["Aspen Grove Post"] = "Aspen Grove Post",
	["Assault on Shaol'mara"] = "Assault on Shaol'mara",
	["Assault on Zan'vess"] = "Assault on Zan'vess",
	["Assault on Zeb'tula"] = "Assault on Zeb'tula",
	Astranaar = "Astranaar",
	["Ata'mal Terrace"] = "Ata'mal Terrace",
	Athenaeum = "Athenaeum",
	["Atrium of the Heart"] = "Atrium of the Heart",
	["Atulhet's Tomb"] = "Atulhet's Tomb",
	["Auberdine Refugee Camp"] = "Auberdine Refugee Camp",
	["Auburn Bluffs"] = "Auburn Bluffs",
	["Auchenai Crypts"] = "Auchenai Crypts",
	["Auchenai Grounds"] = "Auchenai Grounds",
	Auchindoun = "Auchindoun",
	["Auchindoun: Auchenai Crypts"] = "Auchindoun: Auchenai Crypts",
	["Auchindoun - Auchenai Crypts Entrance"] = "Auchindoun - Auchenai Crypts Entrance",
	["Auchindoun: Mana-Tombs"] = "Auchindoun: Mana-Tombs",
	["Auchindoun - Mana-Tombs Entrance"] = "Auchindoun - Mana-Tombs Entrance",
	["Auchindoun: Sethekk Halls"] = "Auchindoun: Sethekk Halls",
	["Auchindoun - Sethekk Halls Entrance"] = "Auchindoun - Sethekk Halls Entrance",
	["Auchindoun: Shadow Labyrinth"] = "Auchindoun: Shadow Labyrinth",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Auchindoun - Shadow Labyrinth Entrance",
	["Auren Falls"] = "Auren Falls",
	["Auren Ridge"] = "Auren Ridge",
	["Autumnshade Ridge"] = "Autumnshade Ridge",
	["Avalanchion's Vault"] = "Avalanchion's Vault",
	Aviary = "Aviary",
	["Axis of Alignment"] = "Axis of Alignment",
	Axxarien = "Axxarien",
	["Azjol-Nerub"] = "Azjol-Nerub",
	["Azjol-Nerub Entrance"] = "Azjol-Nerub Entrance",
	Azshara = "Azshara",
	["Azshara Crater"] = "Azshara Crater",
	["Azshara's Palace"] = "Azshara's Palace",
	["Azurebreeze Coast"] = "Azurebreeze Coast",
	["Azure Dragonshrine"] = "Azure Dragonshrine",
	["Azurelode Mine"] = "Azurelode Mine",
	["Azuremyst Isle"] = "Azuremyst Isle",
	["Azure Watch"] = "Azure Watch",
	["Backbreaker Bay"] = "Backbreaker Bay",
	Badlands = "Badlands",
	["Bael'dun Digsite"] = "Bael'dun Digsite",
	["Bael'dun Keep"] = "Bael'dun Keep",
	["Baelgun's Excavation Site"] = "Baelgun's Excavation Site",
	["Bael Modan"] = "Bael Modan",
	["Bael Modan Excavation"] = "Bael Modan Excavation",
	["Bahrum's Post"] = "Bahrum's Post",
	["Balargarde Fortress"] = "Balargarde Fortress",
	Baleheim = "Baleheim",
	["Balejar Watch"] = "Balejar Watch",
	["Balia'mah Ruins"] = "Balia'mah Ruins",
	["Bal'lal Ruins"] = "Bal'lal Ruins",
	["Balnir Farmstead"] = "Balnir Farmstead",
	Bambala = "Bambala",
	["Band of Acceleration"] = "Band of Acceleration",
	["Band of Alignment"] = "Band of Alignment",
	["Band of Transmutation"] = "Band of Transmutation",
	["Band of Variance"] = "Band of Variance",
	["Ban'ethil Barrow Den"] = "Ban'ethil Barrow Den",
	["Ban'ethil Barrow Descent"] = "Ban'ethil Barrow Descent",
	["Ban'ethil Hollow"] = "Ban'ethil Hollow",
	Bank = "Bank",
	["Banquet Grounds"] = "Banquet Grounds",
	["Ban'Thallow Barrow Den"] = "Ban'Thallow Barrow Den",
	["Baradin Base Camp"] = "Baradin Base Camp",
	["Baradin Bay"] = "Baradin Bay",
	["Baradin Hold"] = "Baradin Hold",
	Barbershop = "Barbershop",
	["Barov Family Vault"] = "Barov Family Vault",
	["Bashal'Aran"] = "Bashal'Aran",
	["Bashal'Aran Collapse"] = "Bashal'Aran Collapse",
	["Bash'ir Landing"] = "Bash'ir Landing",
	["Bastion Antechamber"] = "Bastion Antechamber",
	["Bathran's Haunt"] = "Bathran's Haunt",
	["Battlefront Provisions"] = "Battlefront Provisions",
	["Battle on the High Seas"] = "Battle on the High Seas",
	["Battle Ring"] = "Battle Ring",
	Battlescar = "Battlescar",
	["Battlescar Spire"] = "Battlescar Spire",
	["Battlescar Valley"] = "Battlescar Valley",
	["Bay of Echoes"] = "Bay of Echoes",
	["Bay of Storms"] = "Bay of Storms",
	["Bear's Head"] = "Bear's Head",
	["Beauty's Lair"] = "Beauty's Lair",
	["Beeble's Wreck"] = "Beeble's Wreck",
	["Beezil's Wreck"] = "Beezil's Wreck",
	["Befouled Terrace"] = "Befouled Terrace",
	["Beggar's Haunt"] = "Beggar's Haunt",
	["Beneath The Double Rainbow"] = "Beneath The Double Rainbow",
	["Beneath the Pit"] = "Beneath the Pit",
	["Beren's Peril"] = "Beren's Peril",
	["Bernau's Happy Fun Land"] = "Bernau's Happy Fun Land",
	["Beryl Coast"] = "Beryl Coast",
	["Beryl Egress"] = "Beryl Egress",
	["Beryl Point"] = "Beryl Point",
	["Beth'mora Ridge"] = "Beth'mora Ridge",
	["Beth'tilac's Lair"] = "Beth'tilac's Lair",
	["Biel'aran Ridge"] = "Biel'aran Ridge",
	["Big Beach Brew Bash"] = "Big Beach Brew Bash",
	["Big Blossom Excavation"] = "Big Blossom Excavation",
	["Big Blossom Mine"] = "Big Blossom Mine",
	["Bilgewater Beach"] = "Bilgewater Beach",
	["Bilgewater Harbor"] = "Bilgewater Harbor",
	["Bilgewater Lumber Yard"] = "Bilgewater Lumber Yard",
	["Bilgewater Port"] = "Bilgewater Port",
	["Binan Brew & Stew"] = "Binan Brew & Stew",
	["Binan Village"] = "Binan Village",
	["Bitter Reaches"] = "Bitter Reaches",
	["Bittertide Lake"] = "Bittertide Lake",
	["Bizmo's Brawlpub"] = "Bizmo's Brawlpub",
	["Black Channel Marsh"] = "Black Channel Marsh",
	["Blackchar Cave"] = "Blackchar Cave",
	["Black Drake Roost"] = "Black Drake Roost",
	["Blackfathom Camp"] = "Blackfathom Camp",
	["Blackfathom Deeps"] = "Blackfathom Deeps",
	["Blackfathom Deeps Entrance"] = "Blackfathom Deeps Entrance",
	["Blackhoof Village"] = "Blackhoof Village",
	["Blackhorn's Penance"] = "Blackhorn's Penance",
	["Blackmaw Hold"] = "Blackmaw Hold",
	["Black Ox Temple"] = "Black Ox Temple",
	["Blackriver Logging Camp"] = "Blackriver Logging Camp",
	["Blackrock Caverns"] = "Blackrock Caverns",
	["Blackrock Caverns Entrance"] = "Blackrock Caverns Entrance",
	["Blackrock Depths"] = "Blackrock Depths",
	["Blackrock Depths Entrance"] = "Blackrock Depths Entrance",
	["Blackrock Mountain"] = "Blackrock Mountain",
	["Blackrock Pass"] = "Blackrock Pass",
	["Blackrock Spire"] = "Blackrock Spire",
	["Blackrock Spire Entrance"] = "Blackrock Spire Entrance",
	["Blackrock Stadium"] = "Blackrock Stadium",
	["Blackrock Stronghold"] = "Blackrock Stronghold",
	["Blacksand Spillway"] = "Blacksand Spillway",
	["Blacksilt Shore"] = "Blacksilt Shore",
	Blacksmith = "Blacksmith",
	["Blackstone Span"] = "Blackstone Span",
	["Black Temple"] = "Black Temple",
	["Black Tooth Hovel"] = "Black Tooth Hovel",
	Blackwatch = "Blackwatch",
	["Blackwater Cove"] = "Blackwater Cove",
	["Blackwater Shipwrecks"] = "Blackwater Shipwrecks",
	["Blackwind Lake"] = "Blackwind Lake",
	["Blackwind Landing"] = "Blackwind Landing",
	["Blackwind Valley"] = "Blackwind Valley",
	["Blackwing Coven"] = "Blackwing Coven",
	["Blackwing Descent"] = "Blackwing Descent",
	["Blackwing Lair"] = "Blackwing Lair",
	["Blackwolf River"] = "Blackwolf River",
	["Blackwood Camp"] = "Blackwood Camp",
	["Blackwood Den"] = "Blackwood Den",
	["Blackwood Lake"] = "Blackwood Lake",
	["Bladed Gulch"] = "Bladed Gulch",
	["Bladefist Bay"] = "Bladefist Bay",
	["Bladelord's Retreat"] = "Bladelord's Retreat",
	["Blades & Axes"] = "Blades & Axes",
	["Blade's Edge Arena"] = "Blade's Edge Arena",
	["Blade's Edge Mountains"] = "Blade's Edge Mountains",
	["Bladespire Grounds"] = "Bladespire Grounds",
	["Bladespire Hold"] = "Bladespire Hold",
	["Bladespire Outpost"] = "Bladespire Outpost",
	["Blades' Run"] = "Blades' Run",
	["Blade Tooth Canyon"] = "Blade Tooth Canyon",
	Bladewood = "Bladewood",
	["Blasted Lands"] = "Blasted Lands",
	["Bleak Hollow"] = "Bleak Hollow",
	["Bleeding Hollow Ruins"] = "Bleeding Hollow Ruins",
	["Bleeding Vale"] = "Bleeding Vale",
	["Bleeding Ziggurat"] = "Bleeding Ziggurat",
	["Blistering Pool"] = "Blistering Pool",
	["Bloodcurse Isle"] = "Bloodcurse Isle",
	["Blood Elf Tower"] = "Blood Elf Tower",
	["Bloodfen Burrow"] = "Bloodfen Burrow",
	Bloodgulch = "Bloodgulch",
	["Bloodhoof Village"] = "Bloodhoof Village",
	["Bloodied Crossing"] = "Bloodied Crossing",
	["Blood in the Snow"] = "Blood in the Snow",
	["Bloodmaul Camp"] = "Bloodmaul Camp",
	["Bloodmaul Outpost"] = "Bloodmaul Outpost",
	["Bloodmaul Ravine"] = "Bloodmaul Ravine",
	["Bloodmoon Isle"] = "Bloodmoon Isle",
	["Bloodmyst Isle"] = "Bloodmyst Isle",
	["Bloodscale Enclave"] = "Bloodscale Enclave",
	["Bloodscale Grounds"] = "Bloodscale Grounds",
	["Bloodspore Plains"] = "Bloodspore Plains",
	["Bloodtalon Shore"] = "Bloodtalon Shore",
	["Bloodtooth Camp"] = "Bloodtooth Camp",
	["Bloodvenom Falls"] = "Bloodvenom Falls",
	["Bloodvenom Post"] = "Bloodvenom Post",
	["Bloodvenom Post "] = "Bloodvenom Post ",
	["Bloodvenom River"] = "Bloodvenom River",
	["Bloodwash Cavern"] = "Bloodwash Cavern",
	["Bloodwash Fighting Pits"] = "Bloodwash Fighting Pits",
	["Bloodwash Shrine"] = "Bloodwash Shrine",
	["Blood Watch"] = "Blood Watch",
	["Bloodwatcher Point"] = "Bloodwatcher Point",
	Bluefen = "Bluefen",
	["Bluegill Marsh"] = "Bluegill Marsh",
	["Blue Sky Logging Grounds"] = "Blue Sky Logging Grounds",
	["Bluff of the South Wind"] = "Bluff of the South Wind",
	["Bogen's Ledge"] = "Bogen's Ledge",
	Bogpaddle = "Bogpaddle",
	["Boha'mu Ruins"] = "Boha'mu Ruins",
	["Bolgan's Hole"] = "Bolgan's Hole",
	["Bolyun's Camp"] = "Bolyun's Camp",
	["Bonechewer Ruins"] = "Bonechewer Ruins",
	["Bonesnap's Camp"] = "Bonesnap's Camp",
	["Bones of Grakkarond"] = "Bones of Grakkarond",
	["Bootlegger Outpost"] = "Bootlegger Outpost",
	["Booty Bay"] = "Booty Bay",
	["Borean Tundra"] = "Borean Tundra",
	["Bor'gorok Outpost"] = "Bor'gorok Outpost",
	["Bor's Breath"] = "Bor's Breath",
	["Bor's Breath River"] = "Bor's Breath River",
	["Bor's Fall"] = "Bor's Fall",
	["Bor's Fury"] = "Bor's Fury",
	["Borune Ruins"] = "Borune Ruins",
	["Bough Shadow"] = "Bough Shadow",
	["Bouldercrag's Refuge"] = "Bouldercrag's Refuge",
	["Boulderfist Hall"] = "Boulderfist Hall",
	["Boulderfist Outpost"] = "Boulderfist Outpost",
	["Boulder'gor"] = "Boulder'gor",
	["Boulder Hills"] = "Boulder Hills",
	["Boulder Lode Mine"] = "Boulder Lode Mine",
	["Boulder'mok"] = "Boulder'mok",
	["Boulderslide Cavern"] = "Boulderslide Cavern",
	["Boulderslide Ravine"] = "Boulderslide Ravine",
	["Bozzle's Wreck"] = "Bozzle's Wreck",
	["Brackenwall Village"] = "Brackenwall Village",
	["Brackwell Pumpkin Patch"] = "Brackwell Pumpkin Patch",
	["Brambleblade Ravine"] = "Brambleblade Ravine",
	Bramblescar = "Bramblescar",
	["Brann's Base-Camp"] = "Brann's Base-Camp",
	["Brashtide Attack Fleet"] = "Brashtide Attack Fleet",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Brashtide Attack Fleet (Force Outdoors)",
	["Brave Wind Mesa"] = "Brave Wind Mesa",
	["Brawl'gar Arena"] = "Brawl'gar Arena",
	["Brazie Farmstead"] = "Brazie Farmstead",
	["Brewmoon Festival"] = "Brewmoon Festival",
	["Brewnall Village"] = "Brewnall Village",
	["Bridge of Souls"] = "Bridge of Souls",
	["Brightwater Lake"] = "Brightwater Lake",
	["Brightwood Grove"] = "Brightwood Grove",
	Brill = "Brill",
	["Brill Town Hall"] = "Brill Town Hall",
	["Bristlelimb Enclave"] = "Bristlelimb Enclave",
	["Bristlelimb Village"] = "Bristlelimb Village",
	["Broken Commons"] = "Broken Commons",
	["Broken Hill"] = "Broken Hill",
	["Broken Pillar"] = "Broken Pillar",
	["Broken Spear Village"] = "Broken Spear Village",
	["Broken Wilds"] = "Broken Wilds",
	["Broketooth Outpost"] = "Broketooth Outpost",
	["Bronzebeard Encampment"] = "Bronzebeard Encampment",
	["Bronze Dragonshrine"] = "Bronze Dragonshrine",
	["Browman Mill"] = "Browman Mill",
	["Brunnhildar Village"] = "Brunnhildar Village",
	["Bucklebree Farm"] = "Bucklebree Farm",
	["Budd's Dig"] = "Budd's Dig",
	["Burning Blade Coven"] = "Burning Blade Coven",
	["Burning Blade Ruins"] = "Burning Blade Ruins",
	["Burning Steppes"] = "Burning Steppes",
	["Butcher's Sanctum"] = "Butcher's Sanctum",
	["Butcher's Stand"] = "Butcher's Stand",
	["Caer Darrow"] = "Caer Darrow",
	["Caldemere Lake"] = "Caldemere Lake",
	["Calston Estate"] = "Calston Estate",
	["Camp Aparaje"] = "Camp Aparaje",
	["Camp Ataya"] = "Camp Ataya",
	["Camp Boff"] = "Camp Boff",
	["Camp Broketooth"] = "Camp Broketooth",
	["Camp Cagg"] = "Camp Cagg",
	["Camp E'thok"] = "Camp E'thok",
	["Camp Everstill"] = "Camp Everstill",
	["Camp Gormal"] = "Camp Gormal",
	["Camp Kosh"] = "Camp Kosh",
	["Camp Mojache"] = "Camp Mojache",
	["Camp Mojache Longhouse"] = "Camp Mojache Longhouse",
	["Camp Narache"] = "Camp Narache",
	["Camp Nooka Nooka"] = "Camp Nooka Nooka",
	["Camp of Boom"] = "Camp of Boom",
	["Camp Onequah"] = "Camp Onequah",
	["Camp Oneqwah"] = "Camp Oneqwah",
	["Camp Sungraze"] = "Camp Sungraze",
	["Camp Tunka'lo"] = "Camp Tunka'lo",
	["Camp Una'fe"] = "Camp Una'fe",
	["Camp Winterhoof"] = "Camp Winterhoof",
	["Camp Wurg"] = "Camp Wurg",
	Canals = "Canals",
	["Cannon's Inferno"] = "Cannon's Inferno",
	["Cantrips & Crows"] = "Cantrips & Crows",
	["Cape of Lost Hope"] = "Cape of Lost Hope",
	["Cape of Stranglethorn"] = "Cape of Stranglethorn",
	["Capital Gardens"] = "Capital Gardens",
	["Carrion Hill"] = "Carrion Hill",
	["Cartier & Co. Fine Jewelry"] = "Cartier & Co. Fine Jewelry",
	Cataclysm = "Cataclysm",
	["Cathedral of Darkness"] = "Cathedral of Darkness",
	["Cathedral of Light"] = "Cathedral of Light",
	["Cathedral Quarter"] = "Cathedral Quarter",
	["Cathedral Square"] = "Cathedral Square",
	["Cattail Lake"] = "Cattail Lake",
	["Cauldros Isle"] = "Cauldros Isle",
	["Cave of Mam'toth"] = "Cave of Mam'toth",
	["Cave of Meditation"] = "Cave of Meditation",
	["Cave of the Crane"] = "Cave of the Crane",
	["Cave of Words"] = "Cave of Words",
	["Cavern of Endless Echoes"] = "Cavern of Endless Echoes",
	["Cavern of Mists"] = "Cavern of Mists",
	["Caverns of Time"] = "Caverns of Time",
	["Celestial Enclave"] = "Celestial Enclave",
	["Celestial Ridge"] = "Celestial Ridge",
	["Cenarion Enclave"] = "Cenarion Enclave",
	["Cenarion Hold"] = "Cenarion Hold",
	["Cenarion Post"] = "Cenarion Post",
	["Cenarion Refuge"] = "Cenarion Refuge",
	["Cenarion Thicket"] = "Cenarion Thicket",
	["Cenarion Watchpost"] = "Cenarion Watchpost",
	["Cenarion Wildlands"] = "Cenarion Wildlands",
	["Central Bridge"] = "Central Bridge",
	["Chamber of Ancient Relics"] = "Chamber of Ancient Relics",
	["Chamber of Atonement"] = "Chamber of Atonement",
	["Chamber of Battle"] = "Chamber of Battle",
	["Chamber of Blood"] = "Chamber of Blood",
	["Chamber of Command"] = "Chamber of Command",
	["Chamber of Enchantment"] = "Chamber of Enchantment",
	["Chamber of Enlightenment"] = "Chamber of Enlightenment",
	["Chamber of Fanatics"] = "Chamber of Fanatics",
	["Chamber of Incineration"] = "Chamber of Incineration",
	["Chamber of Masters"] = "Chamber of Masters",
	["Chamber of Prophecy"] = "Chamber of Prophecy",
	["Chamber of Reflection"] = "Chamber of Reflection",
	["Chamber of Respite"] = "Chamber of Respite",
	["Chamber of Summoning"] = "Chamber of Summoning",
	["Chamber of Test Namesets"] = "Chamber of Test Namesets",
	["Chamber of the Aspects"] = "Chamber of the Aspects",
	["Chamber of the Dreamer"] = "Chamber of the Dreamer",
	["Chamber of the Moon"] = "Chamber of the Moon",
	["Chamber of the Restless"] = "Chamber of the Restless",
	["Chamber of the Stars"] = "Chamber of the Stars",
	["Chamber of the Sun"] = "Chamber of the Sun",
	["Chamber of Whispers"] = "Chamber of Whispers",
	["Chamber of Wisdom"] = "Chamber of Wisdom",
	["Champion's Hall"] = "Champion's Hall",
	["Champions' Hall"] = "Champions' Hall",
	["Chapel Gardens"] = "Chapel Gardens",
	["Chapel of the Crimson Flame"] = "Chapel of the Crimson Flame",
	["Chapel Yard"] = "Chapel Yard",
	["Charred Outpost"] = "Charred Outpost",
	["Charred Rise"] = "Charred Rise",
	["Chill Breeze Valley"] = "Chill Breeze Valley",
	["Chillmere Coast"] = "Chillmere Coast",
	["Chillwind Camp"] = "Chillwind Camp",
	["Chillwind Point"] = "Chillwind Point",
	Chiselgrip = "Chiselgrip",
	["Chittering Coast"] = "Chittering Coast",
	["Chow Farmstead"] = "Chow Farmstead",
	["Churning Gulch"] = "Churning Gulch",
	["Circle of Blood"] = "Circle of Blood",
	["Circle of Blood Arena"] = "Circle of Blood Arena",
	["Circle of Bone"] = "Circle of Bone",
	["Circle of East Binding"] = "Circle of East Binding",
	["Circle of Inner Binding"] = "Circle of Inner Binding",
	["Circle of Outer Binding"] = "Circle of Outer Binding",
	["Circle of Scale"] = "Circle of Scale",
	["Circle of Stone"] = "Circle of Stone",
	["Circle of Thorns"] = "Circle of Thorns",
	["Circle of West Binding"] = "Circle of West Binding",
	["Circle of Wills"] = "Circle of Wills",
	City = "City",
	["City of Ironforge"] = "City of Ironforge",
	["City Siege - Mogu Island Progression Scenario"] = "City Siege - Mogu Island Progression Scenario",
	["Clan Watch"] = "Clan Watch",
	["Class Quest"] = "Class Quest",
	["Claytön's WoWEdit Land"] = "Claytön's WoWEdit Land",
	["Cleft of Shadow"] = "Cleft of Shadow",
	["Cliffspring Falls"] = "Cliffspring Falls",
	["Cliffspring Hollow"] = "Cliffspring Hollow",
	["Cliffspring River"] = "Cliffspring River",
	["Cliffwalker Post"] = "Cliffwalker Post",
	["Cloudstrike Dojo"] = "Cloudstrike Dojo",
	["Cloudtop Terrace"] = "Cloudtop Terrace",
	["Coast of Echoes"] = "Coast of Echoes",
	["Coast of Idols"] = "Coast of Idols",
	["Coilfang Reservoir"] = "Coilfang Reservoir",
	["Coilfang: Serpentshrine Cavern"] = "Coilfang: Serpentshrine Cavern",
	["Coilfang: The Slave Pens"] = "Coilfang: The Slave Pens",
	["Coilfang - The Slave Pens Entrance"] = "Coilfang - The Slave Pens Entrance",
	["Coilfang: The Steamvault"] = "Coilfang: The Steamvault",
	["Coilfang - The Steamvault Entrance"] = "Coilfang - The Steamvault Entrance",
	["Coilfang: The Underbog"] = "Coilfang: The Underbog",
	["Coilfang - The Underbog Entrance"] = "Coilfang - The Underbog Entrance",
	["Coilskar Cistern"] = "Coilskar Cistern",
	["Coilskar Point"] = "Coilskar Point",
	Coldarra = "Coldarra",
	["Coldarra Ledge"] = "Coldarra Ledge",
	["Coldbite Burrow"] = "Coldbite Burrow",
	["Cold Hearth Manor"] = "Cold Hearth Manor",
	["Coldridge Pass"] = "Coldridge Pass",
	["Coldridge Valley"] = "Coldridge Valley",
	["Coldrock Quarry"] = "Coldrock Quarry",
	["Coldtooth Mine"] = "Coldtooth Mine",
	["Coldwind Heights"] = "Coldwind Heights",
	["Coldwind Pass"] = "Coldwind Pass",
	["Collin's Test"] = "Collin's Test",
	["Command Center"] = "Command Center",
	["Commons Hall"] = "Commons Hall",
	["Condemned Halls"] = "Condemned Halls",
	["Conqueror's Terrace"] = "Conqueror's Terrace",
	["Conquest Hold"] = "Conquest Hold",
	["Containment Core"] = "Containment Core",
	["Cooper Residence"] = "Cooper Residence",
	["Coral Garden"] = "Coral Garden",
	["Cordell's Enchanting"] = "Cordell's Enchanting",
	["Corin's Crossing"] = "Corin's Crossing",
	["Corp'rethar: The Horror Gate"] = "Corp'rethar: The Horror Gate",
	["Corrahn's Dagger"] = "Corrahn's Dagger",
	Cosmowrench = "Cosmowrench",
	["Court of Bones"] = "Court of Bones",
	["Court of the Highborne"] = "Court of the Highborne",
	["Court of the Sun"] = "Court of the Sun",
	["Courtyard of Lights"] = "Courtyard of Lights",
	["Courtyard of the Ancients"] = "Courtyard of the Ancients",
	["Cradle of Chi-Ji"] = "Cradle of Chi-Ji",
	["Cradle of the Ancients"] = "Cradle of the Ancients",
	["Craftsmen's Terrace"] = "Craftsmen's Terrace",
	["Crag of the Everliving"] = "Crag of the Everliving",
	["Cragpool Lake"] = "Cragpool Lake",
	["Crane Wing Refuge"] = "Crane Wing Refuge",
	["Crash Site"] = "Crash Site",
	["Crescent Hall"] = "Crescent Hall",
	["Crimson Assembly Hall"] = "Crimson Assembly Hall",
	["Crimson Expanse"] = "Crimson Expanse",
	["Crimson Watch"] = "Crimson Watch",
	Crossroads = "Crossroads",
	["Crowley Orchard"] = "Crowley Orchard",
	["Crowley Stable Grounds"] = "Crowley Stable Grounds",
	["Crown Guard Tower"] = "Crown Guard Tower",
	["Crucible of Carnage"] = "Crucible of Carnage",
	["Crumbling Depths"] = "Crumbling Depths",
	["Crumbling Stones"] = "Crumbling Stones",
	["Crusader Forward Camp"] = "Crusader Forward Camp",
	["Crusader Outpost"] = "Crusader Outpost",
	["Crusader's Armory"] = "Crusader's Armory",
	["Crusader's Chapel"] = "Crusader's Chapel",
	["Crusader's Landing"] = "Crusader's Landing",
	["Crusader's Outpost"] = "Crusader's Outpost",
	["Crusaders' Pinnacle"] = "Crusaders' Pinnacle",
	["Crusader's Run"] = "Crusader's Run",
	["Crusader's Spire"] = "Crusader's Spire",
	["Crusaders' Square"] = "Crusaders' Square",
	Crushblow = "Crushblow",
	["Crushcog's Arsenal"] = "Crushcog's Arsenal",
	["Crushridge Hold"] = "Crushridge Hold",
	Crypt = "Crypt",
	["Crypt of Forgotten Kings"] = "Crypt of Forgotten Kings",
	["Crypt of Remembrance"] = "Crypt of Remembrance",
	["Crystal Lake"] = "Crystal Lake",
	["Crystalline Quarry"] = "Crystalline Quarry",
	["Crystalsong Forest"] = "Crystalsong Forest",
	["Crystal Spine"] = "Crystal Spine",
	["Crystalvein Mine"] = "Crystalvein Mine",
	["Crystalweb Cavern"] = "Crystalweb Cavern",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "Curiosities & Moore",
	["Cursed Depths"] = "Cursed Depths",
	["Cursed Hollow"] = "Cursed Hollow",
	["Cut-Throat Alley"] = "Cut-Throat Alley",
	["Cyclone Summit"] = "Cyclone Summit",
	["Dabyrie's Farmstead"] = "Dabyrie's Farmstead",
	["Daggercap Bay"] = "Daggercap Bay",
	["Daggerfen Village"] = "Daggerfen Village",
	["Dagger in the Dark"] = "Dagger in the Dark",
	["Daggermaw Canyon"] = "Daggermaw Canyon",
	["Dagger Pass"] = "Dagger Pass",
	["Dais of Conquerors"] = "Dais of Conquerors",
	Dalaran = "Dalaran",
	["Dalaran Arena"] = "Dalaran Arena",
	["Dalaran City"] = "Dalaran City",
	["Dalaran Crater"] = "Dalaran Crater",
	["Dalaran Floating Rocks"] = "Dalaran Floating Rocks",
	["Dalaran Island"] = "Dalaran Island",
	["Dalaran Merchant's Bank"] = "Dalaran Merchant's Bank",
	["Dalaran Sewers"] = "Dalaran Sewers",
	["Dalaran Visitor Center"] = "Dalaran Visitor Center",
	["Dalson's Farm"] = "Dalson's Farm",
	["Damplight Cavern"] = "Damplight Cavern",
	["Damplight Chamber"] = "Damplight Chamber",
	["Dampsoil Burrow"] = "Dampsoil Burrow",
	["Dandred's Fold"] = "Dandred's Fold",
	["Dargath's Demise"] = "Dargath's Demise",
	["Darkbreak Cove"] = "Darkbreak Cove",
	["Darkcloud Pinnacle"] = "Darkcloud Pinnacle",
	["Darkcrest Enclave"] = "Darkcrest Enclave",
	["Darkcrest Shore"] = "Darkcrest Shore",
	["Dark Heart of Pandaria"] = "Dark Heart of Pandaria",
	["Dark Iron Highway"] = "Dark Iron Highway",
	["Darkmist Cavern"] = "Darkmist Cavern",
	["Darkmist Ruins"] = "Darkmist Ruins",
	["Darkmoon Boardwalk"] = "Darkmoon Boardwalk",
	["Darkmoon Deathmatch"] = "Darkmoon Deathmatch",
	["Darkmoon Deathmatch Pit (PH)"] = "Darkmoon Deathmatch Pit (PH)",
	["Darkmoon Faire"] = "Darkmoon Faire",
	["Darkmoon Island"] = "Darkmoon Island",
	["Darkmoon Island Cave"] = "Darkmoon Island Cave",
	["Darkmoon Path"] = "Darkmoon Path",
	["Darkmoon Pavilion"] = "Darkmoon Pavilion",
	Darkshire = "Darkshire",
	["Darkshire Town Hall"] = "Darkshire Town Hall",
	Darkshore = "Darkshore",
	["Darkspear Hold"] = "Darkspear Hold",
	["Darkspear Isle"] = "Darkspear Isle",
	["Darkspear Shore"] = "Darkspear Shore",
	["Darkspear Strand"] = "Darkspear Strand",
	["Darkspear Training Grounds"] = "Darkspear Training Grounds",
	["Darkwhisper Gorge"] = "Darkwhisper Gorge",
	["Darkwhisper Pass"] = "Darkwhisper Pass",
	["Darnassian Base Camp"] = "Darnassian Base Camp",
	Darnassus = "Darnassus",
	["Darrow Hill"] = "Darrow Hill",
	["Darrowmere Lake"] = "Darrowmere Lake",
	Darrowshire = "Darrowshire",
	["Darrowshire Hunting Grounds"] = "Darrowshire Hunting Grounds",
	["Darsok's Outpost"] = "Darsok's Outpost",
	["Dawnchaser Retreat"] = "Dawnchaser Retreat",
	["Dawning Lane"] = "Dawning Lane",
	["Dawning Wood Catacombs"] = "Dawning Wood Catacombs",
	["Dawnrise Expedition"] = "Dawnrise Expedition",
	["Dawn's Blossom"] = "Dawn's Blossom",
	["Dawnseeker Promontory"] = "Dawnseeker Promontory",
	["Dawnseeker's Promontory"] = "Dawnseeker's Promontory",
	["Dawn's Reach"] = "Dawn's Reach",
	["Dawnstar Spire"] = "Dawnstar Spire",
	["Dawnstar Village"] = "Dawnstar Village",
	["Daxil's Dig"] = "Daxil's Dig",
	["D-Block"] = "D-Block",
	["Deadeye Shore"] = "Deadeye Shore",
	["Deadman's Crossing"] = "Deadman's Crossing",
	["Dead Man's Hole"] = "Dead Man's Hole",
	Deadmines = "Deadmines",
	["Deadtalker's Plateau"] = "Deadtalker's Plateau",
	["Deadwind Pass"] = "Deadwind Pass",
	["Deadwind Ravine"] = "Deadwind Ravine",
	["Deadwood Village"] = "Deadwood Village",
	["Deathbringer's Rise"] = "Deathbringer's Rise",
	["Death Cultist Base Camp"] = "Death Cultist Base Camp",
	["Deathforge Tower"] = "Deathforge Tower",
	Deathknell = "Deathknell",
	["Deathmatch Pavilion"] = "Deathmatch Pavilion",
	Deatholme = "Deatholme",
	["Death's Breach"] = "Death's Breach",
	["Death's Door"] = "Death's Door",
	["Death's Hand Encampment"] = "Death's Hand Encampment",
	["Deathspeaker's Watch"] = "Deathspeaker's Watch",
	["Death's Rise"] = "Death's Rise",
	["Death's Stand"] = "Death's Stand",
	["Death's Step"] = "Death's Step",
	["Death's Watch Waystation"] = "Death's Watch Waystation",
	Deathwing = "Deathwing",
	["Deathwing's Fall"] = "Deathwing's Fall",
	["Deep Blue Observatory"] = "Deep Blue Observatory",
	["Deep Elem Mine"] = "Deep Elem Mine",
	["Deepfin Ridge"] = "Deepfin Ridge",
	Deepholm = "Deepholm",
	["Deephome Ceiling"] = "Deephome Ceiling",
	["Deepmist Grotto"] = "Deepmist Grotto",
	["Deeprun Tram"] = "Deeprun Tram",
	["Deepwater Tavern"] = "Deepwater Tavern",
	["Deepwind Gorge"] = "Deepwind Gorge",
	["Defense of the Alehouse"] = "Defense of the Alehouse",
	["Defense Of The Ale House BG"] = "Defense Of The Ale House BG",
	["Defias Hideout"] = "Defias Hideout",
	["Defiler's Den"] = "Defiler's Den",
	["D.E.H.T.A. Encampment"] = "D.E.H.T.A. Encampment",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "Demon Fall Canyon",
	["Demon Fall Ridge"] = "Demon Fall Ridge",
	["Demont's Place"] = "Demont's Place",
	["Den of Defiance"] = "Den of Defiance",
	["Den of Dying"] = "Den of Dying",
	["Den of Haal'esh"] = "Den of Haal'esh",
	["Den of Iniquity"] = "Den of Iniquity",
	["Den of Mortal Delights"] = "Den of Mortal Delights",
	["Den of Sorrow"] = "Den of Sorrow",
	["Den of Sseratus"] = "Den of Sseratus",
	["Den of the Caller"] = "Den of the Caller",
	["Den of the Devourer"] = "Den of the Devourer",
	["Den of the Disciples"] = "Den of the Disciples",
	["Den of the Unholy"] = "Den of the Unholy",
	["Derelict Caravan"] = "Derelict Caravan",
	["Derelict Manor"] = "Derelict Manor",
	["Derelict Strand"] = "Derelict Strand",
	["Designer Island"] = "Designer Island",
	Desolace = "Desolace",
	["Desolation Hold"] = "Desolation Hold",
	["Detention Block"] = "Detention Block",
	["Development Land"] = "Development Land",
	["Diamondhead River"] = "Diamondhead River",
	["Diamond Island"] = "Diamond Island",
	["Dig One"] = "Dig One",
	["Dig Three"] = "Dig Three",
	["Dig Two"] = "Dig Two",
	["Direforge Hill"] = "Direforge Hill",
	["Direhorn Post"] = "Direhorn Post",
	["Dire Maul"] = "Dire Maul",
	["Dire Maul - Capital Gardens Entrance"] = "Dire Maul - Capital Gardens Entrance",
	["Dire Maul - East"] = "Dire Maul - East",
	["Dire Maul - Gordok Commons Entrance"] = "Dire Maul - Gordok Commons Entrance",
	["Dire Maul - North"] = "Dire Maul - North",
	["Dire Maul - Warpwood Quarter Entrance"] = "Dire Maul - Warpwood Quarter Entrance",
	["Dire Maul - West"] = "Dire Maul - West",
	Diremoor = "Diremoor",
	["Dire Strait"] = "Dire Strait",
	["Disciple's Enclave"] = "Disciple's Enclave",
	Docks = "Docks",
	["Dojani River"] = "Dojani River",
	Dolanaar = "Dolanaar",
	["Dome Balrissa"] = "Dome Balrissa",
	["Domination Point"] = "Domination Point",
	["Donna's Kitty Shack"] = "Donna's Kitty Shack",
	["DO NOT USE"] = "DO NOT USE",
	["Dookin' Grounds"] = "Dookin' Grounds",
	["Doom's Vigil"] = "Doom's Vigil",
	["Dorian's Outpost"] = "Dorian's Outpost",
	["Draco'dar"] = "Draco'dar",
	["Draenei Ruins"] = "Draenei Ruins",
	["Draenethyst Mine"] = "Draenethyst Mine",
	["Draenil'dur Village"] = "Draenil'dur Village",
	Dragonblight = "Dragonblight",
	["Dragonflayer Pens"] = "Dragonflayer Pens",
	["Dragonmaw Base Camp"] = "Dragonmaw Base Camp",
	["Dragonmaw Flag Room"] = "Dragonmaw Flag Room",
	["Dragonmaw Forge"] = "Dragonmaw Forge",
	["Dragonmaw Fortress"] = "Dragonmaw Fortress",
	["Dragonmaw Garrison"] = "Dragonmaw Garrison",
	["Dragonmaw Gates"] = "Dragonmaw Gates",
	["Dragonmaw Pass"] = "Dragonmaw Pass",
	["Dragonmaw Port"] = "Dragonmaw Port",
	["Dragonmaw Skyway"] = "Dragonmaw Skyway",
	["Dragonmaw Stronghold"] = "Dragonmaw Stronghold",
	["Dragons' End"] = "Dragons' End",
	["Dragon's Fall"] = "Dragon's Fall",
	["Dragon's Mouth"] = "Dragon's Mouth",
	["Dragon Soul"] = "Dragon Soul",
	["Dragon Soul Raid - East Sarlac"] = "Dragon Soul Raid - East Sarlac",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Dragon Soul Raid - Wyrmrest Temple Base",
	["Dragonspine Peaks"] = "Dragonspine Peaks",
	["Dragonspine Ridge"] = "Dragonspine Ridge",
	["Dragonspine Tributary"] = "Dragonspine Tributary",
	["Dragonspire Hall"] = "Dragonspire Hall",
	["Drak'Agal"] = "Drak'Agal",
	["Draka's Fury"] = "Draka's Fury",
	["Drak'atal Passage"] = "Drak'atal Passage",
	["Drakil'jin Ruins"] = "Drakil'jin Ruins",
	["Drak'Mabwa"] = "Drak'Mabwa",
	["Drak'Mar Lake"] = "Drak'Mar Lake",
	["Draknid Lair"] = "Draknid Lair",
	["Drak'Sotra"] = "Drak'Sotra",
	["Drak'Sotra Fields"] = "Drak'Sotra Fields",
	["Drak'Tharon Keep"] = "Drak'Tharon Keep",
	["Drak'Tharon Keep Entrance"] = "Drak'Tharon Keep Entrance",
	["Drak'Tharon Overlook"] = "Drak'Tharon Overlook",
	["Drak'ural"] = "Drak'ural",
	["Dread Clutch"] = "Dread Clutch",
	["Dread Expanse"] = "Dread Expanse",
	["Dreadmaul Furnace"] = "Dreadmaul Furnace",
	["Dreadmaul Hold"] = "Dreadmaul Hold",
	["Dreadmaul Post"] = "Dreadmaul Post",
	["Dreadmaul Rock"] = "Dreadmaul Rock",
	["Dreadmist Camp"] = "Dreadmist Camp",
	["Dreadmist Den"] = "Dreadmist Den",
	["Dreadmist Peak"] = "Dreadmist Peak",
	["Dreadmurk Shore"] = "Dreadmurk Shore",
	["Dread Terrace"] = "Dread Terrace",
	["Dread Wastes"] = "Dread Wastes",
	["Dreadwatch Outpost"] = "Dreadwatch Outpost",
	["Dream Bough"] = "Dream Bough",
	["Dreamer's Pavilion"] = "Dreamer's Pavilion",
	["Dreamer's Rest"] = "Dreamer's Rest",
	["Dreamer's Rock"] = "Dreamer's Rock",
	Drudgetown = "Drudgetown",
	["Drygulch Ravine"] = "Drygulch Ravine",
	["Drywhisker Gorge"] = "Drywhisker Gorge",
	["Dubra'Jin"] = "Dubra'Jin",
	["Dun Algaz"] = "Dun Algaz",
	["Dun Argol"] = "Dun Argol",
	["Dun Baldar"] = "Dun Baldar",
	["Dun Baldar Pass"] = "Dun Baldar Pass",
	["Dun Baldar Tunnel"] = "Dun Baldar Tunnel",
	["Dunemaul Compound"] = "Dunemaul Compound",
	["Dunemaul Recruitment Camp"] = "Dunemaul Recruitment Camp",
	["Dun Garok"] = "Dun Garok",
	["Dun Mandarr"] = "Dun Mandarr",
	["Dun Modr"] = "Dun Modr",
	["Dun Morogh"] = "Dun Morogh",
	["Dun Niffelem"] = "Dun Niffelem",
	["Dunwald Holdout"] = "Dunwald Holdout",
	["Dunwald Hovel"] = "Dunwald Hovel",
	["Dunwald Market Row"] = "Dunwald Market Row",
	["Dunwald Ruins"] = "Dunwald Ruins",
	["Dunwald Town Square"] = "Dunwald Town Square",
	["Durnholde Keep"] = "Durnholde Keep",
	Durotar = "Durotar",
	Duskhaven = "Duskhaven",
	["Duskhowl Den"] = "Duskhowl Den",
	["Dusklight Bridge"] = "Dusklight Bridge",
	["Dusklight Hollow"] = "Dusklight Hollow",
	["Duskmist Shore"] = "Duskmist Shore",
	["Duskroot Fen"] = "Duskroot Fen",
	["Duskwither Grounds"] = "Duskwither Grounds",
	["Duskwither Spire"] = "Duskwither Spire",
	Duskwood = "Duskwood",
	["Dustback Gorge"] = "Dustback Gorge",
	["Dustbelch Grotto"] = "Dustbelch Grotto",
	["Dustfire Valley"] = "Dustfire Valley",
	["Dustquill Ravine"] = "Dustquill Ravine",
	["Dustwallow Bay"] = "Dustwallow Bay",
	["Dustwallow Marsh"] = "Dustwallow Marsh",
	["Dustwind Cave"] = "Dustwind Cave",
	["Dustwind Dig"] = "Dustwind Dig",
	["Dustwind Gulch"] = "Dustwind Gulch",
	["Dwarven District"] = "Dwarven District",
	["Eagle's Eye"] = "Eagle's Eye",
	["Earthshatter Cavern"] = "Earthshatter Cavern",
	["Earth Song Falls"] = "Earth Song Falls",
	["Earth Song Gate"] = "Earth Song Gate",
	["Eastern Bridge"] = "Eastern Bridge",
	["Eastern Kingdoms"] = "Eastern Kingdoms",
	["Eastern Plaguelands"] = "Eastern Plaguelands",
	["Eastern Strand"] = "Eastern Strand",
	["East Garrison"] = "East Garrison",
	["Eastmoon Ruins"] = "Eastmoon Ruins",
	["East Pavilion"] = "East Pavilion",
	["East Pillar"] = "East Pillar",
	["Eastpoint Tower"] = "Eastpoint Tower",
	["East Sanctum"] = "East Sanctum",
	["Eastspark Workshop"] = "Eastspark Workshop",
	["East Spire"] = "East Spire",
	["East Supply Caravan"] = "East Supply Caravan",
	["Eastvale Logging Camp"] = "Eastvale Logging Camp",
	["Eastwall Gate"] = "Eastwall Gate",
	["Eastwall Tower"] = "Eastwall Tower",
	["Eastwind Rest"] = "Eastwind Rest",
	["Eastwind Shore"] = "Eastwind Shore",
	["Ebon Hold"] = "Ebon Hold",
	["Ebon Watch"] = "Ebon Watch",
	["Echo Cove"] = "Echo Cove",
	["Echo Isles"] = "Echo Isles",
	["Echomok Cavern"] = "Echomok Cavern",
	["Echo Reach"] = "Echo Reach",
	["Echo Ridge Mine"] = "Echo Ridge Mine",
	["Eclipse Point"] = "Eclipse Point",
	["Eclipsion Fields"] = "Eclipsion Fields",
	["Eco-Dome Farfield"] = "Eco-Dome Farfield",
	["Eco-Dome Midrealm"] = "Eco-Dome Midrealm",
	["Eco-Dome Skyperch"] = "Eco-Dome Skyperch",
	["Eco-Dome Sutheron"] = "Eco-Dome Sutheron",
	["Elder Rise"] = "Elder Rise",
	["Elders' Square"] = "Elders' Square",
	["Eldreth Row"] = "Eldreth Row",
	["Eldritch Heights"] = "Eldritch Heights",
	["Elemental Plateau"] = "Elemental Plateau",
	["Elementium Depths"] = "Elementium Depths",
	Elevator = "Elevator",
	["Elrendar Crossing"] = "Elrendar Crossing",
	["Elrendar Falls"] = "Elrendar Falls",
	["Elrendar River"] = "Elrendar River",
	["Elwynn Forest"] = "Elwynn Forest",
	["Ember Clutch"] = "Ember Clutch",
	Emberglade = "Emberglade",
	["Ember Spear Tower"] = "Ember Spear Tower",
	["Emberstone Mine"] = "Emberstone Mine",
	["Emberstone Village"] = "Emberstone Village",
	["Emberstrife's Den"] = "Emberstrife's Den",
	["Emerald Dragonshrine"] = "Emerald Dragonshrine",
	["Emerald Dream"] = "Emerald Dream",
	["Emerald Forest"] = "Emerald Forest",
	["Emerald Sanctuary"] = "Emerald Sanctuary",
	["Emperor Rikktik's Rest"] = "Emperor Rikktik's Rest",
	["Emperor's Omen"] = "Emperor's Omen",
	["Emperor's Reach"] = "Emperor's Reach",
	["End Time"] = "End Time",
	["Engineering Labs"] = "Engineering Labs",
	["Engineering Labs "] = "Engineering Labs ",
	["Engine of Nalak'sha"] = "Engine of Nalak'sha",
	["Engine of the Makers"] = "Engine of the Makers",
	["Entryway of Time"] = "Entryway of Time",
	["Ethel Rethor"] = "Ethel Rethor",
	["Ethereal Corridor"] = "Ethereal Corridor",
	["Ethereum Staging Grounds"] = "Ethereum Staging Grounds",
	["Evergreen Trading Post"] = "Evergreen Trading Post",
	Evergrove = "Evergrove",
	Everlook = "Everlook",
	["Eversong - Duskwither Teleport"] = "Eversong - Duskwither Teleport",
	["Eversong Woods"] = "Eversong Woods",
	["Excavation Center"] = "Excavation Center",
	["Excavation Lift"] = "Excavation Lift",
	["Exclamation Point"] = "Exclamation Point",
	["Expedition Armory"] = "Expedition Armory",
	["Expedition Base Camp"] = "Expedition Base Camp",
	["Expedition Point"] = "Expedition Point",
	["Explorers' League Digsite"] = "Explorers' League Digsite",
	["Explorers' League Outpost"] = "Explorers' League Outpost",
	["Exposition Pavilion"] = "Exposition Pavilion",
	["Eye of Eternity"] = "Eye of Eternity",
	["Eye of the Storm"] = "Eye of the Storm",
	["Fairbreeze Village"] = "Fairbreeze Village",
	["Fairbridge Strand"] = "Fairbridge Strand",
	["Falcon Watch"] = "Falcon Watch",
	["Falconwing Inn"] = "Falconwing Inn",
	["Falconwing Square"] = "Falconwing Square",
	["Faldir's Cove"] = "Faldir's Cove",
	["Falfarren River"] = "Falfarren River",
	["Fallen Sky Lake"] = "Fallen Sky Lake",
	["Fallen Sky Ridge"] = "Fallen Sky Ridge",
	["Fallen Temple of Ahn'kahet"] = "Fallen Temple of Ahn'kahet",
	["Fall of Return"] = "Fall of Return",
	["Fallowmere Inn"] = "Fallowmere Inn",
	["Fallow Sanctuary"] = "Fallow Sanctuary",
	["Falls of Ymiron"] = "Falls of Ymiron",
	["Fallsong Village"] = "Fallsong Village",
	["Falthrien Academy"] = "Falthrien Academy",
	Familiars = "Familiars",
	["Faol's Rest"] = "Faol's Rest",
	["Fargaze Mesa"] = "Fargaze Mesa",
	["Fargodeep Mine"] = "Fargodeep Mine",
	Farm = "Farm",
	Farshire = "Farshire",
	["Farshire Fields"] = "Farshire Fields",
	["Farshire Lighthouse"] = "Farshire Lighthouse",
	["Farshire Mine"] = "Farshire Mine",
	["Farson Hold"] = "Farson Hold",
	["Farstrider Enclave"] = "Farstrider Enclave",
	["Farstrider Lodge"] = "Farstrider Lodge",
	["Farstrider Retreat"] = "Farstrider Retreat",
	["Farstriders' Enclave"] = "Farstriders' Enclave",
	["Farstriders' Square"] = "Farstriders' Square",
	["Farwatcher's Glen"] = "Farwatcher's Glen",
	["Farwatch Overlook"] = "Farwatch Overlook",
	["Far Watch Post"] = "Far Watch Post",
	["Fear Clutch"] = "Fear Clutch",
	["Featherbeard's Hovel"] = "Featherbeard's Hovel",
	Feathermoon = "Feathermoon",
	["Feathermoon Stronghold"] = "Feathermoon Stronghold",
	["Fe-Feng Village"] = "Fe-Feng Village",
	["Felfire Hill"] = "Felfire Hill",
	["Felpaw Village"] = "Felpaw Village",
	["Fel Reaver Ruins"] = "Fel Reaver Ruins",
	["Fel Rock"] = "Fel Rock",
	["Felspark Ravine"] = "Felspark Ravine",
	["Felstone Field"] = "Felstone Field",
	Felwood = "Felwood",
	["Fenris Isle"] = "Fenris Isle",
	["Fenris Keep"] = "Fenris Keep",
	Feralas = "Feralas",
	["Feralfen Village"] = "Feralfen Village",
	["Feral Scar Vale"] = "Feral Scar Vale",
	["Festering Pools"] = "Festering Pools",
	["Festival Lane"] = "Festival Lane",
	["Feth's Way"] = "Feth's Way",
	["Field of Korja"] = "Field of Korja",
	["Field of Strife"] = "Field of Strife",
	["Fields of Blood"] = "Fields of Blood",
	["Fields of Honor"] = "Fields of Honor",
	["Fields of Niuzao"] = "Fields of Niuzao",
	Filming = "Filming",
	["Final Gate - Mogu Island Progression Scenario"] = "Final Gate - Mogu Island Progression Scenario",
	["Firebeard Cemetery"] = "Firebeard Cemetery",
	["Firebeard's Patrol"] = "Firebeard's Patrol",
	["Firebough Nook"] = "Firebough Nook",
	["Fire Camp Bataar"] = "Fire Camp Bataar",
	["Fire Camp Gai-Cho"] = "Fire Camp Gai-Cho",
	["Fire Camp Ordo"] = "Fire Camp Ordo",
	["Fire Camp Osul"] = "Fire Camp Osul",
	["Fire Camp Ruqin"] = "Fire Camp Ruqin",
	["Fire Camp Yongqi"] = "Fire Camp Yongqi",
	["Firegut Furnace"] = "Firegut Furnace",
	Firelands = "Firelands",
	["Firelands Forgeworks"] = "Firelands Forgeworks",
	["Firelands Hatchery"] = "Firelands Hatchery",
	["Firelands Terrain 2"] = "Firelands Terrain 2",
	["Fireplume Peak"] = "Fireplume Peak",
	["Fire Plume Ridge"] = "Fire Plume Ridge",
	["Fireplume Trench"] = "Fireplume Trench",
	["Fire Scar Shrine"] = "Fire Scar Shrine",
	["Fire Stone Mesa"] = "Fire Stone Mesa",
	["Firestone Point"] = "Firestone Point",
	["Firewatch Ridge"] = "Firewatch Ridge",
	["Firewing Point"] = "Firewing Point",
	["First Bank of Kezan"] = "First Bank of Kezan",
	["First Legion Forward Camp"] = "First Legion Forward Camp",
	["First to Your Aid"] = "First to Your Aid",
	["Fishing Village"] = "Fishing Village",
	["Fizzcrank Airstrip"] = "Fizzcrank Airstrip",
	["Fizzcrank Pumping Station"] = "Fizzcrank Pumping Station",
	["Fizzle & Pozzik's Speedbarge"] = "Fizzle & Pozzik's Speedbarge",
	["Fjorn's Anvil"] = "Fjorn's Anvil",
	Flamebreach = "Flamebreach",
	["Flame Crest"] = "Flame Crest",
	["Flamestar Post"] = "Flamestar Post",
	["Flamewatch Tower"] = "Flamewatch Tower",
	["Flavor - Stormwind Harbor - Stop"] = "Flavor - Stormwind Harbor - Stop",
	["Fleshrender's Workshop"] = "Fleshrender's Workshop",
	["Foothold Citadel"] = "Foothold Citadel",
	["Footman's Armory"] = "Footman's Armory",
	["Force Interior"] = "Force Interior",
	["Fordragon Hold"] = "Fordragon Hold",
	["Forest Heart"] = "Forest Heart",
	["Forest's Edge"] = "Forest's Edge",
	["Forest's Edge Post"] = "Forest's Edge Post",
	["Forest Song"] = "Forest Song",
	["Forge Base: Gehenna"] = "Forge Base: Gehenna",
	["Forge Base: Oblivion"] = "Forge Base: Oblivion",
	["Forge Camp: Anger"] = "Forge Camp: Anger",
	["Forge Camp: Fear"] = "Forge Camp: Fear",
	["Forge Camp: Hate"] = "Forge Camp: Hate",
	["Forge Camp: Mageddon"] = "Forge Camp: Mageddon",
	["Forge Camp: Rage"] = "Forge Camp: Rage",
	["Forge Camp: Terror"] = "Forge Camp: Terror",
	["Forge Camp: Wrath"] = "Forge Camp: Wrath",
	["Forge of Fate"] = "Forge of Fate",
	["Forge of the Endless"] = "Forge of the Endless",
	["Forgewright's Tomb"] = "Forgewright's Tomb",
	["Forgotten Depths"] = "Forgotten Depths",
	["Forgotten Hill"] = "Forgotten Hill",
	["Forgotten Mire"] = "Forgotten Mire",
	["Forgotten Passageway"] = "Forgotten Passageway",
	["Forlorn Cloister"] = "Forlorn Cloister",
	["Forlorn Hut"] = "Forlorn Hut",
	["Forlorn Ridge"] = "Forlorn Ridge",
	["Forlorn Rowe"] = "Forlorn Rowe",
	["Forlorn Spire"] = "Forlorn Spire",
	["Forlorn Woods"] = "Forlorn Woods",
	["Formation Grounds"] = "Formation Grounds",
	["Forsaken Forward Command"] = "Forsaken Forward Command",
	["Forsaken High Command"] = "Forsaken High Command",
	["Forsaken Rear Guard"] = "Forsaken Rear Guard",
	["Fort Livingston"] = "Fort Livingston",
	["Fort Silverback"] = "Fort Silverback",
	["Fort Triumph"] = "Fort Triumph",
	["Fortune's Fist"] = "Fortune's Fist",
	["Fort Wildervar"] = "Fort Wildervar",
	["Forward Assault Camp"] = "Forward Assault Camp",
	["Forward Command"] = "Forward Command",
	["Foulspore Cavern"] = "Foulspore Cavern",
	["Foulspore Pools"] = "Foulspore Pools",
	["Fountain of the Everseeing"] = "Fountain of the Everseeing",
	["Fox Grove"] = "Fox Grove",
	["Fractured Front"] = "Fractured Front",
	["Frayfeather Highlands"] = "Frayfeather Highlands",
	["Fray Island"] = "Fray Island",
	["Frazzlecraz Motherlode"] = "Frazzlecraz Motherlode",
	["Freewind Post"] = "Freewind Post",
	["Frenzyheart Hill"] = "Frenzyheart Hill",
	["Frenzyheart River"] = "Frenzyheart River",
	["Frigid Breach"] = "Frigid Breach",
	["Frostblade Pass"] = "Frostblade Pass",
	["Frostblade Peak"] = "Frostblade Peak",
	["Frostclaw Den"] = "Frostclaw Den",
	["Frost Dagger Pass"] = "Frost Dagger Pass",
	["Frostfield Lake"] = "Frostfield Lake",
	["Frostfire Hot Springs"] = "Frostfire Hot Springs",
	["Frostfloe Deep"] = "Frostfloe Deep",
	["Frostgrip's Hollow"] = "Frostgrip's Hollow",
	Frosthold = "Frosthold",
	["Frosthowl Cavern"] = "Frosthowl Cavern",
	["Frostmane Front"] = "Frostmane Front",
	["Frostmane Hold"] = "Frostmane Hold",
	["Frostmane Hovel"] = "Frostmane Hovel",
	["Frostmane Retreat"] = "Frostmane Retreat",
	Frostmourne = "Frostmourne",
	["Frostmourne Cavern"] = "Frostmourne Cavern",
	["Frostsaber Rock"] = "Frostsaber Rock",
	["Frostwhisper Gorge"] = "Frostwhisper Gorge",
	["Frostwing Halls"] = "Frostwing Halls",
	["Frostwolf Graveyard"] = "Frostwolf Graveyard",
	["Frostwolf Keep"] = "Frostwolf Keep",
	["Frostwolf Pass"] = "Frostwolf Pass",
	["Frostwolf Tunnel"] = "Frostwolf Tunnel",
	["Frostwolf Village"] = "Frostwolf Village",
	["Frozen Reach"] = "Frozen Reach",
	["Fungal Deep"] = "Fungal Deep",
	["Fungal Rock"] = "Fungal Rock",
	["Funggor Cavern"] = "Funggor Cavern",
	["Furien's Post"] = "Furien's Post",
	["Furlbrow's Pumpkin Farm"] = "Furlbrow's Pumpkin Farm",
	["Furnace of Hate"] = "Furnace of Hate",
	["Furywing's Perch"] = "Furywing's Perch",
	Fuselight = "Fuselight",
	["Fuselight-by-the-Sea"] = "Fuselight-by-the-Sea",
	["Fu's Pond"] = "Fu's Pond",
	Gadgetzan = "Gadgetzan",
	["Gahrron's Withering"] = "Gahrron's Withering",
	["Gai-Cho Battlefield"] = "Gai-Cho Battlefield",
	["Galak Hold"] = "Galak Hold",
	["Galakrond's Rest"] = "Galakrond's Rest",
	["Galardell Valley"] = "Galardell Valley",
	["Galen's Fall"] = "Galen's Fall",
	["Galerek's Remorse"] = "Galerek's Remorse",
	["Galewatch Lighthouse"] = "Galewatch Lighthouse",
	["Gallery of Treasures"] = "Gallery of Treasures",
	["Gallows' Corner"] = "Gallows' Corner",
	["Gallows' End Tavern"] = "Gallows' End Tavern",
	["Gallywix Docks"] = "Gallywix Docks",
	["Gallywix Labor Mine"] = "Gallywix Labor Mine",
	["Gallywix Pleasure Palace"] = "Gallywix Pleasure Palace",
	["Gallywix's Villa"] = "Gallywix's Villa",
	["Gallywix's Yacht"] = "Gallywix's Yacht",
	["Galus' Chamber"] = "Galus' Chamber",
	["Gamesman's Hall"] = "Gamesman's Hall",
	Gammoth = "Gammoth",
	["Gao-Ran Battlefront"] = "Gao-Ran Battlefront",
	Garadar = "Garadar",
	["Gar'gol's Hovel"] = "Gar'gol's Hovel",
	Garm = "Garm",
	["Garm's Bane"] = "Garm's Bane",
	["Garm's Rise"] = "Garm's Rise",
	["Garren's Haunt"] = "Garren's Haunt",
	["Garrison Armory"] = "Garrison Armory",
	["Garrosh'ar Advance"] = "Garrosh'ar Advance",
	["Garrosh'ar Point"] = "Garrosh'ar Point",
	["Garrosh's Landing"] = "Garrosh's Landing",
	["Garvan's Reef"] = "Garvan's Reef",
	["Gate of Echoes"] = "Gate of Echoes",
	["Gate of Endless Spring"] = "Gate of Endless Spring",
	["Gate of Hamatep"] = "Gate of Hamatep",
	["Gate of Lightning"] = "Gate of Lightning",
	["Gate of the August Celestials"] = "Gate of the August Celestials",
	["Gate of the Blue Sapphire"] = "Gate of the Blue Sapphire",
	["Gate of the Green Emerald"] = "Gate of the Green Emerald",
	["Gate of the Purple Amethyst"] = "Gate of the Purple Amethyst",
	["Gate of the Red Sun"] = "Gate of the Red Sun",
	["Gate of the Setting Sun"] = "Gate of the Setting Sun",
	["Gate of the Yellow Moon"] = "Gate of the Yellow Moon",
	["Gates of Ahn'Qiraj"] = "Gates of Ahn'Qiraj",
	["Gates of Ironforge"] = "Gates of Ironforge",
	["Gates of Sothann"] = "Gates of Sothann",
	["Gauntlet of Flame"] = "Gauntlet of Flame",
	["Gavin's Naze"] = "Gavin's Naze",
	["Geezle's Camp"] = "Geezle's Camp",
	["Gelkis Village"] = "Gelkis Village",
	["General Goods"] = "General Goods",
	["General's Terrace"] = "General's Terrace",
	["Ghostblade Post"] = "Ghostblade Post",
	Ghostlands = "Ghostlands",
	["Ghost Walker Post"] = "Ghost Walker Post",
	["Giant's Run"] = "Giant's Run",
	["Giants' Run"] = "Giants' Run",
	["Gilded Fan"] = "Gilded Fan",
	["Gillijim's Isle"] = "Gillijim's Isle",
	["Gilnean Coast"] = "Gilnean Coast",
	["Gilnean Stronghold"] = "Gilnean Stronghold",
	Gilneas = "Gilneas",
	Gilneas2 = "Gilneas2",
	["Gilneas City"] = "Gilneas City",
	["Gilneas (Do Not Reuse)"] = "Gilneas (Do Not Reuse)",
	["Gilneas Liberation Front Base Camp"] = "Gilneas Liberation Front Base Camp",
	GilneasPhase1 = "GilneasPhase1",
	GilneasPhase2 = "GilneasPhase2",
	["Gimorak's Den"] = "Gimorak's Den",
	Gjalerbron = "Gjalerbron",
	Gjalerhorn = "Gjalerhorn",
	["Glacial Falls"] = "Glacial Falls",
	["Glimmer Bay"] = "Glimmer Bay",
	["Glimmerdeep Gorge"] = "Glimmerdeep Gorge",
	["Glittering Strand"] = "Glittering Strand",
	["Glopgut's Hollow"] = "Glopgut's Hollow",
	["Glorious Goods"] = "Glorious Goods",
	Glory = "Glory",
	["GM Island"] = "GM Island",
	["Gnarlpine Hold"] = "Gnarlpine Hold",
	["Gnaws' Boneyard"] = "Gnaws' Boneyard",
	Gnomeregan = "Gnomeregan",
	["Gobline Mine"] = "Gobline Mine",
	["Goblin Foundry"] = "Goblin Foundry",
	["Goblin Mine"] = "Goblin Mine",
	["Goblin Slums"] = "Goblin Slums",
	["Gokk'lok's Grotto"] = "Gokk'lok's Grotto",
	["Gokk'lok Shallows"] = "Gokk'lok Shallows",
	["Golakka Hot Springs"] = "Golakka Hot Springs",
	["Gol'Bolar Quarry"] = "Gol'Bolar Quarry",
	["Gol'Bolar Quarry Mine"] = "Gol'Bolar Quarry Mine",
	["Gold Coast Quarry"] = "Gold Coast Quarry",
	["Goldenbough Pass"] = "Goldenbough Pass",
	["Goldenmist Village"] = "Goldenmist Village",
	["Golden Strand"] = "Golden Strand",
	["Gold Mine"] = "Gold Mine",
	["Gold Road"] = "Gold Road",
	["Gold Rush BG"] = "Gold Rush BG",
	Goldshire = "Goldshire",
	["Goldtooth's Den"] = "Goldtooth's Den",
	["Goodgrub Smoking Pit"] = "Goodgrub Smoking Pit",
	["Gordok's Seat"] = "Gordok's Seat",
	["Gordunni Outpost"] = "Gordunni Outpost",
	["Gorefiend's Vigil"] = "Gorefiend's Vigil",
	["Gor'gaz Outpost"] = "Gor'gaz Outpost",
	Gornia = "Gornia",
	["Gorrok's Lament"] = "Gorrok's Lament",
	["Gorshak War Camp"] = "Gorshak War Camp",
	["Go'Shek Farm"] = "Go'Shek Farm",
	["Grain Cellar"] = "Grain Cellar",
	["Grand Courtyard"] = "Grand Courtyard",
	["Grand Magister's Asylum"] = "Grand Magister's Asylum",
	["Grand Overlook"] = "Grand Overlook",
	["Grand Promenade"] = "Grand Promenade",
	["Grangol'var Village"] = "Grangol'var Village",
	["Granite Springs"] = "Granite Springs",
	["Grassy Cline"] = "Grassy Cline",
	["Greatwood Vale"] = "Greatwood Vale",
	["Greengill Coast"] = "Greengill Coast",
	["Greenpaw Village"] = "Greenpaw Village",
	["Greenstone Dojo"] = "Greenstone Dojo",
	["Greenstone Inn"] = "Greenstone Inn",
	["Greenstone Masons' Quarter"] = "Greenstone Masons' Quarter",
	["Greenstone Quarry"] = "Greenstone Quarry",
	["Greenstone Village"] = "Greenstone Village",
	["Greenwarden's Grove"] = "Greenwarden's Grove",
	["Greymane Court"] = "Greymane Court",
	["Greymane Manor"] = "Greymane Manor",
	["Greymist Firth"] = "Greymist Firth",
	["Grim Batol"] = "Grim Batol",
	["Grim Batol Entrance"] = "Grim Batol Entrance",
	["Grimesilt Dig Site"] = "Grimesilt Dig Site",
	["Grimtotem Compound"] = "Grimtotem Compound",
	["Grimtotem Post"] = "Grimtotem Post",
	Grishnath = "Grishnath",
	Grizzlemaw = "Grizzlemaw",
	["Grizzlepaw Ridge"] = "Grizzlepaw Ridge",
	["Grizzly Hills"] = "Grizzly Hills",
	["Grol'dom Farm"] = "Grol'dom Farm",
	["Grolluk's Grave"] = "Grolluk's Grave",
	["Grom'arsh Crash-Site"] = "Grom'arsh Crash-Site",
	["Grom'gol"] = "Grom'gol",
	["Grom'gol Base Camp"] = "Grom'gol Base Camp",
	["Grommash Hold"] = "Grommash Hold",
	["Grookin Hill"] = "Grookin Hill",
	["Grosh'gok Compound"] = "Grosh'gok Compound",
	["Grove of Aessina"] = "Grove of Aessina",
	["Grove of Falling Blossoms"] = "Grove of Falling Blossoms",
	["Grove of the Ancients"] = "Grove of the Ancients",
	["Growless Cave"] = "Growless Cave",
	["Gruul's Lair"] = "Gruul's Lair",
	["Gryphon Roost"] = "Gryphon Roost",
	["Guardian's Library"] = "Guardian's Library",
	Gundrak = "Gundrak",
	["Gundrak Entrance"] = "Gundrak Entrance",
	["Gunstan's Dig"] = "Gunstan's Dig",
	["Gunstan's Post"] = "Gunstan's Post",
	["Gunther's Retreat"] = "Gunther's Retreat",
	["Guo-Lai Halls"] = "Guo-Lai Halls",
	["Guo-Lai Ritual Chamber"] = "Guo-Lai Ritual Chamber",
	["Guo-Lai Vault"] = "Guo-Lai Vault",
	["Gurboggle's Ledge"] = "Gurboggle's Ledge",
	["Gurubashi Arena"] = "Gurubashi Arena",
	["Gyro-Plank Bridge"] = "Gyro-Plank Bridge",
	["Haal'eshi Gorge"] = "Haal'eshi Gorge",
	["Hadronox's Lair"] = "Hadronox's Lair",
	["Hailwood Marsh"] = "Hailwood Marsh",
	Halaa = "Halaa",
	["Halaani Basin"] = "Halaani Basin",
	["Halcyon Egress"] = "Halcyon Egress",
	["Haldarr Encampment"] = "Haldarr Encampment",
	Halfhill = "Halfhill",
	Halgrind = "Halgrind",
	["Hall of Arms"] = "Hall of Arms",
	["Hall of Binding"] = "Hall of Binding",
	["Hall of Blackhand"] = "Hall of Blackhand",
	["Hall of Blades"] = "Hall of Blades",
	["Hall of Bones"] = "Hall of Bones",
	["Hall of Champions"] = "Hall of Champions",
	["Hall of Command"] = "Hall of Command",
	["Hall of Crafting"] = "Hall of Crafting",
	["Hall of Departure"] = "Hall of Departure",
	["Hall of Explorers"] = "Hall of Explorers",
	["Hall of Faces"] = "Hall of Faces",
	["Hall of Horrors"] = "Hall of Horrors",
	["Hall of Illusions"] = "Hall of Illusions",
	["Hall of Kings"] = "Hall of Kings",
	["Hall of Legends"] = "Hall of Legends",
	["Hall of Masks"] = "Hall of Masks",
	["Hall of Memories"] = "Hall of Memories",
	["Hall of Mysteries"] = "Hall of Mysteries",
	["Hall of Repose"] = "Hall of Repose",
	["Hall of Return"] = "Hall of Return",
	["Hall of Ritual"] = "Hall of Ritual",
	["Hall of Secrets"] = "Hall of Secrets",
	["Hall of Serpents"] = "Hall of Serpents",
	["Hall of Shapers"] = "Hall of Shapers",
	["Hall of Stasis"] = "Hall of Stasis",
	["Hall of the Brave"] = "Hall of the Brave",
	["Hall of the Conquered Kings"] = "Hall of the Conquered Kings",
	["Hall of the Crafters"] = "Hall of the Crafters",
	["Hall of the Crescent Moon"] = "Hall of the Crescent Moon",
	["Hall of the Crusade"] = "Hall of the Crusade",
	["Hall of the Cursed"] = "Hall of the Cursed",
	["Hall of the Damned"] = "Hall of the Damned",
	["Hall of the Defamed"] = "Hall of the Defamed",
	["Hall of the Exalted"] = "Hall of the Exalted",
	["Hall of the Fathers"] = "Hall of the Fathers",
	["Hall of the Frostwolf"] = "Hall of the Frostwolf",
	["Hall of the Grand Imperion"] = "Hall of the Grand Imperion",
	["Hall of the High Father"] = "Hall of the High Father",
	["Hall of the Keepers"] = "Hall of the Keepers",
	["Hall of the Shaper"] = "Hall of the Shaper",
	["Hall of the Stormpike"] = "Hall of the Stormpike",
	["Hall of the Tortured"] = "Hall of the Tortured",
	["Hall of the Watchers"] = "Hall of the Watchers",
	["Hall of the Wicked"] = "Hall of the Wicked",
	["Hall of Tombs"] = "Hall of Tombs",
	["Hall of Tranquility"] = "Hall of Tranquility",
	["Hall of Tranquillity"] = "Hall of Tranquillity",
	["Hall of Twilight"] = "Hall of Twilight",
	["Halls of Anguish"] = "Halls of Anguish",
	["Halls of Awakening"] = "Halls of Awakening",
	["Halls of Binding"] = "Halls of Binding",
	["Halls of Destruction"] = "Halls of Destruction",
	["Halls of Flesh-Shaping"] = "Halls of Flesh-Shaping",
	["Halls of Lightning"] = "Halls of Lightning",
	["Halls of Lightning Entrance"] = "Halls of Lightning Entrance",
	["Halls of Mourning"] = "Halls of Mourning",
	["Halls of Origination"] = "Halls of Origination",
	["Halls of Origination Entrance"] = "Halls of Origination Entrance",
	["Halls of Reflection"] = "Halls of Reflection",
	["Halls of Reflection Entrance"] = "Halls of Reflection Entrance",
	["Halls of Silence"] = "Halls of Silence",
	["Halls of Stone"] = "Halls of Stone",
	["Halls of Stone Entrance"] = "Halls of Stone Entrance",
	["Halls of Strife"] = "Halls of Strife",
	["Halls of the Ancestors"] = "Halls of the Ancestors",
	["Halls of the Hereafter"] = "Halls of the Hereafter",
	["Halls of the Law"] = "Halls of the Law",
	["Halls of Theory"] = "Halls of Theory",
	["Halycon's Lair"] = "Halycon's Lair",
	Hammerfall = "Hammerfall",
	["Hammertoe's Digsite"] = "Hammertoe's Digsite",
	["Hammond Farmstead"] = "Hammond Farmstead",
	Hangar = "Hangar",
	["Hardknuckle Clearing"] = "Hardknuckle Clearing",
	["Hardwrench Hideaway"] = "Hardwrench Hideaway",
	["Harkor's Camp"] = "Harkor's Camp",
	["Hatchet Hills"] = "Hatchet Hills",
	["Hatescale Burrow"] = "Hatescale Burrow",
	["Hatred's Vice"] = "Hatred's Vice",
	Havenshire = "Havenshire",
	["Havenshire Farms"] = "Havenshire Farms",
	["Havenshire Lumber Mill"] = "Havenshire Lumber Mill",
	["Havenshire Mine"] = "Havenshire Mine",
	["Havenshire Stables"] = "Havenshire Stables",
	["Hayward Fishery"] = "Hayward Fishery",
	["Headmaster's Retreat"] = "Headmaster's Retreat",
	["Headmaster's Study"] = "Headmaster's Study",
	Hearthglen = "Hearthglen",
	["Heart of Destruction"] = "Heart of Destruction",
	["Heart of Fear"] = "Heart of Fear",
	["Heart of the Old God Scenario"] = "Heart of the Old God Scenario",
	["Heart of Zan'vess"] = "Heart of Zan'vess",
	["Heart's Blood Shrine"] = "Heart's Blood Shrine",
	["Heartwood Trading Post"] = "Heartwood Trading Post",
	["Heb'Drakkar"] = "Heb'Drakkar",
	["Heb'Valok"] = "Heb'Valok",
	["Hellfire Basin"] = "Hellfire Basin",
	["Hellfire Citadel"] = "Hellfire Citadel",
	["Hellfire Citadel: Ramparts"] = "Hellfire Citadel: Ramparts",
	["Hellfire Citadel - Ramparts Entrance"] = "Hellfire Citadel - Ramparts Entrance",
	["Hellfire Citadel: The Blood Furnace"] = "Hellfire Citadel: The Blood Furnace",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Hellfire Citadel - The Blood Furnace Entrance",
	["Hellfire Citadel: The Shattered Halls"] = "Hellfire Citadel: The Shattered Halls",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Hellfire Citadel - The Shattered Halls Entrance",
	["Hellfire Peninsula"] = "Hellfire Peninsula",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Hellfire Peninsula - Force Camp Beach Head",
	["Hellfire Peninsula - Reaver's Fall"] = "Hellfire Peninsula - Reaver's Fall",
	["Hellfire Ramparts"] = "Hellfire Ramparts",
	["Hellscream Arena"] = "Hellscream Arena",
	["Hellscream's Camp"] = "Hellscream's Camp",
	["Hellscream's Fist"] = "Hellscream's Fist",
	["Hellscream's Grasp"] = "Hellscream's Grasp",
	["Hellscream's Watch"] = "Hellscream's Watch",
	["Helm's Bed Lake"] = "Helm's Bed Lake",
	["Heroes' Vigil"] = "Heroes' Vigil",
	["Hetaera's Clutch"] = "Hetaera's Clutch",
	["Hewn Bog"] = "Hewn Bog",
	["Heyman's Hubris"] = "Heyman's Hubris",
	["Hibernal Cavern"] = "Hibernal Cavern",
	["Hidden Cell"] = "Hidden Cell",
	["Hidden Path"] = "Hidden Path",
	Highbank = "Highbank",
	["High Bank"] = "High Bank",
	["Highland Forest"] = "Highland Forest",
	Highperch = "Highperch",
	["High Wilderness"] = "High Wilderness",
	Hillsbrad = "Hillsbrad",
	["Hillsbrad Fields"] = "Hillsbrad Fields",
	["Hillsbrad Foothills"] = "Hillsbrad Foothills",
	["Hiri'watha Research Station"] = "Hiri'watha Research Station",
	["Hive'Ashi"] = "Hive'Ashi",
	["Hive'Regal"] = "Hive'Regal",
	["Hive'Zora"] = "Hive'Zora",
	["Hogger Hill"] = "Hogger Hill",
	["Hollowed Out Tree"] = "Hollowed Out Tree",
	["Hollowstone Mine"] = "Hollowstone Mine",
	["Honeydew Farm"] = "Honeydew Farm",
	["Honeydew Glade"] = "Honeydew Glade",
	["Honeydew Village"] = "Honeydew Village",
	["Honor Hold"] = "Honor Hold",
	["Honor Hold Mine"] = "Honor Hold Mine",
	["Honor Point"] = "Honor Point",
	["Honor's Stand"] = "Honor's Stand",
	["Honor's Tomb"] = "Honor's Tomb",
	["Horde Base Camp"] = "Horde Base Camp",
	["Horde Beach Daily Area"] = "Horde Beach Daily Area",
	["Horde Encampment"] = "Horde Encampment",
	["Horde Keep"] = "Horde Keep",
	["Horde Landing"] = "Horde Landing",
	["Horde Landing Site"] = "Horde Landing Site",
	["Hordemar City"] = "Hordemar City",
	["Horde PVP Barracks"] = "Horde PVP Barracks",
	["Horror Clutch"] = "Horror Clutch",
	["Hour of Twilight"] = "Hour of Twilight",
	["House of Edune"] = "House of Edune",
	["Howling Fjord"] = "Howling Fjord",
	["Howlingwind Cavern"] = "Howlingwind Cavern",
	["Howlingwind Trail"] = "Howlingwind Trail",
	["Howling Ziggurat"] = "Howling Ziggurat",
	["Hrothgar's Landing"] = "Hrothgar's Landing",
	["Huangtze Falls"] = "Huangtze Falls",
	["Hull of the Foebreaker"] = "Hull of the Foebreaker",
	["Humboldt Conflagration"] = "Humboldt Conflagration",
	["Hunter Rise"] = "Hunter Rise",
	["Hunter's Hill"] = "Hunter's Hill",
	["Huntress of the Sun"] = "Huntress of the Sun",
	["Huntsman's Cloister"] = "Huntsman's Cloister",
	Hyjal = "Hyjal",
	["Hyjal Barrow Dens"] = "Hyjal Barrow Dens",
	["Hyjal Past"] = "Hyjal Past",
	["Hyjal Summit"] = "Hyjal Summit",
	["Iceblood Garrison"] = "Iceblood Garrison",
	["Iceblood Graveyard"] = "Iceblood Graveyard",
	Icecrown = "Icecrown",
	["Icecrown Citadel"] = "Icecrown Citadel",
	["Icecrown Dungeon - Gunships"] = "Icecrown Dungeon - Gunships",
	["Icecrown Glacier"] = "Icecrown Glacier",
	["Iceflow Lake"] = "Iceflow Lake",
	["Ice Heart Cavern"] = "Ice Heart Cavern",
	["Icemist Falls"] = "Icemist Falls",
	["Icemist Village"] = "Icemist Village",
	["Ice Thistle Hills"] = "Ice Thistle Hills",
	["Icewing Bunker"] = "Icewing Bunker",
	["Icewing Cavern"] = "Icewing Cavern",
	["Icewing Pass"] = "Icewing Pass",
	["Idlewind Lake"] = "Idlewind Lake",
	["Igneous Depths"] = "Igneous Depths",
	["Ihgaluk Crag"] = "Ihgaluk Crag",
	["Ik'vess"] = "Ik'vess",
	["Ikz'ka Ridge"] = "Ikz'ka Ridge",
	["Illidari Point"] = "Illidari Point",
	["Illidari Training Grounds"] = "Illidari Training Grounds",
	["Indu'le Village"] = "Indu'le Village",
	["Infiltrating the Shipyard"] = "Infiltrating the Shipyard",
	["Inkgill Mere"] = "Inkgill Mere",
	Inn = "Inn",
	["Inner Sanctum"] = "Inner Sanctum",
	["Inner Veil"] = "Inner Veil",
	["Insidion's Perch"] = "Insidion's Perch",
	["Invasion Point: Annihilator"] = "Invasion Point: Annihilator",
	["Invasion Point: Cataclysm"] = "Invasion Point: Cataclysm",
	["Invasion Point: Destroyer"] = "Invasion Point: Destroyer",
	["Invasion Point: Overlord"] = "Invasion Point: Overlord",
	["Ironband's Compound"] = "Ironband's Compound",
	["Ironband's Excavation Site"] = "Ironband's Excavation Site",
	["Ironbeard's Tomb"] = "Ironbeard's Tomb",
	["Ironclad Cove"] = "Ironclad Cove",
	["Ironclad Garrison"] = "Ironclad Garrison",
	["Ironclad Prison"] = "Ironclad Prison",
	["Iron Concourse"] = "Iron Concourse",
	["Irondeep Mine"] = "Irondeep Mine",
	Ironforge = "Ironforge",
	["Ironforge Airfield"] = "Ironforge Airfield",
	["Ironstone Camp"] = "Ironstone Camp",
	["Ironstone Plateau"] = "Ironstone Plateau",
	["Iron Summit"] = "Iron Summit",
	["Irontree Cavern"] = "Irontree Cavern",
	["Irontree Clearing"] = "Irontree Clearing",
	["Irontree Woods"] = "Irontree Woods",
	["Ironwall Dam"] = "Ironwall Dam",
	["Ironwall Rampart"] = "Ironwall Rampart",
	["Ironwing Cavern"] = "Ironwing Cavern",
	Iskaal = "Iskaal",
	["Island of Doctor Lapidis"] = "Island of Doctor Lapidis",
	["Isle of Conquest"] = "Isle of Conquest",
	["Isle of Conquest No Man's Land"] = "Isle of Conquest No Man's Land",
	["Isle of Dread"] = "Isle of Dread",
	["Isle of Giants"] = "Isle of Giants",
	["Isle of Quel'Danas"] = "Isle of Quel'Danas",
	["Isle of Reckoning"] = "Isle of Reckoning",
	["Isle of Thunder"] = "Isle of Thunder",
	["Isle of Tribulations"] = "Isle of Tribulations",
	["Iso'rath"] = "Iso'rath",
	["Itharius's Cave"] = "Itharius's Cave",
	["Ivald's Ruin"] = "Ivald's Ruin",
	["Ix'lar's Domain"] = "Ix'lar's Domain",
	["Jadefire Glen"] = "Jadefire Glen",
	["Jadefire Run"] = "Jadefire Run",
	["Jade Forest Alliance Hub Phase"] = "Jade Forest Alliance Hub Phase",
	["Jade Forest Battlefield Phase"] = "Jade Forest Battlefield Phase",
	["Jade Forest Horde Starting Area"] = "Jade Forest Horde Starting Area",
	["Jademir Lake"] = "Jademir Lake",
	["Jade Temple Grounds"] = "Jade Temple Grounds",
	Jaedenar = "Jaedenar",
	["Jagged Reef"] = "Jagged Reef",
	["Jagged Ridge"] = "Jagged Ridge",
	["Jaggedswine Farm"] = "Jaggedswine Farm",
	["Jagged Wastes"] = "Jagged Wastes",
	["Jaguero Isle"] = "Jaguero Isle",
	["Jaina Dalaran Scenario"] = "Jaina Dalaran Scenario",
	["Janeiro's Point"] = "Janeiro's Point",
	["Jangolode Mine"] = "Jangolode Mine",
	["Jaquero Isle"] = "Jaquero Isle",
	["Jasperlode Mine"] = "Jasperlode Mine",
	["Jeff NE Quadrant Changed"] = "Jeff NE Quadrant Changed",
	["Jeff NW Quadrant"] = "Jeff NW Quadrant",
	["Jeff SE Quadrant"] = "Jeff SE Quadrant",
	["Jeff SW Quadrant"] = "Jeff SW Quadrant",
	["Jerod's Landing"] = "Jerod's Landing",
	["Jintha'Alor"] = "Jintha'Alor",
	["Jintha'kalar"] = "Jintha'kalar",
	["Jintha'kalar Passage"] = "Jintha'kalar Passage",
	["Jin Yang Road"] = "Jin Yang Road",
	Jotunheim = "Jotunheim",
	K3 = "K3",
	["Kaja'mine"] = "Kaja'mine",
	["Kaja'mite Cave"] = "Kaja'mite Cave",
	["Kaja'mite Cavern"] = "Kaja'mite Cavern",
	["Kajaro Field"] = "Kajaro Field",
	["Kal'ai Ruins"] = "Kal'ai Ruins",
	Kalimdor = "Kalimdor",
	Kamagua = "Kamagua",
	["Karabor Sewers"] = "Karabor Sewers",
	Karazhan = "Karazhan",
	["Kargathia Keep"] = "Kargathia Keep",
	["Karnum's Glade"] = "Karnum's Glade",
	["Kartak's Hold"] = "Kartak's Hold",
	Kaskala = "Kaskala",
	["Kaw's Roost"] = "Kaw's Roost",
	["Kea Krak"] = "Kea Krak",
	["Keelen's Trustworthy Tailoring"] = "Keelen's Trustworthy Tailoring",
	["Keel Harbor"] = "Keel Harbor",
	["Keeshan's Post"] = "Keeshan's Post",
	["Kelp'thar Forest"] = "Kelp'thar Forest",
	["Kel'Thuzad Chamber"] = "Kel'Thuzad Chamber",
	["Kel'Thuzad's Chamber"] = "Kel'Thuzad's Chamber",
	["Keset Pass"] = "Keset Pass",
	["Kessel's Crossing"] = "Kessel's Crossing",
	Kezan = "Kezan",
	Kharanos = "Kharanos",
	["Khardros' Anvil"] = "Khardros' Anvil",
	["Khartut's Tomb"] = "Khartut's Tomb",
	["Khaz'goroth's Seat"] = "Khaz'goroth's Seat",
	["Ki-Han Brewery"] = "Ki-Han Brewery",
	["Kili'ua's Atoll"] = "Kili'ua's Atoll",
	["Kil'sorrow Fortress"] = "Kil'sorrow Fortress",
	["King's Gate"] = "King's Gate",
	["King's Harbor"] = "King's Harbor",
	["King's Hoard"] = "King's Hoard",
	["King's Square"] = "King's Square",
	["Kirin'Var Village"] = "Kirin'Var Village",
	Kirthaven = "Kirthaven",
	["Klaxxi'vess"] = "Klaxxi'vess",
	["Klik'vess"] = "Klik'vess",
	["Knucklethump Hole"] = "Knucklethump Hole",
	["Kodo Graveyard"] = "Kodo Graveyard",
	["Kodo Rock"] = "Kodo Rock",
	["Kolkar Village"] = "Kolkar Village",
	Kolramas = "Kolramas",
	["Kor'kron Vanguard"] = "Kor'kron Vanguard",
	["Kormek's Hut"] = "Kormek's Hut",
	["Koroth's Den"] = "Koroth's Den",
	["Korthun's End"] = "Korthun's End",
	["Kor'vess"] = "Kor'vess",
	["Kota Basecamp"] = "Kota Basecamp",
	["Kota Peak"] = "Kota Peak",
	["Krasarang Cove"] = "Krasarang Cove",
	["Krasarang River"] = "Krasarang River",
	["Krasarang Wilds"] = "Krasarang Wilds",
	["Krasari Falls"] = "Krasari Falls",
	["Krasus' Landing"] = "Krasus' Landing",
	["Krazzworks Attack Zeppelin"] = "Krazzworks Attack Zeppelin",
	["Kril'Mandar Point"] = "Kril'Mandar Point",
	["Kri'vess"] = "Kri'vess",
	["Krolg's Hut"] = "Krolg's Hut",
	["Krom'gar Fortress"] = "Krom'gar Fortress",
	["Krom's Landing"] = "Krom's Landing",
	["KTC Headquarters"] = "KTC Headquarters",
	["KTC Oil Platform"] = "KTC Oil Platform",
	["Kul'galar Keep"] = "Kul'galar Keep",
	["Kul Tiras"] = "Kul Tiras",
	["Kun-Lai Pass"] = "Kun-Lai Pass",
	["Kun-Lai Summit"] = "Kun-Lai Summit",
	["Kunzen Cave"] = "Kunzen Cave",
	["Kunzen Village"] = "Kunzen Village",
	["Kurzen's Compound"] = "Kurzen's Compound",
	["Kypari Ik"] = "Kypari Ik",
	["Kyparite Quarry"] = "Kyparite Quarry",
	["Kypari Vor"] = "Kypari Vor",
	["Kypari Zar"] = "Kypari Zar",
	["Kzzok Warcamp"] = "Kzzok Warcamp",
	["Lair of Skiggit"] = "Lair of Skiggit",
	["Lair of the Beast"] = "Lair of the Beast",
	["Lair of the Chosen"] = "Lair of the Chosen",
	["Lair of the Jade Witch"] = "Lair of the Jade Witch",
	["Lair of Tortos"] = "Lair of Tortos",
	["Lake Al'Ameth"] = "Lake Al'Ameth",
	["Lake Cauldros"] = "Lake Cauldros",
	["Lake Dumont"] = "Lake Dumont",
	["Lake Edunel"] = "Lake Edunel",
	["Lake Elrendar"] = "Lake Elrendar",
	["Lake Elune'ara"] = "Lake Elune'ara",
	["Lake Ere'Noru"] = "Lake Ere'Noru",
	["Lake Everstill"] = "Lake Everstill",
	["Lake Falathim"] = "Lake Falathim",
	["Lake Indu'le"] = "Lake Indu'le",
	["Lake Jorune"] = "Lake Jorune",
	["Lake Kel'Theril"] = "Lake Kel'Theril",
	["Lake Kittitata"] = "Lake Kittitata",
	["Lake Kum'uya"] = "Lake Kum'uya",
	["Lake Mennar"] = "Lake Mennar",
	["Lake Mereldar"] = "Lake Mereldar",
	["Lake Nazferiti"] = "Lake Nazferiti",
	["Lake of Stars"] = "Lake of Stars",
	["Lakeridge Highway"] = "Lakeridge Highway",
	Lakeshire = "Lakeshire",
	["Lakeshire Inn"] = "Lakeshire Inn",
	["Lakeshire Town Hall"] = "Lakeshire Town Hall",
	["Lakeside Landing"] = "Lakeside Landing",
	["Lake Sunspring"] = "Lake Sunspring",
	["Lakkari Tar Pits"] = "Lakkari Tar Pits",
	["Landing Beach"] = "Landing Beach",
	["Landing Site"] = "Landing Site",
	["Land's End Beach"] = "Land's End Beach",
	["Langrom's Leather & Links"] = "Langrom's Leather & Links",
	["Lao & Son's Yakwash"] = "Lao & Son's Yakwash",
	["Largo's Overlook"] = "Largo's Overlook",
	["Largo's Overlook Tower"] = "Largo's Overlook Tower",
	["Lariss Pavilion"] = "Lariss Pavilion",
	["Laughing Skull Courtyard"] = "Laughing Skull Courtyard",
	["Laughing Skull Ruins"] = "Laughing Skull Ruins",
	["Launch Bay"] = "Launch Bay",
	["Legash Encampment"] = "Legash Encampment",
	["Legendary Leathers"] = "Legendary Leathers",
	["Legion Hold"] = "Legion Hold",
	["Legion's Fate"] = "Legion's Fate",
	["Legion's Rest"] = "Legion's Rest",
	["Lethlor Ravine"] = "Lethlor Ravine",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "Leyara's Sorrow",
	["L'ghorek"] = "L'ghorek",
	["Liang's Retreat"] = "Liang's Retreat",
	["Library Wing"] = "Library Wing",
	Lighthouse = "Lighthouse",
	["Lightning Ascent"] = "Lightning Ascent",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Lightning Forge - Mogu Island Progression Scenario",
	["Lightning Ledge"] = "Lightning Ledge",
	["Lightning Promenade"] = "Lightning Promenade",
	["Lightning Vein Mine"] = "Lightning Vein Mine",
	["Light's Breach"] = "Light's Breach",
	["Light's Dawn Cathedral"] = "Light's Dawn Cathedral",
	["Light's Hammer"] = "Light's Hammer",
	["Light's Hope Chapel"] = "Light's Hope Chapel",
	["Light's Point"] = "Light's Point",
	["Light's Point Tower"] = "Light's Point Tower",
	["Light's Shield Tower"] = "Light's Shield Tower",
	["Light's Trust"] = "Light's Trust",
	["Like Clockwork"] = "Like Clockwork",
	["Lion's Landing"] = "Lion's Landing",
	["Lion's Pride Inn"] = "Lion's Pride Inn",
	["Livery Outpost"] = "Livery Outpost",
	["Livery Stables"] = "Livery Stables",
	["Livery Stables "] = "Livery Stables ",
	["Llane's Oath"] = "Llane's Oath",
	["Loading Room"] = "Loading Room",
	["Loch Modan"] = "Loch Modan",
	["Loch Verrall"] = "Loch Verrall",
	["Loken's Bargain"] = "Loken's Bargain",
	["Lonesome Cove"] = "Lonesome Cove",
	Longshore = "Longshore",
	["Longying Outpost"] = "Longying Outpost",
	["Lordamere Internment Camp"] = "Lordamere Internment Camp",
	["Lordamere Lake"] = "Lordamere Lake",
	["Lor'danel"] = "Lor'danel",
	["Lorthuna's Gate"] = "Lorthuna's Gate",
	["Lost Caldera"] = "Lost Caldera",
	["Lost City of the Tol'vir"] = "Lost City of the Tol'vir",
	["Lost City of the Tol'vir Entrance"] = "Lost City of the Tol'vir Entrance",
	LostIsles = "LostIsles",
	["Lost Isles Town in a Box"] = "Lost Isles Town in a Box",
	["Lost Isles Volcano Eruption"] = "Lost Isles Volcano Eruption",
	["Lost Peak"] = "Lost Peak",
	["Lost Point"] = "Lost Point",
	["Lost Rigger Cove"] = "Lost Rigger Cove",
	["Lothalor Woodlands"] = "Lothalor Woodlands",
	["Lower City"] = "Lower City",
	["Lower Silvermarsh"] = "Lower Silvermarsh",
	["Lower Sumprushes"] = "Lower Sumprushes",
	["Lower Veil Shil'ak"] = "Lower Veil Shil'ak",
	["Lower Wilds"] = "Lower Wilds",
	["Lumber Mill"] = "Lumber Mill",
	["Lushwater Oasis"] = "Lushwater Oasis",
	["Lydell's Ambush"] = "Lydell's Ambush",
	["M.A.C. Diver"] = "M.A.C. Diver",
	["Maelstrom Deathwing Fight"] = "Maelstrom Deathwing Fight",
	["Maelstrom Zone"] = "Maelstrom Zone",
	["Maestra's Post"] = "Maestra's Post",
	["Maexxna's Nest"] = "Maexxna's Nest",
	["Mage Quarter"] = "Mage Quarter",
	["Mage Tower"] = "Mage Tower",
	["Mag'har Grounds"] = "Mag'har Grounds",
	["Mag'hari Procession"] = "Mag'hari Procession",
	["Mag'har Post"] = "Mag'har Post",
	["Magical Menagerie"] = "Magical Menagerie",
	["Magic Quarter"] = "Magic Quarter",
	["Magisters Gate"] = "Magisters Gate",
	["Magister's Terrace"] = "Magister's Terrace",
	["Magisters' Terrace"] = "Magisters' Terrace",
	["Magisters' Terrace Entrance"] = "Magisters' Terrace Entrance",
	["Magmadar Cavern"] = "Magmadar Cavern",
	["Magma Fields"] = "Magma Fields",
	["Magma Springs"] = "Magma Springs",
	["Magmaw's Fissure"] = "Magmaw's Fissure",
	Magmoth = "Magmoth",
	["Magnamoth Caverns"] = "Magnamoth Caverns",
	["Magram Territory"] = "Magram Territory",
	["Magtheridon's Lair"] = "Magtheridon's Lair",
	["Magus Commerce Exchange"] = "Magus Commerce Exchange",
	["Main Chamber"] = "Main Chamber",
	["Main Gate"] = "Main Gate",
	["Main Hall"] = "Main Hall",
	["Maker's Ascent"] = "Maker's Ascent",
	["Maker's Overlook"] = "Maker's Overlook",
	["Maker's Overlook "] = "Maker's Overlook ",
	["Makers' Overlook"] = "Makers' Overlook",
	["Maker's Perch"] = "Maker's Perch",
	["Makers' Perch"] = "Makers' Perch",
	["Malaka'jin"] = "Malaka'jin",
	["Malden's Orchard"] = "Malden's Orchard",
	Maldraz = "Maldraz",
	["Malfurion's Breach"] = "Malfurion's Breach",
	["Malicia's Outpost"] = "Malicia's Outpost",
	["Malykriss: The Vile Hold"] = "Malykriss: The Vile Hold",
	["Mama's Pantry"] = "Mama's Pantry",
	["Mam'toth Crater"] = "Mam'toth Crater",
	["Manaforge Ara"] = "Manaforge Ara",
	["Manaforge B'naar"] = "Manaforge B'naar",
	["Manaforge Coruu"] = "Manaforge Coruu",
	["Manaforge Duro"] = "Manaforge Duro",
	["Manaforge Ultris"] = "Manaforge Ultris",
	["Mana Tombs"] = "Mana Tombs",
	["Mana-Tombs"] = "Mana-Tombs",
	["Mandokir's Domain"] = "Mandokir's Domain",
	["Mandori Village"] = "Mandori Village",
	["Mannoroc Coven"] = "Mannoroc Coven",
	["Manor Mistmantle"] = "Manor Mistmantle",
	["Mantle Rock"] = "Mantle Rock",
	["Map Chamber"] = "Map Chamber",
	["Mar'at"] = "Mar'at",
	Maraudon = "Maraudon",
	["Maraudon - Earth Song Falls Entrance"] = "Maraudon - Earth Song Falls Entrance",
	["Maraudon - Foulspore Cavern Entrance"] = "Maraudon - Foulspore Cavern Entrance",
	["Maraudon - The Wicked Grotto Entrance"] = "Maraudon - The Wicked Grotto Entrance",
	["Mardenholde Keep"] = "Mardenholde Keep",
	Marista = "Marista",
	["Marista's Bait & Brew"] = "Marista's Bait & Brew",
	["Market Row"] = "Market Row",
	["Marshal's Refuge"] = "Marshal's Refuge",
	["Marshal's Stand"] = "Marshal's Stand",
	["Marshlight Lake"] = "Marshlight Lake",
	["Marshtide Watch"] = "Marshtide Watch",
	["Maruadon - The Wicked Grotto Entrance"] = "Maruadon - The Wicked Grotto Entrance",
	["Mason's Folly"] = "Mason's Folly",
	["Masters' Gate"] = "Masters' Gate",
	["Master's Terrace"] = "Master's Terrace",
	["Mast Room"] = "Mast Room",
	["Maw of Destruction"] = "Maw of Destruction",
	["Maw of Go'rath"] = "Maw of Go'rath",
	["Maw of Lycanthoth"] = "Maw of Lycanthoth",
	["Maw of Neltharion"] = "Maw of Neltharion",
	["Maw of Shu'ma"] = "Maw of Shu'ma",
	["Maw of the Void"] = "Maw of the Void",
	["Mazra'Alor"] = "Mazra'Alor",
	Mazthoril = "Mazthoril",
	["Mazu's Overlook"] = "Mazu's Overlook",
	["Medivh's Chambers"] = "Medivh's Chambers",
	["Menagerie Wreckage"] = "Menagerie Wreckage",
	["Menethil Bay"] = "Menethil Bay",
	["Menethil Harbor"] = "Menethil Harbor",
	["Menethil Keep"] = "Menethil Keep",
	["Merchant Square"] = "Merchant Square",
	Middenvale = "Middenvale",
	["Mid Point Station"] = "Mid Point Station",
	["Midrealm Post"] = "Midrealm Post",
	["Midwall Lift"] = "Midwall Lift",
	["Mightstone Quarry"] = "Mightstone Quarry",
	["Military District"] = "Military District",
	["Mimir's Workshop"] = "Mimir's Workshop",
	Mine = "Mine",
	Mines = "Mines",
	["Mirage Abyss"] = "Mirage Abyss",
	["Mirage Flats"] = "Mirage Flats",
	["Mirage Raceway"] = "Mirage Raceway",
	["Mirkfallon Lake"] = "Mirkfallon Lake",
	["Mirkfallon Post"] = "Mirkfallon Post",
	["Mirror Lake"] = "Mirror Lake",
	["Mirror Lake Orchard"] = "Mirror Lake Orchard",
	["Mistblade Den"] = "Mistblade Den",
	["Mistcaller's Cave"] = "Mistcaller's Cave",
	["Mistfall Village"] = "Mistfall Village",
	["Mist's Edge"] = "Mist's Edge",
	["Mistvale Valley"] = "Mistvale Valley",
	["Mistveil Sea"] = "Mistveil Sea",
	["Mistwhisper Refuge"] = "Mistwhisper Refuge",
	["Misty Pine Refuge"] = "Misty Pine Refuge",
	["Misty Reed Post"] = "Misty Reed Post",
	["Misty Reed Strand"] = "Misty Reed Strand",
	["Misty Ridge"] = "Misty Ridge",
	["Misty Shore"] = "Misty Shore",
	["Misty Shores"] = "Misty Shores",
	["Misty Valley"] = "Misty Valley",
	["Miwana's Longhouse"] = "Miwana's Longhouse",
	["Mizjah Ruins"] = "Mizjah Ruins",
	["Moa'ki"] = "Moa'ki",
	["Moa'ki Harbor"] = "Moa'ki Harbor",
	["Moggle Point"] = "Moggle Point",
	["Mo'grosh Stronghold"] = "Mo'grosh Stronghold",
	["Mogu Island Daily Area"] = "Mogu Island Daily Area",
	["Mogu Island Events - Alliance Base"] = "Mogu Island Events - Alliance Base",
	["Mogu Island Events - Horde Base"] = "Mogu Island Events - Horde Base",
	["Mogu Island Loot Room"] = "Mogu Island Loot Room",
	["Mogu Island Progression Events"] = "Mogu Island Progression Events",
	Mogujia = "Mogujia",
	["Mogu'shan Palace"] = "Mogu'shan Palace",
	["Mogu'shan Terrace"] = "Mogu'shan Terrace",
	["Mogu'shan Vaults"] = "Mogu'shan Vaults",
	["Mok'Doom"] = "Mok'Doom",
	["Mok'Gordun"] = "Mok'Gordun",
	["Mok'Nathal Village"] = "Mok'Nathal Village",
	["Mold Foundry"] = "Mold Foundry",
	["Molten Core"] = "Molten Core",
	["Molten Front"] = "Molten Front",
	Moonbrook = "Moonbrook",
	Moonglade = "Moonglade",
	["Moongraze Woods"] = "Moongraze Woods",
	["Moon Horror Den"] = "Moon Horror Den",
	["Moonrest Gardens"] = "Moonrest Gardens",
	["Moonshrine Ruins"] = "Moonshrine Ruins",
	["Moonshrine Sanctum"] = "Moonshrine Sanctum",
	["Moontouched Den"] = "Moontouched Den",
	["Moonwater Retreat"] = "Moonwater Retreat",
	["Moonwell of Cleansing"] = "Moonwell of Cleansing",
	["Moonwell of Purity"] = "Moonwell of Purity",
	["Moonwing Den"] = "Moonwing Den",
	["Mord'rethar: The Death Gate"] = "Mord'rethar: The Death Gate",
	["Morgan's Plot"] = "Morgan's Plot",
	["Morgan's Vigil"] = "Morgan's Vigil",
	["Morlos'Aran"] = "Morlos'Aran",
	["Morning Breeze Lake"] = "Morning Breeze Lake",
	["Morning Breeze Village"] = "Morning Breeze Village",
	Morrowchamber = "Morrowchamber",
	["Mor'shan Base Camp"] = "Mor'shan Base Camp",
	["Mortal's Demise"] = "Mortal's Demise",
	["Mortbreath Grotto"] = "Mortbreath Grotto",
	["Mortwake's Tower"] = "Mortwake's Tower",
	["Mosh'Ogg Ogre Mound"] = "Mosh'Ogg Ogre Mound",
	["Mosshide Fen"] = "Mosshide Fen",
	["Mosswalker Village"] = "Mosswalker Village",
	["Mossy Pile"] = "Mossy Pile",
	["Motherseed Pit"] = "Motherseed Pit",
	["Mountainfoot Strip Mine"] = "Mountainfoot Strip Mine",
	["Mount Akher"] = "Mount Akher",
	["Mount Hyjal"] = "Mount Hyjal",
	["Mount Hyjal Phase 1"] = "Mount Hyjal Phase 1",
	["Mount Neverest"] = "Mount Neverest",
	["Muckscale Grotto"] = "Muckscale Grotto",
	["Muckscale Shallows"] = "Muckscale Shallows",
	["Mudmug's Place"] = "Mudmug's Place",
	Mudsprocket = "Mudsprocket",
	Mulgore = "Mulgore",
	["Murder Row"] = "Murder Row",
	["Murkdeep Cavern"] = "Murkdeep Cavern",
	["Murky Bank"] = "Murky Bank",
	["Muskpaw Ranch"] = "Muskpaw Ranch",
	["Mystral Lake"] = "Mystral Lake",
	Mystwood = "Mystwood",
	Nagrand = "Nagrand",
	["Nagrand Arena"] = "Nagrand Arena",
	Nahom = "Nahom",
	["Nar'shola Terrace"] = "Nar'shola Terrace",
	["Narsong Spires"] = "Narsong Spires",
	["Narsong Trench"] = "Narsong Trench",
	["Narvir's Cradle"] = "Narvir's Cradle",
	["Nasam's Talon"] = "Nasam's Talon",
	["Nat's Landing"] = "Nat's Landing",
	["Naval Battle Scenario"] = "Naval Battle Scenario",
	Naxxanar = "Naxxanar",
	Naxxramas = "Naxxramas",
	["Nayeli Lagoon"] = "Nayeli Lagoon",
	["Naz'anak: The Forgotten Depths"] = "Naz'anak: The Forgotten Depths",
	["Nazj'vel"] = "Nazj'vel",
	Nazzivian = "Nazzivian",
	["Nectarbreeze Orchard"] = "Nectarbreeze Orchard",
	["Needlerock Chasm"] = "Needlerock Chasm",
	["Needlerock Slag"] = "Needlerock Slag",
	["Nefarian's Lair"] = "Nefarian's Lair",
	["Nefarian�s Lair"] = "Nefarian�s Lair",
	["Neferset City"] = "Neferset City",
	["Neferset City Outskirts"] = "Neferset City Outskirts",
	["Nek'mani Wellspring"] = "Nek'mani Wellspring",
	["Neptulon's Rise"] = "Neptulon's Rise",
	["Nesingwary Base Camp"] = "Nesingwary Base Camp",
	["Nesingwary Safari"] = "Nesingwary Safari",
	["Nesingwary's Expedition"] = "Nesingwary's Expedition",
	["Nesingwary's Safari"] = "Nesingwary's Safari",
	Nespirah = "Nespirah",
	["Nestlewood Hills"] = "Nestlewood Hills",
	["Nestlewood Thicket"] = "Nestlewood Thicket",
	["Nethander Stead"] = "Nethander Stead",
	["Nethergarde Keep"] = "Nethergarde Keep",
	["Nethergarde Mines"] = "Nethergarde Mines",
	["Nethergarde Supply Camps"] = "Nethergarde Supply Camps",
	Netherspace = "Netherspace",
	Netherstone = "Netherstone",
	Netherstorm = "Netherstorm",
	["Netherweb Ridge"] = "Netherweb Ridge",
	["Netherwing Fields"] = "Netherwing Fields",
	["Netherwing Ledge"] = "Netherwing Ledge",
	["Netherwing Mines"] = "Netherwing Mines",
	["Netherwing Pass"] = "Netherwing Pass",
	["Neverest Basecamp"] = "Neverest Basecamp",
	["Neverest Pinnacle"] = "Neverest Pinnacle",
	["New Agamand"] = "New Agamand",
	["New Agamand Inn"] = "New Agamand Inn",
	["New Avalon"] = "New Avalon",
	["New Avalon Fields"] = "New Avalon Fields",
	["New Avalon Forge"] = "New Avalon Forge",
	["New Avalon Orchard"] = "New Avalon Orchard",
	["New Avalon Town Hall"] = "New Avalon Town Hall",
	["New Cifera"] = "New Cifera",
	["New Hearthglen"] = "New Hearthglen",
	["New Kargath"] = "New Kargath",
	["New Thalanaar"] = "New Thalanaar",
	["New Tinkertown"] = "New Tinkertown",
	["Nexus Legendary"] = "Nexus Legendary",
	Nidavelir = "Nidavelir",
	["Nidvar Stair"] = "Nidvar Stair",
	Nifflevar = "Nifflevar",
	["Night Elf Village"] = "Night Elf Village",
	Nighthaven = "Nighthaven",
	["Nightingale Lounge"] = "Nightingale Lounge",
	["Nightmare Depths"] = "Nightmare Depths",
	["Nightmare Scar"] = "Nightmare Scar",
	["Nightmare Vale"] = "Nightmare Vale",
	["Night Run"] = "Night Run",
	["Nightsong Woods"] = "Nightsong Woods",
	["Night Web's Hollow"] = "Night Web's Hollow",
	["Nijel's Point"] = "Nijel's Point",
	["Nimbus Rise"] = "Nimbus Rise",
	Nine = "Nine",
	["Niuzao Catacombs"] = "Niuzao Catacombs",
	["Niuzao Temple"] = "Niuzao Temple",
	["Njord's Breath Bay"] = "Njord's Breath Bay",
	["Njorndar Village"] = "Njorndar Village",
	["Njorn Stair"] = "Njorn Stair",
	["Nook of Konk"] = "Nook of Konk",
	["Noonshade Ruins"] = "Noonshade Ruins",
	Nordrassil = "Nordrassil",
	["Nordrassil Inn"] = "Nordrassil Inn",
	["Nordune Ridge"] = "Nordune Ridge",
	["North Common Hall"] = "North Common Hall",
	Northdale = "Northdale",
	["Northern Barrens"] = "Northern Barrens",
	["Northern Elwynn Mountains"] = "Northern Elwynn Mountains",
	["Northern Headlands"] = "Northern Headlands",
	["Northern Rampart"] = "Northern Rampart",
	["Northern Rocketway"] = "Northern Rocketway",
	["Northern Rocketway Exchange"] = "Northern Rocketway Exchange",
	["Northern Stranglethorn"] = "Northern Stranglethorn",
	["Northfold Manor"] = "Northfold Manor",
	["Northgate Breach"] = "Northgate Breach",
	["North Gate Outpost"] = "North Gate Outpost",
	["North Gate Pass"] = "North Gate Pass",
	["Northgate River"] = "Northgate River",
	["Northgate Woods"] = "Northgate Woods",
	["Northmaul Tower"] = "Northmaul Tower",
	["Northpass Tower"] = "Northpass Tower",
	["North Point Station"] = "North Point Station",
	["North Point Tower"] = "North Point Tower",
	Northrend = "Northrend",
	["Northridge Lumber Camp"] = "Northridge Lumber Camp",
	["North Sanctum"] = "North Sanctum",
	Northshire = "Northshire",
	["Northshire Abbey"] = "Northshire Abbey",
	["Northshire River"] = "Northshire River",
	["Northshire Valley"] = "Northshire Valley",
	["Northshire Vineyards"] = "Northshire Vineyards",
	["North Spear Tower"] = "North Spear Tower",
	["North Tide's Beachhead"] = "North Tide's Beachhead",
	["North Tide's Run"] = "North Tide's Run",
	["Northwatch Expedition Base Camp"] = "Northwatch Expedition Base Camp",
	["Northwatch Expedition Base Camp Inn"] = "Northwatch Expedition Base Camp Inn",
	["Northwatch Foothold"] = "Northwatch Foothold",
	["Northwatch Hold"] = "Northwatch Hold",
	["Northwind Cleft"] = "Northwind Cleft",
	["North Wind Tavern"] = "North Wind Tavern",
	["Nozzlepot's Outpost"] = "Nozzlepot's Outpost",
	["Nozzlerust Post"] = "Nozzlerust Post",
	["Oasis of the Fallen Prophet"] = "Oasis of the Fallen Prophet",
	["Oasis of Vir'sar"] = "Oasis of Vir'sar",
	["Obelisk of the Moon"] = "Obelisk of the Moon",
	["Obelisk of the Stars"] = "Obelisk of the Stars",
	["Obelisk of the Sun"] = "Obelisk of the Sun",
	["O'Breen's Camp"] = "O'Breen's Camp",
	["Observance Hall"] = "Observance Hall",
	["Observation Grounds"] = "Observation Grounds",
	["Obsidian Breakers"] = "Obsidian Breakers",
	["Obsidian Dragonshrine"] = "Obsidian Dragonshrine",
	["Obsidian Forest"] = "Obsidian Forest",
	["Obsidian Lair"] = "Obsidian Lair",
	["Obsidia's Perch"] = "Obsidia's Perch",
	["Odesyus' Landing"] = "Odesyus' Landing",
	["Ogri'la"] = "Ogri'la",
	["Ogri'La"] = "Ogri'La",
	["Old Hillsbrad Foothills"] = "Old Hillsbrad Foothills",
	["Old Ironforge"] = "Old Ironforge",
	["Old Town"] = "Old Town",
	Olembas = "Olembas",
	["Olivia's Pond"] = "Olivia's Pond",
	["Olsen's Farthing"] = "Olsen's Farthing",
	Oneiros = "Oneiros",
	["One Keg"] = "One Keg",
	["One More Glass"] = "One More Glass",
	["Onslaught Base Camp"] = "Onslaught Base Camp",
	["Onslaught Harbor"] = "Onslaught Harbor",
	["Onyxia's Lair"] = "Onyxia's Lair",
	["Oomlot Village"] = "Oomlot Village",
	["Oona Kagu"] = "Oona Kagu",
	Oostan = "Oostan",
	["Oostan Nord"] = "Oostan Nord",
	["Oostan Ost"] = "Oostan Ost",
	["Oostan Sor"] = "Oostan Sor",
	["Opening of the Dark Portal"] = "Opening of the Dark Portal",
	["Opening of the Dark Portal Entrance"] = "Opening of the Dark Portal Entrance",
	["Oratorium of the Voice"] = "Oratorium of the Voice",
	["Oratory of the Damned"] = "Oratory of the Damned",
	["Orchid Hollow"] = "Orchid Hollow",
	["Orebor Harborage"] = "Orebor Harborage",
	["Oregrind's Dig"] = "Oregrind's Dig",
	["Orendil's Retreat"] = "Orendil's Retreat",
	Orgrimmar = "Orgrimmar",
	["Orgrimmar Gunship Pandaria Start"] = "Orgrimmar Gunship Pandaria Start",
	["Orgrimmar Rear Gate"] = "Orgrimmar Rear Gate",
	["Orgrimmar Rocketway Exchange"] = "Orgrimmar Rocketway Exchange",
	["Orgrim's Hammer"] = "Orgrim's Hammer",
	["Oronok's Farm"] = "Oronok's Farm",
	Orsis = "Orsis",
	["Ortell's Hideout"] = "Ortell's Hideout",
	["Oshu'gun"] = "Oshu'gun",
	["Outdoor Ruins"] = "Outdoor Ruins",
	Outland = "Outland",
	["Overgrown Camp"] = "Overgrown Camp",
	["Overgrown Statuary"] = "Overgrown Statuary",
	["Owen's Wishing Well"] = "Owen's Wishing Well",
	["Owl Wing Thicket"] = "Owl Wing Thicket",
	["Palace Antechamber"] = "Palace Antechamber",
	["Pal'ea"] = "Pal'ea",
	["Palemane Rock"] = "Palemane Rock",
	["Pandaren Mine"] = "Pandaren Mine",
	Pandaria = "Pandaria",
	["Pang's Stead"] = "Pang's Stead",
	["Panic Clutch"] = "Panic Clutch",
	["Paoquan Hollow"] = "Paoquan Hollow",
	["Parhelion Plaza"] = "Parhelion Plaza",
	["Passage of Lost Fiends"] = "Passage of Lost Fiends",
	["Path of a Hundred Steps"] = "Path of a Hundred Steps",
	["Path of Conquerors"] = "Path of Conquerors",
	["Path of Enlightenment"] = "Path of Enlightenment",
	["Path of Serenity"] = "Path of Serenity",
	["Path of the Titans"] = "Path of the Titans",
	["Path of Uther"] = "Path of Uther",
	["Pattymack Land"] = "Pattymack Land",
	["Pauper's Walk"] = "Pauper's Walk",
	["Paur's Pub"] = "Paur's Pub",
	["Paw'don Glade"] = "Paw'don Glade",
	["Paw'don Village"] = "Paw'don Village",
	["Paw'Don Village"] = "Paw'Don Village",
	["Peak of Serenity"] = "Peak of Serenity",
	["Pearlfin Village"] = "Pearlfin Village",
	["Pearl Lake"] = "Pearl Lake",
	["Pedestal of Hope"] = "Pedestal of Hope",
	["Pei-Wu Forest"] = "Pei-Wu Forest",
	["Pestilent Scar"] = "Pestilent Scar",
	["Pet Battle - Jade Forest"] = "Pet Battle - Jade Forest",
	["Petitioner's Chamber"] = "Petitioner's Chamber",
	["Pilgrim's Precipice"] = "Pilgrim's Precipice",
	["Pincer X2"] = "Pincer X2",
	["Pinnacle of Storms"] = "Pinnacle of Storms",
	["Pit of Fangs"] = "Pit of Fangs",
	["Pit of Saron"] = "Pit of Saron",
	["Pit of Saron Entrance"] = "Pit of Saron Entrance",
	["Plaguelands: The Scarlet Enclave"] = "Plaguelands: The Scarlet Enclave",
	["Plaguemist Ravine"] = "Plaguemist Ravine",
	Plaguewood = "Plaguewood",
	["Plaguewood Tower"] = "Plaguewood Tower",
	["Plain of Echoes"] = "Plain of Echoes",
	["Plain of Shards"] = "Plain of Shards",
	["Plain of Thieves"] = "Plain of Thieves",
	["Plains of Nasam"] = "Plains of Nasam",
	["Pod Cluster"] = "Pod Cluster",
	["Pod Wreckage"] = "Pod Wreckage",
	["Poison Falls"] = "Poison Falls",
	["Pool of Reflection"] = "Pool of Reflection",
	["Pool of Tears"] = "Pool of Tears",
	["Pool of the Paw"] = "Pool of the Paw",
	["Pool of Twisted Reflections"] = "Pool of Twisted Reflections",
	["Pools of Aggonar"] = "Pools of Aggonar",
	["Pools of Arlithrien"] = "Pools of Arlithrien",
	["Pools of Jin'Alai"] = "Pools of Jin'Alai",
	["Pools of Purity"] = "Pools of Purity",
	["Pools of Youth"] = "Pools of Youth",
	["Pools of Zha'Jin"] = "Pools of Zha'Jin",
	["Portal Clearing"] = "Portal Clearing",
	["Pranksters' Hollow"] = "Pranksters' Hollow",
	["Predator's Perch"] = "Predator's Perch",
	["Prison of Immol'thar"] = "Prison of Immol'thar",
	["Programmer Isle"] = "Programmer Isle",
	["Promontory Point"] = "Promontory Point",
	["Prospector's Point"] = "Prospector's Point",
	["Protectorate Watch Post"] = "Protectorate Watch Post",
	["Proving Grounds"] = "Proving Grounds",
	["Purespring Cavern"] = "Purespring Cavern",
	["Purgation Isle"] = "Purgation Isle",
	["Pursuing the Black Harvest"] = "Pursuing the Black Harvest",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Putricide's Laboratory of Alchemical Horrors and Fun",
	["Pyrewood Chapel"] = "Pyrewood Chapel",
	["Pyrewood Inn"] = "Pyrewood Inn",
	["Pyrewood Town Hall"] = "Pyrewood Town Hall",
	["Pyrewood Village"] = "Pyrewood Village",
	["Pyrox Flats"] = "Pyrox Flats",
	["QA and DVD"] = "QA and DVD",
	["Quagg Ridge"] = "Quagg Ridge",
	Quarry = "Quarry",
	["Quartzite Basin"] = "Quartzite Basin",
	["Queen's Gate"] = "Queen's Gate",
	["Quel'Danil Lodge"] = "Quel'Danil Lodge",
	["Quel'Delar's Rest"] = "Quel'Delar's Rest",
	["Quel'Dormir Gardens"] = "Quel'Dormir Gardens",
	["Quel'Dormir Temple"] = "Quel'Dormir Temple",
	["Quel'Dormir Terrace"] = "Quel'Dormir Terrace",
	["Quel'Lithien Lodge"] = "Quel'Lithien Lodge",
	["Quel'thalas"] = "Quel'thalas",
	["Quickchop's Lumber Farm"] = "Quickchop's Lumber Farm",
	["Raastok Glade"] = "Raastok Glade",
	["Raceway Ruins"] = "Raceway Ruins",
	["Rageclaw Den"] = "Rageclaw Den",
	["Rageclaw Lake"] = "Rageclaw Lake",
	["Rage Fang Shrine"] = "Rage Fang Shrine",
	["Ragefeather Ridge"] = "Ragefeather Ridge",
	["Ragefire Caverns"] = "Ragefire Caverns",
	["Ragefire Chasm"] = "Ragefire Chasm",
	["Ragefire Core"] = "Ragefire Core",
	["Rage Scar Hold"] = "Rage Scar Hold",
	["Ragnaros' Lair"] = "Ragnaros' Lair",
	["Ragnaros' Reach"] = "Ragnaros' Reach",
	["Rainspeaker Canopy"] = "Rainspeaker Canopy",
	["Rainspeaker Rapids"] = "Rainspeaker Rapids",
	Ramkahen = "Ramkahen",
	["Ramkahen Legion Outpost"] = "Ramkahen Legion Outpost",
	["Rampart of Skulls"] = "Rampart of Skulls",
	["Ranazjar Isle"] = "Ranazjar Isle",
	["Raptor Pens"] = "Raptor Pens",
	["Raptor Ridge"] = "Raptor Ridge",
	["Raptor Rise"] = "Raptor Rise",
	Ratchet = "Ratchet",
	["Rated Eye of the Storm"] = "Rated Eye of the Storm",
	["Ravaged Caravan"] = "Ravaged Caravan",
	["Ravaged Crypt"] = "Ravaged Crypt",
	["Ravaged Twilight Camp"] = "Ravaged Twilight Camp",
	["Ravencrest Monument"] = "Ravencrest Monument",
	["Raven Hill"] = "Raven Hill",
	["Raven Hill Cemetery"] = "Raven Hill Cemetery",
	["Ravenholdt Manor"] = "Ravenholdt Manor",
	["Raven's Watch"] = "Raven's Watch",
	["Raven's Wood"] = "Raven's Wood",
	["Raynewood Retreat"] = "Raynewood Retreat",
	["Raynewood Tower"] = "Raynewood Tower",
	["Razaan's Landing"] = "Razaan's Landing",
	["Razorfen Downs"] = "Razorfen Downs",
	["Razorfen Downs Entrance"] = "Razorfen Downs Entrance",
	["Razorfen Kraul"] = "Razorfen Kraul",
	["Razorfen Kraul Entrance"] = "Razorfen Kraul Entrance",
	["Razor Hill"] = "Razor Hill",
	["Razor Hill Barracks"] = "Razor Hill Barracks",
	["Razor Hill Outskirts"] = "Razor Hill Outskirts",
	["Razor Hill Watchtower"] = "Razor Hill Watchtower",
	["Razormane Grounds"] = "Razormane Grounds",
	["Razor Ridge"] = "Razor Ridge",
	["Razorscale's Aerie"] = "Razorscale's Aerie",
	["Razorthorn Rise"] = "Razorthorn Rise",
	["Razorthorn Shelf"] = "Razorthorn Shelf",
	["Razorthorn Trail"] = "Razorthorn Trail",
	["Razorwind Canyon"] = "Razorwind Canyon",
	["Rear Staging Area"] = "Rear Staging Area",
	["Reaver's Fall"] = "Reaver's Fall",
	["Reavers' Hall"] = "Reavers' Hall",
	["Rebel Camp"] = "Rebel Camp",
	["Red Cloud Mesa"] = "Red Cloud Mesa",
	["Redpine Dell"] = "Redpine Dell",
	["Redridge - Bridge Phase One"] = "Redridge - Bridge Phase One",
	["Redridge - Bridge Phase Two"] = "Redridge - Bridge Phase Two",
	["Redridge Canyons"] = "Redridge Canyons",
	["Redridge Mountains"] = "Redridge Mountains",
	["Redridge - Orc Bomb"] = "Redridge - Orc Bomb",
	["Red Rocks"] = "Red Rocks",
	["Redwood Trading Post"] = "Redwood Trading Post",
	Refinery = "Refinery",
	["Refugee Caravan"] = "Refugee Caravan",
	["Refuge Pointe"] = "Refuge Pointe",
	["Refuse Disposal"] = "Refuse Disposal",
	["Reliquary of Agony"] = "Reliquary of Agony",
	["Reliquary of Pain"] = "Reliquary of Pain",
	["Remains of Iris Lake"] = "Remains of Iris Lake",
	["Remains of the Fleet"] = "Remains of the Fleet",
	["Remtravel's Excavation"] = "Remtravel's Excavation",
	["Render's Camp"] = "Render's Camp",
	["Render's Crater"] = "Render's Crater",
	["Render's Rock"] = "Render's Rock",
	["Render's Valley"] = "Render's Valley",
	["Rensai's Watchpost"] = "Rensai's Watchpost",
	["Rethban Caverns"] = "Rethban Caverns",
	["Rethress Sanctum"] = "Rethress Sanctum",
	Reuse = "Reuse",
	["Reuse Me 7"] = "Reuse Me 7",
	["Revantusk Village"] = "Revantusk Village",
	["Rhea's Camp"] = "Rhea's Camp",
	["Rhonin's Beard"] = "Rhonin's Beard",
	["Rhyolith Plateau"] = "Rhyolith Plateau",
	["Ricket's Folly"] = "Ricket's Folly",
	["Ridge of Laughing Winds"] = "Ridge of Laughing Winds",
	["Ridge of Madness"] = "Ridge of Madness",
	["Ridgepoint Tower"] = "Ridgepoint Tower",
	Rikkilea = "Rikkilea",
	["Rikkitun Village"] = "Rikkitun Village",
	["Rim of the World"] = "Rim of the World",
	["Ring of Judgement"] = "Ring of Judgement",
	["Ring of Observance"] = "Ring of Observance",
	["Ring of the Elements"] = "Ring of the Elements",
	["Ring of the Law"] = "Ring of the Law",
	["Riplash Ruins"] = "Riplash Ruins",
	["Riplash Strand"] = "Riplash Strand",
	["Rise of Suffering"] = "Rise of Suffering",
	["Rise of the Defiler"] = "Rise of the Defiler",
	["Ritual Chamber of Akali"] = "Ritual Chamber of Akali",
	["Rivendark's Perch"] = "Rivendark's Perch",
	Rivenwood = "Rivenwood",
	["River's Heart"] = "River's Heart",
	["Rock of Durotan"] = "Rock of Durotan",
	["Rockpool Village"] = "Rockpool Village",
	["Rocktusk Farm"] = "Rocktusk Farm",
	["Roguefeather Den"] = "Roguefeather Den",
	["Rogues' Quarter"] = "Rogues' Quarter",
	["Rohemdal Pass"] = "Rohemdal Pass",
	["Roland's Doom"] = "Roland's Doom",
	["Room of Hidden Secrets"] = "Room of Hidden Secrets",
	["Roost of Ji-Kun"] = "Roost of Ji-Kun",
	["Rotbrain Encampment"] = "Rotbrain Encampment",
	["Royal Amphitheater"] = "Royal Amphitheater",
	["Royal Approach"] = "Royal Approach",
	["Royal Exchange Auction House"] = "Royal Exchange Auction House",
	["Royal Exchange Bank"] = "Royal Exchange Bank",
	["Royal Gallery"] = "Royal Gallery",
	["Royal Library"] = "Royal Library",
	["Royal Quarter"] = "Royal Quarter",
	["Ruby Dragonshrine"] = "Ruby Dragonshrine",
	["Ruined Approach"] = "Ruined Approach",
	["Ruined City Post 01"] = "Ruined City Post 01",
	["Ruined Court"] = "Ruined Court",
	["Ruins of Aboraz"] = "Ruins of Aboraz",
	["Ruins of Ahmtul"] = "Ruins of Ahmtul",
	["Ruins of Ahn'Qiraj"] = "Ruins of Ahn'Qiraj",
	["Ruins of Alterac"] = "Ruins of Alterac",
	["Ruins of Ammon"] = "Ruins of Ammon",
	["Ruins of Arkkoran"] = "Ruins of Arkkoran",
	["Ruins of Auberdine"] = "Ruins of Auberdine",
	["Ruins of Baa'ri"] = "Ruins of Baa'ri",
	["Ruins of Constellas"] = "Ruins of Constellas",
	["Ruins of Dojan"] = "Ruins of Dojan",
	["Ruins of Drakgor"] = "Ruins of Drakgor",
	["Ruins of Drak'Zin"] = "Ruins of Drak'Zin",
	["Ruins of Eldarath"] = "Ruins of Eldarath",
	["Ruins of Eldarath "] = "Ruins of Eldarath ",
	["Ruins of Eldra'nath"] = "Ruins of Eldra'nath",
	["Ruins of Eldre'thar"] = "Ruins of Eldre'thar",
	["Ruins of Enkaat"] = "Ruins of Enkaat",
	["Ruins of Farahlon"] = "Ruins of Farahlon",
	["Ruins of Feathermoon"] = "Ruins of Feathermoon",
	["Ruins of Gilneas"] = "Ruins of Gilneas",
	["Ruins of Gilneas City"] = "Ruins of Gilneas City",
	["Ruins of Guo-Lai"] = "Ruins of Guo-Lai",
	["Ruins of Isildien"] = "Ruins of Isildien",
	["Ruins of Jubuwal"] = "Ruins of Jubuwal",
	["Ruins of Karabor"] = "Ruins of Karabor",
	["Ruins of Kargath"] = "Ruins of Kargath",
	["Ruins of Khintaset"] = "Ruins of Khintaset",
	["Ruins of Korja"] = "Ruins of Korja",
	["Ruins of Korune"] = "Ruins of Korune",
	["Ruins of Lar'donir"] = "Ruins of Lar'donir",
	["Ruins of Lordaeron"] = "Ruins of Lordaeron",
	["Ruins of Loreth'Aran"] = "Ruins of Loreth'Aran",
	["Ruins of Lornesta"] = "Ruins of Lornesta",
	["Ruins of Mathystra"] = "Ruins of Mathystra",
	["Ruins of Nordressa"] = "Ruins of Nordressa",
	["Ruins of Ogudei"] = "Ruins of Ogudei",
	["Ruins of Ravenwind"] = "Ruins of Ravenwind",
	["Ruins of Sha'naar"] = "Ruins of Sha'naar",
	["Ruins of Shandaral"] = "Ruins of Shandaral",
	["Ruins of Silvermoon"] = "Ruins of Silvermoon",
	["Ruins of Solarsal"] = "Ruins of Solarsal",
	["Ruins of Southshore"] = "Ruins of Southshore",
	["Ruins of Taurajo"] = "Ruins of Taurajo",
	["Ruins of Tethys"] = "Ruins of Tethys",
	["Ruins of Thaurissan"] = "Ruins of Thaurissan",
	["Ruins of Thelserai Temple"] = "Ruins of Thelserai Temple",
	["Ruins of Theramore"] = "Ruins of Theramore",
	["Ruins of the Scarlet Enclave"] = "Ruins of the Scarlet Enclave",
	["Ruins of Uldum"] = "Ruins of Uldum",
	["Ruins of Vashj'elan"] = "Ruins of Vashj'elan",
	["Ruins of Vashj'ir"] = "Ruins of Vashj'ir",
	["Ruins of Zul'Kunda"] = "Ruins of Zul'Kunda",
	["Ruins of Zul'Mamwe"] = "Ruins of Zul'Mamwe",
	["Ruins Rise"] = "Ruins Rise",
	["Rumbling Terrace"] = "Rumbling Terrace",
	["Runestone Falithas"] = "Runestone Falithas",
	["Runestone Shan'dor"] = "Runestone Shan'dor",
	["Runeweaver Square"] = "Runeweaver Square",
	["Rustberg Village"] = "Rustberg Village",
	["Rustmaul Dive Site"] = "Rustmaul Dive Site",
	["Rutsak's Guard"] = "Rutsak's Guard",
	["Rut'theran Village"] = "Rut'theran Village",
	["Ruuan Weald"] = "Ruuan Weald",
	["Ruuna's Camp"] = "Ruuna's Camp",
	["Ruuzel's Isle"] = "Ruuzel's Isle",
	["Rygna's Lair"] = "Rygna's Lair",
	["Sable Ridge"] = "Sable Ridge",
	["Sacrificial Altar"] = "Sacrificial Altar",
	["Sahket Wastes"] = "Sahket Wastes",
	Salabria = "Salabria",
	["Saldean's Farm"] = "Saldean's Farm",
	["Saltheril's Haven"] = "Saltheril's Haven",
	["Saltspray Glen"] = "Saltspray Glen",
	["Sanctuary of Malorne"] = "Sanctuary of Malorne",
	["Sanctuary of Shadows"] = "Sanctuary of Shadows",
	["Sanctum of Reanimation"] = "Sanctum of Reanimation",
	["Sanctum of Shadows"] = "Sanctum of Shadows",
	["Sanctum of the Ascended"] = "Sanctum of the Ascended",
	["Sanctum of the Fallen God"] = "Sanctum of the Fallen God",
	["Sanctum of the Moon"] = "Sanctum of the Moon",
	["Sanctum of the Prophets"] = "Sanctum of the Prophets",
	["Sanctum of the South Wind"] = "Sanctum of the South Wind",
	["Sanctum of the Stars"] = "Sanctum of the Stars",
	["Sanctum of the Sun"] = "Sanctum of the Sun",
	["Sands of Nasam"] = "Sands of Nasam",
	["Sandsorrow Watch"] = "Sandsorrow Watch",
	["Sandy Beach"] = "Sandy Beach",
	["Sandy Shallows"] = "Sandy Shallows",
	["Sanguine Chamber"] = "Sanguine Chamber",
	["Sapphire Hive"] = "Sapphire Hive",
	["Sapphiron's Lair"] = "Sapphiron's Lair",
	["Saragosa's Landing"] = "Saragosa's Landing",
	Sarahland = "Sarahland",
	["Sardor Isle"] = "Sardor Isle",
	Sargeron = "Sargeron",
	["Sarjun Depths"] = "Sarjun Depths",
	["Saronite Mines"] = "Saronite Mines",
	["Sar'theris Strand"] = "Sar'theris Strand",
	Satyrnaar = "Satyrnaar",
	["Saurok Creation Pit"] = "Saurok Creation Pit",
	["Savage Ledge"] = "Savage Ledge",
	["Scalawag Point"] = "Scalawag Point",
	["Scalding Pools"] = "Scalding Pools",
	["Scalebeard's Cave"] = "Scalebeard's Cave",
	["Scalewing Shelf"] = "Scalewing Shelf",
	["Scarab Terrace"] = "Scarab Terrace",
	["Scarlet Encampment"] = "Scarlet Encampment",
	["Scarlet Halls"] = "Scarlet Halls",
	["Scarlet Hold"] = "Scarlet Hold",
	["Scarlet Monastery"] = "Scarlet Monastery",
	["Scarlet Monastery Entrance"] = "Scarlet Monastery Entrance",
	["Scarlet Overlook"] = "Scarlet Overlook",
	["Scarlet Palisade"] = "Scarlet Palisade",
	["Scarlet Point"] = "Scarlet Point",
	["Scarlet Raven Tavern"] = "Scarlet Raven Tavern",
	["Scarlet Tavern"] = "Scarlet Tavern",
	["Scarlet Tower"] = "Scarlet Tower",
	["Scarlet Watch Post"] = "Scarlet Watch Post",
	["Scarlet Watchtower"] = "Scarlet Watchtower",
	["Scar of the Worldbreaker"] = "Scar of the Worldbreaker",
	["Scarred Terrace"] = "Scarred Terrace",
	["Scenario: Alcaz Island"] = "Scenario: Alcaz Island",
	["Scenario - Black Ox Temple"] = "Scenario - Black Ox Temple",
	["Scenario - Mogu Ruins"] = "Scenario - Mogu Ruins",
	["Scenic Overlook"] = "Scenic Overlook",
	["Schnottz's Frigate"] = "Schnottz's Frigate",
	["Schnottz's Hostel"] = "Schnottz's Hostel",
	["Schnottz's Landing"] = "Schnottz's Landing",
	Scholomance = "Scholomance",
	["Scholomance Entrance"] = "Scholomance Entrance",
	ScholomanceOLD = "ScholomanceOLD",
	["School of Necromancy"] = "School of Necromancy",
	["Scorched Gully"] = "Scorched Gully",
	["Scott's Spooky Area"] = "Scott's Spooky Area",
	["Scoured Reach"] = "Scoured Reach",
	Scourgehold = "Scourgehold",
	Scourgeholme = "Scourgeholme",
	["Scourgelord's Command"] = "Scourgelord's Command",
	["Scrabblescrew's Camp"] = "Scrabblescrew's Camp",
	["Screaming Gully"] = "Screaming Gully",
	["Scryer's Tier"] = "Scryer's Tier",
	["Scuttle Coast"] = "Scuttle Coast",
	Sea = "Sea",
	Seabrush = "Seabrush",
	["Seafarer's Tomb"] = "Seafarer's Tomb",
	["Sealed Chambers"] = "Sealed Chambers",
	["Seal of the Sun King"] = "Seal of the Sun King",
	["Sea Mist Ridge"] = "Sea Mist Ridge",
	["Searing Gorge"] = "Searing Gorge",
	["Seaspittle Cove"] = "Seaspittle Cove",
	["Seaspittle Nook"] = "Seaspittle Nook",
	["Seat of Destruction"] = "Seat of Destruction",
	["Seat of Knowledge"] = "Seat of Knowledge",
	["Seat of Life"] = "Seat of Life",
	["Seat of Magic"] = "Seat of Magic",
	["Seat of Radiance"] = "Seat of Radiance",
	["Seat of the Chosen"] = "Seat of the Chosen",
	["Seat of the Naaru"] = "Seat of the Naaru",
	["Seat of the Spirit Waker"] = "Seat of the Spirit Waker",
	["Seeker's Folly"] = "Seeker's Folly",
	["Seeker's Point"] = "Seeker's Point",
	["Sen'jin Village"] = "Sen'jin Village",
	["Sen'jin Village Outskirts"] = "Sen'jin Village Outskirts",
	["Sentinel Basecamp"] = "Sentinel Basecamp",
	["Sentinel Hill"] = "Sentinel Hill",
	["Sentinel Tower"] = "Sentinel Tower",
	["Sentry Point"] = "Sentry Point",
	Seradane = "Seradane",
	["Serenity Falls"] = "Serenity Falls",
	["Serpent Lake"] = "Serpent Lake",
	["Serpent's Coil"] = "Serpent's Coil",
	["Serpent's Heart"] = "Serpent's Heart",
	["Serpentshrine Cavern"] = "Serpentshrine Cavern",
	["Serpent's Overlook"] = "Serpent's Overlook",
	["Serpent's Spine"] = "Serpent's Spine",
	["Servants' Quarters"] = "Servants' Quarters",
	["Service Entrance"] = "Service Entrance",
	["Sethekk Halls"] = "Sethekk Halls",
	["Sethria's Roost"] = "Sethria's Roost",
	["Setting Sun Garrison"] = "Setting Sun Garrison",
	["Set'vess"] = "Set'vess",
	["Sewer Access Point"] = "Sewer Access Point",
	["Sewer Exit Pipe"] = "Sewer Exit Pipe",
	Sewers = "Sewers",
	Shadebough = "Shadebough",
	["Shadewood Thicket"] = "Shadewood Thicket",
	["Shado-Li Basin"] = "Shado-Li Basin",
	["Shado-Pan Fallback"] = "Shado-Pan Fallback",
	["Shado-Pan Garrison"] = "Shado-Pan Garrison",
	["Shado-Pan Monastery"] = "Shado-Pan Monastery",
	["Shadowbreak Ravine"] = "Shadowbreak Ravine",
	["Shadowfang Keep"] = "Shadowfang Keep",
	["Shadowfang Keep Entrance"] = "Shadowfang Keep Entrance",
	["Shadowfang Tower"] = "Shadowfang Tower",
	["Shadowforge City"] = "Shadowforge City",
	Shadowglen = "Shadowglen",
	["Shadow Grave"] = "Shadow Grave",
	["Shadow Hold"] = "Shadow Hold",
	["Shadow Labyrinth"] = "Shadow Labyrinth",
	["Shadowlurk Ridge"] = "Shadowlurk Ridge",
	["Shadowmoon Valley"] = "Shadowmoon Valley",
	["Shadowmoon Village"] = "Shadowmoon Village",
	["Shadow-Pan Monastery"] = "Shadow-Pan Monastery",
	["Shadowprey Village"] = "Shadowprey Village",
	["Shadow Ridge"] = "Shadow Ridge",
	["Shadowshard Cavern"] = "Shadowshard Cavern",
	["Shadowsight Tower"] = "Shadowsight Tower",
	["Shadowsong Shrine"] = "Shadowsong Shrine",
	["Shadowthread Cave"] = "Shadowthread Cave",
	["Shadow Tomb"] = "Shadow Tomb",
	["Shadow Wing Lair"] = "Shadow Wing Lair",
	["Shadra'Alor"] = "Shadra'Alor",
	["Shadybranch Pocket"] = "Shadybranch Pocket",
	["Shady Rest Inn"] = "Shady Rest Inn",
	["Shalandis Isle"] = "Shalandis Isle",
	["Shalewind Canyon"] = "Shalewind Canyon",
	["Shallow's End"] = "Shallow's End",
	["Shallowstep Pass"] = "Shallowstep Pass",
	["Shalzaru's Lair"] = "Shalzaru's Lair",
	Shamanar = "Shamanar",
	["Sha'naari Wastes"] = "Sha'naari Wastes",
	["Shang's Stead"] = "Shang's Stead",
	["Shang's Valley"] = "Shang's Valley",
	["Shang Xi Training Grounds"] = "Shang Xi Training Grounds",
	["Shan'ze Dao"] = "Shan'ze Dao",
	["Shaol'mara"] = "Shaol'mara",
	["Shaol'watha"] = "Shaol'watha",
	["Shaper's Terrace"] = "Shaper's Terrace",
	["Shaper's Terrace "] = "Shaper's Terrace ",
	["Shartuul's Transporter"] = "Shartuul's Transporter",
	["Sha'tari Base Camp"] = "Sha'tari Base Camp",
	["Sha'tari Outpost"] = "Sha'tari Outpost",
	["Shattered Convoy"] = "Shattered Convoy",
	["Shattered Plains"] = "Shattered Plains",
	["Shattered Straits"] = "Shattered Straits",
	["Shattered Sun Staging Area"] = "Shattered Sun Staging Area",
	["Shatter Point"] = "Shatter Point",
	["Shatter Scar Vale"] = "Shatter Scar Vale",
	Shattershore = "Shattershore",
	["Shatterspear Pass"] = "Shatterspear Pass",
	["Shatterspear Vale"] = "Shatterspear Vale",
	["Shatterspear War Camp"] = "Shatterspear War Camp",
	Shatterstone = "Shatterstone",
	Shattrath = "Shattrath",
	["Shattrath City"] = "Shattrath City",
	["Shelf of Mazu"] = "Shelf of Mazu",
	["Shell Beach"] = "Shell Beach",
	["Shield Hill"] = "Shield Hill",
	["Shields of Silver"] = "Shields of Silver",
	["Shimmering Bog"] = "Shimmering Bog",
	["Shimmering Expanse"] = "Shimmering Expanse",
	["Shimmering Grotto"] = "Shimmering Grotto",
	["Shimmer Ridge"] = "Shimmer Ridge",
	["Shindigger's Camp"] = "Shindigger's Camp",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Ship to Vashj'ir (Orgrimmar -> Vashj'ir)",
	["Shipwreck Shore"] = "Shipwreck Shore",
	Shipyard = "Shipyard",
	["Shipyard - Mogu Island Progression Scenario"] = "Shipyard - Mogu Island Progression Scenario",
	["Shok'Thokar"] = "Shok'Thokar",
	["Sholazar Basin"] = "Sholazar Basin",
	["Shores of the Well"] = "Shores of the Well",
	["Shrine of Aessina"] = "Shrine of Aessina",
	["Shrine of Aviana"] = "Shrine of Aviana",
	["Shrine of Dath'Remar"] = "Shrine of Dath'Remar",
	["Shrine of Dreaming Stones"] = "Shrine of Dreaming Stones",
	["Shrine of Eck"] = "Shrine of Eck",
	["Shrine of Fellowship"] = "Shrine of Fellowship",
	["Shrine of Five Dawns"] = "Shrine of Five Dawns",
	["Shrine of Goldrinn"] = "Shrine of Goldrinn",
	["Shrine of Inner-Light"] = "Shrine of Inner-Light",
	["Shrine of Lost Souls"] = "Shrine of Lost Souls",
	["Shrine of Nala'shi"] = "Shrine of Nala'shi",
	["Shrine of Remembrance"] = "Shrine of Remembrance",
	["Shrine of Remulos"] = "Shrine of Remulos",
	["Shrine of Scales"] = "Shrine of Scales",
	["Shrine of Seven Stars"] = "Shrine of Seven Stars",
	["Shrine of Thaurissan"] = "Shrine of Thaurissan",
	["Shrine of the Dawn"] = "Shrine of the Dawn",
	["Shrine of the Deceiver"] = "Shrine of the Deceiver",
	["Shrine of the Dormant Flame"] = "Shrine of the Dormant Flame",
	["Shrine of the Eclipse"] = "Shrine of the Eclipse",
	["Shrine of the Elements"] = "Shrine of the Elements",
	["Shrine of the Fallen Warrior"] = "Shrine of the Fallen Warrior",
	["Shrine of the Five Khans"] = "Shrine of the Five Khans",
	["Shrine of the Merciless One"] = "Shrine of the Merciless One",
	["Shrine of the Ox"] = "Shrine of the Ox",
	["Shrine of Twin Serpents"] = "Shrine of Twin Serpents",
	["Shrine of Two Moons"] = "Shrine of Two Moons",
	["Shrine of Unending Light"] = "Shrine of Unending Light",
	["Shriveled Oasis"] = "Shriveled Oasis",
	["Shuddering Spires"] = "Shuddering Spires",
	["SI:7"] = "SI:7",
	["Siege of Niuzao Temple"] = "Siege of Niuzao Temple",
	["Siege Vise"] = "Siege Vise",
	["Siege Workshop"] = "Siege Workshop",
	["Sifreldar Village"] = "Sifreldar Village",
	["Sik'vess"] = "Sik'vess",
	["Sik'vess Lair"] = "Sik'vess Lair",
	["Silent Vigil"] = "Silent Vigil",
	Silithus = "Silithus",
	["Silken Fields"] = "Silken Fields",
	["Silken Shore"] = "Silken Shore",
	["Silmyr Lake"] = "Silmyr Lake",
	["Silting Shore"] = "Silting Shore",
	Silverbrook = "Silverbrook",
	["Silverbrook Hills"] = "Silverbrook Hills",
	["Silver Covenant Pavilion"] = "Silver Covenant Pavilion",
	["Silverlight Cavern"] = "Silverlight Cavern",
	["Silverline Lake"] = "Silverline Lake",
	["Silvermoon City"] = "Silvermoon City",
	["Silvermoon City Inn"] = "Silvermoon City Inn",
	["Silvermoon Finery"] = "Silvermoon Finery",
	["Silvermoon Jewelery"] = "Silvermoon Jewelery",
	["Silvermoon Registry"] = "Silvermoon Registry",
	["Silvermoon's Pride"] = "Silvermoon's Pride",
	["Silvermyst Isle"] = "Silvermyst Isle",
	["Silverpine Forest"] = "Silverpine Forest",
	["Silvershard Mines"] = "Silvershard Mines",
	["Silver Stream Mine"] = "Silver Stream Mine",
	["Silver Tide Hollow"] = "Silver Tide Hollow",
	["Silver Tide Trench"] = "Silver Tide Trench",
	["Silverwind Refuge"] = "Silverwind Refuge",
	["Silverwing Flag Room"] = "Silverwing Flag Room",
	["Silverwing Grove"] = "Silverwing Grove",
	["Silverwing Hold"] = "Silverwing Hold",
	["Silverwing Outpost"] = "Silverwing Outpost",
	["Simply Enchanting"] = "Simply Enchanting",
	["Sindragosa's Fall"] = "Sindragosa's Fall",
	["Sindweller's Rise"] = "Sindweller's Rise",
	["Singing Marshes"] = "Singing Marshes",
	["Singing Ridge"] = "Singing Ridge",
	["Sinner's Folly"] = "Sinner's Folly",
	["Sira'kess Front"] = "Sira'kess Front",
	["Sishir Canyon"] = "Sishir Canyon",
	["Sisters Sorcerous"] = "Sisters Sorcerous",
	Skald = "Skald",
	["Sketh'lon Base Camp"] = "Sketh'lon Base Camp",
	["Sketh'lon Wreckage"] = "Sketh'lon Wreckage",
	["Skethyl Mountains"] = "Skethyl Mountains",
	Skettis = "Skettis",
	["Skitterweb Tunnels"] = "Skitterweb Tunnels",
	Skorn = "Skorn",
	["Skulking Row"] = "Skulking Row",
	["Skulk Rock"] = "Skulk Rock",
	["Skull Rock"] = "Skull Rock",
	["Sky Falls"] = "Sky Falls",
	["Skyguard Outpost"] = "Skyguard Outpost",
	["Skyline Ridge"] = "Skyline Ridge",
	Skyrange = "Skyrange",
	["Skysong Lake"] = "Skysong Lake",
	["Slabchisel's Survey"] = "Slabchisel's Survey",
	["Slag Watch"] = "Slag Watch",
	Slagworks = "Slagworks",
	["Slaughter Hollow"] = "Slaughter Hollow",
	["Slaughter Square"] = "Slaughter Square",
	["Sleeping Gorge"] = "Sleeping Gorge",
	["Slicky Stream"] = "Slicky Stream",
	["Slingtail Pits"] = "Slingtail Pits",
	["Slitherblade Shore"] = "Slitherblade Shore",
	["Slithering Cove"] = "Slithering Cove",
	["Slither Rock"] = "Slither Rock",
	["Sludgeguard Tower"] = "Sludgeguard Tower",
	["Smuggler's Scar"] = "Smuggler's Scar",
	["Snicklefritz Mine"] = "Snicklefritz Mine",
	["Snowblind Hills"] = "Snowblind Hills",
	["Snowblind Terrace"] = "Snowblind Terrace",
	["Snowden Chalet"] = "Snowden Chalet",
	["Snowdrift Dojo"] = "Snowdrift Dojo",
	["Snowdrift Plains"] = "Snowdrift Plains",
	["Snowfall Glade"] = "Snowfall Glade",
	["Snowfall Graveyard"] = "Snowfall Graveyard",
	["Socrethar's Seat"] = "Socrethar's Seat",
	["Sofera's Naze"] = "Sofera's Naze",
	["Soggy's Gamble"] = "Soggy's Gamble",
	["Solace Glade"] = "Solace Glade",
	["Solliden Farmstead"] = "Solliden Farmstead",
	["Solstice Village"] = "Solstice Village",
	["Sorlof's Strand"] = "Sorlof's Strand",
	["Sorrow Hill"] = "Sorrow Hill",
	["Sorrow Hill Crypt"] = "Sorrow Hill Crypt",
	Sorrowmurk = "Sorrowmurk",
	["Sorrow Wing Point"] = "Sorrow Wing Point",
	["Soulgrinder's Barrow"] = "Soulgrinder's Barrow",
	["Southbreak Shore"] = "Southbreak Shore",
	["South Common Hall"] = "South Common Hall",
	["Southern Barrens"] = "Southern Barrens",
	["Southern Gold Road"] = "Southern Gold Road",
	["Southern Rampart"] = "Southern Rampart",
	["Southern Rocketway"] = "Southern Rocketway",
	["Southern Rocketway Terminus"] = "Southern Rocketway Terminus",
	["Southern Savage Coast"] = "Southern Savage Coast",
	["Southfury River"] = "Southfury River",
	["Southfury Watershed"] = "Southfury Watershed",
	["South Gate Outpost"] = "South Gate Outpost",
	["South Gate Pass"] = "South Gate Pass",
	["Southmaul Tower"] = "Southmaul Tower",
	["Southmoon Ruins"] = "Southmoon Ruins",
	["South Pavilion"] = "South Pavilion",
	["Southpoint Gate"] = "Southpoint Gate",
	["South Point Station"] = "South Point Station",
	["Southpoint Tower"] = "Southpoint Tower",
	["Southridge Beach"] = "Southridge Beach",
	["Southsea Holdfast"] = "Southsea Holdfast",
	["South Seas"] = "South Seas",
	Southshore = "Southshore",
	["Southshore Town Hall"] = "Southshore Town Hall",
	["South Spire"] = "South Spire",
	["South Tide's Run"] = "South Tide's Run",
	["Southwind Cleft"] = "Southwind Cleft",
	["Southwind Village"] = "Southwind Village",
	["Sparkrocket Outpost"] = "Sparkrocket Outpost",
	["Sparksocket Minefield"] = "Sparksocket Minefield",
	["Sparktouched Haven"] = "Sparktouched Haven",
	["Sparring Hall"] = "Sparring Hall",
	["Spearborn Encampment"] = "Spearborn Encampment",
	Spearhead = "Spearhead",
	["Speedbarge Bar"] = "Speedbarge Bar",
	Spellsails = "Spellsails",
	["Spinebreaker Mountains"] = "Spinebreaker Mountains",
	["Spinebreaker Pass"] = "Spinebreaker Pass",
	["Spinebreaker Post"] = "Spinebreaker Post",
	["Spinebreaker Ridge"] = "Spinebreaker Ridge",
	["Spiral of Thorns"] = "Spiral of Thorns",
	["Spire of Blood"] = "Spire of Blood",
	["Spire of Decay"] = "Spire of Decay",
	["Spire of Pain"] = "Spire of Pain",
	["Spire of Solitude"] = "Spire of Solitude",
	["Spire Throne"] = "Spire Throne",
	["Spirit Den"] = "Spirit Den",
	["Spirit Fields"] = "Spirit Fields",
	["Spirit Rise"] = "Spirit Rise",
	["Spirit Rock"] = "Spirit Rock",
	["Spiritsong River"] = "Spiritsong River",
	["Spiritsong's Rest"] = "Spiritsong's Rest",
	["Spitescale Cavern"] = "Spitescale Cavern",
	["Spitescale Cove"] = "Spitescale Cove",
	["Splinterspear Junction"] = "Splinterspear Junction",
	Splintertree = "Splintertree",
	["Splintertree Mine"] = "Splintertree Mine",
	["Splintertree Post"] = "Splintertree Post",
	["Splithoof Crag"] = "Splithoof Crag",
	["Splithoof Heights"] = "Splithoof Heights",
	["Splithoof Hold"] = "Splithoof Hold",
	Sporeggar = "Sporeggar",
	["Sporewind Lake"] = "Sporewind Lake",
	["Springtail Crag"] = "Springtail Crag",
	["Springtail Warren"] = "Springtail Warren",
	["Spruce Point Post"] = "Spruce Point Post",
	["Sra'thik Incursion"] = "Sra'thik Incursion",
	["Sra'thik Swarmdock"] = "Sra'thik Swarmdock",
	["Sra'vess"] = "Sra'vess",
	["Sra'vess Rootchamber"] = "Sra'vess Rootchamber",
	["Sri-La Inn"] = "Sri-La Inn",
	["Sri-La Village"] = "Sri-La Village",
	Stables = "Stables",
	Stagalbog = "Stagalbog",
	["Stagalbog Cave"] = "Stagalbog Cave",
	["Stagecoach Crash Site"] = "Stagecoach Crash Site",
	["Staghelm Point"] = "Staghelm Point",
	["Staging Balcony"] = "Staging Balcony",
	["Stairway to Honor"] = "Stairway to Honor",
	["Starbreeze Village"] = "Starbreeze Village",
	["Stardust Spire"] = "Stardust Spire",
	["Starfall Village"] = "Starfall Village",
	["Stars' Rest"] = "Stars' Rest",
	["Stasis Block: Maximus"] = "Stasis Block: Maximus",
	["Stasis Block: Trion"] = "Stasis Block: Trion",
	["Steam Springs"] = "Steam Springs",
	["Steamwheedle Port"] = "Steamwheedle Port",
	["Steel Gate"] = "Steel Gate",
	["Steelgrill's Depot"] = "Steelgrill's Depot",
	["Steeljaw's Caravan"] = "Steeljaw's Caravan",
	["Steelspark Station"] = "Steelspark Station",
	["Stendel's Pond"] = "Stendel's Pond",
	["Stillpine Hold"] = "Stillpine Hold",
	["Stillwater Pond"] = "Stillwater Pond",
	["Stillwhisper Pond"] = "Stillwhisper Pond",
	Stonard = "Stonard",
	["Stonebreaker Camp"] = "Stonebreaker Camp",
	["Stonebreaker Hold"] = "Stonebreaker Hold",
	["Stonebull Lake"] = "Stonebull Lake",
	["Stone Cairn Lake"] = "Stone Cairn Lake",
	Stonehearth = "Stonehearth",
	["Stonehearth Bunker"] = "Stonehearth Bunker",
	["Stonehearth Graveyard"] = "Stonehearth Graveyard",
	["Stonehearth Outpost"] = "Stonehearth Outpost",
	["Stonemaul Hold"] = "Stonemaul Hold",
	["Stonemaul Ruins"] = "Stonemaul Ruins",
	["Stone Mug Tavern"] = "Stone Mug Tavern",
	Stoneplow = "Stoneplow",
	["Stoneplow Fields"] = "Stoneplow Fields",
	["Stone Sentinel's Overlook"] = "Stone Sentinel's Overlook",
	["Stonesplinter Valley"] = "Stonesplinter Valley",
	["Stonetalon Bomb"] = "Stonetalon Bomb",
	["Stonetalon Mountains"] = "Stonetalon Mountains",
	["Stonetalon Pass"] = "Stonetalon Pass",
	["Stonetalon Peak"] = "Stonetalon Peak",
	["Stonewall Canyon"] = "Stonewall Canyon",
	["Stonewall Lift"] = "Stonewall Lift",
	["Stoneward Prison"] = "Stoneward Prison",
	Stonewatch = "Stonewatch",
	["Stonewatch Falls"] = "Stonewatch Falls",
	["Stonewatch Keep"] = "Stonewatch Keep",
	["Stonewatch Tower"] = "Stonewatch Tower",
	["Stonewrought Dam"] = "Stonewrought Dam",
	["Stonewrought Pass"] = "Stonewrought Pass",
	["Storm Cliffs"] = "Storm Cliffs",
	Stormcrest = "Stormcrest",
	["Stormfeather Outpost"] = "Stormfeather Outpost",
	["Stormglen Village"] = "Stormglen Village",
	["Storm Peaks"] = "Storm Peaks",
	["Stormpike Graveyard"] = "Stormpike Graveyard",
	["Stormrage Barrow Dens"] = "Stormrage Barrow Dens",
	["Stormsea Landing"] = "Stormsea Landing",
	["Storm's Fury Wreckage"] = "Storm's Fury Wreckage",
	["Stormstout Brewery"] = "Stormstout Brewery",
	["Stormstout Brewery Interior"] = "Stormstout Brewery Interior",
	["Stormstout Brewhall"] = "Stormstout Brewhall",
	Stormwind = "Stormwind",
	["Stormwind City"] = "Stormwind City",
	["Stormwind City Cemetery"] = "Stormwind City Cemetery",
	["Stormwind City Outskirts"] = "Stormwind City Outskirts",
	["Stormwind Gunship Pandaria Start Area"] = "Stormwind Gunship Pandaria Start Area",
	["Stormwind Harbor"] = "Stormwind Harbor",
	["Stormwind Keep"] = "Stormwind Keep",
	["Stormwind Lake"] = "Stormwind Lake",
	["Stormwind Mountains"] = "Stormwind Mountains",
	["Stormwind Stockade"] = "Stormwind Stockade",
	["Stormwind Vault"] = "Stormwind Vault",
	["Stoutlager Inn"] = "Stoutlager Inn",
	Strahnbrad = "Strahnbrad",
	["Strand of the Ancients"] = "Strand of the Ancients",
	["Stranglethorn Vale"] = "Stranglethorn Vale",
	Stratholme = "Stratholme",
	["Stratholme Entrance"] = "Stratholme Entrance",
	["Stratholme - Main Gate"] = "Stratholme - Main Gate",
	["Stratholme - Service Entrance"] = "Stratholme - Service Entrance",
	["Stratholme Service Entrance"] = "Stratholme Service Entrance",
	["Stromgarde Keep"] = "Stromgarde Keep",
	["Strongarm Airstrip"] = "Strongarm Airstrip",
	["STV Diamond Mine BG"] = "STV Diamond Mine BG",
	["Stygian Bounty"] = "Stygian Bounty",
	["Sub zone"] = "Sub zone",
	["Sulfuron Keep"] = "Sulfuron Keep",
	["Sulfuron Keep Courtyard"] = "Sulfuron Keep Courtyard",
	["Sulfuron Span"] = "Sulfuron Span",
	["Sulfuron Spire"] = "Sulfuron Spire",
	["Sullah's Sideshow"] = "Sullah's Sideshow",
	["Summer's Rest"] = "Summer's Rest",
	["Summoners' Tomb"] = "Summoners' Tomb",
	["Sunblossom Hill"] = "Sunblossom Hill",
	["Suncrown Village"] = "Suncrown Village",
	["Sundown Marsh"] = "Sundown Marsh",
	["Sunfire Point"] = "Sunfire Point",
	["Sunfury Hold"] = "Sunfury Hold",
	["Sunfury Spire"] = "Sunfury Spire",
	["Sungraze Peak"] = "Sungraze Peak",
	["Sunken Dig Site"] = "Sunken Dig Site",
	["Sunken Temple"] = "Sunken Temple",
	["Sunken Temple Entrance"] = "Sunken Temple Entrance",
	["Sunreaver Pavilion"] = "Sunreaver Pavilion",
	["Sunreaver's Command"] = "Sunreaver's Command",
	["Sunreaver's Sanctuary"] = "Sunreaver's Sanctuary",
	["Sun Rock Retreat"] = "Sun Rock Retreat",
	["Sunsail Anchorage"] = "Sunsail Anchorage",
	["Sunsoaked Meadow"] = "Sunsoaked Meadow",
	["Sunsong Ranch"] = "Sunsong Ranch",
	["Sunspring Post"] = "Sunspring Post",
	["Sun's Reach Armory"] = "Sun's Reach Armory",
	["Sun's Reach Harbor"] = "Sun's Reach Harbor",
	["Sun's Reach Sanctum"] = "Sun's Reach Sanctum",
	["Sunstone Terrace"] = "Sunstone Terrace",
	["Sunstrider Isle"] = "Sunstrider Isle",
	["Sunveil Excursion"] = "Sunveil Excursion",
	["Sunwatcher's Ridge"] = "Sunwatcher's Ridge",
	["Sunwell Plateau"] = "Sunwell Plateau",
	["Supply Caravan"] = "Supply Caravan",
	["Surge Needle"] = "Surge Needle",
	["Surveyors' Outpost"] = "Surveyors' Outpost",
	Surwich = "Surwich",
	["Svarnos' Cell"] = "Svarnos' Cell",
	["Swamplight Manor"] = "Swamplight Manor",
	["Swamp of Sorrows"] = "Swamp of Sorrows",
	["Swamprat Post"] = "Swamprat Post",
	["Swiftgear Station"] = "Swiftgear Station",
	["Swindlegrin's Dig"] = "Swindlegrin's Dig",
	["Swindle Street"] = "Swindle Street",
	["Sword's Rest"] = "Sword's Rest",
	Sylvanaar = "Sylvanaar",
	["Tabetha's Farm"] = "Tabetha's Farm",
	["Taelan's Tower"] = "Taelan's Tower",
	["Tahonda Ruins"] = "Tahonda Ruins",
	["Tahret Grounds"] = "Tahret Grounds",
	["Tal'doren"] = "Tal'doren",
	["Talismanic Textiles"] = "Talismanic Textiles",
	["Tallmug's Camp"] = "Tallmug's Camp",
	["Talonbranch Glade"] = "Talonbranch Glade",
	["Talonbranch Glade "] = "Talonbranch Glade ",
	["Talondeep Pass"] = "Talondeep Pass",
	["Talondeep Vale"] = "Talondeep Vale",
	["Talon Stand"] = "Talon Stand",
	Talramas = "Talramas",
	["Talrendis Point"] = "Talrendis Point",
	Tanaris = "Tanaris",
	["Tanaris Desert"] = "Tanaris Desert",
	["Tanks for Everything"] = "Tanks for Everything",
	["Tanner Camp"] = "Tanner Camp",
	["Tarren Mill"] = "Tarren Mill",
	["Tasters' Arena"] = "Tasters' Arena",
	["Taunka'le Village"] = "Taunka'le Village",
	["Tavern in the Mists"] = "Tavern in the Mists",
	["Tazz'Alaor"] = "Tazz'Alaor",
	["Tear Down This Wall!"] = "Tear Down This Wall!",
	["Teegan's Expedition"] = "Teegan's Expedition",
	["Teeming Burrow"] = "Teeming Burrow",
	Telaar = "Telaar",
	["Telaari Basin"] = "Telaari Basin",
	["Tel'athion's Camp"] = "Tel'athion's Camp",
	Teldrassil = "Teldrassil",
	Telredor = "Telredor",
	["Tempest Bridge"] = "Tempest Bridge",
	["Tempest Keep"] = "Tempest Keep",
	["Tempest Keep: The Arcatraz"] = "Tempest Keep: The Arcatraz",
	["Tempest Keep - The Arcatraz Entrance"] = "Tempest Keep - The Arcatraz Entrance",
	["Tempest Keep: The Botanica"] = "Tempest Keep: The Botanica",
	["Tempest Keep - The Botanica Entrance"] = "Tempest Keep - The Botanica Entrance",
	["Tempest Keep: The Mechanar"] = "Tempest Keep: The Mechanar",
	["Tempest Keep - The Mechanar Entrance"] = "Tempest Keep - The Mechanar Entrance",
	["Tempest's Reach"] = "Tempest's Reach",
	["Temple City of En'kilah"] = "Temple City of En'kilah",
	["Temple Hall"] = "Temple Hall",
	["Temple of Ahn'Qiraj"] = "Temple of Ahn'Qiraj",
	["Temple of Arkkoran"] = "Temple of Arkkoran",
	["Temple of Asaad"] = "Temple of Asaad",
	["Temple of Bethekk"] = "Temple of Bethekk",
	["Temple of Earth"] = "Temple of Earth",
	["Temple of Five Dawns"] = "Temple of Five Dawns",
	["Temple of Invention"] = "Temple of Invention",
	["Temple of Kotmogu"] = "Temple of Kotmogu",
	["Temple of Life"] = "Temple of Life",
	["Temple of Order"] = "Temple of Order",
	["Temple of Storms"] = "Temple of Storms",
	["Temple of Telhamat"] = "Temple of Telhamat",
	["Temple of the Forgotten"] = "Temple of the Forgotten",
	["Temple of the Jade Serpent"] = "Temple of the Jade Serpent",
	["Temple of the Moon"] = "Temple of the Moon",
	["Temple of the Red Crane"] = "Temple of the Red Crane",
	["Temple of the White Tiger"] = "Temple of the White Tiger",
	["Temple of Uldum"] = "Temple of Uldum",
	["Temple of Winter"] = "Temple of Winter",
	["Temple of Wisdom"] = "Temple of Wisdom",
	["Temple of Zin-Malor"] = "Temple of Zin-Malor",
	["Temple Summit"] = "Temple Summit",
	["Tenebrous Cavern"] = "Tenebrous Cavern",
	["Terokkar Forest"] = "Terokkar Forest",
	["Terokk's Rest"] = "Terokk's Rest",
	["Terrace of Endless Spring"] = "Terrace of Endless Spring",
	["Terrace of Gurthan"] = "Terrace of Gurthan",
	["Terrace of Light"] = "Terrace of Light",
	["Terrace of Repose"] = "Terrace of Repose",
	["Terrace of Ten Thunders"] = "Terrace of Ten Thunders",
	["Terrace of the Augurs"] = "Terrace of the Augurs",
	["Terrace of the Makers"] = "Terrace of the Makers",
	["Terrace of the Sun"] = "Terrace of the Sun",
	["Terrace of the Tiger"] = "Terrace of the Tiger",
	["Terrace of the Twin Dragons"] = "Terrace of the Twin Dragons",
	Terrordale = "Terrordale",
	["Terror Run"] = "Terror Run",
	["Terrorweb Tunnel"] = "Terrorweb Tunnel",
	["Terror Wing Path"] = "Terror Wing Path",
	["Tethris Aran"] = "Tethris Aran",
	Thalanaar = "Thalanaar",
	["Thalassian Pass"] = "Thalassian Pass",
	["Thalassian Range"] = "Thalassian Range",
	["Thal'darah Grove"] = "Thal'darah Grove",
	["Thal'darah Overlook"] = "Thal'darah Overlook",
	["Thandol Span"] = "Thandol Span",
	["Thargad's Camp"] = "Thargad's Camp",
	["The Abandoned Reach"] = "The Abandoned Reach",
	["The Abyssal Maw"] = "The Abyssal Maw",
	["The Abyssal Shelf"] = "The Abyssal Shelf",
	["The Admiral's Den"] = "The Admiral's Den",
	["The Agronomical Apothecary"] = "The Agronomical Apothecary",
	["The Alliance Valiants' Ring"] = "The Alliance Valiants' Ring",
	["The Altar of Damnation"] = "The Altar of Damnation",
	["The Altar of Shadows"] = "The Altar of Shadows",
	["The Altar of Zul"] = "The Altar of Zul",
	["The Amber Hibernal"] = "The Amber Hibernal",
	["The Amber Vault"] = "The Amber Vault",
	["The Amber Womb"] = "The Amber Womb",
	["The Ancient Grove"] = "The Ancient Grove",
	["The Ancient Lift"] = "The Ancient Lift",
	["The Ancient Passage"] = "The Ancient Passage",
	["The Antechamber"] = "The Antechamber",
	["The Anvil of Conflagration"] = "The Anvil of Conflagration",
	["The Anvil of Flame"] = "The Anvil of Flame",
	["The Apothecarium"] = "The Apothecarium",
	["The Arachnid Quarter"] = "The Arachnid Quarter",
	["The Arboretum"] = "The Arboretum",
	["The Arcanium"] = "The Arcanium",
	["The Arcanium "] = "The Arcanium ",
	["The Arcatraz"] = "The Arcatraz",
	["The Archivum"] = "The Archivum",
	["The Argent Stand"] = "The Argent Stand",
	["The Argent Valiants' Ring"] = "The Argent Valiants' Ring",
	["The Argent Vanguard"] = "The Argent Vanguard",
	["The Arsenal Absolute"] = "The Arsenal Absolute",
	["The Aspirants' Ring"] = "The Aspirants' Ring",
	["The Assembly Chamber"] = "The Assembly Chamber",
	["The Assembly of Iron"] = "The Assembly of Iron",
	["The Athenaeum"] = "The Athenaeum",
	["The Autumn Plains"] = "The Autumn Plains",
	["The Avalanche"] = "The Avalanche",
	["The Azure Front"] = "The Azure Front",
	["The Bamboo Wilds"] = "The Bamboo Wilds",
	["The Bank of Dalaran"] = "The Bank of Dalaran",
	["The Bank of Silvermoon"] = "The Bank of Silvermoon",
	["The Banquet Hall"] = "The Banquet Hall",
	["The Barrier Hills"] = "The Barrier Hills",
	["The Bastion of Twilight"] = "The Bastion of Twilight",
	["The Battleboar Pen"] = "The Battleboar Pen",
	["The Battle for Gilneas"] = "The Battle for Gilneas",
	["The Battle for Gilneas (Old City Map)"] = "The Battle for Gilneas (Old City Map)",
	["The Battle for Mount Hyjal"] = "The Battle for Mount Hyjal",
	["The Battlefront"] = "The Battlefront",
	["The Bazaar"] = "The Bazaar",
	["The Beast Pens"] = "The Beast Pens",
	["The Beer Garden"] = "The Beer Garden",
	["The Bite"] = "The Bite",
	["The Black Breach"] = "The Black Breach",
	["The Black Market"] = "The Black Market",
	["The Black Morass"] = "The Black Morass",
	["The Black Temple"] = "The Black Temple",
	["The Black Vault"] = "The Black Vault",
	["The Blackwald"] = "The Blackwald",
	["The Blazing Strand"] = "The Blazing Strand",
	["The Blighted Pool"] = "The Blighted Pool",
	["The Blight Line"] = "The Blight Line",
	["The Bloodcursed Reef"] = "The Bloodcursed Reef",
	["The Blood Furnace"] = "The Blood Furnace",
	["The Bloodmire"] = "The Bloodmire",
	["The Bloodoath"] = "The Bloodoath",
	["The Blood Trail"] = "The Blood Trail",
	["The Bloodwash"] = "The Bloodwash",
	["The Boiling Crustacean"] = "The Boiling Crustacean",
	["The Bombardment"] = "The Bombardment",
	["The Bonefields"] = "The Bonefields",
	["The Bone Pile"] = "The Bone Pile",
	["The Bones of Nozronn"] = "The Bones of Nozronn",
	["The Bone Wastes"] = "The Bone Wastes",
	["The Boneyard"] = "The Boneyard",
	["The Borean Wall"] = "The Borean Wall",
	["The Botanica"] = "The Botanica",
	["The Bradshaw Mill"] = "The Bradshaw Mill",
	["The Breach"] = "The Breach",
	["The Briny Cutter"] = "The Briny Cutter",
	["The Briny Muck"] = "The Briny Muck",
	["The Briny Pinnacle"] = "The Briny Pinnacle",
	["The Broken Bluffs"] = "The Broken Bluffs",
	["The Broken Front"] = "The Broken Front",
	["The Broken Hall"] = "The Broken Hall",
	["The Broken Hills"] = "The Broken Hills",
	["The Broken Stair"] = "The Broken Stair",
	["The Broken Temple"] = "The Broken Temple",
	["The Broodmother's Nest"] = "The Broodmother's Nest",
	["The Brood Pit"] = "The Brood Pit",
	["The Bulwark"] = "The Bulwark",
	["The Burlap Trail"] = "The Burlap Trail",
	["The Burlap Valley"] = "The Burlap Valley",
	["The Burlap Waystation"] = "The Burlap Waystation",
	["The Burning Corridor"] = "The Burning Corridor",
	["The Butchery"] = "The Butchery",
	["The Cache of Madness"] = "The Cache of Madness",
	["The Caller's Chamber"] = "The Caller's Chamber",
	["The Canals"] = "The Canals",
	["The Cape of Stranglethorn"] = "The Cape of Stranglethorn",
	["The Carrion Fields"] = "The Carrion Fields",
	["The Catacombs"] = "The Catacombs",
	["The Cauldron"] = "The Cauldron",
	["The Cauldron of Flames"] = "The Cauldron of Flames",
	["The Cave"] = "The Cave",
	["The Celestial Planetarium"] = "The Celestial Planetarium",
	["The Celestial Vault"] = "The Celestial Vault",
	["The Celestial Watch"] = "The Celestial Watch",
	["The Cemetary"] = "The Cemetary",
	["The Cerebrillum"] = "The Cerebrillum",
	["The Charred Vale"] = "The Charred Vale",
	["The Chilled Quagmire"] = "The Chilled Quagmire",
	["The Chum Bucket"] = "The Chum Bucket",
	["The Circle of Cinders"] = "The Circle of Cinders",
	["The Circle of Life"] = "The Circle of Life",
	["The Circle of Suffering"] = "The Circle of Suffering",
	["The Clarion Bell"] = "The Clarion Bell",
	["The Clash of Thunder"] = "The Clash of Thunder",
	["The Clean Zone"] = "The Clean Zone",
	["The Cleft"] = "The Cleft",
	["The Clockwerk Run"] = "The Clockwerk Run",
	["The Clutch"] = "The Clutch",
	["The Clutches of Shek'zeer"] = "The Clutches of Shek'zeer",
	["The Coil"] = "The Coil",
	["The Colossal Forge"] = "The Colossal Forge",
	["The Comb"] = "The Comb",
	["The Commons"] = "The Commons",
	["The Conflagration"] = "The Conflagration",
	["The Conquest Pit"] = "The Conquest Pit",
	["The Conservatory"] = "The Conservatory",
	["The Conservatory of Life"] = "The Conservatory of Life",
	["The Construct Quarter"] = "The Construct Quarter",
	["The Cooper Residence"] = "The Cooper Residence",
	["The Corridors of Ingenuity"] = "The Corridors of Ingenuity",
	["The Court of Bones"] = "The Court of Bones",
	["The Court of Skulls"] = "The Court of Skulls",
	["The Coven"] = "The Coven",
	["The Coven "] = "The Coven ",
	["The Creeping Ruin"] = "The Creeping Ruin",
	["The Crimson Assembly Hall"] = "The Crimson Assembly Hall",
	["The Crimson Cathedral"] = "The Crimson Cathedral",
	["The Crimson Dawn"] = "The Crimson Dawn",
	["The Crimson Hall"] = "The Crimson Hall",
	["The Crimson Reach"] = "The Crimson Reach",
	["The Crimson Throne"] = "The Crimson Throne",
	["The Crimson Treader"] = "The Crimson Treader",
	["The Crimson Veil"] = "The Crimson Veil",
	["The Crossroads"] = "The Crossroads",
	["The Crucible"] = "The Crucible",
	["The Crucible of Flame"] = "The Crucible of Flame",
	["The Crumbling Waste"] = "The Crumbling Waste",
	["The Cryo-Core"] = "The Cryo-Core",
	["The Crystal Hall"] = "The Crystal Hall",
	["The Crystal Shore"] = "The Crystal Shore",
	["The Crystal Vale"] = "The Crystal Vale",
	["The Crystal Vice"] = "The Crystal Vice",
	["The Culling of Stratholme"] = "The Culling of Stratholme",
	["The Culling of Stratholme Entrance"] = "The Culling of Stratholme Entrance",
	["The Cursed Landing"] = "The Cursed Landing",
	["The Dagger Hills"] = "The Dagger Hills",
	["The Dai-Lo Farmstead"] = "The Dai-Lo Farmstead",
	["The Damsel's Luck"] = "The Damsel's Luck",
	["The Dancing Serpent"] = "The Dancing Serpent",
	["The Dark Approach"] = "The Dark Approach",
	["The Dark Defiance"] = "The Dark Defiance",
	["The Darkened Bank"] = "The Darkened Bank",
	["The Dark Hollow"] = "The Dark Hollow",
	["The Darkmoon Faire"] = "The Darkmoon Faire",
	["The Dark Portal"] = "The Dark Portal",
	["The Dark Rookery"] = "The Dark Rookery",
	["The Darkwood"] = "The Darkwood",
	["The Dawnchaser"] = "The Dawnchaser",
	["The Dawning Isles"] = "The Dawning Isles",
	["The Dawning Span"] = "The Dawning Span",
	["The Dawning Square"] = "The Dawning Square",
	["The Dawning Stair"] = "The Dawning Stair",
	["The Dawning Valley"] = "The Dawning Valley",
	["The Dead Acre"] = "The Dead Acre",
	["The Dead Field"] = "The Dead Field",
	["The Dead Fields"] = "The Dead Fields",
	["The Deadmines"] = "The Deadmines",
	["The Dead Mire"] = "The Dead Mire",
	["The Dead Scar"] = "The Dead Scar",
	["The Deathforge"] = "The Deathforge",
	["The Deathknell Graves"] = "The Deathknell Graves",
	["The Decrepit Fields"] = "The Decrepit Fields",
	["The Decrepit Flow"] = "The Decrepit Flow",
	["The Deeper"] = "The Deeper",
	["The Deep Reaches"] = "The Deep Reaches",
	["The Deepwild"] = "The Deepwild",
	["The Defiant"] = "The Defiant",
	["The Defiled Chapel"] = "The Defiled Chapel",
	["The Den"] = "The Den",
	["The Den of Flame"] = "The Den of Flame",
	["The Dens of Dying"] = "The Dens of Dying",
	["The Dens of the Dying"] = "The Dens of the Dying",
	["The Descent into Madness"] = "The Descent into Madness",
	["The Desecrated Altar"] = "The Desecrated Altar",
	["The Devil's Terrace"] = "The Devil's Terrace",
	["The Devouring Breach"] = "The Devouring Breach",
	["The Domicile"] = "The Domicile",
	["The Domicile "] = "The Domicile ",
	["The Dooker Dome"] = "The Dooker Dome",
	["The Dor'Danil Barrow Den"] = "The Dor'Danil Barrow Den",
	["The Dormitory"] = "The Dormitory",
	["The Drag"] = "The Drag",
	["The Dragonmurk"] = "The Dragonmurk",
	["The Dragon Wastes"] = "The Dragon Wastes",
	["The Drain"] = "The Drain",
	["The Dranosh'ar Blockade"] = "The Dranosh'ar Blockade",
	["The Drowned Reef"] = "The Drowned Reef",
	["The Drowned Sacellum"] = "The Drowned Sacellum",
	["The Drunken Hozen"] = "The Drunken Hozen",
	["The Dry Hills"] = "The Dry Hills",
	["The Dustbowl"] = "The Dustbowl",
	["The Dust Plains"] = "The Dust Plains",
	["The Eastern Earthshrine"] = "The Eastern Earthshrine",
	["The Elders' Path"] = "The Elders' Path",
	["The Emerald Summit"] = "The Emerald Summit",
	["The Emperor's Approach"] = "The Emperor's Approach",
	["The Emperor's Gate"] = "The Emperor's Gate",
	["The Emperor's Reach"] = "The Emperor's Reach",
	["The Emperor's Step"] = "The Emperor's Step",
	["The Escape From Durnholde"] = "The Escape From Durnholde",
	["The Escape from Durnholde Entrance"] = "The Escape from Durnholde Entrance",
	["The Eventide"] = "The Eventide",
	["The Exodar"] = "The Exodar",
	["The Eye"] = "The Eye",
	["The Eye of Eternity"] = "The Eye of Eternity",
	["The Eye of the Vortex"] = "The Eye of the Vortex",
	["The Fall of Shan Bu"] = "The Fall of Shan Bu",
	["The Farstrider Lodge"] = "The Farstrider Lodge",
	["The Feeding Pits"] = "The Feeding Pits",
	["The Fel Pits"] = "The Fel Pits",
	["The Fertile Copse"] = "The Fertile Copse",
	["The Fetid Pool"] = "The Fetid Pool",
	["The Filthy Animal"] = "The Filthy Animal",
	["The Firehawk"] = "The Firehawk",
	["The Five Sisters"] = "The Five Sisters",
	["The Flamewake"] = "The Flamewake",
	["The Fleshwerks"] = "The Fleshwerks",
	["The Flood Plains"] = "The Flood Plains",
	["The Fold"] = "The Fold",
	["The Foothill Caverns"] = "The Foothill Caverns",
	["The Foot of Lei Shen"] = "The Foot of Lei Shen",
	["The Foot Steppes"] = "The Foot Steppes",
	["The Forbidden Jungle"] = "The Forbidden Jungle",
	["The Forbidding Sea"] = "The Forbidding Sea",
	["The Forest of Shadows"] = "The Forest of Shadows",
	["The Forge of Souls"] = "The Forge of Souls",
	["The Forge of Souls Entrance"] = "The Forge of Souls Entrance",
	["The Forge of Supplication"] = "The Forge of Supplication",
	["The Forge of Wills"] = "The Forge of Wills",
	["The Forgotten Coast"] = "The Forgotten Coast",
	["The Forgotten Overlook"] = "The Forgotten Overlook",
	["The Forgotten Pool"] = "The Forgotten Pool",
	["The Forgotten Pools"] = "The Forgotten Pools",
	["The Forgotten Shore"] = "The Forgotten Shore",
	["The Forlorn Cavern"] = "The Forlorn Cavern",
	["The Forlorn Mine"] = "The Forlorn Mine",
	["The Forsaken Front"] = "The Forsaken Front",
	["The Foul Pool"] = "The Foul Pool",
	["The Frigid Tomb"] = "The Frigid Tomb",
	["The Frost Queen's Lair"] = "The Frost Queen's Lair",
	["The Frostwing Halls"] = "The Frostwing Halls",
	["The Frozen Glade"] = "The Frozen Glade",
	["The Frozen Halls"] = "The Frozen Halls",
	["The Frozen Mine"] = "The Frozen Mine",
	["The Frozen Sea"] = "The Frozen Sea",
	["The Frozen Throne"] = "The Frozen Throne",
	["The Fungal Vale"] = "The Fungal Vale",
	["The Furnace"] = "The Furnace",
	["The Gaping Chasm"] = "The Gaping Chasm",
	["The Gatehouse"] = "The Gatehouse",
	["The Gatehouse "] = "The Gatehouse ",
	["The Gate of Unending Cycles"] = "The Gate of Unending Cycles",
	["The Gauntlet"] = "The Gauntlet",
	["The Geyser Fields"] = "The Geyser Fields",
	["The Ghastly Confines"] = "The Ghastly Confines",
	["The Gilded Foyer"] = "The Gilded Foyer",
	["The Gilded Gate"] = "The Gilded Gate",
	["The Gilding Stream"] = "The Gilding Stream",
	["The Glimmering Pillar"] = "The Glimmering Pillar",
	["The Golden Gateway"] = "The Golden Gateway",
	["The Golden Hall"] = "The Golden Hall",
	["The Golden Lantern"] = "The Golden Lantern",
	["The Golden Pagoda"] = "The Golden Pagoda",
	["The Golden Plains"] = "The Golden Plains",
	["The Golden Rose"] = "The Golden Rose",
	["The Golden Stair"] = "The Golden Stair",
	["The Golden Terrace"] = "The Golden Terrace",
	["The Gong of Hope"] = "The Gong of Hope",
	["The Grand Ballroom"] = "The Grand Ballroom",
	["The Grand Vestibule"] = "The Grand Vestibule",
	["The Great Arena"] = "The Great Arena",
	["The Great Divide"] = "The Great Divide",
	["The Great Fissure"] = "The Great Fissure",
	["The Great Forge"] = "The Great Forge",
	["The Great Gate"] = "The Great Gate",
	["The Great Lift"] = "The Great Lift",
	["The Great Ossuary"] = "The Great Ossuary",
	["The Great Sea"] = "The Great Sea",
	["The Great Tree"] = "The Great Tree",
	["The Great Wheel"] = "The Great Wheel",
	["The Green Belt"] = "The Green Belt",
	["The Greymane Wall"] = "The Greymane Wall",
	["The Grim Guzzler"] = "The Grim Guzzler",
	["The Grinding Quarry"] = "The Grinding Quarry",
	["The Grizzled Den"] = "The Grizzled Den",
	["The Grummle Bazaar"] = "The Grummle Bazaar",
	["The Guardhouse"] = "The Guardhouse",
	["The Guest Chambers"] = "The Guest Chambers",
	["The Gullet"] = "The Gullet",
	["The Halfhill Market"] = "The Halfhill Market",
	["The Half Shell"] = "The Half Shell",
	["The Hall of Blood"] = "The Hall of Blood",
	["The Hall of Gears"] = "The Hall of Gears",
	["The Hall of Lights"] = "The Hall of Lights",
	["The Hall of Respite"] = "The Hall of Respite",
	["The Hall of Statues"] = "The Hall of Statues",
	["The Hall of the Serpent"] = "The Hall of the Serpent",
	["The Hall of Tiles"] = "The Hall of Tiles",
	["The Halls of Reanimation"] = "The Halls of Reanimation",
	["The Halls of Winter"] = "The Halls of Winter",
	["The Hand of Gul'dan"] = "The Hand of Gul'dan",
	["The Harborage"] = "The Harborage",
	["The Hatchery"] = "The Hatchery",
	["The Headland"] = "The Headland",
	["The Headlands"] = "The Headlands",
	["The Heap"] = "The Heap",
	["The Heartland"] = "The Heartland",
	["The Heart of Acherus"] = "The Heart of Acherus",
	["The Heart of Jade"] = "The Heart of Jade",
	["The Hidden Clutch"] = "The Hidden Clutch",
	["The Hidden Grove"] = "The Hidden Grove",
	["The Hidden Hollow"] = "The Hidden Hollow",
	["The Hidden Passage"] = "The Hidden Passage",
	["The Hidden Reach"] = "The Hidden Reach",
	["The Hidden Reef"] = "The Hidden Reef",
	["The High Path"] = "The High Path",
	["The High Road"] = "The High Road",
	["The High Seat"] = "The High Seat",
	["The Hinterlands"] = "The Hinterlands",
	["The Hoard"] = "The Hoard",
	["The Hole"] = "The Hole",
	["The Horde Valiants' Ring"] = "The Horde Valiants' Ring",
	["The Horrid March"] = "The Horrid March",
	["The Horsemen's Assembly"] = "The Horsemen's Assembly",
	["The Howling Hollow"] = "The Howling Hollow",
	["The Howling Oak"] = "The Howling Oak",
	["The Howling Vale"] = "The Howling Vale",
	["The Hunter's Reach"] = "The Hunter's Reach",
	["The Hushed Bank"] = "The Hushed Bank",
	["The Icy Depths"] = "The Icy Depths",
	["The Immortal Coil"] = "The Immortal Coil",
	["The Imperial Exchange"] = "The Imperial Exchange",
	["The Imperial Granary"] = "The Imperial Granary",
	["The Imperial Mercantile"] = "The Imperial Mercantile",
	["The Imperial Seat"] = "The Imperial Seat",
	["The Incursion"] = "The Incursion",
	["The Infectis Scar"] = "The Infectis Scar",
	["The Inferno"] = "The Inferno",
	["The Inner Spire"] = "The Inner Spire",
	["The Intrepid"] = "The Intrepid",
	["The Inventor's Library"] = "The Inventor's Library",
	["The Iron Crucible"] = "The Iron Crucible",
	["The Iron Hall"] = "The Iron Hall",
	["The Iron Reaper"] = "The Iron Reaper",
	["The Isle of Spears"] = "The Isle of Spears",
	["The Ivar Patch"] = "The Ivar Patch",
	["The Jade Forest"] = "The Jade Forest",
	["The Jade Vaults"] = "The Jade Vaults",
	["The Jansen Stead"] = "The Jansen Stead",
	["The Keggary"] = "The Keggary",
	["The Kennel"] = "The Kennel",
	["The Krasari Ruins"] = "The Krasari Ruins",
	["The Krazzworks"] = "The Krazzworks",
	["The Laboratory"] = "The Laboratory",
	["The Lady Mehley"] = "The Lady Mehley",
	["The Lagoon"] = "The Lagoon",
	["The Laughing Stand"] = "The Laughing Stand",
	["The Lazy Turnip"] = "The Lazy Turnip",
	["The Legerdemain Lounge"] = "The Legerdemain Lounge",
	["The Legion Front"] = "The Legion Front",
	["Thelgen Rock"] = "Thelgen Rock",
	["The Librarium"] = "The Librarium",
	["The Library"] = "The Library",
	["The Lifebinder's Cell"] = "The Lifebinder's Cell",
	["The Lifeblood Pillar"] = "The Lifeblood Pillar",
	["The Lightless Reaches"] = "The Lightless Reaches",
	["The Lion's Redoubt"] = "The Lion's Redoubt",
	["The Living Grove"] = "The Living Grove",
	["The Living Wood"] = "The Living Wood",
	["The LMS Mark II"] = "The LMS Mark II",
	["The Loch"] = "The Loch",
	["The Long Wash"] = "The Long Wash",
	["The Lost Fleet"] = "The Lost Fleet",
	["The Lost Fold"] = "The Lost Fold",
	["The Lost Isles"] = "The Lost Isles",
	["The Lost Lands"] = "The Lost Lands",
	["The Lost Passage"] = "The Lost Passage",
	["The Low Path"] = "The Low Path",
	Thelsamar = "Thelsamar",
	["The Lucky Traveller"] = "The Lucky Traveller",
	["The Lyceum"] = "The Lyceum",
	["The Maclure Vineyards"] = "The Maclure Vineyards",
	["The Maelstrom"] = "The Maelstrom",
	["The Maker's Overlook"] = "The Maker's Overlook",
	["The Makers' Overlook"] = "The Makers' Overlook",
	["The Makers' Perch"] = "The Makers' Perch",
	["The Maker's Rise"] = "The Maker's Rise",
	["The Maker's Terrace"] = "The Maker's Terrace",
	["The Manufactory"] = "The Manufactory",
	["The Marris Stead"] = "The Marris Stead",
	["The Marshlands"] = "The Marshlands",
	["The Masonary"] = "The Masonary",
	["The Master's Cellar"] = "The Master's Cellar",
	["The Master's Glaive"] = "The Master's Glaive",
	["The Maul"] = "The Maul",
	["The Maw of Madness"] = "The Maw of Madness",
	["The Mechanar"] = "The Mechanar",
	["The Menagerie"] = "The Menagerie",
	["The Menders' Stead"] = "The Menders' Stead",
	["The Merchant Coast"] = "The Merchant Coast",
	["The Militant Mystic"] = "The Militant Mystic",
	["The Military Quarter"] = "The Military Quarter",
	["The Military Ward"] = "The Military Ward",
	["The Mind's Eye"] = "The Mind's Eye",
	["The Mirror of Dawn"] = "The Mirror of Dawn",
	["The Mirror of Twilight"] = "The Mirror of Twilight",
	["The Molsen Farm"] = "The Molsen Farm",
	["The Molten Bridge"] = "The Molten Bridge",
	["The Molten Core"] = "The Molten Core",
	["The Molten Fields"] = "The Molten Fields",
	["The Molten Flow"] = "The Molten Flow",
	["The Molten Span"] = "The Molten Span",
	["The Mor'shan Rampart"] = "The Mor'shan Rampart",
	["The Mor'Shan Ramparts"] = "The Mor'Shan Ramparts",
	["The Mosslight Pillar"] = "The Mosslight Pillar",
	["The Mountain Den"] = "The Mountain Den",
	["The Murder Pens"] = "The Murder Pens",
	["The Mystic Ward"] = "The Mystic Ward",
	["The Necrotic Vault"] = "The Necrotic Vault",
	["The Nexus"] = "The Nexus",
	["The Nexus Entrance"] = "The Nexus Entrance",
	["The Nightmare Scar"] = "The Nightmare Scar",
	["The North Coast"] = "The North Coast",
	["The North Sea"] = "The North Sea",
	["The Nosebleeds"] = "The Nosebleeds",
	["The Noxious Glade"] = "The Noxious Glade",
	["The Noxious Hollow"] = "The Noxious Hollow",
	["The Noxious Lair"] = "The Noxious Lair",
	["The Noxious Pass"] = "The Noxious Pass",
	["The Oblivion"] = "The Oblivion",
	["The Observation Ring"] = "The Observation Ring",
	["The Obsidian Sanctum"] = "The Obsidian Sanctum",
	["The Oculus"] = "The Oculus",
	["The Oculus Entrance"] = "The Oculus Entrance",
	["The Old Barracks"] = "The Old Barracks",
	["The Old Dormitory"] = "The Old Dormitory",
	["The Old Port Authority"] = "The Old Port Authority",
	["The Opera Hall"] = "The Opera Hall",
	["The Oracle Glade"] = "The Oracle Glade",
	["The Outer Ring"] = "The Outer Ring",
	["The Overgrowth"] = "The Overgrowth",
	["The Overlook"] = "The Overlook",
	["The Overlook Cliffs"] = "The Overlook Cliffs",
	["The Overlook Inn"] = "The Overlook Inn",
	["The Ox Gate"] = "The Ox Gate",
	["The Pale Roost"] = "The Pale Roost",
	["The Park"] = "The Park",
	["The Path of Anguish"] = "The Path of Anguish",
	["The Path of Conquest"] = "The Path of Conquest",
	["The Path of Corruption"] = "The Path of Corruption",
	["The Path of Glory"] = "The Path of Glory",
	["The Path of Iron"] = "The Path of Iron",
	["The Path of the Lifewarden"] = "The Path of the Lifewarden",
	["The Phoenix Hall"] = "The Phoenix Hall",
	["The Pillar of Ash"] = "The Pillar of Ash",
	["The Pipe"] = "The Pipe",
	["The Pit of Criminals"] = "The Pit of Criminals",
	["The Pit of Fiends"] = "The Pit of Fiends",
	["The Pit of Narjun"] = "The Pit of Narjun",
	["The Pit of Refuse"] = "The Pit of Refuse",
	["The Pit of Sacrifice"] = "The Pit of Sacrifice",
	["The Pit of Scales"] = "The Pit of Scales",
	["The Pit of the Fang"] = "The Pit of the Fang",
	["The Plague Quarter"] = "The Plague Quarter",
	["The Plagueworks"] = "The Plagueworks",
	["The Pool of Ask'ar"] = "The Pool of Ask'ar",
	["The Pools of Vision"] = "The Pools of Vision",
	["The Prison of Yogg-Saron"] = "The Prison of Yogg-Saron",
	["The Proving Grounds"] = "The Proving Grounds",
	["The Purple Parlor"] = "The Purple Parlor",
	["The Quagmire"] = "The Quagmire",
	["The Quaking Fields"] = "The Quaking Fields",
	["The Queen's Reprisal"] = "The Queen's Reprisal",
	["The Raging Chasm"] = "The Raging Chasm",
	Theramore = "Theramore",
	["Theramore Isle"] = "Theramore Isle",
	["Theramore's Fall"] = "Theramore's Fall",
	["Theramore's Fall (A)"] = "Theramore's Fall (A)",
	["Theramore's Fall (H)"] = "Theramore's Fall (H)",
	["Theramore's Fall Phase"] = "Theramore's Fall Phase",
	["The Rangers' Lodge"] = "The Rangers' Lodge",
	["Therazane's Throne"] = "Therazane's Throne",
	["The Red Reaches"] = "The Red Reaches",
	["The Refectory"] = "The Refectory",
	["The Regrowth"] = "The Regrowth",
	["The Reliquary"] = "The Reliquary",
	["The Repository"] = "The Repository",
	["The Reservoir"] = "The Reservoir",
	["The Restless Front"] = "The Restless Front",
	["The Ridge of Ancient Flame"] = "The Ridge of Ancient Flame",
	["The Rift"] = "The Rift",
	["The Ring of Balance"] = "The Ring of Balance",
	["The Ring of Blood"] = "The Ring of Blood",
	["The Ring of Champions"] = "The Ring of Champions",
	["The Ring of Inner Focus"] = "The Ring of Inner Focus",
	["The Ring of Trials"] = "The Ring of Trials",
	["The Ring of Valor"] = "The Ring of Valor",
	["The Riptide"] = "The Riptide",
	["The Riverblade Den"] = "The Riverblade Den",
	["Thermal Vents"] = "Thermal Vents",
	["The Roiling Gardens"] = "The Roiling Gardens",
	["The Rolling Gardens"] = "The Rolling Gardens",
	["The Rolling Plains"] = "The Rolling Plains",
	["The Rookery"] = "The Rookery",
	["The Rotting Orchard"] = "The Rotting Orchard",
	["The Rows"] = "The Rows",
	["The Royal Exchange"] = "The Royal Exchange",
	["The Ruby Sanctum"] = "The Ruby Sanctum",
	["The Ruined Reaches"] = "The Ruined Reaches",
	["The Ruins of Kel'Theril"] = "The Ruins of Kel'Theril",
	["The Ruins of Ordil'Aran"] = "The Ruins of Ordil'Aran",
	["The Ruins of Stardust"] = "The Ruins of Stardust",
	["The Rumble Cage"] = "The Rumble Cage",
	["The Rustmaul Dig Site"] = "The Rustmaul Dig Site",
	["The Sacred Grove"] = "The Sacred Grove",
	["The Salty Sailor Tavern"] = "The Salty Sailor Tavern",
	["The Sanctum"] = "The Sanctum",
	["The Sanctum of Blood"] = "The Sanctum of Blood",
	["The Savage Coast"] = "The Savage Coast",
	["The Savage Glen"] = "The Savage Glen",
	["The Savage Thicket"] = "The Savage Thicket",
	["The Scalding Chasm"] = "The Scalding Chasm",
	["The Scalding Pools"] = "The Scalding Pools",
	["The Scarab Dais"] = "The Scarab Dais",
	["The Scarab Wall"] = "The Scarab Wall",
	["The Scarlet Basilica"] = "The Scarlet Basilica",
	["The Scarlet Bastion"] = "The Scarlet Bastion",
	["The Scorched Grove"] = "The Scorched Grove",
	["The Scorched Plain"] = "The Scorched Plain",
	["The Scrap Field"] = "The Scrap Field",
	["The Scrapyard"] = "The Scrapyard",
	["The Screaming Hall"] = "The Screaming Hall",
	["The Screaming Reaches"] = "The Screaming Reaches",
	["The Screeching Canyon"] = "The Screeching Canyon",
	["The Scribe of Stormwind"] = "The Scribe of Stormwind",
	["The Scribes' Sacellum"] = "The Scribes' Sacellum",
	["The Scrollkeeper's Sanctum"] = "The Scrollkeeper's Sanctum",
	["The Scullery"] = "The Scullery",
	["The Scullery "] = "The Scullery ",
	["The Seabolt"] = "The Seabolt",
	["The Seabreach Flow"] = "The Seabreach Flow",
	["The Sealed Hall"] = "The Sealed Hall",
	["The Sea of Cinders"] = "The Sea of Cinders",
	["The Sea Reaver's Run"] = "The Sea Reaver's Run",
	["The Searing Gateway"] = "The Searing Gateway",
	["The Sea Wolf"] = "The Sea Wolf",
	["The Secret Aerie"] = "The Secret Aerie",
	["The Secret Lab"] = "The Secret Lab",
	["The Secrets of Ragefire"] = "The Secrets of Ragefire",
	["The Seer's Library"] = "The Seer's Library",
	["The Sepulcher"] = "The Sepulcher",
	["The Severed Span"] = "The Severed Span",
	["The Sewer"] = "The Sewer",
	["The Shadow Stair"] = "The Shadow Stair",
	["The Shadow Throne"] = "The Shadow Throne",
	["The Shadow Vault"] = "The Shadow Vault",
	["The Shady Nook"] = "The Shady Nook",
	["The Shaper's Terrace"] = "The Shaper's Terrace",
	["The Shattered Halls"] = "The Shattered Halls",
	["The Shattered Strand"] = "The Shattered Strand",
	["The Shattered Walkway"] = "The Shattered Walkway",
	["The Shepherd's Gate"] = "The Shepherd's Gate",
	["The Shifting Mire"] = "The Shifting Mire",
	["The Shimmering Deep"] = "The Shimmering Deep",
	["The Shimmering Flats"] = "The Shimmering Flats",
	["The Shining Strand"] = "The Shining Strand",
	["The Shrine of Aessina"] = "The Shrine of Aessina",
	["The Shrine of Eldretharr"] = "The Shrine of Eldretharr",
	["The Silent Sanctuary"] = "The Silent Sanctuary",
	["The Silkwood"] = "The Silkwood",
	["The Silver Blade"] = "The Silver Blade",
	["The Silver Enclave"] = "The Silver Enclave",
	["The Singing Grove"] = "The Singing Grove",
	["The Singing Pools"] = "The Singing Pools",
	["The Sin'loren"] = "The Sin'loren",
	["The Skeletal Reef"] = "The Skeletal Reef",
	["The Skittering Dark"] = "The Skittering Dark",
	["The Skull Warren"] = "The Skull Warren",
	["The Skunkworks"] = "The Skunkworks",
	["The Skybreaker"] = "The Skybreaker",
	["The Skyfire"] = "The Skyfire",
	["The Skyreach Pillar"] = "The Skyreach Pillar",
	["The Slag Pit"] = "The Slag Pit",
	["The Slaughtered Lamb"] = "The Slaughtered Lamb",
	["The Slaughter House"] = "The Slaughter House",
	["The Slave Pens"] = "The Slave Pens",
	["The Slave Pits"] = "The Slave Pits",
	["The Slick"] = "The Slick",
	["The Slithering Scar"] = "The Slithering Scar",
	["The Slough of Dispair"] = "The Slough of Dispair",
	["The Sludge Fen"] = "The Sludge Fen",
	["The Sludge Fields"] = "The Sludge Fields",
	["The Sludgewerks"] = "The Sludgewerks",
	["The Solarium"] = "The Solarium",
	["The Solar Vigil"] = "The Solar Vigil",
	["The Southern Isles"] = "The Southern Isles",
	["The Southern Wall"] = "The Southern Wall",
	["The Sparkling Crawl"] = "The Sparkling Crawl",
	["The Spark of Imagination"] = "The Spark of Imagination",
	["The Spawning Glen"] = "The Spawning Glen",
	["The Spire"] = "The Spire",
	["The Splintered Path"] = "The Splintered Path",
	["The Spring Road"] = "The Spring Road",
	["The Stadium"] = "The Stadium",
	["The Stagnant Oasis"] = "The Stagnant Oasis",
	["The Staidridge"] = "The Staidridge",
	["The Stair of Destiny"] = "The Stair of Destiny",
	["The Stair of Doom"] = "The Stair of Doom",
	["The Starchaser"] = "The Starchaser",
	["The Star's Bazaar"] = "The Star's Bazaar",
	["The Steam Pools"] = "The Steam Pools",
	["The Steamvault"] = "The Steamvault",
	["The Steppe of Life"] = "The Steppe of Life",
	["The Steps of Fate"] = "The Steps of Fate",
	["The Stinging Trail"] = "The Stinging Trail",
	["The Stockade"] = "The Stockade",
	["The Stockpile"] = "The Stockpile",
	["The Stonecore"] = "The Stonecore",
	["The Stonecore Entrance"] = "The Stonecore Entrance",
	["The Stonefield Farm"] = "The Stonefield Farm",
	["The Stone Vault"] = "The Stone Vault",
	["The Storehouse"] = "The Storehouse",
	["The Stormbreaker"] = "The Stormbreaker",
	["The Stormbridge"] = "The Stormbridge",
	["The Storm Foundry"] = "The Storm Foundry",
	["The Storm Peaks"] = "The Storm Peaks",
	["The Stormspire"] = "The Stormspire",
	["The Stormwright's Shelf"] = "The Stormwright's Shelf",
	["The Summer Fields"] = "The Summer Fields",
	["The Summer Terrace"] = "The Summer Terrace",
	["The Sundered Shard"] = "The Sundered Shard",
	["The Sundering"] = "The Sundering",
	["The Sun Forge"] = "The Sun Forge",
	["The Sunken Ring"] = "The Sunken Ring",
	["The Sunset Brewgarden"] = "The Sunset Brewgarden",
	["The Sunspire"] = "The Sunspire",
	["The Suntouched Pillar"] = "The Suntouched Pillar",
	["The Sunwell"] = "The Sunwell",
	["The Swarming Pillar"] = "The Swarming Pillar",
	["The Swollen Vault"] = "The Swollen Vault",
	["The Tainted Forest"] = "The Tainted Forest",
	["The Tainted Scar"] = "The Tainted Scar",
	["The Talondeep Path"] = "The Talondeep Path",
	["The Talon Den"] = "The Talon Den",
	["The Tasting Room"] = "The Tasting Room",
	["The Tempest Rift"] = "The Tempest Rift",
	["The Temple Gardens"] = "The Temple Gardens",
	["The Temple of Atal'Hakkar"] = "The Temple of Atal'Hakkar",
	["The Temple of the Jade Serpent"] = "The Temple of the Jade Serpent",
	["The Terrestrial Watchtower"] = "The Terrestrial Watchtower",
	["The Thornsnarl"] = "The Thornsnarl",
	["The Threads of Fate"] = "The Threads of Fate",
	["The Threshold"] = "The Threshold",
	["The Throne of Flame"] = "The Throne of Flame",
	["The Thunder Forge"] = "The Thunder Forge",
	["The Thunder Forges"] = "The Thunder Forges",
	["The Thundering Run"] = "The Thundering Run",
	["The Thundering Spire"] = "The Thundering Spire",
	["The Thunderspire"] = "The Thunderspire",
	["The Thunderwood"] = "The Thunderwood",
	["The Tidebreaker"] = "The Tidebreaker",
	["The Tidus Stair"] = "The Tidus Stair",
	["The Tiger's Peak"] = "The Tiger's Peak",
	["The Torjari Pit"] = "The Torjari Pit",
	["The Tower of Arathor"] = "The Tower of Arathor",
	["The Toxic Airfield"] = "The Toxic Airfield",
	["The Trail of Devastation"] = "The Trail of Devastation",
	["The Tranquil Grove"] = "The Tranquil Grove",
	["The Transitus Stair"] = "The Transitus Stair",
	["The Trapper's Enclave"] = "The Trapper's Enclave",
	["The Tribunal of Ages"] = "The Tribunal of Ages",
	["The Tundrid Hills"] = "The Tundrid Hills",
	["The Twilight Breach"] = "The Twilight Breach",
	["The Twilight Caverns"] = "The Twilight Caverns",
	["The Twilight Citadel"] = "The Twilight Citadel",
	["The Twilight Enclave"] = "The Twilight Enclave",
	["The Twilight Gate"] = "The Twilight Gate",
	["The Twilight Gauntlet"] = "The Twilight Gauntlet",
	["The Twilight Ridge"] = "The Twilight Ridge",
	["The Twilight Rivulet"] = "The Twilight Rivulet",
	["The Twilight Withering"] = "The Twilight Withering",
	["The Twin Colossals"] = "The Twin Colossals",
	["The Twisted Glade"] = "The Twisted Glade",
	["The Twisted Warren"] = "The Twisted Warren",
	["The Two Fisted Brew"] = "The Two Fisted Brew",
	["The Unbound Thicket"] = "The Unbound Thicket",
	["The Underbelly"] = "The Underbelly",
	["The Underbog"] = "The Underbog",
	["The Underbough"] = "The Underbough",
	["The Undercroft"] = "The Undercroft",
	["The Underhalls"] = "The Underhalls",
	["The Undershell"] = "The Undershell",
	["The Uplands"] = "The Uplands",
	["The Upside-down Sinners"] = "The Upside-down Sinners",
	["The Valley of Fallen Heroes"] = "The Valley of Fallen Heroes",
	["The Valley of Lost Hope"] = "The Valley of Lost Hope",
	["The Vault of Lights"] = "The Vault of Lights",
	["The Vector Coil"] = "The Vector Coil",
	["The Veiled Cleft"] = "The Veiled Cleft",
	["The Veiled Sea"] = "The Veiled Sea",
	["The Veiled Stair"] = "The Veiled Stair",
	["The Venture Co. Mine"] = "The Venture Co. Mine",
	["The Verdant Fields"] = "The Verdant Fields",
	["The Verdant Thicket"] = "The Verdant Thicket",
	["The Verne"] = "The Verne",
	["The Verne - Bridge"] = "The Verne - Bridge",
	["The Verne - Entryway"] = "The Verne - Entryway",
	["The Vibrant Glade"] = "The Vibrant Glade",
	["The Vice"] = "The Vice",
	["The Vicious Vale"] = "The Vicious Vale",
	["The Viewing Room"] = "The Viewing Room",
	["The Vile Reef"] = "The Vile Reef",
	["The Violet Citadel"] = "The Violet Citadel",
	["The Violet Citadel Spire"] = "The Violet Citadel Spire",
	["The Violet Gate"] = "The Violet Gate",
	["The Violet Hold"] = "The Violet Hold",
	["The Violet Spire"] = "The Violet Spire",
	["The Violet Tower"] = "The Violet Tower",
	["The Vortex Fields"] = "The Vortex Fields",
	["The Vortex Pinnacle"] = "The Vortex Pinnacle",
	["The Vortex Pinnacle Entrance"] = "The Vortex Pinnacle Entrance",
	["The Wailing Caverns"] = "The Wailing Caverns",
	["The Wailing Ziggurat"] = "The Wailing Ziggurat",
	["The Waking Halls"] = "The Waking Halls",
	["The Wandering Isle"] = "The Wandering Isle",
	["The Warlord's Garrison"] = "The Warlord's Garrison",
	["The Warlord's Terrace"] = "The Warlord's Terrace",
	["The Warp Fields"] = "The Warp Fields",
	["The Warp Piston"] = "The Warp Piston",
	["The Wavecrest"] = "The Wavecrest",
	["The Weathered Nook"] = "The Weathered Nook",
	["The Weeping Cave"] = "The Weeping Cave",
	["The Western Earthshrine"] = "The Western Earthshrine",
	["The Westrift"] = "The Westrift",
	["The Whelping Downs"] = "The Whelping Downs",
	["The Whipple Estate"] = "The Whipple Estate",
	["The Wicked Coil"] = "The Wicked Coil",
	["The Wicked Grotto"] = "The Wicked Grotto",
	["The Wicked Tunnels"] = "The Wicked Tunnels",
	["The Widening Deep"] = "The Widening Deep",
	["The Widow's Clutch"] = "The Widow's Clutch",
	["The Widow's Wail"] = "The Widow's Wail",
	["The Wild Plains"] = "The Wild Plains",
	["The Wild Shore"] = "The Wild Shore",
	["The Winding Halls"] = "The Winding Halls",
	["The Windrunner"] = "The Windrunner",
	["The Windspire"] = "The Windspire",
	["The Wollerton Stead"] = "The Wollerton Stead",
	["The Wonderworks"] = "The Wonderworks",
	["The Wood of Staves"] = "The Wood of Staves",
	["The World Tree"] = "The World Tree",
	["The Writhing Deep"] = "The Writhing Deep",
	["The Writhing Haunt"] = "The Writhing Haunt",
	["The Yaungol Advance"] = "The Yaungol Advance",
	["The Yorgen Farmstead"] = "The Yorgen Farmstead",
	["The Zandalari Vanguard"] = "The Zandalari Vanguard",
	["The Zoram Strand"] = "The Zoram Strand",
	["Thieves Camp"] = "Thieves Camp",
	["Thirsty Alley"] = "Thirsty Alley",
	["Thistlefur Hold"] = "Thistlefur Hold",
	["Thistlefur Village"] = "Thistlefur Village",
	["Thistleshrub Valley"] = "Thistleshrub Valley",
	["Thondroril River"] = "Thondroril River",
	["Thoradin's Wall"] = "Thoradin's Wall",
	["Thorium Advance"] = "Thorium Advance",
	["Thorium Point"] = "Thorium Point",
	["Thor Modan"] = "Thor Modan",
	["Thornfang Hill"] = "Thornfang Hill",
	["Thorn Hill"] = "Thorn Hill",
	["Thornmantle's Hideout"] = "Thornmantle's Hideout",
	["Thorson's Post"] = "Thorson's Post",
	["Thorvald's Camp"] = "Thorvald's Camp",
	["Thousand Needles"] = "Thousand Needles",
	Thrallmar = "Thrallmar",
	["Thrallmar Mine"] = "Thrallmar Mine",
	["Three Corners"] = "Three Corners",
	["Throne of Ancient Conquerors"] = "Throne of Ancient Conquerors",
	["Throne of Kil'jaeden"] = "Throne of Kil'jaeden",
	["Throne of Neptulon"] = "Throne of Neptulon",
	["Throne of the Apocalypse"] = "Throne of the Apocalypse",
	["Throne of the Damned"] = "Throne of the Damned",
	["Throne of the Elements"] = "Throne of the Elements",
	["Throne of the Four Winds"] = "Throne of the Four Winds",
	["Throne of the Tides"] = "Throne of the Tides",
	["Throne of the Tides Entrance"] = "Throne of the Tides Entrance",
	["Throne of Thunder"] = "Throne of Thunder",
	["Throne of Tides"] = "Throne of Tides",
	["Thrym's End"] = "Thrym's End",
	["Thunder Axe Fortress"] = "Thunder Axe Fortress",
	Thunderbluff = "Thunderbluff",
	["Thunder Bluff"] = "Thunder Bluff",
	["Thunderbrew Distillery"] = "Thunderbrew Distillery",
	["Thunder Cleft"] = "Thunder Cleft",
	Thunderfall = "Thunderfall",
	["Thunder Falls"] = "Thunder Falls",
	["Thunderfoot Farm"] = "Thunderfoot Farm",
	["Thunderfoot Fields"] = "Thunderfoot Fields",
	["Thunderfoot Inn"] = "Thunderfoot Inn",
	["Thunderfoot Ranch"] = "Thunderfoot Ranch",
	["Thunder Hold"] = "Thunder Hold",
	["Thunderhorn Water Well"] = "Thunderhorn Water Well",
	["Thundering Overlook"] = "Thundering Overlook",
	["Thunder Island Alliance Hub"] = "Thunder Island Alliance Hub",
	["Thunder King Horde Hub"] = "Thunder King Horde Hub",
	["Thunder King's Citadel"] = "Thunder King's Citadel",
	["Thunderlord Stronghold"] = "Thunderlord Stronghold",
	Thundermar = "Thundermar",
	["Thundermar Ruins"] = "Thundermar Ruins",
	["Thunderpaw Overlook"] = "Thunderpaw Overlook",
	["Thunderpaw Refuge"] = "Thunderpaw Refuge",
	["Thunder Peak"] = "Thunder Peak",
	["Thunder Ridge"] = "Thunder Ridge",
	["Thunder's Call"] = "Thunder's Call",
	["Thunderstrike Mountain"] = "Thunderstrike Mountain",
	["Thunk's Abode"] = "Thunk's Abode",
	["Thuron's Livery"] = "Thuron's Livery",
	["Tian Monastery"] = "Tian Monastery",
	["Tidefury Cove"] = "Tidefury Cove",
	["Tides' Hollow"] = "Tides' Hollow",
	["Tideview Thicket"] = "Tideview Thicket",
	["Tigers' Wood"] = "Tigers' Wood",
	["Timbermaw Hold"] = "Timbermaw Hold",
	["Timbermaw Post"] = "Timbermaw Post",
	["Tinkers' Court"] = "Tinkers' Court",
	["Tinker Town"] = "Tinker Town",
	["Tiragarde Keep"] = "Tiragarde Keep",
	["Tirisfal Glades"] = "Tirisfal Glades",
	["Tirth's Haunt"] = "Tirth's Haunt",
	["Tkashi Ruins"] = "Tkashi Ruins",
	["Tol Barad"] = "Tol Barad",
	["Tol Barad Peninsula"] = "Tol Barad Peninsula",
	["Tol'Vir Arena"] = "Tol'Vir Arena",
	["Tol'viron Arena"] = "Tol'viron Arena",
	["Tol'Viron Arena"] = "Tol'Viron Arena",
	["Tomb of Conquerors"] = "Tomb of Conquerors",
	["Tomb of Lights"] = "Tomb of Lights",
	["Tomb of Secrets"] = "Tomb of Secrets",
	["Tomb of Shadows"] = "Tomb of Shadows",
	["Tomb of the Ancients"] = "Tomb of the Ancients",
	["Tomb of the Earthrager"] = "Tomb of the Earthrager",
	["Tomb of the Lost Kings"] = "Tomb of the Lost Kings",
	["Tomb of the Sun King"] = "Tomb of the Sun King",
	["Tomb of the Watchers"] = "Tomb of the Watchers",
	["Tombs of the Precursors"] = "Tombs of the Precursors",
	["Tome of the Unrepentant"] = "Tome of the Unrepentant",
	["Tome of the Unrepentant "] = "Tome of the Unrepentant ",
	["Tor'kren Farm"] = "Tor'kren Farm",
	["Torp's Farm"] = "Torp's Farm",
	["Torseg's Rest"] = "Torseg's Rest",
	["Tor'Watha"] = "Tor'Watha",
	["Toryl Estate"] = "Toryl Estate",
	["Toshley's Station"] = "Toshley's Station",
	["To the Skies!"] = "To the Skies!",
	["To The Skies!"] = "To The Skies!",
	["Tower of Althalaxx"] = "Tower of Althalaxx",
	["Tower of Azora"] = "Tower of Azora",
	["Tower of Eldara"] = "Tower of Eldara",
	["Tower of Estulan"] = "Tower of Estulan",
	["Tower of Ilgalar"] = "Tower of Ilgalar",
	["Tower of the Damned"] = "Tower of the Damned",
	["Tower Point"] = "Tower Point",
	["Tower Watch"] = "Tower Watch",
	["Town-In-A-Box"] = "Town-In-A-Box",
	["Townlong Steppes"] = "Townlong Steppes",
	["Town Square"] = "Town Square",
	["Trade District"] = "Trade District",
	["Trade Quarter"] = "Trade Quarter",
	["Trader's Tier"] = "Trader's Tier",
	["Tradesmen's Terrace"] = "Tradesmen's Terrace",
	["Train Depot"] = "Train Depot",
	["Training Grounds"] = "Training Grounds",
	["Training Quarters"] = "Training Quarters",
	["Traitor's Cove"] = "Traitor's Cove",
	["Tranquil Coast"] = "Tranquil Coast",
	["Tranquil Gardens Cemetery"] = "Tranquil Gardens Cemetery",
	["Tranquil Grotto"] = "Tranquil Grotto",
	Tranquillien = "Tranquillien",
	["Tranquil Shore"] = "Tranquil Shore",
	["Tranquil Wash"] = "Tranquil Wash",
	Transborea = "Transborea",
	["Transitus Shield"] = "Transitus Shield",
	["Transport: Alliance Gunship"] = "Transport: Alliance Gunship",
	["Transport: Alliance Gunship (IGB)"] = "Transport: Alliance Gunship (IGB)",
	["Transport: Horde Gunship"] = "Transport: Horde Gunship",
	["Transport: Horde Gunship (IGB)"] = "Transport: Horde Gunship (IGB)",
	["Transport: Onyxia/Nefarian Elevator"] = "Transport: Onyxia/Nefarian Elevator",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Trasnport: The Mighty Wind (Icecrown Citadel Raid)",
	["Trelleum Mine"] = "Trelleum Mine",
	["Trial of Fire"] = "Trial of Fire",
	["Trial of Frost"] = "Trial of Frost",
	["Trial of Shadow"] = "Trial of Shadow",
	["Trial of the Champion"] = "Trial of the Champion",
	["Trial of the Champion Entrance"] = "Trial of the Champion Entrance",
	["Trial of the Crusader"] = "Trial of the Crusader",
	["Trickling Passage"] = "Trickling Passage",
	["Trogma's Claim"] = "Trogma's Claim",
	["Trollbane Hall"] = "Trollbane Hall",
	["Troll War Camp Outskirts"] = "Troll War Camp Outskirts",
	["Trophy Hall"] = "Trophy Hall",
	["Troves of the Thunder King"] = "Troves of the Thunder King",
	["Trueshot Point"] = "Trueshot Point",
	["Tuluman's Landing"] = "Tuluman's Landing",
	["Turtle Beach"] = "Turtle Beach",
	["Tu Shen Burial Ground"] = "Tu Shen Burial Ground",
	Tuurem = "Tuurem",
	["Twilight Aerie"] = "Twilight Aerie",
	["Twilight Altar of Storms"] = "Twilight Altar of Storms",
	["Twilight Base Camp"] = "Twilight Base Camp",
	["Twilight Bulwark"] = "Twilight Bulwark",
	["Twilight Camp"] = "Twilight Camp",
	["Twilight Command Post"] = "Twilight Command Post",
	["Twilight Crossing"] = "Twilight Crossing",
	["Twilight Forge"] = "Twilight Forge",
	["Twilight Grove"] = "Twilight Grove",
	["Twilight Highlands"] = "Twilight Highlands",
	["Twilight Highlands Dragonmaw Phase"] = "Twilight Highlands Dragonmaw Phase",
	["Twilight Highlands Phased Entrance"] = "Twilight Highlands Phased Entrance",
	["Twilight Highlands Zeppelin 1"] = "Twilight Highlands Zeppelin 1",
	["Twilight Highlands Zeppelin 2"] = "Twilight Highlands Zeppelin 2",
	["Twilight Outpost"] = "Twilight Outpost",
	["Twilight Overlook"] = "Twilight Overlook",
	["Twilight Post"] = "Twilight Post",
	["Twilight Precipice"] = "Twilight Precipice",
	["Twilight Shore"] = "Twilight Shore",
	["Twilight's Run"] = "Twilight's Run",
	["Twilight Terrace"] = "Twilight Terrace",
	["Twilight Vale"] = "Twilight Vale",
	["Twinbraid's Patrol"] = "Twinbraid's Patrol",
	["Twin Peaks"] = "Twin Peaks",
	["Twin Shores"] = "Twin Shores",
	["Twinspire Keep"] = "Twinspire Keep",
	["Twinspire Keep Interior"] = "Twinspire Keep Interior",
	["Twin Spire Ruins"] = "Twin Spire Ruins",
	["Twisting Nether"] = "Twisting Nether",
	["Tyr's Hand"] = "Tyr's Hand",
	["Tyr's Hand Abbey"] = "Tyr's Hand Abbey",
	["Tyr's Terrace"] = "Tyr's Terrace",
	["Ufrang's Hall"] = "Ufrang's Hall",
	Uldaman = "Uldaman",
	["Uldaman Entrance"] = "Uldaman Entrance",
	Uldis = "Uldis",
	Ulduar = "Ulduar",
	["Ulduar Raid - Interior - Insertion Point"] = "Ulduar Raid - Interior - Insertion Point",
	["Ulduar Raid - Iron Concourse"] = "Ulduar Raid - Iron Concourse",
	Uldum = "Uldum",
	["Uldum Phased Entrance"] = "Uldum Phased Entrance",
	["Uldum Phase Oasis"] = "Uldum Phase Oasis",
	["Uldum - Phase Wrecked Camp"] = "Uldum - Phase Wrecked Camp",
	["Umbrafen Lake"] = "Umbrafen Lake",
	["Umbrafen Village"] = "Umbrafen Village",
	["Uncharted Sea"] = "Uncharted Sea",
	Undercity = "Undercity",
	["Underlight Canyon"] = "Underlight Canyon",
	["Underlight Mines"] = "Underlight Mines",
	["Unearthed Grounds"] = "Unearthed Grounds",
	["Unga Ingoo"] = "Unga Ingoo",
	["Un'Goro Crater"] = "Un'Goro Crater",
	["Unu'pe"] = "Unu'pe",
	["Unyielding Garrison"] = "Unyielding Garrison",
	["Upper Silvermarsh"] = "Upper Silvermarsh",
	["Upper Sumprushes"] = "Upper Sumprushes",
	["Upper Veil Shil'ak"] = "Upper Veil Shil'ak",
	["Ursoc's Den"] = "Ursoc's Den",
	Ursolan = "Ursolan",
	["Utgarde Catacombs"] = "Utgarde Catacombs",
	["Utgarde Keep"] = "Utgarde Keep",
	["Utgarde Keep Entrance"] = "Utgarde Keep Entrance",
	["Utgarde Pinnacle"] = "Utgarde Pinnacle",
	["Utgarde Pinnacle Entrance"] = "Utgarde Pinnacle Entrance",
	["Uther's Tomb"] = "Uther's Tomb",
	["Valaar's Berth"] = "Valaar's Berth",
	["Vale of Eternal Blossoms"] = "Vale of Eternal Blossoms",
	["Valgan's Field"] = "Valgan's Field",
	Valgarde = "Valgarde",
	["Valgarde Port"] = "Valgarde Port",
	Valhalas = "Valhalas",
	["Valiance Keep"] = "Valiance Keep",
	["Valiance Landing Camp"] = "Valiance Landing Camp",
	["Valiant Rest"] = "Valiant Rest",
	Valkyrion = "Valkyrion",
	["Valley of Ancient Winters"] = "Valley of Ancient Winters",
	["Valley of Ashes"] = "Valley of Ashes",
	["Valley of Bones"] = "Valley of Bones",
	["Valley of Echoes"] = "Valley of Echoes",
	["Valley of Emperors"] = "Valley of Emperors",
	["Valley of Fangs"] = "Valley of Fangs",
	["Valley of Heroes"] = "Valley of Heroes",
	["Valley Of Heroes"] = "Valley Of Heroes",
	["Valley of Honor"] = "Valley of Honor",
	["Valley of Kings"] = "Valley of Kings",
	["Valley of Power"] = "Valley of Power",
	["Valley Of Power - Scenario"] = "Valley Of Power - Scenario",
	["Valley of Spears"] = "Valley of Spears",
	["Valley of Spirits"] = "Valley of Spirits",
	["Valley of Strength"] = "Valley of Strength",
	["Valley of the Bloodfuries"] = "Valley of the Bloodfuries",
	["Valley of the Four Winds"] = "Valley of the Four Winds",
	["Valley of the Watchers"] = "Valley of the Watchers",
	["Valley of Trials"] = "Valley of Trials",
	["Valley of Wisdom"] = "Valley of Wisdom",
	Valormok = "Valormok",
	["Valor's Edge"] = "Valor's Edge",
	["Valor's Rest"] = "Valor's Rest",
	["Valorwind Lake"] = "Valorwind Lake",
	["Vanguard Infirmary"] = "Vanguard Infirmary",
	["Vanndir Encampment"] = "Vanndir Encampment",
	["Vargoth's Retreat"] = "Vargoth's Retreat",
	["Vashj'elan Spawning Pool"] = "Vashj'elan Spawning Pool",
	["Vashj'ir"] = "Vashj'ir",
	["Vashj'ir Sub - Alliance"] = "Vashj'ir Sub - Alliance",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Vashj'ir Sub - Alliance circling Abyssal Maw",
	["Vashj'ir Sub - Horde"] = "Vashj'ir Sub - Horde",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Vashj'ir Sub - Horde - Circling Abyssal Maw",
	["Vault of Archavon"] = "Vault of Archavon",
	["Vault of Ironforge"] = "Vault of Ironforge",
	["Vault of Kings Past"] = "Vault of Kings Past",
	["Vault of the Ravenian"] = "Vault of the Ravenian",
	["Vault of the Shadowflame"] = "Vault of the Shadowflame",
	["Vault of Y'Shaarj"] = "Vault of Y'Shaarj",
	["Veil Ala'rak"] = "Veil Ala'rak",
	["Veil Harr'ik"] = "Veil Harr'ik",
	["Veil Lashh"] = "Veil Lashh",
	["Veil Lithic"] = "Veil Lithic",
	["Veil Reskk"] = "Veil Reskk",
	["Veil Rhaze"] = "Veil Rhaze",
	["Veil Ruuan"] = "Veil Ruuan",
	["Veil Sethekk"] = "Veil Sethekk",
	["Veil Shalas"] = "Veil Shalas",
	["Veil Shienor"] = "Veil Shienor",
	["Veil Skith"] = "Veil Skith",
	["Veil Vekh"] = "Veil Vekh",
	["Vekhaar Stand"] = "Vekhaar Stand",
	["Velaani's Arcane Goods"] = "Velaani's Arcane Goods",
	["Vendetta Point"] = "Vendetta Point",
	["Vengeance Landing"] = "Vengeance Landing",
	["Vengeance Landing Inn"] = "Vengeance Landing Inn",
	["Vengeance Landing Inn, Howling Fjord"] = "Vengeance Landing Inn, Howling Fjord",
	["Vengeance Lift"] = "Vengeance Lift",
	["Vengeance Pass"] = "Vengeance Pass",
	["Vengeance Wake"] = "Vengeance Wake",
	["Venomous Ledge"] = "Venomous Ledge",
	Venomspite = "Venomspite",
	["Venomsting Pits"] = "Venomsting Pits",
	["Venomweb Vale"] = "Venomweb Vale",
	["Venture Bay"] = "Venture Bay",
	["Venture Co. Base Camp"] = "Venture Co. Base Camp",
	["Venture Co. Operations Center"] = "Venture Co. Operations Center",
	["Verdant Belt"] = "Verdant Belt",
	["Verdant Highlands"] = "Verdant Highlands",
	["Verdantis River"] = "Verdantis River",
	["Veridian Point"] = "Veridian Point",
	["Verlok Stand"] = "Verlok Stand",
	["Vermillion Redoubt"] = "Vermillion Redoubt",
	["Verming Tunnels Micro"] = "Verming Tunnels Micro",
	["Verrall Delta"] = "Verrall Delta",
	["Verrall River"] = "Verrall River",
	["Victor's Point"] = "Victor's Point",
	["Vileprey Village"] = "Vileprey Village",
	["Vim'gol's Circle"] = "Vim'gol's Circle",
	["Vindicator's Rest"] = "Vindicator's Rest",
	["Violet Citadel Balcony"] = "Violet Citadel Balcony",
	["Violet Hold"] = "Violet Hold",
	["Violet Hold Entrance"] = "Violet Hold Entrance",
	["Violet Rise"] = "Violet Rise",
	["Violet Stand"] = "Violet Stand",
	["Virmen Grotto"] = "Virmen Grotto",
	["Virmen Nest"] = "Virmen Nest",
	["Vir'naal Dam"] = "Vir'naal Dam",
	["Vir'naal Lake"] = "Vir'naal Lake",
	["Vir'naal Oasis"] = "Vir'naal Oasis",
	["Vir'naal River"] = "Vir'naal River",
	["Vir'naal River Delta"] = "Vir'naal River Delta",
	["Void Ridge"] = "Void Ridge",
	["Voidwind Plateau"] = "Voidwind Plateau",
	["Volcanoth's Lair"] = "Volcanoth's Lair",
	["Voldrin's Hold"] = "Voldrin's Hold",
	Voldrune = "Voldrune",
	["Voldrune Dwelling"] = "Voldrune Dwelling",
	Voltarus = "Voltarus",
	["Vordrassil Pass"] = "Vordrassil Pass",
	["Vordrassil's Heart"] = "Vordrassil's Heart",
	["Vordrassil's Limb"] = "Vordrassil's Limb",
	["Vordrassil's Tears"] = "Vordrassil's Tears",
	["Vortex Pinnacle"] = "Vortex Pinnacle",
	["Vortex Summit"] = "Vortex Summit",
	["Vul'Gol Ogre Mound"] = "Vul'Gol Ogre Mound",
	["Vyletongue Seat"] = "Vyletongue Seat",
	["Wahl Cottage"] = "Wahl Cottage",
	["Wailing Caverns"] = "Wailing Caverns",
	["Walk of Elders"] = "Walk of Elders",
	["Warbringer's Ring"] = "Warbringer's Ring",
	["Warchief's Lookout"] = "Warchief's Lookout",
	["Warden's Cage"] = "Warden's Cage",
	["Warden's Chambers"] = "Warden's Chambers",
	["Warden's Vigil"] = "Warden's Vigil",
	["Warlock Area"] = "Warlock Area",
	["Warmaul Hill"] = "Warmaul Hill",
	["Warpwood Quarter"] = "Warpwood Quarter",
	["War Quarter"] = "War Quarter",
	["Warrior's Terrace"] = "Warrior's Terrace",
	["War Room"] = "War Room",
	Warship = "Warship",
	["Warsong Camp"] = "Warsong Camp",
	["Warsong Farms Outpost"] = "Warsong Farms Outpost",
	["Warsong Flag Room"] = "Warsong Flag Room",
	["Warsong Granary"] = "Warsong Granary",
	["Warsong Gulch"] = "Warsong Gulch",
	["Warsong Hold"] = "Warsong Hold",
	["Warsong Jetty"] = "Warsong Jetty",
	["Warsong Labor Camp"] = "Warsong Labor Camp",
	["Warsong Lumber Camp"] = "Warsong Lumber Camp",
	["Warsong Lumber Mill"] = "Warsong Lumber Mill",
	["Warsong Slaughterhouse"] = "Warsong Slaughterhouse",
	["Watcher's Sanctum"] = "Watcher's Sanctum",
	["Watchers' Terrace"] = "Watchers' Terrace",
	["Waterspeaker's Sanctuary"] = "Waterspeaker's Sanctuary",
	["Waterspring Field"] = "Waterspring Field",
	Waterworks = "Waterworks",
	["Wavestrider Beach"] = "Wavestrider Beach",
	Waxwood = "Waxwood",
	["Wayfarer's Rest"] = "Wayfarer's Rest",
	Waygate = "Waygate",
	["Wayne's Refuge"] = "Wayne's Refuge",
	["Weazel's Crater"] = "Weazel's Crater",
	["Webwinder Hollow"] = "Webwinder Hollow",
	["Webwinder Path"] = "Webwinder Path",
	["Weeping Quarry"] = "Weeping Quarry",
	["Well of Eternity"] = "Well of Eternity",
	["Well of the Forgotten"] = "Well of the Forgotten",
	["Wellson Shipyard"] = "Wellson Shipyard",
	["Wellspring Hovel"] = "Wellspring Hovel",
	["Wellspring Lake"] = "Wellspring Lake",
	["Wellspring River"] = "Wellspring River",
	["Westbrook Garrison"] = "Westbrook Garrison",
	["Western Bridge"] = "Western Bridge",
	["Western Plaguelands"] = "Western Plaguelands",
	["Western Strand"] = "Western Strand",
	Westersea = "Westersea",
	Westfall = "Westfall",
	["Westfall Brigade"] = "Westfall Brigade",
	["Westfall Brigade Encampment"] = "Westfall Brigade Encampment",
	["Westfall Lighthouse"] = "Westfall Lighthouse",
	["West Garrison"] = "West Garrison",
	["Westguard Inn"] = "Westguard Inn",
	["Westguard Keep"] = "Westguard Keep",
	["Westguard Turret"] = "Westguard Turret",
	["West Pavilion"] = "West Pavilion",
	["West Pillar"] = "West Pillar",
	["West Point Station"] = "West Point Station",
	["West Point Tower"] = "West Point Tower",
	["Westreach Summit"] = "Westreach Summit",
	["West Sanctum"] = "West Sanctum",
	["Westspark Workshop"] = "Westspark Workshop",
	["West Spear Tower"] = "West Spear Tower",
	["West Spire"] = "West Spire",
	["Westwind Lift"] = "Westwind Lift",
	["Westwind Refugee Camp"] = "Westwind Refugee Camp",
	["Westwind Rest"] = "Westwind Rest",
	Wetlands = "Wetlands",
	Wheelhouse = "Wheelhouse",
	["Whelgar's Excavation Site"] = "Whelgar's Excavation Site",
	["Whelgar's Retreat"] = "Whelgar's Retreat",
	["Whispercloud Rise"] = "Whispercloud Rise",
	["Whisper Gulch"] = "Whisper Gulch",
	["Whispering Forest"] = "Whispering Forest",
	["Whispering Gardens"] = "Whispering Gardens",
	["Whispering Inlet"] = "Whispering Inlet",
	["Whispering Shore"] = "Whispering Shore",
	["Whispering Stones"] = "Whispering Stones",
	["Whisperwind Grove"] = "Whisperwind Grove",
	["Whistling Grove"] = "Whistling Grove",
	["Whitebeard's Encampment"] = "Whitebeard's Encampment",
	["Whitepetal Lake"] = "Whitepetal Lake",
	["White Pine Trading Post"] = "White Pine Trading Post",
	["Whitereach Post"] = "Whitereach Post",
	["Wildbend River"] = "Wildbend River",
	["Wildervar Mine"] = "Wildervar Mine",
	["Wildflame Point"] = "Wildflame Point",
	["Wildgrowth Mangal"] = "Wildgrowth Mangal",
	["Wildhammer Flag Room"] = "Wildhammer Flag Room",
	["Wildhammer Keep"] = "Wildhammer Keep",
	["Wildhammer Stronghold"] = "Wildhammer Stronghold",
	["Wildheart Point"] = "Wildheart Point",
	["Wildmane Water Well"] = "Wildmane Water Well",
	["Wild Overlook"] = "Wild Overlook",
	["Wildpaw Cavern"] = "Wildpaw Cavern",
	["Wildpaw Ridge"] = "Wildpaw Ridge",
	["Wilds' Edge Inn"] = "Wilds' Edge Inn",
	["Wild Shore"] = "Wild Shore",
	["Wildvine Marsh"] = "Wildvine Marsh",
	["Wildwind Lake"] = "Wildwind Lake",
	["Wildwind Path"] = "Wildwind Path",
	["Wildwind Peak"] = "Wildwind Peak",
	["Windbreak Canyon"] = "Windbreak Canyon",
	["Windfury Ridge"] = "Windfury Ridge",
	["Windrunner's Overlook"] = "Windrunner's Overlook",
	["Windrunner Spire"] = "Windrunner Spire",
	["Windrunner Village"] = "Windrunner Village",
	["Winds' Edge"] = "Winds' Edge",
	["Windshear Crag"] = "Windshear Crag",
	["Windshear Heights"] = "Windshear Heights",
	["Windshear Hold"] = "Windshear Hold",
	["Windshear Mine"] = "Windshear Mine",
	["Windshear Valley"] = "Windshear Valley",
	["Windspire Bridge"] = "Windspire Bridge",
	["Windward Isle"] = "Windward Isle",
	["Windy Bluffs"] = "Windy Bluffs",
	["Windyreed Pass"] = "Windyreed Pass",
	["Windyreed Village"] = "Windyreed Village",
	["Winterax Hold"] = "Winterax Hold",
	["Winterbough Glade"] = "Winterbough Glade",
	["Winterfall Village"] = "Winterfall Village",
	["Winterfin Caverns"] = "Winterfin Caverns",
	["Winterfin Retreat"] = "Winterfin Retreat",
	["Winterfin Village"] = "Winterfin Village",
	["Wintergarde Crypt"] = "Wintergarde Crypt",
	["Wintergarde Keep"] = "Wintergarde Keep",
	["Wintergarde Mausoleum"] = "Wintergarde Mausoleum",
	["Wintergarde Mine"] = "Wintergarde Mine",
	Wintergrasp = "Wintergrasp",
	["Wintergrasp Fortress"] = "Wintergrasp Fortress",
	["Wintergrasp River"] = "Wintergrasp River",
	["Winterhoof Water Well"] = "Winterhoof Water Well",
	["Winter's Blossom"] = "Winter's Blossom",
	["Winter's Breath Lake"] = "Winter's Breath Lake",
	["Winter's Edge Tower"] = "Winter's Edge Tower",
	["Winter's Heart"] = "Winter's Heart",
	Winterspring = "Winterspring",
	["Winter's Terrace"] = "Winter's Terrace",
	["Witch Hill"] = "Witch Hill",
	["Witch's Sanctum"] = "Witch's Sanctum",
	["Witherbark Caverns"] = "Witherbark Caverns",
	["Witherbark Village"] = "Witherbark Village",
	["Withering Thicket"] = "Withering Thicket",
	["Wizard Row"] = "Wizard Row",
	["Wizard's Sanctum"] = "Wizard's Sanctum",
	["Wolf's Run"] = "Wolf's Run",
	["Woodpaw Den"] = "Woodpaw Den",
	["Woodpaw Hills"] = "Woodpaw Hills",
	["Wood's End Cabin"] = "Wood's End Cabin",
	["Woods of the Lost"] = "Woods of the Lost",
	Workshop = "Workshop",
	["Workshop Entrance"] = "Workshop Entrance",
	["World's End Tavern"] = "World's End Tavern",
	["Wrathscale Lair"] = "Wrathscale Lair",
	["Wrathscale Point"] = "Wrathscale Point",
	["Wreckage of the Silver Dawning"] = "Wreckage of the Silver Dawning",
	["Wreck of Hellscream's Fist"] = "Wreck of Hellscream's Fist",
	["Wreck of the Mist-Hopper"] = "Wreck of the Mist-Hopper",
	["Wreck of the Skyseeker"] = "Wreck of the Skyseeker",
	["Wreck of the Vanguard"] = "Wreck of the Vanguard",
	["Writhing Mound"] = "Writhing Mound",
	Writhingwood = "Writhingwood",
	["Wu-Song Village"] = "Wu-Song Village",
	Wyrmbog = "Wyrmbog",
	["Wyrmbreaker's Rookery"] = "Wyrmbreaker's Rookery",
	["Wyrmrest Summit"] = "Wyrmrest Summit",
	["Wyrmrest Temple"] = "Wyrmrest Temple",
	["Wyrmrest Temple - bottom to middle"] = "Wyrmrest Temple - bottom to middle",
	["Wyrmrest Temple - bottom to top"] = "Wyrmrest Temple - bottom to top",
	["Wyrmrest Temple - middle to bottom"] = "Wyrmrest Temple - middle to bottom",
	["Wyrmrest Temple - middle to top"] = "Wyrmrest Temple - middle to top",
	["Wyrmrest Temple - top to bottom"] = "Wyrmrest Temple - top to bottom",
	["Wyrmrest Temple - top to middle"] = "Wyrmrest Temple - top to middle",
	["Wyrms' Bend"] = "Wyrms' Bend",
	["Wyrmscar Island"] = "Wyrmscar Island",
	["Wyrmskull Bridge"] = "Wyrmskull Bridge",
	["Wyrmskull Tunnel"] = "Wyrmskull Tunnel",
	["Wyrmskull Village"] = "Wyrmskull Village",
	["X-2 Pincer"] = "X-2 Pincer",
	Xavian = "Xavian",
	["Yan-Zhe River"] = "Yan-Zhe River",
	["Yeti Mountain Basecamp"] = "Yeti Mountain Basecamp",
	["Yinying Village"] = "Yinying Village",
	Ymirheim = "Ymirheim",
	["Ymiron's Seat"] = "Ymiron's Seat",
	["Yojamba Isle"] = "Yojamba Isle",
	["Yowler's Den"] = "Yowler's Den",
	["Zabra'jin"] = "Zabra'jin",
	["Zaetar's Choice"] = "Zaetar's Choice",
	["Zaetar's Grave"] = "Zaetar's Grave",
	["Zalashji's Den"] = "Zalashji's Den",
	["Zalazane's Fall"] = "Zalazane's Fall",
	["Zane's Eye Crater"] = "Zane's Eye Crater",
	Zangarmarsh = "Zangarmarsh",
	["Zangar Ridge"] = "Zangar Ridge",
	["Zan'vess"] = "Zan'vess",
	["Za'Tual"] = "Za'Tual",
	["Zeb'Halak"] = "Zeb'Halak",
	["Zeb'Nowa"] = "Zeb'Nowa",
	["Zeb'Sora"] = "Zeb'Sora",
	["Zeb'Tela"] = "Zeb'Tela",
	["Zeb'tula"] = "Zeb'tula",
	["Zeb'Watha"] = "Zeb'Watha",
	["Zeppelin Crash"] = "Zeppelin Crash",
	Zeramas = "Zeramas",
	["Zeth'Gor"] = "Zeth'Gor",
	["Zhu Province"] = "Zhu Province",
	["Zhu's Descent"] = "Zhu's Descent",
	["Zhu's Watch"] = "Zhu's Watch",
	["Ziata'jai Ruins"] = "Ziata'jai Ruins",
	["Zim'Abwa"] = "Zim'Abwa",
	["Zim'bo's Hideout"] = "Zim'bo's Hideout",
	["Zim'Rhuk"] = "Zim'Rhuk",
	["Zim'Torga"] = "Zim'Torga",
	["Zol'Heb"] = "Zol'Heb",
	["Zol'Maz Stronghold"] = "Zol'Maz Stronghold",
	["Zoram'gar Outpost"] = "Zoram'gar Outpost",
	["Zouchin Province"] = "Zouchin Province",
	["Zouchin Strand"] = "Zouchin Strand",
	["Zouchin Village"] = "Zouchin Village",
	["Zul'Aman"] = "Zul'Aman",
	["Zul'Drak"] = "Zul'Drak",
	["Zul'Farrak"] = "Zul'Farrak",
	["Zul'Farrak Entrance"] = "Zul'Farrak Entrance",
	["Zul'Gurub"] = "Zul'Gurub",
	["Zul'Mashar"] = "Zul'Mashar",
	["Zun'watha"] = "Zun'watha",
	["Zuuldaia Ruins"] = "Zuuldaia Ruins",
}

if GAME_LOCALE == "enUS" then
	lib:SetCurrentTranslations(true)
elseif GAME_LOCALE == "deDE" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "Basislager der 7. Legion",
	["7th Legion Front"] = "Front der 7. Legion",
	["7th Legion Submarine"] = "U-Boot der 7. Legion",
	["Abandoned Armory"] = "Verlassenes Rüstlager",
	["Abandoned Camp"] = "Verlassenes Lager",
	["Abandoned Mine"] = "Verlassene Mine",
	["Abandoned Reef"] = "Das Verlassene Riff",
	["Above the Frozen Sea"] = "Über der Gefrorenen See",
	["A Brewing Storm"] = "Ein Sturm braut sich zusammen",
	["Abyssal Breach"] = "Wirbelnder Abgrund",
	["Abyssal Depths"] = "Abyssische Tiefen",
	["Abyssal Halls"] = "Die Abyssalhallen",
	["Abyssal Maw"] = "Meeresschlund",
	["Abyssal Maw Exterior"] = "Der Meeresschlund",
	["Abyssal Sands"] = "Die Ewigen Sande",
	["Abyssion's Lair"] = "Abyssions Hort",
	["Access Shaft Zeon"] = "Zugangsschacht Zeon",
	["Acherus: The Ebon Hold"] = "Acherus: Die Schwarze Festung",
	["Addle's Stead"] = "Addles Siedlung",
	["Aderic's Repose"] = "Aderics Ruhestätte",
	["Aerie Peak"] = "Nistgipfel",
	["Aeris Landing"] = "Aerissteg",
	["Agamand Family Crypt"] = "Gruft der Familie Agamand",
	["Agamand Mills"] = "Agamands Mühlen",
	["Agmar's Hammer"] = "Agmars Hammer",
	["Agmond's End"] = "Agmondkuppe",
	["Agol'watha"] = "Agol'watha",
	["A Hero's Welcome"] = "Zum Gefeierten Helden",
	["Ahn'kahet: The Old Kingdom"] = "Ahn'kahet: Das Alte Königreich",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Eingang zu Ahn'kahet: Das Alte Königreich",
	["Ahn Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj Temple"] = "Tempel von Ahn'Qiraj",
	["Ahn'Qiraj Terrace"] = "Terrasse von Ahn'Qiraj",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ahn'Qiraj: Das Gefallene Königreich",
	["Akhenet Fields"] = "Felder von Akhenet",
	["Aku'mai's Lair"] = "Aku'mais Unterschlupf",
	["Alabaster Shelf"] = "Alabasterschelf",
	["Alcaz Island"] = "Insel Alcaz",
	["Aldor Rise"] = "Aldorhöhe",
	Aldrassil = "Aldrassil",
	["Aldur'thar: The Desolation Gate"] = "Aldur'thar: Das Tor der Verwüstung",
	["Alexston Farmstead"] = "Alexstons Bauernhof",
	["Algaz Gate"] = "Algaz-Tor",
	["Algaz Station"] = "Station Algaz",
	["A Little Patience"] = "Ein wenig Geduld",
	["Allen Farmstead"] = "Allens Bauernhof",
	["Allerian Post"] = "Allerias Posten",
	["Allerian Stronghold"] = "Allerias Feste",
	["Alliance Base"] = "Basis der Allianz",
	["Alliance Beach Daily Area"] = "Tägliche Quests: Allianz am Strand",
	["Alliance Beachhead"] = "Landespitze der Allianz",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Allianzknotenpunkt - Moguinselfortschrittszenario",
	["Alliance Keep"] = "Allianzfestung",
	["Alliance Mercenary Ship to Vashj'ir"] = "Allianzsöldnerschiff nach Vashj'ir",
	["Alliance PVP Barracks"] = "Allianz PvP Kaserne",
	["All That Glitters Prospecting Co."] = "Prospektorunternehmen Alles was Glänzt",
	["Alonsus Chapel"] = "Alonsuskapelle",
	["Altar of Ascension"] = "Altar des Aufstiegs",
	["Altar of Har'koa"] = "Altar von Har'koa",
	["Altar of Mam'toth"] = "Altar von Mam'toth",
	["Altar of Quetz'lun"] = "Altar von Quetz'lun",
	["Altar of Rhunok"] = "Altar von Rhunok",
	["Altar of Sha'tar"] = "Altar der Sha'tar",
	["Altar of Sseratus"] = "Altar von Sseratus",
	["Altar of Storms"] = "Altar der Stürme",
	["Altar of the Blood God"] = "Altar des Blutgottes",
	["Altar of Twilight"] = "Zwielichtaltar",
	["Alterac Mountains"] = "Alteracgebirge",
	["Alterac Valley"] = "Alteractal",
	["Alther's Mill"] = "Althers Mühle",
	["Amani Catacombs"] = "Amanikatakomben",
	["Amani Mountains"] = "Amanigebirge",
	["Amani Pass"] = "Amanipass",
	["Amberfly Bog"] = "Bernfliegensumpf",
	["Amberglow Hollow"] = "Die Bernscheinkuhle",
	["Amber Ledge"] = "Bernsteinflöz",
	Ambermarsh = "Die Bernmarschen",
	Ambermill = "Mühlenbern",
	["Amberpine Lodge"] = "Ammertannhütte",
	["Amber Quarry"] = "Berntagebau",
	["Amber Research Sanctum"] = "Bernforschungssanktum",
	["Ambershard Cavern"] = "Bernsteinsplitterhöhle",
	["Amberstill Ranch"] = "Gehöft Bernruh",
	["Amberweb Pass"] = "Goldweberpass",
	["Ameth'Aran"] = "Ameth'Aran",
	["Ammen Fields"] = "Am'menfelder",
	["Ammen Ford"] = "Am'menfluss",
	["Ammen Vale"] = "Am'mental",
	["Amphitheater of Anguish"] = "Amphitheater der Agonie",
	["Ampitheater of Anguish"] = "Amphitheater der Agonie",
	["Ancestral Grounds"] = "Ahnengrund",
	["Ancestral Rise"] = "Ahnenhöhe",
	["Ancient Courtyard"] = "Uralter Hof",
	["Ancient Zul'Gurub"] = "Altes Zul'Gurub",
	["An'daroth"] = "An'daroth",
	["Andilien Estate"] = "Andiliens Grund",
	Andorhal = "Andorhal",
	Andruk = "Andruk",
	["Angerfang Encampment"] = "Lager der Grollhauer",
	["Angkhal Pavilion"] = "Angkhalpavillon",
	["Anglers Expedition"] = "Die Anglerexpedition",
	["Anglers Wharf"] = "Anlegestelle der Angler",
	["Angor Fortress"] = "Festung Angor",
	["Ango'rosh Grounds"] = "Grund der Ango'rosh",
	["Ango'rosh Stronghold"] = "Festung der Ango'rosh",
	["Angrathar the Wrathgate"] = "Angrathar, Pforte des Zorns",
	["Angrathar the Wrath Gate"] = "Angrathar, Pforte des Zorns",
	["An'owyn"] = "An'owyn",
	["An'telas"] = "An'telas",
	["Antonidas Memorial"] = "Antonidas' Denkmal",
	Anvilmar = "Ambossar",
	["Anvil of Conflagration"] = "Amboss der Feuersbrunst",
	["Apex Point"] = "Der Apex",
	["Apocryphan's Rest"] = "Apocryphans Ruheplatz",
	["Apothecary Camp"] = "Apothekerlager",
	["Applebloom Tavern"] = "Taverne zur Apfelblüte",
	["Arathi Basin"] = "Arathibecken",
	["Arathi Highlands"] = "Arathihochland",
	["Arcane Pinnacle"] = "Die Arkane Spitze",
	["Archmage Vargoth's Retreat"] = "Erzmagier Vargoths Rückzugsort",
	["Area 52"] = "Area 52",
	["Arena Floor"] = "Arenagrund",
	["Arena of Annihilation"] = "Arena der Auslöschung",
	["Argent Pavilion"] = "Argentumpavillon",
	["Argent Stand"] = "Die Argentumwache",
	["Argent Tournament Grounds"] = "Argentumturnierplatz",
	["Argent Vanguard"] = "Argentumvorhut",
	["Ariden's Camp"] = "Aridens Lager",
	["Arikara's Needle"] = "Arikaras Nadel",
	["Arklonis Ridge"] = "Arklonisgrat",
	["Arklon Ruins"] = "Ruinen von Arklon",
	["Arriga Footbridge"] = "Arrigabrücke",
	["Arsad Trade Post"] = "Handelsposten Arsad",
	["Ascendant's Rise"] = "Anhöhe des Aszendenten",
	["Ascent of Swirling Winds"] = "Aufstieg der Wirbelnden Winde",
	["Ashen Fields"] = "Die Aschenfelder",
	["Ashen Lake"] = "Aschensee",
	Ashenvale = "Eschental",
	["Ashwood Lake"] = "Eschenholzsee",
	["Ashwood Post"] = "Eschenholzposten",
	["Aspen Grove Post"] = "Posten des Espenhains",
	["Assault on Shaol'mara"] = "Angriff auf Shaol'mara",
	["Assault on Zan'vess"] = "Angriff auf Zan'vess",
	["Assault on Zeb'tula"] = "Angriff auf Zeb'tula",
	Astranaar = "Astranaar",
	["Ata'mal Terrace"] = "Terrasse von Ata'mal",
	Athenaeum = "Athenaeum",
	["Atrium of the Heart"] = "Atrium des Herzens",
	["Atulhet's Tomb"] = "Atulhets Grab",
	["Auberdine Refugee Camp"] = "Flüchtlingslager von Auberdine",
	["Auburn Bluffs"] = "Kastanienfelsen",
	["Auchenai Crypts"] = "Auchenaikrypta",
	["Auchenai Grounds"] = "Auchenaigründe",
	Auchindoun = "Auchindoun",
	["Auchindoun: Auchenai Crypts"] = "Auchindoun: Auchenaikrypta",
	["Auchindoun - Auchenai Crypts Entrance"] = "Auchindoun - Eingang zur Auchenaikrypta",
	["Auchindoun: Mana-Tombs"] = "Auchindoun: Managruft",
	["Auchindoun - Mana-Tombs Entrance"] = "Auchindoun - Eingang zur Managruft",
	["Auchindoun: Sethekk Halls"] = "Auchindoun: Sethekkhallen",
	["Auchindoun - Sethekk Halls Entrance"] = "Auchindoun - Eingang zu den Sethekkhallen",
	["Auchindoun: Shadow Labyrinth"] = "Auchindoun: Schattenlabyrinth",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Auchindoun - Eingang zum Schattenlabyrinth",
	["Auren Falls"] = "Aurenfälle",
	["Auren Ridge"] = "Aurenkamm",
	["Autumnshade Ridge"] = "Herbstschattengrat",
	["Avalanchion's Vault"] = "Lavinius' Gewölbe",
	Aviary = "Voliere",
	["Axis of Alignment"] = "Achse der Ausrichtung",
	Axxarien = "Axxarien",
	["Azjol-Nerub"] = "Azjol-Nerub",
	["Azjol-Nerub Entrance"] = "Eingang nach Azjol-Nerub",
	Azshara = "Azshara",
	["Azshara Crater"] = "Krater von Azshara",
	["Azshara's Palace"] = "Azsharas Palast",
	["Azurebreeze Coast"] = "Azurblaue Küste",
	["Azure Dragonshrine"] = "Azurdrachenschrein",
	["Azurelode Mine"] = "Der Azurschacht",
	["Azuremyst Isle"] = "Azurmythosinsel",
	["Azure Watch"] = "Azurwacht",
	["Backbreaker Bay"] = "Rückenbrecherbucht",
	Badlands = "Ödland",
	["Bael'dun Digsite"] = "Grabungsstätte von Bael'dun",
	["Bael'dun Keep"] = "Burg Bael'dun",
	["Baelgun's Excavation Site"] = "Baelguns Ausgrabungsstätte",
	["Bael Modan"] = "Bael Modan",
	["Bael Modan Excavation"] = "Ausgrabungsstätte von Bael Modan",
	["Bahrum's Post"] = "Bahrums Posten",
	["Balargarde Fortress"] = "Festung Balargarde",
	Baleheim = "Quälheim",
	["Balejar Watch"] = "Balejarwacht",
	["Balia'mah Ruins"] = "Ruinen von Balia'mah",
	["Bal'lal Ruins"] = "Ruinen von Bal'lal",
	["Balnir Farmstead"] = "Balnirs Bauernhof",
	Bambala = "Bambala",
	["Band of Acceleration"] = "Ring der Akzeleration",
	["Band of Alignment"] = "Ring der Abgleichung",
	["Band of Transmutation"] = "Ring der Transmutation",
	["Band of Variance"] = "Ring der Varianz",
	["Ban'ethil Barrow Den"] = "Grabhügel von Ban'ethil",
	["Ban'ethil Barrow Descent"] = "Abstieg in den Grabhügel von Ban'ethil",
	["Ban'ethil Hollow"] = "Lichtung von Ban'ethil",
	Bank = "Bank",
	["Banquet Grounds"] = "Bankettareal",
	["Ban'Thallow Barrow Den"] = "Grabhügel von Ban'Thallow",
	["Baradin Base Camp"] = "Baradinbasislager",
	["Baradin Bay"] = "Baradinbucht",
	["Baradin Hold"] = "Baradinfestung",
	Barbershop = "Barbier",
	["Barov Family Vault"] = "Gruft der Familie Barov",
	["Bashal'Aran"] = "Bashal'Aran",
	["Bashal'Aran Collapse"] = "Einsturz von Bashal'Aran",
	["Bash'ir Landing"] = "Landeplatz von Bash'ir",
	["Bastion Antechamber"] = "Vorkammer der Bastion",
	["Bathran's Haunt"] = "Bathrans Schlupfwinkel",
	["Battlefront Provisions"] = "Schlachtfrontrationen",
	["Battle on the High Seas"] = "Schlacht auf hoher See",
	["Battle Ring"] = "Kampfring",
	Battlescar = "Kriegsnarbe",
	["Battlescar Spire"] = "Kriegsnarbenwarte",
	["Battlescar Valley"] = "Kriegsnarbental",
	["Bay of Echoes"] = "Echobucht",
	["Bay of Storms"] = "Die Bucht der Stürme",
	["Bear's Head"] = "Bärenkopf",
	["Beauty's Lair"] = "Bellas Unterschlupf",
	["Beeble's Wreck"] = "Beebles Wrack",
	["Beezil's Wreck"] = "Beezils Wrack",
	["Befouled Terrace"] = "Besudelte Terrasse",
	["Beggar's Haunt"] = "Bettlerschlupfwinkel",
	["Beneath The Double Rainbow"] = "Unter dem doppelten Regenbogen",
	["Beneath the Pit"] = "Unter der Grube",
	["Beren's Peril"] = "Berens List",
	["Bernau's Happy Fun Land"] = "Bernaus Lustiges Paradies",
	["Beryl Coast"] = "Beryllküste",
	["Beryl Egress"] = "Beryllaufstieg",
	["Beryl Point"] = "Beryllspitze",
	["Beth'mora Ridge"] = "Beth'moragrat",
	["Beth'tilac's Lair"] = "Beth'tilacs Unterschlupf",
	["Biel'aran Ridge"] = "Biel'arangrat",
	["Big Beach Brew Bash"] = "Sommer, Sonne, Strand und Bier",
	["Big Blossom Excavation"] = "Großblütenausgrabung",
	["Big Blossom Mine"] = "Großblütenmine",
	["Bilgewater Beach"] = "Bilgewasserstrand",
	["Bilgewater Harbor"] = "Bilgewasserhafen",
	["Bilgewater Lumber Yard"] = "Bilgewässer Rodungsfläche",
	["Bilgewater Port"] = "Der Bilgepier",
	["Binan Brew & Stew"] = "Trunk und Tafel",
	["Binan Village"] = "Binan",
	["Bitter Reaches"] = "Bittere Landzunge",
	["Bittertide Lake"] = "Bittertidensee",
	["Bizmo's Brawlpub"] = "Bizmos Boxbar",
	["Black Channel Marsh"] = "Schwarzkanalmarschen",
	["Blackchar Cave"] = "Schwarzbrandhöhle",
	["Black Drake Roost"] = "Schwarzdrachennest",
	["Blackfathom Camp"] = "Stützpunkt an der Grotte",
	["Blackfathom Deeps"] = "Tiefschwarze Grotte",
	["Blackfathom Deeps Entrance"] = "Eingang zur Tiefschwarzen Grotte",
	["Blackhoof Village"] = "Dorf der Schwarzhufe",
	["Blackhorn's Penance"] = "Schwarzhorns Buße",
	["Blackmaw Hold"] = "Schwarzschlundfeste",
	["Black Ox Temple"] = "Tempel des Schwarzen Ochsen",
	["Blackriver Logging Camp"] = "Holzfällerlager Schwarzwasser",
	["Blackrock Caverns"] = "Schwarzfelshöhlen",
	["Blackrock Caverns Entrance"] = "Eingang zu den Schwarzfelshöhlen",
	["Blackrock Depths"] = "Schwarzfelstiefen",
	["Blackrock Depths Entrance"] = "Eingang zu den Schwarzfelstiefen",
	["Blackrock Mountain"] = "Der Schwarzfels",
	["Blackrock Pass"] = "Schwarzfelspass",
	["Blackrock Spire"] = "Schwarzfelsspitze",
	["Blackrock Spire Entrance"] = "Eingang zur Schwarzfelsspitze",
	["Blackrock Stadium"] = "Schwarzfelsstadion",
	["Blackrock Stronghold"] = "Schwarzfelsfestung",
	["Blacksand Spillway"] = "Schwarzsandüberlauf",
	["Blacksilt Shore"] = "Schwarzschlammküste",
	Blacksmith = "Schmiede",
	["Blackstone Span"] = "Schwarzsteinübergang",
	["Black Temple"] = "Der Schwarze Tempel",
	["Black Tooth Hovel"] = "Schwarzzahnunterschlupf",
	Blackwatch = "Die Schwarzwacht",
	["Blackwater Cove"] = "Schwarzmeerbucht",
	["Blackwater Shipwrecks"] = "Schiffswracks der Schwarzmeerräuber",
	["Blackwind Lake"] = "Schattenwindsee",
	["Blackwind Landing"] = "Schattenwindlager",
	["Blackwind Valley"] = "Schattenwindtal",
	["Blackwing Coven"] = "Pechschwingenkoven",
	["Blackwing Descent"] = "Pechschwingenabstieg",
	["Blackwing Lair"] = "Pechschwingenhort",
	["Blackwolf River"] = "Schwarzwolfschnellen",
	["Blackwood Camp"] = "Lager der Schwarzfelle",
	["Blackwood Den"] = "Bau der Schwarzfelle",
	["Blackwood Lake"] = "Faulholzsee",
	["Bladed Gulch"] = "Messerschlucht",
	["Bladefist Bay"] = "Messerbucht",
	["Bladelord's Retreat"] = "Die Zuflucht des Klingenfürsten",
	["Blades & Axes"] = "Klingen & Äxte",
	["Blade's Edge Arena"] = "Arena des Schergrats",
	["Blade's Edge Mountains"] = "Schergrat",
	["Bladespire Grounds"] = "Grund der Speerspießer",
	["Bladespire Hold"] = "Wehr der Speerspießer",
	["Bladespire Outpost"] = "Außenposten der Speerspießer",
	["Blades' Run"] = "Säbelflucht",
	["Blade Tooth Canyon"] = "Säbelzahnschlucht",
	Bladewood = "Messerwinkel",
	["Blasted Lands"] = "Verwüstete Lande",
	["Bleak Hollow"] = "Triste Höhle",
	["Bleeding Hollow Ruins"] = "Ruinen des Blutenden Auges",
	["Bleeding Vale"] = "Blutklamm",
	["Bleeding Ziggurat"] = "Die Blutende Ziggurat",
	["Blistering Pool"] = "Kochender Teich",
	["Bloodcurse Isle"] = "Insel des Blutfluchs",
	["Blood Elf Tower"] = "Blutelfenturm",
	["Bloodfen Burrow"] = "Blutsumpfbau",
	Bloodgulch = "Blutschlucht",
	["Bloodhoof Village"] = "Dorf der Bluthufe",
	["Bloodied Crossing"] = "Die Blutige Kreuzung",
	["Blood in the Snow"] = "Blutroter Schnee",
	["Bloodmaul Camp"] = "Lager der Blutschläger",
	["Bloodmaul Outpost"] = "Außenposten der Blutschläger",
	["Bloodmaul Ravine"] = "Blutschlägerklamm",
	["Bloodmoon Isle"] = "Blutmondinsel",
	["Bloodmyst Isle"] = "Blutmythosinsel",
	["Bloodscale Enclave"] = "Enklave der Blutschuppen",
	["Bloodscale Grounds"] = "Blutschuppengrund",
	["Bloodspore Plains"] = "Blutsporenprärie",
	["Bloodtalon Shore"] = "Blutkrallenküste",
	["Bloodtooth Camp"] = "Blutreißers Lager",
	["Bloodvenom Falls"] = "Die Blutgiftfälle",
	["Bloodvenom Post"] = "Blutgiftposten",
	["Bloodvenom Post "] = "Blutgiftposten",
	["Bloodvenom River"] = "Blutgiftbach",
	["Bloodwash Cavern"] = "Höhle der Blutbrandung",
	["Bloodwash Fighting Pits"] = "Kampfplatz der Blutbrandung",
	["Bloodwash Shrine"] = "Schrein der Blutbrandung",
	["Blood Watch"] = "Blutwacht",
	["Bloodwatcher Point"] = "Blutwächterposten",
	Bluefen = "Blaumoor",
	["Bluegill Marsh"] = "Blaukiemenmarschen",
	["Blue Sky Logging Grounds"] = "Holzfällerposten Blauhimmel",
	["Bluff of the South Wind"] = "Felsen des Südwinds",
	["Bogen's Ledge"] = "Bogens Kante",
	Bogpaddle = "Kraulsumpf",
	["Boha'mu Ruins"] = "Ruinen von Boha'mu",
	["Bolgan's Hole"] = "Bolgans Loch",
	["Bolyun's Camp"] = "Bolyuns Lager",
	["Bonechewer Ruins"] = "Ruinen der Knochenmalmer",
	["Bonesnap's Camp"] = "Knochenknackers Lager",
	["Bones of Grakkarond"] = "Knochen von Grakkarond",
	["Bootlegger Outpost"] = "Schmugglerposten",
	["Booty Bay"] = "Beutebucht",
	["Borean Tundra"] = "Boreanische Tundra",
	["Bor'gorok Outpost"] = "Außenposten Bor'gorok",
	["Bor's Breath"] = "Bors Atem",
	["Bor's Breath River"] = "Bors Atemstrom",
	["Bor's Fall"] = "Bors Sturz",
	["Bor's Fury"] = "Bors Zorn",
	["Borune Ruins"] = "Ruinen von Borune",
	["Bough Shadow"] = "Schattengrün",
	["Bouldercrag's Refuge"] = "Bergfels' Zuflucht",
	["Boulderfist Hall"] = "Halle der Felsfäuste",
	["Boulderfist Outpost"] = "Außenposten der Felsfäuste",
	["Boulder'gor"] = "Fels'gor",
	["Boulder Hills"] = "Felshügel",
	["Boulder Lode Mine"] = "Felsadermine",
	["Boulder'mok"] = "Fels'mok",
	["Boulderslide Cavern"] = "Steinschlaghöhle",
	["Boulderslide Ravine"] = "Steinschlagklamm",
	["Bozzle's Wreck"] = "Bozzles Wrack",
	["Brackenwall Village"] = "Brackenwall",
	["Brackwell Pumpkin Patch"] = "Brackbrunns Kürbisbeet",
	["Brambleblade Ravine"] = "Dornrankenklamm",
	Bramblescar = "Dornennarbe",
	["Brann's Base-Camp"] = "Branns Basislager",
	["Brashtide Attack Fleet"] = "Trümmerflutangriffsflotte",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Trümmerflutangriffsflotte",
	["Brave Wind Mesa"] = "Heldenwindebene",
	["Brawl'gar Arena"] = "Shlae'gararena",
	["Brazie Farmstead"] = "Brazies Bauernhof",
	["Brewmoon Festival"] = "Das Braumondfest",
	["Brewnall Village"] = "Bräuhall",
	["Bridge of Souls"] = "Brücke der Seelen",
	["Brightwater Lake"] = "Blendwassersee",
	["Brightwood Grove"] = "Schattenhain",
	Brill = "Brill",
	["Brill Town Hall"] = "Rathaus von Brill",
	["Bristlelimb Enclave"] = "Enklave der Sichelklauen",
	["Bristlelimb Village"] = "Dorf der Sichelklauen",
	["Broken Commons"] = "Die Zerstörte Allmende",
	["Broken Hill"] = "Die Trümmerbastion",
	["Broken Pillar"] = "Zerbrochene Säule",
	["Broken Spear Village"] = "Bruchspeeringen",
	["Broken Wilds"] = "Zerschlagene Wildnis",
	["Broketooth Outpost"] = "Bruchzahnaußenposten",
	["Bronzebeard Encampment"] = "Bronzebarts Lager",
	["Bronze Dragonshrine"] = "Bronzedrachenschrein",
	["Browman Mill"] = "Braumanns Mühle",
	["Brunnhildar Village"] = "Brunnhildar",
	["Bucklebree Farm"] = "Hof Schildhöh",
	["Budd's Dig"] = "Budds Ausgrabung",
	["Burning Blade Coven"] = "Koven der Brennenden Klinge",
	["Burning Blade Ruins"] = "Ruinen der Brennenden Klinge",
	["Burning Steppes"] = "Brennende Steppe",
	["Butcher's Sanctum"] = "Heiligtum des Schlächters",
	["Butcher's Stand"] = "Metzgerstand",
	["Caer Darrow"] = "Darrowehr",
	["Caldemere Lake"] = "Kaldemaarsee",
	["Calston Estate"] = "Calstonanwesen",
	["Camp Aparaje"] = "Camp Aparaje",
	["Camp Ataya"] = "Camp Ataya",
	["Camp Boff"] = "Camp Boff",
	["Camp Broketooth"] = "Bruchzahnlager",
	["Camp Cagg"] = "Camp Cagg",
	["Camp E'thok"] = "Camp E'thok",
	["Camp Everstill"] = "Immerruhlager",
	["Camp Gormal"] = "Lager Gormal",
	["Camp Kosh"] = "Camp Kosh",
	["Camp Mojache"] = "Camp Mojache",
	["Camp Mojache Longhouse"] = "Langhaus von Camp Mojache",
	["Camp Narache"] = "Camp Narache",
	["Camp Nooka Nooka"] = "Lager Nuka-Nuka",
	["Camp of Boom"] = "Lager von Dr. Bumm",
	["Camp Onequah"] = "Camp Oneqwah",
	["Camp Oneqwah"] = "Camp Oneqwah",
	["Camp Sungraze"] = "Sonnenweidenlager",
	["Camp Tunka'lo"] = "Camp Tunka'lo",
	["Camp Una'fe"] = "Camp Una'fe",
	["Camp Winterhoof"] = "Lager der Winterhufe",
	["Camp Wurg"] = "Camp Wurg",
	Canals = "Kanäle",
	["Cannon's Inferno"] = "Artillerius' Inferno",
	["Cantrips & Crows"] = "Zur Zauberkrähe",
	["Cape of Lost Hope"] = "Kap der Verlorenen Hoffnung",
	["Cape of Stranglethorn"] = "Schlingendornkap",
	["Capital Gardens"] = "Hauptstadtgärten",
	["Carrion Hill"] = "Aashügel",
	["Cartier & Co. Fine Jewelry"] = "Juwelier 'Cartier & Co.'",
	Cataclysm = "Cataclysm",
	["Cathedral of Darkness"] = "Kathedrale der Dunkelheit",
	["Cathedral of Light"] = "Kathedrale des Lichts",
	["Cathedral Quarter"] = "Kathedralenviertel",
	["Cathedral Square"] = "Kathedralenplatz",
	["Cattail Lake"] = "Rohrkolbensee",
	["Cauldros Isle"] = "Kaldrosinsel",
	["Cave of Mam'toth"] = "Höhle von Mam'toth",
	["Cave of Meditation"] = "Höhle der Meditation",
	["Cave of the Crane"] = "Die Höhle des Kranichs",
	["Cave of Words"] = "Höhle der Wörter",
	["Cavern of Endless Echoes"] = "Die Höhle Endloser Echos",
	["Cavern of Mists"] = "Höhle der Nebel",
	["Caverns of Time"] = "Höhlen der Zeit",
	["Celestial Enclave"] = "Himmlische Enklave",
	["Celestial Ridge"] = "Sternensturz",
	["Cenarion Enclave"] = "Die Enklave des Cenarius",
	["Cenarion Hold"] = "Burg Cenarius",
	["Cenarion Post"] = "Posten des Cenarius",
	["Cenarion Refuge"] = "Zuflucht des Cenarius",
	["Cenarion Thicket"] = "Cenariusdickicht",
	["Cenarion Watchpost"] = "Wachposten des Cenarius",
	["Cenarion Wildlands"] = "Cenariuswildnis",
	["Central Bridge"] = "Zentrale Brücke",
	["Chamber of Ancient Relics"] = "Kammer der Uralten Relikte",
	["Chamber of Atonement"] = "Kammer der Buße",
	["Chamber of Battle"] = "Kammer der Schlachten",
	["Chamber of Blood"] = "Kammer des Bluts",
	["Chamber of Command"] = "Kommandoraum",
	["Chamber of Enchantment"] = "Kammer der Verzauberung",
	["Chamber of Enlightenment"] = "Die Kammer der Erleuchtung",
	["Chamber of Fanatics"] = "Kammer der Fanatiker",
	["Chamber of Incineration"] = "Kammer der Einäscherung",
	["Chamber of Masters"] = "Kammer der Meister",
	["Chamber of Prophecy"] = "Kammer der Prophezeiung",
	["Chamber of Reflection"] = "Die Kammer der Reflexion",
	["Chamber of Respite"] = "Kammer der Erholung",
	["Chamber of Summoning"] = "Kammer der Beschwörung",
	["Chamber of Test Namesets"] = "Chamber of Test Namesets",
	["Chamber of the Aspects"] = "Kammer der Aspekte",
	["Chamber of the Dreamer"] = "Kammer des Träumers",
	["Chamber of the Moon"] = "Kammer des Mondes",
	["Chamber of the Restless"] = "Kammer der Ruhelosen",
	["Chamber of the Stars"] = "Kammer der Sterne",
	["Chamber of the Sun"] = "Kammer der Sonne",
	["Chamber of Whispers"] = "Kammer des Raunens",
	["Chamber of Wisdom"] = "Kammer der Weisheit",
	["Champion's Hall"] = "Halle des Champions",
	["Champions' Hall"] = "Halle der Champions",
	["Chapel Gardens"] = "Kapellengarten",
	["Chapel of the Crimson Flame"] = "Kapelle der Scharlachroten Flamme",
	["Chapel Yard"] = "Kapellenhof",
	["Charred Outpost"] = "Niedergebrannter Außenposten",
	["Charred Rise"] = "Kohlschwarze Anhöhe",
	["Chill Breeze Valley"] = "Frosthauchtal",
	["Chillmere Coast"] = "Küste des Frostmaares",
	["Chillwind Camp"] = "Zugwindlager",
	["Chillwind Point"] = "Zugwindspitze",
	Chiselgrip = "Meißelgriff",
	["Chittering Coast"] = "Zwitscherküste",
	["Chow Farmstead"] = "Bauernhof der Chows",
	["Churning Gulch"] = "Grabenschlucht",
	["Circle of Blood"] = "Ring des Blutes",
	["Circle of Blood Arena"] = "Arena des Zirkels des Blutes",
	["Circle of Bone"] = "Ring der Knochen",
	["Circle of East Binding"] = "Kreis der Östlichen Bindung",
	["Circle of Inner Binding"] = "Kreis der Inneren Bindung",
	["Circle of Outer Binding"] = "Kreis der Äußeren Bindung",
	["Circle of Scale"] = "Ring der Schuppen",
	["Circle of Stone"] = "Ring der Steine",
	["Circle of Thorns"] = "Zirkel der Dornen",
	["Circle of West Binding"] = "Kreis der Westlichen Bindung",
	["Circle of Wills"] = "Kreis der Mächte",
	City = "Hauptstädte",
	["City of Ironforge"] = "Eisenschmiede",
	["City Siege - Mogu Island Progression Scenario"] = "Stadtbelagerung - Moguinselfortschrittszenario",
	["Clan Watch"] = "Klanwacht",
	["Class Quest"] = "Klassenquest",
	["Claytön's WoWEdit Land"] = "Claytön's WoWEdit-Land",
	["Cleft of Shadow"] = "Kluft der Schatten",
	["Cliffspring Falls"] = "Klippenquellfälle",
	["Cliffspring Hollow"] = "Klippenquellgrotte",
	["Cliffspring River"] = "Klippenquell",
	["Cliffwalker Post"] = "Klippenläuferposten",
	["Cloudstrike Dojo"] = "Meister Wolkenschlags Dojo",
	["Cloudtop Terrace"] = "Wolkendomterrasse",
	["Coast of Echoes"] = "Echoküste",
	["Coast of Idols"] = "Küste der Götzen",
	["Coilfang Reservoir"] = "Der Echsenkessel",
	["Coilfang: Serpentshrine Cavern"] = "Echsenkessel: Höhle des Schlangenschreins",
	["Coilfang: The Slave Pens"] = "Echsenkessel: Sklavenunterkünfte",
	["Coilfang - The Slave Pens Entrance"] = "Echsenkessel - Eingang zu den Sklavenunterkünften",
	["Coilfang: The Steamvault"] = "Echsenkessel: Dampfkammer",
	["Coilfang - The Steamvault Entrance"] = "Echsenkessel - Eingang zur Dampfkammer",
	["Coilfang: The Underbog"] = "Echsenkessel: Tiefensumpf",
	["Coilfang - The Underbog Entrance"] = "Echsenkessel - Eingang zum Tiefensumpf",
	["Coilskar Cistern"] = "Zisterne der Echsennarbe",
	["Coilskar Point"] = "Echsennarbe",
	Coldarra = "Kaltarra",
	["Coldarra Ledge"] = "Kaltarrarücken",
	["Coldbite Burrow"] = "Kaltbisshöhle",
	["Cold Hearth Manor"] = "Das Verlassene Anwesen",
	["Coldridge Pass"] = "Eisklamm",
	["Coldridge Valley"] = "Das Eisklammtal",
	["Coldrock Quarry"] = "Froststeinbruch",
	["Coldtooth Mine"] = "Eisbeißermine",
	["Coldwind Heights"] = "Kaltwindanhöhen",
	["Coldwind Pass"] = "Kaltwindpass",
	["Collin's Test"] = "Collin's Test",
	["Command Center"] = "Kommandozentrale",
	["Commons Hall"] = "Versammlungshalle",
	["Condemned Halls"] = "Verdammte Hallen",
	["Conqueror's Terrace"] = "Terrasse des Eroberers",
	["Conquest Hold"] = "Burg Siegeswall",
	["Containment Core"] = "Eindämmungskern",
	["Cooper Residence"] = "Coopers Residenz",
	["Coral Garden"] = "Korallengarten",
	["Cordell's Enchanting"] = "Cordells Verzauberungen",
	["Corin's Crossing"] = "Corins Kreuzung",
	["Corp'rethar: The Horror Gate"] = "Corp'rethar: Das Tor des Schreckens",
	["Corrahn's Dagger"] = "Corrahns Dolch",
	Cosmowrench = "Kosmozang",
	["Court of Bones"] = "Der Hof der Knochen",
	["Court of the Highborne"] = "Hof der Hochgeborenen",
	["Court of the Sun"] = "Sonnenhof",
	["Courtyard of Lights"] = "Hof der Lichter",
	["Courtyard of the Ancients"] = "Hof der Uralten",
	["Cradle of Chi-Ji"] = "Chi-Jis Wiege",
	["Cradle of the Ancients"] = "Wiege der Uralten",
	["Craftsmen's Terrace"] = "Die Terrasse der Handwerker",
	["Crag of the Everliving"] = "Klippe der Ewiglebenden",
	["Cragpool Lake"] = "Felskesselsee",
	["Crane Wing Refuge"] = "Refugium der Kranichschwingen",
	["Crash Site"] = "Absturzstelle",
	["Crescent Hall"] = "Mondsichelhalle",
	["Crimson Assembly Hall"] = "Die Karminrote Versammlungshalle",
	["Crimson Expanse"] = "Rubinspanne",
	["Crimson Watch"] = "Purpurwacht",
	Crossroads = "Das Wegekreuz",
	["Crowley Orchard"] = "Crowleys Obstgarten",
	["Crowley Stable Grounds"] = "Crowleys Stallungen",
	["Crown Guard Tower"] = "Turm der Kronenwache",
	["Crucible of Carnage"] = "Schmelztiegel des Gemetzels",
	["Crumbling Depths"] = "Bruchtiefen",
	["Crumbling Stones"] = "Die Brechenden Steine",
	["Crusader Forward Camp"] = "Lager der Kreuzfahrer",
	["Crusader Outpost"] = "Außenposten der Kreuzzügler",
	["Crusader's Armory"] = "Waffenkammer der Kreuzzügler",
	["Crusader's Chapel"] = "Kapelle des Kreuzfahreres",
	["Crusader's Landing"] = "Hafen des Kreuzzüglers",
	["Crusader's Outpost"] = "Außenposten der Kreuzzügler",
	["Crusaders' Pinnacle"] = "Kreuzfahrerturm",
	["Crusader's Run"] = "Kreuzfahrerpass",
	["Crusader's Spire"] = "Kreuzfahrerturm",
	["Crusaders' Square"] = "Kreuzzüglerplatz",
	Crushblow = "Schmetterschlagposten",
	["Crushcog's Arsenal"] = "Ritzelstoß' Arsenal",
	["Crushridge Hold"] = "Trümmergrathöhle",
	Crypt = "Gruft",
	["Crypt of Forgotten Kings"] = "Gruft der Vergessenen Könige",
	["Crypt of Remembrance"] = "Krypta der Erinnerung",
	["Crystal Lake"] = "Kristallsee",
	["Crystalline Quarry"] = "Kristallsteinbruch",
	["Crystalsong Forest"] = "Kristallsangwald",
	["Crystal Spine"] = "Kristallrücken",
	["Crystalvein Mine"] = "Kristalladermine",
	["Crystalweb Cavern"] = "Kristallnetzhöhle",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "Kuriositäten & Meer",
	["Cursed Depths"] = "Verfluchte Tiefen",
	["Cursed Hollow"] = "Verfluchtes Dunkel",
	["Cut-Throat Alley"] = "Halsabschneidergasse",
	["Cyclone Summit"] = "Zyklonspitze",
	["Dabyrie's Farmstead"] = "Bauernhof der Dabyries",
	["Daggercap Bay"] = "Dolchbucht",
	["Daggerfen Village"] = "Dolchfenn",
	["Dagger in the Dark"] = "Ein Dolch im Dunkel",
	["Daggermaw Canyon"] = "Dolchrachenklamm",
	["Dagger Pass"] = "Dolchpass",
	["Dais of Conquerors"] = "Estrade der Eroberer",
	Dalaran = "Dalaran",
	["Dalaran Arena"] = "Arena von Dalaran",
	["Dalaran City"] = "Dalaran",
	["Dalaran Crater"] = "Dalarankrater",
	["Dalaran Floating Rocks"] = "Fliegende Felsen von Dalaran",
	["Dalaran Island"] = "Insel Dalaran",
	["Dalaran Merchant's Bank"] = "Händlerbank von Dalaran",
	["Dalaran Sewers"] = "Kanalisation von Dalaran",
	["Dalaran Visitor Center"] = "Besucherzentrum von Dalaran",
	["Dalson's Farm"] = "Dalsons Hof",
	["Damplight Cavern"] = "Feuchtlichthöhle",
	["Damplight Chamber"] = "Dunstlichtkammer",
	["Dampsoil Burrow"] = "Feuchterdengrube",
	["Dandred's Fold"] = "Dandreds Senke",
	["Dargath's Demise"] = "Dargaths Niedergang",
	["Darkbreak Cove"] = "Dämmerbucht",
	["Darkcloud Pinnacle"] = "Düsterwolkengipfel",
	["Darkcrest Enclave"] = "Enklave der Dunkelkämme",
	["Darkcrest Shore"] = "Küste der Dunkelkämme",
	["Dark Heart of Pandaria"] = "Das dunkle Herz Pandarias",
	["Dark Iron Highway"] = "Dunkeleisenstraße",
	["Darkmist Cavern"] = "Graunebelhöhlen",
	["Darkmist Ruins"] = "Graunebelruinen",
	["Darkmoon Boardwalk"] = "Dunkelmond-Promenade",
	["Darkmoon Deathmatch"] = "Dunkelmond-Todesgrube",
	["Darkmoon Deathmatch Pit (PH)"] = "Darkmoon Deathmatch Pit (PH)",
	["Darkmoon Faire"] = "Dunkelmond-Jahrmarkt",
	["Darkmoon Island"] = "Dunkelmond-Insel",
	["Darkmoon Island Cave"] = "Höhle der Dunkelmond-Insel",
	["Darkmoon Path"] = "Dunkelmond-Pfad",
	["Darkmoon Pavilion"] = "Dunkelmondpavillon",
	Darkshire = "Dunkelhain",
	["Darkshire Town Hall"] = "Rathaus von Dunkelhain",
	Darkshore = "Dunkelküste",
	["Darkspear Hold"] = "Dunkelspeerfeste",
	["Darkspear Isle"] = "Dunkelspeerinsel",
	["Darkspear Shore"] = "Dunkelspeerküste",
	["Darkspear Strand"] = "Strand der Dunkelspeere",
	["Darkspear Training Grounds"] = "Übungsgelände der Dunkelspeere",
	["Darkwhisper Gorge"] = "Die Flüsternde Schlucht",
	["Darkwhisper Pass"] = "Der Flüsternde Pass",
	["Darnassian Base Camp"] = "Darnassisches Basislager",
	Darnassus = "Darnassus",
	["Darrow Hill"] = "Darrohügel",
	["Darrowmere Lake"] = "Darromersee",
	Darrowshire = "Darroheim",
	["Darrowshire Hunting Grounds"] = "Jagdgrund von Darroheim",
	["Darsok's Outpost"] = "Darsoks Außenposten",
	["Dawnchaser Retreat"] = "Morgenjägerzuflucht",
	["Dawning Lane"] = "Dämmerweg",
	["Dawning Wood Catacombs"] = "Katakomben des Morgenwaldes",
	["Dawnrise Expedition"] = "Morgendunstexpedition",
	["Dawn's Blossom"] = "Morgenblüte",
	["Dawnseeker Promontory"] = "Morgensucherkap",
	["Dawnseeker's Promontory"] = "Morgensucherkap",
	["Dawn's Reach"] = "Dämmerkuppe",
	["Dawnstar Spire"] = "Morgensternturm",
	["Dawnstar Village"] = "Morgenstern",
	["Daxil's Dig"] = "Daxils Grabung",
	["D-Block"] = "D-Block",
	["Deadeye Shore"] = "Killrogs Küste",
	["Deadman's Crossing"] = "Totmannsfurt",
	["Dead Man's Hole"] = "Dead Man's Hole",
	Deadmines = "Todesminen",
	["Deadtalker's Plateau"] = "Plateau des Totensprechers",
	["Deadwind Pass"] = "Gebirgspass der Totenwinde",
	["Deadwind Ravine"] = "Schlucht der Totenwinde",
	["Deadwood Village"] = "Lager der Totenwaldfelle",
	["Deathbringer's Rise"] = "Dom des Todesbringers",
	["Death Cultist Base Camp"] = "Basislager der Todeskultisten",
	["Deathforge Tower"] = "Turm der Todesschmiede",
	Deathknell = "Todesend",
	["Deathmatch Pavilion"] = "Todesgrubenpavillon",
	Deatholme = "Die Todesfestung",
	["Death's Breach"] = "Die Todesbresche",
	["Death's Door"] = "Schwelle des Todes",
	["Death's Hand Encampment"] = "Lager der Todeshand",
	["Deathspeaker's Watch"] = "Todessprechers Wacht",
	["Death's Rise"] = "Todesanhöhe",
	["Death's Stand"] = "Todeswehr",
	["Death's Step"] = "Treppe des Schnitters",
	["Death's Watch Waystation"] = "Wegstation Todeswacht",
	Deathwing = "Todesschwinge",
	["Deathwing's Fall"] = "Todesschwinges Sturz",
	["Deep Blue Observatory"] = "Tiefseeobservatorium",
	["Deep Elem Mine"] = "Tiefenfelsmine",
	["Deepfin Ridge"] = "Tiefenflossengrat",
	Deepholm = "Tiefenheim",
	["Deephome Ceiling"] = "Tiefenheim",
	["Deepmist Grotto"] = "Tiefennebelgrotte",
	["Deeprun Tram"] = "Die Tiefenbahn",
	["Deepwater Tavern"] = "Tiefenwassertaverne",
	["Deepwind Gorge"] = "Tiefenwindschlucht",
	["Defense of the Alehouse"] = "Verteidigung des Bierhauses",
	["Defense Of The Ale House BG"] = "Verteidigung des Bierhauses",
	["Defias Hideout"] = "Versteck der Defias",
	["Defiler's Den"] = "Die Entweihte Feste",
	["D.E.H.T.A. Encampment"] = "Lager der D.E.H.T.A.",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "Dämonensturz",
	["Demon Fall Ridge"] = "Dämonenstieg",
	["Demont's Place"] = "Demonts Heim",
	["Den of Defiance"] = "Die Höhle des Widerstands",
	["Den of Dying"] = "Höhlen des Todes",
	["Den of Haal'esh"] = "Haal'eshbau",
	["Den of Iniquity"] = "Sündenpfuhl",
	["Den of Mortal Delights"] = "Hof der Irdischen Gelüste",
	["Den of Sorrow"] = "Höhle der Trauer",
	["Den of Sseratus"] = "Bau von Sseratus",
	["Den of the Caller"] = "Höhlenbau des Rufenden",
	["Den of the Devourer"] = "Versteck des Verschlingers",
	["Den of the Disciples"] = "Schlupfwinkel der Jünger",
	["Den of the Unholy"] = "Höhlenbau des Unheiligen",
	["Derelict Caravan"] = "Die Herrenlose Karawane",
	["Derelict Manor"] = "Heruntergekommenes Anwesen",
	["Derelict Strand"] = "Verlassener Strand",
	["Designer Island"] = "Designer-Insel",
	Desolace = "Desolace",
	["Desolation Hold"] = "Ödnisfeste",
	["Detention Block"] = "Gefängnisblock",
	["Development Land"] = "Entwicklungsland",
	["Diamondhead River"] = "Diamantschnellen",
	["Diamond Island"] = "Diamantinsel",
	["Dig One"] = "Grabung Eins",
	["Dig Three"] = "Grabung Drei",
	["Dig Two"] = "Grabung Zwei",
	["Direforge Hill"] = "Hügel der Düsterschmiede",
	["Direhorn Post"] = "Grollhornposten",
	["Dire Maul"] = "Düsterbruch",
	["Dire Maul - Capital Gardens Entrance"] = "Düsterbruch - Eingang zu den Hauptstadtgärten",
	["Dire Maul - East"] = "Düsterbruch - Ost",
	["Dire Maul - Gordok Commons Entrance"] = "Düsterbruch - Eingang zun den Gordokhallen",
	["Dire Maul - North"] = "Düsterbruch - Nord",
	["Dire Maul - Warpwood Quarter Entrance"] = "Düsterbruch - Eingang zum Überwucherten Palast",
	["Dire Maul - West"] = "Düsterbruch - West",
	Diremoor = "Düstermoor",
	["Dire Strait"] = "Die Bedrängnis",
	["Disciple's Enclave"] = "Enklave der Jünger",
	Docks = "Docks",
	["Dojani River"] = "Der Dojani",
	Dolanaar = "Dolanaar",
	["Dome Balrissa"] = "Balrissakuppel",
	["Domination Point"] = "Herrschaftsfeste",
	["Donna's Kitty Shack"] = "Donnas Kätzchenkiste",
	["DO NOT USE"] = "DO NOT USE",
	["Dookin' Grounds"] = "Knatzelgründe",
	["Doom's Vigil"] = "Verdammniswacht",
	["Dorian's Outpost"] = "Dorians Außenposten",
	["Draco'dar"] = "Draco'dar",
	["Draenei Ruins"] = "Draeneiruinen",
	["Draenethyst Mine"] = "Draenethystmine",
	["Draenil'dur Village"] = "Draenil'dur",
	Dragonblight = "Drachenöde",
	["Dragonflayer Pens"] = "Stallungen der Drachenschinder",
	["Dragonmaw Base Camp"] = "Basislager des Drachenmals",
	["Dragonmaw Flag Room"] = "Flaggenraum des Drachenmalklans",
	["Dragonmaw Forge"] = "Schmiede des Drachenmals",
	["Dragonmaw Fortress"] = "Festung des Drachenmals",
	["Dragonmaw Garrison"] = "Garnison des Drachenmals",
	["Dragonmaw Gates"] = "Tore des Drachenmals",
	["Dragonmaw Pass"] = "Drachenmalpass",
	["Dragonmaw Port"] = "Hafen des Drachenmals",
	["Dragonmaw Skyway"] = "Himmelspfad des Drachenmals",
	["Dragonmaw Stronghold"] = "Festung des Drachenmals",
	["Dragons' End"] = "Drachenend",
	["Dragon's Fall"] = "Drachensturz",
	["Dragon's Mouth"] = "Drachenschlund",
	["Dragon Soul"] = "Drachenseele",
	["Dragon Soul Raid - East Sarlac"] = "Drachenseele (Schlachtzug) - Östlicher Sarlac",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Drachenseele (Schlachtzug) - Basis am Wyrmruhtempel",
	["Dragonspine Peaks"] = "Drachenwirbelgipfel",
	["Dragonspine Ridge"] = "Drachenwirbelgrat",
	["Dragonspine Tributary"] = "Drachenwirbelzufluss",
	["Dragonspire Hall"] = "Drachenspitzhalle",
	["Drak'Agal"] = "Drak'Agal",
	["Draka's Fury"] = "Drakas Furor",
	["Drak'atal Passage"] = "Passage von Drak'atal",
	["Drakil'jin Ruins"] = "Ruinen von Drakil'jin",
	["Drak'Mabwa"] = "Drak'Mabwa",
	["Drak'Mar Lake"] = "Drak'Marsee",
	["Draknid Lair"] = "Unterschlupf der Drakniden",
	["Drak'Sotra"] = "Drak'Sotra",
	["Drak'Sotra Fields"] = "Felder von Drak'Sotra",
	["Drak'Tharon Keep"] = "Feste Drak'Tharon",
	["Drak'Tharon Keep Entrance"] = "Eingang zur Feste Drak'Tharon",
	["Drak'Tharon Overlook"] = "Aussichtspunkt von Drak'Tharon",
	["Drak'ural"] = "Drak'ural",
	["Dread Clutch"] = "Das Nest des Schreckens",
	["Dread Expanse"] = "Schreckensweite",
	["Dreadmaul Furnace"] = "Schreckensfelssenke",
	["Dreadmaul Hold"] = "Feste Schreckensfels",
	["Dreadmaul Post"] = "Schreckensfelsposten",
	["Dreadmaul Rock"] = "Schreckensfels",
	["Dreadmist Camp"] = "Glutnebellager",
	["Dreadmist Den"] = "Glutnebelbau",
	["Dreadmist Peak"] = "Glutnebelgipfel",
	["Dreadmurk Shore"] = "Schreckensmoorküste",
	["Dread Terrace"] = "Schreckensterrasse",
	["Dread Wastes"] = "Schreckensöde",
	["Dreadwatch Outpost"] = "Schreckenswacht",
	["Dream Bough"] = "Traumgeäst",
	["Dreamer's Pavilion"] = "Pavillon des Träumers",
	["Dreamer's Rest"] = "Träumersruh",
	["Dreamer's Rock"] = "Träumerstein",
	Drudgetown = "Malocherviertel",
	["Drygulch Ravine"] = "Staubwindklamm",
	["Drywhisker Gorge"] = "Schlucht der Trockenstoppel",
	["Dubra'Jin"] = "Dubra'Jin",
	["Dun Algaz"] = "Dun Algaz",
	["Dun Argol"] = "Dun Argol",
	["Dun Baldar"] = "Dun Baldar",
	["Dun Baldar Pass"] = "Pass von Dun Baldar",
	["Dun Baldar Tunnel"] = "Tunnel von Dun Baldar",
	["Dunemaul Compound"] = "Truppenlager der Dünenbrecher",
	["Dunemaul Recruitment Camp"] = "Rekrutierungslager der Dünenbrecher",
	["Dun Garok"] = "Dun Garok",
	["Dun Mandarr"] = "Dun Mandarr",
	["Dun Modr"] = "Dun Modr",
	["Dun Morogh"] = "Dun Morogh",
	["Dun Niffelem"] = "Dun Niffelem",
	["Dunwald Holdout"] = "Bastion von Dunwald",
	["Dunwald Hovel"] = "Hütten von Dunwald",
	["Dunwald Market Row"] = "Marktgasse von Dunwald",
	["Dunwald Ruins"] = "Ruinen von Dunwald",
	["Dunwald Town Square"] = "Ratsplatz von Dunwald",
	["Durnholde Keep"] = "Burg Durnholde",
	Durotar = "Durotar",
	Duskhaven = "Dämmerhafen",
	["Duskhowl Den"] = "Grauheulerbau",
	["Dusklight Bridge"] = "Dämmerlichtbrücke",
	["Dusklight Hollow"] = "Dämmerlichtstumpf",
	["Duskmist Shore"] = "Abendnebelküste",
	["Duskroot Fen"] = "Dämmerwurzmoor",
	["Duskwither Grounds"] = "Nachtschimmergrund",
	["Duskwither Spire"] = "Nachtschimmerturm",
	Duskwood = "Dämmerwald",
	["Dustback Gorge"] = "Staubrückenklamm",
	["Dustbelch Grotto"] = "Die Staubspeiergrotte",
	["Dustfire Valley"] = "Staubfeuertal",
	["Dustquill Ravine"] = "Staubstachelschlucht",
	["Dustwallow Bay"] = "Düstermarschenbucht",
	["Dustwallow Marsh"] = "Düstermarschen",
	["Dustwind Cave"] = "Staubwindhöhle",
	["Dustwind Dig"] = "Staubwindausgrabung",
	["Dustwind Gulch"] = "Staubwindschlucht",
	["Dwarven District"] = "Zwergendistrikt",
	["Eagle's Eye"] = "Adlerauge",
	["Earthshatter Cavern"] = "Erdspaltergrotte",
	["Earth Song Falls"] = "Fälle des Irdenen Gesangs",
	["Earth Song Gate"] = "Tor zu den Fällen des Irdenen Gesangs",
	["Eastern Bridge"] = "Östliche Brücke",
	["Eastern Kingdoms"] = "Östliche Königreiche",
	["Eastern Plaguelands"] = "Östliche Pestländer",
	["Eastern Strand"] = "Oststrand",
	["East Garrison"] = "Ostgarnison",
	["Eastmoon Ruins"] = "Ostmondruinen",
	["East Pavilion"] = "Östlicher Pavillon",
	["East Pillar"] = "Ostsäule",
	["Eastpoint Tower"] = "Ostwachtturm",
	["East Sanctum"] = "Sanktum des Ostens",
	["Eastspark Workshop"] = "Werkstatt Ostfunk",
	["East Spire"] = "Ostturm",
	["East Supply Caravan"] = "Östliche Versorgungskarawane",
	["Eastvale Logging Camp"] = "Holzfällerlager des Osttals",
	["Eastwall Gate"] = "Ostwalltor",
	["Eastwall Tower"] = "Ostwallturm",
	["Eastwind Rest"] = "Ostwindruhestätte",
	["Eastwind Shore"] = "Ostwindküste",
	["Ebon Hold"] = "Schwarze Festung",
	["Ebon Watch"] = "Die Schwarze Wacht",
	["Echo Cove"] = "Echobucht",
	["Echo Isles"] = "Die Echoinseln",
	["Echomok Cavern"] = "Echomokhöhle",
	["Echo Reach"] = "Echoweiten",
	["Echo Ridge Mine"] = "Echokammmine",
	["Eclipse Point"] = "Stätte der Mondfinsternis",
	["Eclipsion Fields"] = "Felder der Mondfinsternis",
	["Eco-Dome Farfield"] = "Biokuppel Fernfeld",
	["Eco-Dome Midrealm"] = "Biokuppel Mittelreich",
	["Eco-Dome Skyperch"] = "Biokuppel Himmelssitz",
	["Eco-Dome Sutheron"] = "Biokuppel Sutheron",
	["Elder Rise"] = "Die Anhöhe der Ältesten",
	["Elders' Square"] = "Ältestenplatz",
	["Eldreth Row"] = "Eldrethgasse",
	["Eldritch Heights"] = "Düsterhöhen",
	["Elemental Plateau"] = "Elementarplateau",
	["Elementium Depths"] = "Elementiumtiefen",
	Elevator = "Aufzug",
	["Elrendar Crossing"] = "Elrendarkreuzung",
	["Elrendar Falls"] = "Elrendarfälle",
	["Elrendar River"] = "Der Elrendar",
	["Elwynn Forest"] = "Wald von Elwynn",
	["Ember Clutch"] = "Glutstätte",
	Emberglade = "Glutgrund",
	["Ember Spear Tower"] = "Glutspeerturm",
	["Emberstone Mine"] = "Glutsteinmine",
	["Emberstone Village"] = "Glutstein",
	["Emberstrife's Den"] = "Aschenschwinges Bau",
	["Emerald Dragonshrine"] = "Smaragddrachenschrein",
	["Emerald Dream"] = "Smaragdgrüner Traum",
	["Emerald Forest"] = "Smaragdwald",
	["Emerald Sanctuary"] = "Das Smaragdrefugium",
	["Emperor Rikktik's Rest"] = "Kaiser Rikktiks Ruhestätte",
	["Emperor's Omen"] = "Omen des Kaisers",
	["Emperor's Reach"] = "Die Kaiserhöhe",
	["End Time"] = "Die Endzeit",
	["Engineering Labs"] = "Ingenieurslabore",
	["Engineering Labs "] = "Ingenieurslabore",
	["Engine of Nalak'sha"] = "Maschine von Nalak'sha",
	["Engine of the Makers"] = "Maschine der Schöpfer",
	["Entryway of Time"] = "Eingangspfad der Zeit",
	["Ethel Rethor"] = "Ethel Rethor",
	["Ethereal Corridor"] = "Korridor der Astralen",
	["Ethereum Staging Grounds"] = "Stützpunkt des Astraleums",
	["Evergreen Trading Post"] = "Handelsposten Immergrün",
	Evergrove = "Der Ewige Hain",
	Everlook = "Ewige Warte",
	["Eversong - Duskwither Teleport"] = "Immersang - Nachtschimmerteleport",
	["Eversong Woods"] = "Immersangwald",
	["Excavation Center"] = "Ausgrabungszentrum",
	["Excavation Lift"] = "Aufzug an der Ausgrabungsstätte",
	["Exclamation Point"] = "Der Ausrufepunkt",
	["Expedition Armory"] = "Expeditionsrüstlager",
	["Expedition Base Camp"] = "Basislager der Expedition",
	["Expedition Point"] = "Expeditionsposten",
	["Explorers' League Digsite"] = "Grabungsstätte der Forscherliga",
	["Explorers' League Outpost"] = "Außenposten der Forscherliga",
	["Exposition Pavilion"] = "Ausstellungspavillon",
	["Eye of Eternity"] = "Auge der Ewigkeit",
	["Eye of the Storm"] = "Auge des Sturms",
	["Fairbreeze Village"] = "Morgenluft",
	["Fairbridge Strand"] = "Morgentaustrand",
	["Falcon Watch"] = "Falkenwacht",
	["Falconwing Inn"] = "Gasthaus des Falkenplatzes",
	["Falconwing Square"] = "Falkenplatz",
	["Faldir's Cove"] = "Die Faldirbucht",
	["Falfarren River"] = "Der Falfarren",
	["Fallen Sky Lake"] = "Himmelssturzsee",
	["Fallen Sky Ridge"] = "Himmelssturzgrat",
	["Fallen Temple of Ahn'kahet"] = "Der Gefallene Tempel Ahn'kahet",
	["Fall of Return"] = "Sturz der Wiederkehr",
	["Fallowmere Inn"] = "Brachweiherschenke",
	["Fallow Sanctuary"] = "Zuflucht der Verirrten",
	["Falls of Ymiron"] = "Ymironfälle",
	["Fallsong Village"] = "Fallsang",
	["Falthrien Academy"] = "Akademie von Falthrien",
	Familiars = "Familiare",
	["Faol's Rest"] = "Faols Ruheplatz",
	["Fargaze Mesa"] = "Horizontmesa",
	["Fargodeep Mine"] = "Tiefenschachtmine",
	Farm = "Hof",
	Farshire = "Fernhain",
	["Farshire Fields"] = "Weiden von Fernhain",
	["Farshire Lighthouse"] = "Leuchtturm von Fernhain",
	["Farshire Mine"] = "Mine von Fernhain",
	["Farson Hold"] = "Farsonfestung",
	["Farstrider Enclave"] = "Enklave der Weltenwanderer",
	["Farstrider Lodge"] = "Jagdhütte der Weltenwanderer",
	["Farstrider Retreat"] = "Zuflucht der Weltenwanderer",
	["Farstriders' Enclave"] = "Enklave der Weltenwanderer",
	["Farstriders' Square"] = "Platz der Weltenwanderer",
	["Farwatcher's Glen"] = "Weitblicktal",
	["Farwatch Overlook"] = "Die Weitblickwarte",
	["Far Watch Post"] = "Fernwacht",
	["Fear Clutch"] = "Das Nest der Angst",
	["Featherbeard's Hovel"] = "Federbarts Hütte",
	Feathermoon = "Mondfederfeste",
	["Feathermoon Stronghold"] = "Mondfederfeste",
	["Fe-Feng Village"] = "Fe-Feng",
	["Felfire Hill"] = "Dämonenhügel",
	["Felpaw Village"] = "Revier der Teufelspfoten",
	["Fel Reaver Ruins"] = "Teufelshäscherruinen",
	["Fel Rock"] = "Teufelsfels",
	["Felspark Ravine"] = "Teufelsfunkenklamm",
	["Felstone Field"] = "Teufelssteinfeld",
	Felwood = "Teufelswald",
	["Fenris Isle"] = "Insel Fenris",
	["Fenris Keep"] = "Burg Fenris",
	Feralas = "Feralas",
	["Feralfen Village"] = "Wildfenn",
	["Feral Scar Vale"] = "Wildschrammtal",
	["Festering Pools"] = "Eiterteiche",
	["Festival Lane"] = "Feststraße",
	["Feth's Way"] = "Feths Pfad",
	["Field of Korja"] = "Felder von Korja",
	["Field of Strife"] = "Feld des Kampfes",
	["Fields of Blood"] = "Felder des Blutes",
	["Fields of Honor"] = "Felder der Ehre",
	["Fields of Niuzao"] = "Felder von Niuzao",
	Filming = "Filmen",
	["Final Gate - Mogu Island Progression Scenario"] = "Letztes Tor - Moguinselfortschrittszenario",
	["Firebeard Cemetery"] = "Feuerbarts Friedhof",
	["Firebeard's Patrol"] = "Feuerbarts Patrouille",
	["Firebough Nook"] = "Feuerzweigwinkel",
	["Fire Camp Bataar"] = "Streitlager Bataar",
	["Fire Camp Gai-Cho"] = "Streitlager Gai-Cho",
	["Fire Camp Ordo"] = "Streitlager Ordo",
	["Fire Camp Osul"] = "Streitlager Osul",
	["Fire Camp Ruqin"] = "Streitlager Ruqin",
	["Fire Camp Yongqi"] = "Streitlager Yongqi",
	["Firegut Furnace"] = "Ofen der Feuermägen",
	Firelands = "Feuerlande",
	["Firelands Forgeworks"] = "Schmiedewerk der Feuerlande",
	["Firelands Hatchery"] = "Brutstätte der Feuerlande",
	["Firelands Terrain 2"] = "Feuerlande-Terrain 2",
	["Fireplume Peak"] = "Schwarzrauchgipfel",
	["Fire Plume Ridge"] = "Feuersäulengrat",
	["Fireplume Trench"] = "Der Schwarzrauchgraben",
	["Fire Scar Shrine"] = "Schrein des Sengenden Feuers",
	["Fire Stone Mesa"] = "Steinflammenebene",
	["Firestone Point"] = "Flammensteinspitze",
	["Firewatch Ridge"] = "Feuerwachtgrat",
	["Firewing Point"] = "Posten der Feuerschwingen",
	["First Bank of Kezan"] = "Erste Bank von Kezan",
	["First Legion Forward Camp"] = "Vorhutslager der Ersten Legion",
	["First to Your Aid"] = "Die Helfende Hand",
	["Fishing Village"] = "Fischerdorf",
	["Fizzcrank Airstrip"] = "Landebahn Kurbelzisch",
	["Fizzcrank Pumping Station"] = "Kurbelzischs Pumpstation",
	["Fizzle & Pozzik's Speedbarge"] = "Fizzels & Pozziks Turbodampfer",
	["Fjorn's Anvil"] = "Fjorns Amboss",
	Flamebreach = "Flammenbresche",
	["Flame Crest"] = "Flammenkamm",
	["Flamestar Post"] = "Flammensternposten",
	["Flamewatch Tower"] = "Flammenaugenturm",
	["Flavor - Stormwind Harbor - Stop"] = "Hafen von Sturmwind - Stop",
	["Fleshrender's Workshop"] = "Werkstatt des Fleischfetzers",
	["Foothold Citadel"] = "Wehrzitadelle",
	["Footman's Armory"] = "Waffenkammer des Fußsoldaten",
	["Force Interior"] = "Das Innere der Macht",
	["Fordragon Hold"] = "Feste Fordragon",
	["Forest Heart"] = "Herz des Waldes",
	["Forest's Edge"] = "Der Waldrand",
	["Forest's Edge Post"] = "Posten des Waldrands",
	["Forest Song"] = "Waldeslied",
	["Forge Base: Gehenna"] = "Konstruktionsbasis: Gehenna",
	["Forge Base: Oblivion"] = "Konstruktionsbasis: Vergessenheit",
	["Forge Camp: Anger"] = "Konstruktionslager: Groll",
	["Forge Camp: Fear"] = "Konstruktionslager: Furcht",
	["Forge Camp: Hate"] = "Konstruktionslager: Hass",
	["Forge Camp: Mageddon"] = "Konstruktionslager: Mageddon",
	["Forge Camp: Rage"] = "Konstruktionslager: Zorn",
	["Forge Camp: Terror"] = "Konstruktionslager: Terror",
	["Forge Camp: Wrath"] = "Konstruktionslager: Wut",
	["Forge of Fate"] = "Schmiede des Schicksals",
	["Forge of the Endless"] = "Schmiede des Unendlichen",
	["Forgewright's Tomb"] = "Schmiedevaters Grabmal",
	["Forgotten Depths"] = "Vergessene Tiefen",
	["Forgotten Hill"] = "Vergessener Hügel",
	["Forgotten Mire"] = "Der Vergessene Sumpf",
	["Forgotten Passageway"] = "Die Vergessene Passage",
	["Forlorn Cloister"] = "Unglückseliger Kreuzgang",
	["Forlorn Hut"] = "Einsame Hütte",
	["Forlorn Ridge"] = "Der Einsame Grat",
	["Forlorn Rowe"] = "Das Verlassene Gut",
	["Forlorn Spire"] = "Der Einsame Turm",
	["Forlorn Woods"] = "Die Trostlosen Wälder",
	["Formation Grounds"] = "Gestaltungsgelände",
	["Forsaken Forward Command"] = "Gefechtsstand der Verlassenen",
	["Forsaken High Command"] = "Kommandozentrale der Verlassenen",
	["Forsaken Rear Guard"] = "Rückendeckung der Verlassenen",
	["Fort Livingston"] = "Fort Livingston",
	["Fort Silverback"] = "Fort Silberrücken",
	["Fort Triumph"] = "Triumphfeste",
	["Fortune's Fist"] = "Schicksalsfaust",
	["Fort Wildervar"] = "Fort Wildervar",
	["Forward Assault Camp"] = "Vorderes Angriffslager",
	["Forward Command"] = "Gefechtsstand",
	["Foulspore Cavern"] = "Faulsporenhöhle",
	["Foulspore Pools"] = "Faulsporenteiche",
	["Fountain of the Everseeing"] = "Quell des Allsehenden",
	["Fox Grove"] = "Fuchswäldchen",
	["Fractured Front"] = "Zerrissene Front",
	["Frayfeather Highlands"] = "Fransenfederhochland",
	["Fray Island"] = "Prügeleiland",
	["Frazzlecraz Motherlode"] = "Frazzelcraz' Hauptader",
	["Freewind Post"] = "Freiwindposten",
	["Frenzyheart Hill"] = "Hügel der Wildherzen",
	["Frenzyheart River"] = "Strom der Wildherzen",
	["Frigid Breach"] = "Die Eisbresche",
	["Frostblade Pass"] = "Frostklingenpass",
	["Frostblade Peak"] = "Frostklingengipfel",
	["Frostclaw Den"] = "Frostklauenbau",
	["Frost Dagger Pass"] = "Frostdolchpass",
	["Frostfield Lake"] = "Frostfeldsee",
	["Frostfire Hot Springs"] = "Die Frostfeuerquellen",
	["Frostfloe Deep"] = "Frostschollentiefe",
	["Frostgrip's Hollow"] = "Frostgriffs Höhle",
	Frosthold = "Eisfestung",
	["Frosthowl Cavern"] = "Heulende Frosthöhle",
	["Frostmane Front"] = "Frontlinie der Frostmähnen",
	["Frostmane Hold"] = "Höhle der Frostmähnen",
	["Frostmane Hovel"] = "Frostmähnenbau",
	["Frostmane Retreat"] = "Zuflucht der Frostmähnen",
	Frostmourne = "Frostgram",
	["Frostmourne Cavern"] = "Frostgramhöhlen",
	["Frostsaber Rock"] = "Frostsäblerfelsen",
	["Frostwhisper Gorge"] = "Frosthauchschlucht",
	["Frostwing Halls"] = "Die Frostschwingenhallen",
	["Frostwolf Graveyard"] = "Friedhof der Frostwölfe",
	["Frostwolf Keep"] = "Burg Frostwolf",
	["Frostwolf Pass"] = "Frostwolfpass",
	["Frostwolf Tunnel"] = "Frostwolftunnel",
	["Frostwolf Village"] = "Dorf der Frostwölfe",
	["Frozen Reach"] = "Die Gefrorenen Weiten",
	["Fungal Deep"] = "Fungustiefe",
	["Fungal Rock"] = "Fungusfels",
	["Funggor Cavern"] = "Funggorhöhle",
	["Furien's Post"] = "Furiens Posten",
	["Furlbrow's Pumpkin Farm"] = "Brauenwirbels Kürbishof",
	["Furnace of Hate"] = "Brennofen des Hasses",
	["Furywing's Perch"] = "Zornschwinges Hort",
	Fuselight = "Luntenbrand",
	["Fuselight-by-the-Sea"] = "Luntenbrand-am-Meer",
	["Fu's Pond"] = "Fus Teich",
	Gadgetzan = "Gadgetzan",
	["Gahrron's Withering"] = "Gahrrons Trauerfeld",
	["Gai-Cho Battlefield"] = "Schlachtfeld von Gai-Cho",
	["Galak Hold"] = "Galakhöhle",
	["Galakrond's Rest"] = "Galakronds Ruhestätte",
	["Galardell Valley"] = "Galardelltal",
	["Galen's Fall"] = "Galens Sturz",
	["Galerek's Remorse"] = "Galereks Sühne",
	["Galewatch Lighthouse"] = "Leuchtturm der Sturmwacht",
	["Gallery of Treasures"] = "Galerie der Schätze",
	["Gallows' Corner"] = "Galgeneck",
	["Gallows' End Tavern"] = "Taverne Zur Galgenschlinge",
	["Gallywix Docks"] = "Gallywix' Docks",
	["Gallywix Labor Mine"] = "Gallywix' Fronmine",
	["Gallywix Pleasure Palace"] = "Gallywix' Lustschloss",
	["Gallywix's Villa"] = "Gallywix' Villa",
	["Gallywix's Yacht"] = "Gallywix' Yacht",
	["Galus' Chamber"] = "Galus' Kammer",
	["Gamesman's Hall"] = "Halle der Spiele",
	Gammoth = "Gammut",
	["Gao-Ran Battlefront"] = "Gao-Ran-Front",
	Garadar = "Garadar",
	["Gar'gol's Hovel"] = "Gar'gols Unterschlupf",
	Garm = "Garm",
	["Garm's Bane"] = "Garms Bann",
	["Garm's Rise"] = "Garms Erhebung",
	["Garren's Haunt"] = "Garrens Schlupfwinkel",
	["Garrison Armory"] = "Garnisonswaffenkammer",
	["Garrosh'ar Advance"] = "Garrosh'arvorstoß",
	["Garrosh'ar Point"] = "Garrosh'ar",
	["Garrosh's Landing"] = "Garroshs Landeplatz",
	["Garvan's Reef"] = "Garvans Riff",
	["Gate of Echoes"] = "Tor der Echos",
	["Gate of Endless Spring"] = "Tor des Endlosen Frühlings",
	["Gate of Hamatep"] = "Hamateps Tor",
	["Gate of Lightning"] = "Tor der Blitze",
	["Gate of the August Celestials"] = "Tor der Himmlischen Erhabenen",
	["Gate of the Blue Sapphire"] = "Tor des Saphirhimmels",
	["Gate of the Green Emerald"] = "Tor des Smaragdhorizonts",
	["Gate of the Purple Amethyst"] = "Tor des Amethyststerns",
	["Gate of the Red Sun"] = "Tor der Rubinsonne",
	["Gate of the Setting Sun"] = "Das Tor der Untergehenden Sonne",
	["Gate of the Yellow Moon"] = "Tor des Goldmondes",
	["Gates of Ahn'Qiraj"] = "Tore von Ahn'Qiraj",
	["Gates of Ironforge"] = "Tore von Eisenschmiede",
	["Gates of Sothann"] = "Tore von Sothann",
	["Gauntlet of Flame"] = "Lauf der Flamme",
	["Gavin's Naze"] = "Gavins Landspitze",
	["Geezle's Camp"] = "Geezles Lager",
	["Gelkis Village"] = "Dorf der Gelkis",
	["General Goods"] = "Gemischtwaren",
	["General's Terrace"] = "Terrasse des Generals",
	["Ghostblade Post"] = "Geisterklingenposten",
	Ghostlands = "Geisterlande",
	["Ghost Walker Post"] = "Geistwandlerposten",
	["Giant's Run"] = "Plateau der Riesen",
	["Giants' Run"] = "Plateau der Riesen",
	["Gilded Fan"] = "Der Goldfächer",
	["Gillijim's Isle"] = "Gillijims Insel",
	["Gilnean Coast"] = "Gilnearische Küste",
	["Gilnean Stronghold"] = "Gilnearische Feste",
	Gilneas = "Gilneas",
	Gilneas2 = "Gilneas",
	["Gilneas City"] = "Gilneas",
	["Gilneas (Do Not Reuse)"] = "Gilneas",
	["Gilneas Liberation Front Base Camp"] = "Vorderes Basislager der Gilnearischen Befreiungsfront",
	GilneasPhase1 = "Gilneas",
	GilneasPhase2 = "Gilneas",
	["Gimorak's Den"] = "Gimoraks Bau",
	Gjalerbron = "Gjalerbron",
	Gjalerhorn = "Gjalerhorn",
	["Glacial Falls"] = "Eiswasserfälle",
	["Glimmer Bay"] = "Glimmerbucht",
	["Glimmerdeep Gorge"] = "Glimmertiefenschlucht",
	["Glittering Strand"] = "Glimmerstrand",
	["Glopgut's Hollow"] = "Stopfwampes Anhöhe",
	["Glorious Goods"] = "Wunderbare Waren",
	Glory = "Glorie",
	["GM Island"] = "GM-Insel",
	["Gnarlpine Hold"] = "Höhle der Knarzklauen",
	["Gnaws' Boneyard"] = "Nagers Friedhof",
	Gnomeregan = "Gnomeregan",
	["Gobline Mine"] = "Goblinmine",
	["Goblin Foundry"] = "Goblingießerei",
	["Goblin Mine"] = "Goblinmine",
	["Goblin Slums"] = "Die Goblinslums",
	["Gokk'lok's Grotto"] = "Gokk'loks Grotte",
	["Gokk'lok Shallows"] = "Gokk'lokuntiefen",
	["Golakka Hot Springs"] = "Die Heißen Quellen von Golakka",
	["Gol'Bolar Quarry"] = "Steinbruch Gol'Bolar",
	["Gol'Bolar Quarry Mine"] = "Gol'Bolarmine",
	["Gold Coast Quarry"] = "Der Goldküstensteinbruch",
	["Goldenbough Pass"] = "Goldblattpass",
	["Goldenmist Village"] = "Goldnebel",
	["Golden Strand"] = "Der Goldene Strand",
	["Gold Mine"] = "Goldmine",
	["Gold Road"] = "Goldstraße",
	["Gold Rush BG"] = "Goldrausch",
	Goldshire = "Goldhain",
	["Goldtooth's Den"] = "Goldzahns Lager",
	["Goodgrub Smoking Pit"] = "Gutmampfs Räuchergrube",
	["Gordok's Seat"] = "Gordoks Sitz",
	["Gordunni Outpost"] = "Außenposten der Gordunni",
	["Gorefiend's Vigil"] = "Blutschattens Wacht",
	["Gor'gaz Outpost"] = "Außenposten von Gor'gaz",
	Gornia = "Gornia",
	["Gorrok's Lament"] = "Gorroks Klage",
	["Gorshak War Camp"] = "Kriegslager Gorshak",
	["Go'Shek Farm"] = "Go'Sheks Hof",
	["Grain Cellar"] = "Kornkeller",
	["Grand Courtyard"] = "Großer Innenhof",
	["Grand Magister's Asylum"] = "Zuflucht des Großmagisters",
	["Grand Overlook"] = "Der Große Rundblick",
	["Grand Promenade"] = "Große Promenade",
	["Grangol'var Village"] = "Grangol'var",
	["Granite Springs"] = "Granitquell",
	["Grassy Cline"] = "Das Grasgefälle",
	["Greatwood Vale"] = "Hochwipfeltal",
	["Greengill Coast"] = "Küste der Grünkiemen",
	["Greenpaw Village"] = "Laubtatzenlichtung",
	["Greenstone Dojo"] = "Dojo von Grünstein",
	["Greenstone Inn"] = "Gasthaus von Grünstein",
	["Greenstone Masons' Quarter"] = "Steinmetzviertel von Grünstein",
	["Greenstone Quarry"] = "Grünsteinbruch",
	["Greenstone Village"] = "Grünstein",
	["Greenwarden's Grove"] = "Hain des Sumpfhüters",
	["Greymane Court"] = "Graumähnenhof",
	["Greymane Manor"] = "Graumähnenanwesen",
	["Greymist Firth"] = "Graumistförde",
	["Grim Batol"] = "Grim Batol",
	["Grim Batol Entrance"] = "Eingang nach Grim Batol",
	["Grimesilt Dig Site"] = "Rußschlacks Grabungsstätte",
	["Grimtotem Compound"] = "Truppenlager der Grimmtotem",
	["Grimtotem Post"] = "Posten der Grimmtotem",
	Grishnath = "Grishnath",
	Grizzlemaw = "Grauschlund",
	["Grizzlepaw Ridge"] = "Grautatzengrat",
	["Grizzly Hills"] = "Grizzlyhügel",
	["Grol'dom Farm"] = "Grol'doms Hof",
	["Grolluk's Grave"] = "Grolluks Grab",
	["Grom'arsh Crash-Site"] = "Absturzstelle Grom'ash",
	["Grom'gol"] = "Grom'gol",
	["Grom'gol Base Camp"] = "Basislager Grom'gol",
	["Grommash Hold"] = "Feste Grommash",
	["Grookin Hill"] = "Flotschhügel",
	["Grosh'gok Compound"] = "Das Lager von Grosh'gok",
	["Grove of Aessina"] = "Hain von Aessina",
	["Grove of Falling Blossoms"] = "Hain der Fallenden Blüten",
	["Grove of the Ancients"] = "Der Hain der Uralten",
	["Growless Cave"] = "Eisfellhöhle",
	["Gruul's Lair"] = "Gruuls Unterschlupf",
	["Gryphon Roost"] = "Greifenhorst",
	["Guardian's Library"] = "Bibliothek des Wächters",
	Gundrak = "Gundrak",
	["Gundrak Entrance"] = "Eingang nach Gundrak",
	["Gunstan's Dig"] = "Gunstans Grabung",
	["Gunstan's Post"] = "Gunstans Posten",
	["Gunther's Retreat"] = "Gunthers Zufluchtsort",
	["Guo-Lai Halls"] = "Guo-Lai-Hallen",
	["Guo-Lai Ritual Chamber"] = "Guo-Lai-Ritualkammer",
	["Guo-Lai Vault"] = "Guo-Lai-Gewölbe",
	["Gurboggle's Ledge"] = "Gurboggels Fels",
	["Gurubashi Arena"] = "Arena der Gurubashi",
	["Gyro-Plank Bridge"] = "Gyroplankenbrücke",
	["Haal'eshi Gorge"] = "Schlucht der Haal'eshi",
	["Hadronox's Lair"] = "Hadronox' Hort",
	["Hailwood Marsh"] = "Hagelwaldmoor",
	Halaa = "Halaa",
	["Halaani Basin"] = "Halaanibecken",
	["Halcyon Egress"] = "Der Halcyonaufstieg",
	["Haldarr Encampment"] = "Lager der Haldarr",
	Halfhill = "Halbhügel",
	Halgrind = "Halgrind",
	["Hall of Arms"] = "Halle der Waffen",
	["Hall of Binding"] = "Halle der Bindung",
	["Hall of Blackhand"] = "Schwarzfausthalle",
	["Hall of Blades"] = "Halle der Messer",
	["Hall of Bones"] = "Halle der Knochen",
	["Hall of Champions"] = "Halle der Helden",
	["Hall of Command"] = "Halle des Befehls",
	["Hall of Crafting"] = "Halle des Handwerks",
	["Hall of Departure"] = "Halle des Abschieds",
	["Hall of Explorers"] = "Halle der Forscher",
	["Hall of Faces"] = "Halle der Gesichter",
	["Hall of Horrors"] = "Halle des Grauens",
	["Hall of Illusions"] = "Halle der Illusionen",
	["Hall of Kings"] = "Halle der Könige",
	["Hall of Legends"] = "Halle der Legenden",
	["Hall of Masks"] = "Halle der Masken",
	["Hall of Memories"] = "Halle der Erinnerungen",
	["Hall of Mysteries"] = "Halle der Mysterien",
	["Hall of Repose"] = "Halle der Muße",
	["Hall of Return"] = "Halle der Wiederkehr",
	["Hall of Ritual"] = "Halle des Rituals",
	["Hall of Secrets"] = "Halle der Geheimnisse",
	["Hall of Serpents"] = "Halle der Schlangen",
	["Hall of Shapers"] = "Halle der Former",
	["Hall of Stasis"] = "Halle der Stasis",
	["Hall of the Brave"] = "Halle der Kriegerhelden",
	["Hall of the Conquered Kings"] = "Halle der Bezwungenen Könige",
	["Hall of the Crafters"] = "Halle der Handwerker",
	["Hall of the Crescent Moon"] = "Halle des Halbmonds",
	["Hall of the Crusade"] = "Halle des Kreuzzugs",
	["Hall of the Cursed"] = "Halle der Verfluchten",
	["Hall of the Damned"] = "Halle der Verdammten",
	["Hall of the Defamed"] = "Halle der Verleumdeten",
	["Hall of the Exalted"] = "Halle der Ehrwürdigen",
	["Hall of the Fathers"] = "Halle der Vorväter",
	["Hall of the Frostwolf"] = "Halle der Frostwölfe",
	["Hall of the Grand Imperion"] = "Halle des Großen Imperion",
	["Hall of the High Father"] = "Halle des Hohen Vaters",
	["Hall of the Keepers"] = "Halle der Bewahrer",
	["Hall of the Shaper"] = "Halle des Formers",
	["Hall of the Stormpike"] = "Halle der Sturmlanzen",
	["Hall of the Tortured"] = "Halle der Gefolterten",
	["Hall of the Watchers"] = "Halle der Behüter",
	["Hall of the Wicked"] = "Halle der Tückischen",
	["Hall of Tombs"] = "Halle der Gräber",
	["Hall of Tranquility"] = "Halle der Ruhe",
	["Hall of Tranquillity"] = "Halle der Ruhe",
	["Hall of Twilight"] = "Halle des Zwielichts",
	["Halls of Anguish"] = "Hallen der Pein",
	["Halls of Awakening"] = "Hallen des Erwachens",
	["Halls of Binding"] = "Hallen der Bindung",
	["Halls of Destruction"] = "Hallen der Zerstörung",
	["Halls of Flesh-Shaping"] = "Hallen der Fleischformer",
	["Halls of Lightning"] = "Hallen der Blitze",
	["Halls of Lightning Entrance"] = "Eingang zu den Hallen der Blitze",
	["Halls of Mourning"] = "Hallen der Trauer",
	["Halls of Origination"] = "Hallen des Ursprungs",
	["Halls of Origination Entrance"] = "Eingang zu den Hallen des Ursprungs",
	["Halls of Reflection"] = "Hallen der Reflexion",
	["Halls of Reflection Entrance"] = "Eingang zu den Hallen der Reflexion",
	["Halls of Silence"] = "Hallen des Schweigens",
	["Halls of Stone"] = "Hallen des Steins",
	["Halls of Stone Entrance"] = "Eingang zu den Hallen des Steins",
	["Halls of Strife"] = "Hallen des Zwists",
	["Halls of the Ancestors"] = "Hallen der Vorfahren",
	["Halls of the Hereafter"] = "Hallen des Jenseits",
	["Halls of the Law"] = "Halle des Gesetzes",
	["Halls of Theory"] = "Hallen der Theorie",
	["Halycon's Lair"] = "Halycons Hort",
	Hammerfall = "Hammerfall",
	["Hammertoe's Digsite"] = "Hammerzehs Grabungsstätte",
	["Hammond Farmstead"] = "Hammonds Bauernhof",
	Hangar = "Hangar",
	["Hardknuckle Clearing"] = "Lichtung der Hartknöchel",
	["Hardwrench Hideaway"] = "Hartzangs Versteck",
	["Harkor's Camp"] = "Harkors Lager",
	["Hatchet Hills"] = "Die Axthügel",
	["Hatescale Burrow"] = "Der Hassschuppenbau",
	["Hatred's Vice"] = "Haderzwinge",
	Havenshire = "Havenau",
	["Havenshire Farms"] = "Höfe von Havenau",
	["Havenshire Lumber Mill"] = "Sägewerk von Havenau",
	["Havenshire Mine"] = "Mine von Havenau",
	["Havenshire Stables"] = "Ställe von Havenau",
	["Hayward Fishery"] = "Fischerei Hayward",
	["Headmaster's Retreat"] = "Rückzugsort des Direktors",
	["Headmaster's Study"] = "Arbeitszimmer des Direktors",
	Hearthglen = "Herdweiler",
	["Heart of Destruction"] = "Herz der Zerstörung",
	["Heart of Fear"] = "Das Herz der Angst",
	["Heart of the Old God Scenario"] = "Das dunkle Herz Pandarias",
	["Heart of Zan'vess"] = "Herz von Zan'vess",
	["Heart's Blood Shrine"] = "Schrein des Herzensblutes",
	["Heartwood Trading Post"] = "Handelsposten Kernholz",
	["Heb'Drakkar"] = "Heb'Drakkar",
	["Heb'Valok"] = "Heb'Valok",
	["Hellfire Basin"] = "Höllenfeuerbecken",
	["Hellfire Citadel"] = "Höllenfeuerzitadelle",
	["Hellfire Citadel: Ramparts"] = "Höllenfeuerzitadelle: Bollwerk",
	["Hellfire Citadel - Ramparts Entrance"] = "Höllenfeuerzitadelle - Eingang zum Bollwerk",
	["Hellfire Citadel: The Blood Furnace"] = "Höllenfeuerzitadelle: Blutkessel",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Höllenfeuerzitadelle - Eingang zum Blutkessel",
	["Hellfire Citadel: The Shattered Halls"] = "Höllenfeuerzitadelle: Zerschmetterte Hallen",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Höllenfeuerzitadelle - Eingang zu den Zerschmetterten Hallen",
	["Hellfire Peninsula"] = "Höllenfeuerhalbinsel",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Höllenfeuerhalbinsel - Lager - Landzunge",
	["Hellfire Peninsula - Reaver's Fall"] = "Höllenfeuerhalbinsel - Häschersturz",
	["Hellfire Ramparts"] = "Höllenfeuerbollwerk",
	["Hellscream Arena"] = "Höllschrei-Arena",
	["Hellscream's Camp"] = "Höllschreis Lager",
	["Hellscream's Fist"] = "Höllschreis Faust",
	["Hellscream's Grasp"] = "Höllschreis Griff",
	["Hellscream's Watch"] = "Höllschreis Wacht",
	["Helm's Bed Lake"] = "Helmsbettsee",
	["Heroes' Vigil"] = "Heldenwache",
	["Hetaera's Clutch"] = "Hetaeras Gelege",
	["Hewn Bog"] = "Prügelsumpf",
	["Heyman's Hubris"] = "Heymans Hybris",
	["Hibernal Cavern"] = "Überwinterungshöhle",
	["Hidden Cell"] = "Versteckte Zelle",
	["Hidden Path"] = "Verborgener Pfad",
	Highbank = "Hochstade",
	["High Bank"] = "Hochstade",
	["Highland Forest"] = "Hochlandwald",
	Highperch = "Der Steilhang",
	["High Wilderness"] = "Die Obere Wildnis",
	Hillsbrad = "Hügellandhof",
	["Hillsbrad Fields"] = "Die Felder des Hügellands",
	["Hillsbrad Foothills"] = "Vorgebirge des Hügellands",
	["Hiri'watha Research Station"] = "Forschungsstation Hiri'watha",
	["Hive'Ashi"] = "Bau des Ashischwarms",
	["Hive'Regal"] = "Bau des Regalschwarms",
	["Hive'Zora"] = "Bau des Zoraschwarms",
	["Hogger Hill"] = "Hoggerhügel",
	["Hollowed Out Tree"] = "Der Ausgehöhlte Baum",
	["Hollowstone Mine"] = "Hohlsteinmine",
	["Honeydew Farm"] = "Honigtauhof",
	["Honeydew Glade"] = "Honigtaulichtung",
	["Honeydew Village"] = "Honigtau",
	["Honor Hold"] = "Ehrenfeste",
	["Honor Hold Mine"] = "Mine",
	["Honor Point"] = "Ehrenposten ",
	["Honor's Stand"] = "Ehrenwacht",
	["Honor's Tomb"] = "Ehrengrabmal",
	["Horde Base Camp"] = "Basislager der Horde",
	["Horde Beach Daily Area"] = "Tägliche Quests: Horde am Strand",
	["Horde Encampment"] = "Lager der Horde",
	["Horde Keep"] = "Hordenfestung",
	["Horde Landing"] = "Landeplatz der Horde",
	["Horde Landing Site"] = "Landezone der Horde",
	["Hordemar City"] = "Hordemar",
	["Horde PVP Barracks"] = "Horde PvP Kaserne",
	["Horror Clutch"] = "Das Nest des Grauens",
	["Hour of Twilight"] = "Stunde des Zwielichts",
	["House of Edune"] = "Haus von Edune",
	["Howling Fjord"] = "Der Heulende Fjord",
	["Howlingwind Cavern"] = "Heulwindhöhle",
	["Howlingwind Trail"] = "Der Wimmerwindpfad",
	["Howling Ziggurat"] = "Die Heulende Ziggurat",
	["Hrothgar's Landing"] = "Hrothgars Landestelle",
	["Huangtze Falls"] = "Huangtzekaskade",
	["Hull of the Foebreaker"] = "Rumpf der Feindbrecher",
	["Humboldt Conflagration"] = "Die Humboldtfeuersbrunst",
	["Hunter Rise"] = "Die Anhöhe der Jäger",
	["Hunter's Hill"] = "Der Jägerhügel",
	["Huntress of the Sun"] = "Jägerin der Sonne",
	["Huntsman's Cloister"] = "Kreuzgang des Jägers",
	Hyjal = "Hyjal",
	["Hyjal Barrow Dens"] = "Grabhügel des Hyjal",
	["Hyjal Past"] = "Hyjal der Vergangenheit",
	["Hyjal Summit"] = "Hyjalgipfel",
	["Iceblood Garrison"] = "Eisblutgarnison",
	["Iceblood Graveyard"] = "Eisblutfriedhof",
	Icecrown = "Eiskrone",
	["Icecrown Citadel"] = "Eiskronenzitadelle",
	["Icecrown Dungeon - Gunships"] = "Eiskronen-Dungeon - Kanonenschiffe",
	["Icecrown Glacier"] = "Eiskronengletscher",
	["Iceflow Lake"] = "Eiswellensee",
	["Ice Heart Cavern"] = "Eiskernhöhlen",
	["Icemist Falls"] = "Eisnebelfälle",
	["Icemist Village"] = "Eisnebel",
	["Ice Thistle Hills"] = "Eisdistelberge",
	["Icewing Bunker"] = "Eisschwingenbunker",
	["Icewing Cavern"] = "Eisschwingenhöhle",
	["Icewing Pass"] = "Eisschwingenpass",
	["Idlewind Lake"] = "Idlewindsee",
	["Igneous Depths"] = "Die Feurigen Tiefen",
	["Ihgaluk Crag"] = "Ihgalukklamm",
	["Ik'vess"] = "Ik'vess",
	["Ikz'ka Ridge"] = "Die Ikz'kaklippe",
	["Illidari Point"] = "Stätte der Illidari",
	["Illidari Training Grounds"] = "Ausbildungsgelände der Illidari",
	["Indu'le Village"] = "Indu'le",
	["Infiltrating the Shipyard"] = "Infiltration der Werft",
	["Inkgill Mere"] = "Tintenkiemenweiher",
	Inn = "Gasthaus",
	["Inner Sanctum"] = "Inneres Sanktum",
	["Inner Veil"] = "Der Innere Zwist",
	["Insidion's Perch"] = "Insidions Hort",
	["Invasion Point: Annihilator"] = "Invasionspunkt: Vernichter",
	["Invasion Point: Cataclysm"] = "Invasionspunkt: Katastrophe",
	["Invasion Point: Destroyer"] = "Invasionspunkt: Zerstörer",
	["Invasion Point: Overlord"] = "Invasionspunkt: Oberanführer",
	["Ironband's Compound"] = "Eisenbands Truppenlager",
	["Ironband's Excavation Site"] = "Eisenbands Ausgrabungsstätte",
	["Ironbeard's Tomb"] = "Eisenbarts Grabmal",
	["Ironclad Cove"] = "Eiserne Bucht",
	["Ironclad Garrison"] = "Eiserne Garnison",
	["Ironclad Prison"] = "Eisernes Gefängnis",
	["Iron Concourse"] = "Der Eisenstau",
	["Irondeep Mine"] = "Eisenschachtmine",
	Ironforge = "Eisenschmiede",
	["Ironforge Airfield"] = "Flugplatz von Eisenschmiede",
	["Ironstone Camp"] = "Eisensteinlager",
	["Ironstone Plateau"] = "Eisensteinplateau",
	["Iron Summit"] = "Eisengipfel",
	["Irontree Cavern"] = "Eisenwaldhöhle",
	["Irontree Clearing"] = "Eisenwaldlichtung",
	["Irontree Woods"] = "Der Eisenwald",
	["Ironwall Dam"] = "Eisenwalldamm",
	["Ironwall Rampart"] = "Eisenwallbollwerk",
	["Ironwing Cavern"] = "Eisenschwingenhöhle",
	Iskaal = "Iskaal",
	["Island of Doctor Lapidis"] = "Insel des Doktor Lapidis",
	["Isle of Conquest"] = "Insel der Eroberung",
	["Isle of Conquest No Man's Land"] = "Niemandsland auf der Insel der Eroberung",
	["Isle of Dread"] = "Die Insel des Schreckens",
	["Isle of Giants"] = "Insel der Riesen",
	["Isle of Quel'Danas"] = "Insel von Quel'Danas",
	["Isle of Reckoning"] = "Insel der Abrechnung",
	["Isle of Thunder"] = "Insel des Donners",
	["Isle of Tribulations"] = "Insel des Martyriums",
	["Iso'rath"] = "Iso'rath",
	["Itharius's Cave"] = "Itharius' Höhle",
	["Ivald's Ruin"] = "Ivalds Ruine",
	["Ix'lar's Domain"] = "Ix'lars Domäne",
	["Jadefire Glen"] = "Jadefeuertal",
	["Jadefire Run"] = "Jadefeuerschlucht",
	["Jade Forest Alliance Hub Phase"] = "Jade Forest Alliance Hub Phase",
	["Jade Forest Battlefield Phase"] = "Jade Forest Battlefield Phase",
	["Jade Forest Horde Starting Area"] = "Jadewald Startgebiet Horde",
	["Jademir Lake"] = "Jademirsee",
	["Jade Temple Grounds"] = "Anlagen des Jadetempels",
	Jaedenar = "Jaedenar",
	["Jagged Reef"] = "Gezacktes Riff",
	["Jagged Ridge"] = "Zackengrat",
	["Jaggedswine Farm"] = "Scheckeneberhof",
	["Jagged Wastes"] = "Zackenwüste",
	["Jaguero Isle"] = "Die Insel Jaguero",
	["Jaina Dalaran Scenario"] = "Szenario: Jaina in Dalaran",
	["Janeiro's Point"] = "Janeirospitze",
	["Jangolode Mine"] = "Der Jangoschacht",
	["Jaquero Isle"] = "Die Insel Jaguero",
	["Jasperlode Mine"] = "Jaspismine",
	["Jeff NE Quadrant Changed"] = "Jeff NO-Quadrant geändert",
	["Jeff NW Quadrant"] = "Jeff NW-Quadrant",
	["Jeff SE Quadrant"] = "Jeff SO-Quadrant",
	["Jeff SW Quadrant"] = "Jeff SW-Quadrant",
	["Jerod's Landing"] = "Jerods Anlegestelle",
	["Jintha'Alor"] = "Jintha'Alor",
	["Jintha'kalar"] = "Jintha'kalar",
	["Jintha'kalar Passage"] = "Jintha'kalarpassage",
	["Jin Yang Road"] = "Jin-Yang-Straße",
	Jotunheim = "Jotunheim",
	K3 = "K3",
	["Kaja'mine"] = "Kaja'mine",
	["Kaja'mite Cave"] = "Kaja'mithöhle",
	["Kaja'mite Cavern"] = "Kaja'mithöhle",
	["Kajaro Field"] = "Kajarofeld",
	["Kal'ai Ruins"] = "Ruinen von Kal'ai",
	Kalimdor = "Kalimdor",
	Kamagua = "Kamagua",
	["Karabor Sewers"] = "Kanäle von Karabor",
	Karazhan = "Karazhan",
	["Kargathia Keep"] = "Burg Kargathia",
	["Karnum's Glade"] = "Karnums Lichtung",
	["Kartak's Hold"] = "Kartaks Stellung",
	Kaskala = "Kaskala",
	["Kaw's Roost"] = "Kraas Ruhestätte",
	["Kea Krak"] = "Kea-Krak",
	["Keelen's Trustworthy Tailoring"] = "Keelens tadellose Schneiderei",
	["Keel Harbor"] = "Kielwasser",
	["Keeshan's Post"] = "Keeshans Posten",
	["Kelp'thar Forest"] = "Tang'tharwald",
	["Kel'Thuzad Chamber"] = "Kel'Thuzads Gemächer",
	["Kel'Thuzad's Chamber"] = "Kel'Thuzads Gemächer",
	["Keset Pass"] = "Kesetpass",
	["Kessel's Crossing"] = "Kessels Wegelager",
	Kezan = "Kezan",
	Kharanos = "Kharanos",
	["Khardros' Anvil"] = "Khardros' Amboss",
	["Khartut's Tomb"] = "Grab des Khartut",
	["Khaz'goroth's Seat"] = "Khaz'goroths Sitz",
	["Ki-Han Brewery"] = "Brauerei Ki-Han",
	["Kili'ua's Atoll"] = "Kili'uas Atoll",
	["Kil'sorrow Fortress"] = "Festung Kil'sorge",
	["King's Gate"] = "Königstor",
	["King's Harbor"] = "Königshafen",
	["King's Hoard"] = "Königslager",
	["King's Square"] = "Königsplatz",
	["Kirin'Var Village"] = "Kirin'Var",
	Kirthaven = "Kirthafen",
	["Klaxxi'vess"] = "Klaxxi'vess",
	["Klik'vess"] = "Klik'vess",
	["Knucklethump Hole"] = "Faustklopploch",
	["Kodo Graveyard"] = "Der Kodofriedhof",
	["Kodo Rock"] = "Kodofels",
	["Kolkar Village"] = "Kolkar",
	Kolramas = "Kolramas",
	["Kor'kron Vanguard"] = "Vorposten der Kor'kron",
	["Kormek's Hut"] = "Kormeks Hütte",
	["Koroth's Den"] = "Koroths Bau",
	["Korthun's End"] = "Korthuns Ende",
	["Kor'vess"] = "Kor'vess",
	["Kota Basecamp"] = "Basislager am Kota",
	["Kota Peak"] = "Kotaspitze",
	["Krasarang Cove"] = "Krasarangbucht",
	["Krasarang River"] = "Der Krasarang",
	["Krasarang Wilds"] = "Krasarangwildnis",
	["Krasari Falls"] = "Krasarifälle",
	["Krasus' Landing"] = "Krasus' Landeplatz",
	["Krazzworks Attack Zeppelin"] = "Angriffszeppelin der Krazzwerke",
	["Kril'Mandar Point"] = "Kril'mandarspitze",
	["Kri'vess"] = "Kri'vess",
	["Krolg's Hut"] = "Krolgs Hütte",
	["Krom'gar Fortress"] = "Feste Krom'gar",
	["Krom's Landing"] = "Kroms Landeplatz",
	["KTC Headquarters"] = "Hauptgeschäftssitz der HGK",
	["KTC Oil Platform"] = "Ölplattform der HGK",
	["Kul'galar Keep"] = "Feste Kul'galar",
	["Kul Tiras"] = "Kul Tiras",
	["Kun-Lai Pass"] = "Kun-Lai-Pass",
	["Kun-Lai Summit"] = "Kun-Lai-Gipfel",
	["Kunzen Cave"] = "Kunzen-Höhle",
	["Kunzen Village"] = "Kunzen",
	["Kurzen's Compound"] = "Kurzens Truppenlager",
	["Kypari Ik"] = "Kypari Ik",
	["Kyparite Quarry"] = "Der Kyparitsteinbruch",
	["Kypari Vor"] = "Kypari Vor",
	["Kypari Zar"] = "Kypari Zar",
	["Kzzok Warcamp"] = "Kriegslager Kzzok",
	["Lair of Skiggit"] = "Skiggits Unterschlupf",
	["Lair of the Beast"] = "Hort der Bestie",
	["Lair of the Chosen"] = "Unterschlupf des Auserwählten",
	["Lair of the Jade Witch"] = "Versteck der Jadehexe",
	["Lair of Tortos"] = "Tortos' Unterschlupf",
	["Lake Al'Ameth"] = "Al'Amethsee",
	["Lake Cauldros"] = "Kaldrossee",
	["Lake Dumont"] = "Dumontsee",
	["Lake Edunel"] = "Edunelsee",
	["Lake Elrendar"] = "Elrendarsee",
	["Lake Elune'ara"] = "See von Elune'ara",
	["Lake Ere'Noru"] = "See von Ere'Noru",
	["Lake Everstill"] = "Der Immerruhsee",
	["Lake Falathim"] = "Falathimsee",
	["Lake Indu'le"] = "Wasser von Indu'le",
	["Lake Jorune"] = "Jorunesee",
	["Lake Kel'Theril"] = "Kel'Therilsee",
	["Lake Kittitata"] = "Kittitatasee",
	["Lake Kum'uya"] = "Kum'uyasee",
	["Lake Mennar"] = "Mennarsee",
	["Lake Mereldar"] = "Mereldarsee",
	["Lake Nazferiti"] = "Der Nazferitisee",
	["Lake of Stars"] = "Der Sternensee",
	["Lakeridge Highway"] = "Uferpfad",
	Lakeshire = "Seenhain",
	["Lakeshire Inn"] = "Gasthaus von Seenhain",
	["Lakeshire Town Hall"] = "Rathaus von Seenhain",
	["Lakeside Landing"] = "Landeplatz am See",
	["Lake Sunspring"] = "Sonnenwindsee",
	["Lakkari Tar Pits"] = "Teergruben von Lakkari",
	["Landing Beach"] = "Anlandestrand",
	["Landing Site"] = "Landeplatz",
	["Land's End Beach"] = "Landendestrand",
	["Langrom's Leather & Links"] = "Langroms Leder & Ketten",
	["Lao & Son's Yakwash"] = "Yaksalberei Lao & Sohn",
	["Largo's Overlook"] = "Largos Warte",
	["Largo's Overlook Tower"] = "Turm von Largos Warte",
	["Lariss Pavilion"] = "Larisspavillon",
	["Laughing Skull Courtyard"] = "Hof des Lachenden Schädels",
	["Laughing Skull Ruins"] = "Ruinen des Lachenden Schädels",
	["Launch Bay"] = "Startrampe",
	["Legash Encampment"] = "Lager der Legashi",
	["Legendary Leathers"] = "Legendäre Leder",
	["Legion Hold"] = "Feste der Legion",
	["Legion's Fate"] = "Verhängnis der Legion",
	["Legion's Rest"] = "Ruhestatt der Legion",
	["Lethlor Ravine"] = "Die Lethlorklamm",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "Leyaras Trauer",
	["L'ghorek"] = "L'ghorek",
	["Liang's Retreat"] = "Liangs Refugium",
	["Library Wing"] = "Bibliotheksflügel",
	Lighthouse = "Leuchtturm",
	["Lightning Ascent"] = "Der Blitzaufstieg",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Blitzschmiede - Moguinselfortschrittszenario",
	["Lightning Ledge"] = "Gewittersims",
	["Lightning Promenade"] = "Die Blitzpromenade",
	["Lightning Vein Mine"] = "Die Blitzaderminen",
	["Light's Breach"] = "Die Lichtbresche",
	["Light's Dawn Cathedral"] = "Kathedrale des Erwachenden Lichts",
	["Light's Hammer"] = "Hammer des Lichts",
	["Light's Hope Chapel"] = "Kapelle des Hoffnungsvollen Lichts",
	["Light's Point"] = "Lichtgipfel",
	["Light's Point Tower"] = "Lichtgipfelturm",
	["Light's Shield Tower"] = "Lichtschildturm",
	["Light's Trust"] = "Die Lichtwarte",
	["Like Clockwork"] = "Auf die Sekunde",
	["Lion's Landing"] = "Löwenlandung",
	["Lion's Pride Inn"] = "Gasthaus Zur Höhle des Löwen",
	["Livery Outpost"] = "Pferdewechselstation",
	["Livery Stables"] = "Nobelställe",
	["Livery Stables "] = "Nobelställe",
	["Llane's Oath"] = "Llanes Schwur",
	["Loading Room"] = "Laderaum",
	["Loch Modan"] = "Loch Modan",
	["Loch Verrall"] = "Loch Verrall",
	["Loken's Bargain"] = "Lokens Handel",
	["Lonesome Cove"] = "Die Einsame Bucht",
	Longshore = "Die Endlose Küste",
	["Longying Outpost"] = "Außenposten Longying",
	["Lordamere Internment Camp"] = "Lordamere-Internierungslager",
	["Lordamere Lake"] = "Der Lordameresee",
	["Lor'danel"] = "Lor'danel",
	["Lorthuna's Gate"] = "Lorthunas Tor",
	["Lost Caldera"] = "Verlorene Caldera",
	["Lost City of the Tol'vir"] = "Die Verlorene Stadt der Tol'vir",
	["Lost City of the Tol'vir Entrance"] = "Eingang zur Verlorenen Stadt der Tol'vir",
	LostIsles = "Die Verlorenen Inseln",
	["Lost Isles Town in a Box"] = "Die Verlorenen Inseln",
	["Lost Isles Volcano Eruption"] = "Die Verlorenen Inseln",
	["Lost Peak"] = "Verlorener Gipfel",
	["Lost Point"] = "Die Verlassene Wacht",
	["Lost Rigger Cove"] = "Mast- und Schotbucht",
	["Lothalor Woodlands"] = "Waldländer von Lothalor",
	["Lower City"] = "Unteres Viertel",
	["Lower Silvermarsh"] = "Untere Silbermarschen",
	["Lower Sumprushes"] = "Sumpfbinsensenke",
	["Lower Veil Shil'ak"] = "Unteres Shil'akversteck",
	["Lower Wilds"] = "Die Untere Wildnis",
	["Lumber Mill"] = "Sägewerk",
	["Lushwater Oasis"] = "Die Blühende Oase",
	["Lydell's Ambush"] = "Lydells Hinterhalt",
	["M.A.C. Diver"] = "M.A.C. Dyver",
	["Maelstrom Deathwing Fight"] = "Kampf mit Todesschwinge am Mahlstrom",
	["Maelstrom Zone"] = "Die Mahlstromzone",
	["Maestra's Post"] = "Maestras Posten",
	["Maexxna's Nest"] = "Maexxnas Nest",
	["Mage Quarter"] = "Magierviertel",
	["Mage Tower"] = "Magierturm",
	["Mag'har Grounds"] = "Grund der Mag'har",
	["Mag'hari Procession"] = "Mag'harische Prozession",
	["Mag'har Post"] = "Posten der Mag'har",
	["Magical Menagerie"] = "Magische Menagerie",
	["Magic Quarter"] = "Magieviertel",
	["Magisters Gate"] = "Magistertor",
	["Magister's Terrace"] = "Terrasse der Magister",
	["Magisters' Terrace"] = "Terrasse der Magister",
	["Magisters' Terrace Entrance"] = "Eingang zur Terrasse der Magister",
	["Magmadar Cavern"] = "Magmadarhöhle",
	["Magma Fields"] = "Magmafelder",
	["Magma Springs"] = "Die Magmaquellen",
	["Magmaw's Fissure"] = "Magmauls Kluft",
	Magmoth = "Magmut",
	["Magnamoth Caverns"] = "Magnamuthöhlen",
	["Magram Territory"] = "Territorium der Magram",
	["Magtheridon's Lair"] = "Magtheridons Kammer",
	["Magus Commerce Exchange"] = "Handelsmarkt der Magier",
	["Main Chamber"] = "Hauptkammer",
	["Main Gate"] = "Haupttor",
	["Main Hall"] = "Haupthalle",
	["Maker's Ascent"] = "Aufstieg des Schöpfers",
	["Maker's Overlook"] = "Warte des Schöpfers",
	["Maker's Overlook "] = "Warte des Schöpfers",
	["Makers' Overlook"] = "Warte der Schöpfer",
	["Maker's Perch"] = "Hort der Schöpfer",
	["Makers' Perch"] = "Hort der Schöpfer",
	["Malaka'jin"] = "Malaka'jin",
	["Malden's Orchard"] = "Maldens Obsthain",
	Maldraz = "Maldraz",
	["Malfurion's Breach"] = "Malfurions Bresche",
	["Malicia's Outpost"] = "Malicias Außenposten",
	["Malykriss: The Vile Hold"] = "Malykriss: Die Unheilvolle Festung",
	["Mama's Pantry"] = "Mamas Speisekammer",
	["Mam'toth Crater"] = "Krater Mam'toth",
	["Manaforge Ara"] = "Manaschmiede Ara",
	["Manaforge B'naar"] = "Manaschmiede B'naar",
	["Manaforge Coruu"] = "Manaschmiede Coruu",
	["Manaforge Duro"] = "Manaschmiede Duro",
	["Manaforge Ultris"] = "Manaschmiede Ultris",
	["Mana Tombs"] = "Managruft",
	["Mana-Tombs"] = "Managruft",
	["Mandokir's Domain"] = "Mandokirs Reich",
	["Mandori Village"] = "Mandori",
	["Mannoroc Coven"] = "Zirkel der Mannoroc",
	["Manor Mistmantle"] = "Anwesen der Dunstmantels",
	["Mantle Rock"] = "Mantelfels",
	["Map Chamber"] = "Kartenkammer",
	["Mar'at"] = "Mar'at",
	Maraudon = "Maraudon",
	["Maraudon - Earth Song Falls Entrance"] = "Maraudon - Eingang zu den Fällen des Irdenen Gesangs",
	["Maraudon - Foulspore Cavern Entrance"] = "Maraudon - Eingang zur Faulsporenhöhle",
	["Maraudon - The Wicked Grotto Entrance"] = "Maraudon - Eingang zur Tückischen Grotte",
	["Mardenholde Keep"] = "Burg Mardenholde",
	Marista = "Marista",
	["Marista's Bait & Brew"] = "Maristas Köder & Kulinarisches",
	["Market Row"] = "Marktgasse",
	["Marshal's Refuge"] = "Marschalls Zuflucht",
	["Marshal's Stand"] = "Marschalls Wehr",
	["Marshlight Lake"] = "Sumpflichtsee",
	["Marshtide Watch"] = "Sumpftidenwacht",
	["Maruadon - The Wicked Grotto Entrance"] = "Maraudon - Eingang zur Tückischen Grotte",
	["Mason's Folly"] = "Des Steinmetz' Torheit",
	["Masters' Gate"] = "Tor der Meister",
	["Master's Terrace"] = "Terrasse des Meisters",
	["Mast Room"] = "Mastraum",
	["Maw of Destruction"] = "Schlund der Zerstörung",
	["Maw of Go'rath"] = "Schlund des Go'rath",
	["Maw of Lycanthoth"] = "Schlund von Lycanthoth",
	["Maw of Neltharion"] = "Neltharions Schlund",
	["Maw of Shu'ma"] = "Schlund des Shu'ma",
	["Maw of the Void"] = "Maul der Leere",
	["Mazra'Alor"] = "Mazra'Alor",
	Mazthoril = "Mazthoril",
	["Mazu's Overlook"] = "Mazus Ausblick",
	["Medivh's Chambers"] = "Medivhs Gemächer",
	["Menagerie Wreckage"] = "Menagerietrümmer",
	["Menethil Bay"] = "Bucht von Menethil",
	["Menethil Harbor"] = "Hafen von Menethil",
	["Menethil Keep"] = "Burg Menethil",
	["Merchant Square"] = "Händlerplatz",
	Middenvale = "Trümmerfall",
	["Mid Point Station"] = "Zentralstation",
	["Midrealm Post"] = "Mittelreichposten",
	["Midwall Lift"] = "Aufzug am Hauptwall",
	["Mightstone Quarry"] = "Großfelsbruch",
	["Military District"] = "Militärviertel",
	["Mimir's Workshop"] = "Mimirs Werkstatt",
	Mine = "Mine",
	Mines = "Minen",
	["Mirage Abyss"] = "Illusionenschlund",
	["Mirage Flats"] = "Illusionenebene",
	["Mirage Raceway"] = "Illusionenrennbahn",
	["Mirkfallon Lake"] = "Mirkfallonsee",
	["Mirkfallon Post"] = "Mirkfallonposten",
	["Mirror Lake"] = "Spiegelsee",
	["Mirror Lake Orchard"] = "Obsthain am Spiegelsee",
	["Mistblade Den"] = "Nebelklingenbau",
	["Mistcaller's Cave"] = "Höhle des Nebelrufers",
	["Mistfall Village"] = "Nebelhauch",
	["Mist's Edge"] = "Nebelrand",
	["Mistvale Valley"] = "Nebeltal",
	["Mistveil Sea"] = "Nebelschleiersee",
	["Mistwhisper Refuge"] = "Zuflucht der Nebelflüsterer",
	["Misty Pine Refuge"] = "Nebelfichtenzuflucht",
	["Misty Reed Post"] = "Nebelschilfposten",
	["Misty Reed Strand"] = "Nebelschilfstrand",
	["Misty Ridge"] = "Nebelpass",
	["Misty Shore"] = "Nebelufer",
	["Misty Shores"] = "Nebelküste",
	["Misty Valley"] = "Das Neblige Tal",
	["Miwana's Longhouse"] = "Miwanas Langhaus",
	["Mizjah Ruins"] = "Ruinen von Mizjah",
	["Moa'ki"] = "Moa'ki",
	["Moa'ki Harbor"] = "Hafen Moa'ki",
	["Moggle Point"] = "Moggelspitze",
	["Mo'grosh Stronghold"] = "Festung Mo'grosh",
	["Mogu Island Daily Area"] = "Mogu Island Daily Area",
	["Mogu Island Events - Alliance Base"] = "Moguinselereignisse - Allianzbasis",
	["Mogu Island Events - Horde Base"] = "Moguinselereignisse - Hordebasis",
	["Mogu Island Loot Room"] = "Die Prall Gefüllte Kammer",
	["Mogu Island Progression Events"] = "Moguinselfortschrittsereignisse",
	Mogujia = "Mogujia",
	["Mogu'shan Palace"] = "Mogu'shanpalast",
	["Mogu'shan Terrace"] = "Mogu'shanterrasse",
	["Mogu'shan Vaults"] = "Mogu'shangewölbe",
	["Mok'Doom"] = "Mok'Doom",
	["Mok'Gordun"] = "Mok'Gordun",
	["Mok'Nathal Village"] = "Dorf der Mok'Nathal",
	["Mold Foundry"] = "Formgießerei",
	["Molten Core"] = "Geschmolzener Kern",
	["Molten Front"] = "Geschmolzene Front",
	Moonbrook = "Mondbruch",
	Moonglade = "Mondlichtung",
	["Moongraze Woods"] = "Mondweidenwald",
	["Moon Horror Den"] = "Mondschreckensbau",
	["Moonrest Gardens"] = "Mondruhgärten",
	["Moonshrine Ruins"] = "Mondschreinruine",
	["Moonshrine Sanctum"] = "Mondschreinsanktum",
	["Moontouched Den"] = "Mondbestrahlter Bau",
	["Moonwater Retreat"] = "Mondwasserzuflucht",
	["Moonwell of Cleansing"] = "Mondbrunnen der Läuterung",
	["Moonwell of Purity"] = "Mondbrunnen der Reinheit",
	["Moonwing Den"] = "Mondschwingenbau",
	["Mord'rethar: The Death Gate"] = "Mord'rethar: Das Tor des Todes",
	["Morgan's Plot"] = "Morgans Grund",
	["Morgan's Vigil"] = "Morgans Wacht",
	["Morlos'Aran"] = "Morlos'Aran",
	["Morning Breeze Lake"] = "Morgenhauchsee",
	["Morning Breeze Village"] = "Morgenhauch",
	Morrowchamber = "Morgenkammer",
	["Mor'shan Base Camp"] = "Stützpunkt Mor'shan",
	["Mortal's Demise"] = "Untergang des Sterblichen",
	["Mortbreath Grotto"] = "Todesrachengrotte",
	["Mortwake's Tower"] = "Jagdrufs Turm",
	["Mosh'Ogg Ogre Mound"] = "Ogerhügel der Mosh'Ogg",
	["Mosshide Fen"] = "Moosfellmoor",
	["Mosswalker Village"] = "Mooswandlerdorf",
	["Mossy Pile"] = "Mooshügel",
	["Motherseed Pit"] = "Muttersaatgrube",
	["Mountainfoot Strip Mine"] = "Tagebau am Gebirgsfuß",
	["Mount Akher"] = "Der Berg Akher",
	["Mount Hyjal"] = "Hyjal",
	["Mount Hyjal Phase 1"] = "Hyjal",
	["Mount Neverest"] = "Der Nimmerlaya",
	["Muckscale Grotto"] = "Grotte der Schlickschuppen",
	["Muckscale Shallows"] = "Untiefe der Schlickschuppen",
	["Mudmug's Place"] = "Trübtrunks Schenke",
	Mudsprocket = "Morastwinkel",
	Mulgore = "Mulgore",
	["Murder Row"] = "Mördergasse",
	["Murkdeep Cavern"] = "Finstergrundhöhle",
	["Murky Bank"] = "Düsterbank",
	["Muskpaw Ranch"] = "Gehöft Moschuspranke",
	["Mystral Lake"] = "Mystralsee",
	Mystwood = "Mythoswald",
	Nagrand = "Nagrand",
	["Nagrand Arena"] = "Arena von Nagrand",
	Nahom = "Nahom",
	["Nar'shola Terrace"] = "Terrasse von Nar'shola",
	["Narsong Spires"] = "Narsongtürme",
	["Narsong Trench"] = "Narsonggraben",
	["Narvir's Cradle"] = "Narvirs Wiege",
	["Nasam's Talon"] = "Nasams Klaue",
	["Nat's Landing"] = "Nats Angelplatz",
	["Naval Battle Scenario"] = "Szenario: Seeschlacht",
	Naxxanar = "Naxxanar",
	Naxxramas = "Naxxramas",
	["Nayeli Lagoon"] = "Nayelilagune",
	["Naz'anak: The Forgotten Depths"] = "Naz'anak: Die Vergessenen Tiefen",
	["Nazj'vel"] = "Nazj'vel",
	Nazzivian = "Nazzivian",
	["Nectarbreeze Orchard"] = "Obstgarten Nektarhauch",
	["Needlerock Chasm"] = "Nadelfelsschlucht",
	["Needlerock Slag"] = "Nadelfelsbruch",
	["Nefarian's Lair"] = "Nefarians Unterschlupf",
	["Nefarian�s Lair"] = "Nefarians Unterschlupf",
	["Neferset City"] = "Neferset",
	["Neferset City Outskirts"] = "Außenbezirke von Neferset",
	["Nek'mani Wellspring"] = "Nek'maniquellbrunnen",
	["Neptulon's Rise"] = "Neptulons Erhebung",
	["Nesingwary Base Camp"] = "Nesingwarys Basislager",
	["Nesingwary Safari"] = "Nesingwarys Safari",
	["Nesingwary's Expedition"] = "Nesingwarys Expedition",
	["Nesingwary's Safari"] = "Nesingwarys Safari",
	Nespirah = "Nespirah",
	["Nestlewood Hills"] = "Nistelhügel",
	["Nestlewood Thicket"] = "Nisteldickicht",
	["Nethander Stead"] = "Nethandersiedlung",
	["Nethergarde Keep"] = "Burg Nethergarde",
	["Nethergarde Mines"] = "Mine von Nethergarde",
	["Nethergarde Supply Camps"] = "Versorgungslager von Nethergarde",
	Netherspace = "Netherraum",
	Netherstone = "Netherstein",
	Netherstorm = "Nethersturm",
	["Netherweb Ridge"] = "Netherweberkamm",
	["Netherwing Fields"] = "Netherschwingenfelder",
	["Netherwing Ledge"] = "Netherschwingenscherbe",
	["Netherwing Mines"] = "Netherschwingenminen",
	["Netherwing Pass"] = "Netherschwingenpass",
	["Neverest Basecamp"] = "Basislager am Nimmerlaya",
	["Neverest Pinnacle"] = "Gipfel des Nimmerlaya",
	["New Agamand"] = "Neu-Agamand",
	["New Agamand Inn"] = "Gasthaus von Neu-Agamand",
	["New Avalon"] = "Neu-Avalon",
	["New Avalon Fields"] = "Felder von Neu-Avalon",
	["New Avalon Forge"] = "Schmiede von Neu-Avalon",
	["New Avalon Orchard"] = "Obsthain von Neu-Avalon",
	["New Avalon Town Hall"] = "Rathaus von Neu-Avalon",
	["New Cifera"] = "Neu-Cifera",
	["New Hearthglen"] = "Neuherdweiler",
	["New Kargath"] = "Neu-Kargath",
	["New Thalanaar"] = "Neu-Thalanaar",
	["New Tinkertown"] = "Neu-Tüftlerstadt",
	["Nexus Legendary"] = "Der Nexus (Legendäre Waffe)",
	Nidavelir = "Nidavelir",
	["Nidvar Stair"] = "Nidvarstieg",
	Nifflevar = "Niffelvar",
	["Night Elf Village"] = "Nachtelfendorf",
	Nighthaven = "Nachthafen",
	["Nightingale Lounge"] = "Die Nachtigalllounge",
	["Nightmare Depths"] = "Die Alptraumtiefen",
	["Nightmare Scar"] = "Die Alptraumnarbe",
	["Nightmare Vale"] = "Alptraumtal",
	["Night Run"] = "Nachtflucht",
	["Nightsong Woods"] = "Nachtweisenwald",
	["Night Web's Hollow"] = "Nachtwebergrund",
	["Nijel's Point"] = "Die Nijelspitze",
	["Nimbus Rise"] = "Nimbusanhöhe",
	Nine = "Nine",
	["Niuzao Catacombs"] = "Niuzaokatakomben",
	["Niuzao Temple"] = "Niuzaotempel",
	["Njord's Breath Bay"] = "Bucht des Njordatems",
	["Njorndar Village"] = "Njorndar",
	["Njorn Stair"] = "Njornstieg",
	["Nook of Konk"] = "Konkwinkel",
	["Noonshade Ruins"] = "Tagschattenruinen",
	Nordrassil = "Nordrassil",
	["Nordrassil Inn"] = "Gasthaus zu Nordrassil",
	["Nordune Ridge"] = "Nordunegrat",
	["North Common Hall"] = "Nördliche Bankenhalle",
	Northdale = "Nordtal",
	["Northern Barrens"] = "Nördliches Brachland",
	["Northern Elwynn Mountains"] = "Nördliches Elwynngebirge",
	["Northern Headlands"] = "Die Nordmark",
	["Northern Rampart"] = "Nördliches Bollwerk",
	["Northern Rocketway"] = "Nördliche Raketenbahn",
	["Northern Rocketway Exchange"] = "Nördlicher Umschlagplatz der Raketenbahn",
	["Northern Stranglethorn"] = "Nördliches Schlingendorntal",
	["Northfold Manor"] = "Nordhof",
	["Northgate Breach"] = "Nordtorbresche",
	["North Gate Outpost"] = "Nordtoraußenposten",
	["North Gate Pass"] = "Nordtorpass",
	["Northgate River"] = "Nordtorfluss",
	["Northgate Woods"] = "Nordtorwald",
	["Northmaul Tower"] = "Nordschlägerturm",
	["Northpass Tower"] = "Nordpassturm",
	["North Point Station"] = "Nordstation",
	["North Point Tower"] = "Nordwacht",
	Northrend = "Nordend",
	["Northridge Lumber Camp"] = "Sägewerk des Nordkamms",
	["North Sanctum"] = "Sanktum des Nordens",
	Northshire = "Nordhain",
	["Northshire Abbey"] = "Abtei von Nordhain",
	["Northshire River"] = "Nordhainfluss",
	["Northshire Valley"] = "Nordhaintal",
	["Northshire Vineyards"] = "Weingut von Nordhain",
	["North Spear Tower"] = "Nordspeerturm",
	["North Tide's Beachhead"] = "Nördliche Gezeitenbucht",
	["North Tide's Run"] = "Nördlicher Gezeitenstrom",
	["Northwatch Expedition Base Camp"] = "Basislager der Nordwachtexpedition",
	["Northwatch Expedition Base Camp Inn"] = "Gasthaus der Nordwachtexpedition",
	["Northwatch Foothold"] = "Vorposten der Nordwacht",
	["Northwatch Hold"] = "Die Feste Nordwacht",
	["Northwind Cleft"] = "Nordwindkluft",
	["North Wind Tavern"] = "Taverne des Nordwinds",
	["Nozzlepot's Outpost"] = "Düsentopfs Außenposten",
	["Nozzlerust Post"] = "Düsenrostposten",
	["Oasis of the Fallen Prophet"] = "Oase des Gefallenen Propheten",
	["Oasis of Vir'sar"] = "Oase Vir'sar",
	["Obelisk of the Moon"] = "Obelisk des Mondes",
	["Obelisk of the Stars"] = "Obelisk der Sterne",
	["Obelisk of the Sun"] = "Obelisk der Sonne",
	["O'Breen's Camp"] = "O'Breens Lager",
	["Observance Hall"] = "Beobachtungshalle",
	["Observation Grounds"] = "Beobachtungsplatz",
	["Obsidian Breakers"] = "Obsidianbrecher",
	["Obsidian Dragonshrine"] = "Obsidiandrachenschrein",
	["Obsidian Forest"] = "Obsidianwald",
	["Obsidian Lair"] = "Obsidianhort",
	["Obsidia's Perch"] = "Obsidias Hort",
	["Odesyus' Landing"] = "Odesyus' Ankerplatz",
	["Ogri'la"] = "Ogri'la",
	["Ogri'La"] = "Ogri'La",
	["Old Hillsbrad Foothills"] = "Vorgebirge des Alten Hügellands",
	["Old Ironforge"] = "Altstadt von Eisenschmiede",
	["Old Town"] = "Altstadt",
	Olembas = "Olembas",
	["Olivia's Pond"] = "Olivias Teich",
	["Olsen's Farthing"] = "Olsens Acker",
	Oneiros = "Oneiros",
	["One Keg"] = "Einfass",
	["One More Glass"] = "Noch ein Gläschen",
	["Onslaught Base Camp"] = "Basislager des Ansturms",
	["Onslaught Harbor"] = "Hafen des Ansturms",
	["Onyxia's Lair"] = "Onyxias Hort",
	["Oomlot Village"] = "Oomlot",
	["Oona Kagu"] = "Uuna Kagu",
	Oostan = "Oostan",
	["Oostan Nord"] = "Oostan-Nord",
	["Oostan Ost"] = "Oostan-Ost",
	["Oostan Sor"] = "Oostan-Sor",
	["Opening of the Dark Portal"] = "Öffnung des Dunklen Portals",
	["Opening of the Dark Portal Entrance"] = "Eingang zur Öffnung des Dunklen Portals",
	["Oratorium of the Voice"] = "Oratorium der Stimme",
	["Oratory of the Damned"] = "Oratorium der Verdammten",
	["Orchid Hollow"] = "Orchideenwinkel",
	["Orebor Harborage"] = "Oreborzuflucht",
	["Oregrind's Dig"] = "Erzschleifs Grabung",
	["Orendil's Retreat"] = "Orendils Zuflucht",
	Orgrimmar = "Orgrimmar",
	["Orgrimmar Gunship Pandaria Start"] = "Luftschiff aus Orgrimmar Pandaria Start",
	["Orgrimmar Rear Gate"] = "Hinteres Tor von Orgrimmar",
	["Orgrimmar Rocketway Exchange"] = "Umschlagplatz der Raketenbahn von Orgrimmar",
	["Orgrim's Hammer"] = "Orgrims Hammer",
	["Oronok's Farm"] = "Oronoks Hof",
	Orsis = "Orsis",
	["Ortell's Hideout"] = "Ortells Unterschlupf",
	["Oshu'gun"] = "Oshu'gun",
	["Outdoor Ruins"] = "Äußere Ruinen",
	Outland = "Scherbenwelt",
	["Overgrown Camp"] = "Überwachsenes Lager",
	["Overgrown Statuary"] = "Überwucherter Statuenhof",
	["Owen's Wishing Well"] = "Owens Wunschbrunnen",
	["Owl Wing Thicket"] = "Eulenflügeldickicht",
	["Palace Antechamber"] = "Vorkammer des Palasts",
	["Pal'ea"] = "Pal'ea",
	["Palemane Rock"] = "Bleichmähnenfels",
	["Pandaren Mine"] = "Pandarenmine",
	Pandaria = "Pandaria",
	["Pang's Stead"] = "Pangs Hof",
	["Panic Clutch"] = "Das Nest der Panik",
	["Paoquan Hollow"] = "Paoquansenke",
	["Parhelion Plaza"] = "Parhelionplaza",
	["Passage of Lost Fiends"] = "Pass der Verlorenen Geister",
	["Path of a Hundred Steps"] = "Pfad der hundert Stufen",
	["Path of Conquerors"] = "Der Pfad der Eroberer",
	["Path of Enlightenment"] = "Pfad der Erleuchtung",
	["Path of Serenity"] = "Der Pfad des Gleichmuts",
	["Path of the Titans"] = "Pfad der Titanen",
	["Path of Uther"] = "Pfad Uthers",
	["Pattymack Land"] = "Pattymack-Land",
	["Pauper's Walk"] = "Bettlergasse",
	["Paur's Pub"] = "Paurs Pinte",
	["Paw'don Glade"] = "Hain von Pel'zin",
	["Paw'don Village"] = "Pel'zin",
	["Paw'Don Village"] = "Pel'zin", -- Needs review
	["Peak of Serenity"] = "Gipfel der Ruhe",
	["Pearlfin Village"] = "Dorf der Perlflossen",
	["Pearl Lake"] = "Perlsee",
	["Pedestal of Hope"] = "Podest der Hoffnung",
	["Pei-Wu Forest"] = "Pei-Wu-Wald",
	["Pestilent Scar"] = "Pestilenznarbe",
	["Pet Battle - Jade Forest"] = "Haustierkampf - Jadewald",
	["Petitioner's Chamber"] = "Bittstellerraum",
	["Pilgrim's Precipice"] = "Pilgerklippe",
	["Pincer X2"] = "Zange X2",
	["Pinnacle of Storms"] = "Die Spitze der Stürme",
	["Pit of Fangs"] = "Fangzahngrube",
	["Pit of Saron"] = "Grube von Saron",
	["Pit of Saron Entrance"] = "Eingang zur Grube von Saron",
	["Plaguelands: The Scarlet Enclave"] = "Pestländer: Die Scharlachrote Enklave",
	["Plaguemist Ravine"] = "Seuchennebelklamm",
	Plaguewood = "Der Pestwald",
	["Plaguewood Tower"] = "Pestwaldturm",
	["Plain of Echoes"] = "Ebene der Echos",
	["Plain of Shards"] = "Splitterebene",
	["Plain of Thieves"] = "Ebene der Diebe",
	["Plains of Nasam"] = "Ebene von Nasam",
	["Pod Cluster"] = "Kapselteil",
	["Pod Wreckage"] = "Kapselwrack",
	["Poison Falls"] = "Giftfälle",
	["Pool of Reflection"] = "Teich der Reflexion",
	["Pool of Tears"] = "Tränenteich",
	["Pool of the Paw"] = "Teich der Pfote",
	["Pool of Twisted Reflections"] = "Teich der Entstellten Spiegelungen",
	["Pools of Aggonar"] = "Teiche von Aggonar",
	["Pools of Arlithrien"] = "Teiche von Arlithrien",
	["Pools of Jin'Alai"] = "Teiche von Jin'Alai",
	["Pools of Purity"] = "Teiche der Reinheit",
	["Pools of Youth"] = "Teiche der Jugend",
	["Pools of Zha'Jin"] = "Teiche von Zha'Jin",
	["Portal Clearing"] = "Portalsicherung",
	["Pranksters' Hollow"] = "Witzboldwinkel",
	["Predator's Perch"] = "Die Lauerstellung",
	["Prison of Immol'thar"] = "Das Gefängnis von Immol'thar",
	["Programmer Isle"] = "Programmierer-Insel",
	["Promontory Point"] = "Das Kap",
	["Prospector's Point"] = "Prospektorat",
	["Protectorate Watch Post"] = "Wachposten des Protektorats",
	["Proving Grounds"] = "Feuerprobe",
	["Purespring Cavern"] = "Reinquellhöhle",
	["Purgation Isle"] = "Fegefeuerinsel",
	["Pursuing the Black Harvest"] = "Jagd auf die Schwarze Ernte",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Seuchenmords Laboratorium der Alchemistischen Schrecken und Späße",
	["Pyrewood Chapel"] = "Kapelle von Lohenscheit",
	["Pyrewood Inn"] = "Gasthaus von Lohenscheit",
	["Pyrewood Town Hall"] = "Rathaus von Lohenscheit",
	["Pyrewood Village"] = "Lohenscheit",
	["Pyrox Flats"] = "Pyroxebenen",
	["QA and DVD"] = "QA und DVD",
	["Quagg Ridge"] = "Quaggkamm",
	Quarry = "Steinbruch",
	["Quartzite Basin"] = "Quarzitbecken",
	["Queen's Gate"] = "Königinnentor",
	["Quel'Danil Lodge"] = "Jagdhütte Quel'Danil",
	["Quel'Delar's Rest"] = "Quel'Delars Ruh",
	["Quel'Dormir Gardens"] = "Gärten von Quel'Dormir",
	["Quel'Dormir Temple"] = "Tempel von Quel'Dormir",
	["Quel'Dormir Terrace"] = "Terrasse von Quel'Dormir",
	["Quel'Lithien Lodge"] = "Jagdhütte Quel'Lithien",
	["Quel'thalas"] = "Quel'Thalas",
	["Quickchop's Lumber Farm"] = "Blitzbeils Holzhof",
	["Raastok Glade"] = "Raastokgrund",
	["Raceway Ruins"] = "Rennbahnruinen",
	["Rageclaw Den"] = "Zornklauenbau",
	["Rageclaw Lake"] = "Zornklauensee",
	["Rage Fang Shrine"] = "Schrein des Grollfangs",
	["Ragefeather Ridge"] = "Rachfederkamm",
	["Ragefire Caverns"] = "Höhlen des Flammenschlunds",
	["Ragefire Chasm"] = "Der Flammenschlund",
	["Ragefire Core"] = "Kern des Flammenschlunds",
	["Rage Scar Hold"] = "Wutschrammfeste",
	["Ragnaros' Lair"] = "Ragnaros' Unterschlupf",
	["Ragnaros' Reach"] = "Ragnaros' Ebenen",
	["Rainspeaker Canopy"] = "Baldachin der Regenrufer",
	["Rainspeaker Rapids"] = "Katarakt der Regenrufer",
	Ramkahen = "Ramkahen",
	["Ramkahen Legion Outpost"] = "Außenposten der Legion von Ramkahen",
	["Rampart of Skulls"] = "Das Schädelbollwerk",
	["Ranazjar Isle"] = "Die Insel Ranazjar",
	["Raptor Pens"] = "Raptorenställe",
	["Raptor Ridge"] = "Raptorgrat",
	["Raptor Rise"] = "Raptorenbuckel",
	Ratchet = "Ratschet",
	["Rated Eye of the Storm"] = "Gewertetes Auge des Sturms",
	["Ravaged Caravan"] = "Überfallene Karawane",
	["Ravaged Crypt"] = "Verwüstete Krypta",
	["Ravaged Twilight Camp"] = "Verwüsteter Stützpunkt des Schattenhammers",
	["Ravencrest Monument"] = "Rabenkrones Monument",
	["Raven Hill"] = "Rabenflucht",
	["Raven Hill Cemetery"] = "Friedhof von Rabenflucht",
	["Ravenholdt Manor"] = "Rabenholdtanwesen",
	["Raven's Watch"] = "Rabenwacht",
	["Raven's Wood"] = "Rabenwald",
	["Raynewood Retreat"] = "Rajenbaum",
	["Raynewood Tower"] = "Rajenbaumturm",
	["Razaan's Landing"] = "Razaans Landeplatz",
	["Razorfen Downs"] = "Hügel der Klingenhauer",
	["Razorfen Downs Entrance"] = "Eingang zum Hügeln der Klingenhauer",
	["Razorfen Kraul"] = "Kral der Klingenhauer",
	["Razorfen Kraul Entrance"] = "Eingang zum Kral der Klingenhauer",
	["Razor Hill"] = "Klingenhügel",
	["Razor Hill Barracks"] = "Kaserne von Klingenhügel",
	["Razor Hill Outskirts"] = "Umland von Klingenhügel",
	["Razor Hill Watchtower"] = "Wachturm von Klingenhügel",
	["Razormane Grounds"] = "Revier der Klingenmähnen",
	["Razor Ridge"] = "Messergrat",
	["Razorscale's Aerie"] = "Klingenschuppes Kanzel",
	["Razorthorn Rise"] = "Messerdornhöhe",
	["Razorthorn Shelf"] = "Messerdornbank",
	["Razorthorn Trail"] = "Messerdornpfad",
	["Razorwind Canyon"] = "Klingenschlucht",
	["Rear Staging Area"] = "Hinterer Aufmarschplatz",
	["Reaver's Fall"] = "Häschersturz",
	["Reavers' Hall"] = "Halle der Häscher",
	["Rebel Camp"] = "Rebellenlager",
	["Red Cloud Mesa"] = "Hochwolkenebene",
	["Redpine Dell"] = "Rotkiefersenke",
	["Redridge - Bridge Phase One"] = "Redridge - Bridge Phase One",
	["Redridge - Bridge Phase Two"] = "Redridge - Bridge Phase Two",
	["Redridge Canyons"] = "Rotkammschlucht",
	["Redridge Mountains"] = "Rotkammgebirge",
	["Redridge - Orc Bomb"] = "Redridge - Orc Bomb",
	["Red Rocks"] = "Teufelsfelsen",
	["Redwood Trading Post"] = "Handelsposten von Rotholz",
	Refinery = "Raffinerie",
	["Refugee Caravan"] = "Flüchtlingskarawane",
	["Refuge Pointe"] = "Die Zuflucht",
	["Refuse Disposal"] = "Unratdeponie",
	["Reliquary of Agony"] = "Reliquie der Pein",
	["Reliquary of Pain"] = "Reliquiar des Schmerzes",
	["Remains of Iris Lake"] = "Überreste des Irissees",
	["Remains of the Fleet"] = "Überreste der Flotte",
	["Remtravel's Excavation"] = "Wirrbarts Ausgrabung",
	["Render's Camp"] = "Renders Lager",
	["Render's Crater"] = "Renders Krater",
	["Render's Rock"] = "Renders Fels",
	["Render's Valley"] = "Renders Tal",
	["Rensai's Watchpost"] = "Rensais Wachposten",
	["Rethban Caverns"] = "Rethbanhöhlen",
	["Rethress Sanctum"] = "Rethress' Sanktum",
	Reuse = "Reuse",
	["Reuse Me 7"] = "Reuse Me 7",
	["Revantusk Village"] = "Dorf der Bruchhauer",
	["Rhea's Camp"] = "Rheas Lager",
	["Rhonin's Beard"] = "Rhonins Bart",
	["Rhyolith Plateau"] = "Rhyolithplateau",
	["Ricket's Folly"] = "Rickets Torheit",
	["Ridge of Laughing Winds"] = "Grat der Lachenden Winde",
	["Ridge of Madness"] = "Grat des Wahnsinns",
	["Ridgepoint Tower"] = "Kammwacht",
	Rikkilea = "Rikkilea",
	["Rikkitun Village"] = "Rikkitun",
	["Rim of the World"] = "Rand der Welt",
	["Ring of Judgement"] = "Ring des Richturteils",
	["Ring of Observance"] = "Ring der Beobachtung",
	["Ring of the Elements"] = "Ring der Elemente",
	["Ring of the Law"] = "Ring des Gesetzes",
	["Riplash Ruins"] = "Ruinen der Peitschennarbe",
	["Riplash Strand"] = "Strand der Peitschennarbe",
	["Rise of Suffering"] = "Anhöhe des Leidens",
	["Rise of the Defiler"] = "Anhöhe des Entweihers",
	["Ritual Chamber of Akali"] = "Ritualkammer von Akali",
	["Rivendark's Perch"] = "Nachtreißers Hort",
	Rivenwood = "Bruchwald",
	["River's Heart"] = "Flussnabel",
	["Rock of Durotan"] = "Fels von Durotan",
	["Rockpool Village"] = "Steinteich",
	["Rocktusk Farm"] = "Felshauerhof",
	["Roguefeather Den"] = "Bau der Wildfedern",
	["Rogues' Quarter"] = "Schurkenviertel",
	["Rohemdal Pass"] = "Rohemdalpass",
	["Roland's Doom"] = "Rolands Verdammnis",
	["Room of Hidden Secrets"] = "Raum der Versteckten Geheimnisse",
	["Roost of Ji-Kun"] = "Horst von Ji-Kun",
	["Rotbrain Encampment"] = "Lager der Moderhirne",
	["Royal Amphitheater"] = "Das Königliche Amphitheater",
	["Royal Approach"] = "Königlicher Aufgang",
	["Royal Exchange Auction House"] = "Auktionshaus des Königlichen Markts",
	["Royal Exchange Bank"] = "Bank des Königlichen Markts",
	["Royal Gallery"] = "Königliche Galerie",
	["Royal Library"] = "Königliche Bibliothek",
	["Royal Quarter"] = "Königsviertel",
	["Ruby Dragonshrine"] = "Rubindrachenschrein",
	["Ruined Approach"] = "Der Zerschlagene Vorstoß",
	["Ruined City Post 01"] = "Ruinenstadt 01",
	["Ruined Court"] = "Verfallener Gerichtssaal",
	["Ruins of Aboraz"] = "Ruinen von Aboraz",
	["Ruins of Ahmtul"] = "Ruinen von Ahmtul",
	["Ruins of Ahn'Qiraj"] = "Ruinen von Ahn'Qiraj",
	["Ruins of Alterac"] = "Die Ruinen von Alterac",
	["Ruins of Ammon"] = "Ruinen von Ammon",
	["Ruins of Arkkoran"] = "Ruinen von Arkkoran",
	["Ruins of Auberdine"] = "Ruinen von Auberdine",
	["Ruins of Baa'ri"] = "Ruinen von Baa'ri",
	["Ruins of Constellas"] = "Ruinen von Constellas",
	["Ruins of Dojan"] = "Ruinen von Dojan",
	["Ruins of Drakgor"] = "Ruinen von Drakgor",
	["Ruins of Drak'Zin"] = "Ruinen von Drak'Zin",
	["Ruins of Eldarath"] = "Ruinen von Eldarath",
	["Ruins of Eldarath "] = "Ruinen von Eldarath",
	["Ruins of Eldra'nath"] = "Ruinen von Eldra'nath",
	["Ruins of Eldre'thar"] = "Ruinen von Eldre'thar",
	["Ruins of Enkaat"] = "Ruinen von Enkaat",
	["Ruins of Farahlon"] = "Ruinen von Farahlon",
	["Ruins of Feathermoon"] = "Ruinen der Mondfederfeste",
	["Ruins of Gilneas"] = "Ruinen von Gilneas",
	["Ruins of Gilneas City"] = "Ruinen von Gilneas",
	["Ruins of Guo-Lai"] = "Guo-Lai-Ruinen",
	["Ruins of Isildien"] = "Ruinen von Isildien",
	["Ruins of Jubuwal"] = "Ruinen von Jubuwal",
	["Ruins of Karabor"] = "Ruinen von Karabor",
	["Ruins of Kargath"] = "Ruinen von Kargath",
	["Ruins of Khintaset"] = "Ruinen von Khintaset",
	["Ruins of Korja"] = "Ruinen von Korja",
	["Ruins of Korune"] = "Ruinen von Korun",
	["Ruins of Lar'donir"] = "Ruinen von Lar'donir",
	["Ruins of Lordaeron"] = "Ruinen von Lordaeron",
	["Ruins of Loreth'Aran"] = "Ruinen von Loreth'Aran",
	["Ruins of Lornesta"] = "Ruinen von Lornesta",
	["Ruins of Mathystra"] = "Ruinen von Mathystra",
	["Ruins of Nordressa"] = "Ruinen von Nordressa",
	["Ruins of Ogudei"] = "Ruinen von Ogudei",
	["Ruins of Ravenwind"] = "Ruinen von Rabenwind",
	["Ruins of Sha'naar"] = "Ruinen von Sha'naar",
	["Ruins of Shandaral"] = "Ruinen von Shandaral",
	["Ruins of Silvermoon"] = "Ruinen von Silbermond",
	["Ruins of Solarsal"] = "Ruinen von Solarsal",
	["Ruins of Southshore"] = "Ruinen von Süderstade",
	["Ruins of Taurajo"] = "Überreste von Camp Taurajo",
	["Ruins of Tethys"] = "Ruinen von Tethys",
	["Ruins of Thaurissan"] = "Die Ruinen von Thaurissan",
	["Ruins of Thelserai Temple"] = "Ruinen des Thelseraitempels",
	["Ruins of Theramore"] = "Die Ruinen von Theramore",
	["Ruins of the Scarlet Enclave"] = "Ruinen der Scharlachroten Enklave",
	["Ruins of Uldum"] = "Ruinen von Uldum",
	["Ruins of Vashj'elan"] = "Ruinen von Vashj'elan",
	["Ruins of Vashj'ir"] = "Ruinen von Vashj'ir",
	["Ruins of Zul'Kunda"] = "Ruinen von Zul'Kunda",
	["Ruins of Zul'Mamwe"] = "Ruinen von Zul'Mamwe",
	["Ruins Rise"] = "Ruinenberg",
	["Rumbling Terrace"] = "Polternde Terrasse",
	["Runestone Falithas"] = "Runenstein Falithas",
	["Runestone Shan'dor"] = "Runenstein Shan'dor",
	["Runeweaver Square"] = "Runenweberplatz",
	["Rustberg Village"] = "Rostberg",
	["Rustmaul Dive Site"] = "Rostnagels Tauchplatz",
	["Rutsak's Guard"] = "Rutaks Wacht",
	["Rut'theran Village"] = "Rut'theran",
	["Ruuan Weald"] = "Ruuanwald",
	["Ruuna's Camp"] = "Ruunas Lager",
	["Ruuzel's Isle"] = "Ruuzels Insel",
	["Rygna's Lair"] = "Rygnas Hort",
	["Sable Ridge"] = "Säbelrücken",
	["Sacrificial Altar"] = "Opferaltar",
	["Sahket Wastes"] = "Sahketwüste",
	Salabria = "Salabria",
	["Saldean's Farm"] = "Saldeans Hof",
	["Saltheril's Haven"] = "Saltherils Hafen",
	["Saltspray Glen"] = "Salzgischtschlucht",
	["Sanctuary of Malorne"] = "Heiligtum von Malorne",
	["Sanctuary of Shadows"] = "Zuflucht der Schatten",
	["Sanctum of Reanimation"] = "Sanktum der Reanimation",
	["Sanctum of Shadows"] = "Sanktum des Schattens",
	["Sanctum of the Ascended"] = "Sanktum der Aszendenten",
	["Sanctum of the Fallen God"] = "Sanktum des Gefallenen Gottes",
	["Sanctum of the Moon"] = "Sanktum des Mondes",
	["Sanctum of the Prophets"] = "Sanktum der Propheten",
	["Sanctum of the South Wind"] = "Sanktum des Südwinds",
	["Sanctum of the Stars"] = "Sanktum der Sterne",
	["Sanctum of the Sun"] = "Sanktum der Sonne",
	["Sands of Nasam"] = "Sande von Nasam",
	["Sandsorrow Watch"] = "Sandmarterwache",
	["Sandy Beach"] = "Der Sandstrand",
	["Sandy Shallows"] = "Sandige Untiefen",
	["Sanguine Chamber"] = "Sanguiskammer",
	["Sapphire Hive"] = "Saphirschwarm",
	["Sapphiron's Lair"] = "Saphirons Hort",
	["Saragosa's Landing"] = "Saragosas Landeplatz",
	Sarahland = "Sarahland",
	["Sardor Isle"] = "Insel Sardor",
	Sargeron = "Sargeron",
	["Sarjun Depths"] = "Sarjuntiefen",
	["Saronite Mines"] = "Saronitminen",
	["Sar'theris Strand"] = "Sar'therisstrand",
	Satyrnaar = "Satyrnaar",
	["Saurok Creation Pit"] = "Die Saurokschöpfungsgrube",
	["Savage Ledge"] = "Wilde Klippe",
	["Scalawag Point"] = "Halunkeneck",
	["Scalding Pools"] = "Siedende Teiche",
	["Scalebeard's Cave"] = "Schuppenbarts Höhle",
	["Scalewing Shelf"] = "Schuppenflügelbank",
	["Scarab Terrace"] = "Skarabäusterrasse",
	["Scarlet Encampment"] = "Scharlachrote Lagerstatt",
	["Scarlet Halls"] = "Scharlachrote Hallen",
	["Scarlet Hold"] = "Scharlachrote Festung",
	["Scarlet Monastery"] = "Das Scharlachrote Kloster",
	["Scarlet Monastery Entrance"] = "Eingang zum Scharlachroten Kloster",
	["Scarlet Overlook"] = "Scharlachroter Rundblick",
	["Scarlet Palisade"] = "Scharlachrote Palisade",
	["Scarlet Point"] = "Scharlachrote Wacht",
	["Scarlet Raven Tavern"] = "Taverne Zum Roten Raben",
	["Scarlet Tavern"] = "Scharlachrote Taverne",
	["Scarlet Tower"] = "Scharlachroter Turm",
	["Scarlet Watch Post"] = "Scharlachroter Wachposten",
	["Scarlet Watchtower"] = "Scharlachroter Wachturm",
	["Scar of the Worldbreaker"] = "Narbe des Weltenbrechers",
	["Scarred Terrace"] = "Zerfurchte Terrasse",
	["Scenario: Alcaz Island"] = "Szenario: Insel Alcaz",
	["Scenario - Black Ox Temple"] = "Scenario - Black Ox Temple",
	["Scenario - Mogu Ruins"] = "Scenario - Mogu Ruins",
	["Scenic Overlook"] = "Idyllischer Aussichtspunkt",
	["Schnottz's Frigate"] = "Schnottz' Fregatte",
	["Schnottz's Hostel"] = "Schnottz' Herberge",
	["Schnottz's Landing"] = "Schnottz' Landeplatz",
	Scholomance = "Scholomance",
	["Scholomance Entrance"] = "Eingang nach Scholomance",
	ScholomanceOLD = "Scholomance",
	["School of Necromancy"] = "Schule der Totenbeschwörung",
	["Scorched Gully"] = "Versengte Rinne",
	["Scott's Spooky Area"] = "Scotts Unheimliches Gebiet",
	["Scoured Reach"] = "Geschliffener Schlund",
	Scourgehold = "Geißelfeste",
	Scourgeholme = "Geißelholme",
	["Scourgelord's Command"] = "Order des Geißelfürsten",
	["Scrabblescrew's Camp"] = "Schraubenbuddels Lager",
	["Screaming Gully"] = "Kreischende Schlucht",
	["Scryer's Tier"] = "Sehertreppe",
	["Scuttle Coast"] = "Schipperküste",
	Sea = "Meer",
	Seabrush = "Meeresdickicht",
	["Seafarer's Tomb"] = "Seefahrergrab",
	["Sealed Chambers"] = "Versiegelte Kammern",
	["Seal of the Sun King"] = "Siegel des Sonnenkönigs",
	["Sea Mist Ridge"] = "Küstennebelgrat",
	["Searing Gorge"] = "Sengende Schlucht",
	["Seaspittle Cove"] = "Speichelschaumbucht",
	["Seaspittle Nook"] = "Speichelschaumwinkel",
	["Seat of Destruction"] = "Stätte des Chaos",
	["Seat of Knowledge"] = "Heim des Wissens",
	["Seat of Life"] = "Sitz des Lebens",
	["Seat of Magic"] = "Stätte der Magie",
	["Seat of Radiance"] = "Stätte des Glanzes",
	["Seat of the Chosen"] = "Sitz der Auserwählten",
	["Seat of the Naaru"] = "Sitz der Naaru",
	["Seat of the Spirit Waker"] = "Sitz des Geistererweckers",
	["Seeker's Folly"] = "Pfad des Unwissenden",
	["Seeker's Point"] = "Grat des Unwissenden",
	["Sen'jin Village"] = "Sen'jin",
	["Sen'jin Village Outskirts"] = "Umland von Sen'jin",
	["Sentinel Basecamp"] = "Lager der Schildwachen",
	["Sentinel Hill"] = "Späherkuppe",
	["Sentinel Tower"] = "Späherturm",
	["Sentry Point"] = "Späherwacht",
	Seradane = "Seradane",
	["Serenity Falls"] = "Kaskade der Ruhe",
	["Serpent Lake"] = "Schlangensee",
	["Serpent's Coil"] = "Schlangenschlinge",
	["Serpent's Heart"] = "Das Schlangenherz",
	["Serpentshrine Cavern"] = "Höhle des Schlangenschreins",
	["Serpent's Overlook"] = "Der Schlangenblick",
	["Serpent's Spine"] = "Der Schlangenrücken",
	["Servants' Quarters"] = "Bedienstetenunterkünfte",
	["Service Entrance"] = "Bediensteteneingang",
	["Sethekk Halls"] = "Sethekkhallen",
	["Sethria's Roost"] = "Sethrias Nest",
	["Setting Sun Garrison"] = "Garnison der Untergehenden Sonne",
	["Set'vess"] = "Set'vess",
	["Sewer Access Point"] = "Kanalisationsschacht",
	["Sewer Exit Pipe"] = "Kanalisationsausgangsrohr",
	Sewers = "Die Abwasserkanäle",
	Shadebough = "Schattengeäst",
	["Shadewood Thicket"] = "Schattenlaubdickicht",
	["Shado-Li Basin"] = "Shado-Li-Becken",
	["Shado-Pan Fallback"] = "Shado-Pan-Rückzug",
	["Shado-Pan Garrison"] = "Shado-Pan-Garnison",
	["Shado-Pan Monastery"] = "Shado-Pan-Kloster",
	["Shadowbreak Ravine"] = "Schattenklamm",
	["Shadowfang Keep"] = "Burg Schattenfang",
	["Shadowfang Keep Entrance"] = "Eingang zur Burg Schattenfang",
	["Shadowfang Tower"] = "Schattenfangturm",
	["Shadowforge City"] = "Die Schattenschmiede",
	Shadowglen = "Laubschattental",
	["Shadow Grave"] = "Schattengrab",
	["Shadow Hold"] = "Schattenfeste",
	["Shadow Labyrinth"] = "Schattenlabyrinth",
	["Shadowlurk Ridge"] = "Schattenlauergrat",
	["Shadowmoon Valley"] = "Schattenmondtal",
	["Shadowmoon Village"] = "Schattenmond",
	["Shadow-Pan Monastery"] = "Shado-Pan-Kloster",
	["Shadowprey Village"] = "Schattenflucht",
	["Shadow Ridge"] = "Schattenkamm",
	["Shadowshard Cavern"] = "Schattensplitterhöhle",
	["Shadowsight Tower"] = "Schattenblickturm",
	["Shadowsong Shrine"] = "Schattensangschrein",
	["Shadowthread Cave"] = "Schattenweberhöhle",
	["Shadow Tomb"] = "Schattengrab",
	["Shadow Wing Lair"] = "Schattenschwingenunterschlupf",
	["Shadra'Alor"] = "Shadra'Alor",
	["Shadybranch Pocket"] = "Schattenastwinkel",
	["Shady Rest Inn"] = "Gasthaus Zur Süßen Ruh",
	["Shalandis Isle"] = "Die Insel Shalandis",
	["Shalewind Canyon"] = "Schieferwindtal",
	["Shallow's End"] = "Der Tiefgang",
	["Shallowstep Pass"] = "Der Schleichsteig",
	["Shalzaru's Lair"] = "Shalzarus Unterschlupf",
	Shamanar = "Shamanar",
	["Sha'naari Wastes"] = "Weiten von Sha'naari",
	["Shang's Stead"] = "Shangs Hof",
	["Shang's Valley"] = "Shangs Tal",
	["Shang Xi Training Grounds"] = "Shang Xis Ausbildungsgelände",
	["Shan'ze Dao"] = "Shan'ze Dao",
	["Shaol'mara"] = "Shaol'mara",
	["Shaol'watha"] = "Shaol'watha",
	["Shaper's Terrace"] = "Terrasse des Formers",
	["Shaper's Terrace "] = "Terrasse des Formers",
	["Shartuul's Transporter"] = "Shartuuls Transporter",
	["Sha'tari Base Camp"] = "Basislager der Sha'tari",
	["Sha'tari Outpost"] = "Außenposten der Sha'tari",
	["Shattered Convoy"] = "Zerschlagener Konvoi",
	["Shattered Plains"] = "Zerschlagene Weiten",
	["Shattered Straits"] = "Straße der Trümmer",
	["Shattered Sun Staging Area"] = "Sammelpunkt der Zerschmetterten Sonne",
	["Shatter Point"] = "Trümmerposten",
	["Shatter Scar Vale"] = "Narbengrund",
	Shattershore = "Havarieküste",
	["Shatterspear Pass"] = "Splitterspeerpass",
	["Shatterspear Vale"] = "Splitterspeertal",
	["Shatterspear War Camp"] = "Kriegslager der Splitterspeere",
	Shatterstone = "Trümmerstein",
	Shattrath = "Shattrath",
	["Shattrath City"] = "Shattrath",
	["Shelf of Mazu"] = "Das Riff von Mazu",
	["Shell Beach"] = "Muschelschalenstrand",
	["Shield Hill"] = "Schildhügel",
	["Shields of Silver"] = "Silberne Schilde",
	["Shimmering Bog"] = "Schimmersumpf",
	["Shimmering Expanse"] = "Schimmernde Weiten",
	["Shimmering Grotto"] = "Die Schimmernde Grotte",
	["Shimmer Ridge"] = "Schimmergrat",
	["Shindigger's Camp"] = "Kniegräbers Lager",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Schiff nach Vashj'ir (Orgrimmar -> Vashj'ir)",
	["Shipwreck Shore"] = "Schiffbruchküste",
	Shipyard = "Werft",
	["Shipyard - Mogu Island Progression Scenario"] = "Werft - Moguinselfortschrittszenario",
	["Shok'Thokar"] = "Shok'Thokar",
	["Sholazar Basin"] = "Sholazarbecken",
	["Shores of the Well"] = "Ufer des Brunnens",
	["Shrine of Aessina"] = "Schrein von Aessina",
	["Shrine of Aviana"] = "Schrein von Aviana",
	["Shrine of Dath'Remar"] = "Schrein von Dath'Remar",
	["Shrine of Dreaming Stones"] = "Schrein der Träumenden Steine",
	["Shrine of Eck"] = "Schrein von Eck",
	["Shrine of Fellowship"] = "Schrein der Gefährten",
	["Shrine of Five Dawns"] = "Schrein der Fünf Morgendämmerungen",
	["Shrine of Goldrinn"] = "Schrein von Goldrinn",
	["Shrine of Inner-Light"] = "Schrein des Inneren Lichts",
	["Shrine of Lost Souls"] = "Schrein der Verlorenen Seelen",
	["Shrine of Nala'shi"] = "Schrein von Nala'shi",
	["Shrine of Remembrance"] = "Schrein der Gedenken",
	["Shrine of Remulos"] = "Schrein von Remulos",
	["Shrine of Scales"] = "Schrein der Schuppen",
	["Shrine of Seven Stars"] = "Schrein der Sieben Sterne",
	["Shrine of Thaurissan"] = "Schrein von Thaurissan",
	["Shrine of the Dawn"] = "Schrein der Morgensonne",
	["Shrine of the Deceiver"] = "Schrein des Betrügers",
	["Shrine of the Dormant Flame"] = "Schrein der Schlafenden Flamme",
	["Shrine of the Eclipse"] = "Schrein der Finsternis",
	["Shrine of the Elements"] = "Schrein der Elemente",
	["Shrine of the Fallen Warrior"] = "Schrein des Gefallenen Kriegers",
	["Shrine of the Five Khans"] = "Der Schrein der Fünf Khans",
	["Shrine of the Merciless One"] = "Schrein des Gnadenlosen",
	["Shrine of the Ox"] = "Der Schrein des Ochsen",
	["Shrine of Twin Serpents"] = "Schrein der Zwillingsschlangen",
	["Shrine of Two Moons"] = "Schrein der Zwei Monde",
	["Shrine of Unending Light"] = "Schrein des Endlosen Lichts",
	["Shriveled Oasis"] = "Verdorrte Oase",
	["Shuddering Spires"] = "Berstende Säulen",
	["SI:7"] = "SI:7",
	["Siege of Niuzao Temple"] = "Die Belagerung des Niuzaotempels",
	["Siege Vise"] = "Belagerungszwinge",
	["Siege Workshop"] = "Belagerungswerkstatt",
	["Sifreldar Village"] = "Sifreldar",
	["Sik'vess"] = "Sik'vess",
	["Sik'vess Lair"] = "Der Sik'vesshort",
	["Silent Vigil"] = "Die Stille Nachtwache",
	Silithus = "Silithus",
	["Silken Fields"] = "Seidenfelder",
	["Silken Shore"] = "Seidenküste",
	["Silmyr Lake"] = "Silmyrsee",
	["Silting Shore"] = "Schlickerküste",
	Silverbrook = "Silberwasser",
	["Silverbrook Hills"] = "Silberwasserhügel",
	["Silver Covenant Pavilion"] = "Silberbundpavillon",
	["Silverlight Cavern"] = "Silberlichthöhle",
	["Silverline Lake"] = "Silberwellensee",
	["Silvermoon City"] = "Silbermond",
	["Silvermoon City Inn"] = "Gasthaus von Silbermond",
	["Silvermoon Finery"] = "Silbermonds Zeitgeist",
	["Silvermoon Jewelery"] = "Juwelier von Silbermond",
	["Silvermoon Registry"] = "Meldeamt von Silbermond",
	["Silvermoon's Pride"] = "Silbermonds Stolz",
	["Silvermyst Isle"] = "Silbermythosinsel",
	["Silverpine Forest"] = "Silberwald",
	["Silvershard Mines"] = "Silberbruchmine",
	["Silver Stream Mine"] = "Silberbachmine",
	["Silver Tide Hollow"] = "Silberfluthöhle",
	["Silver Tide Trench"] = "Silberflutgraben",
	["Silverwind Refuge"] = "Silberwindzuflucht",
	["Silverwing Flag Room"] = "Flaggenraum der Silberschwingen",
	["Silverwing Grove"] = "Hain der Silberschwingen",
	["Silverwing Hold"] = "Feste der Silberschwingen",
	["Silverwing Outpost"] = "Außenposten der Silberschwingen",
	["Simply Enchanting"] = "Einfach Verzaubernd!",
	["Sindragosa's Fall"] = "Sindragosas Sturz",
	["Sindweller's Rise"] = "Sündschwelgers Anhöhe",
	["Singing Marshes"] = "Singende Marschen",
	["Singing Ridge"] = "Der Singende Bergrücken",
	["Sinner's Folly"] = "Sündenbabel",
	["Sira'kess Front"] = "Frontlinie der Sira'kess",
	["Sishir Canyon"] = "Sishircanyon",
	["Sisters Sorcerous"] = "Zauberhafte Schwestern",
	Skald = "Skald",
	["Sketh'lon Base Camp"] = "Basislager der Sketh'lon",
	["Sketh'lon Wreckage"] = "Wrack der Sketh'lon",
	["Skethyl Mountains"] = "Skethylberge",
	Skettis = "Skettis",
	["Skitterweb Tunnels"] = "Listspinnertunnel",
	Skorn = "Skorn",
	["Skulking Row"] = "Lauergasse",
	["Skulk Rock"] = "Lauerfels",
	["Skull Rock"] = "Knochenhöhle",
	["Sky Falls"] = "Himmelsfälle",
	["Skyguard Outpost"] = "Außenposten der Himmelswache",
	["Skyline Ridge"] = "Horizontgrat",
	Skyrange = "Himmelsweite",
	["Skysong Lake"] = "Himmelsweisensee",
	["Slabchisel's Survey"] = "Fliesmeißels Messstation",
	["Slag Watch"] = "Schlackenwacht",
	Slagworks = "Erzraffinerie",
	["Slaughter Hollow"] = "Schlächtergrotte",
	["Slaughter Square"] = "Schlächterplatz",
	["Sleeping Gorge"] = "Die Schlummernde Schlucht",
	["Slicky Stream"] = "Glitschifluss",
	["Slingtail Pits"] = "Schlingschwanzgruben",
	["Slitherblade Shore"] = "Strand der Zackenkämme",
	["Slithering Cove"] = "Die Wuchernde Bucht",
	["Slither Rock"] = "Schlitterfels",
	["Sludgeguard Tower"] = "Schlickwachtturm",
	["Smuggler's Scar"] = "Schmugglerschmiss",
	["Snicklefritz Mine"] = "Klitzefritz' Mine",
	["Snowblind Hills"] = "Blendschneehügel",
	["Snowblind Terrace"] = "Blendschneeterrasse",
	["Snowden Chalet"] = "Schneewehs Berghütte",
	["Snowdrift Dojo"] = "Meister Schneewehes Dojo",
	["Snowdrift Plains"] = "Die Verschneiten Ebenen",
	["Snowfall Glade"] = "Schneewehenlichtung",
	["Snowfall Graveyard"] = "Schneewehenfriedhof",
	["Socrethar's Seat"] = "Socrethars Sitz",
	["Sofera's Naze"] = "Soferas Landspitze",
	["Soggy's Gamble"] = "Tropfs Wagnis",
	["Solace Glade"] = "Die Trostlichtung",
	["Solliden Farmstead"] = "Sollidens Bauernhof",
	["Solstice Village"] = "Julheim",
	["Sorlof's Strand"] = "Sorlofs Strand",
	["Sorrow Hill"] = "Trauerhügel",
	["Sorrow Hill Crypt"] = "Krypta des Trauerhügels",
	Sorrowmurk = "Sorgendunkel",
	["Sorrow Wing Point"] = "Stätte der Gramschwingen",
	["Soulgrinder's Barrow"] = "Hügel des Seelenschänders",
	["Southbreak Shore"] = "Südbrandung",
	["South Common Hall"] = "Südliche Bankenhalle",
	["Southern Barrens"] = "Südliches Brachland",
	["Southern Gold Road"] = "Südliche Goldstraße",
	["Southern Rampart"] = "Südliches Bollwerk",
	["Southern Rocketway"] = "Südliche Raketenbahn",
	["Southern Rocketway Terminus"] = "Südliche Endhaltestelle der Raketenbahn",
	["Southern Savage Coast"] = "Südliche Ungezähmte Küste",
	["Southfury River"] = "Der Südstrom",
	["Southfury Watershed"] = "Die Südstromaue",
	["South Gate Outpost"] = "Südtoraußenposten",
	["South Gate Pass"] = "Südtorpass",
	["Southmaul Tower"] = "Südschlägerturm",
	["Southmoon Ruins"] = "Südmondruinen",
	["South Pavilion"] = "Südlicher Pavillon",
	["Southpoint Gate"] = "Südwachttor",
	["South Point Station"] = "Südstation",
	["Southpoint Tower"] = "Südwachtturm",
	["Southridge Beach"] = "Südklippenufer",
	["Southsea Holdfast"] = "Südmeerstützpunkt",
	["South Seas"] = "Die Südlichen Meere",
	Southshore = "Süderstade",
	["Southshore Town Hall"] = "Rathaus von Süderstade",
	["South Spire"] = "Südturm",
	["South Tide's Run"] = "Südlicher Gezeitenstrom",
	["Southwind Cleft"] = "Südwindkluft",
	["Southwind Village"] = "Südwindposten",
	["Sparkrocket Outpost"] = "Außenposten Zündmine",
	["Sparksocket Minefield"] = "Funksockels Minenfeld",
	["Sparktouched Haven"] = "Zuflucht der Funkenbesprühten",
	["Sparring Hall"] = "Übungshalle",
	["Spearborn Encampment"] = "Lager der Speerträger",
	Spearhead = "Speerspitze",
	["Speedbarge Bar"] = "Turbodampferschenke",
	Spellsails = "Zaubersegel",
	["Spinebreaker Mountains"] = "Rückenbrecherberge",
	["Spinebreaker Pass"] = "Rückenbrecherpass",
	["Spinebreaker Post"] = "Rückenbrecherposten",
	["Spinebreaker Ridge"] = "Rückenbrechergrat",
	["Spiral of Thorns"] = "Wendel der Dornen",
	["Spire of Blood"] = "Säule des Blutes",
	["Spire of Decay"] = "Säule der Fäulnis",
	["Spire of Pain"] = "Säule der Pein",
	["Spire of Solitude"] = "Turm der Abgeschiedenheit",
	["Spire Throne"] = "Spitzenthron",
	["Spirit Den"] = "Geisterhöhlenbau",
	["Spirit Fields"] = "Geisterfelder",
	["Spirit Rise"] = "Die Anhöhe der Geister",
	["Spirit Rock"] = "Geisterfelsen",
	["Spiritsong River"] = "Geisterliedfluss",
	["Spiritsong's Rest"] = "Geisterliedruh",
	["Spitescale Cavern"] = "Gallschuppenhöhle",
	["Spitescale Cove"] = "Bucht der Gallschuppen",
	["Splinterspear Junction"] = "Splitterspeerkreuzung",
	Splintertree = "Splitterholzposten",
	["Splintertree Mine"] = "Splitterholzmine",
	["Splintertree Post"] = "Splitterholzposten",
	["Splithoof Crag"] = "Spalthufklippe",
	["Splithoof Heights"] = "Spalthufanhöhen",
	["Splithoof Hold"] = "Spalthufhöhle",
	Sporeggar = "Sporeggar",
	["Sporewind Lake"] = "Sporenwindsee",
	["Springtail Crag"] = "Sprungschweifklippe",
	["Springtail Warren"] = "Der Sprungschweifbau",
	["Spruce Point Post"] = "Posten des Fichtenpunkts",
	["Sra'thik Incursion"] = "Übergriff der Sra'thik",
	["Sra'thik Swarmdock"] = "Schwarmdock der Sra'thik",
	["Sra'vess"] = "Sra'vess",
	["Sra'vess Rootchamber"] = "Wurzelkammer der Sra'vess",
	["Sri-La Inn"] = "Gasthaus von Sri-La",
	["Sri-La Village"] = "Sri-La",
	Stables = "Ställe",
	Stagalbog = "Stagalsumpf",
	["Stagalbog Cave"] = "Stagalsumpfhöhle",
	["Stagecoach Crash Site"] = "Postkutschenunfallstelle",
	["Staghelm Point"] = "Hirschhaupts Stätte",
	["Staging Balcony"] = "Darbietungsbalkon",
	["Stairway to Honor"] = "Treppe zur Ehre",
	["Starbreeze Village"] = "Sternenhauch",
	["Stardust Spire"] = "Sternenstaubspitze",
	["Starfall Village"] = "Sternfall",
	["Stars' Rest"] = "Sternenruh",
	["Stasis Block: Maximus"] = "Stasisblock: Maximus",
	["Stasis Block: Trion"] = "Stasisblock: Trion",
	["Steam Springs"] = "Dampfquellen",
	["Steamwheedle Port"] = "Dampfdruckpier",
	["Steel Gate"] = "Das Stählerne Tor",
	["Steelgrill's Depot"] = "Stahlrosts Depot",
	["Steeljaw's Caravan"] = "Stahlkiefers Karawane",
	["Steelspark Station"] = "Station Stahlfunken",
	["Stendel's Pond"] = "Stendels Tümpel",
	["Stillpine Hold"] = "Tannenruhfeste",
	["Stillwater Pond"] = "Stillwassertümpel",
	["Stillwhisper Pond"] = "Stillwispertümpel",
	Stonard = "Steinard",
	["Stonebreaker Camp"] = "Steinbrecherlager",
	["Stonebreaker Hold"] = "Steinbrecherfeste",
	["Stonebull Lake"] = "Steinbullensee",
	["Stone Cairn Lake"] = "Der Steinhügelsee",
	Stonehearth = "Steinruh",
	["Stonehearth Bunker"] = "Steinbruchbunker",
	["Stonehearth Graveyard"] = "Steinbruchfriedhof",
	["Stonehearth Outpost"] = "Steinbruchaußenposten",
	["Stonemaul Hold"] = "Festung der Steinbrecher",
	["Stonemaul Ruins"] = "Ruinen der Steinbrecher",
	["Stone Mug Tavern"] = "Steinkrugtaverne",
	Stoneplow = "Steinpflug",
	["Stoneplow Fields"] = "Steinpflugfelder",
	["Stone Sentinel's Overlook"] = "Warte des Steinwächters",
	["Stonesplinter Valley"] = "Splittersteintal",
	["Stonetalon Bomb"] = "Bombe des Steinkrallengebirges",
	["Stonetalon Mountains"] = "Steinkrallengebirge",
	["Stonetalon Pass"] = "Steinkrallenpass",
	["Stonetalon Peak"] = "Der Steinkrallengipfel",
	["Stonewall Canyon"] = "Steinwallschlucht",
	["Stonewall Lift"] = "Aufzug am Steinwall",
	["Stoneward Prison"] = "Steinwallgefängnis",
	Stonewatch = "Steinwacht",
	["Stonewatch Falls"] = "Steinwachtfälle",
	["Stonewatch Keep"] = "Burg Steinwacht",
	["Stonewatch Tower"] = "Turm der Steinwacht",
	["Stonewrought Dam"] = "Der Steinwerkdamm",
	["Stonewrought Pass"] = "Steinwerkpass",
	["Storm Cliffs"] = "Sturmklippen",
	Stormcrest = "Sturmspitze",
	["Stormfeather Outpost"] = "Sturmfederaußenposten",
	["Stormglen Village"] = "Sturmsiel",
	["Storm Peaks"] = "Die Sturmgipfel",
	["Stormpike Graveyard"] = "Friedhof der Sturmlanzen",
	["Stormrage Barrow Dens"] = "Sturmgrimms Grabhügel",
	["Stormsea Landing"] = "Der Sturmgepeitschte Hafen",
	["Storm's Fury Wreckage"] = "Wrack der Sturmfuror",
	["Stormstout Brewery"] = "Brauerei Sturmbräu",
	["Stormstout Brewery Interior"] = "Innenraum der Brauerei Sturmwind",
	["Stormstout Brewhall"] = "Sturmbräuhalle",
	Stormwind = "Sturmwind",
	["Stormwind City"] = "Sturmwind",
	["Stormwind City Cemetery"] = "Friedhof von Sturmwind",
	["Stormwind City Outskirts"] = "Stadtrand von Sturmwind",
	["Stormwind Gunship Pandaria Start Area"] = "Kanonenboot von Sturmwind, Startgebiet Pandaria",
	["Stormwind Harbor"] = "Hafen von Sturmwind",
	["Stormwind Keep"] = "Burg Sturmwind",
	["Stormwind Lake"] = "Sturmwindsee",
	["Stormwind Mountains"] = "Berge von Sturmwind",
	["Stormwind Stockade"] = "Verlies von Sturmwind",
	["Stormwind Vault"] = "Gewölbe von Sturmwind",
	["Stoutlager Inn"] = "Gasthof zum Starkbierlager",
	Strahnbrad = "Strahnbrad",
	["Strand of the Ancients"] = "Strand der Uralten",
	["Stranglethorn Vale"] = "Schlingendorntal",
	Stratholme = "Stratholme",
	["Stratholme Entrance"] = "Eingang von Stratholme",
	["Stratholme - Main Gate"] = "Stratholme - Haupttor",
	["Stratholme - Service Entrance"] = "Stratholme - Dienstboteneingang",
	["Stratholme Service Entrance"] = "Dienstboteneingang von Stratholme",
	["Stromgarde Keep"] = "Burg Stromgarde",
	["Strongarm Airstrip"] = "Starkarmflugplatz",
	["STV Diamond Mine BG"] = "STV Diamond Mine BG",
	["Stygian Bounty"] = "Höllenjuwel",
	["Sub zone"] = "Subzone",
	["Sulfuron Keep"] = "Sulfuronfestung",
	["Sulfuron Keep Courtyard"] = "Innenhof der Sulfuronfestung",
	["Sulfuron Span"] = "Sulfuronspanne",
	["Sulfuron Spire"] = "Sulfuronspitze",
	["Sullah's Sideshow"] = "Sullahs Fahrender Zirkus",
	["Summer's Rest"] = "Sommerrast",
	["Summoners' Tomb"] = "Gruft der Beschwörer",
	["Sunblossom Hill"] = "Sonnenblütenhügel",
	["Suncrown Village"] = "Sonnenkuppe",
	["Sundown Marsh"] = "Sonnenwendmarschen",
	["Sunfire Point"] = "Sonnenfeuergrund",
	["Sunfury Hold"] = "Sonnenzornposten",
	["Sunfury Spire"] = "Sonnenzornturm",
	["Sungraze Peak"] = "Sonnenhügel",
	["Sunken Dig Site"] = "Versunkene Ausgrabungsstätte",
	["Sunken Temple"] = "Versunkener Tempel",
	["Sunken Temple Entrance"] = "Eingang des Versunkenen Tempels",
	["Sunreaver Pavilion"] = "Sonnenhäscherpavillon",
	["Sunreaver's Command"] = "Sonnenhäschers Schar",
	["Sunreaver's Sanctuary"] = "Sonnenhäschers Zuflucht",
	["Sun Rock Retreat"] = "Sonnenfels",
	["Sunsail Anchorage"] = "Ankerplatz der Sonnensegel",
	["Sunsoaked Meadow"] = "Sonnendurchtränkte Wiese",
	["Sunsong Ranch"] = "Gehöft Sonnensang",
	["Sunspring Post"] = "Sonnenwindposten",
	["Sun's Reach Armory"] = "Waffenkammer der Sonnenweiten",
	["Sun's Reach Harbor"] = "Hafen der Sonnenweiten",
	["Sun's Reach Sanctum"] = "Sanktum der Sonnenweiten",
	["Sunstone Terrace"] = "Sonnensteinterrasse",
	["Sunstrider Isle"] = "Insel der Sonnenwanderer",
	["Sunveil Excursion"] = "Sonnenschleiers Exkursionstrupp",
	["Sunwatcher's Ridge"] = "Sonnenbehütergrat",
	["Sunwell Plateau"] = "Sonnenbrunnenplateau",
	["Supply Caravan"] = "Versorgungskarawane",
	["Surge Needle"] = "Sognadel",
	["Surveyors' Outpost"] = "Feldmesserposten",
	Surwich = "Surwich",
	["Svarnos' Cell"] = "Svarnos' Zelle",
	["Swamplight Manor"] = "Irrlichtanwesen",
	["Swamp of Sorrows"] = "Sümpfe des Elends",
	["Swamprat Post"] = "Sumpfrattenposten",
	["Swiftgear Station"] = "Schnellschalts Station",
	["Swindlegrin's Dig"] = "Schwindelgrins' Grabungsstätte",
	["Swindle Street"] = "Gaunergasse",
	["Sword's Rest"] = "Schwertruh",
	Sylvanaar = "Sylvanaar",
	["Tabetha's Farm"] = "Tabethas Hof",
	["Taelan's Tower"] = "Taelans Turm",
	["Tahonda Ruins"] = "Ruinen von Tahonda",
	["Tahret Grounds"] = "Tahretgründe",
	["Tal'doren"] = "Tal'doren",
	["Talismanic Textiles"] = "Glück bringende Textilien",
	["Tallmug's Camp"] = "Humpens",
	["Talonbranch Glade"] = "Nachtlaublichtung",
	["Talonbranch Glade "] = "Nachtlaublichtung",
	["Talondeep Pass"] = "Steinkrallenpass",
	["Talondeep Vale"] = "Steinkrallental",
	["Talon Stand"] = "Krallenhoch",
	Talramas = "Talramas",
	["Talrendis Point"] = "Talrendisspitze",
	Tanaris = "Tanaris",
	["Tanaris Desert"] = "Tanariswüste",
	["Tanks for Everything"] = "Plattenladen",
	["Tanner Camp"] = "Gerbers Lager",
	["Tarren Mill"] = "Tarrens Mühle",
	["Tasters' Arena"] = "Arena der Verkoster",
	["Taunka'le Village"] = "Taunka'le",
	["Tavern in the Mists"] = "Taverne im Nebel",
	["Tazz'Alaor"] = "Tazz'Alaor",
	["Tear Down This Wall!"] = "Die Mauer muss weg!",
	["Teegan's Expedition"] = "Teegans Expedition",
	["Teeming Burrow"] = "Der Wimmelnde Bau",
	Telaar = "Telaar",
	["Telaari Basin"] = "Telaaribecken",
	["Tel'athion's Camp"] = "Tel'athions Lager",
	Teldrassil = "Teldrassil",
	Telredor = "Telredor",
	["Tempest Bridge"] = "Brücke der Stürme",
	["Tempest Keep"] = "Festung der Stürme",
	["Tempest Keep: The Arcatraz"] = "Festung der Stürme: Die Arkatraz",
	["Tempest Keep - The Arcatraz Entrance"] = "Festung der Stürme - Eingang zur Arkatraz",
	["Tempest Keep: The Botanica"] = "Festung der Stürme: Die Botanika",
	["Tempest Keep - The Botanica Entrance"] = "Festung der Stürme - Eingang zur Botanika",
	["Tempest Keep: The Mechanar"] = "Festung der Stürme: Die Mechanar",
	["Tempest Keep - The Mechanar Entrance"] = "Festung der Stürme - Eingang zur Mechanar",
	["Tempest's Reach"] = "Witterfront",
	["Temple City of En'kilah"] = "Tempelstadt En'kilah",
	["Temple Hall"] = "Tempelhalle",
	["Temple of Ahn'Qiraj"] = "Tempel von Ahn'Qiraj",
	["Temple of Arkkoran"] = "Der Tempel von Arkkoran",
	["Temple of Asaad"] = "Tempel von Asaad",
	["Temple of Bethekk"] = "Tempel von Bethekk",
	["Temple of Earth"] = "Tempel der Erde",
	["Temple of Five Dawns"] = "Tempel der Fünf Sonnenaufgänge",
	["Temple of Invention"] = "Tempel des Erfindungsreichtums",
	["Temple of Kotmogu"] = "Tempel von Katmogu",
	["Temple of Life"] = "Tempel des Lebens",
	["Temple of Order"] = "Tempel der Ordnung",
	["Temple of Storms"] = "Tempel der Stürme",
	["Temple of Telhamat"] = "Tempel von Telhamat",
	["Temple of the Forgotten"] = "Tempel der Vergessenen",
	["Temple of the Jade Serpent"] = "Tempel der Jadeschlange",
	["Temple of the Moon"] = "Tempel des Mondes",
	["Temple of the Red Crane"] = "Tempel des Roten Kranichs",
	["Temple of the White Tiger"] = "Tempel des Weißen Tigers",
	["Temple of Uldum"] = "Tempel von Uldum",
	["Temple of Winter"] = "Tempel des Winters",
	["Temple of Wisdom"] = "Tempel der Weisheit",
	["Temple of Zin-Malor"] = "Tempel von Zin-Malor",
	["Temple Summit"] = "Tempelspitze",
	["Tenebrous Cavern"] = "Schattenhöhle",
	["Terokkar Forest"] = "Wälder von Terokkar",
	["Terokk's Rest"] = "Terokks Ruh",
	["Terrace of Endless Spring"] = "Terrasse des Endlosen Frühlings",
	["Terrace of Gurthan"] = "Terrasse von Gurthan",
	["Terrace of Light"] = "Terrasse des Lichts",
	["Terrace of Repose"] = "Terrasse der Muße",
	["Terrace of Ten Thunders"] = "Terrasse der Zehn Donner",
	["Terrace of the Augurs"] = "Terrasse der Weissager",
	["Terrace of the Makers"] = "Terrasse der Schöpfer",
	["Terrace of the Sun"] = "Terrasse der Sonne",
	["Terrace of the Tiger"] = "Die Terrasse des Tigers",
	["Terrace of the Twin Dragons"] = "Terrasse der Zwillingsdrachen",
	Terrordale = "Schreckenstal",
	["Terror Run"] = "Terrorflucht",
	["Terrorweb Tunnel"] = "Schreckenstunnel",
	["Terror Wing Path"] = "Schreckenspfad",
	["Tethris Aran"] = "Tethris Aran",
	Thalanaar = "Thalanaar",
	["Thalassian Pass"] = "Thalassischer Pass",
	["Thalassian Range"] = "Thalassische Weide",
	["Thal'darah Grove"] = "Hain von Thal'darah",
	["Thal'darah Overlook"] = "Aussicht von Thal'darah",
	["Thandol Span"] = "Thandolübergang",
	["Thargad's Camp"] = "Thargads Lager",
	["The Abandoned Reach"] = "Die Verlassenen Weiten",
	["The Abyssal Maw"] = "Der Meeresschlund",
	["The Abyssal Shelf"] = "Die Abyssische Untiefe",
	["The Admiral's Den"] = "Admiralsunterschlupf",
	["The Agronomical Apothecary"] = "Das Agrarwissenschaftliche Apothekarium",
	["The Alliance Valiants' Ring"] = "Der Ring der Recken der Allianz",
	["The Altar of Damnation"] = "Altar der Verdammnis",
	["The Altar of Shadows"] = "Altar der Schatten",
	["The Altar of Zul"] = "Der Altar von Zul",
	["The Amber Hibernal"] = "Die Bernüberwinterung",
	["The Amber Vault"] = "Das Berngewölbe",
	["The Amber Womb"] = "Der Bernschoß",
	["The Ancient Grove"] = "Der Uralte Hain",
	["The Ancient Lift"] = "Der Uralte Aufzug",
	["The Ancient Passage"] = "Die Uralte Passage",
	["The Antechamber"] = "Die Vorkammer",
	["The Anvil of Conflagration"] = "Der Amboss der Feuersbrunst",
	["The Anvil of Flame"] = "Der Amboss des Feuers",
	["The Apothecarium"] = "Das Apothekarium",
	["The Arachnid Quarter"] = "Das Arachnidenviertel",
	["The Arboretum"] = "Das Arboretum",
	["The Arcanium"] = "Das Arkanium",
	["The Arcanium "] = "Das Arkanium",
	["The Arcatraz"] = "Die Arkatraz",
	["The Archivum"] = "Das Archivum",
	["The Argent Stand"] = "Die Argentumwache",
	["The Argent Valiants' Ring"] = "Der Ring der Recken des Argentumkreuzzugs",
	["The Argent Vanguard"] = "Die Argentumvorhut",
	["The Arsenal Absolute"] = "Das Absolute Arsenal",
	["The Aspirants' Ring"] = "Der Ring der Streiter",
	["The Assembly Chamber"] = "Die Versammlungskammer",
	["The Assembly of Iron"] = "Die Versammlung des Eisens",
	["The Athenaeum"] = "Das Athenaeum",
	["The Autumn Plains"] = "Die Herbstebenen",
	["The Avalanche"] = "Die Lawine",
	["The Azure Front"] = "Die Azurfront",
	["The Bamboo Wilds"] = "Die Bambuswildnis",
	["The Bank of Dalaran"] = "Die Bank von Dalaran",
	["The Bank of Silvermoon"] = "Die Bank von Silbermond",
	["The Banquet Hall"] = "Der Bankettsaal",
	["The Barrier Hills"] = "Die Hügelwand",
	["The Bastion of Twilight"] = "Die Bastion des Zwielichts",
	["The Battleboar Pen"] = "Kriegseberpferch",
	["The Battle for Gilneas"] = "Die Schlacht um Gilneas",
	["The Battle for Gilneas (Old City Map)"] = "Die Schlacht um Gilneas (Alte Stadtkarte)",
	["The Battle for Mount Hyjal"] = "Die Schlacht um den Hyjal",
	["The Battlefront"] = "Die Schlachtenfront",
	["The Bazaar"] = "Der Basar",
	["The Beast Pens"] = "Die Bestienpferche",
	["The Beer Garden"] = "Der Biergarten",
	["The Bite"] = "Der Biss",
	["The Black Breach"] = "Der Schwarze Riss",
	["The Black Market"] = "Der Schwarzmarkt",
	["The Black Morass"] = "Der Schwarze Morast",
	["The Black Temple"] = "Der Schwarze Tempel",
	["The Black Vault"] = "Das Schwarze Gewölbe",
	["The Blackwald"] = "Der Schwarzforst",
	["The Blazing Strand"] = "Der Lodernde Strand",
	["The Blighted Pool"] = "Der Verseuchte Teich",
	["The Blight Line"] = "Die Seuchenfront",
	["The Bloodcursed Reef"] = "Das Riff des Blutfluchs",
	["The Blood Furnace"] = "Der Blutkessel",
	["The Bloodmire"] = "Der Blutsumpf",
	["The Bloodoath"] = "Die Blutschwur",
	["The Blood Trail"] = "Der Blutpfad",
	["The Bloodwash"] = "Blutbrandung",
	["The Boiling Crustacean"] = "Kantine zum Kreischenden Krebs",
	["The Bombardment"] = "Das Bombardement",
	["The Bonefields"] = "Die Knochenfelder",
	["The Bone Pile"] = "Der Knochenhaufen",
	["The Bones of Nozronn"] = "Die Knochen von Nozronn",
	["The Bone Wastes"] = "Die Knochenwüste",
	["The Boneyard"] = "Der Totenacker",
	["The Borean Wall"] = "Der Boreanische Wall",
	["The Botanica"] = "Die Botanika",
	["The Bradshaw Mill"] = "Die Bradshawmühle",
	["The Breach"] = "Die Bresche",
	["The Briny Cutter"] = "Der Salzkutter",
	["The Briny Muck"] = "Der Salzige Schlick",
	["The Briny Pinnacle"] = "Die Salzzinne",
	["The Broken Bluffs"] = "Der Felssturz",
	["The Broken Front"] = "Die Zerbrochene Front",
	["The Broken Hall"] = "Die Verheerte Halle",
	["The Broken Hills"] = "Die Zerklüfteten Hügel",
	["The Broken Stair"] = "Die Eingestürzte Treppe",
	["The Broken Temple"] = "Der Zerbrochene Tempel",
	["The Broodmother's Nest"] = "Das Nest der Brutmutter",
	["The Brood Pit"] = "Die Brutgrube",
	["The Bulwark"] = "Das Bollwerk",
	["The Burlap Trail"] = "Der Jutepfad",
	["The Burlap Valley"] = "Das Jutetal",
	["The Burlap Waystation"] = "Die Zwischenstation des Jutepfads",
	["The Burning Corridor"] = "Der Brennende Korridor",
	["The Butchery"] = "Der Schlachthof",
	["The Cache of Madness"] = "Der Hort des Wahnsinns",
	["The Caller's Chamber"] = "Der Bittstellerraum",
	["The Canals"] = "Die Kanäle",
	["The Cape of Stranglethorn"] = "Das Schlingendornkap",
	["The Carrion Fields"] = "Die Aasfelder",
	["The Catacombs"] = "Die Katakomben",
	["The Cauldron"] = "Der Kessel",
	["The Cauldron of Flames"] = "Der Flammenkessel",
	["The Cave"] = "Die Höhle",
	["The Celestial Planetarium"] = "Das Himmlische Planetarium",
	["The Celestial Vault"] = "Das Himmlische Gewölbe",
	["The Celestial Watch"] = "Die Himmelswacht",
	["The Cemetary"] = "Der Friedhof",
	["The Cerebrillum"] = "Das Cerebrillum",
	["The Charred Vale"] = "Das Verbrannte Tal",
	["The Chilled Quagmire"] = "Der Kühle Sumpf",
	["The Chum Bucket"] = "Der Abfalleimer",
	["The Circle of Cinders"] = "Der Aschenzirkel",
	["The Circle of Life"] = "Der Kreis des Lebens",
	["The Circle of Suffering"] = "Der Kreis des Leidens",
	["The Clarion Bell"] = "Die Wachglocke",
	["The Clash of Thunder"] = "Der Donnerschlag",
	["The Clean Zone"] = "Die Saubere Zone",
	["The Cleft"] = "Die Kluft",
	["The Clockwerk Run"] = "Die Uhrwerkgasse",
	["The Clutch"] = "Die Umklammerung",
	["The Clutches of Shek'zeer"] = "Die Gelege von Shek'zeer",
	["The Coil"] = "Die Windung",
	["The Colossal Forge"] = "Die Kolossale Schmiede",
	["The Comb"] = "Die Wabenkammer",
	["The Commons"] = "Versammlungshalle",
	["The Conflagration"] = "Der Großbrand",
	["The Conquest Pit"] = "Die Siegeswallgrube",
	["The Conservatory"] = "Das Konservatorium",
	["The Conservatory of Life"] = "Das Konservatorium des Lebens",
	["The Construct Quarter"] = "Das Konstruktviertel",
	["The Cooper Residence"] = "Coopers Residenz",
	["The Corridors of Ingenuity"] = "Die Korridore des Scharfsinns",
	["The Court of Bones"] = "Der Hof der Knochen",
	["The Court of Skulls"] = "Der Hof der Schädel",
	["The Coven"] = "Der Koven",
	["The Coven "] = "Der Koven",
	["The Creeping Ruin"] = "Die Gruselruinen",
	["The Crimson Assembly Hall"] = "Die Karminrote Versammlungshalle",
	["The Crimson Cathedral"] = "Die Scharlachrote Kathedrale",
	["The Crimson Dawn"] = "Die Scharlachroter Morgen",
	["The Crimson Hall"] = "Die Blutrote Halle",
	["The Crimson Reach"] = "Die Purpurbrandung",
	["The Crimson Throne"] = "Der Purpurthron",
	["The Crimson Treader"] = "Die Blutläufer",
	["The Crimson Veil"] = "Die Purpurschleier",
	["The Crossroads"] = "Das Wegekreuz",
	["The Crucible"] = "Der Schmelztiegel",
	["The Crucible of Flame"] = "Schmelztiegel der Flammen",
	["The Crumbling Waste"] = "Die Schwindende Weite",
	["The Cryo-Core"] = "Der Kryokern",
	["The Crystal Hall"] = "Die Kristallhalle",
	["The Crystal Shore"] = "Das Kristallufer",
	["The Crystal Vale"] = "Das Kristalltal",
	["The Crystal Vice"] = "Die Kristallschlucht",
	["The Culling of Stratholme"] = "Das Ausmerzen von Stratholme",
	["The Culling of Stratholme Entrance"] = "Eingang zum Ausmerzen von Stratholme",
	["The Cursed Landing"] = "Der Verfluchte Landeplatz",
	["The Dagger Hills"] = "Die Dolchhügel",
	["The Dai-Lo Farmstead"] = "Der Dai-Lo-Bauernhof",
	["The Damsel's Luck"] = "Die Maid im Glück",
	["The Dancing Serpent"] = "Die Tanzende Schlange",
	["The Dark Approach"] = "Der Dunkle Zugang",
	["The Dark Defiance"] = "Die Dunkle Rebellin",
	["The Darkened Bank"] = "Das Dunkle Ufer",
	["The Dark Hollow"] = "Die Dunkle Höhle",
	["The Darkmoon Faire"] = "Der Dunkelmond-Jahrmarkt",
	["The Dark Portal"] = "Das Dunkle Portal",
	["The Dark Rookery"] = "Der Dunkle Krähenhorst",
	["The Darkwood"] = "Der Finsterwald",
	["The Dawnchaser"] = "Die Morgensturm",
	["The Dawning Isles"] = "Die Morgeninseln",
	["The Dawning Span"] = "Die Morgenspanne",
	["The Dawning Square"] = "Platz der Morgenröte",
	["The Dawning Stair"] = "Treppe des Anbrechenden Morgens",
	["The Dawning Valley"] = "Tal des Anbrechenden Morgens",
	["The Dead Acre"] = "Der Todesacker",
	["The Dead Field"] = "Das Todesfeld",
	["The Dead Fields"] = "Die Toten Felder",
	["The Deadmines"] = "Die Todesminen",
	["The Dead Mire"] = "Das Todesmoor",
	["The Dead Scar"] = "Die Todesschneise",
	["The Deathforge"] = "Die Todesschmiede",
	["The Deathknell Graves"] = "Die Gräber von Todesend",
	["The Decrepit Fields"] = "Die Verfallenen Felder",
	["The Decrepit Flow"] = "Der Versiegende Strom",
	["The Deeper"] = "Die Tiefere",
	["The Deep Reaches"] = "Die Ausufernden Tiefen",
	["The Deepwild"] = "Die Tiefwildnis",
	["The Defiant"] = "Die Kühnheit",
	["The Defiled Chapel"] = "Die Entweihte Kapelle",
	["The Den"] = "Der Höhlenbau",
	["The Den of Flame"] = "Der Flammenbau",
	["The Dens of Dying"] = "Die Höhlen des Todes",
	["The Dens of the Dying"] = "Höhlen des Todes",
	["The Descent into Madness"] = "Der Abstieg in den Wahnsinn",
	["The Desecrated Altar"] = "Der Entweihte Altar",
	["The Devil's Terrace"] = "Die Terrasse des Teufels",
	["The Devouring Breach"] = "Der Verschlingende Riss",
	["The Domicile"] = "Das Domizil",
	["The Domicile "] = "Das Domizil",
	["The Dooker Dome"] = "Die Knatzelkuppel",
	["The Dor'Danil Barrow Den"] = "Grabhügel von Dor'Danil",
	["The Dormitory"] = "Der Schlafsaal",
	["The Drag"] = "Die Gasse",
	["The Dragonmurk"] = "Das Drachendüster",
	["The Dragon Wastes"] = "Die Dracheneiswüste",
	["The Drain"] = "Der Abfluss",
	["The Dranosh'ar Blockade"] = "Die Blockade von Dranosh'ar",
	["The Drowned Reef"] = "Das Versunkene Riff",
	["The Drowned Sacellum"] = "Die Versunkene Weihekammer",
	["The Drunken Hozen"] = "Zum Betrunkenen Ho-zen",
	["The Dry Hills"] = "Die Trockenen Hügel",
	["The Dustbowl"] = "Das Staubbecken",
	["The Dust Plains"] = "Die Staubebenen",
	["The Eastern Earthshrine"] = "Der Östliche Erdschrein",
	["The Elders' Path"] = "Der Pfad der Ältesten",
	["The Emerald Summit"] = "Der Smaragdgipfel",
	["The Emperor's Approach"] = "Der Kaisergang",
	["The Emperor's Gate"] = "Das Tor des Kaisers",
	["The Emperor's Reach"] = "Die Kaiserhöhe",
	["The Emperor's Step"] = "Der Kaisertritt",
	["The Escape From Durnholde"] = "Die Flucht von Durnholde",
	["The Escape from Durnholde Entrance"] = "Eingang zur Flucht von Durnholde",
	["The Eventide"] = "Die Abendruh",
	["The Exodar"] = "Die Exodar",
	["The Eye"] = "Festung der Stürme",
	["The Eye of Eternity"] = "Das Auge der Ewigkeit",
	["The Eye of the Vortex"] = "Das Auge des Vortex",
	["The Fall of Shan Bu"] = "Der Sturz von Shan'Bu",
	["The Farstrider Lodge"] = "Jagdhütte der Weltenwanderer",
	["The Feeding Pits"] = "Die Fütterungsgruben",
	["The Fel Pits"] = "Die Teufelsgruben",
	["The Fertile Copse"] = "Das Fruchtbare Dickicht",
	["The Fetid Pool"] = "Der Faulige Teich",
	["The Filthy Animal"] = "Das Rattenloch",
	["The Firehawk"] = "Die Feuerfalke",
	["The Five Sisters"] = "Die Fünf Schwestern",
	["The Flamewake"] = "Die Flammenschneise",
	["The Fleshwerks"] = "Die Fleischwerke",
	["The Flood Plains"] = "Die Flutebenen",
	["The Fold"] = "Der Bruch",
	["The Foothill Caverns"] = "Die Vorgebirgshöhlen",
	["The Foot of Lei Shen"] = "Der Fuß des Lei Shen",
	["The Foot Steppes"] = "Die Fußmarschen",
	["The Forbidden Jungle"] = "Der Verbotene Dschungel",
	["The Forbidding Sea"] = "Das Verbotene Meer",
	["The Forest of Shadows"] = "Der Schattenwald",
	["The Forge of Souls"] = "Die Seelenschmiede",
	["The Forge of Souls Entrance"] = "Eingang zur Seelenschmiede",
	["The Forge of Supplication"] = "Die Schmiede der Unterwerfung",
	["The Forge of Wills"] = "Die Seelenschmiede",
	["The Forgotten Coast"] = "Die Vergessene Küste",
	["The Forgotten Overlook"] = "Die Vergessene Warte",
	["The Forgotten Pool"] = "Der Vergessene Teich",
	["The Forgotten Pools"] = "Die Vergessenen Teiche",
	["The Forgotten Shore"] = "Der Vergessene Strand",
	["The Forlorn Cavern"] = "Das Düstere Viertel",
	["The Forlorn Mine"] = "Die Verlassene Mine",
	["The Forsaken Front"] = "Frontlinie der Verlassenen",
	["The Foul Pool"] = "Der Besudelte Teich",
	["The Frigid Tomb"] = "Das Eisige Grab",
	["The Frost Queen's Lair"] = "Der Hort der Frostkönigin",
	["The Frostwing Halls"] = "Die Frostschwingenhallen",
	["The Frozen Glade"] = "Gefrorene Lichtung",
	["The Frozen Halls"] = "Die Gefrorenen Hallen",
	["The Frozen Mine"] = "Die Gefrorene Mine",
	["The Frozen Sea"] = "Die Gefrorene See",
	["The Frozen Throne"] = "Der Frostthron",
	["The Fungal Vale"] = "Das Fungustal",
	["The Furnace"] = "Der Schmelzofen",
	["The Gaping Chasm"] = "Die Klaffende Schlucht",
	["The Gatehouse"] = "Das Torhaus",
	["The Gatehouse "] = "Das Torhaus",
	["The Gate of Unending Cycles"] = "Tor der Ewigen Zyklen",
	["The Gauntlet"] = "Der Spießrutenlauf",
	["The Geyser Fields"] = "Die Geysirfelder",
	["The Ghastly Confines"] = "Der Gespenstische Grenzwall",
	["The Gilded Foyer"] = "Das Vergoldete Foyer",
	["The Gilded Gate"] = "Das Vergoldete Tor",
	["The Gilding Stream"] = "Der Goldstrom",
	["The Glimmering Pillar"] = "Die Schimmersäule",
	["The Golden Gateway"] = "Das Goldene Tor",
	["The Golden Hall"] = "Die Goldene Halle",
	["The Golden Lantern"] = "Die Goldene Laterne",
	["The Golden Pagoda"] = "Die Goldene Pagode",
	["The Golden Plains"] = "Die Goldenen Ebenen",
	["The Golden Rose"] = "Die Goldene Rose",
	["The Golden Stair"] = "Die Goldene Treppe",
	["The Golden Terrace"] = "Die Goldene Terrasse",
	["The Gong of Hope"] = "Der Gong der Hoffnung",
	["The Grand Ballroom"] = "Der Große Ballsaal",
	["The Grand Vestibule"] = "Das Große Vestibül",
	["The Great Arena"] = "Die Große Arena",
	["The Great Divide"] = "Der Große Graben",
	["The Great Fissure"] = "Die Große Kluft",
	["The Great Forge"] = "Die Große Schmiede",
	["The Great Gate"] = "Die Große Pforte",
	["The Great Lift"] = "Der Große Aufzug",
	["The Great Ossuary"] = "Das Große Ossuarium",
	["The Great Sea"] = "Das Große Meer",
	["The Great Tree"] = "Der Große Baum",
	["The Great Wheel"] = "Das Große Rad",
	["The Green Belt"] = "Der Grüne Gürtel",
	["The Greymane Wall"] = "Der Graumähnenwall",
	["The Grim Guzzler"] = "Zum Grimmigen Säufer",
	["The Grinding Quarry"] = "Der Mahlsteinbruch",
	["The Grizzled Den"] = "Der Graufelsbau",
	["The Grummle Bazaar"] = "Der Grummelbasar",
	["The Guardhouse"] = "Die Wachstube",
	["The Guest Chambers"] = "Die Gästezimmer",
	["The Gullet"] = "Der Rachen",
	["The Halfhill Market"] = "Der Halbhügelmarkt",
	["The Half Shell"] = "Die Halbmuschel",
	["The Hall of Blood"] = "Die Halle des Blutes",
	["The Hall of Gears"] = "Die Halle der Zahnräder",
	["The Hall of Lights"] = "Galerie der Schätze",
	["The Hall of Respite"] = "Die Halle der Ruhe",
	["The Hall of Statues"] = "Die Statuenhalle",
	["The Hall of the Serpent"] = "Die Halle der Schlange",
	["The Hall of Tiles"] = "Die Mosaikhalle",
	["The Halls of Reanimation"] = "Die Hallen der Wiederbelebung",
	["The Halls of Winter"] = "Die Hallen des Winters",
	["The Hand of Gul'dan"] = "Die Hand von Gul'dan",
	["The Harborage"] = "Der Sichere Hafen",
	["The Hatchery"] = "Die Brutstätte",
	["The Headland"] = "Die Landzunge",
	["The Headlands"] = "Die Mark",
	["The Heap"] = "Der Hügel",
	["The Heartland"] = "Das Kernland",
	["The Heart of Acherus"] = "Das Herz von Acherus",
	["The Heart of Jade"] = "Das Jadeherz",
	["The Hidden Clutch"] = "Das Versteckte Gelege",
	["The Hidden Grove"] = "Der Versteckte Hain",
	["The Hidden Hollow"] = "Die Versteckte Senke",
	["The Hidden Passage"] = "Die Versteckte Passage",
	["The Hidden Reach"] = "Der Versteckte Zugang",
	["The Hidden Reef"] = "Das Versteckte Riff",
	["The High Path"] = "Der Hochpfad",
	["The High Road"] = "Der Höhenpfad",
	["The High Seat"] = "Der Hohe Sitz",
	["The Hinterlands"] = "Hinterland",
	["The Hoard"] = "Der Hort",
	["The Hole"] = "Das Loch",
	["The Horde Valiants' Ring"] = "Der Ring der Recken der Horde",
	["The Horrid March"] = "Mark des Schreckens",
	["The Horsemen's Assembly"] = "Das Reiterkonzil",
	["The Howling Hollow"] = "Die Heulende Senke",
	["The Howling Oak"] = "Die Heulende Eiche",
	["The Howling Vale"] = "Das Heulende Tal",
	["The Hunter's Reach"] = "Die Weiten des Jägers",
	["The Hushed Bank"] = "Das Stille Ufer",
	["The Icy Depths"] = "Die Eisigen Tiefen",
	["The Immortal Coil"] = "Die Ewiger Kreislauf",
	["The Imperial Exchange"] = "Das Kaiserliche Kontor",
	["The Imperial Granary"] = "Die Kaiserliche Kornkammer",
	["The Imperial Mercantile"] = "Der Kaiserliche Basar",
	["The Imperial Seat"] = "Der Kaiserliche Sitz",
	["The Incursion"] = "Der Übergriff",
	["The Infectis Scar"] = "Die Infektnarbe",
	["The Inferno"] = "Das Inferno",
	["The Inner Spire"] = "Die Innere Spitze",
	["The Intrepid"] = "Die Kühnheit",
	["The Inventor's Library"] = "Die Bibliothek des Erfinders",
	["The Iron Crucible"] = "Der Eiserne Schmelztiegel",
	["The Iron Hall"] = "Die Eisenhalle",
	["The Iron Reaper"] = "Die Eisenrächer",
	["The Isle of Spears"] = "Die Insel der Speere",
	["The Ivar Patch"] = "Das Ivarfeld",
	["The Jade Forest"] = "Der Jadewald",
	["The Jade Vaults"] = "Das Jadegewölbe",
	["The Jansen Stead"] = "Jansens Hof",
	["The Keggary"] = "Das Fasslager",
	["The Kennel"] = "Der Hundezwinger",
	["The Krasari Ruins"] = "Die Krasariruinen",
	["The Krazzworks"] = "Die Krazzwerke",
	["The Laboratory"] = "Das Labor",
	["The Lady Mehley"] = "Die Lady Mehley",
	["The Lagoon"] = "Die Lagune",
	["The Laughing Stand"] = "Der Lachende Stützpunkt",
	["The Lazy Turnip"] = "Zur Faulen Rübe",
	["The Legerdemain Lounge"] = "Zum Zauberkasten",
	["The Legion Front"] = "Die Front der Legion",
	["Thelgen Rock"] = "Thelgenfelsen",
	["The Librarium"] = "Das Librarium",
	["The Library"] = "Die Bibliothek",
	["The Lifebinder's Cell"] = "Die Zelle der Lebensbinderin",
	["The Lifeblood Pillar"] = "Die Lebensblutsäule",
	["The Lightless Reaches"] = "Die Lichtlosen Weiten",
	["The Lion's Redoubt"] = "Refugium des Löwen",
	["The Living Grove"] = "Der Lebende Hain",
	["The Living Wood"] = "Der Lebende Wald",
	["The LMS Mark II"] = "Die LMS Mark II",
	["The Loch"] = "Der Loch",
	["The Long Wash"] = "Der Lange Strand",
	["The Lost Fleet"] = "Die Verlorene Flotte",
	["The Lost Fold"] = "Die Verlorene Furt",
	["The Lost Isles"] = "Die Verlorenen Inseln",
	["The Lost Lands"] = "Die Verlorenen Lande",
	["The Lost Passage"] = "Die Verlorene Passage",
	["The Low Path"] = "Der Niederpfad",
	Thelsamar = "Thelsamar",
	["The Lucky Traveller"] = "Zum Glücklichen Reisenden",
	["The Lyceum"] = "Das Lyzeum",
	["The Maclure Vineyards"] = "Weinberge der Maclures",
	["The Maelstrom"] = "Der Mahlstrom",
	["The Maker's Overlook"] = "Die Warte des Schöpfers",
	["The Makers' Overlook"] = "Die Warte der Schöpfer",
	["The Makers' Perch"] = "Hort der Schöpfer",
	["The Maker's Rise"] = "Die Anhöhe des Schöpfers",
	["The Maker's Terrace"] = "Terrasse des Schöpfers",
	["The Manufactory"] = "Die Manufaktur",
	["The Marris Stead"] = "Marris' Siedlung",
	["The Marshlands"] = "Die Marschen",
	["The Masonary"] = "Die Freimaurerei",
	["The Master's Cellar"] = "Der Keller des Meisters",
	["The Master's Glaive"] = "Die Meistergleve",
	["The Maul"] = "Die Schlägergrube",
	["The Maw of Madness"] = "Der Schlund des Wahnsinns",
	["The Mechanar"] = "Die Mechanar",
	["The Menagerie"] = "Die Menagerie",
	["The Menders' Stead"] = "Die Stätte der Heiler",
	["The Merchant Coast"] = "Die Händlerküste",
	["The Militant Mystic"] = "Der Militante Mystiker",
	["The Military Quarter"] = "Das Militärviertel",
	["The Military Ward"] = "Das Militärviertel",
	["The Mind's Eye"] = "Das Gedankenauge",
	["The Mirror of Dawn"] = "Spiegel der Morgenröte",
	["The Mirror of Twilight"] = "Der Zwielichtspiegel",
	["The Molsen Farm"] = "Molsens Hof",
	["The Molten Bridge"] = "Die Geschmolzene Brücke",
	["The Molten Core"] = "Der Geschmolzene Kern",
	["The Molten Fields"] = "Die Geschmolzenen Felder",
	["The Molten Flow"] = "Der Geschmolzene Strom",
	["The Molten Span"] = "Der Geschmolzene Übergang",
	["The Mor'shan Rampart"] = "Schutzwall von Mor'shan",
	["The Mor'Shan Ramparts"] = "Schutzwall von Mor'shan",
	["The Mosslight Pillar"] = "Die Mooslichtsäule",
	["The Mountain Den"] = "Die Berghöhle",
	["The Murder Pens"] = "Die Mörderpferche",
	["The Mystic Ward"] = "Das Mystikerviertel",
	["The Necrotic Vault"] = "Die Nekrotische Kammer",
	["The Nexus"] = "Der Nexus",
	["The Nexus Entrance"] = "Eingang zum Nexus",
	["The Nightmare Scar"] = "Die Alptraumnarbe",
	["The North Coast"] = "Die Nordküste",
	["The North Sea"] = "Das Nordmeer",
	["The Nosebleeds"] = "Das Nasenbluten",
	["The Noxious Glade"] = "Das Giftige Tal",
	["The Noxious Hollow"] = "Die Giftige Senke",
	["The Noxious Lair"] = "Der Giftige Unterschlupf",
	["The Noxious Pass"] = "Der Giftpass",
	["The Oblivion"] = "Die Ewige Vergessenheit",
	["The Observation Ring"] = "Der Beobachtungsring",
	["The Obsidian Sanctum"] = "Das Obsidiansanktum",
	["The Oculus"] = "Das Oculus",
	["The Oculus Entrance"] = "Eingang zum Oculus",
	["The Old Barracks"] = "Die Alte Kaserne",
	["The Old Dormitory"] = "Der Alte Schlafsaal",
	["The Old Port Authority"] = "Die Alte Hafenbehörde",
	["The Opera Hall"] = "Der Opernsaal",
	["The Oracle Glade"] = "Die Lichtung des Orakels",
	["The Outer Ring"] = "Der Äußere Ring",
	["The Overgrowth"] = "Die Überwucherung",
	["The Overlook"] = "Der Rundblick",
	["The Overlook Cliffs"] = "Die Aussichtsklippen",
	["The Overlook Inn"] = "Gasthaus des Rundblicks",
	["The Ox Gate"] = "Das Ochsentor",
	["The Pale Roost"] = "Der Bleiche Hort",
	["The Park"] = "Der Park",
	["The Path of Anguish"] = "Der Pfad der Pein",
	["The Path of Conquest"] = "Der Pfad der Eroberung",
	["The Path of Corruption"] = "Der Pfad der Verderbnis",
	["The Path of Glory"] = "Der Pfad des Ruhms",
	["The Path of Iron"] = "Der Eisenpfad",
	["The Path of the Lifewarden"] = "Der Pfad der Lebenswächterin",
	["The Phoenix Hall"] = "Die Phönixhalle",
	["The Pillar of Ash"] = "Die Aschensäule",
	["The Pipe"] = "Das Rohr",
	["The Pit of Criminals"] = "Die Grube der Verbrecher",
	["The Pit of Fiends"] = "Die Schreckensgrube",
	["The Pit of Narjun"] = "Die Grube von Narjun",
	["The Pit of Refuse"] = "Die Grube der Weigerung",
	["The Pit of Sacrifice"] = "Die Grube der Opferung",
	["The Pit of Scales"] = "Die Schuppengrube",
	["The Pit of the Fang"] = "Die Reißzahngrube",
	["The Plague Quarter"] = "Das Seuchenviertel",
	["The Plagueworks"] = "Die Seuchenwerke",
	["The Pool of Ask'ar"] = "Der Teich von Ask'ar",
	["The Pools of Vision"] = "Die Teiche der Visionen",
	["The Prison of Yogg-Saron"] = "Das Gefängnis von Yogg-Saron",
	["The Proving Grounds"] = "Die Versuchsgründe",
	["The Purple Parlor"] = "Der Purpursalon",
	["The Quagmire"] = "Der Morast",
	["The Quaking Fields"] = "Die Bebenden Felder",
	["The Queen's Reprisal"] = "Die Vergeltung ihrer Majestät",
	["The Raging Chasm"] = "Der Rasende Schlund",
	Theramore = "Theramore",
	["Theramore Isle"] = "Die Insel Theramore",
	["Theramore's Fall"] = "Theramores Sturz",
	["Theramore's Fall (A)"] = "Theramores Sturz (A)",
	["Theramore's Fall (H)"] = "Theramores Sturz (H)",
	["Theramore's Fall Phase"] = "Theramores Sturz Phase",
	["The Rangers' Lodge"] = "Die Waldläuferhütte",
	["Therazane's Throne"] = "Therazanes Thron",
	["The Red Reaches"] = "Die Roten Weiten",
	["The Refectory"] = "Das Warenlager",
	["The Regrowth"] = "Der Geheilte Hyjal",
	["The Reliquary"] = "Das Reliquiarium",
	["The Repository"] = "Das Archiv",
	["The Reservoir"] = "Das Reservoir",
	["The Restless Front"] = "Die Rastlose Front",
	["The Ridge of Ancient Flame"] = "Der Grat der Urtümlichen Flamme",
	["The Rift"] = "Der Riss",
	["The Ring of Balance"] = "Der Ring des Gleichgewichts",
	["The Ring of Blood"] = "Der Ring des Blutes",
	["The Ring of Champions"] = "Der Ring der Champions",
	["The Ring of Inner Focus"] = "Der Ring des Inneren Fokus",
	["The Ring of Trials"] = "Der Ring der Prüfung",
	["The Ring of Valor"] = "Der Ring der Ehre",
	["The Riptide"] = "Die Springflut",
	["The Riverblade Den"] = "Die Höhle der Flussklingen",
	["Thermal Vents"] = "Thermalquelle",
	["The Roiling Gardens"] = "Die Aufwühlenden Gärten",
	["The Rolling Gardens"] = "Die Aufwühlenden Gärten",
	["The Rolling Plains"] = "Die Wogenden Ebenen",
	["The Rookery"] = "Der Krähenhorst",
	["The Rotting Orchard"] = "Der Verrottende Obstgarten",
	["The Rows"] = "Die Ränge",
	["The Royal Exchange"] = "Der Königliche Markt",
	["The Ruby Sanctum"] = "Das Rubinsanktum",
	["The Ruined Reaches"] = "Die Verfallenen Gegenden",
	["The Ruins of Kel'Theril"] = "Die Ruinen von Kel'Theril",
	["The Ruins of Ordil'Aran"] = "Die Ruinen von Ordil'Aran",
	["The Ruins of Stardust"] = "Die Sternenstaubruinen",
	["The Rumble Cage"] = "Der Rumblekäfig",
	["The Rustmaul Dig Site"] = "Rostnagels Grabungsstätte",
	["The Sacred Grove"] = "Der Heilige Hain",
	["The Salty Sailor Tavern"] = "Taverne Zum Salzigen Seemann",
	["The Sanctum"] = "Das Sanktum",
	["The Sanctum of Blood"] = "Das Sanktum des Blutes",
	["The Savage Coast"] = "Die Ungezähmte Küste",
	["The Savage Glen"] = "Die Wilde Schlucht",
	["The Savage Thicket"] = "Das Wilde Dickicht",
	["The Scalding Chasm"] = "Der Brühgraben",
	["The Scalding Pools"] = "Die Siedenden Teiche",
	["The Scarab Dais"] = "Die Skarabäushöhe",
	["The Scarab Wall"] = "Der Skarabäuswall",
	["The Scarlet Basilica"] = "Die Scharlachrote Basilika",
	["The Scarlet Bastion"] = "Die Scharlachrote Bastion",
	["The Scorched Grove"] = "Der Versengte Hain",
	["The Scorched Plain"] = "Die Verbrannte Ebene",
	["The Scrap Field"] = "Das Trümmerfeld",
	["The Scrapyard"] = "Der Schrottplatz",
	["The Screaming Hall"] = "Die Schreiende Halle",
	["The Screaming Reaches"] = "Die Schreienden Weiten",
	["The Screeching Canyon"] = "Der Kreischende Canyon",
	["The Scribe of Stormwind"] = "Der Schriftgelehrte von Sturmwind",
	["The Scribes' Sacellum"] = "Das Sacellum der Schreiber",
	["The Scrollkeeper's Sanctum"] = "Das Sanktum des Schriftrollenhüters",
	["The Scullery"] = "Die Küche",
	["The Scullery "] = "Die Küche",
	["The Seabolt"] = "Die Meereskeil",
	["The Seabreach Flow"] = "Der Meeresklammstrom",
	["The Sealed Hall"] = "Die Versiegelte Halle",
	["The Sea of Cinders"] = "Das Meer der Asche",
	["The Sea Reaver's Run"] = "Die Straße der Meerhäscher",
	["The Searing Gateway"] = "Das Sengende Tor",
	["The Sea Wolf"] = "Die Seewolf",
	["The Secret Aerie"] = "Der versteckte Horst",
	["The Secret Lab"] = "Das Geheimlabor",
	["The Secrets of Ragefire"] = "Geheimnisse des Flammenschlunds",
	["The Seer's Library"] = "Bibliothek der Seher",
	["The Sepulcher"] = "Das Grabmal",
	["The Severed Span"] = "Der Geteilte Übergang",
	["The Sewer"] = "Der Kanal",
	["The Shadow Stair"] = "Die Schattentreppe",
	["The Shadow Throne"] = "Der Schattenthron",
	["The Shadow Vault"] = "Das Schattengewölbe",
	["The Shady Nook"] = "Der Schattenwinkel",
	["The Shaper's Terrace"] = "Die Terrasse des Formers",
	["The Shattered Halls"] = "Die Zerschmetterten Hallen",
	["The Shattered Strand"] = "Strand der Trümmer",
	["The Shattered Walkway"] = "Der Zerschmetterte Gang",
	["The Shepherd's Gate"] = "Hirtentor",
	["The Shifting Mire"] = "Der Wabersumpf",
	["The Shimmering Deep"] = "Die Schimmernde Tiefe",
	["The Shimmering Flats"] = "Die Schimmernde Ebene",
	["The Shining Strand"] = "Der Leuchtende Strand",
	["The Shrine of Aessina"] = "Der Schrein von Aessina",
	["The Shrine of Eldretharr"] = "Der Schrein von Eldretharr",
	["The Silent Sanctuary"] = "Das Stille Sanktum",
	["The Silkwood"] = "Der Seidenwald",
	["The Silver Blade"] = "Die Silberklinge",
	["The Silver Enclave"] = "Die Silberne Enklave",
	["The Singing Grove"] = "Der Singende Hain",
	["The Singing Pools"] = "Die Singenden Teiche",
	["The Sin'loren"] = "Die Sin'loren",
	["The Skeletal Reef"] = "Das Skelettriff",
	["The Skittering Dark"] = "Das Huschdunkel",
	["The Skull Warren"] = "Die Schädelhöhle",
	["The Skunkworks"] = "Die Stinkwerke",
	["The Skybreaker"] = "Die Himmelsbrecher",
	["The Skyfire"] = "Die Himmelsfeuer",
	["The Skyreach Pillar"] = "Die Himmelszeltsäule",
	["The Slag Pit"] = "Die Schlackengrube",
	["The Slaughtered Lamb"] = "Zum Geschlachteten Lamm",
	["The Slaughter House"] = "Das Schlachthaus",
	["The Slave Pens"] = "Die Sklavenunterkünfte",
	["The Slave Pits"] = "Die Sklavengruben",
	["The Slick"] = "Der Schlickstand",
	["The Slithering Scar"] = "Die Wuchernde Narbe",
	["The Slough of Dispair"] = "Die Sumpf der Verzweiflung",
	["The Sludge Fen"] = "Das Schlickmoor",
	["The Sludge Fields"] = "Die Schlickfelder",
	["The Sludgewerks"] = "Die Schlickwerke",
	["The Solarium"] = "Solaris",
	["The Solar Vigil"] = "Die Solarwacht",
	["The Southern Isles"] = "Die Südlichen Inseln",
	["The Southern Wall"] = "Die Südliche Mauer",
	["The Sparkling Crawl"] = "Der Glitzernde Kriechgang",
	["The Spark of Imagination"] = "Der Funke der Imagination",
	["The Spawning Glen"] = "Das Pilzgeflecht",
	["The Spire"] = "Die Bastion",
	["The Splintered Path"] = "Der Gesplitterte Pfad",
	["The Spring Road"] = "Die Lenzstraße",
	["The Stadium"] = "Das Stadion",
	["The Stagnant Oasis"] = "Die Brackige Oase",
	["The Staidridge"] = "Der Nimbusrücken",
	["The Stair of Destiny"] = "Die Stufen des Schicksals",
	["The Stair of Doom"] = "Die Stufen der Verdammnis",
	["The Starchaser"] = "Die Sternenjäger",
	["The Star's Bazaar"] = "Der Sternenbasar",
	["The Steam Pools"] = "Die Dampfteiche",
	["The Steamvault"] = "Die Dampfkammer",
	["The Steppe of Life"] = "Die Lebendige Steppe",
	["The Steps of Fate"] = "Die Schicksalsstiege",
	["The Stinging Trail"] = "Der Stechende Pfad",
	["The Stockade"] = "Das Verlies",
	["The Stockpile"] = "Das Vorratslager",
	["The Stonecore"] = "Der Steinerne Kern",
	["The Stonecore Entrance"] = "Eingang zum Steinernen Kern",
	["The Stonefield Farm"] = "Hof der Steinfelds",
	["The Stone Vault"] = "Das Steingewölbe",
	["The Storehouse"] = "Das Lagerhaus",
	["The Stormbreaker"] = "Die Sturmbrecher",
	["The Stormbridge"] = "Die Sturmbrücke",
	["The Storm Foundry"] = "Die Wiege des Sturms",
	["The Storm Peaks"] = "Die Sturmgipfel",
	["The Stormspire"] = "Die Sturmsäule",
	["The Stormwright's Shelf"] = "Das Sturmherrenschelf",
	["The Summer Fields"] = "Die Sommerfelder",
	["The Summer Terrace"] = "Die Sommerterrasse",
	["The Sundered Shard"] = "Die Versprengte Scherbe",
	["The Sundering"] = "Die Zerschlagung",
	["The Sun Forge"] = "Die Sonnenschmiede",
	["The Sunken Ring"] = "Der Versunkene Ring",
	["The Sunset Brewgarden"] = "Abendlichtbraugarten",
	["The Sunspire"] = "Der Sonnenturm",
	["The Suntouched Pillar"] = "Die Sonnenstrahlsäule",
	["The Sunwell"] = "Der Sonnenbrunnen",
	["The Swarming Pillar"] = "Die Schwarmsäule",
	["The Swollen Vault"] = "Die Prall Gefüllte Kammer",
	["The Tainted Forest"] = "Der Besudelte Wald",
	["The Tainted Scar"] = "Die Faulende Narbe",
	["The Talondeep Path"] = "Der Steinkrallenpfad",
	["The Talon Den"] = "Der Krallenbau",
	["The Tasting Room"] = "Der Verkostungsraum",
	["The Tempest Rift"] = "Kluft der Stürme",
	["The Temple Gardens"] = "Die Tempelgärten",
	["The Temple of Atal'Hakkar"] = "Der Tempel von Atal'Hakkar",
	["The Temple of the Jade Serpent"] = "Tempel der Jadeschlange",
	["The Terrestrial Watchtower"] = "Der Irdische Wachturm",
	["The Thornsnarl"] = "Der Dornknoten",
	["The Threads of Fate"] = "Die Fäden des Schicksals",
	["The Threshold"] = "Die Schwelle",
	["The Throne of Flame"] = "Der Flammenthron",
	["The Thunder Forge"] = "Die Donnerschmiede",
	["The Thunder Forges"] = "Die Donnerschmiede",
	["The Thundering Run"] = "Die Donnernde Schlucht",
	["The Thundering Spire"] = "Die Donnernde Spitze",
	["The Thunderspire"] = "Die Donnernde Spitze",
	["The Thunderwood"] = "Das Donnerholz",
	["The Tidebreaker"] = "Die Gezeitenbrecher",
	["The Tidus Stair"] = "Der Tidustritt",
	["The Tiger's Peak"] = "Der Tigergipfel",
	["The Torjari Pit"] = "Die Torjarigrube",
	["The Tower of Arathor"] = "Der Turm von Arathor",
	["The Toxic Airfield"] = "Der Toxische Flugplatz",
	["The Trail of Devastation"] = "Der Pfad der Verwüstung",
	["The Tranquil Grove"] = "Der Friedvolle Hain",
	["The Transitus Stair"] = "Die Transitustreppe",
	["The Trapper's Enclave"] = "Die Enklave der Jäger",
	["The Tribunal of Ages"] = "Das Tribunal der Zeitalter",
	["The Tundrid Hills"] = "Die Tundridhügel",
	["The Twilight Breach"] = "Der Schattenriss",
	["The Twilight Caverns"] = "Die Zwielichthöhlen",
	["The Twilight Citadel"] = "Die Schattenzitadelle",
	["The Twilight Enclave"] = "Die Zwielichtenklave",
	["The Twilight Gate"] = "Das Schattentor",
	["The Twilight Gauntlet"] = "Feuerprobe des Schattenhammers",
	["The Twilight Ridge"] = "Zwielichthöhe",
	["The Twilight Rivulet"] = "Der Zwielichtbach",
	["The Twilight Withering"] = "Schattenödnis",
	["The Twin Colossals"] = "Die Zwillingskolosse",
	["The Twisted Glade"] = "Siechende Lichtung",
	["The Twisted Warren"] = "Das Gewundene Gewirr",
	["The Two Fisted Brew"] = "Zum Schänkelklopfer",
	["The Unbound Thicket"] = "Unbändiges Dickicht",
	["The Underbelly"] = "Die Schattenseite",
	["The Underbog"] = "Der Tiefensumpf",
	["The Underbough"] = "Das Unterholz",
	["The Undercroft"] = "Das Tiefgewölbe",
	["The Underhalls"] = "Das Kellergewölbe",
	["The Undershell"] = "Muscheltiefe",
	["The Uplands"] = "Das Oberland",
	["The Upside-down Sinners"] = "Die Umgekehrten Sünder",
	["The Valley of Fallen Heroes"] = "Das Tal der Gefallenen Helden",
	["The Valley of Lost Hope"] = "Das Tal der Verlorenen Hoffnung",
	["The Vault of Lights"] = "Die Halle des Lichts",
	["The Vector Coil"] = "Die Vektorspule",
	["The Veiled Cleft"] = "Die Verhüllte Kluft",
	["The Veiled Sea"] = "Das Verhüllte Meer",
	["The Veiled Stair"] = "Die Verhüllte Treppe",
	["The Venture Co. Mine"] = "Die Mine der Venture Co.",
	["The Verdant Fields"] = "Die Saftgrünen Felder",
	["The Verdant Thicket"] = "Das Saftgrüne Dickicht",
	["The Verne"] = "Die Verne",
	["The Verne - Bridge"] = "Die Verne - Brücke",
	["The Verne - Entryway"] = "Die Verne - Eingang",
	["The Vibrant Glade"] = "Lebendige Lichtung",
	["The Vice"] = "Das Joch",
	["The Vicious Vale"] = "Das Kleine Horrortal",
	["The Viewing Room"] = "Der Vorführraum",
	["The Vile Reef"] = "Das Finstere Riff",
	["The Violet Citadel"] = "Die Violette Zitadelle",
	["The Violet Citadel Spire"] = "Turm der Violetten Zitadelle",
	["The Violet Gate"] = "Das Violette Tor",
	["The Violet Hold"] = "Die Violette Festung",
	["The Violet Spire"] = "Der Violette Turm",
	["The Violet Tower"] = "Der Violette Turm",
	["The Vortex Fields"] = "Die Vortexfelder",
	["The Vortex Pinnacle"] = "Der Vortexgipfel",
	["The Vortex Pinnacle Entrance"] = "Eingang zum Vortexgipfel",
	["The Wailing Caverns"] = "Die Höhlen des Wehklagens",
	["The Wailing Ziggurat"] = "Die Klagende Ziggurat",
	["The Waking Halls"] = "Die Hallen des Erwachens",
	["The Wandering Isle"] = "Die Wandernde Insel",
	["The Warlord's Garrison"] = "Die Garnison des Kriegsherren",
	["The Warlord's Terrace"] = "Die Terrasse des Kriegsherren",
	["The Warp Fields"] = "Die Sphärenfelder",
	["The Warp Piston"] = "Die Warpgondel",
	["The Wavecrest"] = "Die Schaumkrone",
	["The Weathered Nook"] = "Der Wetterwinkel",
	["The Weeping Cave"] = "Die Weinende Höhle",
	["The Western Earthshrine"] = "Der Westliche Erdschrein",
	["The Westrift"] = "Die Westklamm",
	["The Whelping Downs"] = "Die Schlupfhügel",
	["The Whipple Estate"] = "Anwesen der Whipples",
	["The Wicked Coil"] = "Die Serpentine",
	["The Wicked Grotto"] = "Die Tückische Grotte",
	["The Wicked Tunnels"] = "Die Tückischen Tunnel",
	["The Widening Deep"] = "Die Klaffende Tiefe",
	["The Widow's Clutch"] = "Das Gelege der Witwe",
	["The Widow's Wail"] = "Das Klagen der Witwe",
	["The Wild Plains"] = "Die Wilden Ebenen",
	["The Wild Shore"] = "Die Wilde Küste",
	["The Winding Halls"] = "Die Gewundenen Hallen",
	["The Windrunner"] = "Die Windläufer",
	["The Windspire"] = "Die Windspitze",
	["The Wollerton Stead"] = "Wollertons Bauernhof",
	["The Wonderworks"] = "Die Wunderwerke",
	["The Wood of Staves"] = "Der Stabwald",
	["The World Tree"] = "Der Weltenbaum",
	["The Writhing Deep"] = "Die Gewundene Tiefe",
	["The Writhing Haunt"] = "Das Trostlose Feld",
	["The Yaungol Advance"] = "Der Yaungolvorstoß",
	["The Yorgen Farmstead"] = "Yorgens Bauernhof",
	["The Zandalari Vanguard"] = "Die Vorhut der Zandalari",
	["The Zoram Strand"] = "Der Zoramstrand",
	["Thieves Camp"] = "Diebeslager",
	["Thirsty Alley"] = "Durststrecke",
	["Thistlefur Hold"] = "Höhle der Distelfelle",
	["Thistlefur Village"] = "Lager der Distelfelle",
	["Thistleshrub Valley"] = "Disteltal",
	["Thondroril River"] = "Thondroril",
	["Thoradin's Wall"] = "Thoradinswall",
	["Thorium Advance"] = "Thoriumvorstoß",
	["Thorium Point"] = "Thoriumspitze",
	["Thor Modan"] = "Thor Modan",
	["Thornfang Hill"] = "Dornnebelhügel",
	["Thorn Hill"] = "Dornenhügel",
	["Thornmantle's Hideout"] = "Dornmantels Versteck",
	["Thorson's Post"] = "Thorsons Posten",
	["Thorvald's Camp"] = "Thorvalds Lager",
	["Thousand Needles"] = "Tausend Nadeln",
	Thrallmar = "Thrallmar",
	["Thrallmar Mine"] = "Mine von Thrallmar",
	["Three Corners"] = "Drei Ecken",
	["Throne of Ancient Conquerors"] = "Der Thron der Uralten Eroberer",
	["Throne of Kil'jaeden"] = "Kil'jaedens Thron",
	["Throne of Neptulon"] = "Thron von Neptulon",
	["Throne of the Apocalypse"] = "Thron der Apokalypse",
	["Throne of the Damned"] = "Thron der Verdammten",
	["Throne of the Elements"] = "Thron der Elemente",
	["Throne of the Four Winds"] = "Thron der Vier Winde",
	["Throne of the Tides"] = "Thron der Gezeiten",
	["Throne of the Tides Entrance"] = "Eingang zum Thron der Gezeiten",
	["Throne of Thunder"] = "Der Thron des Donners",
	["Throne of Tides"] = "Thron der Gezeiten",
	["Thrym's End"] = "Thryms Ende",
	["Thunder Axe Fortress"] = "Festung Donneraxt",
	Thunderbluff = "Donnerfels",
	["Thunder Bluff"] = "Donnerfels",
	["Thunderbrew Distillery"] = "Brauerei Donnerbräu",
	["Thunder Cleft"] = "Donnerkluft",
	Thunderfall = "Donnerfall",
	["Thunder Falls"] = "Donnerfälle",
	["Thunderfoot Farm"] = "Donnerfußhof",
	["Thunderfoot Fields"] = "Donnerfußfelder",
	["Thunderfoot Inn"] = "Gasthaus Donnerfuß",
	["Thunderfoot Ranch"] = "Gehöft Donnerfuß",
	["Thunder Hold"] = "Donnerwehr",
	["Thunderhorn Water Well"] = "Brunnen der Donnerhörner",
	["Thundering Overlook"] = "Donnernde Aussicht",
	["Thunder Island Alliance Hub"] = "Allianzknotenpunkt für den Donnerkönig",
	["Thunder King Horde Hub"] = "Hordeknotenpunkt für den Donnerkönig",
	["Thunder King's Citadel"] = "Zitadelle des Donnerkönigs",
	["Thunderlord Stronghold"] = "Donnerfeste",
	Thundermar = "Donnermar",
	["Thundermar Ruins"] = "Ruinen von Donnermar",
	["Thunderpaw Overlook"] = "Donnerpfotenausguck",
	["Thunderpaw Refuge"] = "Donnerpfotenrefugium",
	["Thunder Peak"] = "Donnergipfel",
	["Thunder Ridge"] = "Donnergrat",
	["Thunder's Call"] = "Donnersruf",
	["Thunderstrike Mountain"] = "Berg Donnerschlag",
	["Thunk's Abode"] = "Thunks Heimstatt",
	["Thuron's Livery"] = "Thurons Aufzucht",
	["Tian Monastery"] = "Tiankloster",
	["Tidefury Cove"] = "Tidenbucht",
	["Tides' Hollow"] = "Gezeitenhöhle",
	["Tideview Thicket"] = "Gezeitenblickdickicht",
	["Tigers' Wood"] = "Tigergehölz",
	["Timbermaw Hold"] = "Holzschlundfeste",
	["Timbermaw Post"] = "Holzschlundposten",
	["Tinkers' Court"] = "Tüftlerhof",
	["Tinker Town"] = "Tüftlerstadt",
	["Tiragarde Keep"] = "Burg Tiragarde",
	["Tirisfal Glades"] = "Tirisfal",
	["Tirth's Haunt"] = "Tirths Heimsuchung",
	["Tkashi Ruins"] = "Ruinen von Tkashi",
	["Tol Barad"] = "Tol Barad",
	["Tol Barad Peninsula"] = "Halbinsel von Tol Barad",
	["Tol'Vir Arena"] = "Arena der Tol'vir",
	["Tol'viron Arena"] = "Arena der Tol'vir",
	["Tol'Viron Arena"] = "Arena der Tol'vir",
	["Tomb of Conquerors"] = "Das Grab der Eroberer",
	["Tomb of Lights"] = "Grab des Lichts",
	["Tomb of Secrets"] = "Das Grab der Geheimnisse",
	["Tomb of Shadows"] = "Das Grab der Schatten",
	["Tomb of the Ancients"] = "Grab der Uralten",
	["Tomb of the Earthrager"] = "Grab des Erdwüters",
	["Tomb of the Lost Kings"] = "Gruft der Verlorenen Könige",
	["Tomb of the Sun King"] = "Grab des Sonnenkönigs",
	["Tomb of the Watchers"] = "Grab der Behüter",
	["Tombs of the Precursors"] = "Gräber der Wegbereiter",
	["Tome of the Unrepentant"] = "Foliant der Reuelosen",
	["Tome of the Unrepentant "] = "Foliant der Reuelosen",
	["Tor'kren Farm"] = "Tor'krens Hof",
	["Torp's Farm"] = "Torps Bauernhof",
	["Torseg's Rest"] = "Torsegs Ruheplatz",
	["Tor'Watha"] = "Tor'Watha",
	["Toryl Estate"] = "Toryls Grund",
	["Toshley's Station"] = "Toshleys Station",
	["To the Skies!"] = "In die Lüfte!",
	["To The Skies!"] = "In die Lüfte!",
	["Tower of Althalaxx"] = "Turm von Althalaxx",
	["Tower of Azora"] = "Turm von Azora",
	["Tower of Eldara"] = "Turm von Eldara",
	["Tower of Estulan"] = "Turm von Estulan",
	["Tower of Ilgalar"] = "Der Turm von Ilgalar",
	["Tower of the Damned"] = "Turm der Verdammten",
	["Tower Point"] = "Turmstellung",
	["Tower Watch"] = "Turmwacht",
	["Town-In-A-Box"] = "Instastadt",
	["Townlong Steppes"] = "Tonlongsteppe",
	["Town Square"] = "Ratsplatz",
	["Trade District"] = "Handelsdistrikt",
	["Trade Quarter"] = "Handwerksviertel",
	["Trader's Tier"] = "Händlertreppe",
	["Tradesmen's Terrace"] = "Die Terrasse der Händler",
	["Train Depot"] = "Zugdepot",
	["Training Grounds"] = "Ausbildungsgelände",
	["Training Quarters"] = "Übungsräume",
	["Traitor's Cove"] = "Verräterbucht",
	["Tranquil Coast"] = "Stille Küste",
	["Tranquil Gardens Cemetery"] = "Der Friedhof Stille Gärten",
	["Tranquil Grotto"] = "Stille Grotte",
	Tranquillien = "Tristessa",
	["Tranquil Shore"] = "Die Stille Küste",
	["Tranquil Wash"] = "Der Stille Strand",
	Transborea = "Transborea",
	["Transitus Shield"] = "Transitusschild",
	["Transport: Alliance Gunship"] = "Transport: Kanonenboot der Allianz",
	["Transport: Alliance Gunship (IGB)"] = "Transport: Kanonenboot der Allianz (IGB)",
	["Transport: Horde Gunship"] = "Transport: Kanonenboot der Horde",
	["Transport: Horde Gunship (IGB)"] = "Transport: Kanonenboot der Horde (IGB)",
	["Transport: Onyxia/Nefarian Elevator"] = "Transport: Onyxia/Nefarian-Fahrstuhl",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Transport: Die Stürmische Macht",
	["Trelleum Mine"] = "Trelleummine",
	["Trial of Fire"] = "Prüfung des Feuers",
	["Trial of Frost"] = "Prüfung des Frosts",
	["Trial of Shadow"] = "Prüfung des Schattens",
	["Trial of the Champion"] = "Prüfung des Champions",
	["Trial of the Champion Entrance"] = "Eingang zur Prüfung des Champions",
	["Trial of the Crusader"] = "Prüfung des Kreuzfahrers",
	["Trickling Passage"] = "Die Tropfende Passage",
	["Trogma's Claim"] = "Trogmas Besitz",
	["Trollbane Hall"] = "Trollbanns Halle",
	["Troll War Camp Outskirts"] = "Rand des Kriegslagers der Trolle",
	["Trophy Hall"] = "Trophäenhalle",
	["Troves of the Thunder King"] = "Schatzkammer des Donnerkönigs",
	["Trueshot Point"] = "Volltrefferposten",
	["Tuluman's Landing"] = "Tulumans Landeplatz",
	["Turtle Beach"] = "Schildkrötenstrand",
	["Tu Shen Burial Ground"] = "Tu-Shen-Begräbnisstätte",
	Tuurem = "Tuurem",
	["Twilight Aerie"] = "Zwielichthorst",
	["Twilight Altar of Storms"] = "Zwielichtaltar der Stürme",
	["Twilight Base Camp"] = "Basislager des Schattenhammers",
	["Twilight Bulwark"] = "Schattenbollwerk",
	["Twilight Camp"] = "Stützpunkt des Schattenhammers",
	["Twilight Command Post"] = "Schattenkommandoposten",
	["Twilight Crossing"] = "Zwielichtkreuzung",
	["Twilight Forge"] = "Zwielichtschmiede",
	["Twilight Grove"] = "Zwielichtshain",
	["Twilight Highlands"] = "Schattenhochland",
	["Twilight Highlands Dragonmaw Phase"] = "Twilight Highlands Dragonmaw Phase",
	["Twilight Highlands Phased Entrance"] = "Twilight Highlands Phased Entrance",
	["Twilight Highlands Zeppelin 1"] = "Zeppelin des Schattenhochlands 1",
	["Twilight Highlands Zeppelin 2"] = "Zeppelin des Schattenhochlands 2",
	["Twilight Outpost"] = "Außenposten des Schattenhammers",
	["Twilight Overlook"] = "Zwielichtwarte",
	["Twilight Post"] = "Posten des Schattenhammers",
	["Twilight Precipice"] = "Zwielichthang",
	["Twilight Shore"] = "Zwielichtufer",
	["Twilight's Run"] = "Kavernen des Schattenhammers",
	["Twilight Terrace"] = "Zwielichtterrasse",
	["Twilight Vale"] = "Zwielichttal",
	["Twinbraid's Patrol"] = "Doppelzopfs Patrouille",
	["Twin Peaks"] = "Zwillingsgipfel",
	["Twin Shores"] = "Zwillingsküste",
	["Twinspire Keep"] = "Burg Zwillingsfels",
	["Twinspire Keep Interior"] = "Das Innere der Burg Zwillingsfels",
	["Twin Spire Ruins"] = "Ruinen der Zwillingsspitze",
	["Twisting Nether"] = "Wirbelnder Nether",
	["Tyr's Hand"] = "Tyrs Hand",
	["Tyr's Hand Abbey"] = "Abtei von Tyrs Hand",
	["Tyr's Terrace"] = "Tyrs Terrasse",
	["Ufrang's Hall"] = "Ufrangs Halle",
	Uldaman = "Uldaman",
	["Uldaman Entrance"] = "Eingang nach Uldaman",
	Uldis = "Uldis",
	Ulduar = "Ulduar",
	["Ulduar Raid - Interior - Insertion Point"] = "Ulduar Raid - Inneres - Startpunkt",
	["Ulduar Raid - Iron Concourse"] = "Ulduar Raid - Der Eisenstau",
	Uldum = "Uldum",
	["Uldum Phased Entrance"] = "Uldum Phased Entrance",
	["Uldum Phase Oasis"] = "Uldum Phase Oasis",
	["Uldum - Phase Wrecked Camp"] = "Uldum - Zerstörtes Lager",
	["Umbrafen Lake"] = "Umbrafennsee",
	["Umbrafen Village"] = "Umbrafenn",
	["Uncharted Sea"] = "Unerforschtes Meer",
	Undercity = "Unterstadt",
	["Underlight Canyon"] = "Tiefenlichtkluft",
	["Underlight Mines"] = "Grubenlichtminen",
	["Unearthed Grounds"] = "Grabstätte",
	["Unga Ingoo"] = "Unga Ingu",
	["Un'Goro Crater"] = "Krater von Un'Goro",
	["Unu'pe"] = "Unu'pe",
	["Unyielding Garrison"] = "Die Unnachgiebige Garnison",
	["Upper Silvermarsh"] = "Obere Silbermarschen",
	["Upper Sumprushes"] = "Sumpfbinsenhöhe",
	["Upper Veil Shil'ak"] = "Oberes Shil'akversteck",
	["Ursoc's Den"] = "Ursocs Höhle",
	Ursolan = "Ursolan",
	["Utgarde Catacombs"] = "Katakomben von Utgarde",
	["Utgarde Keep"] = "Burg Utgarde",
	["Utgarde Keep Entrance"] = "Eingang zur Burg Utgarde",
	["Utgarde Pinnacle"] = "Turm Utgarde",
	["Utgarde Pinnacle Entrance"] = "Eingang zum Turm Utgarde",
	["Uther's Tomb"] = "Uthers Grabmal",
	["Valaar's Berth"] = "Valaars Steg",
	["Vale of Eternal Blossoms"] = "Tal der Ewigen Blüten",
	["Valgan's Field"] = "Valgans Feld",
	Valgarde = "Valgarde",
	["Valgarde Port"] = "Hafen von Valgarde",
	Valhalas = "Valhalas",
	["Valiance Keep"] = "Valianzfeste",
	["Valiance Landing Camp"] = "Valianzlager",
	["Valiant Rest"] = "Zur Wackeren Einkehr",
	Valkyrion = "Valkyrion",
	["Valley of Ancient Winters"] = "Das Uralte Wintertal",
	["Valley of Ashes"] = "Tal der Asche",
	["Valley of Bones"] = "Tal der Knochen",
	["Valley of Echoes"] = "Tal der Echos",
	["Valley of Emperors"] = "Das Tal der Kaiser",
	["Valley of Fangs"] = "Fangzahntal",
	["Valley of Heroes"] = "Das Tal der Helden",
	["Valley Of Heroes"] = "Tal der Helden",
	["Valley of Honor"] = "Tal der Ehre",
	["Valley of Kings"] = "Tal der Könige",
	["Valley of Power"] = "Das Tal der Macht",
	["Valley Of Power - Scenario"] = "Das Tal der Macht - Szenario",
	["Valley of Spears"] = "Tal der Speere",
	["Valley of Spirits"] = "Tal der Geister",
	["Valley of Strength"] = "Tal der Stärke",
	["Valley of the Bloodfuries"] = "Tal der Blutfurien",
	["Valley of the Four Winds"] = "Tal der Vier Winde",
	["Valley of the Watchers"] = "Tal der Behüter",
	["Valley of Trials"] = "Tal der Prüfungen",
	["Valley of Wisdom"] = "Tal der Weisheit",
	Valormok = "Valormok",
	["Valor's Edge"] = "Die Klinge der Tapferkeit",
	["Valor's Rest"] = "Heldenwacht",
	["Valorwind Lake"] = "Ehrenwindsee",
	["Vanguard Infirmary"] = "Feldlazarett der Vorhut",
	["Vanndir Encampment"] = "Vanndirlager",
	["Vargoth's Retreat"] = "Erzmagier Vargoths Rückzugsort",
	["Vashj'elan Spawning Pool"] = "Laichbecken von Vashj'elan",
	["Vashj'ir"] = "Vashj'ir",
	["Vashj'ir Sub - Alliance"] = "Vashj'ir Sub - Alliance",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Vashj'ir Sub - Alliance circling Abyssal Maw",
	["Vashj'ir Sub - Horde"] = "Vashj'ir Sub - Horde",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Vashj'ir Sub - Horde - Circling Abyssal Maw",
	["Vault of Archavon"] = "Archavons Kammer",
	["Vault of Ironforge"] = "Tresor von Eisenschmiede",
	["Vault of Kings Past"] = "Gewölbe der Vergangenen Könige",
	["Vault of the Ravenian"] = "Gewölbe des Raveniers",
	["Vault of the Shadowflame"] = "Gewölbe der Schattenflamme",
	["Vault of Y'Shaarj"] = "Kammer von Y'Shaarj",
	["Veil Ala'rak"] = "Ala'rakversteck",
	["Veil Harr'ik"] = "Harr'ikversteck",
	["Veil Lashh"] = "Lashhversteck",
	["Veil Lithic"] = "Lithicversteck",
	["Veil Reskk"] = "Reskkversteck",
	["Veil Rhaze"] = "Rhazeversteck",
	["Veil Ruuan"] = "Ruuanversteck",
	["Veil Sethekk"] = "Sethekkversteck",
	["Veil Shalas"] = "Shalasversteck",
	["Veil Shienor"] = "Shienorversteck",
	["Veil Skith"] = "Skithversteck",
	["Veil Vekh"] = "Vekhversteck",
	["Vekhaar Stand"] = "Vekhaar",
	["Velaani's Arcane Goods"] = "Velannis Arkanarien",
	["Vendetta Point"] = "Vendettakuppe",
	["Vengeance Landing"] = "Hafen der Vergeltung",
	["Vengeance Landing Inn"] = "Gasthaus des Hafens der Vergeltung",
	["Vengeance Landing Inn, Howling Fjord"] = "Gasthaus des Hafens der Vergeltung, Heulender Fjord",
	["Vengeance Lift"] = "Blutklammlift",
	["Vengeance Pass"] = "Pass der Vergeltung",
	["Vengeance Wake"] = "Sog der Vergeltung",
	["Venomous Ledge"] = "Giftige Klippe",
	Venomspite = "Gallgrimm",
	["Venomsting Pits"] = "Giftstechergruben",
	["Venomweb Vale"] = "Giftwebertal",
	["Venture Bay"] = "Venturebucht",
	["Venture Co. Base Camp"] = "Stützpunkt der Venture Co.",
	["Venture Co. Operations Center"] = "Arbeitszentrale der Venture Co.",
	["Verdant Belt"] = "Grüner Gürtel",
	["Verdant Highlands"] = "Das Tiefgrüne Hochland",
	["Verdantis River"] = "Verdantis",
	["Veridian Point"] = "Viridiangrund",
	["Verlok Stand"] = "Wacht Verlok",
	["Vermillion Redoubt"] = "Zinnoberrefugium",
	["Verming Tunnels Micro"] = "Shed-Ling-Tunnel",
	["Verrall Delta"] = "Flussdelta des Verrall",
	["Verrall River"] = "Verrall",
	["Victor's Point"] = "Gipfel des Siegers",
	["Vileprey Village"] = "Vil'prajidorf",
	["Vim'gol's Circle"] = "Vim'gols Kreis",
	["Vindicator's Rest"] = "Verteidigers Ruh'",
	["Violet Citadel Balcony"] = "Balkon der Violetten Zitadelle",
	["Violet Hold"] = "Violette Festung",
	["Violet Hold Entrance"] = "Eingang zur Violetten Festung",
	["Violet Rise"] = "Die Violette Erhebung",
	["Violet Stand"] = "Die Violette Wacht",
	["Virmen Grotto"] = "Shed-Ling-Grotte",
	["Virmen Nest"] = "Shed-Ling-Nest",
	["Vir'naal Dam"] = "Vir'naaldamm",
	["Vir'naal Lake"] = "Der Vir'naalsee",
	["Vir'naal Oasis"] = "Die Vir'naaloase",
	["Vir'naal River"] = "Der Vir'naal",
	["Vir'naal River Delta"] = "Das Vir'naaldelta",
	["Void Ridge"] = "Leerengrat",
	["Voidwind Plateau"] = "Leerenwindplateau",
	["Volcanoth's Lair"] = "Volcanoths Hort",
	["Voldrin's Hold"] = "Voldrins Mut",
	Voldrune = "Voldrune",
	["Voldrune Dwelling"] = "Voldrunenbehausung",
	Voltarus = "Voltarus",
	["Vordrassil Pass"] = "Pass von Vordrassil",
	["Vordrassil's Heart"] = "Vordrassils Herz",
	["Vordrassil's Limb"] = "Vordrassils Ast",
	["Vordrassil's Tears"] = "Vordrassils Tränen",
	["Vortex Pinnacle"] = "Der Vortexgipfel",
	["Vortex Summit"] = "Vortexgipfel",
	["Vul'Gol Ogre Mound"] = "Ogerhort Vul'Gol",
	["Vyletongue Seat"] = "Schlangenzunges Sitz",
	["Wahl Cottage"] = "Wahls Landhaus",
	["Wailing Caverns"] = "Die Höhlen des Wehklagens",
	["Walk of Elders"] = "Straße der Urahnen",
	["Warbringer's Ring"] = "Ring des Kriegshetzers",
	["Warchief's Lookout"] = "Spähposten des Kriegshäuptlings",
	["Warden's Cage"] = "Kerker des Wächters",
	["Warden's Chambers"] = "Räume des Warters",
	["Warden's Vigil"] = "Hüterwacht",
	["Warlock Area"] = "Hexenmeistergebiet",
	["Warmaul Hill"] = "Totschlägerhügel",
	["Warpwood Quarter"] = "Wucherborkenviertel",
	["War Quarter"] = "Kriegsviertel",
	["Warrior's Terrace"] = "Die Terrasse der Krieger",
	["War Room"] = "Kriegsraum",
	Warship = "Kriegsschiff",
	["Warsong Camp"] = "Kriegshymnenlager",
	["Warsong Farms Outpost"] = "Höfe des Kriegshymnenklans",
	["Warsong Flag Room"] = "Flaggenraum des Kriegshymnenklans",
	["Warsong Granary"] = "Kornkammer des Kriegshymnenklans",
	["Warsong Gulch"] = "Kriegshymnenschlucht",
	["Warsong Hold"] = "Kriegshymnenfeste",
	["Warsong Jetty"] = "Landebrücke des Kriegshymnenklans",
	["Warsong Labor Camp"] = "Lager des Kriegshymnenklans",
	["Warsong Lumber Camp"] = "Holzfällerlager des Kriegshymnenklans",
	["Warsong Lumber Mill"] = "Sägewerk des Kriegshymnenklans",
	["Warsong Slaughterhouse"] = "Schlachthof des Kriegshymnenklans",
	["Watcher's Sanctum"] = "Das Sanktum des Wächters",
	["Watchers' Terrace"] = "Terrasse der Wächter",
	["Waterspeaker's Sanctuary"] = "Heiligtum des Wassersprechers",
	["Waterspring Field"] = "Wasserfeld",
	Waterworks = "Wasserwerke",
	["Wavestrider Beach"] = "Wellenschreiterstrand",
	Waxwood = "Wachsgehölz",
	["Wayfarer's Rest"] = "Wanderers Ruh'",
	Waygate = "Das Tor",
	["Wayne's Refuge"] = "Waynes Zuflucht",
	["Weazel's Crater"] = "Weazels Krater",
	["Webwinder Hollow"] = "Weberkuhle",
	["Webwinder Path"] = "Weberpass",
	["Weeping Quarry"] = "Der Tränenbruch",
	["Well of Eternity"] = "Brunnen der Ewigkeit",
	["Well of the Forgotten"] = "Brunnen der Vergessenen",
	["Wellson Shipyard"] = "Wellsons Werft",
	["Wellspring Hovel"] = "Die Hütte am Quell",
	["Wellspring Lake"] = "Quellsee",
	["Wellspring River"] = "Quellfluss",
	["Westbrook Garrison"] = "Weststromgarnison",
	["Western Bridge"] = "Westliche Brücke",
	["Western Plaguelands"] = "Westliche Pestländer",
	["Western Strand"] = "Weststrand",
	Westersea = "Westermeer",
	Westfall = "Westfall",
	["Westfall Brigade"] = "Westfallbrigade",
	["Westfall Brigade Encampment"] = "Lager der Westfallbrigade",
	["Westfall Lighthouse"] = "Der Leuchtturm von Westfall",
	["West Garrison"] = "Westgarnison",
	["Westguard Inn"] = "Gasthaus der Westwacht",
	["Westguard Keep"] = "Westwacht",
	["Westguard Turret"] = "Turm der Westwacht",
	["West Pavilion"] = "Westlicher Pavillon",
	["West Pillar"] = "Westsäule",
	["West Point Station"] = "Weststation",
	["West Point Tower"] = "Westwacht",
	["Westreach Summit"] = "Der Westliche Gipfel",
	["West Sanctum"] = "Sanktum des Westens",
	["Westspark Workshop"] = "Werkstatt Westfunk",
	["West Spear Tower"] = "Westspeerturm",
	["West Spire"] = "Westturm",
	["Westwind Lift"] = "Aufzug am Flüchtlingslager",
	["Westwind Refugee Camp"] = "Flüchtlingslager von Westwind",
	["Westwind Rest"] = "Westwindruhestätte",
	Wetlands = "Sumpfland",
	Wheelhouse = "Radhaus",
	["Whelgar's Excavation Site"] = "Whelgars Ausgrabungsstätte",
	["Whelgar's Retreat"] = "Whelgars Zuflucht",
	["Whispercloud Rise"] = "Flüsterwolkenhöhe",
	["Whisper Gulch"] = "Flüsterschlucht",
	["Whispering Forest"] = "Der Flüsternde Wald",
	["Whispering Gardens"] = "Flüstergärten",
	["Whispering Inlet"] = "Flüsternder Meeresarm",
	["Whispering Shore"] = "Die Flüsternde Küste",
	["Whispering Stones"] = "Die Flüsternden Steine",
	["Whisperwind Grove"] = "Wisperwindhain",
	["Whistling Grove"] = "Der Rauschende Hain",
	["Whitebeard's Encampment"] = "Weißbarts Lager",
	["Whitepetal Lake"] = "Weißblütensee",
	["White Pine Trading Post"] = "Handelsposten Weißkiefer",
	["Whitereach Post"] = "Weißgipfelposten",
	["Wildbend River"] = "Wildschnellen",
	["Wildervar Mine"] = "Mine von Wildervar",
	["Wildflame Point"] = "Wildflammenspitze",
	["Wildgrowth Mangal"] = "Wildwuchsmangal",
	["Wildhammer Flag Room"] = "Flaggenraum des Wildhammerklans",
	["Wildhammer Keep"] = "Burg Wildhammer",
	["Wildhammer Stronghold"] = "Wildhammerfeste",
	["Wildheart Point"] = "Wildherzens Lager",
	["Wildmane Water Well"] = "Brunnen der Wildmähnen",
	["Wild Overlook"] = "Die Wilde Aussicht",
	["Wildpaw Cavern"] = "Höhle der Wildpfoten",
	["Wildpaw Ridge"] = "Wildpfotengrat",
	["Wilds' Edge Inn"] = "Zum Waldrand",
	["Wild Shore"] = "Die Wilden Ufer",
	["Wildvine Marsh"] = "Wildrankensumpf",
	["Wildwind Lake"] = "Wildwindsee",
	["Wildwind Path"] = "Wildwindpfad",
	["Wildwind Peak"] = "Wildwindgipfel",
	["Windbreak Canyon"] = "Schlucht der Heulenden Winde",
	["Windfury Ridge"] = "Windfurienkamm",
	["Windrunner's Overlook"] = "Windläufers Warte",
	["Windrunner Spire"] = "Windläuferturm",
	["Windrunner Village"] = "Windläuferdorf",
	["Winds' Edge"] = "Die Windschneide",
	["Windshear Crag"] = "Die Scherwindklippe",
	["Windshear Heights"] = "Scherwindhöhen",
	["Windshear Hold"] = "Scherwindfeste",
	["Windshear Mine"] = "Scherwindmine",
	["Windshear Valley"] = "Scherwindtal",
	["Windspire Bridge"] = "Windspitzenbrücke",
	["Windward Isle"] = "Windwärtsinsel",
	["Windy Bluffs"] = "Die Windigen Klippen",
	["Windyreed Pass"] = "Schilftanzpass",
	["Windyreed Village"] = "Schilftanz",
	["Winterax Hold"] = "Feste der Winterax",
	["Winterbough Glade"] = "Winterastlichtung",
	["Winterfall Village"] = "Lager der Winterfelle",
	["Winterfin Caverns"] = "Höhlen der Winterflossen",
	["Winterfin Retreat"] = "Zuflucht der Winterflossen",
	["Winterfin Village"] = "Dorf der Winterflossen",
	["Wintergarde Crypt"] = "Gruft von Wintergarde",
	["Wintergarde Keep"] = "Feste Wintergarde",
	["Wintergarde Mausoleum"] = "Mausoleum von Wintergarde",
	["Wintergarde Mine"] = "Minen von Wintergarde",
	Wintergrasp = "Tausendwinter",
	["Wintergrasp Fortress"] = "Tausendwinterfestung",
	["Wintergrasp River"] = "Tausendwinterfluss",
	["Winterhoof Water Well"] = "Brunnen der Winterhufe",
	["Winter's Blossom"] = "Winterblüte",
	["Winter's Breath Lake"] = "Winterhauchsee",
	["Winter's Edge Tower"] = "Wintersturzturm",
	["Winter's Heart"] = "Winterherz",
	Winterspring = "Winterquell",
	["Winter's Terrace"] = "Terrasse des Winters",
	["Witch Hill"] = "Hexenhügel",
	["Witch's Sanctum"] = "Sanktum der Hexe",
	["Witherbark Caverns"] = "Höhlen der Bleichborken",
	["Witherbark Village"] = "Lager der Bleichborken",
	["Withering Thicket"] = "Das Welkende Dickicht",
	["Wizard Row"] = "Zaubergasse",
	["Wizard's Sanctum"] = "Magiersanktum",
	["Wolf's Run"] = "Wolfsschlucht",
	["Woodpaw Den"] = "Waldpfotenbau",
	["Woodpaw Hills"] = "Waldpfotenhügel",
	["Wood's End Cabin"] = "Waldrandhütte",
	["Woods of the Lost"] = "Wälder der Verlorenen",
	Workshop = "Werkstatt",
	["Workshop Entrance"] = "Eingang zur Werkstatt",
	["World's End Tavern"] = "Taverne Weltenend",
	["Wrathscale Lair"] = "Hassprankenzuflucht",
	["Wrathscale Point"] = "Hassprankenterritorium",
	["Wreckage of the Silver Dawning"] = "Wrack der Silbermorgen",
	["Wreck of Hellscream's Fist"] = "Wrack der Höllschreis Faust",
	["Wreck of the Mist-Hopper"] = "Wrack der Nebelhüpfer",
	["Wreck of the Skyseeker"] = "Wrack der Himmelssucher",
	["Wreck of the Vanguard"] = "Wrack der Herold",
	["Writhing Mound"] = "Der Gequälte Hügel",
	Writhingwood = "Windegehölz",
	["Wu-Song Village"] = "Wu-Song",
	Wyrmbog = "Der Drachensumpf",
	["Wyrmbreaker's Rookery"] = "Wyrmbrechers Hort",
	["Wyrmrest Summit"] = "Spitze des Wyrmruhtempels",
	["Wyrmrest Temple"] = "Wyrmruhtempel",
	["Wyrmrest Temple - bottom to middle"] = "Wyrmrest Temple - bottom to middle",
	["Wyrmrest Temple - bottom to top"] = "Wyrmruhtempel - von unten bis oben",
	["Wyrmrest Temple - middle to bottom"] = "Wyrmrest Temple - middle to bottom",
	["Wyrmrest Temple - middle to top"] = "Wyrmrest Temple - middle to top",
	["Wyrmrest Temple - top to bottom"] = "Wyrmruhtempel - von oben bis unten",
	["Wyrmrest Temple - top to middle"] = "Wyrmrest Temple - top to middle",
	["Wyrms' Bend"] = "Die Wyrmbiege",
	["Wyrmscar Island"] = "Insel Drachenfels",
	["Wyrmskull Bridge"] = "Brücke des Wyrmschädels",
	["Wyrmskull Tunnel"] = "Tunnel des Wyrmschädels",
	["Wyrmskull Village"] = "Wyrmskol",
	["X-2 Pincer"] = "X-2-Kneifer",
	Xavian = "Xavian",
	["Yan-Zhe River"] = "Der Huangtze",
	["Yeti Mountain Basecamp"] = "Basislager am Yetiberg",
	["Yinying Village"] = "Yinying",
	Ymirheim = "Ymirheim",
	["Ymiron's Seat"] = "Ymirons Sitz",
	["Yojamba Isle"] = "Die Insel Yojamba",
	["Yowler's Den"] = "Jaulers Höhle",
	["Zabra'jin"] = "Zabra'jin",
	["Zaetar's Choice"] = "Zaetars Entscheidung",
	["Zaetar's Grave"] = "Zaetars Grab",
	["Zalashji's Den"] = "Zalashjis Bau",
	["Zalazane's Fall"] = "Zalazanes Sturz",
	["Zane's Eye Crater"] = "Zanes Augenkrater",
	Zangarmarsh = "Zangarmarschen",
	["Zangar Ridge"] = "Zangarkamm",
	["Zan'vess"] = "Zan'vess",
	["Za'Tual"] = "Za'Tual",
	["Zeb'Halak"] = "Zeb'Halak",
	["Zeb'Nowa"] = "Zeb'Nowa",
	["Zeb'Sora"] = "Zeb'Sora",
	["Zeb'Tela"] = "Zeb'Tela",
	["Zeb'tula"] = "Zeb'tula",
	["Zeb'Watha"] = "Zeb'Watha",
	["Zeppelin Crash"] = "Zeppelinabsturzstelle",
	Zeramas = "Zeramas",
	["Zeth'Gor"] = "Zeth'Gor",
	["Zhu Province"] = "Provinz Zhu",
	["Zhu's Descent"] = "Zhus Abstieg",
	["Zhu's Watch"] = "Zhus Wacht",
	["Ziata'jai Ruins"] = "Ruinen von Ziata'jai",
	["Zim'Abwa"] = "Zim'Abwa",
	["Zim'bo's Hideout"] = "Zim'bos Versteck",
	["Zim'Rhuk"] = "Zim'Rhuk",
	["Zim'Torga"] = "Zim'Torga",
	["Zol'Heb"] = "Zol'Heb",
	["Zol'Maz Stronghold"] = "Festung Zol'Maz",
	["Zoram'gar Outpost"] = "Außenposten von Zoram'gar",
	["Zouchin Province"] = "Provinz Zouchin",
	["Zouchin Strand"] = "Zouchinstrand",
	["Zouchin Village"] = "Zouchin",
	["Zul'Aman"] = "Zul'Aman",
	["Zul'Drak"] = "Zul'Drak",
	["Zul'Farrak"] = "Zul'Farrak",
	["Zul'Farrak Entrance"] = "Eingang nach Zul'Farrak",
	["Zul'Gurub"] = "Zul'Gurub",
	["Zul'Mashar"] = "Zul'Mashar",
	["Zun'watha"] = "Zun'watha",
	["Zuuldaia Ruins"] = "Ruinen von Zuuldaia",
}

elseif GAME_LOCALE == "itIT" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "Campo della VII Legione",
	["7th Legion Front"] = "Fronte della VII Legione",
	["7th Legion Submarine"] = "Sottomarino della VII Legione",
	["Abandoned Armory"] = "Armeria Abbandonata",
	["Abandoned Camp"] = "Bivacco Abbandonato",
	["Abandoned Mine"] = "Miniera Abbandonata",
	["Abandoned Reef"] = "Distesa Sterile",
	["Above the Frozen Sea"] = "Sopra il Mare Ghiacciato",
	["A Brewing Storm"] = "Tempesta Alcolica",
	["Abyssal Breach"] = "Breccia Abissale",
	["Abyssal Depths"] = "Profondità Abissali",
	["Abyssal Halls"] = "Sale Abissali",
	["Abyssal Maw"] = "Fauci dell'Abisso",
	["Abyssal Maw Exterior"] = "Esterno delle Fauci dell'Abisso",
	["Abyssal Sands"] = "Sabbie Abissali",
	["Abyssion's Lair"] = "Antro di Abyssion",
	["Access Shaft Zeon"] = "Pozzo d'Accesso Zeon",
	["Acherus: The Ebon Hold"] = "Acherus, la Roccaforte d'Ebano",
	["Addle's Stead"] = "Cascina degli Addle",
	["Aderic's Repose"] = "Cimitero di Aderic",
	["Aerie Peak"] = "Picco dell'Aquila",
	["Aeris Landing"] = "Approdo di Aeris",
	["Agamand Family Crypt"] = "Cripta degli Agamand",
	["Agamand Mills"] = "Mulini degli Agamand",
	["Agmar's Hammer"] = "Martello di Agmar",
	["Agmond's End"] = "Fossa di Agmond",
	["Agol'watha"] = "Agol'watha",
	["A Hero's Welcome"] = "Locanda degli Eroi",
	["Ahn'kahet: The Old Kingdom"] = "Ahn'Kahet, il Regno Antico",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Ingresso ad Ahn'Kahet, il Regno Antico",
	["Ahn Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj Temple"] = "Tempio di Ahn'Qiraj",
	["Ahn'Qiraj Terrace"] = "Terrazza di Ahn'Qiraj",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ahn'Qiraj: il Regno Perduto",
	["Akhenet Fields"] = "Campi di Akhenet",
	["Aku'mai's Lair"] = "Antro di Aku'mai",
	["Alabaster Shelf"] = "Piattaforma d'Alabastro",
	["Alcaz Island"] = "Isola di Alcaz",
	["Aldor Rise"] = "Poggio degli Aldor",
	Aldrassil = "Aldrassil",
	["Aldur'thar: The Desolation Gate"] = "Aldur'thar, Cancello della Desolazione",
	["Alexston Farmstead"] = "Cascina degli Alexston",
	["Algaz Gate"] = "Porta di Algaz",
	["Algaz Station"] = "Avamposto di Algaz",
	["A Little Patience"] = "Armarsi di Pazienza",
	["Allen Farmstead"] = "Fattoria degli Allen",
	["Allerian Post"] = "Accampamento di Alleria",
	["Allerian Stronghold"] = "Fortezza di Alleria",
	["Alliance Base"] = "Base dell'Alleanza",
	["Alliance Beach Daily Area"] = "Area Giornaliera Spiaggia dell'Alleanza",
	["Alliance Beachhead"] = "Testa di Ponte dell'Alleanza",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Area Alleanza - Progresso Scenario Isola del Tuono",
	["Alliance Keep"] = "Forte dell'Alleanza",
	["Alliance Mercenary Ship to Vashj'ir"] = "Nave Mercenaria Alleata per Vashj'ir",
	["Alliance PVP Barracks"] = "Caserme PvP dell'Alleanza",
	["All That Glitters Prospecting Co."] = "Società d'Estrazione Brilla e Sfavilla",
	["Alonsus Chapel"] = "Cappella di Alonsus",
	["Altar of Ascension"] = "Altare dell'Ascesa",
	["Altar of Har'koa"] = "Altare di Har'koa",
	["Altar of Mam'toth"] = "Altare di Mam'toth",
	["Altar of Quetz'lun"] = "Altare di Quetz'lun",
	["Altar of Rhunok"] = "Altare di Rhunok",
	["Altar of Sha'tar"] = "Altare degli Sha'tar",
	["Altar of Sseratus"] = "Altare di Sseratus",
	["Altar of Storms"] = "Altare delle Tempeste",
	["Altar of the Blood God"] = "Altare del Dio del Sangue",
	["Altar of Twilight"] = "Altare del Crepuscolo",
	["Alterac Mountains"] = "Montagne d'Alterac",
	["Alterac Valley"] = "Valle d'Alterac",
	["Alther's Mill"] = "Segheria di Alther",
	["Amani Catacombs"] = "Catacombe degli Amani",
	["Amani Mountains"] = "Montagne degli Amani",
	["Amani Pass"] = "Passo degli Amani",
	["Amberfly Bog"] = "Foschia Ambrata",
	["Amberglow Hollow"] = "Antro del Bagliore d'Ambra",
	["Amber Ledge"] = "Scogliera d'Ambra",
	Ambermarsh = "Pozze d'Ambra",
	Ambermill = "Mulino d'Ambra",
	["Amberpine Lodge"] = "Rifugio di Pinambrato",
	["Amber Quarry"] = "Cava d'Ambra",
	["Amber Research Sanctum"] = "Santuario di Ricerca dell'Ambra",
	["Ambershard Cavern"] = "Caverna di Ambra Scheggiata",
	["Amberstill Ranch"] = "Tenuta di Ambraquieta",
	["Amberweb Pass"] = "Passo Tela d'Ambra",
	["Ameth'Aran"] = "Ameth'Aran",
	["Ammen Fields"] = "Campi di Ammen",
	["Ammen Ford"] = "Guado di Ammen",
	["Ammen Vale"] = "Valle di Ammen",
	["Amphitheater of Anguish"] = "Anfiteatro del Tormento",
	["Ampitheater of Anguish"] = "Crogiolo della Carneficina",
	["Ancestral Grounds"] = "Terre Ancestrali",
	["Ancestral Rise"] = "Altura Ancestrale",
	["Ancient Courtyard"] = "Corte Antica",
	["Ancient Zul'Gurub"] = "Zul'Gurub Antica",
	["An'daroth"] = "An'daroth",
	["Andilien Estate"] = "Padiglione di Andilien",
	Andorhal = "Andorhal",
	Andruk = "Andruk",
	["Angerfang Encampment"] = "Accampamento Zannarabbiosa",
	["Angkhal Pavilion"] = "Padiglione Angkhal",
	["Anglers Expedition"] = "Spedizione dei Lancialenza",
	["Anglers Wharf"] = "Palafitte dei Lancialenza",
	["Angor Fortress"] = "Fortezza di Angor",
	["Ango'rosh Grounds"] = "Terre degli Ango'rosh",
	["Ango'rosh Stronghold"] = "Roccaforte degli Ango'rosh",
	["Angrathar the Wrathgate"] = "Angrathar, Cancello dell'Ira",
	["Angrathar the Wrath Gate"] = "Angrathar, Cancello dell'Ira",
	["An'owyn"] = "An'owyn",
	["An'telas"] = "An'telas",
	["Antonidas Memorial"] = "Monumento ad Antonidas",
	Anvilmar = "Forgiamara",
	["Anvil of Conflagration"] = "Incudine della Conflagrazione",
	["Apex Point"] = "Apogeo",
	["Apocryphan's Rest"] = "Riposo dell'Apocrifano",
	["Apothecary Camp"] = "Accampamento dello Speziale",
	["Applebloom Tavern"] = "Taverna degli Sboccia Mele",
	["Arathi Basin"] = "Bacino d'Arathi",
	["Arathi Highlands"] = "Altopiani d'Arathi",
	["Arcane Pinnacle"] = "Pinnacolo Arcano",
	["Archmage Vargoth's Retreat"] = "Studio dell'Arcimago Vargoth",
	["Area 52"] = "Area 52",
	["Arena Floor"] = "Terreno dell'Arena",
	["Arena of Annihilation"] = "Arena dell'Annientamento",
	["Argent Pavilion"] = "Padiglione d'Argento",
	["Argent Stand"] = "Bastione d'Argento",
	["Argent Tournament Grounds"] = "Campi del Torneo d'Argento",
	["Argent Vanguard"] = "Avanguardia d'Argento",
	["Ariden's Camp"] = "Accampamento di Ariden",
	["Arikara's Needle"] = "Guglia di Arikara",
	["Arklonis Ridge"] = "Cresta di Arklonis",
	["Arklon Ruins"] = "Rovine di Arklon",
	["Arriga Footbridge"] = "Passerella di Arriga",
	["Arsad Trade Post"] = "Bazar di Arsad",
	["Ascendant's Rise"] = "Altura dell'Ascesa",
	["Ascent of Swirling Winds"] = "Ascesa dei Venti Turbinanti",
	["Ashen Fields"] = "Campi Cinerei",
	["Ashen Lake"] = "Lago delle Ceneri",
	Ashenvale = "Valtetra",
	["Ashwood Lake"] = "Lago di Legno Secco",
	["Ashwood Post"] = "Postazione Legno Secco",
	["Aspen Grove Post"] = "Postazione Vecchio Pioppo",
	["Assault on Shaol'mara"] = "Assalto a Shaol'mara",
	["Assault on Zan'vess"] = "Assalto a Zan'vess",
	["Assault on Zeb'tula"] = "Assalto a Zeb'tula",
	Astranaar = "Astranaar",
	["Ata'mal Terrace"] = "Terrazza di Ata'mal",
	Athenaeum = "Ateneo",
	["Atrium of the Heart"] = "Atrio del Cuore",
	["Atulhet's Tomb"] = "Tomba di Atulhet",
	["Auberdine Refugee Camp"] = "Campo dei Rifugiati di Auberdine",
	["Auburn Bluffs"] = "Rupi Ramate",
	["Auchenai Crypts"] = "Cripte degli Auchenai",
	["Auchenai Grounds"] = "Terre degli Auchenai",
	Auchindoun = "Auchindoun",
	["Auchindoun: Auchenai Crypts"] = "Auchindoun: Cripte degli Auchenai",
	["Auchindoun - Auchenai Crypts Entrance"] = "Ingresso alle Cripte degli Auchenai di Auchindoun",
	["Auchindoun: Mana-Tombs"] = "Auchindoun: Tombe del Mana",
	["Auchindoun - Mana-Tombs Entrance"] = "Ingresso alle Tombe del Mana di Auchindoun",
	["Auchindoun: Sethekk Halls"] = "Auchindoun: Sale dei Sethekk",
	["Auchindoun - Sethekk Halls Entrance"] = "Ingresso alle Sale dei Sethekk di Auchindoun",
	["Auchindoun: Shadow Labyrinth"] = "Auchindoun: Labirinto delle Ombre",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Ingresso al Labirinto delle Ombre di Auchindoun",
	["Auren Falls"] = "Cascate di Auren",
	["Auren Ridge"] = "Cresta di Auren",
	["Autumnshade Ridge"] = "Crinale dell'Ombra Autunnale",
	["Avalanchion's Vault"] = "Cava di Valanghion",
	Aviary = "Voliera",
	["Axis of Alignment"] = "Asse di Allineamento",
	Axxarien = "Axxarien",
	["Azjol-Nerub"] = "Azjol-Nerub",
	["Azjol-Nerub Entrance"] = "Ingresso ad Azjol-Nerub",
	Azshara = "Azshara",
	["Azshara Crater"] = "Cratere di Azshara",
	["Azshara's Palace"] = "Palazzo di Azshara",
	["Azurebreeze Coast"] = "Costa di Brezzazzurra",
	["Azure Dragonshrine"] = "Santuario dei Draghi di Zaffiro",
	["Azurelode Mine"] = "Miniera di Venazzurra",
	["Azuremyst Isle"] = "Isola Brumazzurra",
	["Azure Watch"] = "Presidio Azzurro",
	["Backbreaker Bay"] = "Baia dello Spaccaschiena",
	Badlands = "Maleterre",
	["Bael'dun Digsite"] = "Scavi di Bael'dun",
	["Bael'dun Keep"] = "Forte di Bael'dun",
	["Baelgun's Excavation Site"] = "Scavi di Baelgun",
	["Bael Modan"] = "Bael Modan",
	["Bael Modan Excavation"] = "Scavi di Bael Modan",
	["Bahrum's Post"] = "Presidio di Bahrum",
	["Balargarde Fortress"] = "Fortezza di Balargarde",
	Baleheim = "Baleheim",
	["Balejar Watch"] = "Presidio di Balejar",
	["Balia'mah Ruins"] = "Rovine di Balia'mah",
	["Bal'lal Ruins"] = "Rovine di Bal'lal",
	["Balnir Farmstead"] = "Cascina dei Balnir",
	Bambala = "Bambala",
	["Band of Acceleration"] = "Anello dell'Accelerazione",
	["Band of Alignment"] = "Anello dell'Allineamento",
	["Band of Transmutation"] = "Anello della Trasmutazione",
	["Band of Variance"] = "Anello della Varianza",
	["Ban'ethil Barrow Den"] = "Eremo di Ban'ethil",
	["Ban'ethil Barrow Descent"] = "Discesa all'Eremo di Ban'ethil",
	["Ban'ethil Hollow"] = "Vallata di Ban'ethil",
	Bank = "Banca",
	["Banquet Grounds"] = "Cortile del Ristoro",
	["Ban'Thallow Barrow Den"] = "Eremo di Ban'thallow",
	["Baradin Base Camp"] = "Campo Base di Baradin",
	["Baradin Bay"] = "Baia di Baradin",
	["Baradin Hold"] = "Forte di Baradin",
	Barbershop = "Barbiere",
	["Barov Family Vault"] = "Cripta della Famiglia Barov",
	["Bashal'Aran"] = "Bashal'Aran",
	["Bashal'Aran Collapse"] = "Collasso di Bashal'Aran",
	["Bash'ir Landing"] = "Approdo di Bash'ir",
	["Bastion Antechamber"] = "Anticamera del Bastione",
	["Bathran's Haunt"] = "Covo di Bathran",
	["Battlefront Provisions"] = "Provviste del Fronte della Battaglia",
	["Battle on the High Seas"] = "Battaglia in Mare Aperto",
	["Battle Ring"] = "Terreno di Scontro",
	Battlescar = "Fossa di Guerra",
	["Battlescar Spire"] = "Mastio della Fossa di Guerra",
	["Battlescar Valley"] = "Valle della Fossa di Guerra",
	["Bay of Echoes"] = "Baia dell'Eco",
	["Bay of Storms"] = "Baia delle Tempeste",
	["Bear's Head"] = "Testa d'Orso",
	["Beauty's Lair"] = "Antro di Bella",
	["Beeble's Wreck"] = "Relitto di Beeble",
	["Beezil's Wreck"] = "Relitto di Beezil",
	["Befouled Terrace"] = "Terrazza dell'Inganno",
	["Beggar's Haunt"] = "Torrione del Mendicante",
	["Beneath The Double Rainbow"] = "Sotto al Doppio Arcobaleno",
	["Beneath the Pit"] = "Sotto la Fossa",
	["Beren's Peril"] = "Grotta di Beren",
	["Bernau's Happy Fun Land"] = "Terra Felice di Bernau",
	["Beryl Coast"] = "Costa di Beryl",
	["Beryl Egress"] = "Ritrovo di Beryl",
	["Beryl Point"] = "Promontorio di Beryl",
	["Beth'mora Ridge"] = "Cresta di Beth'mora",
	["Beth'tilac's Lair"] = "Antro di Beth'tilac",
	["Biel'aran Ridge"] = "Altura di Biel'aran",
	["Big Beach Brew Bash"] = "Rissa Alcolica da Spiaggia",
	["Big Blossom Excavation"] = "Scavi di Fioreterno",
	["Big Blossom Mine"] = "Miniera di Fioreterno",
	["Bilgewater Beach"] = "Spiaggia degli Acqualorda",
	["Bilgewater Harbor"] = "Porto degli Acqualorda",
	["Bilgewater Lumber Yard"] = "Campo di Taglio degli Acqualorda",
	["Bilgewater Port"] = "Attracco degli Acqualorda",
	["Binan Brew & Stew"] = "Birre e Stufati di Binan",
	["Binan Village"] = "Binan",
	["Bitter Reaches"] = "Lande Amare",
	["Bittertide Lake"] = "Lago di Aspramarea",
	["Bizmo's Brawlpub"] = "Club dei Combattenti di Bizmo",
	["Black Channel Marsh"] = "Acquitrino Solconero",
	["Blackchar Cave"] = "Caverna Bracenera",
	["Black Drake Roost"] = "Nido del Draco Nero",
	["Blackfathom Camp"] = "Accampamento di Fondocupo",
	["Blackfathom Deeps"] = "Abissi di Fondocupo",
	["Blackfathom Deeps Entrance"] = "Ingresso agli Abissi di Fondocupo",
	["Blackhoof Village"] = "Villaggio di Zoccolo Nero",
	["Blackhorn's Penance"] = "Prigione di Cornonero",
	["Blackmaw Hold"] = "Tana degli Zannanera",
	["Black Ox Temple"] = "Tempio dello Yak Nero",
	["Blackriver Logging Camp"] = "Campo di Taglio di Tetrorivo",
	["Blackrock Caverns"] = "Caverne di Roccianera",
	["Blackrock Caverns Entrance"] = "Ingresso alle Caverne di Roccianera",
	["Blackrock Depths"] = "Sotterranei di Roccianera",
	["Blackrock Depths Entrance"] = "Ingresso ai Sotterranei di Roccianera",
	["Blackrock Mountain"] = "Massiccio Roccianera",
	["Blackrock Pass"] = "Passo di Roccianera",
	["Blackrock Spire"] = "Bastioni di Roccianera",
	["Blackrock Spire Entrance"] = "Ingresso ai Bastioni di Roccianera",
	["Blackrock Stadium"] = "Stadio di Roccianera",
	["Blackrock Stronghold"] = "Fortezza Roccianera",
	["Blacksand Spillway"] = "Baia Sabbianera",
	["Blacksilt Shore"] = "Riva dei Sabbianera",
	Blacksmith = "Fucina",
	["Blackstone Span"] = "Ponte di Pietranera",
	["Black Temple"] = "Tempio Nero",
	["Black Tooth Hovel"] = "Tugurio di Dente Nero",
	Blackwatch = "Osservatorio Nero",
	["Blackwater Cove"] = "Baia degli Acquanera",
	["Blackwater Shipwrecks"] = "Relitti degli Acquanera",
	["Blackwind Lake"] = "Lago di Ventotetro",
	["Blackwind Landing"] = "Aerodromo di Ventotetro",
	["Blackwind Valley"] = "Valle di Ventotetro",
	["Blackwing Coven"] = "Congrega dell'Ala Nera",
	["Blackwing Descent"] = "Sotterranei dell'Ala Nera",
	["Blackwing Lair"] = "Fortezza dell'Ala Nera",
	["Blackwolf River"] = "Fiume Luponero",
	["Blackwood Camp"] = "Campo dei Selvanera",
	["Blackwood Den"] = "Covo dei Selvanera",
	["Blackwood Lake"] = "Lago di Selvanera",
	["Bladed Gulch"] = "Gola Tagliente",
	["Bladefist Bay"] = "Baia di Manotagliente",
	["Bladelord's Retreat"] = "Anticamera del Signore delle Lame",
	["Blades & Axes"] = "Asce e Spade",
	["Blade's Edge Arena"] = "Arena di Spinaguzza",
	["Blade's Edge Mountains"] = "Montagne Spinaguzza",
	["Bladespire Grounds"] = "Terreni dei Lamacurva",
	["Bladespire Hold"] = "Rocca dei Lamacurva",
	["Bladespire Outpost"] = "Avamposto dei Lamacurva",
	["Blades' Run"] = "Cammino degli Aculei",
	["Blade Tooth Canyon"] = "Canyon di Rocciafendente",
	Bladewood = "Selva Tagliente",
	["Blasted Lands"] = "Terre Devastate",
	["Bleak Hollow"] = "Conca Tetra",
	["Bleeding Hollow Ruins"] = "Rovine dei Guerci Insanguinati",
	["Bleeding Vale"] = "Valle Sanguinante",
	["Bleeding Ziggurat"] = "Ziggurat Sanguinante",
	["Blistering Pool"] = "Acquitrino Bollente",
	["Bloodcurse Isle"] = "Isola di Sangue Dannato",
	["Blood Elf Tower"] = "Torre dell'Elfo del Sangue",
	["Bloodfen Burrow"] = "Covo dei Codarossa",
	Bloodgulch = "Forra del Sangue",
	["Bloodhoof Village"] = "Villaggio di Zoccolo Sanguinario",
	["Bloodied Crossing"] = "Crocevia Insanguinato",
	["Blood in the Snow"] = "Neve Insanguinata",
	["Bloodmaul Camp"] = "Accampamento dei Magliorosso",
	["Bloodmaul Outpost"] = "Avamposto dei Magliorosso",
	["Bloodmaul Ravine"] = "Gola dei Magliorosso",
	["Bloodmoon Isle"] = "Isola di Lunarossa",
	["Bloodmyst Isle"] = "Isola Brumacremisi",
	["Bloodscale Enclave"] = "Enclave degli Scagliacremisi",
	["Bloodscale Grounds"] = "Terre degli Scagliacremisi",
	["Bloodspore Plains"] = "Pianure degli Sporasangue",
	["Bloodtalon Shore"] = "Spiaggia dei Grinfiarossa",
	["Bloodtooth Camp"] = "Accampamento di Zannarossa",
	["Bloodvenom Falls"] = "Cascate Sanguemarcio",
	["Bloodvenom Post"] = "Accampamento di Sanguemarcio",
	["Bloodvenom Post "] = "Accampamento di Sanguemarcio",
	["Bloodvenom River"] = "Fiume Sanguemarcio",
	["Bloodwash Cavern"] = "Caverna dei Fiottorosso",
	["Bloodwash Fighting Pits"] = "Fosse di Combattimento dei Fiottorosso",
	["Bloodwash Shrine"] = "Santuario dei Fiottorosso",
	["Blood Watch"] = "Presidio Vermiglio",
	["Bloodwatcher Point"] = "Presidio di Mirasangue",
	Bluefen = "Motazzurra",
	["Bluegill Marsh"] = "Palude dei Branchiazzurra",
	["Blue Sky Logging Grounds"] = "Campo di Taglio di Ciel Sereno",
	["Bluff of the South Wind"] = "Promontorio del Vento del Sud",
	["Bogen's Ledge"] = "Grotta di Bogen",
	Bogpaddle = "Spalatorba",
	["Boha'mu Ruins"] = "Rovine di Boha'mu",
	["Bolgan's Hole"] = "Covo di Bolgan",
	["Bolyun's Camp"] = "Accampamento di Bolyun",
	["Bonechewer Ruins"] = "Rovine dei Tritaossa",
	["Bonesnap's Camp"] = "Bivacco di Ossorotto",
	["Bones of Grakkarond"] = "Ossa di Grakkarond",
	["Bootlegger Outpost"] = "Avamposto dei Contrabbandieri",
	["Booty Bay"] = "Baia del Bottino",
	["Borean Tundra"] = "Tundra Boreale",
	["Bor'gorok Outpost"] = "Avamposto di Bor'gorok",
	["Bor's Breath"] = "Forra di Bor",
	["Bor's Breath River"] = "Fiume della Forra di Bor",
	["Bor's Fall"] = "Cascata di Bor",
	["Bor's Fury"] = "Furia di Bor",
	["Borune Ruins"] = "Rovine di Borune",
	["Bough Shadow"] = "Frondascura",
	["Bouldercrag's Refuge"] = "Rifugio di Spaccaroccia",
	["Boulderfist Hall"] = "Fortilizio dei Rocciadura",
	["Boulderfist Outpost"] = "Avamposto dei Rocciadura",
	["Boulder'gor"] = "Roccia'gor",
	["Boulder Hills"] = "Colli del Macigno",
	["Boulder Lode Mine"] = "Miniera di Pietravera",
	["Boulder'mok"] = "Bolde'mok",
	["Boulderslide Cavern"] = "Caverna dei Franamassi",
	["Boulderslide Ravine"] = "Gola dei Franamassi",
	["Bozzle's Wreck"] = "Relitto di Bozzle",
	["Brackenwall Village"] = "Felcimura",
	["Brackwell Pumpkin Patch"] = "Campo di Zucche dei Pozzonero",
	["Brambleblade Ravine"] = "Depressione di Rovoaguzzo",
	Bramblescar = "Rovotagliente",
	["Brann's Base-Camp"] = "Campo Base di Brann",
	["Brashtide Attack Fleet"] = "Flotta d'Attacco dei Razziamarea",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Flotta d'Attacco dei Razziamarea (Forza Esterna)",
	["Brave Wind Mesa"] = "Mesa Vento Valoroso",
	["Brawl'gar Arena"] = "Arena dei Combattenti",
	["Brazie Farmstead"] = "Cascina di Brazie",
	["Brewmoon Festival"] = "Festival di Birraluna",
	["Brewnall Village"] = "Borgo Luppolo",
	["Bridge of Souls"] = "Ponte delle Anime",
	["Brightwater Lake"] = "Lago di Acqualucente",
	["Brightwood Grove"] = "Bosco Legnoradioso",
	Brill = "Brill",
	["Brill Town Hall"] = "Municipio di Brill",
	["Bristlelimb Enclave"] = "Enclave dei Braccioirsuto",
	["Bristlelimb Village"] = "Villaggio dei Braccioirsuto",
	["Broken Commons"] = "Piazzale in Rovina",
	["Broken Hill"] = "Collerotto",
	["Broken Pillar"] = "Pilastro Spezzato",
	["Broken Spear Village"] = "Villaggio delle Lance Spezzate",
	["Broken Wilds"] = "Lande Spezzate",
	["Broketooth Outpost"] = "Avamposto dei Denterotto",
	["Bronzebeard Encampment"] = "Accampamento di Barbabronzea",
	["Bronze Dragonshrine"] = "Santuario dei Draghi di Bronzo",
	["Browman Mill"] = "Masseria di Browman",
	["Brunnhildar Village"] = "Brunnhildar",
	["Bucklebree Farm"] = "Fattoria dei Fibbiadoro",
	["Budd's Dig"] = "Scavo di Budd",
	["Burning Blade Coven"] = "Covo delle Lame Ardenti",
	["Burning Blade Ruins"] = "Rovine delle Lame Ardenti",
	["Burning Steppes"] = "Steppe Ardenti",
	["Butcher's Sanctum"] = "Santuario del Macellaio",
	["Butcher's Stand"] = "Banco del Macellaio",
	["Caer Darrow"] = "Caer Darrow",
	["Caldemere Lake"] = "Lago Caldemere",
	["Calston Estate"] = "Tenuta dei Calston",
	["Camp Aparaje"] = "Accampamento Aparaje",
	["Camp Ataya"] = "Accampamento Ataya",
	["Camp Boff"] = "Campo Boff",
	["Camp Broketooth"] = "Accampamento dei Denterotto",
	["Camp Cagg"] = "Campo Cagg",
	["Camp E'thok"] = "Accampamento E'thok",
	["Camp Everstill"] = "Accampamento Placido",
	["Camp Gormal"] = "Accampamento di Gormal",
	["Camp Kosh"] = "Campo Kosh",
	["Camp Mojache"] = "Accampamento Mojache",
	["Camp Mojache Longhouse"] = "Casalunga dell'Accampamento Mojache",
	["Camp Narache"] = "Campo Narache",
	["Camp Nooka Nooka"] = "Accampamento Nuga Nuga",
	["Camp of Boom"] = "Accampamento di Boom",
	["Camp Onequah"] = "Accampamento Oneqwah",
	["Camp Oneqwah"] = "Accampamento Oneqwah",
	["Camp Sungraze"] = "Accampamento di Sfregiosole",
	["Camp Tunka'lo"] = "Accampamento Tunka'lo",
	["Camp Una'fe"] = "Accampamento Una'fe",
	["Camp Winterhoof"] = "Accampamento degli Zoccolo Artico",
	["Camp Wurg"] = "Campo Wurg",
	Canals = "Canali Sotterranei",
	["Cannon's Inferno"] = "Polveriera Infernale",
	["Cantrips & Crows"] = "Canti e Incanti",
	["Cape of Lost Hope"] = "Capo di Senza Speranza",
	["Cape of Stranglethorn"] = "Capo di Rovotorto",
	["Capital Gardens"] = "Giardini della Capitale",
	["Carrion Hill"] = "Colle delle Carogne",
	["Cartier & Co. Fine Jewelry"] = "Gioielleria Cartier & Co.",
	Cataclysm = "Cataclysm",
	["Cathedral of Darkness"] = "Cattedrale dell'Oscurità",
	["Cathedral of Light"] = "Cattedrale della Luce",
	["Cathedral Quarter"] = "Quartiere della Cattedrale",
	["Cathedral Square"] = "Piazza della Cattedrale",
	["Cattail Lake"] = "Lago del Canneto",
	["Cauldros Isle"] = "Isola Cauldros",
	["Cave of Mam'toth"] = "Caverna di Mam'toth",
	["Cave of Meditation"] = "Grotta della Meditazione",
	["Cave of the Crane"] = "Caverna della Gru",
	["Cave of Words"] = "Grotta delle Parole",
	["Cavern of Endless Echoes"] = "Caverna dell'Eco Eterno",
	["Cavern of Mists"] = "Caverna delle Nebbie",
	["Caverns of Time"] = "Caverne del Tempo",
	["Celestial Enclave"] = "Enclave Celeste",
	["Celestial Ridge"] = "Cresta Celeste",
	["Cenarion Enclave"] = "Enclave Cenariana",
	["Cenarion Hold"] = "Fortezza Cenariana",
	["Cenarion Post"] = "Avamposto Cenariano",
	["Cenarion Refuge"] = "Rifugio Cenariano",
	["Cenarion Thicket"] = "Macchia Cenariana",
	["Cenarion Watchpost"] = "Bivacco Cenariano",
	["Cenarion Wildlands"] = "Terre Fertili Cenariane",
	["Central Bridge"] = "Ponte Centrale",
	["Chamber of Ancient Relics"] = "Stanza delle Antiche Reliquie",
	["Chamber of Atonement"] = "Stanza dell'Espiazione",
	["Chamber of Battle"] = "Stanza della Guerra",
	["Chamber of Blood"] = "Stanza del Sangue",
	["Chamber of Command"] = "Stanza del Comando",
	["Chamber of Enchantment"] = "Stanza degli Incantamenti",
	["Chamber of Enlightenment"] = "Sala dell'Illuminazione",
	["Chamber of Fanatics"] = "Stanza dei Fanatici",
	["Chamber of Incineration"] = "Stanza dell'Incenerimento",
	["Chamber of Masters"] = "Sala dei Maestri",
	["Chamber of Prophecy"] = "Sala della Profezia",
	["Chamber of Reflection"] = "Sala del Riflesso",
	["Chamber of Respite"] = "Stanza del Respiro",
	["Chamber of Summoning"] = "Stanza dell'Evocazione",
	["Chamber of Test Namesets"] = "Sala delle Prove dei Nomi",
	["Chamber of the Aspects"] = "Stanza degli Aspetti",
	["Chamber of the Dreamer"] = "Stanza del Sognatore",
	["Chamber of the Moon"] = "Sala della Luna",
	["Chamber of the Restless"] = "Stanza dei Senza Requie",
	["Chamber of the Stars"] = "Sala delle Stelle",
	["Chamber of the Sun"] = "Sala del Sole",
	["Chamber of Whispers"] = "Sale dei Sussurri",
	["Chamber of Wisdom"] = "Sala della Saggezza",
	["Champion's Hall"] = "Sala del Campione",
	["Champions' Hall"] = "Sala dei Campioni",
	["Chapel Gardens"] = "Giardini della Cappella",
	["Chapel of the Crimson Flame"] = "Cappella della Fiamma Cremisi",
	["Chapel Yard"] = "Chiostro della Cappella",
	["Charred Outpost"] = "Avamposto Bruciato",
	["Charred Rise"] = "Altura Carbonizzata",
	["Chill Breeze Valley"] = "Valle Brezzagelida",
	["Chillmere Coast"] = "Costa Ondafredda",
	["Chillwind Camp"] = "Accampamento di Ventofreddo",
	["Chillwind Point"] = "Gola di Ventofreddo",
	Chiselgrip = "Brandibulino",
	["Chittering Coast"] = "Piana del Tormento",
	["Chow Farmstead"] = "Fattoria dei Chow",
	["Churning Gulch"] = "Gola Brulicante",
	["Circle of Blood"] = "Cerchio del Sangue",
	["Circle of Blood Arena"] = "Arena Cerchio del Sangue",
	["Circle of Bone"] = "Cerchio delle Ossa",
	["Circle of East Binding"] = "Circolo del Vincolo Orientale",
	["Circle of Inner Binding"] = "Circolo del Vincolo Interno",
	["Circle of Outer Binding"] = "Circolo del Vincolo Esterno",
	["Circle of Scale"] = "Cerchio delle Scaglie",
	["Circle of Stone"] = "Cerchio della Pietra",
	["Circle of Thorns"] = "Circolo delle Spine",
	["Circle of West Binding"] = "Circolo del Vincolo Occidentale",
	["Circle of Wills"] = "Circolo delle Volontà",
	City = "Città",
	["City of Ironforge"] = "Forgiardente",
	["City Siege - Mogu Island Progression Scenario"] = "Assedio della Cittadella - Progresso Scenario Isola del Tuono",
	["Clan Watch"] = "Presidio dei Clan",
	["Class Quest"] = "Missione di Classe",
	["Claytön's WoWEdit Land"] = "Claytön's WoWEdit Land",
	["Cleft of Shadow"] = "Spelonca delle Ombre",
	["Cliffspring Falls"] = "Cascate di Altafonte",
	["Cliffspring Hollow"] = "Grotta di Altafonte",
	["Cliffspring River"] = "Fiume Altafonte",
	["Cliffwalker Post"] = "Accampamento dei Cavalca Rupe",
	["Cloudstrike Dojo"] = "Dojo di Nube Truce",
	["Cloudtop Terrace"] = "Terrazza delle Nubi",
	["Coast of Echoes"] = "Costa dell'Eco",
	["Coast of Idols"] = "Costa degli Idoli",
	["Coilfang Reservoir"] = "Bacino degli Spiraguzza",
	["Coilfang: Serpentshrine Cavern"] = "Spiraguzza: Caverna di Sacrespire",
	["Coilfang: The Slave Pens"] = "Spiraguzza: Fosse degli Schiavi",
	["Coilfang - The Slave Pens Entrance"] = "Ingresso alle Fosse degli Schiavi degli Spiraguzza",
	["Coilfang: The Steamvault"] = "Spiraguzza: Antro dei Vapori",
	["Coilfang - The Steamvault Entrance"] = "Ingresso all'Antro dei Vapori degli Spiraguzza",
	["Coilfang: The Underbog"] = "Spiraguzza: Torbiera Sotterranea",
	["Coilfang - The Underbog Entrance"] = "Ingresso alla Torbiera Sotterranea degli Spiraguzza",
	["Coilskar Cistern"] = "Cisterna dei Malaspira",
	["Coilskar Point"] = "Presidio dei Malaspira",
	Coldarra = "Ibernia",
	["Coldarra Ledge"] = "Sporgenza di Ibernia",
	["Coldbite Burrow"] = "Tana dei Morsogelido",
	["Cold Hearth Manor"] = "Maniero Cuorduro",
	["Coldridge Pass"] = "Passo Crestafredda",
	["Coldridge Valley"] = "Valle Crestafredda",
	["Coldrock Quarry"] = "Cava di Rocciafredda",
	["Coldtooth Mine"] = "Miniera di Dentefreddo",
	["Coldwind Heights"] = "Alture di Ventogelido",
	["Coldwind Pass"] = "Passo di Ventogelido",
	["Collin's Test"] = "Prova di Collin",
	["Command Center"] = "Centro di Comando",
	["Commons Hall"] = "Sala delle Udienze",
	["Condemned Halls"] = "Sale della Condanna",
	["Conqueror's Terrace"] = "Terrazza del Conquistatore",
	["Conquest Hold"] = "Fortezza della Conquista",
	["Containment Core"] = "Nucleo di Contenimento",
	["Cooper Residence"] = "Residenza dei Cooper",
	["Coral Garden"] = "Giardino di Corallo",
	["Cordell's Enchanting"] = "Incantamenti di Cordell",
	["Corin's Crossing"] = "Crocevia di Corin",
	["Corp'rethar: The Horror Gate"] = "Corp'rethar, Cancello dell'Orrore",
	["Corrahn's Dagger"] = "Daga di Corrahn",
	Cosmowrench = "Kosmika",
	["Court of Bones"] = "Corte delle Ossa",
	["Court of the Highborne"] = "Corte degli Alti Nobili",
	["Court of the Sun"] = "Corte del Sole",
	["Courtyard of Lights"] = "Cortile delle Luci",
	["Courtyard of the Ancients"] = "Cortile degli Antichi",
	["Cradle of Chi-Ji"] = "Culla di Chi-Ji",
	["Cradle of the Ancients"] = "Culla degli Antichi",
	["Craftsmen's Terrace"] = "Terrazza degli Artigiani",
	["Crag of the Everliving"] = "Dirupo dell'Eterno",
	["Cragpool Lake"] = "Lago di Altarupe",
	["Crane Wing Refuge"] = "Bivacco della Gru Selvaggia",
	["Crash Site"] = "Punto d'Impatto",
	["Crescent Hall"] = "Sala della Mezzaluna",
	["Crimson Assembly Hall"] = "Sala dell'Assemblea Cremisi",
	["Crimson Expanse"] = "Distesa Cremisi",
	["Crimson Watch"] = "Terrazza Cremisi",
	Crossroads = "Crocevia",
	["Crowley Orchard"] = "Frutteto dei Crowley",
	["Crowley Stable Grounds"] = "Pascolo dei Crowley",
	["Crown Guard Tower"] = "Torre della Corona",
	["Crucible of Carnage"] = "Crogiolo della Carneficina",
	["Crumbling Depths"] = "Profondità Disgregate",
	["Crumbling Stones"] = "Pietre Sgretolate",
	["Crusader Forward Camp"] = "Avanguardia dei Crociati",
	["Crusader Outpost"] = "Avamposto dei Crociati",
	["Crusader's Armory"] = "Armeria dei Crociati",
	["Crusader's Chapel"] = "Cappella dei Crociati",
	["Crusader's Landing"] = "Approdo dei Crociati",
	["Crusader's Outpost"] = "Avamposto dei Crociati",
	["Crusaders' Pinnacle"] = "Pinnacolo dei Crociati",
	["Crusader's Run"] = "Gola dei Crociati",
	["Crusader's Spire"] = "Torrione dei Crociati",
	["Crusaders' Square"] = "Piazza dei Crociati",
	Crushblow = "Spezzacollo",
	["Crushcog's Arsenal"] = "Arsenale di Spezzarotella",
	["Crushridge Hold"] = "Rocca degli Sfasciacresta",
	Crypt = "Cripta",
	["Crypt of Forgotten Kings"] = "Cripta degli Imperatori Dimenticati",
	["Crypt of Remembrance"] = "Cripta della Rimembranza",
	["Crystal Lake"] = "Lago di Cristallo",
	["Crystalline Quarry"] = "Cava Cristallina",
	["Crystalsong Forest"] = "Foresta di Cristallo",
	["Crystal Spine"] = "Dorsale di Cristallo",
	["Crystalvein Mine"] = "Miniera di Cristallo",
	["Crystalweb Cavern"] = "Caverna Tela di Cristallo",
	CTF3 = "CLB3",
	["Curiosities & Moore"] = "Varie ed Eventuali",
	["Cursed Depths"] = "Abissi Maledetti",
	["Cursed Hollow"] = "Anfratto Maledetto",
	["Cut-Throat Alley"] = "Vicolo dei Tagliagole",
	["Cyclone Summit"] = "Vetta del Ciclone",
	["Dabyrie's Farmstead"] = "Cascina dei Dabyrie",
	["Daggercap Bay"] = "Baia delle Daghe",
	["Daggerfen Village"] = "Villaggio dei Limoaguzzo",
	["Dagger in the Dark"] = "Lame nel Buio",
	["Daggermaw Canyon"] = "Canyon delle Fauci Aguzze",
	["Dagger Pass"] = "Passo del Pugnale",
	["Dais of Conquerors"] = "Piattaforma dei Conquistatori",
	Dalaran = "Dalaran",
	["Dalaran Arena"] = "Arena di Dalaran",
	["Dalaran City"] = "Dalaran",
	["Dalaran Crater"] = "Cratere di Dalaran",
	["Dalaran Floating Rocks"] = "Rocce Fluttuanti di Dalaran",
	["Dalaran Island"] = "Isola di Dalaran",
	["Dalaran Merchant's Bank"] = "Banca Mercantile di Dalaran",
	["Dalaran Sewers"] = "Fogne di Dalaran",
	["Dalaran Visitor Center"] = "Centro d'Accoglienza di Dalaran",
	["Dalson's Farm"] = "Fattoria dei Dalson",
	["Damplight Cavern"] = "Grotta di Lucefioca",
	["Damplight Chamber"] = "Grotta di Lucefioca",
	["Dampsoil Burrow"] = "Fossasecca",
	["Dandred's Fold"] = "Avvallamento di Dandred",
	["Dargath's Demise"] = "Disfatta di Dargath",
	["Darkbreak Cove"] = "Cala Ondascura",
	["Darkcloud Pinnacle"] = "Pinnacolo Nubenera",
	["Darkcrest Enclave"] = "Enclave dei Crestascura",
	["Darkcrest Shore"] = "Costa dei Crestascura",
	["Dark Heart of Pandaria"] = "Cuore Oscuro di Pandaria",
	["Dark Iron Highway"] = "Strada dei Ferroscuro",
	["Darkmist Cavern"] = "Miniera di Brumafosca",
	["Darkmist Ruins"] = "Rovine di Brumafosca",
	["Darkmoon Boardwalk"] = "Molo di Lunacupa",
	["Darkmoon Deathmatch"] = "Fossa di Lunacupa",
	["Darkmoon Deathmatch Pit (PH)"] = "Fossa di Lunacupa",
	["Darkmoon Faire"] = "Fiera di Lunacupa",
	["Darkmoon Island"] = "Isola di Lunacupa",
	["Darkmoon Island Cave"] = "Caverna dell'Isola di Lunacupa",
	["Darkmoon Path"] = "Sentiero di Lunacupa",
	["Darkmoon Pavilion"] = "Padiglione di Lunacupa",
	Darkshire = "Borgoscuro",
	["Darkshire Town Hall"] = "Municipio di Borgoscuro",
	Darkshore = "Rivafosca",
	["Darkspear Hold"] = "Fortezza dei Lanciascura",
	["Darkspear Isle"] = "Isola dei Lanciascura",
	["Darkspear Shore"] = "Spiaggia dei Lanciascura",
	["Darkspear Strand"] = "Riva dei Lanciascura",
	["Darkspear Training Grounds"] = "Campi d'Addestramento dei Lanciascura",
	["Darkwhisper Gorge"] = "Gola di Mormoscuro",
	["Darkwhisper Pass"] = "Passo di Mormoscuro",
	["Darnassian Base Camp"] = "Campo Base Darnassiano",
	Darnassus = "Darnassus",
	["Darrow Hill"] = "Collina di Darrow",
	["Darrowmere Lake"] = "Lago Darrowmere",
	Darrowshire = "Borgo di Darrow",
	["Darrowshire Hunting Grounds"] = "Terreni di Caccia di Darrow",
	["Darsok's Outpost"] = "Avamposto di Darsok",
	["Dawnchaser Retreat"] = "Rifugio degli Alba Nuova",
	["Dawning Lane"] = "Viale dell'Alba",
	["Dawning Wood Catacombs"] = "Catacombe di Bosco d'Alba",
	["Dawnrise Expedition"] = "Spedizione di Albanuova",
	["Dawn's Blossom"] = "Alba Fiorita",
	["Dawnseeker Promontory"] = "Promontorio Albafurente",
	["Dawnseeker's Promontory"] = "Promontorio Albafurente",
	["Dawn's Reach"] = "Avamposto dell'Alba",
	["Dawnstar Spire"] = "Torre degli Albastella",
	["Dawnstar Village"] = "Stella dell'Alba",
	["Daxil's Dig"] = "Scavi di Daxil",
	["D-Block"] = "Blocco-D",
	["Deadeye Shore"] = "Spiaggia di Occhiotetro",
	["Deadman's Crossing"] = "Crocevia del Morto",
	["Dead Man's Hole"] = "Golfo del Morto",
	Deadmines = "Miniere della Morte",
	["Deadtalker's Plateau"] = "Scogliera del Predicatore della Morte",
	["Deadwind Pass"] = "Valico Ventomorto",
	["Deadwind Ravine"] = "Gola di Ventomorto",
	["Deadwood Village"] = "Villaggio dei Legnomorto",
	["Deathbringer's Rise"] = "Loggia dell'Araldo della Morte",
	["Death Cultist Base Camp"] = "Base dei Cultisti della Morte",
	["Deathforge Tower"] = "Torre di Forgiamorte",
	Deathknell = "Albamorta",
	["Deathmatch Pavilion"] = "Padiglione dell'Arena",
	Deatholme = "Mortorium",
	["Death's Breach"] = "Breccia della Morte",
	["Death's Door"] = "Portale della Morte",
	["Death's Hand Encampment"] = "Accampamento Mano della Morte",
	["Deathspeaker's Watch"] = "Accampamento dei Necroratori",
	["Death's Rise"] = "Altura della Morte",
	["Death's Stand"] = "Presidio del Sacrificio",
	["Death's Step"] = "Passo della Morte",
	["Death's Watch Waystation"] = "Postazione Guardamorte",
	Deathwing = "Alamorte",
	["Deathwing's Fall"] = "Caduta di Alamorte",
	["Deep Blue Observatory"] = "Osservatorio Profondo Blu",
	["Deep Elem Mine"] = "Abisso di Elem",
	["Deepfin Ridge"] = "Altura dei Pinnafonda",
	Deepholm = "Rocciafonda",
	["Deephome Ceiling"] = "Volta di Rocciafonda",
	["Deepmist Grotto"] = "Grotta Brumafonda",
	["Deeprun Tram"] = "Tram degli Abissi",
	["Deepwater Tavern"] = "Locanda Acquefonde",
	["Deepwind Gorge"] = "Scavi di Ventotetro",
	["Defense of the Alehouse"] = "Difesa della Casa della Birra",
	["Defense Of The Ale House BG"] = "Difesa della Casa della Birra",
	["Defias Hideout"] = "Nascondiglio dei Defias",
	["Defiler's Den"] = "Covo dei Profanatori",
	["D.E.H.T.A. Encampment"] = "Accampamento dei V.V.F.",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "Canyon della Caduta Infernale",
	["Demon Fall Ridge"] = "Eremo della Caduta Infernale",
	["Demont's Place"] = "Podere di Demont",
	["Den of Defiance"] = "Antro della Sfida",
	["Den of Dying"] = "Antro del Trapasso",
	["Den of Haal'esh"] = "Antro di Haal'esh",
	["Den of Iniquity"] = "Antro dell'Iniquità",
	["Den of Mortal Delights"] = "Antro delle Delizie Mortali",
	["Den of Sorrow"] = "Antro del Cordoglio",
	["Den of Sseratus"] = "Antro di Sseratus",
	["Den of the Caller"] = "Antro dell'Invocatore",
	["Den of the Devourer"] = "Antro del Divoratore",
	["Den of the Disciples"] = "Antro dei Discepoli",
	["Den of the Unholy"] = "Antro dell'Empietà",
	["Derelict Caravan"] = "Carovana Abbandonata",
	["Derelict Manor"] = "Maniero Abbandonato",
	["Derelict Strand"] = "Riva del Conflitto",
	["Designer Island"] = "Isola degli Sviluppatori",
	Desolace = "Desolanda",
	["Desolation Hold"] = "Forte Desolazione",
	["Detention Block"] = "Blocco di Detenzione",
	["Development Land"] = "Terreni di Sviluppo",
	["Diamondhead River"] = "Fiume Diamante",
	["Diamond Island"] = "Isola dei Diamanti",
	["Dig One"] = "Primo Scavo",
	["Dig Three"] = "Terzo Scavo",
	["Dig Two"] = "Secondo Scavo",
	["Direforge Hill"] = "Colle Forgiatroce",
	["Direhorn Post"] = "Accampamento Corno Furente",
	["Dire Maul"] = "Maglio Infausto",
	["Dire Maul - Capital Gardens Entrance"] = "Ingresso ai Giardini della Capitale di Maglio Infausto",
	["Dire Maul - East"] = "Maglio Infausto - Est",
	["Dire Maul - Gordok Commons Entrance"] = "Ingresso alle Sale di Gordok di Maglio Infausto",
	["Dire Maul - North"] = "Maglio Infausto - Nord",
	["Dire Maul - Warpwood Quarter Entrance"] = "Ingresso al Quartiere di Legnotorto di Maglio Infausto",
	["Dire Maul - West"] = "Maglio Infausto - Ovest",
	Diremoor = "Landa Putrida",
	["Dire Strait"] = "Stretto Infausto",
	["Disciple's Enclave"] = "Enclave del Discepolo",
	Docks = "Porto",
	["Dojani River"] = "Fiume Dojani",
	Dolanaar = "Dolanaar",
	["Dome Balrissa"] = "Circolo Balrissa",
	["Domination Point"] = "Presidio del Dominio",
	["Donna's Kitty Shack"] = "Capanno dei Gatti di Donna",
	["DO NOT USE"] = "NON USARE",
	["Dookin' Grounds"] = "Terreni Concimati",
	["Doom's Vigil"] = "Presidio della Condanna",
	["Dorian's Outpost"] = "Avamposto di Dorian",
	["Draco'dar"] = "Draco'dar",
	["Draenei Ruins"] = "Rovine del Draenei",
	["Draenethyst Mine"] = "Miniera di Draenetista",
	["Draenil'dur Village"] = "Draenil'dur",
	Dragonblight = "Dracombra",
	["Dragonflayer Pens"] = "Scuderie degli Scorticadraghi",
	["Dragonmaw Base Camp"] = "Campo Base delle Fauci di Drago",
	["Dragonmaw Flag Room"] = "Sala della Bandiera delle Fauci di Drago",
	["Dragonmaw Forge"] = "Forgia delle Fauci di Drago",
	["Dragonmaw Fortress"] = "Fortezza delle Fauci di Drago",
	["Dragonmaw Garrison"] = "Guarnigione delle Fauci di Drago",
	["Dragonmaw Gates"] = "Portale delle Fauci di Drago",
	["Dragonmaw Pass"] = "Passo delle Fauci di Drago",
	["Dragonmaw Port"] = "Porto delle Fauci di Drago",
	["Dragonmaw Skyway"] = "Stretto delle Fauci di Drago",
	["Dragonmaw Stronghold"] = "Roccaforte delle Fauci di Drago",
	["Dragons' End"] = "Caduta dei Draghi",
	["Dragon's Fall"] = "Trucidrago",
	["Dragon's Mouth"] = "Bocca del Drago",
	["Dragon Soul"] = "Anima del Drago",
	["Dragon Soul Raid - East Sarlac"] = "Incursione di Anima del Drago - Sarlac Orientale",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Incursione di Anima del Drago - Base del Tempio della Lega dei Draghi",
	["Dragonspine Peaks"] = "Picchi di Spina del Drago",
	["Dragonspine Ridge"] = "Cresta di Spina del Drago",
	["Dragonspine Tributary"] = "Fiume Spina del Drago",
	["Dragonspire Hall"] = "Sala della Guglia dei Draghi",
	["Drak'Agal"] = "Drak'Agal",
	["Draka's Fury"] = "Furia di Draka",
	["Drak'atal Passage"] = "Passaggio di Drak'Atal",
	["Drakil'jin Ruins"] = "Rovine di Drakil'jin",
	["Drak'Mabwa"] = "Drak'Mabwa",
	["Drak'Mar Lake"] = "Lago Drak'Mar",
	["Draknid Lair"] = "Antro delle Tele",
	["Drak'Sotra"] = "Drak'Sotra",
	["Drak'Sotra Fields"] = "Campi di Drak'Sotra",
	["Drak'Tharon Keep"] = "Forte di Drak'Tharon",
	["Drak'Tharon Keep Entrance"] = "Ingresso al Forte di Drak'Tharon",
	["Drak'Tharon Overlook"] = "Belvedere di Drak'Tharon",
	["Drak'ural"] = "Drak'Ural",
	["Dread Clutch"] = "Morsa del Terrore",
	["Dread Expanse"] = "Dimensione del Terrore",
	["Dreadmaul Furnace"] = "Fornace dei Maglioinfame",
	["Dreadmaul Hold"] = "Rocca dei Maglioinfame",
	["Dreadmaul Post"] = "Avamposto dei Maglioinfame",
	["Dreadmaul Rock"] = "Masso dei Maglioinfame",
	["Dreadmist Camp"] = "Accampamento di Brumafunesta",
	["Dreadmist Den"] = "Antro di Brumafunesta",
	["Dreadmist Peak"] = "Picco di Brumafunesta",
	["Dreadmurk Shore"] = "Costa di Acquatruce",
	["Dread Terrace"] = "Terrazza del Terrore",
	["Dread Wastes"] = "Distese del Terrore",
	["Dreadwatch Outpost"] = "Avamposto di Cuposguardo",
	["Dream Bough"] = "Albero dei Sogni",
	["Dreamer's Pavilion"] = "Padiglione del Sognatore",
	["Dreamer's Rest"] = "Riposo del Sognatore",
	["Dreamer's Rock"] = "Roccia del Sognatore",
	Drudgetown = "Quartiere Lattina",
	["Drygulch Ravine"] = "Gola di Fossosecco",
	["Drywhisker Gorge"] = "Gola dei Baffosecco",
	["Dubra'Jin"] = "Dubra'Jin",
	["Dun Algaz"] = "Dun Algaz",
	["Dun Argol"] = "Dun Argol",
	["Dun Baldar"] = "Dun Baldar",
	["Dun Baldar Pass"] = "Passo di Dun Baldar",
	["Dun Baldar Tunnel"] = "Tunnel di Dun Baldar",
	["Dunemaul Compound"] = "Insediamento dei Mazzaduna",
	["Dunemaul Recruitment Camp"] = "Campo di Reclutamento dei Mazzaduna",
	["Dun Garok"] = "Dun Garok",
	["Dun Mandarr"] = "Dun Mandarr",
	["Dun Modr"] = "Dun Modr",
	["Dun Morogh"] = "Dun Morogh",
	["Dun Niffelem"] = "Dun Niffelem",
	["Dunwald Holdout"] = "Presidio di Dunwald",
	["Dunwald Hovel"] = "Capanno di Dunwald",
	["Dunwald Market Row"] = "Mercato di Dunwald",
	["Dunwald Ruins"] = "Rovine di Dunwald",
	["Dunwald Town Square"] = "Piazza Centrale di Dunwald",
	["Durnholde Keep"] = "Forte Durnholde",
	Durotar = "Durotar",
	Duskhaven = "Borgotetro",
	["Duskhowl Den"] = "Grotta degli Urloscuro",
	["Dusklight Bridge"] = "Ponte di Albascura",
	["Dusklight Hollow"] = "Cavità di Albascura",
	["Duskmist Shore"] = "Riva di Brumacupa",
	["Duskroot Fen"] = "Palude di Cepposcuro",
	["Duskwither Grounds"] = "Terre di Lungovespro",
	["Duskwither Spire"] = "Pinnacolo di Lungovespro",
	Duskwood = "Boscovespro",
	["Dustback Gorge"] = "Gola dei Pellebrulla",
	["Dustbelch Grotto"] = "Grotta dei Fendiroccia",
	["Dustfire Valley"] = "Valle di Sabbia Arsa",
	["Dustquill Ravine"] = "Gola di Pennalorda",
	["Dustwallow Bay"] = "Baia di Acquemorte",
	["Dustwallow Marsh"] = "Acquemorte",
	["Dustwind Cave"] = "Grotta di Ventolordo",
	["Dustwind Dig"] = "Scavi di Ventolordo",
	["Dustwind Gulch"] = "Gola di Ventolordo",
	["Dwarven District"] = "Distretto dei Nani",
	["Eagle's Eye"] = "Occhio dell'Aquila",
	["Earthshatter Cavern"] = "Caverna di Terrarotta",
	["Earth Song Falls"] = "Cascate Cantaterra",
	["Earth Song Gate"] = "Porta di Cantaterra",
	["Eastern Bridge"] = "Ponte Orientale",
	["Eastern Kingdoms"] = "Regni Orientali",
	["Eastern Plaguelands"] = "Terre Infette Orientali",
	["Eastern Strand"] = "Riva Orientale",
	["East Garrison"] = "Guarnigione Orientale",
	["Eastmoon Ruins"] = "Rovine di Luna dell'Est",
	["East Pavilion"] = "Padiglione Orientale",
	["East Pillar"] = "Pilastro Orientale",
	["Eastpoint Tower"] = "Torre dell'Est",
	["East Sanctum"] = "Santuario dell'Est",
	["Eastspark Workshop"] = "Scintilla dell'Est",
	["East Spire"] = "Torrione Orientale",
	["East Supply Caravan"] = "Carovana Orientale",
	["Eastvale Logging Camp"] = "Campo di Taglio di Vallevante",
	["Eastwall Gate"] = "Cancello di Levante",
	["Eastwall Tower"] = "Torre di Levante",
	["Eastwind Rest"] = "Vento dell'Est",
	["Eastwind Shore"] = "Costa Vento di Levante",
	["Ebon Hold"] = "Roccaforte d'Ebano",
	["Ebon Watch"] = "Presidio d'Ebano",
	["Echo Cove"] = "Cala dell'Eco",
	["Echo Isles"] = "Isole dell'Eco",
	["Echomok Cavern"] = "Caverna di Echomok",
	["Echo Reach"] = "Stretto dell'Eco",
	["Echo Ridge Mine"] = "Miniera Cresta dell'Eco",
	["Eclipse Point"] = "Presidio dell'Eclisse",
	["Eclipsion Fields"] = "Campi dell'Eclisse",
	["Eco-Dome Farfield"] = "Ecosfera Camporemoto",
	["Eco-Dome Midrealm"] = "Ecosfera Mezzoregno",
	["Eco-Dome Skyperch"] = "Ecosfera Sottocielo",
	["Eco-Dome Sutheron"] = "Ecosfera Sopravento",
	["Elder Rise"] = "Altura degli Anziani",
	["Elders' Square"] = "Piazza degli Anziani",
	["Eldreth Row"] = "Viale di Eldreth",
	["Eldritch Heights"] = "Alture Oniriche",
	["Elemental Plateau"] = "Altopiano Elementale",
	["Elementium Depths"] = "Profondità di Elementio",
	Elevator = "Ascensore",
	["Elrendar Crossing"] = "Crocevia di Elrendar",
	["Elrendar Falls"] = "Cascate di Elrendar",
	["Elrendar River"] = "Fiume Elrendar",
	["Elwynn Forest"] = "Foresta di Elwynn",
	["Ember Clutch"] = "Selvardente",
	Emberglade = "Radura Ardente",
	["Ember Spear Tower"] = "Torre Lancia Rovente",
	["Emberstone Mine"] = "Miniera di Pietrardente",
	["Emberstone Village"] = "Pietrardente",
	["Emberstrife's Den"] = "Tana di Braceardente",
	["Emerald Dragonshrine"] = "Santuario dei Draghi di Smeraldo",
	["Emerald Dream"] = "Sogno di Smeraldo",
	["Emerald Forest"] = "Foresta di Smeraldo",
	["Emerald Sanctuary"] = "Santuario di Smeraldo",
	["Emperor Rikktik's Rest"] = "Riposo dell'Imperatore Riggatigga",
	["Emperor's Omen"] = "Presagio dell'Imperatore",
	["Emperor's Reach"] = "Terrazza dell'Imperatore",
	["End Time"] = "Fine dei Tempi",
	["Engineering Labs"] = "Laboratori d'Ingegneria",
	["Engineering Labs "] = "Laboratori d'Ingegneria",
	["Engine of Nalak'sha"] = "Generatore di Nalak'sha",
	["Engine of the Makers"] = "Motrice dei Creatori",
	["Entryway of Time"] = "Ingresso Temporale",
	["Ethel Rethor"] = "Ethel Rethor",
	["Ethereal Corridor"] = "Corridoio degli Eterei",
	["Ethereum Staging Grounds"] = "Campo Base degli Etereum",
	["Evergreen Trading Post"] = "Spaccio Sempreverde",
	Evergrove = "Boscovivo",
	Everlook = "Lungavista",
	["Eversong - Duskwither Teleport"] = "Cantoeterno - Teletrasporto Lungovespro",
	["Eversong Woods"] = "Boschi di Cantoeterno",
	["Excavation Center"] = "Centro degli Scavi",
	["Excavation Lift"] = "Ascensore degli Scavi",
	["Exclamation Point"] = "Vetta dell'Esclamazione",
	["Expedition Armory"] = "Bastioni della Spedizione",
	["Expedition Base Camp"] = "Campo Base della Spedizione",
	["Expedition Point"] = "Presidio della Spedizione",
	["Explorers' League Digsite"] = "Scavi della Lega degli Esploratori",
	["Explorers' League Outpost"] = "Avamposto della Lega degli Esploratori",
	["Exposition Pavilion"] = "Padiglione dell'Esposizione",
	["Eye of Eternity"] = "Occhio dell'Eternità",
	["Eye of the Storm"] = "Occhio del Ciclone",
	["Fairbreeze Village"] = "Brezzaserena",
	["Fairbridge Strand"] = "Riva di Pontevecchio",
	["Falcon Watch"] = "Torrione del Falco",
	["Falconwing Inn"] = "Locanda del Falco",
	["Falconwing Square"] = "Piazza del Falco",
	["Faldir's Cove"] = "Baia di Faldir",
	["Falfarren River"] = "Fiume Falfarren",
	["Fallen Sky Lake"] = "Lago Cielinfranto",
	["Fallen Sky Ridge"] = "Cresta del Cielo Infranto",
	["Fallen Temple of Ahn'kahet"] = "Tempio Decaduto di Ahn'Kahet",
	["Fall of Return"] = "Discesa del Ritorno",
	["Fallowmere Inn"] = "Locanda di Lagobrullo",
	["Fallow Sanctuary"] = "Santuario dei Perduti",
	["Falls of Ymiron"] = "Cascate di Ymiron",
	["Fallsong Village"] = "Acquamantra",
	["Falthrien Academy"] = "Accademia di Falthrien",
	Familiars = "Familiari",
	["Faol's Rest"] = "Sepolcro di Faol",
	["Fargaze Mesa"] = "Mesa Sguardo Lungo",
	["Fargodeep Mine"] = "Miniera Antrocupo",
	Farm = "Fattoria",
	Farshire = "Borgoardito",
	["Farshire Fields"] = "Campi di Borgoardito",
	["Farshire Lighthouse"] = "Faro di Borgoardito",
	["Farshire Mine"] = "Miniera di Borgoardito",
	["Farson Hold"] = "Bastione di Farson",
	["Farstrider Enclave"] = "Enclave dei Lungopasso",
	["Farstrider Lodge"] = "Padiglione Lungopasso",
	["Farstrider Retreat"] = "Ritiro dei Lungopasso",
	["Farstriders' Enclave"] = "Enclave dei Lungopasso",
	["Farstriders' Square"] = "Piazza dei Lungopasso",
	["Farwatcher's Glen"] = "Miralunga",
	["Farwatch Overlook"] = "Altura di Granvista",
	["Far Watch Post"] = "Presidio Lungosguardo",
	["Fear Clutch"] = "Morsa della Paura",
	["Featherbeard's Hovel"] = "Tugurio di Barbapiuma",
	Feathermoon = "Piumaluna",
	["Feathermoon Stronghold"] = "Roccaforte di Piumaluna",
	["Fe-Feng Village"] = "Fe-Feng",
	["Felfire Hill"] = "Colle Vilfuoco",
	["Felpaw Village"] = "Villaggio di Vilzampa",
	["Fel Reaver Ruins"] = "Rovine del Vilrazziatore",
	["Fel Rock"] = "Vilroccia",
	["Felspark Ravine"] = "Golavile",
	["Felstone Field"] = "Campo di Vilpietra",
	Felwood = "Vilbosco",
	["Fenris Isle"] = "Isola di Fenris",
	["Fenris Keep"] = "Forte Fenris",
	Feralas = "Feralas",
	["Feralfen Village"] = "Villaggio dei Limofurioso",
	["Feral Scar Vale"] = "Valsfregiata",
	["Festering Pools"] = "Pozze Purulente",
	["Festival Lane"] = "Viale della Commemorazione",
	["Feth's Way"] = "Sentiero di Feth",
	["Field of Korja"] = "Campo di Korja",
	["Field of Strife"] = "Pian della Discordia",
	["Fields of Blood"] = "Campi del Sangue",
	["Fields of Honor"] = "Campi dell'Onore",
	["Fields of Niuzao"] = "Campi di Niuzao",
	Filming = "Filmato",
	["Final Gate - Mogu Island Progression Scenario"] = "Porta Finale - Progresso Scenario Isola del Tuono",
	["Firebeard Cemetery"] = "Cimitero dei Barbafiamma",
	["Firebeard's Patrol"] = "Bastione dei Barbafiamma",
	["Firebough Nook"] = "Radura di Bosco Ardente",
	["Fire Camp Bataar"] = "Presidio del Fuoco Bataar",
	["Fire Camp Gai-Cho"] = "Presidio del Fuoco Gai-Cho",
	["Fire Camp Ordo"] = "Presidio del Fuoco Ordo",
	["Fire Camp Osul"] = "Presidio del Fuoco Osul",
	["Fire Camp Ruqin"] = "Presidio del Fuoco Ruqin",
	["Fire Camp Yongqi"] = "Presidio del Fuoco Yongqi",
	["Firegut Furnace"] = "Fornace dei Rodifuoco",
	Firelands = "Terre del Fuoco",
	["Firelands Forgeworks"] = "Fucine delle Terre del Fuoco",
	["Firelands Hatchery"] = "Anfratto delle Terre del Fuoco",
	["Firelands Terrain 2"] = "Terre del Fuoco, Terreno 2",
	["Fireplume Peak"] = "Picco Piuma di Fuoco",
	["Fire Plume Ridge"] = "Rilievo del Magma Colante",
	["Fireplume Trench"] = "Promontorio Sommerso",
	["Fire Scar Shrine"] = "Santuario dello Sfregio Rovente",
	["Fire Stone Mesa"] = "Mesa Pietra del Fuoco",
	["Firestone Point"] = "Bivacco Pietra Calda",
	["Firewatch Ridge"] = "Cresta Mirafuoco",
	["Firewing Point"] = "Presidio di Alardente",
	["First Bank of Kezan"] = "Banca Centrale di Kezan",
	["First Legion Forward Camp"] = "Avamposto della Prima Legione",
	["First to Your Aid"] = "Pronti al Soccorso",
	["Fishing Village"] = "Villaggio di Pescatori",
	["Fizzcrank Airstrip"] = "Aerodromo di Frizzapistone",
	["Fizzcrank Pumping Station"] = "Stazione di Pompaggio di Frizzapistone",
	["Fizzle & Pozzik's Speedbarge"] = "Turbochiatta di Fizzle e Pozzik",
	["Fjorn's Anvil"] = "Incudine di Fjorn",
	Flamebreach = "Brecciardente",
	["Flame Crest"] = "Cimiero Ardente",
	["Flamestar Post"] = "Accampamento di Stellardente",
	["Flamewatch Tower"] = "Torre di Scrutafiamme",
	["Flavor - Stormwind Harbor - Stop"] = "Ambiente - Porto di Roccavento - Stop",
	["Fleshrender's Workshop"] = "Laboratorio del Tranciacarne",
	["Foothold Citadel"] = "Cittadella di Theramore",
	["Footman's Armory"] = "Armeria dei Fanti",
	["Force Interior"] = "Forza Interiore",
	["Fordragon Hold"] = "Bastione di Domadraghi",
	["Forest Heart"] = "Cuore della Foresta",
	["Forest's Edge"] = "Bordobosco",
	["Forest's Edge Post"] = "Postazione Selva Rada",
	["Forest Song"] = "Cantaselva",
	["Forge Base: Gehenna"] = "Fornace Gehenna",
	["Forge Base: Oblivion"] = "Fornace Oblio",
	["Forge Camp: Anger"] = "Fornace Collera",
	["Forge Camp: Fear"] = "Fornace Paura",
	["Forge Camp: Hate"] = "Fornace Odio",
	["Forge Camp: Mageddon"] = "Fornace Mageddon",
	["Forge Camp: Rage"] = "Fornace Rabbia",
	["Forge Camp: Terror"] = "Fornace Terrore",
	["Forge Camp: Wrath"] = "Fornace Ira",
	["Forge of Fate"] = "Forgia del Fato",
	["Forge of the Endless"] = "Forgia dell'Eternità",
	["Forgewright's Tomb"] = "Tomba di Forgiabruna",
	["Forgotten Depths"] = "Profondità Dimenticate",
	["Forgotten Hill"] = "Collina Dimenticata",
	["Forgotten Mire"] = "Paludi Dimenticate",
	["Forgotten Passageway"] = "Passaggio Dimenticato",
	["Forlorn Cloister"] = "Chiostro Infausto",
	["Forlorn Hut"] = "Capanna Sperduta",
	["Forlorn Ridge"] = "Dorsale Tetra",
	["Forlorn Rowe"] = "Magione Desolata",
	["Forlorn Spire"] = "Torrione Lugubre",
	["Forlorn Woods"] = "Selva Triste",
	["Formation Grounds"] = "Campi di Formazione",
	["Forsaken Forward Command"] = "Comando Avanzato dei Reietti",
	["Forsaken High Command"] = "Alto Comando dei Reietti",
	["Forsaken Rear Guard"] = "Retroguardia dei Reietti",
	["Fort Livingston"] = "Fortino Livingston",
	["Fort Silverback"] = "Covo dei Noccatroce",
	["Fort Triumph"] = "Roccaforte del Trionfo",
	["Fortune's Fist"] = "Pugno della Sorte",
	["Fort Wildervar"] = "Fortilizio di Wildervar",
	["Forward Assault Camp"] = "Campo d'Assalto Avanzato",
	["Forward Command"] = "Comando Avanzato",
	["Foulspore Cavern"] = "Caverna Spora Funesta",
	["Foulspore Pools"] = "Pozze di Spora Funesta",
	["Fountain of the Everseeing"] = "Fontana dello Sguardo Eterno",
	["Fox Grove"] = "Macchia dei Panda Rossi",
	["Fractured Front"] = "Fronte Infranto",
	["Frayfeather Highlands"] = "Alture dei Piumaribelle",
	["Fray Island"] = "Isola della Contesa",
	["Frazzlecraz Motherlode"] = "Campo Minerario di Vangastorta",
	["Freewind Post"] = "Presidio di Ventolibero",
	["Frenzyheart Hill"] = "Collina dei Cuorferoce",
	["Frenzyheart River"] = "Fiume Cuorferoce",
	["Frigid Breach"] = "Breccia Gelata",
	["Frostblade Pass"] = "Passo di Gelalama",
	["Frostblade Peak"] = "Picco di Gelalama",
	["Frostclaw Den"] = "Antro degli Artigli del Gelo",
	["Frost Dagger Pass"] = "Passo di Lama del Gelo",
	["Frostfield Lake"] = "Lago di Campogelo",
	["Frostfire Hot Springs"] = "Sorgenti di Fuocogelo",
	["Frostfloe Deep"] = "Abisso di Bancogelo",
	["Frostgrip's Hollow"] = "Grotta di Ghermigelo",
	Frosthold = "Fortegelo",
	["Frosthowl Cavern"] = "Caverna di Gridogelido",
	["Frostmane Front"] = "Fronte dei Mantogelido",
	["Frostmane Hold"] = "Covo dei Mantogelido",
	["Frostmane Hovel"] = "Antro dei Mantogelido",
	["Frostmane Retreat"] = "Riparo dei Mantogelido",
	Frostmourne = "Gelidanima",
	["Frostmourne Cavern"] = "Caverna di Gelidanima",
	["Frostsaber Rock"] = "Roccia delle Fiere Glaciali",
	["Frostwhisper Gorge"] = "Gola Eco Freddo",
	["Frostwing Halls"] = "Sale delle Ali del Gelo",
	["Frostwolf Graveyard"] = "Cimitero dei Lupi Bianchi",
	["Frostwolf Keep"] = "Rocca dei Lupi Bianchi",
	["Frostwolf Pass"] = "Passo dei Lupi Bianchi",
	["Frostwolf Tunnel"] = "Galleria dei Lupi Bianchi",
	["Frostwolf Village"] = "Villaggio dei Lupi Bianchi",
	["Frozen Reach"] = "Litorale Ghiacciato",
	["Fungal Deep"] = "Grotta Fungosa",
	["Fungal Rock"] = "Roccia del Fungo",
	["Funggor Cavern"] = "Caverna di Funggor",
	["Furien's Post"] = "Accampamento di Furien",
	["Furlbrow's Pumpkin Farm"] = "Campo di Zucche dei Ciglioarcuato",
	["Furnace of Hate"] = "Fornace dell'Odio",
	["Furywing's Perch"] = "Covo di Furial",
	Fuselight = "Lanternia",
	["Fuselight-by-the-Sea"] = "Lanternia sul Mare",
	["Fu's Pond"] = "Stagno di Fu",
	Gadgetzan = "Meccania",
	["Gahrron's Withering"] = "Podere di Gahrron",
	["Gai-Cho Battlefield"] = "Campo di Battaglia di Gai-Cho",
	["Galak Hold"] = "Covo dei Galak",
	["Galakrond's Rest"] = "Fossa di Galakrond",
	["Galardell Valley"] = "Valle di Galardell",
	["Galen's Fall"] = "Caduta di Galen",
	["Galerek's Remorse"] = "Rimorso di Galerek",
	["Galewatch Lighthouse"] = "Faro della Burrasca",
	["Gallery of Treasures"] = "Galleria d'Arte",
	["Gallows' Corner"] = "Crocevia della Forca",
	["Gallows' End Tavern"] = "Taverna dell'Impiccato",
	["Gallywix Docks"] = "Moli di Gallywix",
	["Gallywix Labor Mine"] = "Miniera Penale di Gallywix",
	["Gallywix Pleasure Palace"] = "Palazzo dei Piaceri di Gallywix",
	["Gallywix's Villa"] = "Villa di Gallywix",
	["Gallywix's Yacht"] = "Panfilo di Gallywix",
	["Galus' Chamber"] = "Sala di Galus",
	["Gamesman's Hall"] = "Sala degli Scacchi",
	Gammoth = "Gammoth",
	["Gao-Ran Battlefront"] = "Fronte di Gao-Ran",
	Garadar = "Garadar",
	["Gar'gol's Hovel"] = "Tugurio di Gar'gol",
	Garm = "Garm",
	["Garm's Bane"] = "Sbarramento di Garm",
	["Garm's Rise"] = "Altura di Garm",
	["Garren's Haunt"] = "Covo di Garren",
	["Garrison Armory"] = "Armeria della Guarnigione",
	["Garrosh'ar Advance"] = "Avanzata Garrosh'ar",
	["Garrosh'ar Point"] = "Approdo Garrosh'ar",
	["Garrosh's Landing"] = "Approdo di Garrosh",
	["Garvan's Reef"] = "Scogliera di Garvan",
	["Gate of Echoes"] = "Portale degli Echi",
	["Gate of Endless Spring"] = "Porta dell'Eterna Primavera",
	["Gate of Hamatep"] = "Porta di Hamatep",
	["Gate of Lightning"] = "Portale del Fulmine",
	["Gate of the August Celestials"] = "Porta dei Venerabili Celestiali",
	["Gate of the Blue Sapphire"] = "Portale dello Zaffiro Blu",
	["Gate of the Green Emerald"] = "Portale dello Smeraldo Verde",
	["Gate of the Purple Amethyst"] = "Portale dell'Ametista Viola",
	["Gate of the Red Sun"] = "Portale del Sole Rosso",
	["Gate of the Setting Sun"] = "Porta del Sole Calante",
	["Gate of the Yellow Moon"] = "Portale della Luna Gialla",
	["Gates of Ahn'Qiraj"] = "Porte di Ahn'Qiraj",
	["Gates of Ironforge"] = "Cancelli di Forgiardente",
	["Gates of Sothann"] = "Portale di Sothann",
	["Gauntlet of Flame"] = "Sfida del Fuoco",
	["Gavin's Naze"] = "Promontorio di Gavin",
	["Geezle's Camp"] = "Accampamento di Geezle",
	["Gelkis Village"] = "Villaggio dei Gelkis",
	["General Goods"] = "Beni Generici",
	["General's Terrace"] = "Terrazza del Generale",
	["Ghostblade Post"] = "Bivacco di Lama Spettrale",
	Ghostlands = "Terre Spettrali",
	["Ghost Walker Post"] = "Presidio delle Ombre",
	["Giant's Run"] = "Percorso dei Giganti",
	["Giants' Run"] = "Percorso dei Giganti",
	["Gilded Fan"] = "Acquitrino Dorato",
	["Gillijim's Isle"] = "Isola di Gillijim",
	["Gilnean Coast"] = "Costa Gilneana",
	["Gilnean Stronghold"] = "Roccaforte Gilneana",
	Gilneas = "Gilneas",
	Gilneas2 = "Gilneas",
	["Gilneas City"] = "Città di Gilneas",
	["Gilneas (Do Not Reuse)"] = "Gilneas",
	["Gilneas Liberation Front Base Camp"] = "Campo del Fronte di Liberazione Gilneano",
	GilneasPhase1 = "Gilneas Fase 1",
	GilneasPhase2 = "Gilneas Fase 2",
	["Gimorak's Den"] = "Antro di Gimorak",
	Gjalerbron = "Gjalerbron",
	Gjalerhorn = "Gjalercorn",
	["Glacial Falls"] = "Cascate Ghiacciate",
	["Glimmer Bay"] = "Baia Scintillante",
	["Glimmerdeep Gorge"] = "Faglia di Fondaluce",
	["Glittering Strand"] = "Costa Splendente",
	["Glopgut's Hollow"] = "Antro dei Rodibudella",
	["Glorious Goods"] = "Mercanzie Gloriose",
	Glory = "Gloria",
	["GM Island"] = "Isola dei GM",
	["Gnarlpine Hold"] = "Accampamento dei Mordipigna",
	["Gnaws' Boneyard"] = "Carnaio di Gnaws",
	Gnomeregan = "Gnomeregan",
	["Gobline Mine"] = "Miniera dei Goblin",
	["Goblin Foundry"] = "Fonderia dei Goblin",
	["Goblin Mine"] = "Miniera dei Goblin",
	["Goblin Slums"] = "Bassifondi dei Goblin",
	["Gokk'lok's Grotto"] = "Caverna di Gokk'lok",
	["Gokk'lok Shallows"] = "Riviera di Gokk'lok",
	["Golakka Hot Springs"] = "Sorgenti Calde di Golakka",
	["Gol'Bolar Quarry"] = "Cava di Gol'Bolar",
	["Gol'Bolar Quarry Mine"] = "Miniera di Gol'Bolar",
	["Gold Coast Quarry"] = "Cava della Costa d'Oro",
	["Goldenbough Pass"] = "Passo Ramo d'Oro",
	["Goldenmist Village"] = "Brumadoro",
	["Golden Strand"] = "Spiaggia Dorata",
	["Gold Mine"] = "Miniera d'Oro",
	["Gold Road"] = "Strada dell'Oro",
	["Gold Rush BG"] = "Corsa all'Oro",
	Goldshire = "Borgodoro",
	["Goldtooth's Den"] = "Tana di Dentedoro",
	["Goodgrub Smoking Pit"] = "Fossa Fumante di Buonristoro",
	["Gordok's Seat"] = "Trono di Gordok",
	["Gordunni Outpost"] = "Avamposto dei Gordunni",
	["Gorefiend's Vigil"] = "Presidio di Malacarne",
	["Gor'gaz Outpost"] = "Avamposto di Gor'gaz",
	Gornia = "Gornia",
	["Gorrok's Lament"] = "Lamento di Gorrok",
	["Gorshak War Camp"] = "Campo di Guerra di Gorshak",
	["Go'Shek Farm"] = "Fattoria di Go'shek",
	["Grain Cellar"] = "Scantinato del Grano",
	["Grand Courtyard"] = "Grande Corte",
	["Grand Magister's Asylum"] = "Rifugio del Gran Magistro",
	["Grand Overlook"] = "Grande Rialzo",
	["Grand Promenade"] = "Gran Terrazza",
	["Grangol'var Village"] = "Grangol'var",
	["Granite Springs"] = "Accampamento Mezzapozza",
	["Grassy Cline"] = "Crinale Erboso",
	["Greatwood Vale"] = "Valle Grandalbero",
	["Greengill Coast"] = "Costa dei Branchiaverde",
	["Greenpaw Village"] = "Villaggio di Zampaverde",
	["Greenstone Dojo"] = "Dojo di Pietraverde",
	["Greenstone Inn"] = "Locanda di Pietraverde",
	["Greenstone Masons' Quarter"] = "Quartiere dei Muratori di Pietraverde",
	["Greenstone Quarry"] = "Cava di Pietraverde",
	["Greenstone Village"] = "Pietraverde",
	["Greenwarden's Grove"] = "Selva di Guardiaverde",
	["Greymane Court"] = "Corte dei Mantogrigio",
	["Greymane Manor"] = "Maniero dei Mantogrigio",
	["Greymist Firth"] = "Fiordo dei Brumagrigia",
	["Grim Batol"] = "Grim Batol",
	["Grim Batol Entrance"] = "Ingresso a Grim Batol",
	["Grimesilt Dig Site"] = "Scavi di Golasporca",
	["Grimtotem Compound"] = "Insediamento dei Totem Truce",
	["Grimtotem Post"] = "Avamposto dei Totem Truce",
	Grishnath = "Grishnath",
	Grizzlemaw = "Faucebigia",
	["Grizzlepaw Ridge"] = "Dorsale di Zampagrigia",
	["Grizzly Hills"] = "Colli Bradi",
	["Grol'dom Farm"] = "Fattoria di Grol'dom",
	["Grolluk's Grave"] = "Tomba di Grolluk",
	["Grom'arsh Crash-Site"] = "Relitto del Grom'arsh",
	["Grom'gol"] = "Grom'gol",
	["Grom'gol Base Camp"] = "Forte di Grom'gol",
	["Grommash Hold"] = "Mastio Grommash",
	["Grookin Hill"] = "Colle dei Gruggatori",
	["Grosh'gok Compound"] = "Antro di Grosh'gok",
	["Grove of Aessina"] = "Selva di Aessina",
	["Grove of Falling Blossoms"] = "Giardino dei Boccioli Caduti",
	["Grove of the Ancients"] = "Bosco degli Antichi",
	["Growless Cave"] = "Caverna Ringhiante",
	["Gruul's Lair"] = "Antro di Gruul",
	["Gryphon Roost"] = "Nido dei Grifoni",
	["Guardian's Library"] = "Biblioteca del Guardiano",
	Gundrak = "Gundrak",
	["Gundrak Entrance"] = "Ingresso a Gundrak",
	["Gunstan's Dig"] = "Scavo di Gunstan",
	["Gunstan's Post"] = "Accampamento di Gunstan",
	["Gunther's Retreat"] = "Asilo di Gunther",
	["Guo-Lai Halls"] = "Sale di Guo-Lai",
	["Guo-Lai Ritual Chamber"] = "Stanza Rituale di Guo-Lai",
	["Guo-Lai Vault"] = "Volta di Guo-Lai",
	["Gurboggle's Ledge"] = "Scogliera di Branchiabigia",
	["Gurubashi Arena"] = "Arena dei Gurubashi",
	["Gyro-Plank Bridge"] = "Ponte Giromatico",
	["Haal'eshi Gorge"] = "Gola Haal'eshi",
	["Hadronox's Lair"] = "Antro di Hadronox",
	["Hailwood Marsh"] = "Acquitrino Legnomarcio",
	Halaa = "Halaa",
	["Halaani Basin"] = "Bacino di Halaa",
	["Halcyon Egress"] = "Passaggio di Alcione",
	["Haldarr Encampment"] = "Accampamento di Haldarr",
	Halfhill = "Mezzocolle",
	Halgrind = "Halgrind",
	["Hall of Arms"] = "Salone delle Armi",
	["Hall of Binding"] = "Sala del Vincolo",
	["Hall of Blackhand"] = "Sala di Manonera",
	["Hall of Blades"] = "Sala delle Lame",
	["Hall of Bones"] = "Sala delle Ossa",
	["Hall of Champions"] = "Salone dei Campioni",
	["Hall of Command"] = "Salone del Comando",
	["Hall of Crafting"] = "Sala degli Artigiani",
	["Hall of Departure"] = "Sala della Partenza",
	["Hall of Explorers"] = "Salone degli Esploratori",
	["Hall of Faces"] = "Sala dei Visi",
	["Hall of Horrors"] = "Sala degli Orrori",
	["Hall of Illusions"] = "Sala delle Illusioni",
	["Hall of Kings"] = "Sala dei Re",
	["Hall of Legends"] = "Sala delle Leggende",
	["Hall of Masks"] = "Sala delle Maschere",
	["Hall of Memories"] = "Sala delle Memorie",
	["Hall of Mysteries"] = "Salone dei Misteri",
	["Hall of Repose"] = "Sala del Riposo",
	["Hall of Return"] = "Sala del Ritorno",
	["Hall of Ritual"] = "Sala del Rituale",
	["Hall of Secrets"] = "Sala dei Segreti",
	["Hall of Serpents"] = "Sala dei Serpenti",
	["Hall of Shapers"] = "Sala dei Dominatori",
	["Hall of Stasis"] = "Sala di Stasi",
	["Hall of the Brave"] = "Sala dei Coraggiosi",
	["Hall of the Conquered Kings"] = "Sala dei Re Sconfitti",
	["Hall of the Crafters"] = "Sala degli Artigiani",
	["Hall of the Crescent Moon"] = "Atrio della Luna Crescente",
	["Hall of the Crusade"] = "Sala della Crociata",
	["Hall of the Cursed"] = "Sala dei Maledetti",
	["Hall of the Damned"] = "Sala dei Dannati",
	["Hall of the Defamed"] = "Sala dei Calunniati",
	["Hall of the Exalted"] = "Sala degli Osannati",
	["Hall of the Fathers"] = "Sala dei Padri",
	["Hall of the Frostwolf"] = "Sala dei Lupi Bianchi",
	["Hall of the Grand Imperion"] = "Sala del Grande Imperion",
	["Hall of the High Father"] = "Sala del Gran Padre",
	["Hall of the Keepers"] = "Sala dei Custodi",
	["Hall of the Shaper"] = "Sala del Modellatore",
	["Hall of the Stormpike"] = "Sala dei Piccatonante",
	["Hall of the Tortured"] = "Sala delle Torture",
	["Hall of the Watchers"] = "Sala dei Guardiani",
	["Hall of the Wicked"] = "Sala dei Maligni",
	["Hall of Tombs"] = "Sala delle Tombe",
	["Hall of Tranquility"] = "Sala della Tranquillità",
	["Hall of Tranquillity"] = "Sala della Tranquillità",
	["Hall of Twilight"] = "Sala del Crepuscolo",
	["Halls of Anguish"] = "Sale del Tormento",
	["Halls of Awakening"] = "Sale del Risveglio",
	["Halls of Binding"] = "Sale del Vincolo",
	["Halls of Destruction"] = "Sale della Distruzione",
	["Halls of Flesh-Shaping"] = "Sale dei Plasmatori di Carne",
	["Halls of Lightning"] = "Sale del Fulmine",
	["Halls of Lightning Entrance"] = "Ingresso alle Sale del Fulmine",
	["Halls of Mourning"] = "Sale del Cordoglio",
	["Halls of Origination"] = "Sale della Creazione",
	["Halls of Origination Entrance"] = "Ingresso alle Sale della Creazione",
	["Halls of Reflection"] = "Sale dei Riflessi",
	["Halls of Reflection Entrance"] = "Ingresso alle Sale dei Riflessi",
	["Halls of Silence"] = "Sale del Silenzio",
	["Halls of Stone"] = "Sale della Pietra",
	["Halls of Stone Entrance"] = "Ingresso alle Sale della Pietra",
	["Halls of Strife"] = "Sale dei Conflitti",
	["Halls of the Ancestors"] = "Sale degli Avi",
	["Halls of the Hereafter"] = "Sala dell'Aldilà",
	["Halls of the Law"] = "Sale della Legge",
	["Halls of Theory"] = "Sale della Teoria",
	["Halycon's Lair"] = "Tana di Halycon",
	Hammerfall = "Requie del Martello",
	["Hammertoe's Digsite"] = "Scavi di Mazzadito",
	["Hammond Farmstead"] = "Tenuta degli Hammond",
	Hangar = "Aviorimessa",
	["Hardknuckle Clearing"] = "Radura dei Noccadura",
	["Hardwrench Hideaway"] = "Rifugio di Serrabullona",
	["Harkor's Camp"] = "Accampamento di Harkor",
	["Hatchet Hills"] = "Colline della Mannaia",
	["Hatescale Burrow"] = "Tana degli Scagliafiele",
	["Hatred's Vice"] = "Morsa dell'Odio",
	Havenshire = "Borgorado",
	["Havenshire Farms"] = "Fattorie di Borgorado",
	["Havenshire Lumber Mill"] = "Segheria di Borgorado",
	["Havenshire Mine"] = "Miniera di Borgorado",
	["Havenshire Stables"] = "Scuderia di Borgorado",
	["Hayward Fishery"] = "Porticciolo dei Tagliafieno",
	["Headmaster's Retreat"] = "Rifugio del Rettore",
	["Headmaster's Study"] = "Studio del Rettore",
	Hearthglen = "Valsalda",
	["Heart of Destruction"] = "Cuore della Distruzione",
	["Heart of Fear"] = "Cuore della Paura",
	["Heart of the Old God Scenario"] = "Cuore Oscuro di Pandaria",
	["Heart of Zan'vess"] = "Cuore di Zan'vess",
	["Heart's Blood Shrine"] = "Santuario di Cuor di Sangue",
	["Heartwood Trading Post"] = "Spaccio Cuor di Legno",
	["Heb'Drakkar"] = "Heb'Drakkar",
	["Heb'Valok"] = "Heb'Valok",
	["Hellfire Basin"] = "Conca del Fuoco Infernale",
	["Hellfire Citadel"] = "Cittadella del Fuoco Infernale",
	["Hellfire Citadel: Ramparts"] = "Cittadella del Fuoco Infernale: Bastioni",
	["Hellfire Citadel - Ramparts Entrance"] = "Ingresso ai Bastioni della Cittadella del Fuoco Infernale",
	["Hellfire Citadel: The Blood Furnace"] = "Cittadella del Fuoco Infernale: Forgia del Sangue",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Ingresso alla Forgia del Sangue della Cittadella del Fuoco Infernale",
	["Hellfire Citadel: The Shattered Halls"] = "Cittadella del Fuoco Infernale: Sale della Devastazione",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Ingresso alle Sale della Devastazione della Cittadella del Fuoco Infernale",
	["Hellfire Peninsula"] = "Penisola del Fuoco Infernale",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Penisola del Fuoco Infernale - Testa di Ponte",
	["Hellfire Peninsula - Reaver's Fall"] = "Penisola del Fuoco Infernale - Colle del Mietitore",
	["Hellfire Ramparts"] = "Bastioni del Fuoco Infernale",
	["Hellscream Arena"] = "Arena di Malogrido",
	["Hellscream's Camp"] = "Presidio di Malogrido",
	["Hellscream's Fist"] = "Furia di Malogrido",
	["Hellscream's Grasp"] = "Avamposto di Malogrido",
	["Hellscream's Watch"] = "Presidio di Malogrido",
	["Helm's Bed Lake"] = "Lago di Lettofreddo",
	["Heroes' Vigil"] = "Veglia degli Eroi",
	["Hetaera's Clutch"] = "Artiglio di Hetaera",
	["Hewn Bog"] = "Palude di Fungomozzo",
	["Heyman's Hubris"] = "Superbia di Heyman",
	["Hibernal Cavern"] = "Caverna Invernale",
	["Hidden Cell"] = "Cella Nascosta",
	["Hidden Path"] = "Sentiero Nascosto",
	Highbank = "Altariva",
	["High Bank"] = "Altariva",
	["Highland Forest"] = "Altobosco",
	Highperch = "Covoalto",
	["High Wilderness"] = "Altopiano Selvaggio",
	Hillsbrad = "Colletorto",
	["Hillsbrad Fields"] = "Campi di Colletorto",
	["Hillsbrad Foothills"] = "Alture di Colletorto",
	["Hiri'watha Research Station"] = "Centro Ricerche di Hiri'watha",
	["Hive'Ashi"] = "Alveare Ashi",
	["Hive'Regal"] = "Alveare Regal",
	["Hive'Zora"] = "Alveare Zora",
	["Hogger Hill"] = "Colle di Boccalarga",
	["Hollowed Out Tree"] = "Albero Cavo",
	["Hollowstone Mine"] = "Miniera di Pietracava",
	["Honeydew Farm"] = "Fattoria di Dolcemiele",
	["Honeydew Glade"] = "Radura di Dolcemiele",
	["Honeydew Village"] = "Dolcemiele",
	["Honor Hold"] = "Rocca dell'Onore",
	["Honor Hold Mine"] = "Miniera della Rocca dell'Onore",
	["Honor Point"] = "Rocca dell'Onore",
	["Honor's Stand"] = "Bastione dell'Onore",
	["Honor's Tomb"] = "Cripta dell'Onore",
	["Horde Base Camp"] = "Campo Base dell'Orda",
	["Horde Beach Daily Area"] = "Area Giornaliera Spiaggia dell'Orda",
	["Horde Encampment"] = "Accampamento dell'Orda",
	["Horde Keep"] = "Forte dell'Orda",
	["Horde Landing"] = "Approdo dell'Orda",
	["Horde Landing Site"] = "Approdo dell'Orda",
	["Hordemar City"] = "Ordamar",
	["Horde PVP Barracks"] = "Caserme PvP dell'Orda",
	["Horror Clutch"] = "Morsa dell'Orrore",
	["Hour of Twilight"] = "Ora del Crepuscolo",
	["House of Edune"] = "Residenza degli Edune",
	["Howling Fjord"] = "Fiordo Echeggiante",
	["Howlingwind Cavern"] = "Caverna di Vento Ululante",
	["Howlingwind Trail"] = "Sentiero del Vento Ululante",
	["Howling Ziggurat"] = "Ziggurat Urlante",
	["Hrothgar's Landing"] = "Approdo di Hrothgar",
	["Huangtze Falls"] = "Cascate Huangtze",
	["Hull of the Foebreaker"] = "Scafo dell'Ira del Mare",
	["Humboldt Conflagration"] = "Conflagrazione di Humboldt",
	["Hunter Rise"] = "Altura dei Cacciatori",
	["Hunter's Hill"] = "Colle del Cacciatore",
	["Huntress of the Sun"] = "Cacciatrice del Sole",
	["Huntsman's Cloister"] = "Chiostro dei Cacciatori",
	Hyjal = "Hyjal",
	["Hyjal Barrow Dens"] = "Eremi di Hyjal",
	["Hyjal Past"] = "Passato di Hyjal",
	["Hyjal Summit"] = "Sommità di Hyjal",
	["Iceblood Garrison"] = "Presidio di Brinarossa",
	["Iceblood Graveyard"] = "Cimitero di Brinarossa",
	Icecrown = "Corona di Ghiaccio",
	["Icecrown Citadel"] = "Rocca della Corona di Ghiaccio",
	["Icecrown Dungeon - Gunships"] = "Spedizione della Corona di Ghiaccio - Cannoniere",
	["Icecrown Glacier"] = "Ghiacciaio delle Ossa",
	["Iceflow Lake"] = "Lago di Ghiacciospesso",
	["Ice Heart Cavern"] = "Caverna Cuor di Ghiaccio",
	["Icemist Falls"] = "Cascate di Foscogelo",
	["Icemist Village"] = "Foscogelo",
	["Ice Thistle Hills"] = "Colline dei Cardighiaccio",
	["Icewing Bunker"] = "Fortilizio di Algidala",
	["Icewing Cavern"] = "Caverna di Algidala",
	["Icewing Pass"] = "Gola di Algidala",
	["Idlewind Lake"] = "Lago di Ventofermo",
	["Igneous Depths"] = "Abissi Ignei",
	["Ihgaluk Crag"] = "Ihgaluk",
	["Ik'vess"] = "Ik'vess",
	["Ikz'ka Ridge"] = "Cresta Ikz'ka",
	["Illidari Point"] = "Presidio Illidariano",
	["Illidari Training Grounds"] = "Campi d'Addestramento Illidariani",
	["Indu'le Village"] = "Indu'le",
	["Infiltrating the Shipyard"] = "Accesso al Porto",
	["Inkgill Mere"] = "Stagno dei Branchiafosca",
	Inn = "Locanda",
	["Inner Sanctum"] = "Santuario Interno",
	["Inner Veil"] = "Velo Interno",
	["Insidion's Perch"] = "Covo di Insidion",
	["Invasion Point: Annihilator"] = "Portale di Invasione: Annientamento",
	["Invasion Point: Cataclysm"] = "Portale di Invasione: Cataclisma",
	["Invasion Point: Destroyer"] = "Portale di Invasione: Distruzione",
	["Invasion Point: Overlord"] = "Portale di Invasione: Angoscia",
	["Ironband's Compound"] = "Presidio di Ferrocollo",
	["Ironband's Excavation Site"] = "Scavi di Ferrocollo",
	["Ironbeard's Tomb"] = "Sepolcro di Barbaferrea",
	["Ironclad Cove"] = "Baia della Corazzata",
	["Ironclad Garrison"] = "Guarnigione Corazzata",
	["Ironclad Prison"] = "Prigione di Ferrospesso",
	["Iron Concourse"] = "Viale di Ferro",
	["Irondeep Mine"] = "Miniera di Ferrofondo",
	Ironforge = "Forgiardente",
	["Ironforge Airfield"] = "Aerodromo di Forgiardente",
	["Ironstone Camp"] = "Accampamento di Pietradura",
	["Ironstone Plateau"] = "Altopiano Pietradura",
	["Iron Summit"] = "Vetta di Ferro",
	["Irontree Cavern"] = "Caverna di Troncoferro",
	["Irontree Clearing"] = "Radura di Troncoferro",
	["Irontree Woods"] = "Bosco di Troncoferro",
	["Ironwall Dam"] = "Diga della Muraglia di Ferro",
	["Ironwall Rampart"] = "Bastione della Muraglia di Ferro",
	["Ironwing Cavern"] = "Caverna di Aladura",
	Iskaal = "Iskaal",
	["Island of Doctor Lapidis"] = "Isola del Dottor Lapidis",
	["Isle of Conquest"] = "Isola della Conquista",
	["Isle of Conquest No Man's Land"] = "Terra di Nessuno dell'Isola della Conquista",
	["Isle of Dread"] = "Isola del Terrore",
	["Isle of Giants"] = "Isola dei Giganti",
	["Isle of Quel'Danas"] = "Isola di Quel'Danas",
	["Isle of Reckoning"] = "Isola della Ricerca",
	["Isle of Thunder"] = "Isola del Tuono",
	["Isle of Tribulations"] = "Isola delle Tribolazioni",
	["Iso'rath"] = "Iso'rath",
	["Itharius's Cave"] = "Caverna di Itharius",
	["Ivald's Ruin"] = "Rovine di Ivald",
	["Ix'lar's Domain"] = "Dominio di Ix'lar",
	["Jadefire Glen"] = "Valle dei Giadafulgida",
	["Jadefire Run"] = "Bivacco dei Giadafulgida",
	["Jade Forest Alliance Hub Phase"] = "Foresta di Giada - Fase Missioni Alleanza",
	["Jade Forest Battlefield Phase"] = "Foresta di Giada - Fase Campo di Battaglia",
	["Jade Forest Horde Starting Area"] = "Area di Partenza dell'Orda della Foresta di Giada",
	["Jademir Lake"] = "Lago Jademir",
	["Jade Temple Grounds"] = "Giardini del Tempio di Giada",
	Jaedenar = "Jaedenar",
	["Jagged Reef"] = "Scogliera Frastagliata",
	["Jagged Ridge"] = "Cresta Frastagliata",
	["Jaggedswine Farm"] = "Fattoria Verroscabro",
	["Jagged Wastes"] = "Distese Frastagliate",
	["Jaguero Isle"] = "Isola di Jaguero",
	["Jaina Dalaran Scenario"] = "Scenario: Jaina a Dalaran",
	["Janeiro's Point"] = "Capo Janeiro",
	["Jangolode Mine"] = "Miniera Venacava",
	["Jaquero Isle"] = "Isola di Jaguero",
	["Jasperlode Mine"] = "Miniera Venarossa",
	["Jeff NE Quadrant Changed"] = "Quadrante NE Modificato di Jeff",
	["Jeff NW Quadrant"] = "Quadrante NO di Jeff",
	["Jeff SE Quadrant"] = "Quadrante SE di Jeff",
	["Jeff SW Quadrant"] = "Quadrante SO di Jeff",
	["Jerod's Landing"] = "Molo di Jerod",
	["Jintha'Alor"] = "Jintha'Alor",
	["Jintha'kalar"] = "Jintha'Kalar",
	["Jintha'kalar Passage"] = "Cammino di Jintha'Kalar",
	["Jin Yang Road"] = "Strada di Jin Yang",
	Jotunheim = "Jotunheim",
	K3 = "K3",
	["Kaja'mine"] = "Kaja'mina",
	["Kaja'mite Cave"] = "Grotta di Kaja'mite",
	["Kaja'mite Cavern"] = "Caverna di Kaja'mite",
	["Kajaro Field"] = "Stadio di Kajaro",
	["Kal'ai Ruins"] = "Rovine di Kal'ai",
	Kalimdor = "Kalimdor",
	Kamagua = "Kamagua",
	["Karabor Sewers"] = "Fogne di Karabor",
	Karazhan = "Karazhan",
	["Kargathia Keep"] = "Forte di Kargath",
	["Karnum's Glade"] = "Selva di Karnum",
	["Kartak's Hold"] = "Palizzata di Kartak",
	Kaskala = "Kaskala",
	["Kaw's Roost"] = "Impalcatura di Kaw",
	["Kea Krak"] = "Kea Krak",
	["Keelen's Trustworthy Tailoring"] = "Rinomata Sartoria di Keelen",
	["Keel Harbor"] = "Porto delle Chiglie",
	["Keeshan's Post"] = "Presidio di Keeshan",
	["Kelp'thar Forest"] = "Foresta di Alg'thar",
	["Kel'Thuzad Chamber"] = "Sala di Kel'Thuzad",
	["Kel'Thuzad's Chamber"] = "Sala di Kel'Thuzad",
	["Keset Pass"] = "Passo di Keset",
	["Kessel's Crossing"] = "Crocicchio di Kessel",
	Kezan = "Kezan",
	Kharanos = "Kharanos",
	["Khardros' Anvil"] = "Incudine di Khardros",
	["Khartut's Tomb"] = "Tomba di Khartut",
	["Khaz'goroth's Seat"] = "Piattaforma di Khaz'goroth",
	["Ki-Han Brewery"] = "Birrificio Ki-Han",
	["Kili'ua's Atoll"] = "Isolotto di Kili'ua",
	["Kil'sorrow Fortress"] = "Fortezza di Kil'sorin",
	["King's Gate"] = "Porta del Re",
	["King's Harbor"] = "Porto del Re",
	["King's Hoard"] = "Tesoro Reale",
	["King's Square"] = "Piazza del Re",
	["Kirin'Var Village"] = "Kirin'Var",
	Kirthaven = "Borgogaio",
	["Klaxxi'vess"] = "Klaxxi'vess",
	["Klik'vess"] = "Klik'vess",
	["Knucklethump Hole"] = "Covo dei Noccatroce",
	["Kodo Graveyard"] = "Cimitero dei Kodo",
	["Kodo Rock"] = "Roccia dei Kodo",
	["Kolkar Village"] = "Villaggio dei Kolkar",
	Kolramas = "Kolramas",
	["Kor'kron Vanguard"] = "Avanguardia dei Kor'kron",
	["Kormek's Hut"] = "Capanno di Kormek",
	["Koroth's Den"] = "Rifugio di Koroth",
	["Korthun's End"] = "Riposo di Korthun",
	["Kor'vess"] = "Kor'vess",
	["Kota Basecamp"] = "Campo Base Kota",
	["Kota Peak"] = "Picco Kota",
	["Krasarang Cove"] = "Baia di Krasarang",
	["Krasarang River"] = "Fiume Krasarang",
	["Krasarang Wilds"] = "Giungla di Krasarang",
	["Krasari Falls"] = "Cascate Krasari",
	["Krasus' Landing"] = "Terrazza di Krasus",
	["Krazzworks Attack Zeppelin"] = "Zeppelin d'attacco di Krazzopoli",
	["Kril'Mandar Point"] = "Promontorio di Kril'mandar",
	["Kri'vess"] = "Kri'vess",
	["Krolg's Hut"] = "Capanno di Krolg",
	["Krom'gar Fortress"] = "Fortezza di Krom'gar",
	["Krom's Landing"] = "Approdo di Krom",
	["KTC Headquarters"] = "Quartier Generale della SCK",
	["KTC Oil Platform"] = "Piattaforma d'Estrazione della SCK",
	["Kul'galar Keep"] = "Forte di Kul'galar",
	["Kul Tiras"] = "Kul Tiras",
	["Kun-Lai Pass"] = "Passo del Kun-Lai",
	["Kun-Lai Summit"] = "Massiccio del Kun-Lai",
	["Kunzen Cave"] = "Grotta dei Kunzen",
	["Kunzen Village"] = "Villaggio dei Kunzen",
	["Kurzen's Compound"] = "Insediamento di Kurzen",
	["Kypari Ik"] = "Kypari Ik",
	["Kyparite Quarry"] = "Cava di Kyparite",
	["Kypari Vor"] = "Kypari Vor",
	["Kypari Zar"] = "Kypari Zar",
	["Kzzok Warcamp"] = "Presidio di Guerra Kzzok",
	["Lair of Skiggit"] = "Antro di Skiggit",
	["Lair of the Beast"] = "Antro della Bestia",
	["Lair of the Chosen"] = "Antro del Prescelto",
	["Lair of the Jade Witch"] = "Capanno della Strega di Giada",
	["Lair of Tortos"] = "Antro di Tortos",
	["Lake Al'Ameth"] = "Lago Al'ameth",
	["Lake Cauldros"] = "Lago Cauldros",
	["Lake Dumont"] = "Lago Dumont",
	["Lake Edunel"] = "Lago Edunel",
	["Lake Elrendar"] = "Lago Elrendar",
	["Lake Elune'ara"] = "Lago Elune'ara",
	["Lake Ere'Noru"] = "Lago Ere'Noru",
	["Lake Everstill"] = "Lago Placido",
	["Lake Falathim"] = "Lago Falathim",
	["Lake Indu'le"] = "Lago Indu'le",
	["Lake Jorune"] = "Lago Jorune",
	["Lake Kel'Theril"] = "Lago Kel'Theril",
	["Lake Kittitata"] = "Lago Kittikaka",
	["Lake Kum'uya"] = "Lago Kum'uya",
	["Lake Mennar"] = "Lago Mennar",
	["Lake Mereldar"] = "Lago Mereldar",
	["Lake Nazferiti"] = "Lago Nazferiti",
	["Lake of Stars"] = "Lago delle Stelle",
	["Lakeridge Highway"] = "Cammino Bordolago",
	Lakeshire = "Borgolago",
	["Lakeshire Inn"] = "Locanda di Borgolago",
	["Lakeshire Town Hall"] = "Municipio di Borgolago",
	["Lakeside Landing"] = "Piattaforma del Lago",
	["Lake Sunspring"] = "Lago di Solenuovo",
	["Lakkari Tar Pits"] = "Pozze di Pece di Lakkari",
	["Landing Beach"] = "Spiaggia di Sbarco",
	["Landing Site"] = "Zona d'Atterraggio",
	["Land's End Beach"] = "Ultima Spiaggia",
	["Langrom's Leather & Links"] = "Cuoio e Maglia di Langrom",
	["Lao & Son's Yakwash"] = "Yaklavaggio di Lao e Figli",
	["Largo's Overlook"] = "Presidio di Largo",
	["Largo's Overlook Tower"] = "Torre d'Osservazione di Largo",
	["Lariss Pavilion"] = "Padiglione di Lariss",
	["Laughing Skull Courtyard"] = "Corte dei Teschio Ridente",
	["Laughing Skull Ruins"] = "Rovine dei Teschio Ridente",
	["Launch Bay"] = "Piattaforma di Lancio",
	["Legash Encampment"] = "Accampamento di Legash",
	["Legendary Leathers"] = "Pelli Epiche",
	["Legion Hold"] = "Roccaforte della Legione",
	["Legion's Fate"] = "Fato della Legione",
	["Legion's Rest"] = "Riparo della Legione",
	["Lethlor Ravine"] = "Piana di Lethlor",
	["Level Design Land - Dev Only"] = "Progettazione dei Livelli - Dev Only",
	["Leyara's Sorrow"] = "Pena di Leyara",
	["L'ghorek"] = "L'ghorek",
	["Liang's Retreat"] = "Rifugio di Liang",
	["Library Wing"] = "Ala della Biblioteca",
	Lighthouse = "Faro",
	["Lightning Ascent"] = "Ascesa del Fulmine",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Forgia dei Fulmini - Progresso Scenario Isola del Tuono",
	["Lightning Ledge"] = "Cengia del Fulmine",
	["Lightning Promenade"] = "Terrazza del Fulmine",
	["Lightning Vein Mine"] = "Miniere della Folgore",
	["Light's Breach"] = "Breccia della Luce",
	["Light's Dawn Cathedral"] = "Cattedrale di Albalucente",
	["Light's Hammer"] = "Martello della Luce",
	["Light's Hope Chapel"] = "Cappella della Luce",
	["Light's Point"] = "Rivachiara",
	["Light's Point Tower"] = "Torre di Rivachiara",
	["Light's Shield Tower"] = "Torre dello Scudo Lucente",
	["Light's Trust"] = "Speranza di Luce",
	["Like Clockwork"] = "Macchine Macchinose",
	["Lion's Landing"] = "Approdo del Leone",
	["Lion's Pride Inn"] = "Locanda del Fiero Leone",
	["Livery Outpost"] = "Avamposto Stalle Grigie",
	["Livery Stables"] = "Scuderie Nobili",
	["Livery Stables "] = "Scuderie Nobili",
	["Llane's Oath"] = "Promessa di Llane",
	["Loading Room"] = "Sala di Carico",
	["Loch Modan"] = "Loch Modan",
	["Loch Verrall"] = "Loch Verrall",
	["Loken's Bargain"] = "Dispositivo di Loken",
	["Lonesome Cove"] = "Cala Malinconica",
	Longshore = "Rivalunga",
	["Longying Outpost"] = "Avamposto di Longying",
	["Lordamere Internment Camp"] = "Campo di concentramento di Lordamere",
	["Lordamere Lake"] = "Lago Lordamere",
	["Lor'danel"] = "Lor'danel",
	["Lorthuna's Gate"] = "Portale di Lorthuna",
	["Lost Caldera"] = "Caldera Perduta",
	["Lost City of the Tol'vir"] = "Città Perduta dei Tol'vir",
	["Lost City of the Tol'vir Entrance"] = "Ingresso alla Città Perduta dei Tol'vir",
	LostIsles = "Isole Perdute",
	["Lost Isles Town in a Box"] = "Città-in-Scatola delle Isole Perdute",
	["Lost Isles Volcano Eruption"] = "Eruzione vulcanica delle Isole Perdute",
	["Lost Peak"] = "Picco Perduto",
	["Lost Point"] = "Presidio Perduto",
	["Lost Rigger Cove"] = "Cala del Sartiame",
	["Lothalor Woodlands"] = "Foresta di Lothalor",
	["Lower City"] = "Città Bassa",
	["Lower Silvermarsh"] = "Palude Argentata Inferiore",
	["Lower Sumprushes"] = "Acquitrini Inferiori",
	["Lower Veil Shil'ak"] = "Vol Shil'ak Inferiore",
	["Lower Wilds"] = "Bassopiano Selvaggio",
	["Lumber Mill"] = "Segheria",
	["Lushwater Oasis"] = "Oasi Acquefertili",
	["Lydell's Ambush"] = "Imboscata di Lydell",
	["M.A.C. Diver"] = "S.U.B. Marino",
	["Maelstrom Deathwing Fight"] = "Combattimento di Alamorte sul Maelstrom",
	["Maelstrom Zone"] = "Zona del Maelstrom",
	["Maestra's Post"] = "Accampamento di Maestra",
	["Maexxna's Nest"] = "Nido di Maexxna",
	["Mage Quarter"] = "Quartiere dei Maghi",
	["Mage Tower"] = "Torre del Mago",
	["Mag'har Grounds"] = "Terre dei Mag'har",
	["Mag'hari Procession"] = "Carovana dei Mag'hari",
	["Mag'har Post"] = "Accampamento dei Mag'har",
	["Magical Menagerie"] = "Serraglio Magico",
	["Magic Quarter"] = "Quartiere della Magia",
	["Magisters Gate"] = "Porta dei Magisteri",
	["Magister's Terrace"] = "Terrazza dei Magisteri",
	["Magisters' Terrace"] = "Terrazza dei Magisteri",
	["Magisters' Terrace Entrance"] = "Ingresso alla Terrazza dei Magisteri",
	["Magmadar Cavern"] = "Caverna di Magmadar",
	["Magma Fields"] = "Campi del Magma",
	["Magma Springs"] = "Sorgenti Magmatiche",
	["Magmaw's Fissure"] = "Fenditura di Rodimagma",
	Magmoth = "Magmoth",
	["Magnamoth Caverns"] = "Caverne di Magnamoth",
	["Magram Territory"] = "Territorio dei Magram",
	["Magtheridon's Lair"] = "Antro di Magtheridon",
	["Magus Commerce Exchange"] = "Distretto dei Commercianti",
	["Main Chamber"] = "Sala Principale",
	["Main Gate"] = "Porta Principale",
	["Main Hall"] = "Sala Principale",
	["Maker's Ascent"] = "Ascesa del Creatore",
	["Maker's Overlook"] = "Terrazza dei Creatori",
	["Maker's Overlook "] = "Rialzo del Creatore",
	["Makers' Overlook"] = "Loggia dei Creatori",
	["Maker's Perch"] = "Belvedere dei Creatori",
	["Makers' Perch"] = "Volta dei Creatori",
	["Malaka'jin"] = "Malaka'jin",
	["Malden's Orchard"] = "Frutteto di Malden",
	Maldraz = "Maldraz",
	["Malfurion's Breach"] = "Breccia di Malfurion",
	["Malicia's Outpost"] = "Avamposto di Malicia",
	["Malykriss: The Vile Hold"] = "Malykriss, la Rocca Ignobile",
	["Mama's Pantry"] = "Dispensa della Mamma",
	["Mam'toth Crater"] = "Cratere di Mam'toth",
	["Manaforge Ara"] = "Manaforgia Ara",
	["Manaforge B'naar"] = "Manaforgia B'naar",
	["Manaforge Coruu"] = "Manaforgia Coruu",
	["Manaforge Duro"] = "Manaforgia Duro",
	["Manaforge Ultris"] = "Manaforgia Ultris",
	["Mana Tombs"] = "Tombe del Mana",
	["Mana-Tombs"] = "Tombe del Mana",
	["Mandokir's Domain"] = "Dominio di Mandokir",
	["Mandori Village"] = "Mandori",
	["Mannoroc Coven"] = "Congrega di Mannoroc",
	["Manor Mistmantle"] = "Maniero di Foscomanto",
	["Mantle Rock"] = "Roccia del Manto",
	["Map Chamber"] = "Salone della Mappa",
	["Mar'at"] = "Mar'at",
	Maraudon = "Maraudon",
	["Maraudon - Earth Song Falls Entrance"] = "Ingresso alle Cascate Cantaterra di Maraudon",
	["Maraudon - Foulspore Cavern Entrance"] = "Ingresso alla Caverna Spora Funesta di Maraudon",
	["Maraudon - The Wicked Grotto Entrance"] = "Ingresso alla Grotta Perversa di Maraudon",
	["Mardenholde Keep"] = "Forte Mardenholde",
	Marista = "Marista",
	["Marista's Bait & Brew"] = "Esche e Birre di Marista",
	["Market Row"] = "Strada del Mercato",
	["Marshal's Refuge"] = "Rifugio dei Grant",
	["Marshal's Stand"] = "Accampamento dei Grant",
	["Marshlight Lake"] = "Lago di Luceamara",
	["Marshtide Watch"] = "Forte di Fangosecco",
	["Maruadon - The Wicked Grotto Entrance"] = "Maraudon - Ingresso Tunnel Perversi",
	["Mason's Folly"] = "Scalinata della Follia",
	["Masters' Gate"] = "Portale dei Maestri",
	["Master's Terrace"] = "Terrazza del Padrone",
	["Mast Room"] = "Sala del Pennone",
	["Maw of Destruction"] = "Fauci della Distruzione",
	["Maw of Go'rath"] = "Fauci di Go'rath",
	["Maw of Lycanthoth"] = "Antro di Lycanthoth",
	["Maw of Neltharion"] = "Fauci di Neltharion",
	["Maw of Shu'ma"] = "Fauci di Shu'ma",
	["Maw of the Void"] = "Fauci del Vuoto",
	["Mazra'Alor"] = "Mazra'Alor",
	Mazthoril = "Mazthoril",
	["Mazu's Overlook"] = "Promontorio di Mazu",
	["Medivh's Chambers"] = "Camere di Medivh",
	["Menagerie Wreckage"] = "Detriti del Serraglio",
	["Menethil Bay"] = "Baia di Menethil",
	["Menethil Harbor"] = "Porto di Menethil",
	["Menethil Keep"] = "Forte di Menethil",
	["Merchant Square"] = "Piazza del Mercato",
	Middenvale = "Val Lorda",
	["Mid Point Station"] = "Stazione Centrale",
	["Midrealm Post"] = "Accampamento di Mezzoregno",
	["Midwall Lift"] = "Ascensore di Mezzomuro",
	["Mightstone Quarry"] = "Cava di Pietragrossa",
	["Military District"] = "Distretto Militare",
	["Mimir's Workshop"] = "Officina di Mimir",
	Mine = "Miniera",
	Mines = "Miniere",
	["Mirage Abyss"] = "Abisso dei Miraggi",
	["Mirage Flats"] = "Piana dei Miraggi",
	["Mirage Raceway"] = "Pista dei Miraggi",
	["Mirkfallon Lake"] = "Lago Mirkfallon",
	["Mirkfallon Post"] = "Accampamento di Mirkfallon",
	["Mirror Lake"] = "Lago Riflesso",
	["Mirror Lake Orchard"] = "Frutteto di Lago Riflesso",
	["Mistblade Den"] = "Antro dei Lamabruma",
	["Mistcaller's Cave"] = "Grotta dell'Evocanebbie",
	["Mistfall Village"] = "Calanebbia",
	["Mist's Edge"] = "Costa Bruma",
	["Mistvale Valley"] = "Vallebruma",
	["Mistveil Sea"] = "Mare delle Guglie di Giada",
	["Mistwhisper Refuge"] = "Rifugio dei Soffiabruma",
	["Misty Pine Refuge"] = "Rifugio Foscopino",
	["Misty Reed Post"] = "Avamposto di Cannamarcia",
	["Misty Reed Strand"] = "Riva di Cannamarcia",
	["Misty Ridge"] = "Cresta Fosca",
	["Misty Shore"] = "Lido delle Nebbie",
	["Misty Shores"] = "Lidi Brumosi",
	["Misty Valley"] = "Valbruma",
	["Miwana's Longhouse"] = "Casalunga di Miwana",
	["Mizjah Ruins"] = "Rovine di Mizjah",
	["Moa'ki"] = "Moa'ki",
	["Moa'ki Harbor"] = "Porto di Moa'ki",
	["Moggle Point"] = "Capo Moggle",
	["Mo'grosh Stronghold"] = "Roccaforte di Mo'grosh",
	["Mogu Island Daily Area"] = "Area Giornaliera Isola del Tuono",
	["Mogu Island Events - Alliance Base"] = "Eventi Isola del Tuono - Base dell'Alleanza",
	["Mogu Island Events - Horde Base"] = "Eventi Isola del Tuono - Base dell'Orda",
	["Mogu Island Loot Room"] = "Sala del Bottino dell'Isola del Tuono",
	["Mogu Island Progression Events"] = "Progresso Eventi Isola del Tuono",
	Mogujia = "Mogujia",
	["Mogu'shan Palace"] = "Palazzo Mogu'shan",
	["Mogu'shan Terrace"] = "Terrazza Mogu'shan",
	["Mogu'shan Vaults"] = "Segrete Mogu'shan",
	["Mok'Doom"] = "Presidio di Omokk",
	["Mok'Gordun"] = "Mok'Gordun",
	["Mok'Nathal Village"] = "Mok'Nathal",
	["Mold Foundry"] = "Fonderia degli Stampi",
	["Molten Core"] = "Nucleo Ardente",
	["Molten Front"] = "Fronte Magmatico",
	Moonbrook = "Rivoluna",
	Moonglade = "Radaluna",
	["Moongraze Woods"] = "Selvaluna",
	["Moon Horror Den"] = "Antro dell'Orrore Lunare",
	["Moonrest Gardens"] = "Giardini di Lunanuova",
	["Moonshrine Ruins"] = "Rovine del Tempio della Luna",
	["Moonshrine Sanctum"] = "Santuario del Tempio della Luna",
	["Moontouched Den"] = "Tana di Luna Lucente",
	["Moonwater Retreat"] = "Rifugio di Acqualuna",
	["Moonwell of Cleansing"] = "Pozzo Lunare della Purificazione",
	["Moonwell of Purity"] = "Pozzo Lunare della Purezza",
	["Moonwing Den"] = "Covo di Alaluna",
	["Mord'rethar: The Death Gate"] = "Mord'rethar, Cancello della Morte",
	["Morgan's Plot"] = "Camposanto di Morgan",
	["Morgan's Vigil"] = "Presidio di Morgan",
	["Morlos'Aran"] = "Morlos'Aran",
	["Morning Breeze Lake"] = "Lago della Brezza Mattutina",
	["Morning Breeze Village"] = "Brezza Mattutina",
	Morrowchamber = "Sala della Linfa",
	["Mor'shan Base Camp"] = "Accampamento Mor'shan",
	["Mortal's Demise"] = "Crollo dei Mortali",
	["Mortbreath Grotto"] = "Caverna dei Fiatoferale",
	["Mortwake's Tower"] = "Torre di Vegliamorte",
	["Mosh'Ogg Ogre Mound"] = "Tumulo degli Ogre Mosh'ogg",
	["Mosshide Fen"] = "Pantano dei Pelomusco",
	["Mosswalker Village"] = "Muschiovivo",
	["Mossy Pile"] = "Tumulo Muschioso",
	["Motherseed Pit"] = "Fossa dei Semimaterni",
	["Mountainfoot Strip Mine"] = "Cava di Piemontano",
	["Mount Akher"] = "Monte Akher",
	["Mount Hyjal"] = "Monte Hyjal",
	["Mount Hyjal Phase 1"] = "Monte Hyjal Fase 1",
	["Mount Neverest"] = "Monte Neverest",
	["Muckscale Grotto"] = "Caverna degli Scagliarotta",
	["Muckscale Shallows"] = "Riviera degli Scagliarotta",
	["Mudmug's Place"] = "Casale di Pintapalta",
	Mudsprocket = "Melmarmitta",
	Mulgore = "Mulgore",
	["Murder Row"] = "Traversa degli Intrighi",
	["Murkdeep Cavern"] = "Caverna di Fondobuio",
	["Murky Bank"] = "Ansa Torbida",
	["Muskpaw Ranch"] = "Tenuta di Palmo Muschiato",
	["Mystral Lake"] = "Lago Mystral",
	Mystwood = "Bosco Brumo",
	Nagrand = "Nagrand",
	["Nagrand Arena"] = "Arena di Nagrand",
	Nahom = "Nahom",
	["Nar'shola Terrace"] = "Terrazza di Nar'shola",
	["Narsong Spires"] = "Guglie di Narsong",
	["Narsong Trench"] = "Fossa di Narsong",
	["Narvir's Cradle"] = "Impalcatura di Narvir",
	["Nasam's Talon"] = "Artiglio di Nasam",
	["Nat's Landing"] = "Molo di Nat",
	["Naval Battle Scenario"] = "Scenario: Battaglia in Mare Aperto",
	Naxxanar = "Naxxanar",
	Naxxramas = "Naxxramas",
	["Nayeli Lagoon"] = "Laguna Nayeli",
	["Naz'anak: The Forgotten Depths"] = "Naz'anak, l'Abisso Dimenticato",
	["Nazj'vel"] = "Nazj'vel",
	Nazzivian = "Nazzivian",
	["Nectarbreeze Orchard"] = "Frutteto Dolce Brezza",
	["Needlerock Chasm"] = "Baratro di Rocciaguglia",
	["Needlerock Slag"] = "Macerie di Rocciaguglia",
	["Nefarian's Lair"] = "Antro di Nefarian",
	["Nefarian�s Lair"] = "Antro di Nefarian",
	["Neferset City"] = "Neferset",
	["Neferset City Outskirts"] = "Periferia di Neferset",
	["Nek'mani Wellspring"] = "Sorgente di Nek'mani",
	["Neptulon's Rise"] = "Osservatorio di Neptulon",
	["Nesingwary Base Camp"] = "Campo Base di Nesingwary",
	["Nesingwary Safari"] = "Bivacco di Nesingwary",
	["Nesingwary's Expedition"] = "Spedizione di Nesingwary",
	["Nesingwary's Safari"] = "Accampamento di Nesingwary",
	Nespirah = "Nespirah",
	["Nestlewood Hills"] = "Colline di Legnocelato",
	["Nestlewood Thicket"] = "Selva di Legnocelato",
	["Nethander Stead"] = "Cascina dei Nethander",
	["Nethergarde Keep"] = "Forte di Guardiafatua",
	["Nethergarde Mines"] = "Miniere di Guardiafatua",
	["Nethergarde Supply Camps"] = "Campi di Rifornimento di Guardiafatua",
	Netherspace = "Spaziofatuo",
	Netherstone = "Pietrafatua",
	Netherstorm = "Landa Fatua",
	["Netherweb Ridge"] = "Cresta di Telafatua",
	["Netherwing Fields"] = "Campi degli Alafatua",
	["Netherwing Ledge"] = "Isola degli Alafatua",
	["Netherwing Mines"] = "Miniere degli Alafatua",
	["Netherwing Pass"] = "Passo degli Alafatua",
	["Neverest Basecamp"] = "Campo Base Neverest",
	["Neverest Pinnacle"] = "Vetta del Neverest",
	["New Agamand"] = "Nuova Agamand",
	["New Agamand Inn"] = "Locanda di Nuova Agamand",
	["New Avalon"] = "Nuova Avalon",
	["New Avalon Fields"] = "Campi di Nuova Avalon",
	["New Avalon Forge"] = "Forgia di Nuova Avalon",
	["New Avalon Orchard"] = "Frutteto di Nuova Avalon",
	["New Avalon Town Hall"] = "Municipio di Nuova Avalon",
	["New Cifera"] = "Nuova Cifera",
	["New Hearthglen"] = "Nuova Valsalda",
	["New Kargath"] = "Nuova Kargath",
	["New Thalanaar"] = "Nuova Thalanaar",
	["New Tinkertown"] = "Nuova Rabberciopoli",
	["Nexus Legendary"] = "Nexus Leggendaria",
	Nidavelir = "Nidavelir",
	["Nidvar Stair"] = "Scalinata di Nidvar",
	Nifflevar = "Nifflevar",
	["Night Elf Village"] = "Villaggio degli Elfi della Notte",
	Nighthaven = "Nottequieta",
	["Nightingale Lounge"] = "Circolo dell'Usignolo",
	["Nightmare Depths"] = "Profondità dell'Incubo",
	["Nightmare Scar"] = "Faglia dell'Incubo",
	["Nightmare Vale"] = "Valle degli Incubi",
	["Night Run"] = "Jorxian",
	["Nightsong Woods"] = "Boschi del Canto Notturno",
	["Night Web's Hollow"] = "Valle Telanera",
	["Nijel's Point"] = "Presidio di Nijel",
	["Nimbus Rise"] = "Terrazza di Nimbus",
	Nine = "Nove",
	["Niuzao Catacombs"] = "Catacombe di Niuzao",
	["Niuzao Temple"] = "Tempio di Niuzao",
	["Njord's Breath Bay"] = "Baia Soffio di Njord",
	["Njorndar Village"] = "Njorndar",
	["Njorn Stair"] = "Scalinata di Njorn",
	["Nook of Konk"] = "Radura di Konk",
	["Noonshade Ruins"] = "Rovine di Ombracorta",
	Nordrassil = "Nordrassil",
	["Nordrassil Inn"] = "Locanda di Nordrassil",
	["Nordune Ridge"] = "Cresta di Nordune",
	["North Common Hall"] = "Sala Comune Settentrionale",
	Northdale = "Valnordia",
	["Northern Barrens"] = "Savane Settentrionali",
	["Northern Elwynn Mountains"] = "Montagne Settentrionali di Elwynn",
	["Northern Headlands"] = "Alture Settentrionali",
	["Northern Rampart"] = "Bastione Settentrionale",
	["Northern Rocketway"] = "Terminale Settentrionale della Razzovia",
	["Northern Rocketway Exchange"] = "Scambio Settentrionale della Razzovia",
	["Northern Stranglethorn"] = "Rovotorto Settentrionale",
	["Northfold Manor"] = "Maniero dei Norten",
	["Northgate Breach"] = "Breccia della Porta Nord",
	["North Gate Outpost"] = "Avamposto Settentrionale",
	["North Gate Pass"] = "Passo Settentrionale",
	["Northgate River"] = "Fiume della Porta Nord",
	["Northgate Woods"] = "Bosco della Porta Nord",
	["Northmaul Tower"] = "Torre Maglio del Nord",
	["Northpass Tower"] = "Torre Passo Nord",
	["North Point Station"] = "Stazione Settentrionale",
	["North Point Tower"] = "Torre Settentrionale",
	Northrend = "Nordania",
	["Northridge Lumber Camp"] = "Campo di Taglio Cresta Nord",
	["North Sanctum"] = "Santuario del Nord",
	Northshire = "Contea del Nord",
	["Northshire Abbey"] = "Abbazia della Contea del Nord",
	["Northshire River"] = "Fiume della Contea del Nord",
	["Northshire Valley"] = "Valle della Contea del Nord",
	["Northshire Vineyards"] = "Vigne della Contea del Nord",
	["North Spear Tower"] = "Torre Lancia del Nord",
	["North Tide's Beachhead"] = "Sbarco della Marea del Nord",
	["North Tide's Run"] = "Costa della Marea del Nord",
	["Northwatch Expedition Base Camp"] = "Campo Base dei Custodi del Nord",
	["Northwatch Expedition Base Camp Inn"] = "Locanda del Campo Base dei Custodi del Nord",
	["Northwatch Foothold"] = "Avamposto dei Custodi del Nord",
	["Northwatch Hold"] = "Fortezza dei Custodi del Nord",
	["Northwind Cleft"] = "Faglia Vento del Nord",
	["North Wind Tavern"] = "Taverna Vento del Nord",
	["Nozzlepot's Outpost"] = "Avamposto di Scaldapignatta",
	["Nozzlerust Post"] = "Bivacco di Pinzagelata",
	["Oasis of the Fallen Prophet"] = "Oasi del Profeta Caduto",
	["Oasis of Vir'sar"] = "Oasi di Vir'sar",
	["Obelisk of the Moon"] = "Obelisco della Luna",
	["Obelisk of the Stars"] = "Obelisco delle Stelle",
	["Obelisk of the Sun"] = "Obelisco del Sole",
	["O'Breen's Camp"] = "Campo di O'Breen",
	["Observance Hall"] = "Sala dell'Osservanza",
	["Observation Grounds"] = "Terreno d'Osservazione",
	["Obsidian Breakers"] = "Scogliere d'Ossidiana",
	["Obsidian Dragonshrine"] = "Santuario dei Draghi di Ossidiana",
	["Obsidian Forest"] = "Foresta d'Ossidiana",
	["Obsidian Lair"] = "Tana d'Ossidiana",
	["Obsidia's Perch"] = "Covo di Obsidia",
	["Odesyus' Landing"] = "Approdo di Odesyus",
	["Ogri'la"] = "Ogri'la",
	["Ogri'La"] = "Ogri'la",
	["Old Hillsbrad Foothills"] = "Passato delle Alture di Colletorto",
	["Old Ironforge"] = "Vecchia Forgiardente",
	["Old Town"] = "Città Vecchia",
	Olembas = "Olembas",
	["Olivia's Pond"] = "Laghetto di Olivia",
	["Olsen's Farthing"] = "Tenuta degli Olsen",
	Oneiros = "Oneiros",
	["One Keg"] = "Mezzabotte",
	["One More Glass"] = "Alla Salute",
	["Onslaught Base Camp"] = "Campo Base delle Furie",
	["Onslaught Harbor"] = "Porto delle Furie",
	["Onyxia's Lair"] = "Antro di Onyxia",
	["Oomlot Village"] = "Oomlot",
	["Oona Kagu"] = "Una Kagu",
	Oostan = "Oostan",
	["Oostan Nord"] = "Oostan Nord",
	["Oostan Ost"] = "Oostan Ost",
	["Oostan Sor"] = "Oostan Sor",
	["Opening of the Dark Portal"] = "Palude Nera",
	["Opening of the Dark Portal Entrance"] = "Ingresso all'Apertura del Portale Oscuro",
	["Oratorium of the Voice"] = "Vestibolo dell'Oratore",
	["Oratory of the Damned"] = "Oratorio dei Dannati",
	["Orchid Hollow"] = "Conca delle Orchidee",
	["Orebor Harborage"] = "Rifugio di Orebor",
	["Oregrind's Dig"] = "Scavi di Tritagemme",
	["Orendil's Retreat"] = "Rifugio di Orendil",
	Orgrimmar = "Orgrimmar",
	["Orgrimmar Gunship Pandaria Start"] = "Cannoniera di Orgrimmar, Area d'Inizio di Pandaria",
	["Orgrimmar Rear Gate"] = "Ingresso Posteriore di Orgrimmar",
	["Orgrimmar Rocketway Exchange"] = "Scambio della Razzovia di Orgrimmar",
	["Orgrim's Hammer"] = "Martello di Orgrim",
	["Oronok's Farm"] = "Fattoria di Oronok",
	Orsis = "Orsis",
	["Ortell's Hideout"] = "Rifugio di Ortell",
	["Oshu'gun"] = "Oshu'gun",
	["Outdoor Ruins"] = "Rovine Esterne",
	Outland = "Terre Esterne",
	["Overgrown Camp"] = "Accampamento del Labirinto Verde",
	["Overgrown Statuary"] = "Sala delle Statue in Rovina",
	["Owen's Wishing Well"] = "Pozzo dei Desideri di Owen",
	["Owl Wing Thicket"] = "Selva Ala di Gufo",
	["Palace Antechamber"] = "Anticamera del Palazzo",
	["Pal'ea"] = "Pal'ea",
	["Palemane Rock"] = "Roccia dei Mantopallido",
	["Pandaren Mine"] = "Miniera dei Pandaren",
	Pandaria = "Pandaria",
	["Pang's Stead"] = "Dimora di Pang",
	["Panic Clutch"] = "Morsa del Panico",
	["Paoquan Hollow"] = "Rifugio di Paoquan",
	["Parhelion Plaza"] = "Piazza Parelio",
	["Passage of Lost Fiends"] = "Passaggio degli Spiriti Perduti",
	["Path of a Hundred Steps"] = "Sentiero dei Cento Gradini",
	["Path of Conquerors"] = "Passaggio dei Conquistatori",
	["Path of Enlightenment"] = "Sentiero dell'Illuminazione",
	["Path of Serenity"] = "Passaggio della Serenità",
	["Path of the Titans"] = "Sentiero dei Titani",
	["Path of Uther"] = "Sentiero di Uther",
	["Pattymack Land"] = "Terra di Pattymack",
	["Pauper's Walk"] = "Cammino dell'Indigente",
	["Paur's Pub"] = "Taverna di Paur",
	["Paw'don Glade"] = "Radura di Pan'don",
	["Paw'don Village"] = "Pan'don",
	["Paw'Don Village"] = "Pan'don",
	["Peak of Serenity"] = "Picco della Serenità",
	["Pearlfin Village"] = "Villaggio dei Pinnavitrea",
	["Pearl Lake"] = "Lago Vitreo",
	["Pedestal of Hope"] = "Volta della Speranza",
	["Pei-Wu Forest"] = "Foresta di Pei-Wu",
	["Pestilent Scar"] = "Gola Pestilenziale",
	["Pet Battle - Jade Forest"] = "Mascotte da Combattimento - Foresta di Giada",
	["Petitioner's Chamber"] = "Sala dei Supplicanti",
	["Pilgrim's Precipice"] = "Precipizio del Pellegrino",
	["Pincer X2"] = "Chela X2",
	["Pinnacle of Storms"] = "Pinnacolo delle Tempeste",
	["Pit of Fangs"] = "Fossa delle Zanne",
	["Pit of Saron"] = "Fossa di Saron",
	["Pit of Saron Entrance"] = "Ingresso alla Fossa di Saron",
	["Plaguelands: The Scarlet Enclave"] = "Terre Infette: l'Enclave Scarlatta",
	["Plaguemist Ravine"] = "Gola di Piagabruma",
	Plaguewood = "Malaselva",
	["Plaguewood Tower"] = "Torre di Malaselva",
	["Plain of Echoes"] = "Piana degli Echi",
	["Plain of Shards"] = "Piana dei Frammenti",
	["Plain of Thieves"] = "Piana dei Ladri",
	["Plains of Nasam"] = "Pianure di Nasam",
	["Pod Cluster"] = "Capsula di Salvataggio",
	["Pod Wreckage"] = "Capsula Distrutta",
	["Poison Falls"] = "Cascate Avvelenate",
	["Pool of Reflection"] = "Pozza del Riflesso",
	["Pool of Tears"] = "Bacino delle Lacrime",
	["Pool of the Paw"] = "Pozza della Zampa",
	["Pool of Twisted Reflections"] = "Stagno dei Riflessi Distorti",
	["Pools of Aggonar"] = "Pozze di Aggonar",
	["Pools of Arlithrien"] = "Pozze di Arlithrien",
	["Pools of Jin'Alai"] = "Vasca di Jin'Alai",
	["Pools of Purity"] = "Stagni della Purezza",
	["Pools of Youth"] = "Fonti della Giovinezza",
	["Pools of Zha'Jin"] = "Vasche di Zha'Jin",
	["Portal Clearing"] = "Radura del Portale",
	["Pranksters' Hollow"] = "Antro dei Piantagrane",
	["Predator's Perch"] = "Covo della Predatrice",
	["Prison of Immol'thar"] = "Prigione di Immol'thar",
	["Programmer Isle"] = "Isola dei Programmatori",
	["Promontory Point"] = "Promontorio Sommerso",
	["Prospector's Point"] = "Bivacco del Prospettore",
	["Protectorate Watch Post"] = "Presidio del Protettorato",
	["Proving Grounds"] = "Piana del Conflitto",
	["Purespring Cavern"] = "Caverna di Fontepura",
	["Purgation Isle"] = "Isola della Purificazione",
	["Pursuing the Black Harvest"] = "Inseguimento della Mietitura Oscura",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Laboratorio degli Allegri Orrori Alchemici di Putricidio",
	["Pyrewood Chapel"] = "Cappella di Rovonero",
	["Pyrewood Inn"] = "Locanda di Rovonero",
	["Pyrewood Town Hall"] = "Municipio di Rovonero",
	["Pyrewood Village"] = "Rovonero",
	["Pyrox Flats"] = "Pianure di Pyrox",
	["QA and DVD"] = "CQ e DVD",
	["Quagg Ridge"] = "Cresta Boleta",
	Quarry = "Cava",
	["Quartzite Basin"] = "Bacino di Quarzite",
	["Queen's Gate"] = "Porta della Regina",
	["Quel'Danil Lodge"] = "Padiglione Quel'Danil",
	["Quel'Delar's Rest"] = "Requie di Quel'Delar",
	["Quel'Dormir Gardens"] = "Giardini di Quel'Dormir",
	["Quel'Dormir Temple"] = "Tempio di Quel'Dormir",
	["Quel'Dormir Terrace"] = "Terrazza di Quel'Dormir",
	["Quel'Lithien Lodge"] = "Padiglione Quel'Lithien",
	["Quel'thalas"] = "Quel'Thalas",
	["Quickchop's Lumber Farm"] = "Segheria dello Sbriciolatore",
	["Raastok Glade"] = "Acquitrino di Raastok",
	["Raceway Ruins"] = "Rovine della Pista",
	["Rageclaw Den"] = "Covo dei Malartiglio",
	["Rageclaw Lake"] = "Lago dei Malartiglio",
	["Rage Fang Shrine"] = "Santuario di Fauce Rabbiosa",
	["Ragefeather Ridge"] = "Cresta di Piumadura",
	["Ragefire Caverns"] = "Caverne di Fiamma Furente",
	["Ragefire Chasm"] = "Baratro di Fiamma Furente",
	["Ragefire Core"] = "Nucleo di Fiamma Furente",
	["Rage Scar Hold"] = "Tana degli Artiglio Selvaggio",
	["Ragnaros' Lair"] = "Antro di Ragnaros",
	["Ragnaros' Reach"] = "Presidio di Ragnaros",
	["Rainspeaker Canopy"] = "Villaggio di Cantapioggia",
	["Rainspeaker Rapids"] = "Rapide di Cantapioggia",
	Ramkahen = "Ramkahen",
	["Ramkahen Legion Outpost"] = "Avamposto della Legione dei Ramkahen",
	["Rampart of Skulls"] = "Bastione dei Teschi",
	["Ranazjar Isle"] = "Isola di Ranazjar",
	["Raptor Pens"] = "Recinti dei Raptor",
	["Raptor Ridge"] = "Dorsale dei Raptor",
	["Raptor Rise"] = "Altura dei Raptor",
	Ratchet = "Porto Paranco",
	["Rated Eye of the Storm"] = "Occhio del Ciclone Classificato",
	["Ravaged Caravan"] = "Carovana Depredata",
	["Ravaged Crypt"] = "Cripta Depredata",
	["Ravaged Twilight Camp"] = "Accampamento Devastato del Crepuscolo",
	["Ravencrest Monument"] = "Colosso di Crinocorvo",
	["Raven Hill"] = "Collecorvo",
	["Raven Hill Cemetery"] = "Cimitero di Collecorvo",
	["Ravenholdt Manor"] = "Maniero dei Corvolesto",
	["Raven's Watch"] = "Terrazzo del Corvo",
	["Raven's Wood"] = "Selva del Corvo",
	["Raynewood Retreat"] = "Rifugio di Legnovivo",
	["Raynewood Tower"] = "Torre di Legnovivo",
	["Razaan's Landing"] = "Approdo di Razaan",
	["Razorfen Downs"] = "Sotterranei di Lamaspina",
	["Razorfen Downs Entrance"] = "Ingresso ai Sotterranei di Lamaspina",
	["Razorfen Kraul"] = "Gallerie di Lamaspina",
	["Razorfen Kraul Entrance"] = "Ingresso alle Gallerie di Lamaspina",
	["Razor Hill"] = "Tranciacolle",
	["Razor Hill Barracks"] = "Caserma di Tranciacolle",
	["Razor Hill Outskirts"] = "Sobborghi di Tranciacolle",
	["Razor Hill Watchtower"] = "Torre di Guardia di Tranciacolle",
	["Razormane Grounds"] = "Terre dei Chiomaguzza",
	["Razor Ridge"] = "Cresta delle Lame",
	["Razorscale's Aerie"] = "Dimora di Scagliafusa",
	["Razorthorn Rise"] = "Altopiano di Tranciaspina",
	["Razorthorn Shelf"] = "Passo di Tranciaspina",
	["Razorthorn Trail"] = "Sentiero di Tranciaspina",
	["Razorwind Canyon"] = "Canyon Brezza Aguzza",
	["Rear Staging Area"] = "Base Operativa di Retrovia",
	["Reaver's Fall"] = "Colle del Mietitore",
	["Reavers' Hall"] = "Sala dei Saccheggiatori",
	["Rebel Camp"] = "Campo dei Ribelli",
	["Red Cloud Mesa"] = "Mesa Nuvola Rossa",
	["Redpine Dell"] = "Valletta dei Pinorosso",
	["Redridge - Bridge Phase One"] = "Redridge - Bridge Phase One",
	["Redridge - Bridge Phase Two"] = "Redridge - Bridge Phase Two",
	["Redridge Canyons"] = "Canyon di Crestarossa",
	["Redridge Mountains"] = "Montagne Crestarossa",
	["Redridge - Orc Bomb"] = "Redridge - Orc Bomb",
	["Red Rocks"] = "Massi Rossi",
	["Redwood Trading Post"] = "Spaccio Gran Sequoia",
	Refinery = "Raffineria",
	["Refugee Caravan"] = "Carovana dei Rifugiati",
	["Refuge Pointe"] = "Fosso dei Rifugiati",
	["Refuse Disposal"] = "Discarica dei Rifiuti",
	["Reliquary of Agony"] = "Reliquiario dell'Agonia",
	["Reliquary of Pain"] = "Reliquiario del Dolore",
	["Remains of Iris Lake"] = "Resti del Lago Iris",
	["Remains of the Fleet"] = "Resti della Flotta",
	["Remtravel's Excavation"] = "Scavi di Errasogni",
	["Render's Camp"] = "Accampamento di Rend",
	["Render's Crater"] = "Cratere della Valle di Rend",
	["Render's Rock"] = "Roccia di Rend",
	["Render's Valley"] = "Valle di Rend",
	["Rensai's Watchpost"] = "Posto di Guardia di Rensai",
	["Rethban Caverns"] = "Caverne di Rethban",
	["Rethress Sanctum"] = "Santuario di Rethress",
	Reuse = "Reuse",
	["Reuse Me 7"] = "Reuse Me 7",
	["Revantusk Village"] = "Villaggio degli Zannatorta",
	["Rhea's Camp"] = "Accampamento di Rhea",
	["Rhonin's Beard"] = "Barba di Rhonin",
	["Rhyolith Plateau"] = "Altopiano di Rhyolith",
	["Ricket's Folly"] = "Cratere di Ricket",
	["Ridge of Laughing Winds"] = "Cresta dei Venti Ridenti",
	["Ridge of Madness"] = "Cresta della Follia",
	["Ridgepoint Tower"] = "Torre Cresta Alta",
	Rikkilea = "Rikkilea",
	["Rikkitun Village"] = "Rikkitun",
	["Rim of the World"] = "Margine del Mondo",
	["Ring of Judgement"] = "Arena del Giudizio",
	["Ring of Observance"] = "Anello dell'Osservanza",
	["Ring of the Elements"] = "Circolo degli Elementi",
	["Ring of the Law"] = "Anello della Legge",
	["Riplash Ruins"] = "Rovine degli Sferzalama",
	["Riplash Strand"] = "Sponda degli Sferzalama",
	["Rise of Suffering"] = "Altura della Sofferenza",
	["Rise of the Defiler"] = "Alture del Profanatore",
	["Ritual Chamber of Akali"] = "Sala del Rituale di Akali",
	["Rivendark's Perch"] = "Covo di Noctor",
	Rivenwood = "Bosco di Legnotorvo",
	["River's Heart"] = "Cuordifiume",
	["Rock of Durotan"] = "Roccia di Durotan",
	["Rockpool Village"] = "Villaggio dei Pozzaroccia",
	["Rocktusk Farm"] = "Fattoria Zannapietra",
	["Roguefeather Den"] = "Antro delle Piume Furenti",
	["Rogues' Quarter"] = "Quartiere dei Ladri",
	["Rohemdal Pass"] = "Passo di Rohemdal",
	["Roland's Doom"] = "Rovina di Roland",
	["Room of Hidden Secrets"] = "Sala dei Segreti Nascosti",
	["Roost of Ji-Kun"] = "Nido di Ji-Kun",
	["Rotbrain Encampment"] = "Accampamento dei Craniomarcio",
	["Royal Amphitheater"] = "Anfiteatro Reale",
	["Royal Approach"] = "Androne Reale",
	["Royal Exchange Auction House"] = "Casa d'Asta Reale",
	["Royal Exchange Bank"] = "Banca Reale",
	["Royal Gallery"] = "Galleria Reale",
	["Royal Library"] = "Biblioteca Reale",
	["Royal Quarter"] = "Quartiere Reale",
	["Ruby Dragonshrine"] = "Santuario dei Draghi di Rubino",
	["Ruined Approach"] = "Androne Dissestato",
	["Ruined City Post 01"] = "Postazione Città in Rovina 01",
	["Ruined Court"] = "Corte Sfondata",
	["Ruins of Aboraz"] = "Rovine di Aboraz",
	["Ruins of Ahmtul"] = "Rovine di Ahmtul",
	["Ruins of Ahn'Qiraj"] = "Rovine di Ahn'Qiraj",
	["Ruins of Alterac"] = "Rovine d'Alterac",
	["Ruins of Ammon"] = "Rovine di Ammon",
	["Ruins of Arkkoran"] = "Rovine di Arkkoran",
	["Ruins of Auberdine"] = "Rovine di Auberdine",
	["Ruins of Baa'ri"] = "Rovine di Baa'ri",
	["Ruins of Constellas"] = "Rovine di Constellas",
	["Ruins of Dojan"] = "Rovine di Dojan",
	["Ruins of Drakgor"] = "Rovine di Drakgor",
	["Ruins of Drak'Zin"] = "Rovine di Drak'Zin",
	["Ruins of Eldarath"] = "Rovine di Eldarath",
	["Ruins of Eldarath "] = "Rovine di Eldarath",
	["Ruins of Eldra'nath"] = "Rovine di Eldra'nath",
	["Ruins of Eldre'thar"] = "Rovine di Eldre'thar",
	["Ruins of Enkaat"] = "Rovine di Enkaat",
	["Ruins of Farahlon"] = "Rovine di Farahlon",
	["Ruins of Feathermoon"] = "Rovine di Piumaluna",
	["Ruins of Gilneas"] = "Rovine di Gilneas",
	["Ruins of Gilneas City"] = "Rovine della Città di Gilneas",
	["Ruins of Guo-Lai"] = "Rovine di Guo-Lai",
	["Ruins of Isildien"] = "Rovine di Isildien",
	["Ruins of Jubuwal"] = "Rovine di Jubuwal",
	["Ruins of Karabor"] = "Rovine di Karabor",
	["Ruins of Kargath"] = "Rovine di Kargath",
	["Ruins of Khintaset"] = "Rovine di Khintaset",
	["Ruins of Korja"] = "Rovine di Korja",
	["Ruins of Korune"] = "Rovine dei Korune",
	["Ruins of Lar'donir"] = "Rovine di Lar'donir",
	["Ruins of Lordaeron"] = "Rovine di Lordaeron",
	["Ruins of Loreth'Aran"] = "Rovine di Loreth'Aran",
	["Ruins of Lornesta"] = "Rovine di Lornesta",
	["Ruins of Mathystra"] = "Rovine di Mathystra",
	["Ruins of Nordressa"] = "Rovine di Nordressa",
	["Ruins of Ogudei"] = "Rovine di Ogudei",
	["Ruins of Ravenwind"] = "Rovine di Corvovento",
	["Ruins of Sha'naar"] = "Rovine di Sha'naar",
	["Ruins of Shandaral"] = "Rovine di Shandaral",
	["Ruins of Silvermoon"] = "Rovine di Lunargenta",
	["Ruins of Solarsal"] = "Rovine di Solarsal",
	["Ruins of Southshore"] = "Rovine di Riva del Sud",
	["Ruins of Taurajo"] = "Rovine di Taurajo",
	["Ruins of Tethys"] = "Rovine di Tethys",
	["Ruins of Thaurissan"] = "Rovine di Thaurissan",
	["Ruins of Thelserai Temple"] = "Rovine del Tempio di Thelserai",
	["Ruins of Theramore"] = "Rovine di Theramore",
	["Ruins of the Scarlet Enclave"] = "Rovine dell'Enclave Scarlatta",
	["Ruins of Uldum"] = "Rovine di Uldum",
	["Ruins of Vashj'elan"] = "Rovine di Vashj'elan",
	["Ruins of Vashj'ir"] = "Rovine di Vashj'ir",
	["Ruins of Zul'Kunda"] = "Rovine di Zul'Kunda",
	["Ruins of Zul'Mamwe"] = "Rovine di Zul'Mamwe",
	["Ruins Rise"] = "Rovine dell'Altura",
	["Rumbling Terrace"] = "Terrazza Rombante",
	["Runestone Falithas"] = "Pietra Runica Falithas",
	["Runestone Shan'dor"] = "Pietra Runica Shan'dor",
	["Runeweaver Square"] = "Piazza di Tessiruna",
	["Rustberg Village"] = "Porto Ruggine",
	["Rustmaul Dive Site"] = "Sito di Immersione di Magliocorroso",
	["Rutsak's Guard"] = "Presidio di Rutsak",
	["Rut'theran Village"] = "Rut'theran",
	["Ruuan Weald"] = "Bosco di Ruuan",
	["Ruuna's Camp"] = "Campo di Ruuna",
	["Ruuzel's Isle"] = "Isola di Ruuzel",
	["Rygna's Lair"] = "Tana di Rygna",
	["Sable Ridge"] = "Cresta Fuligginosa",
	["Sacrificial Altar"] = "Altare Sacrificale",
	["Sahket Wastes"] = "Piane di Sahket",
	Salabria = "Salabria",
	["Saldean's Farm"] = "Fattoria dei Saldean",
	["Saltheril's Haven"] = "Rifugio di Saltheril",
	["Saltspray Glen"] = "Radura Salmastra",
	["Sanctuary of Malorne"] = "Sacrario di Malorne",
	["Sanctuary of Shadows"] = "Santuario delle Ombre",
	["Sanctum of Reanimation"] = "Santuario della Rianimazione",
	["Sanctum of Shadows"] = "Cappella delle Ombre",
	["Sanctum of the Ascended"] = "Santuario dell'Ascensione",
	["Sanctum of the Fallen God"] = "Santuario del Dio Caduto",
	["Sanctum of the Moon"] = "Santuario della Luna",
	["Sanctum of the Prophets"] = "Santuario dei Profeti",
	["Sanctum of the South Wind"] = "Santuario del Vento del Sud",
	["Sanctum of the Stars"] = "Santuario delle Stelle",
	["Sanctum of the Sun"] = "Santuario del Sole",
	["Sands of Nasam"] = "Sabbie di Nasam",
	["Sandsorrow Watch"] = "Osservatorio di Sabbiamesta",
	["Sandy Beach"] = "Spiaggia",
	["Sandy Shallows"] = "Riviera Sabbiosa",
	["Sanguine Chamber"] = "Sala Sanguigna",
	["Sapphire Hive"] = "Alveare di Zaffiro",
	["Sapphiron's Lair"] = "Antro di Zaffirion",
	["Saragosa's Landing"] = "Piattaforma di Saragosa",
	Sarahland = "Saralanda",
	["Sardor Isle"] = "Isola di Sardor",
	Sargeron = "Sargeron",
	["Sarjun Depths"] = "Fossa di Sarjun",
	["Saronite Mines"] = "Miniere di Saronite",
	["Sar'theris Strand"] = "Riva di Sar'theris",
	Satyrnaar = "Satyrnaar",
	["Saurok Creation Pit"] = "Fossa di Creazione dei Saurok",
	["Savage Ledge"] = "Sporgenza Crudele",
	["Scalawag Point"] = "Capo di Granfurto",
	["Scalding Pools"] = "Pozze Sulfuree",
	["Scalebeard's Cave"] = "Grotta di Barbascaglia",
	["Scalewing Shelf"] = "Pianoro delle Scaglie",
	["Scarab Terrace"] = "Terrazza dello Scarabeo",
	["Scarlet Encampment"] = "Accampamento Scarlatto",
	["Scarlet Halls"] = "Sale Scarlatte",
	["Scarlet Hold"] = "Rocca Scarlatta",
	["Scarlet Monastery"] = "Monastero Scarlatto",
	["Scarlet Monastery Entrance"] = "Ingresso al Monastero Scarlatto",
	["Scarlet Overlook"] = "Promontorio Scarlatto",
	["Scarlet Palisade"] = "Palizzata Scarlatta",
	["Scarlet Point"] = "Avamposto Scarlatto",
	["Scarlet Raven Tavern"] = "Taverna del Corvo Scarlatto",
	["Scarlet Tavern"] = "Taverna Scarlatta",
	["Scarlet Tower"] = "Torre Scarlatta",
	["Scarlet Watch Post"] = "Presidio Scarlatto",
	["Scarlet Watchtower"] = "Torre di Guardia Scarlatta",
	["Scar of the Worldbreaker"] = "Sfregio del Devastamondi",
	["Scarred Terrace"] = "Terrazza Sfregiata",
	["Scenario: Alcaz Island"] = "Scenario: Isola di Alcaz",
	["Scenario - Black Ox Temple"] = "Scenario - Tempio dello Yak Nero",
	["Scenario - Mogu Ruins"] = "Scenario - Rovine Mogu",
	["Scenic Overlook"] = "Miracolle",
	["Schnottz's Frigate"] = "Fregata di Schnottz",
	["Schnottz's Hostel"] = "Ostello di Schnottz",
	["Schnottz's Landing"] = "Approdo di Schnottz",
	Scholomance = "Scholomance",
	["Scholomance Entrance"] = "Ingresso a Scholomance",
	ScholomanceOLD = "Scholomance",
	["School of Necromancy"] = "Scuola di Negromanzia",
	["Scorched Gully"] = "Canale Bruciato",
	["Scott's Spooky Area"] = "Area Sinistra di Scott",
	["Scoured Reach"] = "Cunicoli Contorti",
	Scourgehold = "Rocca del Flagello",
	Scourgeholme = "Bastioni del Flagello",
	["Scourgelord's Command"] = "Osservatorio del Signore del Flagello",
	["Scrabblescrew's Camp"] = "Accampamento di Torcivite",
	["Screaming Gully"] = "Canale Mormorante",
	["Scryer's Tier"] = "Loggia dei Veggenti",
	["Scuttle Coast"] = "Costa del Naufragio",
	Sea = "Mare",
	Seabrush = "Selvamarina",
	["Seafarer's Tomb"] = "Tomba dei Marinai",
	["Sealed Chambers"] = "Sale Sigillate",
	["Seal of the Sun King"] = "Sigillo del Re del Sole",
	["Sea Mist Ridge"] = "Scogliera della Bruma Salmastra",
	["Searing Gorge"] = "Gorgia Rovente",
	["Seaspittle Cove"] = "Volta di Spuma Marina",
	["Seaspittle Nook"] = "Volta di Spuma Marina",
	["Seat of Destruction"] = "Seggio della Distruzione",
	["Seat of Knowledge"] = "Archivio della Conoscenza",
	["Seat of Life"] = "Seggio della Vita",
	["Seat of Magic"] = "Seggio della Magia",
	["Seat of Radiance"] = "Seggio della Radiosità",
	["Seat of the Chosen"] = "Accampamento del Prescelto",
	["Seat of the Naaru"] = "Trono dei Naaru",
	["Seat of the Spirit Waker"] = "Seggio del Destaspiriti",
	["Seeker's Folly"] = "Follia del Cercatore",
	["Seeker's Point"] = "Bivacco del Cercatore",
	["Sen'jin Village"] = "Villaggio di Sen'jin",
	["Sen'jin Village Outskirts"] = "Sobborghi del Villaggio di Sen'jin",
	["Sentinel Basecamp"] = "Campo Base delle Sentinelle",
	["Sentinel Hill"] = "Guardiacolle",
	["Sentinel Tower"] = "Torre di Guardiacolle",
	["Sentry Point"] = "Presidio di Guardia",
	Seradane = "Seradane",
	["Serenity Falls"] = "Cascate della Serenità",
	["Serpent Lake"] = "Lago dei Serpenti",
	["Serpent's Coil"] = "Spira del Serpente",
	["Serpent's Heart"] = "Cuore della Serpe",
	["Serpentshrine Cavern"] = "Caverna di Sacrespire",
	["Serpent's Overlook"] = "Osservatorio della Serpe",
	["Serpent's Spine"] = "Muraglia Serpeggiante",
	["Servants' Quarters"] = "Quartieri della Servitù",
	["Service Entrance"] = "Ingresso di Servizio",
	["Sethekk Halls"] = "Sale dei Sethekk",
	["Sethria's Roost"] = "Nido di Sethria",
	["Setting Sun Garrison"] = "Guarnigione del Sole Calante",
	["Set'vess"] = "Set'vess",
	["Sewer Access Point"] = "Punto d'Accesso alle Fognature",
	["Sewer Exit Pipe"] = "Scarico Fognario",
	Sewers = "Fogne",
	Shadebough = "Ramoscuro",
	["Shadewood Thicket"] = "Boschetto Legnoscuro",
	["Shado-Li Basin"] = "Bacino di Shanda-Li",
	["Shado-Pan Fallback"] = "Rifugio degli Shandaren",
	["Shado-Pan Garrison"] = "Guarnigione degli Shandaren",
	["Shado-Pan Monastery"] = "Monastero degli Shandaren",
	["Shadowbreak Ravine"] = "Gola delle Ombre Infrante",
	["Shadowfang Keep"] = "Forte di Zannascura",
	["Shadowfang Keep Entrance"] = "Ingresso al Forte di Zannascura",
	["Shadowfang Tower"] = "Torre di Zannascura",
	["Shadowforge City"] = "Forgiascura",
	Shadowglen = "Vallombra",
	["Shadow Grave"] = "Cripta delle Ombre",
	["Shadow Hold"] = "Eremo delle Ombre",
	["Shadow Labyrinth"] = "Labirinto delle Ombre",
	["Shadowlurk Ridge"] = "Cresta di Ombralosca",
	["Shadowmoon Valley"] = "Valle di Torvaluna",
	["Shadowmoon Village"] = "Villaggio di Torvaluna",
	["Shadow-Pan Monastery"] = "Monastero degli Shandaren",
	["Shadowprey Village"] = "Predombra",
	["Shadow Ridge"] = "Cresta dell'Ombra",
	["Shadowshard Cavern"] = "Caverna dei Rocciacupa",
	["Shadowsight Tower"] = "Torre di Miraombre",
	["Shadowsong Shrine"] = "Santuario dei Cantombroso",
	["Shadowthread Cave"] = "Caverna Telabuia",
	["Shadow Tomb"] = "Tomba delle Ombre",
	["Shadow Wing Lair"] = "Antro delle Ali d'Ombra",
	["Shadra'Alor"] = "Shadra'Alor",
	["Shadybranch Pocket"] = "Boschetto Ramombroso",
	["Shady Rest Inn"] = "Locanda Ombracalma",
	["Shalandis Isle"] = "Isola di Shalandis",
	["Shalewind Canyon"] = "Canyon di Ventoscisto",
	["Shallow's End"] = "Orlo del Baratro",
	["Shallowstep Pass"] = "Passo di Poggiobreve",
	["Shalzaru's Lair"] = "Antro di Shalzaru",
	Shamanar = "Shamanar",
	["Sha'naari Wastes"] = "Distese di Sha'naari",
	["Shang's Stead"] = "Dimora di Shang",
	["Shang's Valley"] = "Vallata di Shang",
	["Shang Xi Training Grounds"] = "Dojo di Shang Xi",
	["Shan'ze Dao"] = "Shan'ze Dao",
	["Shaol'mara"] = "Shaol'mara",
	["Shaol'watha"] = "Shaol'watha",
	["Shaper's Terrace"] = "Terrazza del Modellatore",
	["Shaper's Terrace "] = "Terrazza del Modellatore",
	["Shartuul's Transporter"] = "Teletrasporto di Shartuul",
	["Sha'tari Base Camp"] = "Campo Base Sha'tari",
	["Sha'tari Outpost"] = "Avamposto Sha'tari",
	["Shattered Convoy"] = "Convoglio Distrutto",
	["Shattered Plains"] = "Pianure Pietrose",
	["Shattered Straits"] = "Stretti Infidi",
	["Shattered Sun Staging Area"] = "Base Operativa del Sole Infranto",
	["Shatter Point"] = "Presidio di Torre Infranta",
	["Shatter Scar Vale"] = "Valle dei Crateri Infernali",
	Shattershore = "Spiaggia dei Relitti",
	["Shatterspear Pass"] = "Passo dei Lanciarotta",
	["Shatterspear Vale"] = "Valle dei Lanciarotta",
	["Shatterspear War Camp"] = "Campo di Guerra dei Lanciarotta",
	Shatterstone = "Frangipietra",
	Shattrath = "Shattrath",
	["Shattrath City"] = "Shattrath",
	["Shelf of Mazu"] = "Scogliera di Mazu",
	["Shell Beach"] = "Spiaggia delle Conchiglie",
	["Shield Hill"] = "Colle degli Scudi",
	["Shields of Silver"] = "Scudi d'Argento",
	["Shimmering Bog"] = "Palude Scintillante",
	["Shimmering Expanse"] = "Distesa Scintillante",
	["Shimmering Grotto"] = "Scogliera Scintillante",
	["Shimmer Ridge"] = "Cresta Brillante",
	["Shindigger's Camp"] = "Bivacco di Scavaossa",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Nave per Vashj'ir (Orgrimmar -> Vashj'ir)",
	["Shipwreck Shore"] = "Lido dei Relitti",
	Shipyard = "Porto",
	["Shipyard - Mogu Island Progression Scenario"] = "Porto - Progresso Scenario Isola del Tuono",
	["Shok'Thokar"] = "Shok'Thokar",
	["Sholazar Basin"] = "Bacino di Sholazar",
	["Shores of the Well"] = "Rive del Pozzo",
	["Shrine of Aessina"] = "Santuario di Aessina",
	["Shrine of Aviana"] = "Sacrario di Aviana",
	["Shrine of Dath'Remar"] = "Santuario di Dath'Remar",
	["Shrine of Dreaming Stones"] = "Santuario delle Pietre dei Sogni",
	["Shrine of Eck"] = "Santuario di Eck",
	["Shrine of Fellowship"] = "Santuario dell'Amicizia",
	["Shrine of Five Dawns"] = "Santuario della Quinta Alba",
	["Shrine of Goldrinn"] = "Sacrario di Goldrinn",
	["Shrine of Inner-Light"] = "Santuario della Luce Interiore",
	["Shrine of Lost Souls"] = "Santuario delle Anime Perdute",
	["Shrine of Nala'shi"] = "Sacrario di Nala'shi",
	["Shrine of Remembrance"] = "Santuario della Rimembranza",
	["Shrine of Remulos"] = "Santuario di Remulos",
	["Shrine of Scales"] = "Santuario delle Squame",
	["Shrine of Seven Stars"] = "Santuario delle Sette Stelle",
	["Shrine of Thaurissan"] = "Santuario di Thaurissan",
	["Shrine of the Dawn"] = "Santuario dell'Alba",
	["Shrine of the Deceiver"] = "Eremo dell'Ingannatore",
	["Shrine of the Dormant Flame"] = "Santuario della Fiamma Sopita",
	["Shrine of the Eclipse"] = "Santuario dell'Eclisse",
	["Shrine of the Elements"] = "Santuario degli Elementi",
	["Shrine of the Fallen Warrior"] = "Altare del Guerriero Caduto",
	["Shrine of the Five Khans"] = "Santuario dei Cinque Khan",
	["Shrine of the Merciless One"] = "Santuario dello Spietato",
	["Shrine of the Ox"] = "Santuario dello Yak",
	["Shrine of Twin Serpents"] = "Altare delle Serpi Gemelle",
	["Shrine of Two Moons"] = "Santuario delle Due Lune",
	["Shrine of Unending Light"] = "Santuario della Luce Perpetua",
	["Shriveled Oasis"] = "Oasi Inaridita",
	["Shuddering Spires"] = "Guglie Frementi",
	["SI:7"] = "IR:7",
	["Siege of Niuzao Temple"] = "Assedio al Tempio di Niuzao",
	["Siege Vise"] = "Morsa dell'Assedio",
	["Siege Workshop"] = "Laboratorio d'Assedio",
	["Sifreldar Village"] = "Sifreldar",
	["Sik'vess"] = "Sik'vess",
	["Sik'vess Lair"] = "Antro di Sik'vess",
	["Silent Vigil"] = "Veglia Silente",
	Silithus = "Silitus",
	["Silken Fields"] = "Bottega dei Mastri Setai",
	["Silken Shore"] = "Litorale della Seta",
	["Silmyr Lake"] = "Lago Silmyr",
	["Silting Shore"] = "Costa Limacciosa",
	Silverbrook = "Rioargento",
	["Silverbrook Hills"] = "Colli di Rioargento",
	["Silver Covenant Pavilion"] = "Padiglione del Patto d'Argento",
	["Silverlight Cavern"] = "Caverna di Luceargentea",
	["Silverline Lake"] = "Lago di Filargento",
	["Silvermoon City"] = "Lunargenta",
	["Silvermoon City Inn"] = "Locanda di Lunargenta",
	["Silvermoon Finery"] = "Sartoria di Lunargenta",
	["Silvermoon Jewelery"] = "Gioielleria di Lunargenta",
	["Silvermoon Registry"] = "Registro di Lunargenta",
	["Silvermoon's Pride"] = "Orgoglio di Lunargenta",
	["Silvermyst Isle"] = "Isola di Brumargento",
	["Silverpine Forest"] = "Selva Pinargento",
	["Silvershard Mines"] = "Miniere di Cupargento",
	["Silver Stream Mine"] = "Miniera Vena d'Argento",
	["Silver Tide Hollow"] = "Grotta di Marea d'Argento",
	["Silver Tide Trench"] = "Fossa Marea d'Argento",
	["Silverwind Refuge"] = "Rifugio Vento Argentato",
	["Silverwing Flag Room"] = "Sala della Bandiera degli Alargentea",
	["Silverwing Grove"] = "Boschetto degli Alargentea",
	["Silverwing Hold"] = "Rocca di Alargentea",
	["Silverwing Outpost"] = "Avamposto degli Alargentea",
	["Simply Enchanting"] = "Incantevolmente",
	["Sindragosa's Fall"] = "Fossa di Sindragosa",
	["Sindweller's Rise"] = "Altura di Granvizio",
	["Singing Marshes"] = "Paludi Risonanti",
	["Singing Ridge"] = "Cresta Risonante",
	["Sinner's Folly"] = "Follia del Peccatore",
	["Sira'kess Front"] = "Avamposto dei Sira'kess",
	["Sishir Canyon"] = "Canyon di Sishir",
	["Sisters Sorcerous"] = "Sorelle Fattucchiere",
	Skald = "Skald",
	["Sketh'lon Base Camp"] = "Campo Base di Sketh'lon",
	["Sketh'lon Wreckage"] = "Rovine di Sketh'lon",
	["Skethyl Mountains"] = "Monti Skethyl",
	Skettis = "Skettis",
	["Skitterweb Tunnels"] = "Tunnel dei Filatela",
	Skorn = "Skorn",
	["Skulking Row"] = "Sentiero Celato",
	["Skulk Rock"] = "Tumulo Strisciante",
	["Skull Rock"] = "Roccia del Teschio",
	["Sky Falls"] = "Cascate del Cielo",
	["Skyguard Outpost"] = "Avamposto dei Guardacieli",
	["Skyline Ridge"] = "Cresta dell'Orizzonte",
	Skyrange = "Cieloaperto",
	["Skysong Lake"] = "Lago del Canto Celeste",
	["Slabchisel's Survey"] = "Missione di Sondapietra",
	["Slag Watch"] = "Mastio dell'Ombra",
	Slagworks = "Forte delle Fiamme",
	["Slaughter Hollow"] = "Antro del Martirio",
	["Slaughter Square"] = "Piazza del Mattatoio",
	["Sleeping Gorge"] = "Gola Dormiente",
	["Slicky Stream"] = "Rivolustro",
	["Slingtail Pits"] = "Fosse dei Codalesta",
	["Slitherblade Shore"] = "Spiaggia dei Lamasalmastra",
	["Slithering Cove"] = "Cala Sinuosa",
	["Slither Rock"] = "Roccia Infranta",
	["Sludgeguard Tower"] = "Torre Mirafanghi",
	["Smuggler's Scar"] = "Antro dei Contrabbandieri",
	["Snicklefritz Mine"] = "Miniera di Tagliafritz",
	["Snowblind Hills"] = "Colline dei Mangianeve",
	["Snowblind Terrace"] = "Terrazza dei Mangianeve",
	["Snowden Chalet"] = "Bivacco di Pestaneve",
	["Snowdrift Dojo"] = "Dojo di Neve Lesta",
	["Snowdrift Plains"] = "Piana di Fluttaneve",
	["Snowfall Glade"] = "Radura di Nevealta",
	["Snowfall Graveyard"] = "Cimitero di Nevealta",
	["Socrethar's Seat"] = "Trono di Socrethar",
	["Sofera's Naze"] = "Promontorio di Sofera",
	["Soggy's Gamble"] = "Azzardo di Libeccio",
	["Solace Glade"] = "Radura del Conforto",
	["Solliden Farmstead"] = "Cascina dei Solliden",
	["Solstice Village"] = "Solstizio",
	["Sorlof's Strand"] = "Costa di Sorlof",
	["Sorrow Hill"] = "Collina del Cordoglio",
	["Sorrow Hill Crypt"] = "Cripta della Collina del Cordoglio",
	Sorrowmurk = "Acquatriste",
	["Sorrow Wing Point"] = "Capo di Alatriste",
	["Soulgrinder's Barrow"] = "Riparo di Tritaspiriti",
	["Southbreak Shore"] = "Spiaggia della Risacca",
	["South Common Hall"] = "Sala Comune Meridionale",
	["Southern Barrens"] = "Savane Meridionali",
	["Southern Gold Road"] = "Strada dell'Oro Meridionale",
	["Southern Rampart"] = "Bastione Meridionale",
	["Southern Rocketway"] = "Terminale Sud della Razzovia",
	["Southern Rocketway Terminus"] = "Terminale Sud della Razzovia",
	["Southern Savage Coast"] = "Costa Selvaggia Meridionale",
	["Southfury River"] = "Fiume Furialunga",
	["Southfury Watershed"] = "Bacino di Furialunga",
	["South Gate Outpost"] = "Avamposto Meridionale",
	["South Gate Pass"] = "Passo Meridionale",
	["Southmaul Tower"] = "Torre Maglio del Sud",
	["Southmoon Ruins"] = "Rovine di Luna del Sud",
	["South Pavilion"] = "Padiglione Meridionale",
	["Southpoint Gate"] = "Porta del Sud",
	["South Point Station"] = "Stazione Meridionale",
	["Southpoint Tower"] = "Rocca Meridionale",
	["Southridge Beach"] = "Spiaggia Costa del Sud",
	["Southsea Holdfast"] = "Presidio dei Mari del Sud",
	["South Seas"] = "Mari del Sud",
	Southshore = "Riva del Sud",
	["Southshore Town Hall"] = "Municipio di Riva del Sud",
	["South Spire"] = "Torrione Meridionale",
	["South Tide's Run"] = "Costa della Marea del Sud",
	["Southwind Cleft"] = "Faglia Vento del Sud",
	["Southwind Village"] = "Vento del Sud",
	["Sparkrocket Outpost"] = "Avamposto di Brillarazzo",
	["Sparksocket Minefield"] = "Campo Minato di Sprizzascintille",
	["Sparktouched Haven"] = "Rifugio dei Toccaluce",
	["Sparring Hall"] = "Sala d'Addestramento",
	["Spearborn Encampment"] = "Accampamento di Lancia Selvaggia",
	Spearhead = "Bivacco Punta di Lancia",
	["Speedbarge Bar"] = "Taverna della Turbochiatta",
	Spellsails = "Velarunica",
	["Spinebreaker Mountains"] = "Monti Frangiguglia",
	["Spinebreaker Pass"] = "Passo di Frangiguglia",
	["Spinebreaker Post"] = "Presidio di Frangiguglia",
	["Spinebreaker Ridge"] = "Monti Frangiguglia",
	["Spiral of Thorns"] = "Spirale di Spine",
	["Spire of Blood"] = "Guglia del Sangue",
	["Spire of Decay"] = "Guglia della Decadenza",
	["Spire of Pain"] = "Guglia del Dolore",
	["Spire of Solitude"] = "Guglia della Solitudine",
	["Spire Throne"] = "Trono dei Bastioni",
	["Spirit Den"] = "Antro degli Spiriti",
	["Spirit Fields"] = "Campi degli Spiriti",
	["Spirit Rise"] = "Altura degli Spiriti",
	["Spirit Rock"] = "Roccia dello Spirito",
	["Spiritsong River"] = "Fiume del Canto Spirituale",
	["Spiritsong's Rest"] = "Rifugio del Canto Spirituale",
	["Spitescale Cavern"] = "Caverna degli Scagliatruce",
	["Spitescale Cove"] = "Covo degli Scagliatruce",
	["Splinterspear Junction"] = "Bivio di Frangilancia",
	Splintertree = "Troncorotto",
	["Splintertree Mine"] = "Miniera di Troncorotto",
	["Splintertree Post"] = "Avamposto di Troncorotto",
	["Splithoof Crag"] = "Rupe di Zoccolo Spezzato",
	["Splithoof Heights"] = "Alture di Zoccolo Spezzato",
	["Splithoof Hold"] = "Covo di Zoccolo Spezzato",
	Sporeggar = "Sporeggar",
	["Sporewind Lake"] = "Lago di Sporavento",
	["Springtail Crag"] = "Rupe dei Codalesta",
	["Springtail Warren"] = "Cunicoli dei Codalesta",
	["Spruce Point Post"] = "Postazione Vecchio Abete",
	["Sra'thik Incursion"] = "Invasione degli Sra'thik",
	["Sra'thik Swarmdock"] = "Approdo degli Sra'thik",
	["Sra'vess"] = "Sra'vess",
	["Sra'vess Rootchamber"] = "Sala delle Radici di Sra'vess",
	["Sri-La Inn"] = "Locanda di Sri-La",
	["Sri-La Village"] = "Sri-La",
	Stables = "Scuderie",
	Stagalbog = "Bragonero",
	["Stagalbog Cave"] = "Grotta di Bragonero",
	["Stagecoach Crash Site"] = "Resti della Diligenza",
	["Staghelm Point"] = "Torre Elmocervo",
	["Staging Balcony"] = "Balconata dei Venti",
	["Stairway to Honor"] = "Scalinata dell'Onore",
	["Starbreeze Village"] = "Brezzastella",
	["Stardust Spire"] = "Torre della Polvere Stellare",
	["Starfall Village"] = "Padiglione Pioggia di Stelle",
	["Stars' Rest"] = "Rifugio delle Stelle",
	["Stasis Block: Maximus"] = "Blocco di Stasi: Maximus",
	["Stasis Block: Trion"] = "Blocco di Stasi: Trion",
	["Steam Springs"] = "Sorgenti di Vapore",
	["Steamwheedle Port"] = "Porto degli Spargifumo",
	["Steel Gate"] = "Chiusa d'Acciaio",
	["Steelgrill's Depot"] = "Scalo di Grigliafredda",
	["Steeljaw's Caravan"] = "Carovana di Mordiferro",
	["Steelspark Station"] = "Stazione di Ferfavilla",
	["Stendel's Pond"] = "Stagno di Stendel",
	["Stillpine Hold"] = "Rifugio dei Pinosaldo",
	["Stillwater Pond"] = "Stagno Acqueferme",
	["Stillwhisper Pond"] = "Stagno di Vocequieta",
	Stonard = "Pietrachiusa",
	["Stonebreaker Camp"] = "Avamposto di Spaccapietra",
	["Stonebreaker Hold"] = "Mastio di Spaccapietra",
	["Stonebull Lake"] = "Lago Toro di Pietra",
	["Stone Cairn Lake"] = "Lago del Memoriale",
	Stonehearth = "Cordipietra",
	["Stonehearth Bunker"] = "Fortilizio di Cordipietra",
	["Stonehearth Graveyard"] = "Cimitero di Cordipietra",
	["Stonehearth Outpost"] = "Avamposto di Cordipietra",
	["Stonemaul Hold"] = "Forte dei Mazzapietra",
	["Stonemaul Ruins"] = "Rovine dei Mazzapietra",
	["Stone Mug Tavern"] = "Taverna del Boccale di Pietra",
	Stoneplow = "Arapietra",
	["Stoneplow Fields"] = "Campi di Arapietra",
	["Stone Sentinel's Overlook"] = "Osservatorio della Sentinella di Pietra",
	["Stonesplinter Valley"] = "Valle Pietrarotta",
	["Stonetalon Bomb"] = "Bomba di Petrartiglio",
	["Stonetalon Mountains"] = "Vette di Petrartiglio",
	["Stonetalon Pass"] = "Passo di Petrartiglio",
	["Stonetalon Peak"] = "Picco di Petrartiglio",
	["Stonewall Canyon"] = "Forra di Pietrarossa",
	["Stonewall Lift"] = "Ascensore di Pietramuro",
	["Stoneward Prison"] = "Prigione di Guardiapietra",
	Stonewatch = "Guardamasso",
	["Stonewatch Falls"] = "Cascate di Guardamasso",
	["Stonewatch Keep"] = "Mastio di Guardamasso",
	["Stonewatch Tower"] = "Torre di Guardamasso",
	["Stonewrought Dam"] = "Diga di Pietrasalda",
	["Stonewrought Pass"] = "Passaggio di Pietrasalda",
	["Storm Cliffs"] = "Scogliere della Tempesta",
	Stormcrest = "Crestavento",
	["Stormfeather Outpost"] = "Avamposto di Piumatonante",
	["Stormglen Village"] = "Valtempesta",
	["Storm Peaks"] = "Cime Tempestose",
	["Stormpike Graveyard"] = "Cimitero dei Piccatonante",
	["Stormrage Barrow Dens"] = "Eremi di Grantempesta",
	["Stormsea Landing"] = "Approdo della Tempesta",
	["Storm's Fury Wreckage"] = "Relitto della Furia dei Cieli",
	["Stormstout Brewery"] = "Birrificio Triplo Malto",
	["Stormstout Brewery Interior"] = "Interno del Birrificio Triplo Malto",
	["Stormstout Brewhall"] = "Sala di Fermentazione",
	Stormwind = "Roccavento",
	["Stormwind City"] = "Roccavento",
	["Stormwind City Cemetery"] = "Cimitero di Roccavento",
	["Stormwind City Outskirts"] = "Confini di Roccavento",
	["Stormwind Gunship Pandaria Start Area"] = "Cannoniera di Roccavento, Area d'Inizio di Pandaria",
	["Stormwind Harbor"] = "Porto di Roccavento",
	["Stormwind Keep"] = "Forte di Roccavento",
	["Stormwind Lake"] = "Lago di Roccavento",
	["Stormwind Mountains"] = "Montagne di Roccavento",
	["Stormwind Stockade"] = "Segrete di Roccavento",
	["Stormwind Vault"] = "Prigione di Roccavento",
	["Stoutlager Inn"] = "Locanda di Birraforte",
	Strahnbrad = "Strahnbrad",
	["Strand of the Ancients"] = "Lido degli Antichi",
	["Stranglethorn Vale"] = "Valle di Rovotorto",
	Stratholme = "Stratholme",
	["Stratholme Entrance"] = "Ingresso a Stratholme",
	["Stratholme - Main Gate"] = "Stratholme - Porta Principale",
	["Stratholme - Service Entrance"] = "Stratholme - Ingresso di Servizio",
	["Stratholme Service Entrance"] = "Ingresso di Servizio a Stratholme",
	["Stromgarde Keep"] = "Forte di Stromgarde",
	["Strongarm Airstrip"] = "Aerodromo Voloardito",
	["STV Diamond Mine BG"] = "Miniere di Cupargento",
	["Stygian Bounty"] = "Lancia dello Stige",
	["Sub zone"] = "Sottozona",
	["Sulfuron Keep"] = "Fortezza di Sulfuron",
	["Sulfuron Keep Courtyard"] = "Cortile della Fortezza di Sulfuron",
	["Sulfuron Span"] = "Baratro di Sulfuron",
	["Sulfuron Spire"] = "Torrione di Sulfuron",
	["Sullah's Sideshow"] = "Postazione di Sullah",
	["Summer's Rest"] = "Riposo Estivo",
	["Summoners' Tomb"] = "Tomba degli Evocatori",
	["Sunblossom Hill"] = "Collina Sbocciasole",
	["Suncrown Village"] = "Solcorona",
	["Sundown Marsh"] = "Palude del Tramonto",
	["Sunfire Point"] = "Presidio del Fuoco Solare",
	["Sunfury Hold"] = "Presidio dei Furia del Sole",
	["Sunfury Spire"] = "Guglia dei Furia del Sole",
	["Sungraze Peak"] = "Picco di Sfregiosole",
	["Sunken Dig Site"] = "Scavi Sommersi",
	["Sunken Temple"] = "Sunken Temple",
	["Sunken Temple Entrance"] = "Ingresso al Tempio Sommerso",
	["Sunreaver Pavilion"] = "Padiglione dei Predatori del Sole",
	["Sunreaver's Command"] = "Comando dei Predatori del Sole",
	["Sunreaver's Sanctuary"] = "Santuario dei Predatori del Sole",
	["Sun Rock Retreat"] = "Rifugio Roccia del Sole",
	["Sunsail Anchorage"] = "Ancoraggio di Vela del Sole",
	["Sunsoaked Meadow"] = "Prateria Soleggiata",
	["Sunsong Ranch"] = "Tenuta Cantasole",
	["Sunspring Post"] = "Accampamento di Solenuovo",
	["Sun's Reach Armory"] = "Armeria di Approdo del Sole",
	["Sun's Reach Harbor"] = "Porto di Approdo del Sole",
	["Sun's Reach Sanctum"] = "Santuario di Approdo del Sole",
	["Sunstone Terrace"] = "Terrazza di Pietrasole",
	["Sunstrider Isle"] = "Isola di Solealto",
	["Sunveil Excursion"] = "Spedizione di Solvelato",
	["Sunwatcher's Ridge"] = "Cresta di Mirasole",
	["Sunwell Plateau"] = "Cittadella del Pozzo Solare",
	["Supply Caravan"] = "Carovana dei Rifornimenti",
	["Surge Needle"] = "Guglia Tellurica",
	["Surveyors' Outpost"] = "Avamposto dei Cartografi",
	Surwich = "Surwich",
	["Svarnos' Cell"] = "Cella di Svarnos",
	["Swamplight Manor"] = "Dimora Fuocofioco",
	["Swamp of Sorrows"] = "Palude del Dolore",
	["Swamprat Post"] = "Avamposto Rattomarcio",
	["Swiftgear Station"] = "Stazione di Marcialesta",
	["Swindlegrin's Dig"] = "Scavi di Truffasmorfia",
	["Swindle Street"] = "Viale delle Frodi",
	["Sword's Rest"] = "Altare della Spada",
	Sylvanaar = "Sylvanaar",
	["Tabetha's Farm"] = "Cascina di Tabetha",
	["Taelan's Tower"] = "Torre di Taelan",
	["Tahonda Ruins"] = "Rovine di Tahonda",
	["Tahret Grounds"] = "Terre di Tahret",
	["Tal'doren"] = "Tal'doren",
	["Talismanic Textiles"] = "Tessuti Talismanici",
	["Tallmug's Camp"] = "Accampamento di Brocca Larga",
	["Talonbranch Glade"] = "Radura di Ramocurvo",
	["Talonbranch Glade "] = "Radura di Ramocurvo",
	["Talondeep Pass"] = "Passo di Graffiofondo",
	["Talondeep Vale"] = "Valle di Graffiofondo",
	["Talon Stand"] = "Colle Artiglio",
	Talramas = "Talramas",
	["Talrendis Point"] = "Bivacco di Talrendis",
	Tanaris = "Tanaris",
	["Tanaris Desert"] = "Deserto di Tanaris",
	["Tanks for Everything"] = "Protezioni Portentose",
	["Tanner Camp"] = "Accampamento di Tanner",
	["Tarren Mill"] = "Mulino di Tarren",
	["Tasters' Arena"] = "Arena della Degustazione",
	["Taunka'le Village"] = "Taunka'le",
	["Tavern in the Mists"] = "Taverna nelle Nebbie",
	["Tazz'Alaor"] = "Tazz'Alaor",
	["Tear Down This Wall!"] = "Demolizione delle Mura",
	["Teegan's Expedition"] = "Spedizione di Teegan",
	["Teeming Burrow"] = "Cunicoli Infestati",
	Telaar = "Telaar",
	["Telaari Basin"] = "Bacino di Telaar",
	["Tel'athion's Camp"] = "Accampamento di Tel'athion",
	Teldrassil = "Teldrassil",
	Telredor = "Telredor",
	["Tempest Bridge"] = "Ponte della Tempesta",
	["Tempest Keep"] = "Forte Tempesta",
	["Tempest Keep: The Arcatraz"] = "Forte Tempesta: Arcatraz",
	["Tempest Keep - The Arcatraz Entrance"] = "Ingresso ad Arcatraz di Forte Tempesta",
	["Tempest Keep: The Botanica"] = "Forte Tempesta: Botanica",
	["Tempest Keep - The Botanica Entrance"] = "Ingresso a Botanica di Forte Tempesta",
	["Tempest Keep: The Mechanar"] = "Forte Tempesta: Mecanar",
	["Tempest Keep - The Mechanar Entrance"] = "Ingresso a Mecanar di Forte Tempesta",
	["Tempest's Reach"] = "Riva della Tempesta",
	["Temple City of En'kilah"] = "Acropoli di En'kilah",
	["Temple Hall"] = "Sala del Tempio",
	["Temple of Ahn'Qiraj"] = "Tempio di Ahn'Qiraj",
	["Temple of Arkkoran"] = "Tempio di Arkkoran",
	["Temple of Asaad"] = "Tempio di Asaad",
	["Temple of Bethekk"] = "Tempio di Bethekk",
	["Temple of Earth"] = "Tempio della Terra",
	["Temple of Five Dawns"] = "Tempio delle Cinque Albe",
	["Temple of Invention"] = "Tempio dell'Intelletto",
	["Temple of Kotmogu"] = "Tempio di Kotmogu",
	["Temple of Life"] = "Tempio della Vita",
	["Temple of Order"] = "Tempio dell'Ordine",
	["Temple of Storms"] = "Tempio delle Tempeste",
	["Temple of Telhamat"] = "Tempio di Telhamat",
	["Temple of the Forgotten"] = "Tempio dei Dimenticati",
	["Temple of the Jade Serpent"] = "Tempio della Serpe di Giada",
	["Temple of the Moon"] = "Tempio della Luna",
	["Temple of the Red Crane"] = "Tempio della Gru Rossa",
	["Temple of the White Tiger"] = "Tempio della Tigre Bianca",
	["Temple of Uldum"] = "Tempio di Uldum",
	["Temple of Winter"] = "Tempio dell'Inverno",
	["Temple of Wisdom"] = "Tempio della Saggezza",
	["Temple of Zin-Malor"] = "Tempio di Zin-Malor",
	["Temple Summit"] = "Sommità del Tempio",
	["Tenebrous Cavern"] = "Caverna Tenebrosa",
	["Terokkar Forest"] = "Foresta di Terokk",
	["Terokk's Rest"] = "Requie di Terokk",
	["Terrace of Endless Spring"] = "Terrazza dell'Eterna Primavera",
	["Terrace of Gurthan"] = "Terrazza dei Gurthan",
	["Terrace of Light"] = "Terrazza della Luce",
	["Terrace of Repose"] = "Terrazza della Quiete",
	["Terrace of Ten Thunders"] = "Terrazza dei Dieci Tuoni",
	["Terrace of the Augurs"] = "Terrazza dell'Augure",
	["Terrace of the Makers"] = "Terrazza dei Creatori",
	["Terrace of the Sun"] = "Terrazza del Sole",
	["Terrace of the Tiger"] = "Terrazza della Tigre",
	["Terrace of the Twin Dragons"] = "Terrazza dei Draghi Gemelli",
	Terrordale = "Valterrore",
	["Terror Run"] = "Landa del Terrore",
	["Terrorweb Tunnel"] = "Galleria dell'Orrore Brulicante",
	["Terror Wing Path"] = "Sentiero del Terrore Alato",
	["Tethris Aran"] = "Tethris Aran",
	Thalanaar = "Thalanaar",
	["Thalassian Pass"] = "Passo Thalassiano",
	["Thalassian Range"] = "Catena Montuosa Thalassiana",
	["Thal'darah Grove"] = "Boschetto di Thal'darah",
	["Thal'darah Overlook"] = "Presidio di Thal'darah",
	["Thandol Span"] = "Viadotto di Thandol",
	["Thargad's Camp"] = "Bivacco di Thargad",
	["The Abandoned Reach"] = "Spiaggia Abbandonata",
	["The Abyssal Maw"] = "Fauci dell'Abisso",
	["The Abyssal Shelf"] = "Piattaforma Abissale",
	["The Admiral's Den"] = "Covo dell'Ammiraglio",
	["The Agronomical Apothecary"] = "Speziale Agronomico",
	["The Alliance Valiants' Ring"] = "Arena dei Valorosi dell'Alleanza",
	["The Altar of Damnation"] = "Altare della Dannazione",
	["The Altar of Shadows"] = "Altare delle Ombre",
	["The Altar of Zul"] = "Altare di Zul",
	["The Amber Hibernal"] = "Quiescenza d'Ambra",
	["The Amber Vault"] = "Volta d'Ambra",
	["The Amber Womb"] = "Ventre d'Ambra",
	["The Ancient Grove"] = "Bosco dell'Antico",
	["The Ancient Lift"] = "Funivia Antica",
	["The Ancient Passage"] = "Passaggio Antico",
	["The Antechamber"] = "Anticamera",
	["The Anvil of Conflagration"] = "Incudine della Conflagrazione",
	["The Anvil of Flame"] = "Incudine delle Fiamme",
	["The Apothecarium"] = "Quartiere degli Speziali",
	["The Arachnid Quarter"] = "Ala degli Aracnidi",
	["The Arboretum"] = "Arboreto",
	["The Arcanium"] = "Arcanium",
	["The Arcanium "] = "Arcanium",
	["The Arcatraz"] = "Arcatraz",
	["The Archivum"] = "Archivum",
	["The Argent Stand"] = "Bastione d'Argento",
	["The Argent Valiants' Ring"] = "Arena dei Valorosi d'Argento",
	["The Argent Vanguard"] = "Avanguardia d'Argento",
	["The Arsenal Absolute"] = "Arsenale Assoluto",
	["The Aspirants' Ring"] = "Arena degli Aspiranti",
	["The Assembly Chamber"] = "Sala delle Assemblee",
	["The Assembly of Iron"] = "Adunanza del Ferro",
	["The Athenaeum"] = "Ateneo",
	["The Autumn Plains"] = "Pianure Autunnali",
	["The Avalanche"] = "Grande Slavina",
	["The Azure Front"] = "Fronte Azzurro",
	["The Bamboo Wilds"] = "Foresta di Bambù",
	["The Bank of Dalaran"] = "Banca di Dalaran",
	["The Bank of Silvermoon"] = "Banca di Lunargenta",
	["The Banquet Hall"] = "Sala del Banchetto",
	["The Barrier Hills"] = "Monti Granbarriera",
	["The Bastion of Twilight"] = "Bastione del Crepuscolo",
	["The Battleboar Pen"] = "Recinto dei Cinghiali da Guerra",
	["The Battle for Gilneas"] = "Battaglia per Gilneas",
	["The Battle for Gilneas (Old City Map)"] = "Battaglia per Gilneas (Vecchia Mappa)",
	["The Battle for Mount Hyjal"] = "Battaglia per il Monte Hyjal",
	["The Battlefront"] = "Linea del Fronte",
	["The Bazaar"] = "Bazar",
	["The Beast Pens"] = "Recinti delle Bestie",
	["The Beer Garden"] = "Giardino della Birra",
	["The Bite"] = "Rive della Morsa",
	["The Black Breach"] = "Breccia Nera",
	["The Black Market"] = "Mercato Nero",
	["The Black Morass"] = "Palude Nera",
	["The Black Temple"] = "Tempio Nero",
	["The Black Vault"] = "Tesoreria Oscura",
	["The Blackwald"] = "Bosconero",
	["The Blazing Strand"] = "Riva Fiammeggiante",
	["The Blighted Pool"] = "Vasca Ammorbata",
	["The Blight Line"] = "Confine Ammorbato",
	["The Bloodcursed Reef"] = "Scogliera di Sangue Dannato",
	["The Blood Furnace"] = "Forgia del Sangue",
	["The Bloodmire"] = "Paludi del Sangue",
	["The Bloodoath"] = "Promessa di Sangue",
	["The Blood Trail"] = "Sentiero di Sangue",
	["The Bloodwash"] = "Riva dei Fiottorosso",
	["The Boiling Crustacean"] = "Crostaceo Bollito",
	["The Bombardment"] = "Zona di Bombardamento",
	["The Bonefields"] = "Campi delle Ossa",
	["The Bone Pile"] = "Cumulo d'Ossa",
	["The Bones of Nozronn"] = "Ossa di Nozronn",
	["The Bone Wastes"] = "Distese d'Ossa",
	["The Boneyard"] = "Ossario",
	["The Borean Wall"] = "Muraglia Boreale",
	["The Botanica"] = "Botanica",
	["The Bradshaw Mill"] = "Mulino di Bradshaw",
	["The Breach"] = "Grande Breccia",
	["The Briny Cutter"] = "Lancia Salmastra",
	["The Briny Muck"] = "Acquitrino Salmastro",
	["The Briny Pinnacle"] = "Pinnacolo Salmastro",
	["The Broken Bluffs"] = "Passo di Rupe Pendente",
	["The Broken Front"] = "Fronte Spezzato",
	["The Broken Hall"] = "Sala Sfondata",
	["The Broken Hills"] = "Colli Frastagliati",
	["The Broken Stair"] = "Scala Spezzata",
	["The Broken Temple"] = "Tempio in Rovina",
	["The Broodmother's Nest"] = "Nido della Progenitrice",
	["The Brood Pit"] = "Fossa di Cova",
	["The Bulwark"] = "Granbarricata",
	["The Burlap Trail"] = "Sentiero della Iuta",
	["The Burlap Valley"] = "Vallata della Iuta",
	["The Burlap Waystation"] = "Avamposto della Iuta",
	["The Burning Corridor"] = "Corridoio delle Fiamme",
	["The Butchery"] = "Sala della Carneficina",
	["The Cache of Madness"] = "Scrigno della Follia",
	["The Caller's Chamber"] = "Sala dell'Invocazione",
	["The Canals"] = "Canali",
	["The Cape of Stranglethorn"] = "Capo di Rovotorto",
	["The Carrion Fields"] = "Campi del Contagio",
	["The Catacombs"] = "Catacombe",
	["The Cauldron"] = "Caldera Magmatica",
	["The Cauldron of Flames"] = "Calderone delle Fiamme",
	["The Cave"] = "Grotta",
	["The Celestial Planetarium"] = "Planetario Celeste",
	["The Celestial Vault"] = "Tesoreria Celestiale",
	["The Celestial Watch"] = "Osservatorio Celeste",
	["The Cemetary"] = "Cimitero",
	["The Cerebrillum"] = "Encefalo",
	["The Charred Vale"] = "Valle Bruciata",
	["The Chilled Quagmire"] = "Palude Gelata",
	["The Chum Bucket"] = "Lenza Fedele",
	["The Circle of Cinders"] = "Circolo delle Braci",
	["The Circle of Life"] = "Cerchio della Vita",
	["The Circle of Suffering"] = "Cerchio della Sofferenza",
	["The Clarion Bell"] = "Campana della Chiamata",
	["The Clash of Thunder"] = "Sala del Tuono",
	["The Clean Zone"] = "Area Incontaminata",
	["The Cleft"] = "Faglia Infida",
	["The Clockwerk Run"] = "Corridoio dei Meccanismi",
	["The Clutch"] = "Grinfiastretta",
	["The Clutches of Shek'zeer"] = "Artigli di Shek'zeer",
	["The Coil"] = "Spiratorta",
	["The Colossal Forge"] = "Forgia Colossale",
	["The Comb"] = "Favo Ronzante",
	["The Commons"] = "Area del Mercato",
	["The Conflagration"] = "Deflagrazione delle Fiamme",
	["The Conquest Pit"] = "Fossa del Trionfo",
	["The Conservatory"] = "Bioparco",
	["The Conservatory of Life"] = "Serra della Vita",
	["The Construct Quarter"] = "Ala dei Costrutti",
	["The Cooper Residence"] = "Residenza dei Cooper",
	["The Corridors of Ingenuity"] = "Corridoi dell'Ingegno",
	["The Court of Bones"] = "Corte delle Ossa",
	["The Court of Skulls"] = "Corte dei Teschi",
	["The Coven"] = "Sala della Congrega",
	["The Coven "] = "Sala della Congrega",
	["The Creeping Ruin"] = "Rovine Infestate",
	["The Crimson Assembly Hall"] = "Sala dell'Assemblea Cremisi",
	["The Crimson Cathedral"] = "Cattedrale Vermiglia",
	["The Crimson Dawn"] = "Alba Cremisi",
	["The Crimson Hall"] = "Sala Cremisi",
	["The Crimson Reach"] = "Litorale del Sangue",
	["The Crimson Throne"] = "Trono Cremisi",
	["The Crimson Treader"] = "Sperone Cremisi",
	["The Crimson Veil"] = "Velo Cremisi",
	["The Crossroads"] = "Crocevia",
	["The Crucible"] = "Crogiolo delle Fiamme",
	["The Crucible of Flame"] = "Crogiolo delle Fiamme",
	["The Crumbling Waste"] = "Terre Disgregate",
	["The Cryo-Core"] = "Nucleo Criogenico",
	["The Crystal Hall"] = "Sala di Cristallo",
	["The Crystal Shore"] = "Lido Cristallino",
	["The Crystal Vale"] = "Valle di Cristallo",
	["The Crystal Vice"] = "Morsa di Cristallo",
	["The Culling of Stratholme"] = "Epurazione di Stratholme",
	["The Culling of Stratholme Entrance"] = "Ingresso all'Epurazione di Stratholme",
	["The Cursed Landing"] = "Approdo Maledetto",
	["The Dagger Hills"] = "Catena delle Daghe",
	["The Dai-Lo Farmstead"] = "Fattoria Dai-Lo",
	["The Damsel's Luck"] = "Fortuna della Damigella",
	["The Dancing Serpent"] = "Serpe Danzante",
	["The Dark Approach"] = "Ingresso Tenebroso",
	["The Dark Defiance"] = "Sfida Oscura",
	["The Darkened Bank"] = "Argine Fosco",
	["The Dark Hollow"] = "Cavità Oscura",
	["The Darkmoon Faire"] = "Fiera di Lunacupa",
	["The Dark Portal"] = "Portale Oscuro",
	["The Dark Rookery"] = "Colonia Oscura",
	["The Darkwood"] = "Boscoscuro",
	["The Dawnchaser"] = "Aurora di Fuoco",
	["The Dawning Isles"] = "Isole dell'Aurora",
	["The Dawning Span"] = "Archi dell'Alba",
	["The Dawning Square"] = "Piazza dell'Alba",
	["The Dawning Stair"] = "Scalinata dell'Alba",
	["The Dawning Valley"] = "Vallata Albeggiante",
	["The Dead Acre"] = "Acro della Morte",
	["The Dead Field"] = "Agro dei Morti",
	["The Dead Fields"] = "Campi Sterili",
	["The Deadmines"] = "Miniere della Morte",
	["The Dead Mire"] = "Melmamorta",
	["The Dead Scar"] = "Fenditura Morta",
	["The Deathforge"] = "Forgiamorte",
	["The Deathknell Graves"] = "Tombe di Albamorta",
	["The Decrepit Fields"] = "Campi Fatiscenti",
	["The Decrepit Flow"] = "Bacino Decrepito",
	["The Deeper"] = "Fondobuio",
	["The Deep Reaches"] = "Fossafonda",
	["The Deepwild"] = "Selvafonda",
	["The Defiant"] = "L'Insolente",
	["The Defiled Chapel"] = "Cappella Profanata",
	["The Den"] = "Antro del Tirocinio",
	["The Den of Flame"] = "Covo delle Fiamme",
	["The Dens of Dying"] = "Antro del Trapasso",
	["The Dens of the Dying"] = "Antri del Trapasso",
	["The Descent into Madness"] = "Discesa nella Follia",
	["The Desecrated Altar"] = "Altare Dissacrato",
	["The Devil's Terrace"] = "Terrazza del Diavolo",
	["The Devouring Breach"] = "Fossa Divoratrice",
	["The Domicile"] = "Residenze",
	["The Domicile "] = "Residenze",
	["The Dooker Dome"] = "Circolo della Gugga",
	["The Dor'Danil Barrow Den"] = "Eremo di Dor'danil",
	["The Dormitory"] = "Dormitorio",
	["The Drag"] = "Varcolargo",
	["The Dragonmurk"] = "Stagno dei Draghi",
	["The Dragon Wastes"] = "Distese dei Draghi",
	["The Drain"] = "Sistema Idraulico",
	["The Dranosh'ar Blockade"] = "Barricata Dranosh'ar",
	["The Drowned Reef"] = "Scogliera Sommersa",
	["The Drowned Sacellum"] = "Tempio Sommerso",
	["The Drunken Hozen"] = "Locanda dell'Hozen Ubriaco",
	["The Dry Hills"] = "Colli Aridi",
	["The Dustbowl"] = "Piana della Polvere",
	["The Dust Plains"] = "Piane Incolte",
	["The Eastern Earthshrine"] = "Santuario Orientale della Terra",
	["The Elders' Path"] = "Sentiero degli Anziani",
	["The Emerald Summit"] = "Vetta di Smeraldo",
	["The Emperor's Approach"] = "Approccio dell'Imperatore",
	["The Emperor's Gate"] = "Porta dell'Imperatore",
	["The Emperor's Reach"] = "Terrazza dell'Imperatore",
	["The Emperor's Step"] = "Scala dell'Imperatore",
	["The Escape From Durnholde"] = "Fuga da Durnholde",
	["The Escape from Durnholde Entrance"] = "Ingresso alla Fuga da Durnholde",
	["The Eventide"] = "Piazza del Vespro",
	["The Exodar"] = "Exodar",
	["The Eye"] = "Forte Tempesta",
	["The Eye of Eternity"] = "Occhio dell'Eternità",
	["The Eye of the Vortex"] = "Occhio del Vortice",
	["The Fall of Shan Bu"] = "Caduta di Shan Bu",
	["The Farstrider Lodge"] = "Padiglione Lungopasso",
	["The Feeding Pits"] = "Fosse di Nutrimento",
	["The Fel Pits"] = "Fosse Vili",
	["The Fertile Copse"] = "Macchia Lussurreggiante",
	["The Fetid Pool"] = "Pozza Fetida",
	["The Filthy Animal"] = "Belva Assetata",
	["The Firehawk"] = "Falco di Fuoco",
	["The Five Sisters"] = "Cinque Sorelle",
	["The Flamewake"] = "Desolazione di Fuoco",
	["The Fleshwerks"] = "Officina della Carne",
	["The Flood Plains"] = "Pianure Alluvionali",
	["The Fold"] = "Gran Dosso",
	["The Foothill Caverns"] = "Caverne delle Alture",
	["The Foot of Lei Shen"] = "Atrio di Lei Shen",
	["The Foot Steppes"] = "Piedimonte",
	["The Forbidden Jungle"] = "Foresta Proibita",
	["The Forbidding Sea"] = "Mar delle Insidie",
	["The Forest of Shadows"] = "Foresta delle Ombre",
	["The Forge of Souls"] = "Forgia delle Anime",
	["The Forge of Souls Entrance"] = "Ingresso alla Forgia delle Anime",
	["The Forge of Supplication"] = "Forgia della Supplica",
	["The Forge of Wills"] = "Forgia delle Volontà",
	["The Forgotten Coast"] = "Costa dell'Oblio",
	["The Forgotten Overlook"] = "Promontorio Dimenticato",
	["The Forgotten Pool"] = "Pozza Dimenticata",
	["The Forgotten Pools"] = "Sorgenti Dimenticate",
	["The Forgotten Shore"] = "Riva dell'Oblio",
	["The Forlorn Cavern"] = "Caverna degli Inganni",
	["The Forlorn Mine"] = "Miniera della Disperazione",
	["The Forsaken Front"] = "Fronte dei Reietti",
	["The Foul Pool"] = "Bacino Infetto",
	["The Frigid Tomb"] = "Tomba Glaciale",
	["The Frost Queen's Lair"] = "Rifugio della Regina del Gelo",
	["The Frostwing Halls"] = "Sale delle Ali del Gelo",
	["The Frozen Glade"] = "Radura Gelata",
	["The Frozen Halls"] = "Sale Gelide",
	["The Frozen Mine"] = "Miniera Gelata",
	["The Frozen Sea"] = "Mare Ghiacciato",
	["The Frozen Throne"] = "Trono di Ghiaccio",
	["The Fungal Vale"] = "Valfungosa",
	["The Furnace"] = "Fornace Ardente",
	["The Gaping Chasm"] = "Abisso Golaperta",
	["The Gatehouse"] = "Atrio",
	["The Gatehouse "] = "Atrio",
	["The Gate of Unending Cycles"] = "Portale dei Cicli Infiniti",
	["The Gauntlet"] = "Piazza della Sfida",
	["The Geyser Fields"] = "Solfatare",
	["The Ghastly Confines"] = "Confini dell'Oltretomba",
	["The Gilded Foyer"] = "Atrio Dorato",
	["The Gilded Gate"] = "Porta Dorata",
	["The Gilding Stream"] = "Rivo Dorato",
	["The Glimmering Pillar"] = "Pilastro dei Cristalli",
	["The Golden Gateway"] = "Varco Dorato",
	["The Golden Hall"] = "Sala Dorata",
	["The Golden Lantern"] = "Lanterna Dorata",
	["The Golden Pagoda"] = "Pagoda Dorata",
	["The Golden Plains"] = "Piana Dorata",
	["The Golden Rose"] = "Rosa Dorata",
	["The Golden Stair"] = "Scalinata Dorata",
	["The Golden Terrace"] = "Terrazza Dorata",
	["The Gong of Hope"] = "Gong della Speranza",
	["The Grand Ballroom"] = "Salone da Ballo",
	["The Grand Vestibule"] = "Grande Vestibolo",
	["The Great Arena"] = "Grande Arena",
	["The Great Divide"] = "Grande Fenditura",
	["The Great Fissure"] = "Granforra",
	["The Great Forge"] = "Grande Forgia",
	["The Great Gate"] = "Grande Palizzata",
	["The Great Lift"] = "Grande Ascensore",
	["The Great Ossuary"] = "Grande Ossario",
	["The Great Sea"] = "Grande Mare",
	["The Great Tree"] = "Grande Albero",
	["The Great Wheel"] = "Grande Ruota",
	["The Green Belt"] = "Cintura Rigogliosa",
	["The Greymane Wall"] = "Muro Mantogrigio",
	["The Grim Guzzler"] = "Torvo Beone",
	["The Grinding Quarry"] = "Grande Cava",
	["The Grizzled Den"] = "Tana Selvaggia",
	["The Grummle Bazaar"] = "Bazaar dei Grumyan",
	["The Guardhouse"] = "Sala del Corpo di Guardia",
	["The Guest Chambers"] = "Camere degli Ospiti",
	["The Gullet"] = "Grandirupo",
	["The Halfhill Market"] = "Mercato di Mezzocolle",
	["The Half Shell"] = "Mezzoguscio",
	["The Hall of Blood"] = "Sala del Sangue",
	["The Hall of Gears"] = "Sala degli Ingranaggi",
	["The Hall of Lights"] = "Sala delle Luci",
	["The Hall of Respite"] = "Sala della Tregua",
	["The Hall of Statues"] = "Sala delle Statue",
	["The Hall of the Serpent"] = "Sala della Serpe",
	["The Hall of Tiles"] = "Sala delle Mattonelle",
	["The Halls of Reanimation"] = "Sale di Rianimazione",
	["The Halls of Winter"] = "Sale dell'Inverno",
	["The Hand of Gul'dan"] = "Mano di Gul'dan",
	["The Harborage"] = "Rifugio dei Corrotti",
	["The Hatchery"] = "Anfratto delle Uova",
	["The Headland"] = "Altocolle",
	["The Headlands"] = "Alture delle Rovine",
	["The Heap"] = "Cumulo di Rottami",
	["The Heartland"] = "Cuorflorido",
	["The Heart of Acherus"] = "Cuore di Acherus",
	["The Heart of Jade"] = "Cuore di Giada",
	["The Hidden Clutch"] = "Nido Nascosto",
	["The Hidden Grove"] = "Boschetto Segreto",
	["The Hidden Hollow"] = "Grotta Nascosta",
	["The Hidden Passage"] = "Passaggio Nascosto",
	["The Hidden Reach"] = "Percorso Nascosto",
	["The Hidden Reef"] = "Scogliera Celata",
	["The High Path"] = "Sentiero Alto",
	["The High Road"] = "Altavia",
	["The High Seat"] = "Sala del Trono",
	["The Hinterlands"] = "Entroterre",
	["The Hoard"] = "Armeria",
	["The Hole"] = "Segrete Oscure",
	["The Horde Valiants' Ring"] = "Arena dei Valorosi dell'Orda",
	["The Horrid March"] = "Orrida Marcia",
	["The Horsemen's Assembly"] = "Adunata dei Cavalieri",
	["The Howling Hollow"] = "Grotta delle Urla",
	["The Howling Oak"] = "Quercia Ululante",
	["The Howling Vale"] = "Valle Ululante",
	["The Hunter's Reach"] = "Ritrovo dei Cacciatori",
	["The Hushed Bank"] = "Argine Silenzioso",
	["The Icy Depths"] = "Profondità Gelate",
	["The Immortal Coil"] = "Chiglia Immortale",
	["The Imperial Exchange"] = "Salone Imperiale dei Mercanti",
	["The Imperial Granary"] = "Granaio Imperiale",
	["The Imperial Mercantile"] = "Salone Imperiale del Commercio",
	["The Imperial Seat"] = "Trono Imperiale",
	["The Incursion"] = "Grande Incursione",
	["The Infectis Scar"] = "Cicatrice Infetta",
	["The Inferno"] = "Inferno",
	["The Inner Spire"] = "Torrione Interno",
	["The Intrepid"] = "Intrepida",
	["The Inventor's Library"] = "Biblioteca dell'Intelletto",
	["The Iron Crucible"] = "Crogiolo di Ferro",
	["The Iron Hall"] = "Sala del Ferro",
	["The Iron Reaper"] = "Mietitrice di Ferro",
	["The Isle of Spears"] = "Isola delle Lance",
	["The Ivar Patch"] = "Podere di Ivar",
	["The Jade Forest"] = "Foresta di Giada",
	["The Jade Vaults"] = "Tesoreria di Giada",
	["The Jansen Stead"] = "Cascina dei Jansen",
	["The Keggary"] = "Barilario",
	["The Kennel"] = "Canile",
	["The Krasari Ruins"] = "Rovine Krasari",
	["The Krazzworks"] = "Krazzopoli",
	["The Laboratory"] = "Laboratorio",
	["The Lady Mehley"] = "Dama Mehley",
	["The Lagoon"] = "Grande Laguna",
	["The Laughing Stand"] = "Riva del Sogghigno",
	["The Lazy Turnip"] = "Rapa Pigra",
	["The Legerdemain Lounge"] = "Abracadabar",
	["The Legion Front"] = "Fronte della Legione",
	["Thelgen Rock"] = "Masso di Thelgen",
	["The Librarium"] = "Librarium",
	["The Library"] = "Biblioteca",
	["The Lifebinder's Cell"] = "Cella della Protettrice della Vita",
	["The Lifeblood Pillar"] = "Pilastro della Vita",
	["The Lightless Reaches"] = "Faglia Oscura",
	["The Lion's Redoubt"] = "Trincea del Leone",
	["The Living Grove"] = "Selva Vivente",
	["The Living Wood"] = "Selvaviva",
	["The LMS Mark II"] = "LMS Modello II",
	["The Loch"] = "Loch",
	["The Long Wash"] = "Lungoflutto",
	["The Lost Fleet"] = "Flotta Perduta",
	["The Lost Fold"] = "Rottami Dispersi",
	["The Lost Isles"] = "Isole Perdute",
	["The Lost Lands"] = "Terre Perdute",
	["The Lost Passage"] = "Passaggio Perduto",
	["The Low Path"] = "Sentiero Basso",
	Thelsamar = "Thelsamar",
	["The Lucky Traveller"] = "Viaggiatore Fortunato",
	["The Lyceum"] = "Liceo",
	["The Maclure Vineyards"] = "Vigne dei Maclure",
	["The Maelstrom"] = "Maelstrom",
	["The Maker's Overlook"] = "Loggia dei Creatori",
	["The Makers' Overlook"] = "Loggia dei Creatori",
	["The Makers' Perch"] = "Volta dei Creatori",
	["The Maker's Rise"] = "Ascensore del Creatore",
	["The Maker's Terrace"] = "Terrapieno dell'Artefice",
	["The Manufactory"] = "Fabbrica di Costrutti",
	["The Marris Stead"] = "Cascina dei Marris",
	["The Marshlands"] = "Acquitrini Selvaggi",
	["The Masonary"] = "Corridoio Oscuro",
	["The Master's Cellar"] = "Cantina del Padrone",
	["The Master's Glaive"] = "Gladio del Maestro",
	["The Maul"] = "Fossa Infausta",
	["The Maw of Madness"] = "Fauci della Follia",
	["The Mechanar"] = "Mecanar",
	["The Menagerie"] = "Serraglio",
	["The Menders' Stead"] = "Bivacco dei Guaritori",
	["The Merchant Coast"] = "Costa dei Mercanti",
	["The Militant Mystic"] = "Mistico Militante",
	["The Military Quarter"] = "Ala dei Combattenti",
	["The Military Ward"] = "Guardia Militare",
	["The Mind's Eye"] = "Occhio della Mente",
	["The Mirror of Dawn"] = "Specchio dell'Alba",
	["The Mirror of Twilight"] = "Specchio del Crepuscolo",
	["The Molsen Farm"] = "Fattoria dei Molsen",
	["The Molten Bridge"] = "Ponte Fuso",
	["The Molten Core"] = "Nucleo Ardente",
	["The Molten Fields"] = "Campi Magmatici",
	["The Molten Flow"] = "Corrente Magmatica",
	["The Molten Span"] = "Viadotto del Magma",
	["The Mor'shan Rampart"] = "Bastione di Mor'shan",
	["The Mor'Shan Ramparts"] = "Bastione di Mor'shan",
	["The Mosslight Pillar"] = "Pilastro del Muschio Brillante",
	["The Mountain Den"] = "Grotta Montana",
	["The Murder Pens"] = "Recinti del Massacro",
	["The Mystic Ward"] = "Guardia Mistica",
	["The Necrotic Vault"] = "Volta Necrotica",
	["The Nexus"] = "Nexus",
	["The Nexus Entrance"] = "Ingresso nel Nexus",
	["The Nightmare Scar"] = "Faglia dell'Incubo",
	["The North Coast"] = "Costa del Nord",
	["The North Sea"] = "Mare del Nord",
	["The Nosebleeds"] = "Nasorotto",
	["The Noxious Glade"] = "Radura Venefica",
	["The Noxious Hollow"] = "Grotta Venefica",
	["The Noxious Lair"] = "Antro Venefico",
	["The Noxious Pass"] = "Passo Venefico",
	["The Oblivion"] = "Oblio",
	["The Observation Ring"] = "Anello d'Osservazione",
	["The Obsidian Sanctum"] = "Santuario di Ossidiana",
	["The Oculus"] = "Oculus",
	["The Oculus Entrance"] = "Ingresso a Oculus",
	["The Old Barracks"] = "Vecchia Caserma",
	["The Old Dormitory"] = "Vecchio Dormitorio",
	["The Old Port Authority"] = "Vecchia Capitaneria di Porto",
	["The Opera Hall"] = "Teatro",
	["The Oracle Glade"] = "Radura dell'Oracolo",
	["The Outer Ring"] = "Anello Esterno",
	["The Overgrowth"] = "Labirinto Verde",
	["The Overlook"] = "Osservatorio",
	["The Overlook Cliffs"] = "Scogliera Altosguardo",
	["The Overlook Inn"] = "Taverna dell'Osservatorio",
	["The Ox Gate"] = "Porta dello Yak",
	["The Pale Roost"] = "Trespolo Pallido",
	["The Park"] = "Parco",
	["The Path of Anguish"] = "Sentiero del Tormento",
	["The Path of Conquest"] = "Cammino della Conquista",
	["The Path of Corruption"] = "Sentiero della Corruzione",
	["The Path of Glory"] = "Cammino della Gloria",
	["The Path of Iron"] = "Sentiero del Ferro",
	["The Path of the Lifewarden"] = "Sentiero della Custode della Vita",
	["The Phoenix Hall"] = "Sala della Fenice",
	["The Pillar of Ash"] = "Pilastro delle Ceneri",
	["The Pipe"] = "Grande Conduttura",
	["The Pit of Criminals"] = "Fossa dei Criminali",
	["The Pit of Fiends"] = "Fossa dei Demoni",
	["The Pit of Narjun"] = "Fossa di Narjun",
	["The Pit of Refuse"] = "Fossa dei Rifiuti",
	["The Pit of Sacrifice"] = "Fossa dei Sacrifici",
	["The Pit of Scales"] = "Fossa delle Scaglie",
	["The Pit of the Fang"] = "Fossa delle Fauci",
	["The Plague Quarter"] = "Ala della Pestilenza",
	["The Plagueworks"] = "Sale della Pestilenza",
	["The Pool of Ask'ar"] = "Stagno di Ask'ar",
	["The Pools of Vision"] = "Pozze delle Visioni",
	["The Prison of Yogg-Saron"] = "Prigione di Yogg-Saron",
	["The Proving Grounds"] = "Piana del Conflitto",
	["The Purple Parlor"] = "Parlatorio Viola",
	["The Quagmire"] = "Acque Stagnanti",
	["The Quaking Fields"] = "Campi Sismici",
	["The Queen's Reprisal"] = "Rappresaglia della Regina",
	["The Raging Chasm"] = "Baratro Furioso",
	Theramore = "Theramore",
	["Theramore Isle"] = "Isola di Theramore",
	["Theramore's Fall"] = "Caduta di Theramore",
	["Theramore's Fall (A)"] = "Caduta di Theramore (A)",
	["Theramore's Fall (H)"] = "Caduta di Theramore (O)",
	["Theramore's Fall Phase"] = "Fase della Caduta di Theramore",
	["The Rangers' Lodge"] = "Padiglione dei Guardaboschi",
	["Therazane's Throne"] = "Trono di Therazane",
	["The Red Reaches"] = "Insenature Rosse",
	["The Refectory"] = "Refettorio",
	["The Regrowth"] = "Bosco della Ricrescita",
	["The Reliquary"] = "Reliquiario",
	["The Repository"] = "Vestibolo Segreto",
	["The Reservoir"] = "Bacino Idrico",
	["The Restless Front"] = "Fronte Insonne",
	["The Ridge of Ancient Flame"] = "Cresta della Fiamma Antica",
	["The Rift"] = "Fenditura",
	["The Ring of Balance"] = "Anello dell'Equilibrio",
	["The Ring of Blood"] = "Circolo del Sangue",
	["The Ring of Champions"] = "Arena dei Campioni",
	["The Ring of Inner Focus"] = "Anello della Concentrazione",
	["The Ring of Trials"] = "Circolo delle Sfide",
	["The Ring of Valor"] = "Arena del Valore",
	["The Riptide"] = "Granmarea",
	["The Riverblade Den"] = "Antro dei Lamasinuosa",
	["Thermal Vents"] = "Sfiati Termali",
	["The Roiling Gardens"] = "Giardini Torbidi",
	["The Rolling Gardens"] = "Giardini Torbidi",
	["The Rolling Plains"] = "Piana Ondulata",
	["The Rookery"] = "Salone della Covata",
	["The Rotting Orchard"] = "Frutteto Marcescente",
	["The Rows"] = "Terrazze Fertili",
	["The Royal Exchange"] = "Mercato Reale",
	["The Ruby Sanctum"] = "Santuario di Rubino",
	["The Ruined Reaches"] = "Confini Spezzati",
	["The Ruins of Kel'Theril"] = "Rovine di Kel'Theril",
	["The Ruins of Ordil'Aran"] = "Rovine di Ordil'Aran",
	["The Ruins of Stardust"] = "Rovine della Polvere Stellare",
	["The Rumble Cage"] = "Gabbia del Fragore",
	["The Rustmaul Dig Site"] = "Scavi di Magliocorroso",
	["The Sacred Grove"] = "Boschetto Sacro",
	["The Salty Sailor Tavern"] = "Locanda del Lupo di Mare",
	["The Sanctum"] = "Santuario",
	["The Sanctum of Blood"] = "Santuario del Sangue",
	["The Savage Coast"] = "Costa Selvaggia",
	["The Savage Glen"] = "Boschetto Selvatico",
	["The Savage Thicket"] = "Selva Rovente",
	["The Scalding Chasm"] = "Baratro Bollente",
	["The Scalding Pools"] = "Pozze Incandescenti",
	["The Scarab Dais"] = "Altare dello Scarabeo",
	["The Scarab Wall"] = "Vallo dello Scarabeo",
	["The Scarlet Basilica"] = "Basilica Scarlatta",
	["The Scarlet Bastion"] = "Bastione Scarlatto",
	["The Scorched Grove"] = "Bosco Arso",
	["The Scorched Plain"] = "Pianura Bruciata",
	["The Scrap Field"] = "Campo dei Rottami",
	["The Scrapyard"] = "Cantiere di Demolizione",
	["The Screaming Hall"] = "Sala delle Urla",
	["The Screaming Reaches"] = "Confini Urlanti",
	["The Screeching Canyon"] = "Canyon Stridente",
	["The Scribe of Stormwind"] = "Scriba di Roccavento",
	["The Scribes' Sacellum"] = "Cappella degli Scribi",
	["The Scrollkeeper's Sanctum"] = "Santuario delle Pergamene",
	["The Scullery"] = "Quartieri della servitù",
	["The Scullery "] = "Cucina",
	["The Seabolt"] = "Freccia Marina",
	["The Seabreach Flow"] = "Breccia del Mare",
	["The Sealed Hall"] = "Sala Sigillata",
	["The Sea of Cinders"] = "Mare di Cenere",
	["The Sea Reaver's Run"] = "Stretto del Mar Selvaggio",
	["The Searing Gateway"] = "Accesso Infuocato",
	["The Sea Wolf"] = "Lupo di Mare",
	["The Secret Aerie"] = "Laghetto Segreto",
	["The Secret Lab"] = "Laboratorio Segreto",
	["The Secrets of Ragefire"] = "Segreti di Fiamma Furente",
	["The Seer's Library"] = "Biblioteca dei Veggenti",
	["The Sepulcher"] = "Mausolea",
	["The Severed Span"] = "Ponte Spezzato",
	["The Sewer"] = "Fognatura",
	["The Shadow Stair"] = "Scala dell'Ombra",
	["The Shadow Throne"] = "Trono delle Ombre",
	["The Shadow Vault"] = "Volta dell'Ombra",
	["The Shady Nook"] = "Radura Ombrosa",
	["The Shaper's Terrace"] = "Terrazza del Modellatore",
	["The Shattered Halls"] = "Sale della Devastazione",
	["The Shattered Strand"] = "Costa Infranta",
	["The Shattered Walkway"] = "Passaggio Infranto",
	["The Shepherd's Gate"] = "Porta del Magistro",
	["The Shifting Mire"] = "Pantano Mutevole",
	["The Shimmering Deep"] = "Profondità Salate",
	["The Shimmering Flats"] = "Distese Salate",
	["The Shining Strand"] = "Riva Lucente",
	["The Shrine of Aessina"] = "Santuario di Aessina",
	["The Shrine of Eldretharr"] = "Santuario di Eldretharr",
	["The Silent Sanctuary"] = "Santuario del Silenzio",
	["The Silkwood"] = "Selvasetosa",
	["The Silver Blade"] = "Lama d'Argento",
	["The Silver Enclave"] = "Enclave d'Argento",
	["The Singing Grove"] = "Boschetto Echeggiante",
	["The Singing Pools"] = "Laghetti dei Mille Canti",
	["The Sin'loren"] = "Sin'loren",
	["The Skeletal Reef"] = "Scogliera dei Relitti",
	["The Skittering Dark"] = "Oscurità Brulicante",
	["The Skull Warren"] = "Dedalo del Teschio",
	["The Skunkworks"] = "Officina Granbotto",
	["The Skybreaker"] = "Solcacieli",
	["The Skyfire"] = "Fuoco Celeste",
	["The Skyreach Pillar"] = "Pilastro del Cielo",
	["The Slag Pit"] = "Fossa delle Scorie",
	["The Slaughtered Lamb"] = "Agnello Sgozzato",
	["The Slaughter House"] = "Mattatoio",
	["The Slave Pens"] = "Fosse degli Schiavi",
	["The Slave Pits"] = "Campo degli Schiavi",
	["The Slick"] = "Lido Lordo",
	["The Slithering Scar"] = "Anfratto Brulicante",
	["The Slough of Dispair"] = "Pantano della Disperazione",
	["The Sludge Fen"] = "Palude Fangosa",
	["The Sludge Fields"] = "Campi Fangosi",
	["The Sludgewerks"] = "Fangaia",
	["The Solarium"] = "Solarium",
	["The Solar Vigil"] = "Balconata del Sole",
	["The Southern Isles"] = "Isole Meridionali",
	["The Southern Wall"] = "Muraglia Meridionale",
	["The Sparkling Crawl"] = "Caverna Scintillante",
	["The Spark of Imagination"] = "Scintilla dell'Immaginazione",
	["The Spawning Glen"] = "Radura della Procreazione",
	["The Spire"] = "Guglia di Ghiaccio",
	["The Splintered Path"] = "Sentiero Spezzato",
	["The Spring Road"] = "Via della Primavera",
	["The Stadium"] = "Stadio",
	["The Stagnant Oasis"] = "Oasi Stagnante",
	["The Staidridge"] = "Crestagrave",
	["The Stair of Destiny"] = "Scalinata del Destino",
	["The Stair of Doom"] = "Scalinata della Rovina",
	["The Starchaser"] = "Bramastelle",
	["The Star's Bazaar"] = "Bazaar delle Stelle",
	["The Steam Pools"] = "Terme Fumanti",
	["The Steamvault"] = "Antro dei Vapori",
	["The Steppe of Life"] = "Steppa della Vita",
	["The Steps of Fate"] = "Scalinata del Fato",
	["The Stinging Trail"] = "Sentiero Pungente",
	["The Stockade"] = "Segrete di Roccavento",
	["The Stockpile"] = "Caverna Deposito",
	["The Stonecore"] = "Nucleo di Pietra",
	["The Stonecore Entrance"] = "Ingresso al Nucleo di Pietra",
	["The Stonefield Farm"] = "Fattoria dei Pietradura",
	["The Stone Vault"] = "Volta di Pietra",
	["The Storehouse"] = "Magazzino",
	["The Stormbreaker"] = "Solcatempeste",
	["The Stormbridge"] = "Ponte della Tempesta",
	["The Storm Foundry"] = "Forgia della Tempesta",
	["The Storm Peaks"] = "Cime Tempestose",
	["The Stormspire"] = "Guglia Tempestosa",
	["The Stormwright's Shelf"] = "Altopiano della Tempesta Selvaggia",
	["The Summer Fields"] = "Campi Soleggiati",
	["The Summer Terrace"] = "Terrazza Estiva",
	["The Sundered Shard"] = "Frammento Spezzato",
	["The Sundering"] = "Grangorgo",
	["The Sun Forge"] = "Forgia del Sole",
	["The Sunken Ring"] = "Anello Infossato",
	["The Sunset Brewgarden"] = "Resinificio del Tramonto",
	["The Sunspire"] = "Pinnacolo del Sole",
	["The Suntouched Pillar"] = "Pilastro del Sole",
	["The Sunwell"] = "Pozzo Solare",
	["The Swarming Pillar"] = "Pilastro Ronzante",
	["The Swollen Vault"] = "Cripta del Tesoro",
	["The Tainted Forest"] = "Bosco Corrotto",
	["The Tainted Scar"] = "Landa Corrotta",
	["The Talondeep Path"] = "Sentiero di Graffiofondo",
	["The Talon Den"] = "Eremo Grinfialunga",
	["The Tasting Room"] = "Sala di Degustazione",
	["The Tempest Rift"] = "Faglia delle Tempeste",
	["The Temple Gardens"] = "Giardini del Tempio",
	["The Temple of Atal'Hakkar"] = "Tempio di Atal'Hakkar",
	["The Temple of the Jade Serpent"] = "Tempio della Serpe di Giada",
	["The Terrestrial Watchtower"] = "Sala d'Osservazione Planetaria",
	["The Thornsnarl"] = "Spinairta",
	["The Threads of Fate"] = "Fili del Fato",
	["The Threshold"] = "Soglia",
	["The Throne of Flame"] = "Trono delle Fiamme",
	["The Thunder Forge"] = "Forgia dei Fulmini",
	["The Thunder Forges"] = "Forgia dei Fulmini",
	["The Thundering Run"] = "Percorso Tonante",
	["The Thundering Spire"] = "Guglia Tonante",
	["The Thunderspire"] = "Guglia del Tuono",
	["The Thunderwood"] = "Legnotuono",
	["The Tidebreaker"] = "Fendimaree",
	["The Tidus Stair"] = "Scalinata di Tidus",
	["The Tiger's Peak"] = "Picco della Tigre",
	["The Torjari Pit"] = "Fossa di Torjari",
	["The Tower of Arathor"] = "Torre di Arathor",
	["The Toxic Airfield"] = "Aerodromo Tossico",
	["The Trail of Devastation"] = "Via della Devastazione",
	["The Tranquil Grove"] = "Boschetto Pacifico",
	["The Transitus Stair"] = "Scala di Transito",
	["The Trapper's Enclave"] = "Enclave dei Cacciatori",
	["The Tribunal of Ages"] = "Tribunale delle Ere",
	["The Tundrid Hills"] = "Colline di Tundrid",
	["The Twilight Breach"] = "Breccia del Crepuscolo",
	["The Twilight Caverns"] = "Caverne del Crepuscolo",
	["The Twilight Citadel"] = "Cittadella del Crepuscolo",
	["The Twilight Enclave"] = "Enclave del Crepuscolo",
	["The Twilight Gate"] = "Porta del Crepuscolo",
	["The Twilight Gauntlet"] = "Sfida del Crepuscolo",
	["The Twilight Ridge"] = "Cresta del Crepuscolo",
	["The Twilight Rivulet"] = "Rio del Crepuscolo",
	["The Twilight Withering"] = "Radura del Crepuscolo",
	["The Twin Colossals"] = "Colossi Gemelli",
	["The Twisted Glade"] = "Radura Contorta",
	["The Twisted Warren"] = "Cunicoli Contorti",
	["The Two Fisted Brew"] = "Doppia Pinta",
	["The Unbound Thicket"] = "Boscostile",
	["The Underbelly"] = "Sotterranei",
	["The Underbog"] = "Torbiera Sotterranea",
	["The Underbough"] = "Sottofronda",
	["The Undercroft"] = "Cripta di Zaeldarr",
	["The Underhalls"] = "Sale Sotterranee",
	["The Undershell"] = "Sottoguscio",
	["The Uplands"] = "Terre Alte",
	["The Upside-down Sinners"] = "Peccatori Appesi",
	["The Valley of Fallen Heroes"] = "Valle degli Eroi Caduti",
	["The Valley of Lost Hope"] = "Valle della Speranza Perduta",
	["The Vault of Lights"] = "Volta delle Luci",
	["The Vector Coil"] = "Bobina di Alimentazione",
	["The Veiled Cleft"] = "Faglia Velata",
	["The Veiled Sea"] = "Mar Velato",
	["The Veiled Stair"] = "Passo Velato",
	["The Venture Co. Mine"] = "Miniera della S.P.R. & Co.",
	["The Verdant Fields"] = "Campi Verdeggianti",
	["The Verdant Thicket"] = "Macchia Verdeggiante",
	["The Verne"] = "Verne",
	["The Verne - Bridge"] = "Ponte del Verne",
	["The Verne - Entryway"] = "Ingresso del Verne",
	["The Vibrant Glade"] = "Radura Fremente",
	["The Vice"] = "Malvezzo",
	["The Vicious Vale"] = "Valmorsa",
	["The Viewing Room"] = "Sala d'Osservazione",
	["The Vile Reef"] = "Scogliera Infame",
	["The Violet Citadel"] = "Cittadella Violacea",
	["The Violet Citadel Spire"] = "Guglia della Cittadella Violacea",
	["The Violet Gate"] = "Portale Violaceo",
	["The Violet Hold"] = "Fortezza Violacea",
	["The Violet Spire"] = "Guglia Violacea",
	["The Violet Tower"] = "Torre Violacea",
	["The Vortex Fields"] = "Campi del Vortice",
	["The Vortex Pinnacle"] = "Pinnacolo del Vortice",
	["The Vortex Pinnacle Entrance"] = "Ingresso al Pinnacolo del Vortice",
	["The Wailing Caverns"] = "Caverna dei Lamenti",
	["The Wailing Ziggurat"] = "Ziggurat del Lamento",
	["The Waking Halls"] = "Saloni del Risveglio",
	["The Wandering Isle"] = "Isola Errante",
	["The Warlord's Garrison"] = "Guarnigione del Signore della Guerra",
	["The Warlord's Terrace"] = "Terrazza del Signore della Guerra",
	["The Warp Fields"] = "Campi di Distorsione",
	["The Warp Piston"] = "Pistone di Distorsione",
	["The Wavecrest"] = "Cresta dell'Onda",
	["The Weathered Nook"] = "Recesso Logoro",
	["The Weeping Cave"] = "Grotta Piangente",
	["The Western Earthshrine"] = "Santuario Occidentale della Terra",
	["The Westrift"] = "Faglia Occidentale",
	["The Whelping Downs"] = "Collina dei Draghetti",
	["The Whipple Estate"] = "Tenuta degli Whipple",
	["The Wicked Coil"] = "Altura Maligna",
	["The Wicked Grotto"] = "Grotta Perversa",
	["The Wicked Tunnels"] = "Tunnel Perversi",
	["The Widening Deep"] = "Golalarga",
	["The Widow's Clutch"] = "Covo dei Ragni",
	["The Widow's Wail"] = "Antro delle Vedove",
	["The Wild Plains"] = "Pianure Selvagge",
	["The Wild Shore"] = "Costa Selvaggia",
	["The Winding Halls"] = "Sale Serpeggianti",
	["The Windrunner"] = "Ventolesto",
	["The Windspire"] = "Guglia del Vento",
	["The Wollerton Stead"] = "Fattoria dei Wollerton",
	["The Wonderworks"] = "Strabilia",
	["The Wood of Staves"] = "Foresta dei Bastoni",
	["The World Tree"] = "Albero del Mondo",
	["The Writhing Deep"] = "Fossa Fremente",
	["The Writhing Haunt"] = "Campo Putrido",
	["The Yaungol Advance"] = "Avanzata degli Yaungol",
	["The Yorgen Farmstead"] = "Cascina degli Yorgen",
	["The Zandalari Vanguard"] = "Avanguardia degli Zandalari",
	["The Zoram Strand"] = "Spiaggia di Zoram",
	["Thieves Camp"] = "Campo dei Ladri",
	["Thirsty Alley"] = "Vicolo degli Assetati",
	["Thistlefur Hold"] = "Rifugio dei Mantocardo",
	["Thistlefur Village"] = "Villaggio dei Mantocardo",
	["Thistleshrub Valley"] = "Valle dei Cardosecco",
	["Thondroril River"] = "Fiume Thondroril",
	["Thoradin's Wall"] = "Muro di Thoradin",
	["Thorium Advance"] = "Avamposto del Torio",
	["Thorium Point"] = "Presidio del Torio",
	["Thor Modan"] = "Thor Modan",
	["Thornfang Hill"] = "Colle di Serraspina",
	["Thorn Hill"] = "Colli Spinosi",
	["Thornmantle's Hideout"] = "Covo di Mantoirsuto",
	["Thorson's Post"] = "Fattoria di Thorson",
	["Thorvald's Camp"] = "Accampamento di Thorvald",
	["Thousand Needles"] = "Millepicchi",
	Thrallmar = "Thrallmar",
	["Thrallmar Mine"] = "Miniera di Thrallmar",
	["Three Corners"] = "Tre Cammini",
	["Throne of Ancient Conquerors"] = "Trono degli Antichi Conquistatori",
	["Throne of Kil'jaeden"] = "Trono di Kil'jaeden",
	["Throne of Neptulon"] = "Trono di Neptulon",
	["Throne of the Apocalypse"] = "Trono dell'Apocalisse",
	["Throne of the Damned"] = "Trono dei Dannati",
	["Throne of the Elements"] = "Trono degli Elementi",
	["Throne of the Four Winds"] = "Trono dei Quattro Venti",
	["Throne of the Tides"] = "Trono delle Maree",
	["Throne of the Tides Entrance"] = "Ingresso al Trono delle Maree",
	["Throne of Thunder"] = "Regno del Tuono",
	["Throne of Tides"] = "Trono delle Maree",
	["Thrym's End"] = "Riposo di Thrym",
	["Thunder Axe Fortress"] = "Fortezza Ascia del Tuono",
	Thunderbluff = "Picco del Tuono",
	["Thunder Bluff"] = "Picco del Tuono",
	["Thunderbrew Distillery"] = "Distilleria Birratuono",
	["Thunder Cleft"] = "Spaccatuono",
	Thunderfall = "Impietrituono",
	["Thunder Falls"] = "Cascate del Tuono",
	["Thunderfoot Farm"] = "Fattoria dei Palmo Tonante",
	["Thunderfoot Fields"] = "Terreni dei Palmo Tonante",
	["Thunderfoot Inn"] = "Locanda di Palmo Tonante",
	["Thunderfoot Ranch"] = "Tenuta dei Palmo Tonante",
	["Thunder Hold"] = "Forte del Tuono",
	["Thunderhorn Water Well"] = "Pozzo dei Corno Tonante",
	["Thundering Overlook"] = "Terrazza del Tuono",
	["Thunder Island Alliance Hub"] = "Isola del Tuono Area Alleanza",
	["Thunder King Horde Hub"] = "Isola del Tuono Area Orda",
	["Thunder King's Citadel"] = "Cittadella del Re del Tuono",
	["Thunderlord Stronghold"] = "Roccaforte degli Spaccatuono",
	Thundermar = "Tuonocupo",
	["Thundermar Ruins"] = "Rovine di Tuonocupo",
	["Thunderpaw Overlook"] = "Picco degli Zampa Tonante",
	["Thunderpaw Refuge"] = "Dimora degli Zampa Tonante",
	["Thunder Peak"] = "Vetta del Tuono",
	["Thunder Ridge"] = "Fossa del Tuono",
	["Thunder's Call"] = "Richiamo del Fulmine",
	["Thunderstrike Mountain"] = "Monte del Fulmine",
	["Thunk's Abode"] = "Bivacco di Thunk",
	["Thuron's Livery"] = "Allevamento di Thuron",
	["Tian Monastery"] = "Monastero Tian",
	["Tidefury Cove"] = "Cala Ondarabbiosa",
	["Tides' Hollow"] = "Antro delle Maree",
	["Tideview Thicket"] = "Bosco delle Maree",
	["Tigers' Wood"] = "Tana delle Tigri",
	["Timbermaw Hold"] = "Rifugio dei Mordilegno",
	["Timbermaw Post"] = "Accampamento dei Mordilegno",
	["Tinkers' Court"] = "Corte dei Meccanisti",
	["Tinker Town"] = "Rabberciopoli",
	["Tiragarde Keep"] = "Forte di Tiragarde",
	["Tirisfal Glades"] = "Radure di Tirisfal",
	["Tirth's Haunt"] = "Covo di Tirth",
	["Tkashi Ruins"] = "Rovine di Tkashi",
	["Tol Barad"] = "Tol Barad",
	["Tol Barad Peninsula"] = "Penisola di Tol Barad",
	["Tol'Vir Arena"] = "Arena Tol'viron",
	["Tol'viron Arena"] = "Arena Tol'viron",
	["Tol'Viron Arena"] = "Arena Tol'viron",
	["Tomb of Conquerors"] = "Tomba dei Conquistatori",
	["Tomb of Lights"] = "Tomba delle Luci",
	["Tomb of Secrets"] = "Tomba dei Segreti",
	["Tomb of Shadows"] = "Tomba delle Ombre",
	["Tomb of the Ancients"] = "Tomba degli Antichi",
	["Tomb of the Earthrager"] = "Tomba dello Spaccaterra",
	["Tomb of the Lost Kings"] = "Tomba dei Re Perduti",
	["Tomb of the Sun King"] = "Tomba del Re del Sole",
	["Tomb of the Watchers"] = "Tomba dei Guardiani",
	["Tombs of the Precursors"] = "Tombe dei Precursori",
	["Tome of the Unrepentant"] = "Tomo del non Penitente",
	["Tome of the Unrepentant "] = "Tomo dell'Incorreggibile",
	["Tor'kren Farm"] = "Fattoria di Tor'kren",
	["Torp's Farm"] = "Fattoria dei Torp",
	["Torseg's Rest"] = "Bivacco di Torseg",
	["Tor'Watha"] = "Tor'Watha",
	["Toryl Estate"] = "Padiglione di Toryl",
	["Toshley's Station"] = "Stazione di Toshley",
	["To the Skies!"] = "Verso il Cielo!",
	["To The Skies!"] = "Verso il Cielo!",
	["Tower of Althalaxx"] = "Torre di Althalaxx",
	["Tower of Azora"] = "Torre di Azora",
	["Tower of Eldara"] = "Torre di Eldara",
	["Tower of Estulan"] = "Torre di Estulan",
	["Tower of Ilgalar"] = "Torre di Ilgalar",
	["Tower of the Damned"] = "Torre dei Dannati",
	["Tower Point"] = "Torre Granguardia",
	["Tower Watch"] = "Torre di Guardia",
	["Town-In-A-Box"] = "Città-In-Scatola",
	["Townlong Steppes"] = "Steppe di Tong Long",
	["Town Square"] = "Piazza Centrale",
	["Trade District"] = "Distretto Commerciale",
	["Trade Quarter"] = "Quartiere dei Commerci",
	["Trader's Tier"] = "Ponte dei Commercianti",
	["Tradesmen's Terrace"] = "Terrazza dei Mercanti",
	["Train Depot"] = "Deposito dei Treni",
	["Training Grounds"] = "Cortile d'Addestramento",
	["Training Quarters"] = "Quartieri d'Addestramento",
	["Traitor's Cove"] = "Baia del Traditore",
	["Tranquil Coast"] = "Costa Calma",
	["Tranquil Gardens Cemetery"] = "Cimitero Parcosereno",
	["Tranquil Grotto"] = "Spiazzo della Quiete",
	Tranquillien = "Tranquillien",
	["Tranquil Shore"] = "Spiaggia Placida",
	["Tranquil Wash"] = "Quietoflutto",
	Transborea = "Transborea",
	["Transitus Shield"] = "Cupola di Transito",
	["Transport: Alliance Gunship"] = "Trasporto: Cannoniera dell'Alleanza",
	["Transport: Alliance Gunship (IGB)"] = "Trasporto: Cannoniera dell'Alleanza",
	["Transport: Horde Gunship"] = "Trasporto: Cannoniera dell'Orda",
	["Transport: Horde Gunship (IGB)"] = "Trasporto: Cannoniera dell'Orda",
	["Transport: Onyxia/Nefarian Elevator"] = "Trasporto: Ascensore Onyxia/Nefarian",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Trasporto: Grande Vento (Incursione Rocca della Corona di Ghiaccio)",
	["Trelleum Mine"] = "Miniera di Trelleum",
	["Trial of Fire"] = "Prova del Fuoco",
	["Trial of Frost"] = "Prova del Gelo",
	["Trial of Shadow"] = "Prova dell'Ombra",
	["Trial of the Champion"] = "Ordalia dei Campioni",
	["Trial of the Champion Entrance"] = "Ingresso all'Ordalia dei Campioni",
	["Trial of the Crusader"] = "Ordalia dei Crociati",
	["Trickling Passage"] = "Passaggio Sgocciolante",
	["Trogma's Claim"] = "Antro di Trogma",
	["Trollbane Hall"] = "Ritrovo dei Cacciatroll",
	["Troll War Camp Outskirts"] = "Periferia del Campo di Guerra dei Troll",
	["Trophy Hall"] = "Sala dei Trofei",
	["Troves of the Thunder King"] = "Tesori del Re del Tuono",
	["Trueshot Point"] = "Presidio d'Artiglieria",
	["Tuluman's Landing"] = "Approdo di Tuluman",
	["Turtle Beach"] = "Spiaggia della Tartaruga",
	["Tu Shen Burial Ground"] = "Tumulo di Tu Shen",
	Tuurem = "Tuurem",
	["Twilight Aerie"] = "Nido del Crepuscolo",
	["Twilight Altar of Storms"] = "Altare delle Tempeste del Crepuscolo",
	["Twilight Base Camp"] = "Campo Base del Crepuscolo",
	["Twilight Bulwark"] = "Baluardo del Crepuscolo",
	["Twilight Camp"] = "Accampamento del Crepuscolo",
	["Twilight Command Post"] = "Posto di Comando del Crepuscolo",
	["Twilight Crossing"] = "Incrocio del Crepuscolo",
	["Twilight Forge"] = "Forgia del Crepuscolo",
	["Twilight Grove"] = "Bosco del Crepuscolo",
	["Twilight Highlands"] = "Alture del Crepuscolo",
	["Twilight Highlands Dragonmaw Phase"] = "Twilight Highlands Dragonmaw Phase",
	["Twilight Highlands Phased Entrance"] = "Entrata fasata delle Alture del Crepuscolo",
	["Twilight Highlands Zeppelin 1"] = "Zeppelin Alture del Crepuscolo 1",
	["Twilight Highlands Zeppelin 2"] = "Zeppelin Alture del Crepuscolo 2",
	["Twilight Outpost"] = "Avamposto del Crepuscolo",
	["Twilight Overlook"] = "Presidio del Crepuscolo",
	["Twilight Post"] = "Rifugio del Crepuscolo",
	["Twilight Precipice"] = "Precipizio del Crepuscolo",
	["Twilight Shore"] = "Riva del Crepuscolo",
	["Twilight's Run"] = "Grotta del Crepuscolo",
	["Twilight Terrace"] = "Terrazza del Crepuscolo",
	["Twilight Vale"] = "Valle del Crepuscolo",
	["Twinbraid's Patrol"] = "Pattuglia di Trecciadoppia",
	["Twin Peaks"] = "Picchi Gemelli",
	["Twin Shores"] = "Rive Gemelle",
	["Twinspire Keep"] = "Forte Doppiaguglia",
	["Twinspire Keep Interior"] = "Interno di Forte Doppiaguglia",
	["Twin Spire Ruins"] = "Rovine delle Guglie Gemelle",
	["Twisting Nether"] = "Distorsione Fatua",
	["Tyr's Hand"] = "Mano di Tyr",
	["Tyr's Hand Abbey"] = "Abbazia di Mano di Tyr",
	["Tyr's Terrace"] = "Terrazza di Tyr",
	["Ufrang's Hall"] = "Salone di Ufrang",
	Uldaman = "Uldaman",
	["Uldaman Entrance"] = "Ingresso a Uldaman",
	Uldis = "Uldis",
	Ulduar = "Ulduar",
	["Ulduar Raid - Interior - Insertion Point"] = "Incursione Ulduar - Interno - Punto d'Inserimento",
	["Ulduar Raid - Iron Concourse"] = "Incursione Ulduar - Adunanza del Ferro",
	Uldum = "Uldum",
	["Uldum Phased Entrance"] = "Uldum Phased Entrance",
	["Uldum Phase Oasis"] = "Uldum Phase Oasis",
	["Uldum - Phase Wrecked Camp"] = "Uldum - Phase Wrecked Camp",
	["Umbrafen Lake"] = "Lago dei Limombroso",
	["Umbrafen Village"] = "Villaggio dei Limombroso",
	["Uncharted Sea"] = "Mare Inesplorato",
	Undercity = "Sepulcra",
	["Underlight Canyon"] = "Canyon di Sottoluce",
	["Underlight Mines"] = "Miniere Fiocaluce",
	["Unearthed Grounds"] = "Terre Dissotterrate",
	["Unga Ingoo"] = "Unga Ingu",
	["Un'Goro Crater"] = "Cratere di Un'Goro",
	["Unu'pe"] = "Unu'pe",
	["Unyielding Garrison"] = "Guarnigione Inflessibile",
	["Upper Silvermarsh"] = "Palude Argentata Superiore",
	["Upper Sumprushes"] = "Acquitrini Superiori",
	["Upper Veil Shil'ak"] = "Vol Shil'ak Superiore",
	["Ursoc's Den"] = "Tana di Ursoc",
	Ursolan = "Ursolan",
	["Utgarde Catacombs"] = "Catacombe di Utgarde",
	["Utgarde Keep"] = "Forte Utgarde",
	["Utgarde Keep Entrance"] = "Ingresso a Forte Utgarde",
	["Utgarde Pinnacle"] = "Pinnacolo di Utgarde",
	["Utgarde Pinnacle Entrance"] = "Ingresso al Pinnacolo di Utgarde",
	["Uther's Tomb"] = "Sepolcro di Uther",
	["Valaar's Berth"] = "Ormeggio di Valaar",
	["Vale of Eternal Blossoms"] = "Vallata dell'Eterna Primavera",
	["Valgan's Field"] = "Campo di Valgan",
	Valgarde = "Valguardia",
	["Valgarde Port"] = "Porto di Valguardia",
	Valhalas = "Valhalas",
	["Valiance Keep"] = "Forte degli Arditi",
	["Valiance Landing Camp"] = "Approdo degli Arditi",
	["Valiant Rest"] = "Riposo dei Coraggiosi",
	Valkyrion = "Valkyrion",
	["Valley of Ancient Winters"] = "Valle degli Antichi Inverni",
	["Valley of Ashes"] = "Valle delle Ceneri",
	["Valley of Bones"] = "Valle delle Ossa",
	["Valley of Echoes"] = "Valle degli Echi",
	["Valley of Emperors"] = "Valle degli Imperatori",
	["Valley of Fangs"] = "Valle delle Zanne",
	["Valley of Heroes"] = "Valle degli Eroi",
	["Valley Of Heroes"] = "Valle degli Eroi",
	["Valley of Honor"] = "Valle dell'Onore",
	["Valley of Kings"] = "Valle dei Re",
	["Valley of Power"] = "Vallata del Potere",
	["Valley Of Power - Scenario"] = "Vallata del Potere - Scenario",
	["Valley of Spears"] = "Valle delle Lance",
	["Valley of Spirits"] = "Valle degli Spiriti",
	["Valley of Strength"] = "Valle della Forza",
	["Valley of the Bloodfuries"] = "Valle delle Furie Rosse",
	["Valley of the Four Winds"] = "Valle dei Quattro Venti",
	["Valley of the Watchers"] = "Valle dei Guardiani",
	["Valley of Trials"] = "Valle delle Sfide",
	["Valley of Wisdom"] = "Valle della Saggezza",
	Valormok = "Valormok",
	["Valor's Edge"] = "Gloria del Valore",
	["Valor's Rest"] = "Asilo dei Valorosi",
	["Valorwind Lake"] = "Lago di Ardivento",
	["Vanguard Infirmary"] = "Infermeria dell'Avanguardia",
	["Vanndir Encampment"] = "Accampamento di Vanndir",
	["Vargoth's Retreat"] = "Ritiro di Vargoth",
	["Vashj'elan Spawning Pool"] = "Fossa di Riproduzione dei Vashj'elan",
	["Vashj'ir"] = "Vashj'ir",
	["Vashj'ir Sub - Alliance"] = "Sottomarino di Vashj'ir - Alleanza",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Sottomarino di Vashj'ir - Alleanza - Gira intorno alle Fauci dell'Abisso",
	["Vashj'ir Sub - Horde"] = "Sottomarino di Vashj'ir - Orda",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Sottomarino di Vashj'ir - Orda - Gira intorno alle Fauci dell'Abisso",
	["Vault of Archavon"] = "Volta di Archavon",
	["Vault of Ironforge"] = "Banca di Forgiardente",
	["Vault of Kings Past"] = "Cripta degli Imperatori del Passato",
	["Vault of the Ravenian"] = "Cripta del Raveniano",
	["Vault of the Shadowflame"] = "Volta dell'Ombrofuoco",
	["Vault of Y'Shaarj"] = "Cripta di Y'shaarj",
	["Veil Ala'rak"] = "Vol Ala'rak",
	["Veil Harr'ik"] = "Vol Harr'ik",
	["Veil Lashh"] = "Vol Lashh",
	["Veil Lithic"] = "Vol Lithic",
	["Veil Reskk"] = "Vol Reskk",
	["Veil Rhaze"] = "Vol Rhaze",
	["Veil Ruuan"] = "Vol Ruuan",
	["Veil Sethekk"] = "Vol Sethekk",
	["Veil Shalas"] = "Vol Shalas",
	["Veil Shienor"] = "Vol Shienor",
	["Veil Skith"] = "Vol Skith",
	["Veil Vekh"] = "Vol Vekh",
	["Vekhaar Stand"] = "Spianata di Vekhaar",
	["Velaani's Arcane Goods"] = "Articoli Arcani di Velaani",
	["Vendetta Point"] = "Presidio Vendetta",
	["Vengeance Landing"] = "Attracco della Vendetta",
	["Vengeance Landing Inn"] = "Locanda della Vendetta",
	["Vengeance Landing Inn, Howling Fjord"] = "Locanda della Vendetta, Fiordo Echeggiante",
	["Vengeance Lift"] = "Ascensore della Vendetta",
	["Vengeance Pass"] = "Passo della Vendetta",
	["Vengeance Wake"] = "Scia di Vendetta",
	["Venomous Ledge"] = "Cengia Venefica",
	Venomspite = "Venefica",
	["Venomsting Pits"] = "Nidi dei Malaculeo",
	["Venomweb Vale"] = "Valle Tela Venefica",
	["Venture Bay"] = "Baia della S.P.R. & Co.",
	["Venture Co. Base Camp"] = "Campo Base della S.P.R. & Co.",
	["Venture Co. Operations Center"] = "Centro Operativo della S.P.R. & Co.",
	["Verdant Belt"] = "Cintura Verdeggiante",
	["Verdant Highlands"] = "Altopiano Verdeggiante",
	["Verdantis River"] = "Fiume Verdantis",
	["Veridian Point"] = "Capo Veridiano",
	["Verlok Stand"] = "Terrazza dei Verlok",
	["Vermillion Redoubt"] = "Trincea Vermiglia",
	["Verming Tunnels Micro"] = "Microtunnel dei Leproratti",
	["Verrall Delta"] = "Delta del Verrall",
	["Verrall River"] = "Fiume Verrall",
	["Victor's Point"] = "Presidio della Vittoria",
	["Vileprey Village"] = "Vilpreda",
	["Vim'gol's Circle"] = "Cerchio di Vim'gol",
	["Vindicator's Rest"] = "Riposo del Vendicatore",
	["Violet Citadel Balcony"] = "Balcone della Cittadella Violacea",
	["Violet Hold"] = "Fortezza Violacea",
	["Violet Hold Entrance"] = "Ingresso alla Fortezza Violacea",
	["Violet Rise"] = "Terrazza Violacea",
	["Violet Stand"] = "Baluardo Violaceo",
	["Virmen Grotto"] = "Spiazzo dei Leproratti",
	["Virmen Nest"] = "Tana dei Leproratti",
	["Vir'naal Dam"] = "Diga di Vir'naal",
	["Vir'naal Lake"] = "Lago di Vir'naal",
	["Vir'naal Oasis"] = "Oasi di Vir'naal",
	["Vir'naal River"] = "Fiume Vir'naal",
	["Vir'naal River Delta"] = "Delta del Fiume Vir'naal",
	["Void Ridge"] = "Cresta del Vuoto",
	["Voidwind Plateau"] = "Tavolato di Ventovacuo",
	["Volcanoth's Lair"] = "Tana di Volcanoth",
	["Voldrin's Hold"] = "Difesa di Voldrin",
	Voldrune = "Voldrune",
	["Voldrune Dwelling"] = "Alloggi di Voldrune",
	Voltarus = "Voltarus",
	["Vordrassil Pass"] = "Passo di Vordrassil",
	["Vordrassil's Heart"] = "Cuore di Vordassil",
	["Vordrassil's Limb"] = "Arti di Vordassil",
	["Vordrassil's Tears"] = "Lacrime di Vordassil",
	["Vortex Pinnacle"] = "Pinnacolo del Vortice",
	["Vortex Summit"] = "Altopiano del Vortice",
	["Vul'Gol Ogre Mound"] = "Tumulo degli Ogre Vul'Gol",
	["Vyletongue Seat"] = "Seggio di Linguatroce",
	["Wahl Cottage"] = "Villa dei Wahl",
	["Wailing Caverns"] = "Caverna dei Lamenti",
	["Walk of Elders"] = "Corso degli Antichi",
	["Warbringer's Ring"] = "Arena dell'Araldo della Guerra",
	["Warchief's Lookout"] = "Posto di Guardia del Capoguerra",
	["Warden's Cage"] = "Prigione della Guardiana",
	["Warden's Chambers"] = "Sale del Guardiano",
	["Warden's Vigil"] = "Presidio del Guardiano",
	["Warlock Area"] = "Area dello Stregone",
	["Warmaul Hill"] = "Colle dei Fortemaglio",
	["Warpwood Quarter"] = "Quartiere di Legnotorto",
	["War Quarter"] = "Quartiere della Guerra",
	["Warrior's Terrace"] = "Terrazza dei Guerrieri",
	["War Room"] = "Sala della Guerra",
	Warship = "Nave da Guerra",
	["Warsong Camp"] = "Accampamento dei Cantaguerra",
	["Warsong Farms Outpost"] = "Presidio Agricolo dei Cantaguerra",
	["Warsong Flag Room"] = "Sala della Bandiera dei Cantaguerra",
	["Warsong Granary"] = "Granaio dei Cantaguerra",
	["Warsong Gulch"] = "Forra dei Cantaguerra",
	["Warsong Hold"] = "Forte dei Cantaguerra",
	["Warsong Jetty"] = "Molo dei Cantaguerra",
	["Warsong Labor Camp"] = "Campo di Lavoro dei Cantaguerra",
	["Warsong Lumber Camp"] = "Campo di Taglio dei Cantaguerra",
	["Warsong Lumber Mill"] = "Segheria dei Cantaguerra",
	["Warsong Slaughterhouse"] = "Macello dei Cantaguerra",
	["Watcher's Sanctum"] = "Santuario del Guardiano",
	["Watchers' Terrace"] = "Terrazza dei Guardiani",
	["Waterspeaker's Sanctuary"] = "Santuario dell'Oratore dell'Acqua",
	["Waterspring Field"] = "Piana dei Pozzi",
	Waterworks = "Mulino ad Acqua",
	["Wavestrider Beach"] = "Spiaggia Ondalunga",
	Waxwood = "Boscocereo",
	["Wayfarer's Rest"] = "Riposo dei Viaggiatori",
	Waygate = "Portale di Traslocazione",
	["Wayne's Refuge"] = "Bivacco di Wayne",
	["Weazel's Crater"] = "Cratere di Weazel",
	["Webwinder Hollow"] = "Valle di Passocurvo",
	["Webwinder Path"] = "Sentiero Passocurvo",
	["Weeping Quarry"] = "Cava delle Lacrime",
	["Well of Eternity"] = "Pozzo dell'Eternità",
	["Well of the Forgotten"] = "Pozzo dell'Oblio",
	["Wellson Shipyard"] = "Cantiere Navale di Wellson",
	["Wellspring Hovel"] = "Rifugio di Buonpozzo",
	["Wellspring Lake"] = "Lago di Buonpozzo",
	["Wellspring River"] = "Fiume Buonpozzo",
	["Westbrook Garrison"] = "Presidio Rivombroso",
	["Western Bridge"] = "Ponte Occidentale",
	["Western Plaguelands"] = "Terre Infette Occidentali",
	["Western Strand"] = "Riva Occidentale",
	Westersea = "Mare Occidentale",
	Westfall = "Marche Occidentali",
	["Westfall Brigade"] = "Brigata delle Marche",
	["Westfall Brigade Encampment"] = "Presidio Brigata delle Marche",
	["Westfall Lighthouse"] = "Faro delle Marche Occidentali",
	["West Garrison"] = "Guarnigione Occidentale",
	["Westguard Inn"] = "Locanda di Guardia dell'Ovest",
	["Westguard Keep"] = "Forte di Guardia dell'Ovest",
	["Westguard Turret"] = "Torretta di Guardia dell'Ovest",
	["West Pavilion"] = "Padiglione Occidentale",
	["West Pillar"] = "Pilastro Occidentale",
	["West Point Station"] = "Stazione Occidentale",
	["West Point Tower"] = "Torre Occidentale",
	["Westreach Summit"] = "Vetta Occidentale",
	["West Sanctum"] = "Santuario dell'Ovest",
	["Westspark Workshop"] = "Scintilla dell'Ovest",
	["West Spear Tower"] = "Torre Lancia dell'Ovest",
	["West Spire"] = "Torrione Occidentale",
	["Westwind Lift"] = "Ascensore di Ponente",
	["Westwind Refugee Camp"] = "Campo Profughi di Ventoponente",
	["Westwind Rest"] = "Vento dell'Ovest",
	Wetlands = "Paludi Grigie",
	Wheelhouse = "Casa della Ruota",
	["Whelgar's Excavation Site"] = "Scavi di Whelgar",
	["Whelgar's Retreat"] = "Rifugio di Whelgar",
	["Whispercloud Rise"] = "Altura dei Nuvola Soave",
	["Whisper Gulch"] = "Gola dei Sussurri",
	["Whispering Forest"] = "Foresta Sussurrante",
	["Whispering Gardens"] = "Giardini dei Sussurri",
	["Whispering Inlet"] = "Insenatura Sussurrante",
	["Whispering Shore"] = "Riva Mormorante",
	["Whispering Stones"] = "Pietre Sussurranti",
	["Whisperwind Grove"] = "Boschetto di Soffiabrezza",
	["Whistling Grove"] = "Boschetto Sibilante",
	["Whitebeard's Encampment"] = "Accampamento di Barbabianca",
	["Whitepetal Lake"] = "Lago del Petalo Bianco",
	["White Pine Trading Post"] = "Spaccio Pino Mugo",
	["Whitereach Post"] = "Accampamento di Manto Bianco",
	["Wildbend River"] = "Fiume Lettocurvo",
	["Wildervar Mine"] = "Miniera di Wildervar",
	["Wildflame Point"] = "Presidio di Fiammabrada",
	["Wildgrowth Mangal"] = "Giungla Selvaggia",
	["Wildhammer Flag Room"] = "Sala della Bandiera dei Granmartello",
	["Wildhammer Keep"] = "Forte dei Granmartello",
	["Wildhammer Stronghold"] = "Roccaforte dei Granmartello",
	["Wildheart Point"] = "Presidio di Cuorselvaggio",
	["Wildmane Water Well"] = "Pozzo dei Manto Selvaggio",
	["Wild Overlook"] = "Belvedere Selvaggio",
	["Wildpaw Cavern"] = "Caverna degli Zampafurente",
	["Wildpaw Ridge"] = "Cresta degli Zampafurente",
	["Wilds' Edge Inn"] = "Taverna del Limite Ignoto",
	["Wild Shore"] = "Rive Selvagge",
	["Wildvine Marsh"] = "Palude delle Viti Selvagge",
	["Wildwind Lake"] = "Lago di Ventoteso",
	["Wildwind Path"] = "Sentiero di Ventoforte",
	["Wildwind Peak"] = "Picco di Ventoforte",
	["Windbreak Canyon"] = "Canyon di Sbarravento",
	["Windfury Ridge"] = "Dorsale delle Furie del Vento",
	["Windrunner's Overlook"] = "Osservatorio dei Ventolesto",
	["Windrunner Spire"] = "Pinnacolo di Ventolesto",
	["Windrunner Village"] = "Ventolesto",
	["Winds' Edge"] = "Limitare del Vento",
	["Windshear Crag"] = "Landa di Tagliavento",
	["Windshear Heights"] = "Alture di Tagliavento",
	["Windshear Hold"] = "Bastione di Tagliavento",
	["Windshear Mine"] = "Miniera di Tagliavento",
	["Windshear Valley"] = "Valle di Tagliavento",
	["Windspire Bridge"] = "Ponte della Guglia del Vento",
	["Windward Isle"] = "Isola di Guardiavento",
	["Windy Bluffs"] = "Guglie Ventose",
	["Windyreed Pass"] = "Passo dei Brezzalorda",
	["Windyreed Village"] = "Villaggio dei Brezzalorda",
	["Winterax Hold"] = "Covo degli Asciafredda",
	["Winterbough Glade"] = "Radura Invernale",
	["Winterfall Village"] = "Villaggio dei Freddinverno",
	["Winterfin Caverns"] = "Caverne dei Pinnafredda",
	["Winterfin Retreat"] = "Rifugio dei Pinnafredda",
	["Winterfin Village"] = "Villaggio dei Pinnafredda",
	["Wintergarde Crypt"] = "Cripta di Guardia Invernale",
	["Wintergarde Keep"] = "Forte di Guardia Invernale",
	["Wintergarde Mausoleum"] = "Mausoleo di Guardia Invernale",
	["Wintergarde Mine"] = "Miniera di Guardia Invernale",
	Wintergrasp = "Lungoinverno",
	["Wintergrasp Fortress"] = "Fortezza di Lungoinverno",
	["Wintergrasp River"] = "Fiume Lungoinverno",
	["Winterhoof Water Well"] = "Pozzo degli Zoccolo Artico",
	["Winter's Blossom"] = "Bocciolo Invernale",
	["Winter's Breath Lake"] = "Lago di Soffiogelido",
	["Winter's Edge Tower"] = "Torre di Fondogelo",
	["Winter's Heart"] = "Cuore d'Inverno",
	Winterspring = "Fontefredda",
	["Winter's Terrace"] = "Terrazza dell'Inverno",
	["Witch Hill"] = "Colle della Strega",
	["Witch's Sanctum"] = "Santuario delle Streghe",
	["Witherbark Caverns"] = "Caverna degli Scorzasecca",
	["Witherbark Village"] = "Villaggio degli Scorzasecca",
	["Withering Thicket"] = "Boschetto Avvizzito",
	["Wizard Row"] = "Rione dei Maghi",
	["Wizard's Sanctum"] = "Santuario del Mago",
	["Wolf's Run"] = "Sentiero del Lupo",
	["Woodpaw Den"] = "Tana dei Raspalegno",
	["Woodpaw Hills"] = "Colline dei Raspalegno",
	["Wood's End Cabin"] = "Casotto della Radura",
	["Woods of the Lost"] = "Selve dei Dispersi",
	Workshop = "Officina",
	["Workshop Entrance"] = "Ingresso del Laboratorio",
	["World's End Tavern"] = "Taverna della Fine del Mondo",
	["Wrathscale Lair"] = "Santuario degli Scagliarabbiosa",
	["Wrathscale Point"] = "Capo degli Scagliarabbiosa",
	["Wreckage of the Silver Dawning"] = "Relitto dell'Alba d'Argento",
	["Wreck of Hellscream's Fist"] = "Relitto della Furia di Malogrido",
	["Wreck of the Mist-Hopper"] = "Relitto della Saltanebbie",
	["Wreck of the Skyseeker"] = "Relitto della Falcianubi",
	["Wreck of the Vanguard"] = "Relitto dell'Avanguardia",
	["Writhing Mound"] = "Tumulo Inquieto",
	Writhingwood = "Boscotorto",
	["Wu-Song Village"] = "Wu-Song",
	Wyrmbog = "Brago dei Dragoni",
	["Wyrmbreaker's Rookery"] = "Colonia di Spezzadragoni",
	["Wyrmrest Summit"] = "Sommità del Tempio",
	["Wyrmrest Temple"] = "Tempio della Lega dei Draghi",
	-- ["Wyrmrest Temple - bottom to middle"] = "",
	-- ["Wyrmrest Temple - bottom to top"] = "",
	-- ["Wyrmrest Temple - middle to bottom"] = "",
	-- ["Wyrmrest Temple - middle to top"] = "",
	-- ["Wyrmrest Temple - top to bottom"] = "",
	-- ["Wyrmrest Temple - top to middle"] = "",
	["Wyrms' Bend"] = "Ansa dei Dragoni",
	["Wyrmscar Island"] = "Isola di Fendragone",
	["Wyrmskull Bridge"] = "Ponte Cranio del Drago",
	["Wyrmskull Tunnel"] = "Tunnel Cranio del Drago",
	["Wyrmskull Village"] = "Cranio del Drago",
	["X-2 Pincer"] = "Chela X-2",
	Xavian = "Xavian",
	["Yan-Zhe River"] = "Fiume Yan-Zhe",
	["Yeti Mountain Basecamp"] = "Campo Base Monte Yeti",
	["Yinying Village"] = "Yinying",
	Ymirheim = "Ymirheim",
	["Ymiron's Seat"] = "Trono di Ymiron",
	["Yojamba Isle"] = "Isola di Yojamba",
	["Yowler's Den"] = "Tana di Ghignolungo",
	["Zabra'jin"] = "Zabra'jin",
	["Zaetar's Choice"] = "Scelta di Zaetar",
	["Zaetar's Grave"] = "Tomba di Zaetar",
	["Zalashji's Den"] = "Covo di Zalashji",
	["Zalazane's Fall"] = "Caduta di Zalazane",
	["Zane's Eye Crater"] = "Cratere Occhio di Zane",
	Zangarmarsh = "Paludi di Zangar",
	["Zangar Ridge"] = "Cresta di Zangar",
	["Zan'vess"] = "Zan'vess",
	["Za'Tual"] = "Za'tual",
	["Zeb'Halak"] = "Zeb'Halak",
	["Zeb'Nowa"] = "Zeb'Nowa",
	["Zeb'Sora"] = "Zeb'Sora",
	["Zeb'Tela"] = "Zeb'Tela",
	["Zeb'tula"] = "Zeb'tula",
	["Zeb'Watha"] = "Zeb'Watha",
	["Zeppelin Crash"] = "Rottami dello Zeppelin",
	Zeramas = "Zeramas",
	["Zeth'Gor"] = "Zeth'Gor",
	["Zhu Province"] = "Provincia di Zhu",
	["Zhu's Descent"] = "Pendio di Zhu",
	["Zhu's Watch"] = "Baluardo di Zhu",
	["Ziata'jai Ruins"] = "Rovine di Ziata'jai",
	["Zim'Abwa"] = "Zim'Abwa",
	["Zim'bo's Hideout"] = "Rifugio di Zim'bo",
	["Zim'Rhuk"] = "Zim'Rhuk",
	["Zim'Torga"] = "Zim'Torga",
	["Zol'Heb"] = "Zol'Heb",
	["Zol'Maz Stronghold"] = "Roccaforte di Zol'Maz",
	["Zoram'gar Outpost"] = "Avamposto di Zoram'gar",
	["Zouchin Province"] = "Zouchin",
	["Zouchin Strand"] = "Riva di Zouchin",
	["Zouchin Village"] = "Zouchin",
	["Zul'Aman"] = "Zul'Aman",
	["Zul'Drak"] = "Zul'Drak",
	["Zul'Farrak"] = "Zul'Farrak",
	["Zul'Farrak Entrance"] = "Ingresso a Zul'Farrak",
	["Zul'Gurub"] = "Zul'Gurub",
	["Zul'Mashar"] = "Zul'Mashar",
	["Zun'watha"] = "Zun'watha",
	["Zuuldaia Ruins"] = "Rovine di Zuuldaia",
}

elseif GAME_LOCALE == "esMX" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "Campamento base de la Séptima Legión",
	["7th Legion Front"] = "Frente de la Séptima Legión",
	["7th Legion Submarine"] = "Submarino de la Séptima Legión",
	["Abandoned Armory"] = "Armería Abandonada",
	["Abandoned Camp"] = "Campamento Abandonado",
	["Abandoned Mine"] = "Mina Abandonada",
	["Abandoned Reef"] = "Arrecife Abandonado",
	["Above the Frozen Sea"] = "Sobre El Mar Gélido",
	["A Brewing Storm"] = "Cervezas y Truenos",
	["Abyssal Breach"] = "Brecha Abisal",
	["Abyssal Depths"] = "Profundidades Abisales",
	["Abyssal Halls"] = "Cámaras Abisales",
	["Abyssal Maw"] = "Fauce Abisal",
	["Abyssal Maw Exterior"] = "Fauce Abisal Exterior",
	["Abyssal Sands"] = "Arenas Abisales",
	["Abyssion's Lair"] = "Guarida de Abismion",
	["Access Shaft Zeon"] = "Eje de Acceso Zeon",
	["Acherus: The Ebon Hold"] = "Acherus: El Bastión de Ébano",
	["Addle's Stead"] = "Granja de Addle",
	["Aderic's Repose"] = "Reposo de Aderic",
	["Aerie Peak"] = "Pico Nidal",
	["Aeris Landing"] = "Desembarco Aeris",
	["Agamand Family Crypt"] = "Cripta de la Familia Agamand",
	["Agamand Mills"] = "Molinos de Agamand",
	["Agmar's Hammer"] = "Martillo de Agmar",
	["Agmond's End"] = "El Final de Agmond",
	["Agol'watha"] = "Agol'watha",
	["A Hero's Welcome"] = "La Bienvenida de un Héroe",
	["Ahn'kahet: The Old Kingdom"] = "Ahn'kahet: El Antiguo Reino",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Ahn'kahet: Entrada de El Antiguo Reino",
	["Ahn Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj Temple"] = "Templo de Ahn'Qiraj",
	["Ahn'Qiraj Terrace"] = "Bancal de Ahn'Qiraj",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ahn'Qiraj: El Reino Caído",
	["Akhenet Fields"] = "Campos de Akhenet",
	["Aku'mai's Lair"] = "Guarida de Aku'mai",
	["Alabaster Shelf"] = "Saliente Alabastro",
	["Alcaz Island"] = "Isla de Alcaz",
	["Aldor Rise"] = "Alto Aldor",
	Aldrassil = "Aldrassil",
	["Aldur'thar: The Desolation Gate"] = "Aldur'thar: La Puerta de la Desolación",
	["Alexston Farmstead"] = "Hacienda de Alexston",
	["Algaz Gate"] = "Puerta de Algaz",
	["Algaz Station"] = "Estación de Algaz",
	["A Little Patience"] = "Templanza",
	["Allen Farmstead"] = "Hacienda de Allen",
	["Allerian Post"] = "Puesto Allerian",
	["Allerian Stronghold"] = "Bastión Allerian",
	["Alliance Base"] = "Base de la Alianza",
	["Alliance Beach Daily Area"] = "Zona de diarias de playa de la Alianza",
	["Alliance Beachhead"] = "Desembarco de la Alianza",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Centro de la Alianza - Gesta de progresión de la isla mogu",
	["Alliance Keep"] = "Fortaleza de la Alianza",
	["Alliance Mercenary Ship to Vashj'ir"] = "Barco mercenario de la Alianza a Vashj'ir",
	["Alliance PVP Barracks"] = "Cuartel JcJ de la Alianza",
	["All That Glitters Prospecting Co."] = "Prospecciones Todo lo Que Brilla y Cía.",
	["Alonsus Chapel"] = "Capilla de Alonsus",
	["Altar of Ascension"] = "Altar de la Ascensión",
	["Altar of Har'koa"] = "Altar de Har'koa",
	["Altar of Mam'toth"] = "Altar de Mam'toth",
	["Altar of Quetz'lun"] = "Altar de Quetz'lun",
	["Altar of Rhunok"] = "Altar de Rhunok",
	["Altar of Sha'tar"] = "Altar de Sha'tar",
	["Altar of Sseratus"] = "Altar de Sseratus",
	["Altar of Storms"] = "Altar de la Tempestad",
	["Altar of the Blood God"] = "Altar del Dios de la Sangre",
	["Altar of Twilight"] = "Altar del Crepúsculo",
	["Alterac Mountains"] = "Montañas de Alterac",
	["Alterac Valley"] = "Valle de Alterac",
	["Alther's Mill"] = "Molino de Alther",
	["Amani Catacombs"] = "Catacumbas Amani",
	["Amani Mountains"] = "Montañas Amani",
	["Amani Pass"] = "Paso de Amani",
	["Amberfly Bog"] = "Ciénaga Brasacielo",
	["Amberglow Hollow"] = "Cuenca del Resplandor Ámbar",
	["Amber Ledge"] = "El Saliente Ámbar",
	Ambermarsh = "Marjal Ámbar",
	Ambermill = "Molino Ámbar",
	["Amberpine Lodge"] = "Refugio Pino Ámbar",
	["Amber Quarry"] = "Cantera de Ámbar",
	["Amber Research Sanctum"] = "Sagrario de Investigación Ámbar",
	["Ambershard Cavern"] = "Cueva Ambarina",
	["Amberstill Ranch"] = "Granja de Semperámbar",
	["Amberweb Pass"] = "Paso de Redámbar",
	["Ameth'Aran"] = "Ameth'Aran",
	["Ammen Fields"] = "Campos Ammen",
	["Ammen Ford"] = "Vado Ammen",
	["Ammen Vale"] = "Valle Ammen",
	["Amphitheater of Anguish"] = "Anfiteatro de la Angustia",
	["Ampitheater of Anguish"] = "Anfiteatro de la Angustia",
	["Ancestral Grounds"] = "Tierras Ancestrales",
	["Ancestral Rise"] = "Alto Ancestral",
	["Ancient Courtyard"] = "Patio Ancestral",
	["Ancient Zul'Gurub"] = "Antiguo Zul'Gurub",
	["An'daroth"] = "An'daroth",
	["Andilien Estate"] = "Dominios Andilien",
	Andorhal = "Andorhal",
	Andruk = "Andruk",
	["Angerfang Encampment"] = "Campamento Dentellada",
	["Angkhal Pavilion"] = "Pabellón de Angkhal",
	["Anglers Expedition"] = "Expedición de los Pescadores",
	["Anglers Wharf"] = "Muelle de los Pescadores",
	["Angor Fortress"] = "Fortaleza de Angor",
	["Ango'rosh Grounds"] = "Dominios Ango'rosh",
	["Ango'rosh Stronghold"] = "Bastión Ango'rosh",
	["Angrathar the Wrathgate"] = "Angrathar la Puerta de Cólera",
	["Angrathar the Wrath Gate"] = "Angrathar la Puerta de Cólera",
	["An'owyn"] = "An'owyn",
	["An'telas"] = "An'telas",
	["Antonidas Memorial"] = "Monumento de Antonidas",
	Anvilmar = "Yunquemar",
	["Anvil of Conflagration"] = "Yunque de Conflagración",
	["Apex Point"] = "La Cúspide",
	["Apocryphan's Rest"] = "Descanso de Apócrifo",
	["Apothecary Camp"] = "Campamento de los Boticarios",
	["Applebloom Tavern"] = "Taberna Manzana Jugosa",
	["Arathi Basin"] = "Cuenca de Arathi",
	["Arathi Highlands"] = "Tierras Altas de Arathi",
	["Arcane Pinnacle"] = "Pináculo Arcano",
	["Archmage Vargoth's Retreat"] = "Reposo del Archimago Vargoth",
	["Area 52"] = "Área 52",
	["Arena Floor"] = "El Suelo de la Arena",
	["Arena of Annihilation"] = "Arena de la Aniquilación",
	["Argent Pavilion"] = "Pabellón Argenta",
	["Argent Stand"] = "El Confín Argenta",
	["Argent Tournament Grounds"] = "Campos del Torneo Argenta",
	["Argent Vanguard"] = "Vanguardia Argenta",
	["Ariden's Camp"] = "Campamento de Ariden",
	["Arikara's Needle"] = "Aguja de Arikara",
	["Arklonis Ridge"] = "Cresta Arklonis",
	["Arklon Ruins"] = "Ruinas Arklon",
	["Arriga Footbridge"] = "Pasarela de Arriga",
	["Arsad Trade Post"] = "Puesto Comercial de Arsad",
	["Ascendant's Rise"] = "Alto del Ascendiente",
	["Ascent of Swirling Winds"] = "Ascenso de la Espiral de Viento",
	["Ashen Fields"] = "Campos Cinéreos",
	["Ashen Lake"] = "Lago Cinéreo",
	Ashenvale = "Vallefresno",
	["Ashwood Lake"] = "Lago Fresno",
	["Ashwood Post"] = "Puesto Fresno",
	["Aspen Grove Post"] = "Puesto de la Alameda",
	["Assault on Shaol'mara"] = "Asalto a Shaol'mara",
	["Assault on Zan'vess"] = "Asalto a Zan'vess",
	["Assault on Zeb'tula"] = "Asalto a Zeb'tula",
	Astranaar = "Astranaar",
	["Ata'mal Terrace"] = "Bancal de Ata'mal",
	Athenaeum = "El Athenaeum",
	["Atrium of the Heart"] = "Atrio del Corazón",
	["Atulhet's Tomb"] = "Tumba de Atulhet",
	["Auberdine Refugee Camp"] = "Campamento de refugiados de Auberdine",
	["Auburn Bluffs"] = "Cimas Cobrizas",
	["Auchenai Crypts"] = "Criptas Auchenai",
	["Auchenai Grounds"] = "Tierras Auchenai",
	Auchindoun = "Auchindoun",
	["Auchindoun: Auchenai Crypts"] = "Auchindoun: Criptas Auchenai",
	["Auchindoun - Auchenai Crypts Entrance"] = "Auchindoun - Entrada de las Criptas Auchenai",
	["Auchindoun: Mana-Tombs"] = "Auchindoun: Tumbas de Maná",
	["Auchindoun - Mana-Tombs Entrance"] = "Auchindoun - Entrada de las Tumbas de Maná",
	["Auchindoun: Sethekk Halls"] = "Auchindoun: Salas Sethekk",
	["Auchindoun - Sethekk Halls Entrance"] = "Auchindoun - Entrada de las Salas Sethekk",
	["Auchindoun: Shadow Labyrinth"] = "Auchindoun: Laberinto de las Sombras",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Auchindoun - Entrada del Laberinto de las Sombras",
	["Auren Falls"] = "Cascadas Auren",
	["Auren Ridge"] = "Cresta Auren",
	["Autumnshade Ridge"] = "Risco Sombra Otoñal",
	["Avalanchion's Vault"] = "Cámara de Avalanchion",
	Aviary = "El Aviario",
	["Axis of Alignment"] = "Eje de Alineación",
	Axxarien = "Axxarien",
	["Azjol-Nerub"] = "Azjol-Nerub",
	["Azjol-Nerub Entrance"] = "Entrada de Azjol-Nerub",
	Azshara = "Azshara",
	["Azshara Crater"] = "Cráter de Azshara",
	["Azshara's Palace"] = "Palacio de Azshara",
	["Azurebreeze Coast"] = "Costa Bris Azur",
	["Azure Dragonshrine"] = "Santuario de Dragones Azur",
	["Azurelode Mine"] = "Mina Azur",
	["Azuremyst Isle"] = "Isla Bruma Azur",
	["Azure Watch"] = "Avanzada Azur",
	["Backbreaker Bay"] = "Bahía Partedorsales",
	Badlands = "Tierras Inhóspitas",
	["Bael'dun Digsite"] = "Excavación de Bael'dun",
	["Bael'dun Keep"] = "Fortaleza de Bael'dun",
	["Baelgun's Excavation Site"] = "Excavación de Baelgun",
	["Bael Modan"] = "Bael Modan",
	["Bael Modan Excavation"] = "Excavación de Bael Modan",
	["Bahrum's Post"] = "Puesto de Bahrum",
	["Balargarde Fortress"] = "Fortaleza de Balargarde",
	Baleheim = "Baleheim",
	["Balejar Watch"] = "Avanzada Balejar",
	["Balia'mah Ruins"] = "Ruinas de Balia'mah",
	["Bal'lal Ruins"] = "Ruinas de Bal'lal",
	["Balnir Farmstead"] = "Hacienda Balnir",
	Bambala = "Bambala",
	["Band of Acceleration"] = "Anillo de Aceleración",
	["Band of Alignment"] = "Anillo de Alineación",
	["Band of Transmutation"] = "Anillo de Transmutación",
	["Band of Variance"] = "Anillo de Discrepancia",
	["Ban'ethil Barrow Den"] = "Túmulo de Ban'ethil",
	["Ban'ethil Barrow Descent"] = "Descenso del Túmulo de Ban'ethil",
	["Ban'ethil Hollow"] = "Hondonada Ban'ethil",
	Bank = "Banco",
	["Banquet Grounds"] = "Tierras del Festín",
	["Ban'Thallow Barrow Den"] = "Túmulo de Ban'Thallow",
	["Baradin Base Camp"] = "Campamento de Baradin",
	["Baradin Bay"] = "Bahía de Baradin",
	["Baradin Hold"] = "Bastión de Baradin",
	Barbershop = "Peluquería",
	["Barov Family Vault"] = "Cripta de la Familia Barov",
	["Bashal'Aran"] = "Bashal'Aran",
	["Bashal'Aran Collapse"] = "Ocaso de Bashal'Aran",
	["Bash'ir Landing"] = "Alto Bash'ir",
	["Bastion Antechamber"] = "Antecámara del Bastión",
	["Bathran's Haunt"] = "Ruinas de Bathran",
	["Battlefront Provisions"] = "Provisiones del Frente",
	["Battle on the High Seas"] = "Batalla en Alta Mar",
	["Battle Ring"] = "Liza",
	Battlescar = "Marca de Guerra",
	["Battlescar Spire"] = "Cumbre Marca de Guerra",
	["Battlescar Valley"] = "Valle Marca de Guerra",
	["Bay of Echoes"] = "Bahía de los Ecos",
	["Bay of Storms"] = "Bahía de la Tempestad",
	["Bear's Head"] = "Cabeza de Oso",
	["Beauty's Lair"] = "Guarida de Bella",
	["Beeble's Wreck"] = "Siniestro de Beeble",
	["Beezil's Wreck"] = "Siniestro de Beezil",
	["Befouled Terrace"] = "Bancal Infecto",
	["Beggar's Haunt"] = "Refugio de los Mendigos",
	["Beneath The Double Rainbow"] = "Debajo del Arco Iris Doble",
	["Beneath the Pit"] = "Sotofoso",
	["Beren's Peril"] = "El Desafío de Beren",
	["Bernau's Happy Fun Land"] = "El Maravilloso Mundo de Bernau",
	["Beryl Coast"] = "Costa de Berilo",
	["Beryl Egress"] = "Egreso de Berilo",
	["Beryl Point"] = "Alto de Berilo",
	["Beth'mora Ridge"] = "Cresta de Beth'mora",
	["Beth'tilac's Lair"] = "Guarida de Beth'tilac",
	["Biel'aran Ridge"] = "Cresta de Biel'aran",
	["Big Beach Brew Bash"] = "Reyerta de la Gran Playa",
	["Big Blossom Excavation"] = "Excavación de la Gran Flor",
	["Big Blossom Mine"] = "Mina de la Gran Flor",
	["Bilgewater Beach"] = "Playa Pantoque",
	["Bilgewater Harbor"] = "Muelle Pantoque",
	["Bilgewater Lumber Yard"] = "Almacén de Madera Pantoque",
	["Bilgewater Port"] = "Puerto Pantoque",
	["Binan Brew & Stew"] = "Mesón de Binan",
	["Binan Village"] = "Aldea Binan",
	["Bitter Reaches"] = "Costa Amarga",
	["Bittertide Lake"] = "Lago Olamarga",
	["Bizmo's Brawlpub"] = "Club de Lucha de Bizmo",
	["Black Channel Marsh"] = "Pantano del Canal Negro",
	["Blackchar Cave"] = "Cueva Tizonegro",
	["Black Drake Roost"] = "Nidal del Draco Negro",
	["Blackfathom Camp"] = "Campamento Brazanegra",
	["Blackfathom Deeps"] = "Cavernas de Brazanegra",
	["Blackfathom Deeps Entrance"] = "Entrada de las Cavernas de Brazanegra",
	["Blackhoof Village"] = "Poblado Pezuñanegra",
	["Blackhorn's Penance"] = "Penitencia de Cuerno Negro",
	["Blackmaw Hold"] = "Bastión Faucenegra",
	["Black Ox Temple"] = "Templo del Buey Negro",
	["Blackriver Logging Camp"] = "Aserradero Río Negro",
	["Blackrock Caverns"] = "Cavernas Roca Negra",
	["Blackrock Caverns Entrance"] = "Entrada de las Cavernas Roca Negra",
	["Blackrock Depths"] = "Profundidades de Roca Negra",
	["Blackrock Depths Entrance"] = "Entrada de las Profundidades de Roca Negra",
	["Blackrock Mountain"] = "Montaña Roca Negra",
	["Blackrock Pass"] = "Desfiladero de Roca Negra",
	["Blackrock Spire"] = "Cumbre de Roca Negra",
	["Blackrock Spire Entrance"] = "Entrada de la Cumbre de Roca Negra",
	["Blackrock Stadium"] = "Estadio de Roca Negra",
	["Blackrock Stronghold"] = "Bastión de Roca Negra",
	["Blacksand Spillway"] = "Aliviadero Gravanegra",
	["Blacksilt Shore"] = "Costa Cienonegro",
	Blacksmith = "Herrería",
	["Blackstone Span"] = "Tramo Piedranegra",
	["Black Temple"] = "Templo Oscuro",
	["Black Tooth Hovel"] = "Cobertizo Diente Negro",
	Blackwatch = "La Guardia Negra",
	["Blackwater Cove"] = "Cala Aguasnegras",
	["Blackwater Shipwrecks"] = "Naufragios de Aguasnegras",
	["Blackwind Lake"] = "Lago Vientonegro",
	["Blackwind Landing"] = "Alto de los Vientonegro",
	["Blackwind Valley"] = "Valle Vientonegro",
	["Blackwing Coven"] = "Aquelarre Alanegra",
	["Blackwing Descent"] = "Descenso de Alanegra",
	["Blackwing Lair"] = "Guarida de Alanegra",
	["Blackwolf River"] = "Río Lobonegro",
	["Blackwood Camp"] = "Campamento del Bosque Negro",
	["Blackwood Den"] = "Cubil del Bosque Negro",
	["Blackwood Lake"] = "Lago del Bosque Negro",
	["Bladed Gulch"] = "Barranco del Filo",
	["Bladefist Bay"] = "Bahía de Garrafilada",
	["Bladelord's Retreat"] = "Refugio del Señor de las Espadas",
	["Blades & Axes"] = "Espadas y Hachas",
	["Blade's Edge Arena"] = "Arena Filospada",
	["Blade's Edge Mountains"] = "Montañas Filospada",
	["Bladespire Grounds"] = "Dominios Aguja del Filo",
	["Bladespire Hold"] = "Bastión Aguja del Filo",
	["Bladespire Outpost"] = "Avanzada Aguja del Filo",
	["Blades' Run"] = "Camino de las Espadas",
	["Blade Tooth Canyon"] = "Cañón Dientespada",
	Bladewood = "Bosquespada",
	["Blasted Lands"] = "Las Tierras Devastadas",
	["Bleak Hollow"] = "Fosa Lúgubre",
	["Bleeding Hollow Ruins"] = "Ruinas Foso Sangrante",
	["Bleeding Vale"] = "Vega Sangrante",
	["Bleeding Ziggurat"] = "Zigurat Sangrante",
	["Blistering Pool"] = "Poza Virulenta",
	["Bloodcurse Isle"] = "Isla Sangre Maldita",
	["Blood Elf Tower"] = "Torre de los Elfos de Sangre",
	["Bloodfen Burrow"] = "Madriguera de los Cienorrojo",
	Bloodgulch = "Garganta de Sangre",
	["Bloodhoof Village"] = "Poblado Pezuña de Sangre",
	["Bloodied Crossing"] = "Cruce Sangriento",
	["Blood in the Snow"] = "Sangre en la Nieve",
	["Bloodmaul Camp"] = "Campamento Machacasangre",
	["Bloodmaul Outpost"] = "Avanzada Machacasangre",
	["Bloodmaul Ravine"] = "Barranco Machacasangre",
	["Bloodmoon Isle"] = "Isla Luna de Sangre",
	["Bloodmyst Isle"] = "Isla Bruma de Sangre",
	["Bloodscale Enclave"] = "Enclave Escamas de Sangre",
	["Bloodscale Grounds"] = "Tierras Escamas de Sangre",
	["Bloodspore Plains"] = "Llanuras Sanguiespora",
	["Bloodtalon Shore"] = "Costa Garrasangre",
	["Bloodtooth Camp"] = "Asentamiento Sangradientes",
	["Bloodvenom Falls"] = "Cascadas del Veneno",
	["Bloodvenom Post"] = "Puesto del Veneno",
	["Bloodvenom Post "] = "Puesto del Veneno",
	["Bloodvenom River"] = "Río del Veneno",
	["Bloodwash Cavern"] = "Cueva de La Playa de Sangre",
	["Bloodwash Fighting Pits"] = "Fosos de lucha de La Playa de Sangre",
	["Bloodwash Shrine"] = "Santuario de La Playa de Sangre",
	["Blood Watch"] = "Avanzada de Sangre",
	["Bloodwatcher Point"] = "Paso de Mirasangre",
	Bluefen = "Ciénaga Azul",
	["Bluegill Marsh"] = "Pantano Branquiazul",
	["Blue Sky Logging Grounds"] = "Aserradero Cielo Azul",
	["Bluff of the South Wind"] = "Cima del Viento del Sur",
	["Bogen's Ledge"] = "Arrecife de Bogen",
	Bogpaddle = "Chapaleos",
	["Boha'mu Ruins"] = "Ruinas Boha'mu",
	["Bolgan's Hole"] = "Cuenca de Bolgan",
	["Bolyun's Camp"] = "Campamento de Bolyun",
	["Bonechewer Ruins"] = "Ruinas Mascahuesos",
	["Bonesnap's Camp"] = "Campamento Cascahueso",
	["Bones of Grakkarond"] = "Huesos de Grakkarond",
	["Bootlegger Outpost"] = "Avanzada del Contrabandista",
	["Booty Bay"] = "Bahía del Botín",
	["Borean Tundra"] = "Tundra Boreal",
	["Bor'gorok Outpost"] = "Avanzada Bor'gorok",
	["Bor's Breath"] = "Aliento de Bor",
	["Bor's Breath River"] = "Río del Aliento de Bor",
	["Bor's Fall"] = "Caída de Bor",
	["Bor's Fury"] = "La Furia de Bor",
	["Borune Ruins"] = "Ruinas Borune",
	["Bough Shadow"] = "Talloumbrío",
	["Bouldercrag's Refuge"] = "Refugio de Pedruscón",
	["Boulderfist Hall"] = "Sala Puño de Roca",
	["Boulderfist Outpost"] = "Avanzada Puño de Roca",
	["Boulder'gor"] = "Roca'gor",
	["Boulder Hills"] = "Colinas Pedrusco",
	["Boulder Lode Mine"] = "Mina Pedrusco",
	["Boulder'mok"] = "Peña'mok",
	["Boulderslide Cavern"] = "Cueva del Alud",
	["Boulderslide Ravine"] = "Barranco del Alud",
	["Bozzle's Wreck"] = "Siniestro de Bozzle",
	["Brackenwall Village"] = "Poblado Murohelecho",
	["Brackwell Pumpkin Patch"] = "Plantación de Calabazas de Brackwell",
	["Brambleblade Ravine"] = "Barranco Cortazarza",
	Bramblescar = "Rajazarza",
	["Brann's Base-Camp"] = "Campamento base de Brann",
	["Brashtide Attack Fleet"] = "Flota de Asalto Fuertemarea",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Flota de Asalto Fuertemarea (Fuerzas de exterior)",
	["Brave Wind Mesa"] = "Mesa de Viento Bravo",
	["Brawl'gar Arena"] = "Arena Liza'gar",
	["Brazie Farmstead"] = "Granja de Brazie",
	["Brewmoon Festival"] = "Festival de la Cerveza Lunar",
	["Brewnall Village"] = "Las Birras",
	["Bridge of Souls"] = "Puente de las Almas",
	["Brightwater Lake"] = "Lago Aguasclaras",
	["Brightwood Grove"] = "Arboleda del Destello",
	Brill = "Rémol",
	["Brill Town Hall"] = "Concejo de Rémol",
	["Bristlelimb Enclave"] = "Enclave Brazolanudo",
	["Bristlelimb Village"] = "Aldea Brazolanudo",
	["Broken Commons"] = "Ágora",
	["Broken Hill"] = "Cerro Tábido",
	["Broken Pillar"] = "Pilar Partido",
	["Broken Spear Village"] = "Aldea Lanza Partida",
	["Broken Wilds"] = "Landas Tábidas",
	["Broketooth Outpost"] = "Avanzada Dienterroto",
	["Bronzebeard Encampment"] = "Campamento Barbabronce",
	["Bronze Dragonshrine"] = "Santuario de Dragones Bronce",
	["Browman Mill"] = "Molino Cejifrente",
	["Brunnhildar Village"] = "Poblado Brunnhildar",
	["Bucklebree Farm"] = "La granja de Bucklebree",
	["Budd's Dig"] = "Excavación de Budd",
	["Burning Blade Coven"] = "Aquelarre del Filo Ardiente",
	["Burning Blade Ruins"] = "Ruinas Filo Ardiente",
	["Burning Steppes"] = "Las Estepas Ardientes",
	["Butcher's Sanctum"] = "Sagrario del Carnicero",
	["Butcher's Stand"] = "Puesto de Carnicero",
	["Caer Darrow"] = "Castel Darrow",
	["Caldemere Lake"] = "Lago Caldemere",
	["Calston Estate"] = "Dominios de Calston",
	["Camp Aparaje"] = "Campamento Aparaje",
	["Camp Ataya"] = "Campamento Ataya",
	["Camp Boff"] = "Asentamiento Boff",
	["Camp Broketooth"] = "Campamento Dienterroto",
	["Camp Cagg"] = "Asentamiento Cagg",
	["Camp E'thok"] = "Campamento E'thok",
	["Camp Everstill"] = "Campamento Sempiterno",
	["Camp Gormal"] = "Campamento Gormal",
	["Camp Kosh"] = "Asentamiento Kosh",
	["Camp Mojache"] = "Campamento Mojache",
	["Camp Mojache Longhouse"] = "Casa Comunal del Campamento Mojache",
	["Camp Narache"] = "Campamento Narache",
	["Camp Nooka Nooka"] = "Campamento Nooka Nooka",
	["Camp of Boom"] = "Campamento de Bum",
	["Camp Onequah"] = "Campamento Oneqwah",
	["Camp Oneqwah"] = "Campamento Oneqwah",
	["Camp Sungraze"] = "Campamento Rasguño de Sol",
	["Camp Tunka'lo"] = "Campamento Tunka'lo",
	["Camp Una'fe"] = "Campamento Una'fe",
	["Camp Winterhoof"] = "Campamento Pezuña Invernal",
	["Camp Wurg"] = "Asentamiento Wurg",
	Canals = "Canales",
	["Cannon's Inferno"] = "Infierno de Cannon",
	["Cantrips & Crows"] = "Taberna de los Cuervos",
	["Cape of Lost Hope"] = "Cabo de la Esperanza Perdida",
	["Cape of Stranglethorn"] = "El Cabo de Tuercespina",
	["Capital Gardens"] = "Jardines de la Capital",
	["Carrion Hill"] = "Colina Carroña",
	["Cartier & Co. Fine Jewelry"] = "Joyería Fina Cartier y Cía.",
	Cataclysm = "Cataclysm",
	["Cathedral of Darkness"] = "Catedral de la Oscuridad",
	["Cathedral of Light"] = "Catedral de la Luz",
	["Cathedral Quarter"] = "Barrio de la Catedral",
	["Cathedral Square"] = "Plaza de la Catedral",
	["Cattail Lake"] = "Lago de las Eneas",
	["Cauldros Isle"] = "Isla Caldros",
	["Cave of Mam'toth"] = "Cueva de Mam'toth",
	["Cave of Meditation"] = "Cueva de Meditación",
	["Cave of the Crane"] = "Cueva de la Grulla",
	["Cave of Words"] = "Cueva de las Palabras",
	["Cavern of Endless Echoes"] = "Cueva del Eco Infinito",
	["Cavern of Mists"] = "Caverna Vaharada",
	["Caverns of Time"] = "Cavernas del Tiempo",
	["Celestial Enclave"] = "Enclave Celestial",
	["Celestial Ridge"] = "Cresta Celestial",
	["Cenarion Enclave"] = "Enclave Cenarion",
	["Cenarion Hold"] = "Fuerte Cenarion",
	["Cenarion Post"] = "Puesto Cenarion",
	["Cenarion Refuge"] = "Refugio Cenarion",
	["Cenarion Thicket"] = "Matorral Cenarion",
	["Cenarion Watchpost"] = "Puesto de Vigilancia Cenarion",
	["Cenarion Wildlands"] = "Tierras Vírgenes Cenarion",
	["Central Bridge"] = "Puente Central",
	["Chamber of Ancient Relics"] = "Cámara de Reliquias Antiguas",
	["Chamber of Atonement"] = "Cámara Expiatoria",
	["Chamber of Battle"] = "Sala de la Batalla",
	["Chamber of Blood"] = "Cámara Sangrienta",
	["Chamber of Command"] = "Cámara de Mando",
	["Chamber of Enchantment"] = "Cámara del Encantamiento",
	["Chamber of Enlightenment"] = "Cámara de la Iluminación",
	["Chamber of Fanatics"] = "Cámara de los Fanáticos",
	["Chamber of Incineration"] = "Cámara de Incineración",
	["Chamber of Masters"] = "Cámara de los Maestros",
	["Chamber of Prophecy"] = "Sala de la Profecía",
	["Chamber of Reflection"] = "Cámara del Reflejo",
	["Chamber of Respite"] = "Cámara del Descanso",
	["Chamber of Summoning"] = "Cámara de la Invocación",
	["Chamber of Test Namesets"] = "Cámara de Nombres de Prueba",
	["Chamber of the Aspects"] = "Cámara de los Aspectos",
	["Chamber of the Dreamer"] = "Cámara de los Sueños",
	["Chamber of the Moon"] = "Cámara de la Luna",
	["Chamber of the Restless"] = "Cámara de los Sin Sosiego",
	["Chamber of the Stars"] = "Cámara de las Estrellas",
	["Chamber of the Sun"] = "Cámara del Sol",
	["Chamber of Whispers"] = "Cámara de los Susurros",
	["Chamber of Wisdom"] = "Cámara de la Sabiduría",
	["Champion's Hall"] = "Sala de los Campeones",
	["Champions' Hall"] = "Sala de los Campeones",
	["Chapel Gardens"] = "Jardines de la Capilla",
	["Chapel of the Crimson Flame"] = "Capilla de la Llama Carmesí",
	["Chapel Yard"] = "Patio de la Capilla",
	["Charred Outpost"] = "Avanzada Carbonizada",
	["Charred Rise"] = "Alto Carbonizado",
	["Chill Breeze Valley"] = "Valle Escalofrío",
	["Chillmere Coast"] = "Costafría",
	["Chillwind Camp"] = "Campamento del Orvallo",
	["Chillwind Point"] = "Alto del Orvallo",
	Chiselgrip = "Cincelada",
	["Chittering Coast"] = "Costa del Gorjeo",
	["Chow Farmstead"] = "Granja de Tallarín",
	["Churning Gulch"] = "Garganta Bulliciosa",
	["Circle of Blood"] = "Círculo de Sangre",
	["Circle of Blood Arena"] = "Arena del Círculo de Sangre",
	["Circle of Bone"] = "Círculo de Huesos",
	["Circle of East Binding"] = "Círculo de Vínculo Este",
	["Circle of Inner Binding"] = "Círculo de Vínculo Interior",
	["Circle of Outer Binding"] = "Círculo de Vínculo Exterior",
	["Circle of Scale"] = "Círculo de Escamas",
	["Circle of Stone"] = "Círculo de Piedras",
	["Circle of Thorns"] = "Círculo de Espinas",
	["Circle of West Binding"] = "Círculo de Vínculo Oeste",
	["Circle of Wills"] = "Círculo de Voluntades",
	City = "Ciudad",
	["City of Ironforge"] = "Ciudad de Forjaz",
	["City Siege - Mogu Island Progression Scenario"] = "Asedio a la ciudad - Gesta de progresión de la isla mogu",
	["Clan Watch"] = "Avanzada del Clan",
	["Class Quest"] = "Misión de Clase",
	["Claytön's WoWEdit Land"] = "Claytön's WoWEdit Land",
	["Cleft of Shadow"] = "Circo de las Sombras",
	["Cliffspring Falls"] = "Salto de Fonroca",
	["Cliffspring Hollow"] = "Cuenca Fonroca",
	["Cliffspring River"] = "Río Fonroca",
	["Cliffwalker Post"] = "Puesto Caminarrisco",
	["Cloudstrike Dojo"] = "Dojo Golpe Celeste",
	["Cloudtop Terrace"] = "Bancal Altonube",
	["Coast of Echoes"] = "Costa de los Ecos",
	["Coast of Idols"] = "Costa de los Ídolos",
	["Coilfang Reservoir"] = "Reserva Colmillo Torcido",
	["Coilfang: Serpentshrine Cavern"] = "Reserva Colmillo Torcido: Caverna Santuario Serpiente",
	["Coilfang: The Slave Pens"] = "Colmillo Torcido: Recinto de los Esclavos",
	["Coilfang - The Slave Pens Entrance"] = "Colmillo Torcido: Entrada del Recinto de los Esclavos",
	["Coilfang: The Steamvault"] = "Colmillo Torcido: Cámara de Vapor",
	["Coilfang - The Steamvault Entrance"] = "Colmillo Torcido: Entrada de La Cámara de Vapor",
	["Coilfang: The Underbog"] = "Colmillo Torcido: La Sotiénaga",
	["Coilfang - The Underbog Entrance"] = "Colmillo Torcido: Entrada de La Sotiénaga",
	["Coilskar Cistern"] = "Cisterna Cicatriz Espiral",
	["Coilskar Point"] = "Alto Cicatriz Espiral",
	Coldarra = "Gelidar",
	["Coldarra Ledge"] = "Saliente de Gelidar",
	["Coldbite Burrow"] = "Madriguera Muerdefrío",
	["Cold Hearth Manor"] = "Mansión Fríogar",
	["Coldridge Pass"] = "Desfiladero de Crestanevada",
	["Coldridge Valley"] = "Valle de Crestanevada",
	["Coldrock Quarry"] = "Cantera Frioescollo",
	["Coldtooth Mine"] = "Mina Dentefrío",
	["Coldwind Heights"] = "Altos Viento Helado",
	["Coldwind Pass"] = "Pasaje Viento Helado",
	["Collin's Test"] = "Collin's Test",
	["Command Center"] = "Centro de Mando",
	["Commons Hall"] = "Cámara del Pueblo",
	["Condemned Halls"] = "Salas Condenadas",
	["Conqueror's Terrace"] = "Platea del Conquistador",
	["Conquest Hold"] = "Bastión de la Conquista",
	["Containment Core"] = "Pabellón de Aislamiento",
	["Cooper Residence"] = "La Residencia Cooper",
	["Coral Garden"] = "Jardín de Coral",
	["Cordell's Enchanting"] = "Encantamientos de Cordell",
	["Corin's Crossing"] = "Cruce de Corin",
	["Corp'rethar: The Horror Gate"] = "Corp'rethar: La Puerta del Horror",
	["Corrahn's Dagger"] = "Daga de Corrahn",
	Cosmowrench = "Cosmotirón",
	["Court of Bones"] = "El Patio de los Huesos",
	["Court of the Highborne"] = "Corte de los Altonato",
	["Court of the Sun"] = "La Corte del Sol",
	["Courtyard of Lights"] = "Patio de las Luces",
	["Courtyard of the Ancients"] = "Patio de los Ancestros",
	["Cradle of Chi-Ji"] = "Cuna de Chi-Ji",
	["Cradle of the Ancients"] = "Cuna de los Ancestros",
	["Craftsmen's Terrace"] = "Bancal del Artesano",
	["Crag of the Everliving"] = "Risco de los Eternos",
	["Cragpool Lake"] = "Lago del Peñasco",
	["Crane Wing Refuge"] = "Refugio Ala de Grulla",
	["Crash Site"] = "Lugar del Accidente",
	["Crescent Hall"] = "Sala Creciente",
	["Crimson Assembly Hall"] = "La Sala de la Asamblea Carmesí",
	["Crimson Expanse"] = "Extensión Carmesí",
	["Crimson Watch"] = "Atalaya Carmesí",
	Crossroads = "El Cruce",
	["Crowley Orchard"] = "Huerto de Crowley",
	["Crowley Stable Grounds"] = "Tierras del Establo de Crowley",
	["Crown Guard Tower"] = "Torre de la Corona",
	["Crucible of Carnage"] = "Crisol de Matanza",
	["Crumbling Depths"] = "Profundidades Desmoronadas",
	["Crumbling Stones"] = "Rocas Desmoronadas",
	["Crusader Forward Camp"] = "Puesto de Avanzada de los Cruzados",
	["Crusader Outpost"] = "Avanzada de los Cruzados",
	["Crusader's Armory"] = "Arsenal de los Cruzados",
	["Crusader's Chapel"] = "Capilla de los Cruzados",
	["Crusader's Landing"] = "El Tramo del Cruzado",
	["Crusader's Outpost"] = "Avanzada de los Cruzados",
	["Crusaders' Pinnacle"] = "Pináculo de los Cruzados",
	["Crusader's Run"] = "Senda del Cruzado",
	["Crusader's Spire"] = "Espiral de los Cruzados",
	["Crusaders' Square"] = "Plaza de los Cruzados",
	Crushblow = "Machacolpe",
	["Crushcog's Arsenal"] = "Arsenal de Prensadiente",
	["Crushridge Hold"] = "Dominios de los Aplastacresta",
	Crypt = "Cripta",
	["Crypt of Forgotten Kings"] = "Cripta de los Reyes Olvidados",
	["Crypt of Remembrance"] = "Cripta de los Recuerdos",
	["Crystal Lake"] = "Lago de Cristal",
	["Crystalline Quarry"] = "Cantera Cristalina",
	["Crystalsong Forest"] = "Bosque Canto de Cristal",
	["Crystal Spine"] = "Espina de Cristal",
	["Crystalvein Mine"] = "Mina de Cristal",
	["Crystalweb Cavern"] = "Caverna Red de Cristal",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "Curiosidades y Más",
	["Cursed Depths"] = "Profundidades Malditas",
	["Cursed Hollow"] = "Hoya Maldita",
	["Cut-Throat Alley"] = "Callejón Degolladores",
	["Cyclone Summit"] = "Cima del Ciclón",
	["Dabyrie's Farmstead"] = "Granja de Dabyrie",
	["Daggercap Bay"] = "Bahía Cubredaga",
	["Daggerfen Village"] = "Aldea Dagapantano",
	["Dagger in the Dark"] = "Una Daga en la Oscuridad",
	["Daggermaw Canyon"] = "Cañón Faucedaga",
	["Dagger Pass"] = "Paso de la Daga",
	["Dais of Conquerors"] = "Estrado de los Conquistadores",
	Dalaran = "Dalaran",
	["Dalaran Arena"] = "Arena de Dalaran",
	["Dalaran City"] = "Ciudad de Dalaran",
	["Dalaran Crater"] = "Cráter de Dalaran",
	["Dalaran Floating Rocks"] = "Rocas Flotantes de Dalaran",
	["Dalaran Island"] = "Isla de Dalaran",
	["Dalaran Merchant's Bank"] = "Banco de Mercaderes de Dalaran",
	["Dalaran Sewers"] = "Cloacas de Dalaran",
	["Dalaran Visitor Center"] = "Centro de Visitantes de Dalaran",
	["Dalson's Farm"] = "Granja de Dalson",
	["Damplight Cavern"] = "Caverna Luzúmida",
	["Damplight Chamber"] = "Cámara Luzúmida",
	["Dampsoil Burrow"] = "Madriguera Fangosa",
	["Dandred's Fold"] = "Redil de Dandred",
	["Dargath's Demise"] = "Óbito de Dargath",
	["Darkbreak Cove"] = "Cala Brechascura",
	["Darkcloud Pinnacle"] = "Cumbre de la Nube Negra",
	["Darkcrest Enclave"] = "Enclave Cresta Oscura",
	["Darkcrest Shore"] = "Playa Crestanegra",
	["Dark Heart of Pandaria"] = "Corazón Oscuro de Pandaria",
	["Dark Iron Highway"] = "Ruta Hierro Negro",
	["Darkmist Cavern"] = "Cueva Niebla Negra",
	["Darkmist Ruins"] = "Ruinas Niebla Negra",
	["Darkmoon Boardwalk"] = "Paseo marítimo de la Luna Negra",
	["Darkmoon Deathmatch"] = "Combate a muerte de la Feria de la Luna Negra",
	["Darkmoon Deathmatch Pit (PH)"] = "Darkmoon Deathmatch Pit (PH)",
	["Darkmoon Faire"] = "Feria de la Luna Negra",
	["Darkmoon Island"] = "Isla Luna Negra",
	["Darkmoon Island Cave"] = "Cueva de la Isla de la Luna Negra",
	["Darkmoon Path"] = "Senda de la Luna Negra",
	["Darkmoon Pavilion"] = "Pabellón de la Feria de la Luna Negra",
	Darkshire = "Villa Oscura",
	["Darkshire Town Hall"] = "Concejo de Villa Oscura",
	Darkshore = "Costa Oscura",
	["Darkspear Hold"] = "Bastión Lanza Negra",
	["Darkspear Isle"] = "Isla Lanza Negra",
	["Darkspear Shore"] = "Costa Lanza Negra",
	["Darkspear Strand"] = "Playa Lanza Negra",
	["Darkspear Training Grounds"] = "Campo de Entrenamiento Lanza Negra",
	["Darkwhisper Gorge"] = "Garganta Negro Rumor",
	["Darkwhisper Pass"] = "Paso Negro Rumor",
	["Darnassian Base Camp"] = "Campamento Base Darnassiano",
	Darnassus = "Darnassus",
	["Darrow Hill"] = "Colinas de Darrow",
	["Darrowmere Lake"] = "Lago Darrowmere",
	Darrowshire = "Villa Darrow",
	["Darrowshire Hunting Grounds"] = "Terrenos de caza de Villa Darrow",
	["Darsok's Outpost"] = "Avanzada de Darsok",
	["Dawnchaser Retreat"] = "Retiro del Cazador del Alba",
	["Dawning Lane"] = "Calle del Alba",
	["Dawning Wood Catacombs"] = "Catacumbas del Bosque Aurora",
	["Dawnrise Expedition"] = "Expedición Alzalba",
	["Dawn's Blossom"] = "Floralba",
	["Dawnseeker Promontory"] = "Promontorio Buscalba",
	["Dawnseeker's Promontory"] = "Promontorio Buscalba",
	["Dawn's Reach"] = "Tramo del Alba",
	["Dawnstar Spire"] = "Aguja de la Estrella del Alba",
	["Dawnstar Village"] = "Poblado Estrella del Alba",
	["Daxil's Dig"] = "Excavación de Daxil",
	["D-Block"] = "Bloque D",
	["Deadeye Shore"] = "Costa de Mortojo",
	["Deadman's Crossing"] = "Cruce de la Muerte",
	["Dead Man's Hole"] = "El Agujero del Muerto",
	Deadmines = "Minas de la Muerte",
	["Deadtalker's Plateau"] = "Meseta del Espiritista",
	["Deadwind Pass"] = "Paso de la Muerte",
	["Deadwind Ravine"] = "Barranco de la Muerte",
	["Deadwood Village"] = "Aldea Muertobosque",
	["Deathbringer's Rise"] = "Alto del Libramorte",
	["Death Cultist Base Camp"] = "Campamento Cultor de la Muerte",
	["Deathforge Tower"] = "Torre de la Forja Muerta",
	Deathknell = "Camposanto",
	["Deathmatch Pavilion"] = "Pabellón de combate a muerte",
	Deatholme = "Ciudad de la Muerte",
	["Death's Breach"] = "Brecha de la Muerte",
	["Death's Door"] = "Puerta de la Muerte",
	["Death's Hand Encampment"] = "Campamento Mano de la Muerte",
	["Deathspeaker's Watch"] = "Avanzada del Portavoz de la Muerte",
	["Death's Rise"] = "Ascenso de la Muerte",
	["Death's Stand"] = "Confín de la Muerte",
	["Death's Step"] = "Grada de la Muerte",
	["Death's Watch Waystation"] = "Apeadero del Ocelo de la Muerte",
	Deathwing = "Alamuerte",
	["Deathwing's Fall"] = "Caída de Alamuerte",
	["Deep Blue Observatory"] = "Observatorio Azul Profundo",
	["Deep Elem Mine"] = "Mina de Elem",
	["Deepfin Ridge"] = "Cresta de Aleta Profunda",
	Deepholm = "Infralar",
	["Deephome Ceiling"] = "Bóveda de Infralar",
	["Deepmist Grotto"] = "Gruta Brumadensa",
	["Deeprun Tram"] = "Tranvía Subterráneo",
	["Deepwater Tavern"] = "Mesón Aguahonda",
	["Deepwind Gorge"] = "Cañón del Céfiro",
	["Defense of the Alehouse"] = "Defensa de la Taberna",
	["Defense Of The Ale House BG"] = "CDB de Defensa de la Taberna",
	["Defias Hideout"] = "Ladronera de los Defias",
	["Defiler's Den"] = "Guarida de los Rapiñadores",
	["D.E.H.T.A. Encampment"] = "Campamento D.E.H.T.A.",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "Barranco del Demonio",
	["Demon Fall Ridge"] = "Cresta del Demonio",
	["Demont's Place"] = "Paraje de Demont",
	["Den of Defiance"] = "Guarida del Desafío",
	["Den of Dying"] = "Cubil de los Moribundos",
	["Den of Haal'esh"] = "Cubil de Haal'esh",
	["Den of Iniquity"] = "Cubil de Iniquidad",
	["Den of Mortal Delights"] = "Guarida de los Placeres Mortales",
	["Den of Sorrow"] = "Guarida del Pesar",
	["Den of Sseratus"] = "Cubil de Sseratus",
	["Den of the Caller"] = "Cubil del Clamor",
	["Den of the Devourer"] = "Cubil del Devorador",
	["Den of the Disciples"] = "Cubil de los Discípulos",
	["Den of the Unholy"] = "Cubil de los Impuros",
	["Derelict Caravan"] = "Caravana Derelicta",
	["Derelict Manor"] = "Mansión Derelicta",
	["Derelict Strand"] = "Playa Derelicta",
	["Designer Island"] = "Isla del Diseñador",
	Desolace = "Desolace",
	["Desolation Hold"] = "Bastión de la Desolación",
	["Detention Block"] = "Bloque de Detención",
	["Development Land"] = "Tierra de Desarrollo",
	["Diamondhead River"] = "Río Diamante",
	["Diamond Island"] = "Isla Diamante",
	["Dig One"] = "Excavación 1",
	["Dig Three"] = "Excavación 3",
	["Dig Two"] = "Excavación 2",
	["Direforge Hill"] = "Cerro Fraguaferoz",
	["Direhorn Post"] = "Puesto Cuernoatroz",
	["Dire Maul"] = "La Masacre",
	["Dire Maul - Capital Gardens Entrance"] = "La Masacre: Entrada de los Jardines de la Capital",
	["Dire Maul - East"] = "La Masacre: Este",
	["Dire Maul - Gordok Commons Entrance"] = "La Masacre: Entrada del Ágora de Gordok",
	["Dire Maul - North"] = "La Masacre: Norte",
	["Dire Maul - Warpwood Quarter Entrance"] = "La Masacre: Entrada del Barrio Alabeo",
	["Dire Maul - West"] = "La Masacre: Oeste",
	Diremoor = "Malandanza",
	["Dire Strait"] = "Estrecho Temible",
	["Disciple's Enclave"] = "Enclave del Discípulo",
	Docks = "Muelles",
	["Dojani River"] = "Río Dojani",
	Dolanaar = "Dolanaar",
	["Dome Balrissa"] = "Cúpula Balrissa",
	["Domination Point"] = "Punto de Dominio",
	["Donna's Kitty Shack"] = "Casa de gatitos de Donna",
	["DO NOT USE"] = "DO NOT USE",
	["Dookin' Grounds"] = "Campo del Miko",
	["Doom's Vigil"] = "Vigilia de la Fatalidad",
	["Dorian's Outpost"] = "Avanzada de Dorian",
	["Draco'dar"] = "Draco'dar",
	["Draenei Ruins"] = "Ruinas Draenei",
	["Draenethyst Mine"] = "Mina Draenetista",
	["Draenil'dur Village"] = "Aldea Draenil'dur",
	Dragonblight = "Cementerio de Dragones",
	["Dragonflayer Pens"] = "Cercado de Desuelladragones",
	["Dragonmaw Base Camp"] = "Campamento Faucedraco",
	["Dragonmaw Flag Room"] = "Sala de la Bandera Faucedraco",
	["Dragonmaw Forge"] = "Forja Faucedraco",
	["Dragonmaw Fortress"] = "Fortaleza Faucedraco",
	["Dragonmaw Garrison"] = "Cuartel Faucedraco",
	["Dragonmaw Gates"] = "Puertas Faucedraco",
	["Dragonmaw Pass"] = "Paso Faucedraco",
	["Dragonmaw Port"] = "Puerto Faucedraco",
	["Dragonmaw Skyway"] = "Ruta Aérea Faucedraco",
	["Dragonmaw Stronghold"] = "Bastión Faucedraco",
	["Dragons' End"] = "Cabo del Dragón",
	["Dragon's Fall"] = "Caída del Dragón",
	["Dragon's Mouth"] = "Boca del Dragón",
	["Dragon Soul"] = "Alma de Dragón",
	["Dragon Soul Raid - East Sarlac"] = "Banda Alma de Dragón - Este de Sarlac",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Banda de Alma de Dragón - Base del Templo del Reposo del Dragón",
	["Dragonspine Peaks"] = "Cumbres Espinazo de Dragón",
	["Dragonspine Ridge"] = "Cresta Espinazo de Dragón",
	["Dragonspine Tributary"] = "Afluente del Espinazo del Dragón",
	["Dragonspire Hall"] = "Sala Dracopico",
	["Drak'Agal"] = "Drak'Agal",
	["Draka's Fury"] = "Furia de Draka",
	["Drak'atal Passage"] = "Pasaje de Drak'atal",
	["Drakil'jin Ruins"] = "Ruinas de Drakil'jin",
	["Drak'Mabwa"] = "Drak'Mabwa",
	["Drak'Mar Lake"] = "Lago Drak'Mar",
	["Draknid Lair"] = "Guarida Dráknida",
	["Drak'Sotra"] = "Drak'Sotra",
	["Drak'Sotra Fields"] = "Campos Drak'Sotra",
	["Drak'Tharon Keep"] = "Fortaleza de Drak'Tharon",
	["Drak'Tharon Keep Entrance"] = "Entrada de la Fortaleza de Drak'Tharon",
	["Drak'Tharon Overlook"] = "Mirador de Drak'Tharon",
	["Drak'ural"] = "Drak'ural",
	["Dread Clutch"] = "Guarida del Terror",
	["Dread Expanse"] = "Extensión Tremebunda",
	["Dreadmaul Furnace"] = "Horno Machacamiedo",
	["Dreadmaul Hold"] = "Bastión Machacamiedo",
	["Dreadmaul Post"] = "Puesto Machacamiedo",
	["Dreadmaul Rock"] = "Roca Machacamiedo",
	["Dreadmist Camp"] = "Campamento Calígine",
	["Dreadmist Den"] = "Cubil Calígine",
	["Dreadmist Peak"] = "Cima Calígine",
	["Dreadmurk Shore"] = "Playa Tenebruma",
	["Dread Terrace"] = "Tribuna del Terror",
	["Dread Wastes"] = "Desierto del Pavor",
	["Dreadwatch Outpost"] = "Avanzada Velaspanto",
	["Dream Bough"] = "Rama Oniria",
	["Dreamer's Pavilion"] = "Pabellón del Soñador",
	["Dreamer's Rest"] = "Reposo de la Soñadora",
	["Dreamer's Rock"] = "Roca del Soñador",
	Drudgetown = "La Barriada",
	["Drygulch Ravine"] = "Barranco Árido",
	["Drywhisker Gorge"] = "Cañón Mostacho Seco",
	["Dubra'Jin"] = "Dubra'Jin",
	["Dun Algaz"] = "Dun Algaz",
	["Dun Argol"] = "Dun Argol",
	["Dun Baldar"] = "Dun Baldar",
	["Dun Baldar Pass"] = "Paso de Dun Baldar",
	["Dun Baldar Tunnel"] = "Túnel de Dun Baldar",
	["Dunemaul Compound"] = "Base Machacaduna",
	["Dunemaul Recruitment Camp"] = "Campo de Reclutamiento Machacaduna",
	["Dun Garok"] = "Dun Garok",
	["Dun Mandarr"] = "Dun Mandarr",
	["Dun Modr"] = "Dun Modr",
	["Dun Morogh"] = "Dun Morogh",
	["Dun Niffelem"] = "Dun Niffelem",
	["Dunwald Holdout"] = "Resistencia Montocre",
	["Dunwald Hovel"] = "Cobertizo Montocre",
	["Dunwald Market Row"] = "Fila del Mercado Montocre",
	["Dunwald Ruins"] = "Ruinas Montocre",
	["Dunwald Town Square"] = "Plaza Principal Montocre",
	["Durnholde Keep"] = "Castillo de Durnholde",
	Durotar = "Durotar",
	Duskhaven = "Refugio del Ocaso",
	["Duskhowl Den"] = "Cubil Aúllaocaso",
	["Dusklight Bridge"] = "Puente del Anochecer",
	["Dusklight Hollow"] = "Cuenca del Anochecer",
	["Duskmist Shore"] = "Costa Noctuniebla",
	["Duskroot Fen"] = "Fangal Raíz Negra",
	["Duskwither Grounds"] = "Tierras Ocaso Marchito",
	["Duskwither Spire"] = "Aguja Ocaso Marchito",
	Duskwood = "Bosque del Ocaso",
	["Dustback Gorge"] = "Despeñadero Loma Agreste",
	["Dustbelch Grotto"] = "Gruta Rotapolvo",
	["Dustfire Valley"] = "Valle Polvofuego",
	["Dustquill Ravine"] = "Barranco Pluma Polvorienta",
	["Dustwallow Bay"] = "Bahía Revolcafango",
	["Dustwallow Marsh"] = "Marjal Revolcafango",
	["Dustwind Cave"] = "Cueva Viento Seco",
	["Dustwind Dig"] = "Excavación Viento Seco",
	["Dustwind Gulch"] = "Barranco Viento Seco",
	["Dwarven District"] = "Distrito de los Enanos",
	["Eagle's Eye"] = "Ojo de Águila",
	["Earthshatter Cavern"] = "Caverna Rompetierra",
	["Earth Song Falls"] = "Cascadas del Canto de la Tierra",
	["Earth Song Gate"] = "Puerta del Canto de la Tierra",
	["Eastern Bridge"] = "Puente Oriental",
	["Eastern Kingdoms"] = "Reinos del Este",
	["Eastern Plaguelands"] = "Tierras de la Peste del Este",
	["Eastern Strand"] = "Playa del Este",
	["East Garrison"] = "Cuartel del Este",
	["Eastmoon Ruins"] = "Ruinas de Lunaeste",
	["East Pavilion"] = "Pabellón este",
	["East Pillar"] = "Pilar Este",
	["Eastpoint Tower"] = "Torre Oriental",
	["East Sanctum"] = "Sagrario del Este",
	["Eastspark Workshop"] = "Taller Chispa Oriental",
	["East Spire"] = "Fortín del Este",
	["East Supply Caravan"] = "Caravana de Provisiones del Este",
	["Eastvale Logging Camp"] = "Aserradero de la Vega del Este",
	["Eastwall Gate"] = "Puerta de la Muralla del Este",
	["Eastwall Tower"] = "Torre de la Muralla del Este",
	["Eastwind Rest"] = "Reposo Viento del Este",
	["Eastwind Shore"] = "Playa Viento Este",
	["Ebon Hold"] = "El Bastión de Ébano",
	["Ebon Watch"] = "Puesto de Vigilancia de Ébano",
	["Echo Cove"] = "Cala del Eco",
	["Echo Isles"] = "Islas del Eco",
	["Echomok Cavern"] = "Cueva Echomok",
	["Echo Reach"] = "Risco del Eco",
	["Echo Ridge Mine"] = "Mina del Eco",
	["Eclipse Point"] = "Punta Eclipse",
	["Eclipsion Fields"] = "Campos Eclipsianos",
	["Eco-Dome Farfield"] = "Ecodomo Campolejano",
	["Eco-Dome Midrealm"] = "Ecodomo de la Tierra Media",
	["Eco-Dome Skyperch"] = "Ecodomo Altocielo",
	["Eco-Dome Sutheron"] = "Ecodomo Sutheron",
	["Elder Rise"] = "Alto de los Ancestros",
	["Elders' Square"] = "Plaza de los Ancestros",
	["Eldreth Row"] = "Pasaje de Eldreth",
	["Eldritch Heights"] = "Cumbres Fantasmales",
	["Elemental Plateau"] = "Meseta Elemental",
	["Elementium Depths"] = "Profundidades de Elementium",
	Elevator = "Elevador",
	["Elrendar Crossing"] = "Cruce Elrendar",
	["Elrendar Falls"] = "Cascadas Elrendar",
	["Elrendar River"] = "Río Elrendar",
	["Elwynn Forest"] = "Bosque de Elwynn",
	["Ember Clutch"] = "Encierro Ámbar",
	Emberglade = "El Claro de Ascuas",
	["Ember Spear Tower"] = "Torre Lanza Ámbar",
	["Emberstone Mine"] = "Mina Piedra Ígnea",
	["Emberstone Village"] = "Aldea Piedra Ígnea",
	["Emberstrife's Den"] = "Cubil de Brasaliza",
	["Emerald Dragonshrine"] = "Santuario de Dragones Esmeralda",
	["Emerald Dream"] = "Sueño Esmeralda",
	["Emerald Forest"] = "Bosque Esmeralda",
	["Emerald Sanctuary"] = "Santuario Esmeralda",
	["Emperor Rikktik's Rest"] = "Descanso del Emperador Rikktik",
	["Emperor's Omen"] = "Augurio del Emperador",
	["Emperor's Reach"] = "Tramo del Emperador",
	["End Time"] = "Fin de los Días",
	["Engineering Labs"] = "Laboratorios de Ingeniería",
	["Engineering Labs "] = "Laboratorios de Ingeniería",
	["Engine of Nalak'sha"] = "Motor de Nalak'sha",
	["Engine of the Makers"] = "Motor de los Creadores",
	["Entryway of Time"] = "Umbral del Tiempo",
	["Ethel Rethor"] = "Ethel Rethor",
	["Ethereal Corridor"] = "Galería Etérea",
	["Ethereum Staging Grounds"] = "Punto de Escala de El Etereum",
	["Evergreen Trading Post"] = "Puesto de Venta de Siempreverde",
	Evergrove = "Soto Eterno",
	Everlook = "Vista Eterna",
	["Eversong - Duskwither Teleport"] = "Bosque Canción Eterna",
	["Eversong Woods"] = "Bosque Canción Eterna",
	["Excavation Center"] = "Centro de Excavación",
	["Excavation Lift"] = "Elevador de la Excavación",
	["Exclamation Point"] = "Punta del Grito",
	["Expedition Armory"] = "Armería de Expedición",
	["Expedition Base Camp"] = "Campamento Base de la Expedición",
	["Expedition Point"] = "Punta de Expedición",
	["Explorers' League Digsite"] = "Excavación de la Liga de Expedicionarios",
	["Explorers' League Outpost"] = "Avanzada de la Liga de Expedicionarios",
	["Exposition Pavilion"] = "Pabellón de exposición",
	["Eye of Eternity"] = "Ojo de la Eternidad",
	["Eye of the Storm"] = "Ojo de la Tormenta",
	["Fairbreeze Village"] = "Aldea Brisa Pura",
	["Fairbridge Strand"] = "Playa Puentegrato",
	["Falcon Watch"] = "Avanzada del Halcón",
	["Falconwing Inn"] = "Posada Alalcón",
	["Falconwing Square"] = "Plaza Alalcón",
	["Faldir's Cove"] = "Cala de Faldir",
	["Falfarren River"] = "Río Falfarren",
	["Fallen Sky Lake"] = "Lago Cielo Estrellado",
	["Fallen Sky Ridge"] = "Cresta Cielo Estrellado",
	["Fallen Temple of Ahn'kahet"] = "Templo Caído de Ahn'kahet",
	["Fall of Return"] = "Cascada del Retorno",
	["Fallowmere Inn"] = "Taberna de Merobarbecho",
	["Fallow Sanctuary"] = "Retiro Fangoso",
	["Falls of Ymiron"] = "Cataratas de Ymiron",
	["Fallsong Village"] = "Poblado Canción de Otoño",
	["Falthrien Academy"] = "Academia Falthrien",
	Familiars = "Familiares",
	["Faol's Rest"] = "Tumba de Faol",
	["Fargaze Mesa"] = "Colina de Vistalonga",
	["Fargodeep Mine"] = "Mina Abisal",
	Farm = "Granja",
	Farshire = "Lindeallá",
	["Farshire Fields"] = "Campos de Lindeallá",
	["Farshire Lighthouse"] = "Faro de Lindeallá",
	["Farshire Mine"] = "Mina de Lindeallá",
	["Farson Hold"] = "Fortaleza de Farson",
	["Farstrider Enclave"] = "Enclave del Errante",
	["Farstrider Lodge"] = "Cabaña del Errante",
	["Farstrider Retreat"] = "El Retiro del Errante",
	["Farstriders' Enclave"] = "Enclave del Errante",
	["Farstriders' Square"] = "Plaza del Errante",
	["Farwatcher's Glen"] = "Cañada del Vigiaconfines",
	["Farwatch Overlook"] = "Alto de Vigilancia",
	["Far Watch Post"] = "Avanzada del Puente",
	["Fear Clutch"] = "Guarida del Miedo",
	["Featherbeard's Hovel"] = "Cobertizo de Barbapluma",
	Feathermoon = "Plumaluna",
	["Feathermoon Stronghold"] = "Bastión Plumaluna",
	["Fe-Feng Village"] = "Poblado Fe-Feng",
	["Felfire Hill"] = "Cerro Lumbrevil",
	["Felpaw Village"] = "Poblado Zarpavil",
	["Fel Reaver Ruins"] = "Ruinas del Atracador Vil",
	["Fel Rock"] = "Roca Mácula",
	["Felspark Ravine"] = "Barranco Llama Infernal",
	["Felstone Field"] = "Campo de Piedramácula",
	Felwood = "Frondavil",
	["Fenris Isle"] = "Isla de Fenris",
	["Fenris Keep"] = "Castillo de Fenris",
	Feralas = "Feralas",
	["Feralfen Village"] = "Aldea Feropantano",
	["Feral Scar Vale"] = "Vega Cicatriz Feral",
	["Festering Pools"] = "Pozas Purulentas",
	["Festival Lane"] = "Calle del Festival",
	["Feth's Way"] = "Camino de Feth",
	["Field of Korja"] = "Tierra de Korja",
	["Field of Strife"] = "Tierra de Disputa",
	["Fields of Blood"] = "Campos de Sangre",
	["Fields of Honor"] = "Campos de Honor",
	["Fields of Niuzao"] = "Campos de Niuzao",
	Filming = "Grabando",
	["Final Gate - Mogu Island Progression Scenario"] = "Puerta final - Gesta de progresión de la isla mogu",
	["Firebeard Cemetery"] = "Cementerio Barbafuego",
	["Firebeard's Patrol"] = "Patrulla de Barbafuego",
	["Firebough Nook"] = "Rincón Tallo Ardiente",
	["Fire Camp Bataar"] = "Campamento Bataar",
	["Fire Camp Gai-Cho"] = "Campamento Gai-Cho",
	["Fire Camp Ordo"] = "Campamento de Ordo",
	["Fire Camp Osul"] = "Campamento Osul",
	["Fire Camp Ruqin"] = "Campamento Ruqin",
	["Fire Camp Yongqi"] = "Campamento Yongqi",
	["Firegut Furnace"] = "Horno Pirontraña",
	Firelands = "Tierras de Fuego",
	["Firelands Forgeworks"] = "Forja de las Tierras de Fuego",
	["Firelands Hatchery"] = "Criadero de las Tierras de Fuego",
	["Firelands Terrain 2"] = "Firelands Terrain 2",
	["Fireplume Peak"] = "Cima Pluma de Fuego",
	["Fire Plume Ridge"] = "Cresta del Penacho en Llamas",
	["Fireplume Trench"] = "Zanja de Penacho en Llamas",
	["Fire Scar Shrine"] = "Santuario de la Escara",
	["Fire Stone Mesa"] = "Mesa de La Piedra de Fuego",
	["Firestone Point"] = "Punta Piedra de Fuego",
	["Firewatch Ridge"] = "Cresta Vigía",
	["Firewing Point"] = "Alto Ala de Fuego",
	["First Bank of Kezan"] = "Primer Banco de Kezan",
	["First Legion Forward Camp"] = "Puesto de Avanzada de la Primera Legión",
	["First to Your Aid"] = "Te Auxiliamos los Primeros",
	["Fishing Village"] = "Aldea Pesquera",
	["Fizzcrank Airstrip"] = "Pista de Aterrizaje de Palanqueta",
	["Fizzcrank Pumping Station"] = "Estación de Bombeo de Palanqueta",
	["Fizzle & Pozzik's Speedbarge"] = "Barcódromo de Fizzle y Pozzik",
	["Fjorn's Anvil"] = "Yunque de Fjorn",
	Flamebreach = "Brecha Flama",
	["Flame Crest"] = "Peñasco Llamarada",
	["Flamestar Post"] = "Puesto Llamaestrella",
	["Flamewatch Tower"] = "Torre de la Guardia en Llamas",
	["Flavor - Stormwind Harbor - Stop"] = "Flavor - Stormwind Harbor - Stop",
	["Fleshrender's Workshop"] = "Taller del Sacrificador",
	["Foothold Citadel"] = "Ciudadela Garrida",
	["Footman's Armory"] = "Arsenal de los Soldados",
	["Force Interior"] = "Fuerza Interior",
	["Fordragon Hold"] = "Bastión de Fordragón",
	["Forest Heart"] = "Corazón del Bosque",
	["Forest's Edge"] = "Linde del bosque",
	["Forest's Edge Post"] = "Puesto Fronterizo del Bosque",
	["Forest Song"] = "Canción del Bosque",
	["Forge Base: Gehenna"] = "Base Forja: Gehenna",
	["Forge Base: Oblivion"] = "Base Forja: Olvido",
	["Forge Camp: Anger"] = "Campamento Forja: Inquina",
	["Forge Camp: Fear"] = "Campamento Forja: Miedo",
	["Forge Camp: Hate"] = "Campamento Forja: Odio",
	["Forge Camp: Mageddon"] = "Campamento Forja: Mageddon",
	["Forge Camp: Rage"] = "Campamento Forja: Ira",
	["Forge Camp: Terror"] = "Campamento Forja: Terror",
	["Forge Camp: Wrath"] = "Campamento Forja: Cólera",
	["Forge of Fate"] = "Forja del Destino",
	["Forge of the Endless"] = "Forja del Infinito",
	["Forgewright's Tomb"] = "Tumba de Forjador",
	["Forgotten Depths"] = "Abismo de la Desidia",
	["Forgotten Hill"] = "Colina del Olvido",
	["Forgotten Mire"] = "Pantano Olvidado",
	["Forgotten Passageway"] = "Pasadizo Olvidado",
	["Forlorn Cloister"] = "Claustro Abandonado",
	["Forlorn Hut"] = "Cabaña Abandonada",
	["Forlorn Ridge"] = "Loma Desolada",
	["Forlorn Rowe"] = "Loma Inhóspita",
	["Forlorn Spire"] = "Cumbre Inhóspita",
	["Forlorn Woods"] = "El Bosque Desolado",
	["Formation Grounds"] = "Campo de Formación",
	["Forsaken Forward Command"] = "Mando Avanzado Renegado",
	["Forsaken High Command"] = "Alto Mando Renegado",
	["Forsaken Rear Guard"] = "Puesto de Retaguardia Renegado",
	["Fort Livingston"] = "Fuerte Livingston",
	["Fort Silverback"] = "Fuerte Lomoblanco",
	["Fort Triumph"] = "Fuerte Triunfo",
	["Fortune's Fist"] = "Puño de la Fortuna",
	["Fort Wildervar"] = "Fuerte Vildervar",
	["Forward Assault Camp"] = "Campamento de Asalto",
	["Forward Command"] = "Mando de Vanguardia",
	["Foulspore Cavern"] = "Gruta de la Espora Fétida",
	["Foulspore Pools"] = "Pozas de la Espora Fétida",
	["Fountain of the Everseeing"] = "Fuente de la Visión Eterna",
	["Fox Grove"] = "Arboleda del Zorro",
	["Fractured Front"] = "Frente Fracturado",
	["Frayfeather Highlands"] = "Tierras Altas de Plumavieja",
	["Fray Island"] = "Isla de Batalla",
	["Frazzlecraz Motherlode"] = "Filón Catacroquer",
	["Freewind Post"] = "Poblado Viento Libre",
	["Frenzyheart Hill"] = "Colina Corazón Frenético",
	["Frenzyheart River"] = "Río Corazón Frenético",
	["Frigid Breach"] = "Brecha Gélida",
	["Frostblade Pass"] = "Paso Filoescarcha",
	["Frostblade Peak"] = "Pico Filoescarcha",
	["Frostclaw Den"] = "Cubil Garrascarcha",
	["Frost Dagger Pass"] = "Paso de la Daga Escarcha",
	["Frostfield Lake"] = "Lago Campo de Escarcha",
	["Frostfire Hot Springs"] = "Baños de Fuego de Escarcha",
	["Frostfloe Deep"] = "Hondonada Témpano Gélido",
	["Frostgrip's Hollow"] = "Hondonada Puño Helado",
	Frosthold = "Fuerte Escarcha",
	["Frosthowl Cavern"] = "Caverna Aúllaescarcha",
	["Frostmane Front"] = "Frente de Peloescarcha",
	["Frostmane Hold"] = "Poblado Peloescarcha",
	["Frostmane Hovel"] = "Cobertizo Peloescarcha",
	["Frostmane Retreat"] = "Refugio Peloescarcha",
	Frostmourne = "Agonía de Escarcha",
	["Frostmourne Cavern"] = "Caverna Agonía de Escarcha",
	["Frostsaber Rock"] = "Roca Sable de Hielo",
	["Frostwhisper Gorge"] = "Cañón Levescarcha",
	["Frostwing Halls"] = "Las Cámaras de Alaescarcha",
	["Frostwolf Graveyard"] = "Cementerio Lobo Gélido",
	["Frostwolf Keep"] = "Bastión Lobo Gélido",
	["Frostwolf Pass"] = "Paso Lobo Gélido",
	["Frostwolf Tunnel"] = "Túnel de Lobo Gélido",
	["Frostwolf Village"] = "Aldea Lobo Gélido",
	["Frozen Reach"] = "Tramo Helado",
	["Fungal Deep"] = "Profundidades Fungal",
	["Fungal Rock"] = "Roca Fungal",
	["Funggor Cavern"] = "Caverna Funggor",
	["Furien's Post"] = "Puesto de Furien",
	["Furlbrow's Pumpkin Farm"] = "Plantación de Calabazas de Cejade",
	["Furnace of Hate"] = "Horno del Odio",
	["Furywing's Perch"] = "Nido de Alafuria",
	Fuselight = "El Diodo",
	["Fuselight-by-the-Sea"] = "El Diodo de Mar",
	["Fu's Pond"] = "Charca de Fu",
	Gadgetzan = "Gadgetzan",
	["Gahrron's Withering"] = "Gangrena de Gahrron",
	["Gai-Cho Battlefield"] = "Frente Gai-Cho",
	["Galak Hold"] = "Dominios Galak",
	["Galakrond's Rest"] = "Reposo de Galakrond",
	["Galardell Valley"] = "Valle de Galardell",
	["Galen's Fall"] = "Caída de Galen",
	["Galerek's Remorse"] = "Remordimiento de Galerek",
	["Galewatch Lighthouse"] = "Faro Velavento",
	["Gallery of Treasures"] = "Galería de los Tesoros",
	["Gallows' Corner"] = "Camino de la Horca",
	["Gallows' End Tavern"] = "Mesón La Horca",
	["Gallywix Docks"] = "Muelles de Gallywix",
	["Gallywix Labor Mine"] = "Mina de Trabajos Forzados de Gallywix",
	["Gallywix Pleasure Palace"] = "Palacete de Gallywix",
	["Gallywix's Villa"] = "Chalet de Gallywix",
	["Gallywix's Yacht"] = "Yate de Gallywix",
	["Galus' Chamber"] = "Cámara de Galus",
	["Gamesman's Hall"] = "Sala del Tablero",
	Gammoth = "Gammoth",
	["Gao-Ran Battlefront"] = "Frente Gao-Ran",
	Garadar = "Garadar",
	["Gar'gol's Hovel"] = "Casucha de Gar'gol",
	Garm = "Garm",
	["Garm's Bane"] = "Pesadilla de Garm",
	["Garm's Rise"] = "Alto de Garm",
	["Garren's Haunt"] = "Granja de Garren",
	["Garrison Armory"] = "Arsenal del Cuartel",
	["Garrosh'ar Advance"] = "Avance Garrosh'ar",
	["Garrosh'ar Point"] = "Puesto Garrosh'ar",
	["Garrosh's Landing"] = "Desembarco de Garrosh",
	["Garvan's Reef"] = "Arrecife de Garvan",
	["Gate of Echoes"] = "Puerta de los Ecos",
	["Gate of Endless Spring"] = "Puerta de la Primavera Eterna",
	["Gate of Hamatep"] = "Puerta de Hamatep",
	["Gate of Lightning"] = "Puerta de los Rayos",
	["Gate of the August Celestials"] = "Puerta de los Augustos Celestiales",
	["Gate of the Blue Sapphire"] = "Puerta del Zafiro Azul",
	["Gate of the Green Emerald"] = "Puerta de la Esmeralda Verde",
	["Gate of the Purple Amethyst"] = "Puerta de la Amatista Púrpura",
	["Gate of the Red Sun"] = "Puerta del Sol Rojo",
	["Gate of the Setting Sun"] = "Puerta del Sol Poniente",
	["Gate of the Yellow Moon"] = "Puerta de la Luna Amarilla",
	["Gates of Ahn'Qiraj"] = "Puerta de Ahn'Qiraj",
	["Gates of Ironforge"] = "Puertas de Forjaz",
	["Gates of Sothann"] = "Puertas de Sothann",
	["Gauntlet of Flame"] = "Guantelete de Llamas",
	["Gavin's Naze"] = "Saliente de Gavin",
	["Geezle's Camp"] = "Campamento de Geezle",
	["Gelkis Village"] = "Poblado Gelkis",
	["General Goods"] = "Víveres",
	["General's Terrace"] = "Bancal del General",
	["Ghostblade Post"] = "Puesto del Filo Fantasmal",
	Ghostlands = "Tierras Fantasma",
	["Ghost Walker Post"] = "Campamento del Espíritu Errante",
	["Giant's Run"] = "El Paso del Gigante",
	["Giants' Run"] = "El Paso del Gigante",
	["Gilded Fan"] = "El Abanico Dorado",
	["Gillijim's Isle"] = "Isla de Gillijim",
	["Gilnean Coast"] = "Costa de Gilneas",
	["Gilnean Stronghold"] = "Fortaleza de Gilneas",
	Gilneas = "Gilneas",
	Gilneas2 = "Gilneas2",
	["Gilneas City"] = "Ciudad de Gilneas",
	["Gilneas (Do Not Reuse)"] = "Gilneas",
	["Gilneas Liberation Front Base Camp"] = "Campamento base del Frente de Liberación de Gilneas",
	GilneasPhase1 = "GilneasPhase1",
	GilneasPhase2 = "GilneasPhase2",
	["Gimorak's Den"] = "Guarida de Gimorak",
	Gjalerbron = "Gjalerbron",
	Gjalerhorn = "Gjalercorn",
	["Glacial Falls"] = "Cascadas Glaciales",
	["Glimmer Bay"] = "Bahía Titileo",
	["Glimmerdeep Gorge"] = "Barranco Brillohondo",
	["Glittering Strand"] = "Orilla Resplandeciente",
	["Glopgut's Hollow"] = "Foso Tripal",
	["Glorious Goods"] = "Objetos Gloriosos",
	Glory = "Gloria",
	["GM Island"] = "Isla de los MJ",
	["Gnarlpine Hold"] = "Tierras de los Tuercepinos",
	["Gnaws' Boneyard"] = "Fosa de Bocados",
	Gnomeregan = "Gnomeregan",
	["Gobline Mine"] = "Mina Goblin",
	["Goblin Foundry"] = "Fundición Goblin",
	["Goblin Mine"] = "Mina Goblin",
	["Goblin Slums"] = "Suburbios Goblin",
	["Gokk'lok's Grotto"] = "Gruta de Gokk'lok",
	["Gokk'lok Shallows"] = "Arrecifes Gokk'lok",
	["Golakka Hot Springs"] = "Baños de Golakka",
	["Gol'Bolar Quarry"] = "Cantera de Gol'Bolar",
	["Gol'Bolar Quarry Mine"] = "Cantera de Gol'Bolar",
	["Gold Coast Quarry"] = "Mina de la Costa del Oro",
	["Goldenbough Pass"] = "Desfiladero Ramadorada",
	["Goldenmist Village"] = "Aldea Bruma Dorada",
	["Golden Strand"] = "La Ensenada Dorada",
	["Gold Mine"] = "Mina de oro",
	["Gold Road"] = "Camino del Oro",
	["Gold Rush BG"] = "CDB de Fiebre del Oro",
	Goldshire = "Villadorada",
	["Goldtooth's Den"] = "Cubil de Dientes de Oro",
	["Goodgrub Smoking Pit"] = "Foso de Humo de Buenazampa",
	["Gordok's Seat"] = "Trono de Gordok",
	["Gordunni Outpost"] = "Avanzada Gordunni",
	["Gorefiend's Vigil"] = "Vigilia de Sanguino",
	["Gor'gaz Outpost"] = "Avanzada Gor'gaz",
	Gornia = "Gornia",
	["Gorrok's Lament"] = "Lamento de Gorrok",
	["Gorshak War Camp"] = "Campamento de Guerra Gorshak",
	["Go'Shek Farm"] = "Granja Go'shek",
	["Grain Cellar"] = "Almacén de Grano",
	["Grand Courtyard"] = "Gran Patio",
	["Grand Magister's Asylum"] = "Asilo del Gran Magister",
	["Grand Overlook"] = "Gran Mirador",
	["Grand Promenade"] = "Gran Paseo",
	["Grangol'var Village"] = "Poblado Grangol'var",
	["Granite Springs"] = "Manantial de Granito",
	["Grassy Cline"] = "Vega Escarpada",
	["Greatwood Vale"] = "Vega del Gran Bosque",
	["Greengill Coast"] = "Costa Branquia Verde",
	["Greenpaw Village"] = "Poblado Zarpaverde",
	["Greenstone Dojo"] = "Dojo de Verdemar",
	["Greenstone Inn"] = "Posada de Verdemar",
	["Greenstone Masons' Quarter"] = "Barrio de Canteros de Verdemar",
	["Greenstone Quarry"] = "Cantera Verdemar",
	["Greenstone Village"] = "Aldea Verdemar",
	["Greenwarden's Grove"] = "Arboleda del Guardaverde",
	["Greymane Court"] = "Patio de Cringris",
	["Greymane Manor"] = "Mansión de Cringris",
	["Greymist Firth"] = "Ría Brumagris",
	["Grim Batol"] = "Grim Batol",
	["Grim Batol Entrance"] = "Entrada de Grim Batol",
	["Grimesilt Dig Site"] = "Excavación de Limugre",
	["Grimtotem Compound"] = "Dominios Tótem Siniestro",
	["Grimtotem Post"] = "Poblado Tótem Siniestro",
	Grishnath = "Grishnath",
	Grizzlemaw = "Fauceparda",
	["Grizzlepaw Ridge"] = "Fuerte Zarpagris",
	["Grizzly Hills"] = "Colinas Pardas",
	["Grol'dom Farm"] = "Granja de Grol'dom",
	["Grolluk's Grave"] = "Tumba de Grolluk",
	["Grom'arsh Crash-Site"] = "Lugar del accidente de Grom'arsh",
	["Grom'gol"] = "Grom'gol",
	["Grom'gol Base Camp"] = "Campamento Grom'gol",
	["Grommash Hold"] = "Fuerte Grommash",
	["Grookin Hill"] = "Cerro Makaku",
	["Grosh'gok Compound"] = "Dominios Grosh'gok",
	["Grove of Aessina"] = "Arboleda de Aessina",
	["Grove of Falling Blossoms"] = "La Arboleda Florida",
	["Grove of the Ancients"] = "Páramo de los Ancianos",
	["Growless Cave"] = "Caverna Estrecha",
	["Gruul's Lair"] = "Guarida de Gruul",
	["Gryphon Roost"] = "Percha de grifo",
	["Guardian's Library"] = "Biblioteca del Guardián",
	Gundrak = "Gundrak",
	["Gundrak Entrance"] = "Entrada de Gundrak",
	["Gunstan's Dig"] = "Excavación de Dig",
	["Gunstan's Post"] = "Puesto de Gunstan",
	["Gunther's Retreat"] = "Refugio de Gunther",
	["Guo-Lai Halls"] = "Salas de Guo-Lai",
	["Guo-Lai Ritual Chamber"] = "Cámara Ritual de Guo-Lai",
	["Guo-Lai Vault"] = "Cámara de Guo-Lai",
	["Gurboggle's Ledge"] = "Saliente de Guraturdido",
	["Gurubashi Arena"] = "Arena Gurubashi",
	["Gyro-Plank Bridge"] = "Puente Girolámina",
	["Haal'eshi Gorge"] = "Garganta Haal'eshi",
	["Hadronox's Lair"] = "Guarida de Hadronox",
	["Hailwood Marsh"] = "Pantano Bosque del Pedrisco",
	Halaa = "Halaa",
	["Halaani Basin"] = "Cuenca Halaani",
	["Halcyon Egress"] = "Egreso Próspero",
	["Haldarr Encampment"] = "Campamento Haldarr",
	Halfhill = "El Alcor",
	Halgrind = "Haltorboll",
	["Hall of Arms"] = "Sala de Armas",
	["Hall of Binding"] = "Sala de Vínculos",
	["Hall of Blackhand"] = "Sala de Puño Negro",
	["Hall of Blades"] = "Sala de las Espadas",
	["Hall of Bones"] = "Sala de los Huesos",
	["Hall of Champions"] = "Sala de los Campeones",
	["Hall of Command"] = "Sala de Mando",
	["Hall of Crafting"] = "Sala de los Oficios",
	["Hall of Departure"] = "Cámara de Partida",
	["Hall of Explorers"] = "Sala de los Expedicionarios",
	["Hall of Faces"] = "Sala de los Rostros",
	["Hall of Horrors"] = "Cámara de los Horrores",
	["Hall of Illusions"] = "Sala de las Ilusiones",
	["Hall of Kings"] = "Cámara de los Reyes",
	["Hall of Legends"] = "Sala de las Leyendas",
	["Hall of Masks"] = "Sala de las Máscaras",
	["Hall of Memories"] = "Cámara de los Recuerdos",
	["Hall of Mysteries"] = "Sala de los Misterios",
	["Hall of Repose"] = "Sala del Descanso",
	["Hall of Return"] = "Cámara de Regreso",
	["Hall of Ritual"] = "Sala de los Rituales",
	["Hall of Secrets"] = "Sala de los Secretos",
	["Hall of Serpents"] = "Sala de las Serpientes",
	["Hall of Shapers"] = "Sala de Creadores",
	["Hall of Stasis"] = "Cámara de Estasis",
	["Hall of the Brave"] = "Bastión de los Valientes",
	["Hall of the Conquered Kings"] = "Cámara de los Reyes Conquistados",
	["Hall of the Crafters"] = "Sala de los Artesanos",
	["Hall of the Crescent Moon"] = "Sala de la Luna Creciente",
	["Hall of the Crusade"] = "Sala de la Cruzada",
	["Hall of the Cursed"] = "Sala de los Malditos",
	["Hall of the Damned"] = "Sala de los Condenados",
	["Hall of the Defamed"] = "Cámara de los Difamados",
	["Hall of the Exalted"] = "Cámara de los Eminentes",
	["Hall of the Fathers"] = "Cámara de los Patriarcas",
	["Hall of the Frostwolf"] = "Cámara de los Lobo Gélido",
	["Hall of the Grand Imperion"] = "Aposento del Gran Imperión",
	["Hall of the High Father"] = "Cámara del Gran Padre",
	["Hall of the Keepers"] = "Sala de los Guardianes",
	["Hall of the Shaper"] = "Sala del Creador",
	["Hall of the Stormpike"] = "Cámara de los Pico Tormenta",
	["Hall of the Tortured"] = "Cámara de la Tortura",
	["Hall of the Watchers"] = "Cámara de los Vigías",
	["Hall of the Wicked"] = "Cámara de los Malditos",
	["Hall of Tombs"] = "Sala de Tumbas",
	["Hall of Tranquility"] = "Sala de la Quietud",
	["Hall of Tranquillity"] = "Sala de la Quietud",
	["Hall of Twilight"] = "Sala del Crepúsculo",
	["Halls of Anguish"] = "Salas de Angustia",
	["Halls of Awakening"] = "Salas del Despertar",
	["Halls of Binding"] = "Sala de Vínculos",
	["Halls of Destruction"] = "Salas de la Destrucción",
	["Halls of Flesh-Shaping"] = "Cámaras de Modelado de Carne",
	["Halls of Lightning"] = "Cámaras de Relámpagos",
	["Halls of Lightning Entrance"] = "Entrada de Cámaras de Relámpagos",
	["Halls of Mourning"] = "Salas del Luto",
	["Halls of Origination"] = "Cámaras de los Orígenes",
	["Halls of Origination Entrance"] = "Entrada de las Cámaras de los Orígenes",
	["Halls of Reflection"] = "Cámaras de Reflexión",
	["Halls of Reflection Entrance"] = "Entrada de Cámaras de Reflexión",
	["Halls of Silence"] = "Salas del Silencio",
	["Halls of Stone"] = "Cámaras de Piedra",
	["Halls of Stone Entrance"] = "Entrada de Cámaras de Piedra",
	["Halls of Strife"] = "Salas de los Conflictos",
	["Halls of the Ancestors"] = "Salas de los Ancestros",
	["Halls of the Hereafter"] = "Salas del Más Allá",
	["Halls of the Law"] = "Salas de la Ley",
	["Halls of Theory"] = "Galerías de la Teoría",
	["Halycon's Lair"] = "Guarida de Halycon",
	Hammerfall = "Sentencia",
	["Hammertoe's Digsite"] = "Excavación de Piemartillo",
	["Hammond Farmstead"] = "Hacienda de Hammond",
	Hangar = "Hangar",
	["Hardknuckle Clearing"] = "Claro Callonudillo",
	["Hardwrench Hideaway"] = "Escondrijo Malallave",
	["Harkor's Camp"] = "Campamento de Harkor",
	["Hatchet Hills"] = "Colinas Hacha",
	["Hatescale Burrow"] = "Madriguera Escama Odiosa",
	["Hatred's Vice"] = "Corrupción del Odio",
	Havenshire = "Villa Refugio",
	["Havenshire Farms"] = "Granjas de Villa Refugio",
	["Havenshire Lumber Mill"] = "Serrería de Villa Refugio",
	["Havenshire Mine"] = "Mina de Villa Refugio",
	["Havenshire Stables"] = "Establos de Villa Refugio",
	["Hayward Fishery"] = "Caladero Hayward",
	["Headmaster's Retreat"] = "Reposo del Rector",
	["Headmaster's Study"] = "Sala Rectoral",
	Hearthglen = "Vega del Amparo",
	["Heart of Destruction"] = "Corazón de Destrucción",
	["Heart of Fear"] = "Corazón del Miedo",
	["Heart of the Old God Scenario"] = "Gesta del Corazón del Dios Antiguo",
	["Heart of Zan'vess"] = "Corazón de Zan'vess",
	["Heart's Blood Shrine"] = "Santuario Sangre de Corazón",
	["Heartwood Trading Post"] = "Puesto de Venta de Duramen",
	["Heb'Drakkar"] = "Heb'Drakkar",
	["Heb'Valok"] = "Heb'Valok",
	["Hellfire Basin"] = "Cuenca del Fuego Infernal",
	["Hellfire Citadel"] = "Ciudadela del Fuego Infernal",
	["Hellfire Citadel: Ramparts"] = "Ciudadela del Fuego Infernal: Murallas",
	["Hellfire Citadel - Ramparts Entrance"] = "Ciudadela del Fuego Infernal: Entrada de las Murallas",
	["Hellfire Citadel: The Blood Furnace"] = "Ciudadela del Fuego Infernal: Horno de Sangre",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Ciudadela del Fuego Infernal: Entrada de El Horno de Sangre",
	["Hellfire Citadel: The Shattered Halls"] = "Ciudadela del Fuego Infernal: Salas Arrasadas",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Ciudadela del Fuego Infernal: Entrada de Las Salas Arrasadas",
	["Hellfire Peninsula"] = "Península del Fuego Infernal",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Península del Fuego Infernal - Force Camp Beach Head",
	["Hellfire Peninsula - Reaver's Fall"] = "Península del Fuego Infernal - Caída del Atracador Vil",
	["Hellfire Ramparts"] = "Murallas del Fuego Infernal",
	["Hellscream Arena"] = "Arena de Grito Infernal",
	["Hellscream's Camp"] = "Campamento de Grito Infernal",
	["Hellscream's Fist"] = "Puño de Grito Infernal",
	["Hellscream's Grasp"] = "Dominios Grito Infernal",
	["Hellscream's Watch"] = "Avanzada Grito Infernal",
	["Helm's Bed Lake"] = "Lago de Helm",
	["Heroes' Vigil"] = "Vigilia de los Héroes",
	["Hetaera's Clutch"] = "Guarida de Hetaera",
	["Hewn Bog"] = "Ciénaga Talada",
	["Heyman's Hubris"] = "Orgullo de Heyman",
	["Hibernal Cavern"] = "Caverna Hibernal",
	["Hidden Cell"] = "Celda Oculta",
	["Hidden Path"] = "Sendero Oculto",
	Highbank = "Bancalto",
	["High Bank"] = "Bancalto",
	["Highland Forest"] = "Bosque de las Tierras Altas",
	Highperch = "Nido Alto",
	["High Wilderness"] = "Altas Tierras Salvajes",
	Hillsbrad = "Trabalomas",
	["Hillsbrad Fields"] = "Campos de Trabalomas",
	["Hillsbrad Foothills"] = "Laderas de Trabalomas",
	["Hiri'watha Research Station"] = "Estación de Investigación de Hiri'watha",
	["Hive'Ashi"] = "Colmen'Ashi",
	["Hive'Regal"] = "Colmen'Regal",
	["Hive'Zora"] = "Colmen'Zora",
	["Hogger Hill"] = "Colina de Hogger",
	["Hollowed Out Tree"] = "Árbol Hueco",
	["Hollowstone Mine"] = "Mina Piedrahueca",
	["Honeydew Farm"] = "Granja Almíbar",
	["Honeydew Glade"] = "Claro Almíbar",
	["Honeydew Village"] = "Poblado Almíbar",
	["Honor Hold"] = "Bastión del Honor",
	["Honor Hold Mine"] = "Mina Bastión del Honor",
	["Honor Point"] = "Alto del Honor", -- Needs review
	["Honor's Stand"] = "El Alto del Honor",
	["Honor's Tomb"] = "Tumba del Honor",
	["Horde Base Camp"] = "Campamento Base de la Horda",
	["Horde Beach Daily Area"] = "Zona de diarias de playa de la Horda",
	["Horde Encampment"] = "Campamento de la Horda",
	["Horde Keep"] = "Fortaleza de la Horda",
	["Horde Landing"] = "Aterrizaje de la Horda",
	["Horde Landing Site"] = "Lugar del Desembarco de la Horda",
	["Hordemar City"] = "Ciudad Hordemar",
	["Horde PVP Barracks"] = "Cuartel JcJ de la Horda",
	["Horror Clutch"] = "Guarida del Horror",
	["Hour of Twilight"] = "Hora del Crepúsculo",
	["House of Edune"] = "Casa de Edune",
	["Howling Fjord"] = "Fiordo Aquilonal",
	["Howlingwind Cavern"] = "Caverna Viento Aullante",
	["Howlingwind Trail"] = "Senda Viento Aullante",
	["Howling Ziggurat"] = "Zigurat Aullante",
	["Hrothgar's Landing"] = "Desembarco de Hrothgar",
	["Huangtze Falls"] = "Cataratas Huangtze",
	["Hull of the Foebreaker"] = "Casco del Rasgadversarios",
	["Humboldt Conflagration"] = "Conflagración de Humboldt",
	["Hunter Rise"] = "Alto de los Cazadores",
	["Hunter's Hill"] = "Cerro del Cazador",
	["Huntress of the Sun"] = "Cazadora del Sol",
	["Huntsman's Cloister"] = "Claustro del Cazador",
	Hyjal = "Hyjal",
	["Hyjal Barrow Dens"] = "Túmulos de Hyjal",
	["Hyjal Past"] = "El Pasado Hyjal",
	["Hyjal Summit"] = "La Cima Hyjal",
	["Iceblood Garrison"] = "Baluarte Sangrehielo",
	["Iceblood Graveyard"] = "Cementerio Sangrehielo",
	Icecrown = "Corona de Hielo",
	["Icecrown Citadel"] = "Ciudadela de la Corona de Hielo",
	["Icecrown Dungeon - Gunships"] = "Mazmorra de Corona de Hielo",
	["Icecrown Glacier"] = "Glaciar Corona de Hielo",
	["Iceflow Lake"] = "Lago Glacial",
	["Ice Heart Cavern"] = "Caverna Corazón de Hielo",
	["Icemist Falls"] = "Cataratas Bruma de Hielo",
	["Icemist Village"] = "Poblado Bruma de Hielo",
	["Ice Thistle Hills"] = "Colinas Cardo Nevado",
	["Icewing Bunker"] = "Búnker Ala Gélida",
	["Icewing Cavern"] = "Cueva Ala Gélida",
	["Icewing Pass"] = "Paso de Ala Gélida",
	["Idlewind Lake"] = "Lago Soplo",
	["Igneous Depths"] = "Profundidades Ígneas",
	["Ihgaluk Crag"] = "Risco Ihgaluk",
	["Ik'vess"] = "Ik'vess",
	["Ikz'ka Ridge"] = "Cresta Ikz'ka",
	["Illidari Point"] = "Alto Illidari",
	["Illidari Training Grounds"] = "Campo de Entrenamiento Illidari",
	["Indu'le Village"] = "Poblado Indu'le",
	["Infiltrating the Shipyard"] = "Infiltración en el Astillero",
	["Inkgill Mere"] = "Presa Branquias de Tinta",
	Inn = "Posada",
	["Inner Sanctum"] = "Sagrario Interior",
	["Inner Veil"] = "Velo Interior",
	["Insidion's Perch"] = "Nido de Insidion",
	["Invasion Point: Annihilator"] = "Punto de invasión: Aniquilador",
	["Invasion Point: Cataclysm"] = "Punto de Invasión: Cataclismo",
	["Invasion Point: Destroyer"] = "Punto de Invasión: Destructor",
	["Invasion Point: Overlord"] = "Punto de Invasión: Señor Supremo",
	["Ironband's Compound"] = "Complejo Vetaferro",
	["Ironband's Excavation Site"] = "Excavación de Vetaferro",
	["Ironbeard's Tomb"] = "Tumba de Barbaférrea",
	["Ironclad Cove"] = "Cala del Acorazado",
	["Ironclad Garrison"] = "Cuartel del Acorazado",
	["Ironclad Prison"] = "Prisión del Acorazado",
	["Iron Concourse"] = "Explanada de Hierro",
	["Irondeep Mine"] = "Mina Ferrohondo",
	Ironforge = "Forjaz",
	["Ironforge Airfield"] = "Base aérea de Forjaz",
	["Ironstone Camp"] = "Campamento Roca de Hierro",
	["Ironstone Plateau"] = "Meseta Roca de Hierro",
	["Iron Summit"] = "Cima de Hierro",
	["Irontree Cavern"] = "Caverna de Troncoferro",
	["Irontree Clearing"] = "Claro de Troncoferro",
	["Irontree Woods"] = "Bosque de Troncoferro",
	["Ironwall Dam"] = "Presa del Muro de Hierro",
	["Ironwall Rampart"] = "Fortificación del Muro de Hierro",
	["Ironwing Cavern"] = "Caverna de Alahierro",
	Iskaal = "Iskaal",
	["Island of Doctor Lapidis"] = "Isla del Doctor Lapidis",
	["Isle of Conquest"] = "Isla de la Conquista",
	["Isle of Conquest No Man's Land"] = "Tierra de Nadie de Isla de la Conquista",
	["Isle of Dread"] = "Isla del Terror",
	["Isle of Giants"] = "Isla de los Gigantes",
	["Isle of Quel'Danas"] = "Isla de Quel'Danas",
	["Isle of Reckoning"] = "Isla de la Venganza",
	["Isle of Thunder"] = "Isla del Trueno",
	["Isle of Tribulations"] = "Isla de las Tribulaciones",
	["Iso'rath"] = "Iso'rath",
	["Itharius's Cave"] = "Cueva de Itharius",
	["Ivald's Ruin"] = "Ruinas de Ivald",
	["Ix'lar's Domain"] = "Dominio de Ix'lar",
	["Jadefire Glen"] = "Cañada Fuego de Jade",
	["Jadefire Run"] = "Camino Fuego de Jade",
	["Jade Forest Alliance Hub Phase"] = "Fase del centro de la Alianza en El Bosque de Jade",
	["Jade Forest Battlefield Phase"] = "Fase de campo de batalla de El Bosque de Jade",
	["Jade Forest Horde Starting Area"] = "Zona de inicio de la Horda de El Bosque de Jade",
	["Jademir Lake"] = "Lago Jademir",
	["Jade Temple Grounds"] = "Tierras del Templo de Jade",
	Jaedenar = "Jaedenar",
	["Jagged Reef"] = "Arrecife Dentado",
	["Jagged Ridge"] = "Cresta Dentada",
	["Jaggedswine Farm"] = "La Pocilga",
	["Jagged Wastes"] = "Ruinas Dentadas",
	["Jaguero Isle"] = "Isla Jaguero",
	["Jaina Dalaran Scenario"] = "Gesta de Dalaran de Jaina",
	["Janeiro's Point"] = "Cayo de Janeiro",
	["Jangolode Mine"] = "Mina de Jango",
	["Jaquero Isle"] = "Isla Jaquero",
	["Jasperlode Mine"] = "Cantera de Jaspe",
	["Jeff NE Quadrant Changed"] = "Jeff NE Quadrant Changed",
	["Jeff NW Quadrant"] = "Jeff NW Quadrant",
	["Jeff SE Quadrant"] = "Jeff SE Quadrant",
	["Jeff SW Quadrant"] = "Jeff SW Quadrant",
	["Jerod's Landing"] = "Embarcadero de Jerod",
	["Jintha'Alor"] = "Jintha'Alor",
	["Jintha'kalar"] = "Jintha'kalar",
	["Jintha'kalar Passage"] = "Pasaje de Jintha'kalar",
	["Jin Yang Road"] = "Camino Jin Yang",
	Jotunheim = "Jotunheim",
	K3 = "K3",
	["Kaja'mine"] = "Kaja'mina",
	["Kaja'mite Cave"] = "Cueva de Kaja'mita",
	["Kaja'mite Cavern"] = "Caverna de Kaja'mita",
	["Kajaro Field"] = "Campo Kajaro",
	["Kal'ai Ruins"] = "Ruinas de Kal'ai",
	Kalimdor = "Kalimdor",
	Kamagua = "Komawa",
	["Karabor Sewers"] = "Cloacas de Karabor",
	Karazhan = "Karazhan",
	["Kargathia Keep"] = "Fuerte de Kargathia",
	["Karnum's Glade"] = "Claro de Karnum",
	["Kartak's Hold"] = "Bastión de Kartak",
	Kaskala = "Kashala",
	["Kaw's Roost"] = "Percha de Kaw",
	["Kea Krak"] = "Kea Krak",
	["Keelen's Trustworthy Tailoring"] = "La Sastrería Fiable de Keelen",
	["Keel Harbor"] = "Puerto Quilla",
	["Keeshan's Post"] = "Puesto de Keeshan",
	["Kelp'thar Forest"] = "Bosque Kelp'thar",
	["Kel'Thuzad Chamber"] = "Cámara de Kel'Thuzad",
	["Kel'Thuzad's Chamber"] = "Cámara de Kel'Thuzad",
	["Keset Pass"] = "Paso de Keset",
	["Kessel's Crossing"] = "Encrucijada de Kessel",
	Kezan = "Kezan",
	Kharanos = "Kharanos",
	["Khardros' Anvil"] = "Yunque de Khardros",
	["Khartut's Tomb"] = "Tumba de Khartut",
	["Khaz'goroth's Seat"] = "Trono de Khaz'goroth",
	["Ki-Han Brewery"] = "Cervecería Ki-Han",
	["Kili'ua's Atoll"] = "Atolón de Kili'ua",
	["Kil'sorrow Fortress"] = "Fortaleza Mata'penas",
	["King's Gate"] = "Puerta del Rey",
	["King's Harbor"] = "Puerto del Rey",
	["King's Hoard"] = "Reservas del Rey",
	["King's Square"] = "Plaza del Rey",
	["Kirin'Var Village"] = "Poblado Kirin'Var",
	Kirthaven = "Kirthaven",
	["Klaxxi'vess"] = "Klaxxi'vess",
	["Klik'vess"] = "Klik'vess",
	["Knucklethump Hole"] = "Agujero Machakadedo",
	["Kodo Graveyard"] = "Cementerio de Kodos",
	["Kodo Rock"] = "Roca de los Kodos",
	["Kolkar Village"] = "Poblado Kolkar",
	Kolramas = "Kolramas",
	["Kor'kron Vanguard"] = "Vanguardia Kor'kron",
	["Kormek's Hut"] = "Cabaña de Kormek",
	["Koroth's Den"] = "Cubil de Koroth",
	["Korthun's End"] = "Fin de Korthun",
	["Kor'vess"] = "Kor'vess",
	["Kota Basecamp"] = "Campamento Base Kota",
	["Kota Peak"] = "Cumbre Kota",
	["Krasarang Cove"] = "Cala Krasarang",
	["Krasarang River"] = "Río Krasarang",
	["Krasarang Wilds"] = "Espesura Krasarang",
	["Krasari Falls"] = "Cataratas Krasari",
	["Krasus' Landing"] = "Alto de Krasus",
	["Krazzworks Attack Zeppelin"] = "Zepelín de ataque de La Krazzería",
	["Kril'Mandar Point"] = "Punta de Kril'mandar",
	["Kri'vess"] = "Kri'vess",
	["Krolg's Hut"] = "Cabaña de Krolg",
	["Krom'gar Fortress"] = "Fortaleza Krom'gar",
	["Krom's Landing"] = "Puerto de Krom",
	["KTC Headquarters"] = "Central SCK",
	["KTC Oil Platform"] = "Plataforma Petrolera SCK",
	["Kul'galar Keep"] = "Fortaleza de Kul'galar",
	["Kul Tiras"] = "Kul Tiras",
	["Kun-Lai Pass"] = "Paso Kun-Lai",
	["Kun-Lai Summit"] = "Cima Kun-Lai",
	["Kunzen Cave"] = "Cueva Kunzen",
	["Kunzen Village"] = "Poblado Kunzen",
	["Kurzen's Compound"] = "Base de Kurzen",
	["Kypari Ik"] = "Kypari Ik",
	["Kyparite Quarry"] = "Cantera de Kyparita",
	["Kypari Vor"] = "Kypari Vor",
	["Kypari Zar"] = "Kypari Zar",
	["Kzzok Warcamp"] = "Campamento de Guerra Kzzok",
	["Lair of Skiggit"] = "Guarida de Skiggit",
	["Lair of the Beast"] = "Guarida de la Bestia",
	["Lair of the Chosen"] = "Guarida de los Elegidos",
	["Lair of the Jade Witch"] = "Guarida de la Bruja de Jade",
	["Lair of Tortos"] = "Guarida de Tortos",
	["Lake Al'Ameth"] = "Lago Al'Ameth",
	["Lake Cauldros"] = "Lago Caldros",
	["Lake Dumont"] = "Lago Dumont",
	["Lake Edunel"] = "Lago Edunel",
	["Lake Elrendar"] = "Lago Elrendar",
	["Lake Elune'ara"] = "Lago Elune'ara",
	["Lake Ere'Noru"] = "Lago Ere'Noru",
	["Lake Everstill"] = "Lago Sempiterno",
	["Lake Falathim"] = "Lago Falathim",
	["Lake Indu'le"] = "Lago Indu'le",
	["Lake Jorune"] = "Lago Jorune",
	["Lake Kel'Theril"] = "Lago Kel'Theril",
	["Lake Kittitata"] = "Lago Kittitata",
	["Lake Kum'uya"] = "Lago Kum'uya",
	["Lake Mennar"] = "Lago Mennar",
	["Lake Mereldar"] = "Lago Mereldar",
	["Lake Nazferiti"] = "Lago Nazferiti",
	["Lake of Stars"] = "Lago de los Astros",
	["Lakeridge Highway"] = "Camino del Lago",
	Lakeshire = "Villa del Lago",
	["Lakeshire Inn"] = "Posada de Villa del Lago",
	["Lakeshire Town Hall"] = "Concejo de Villa del Lago",
	["Lakeside Landing"] = "Pista del Lago",
	["Lake Sunspring"] = "Lago Primasol",
	["Lakkari Tar Pits"] = "Fosas de Alquitrán Lakkari",
	["Landing Beach"] = "Playa de Desembarco",
	["Landing Site"] = "Lugar del Desembarco",
	["Land's End Beach"] = "Playa Finisterrae",
	["Langrom's Leather & Links"] = "Cuero y Eslabones de Langrom",
	["Lao & Son's Yakwash"] = "Lavadero de Yaks Lao e Hijo",
	["Largo's Overlook"] = "Alto de Largo",
	["Largo's Overlook Tower"] = "Torre del Alto de Largo",
	["Lariss Pavilion"] = "Pabellón de Lariss",
	["Laughing Skull Courtyard"] = "Patio Riecráneos",
	["Laughing Skull Ruins"] = "Ruinas Riecráneos",
	["Launch Bay"] = "Aeropuerto",
	["Legash Encampment"] = "Campamento Legashi",
	["Legendary Leathers"] = "Pieles Legendarias",
	["Legion Hold"] = "Bastión de la Legión",
	["Legion's Fate"] = "Destino de la Legión",
	["Legion's Rest"] = "Reposo de la Legión",
	["Lethlor Ravine"] = "Barranco Lethlor",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "Pesar de Leyara",
	["L'ghorek"] = "L'ghorek",
	["Liang's Retreat"] = "Retiro de Liang",
	["Library Wing"] = "Ala de la Biblioteca",
	Lighthouse = "Faro",
	["Lightning Ascent"] = "Ascenso del Relámpago",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Forja de los relámpagos - Gesta de progresión de la isla mogu",
	["Lightning Ledge"] = "Saliente de Relámpagos",
	["Lightning Promenade"] = "Paseo del Relámpago",
	["Lightning Vein Mine"] = "Mina del Relámpago",
	["Light's Breach"] = "Brecha de la Luz",
	["Light's Dawn Cathedral"] = "Catedral del Alba",
	["Light's Hammer"] = "Martillo de la Luz",
	["Light's Hope Chapel"] = "Capilla de la Esperanza de la Luz",
	["Light's Point"] = "Punta de la Luz",
	["Light's Point Tower"] = "Torre de la Punta de la Luz",
	["Light's Shield Tower"] = "Torre del Escudo de la Luz",
	["Light's Trust"] = "Confianza de la Luz",
	["Like Clockwork"] = "Como un Reloj",
	["Lion's Landing"] = "Desembarco del León",
	["Lion's Pride Inn"] = "Posada Orgullo de León",
	["Livery Outpost"] = "Avanzada de la Caballería",
	["Livery Stables"] = "Caballerizas",
	["Livery Stables "] = "Caballerizas",
	["Llane's Oath"] = "Juramento de Llane",
	["Loading Room"] = "Zona de Carga",
	["Loch Modan"] = "Loch Modan",
	["Loch Verrall"] = "Loch Verrall",
	["Loken's Bargain"] = "Acuerdo de Loken",
	["Lonesome Cove"] = "Cala Solitaria",
	Longshore = "Playa Larga",
	["Longying Outpost"] = "Avanzada Longying",
	["Lordamere Internment Camp"] = "Campo de Reclusión de Lordamere",
	["Lordamere Lake"] = "Lago Lordamere",
	["Lor'danel"] = "Lor'danel",
	["Lorthuna's Gate"] = "Puerta de Lorthuna",
	["Lost Caldera"] = "Caldera Perdida",
	["Lost City of the Tol'vir"] = "Ciudad Perdida de los Tol'vir",
	["Lost City of the Tol'vir Entrance"] = "Entrada de la Ciudad Perdida de los Tol'vir",
	LostIsles = "Las Islas Perdidas",
	["Lost Isles Town in a Box"] = "Ciudad de Bolsillo de Las Islas Perdidas",
	["Lost Isles Volcano Eruption"] = "Erupción de Volcán de Las Islas Perdidas",
	["Lost Peak"] = "Pico Perdido",
	["Lost Point"] = "Punta Perdida",
	["Lost Rigger Cove"] = "Cala del Aparejo Perdido",
	["Lothalor Woodlands"] = "Bosque Lothalor",
	["Lower City"] = "Bajo Arrabal",
	["Lower Silvermarsh"] = "Marjal Argenta Inferior",
	["Lower Sumprushes"] = "El Sumidero Inferior",
	["Lower Veil Shil'ak"] = "Velo Shil'ak Bajo",
	["Lower Wilds"] = "Bajas Tierras Salvajes",
	["Lumber Mill"] = "Aserradero",
	["Lushwater Oasis"] = "Oasis Aguaverde",
	["Lydell's Ambush"] = "Emboscada de Lydell",
	["M.A.C. Diver"] = "Otilius",
	["Maelstrom Deathwing Fight"] = "Lucha de Alamuerte en La Vorágine",
	["Maelstrom Zone"] = "Zona de La Vorágine",
	["Maestra's Post"] = "Atalaya de Maestra",
	["Maexxna's Nest"] = "Nido de Maexxna",
	["Mage Quarter"] = "Barrio de los Magos",
	["Mage Tower"] = "Torre de los Magos",
	["Mag'har Grounds"] = "Dominios Mag'har",
	["Mag'hari Procession"] = "Procesión Mag'hari",
	["Mag'har Post"] = "Puesto Mag'har",
	["Magical Menagerie"] = "Arca Mágica",
	["Magic Quarter"] = "Barrio de la Magia",
	["Magisters Gate"] = "Puerta Magister",
	["Magister's Terrace"] = "Bancal del Magister",
	["Magisters' Terrace"] = "Bancal del Magister",
	["Magisters' Terrace Entrance"] = "Entrada del Bancal del Magister",
	["Magmadar Cavern"] = "Cueva Magmadar",
	["Magma Fields"] = "Campos de Magma",
	["Magma Springs"] = "Fuentes de Magma",
	["Magmaw's Fissure"] = "Fisura de Faucemagma",
	Magmoth = "Magmoth",
	["Magnamoth Caverns"] = "Cavernas Magnamoth",
	["Magram Territory"] = "Territorio Magram",
	["Magtheridon's Lair"] = "Guarida de Magtheridon",
	["Magus Commerce Exchange"] = "Mercado de Magos",
	["Main Chamber"] = "Cámara Principal",
	["Main Gate"] = "Entrada Principal",
	["Main Hall"] = "Sala Principal",
	["Maker's Ascent"] = "Ascenso del Hacedor",
	["Maker's Overlook"] = "El Mirador de los Creadores",
	["Maker's Overlook "] = "El Mirador de los Creadores",
	["Makers' Overlook"] = "El Mirador de los Creadores",
	["Maker's Perch"] = "Pedestal del Creador",
	["Makers' Perch"] = "El Pedestal de los Creadores",
	["Malaka'jin"] = "Malaka'jin",
	["Malden's Orchard"] = "Huerta de Malden",
	Maldraz = "Maldraz",
	["Malfurion's Breach"] = "Brecha de Malfurion",
	["Malicia's Outpost"] = "Avanzada de Malicia",
	["Malykriss: The Vile Hold"] = "Malykriss: El Bastión Inmundo",
	["Mama's Pantry"] = "Despensa de Mamá",
	["Mam'toth Crater"] = "Cráter de Mam'toth",
	["Manaforge Ara"] = "Forja de Maná Ara",
	["Manaforge B'naar"] = "Forja de Maná B'naar",
	["Manaforge Coruu"] = "Forja de Maná Coruu",
	["Manaforge Duro"] = "Forja de Maná Duro",
	["Manaforge Ultris"] = "Forja de Maná Ultris",
	["Mana Tombs"] = "Tumbas de Maná",
	["Mana-Tombs"] = "Tumbas de Maná",
	["Mandokir's Domain"] = "Dominios de Mandokir",
	["Mandori Village"] = "Aldea Mandori",
	["Mannoroc Coven"] = "Aquelarre Mannoroc",
	["Manor Mistmantle"] = "Mansión Mantoniebla",
	["Mantle Rock"] = "Rocamanto",
	["Map Chamber"] = "Cámara del Mapa",
	["Mar'at"] = "Mar'at",
	Maraudon = "Maraudon",
	["Maraudon - Earth Song Falls Entrance"] = "Maraudon: Entrada de las Cascadas del Canto de la Tierra",
	["Maraudon - Foulspore Cavern Entrance"] = "Maraudon: Entrada de la Gruta de la Espora Fétida",
	["Maraudon - The Wicked Grotto Entrance"] = "Maraudon - Entrada de la Gruta Maldita",
	["Mardenholde Keep"] = "Fortaleza de Mardenholde",
	Marista = "Vistamar",
	["Marista's Bait & Brew"] = "Pesca y brebajes de Vistamar",
	["Market Row"] = "Fila del Mercado",
	["Marshal's Refuge"] = "Refugio de Marshal",
	["Marshal's Stand"] = "Alto de Marshal",
	["Marshlight Lake"] = "Lago Luz Pantanosa",
	["Marshtide Watch"] = "Avanzada Marea Pantanosa",
	["Maruadon - The Wicked Grotto Entrance"] = "Maraudon: Entrada de La Gruta Maligna",
	["Mason's Folly"] = "Locura del Albañil",
	["Masters' Gate"] = "Puerta de los Maestros",
	["Master's Terrace"] = "El Bancal del Maestro",
	["Mast Room"] = "Sala del Mástil",
	["Maw of Destruction"] = "Fauces de Destrucción",
	["Maw of Go'rath"] = "Fauces de Go'rath",
	["Maw of Lycanthoth"] = "Fauces de Lycanthoth",
	["Maw of Neltharion"] = "Fauces de Neltharion",
	["Maw of Shu'ma"] = "Fauces de Shu'ma",
	["Maw of the Void"] = "Fauces del Vórtice",
	["Mazra'Alor"] = "Mazra'Alor",
	Mazthoril = "Mazthoril",
	["Mazu's Overlook"] = "Mirador de Mazu",
	["Medivh's Chambers"] = "Estancias de Medivh",
	["Menagerie Wreckage"] = "Restos del Arca",
	["Menethil Bay"] = "Bahía de Menethil",
	["Menethil Harbor"] = "Puerto de Menethil",
	["Menethil Keep"] = "Castillo de Menethil",
	["Merchant Square"] = "Plaza de los Mercaderes",
	Middenvale = "Mediavega",
	["Mid Point Station"] = "Estación de la Punta Central",
	["Midrealm Post"] = "Puesto de la Tierra Media",
	["Midwall Lift"] = "Elevador del Muro Central",
	["Mightstone Quarry"] = "Cantera de Piedra de Poderío",
	["Military District"] = "Distrito Militar",
	["Mimir's Workshop"] = "Taller de Mimir",
	Mine = "Mina",
	Mines = "Minas",
	["Mirage Abyss"] = "Abismo del Espejismo",
	["Mirage Flats"] = "Explanada del Espejismo",
	["Mirage Raceway"] = "Circuito del Espejismo",
	["Mirkfallon Lake"] = "Lago Mirkfallon",
	["Mirkfallon Post"] = "Puesto Mirkfallon",
	["Mirror Lake"] = "Lago Espejo",
	["Mirror Lake Orchard"] = "Vergel del Lago Espejo",
	["Mistblade Den"] = "Guarida Hojaniebla",
	["Mistcaller's Cave"] = "Cueva del Clamaneblina",
	["Mistfall Village"] = "Aldea Bruma Otoñal",
	["Mist's Edge"] = "Cabo de la Niebla",
	["Mistvale Valley"] = "Valle del Velo de Bruma",
	["Mistveil Sea"] = "Mar Velo de Niebla",
	["Mistwhisper Refuge"] = "Refugio Susurraneblina",
	["Misty Pine Refuge"] = "Refugio Pinobruma",
	["Misty Reed Post"] = "Puesto Juncobruma",
	["Misty Reed Strand"] = "Playa Juncobruma",
	["Misty Ridge"] = "Cresta Brumosa",
	["Misty Shore"] = "Costa de la Neblina",
	["Misty Shores"] = "Costa de la Neblina",
	["Misty Valley"] = "Valle Brumoso",
	["Miwana's Longhouse"] = "Casa Comunal de Miwana",
	["Mizjah Ruins"] = "Ruinas de Mizjah",
	["Moa'ki"] = "Puerto Moa'ki",
	["Moa'ki Harbor"] = "Puerto Moa'ki",
	["Moggle Point"] = "Cabo Moggle",
	["Mo'grosh Stronghold"] = "Fortaleza de Mo'grosh",
	["Mogu Island Daily Area"] = "Zona de diarias de la isla mogu",
	["Mogu Island Events - Alliance Base"] = "Eventos de la isla mogu - Base de la Alianza",
	["Mogu Island Events - Horde Base"] = "Eventos de la isla mogu - Base de la Horda",
	["Mogu Island Loot Room"] = "Sala de botín de la isla mogu",
	["Mogu Island Progression Events"] = "Eventos de progresión de la isla mogu",
	Mogujia = "Mogujia",
	["Mogu'shan Palace"] = "Palacio Mogu'shan",
	["Mogu'shan Terrace"] = "Tribuna Mogu'shan",
	["Mogu'shan Vaults"] = "Cámaras Mogu'shan",
	["Mok'Doom"] = "Mok'Doom",
	["Mok'Gordun"] = "Mok'Gordun",
	["Mok'Nathal Village"] = "Aldea Mok'Nathal",
	["Mold Foundry"] = "Fundición del Molde",
	["Molten Core"] = "Núcleo de Magma",
	["Molten Front"] = "Frente de Magma",
	Moonbrook = "Arroyo de la Luna",
	Moonglade = "Claro de la Luna",
	["Moongraze Woods"] = "Bosque Pasto Lunar",
	["Moon Horror Den"] = "Cubil del Horror de la Luna",
	["Moonrest Gardens"] = "Jardines Reposo Lunar",
	["Moonshrine Ruins"] = "Ruinas del Santuario Lunar",
	["Moonshrine Sanctum"] = "Sagrario Lunar",
	["Moontouched Den"] = "Cubil Lunadón",
	["Moonwater Retreat"] = "Retiro Agualuna",
	["Moonwell of Cleansing"] = "Poza de la Luna de Purificación",
	["Moonwell of Purity"] = "Poza de la Luna de Pureza",
	["Moonwing Den"] = "Túmulo Lunala",
	["Mord'rethar: The Death Gate"] = "Mord'rethar: La Puerta de la Muerte",
	["Morgan's Plot"] = "Terreno de Morgan",
	["Morgan's Vigil"] = "Vigilia de Morgan",
	["Morlos'Aran"] = "Morlos'Aran",
	["Morning Breeze Lake"] = "Lago Brisa Temprana",
	["Morning Breeze Village"] = "Aldea Brisa Temprana",
	Morrowchamber = "Cámara del Mañana",
	["Mor'shan Base Camp"] = "Campamento de Mor'shan",
	["Mortal's Demise"] = "Óbito del Mortal",
	["Mortbreath Grotto"] = "Gruta Hálitovil",
	["Mortwake's Tower"] = "Torre Mortoalerta",
	["Mosh'Ogg Ogre Mound"] = "Túmulo Ogro Mosh'Ogg",
	["Mosshide Fen"] = "Pantano Pellejomusgo",
	["Mosswalker Village"] = "Poblado Caminamoho",
	["Mossy Pile"] = "Pilote Musgoso",
	["Motherseed Pit"] = "Foso de la Semilla Madre",
	["Mountainfoot Strip Mine"] = "Cantera de la Ladera",
	["Mount Akher"] = "Monte Akher",
	["Mount Hyjal"] = "Monte Hyjal",
	["Mount Hyjal Phase 1"] = "Mount Hyjal Phase 1",
	["Mount Neverest"] = "Monte Nieverest",
	["Muckscale Grotto"] = "Gruta Mugrescama",
	["Muckscale Shallows"] = "Arrecifes Mugrescama",
	["Mudmug's Place"] = "Hogar de Caolín",
	Mudsprocket = "Piñón de Barro",
	Mulgore = "Mulgore",
	["Murder Row"] = "El Frontal de la Muerte",
	["Murkdeep Cavern"] = "Caverna Negrasombra",
	["Murky Bank"] = "Ribera Turbia",
	["Muskpaw Ranch"] = "Rancho Zarpa Lanuda",
	["Mystral Lake"] = "Lago Mystral",
	Mystwood = "Bosque Bruma",
	Nagrand = "Nagrand",
	["Nagrand Arena"] = "Arena de Nagrand",
	Nahom = "Nahom",
	["Nar'shola Terrace"] = "Bancal de Nar'shola",
	["Narsong Spires"] = "Pináculos de Narsong",
	["Narsong Trench"] = "Zanja de Narsong",
	["Narvir's Cradle"] = "Cuna de Narvir",
	["Nasam's Talon"] = "Garfa de Nasam",
	["Nat's Landing"] = "Embarcadero de Nat",
	["Naval Battle Scenario"] = "Gesta de batalla naval",
	Naxxanar = "Naxxanar",
	Naxxramas = "Naxxramas",
	["Nayeli Lagoon"] = "Laguna Nayeli",
	["Naz'anak: The Forgotten Depths"] = "Naz'anak: Las Profundidades Olvidadas",
	["Nazj'vel"] = "Nazj'vel",
	Nazzivian = "Nazzivian",
	["Nectarbreeze Orchard"] = "Huerto Brisa Dulce",
	["Needlerock Chasm"] = "Sima Rocaguja",
	["Needlerock Slag"] = "Fosa Rocaguja",
	["Nefarian's Lair"] = "Guarida de Nefarian",
	["Nefarian�s Lair"] = "Guarida de Nefarian",
	["Neferset City"] = "Ciudad de Neferset",
	["Neferset City Outskirts"] = "Afueras de la Ciudad de Neferset",
	["Nek'mani Wellspring"] = "Manantial Nek'mani",
	["Neptulon's Rise"] = "Alto de Neptulon",
	["Nesingwary Base Camp"] = "Campamento Base de Nesingwary",
	["Nesingwary Safari"] = "Safari Nesingwary",
	["Nesingwary's Expedition"] = "Expedición de Nesingwary",
	["Nesingwary's Safari"] = "Safari de Nesingwary",
	Nespirah = "Nespirah",
	["Nestlewood Hills"] = "Colinas Cubrebosque",
	["Nestlewood Thicket"] = "Matorral Cubrebosque",
	["Nethander Stead"] = "Granja Nethander",
	["Nethergarde Keep"] = "Castillo de Nethergarde",
	["Nethergarde Mines"] = "Minas de Nethergarde",
	["Nethergarde Supply Camps"] = "Campamento de Suministros de Nethergarde",
	Netherspace = "Espacio Abisal",
	Netherstone = "Piedra Abisal",
	Netherstorm = "Tormenta Abisal",
	["Netherweb Ridge"] = "Cresta Red Abisal",
	["Netherwing Fields"] = "Campos del Ala Abisal",
	["Netherwing Ledge"] = "Arrecife del Ala Abisal",
	["Netherwing Mines"] = "Minas del Ala Abisal",
	["Netherwing Pass"] = "Desfiladero del Ala Abisal",
	["Neverest Basecamp"] = "Campamento Base Nieverest",
	["Neverest Pinnacle"] = "Cumbre del Nieverest",
	["New Agamand"] = "Nuevo Agamand",
	["New Agamand Inn"] = "Posada de Nuevo Agamand",
	["New Avalon"] = "Nuevo Avalon",
	["New Avalon Fields"] = "Campos de Nuevo Avalon",
	["New Avalon Forge"] = "Forja de Nuevo Avalon",
	["New Avalon Orchard"] = "Huerto de Nuevo Avalon",
	["New Avalon Town Hall"] = "Concejo de Nuevo Avalon",
	["New Cifera"] = "Nueva Cifera",
	["New Hearthglen"] = "Nueva Vega del Amparo",
	["New Kargath"] = "Nuevo Kargath",
	["New Thalanaar"] = "Nueva Thalanaar",
	["New Tinkertown"] = "Nueva Ciudad Manitas",
	["Nexus Legendary"] = "Legendario del Nexo",
	Nidavelir = "Nidavelir",
	["Nidvar Stair"] = "Escalera de Nidvar",
	Nifflevar = "Nafsavar",
	["Night Elf Village"] = "Villa Elfo de la Noche",
	Nighthaven = "Amparo de la Noche",
	["Nightingale Lounge"] = "Salón del Ruiseñor",
	["Nightmare Depths"] = "Profundidades de Pesadilla",
	["Nightmare Scar"] = "Paraje Pesadilla",
	["Nightmare Vale"] = "Vega Pesadilla",
	["Night Run"] = "Senda de la Noche",
	["Nightsong Woods"] = "Bosque Arrullanoche",
	["Night Web's Hollow"] = "Hoya Nocturácnidas",
	["Nijel's Point"] = "Punta de Nijel",
	["Nimbus Rise"] = "Alto de Nimbo",
	Nine = "Nine",
	["Niuzao Catacombs"] = "Catacumbas de Niuzao",
	["Niuzao Temple"] = "Templo de Niuzao",
	["Njord's Breath Bay"] = "Bahía Aliento de Njord",
	["Njorndar Village"] = "Poblado Njorndar",
	["Njorn Stair"] = "Escalera de Njorn",
	["Nook of Konk"] = "Caverna de Konk",
	["Noonshade Ruins"] = "Ruinas Sombrasol",
	Nordrassil = "Nordrassil",
	["Nordrassil Inn"] = "Posada de Nordrassil",
	["Nordune Ridge"] = "Cresta Nordune",
	["North Common Hall"] = "Sala Comunal Norte",
	Northdale = "Vallenorte",
	["Northern Barrens"] = "Los Baldíos del Norte",
	["Northern Elwynn Mountains"] = "Montañas de Elwynn del Norte",
	["Northern Headlands"] = "Cabos del Norte",
	["Northern Rampart"] = "Muralla Norte",
	["Northern Rocketway"] = "Cohetepista del Norte",
	["Northern Rocketway Exchange"] = "Intercambiador de la Cohetepista del Norte",
	["Northern Stranglethorn"] = "Norte de la Vega de Tuercespina",
	["Northfold Manor"] = "Mansión Redilnorte",
	["Northgate Breach"] = "Brecha de la Puerta del Norte",
	["North Gate Outpost"] = "Avanzada de la Puerta Norte",
	["North Gate Pass"] = "Paso de la Puerta Norte",
	["Northgate River"] = "Río de la Puerta del Norte",
	["Northgate Woods"] = "Bosque de la Puerta del Norte",
	["Northmaul Tower"] = "Torre Quiebranorte",
	["Northpass Tower"] = "Torre del Paso Norte",
	["North Point Station"] = "Estación de la Punta Norte",
	["North Point Tower"] = "Torre de la Punta Norte",
	Northrend = "Rasganorte",
	["Northridge Lumber Camp"] = "Aserradero Crestanorte",
	["North Sanctum"] = "Sagrario del Norte",
	Northshire = "Villanorte",
	["Northshire Abbey"] = "Abadía de Villanorte",
	["Northshire River"] = "Río de Villanorte",
	["Northshire Valley"] = "Valle de Villanorte",
	["Northshire Vineyards"] = "Viñedos de Villanorte",
	["North Spear Tower"] = "Torre Lanza del Norte",
	["North Tide's Beachhead"] = "Desembarco Mareanorte",
	["North Tide's Run"] = "Cala Mareanorte",
	["Northwatch Expedition Base Camp"] = "Campamento Base de la Expedición del Fuerte del Norte",
	["Northwatch Expedition Base Camp Inn"] = "Taberna del Campamento Base de la Expedición del Fuerte del Norte",
	["Northwatch Foothold"] = "Ciudadela del Fuerte del Norte",
	["Northwatch Hold"] = "Fuerte del Norte",
	["Northwind Cleft"] = "Grieta del Viento Norte",
	["North Wind Tavern"] = "Taberna Vientonorte",
	["Nozzlepot's Outpost"] = "Avanzada de Ollaboquilla",
	["Nozzlerust Post"] = "Puesto Boquilla Oxidada",
	["Oasis of the Fallen Prophet"] = "Oasis del Profeta Caído",
	["Oasis of Vir'sar"] = "Oasis de Vir'sar",
	["Obelisk of the Moon"] = "Obelisco de la Luna",
	["Obelisk of the Stars"] = "Obelisco de las Estrellas",
	["Obelisk of the Sun"] = "Obelisco del Sol",
	["O'Breen's Camp"] = "Campamento de O'Breen",
	["Observance Hall"] = "Cámara de Observancia",
	["Observation Grounds"] = "Sector de Observación",
	["Obsidian Breakers"] = "Rompiente Obsidiana",
	["Obsidian Dragonshrine"] = "Santuario de Dragones Obsidiana",
	["Obsidian Forest"] = "Bosque Obsidiana",
	["Obsidian Lair"] = "Guarida Obsidiana",
	["Obsidia's Perch"] = "Nido de Obsidia",
	["Odesyus' Landing"] = "Desembarco de Odesyus",
	["Ogri'la"] = "Ogri'la",
	["Ogri'La"] = "Ogri'la",
	["Old Hillsbrad Foothills"] = "Antiguas Laderas de Trabalomas",
	["Old Ironforge"] = "Antigua Forjaz",
	["Old Town"] = "Casco Antiguo",
	Olembas = "Olembas",
	["Olivia's Pond"] = "Estanque de Olivia",
	["Olsen's Farthing"] = "Finca de Olsen",
	Oneiros = "Oneiros",
	["One Keg"] = "Barrilia",
	["One More Glass"] = "Una Copa Más",
	["Onslaught Base Camp"] = "Campamento del Embate",
	["Onslaught Harbor"] = "Puerto del Embate",
	["Onyxia's Lair"] = "Guarida de Onyxia",
	["Oomlot Village"] = "Poblado Oomlot",
	["Oona Kagu"] = "Oona Kagu",
	Oostan = "Oostan",
	["Oostan Nord"] = "Oostan Nord",
	["Oostan Ost"] = "Oostan Ost",
	["Oostan Sor"] = "Oostan Sor",
	["Opening of the Dark Portal"] = "Apertura de El Portal Oscuro",
	["Opening of the Dark Portal Entrance"] = "Entrada de la Apertura de El Portal Oscuro",
	["Oratorium of the Voice"] = "Oratorio de la Voz",
	["Oratory of the Damned"] = "Oratorio de los Malditos",
	["Orchid Hollow"] = "Cuenca de la Orquídea",
	["Orebor Harborage"] = "Puerto Orebor",
	["Oregrind's Dig"] = "Excavación de Picamena",
	["Orendil's Retreat"] = "Refugio de Orendil",
	Orgrimmar = "Orgrimmar",
	["Orgrimmar Gunship Pandaria Start"] = "Zona de inicio de Pandaria: nave de guerra de Orgrimmar",
	["Orgrimmar Rear Gate"] = "Puerta Trasera de Orgrimmar",
	["Orgrimmar Rocketway Exchange"] = "Intercambiador de la Cohetepista de Orgrimmar",
	["Orgrim's Hammer"] = "Martillo de Orgrim",
	["Oronok's Farm"] = "Granja de Oronok",
	Orsis = "Orsis",
	["Ortell's Hideout"] = "Guarida de Ortell",
	["Oshu'gun"] = "Oshu'gun",
	["Outdoor Ruins"] = "Ruinas Exteriores",
	Outland = "Terrallende",
	["Overgrown Camp"] = "Campamento Hojarasca",
	["Overgrown Statuary"] = "Recinto de las Grandes Estatuas",
	["Owen's Wishing Well"] = "Pozo de los deseos de Owen",
	["Owl Wing Thicket"] = "Matorral del Ala del Búho",
	["Palace Antechamber"] = "Antecámara del Palacio",
	["Pal'ea"] = "Pal'ea",
	["Palemane Rock"] = "Roca Crines Pálidas",
	["Pandaren Mine"] = "Mina Pandaren",
	Pandaria = "Pandaria",
	["Pang's Stead"] = "Finca de Pang",
	["Panic Clutch"] = "Guarida del Pánico",
	["Paoquan Hollow"] = "Espesura Paoquan",
	["Parhelion Plaza"] = "Plaza del Parhelio",
	["Passage of Lost Fiends"] = "Pasaje de los Malignos Perdidos",
	["Path of a Hundred Steps"] = "Camino de los Cien Pasos",
	["Path of Conquerors"] = "Sendero de los Conquistadores",
	["Path of Enlightenment"] = "Camino de la Iluminación",
	["Path of Serenity"] = "Camino de la Serenidad",
	["Path of the Titans"] = "Senda de los Titanes",
	["Path of Uther"] = "Senda de Uther",
	["Pattymack Land"] = "Tierra de Pattymack",
	["Pauper's Walk"] = "Camino del Indigente",
	["Paur's Pub"] = "Tasca de Paur",
	["Paw'don Glade"] = "Claro Zarpa'don",
	["Paw'don Village"] = "Aldea Zarpa'don",
	["Paw'Don Village"] = "Aldea Zarpa'don", -- Needs review
	["Peak of Serenity"] = "Pico de la Serenidad",
	["Pearlfin Village"] = "Poblado Aleta de Nácar",
	["Pearl Lake"] = "Lago de Nácar",
	["Pedestal of Hope"] = "Pedestal de la Esperanza",
	["Pei-Wu Forest"] = "Bosque Pei-Wu",
	["Pestilent Scar"] = "Cicatriz Pestilente",
	["Pet Battle - Jade Forest"] = "Duelo de mascotas: El Bosque de Jade",
	["Petitioner's Chamber"] = "Cámaras de los Ruegos",
	["Pilgrim's Precipice"] = "Precipicio del Peregrino",
	["Pincer X2"] = "Tenazario X2",
	["Pinnacle of Storms"] = "Pináculo de las Tormentas",
	["Pit of Fangs"] = "Foso de los Colmillos",
	["Pit of Saron"] = "Foso de Saron",
	["Pit of Saron Entrance"] = "Entrada del Foso de Saron",
	["Plaguelands: The Scarlet Enclave"] = "Tierras de la Peste: El Enclave Escarlata",
	["Plaguemist Ravine"] = "Barranco Bruma Enferma",
	Plaguewood = "Bosque de la Peste",
	["Plaguewood Tower"] = "Torre del Bosque de la Peste",
	["Plain of Echoes"] = "Llanura de los Ecos",
	["Plain of Shards"] = "Llanura de los Fragmentos",
	["Plain of Thieves"] = "Llanura de los Ladrones",
	["Plains of Nasam"] = "Llanuras de Nasam",
	["Pod Cluster"] = "La Maraña de Cápsulas",
	["Pod Wreckage"] = "El Cementerio de Cápsulas",
	["Poison Falls"] = "Cascada Hedionda",
	["Pool of Reflection"] = "Charca del Reflejo",
	["Pool of Tears"] = "Charca de Lágrimas",
	["Pool of the Paw"] = "Poza de la Zarpa",
	["Pool of Twisted Reflections"] = "Poza de los Reflejos Distorsionados",
	["Pools of Aggonar"] = "Pozas de Aggonar",
	["Pools of Arlithrien"] = "Estanques de Arlithrien",
	["Pools of Jin'Alai"] = "Pozas de Jin'Alai",
	["Pools of Purity"] = "Pozas de la Pureza",
	["Pools of Youth"] = "Pozas de la Juventud",
	["Pools of Zha'Jin"] = "Pozas de Zha'Jin",
	["Portal Clearing"] = "Portal del Claro",
	["Pranksters' Hollow"] = "Escondrijo de los Bribones",
	["Predator's Perch"] = "Guarida del Depredador",
	["Prison of Immol'thar"] = "Prisión de Immol'thar",
	["Programmer Isle"] = "Isla del Programador",
	["Promontory Point"] = "Alto del Promontorio",
	["Prospector's Point"] = "Altozano del Prospector",
	["Protectorate Watch Post"] = "Avanzada del Protectorado",
	["Proving Grounds"] = "Terreno de Pruebas",
	["Purespring Cavern"] = "Cueva de Manantial",
	["Purgation Isle"] = "Isla del Purgatorio",
	["Pursuing the Black Harvest"] = "Tras la Cosecha Oscura",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Laboratorio Horrores y Risas Alquímicas de Putricidio",
	["Pyrewood Chapel"] = "Capilla Piroleña",
	["Pyrewood Inn"] = "Posada Piroleña",
	["Pyrewood Town Hall"] = "Concejo Piroleña",
	["Pyrewood Village"] = "Aldea Piroleña",
	["Pyrox Flats"] = "Llanos de Pirox",
	["QA and DVD"] = "QA and DVD",
	["Quagg Ridge"] = "Cresta Quagg",
	Quarry = "Cantera",
	["Quartzite Basin"] = "Cuenca de Cuarcita",
	["Queen's Gate"] = "Puerta de la Reina",
	["Quel'Danil Lodge"] = "Avanzada Quel'Danil",
	["Quel'Delar's Rest"] = "Reposo de Quel'Delar",
	["Quel'Dormir Gardens"] = "Jardines de Quel'Dormir",
	["Quel'Dormir Temple"] = "Templo de Quel'Dormir",
	["Quel'Dormir Terrace"] = "Bancal de Quel'Dormir",
	["Quel'Lithien Lodge"] = "Refugio Quel'Lithien",
	["Quel'thalas"] = "Quel'thalas",
	["Quickchop's Lumber Farm"] = "Aserradero de Hachaveloz",
	["Raastok Glade"] = "Claro Raastok",
	["Raceway Ruins"] = "Ruinas del Circuito",
	["Rageclaw Den"] = "Guarida de Garrafuria",
	["Rageclaw Lake"] = "Lago de Garrafuria",
	["Rage Fang Shrine"] = "Santuario Colmillo Iracundo",
	["Ragefeather Ridge"] = "Loma Plumira",
	["Ragefire Caverns"] = "Cavernas de Sima Ígnea",
	["Ragefire Chasm"] = "Sima Ígnea",
	["Ragefire Core"] = "Núcleo de Sima Ígnea",
	["Rage Scar Hold"] = "Dominios de los Cicatriz de Rabia",
	["Ragnaros' Lair"] = "Guarida de Ragnaros",
	["Ragnaros' Reach"] = "Tramo de Ragnaros",
	["Rainspeaker Canopy"] = "Canope de Hablalluvia",
	["Rainspeaker Rapids"] = "Rápidos de Hablalluvia",
	Ramkahen = "Ramkahen",
	["Ramkahen Legion Outpost"] = "Avanzada de la Legión Ramkahen",
	["Rampart of Skulls"] = "La Muralla de las Calaveras",
	["Ranazjar Isle"] = "Isla Ranazjar",
	["Raptor Pens"] = "Cercado de Raptores",
	["Raptor Ridge"] = "Colina del Raptor",
	["Raptor Rise"] = "Alto de Raptores",
	Ratchet = "Trinquete",
	["Rated Eye of the Storm"] = "Ojo de la Tormenta puntuado",
	["Ravaged Caravan"] = "Caravana Devastada",
	["Ravaged Crypt"] = "Cripta Devastada",
	["Ravaged Twilight Camp"] = "Campamento Crepúsculo Devastado",
	["Ravencrest Monument"] = "Monumento Cresta Cuervo",
	["Raven Hill"] = "Cerro del Cuervo",
	["Raven Hill Cemetery"] = "Cementerio del Cerro del Cuervo",
	["Ravenholdt Manor"] = "Mansión Ravenholdt",
	["Raven's Watch"] = "Guardia del Cuervo",
	["Raven's Wood"] = "Bosque del Cuervo",
	["Raynewood Retreat"] = "Refugio de la Algaba",
	["Raynewood Tower"] = "Torre de la Algaba",
	["Razaan's Landing"] = "Zona de Aterrizaje Razaan",
	["Razorfen Downs"] = "Zahúrda Rajacieno",
	["Razorfen Downs Entrance"] = "Entrada de Zahúrda Rajacieno",
	["Razorfen Kraul"] = "Horado Rajacieno",
	["Razorfen Kraul Entrance"] = "Entrada de Horado Rajacieno",
	["Razor Hill"] = "Cerrotajo",
	["Razor Hill Barracks"] = "Cuartel de Cerrotajo",
	["Razor Hill Outskirts"] = "Afueras de Cerrotajo",
	["Razor Hill Watchtower"] = "Torre de vigilancia de Cerrotajo",
	["Razormane Grounds"] = "Tierras Crines de Acero",
	["Razor Ridge"] = "Loma Tajo",
	["Razorscale's Aerie"] = "Nidal de Tajoescama",
	["Razorthorn Rise"] = "Alto Rajaespina",
	["Razorthorn Shelf"] = "Saliente Rajaespina",
	["Razorthorn Trail"] = "Senda Rajaespina",
	["Razorwind Canyon"] = "Cañón del Ventajo",
	["Rear Staging Area"] = "Área de Retaguardia",
	["Reaver's Fall"] = "Caída del Atracador Vil",
	["Reavers' Hall"] = "Cámara de los Atracadores",
	["Rebel Camp"] = "Asentamiento Rebelde",
	["Red Cloud Mesa"] = "Mesa de la Nube Roja",
	["Redpine Dell"] = "Valle Pinorrojo",
	["Redridge - Bridge Phase One"] = "Crestagrana - Primera fase del puente",
	["Redridge - Bridge Phase Two"] = "Crestagrana - Segunda fase del puente",
	["Redridge Canyons"] = "Cañones de Crestagrana",
	["Redridge Mountains"] = "Montañas Crestagrana",
	["Redridge - Orc Bomb"] = "Crestagrana - Bomba de orcos",
	["Red Rocks"] = "Roca Roja",
	["Redwood Trading Post"] = "Puesto de Venta de Madera Roja",
	Refinery = "Refinería",
	["Refugee Caravan"] = "Caravana de Refugiados",
	["Refuge Pointe"] = "Refugio de la Zaga",
	["Refuse Disposal"] = "Vertedero de Residuos",
	["Reliquary of Agony"] = "Relicario de Agonía",
	["Reliquary of Pain"] = "Relicario de Dolor",
	["Remains of Iris Lake"] = "Ruinas del Lago Iris",
	["Remains of the Fleet"] = "Restos de la Flota",
	["Remtravel's Excavation"] = "Excavación de Tripirrem",
	["Render's Camp"] = "Campamento de Render",
	["Render's Crater"] = "Cráter de Render",
	["Render's Rock"] = "Roca de Render",
	["Render's Valley"] = "Valle de Render",
	["Rensai's Watchpost"] = "Vigilancia de Rensai",
	["Rethban Caverns"] = "Cavernas de Rethban",
	["Rethress Sanctum"] = "Sagrario de Rethress",
	Reuse = "REUSE",
	["Reuse Me 7"] = "Reuse Me 7",
	["Revantusk Village"] = "Poblado Sañadiente",
	["Rhea's Camp"] = "Campamento de Rhea",
	["Rhonin's Beard"] = "Barbas de Rhonin",
	["Rhyolith Plateau"] = "Meseta de Piroclasto",
	["Ricket's Folly"] = "Locura de Ricket",
	["Ridge of Laughing Winds"] = "Cresta Viento Risueño",
	["Ridge of Madness"] = "Cresta de la Locura",
	["Ridgepoint Tower"] = "Torre de la Peña",
	Rikkilea = "Rikkilea",
	["Rikkitun Village"] = "Aldea Rikkitun",
	["Rim of the World"] = "Límite del Mundo",
	["Ring of Judgement"] = "El Círculo del Juicio",
	["Ring of Observance"] = "Círculo de la Observancia",
	["Ring of the Elements"] = "Círculo de los Elementos",
	["Ring of the Law"] = "Círculo de la Ley",
	["Riplash Ruins"] = "Ruinas Tralladón",
	["Riplash Strand"] = "Litoral Tralladón",
	["Rise of Suffering"] = "Alto del Sufrimiento",
	["Rise of the Defiler"] = "Alto de los Rapiñadores",
	["Ritual Chamber of Akali"] = "Cámara de Rituales de Akali",
	["Rivendark's Perch"] = "Nido de Desgarro Oscuro",
	Rivenwood = "El Bosque Hendido",
	["River's Heart"] = "Corazón del Río",
	["Rock of Durotan"] = "Roca de Durotan",
	["Rockpool Village"] = "Aldea Pozarroca",
	["Rocktusk Farm"] = "Granja Rocamuela",
	["Roguefeather Den"] = "Guarida Malapluma",
	["Rogues' Quarter"] = "Barrio de los Pícaros",
	["Rohemdal Pass"] = "Paso de Rohemdal",
	["Roland's Doom"] = "Condena de Roland",
	["Room of Hidden Secrets"] = "Sala de los Secretos Ocultos",
	["Roost of Ji-Kun"] = "Nidal de Ji Kun",
	["Rotbrain Encampment"] = "Campamento Pudrecerebro",
	["Royal Amphitheater"] = "Anfiteatro Real",
	["Royal Approach"] = "Senda Real",
	["Royal Exchange Auction House"] = "Casa de subastas de Intercambio Real",
	["Royal Exchange Bank"] = "Banco Real de Cambio",
	["Royal Gallery"] = "Galería Real",
	["Royal Library"] = "Archivo Real",
	["Royal Quarter"] = "Barrio Real",
	["Ruby Dragonshrine"] = "Santuario de Dragones Rubí",
	["Ruined Approach"] = "Acceso en Ruinas",
	["Ruined City Post 01"] = "Puesto 01 de la Ciudad en Ruinas",
	["Ruined Court"] = "Patio en Ruinas",
	["Ruins of Aboraz"] = "Ruinas de Aboraz",
	["Ruins of Ahmtul"] = "Ruinas de Ahmtul",
	["Ruins of Ahn'Qiraj"] = "Ruinas de Ahn'Qiraj",
	["Ruins of Alterac"] = "Ruinas de Alterac",
	["Ruins of Ammon"] = "Ruinas de Ammon",
	["Ruins of Arkkoran"] = "Ruinas de Arkkoran",
	["Ruins of Auberdine"] = "Ruinas de Auberdine",
	["Ruins of Baa'ri"] = "Ruinas de Baa'ri",
	["Ruins of Constellas"] = "Ruinas de Constellas",
	["Ruins of Dojan"] = "Ruinas de Dojan",
	["Ruins of Drakgor"] = "Ruinas de Drakgor",
	["Ruins of Drak'Zin"] = "Ruinas de Drak'Zin",
	["Ruins of Eldarath"] = "Ruinas de Eldarath",
	["Ruins of Eldarath "] = "Ruinas de Eldarath",
	["Ruins of Eldra'nath"] = "Ruinas de Eldra'nath",
	["Ruins of Eldre'thar"] = "Ruinas de Eldre'thar",
	["Ruins of Enkaat"] = "Ruinas de Enkaat",
	["Ruins of Farahlon"] = "Ruinas de Farahlon",
	["Ruins of Feathermoon"] = "Ruinas de Plumaluna",
	["Ruins of Gilneas"] = "Ruinas de Gilneas",
	["Ruins of Gilneas City"] = "Ruinas de la Ciudad de Gilneas",
	["Ruins of Guo-Lai"] = "Ruinas de Guo-Lai",
	["Ruins of Isildien"] = "Ruinas de Isildien",
	["Ruins of Jubuwal"] = "Ruinas de Jubuwal",
	["Ruins of Karabor"] = "Ruinas de Karabor",
	["Ruins of Kargath"] = "Ruinas de Kargath",
	["Ruins of Khintaset"] = "Ruinas de Khintaset",
	["Ruins of Korja"] = "Ruinas de Korja",
	["Ruins of Korune"] = "Ruinas de Korune",
	["Ruins of Lar'donir"] = "Ruinas de Lar'donir",
	["Ruins of Lordaeron"] = "Ruinas de Lordaeron",
	["Ruins of Loreth'Aran"] = "Ruinas de Loreth'Aran",
	["Ruins of Lornesta"] = "Ruinas de Lornesta",
	["Ruins of Mathystra"] = "Ruinas de Mathystra",
	["Ruins of Nordressa"] = "Ruinas de Nordressa",
	["Ruins of Ogudei"] = "Ruinas de Ogudei",
	["Ruins of Ravenwind"] = "Ruinas de Viento Azabache",
	["Ruins of Sha'naar"] = "Ruinas de Sha'naar",
	["Ruins of Shandaral"] = "Ruinas de Shandaral",
	["Ruins of Silvermoon"] = "Ruinas de Lunargenta",
	["Ruins of Solarsal"] = "Ruinas de Solarsal",
	["Ruins of Southshore"] = "Ruinas de Costasur",
	["Ruins of Taurajo"] = "Ruinas de Taurajo",
	["Ruins of Tethys"] = "Ruinas de Tethys",
	["Ruins of Thaurissan"] = "Ruinas de Thaurissan",
	["Ruins of Thelserai Temple"] = "Ruinas del Templo Thelserai",
	["Ruins of Theramore"] = "Ruinas de Theramore",
	["Ruins of the Scarlet Enclave"] = "Ruinas de El Enclave Escarlata",
	["Ruins of Uldum"] = "Ruinas de Uldum",
	["Ruins of Vashj'elan"] = "Ruinas de Vashj'elan",
	["Ruins of Vashj'ir"] = "Ruinas de Vashj'ir",
	["Ruins of Zul'Kunda"] = "Ruinas de Zul'Kunda",
	["Ruins of Zul'Mamwe"] = "Ruinas de Zul'Mamwe",
	["Ruins Rise"] = "Alto de las Ruinas",
	["Rumbling Terrace"] = "Bancal del Fragor",
	["Runestone Falithas"] = "Piedra Rúnica Falithas",
	["Runestone Shan'dor"] = "Piedra Rúnica Shan'dor",
	["Runeweaver Square"] = "Plaza Tejerruna",
	["Rustberg Village"] = "Aldea Monrojo",
	["Rustmaul Dive Site"] = "Excavación Oximelena",
	["Rutsak's Guard"] = "Guardia de Rutsak",
	["Rut'theran Village"] = "Aldea Rut'theran",
	["Ruuan Weald"] = "Foresta Ruuan",
	["Ruuna's Camp"] = "Campamento de Ruuna",
	["Ruuzel's Isle"] = "Isla de Ruuzel",
	["Rygna's Lair"] = "Guarida de Rygna",
	["Sable Ridge"] = "Cumbre Cebellina",
	["Sacrificial Altar"] = "Altar de Sacrificios",
	["Sahket Wastes"] = "Ruinas de Sahket",
	Salabria = "Salabria",
	["Saldean's Farm"] = "Finca de Saldean",
	["Saltheril's Haven"] = "Refugio de Saltheril",
	["Saltspray Glen"] = "Cañada Salobre",
	["Sanctuary of Malorne"] = "Santuario de Malorne",
	["Sanctuary of Shadows"] = "Santuario de las Sombras",
	["Sanctum of Reanimation"] = "Sagrario de Reanimación",
	["Sanctum of Shadows"] = "Sagrario de las Sombras",
	["Sanctum of the Ascended"] = "Sagrario de los Ascendientes",
	["Sanctum of the Fallen God"] = "Sagrario del Dios Caído",
	["Sanctum of the Moon"] = "Sagrario de la Luna",
	["Sanctum of the Prophets"] = "Sagrario de los Profetas",
	["Sanctum of the South Wind"] = "Sagrario del Viento del Sur",
	["Sanctum of the Stars"] = "Sagrario de las Estrellas",
	["Sanctum of the Sun"] = "Sagrario del Sol",
	["Sands of Nasam"] = "Arenas de Nasam",
	["Sandsorrow Watch"] = "Vigía Penas de Arena",
	["Sandy Beach"] = "Playa Arenosa",
	["Sandy Shallows"] = "Arrecifes Arenáceos",
	["Sanguine Chamber"] = "Cámara Sanguina",
	["Sapphire Hive"] = "Enjambre Zafiro",
	["Sapphiron's Lair"] = "Guarida de Sapphiron",
	["Saragosa's Landing"] = "Alto de Saragosa",
	Sarahland = "Sarahlandia",
	["Sardor Isle"] = "Isla de Sardor",
	Sargeron = "Sargeron",
	["Sarjun Depths"] = "Profundidades Sarjun",
	["Saronite Mines"] = "Minas de Saronita",
	["Sar'theris Strand"] = "Playa de Sar'theris",
	Satyrnaar = "Satyrnaar",
	["Saurok Creation Pit"] = "Foso de Producción de Saurok",
	["Savage Ledge"] = "Cornisa Salvaje",
	["Scalawag Point"] = "Cabo Pillastre",
	["Scalding Pools"] = "Pozas Escaldantes",
	["Scalebeard's Cave"] = "Cueva de Barbaescamas",
	["Scalewing Shelf"] = "Plataforma Alaescama",
	["Scarab Terrace"] = "Bancal del Escarabajo",
	["Scarlet Encampment"] = "Campamento Escarlata",
	["Scarlet Halls"] = "Cámaras Escarlata",
	["Scarlet Hold"] = "El Bastión Escarlata",
	["Scarlet Monastery"] = "Monasterio Escarlata",
	["Scarlet Monastery Entrance"] = "Entrada del Monasterio Escarlata",
	["Scarlet Overlook"] = "Mirador Escarlata",
	["Scarlet Palisade"] = "Acantilado Escarlata",
	["Scarlet Point"] = "Punta Escarlata",
	["Scarlet Raven Tavern"] = "Mesón del Cuervo Escarlata",
	["Scarlet Tavern"] = "Taberna Escarlata",
	["Scarlet Tower"] = "Torre Escarlata",
	["Scarlet Watch Post"] = "Atalaya Escarlata",
	["Scarlet Watchtower"] = "Torre de vigilancia Escarlata",
	["Scar of the Worldbreaker"] = "Cicatriz del Rompemundos",
	["Scarred Terrace"] = "Bancal Rajado",
	["Scenario: Alcaz Island"] = "Escenario: Isla de Alcaz",
	["Scenario - Black Ox Temple"] = "Gesta: Templo del Buey Negro",
	["Scenario - Mogu Ruins"] = "Gesta: Ruinas Mogu",
	["Scenic Overlook"] = "Mirador Pintoresco",
	["Schnottz's Frigate"] = "Fragata de Schnottz",
	["Schnottz's Hostel"] = "Hostal de Schnottz",
	["Schnottz's Landing"] = "Embarcadero de Schnottz",
	Scholomance = "Scholomance",
	["Scholomance Entrance"] = "Entrada de Scholomance",
	ScholomanceOLD = "ScholomanceOLD",
	["School of Necromancy"] = "Escuela de Nigromancia",
	["Scorched Gully"] = "Quebrada del Llanto",
	["Scott's Spooky Area"] = "Escalofrío de Scott",
	["Scoured Reach"] = "Tramo de Rozas",
	Scourgehold = "Fuerte de la Plaga",
	Scourgeholme = "Ciudad de la Plaga",
	["Scourgelord's Command"] = "Dominio del Señor de la Plaga",
	["Scrabblescrew's Camp"] = "Campamento de los Mezclatornillos",
	["Screaming Gully"] = "Quebrada del Llanto",
	["Scryer's Tier"] = "Grada del Arúspice",
	["Scuttle Coast"] = "Costa de la Huida",
	Sea = "Mar",
	Seabrush = "Malezamarina",
	["Seafarer's Tomb"] = "Tumba del Navegante",
	["Sealed Chambers"] = "Cámaras Selladas",
	["Seal of the Sun King"] = "Sello del Rey Sol",
	["Sea Mist Ridge"] = "Risco Niebla Marina",
	["Searing Gorge"] = "La Garganta de Fuego",
	["Seaspittle Cove"] = "Cala Marejada",
	["Seaspittle Nook"] = "Rincón de la Marejada",
	["Seat of Destruction"] = "Trono del Caos",
	["Seat of Knowledge"] = "Trono del Saber",
	["Seat of Life"] = "Trono de la Vida",
	["Seat of Magic"] = "Trono de la Magia",
	["Seat of Radiance"] = "Trono del Resplandor",
	["Seat of the Chosen"] = "Trono de los Elegidos",
	["Seat of the Naaru"] = "Trono de los Naaru",
	["Seat of the Spirit Waker"] = "Trono del Invocador",
	["Seeker's Folly"] = "Perdición del Explorador",
	["Seeker's Point"] = "Refugio del Explorador",
	["Sen'jin Village"] = "Poblado Sen'jin",
	["Sen'jin Village Outskirts"] = "Afueras del Poblado Sen'jin",
	["Sentinel Basecamp"] = "Campamento Base de las Centinelas",
	["Sentinel Hill"] = "Colina del Centinela",
	["Sentinel Tower"] = "Torre del Centinela",
	["Sentry Point"] = "Alto del Centinela",
	Seradane = "Seradane",
	["Serenity Falls"] = "Cataratas de la Serenidad",
	["Serpent Lake"] = "Lago Serpiente",
	["Serpent's Coil"] = "Serpiente Enroscada",
	["Serpent's Heart"] = "Corazón del Dragón",
	["Serpentshrine Cavern"] = "Caverna Santuario Serpiente",
	["Serpent's Overlook"] = "Mirador del Dragón",
	["Serpent's Spine"] = "Espinazo del Dragón",
	["Servants' Quarters"] = "Alcobas de los Sirvientes",
	["Service Entrance"] = "Entrada de Servicio",
	["Sethekk Halls"] = "Salas Sethekk",
	["Sethria's Roost"] = "Nidal de Sethria",
	["Setting Sun Garrison"] = "Baluarte del Sol Poniente",
	["Set'vess"] = "Set'vess",
	["Sewer Access Point"] = "Punto de acceso a las Cloacas",
	["Sewer Exit Pipe"] = "Tubería de Salida de las Cloacas",
	Sewers = "Cloacas",
	Shadebough = "Rama Sombría",
	["Shadewood Thicket"] = "Matorral Maderasombra",
	["Shado-Li Basin"] = "Cuenca Shado-Li",
	["Shado-Pan Fallback"] = "Retirada del Shadopan",
	["Shado-Pan Garrison"] = "Cuartel del Shadopan",
	["Shado-Pan Monastery"] = "Monasterio del Shadopan",
	["Shadowbreak Ravine"] = "Barranco Rompesombras",
	["Shadowfang Keep"] = "Castillo de Colmillo Oscuro",
	["Shadowfang Keep Entrance"] = "Entrada del Castillo de Colmillo Oscuro",
	["Shadowfang Tower"] = "Torre de Colmillo Oscuro",
	["Shadowforge City"] = "Ciudad Forjatiniebla",
	Shadowglen = "Cañada Umbría",
	["Shadow Grave"] = "Sepulcro Sombrío",
	["Shadow Hold"] = "Guarida Sombría",
	["Shadow Labyrinth"] = "Laberinto de las Sombras",
	["Shadowlurk Ridge"] = "Cresta Acechumbra",
	["Shadowmoon Valley"] = "Valle Sombraluna",
	["Shadowmoon Village"] = "Aldea Sombraluna",
	["Shadow-Pan Monastery"] = "Monasterio del Shadopan",
	["Shadowprey Village"] = "Aldea Cazasombras",
	["Shadow Ridge"] = "Cresta de las Sombras",
	["Shadowshard Cavern"] = "Cueva Fragmento Oscuro",
	["Shadowsight Tower"] = "Torre de la Vista de las Sombras",
	["Shadowsong Shrine"] = "Santuario Cantosombrío",
	["Shadowthread Cave"] = "Gruta Narácnida",
	["Shadow Tomb"] = "Tumba Umbría",
	["Shadow Wing Lair"] = "Guarida de Alasombra",
	["Shadra'Alor"] = "Shadra'Alor",
	["Shadybranch Pocket"] = "Alameda Ramasombra",
	["Shady Rest Inn"] = "Posada Reposo Umbrío",
	["Shalandis Isle"] = "Isla Shalandis",
	["Shalewind Canyon"] = "Cañón del Viento Calizo",
	["Shallow's End"] = "Confín del Bajío",
	["Shallowstep Pass"] = "Paso de la Senda Lóbrega",
	["Shalzaru's Lair"] = "Guarida de Shalzaru",
	Shamanar = "Shamanar",
	["Sha'naari Wastes"] = "Ruinas Sha'naari",
	["Shang's Stead"] = "Granja de Shang",
	["Shang's Valley"] = "Valle de Shang",
	["Shang Xi Training Grounds"] = "Campos de Entrenamiento de Shang Xi",
	["Shan'ze Dao"] = "Shan'ze Dao",
	["Shaol'mara"] = "Shaol'mara",
	["Shaol'watha"] = "Shaol'watha",
	["Shaper's Terrace"] = "Bancal del Creador",
	["Shaper's Terrace "] = "Bancal del Creador",
	["Shartuul's Transporter"] = "Transportador de Shartuul",
	["Sha'tari Base Camp"] = "Campamento Sha'tari",
	["Sha'tari Outpost"] = "Avanzada Sha'tari",
	["Shattered Convoy"] = "Comitiva Asaltada",
	["Shattered Plains"] = "Llanuras Devastadas",
	["Shattered Straits"] = "Estrecho Devastado",
	["Shattered Sun Staging Area"] = "Zona de Escala de Sol Devastado",
	["Shatter Point"] = "Puesto Devastación",
	["Shatter Scar Vale"] = "Cañada Gran Cicatriz",
	Shattershore = "Costa Quebrada",
	["Shatterspear Pass"] = "Paso Rompelanzas",
	["Shatterspear Vale"] = "Valle Rompelanzas",
	["Shatterspear War Camp"] = "Campamento de Guerra Rompelanzas",
	Shatterstone = "Ruina Pétrea",
	Shattrath = "Shattrath",
	["Shattrath City"] = "Ciudad de Shattrath",
	["Shelf of Mazu"] = "Plataforma de Mazu",
	["Shell Beach"] = "Playa del Molusco",
	["Shield Hill"] = "Colina Escudo",
	["Shields of Silver"] = "Escudos de plata",
	["Shimmering Bog"] = "Ciénaga Bruñida",
	["Shimmering Expanse"] = "Extensión Bruñida",
	["Shimmering Grotto"] = "Gruta Bruñida",
	["Shimmer Ridge"] = "Monte Luz",
	["Shindigger's Camp"] = "Campamento Machacacanillas",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Barco hacia Vashj'ir (Orgrimmar -> Vashj'ir)",
	["Shipwreck Shore"] = "Costa del Naufragio",
	Shipyard = "Astillero",
	["Shipyard - Mogu Island Progression Scenario"] = "Astillero - Gesta de progresión de la isla mogu",
	["Shok'Thokar"] = "Shok'Thokar",
	["Sholazar Basin"] = "Cuenca de Sholazar",
	["Shores of the Well"] = "Orillas del Pozo",
	["Shrine of Aessina"] = "El Santuario de Aessina",
	["Shrine of Aviana"] = "Santuario de Aviana",
	["Shrine of Dath'Remar"] = "Santuario de Dath'Remar",
	["Shrine of Dreaming Stones"] = "Santuario del Risco Soñador",
	["Shrine of Eck"] = "Santuario de Eck",
	["Shrine of Fellowship"] = "Santuario de Avenencia",
	["Shrine of Five Dawns"] = "Santuario de los Cinco Albores",
	["Shrine of Goldrinn"] = "Santuario de Goldrinn",
	["Shrine of Inner-Light"] = "Santuario de la Luz Interior",
	["Shrine of Lost Souls"] = "Santuario de las Almas Perdidas",
	["Shrine of Nala'shi"] = "Santuario de Nala'shi",
	["Shrine of Remembrance"] = "Santuario del Recuerdo",
	["Shrine of Remulos"] = "Santuario de Remulos",
	["Shrine of Scales"] = "Santuario de Escamas",
	["Shrine of Seven Stars"] = "Santuario de las Siete Estrellas",
	["Shrine of Thaurissan"] = "Ruinas de Thaurissan",
	["Shrine of the Dawn"] = "Santuario del Alba",
	["Shrine of the Deceiver"] = "Santuario del Impostor",
	["Shrine of the Dormant Flame"] = "Santuario de la Llama Latente",
	["Shrine of the Eclipse"] = "Santuario del Eclipse",
	["Shrine of the Elements"] = "Santuario de los Elementales",
	["Shrine of the Fallen Warrior"] = "Santuario del Guerrero Caído",
	["Shrine of the Five Khans"] = "Santuario de los Cinco Khans",
	["Shrine of the Merciless One"] = "Santuario del Inclemente",
	["Shrine of the Ox"] = "Santuario del Buey",
	["Shrine of Twin Serpents"] = "Santuario de los Dragones Gemelos",
	["Shrine of Two Moons"] = "Santuario de las Dos Lunas",
	["Shrine of Unending Light"] = "Santuario de Luz Inagotable",
	["Shriveled Oasis"] = "Oasis Árido",
	["Shuddering Spires"] = "Agujas Estremecedoras",
	["SI:7"] = "IV:7",
	["Siege of Niuzao Temple"] = "Asedio del Templo de Niuzao",
	["Siege Vise"] = "Torno de Asedio",
	["Siege Workshop"] = "Taller de Asedio",
	["Sifreldar Village"] = "Poblado Sifreldar",
	["Sik'vess"] = "Sik'vess",
	["Sik'vess Lair"] = "Guarida Sik'vess",
	["Silent Vigil"] = "Vigía Silencioso",
	Silithus = "Silithus",
	["Silken Fields"] = "Campos de Seda",
	["Silken Shore"] = "Costa de la Seda",
	["Silmyr Lake"] = "Lago Silmyr",
	["Silting Shore"] = "La Costa de Cieno",
	Silverbrook = "Arroyoplata",
	["Silverbrook Hills"] = "Colinas de Arroyoplata",
	["Silver Covenant Pavilion"] = "Pabellón de El Pacto de Plata",
	["Silverlight Cavern"] = "Caverna Luz de Plata",
	["Silverline Lake"] = "Lago Lineargenta",
	["Silvermoon City"] = "Ciudad de Lunargenta",
	["Silvermoon City Inn"] = "Posada de Ciudad de Lunargenta",
	["Silvermoon Finery"] = "Galas de Lunargenta",
	["Silvermoon Jewelery"] = "Joyería de Lunargenta",
	["Silvermoon Registry"] = "Registro de Lunargenta",
	["Silvermoon's Pride"] = "Orgullo de Lunargenta",
	["Silvermyst Isle"] = "Isla Bruma de Plata",
	["Silverpine Forest"] = "Bosque de Argénteos",
	["Silvershard Mines"] = "Minas Lonjaplata",
	["Silver Stream Mine"] = "Mina de Fuenteplata",
	["Silver Tide Hollow"] = "Cuenca de Marea Argenta",
	["Silver Tide Trench"] = "Zanja de Marea Argenta",
	["Silverwind Refuge"] = "Refugio Brisa de Plata",
	["Silverwing Flag Room"] = "Sala de la Bandera de Brisa de Plata",
	["Silverwing Grove"] = "Claro Ala de Plata",
	["Silverwing Hold"] = "Bastión Ala de Plata",
	["Silverwing Outpost"] = "Avanzada Ala de Plata",
	["Simply Enchanting"] = "Simplemente Encantador",
	["Sindragosa's Fall"] = "La Caída de Sindragosa",
	["Sindweller's Rise"] = "Alto del Morapecado",
	["Singing Marshes"] = "Marjal Exótico",
	["Singing Ridge"] = "Cresta Canto",
	["Sinner's Folly"] = "Locura del Pecador",
	["Sira'kess Front"] = "Frente de Sira'kess",
	["Sishir Canyon"] = "Cañón Sishir",
	["Sisters Sorcerous"] = "Hermanas Hechiceras",
	Skald = "Skald",
	["Sketh'lon Base Camp"] = "Campamento Sketh'lon",
	["Sketh'lon Wreckage"] = "Ruinas de Sketh'lon",
	["Skethyl Mountains"] = "Montañas Skethyl",
	Skettis = "Skettis",
	["Skitterweb Tunnels"] = "Túneles de Arácnidas",
	Skorn = "Skorn",
	["Skulking Row"] = "El Frontal de la Muerte",
	["Skulk Rock"] = "Roca Oculta",
	["Skull Rock"] = "Roca del Cráneo",
	["Sky Falls"] = "Cascadas del Cielo",
	["Skyguard Outpost"] = "Avanzada de la Guardia del Cielo",
	["Skyline Ridge"] = "Cresta Horizonte",
	Skyrange = "Firmamento",
	["Skysong Lake"] = "Lago Son Celeste",
	["Slabchisel's Survey"] = "Peritaje de Tallalosas",
	["Slag Watch"] = "Vigía de la Escoria",
	Slagworks = "Rescoldos",
	["Slaughter Hollow"] = "Cuenca de la Matanza",
	["Slaughter Square"] = "Plaza Degolladero",
	["Sleeping Gorge"] = "Desfiladero del Letargo",
	["Slicky Stream"] = "Arroyo Manduka",
	["Slingtail Pits"] = "Fosas Colafusta",
	["Slitherblade Shore"] = "Costa Filozante",
	["Slithering Cove"] = "Cala Serpenteante",
	["Slither Rock"] = "Roca Desliz",
	["Sludgeguard Tower"] = "Torre Guardalodo",
	["Smuggler's Scar"] = "Cicatriz del Contrabandista",
	["Snicklefritz Mine"] = "Mina de Tronafritz",
	["Snowblind Hills"] = "Colinas Veloneve",
	["Snowblind Terrace"] = "Bancal Veloneve",
	["Snowden Chalet"] = "Chalet Cubilnevado",
	["Snowdrift Dojo"] = "Dojo Ventisca Algente",
	["Snowdrift Plains"] = "Llanuras Ventisquero",
	["Snowfall Glade"] = "Claro Avalancha",
	["Snowfall Graveyard"] = "Cementerio Avalancha",
	["Socrethar's Seat"] = "Trono de Socrethar",
	["Sofera's Naze"] = "Saliente de Sofera",
	["Soggy's Gamble"] = "Lance de Aguado",
	["Solace Glade"] = "Claro del Consuelo",
	["Solliden Farmstead"] = "Hacienda Solliden",
	["Solstice Village"] = "Poblado Solsticio",
	["Sorlof's Strand"] = "Playa de Sorlof",
	["Sorrow Hill"] = "Colina de las Penas",
	["Sorrow Hill Crypt"] = "Cripta de la Colina de las Penas",
	Sorrowmurk = "Tinieblas de las Penas",
	["Sorrow Wing Point"] = "Punta Alapenas",
	["Soulgrinder's Barrow"] = "Túmulo de Moledor de Almas",
	["Southbreak Shore"] = "Tierras del Sur",
	["South Common Hall"] = "Sala Comunal Sur",
	["Southern Barrens"] = "Los Baldíos del Sur",
	["Southern Gold Road"] = "Camino del Oro Sur",
	["Southern Rampart"] = "Muralla Sur",
	["Southern Rocketway"] = "Cohetepista del Sur",
	["Southern Rocketway Terminus"] = "Terminal de la Cohetepista del Sur",
	["Southern Savage Coast"] = "Costa Salvaje del Sur",
	["Southfury River"] = "Río Furia del Sur",
	["Southfury Watershed"] = "Cuenca Furia del Sur",
	["South Gate Outpost"] = "Avanzada de la Puerta Sur",
	["South Gate Pass"] = "Paso de la Puerta Sur",
	["Southmaul Tower"] = "Torre Quiebrasur",
	["Southmoon Ruins"] = "Ruinas de Lunasur",
	["South Pavilion"] = "Pabellón sur",
	["Southpoint Gate"] = "Puerta Austral",
	["South Point Station"] = "Estación de la Punta Sur",
	["Southpoint Tower"] = "Torre Austral",
	["Southridge Beach"] = "Playa del Arrecife Sur",
	["Southsea Holdfast"] = "Sargazo de los Mares del Sur",
	["South Seas"] = "Mares del Sur",
	Southshore = "Costasur",
	["Southshore Town Hall"] = "Cabildo de Costasur",
	["South Spire"] = "Fortín del Sur",
	["South Tide's Run"] = "Cala Mareasur",
	["Southwind Cleft"] = "Grieta del Viento Sur",
	["Southwind Village"] = "Aldea del Viento del Sur",
	["Sparkrocket Outpost"] = "Avanzada de Chispamisil",
	["Sparksocket Minefield"] = "Campo de Minas Encajebujía",
	["Sparktouched Haven"] = "Retiro Pavesa",
	["Sparring Hall"] = "Sala de Entrenamiento",
	["Spearborn Encampment"] = "Campamento Lanzonato",
	Spearhead = "Punta de Lanza",
	["Speedbarge Bar"] = "Bar del Barcódromo",
	Spellsails = "Sietevelas",
	["Spinebreaker Mountains"] = "Montañas Rompeloma",
	["Spinebreaker Pass"] = "Desfiladero Rompeloma",
	["Spinebreaker Post"] = "Avanzada Rompeloma",
	["Spinebreaker Ridge"] = "Cresta Rompeloma",
	["Spiral of Thorns"] = "Espiral de las Zarzas",
	["Spire of Blood"] = "Aguja de Sangre",
	["Spire of Decay"] = "Aguja de Putrefacción",
	["Spire of Pain"] = "Aguja de Dolor",
	["Spire of Solitude"] = "Aguja de Soledad",
	["Spire Throne"] = "Trono Espiral",
	["Spirit Den"] = "Cubil del Espíritu",
	["Spirit Fields"] = "Campos de Espíritus",
	["Spirit Rise"] = "Alto de los Espíritus",
	["Spirit Rock"] = "Roca de los Espíritus",
	["Spiritsong River"] = "Río Canto Espiritual",
	["Spiritsong's Rest"] = "Reposo Canto Espiritual",
	["Spitescale Cavern"] = "Caverna Escama Maliciosa",
	["Spitescale Cove"] = "Cala Escama Maliciosa",
	["Splinterspear Junction"] = "Cruce Lanzarrota",
	Splintertree = "Hachazo",
	["Splintertree Mine"] = "Mina del Hachazo",
	["Splintertree Post"] = "Puesto del Hachazo",
	["Splithoof Crag"] = "Risco Pezuña Quebrada",
	["Splithoof Heights"] = "Cumbres Pezuña Quebrada",
	["Splithoof Hold"] = "Campamento Pezuña Quebrada",
	Sporeggar = "Esporaggar",
	["Sporewind Lake"] = "Lago Espora Volante",
	["Springtail Crag"] = "Risco Cola Saltarina",
	["Springtail Warren"] = "Gazapera Cola Saltarina",
	["Spruce Point Post"] = "Puesto del Altozano de Píceas",
	["Sra'thik Incursion"] = "Incursión Sra'thik",
	["Sra'thik Swarmdock"] = "Puerto del Enjambre Sra'thik",
	["Sra'vess"] = "Sra'vess",
	["Sra'vess Rootchamber"] = "Cámara de Raíces Sra'vess",
	["Sri-La Inn"] = "Posada de Sri-La",
	["Sri-La Village"] = "Aldea Sri-La",
	Stables = "Establos",
	Stagalbog = "Stagalbog",
	["Stagalbog Cave"] = "Cueva Stagalbog",
	["Stagecoach Crash Site"] = "Lugar del Accidente de la Diligencia",
	["Staghelm Point"] = "Punta de Corzocelada",
	["Staging Balcony"] = "Balcón de Metamorfosis",
	["Stairway to Honor"] = "Escalera del Honor",
	["Starbreeze Village"] = "Aldea Brisa Estelar",
	["Stardust Spire"] = "Aguja del Polvo Estelar",
	["Starfall Village"] = "Aldea Estrella Fugaz",
	["Stars' Rest"] = "Reposo Estelar",
	["Stasis Block: Maximus"] = "Bloque de Estasis: Maximus",
	["Stasis Block: Trion"] = "Bloque de Estasis: Trion",
	["Steam Springs"] = "Manantiales de Vapor",
	["Steamwheedle Port"] = "Puerto Bonvapor",
	["Steel Gate"] = "Las Puertas de Acero",
	["Steelgrill's Depot"] = "Almacén de Brasacerada",
	["Steeljaw's Caravan"] = "Caravana de Quijacero",
	["Steelspark Station"] = "Estación Chispacero",
	["Stendel's Pond"] = "Estanque de Stendel",
	["Stillpine Hold"] = "Bastión Semprepino",
	["Stillwater Pond"] = "Charca Aguaserena",
	["Stillwhisper Pond"] = "Charca Plácido Susurro",
	Stonard = "Rocal",
	["Stonebreaker Camp"] = "Campamento Rompepedras",
	["Stonebreaker Hold"] = "Bastión Rompepedras",
	["Stonebull Lake"] = "Lago Toro de Piedra",
	["Stone Cairn Lake"] = "Lago del Hito",
	Stonehearth = "Hogar Pétreo",
	["Stonehearth Bunker"] = "Búnker Piedrahogar",
	["Stonehearth Graveyard"] = "Cementerio Piedrahogar",
	["Stonehearth Outpost"] = "Avanzada Piedrahogar",
	["Stonemaul Hold"] = "Bastión Quebrantarrocas",
	["Stonemaul Ruins"] = "Ruinas Quebrantarrocas",
	["Stone Mug Tavern"] = "Taberna Jarra Pétrea",
	Stoneplow = "Villarroca",
	["Stoneplow Fields"] = "Campos de Villarroca",
	["Stone Sentinel's Overlook"] = "Mirador del Centinela de Piedra",
	["Stonesplinter Valley"] = "Valle Rompecantos",
	["Stonetalon Bomb"] = "Bomba del Espolón",
	["Stonetalon Mountains"] = "Sierra Espolón",
	["Stonetalon Pass"] = "Paso del Espolón",
	["Stonetalon Peak"] = "Cima del Espolón",
	["Stonewall Canyon"] = "Cañón de la Muralla",
	["Stonewall Lift"] = "Elevador del Muro de Piedra",
	["Stoneward Prison"] = "Prisión Guardapétrea",
	Stonewatch = "Petravista",
	["Stonewatch Falls"] = "Cascadas Petravista",
	["Stonewatch Keep"] = "Fuerte de Petravista",
	["Stonewatch Tower"] = "Torre de Petravista",
	["Stonewrought Dam"] = "Presa de las Tres Cabezas",
	["Stonewrought Pass"] = "Paso de Fraguapiedra",
	["Storm Cliffs"] = "Acantilados de la Tormenta",
	Stormcrest = "Crestormenta",
	["Stormfeather Outpost"] = "Avanzada Tempespluma",
	["Stormglen Village"] = "Poblado Valletormenta",
	["Storm Peaks"] = "Las Cumbres Tormentosas",
	["Stormpike Graveyard"] = "Cementerio Pico Tormenta",
	["Stormrage Barrow Dens"] = "Túmulo de Tempestira",
	["Stormsea Landing"] = "Muelle Aguaturbia",
	["Storm's Fury Wreckage"] = "Restos de la Furia de la Tormenta",
	["Stormstout Brewery"] = "Cervecería del Trueno",
	["Stormstout Brewery Interior"] = "Interior de la Cervecería del Trueno",
	["Stormstout Brewhall"] = "Sala de la Cerveza de Trueno",
	Stormwind = "Ventormenta",
	["Stormwind City"] = "Ciudad de Ventormenta",
	["Stormwind City Cemetery"] = "Cementerio de la Ciudad de Ventormenta",
	["Stormwind City Outskirts"] = "Afueras de la Ciudad de Ventormenta",
	["Stormwind Gunship Pandaria Start Area"] = "Zona de inicio de Pandaria: nave de guerra de Ventormenta",
	["Stormwind Harbor"] = "Puerto de Ventormenta",
	["Stormwind Keep"] = "Castillo de Ventormenta",
	["Stormwind Lake"] = "Lago de Ventormenta",
	["Stormwind Mountains"] = "Montañas de Ventormenta",
	["Stormwind Stockade"] = "Mazmorras de Ventormenta",
	["Stormwind Vault"] = "Cámara de Ventormenta",
	["Stoutlager Inn"] = "Pensión La Cebada",
	Strahnbrad = "Strahnbrad",
	["Strand of the Ancients"] = "Playa de los Ancestros",
	["Stranglethorn Vale"] = "Vega de Tuercespina",
	Stratholme = "Stratholme",
	["Stratholme Entrance"] = "Entrada de Stratholme",
	["Stratholme - Main Gate"] = "Stratholme: Entrada Principal",
	["Stratholme - Service Entrance"] = "Stratholme: Entrada de Servicio",
	["Stratholme Service Entrance"] = "Entrada de Servicio de Stratholme",
	["Stromgarde Keep"] = "Castillo de Stromgarde",
	["Strongarm Airstrip"] = "Pista de Aterrizaje Armafuerte",
	["STV Diamond Mine BG"] = "CB Mina de Diamantes STV",
	["Stygian Bounty"] = "Recompensa Estigia",
	["Sub zone"] = "Subzona",
	["Sulfuron Keep"] = "Fortaleza de Sulfuron",
	["Sulfuron Keep Courtyard"] = "Patio de la Fortaleza de Sulfuron",
	["Sulfuron Span"] = "Puente de Sulfuron",
	["Sulfuron Spire"] = "Aguja de Sulfuron",
	["Sullah's Sideshow"] = "Puesto de Sullah",
	["Summer's Rest"] = "Reposo Estival",
	["Summoners' Tomb"] = "Tumba del Invocador",
	["Sunblossom Hill"] = "Colina Flor de Sol",
	["Suncrown Village"] = "Aldea Corona del Sol",
	["Sundown Marsh"] = "Pantano del Ocaso",
	["Sunfire Point"] = "Punta del Fuego Solar",
	["Sunfury Hold"] = "Bastión Furia del Sol",
	["Sunfury Spire"] = "Aguja Furia del Sol",
	["Sungraze Peak"] = "Cima Rasguño de Sol",
	["Sunken Dig Site"] = "Excavación Sumergida",
	["Sunken Temple"] = "Templo Sumergido",
	["Sunken Temple Entrance"] = "Entrada del Templo Sumergido",
	["Sunreaver Pavilion"] = "Pabellón Atracasol",
	["Sunreaver's Command"] = "Dominio de los Atracasol",
	["Sunreaver's Sanctuary"] = "Santuario Atracasol",
	["Sun Rock Retreat"] = "Refugio Roca del Sol",
	["Sunsail Anchorage"] = "Fondeadero Vela del Sol",
	["Sunsoaked Meadow"] = "Prado Aguasol",
	["Sunsong Ranch"] = "Rancho Cantosol",
	["Sunspring Post"] = "Puesto Primasol",
	["Sun's Reach Armory"] = "Arsenal de Tramo del Sol",
	["Sun's Reach Harbor"] = "Puerto de Tramo del Sol",
	["Sun's Reach Sanctum"] = "Sagrario de Tramo del Sol",
	["Sunstone Terrace"] = "Bancal Piedrasol",
	["Sunstrider Isle"] = "Isla del Caminante del Sol",
	["Sunveil Excursion"] = "Excursión Velosolar",
	["Sunwatcher's Ridge"] = "Monte del Vigía del Sol",
	["Sunwell Plateau"] = "Meseta de La Fuente del Sol",
	["Supply Caravan"] = "Caravana de Provisiones",
	["Surge Needle"] = "Aguja de Flujo",
	["Surveyors' Outpost"] = "Avanzada de vigilantes",
	Surwich = "Mechasur",
	["Svarnos' Cell"] = "Celda de Svarnos",
	["Swamplight Manor"] = "Mansión Cienaluz",
	["Swamp of Sorrows"] = "Pantano de las Penas",
	["Swamprat Post"] = "Avanzada Rata del Pantano",
	["Swiftgear Station"] = "Estación Cambioveloz",
	["Swindlegrin's Dig"] = "Excavación de Timomueca",
	["Swindle Street"] = "Calle del Timo",
	["Sword's Rest"] = "Reposo de la Espada",
	Sylvanaar = "Sylvanaar",
	["Tabetha's Farm"] = "Granja de Tabetha",
	["Taelan's Tower"] = "Torre de Taelan",
	["Tahonda Ruins"] = "Ruinas de Tahonda",
	["Tahret Grounds"] = "Tierras de Tahret",
	["Tal'doren"] = "Tal'doren",
	["Talismanic Textiles"] = "Telas Talismánicas",
	["Tallmug's Camp"] = "Puesto de Jarroalto",
	["Talonbranch Glade"] = "Claro Ramaespolón",
	["Talonbranch Glade "] = "Claro Ramaespolón",
	["Talondeep Pass"] = "Desfiladero del Espolón",
	["Talondeep Vale"] = "Valle del Espolón",
	["Talon Stand"] = "Alto de la Garra",
	Talramas = "Talramas",
	["Talrendis Point"] = "Punta Talrendis",
	Tanaris = "Tanaris",
	["Tanaris Desert"] = "Desierto de Tanaris",
	["Tanks for Everything"] = "Tanques para Todo",
	["Tanner Camp"] = "Base de Peleteros",
	["Tarren Mill"] = "Molino Tarren",
	["Tasters' Arena"] = "Arena de Catadores",
	["Taunka'le Village"] = "Poblado Taunka'le",
	["Tavern in the Mists"] = "Taberna en la Niebla",
	["Tazz'Alaor"] = "Tazz'Alaor",
	["Tear Down This Wall!"] = "¡Abajo la Muralla!",
	["Teegan's Expedition"] = "Expedición de Teegan",
	["Teeming Burrow"] = "Madriguera Fecunda",
	Telaar = "Telaar",
	["Telaari Basin"] = "Cuenca Telaari",
	["Tel'athion's Camp"] = "Campamento de Tel'athion",
	Teldrassil = "Teldrassil",
	Telredor = "Telredor",
	["Tempest Bridge"] = "Puente de la Tempestad",
	["Tempest Keep"] = "El Castillo de la Tempestad",
	["Tempest Keep: The Arcatraz"] = "El Castillo de la Tempestad: El Arcatraz",
	["Tempest Keep - The Arcatraz Entrance"] = "El Castillo de la Tempestad: Entrada de El Arcatraz",
	["Tempest Keep: The Botanica"] = "El Castillo de la Tempestad: El Invernáculo",
	["Tempest Keep - The Botanica Entrance"] = "El Castillo de la Tempestad: Entrada de El Invernáculo",
	["Tempest Keep: The Mechanar"] = "El Castillo de la Tempestad: El Mechanar",
	["Tempest Keep - The Mechanar Entrance"] = "El Castillo de la Tempestad: Entrada de El Mechanar",
	["Tempest's Reach"] = "Tramo de la Tempestad",
	["Temple City of En'kilah"] = "Ciudad Templo de En'kilah",
	["Temple Hall"] = "Sala del Templo",
	["Temple of Ahn'Qiraj"] = "El Templo de Ahn'Qiraj",
	["Temple of Arkkoran"] = "Templo de Arkkoran",
	["Temple of Asaad"] = "Templo de Asaad",
	["Temple of Bethekk"] = "Templo de Bethekk",
	["Temple of Earth"] = "Templo de la Tierra",
	["Temple of Five Dawns"] = "Templo de los Cinco Albores",
	["Temple of Invention"] = "Templo de la Invención",
	["Temple of Kotmogu"] = "Templo de Kotmogu",
	["Temple of Life"] = "Templo de la Vida",
	["Temple of Order"] = "Templo del Orden",
	["Temple of Storms"] = "Templo de las Tormentas",
	["Temple of Telhamat"] = "Templo de Telhamat",
	["Temple of the Forgotten"] = "Templo de los Olvidados",
	["Temple of the Jade Serpent"] = "Templo del Dragón de Jade",
	["Temple of the Moon"] = "Templo de la Luna",
	["Temple of the Red Crane"] = "Templo de la Grulla Roja",
	["Temple of the White Tiger"] = "Templo del Tigre Blanco",
	["Temple of Uldum"] = "Templo de Uldum",
	["Temple of Winter"] = "Templo del Invierno",
	["Temple of Wisdom"] = "Templo de Sabiduría",
	["Temple of Zin-Malor"] = "Templo de Zin-Malor",
	["Temple Summit"] = "Cima del Templo",
	["Tenebrous Cavern"] = "Caverna Tenebrosa",
	["Terokkar Forest"] = "Bosque de Terokkar",
	["Terokk's Rest"] = "Sosiego de Terokk",
	["Terrace of Endless Spring"] = "Veranda de la Primavera Eterna",
	["Terrace of Gurthan"] = "Bancal Gurthan",
	["Terrace of Light"] = "Bancal de la Luz",
	["Terrace of Repose"] = "Bancal del Reposo",
	["Terrace of Ten Thunders"] = "Bancal de los Diez Truenos",
	["Terrace of the Augurs"] = "Bancal de los Augurios",
	["Terrace of the Makers"] = "Bancal de los Creadores",
	["Terrace of the Sun"] = "Bancal del Sol",
	["Terrace of the Tiger"] = "Bancal del Tigre",
	["Terrace of the Twin Dragons"] = "Aposento de los Dragones Gemelos",
	Terrordale = "Valle del Terror",
	["Terror Run"] = "Camino del Terror",
	["Terrorweb Tunnel"] = "Túnel Terroarácnido",
	["Terror Wing Path"] = "Senda del Ala del Terror",
	["Tethris Aran"] = "Tethris Aran",
	Thalanaar = "Thalanaar",
	["Thalassian Pass"] = "Desfiladero Thalassiano",
	["Thalassian Range"] = "Campo de tiro Thalassiano",
	["Thal'darah Grove"] = "Arboleda de Thal'darah",
	["Thal'darah Overlook"] = "Mirador Thal'darah",
	["Thandol Span"] = "Puente Thandol",
	["Thargad's Camp"] = "Campo de Thargad",
	["The Abandoned Reach"] = "El Tramo Abandonado",
	["The Abyssal Maw"] = "Fauce Abisal",
	["The Abyssal Shelf"] = "La Plataforma Abisal",
	["The Admiral's Den"] = "La Guarida del Almirante",
	["The Agronomical Apothecary"] = "La Botica Agronómica",
	["The Alliance Valiants' Ring"] = "La Liza de los Valerosos de la Alianza",
	["The Altar of Damnation"] = "El Altar de Condenación",
	["The Altar of Shadows"] = "El Altar de las Sombras",
	["The Altar of Zul"] = "El Altar de Zul",
	["The Amber Hibernal"] = "El Invernadero Ámbar",
	["The Amber Vault"] = "La Cámara de Ámbar",
	["The Amber Womb"] = "El Resguardo Ámbar",
	["The Ancient Grove"] = "La Antigua Arboleda",
	["The Ancient Lift"] = "El Antiguo Elevador",
	["The Ancient Passage"] = "El Pasaje Antiguo",
	["The Antechamber"] = "La Antecámara",
	["The Anvil of Conflagration"] = "El Yunque de Conflagración",
	["The Anvil of Flame"] = "El Yunque de la Llama",
	["The Apothecarium"] = "El Apothecarium",
	["The Arachnid Quarter"] = "El Arrabal Arácnido",
	["The Arboretum"] = "El Arboretum",
	["The Arcanium"] = "El Arcanium",
	["The Arcanium "] = "El Arcanium",
	["The Arcatraz"] = "El Arcatraz",
	["The Archivum"] = "El Archivum",
	["The Argent Stand"] = "El Confín Argenta",
	["The Argent Valiants' Ring"] = "La Liza de los Valerosos Argenta",
	["The Argent Vanguard"] = "La Vanguardia Argenta",
	["The Arsenal Absolute"] = "El Arsenal Absoluto",
	["The Aspirants' Ring"] = "La Liza de los Aspirantes",
	["The Assembly Chamber"] = "La Cámara de la Asamblea",
	["The Assembly of Iron"] = "La Asamblea de Hierro",
	["The Athenaeum"] = "El Athenaeum",
	["The Autumn Plains"] = "Las Llanuras Otoñales",
	["The Avalanche"] = "La Avalancha",
	["The Azure Front"] = "El Frente Azur",
	["The Bamboo Wilds"] = "Las Tierras de Bambú",
	["The Bank of Dalaran"] = "El Banco de Dalaran",
	["The Bank of Silvermoon"] = "El Banco de Lunargenta",
	["The Banquet Hall"] = "La Sala de Banquetes",
	["The Barrier Hills"] = "Las Colinas Barrera",
	["The Bastion of Twilight"] = "El Bastión del Crepúsculo",
	["The Battleboar Pen"] = "El Cercado de Jabaguerreros",
	["The Battle for Gilneas"] = "La Batalla por Gilneas",
	["The Battle for Gilneas (Old City Map)"] = "La Batalla por Gilneas (Mapa de la antigua ciudad)",
	["The Battle for Mount Hyjal"] = "La Batalla del Monte Hyjal",
	["The Battlefront"] = "El Frente de Batalla",
	["The Bazaar"] = "El Bazar",
	["The Beast Pens"] = "El Cerco de las Bestias",
	["The Beer Garden"] = "La Terraza",
	["The Bite"] = "La Dentellada",
	["The Black Breach"] = "La Brecha Negra",
	["The Black Market"] = "El Mercado Negro",
	["The Black Morass"] = "La Ciénaga Negra",
	["The Black Temple"] = "El Templo Oscuro",
	["The Black Vault"] = "Cámara Negra",
	["The Blackwald"] = "El Monte Negro",
	["The Blazing Strand"] = "La Playa Llameante",
	["The Blighted Pool"] = "La Poza Contagiada",
	["The Blight Line"] = "La Línea de Añublo",
	["The Bloodcursed Reef"] = "El Arrecife Sangre Maldita",
	["The Blood Furnace"] = "El Horno de Sangre",
	["The Bloodmire"] = "Fango de Sangre",
	["The Bloodoath"] = "El Juramento de Sangre",
	["The Blood Trail"] = "El Reguero de Sangre",
	["The Bloodwash"] = "La Playa de Sangre",
	["The Boiling Crustacean"] = "El Crustáceo Hirviente",
	["The Bombardment"] = "El Bombardeo",
	["The Bonefields"] = "Los Campos de Huesos",
	["The Bone Pile"] = "El Montón de Huesos",
	["The Bones of Nozronn"] = "Los Huesos de Nozronn",
	["The Bone Wastes"] = "El Vertedero de Huesos",
	["The Boneyard"] = "El Osario",
	["The Borean Wall"] = "La Muralla Boreal",
	["The Botanica"] = "El Invernáculo",
	["The Bradshaw Mill"] = "Molino Sotogrande",
	["The Breach"] = "La Brecha",
	["The Briny Cutter"] = "El Cúter Salobre",
	["The Briny Muck"] = "La Mugre Salobre",
	["The Briny Pinnacle"] = "El Pináculo Salobre",
	["The Broken Bluffs"] = "Riscos Quebrados",
	["The Broken Front"] = "El Frente Roto",
	["The Broken Hall"] = "Cámara Partida",
	["The Broken Hills"] = "Las Colinas Quebradas",
	["The Broken Stair"] = "La Escalera Quebrada",
	["The Broken Temple"] = "El Templo Quebrado",
	["The Broodmother's Nest"] = "El Nido de la Madre de Linaje",
	["The Brood Pit"] = "La Fosa de la Progenie",
	["The Bulwark"] = "El Baluarte",
	["The Burlap Trail"] = "La Senda Arpillera",
	["The Burlap Valley"] = "El Valle Arpillero",
	["The Burlap Waystation"] = "La Estación Arpillera",
	["The Burning Corridor"] = "El Corredor Ardiente",
	["The Butchery"] = "Carnicería",
	["The Cache of Madness"] = "El Extremo de la Locura",
	["The Caller's Chamber"] = "Cámara de la Llamada",
	["The Canals"] = "Los Canales",
	["The Cape of Stranglethorn"] = "El Cabo de Tuercespina",
	["The Carrion Fields"] = "Los Campos de Carroña",
	["The Catacombs"] = "Las Catacumbas",
	["The Cauldron"] = "La Caldera",
	["The Cauldron of Flames"] = "El Caldero de Llamas",
	["The Cave"] = "La Cueva",
	["The Celestial Planetarium"] = "El Planetario Celestial",
	["The Celestial Vault"] = "La Cámara Celestial",
	["The Celestial Watch"] = "El Mirador Celestial",
	["The Cemetary"] = "El Cementerio",
	["The Cerebrillum"] = "El Cerebelo",
	["The Charred Vale"] = "La Vega Carbonizada",
	["The Chilled Quagmire"] = "El Cenagal Escalofrío",
	["The Chum Bucket"] = "El Cubo de Cebo",
	["The Circle of Cinders"] = "El Círculo de las Cenizas",
	["The Circle of Life"] = "El Círculo de la Vida",
	["The Circle of Suffering"] = "El Círculo de Sufrimiento",
	["The Clarion Bell"] = "La Campana Clarín",
	["The Clash of Thunder"] = "El Fragor del Trueno",
	["The Clean Zone"] = "Punto de Limpieza",
	["The Cleft"] = "La Grieta",
	["The Clockwerk Run"] = "La Rampa del Engranaje",
	["The Clutch"] = "El Encierro",
	["The Clutches of Shek'zeer"] = "La Nidada de Shek'zeer",
	["The Coil"] = "El Serpenteo",
	["The Colossal Forge"] = "La Forja Colosal",
	["The Comb"] = "El Panal",
	["The Commons"] = "Ágora",
	["The Conflagration"] = "La Conflagración",
	["The Conquest Pit"] = "El Foso de la Conquista",
	["The Conservatory"] = "El Vivero",
	["The Conservatory of Life"] = "El Invernadero de Vida",
	["The Construct Quarter"] = "El Arrabal de los Ensamblajes",
	["The Cooper Residence"] = "La Residencia Cooper",
	["The Corridors of Ingenuity"] = "Los Pasillos del Ingenio",
	["The Court of Bones"] = "El Patio de los Huesos",
	["The Court of Skulls"] = "La Corte de las Calaveras",
	["The Coven"] = "El Aquelarre",
	["The Coven "] = "El Aquelarre",
	["The Creeping Ruin"] = "Las Ruinas Abyectas",
	["The Crimson Assembly Hall"] = "La Sala de la Asamblea Carmesí",
	["The Crimson Cathedral"] = "La Catedral Carmesí",
	["The Crimson Dawn"] = "El Alba Carmesí",
	["The Crimson Hall"] = "La Sala Carmesí",
	["The Crimson Reach"] = "El Tramo Carmesí",
	["The Crimson Throne"] = "El Trono Carmesí",
	["The Crimson Treader"] = "Viajero Carmesí",
	["The Crimson Veil"] = "El Velo Carmesí",
	["The Crossroads"] = "El Cruce",
	["The Crucible"] = "El Crisol",
	["The Crucible of Flame"] = "El Crisol de Llamas",
	["The Crumbling Waste"] = "Las Ruinas Desmoronadas",
	["The Cryo-Core"] = "El Crionúcleo",
	["The Crystal Hall"] = "La Sala de Cristal",
	["The Crystal Shore"] = "La Costa de Cristal",
	["The Crystal Vale"] = "La Vega de Cristal",
	["The Crystal Vice"] = "Vicio de Cristal",
	["The Culling of Stratholme"] = "La Matanza de Stratholme",
	["The Culling of Stratholme Entrance"] = "Entrada de La Matanza de Stratholme",
	["The Cursed Landing"] = "El Embarcadero Maldito",
	["The Dagger Hills"] = "Las Colinas Afiladas",
	["The Dai-Lo Farmstead"] = "La Granja de Dai-Lo",
	["The Damsel's Luck"] = "La Damisela Afortunada",
	["The Dancing Serpent"] = "El Dragón Danzante",
	["The Dark Approach"] = "El Trayecto Oscuro",
	["The Dark Defiance"] = "El Desafío Oscuro",
	["The Darkened Bank"] = "La Ribera Lóbrega",
	["The Dark Hollow"] = "El Foso Oscuro",
	["The Darkmoon Faire"] = "La Feria de la Luna Negra",
	["The Dark Portal"] = "El Portal Oscuro",
	["The Dark Rookery"] = "El Dominio Lúgubre",
	["The Darkwood"] = "Leñoscuro",
	["The Dawnchaser"] = "El Cazador del Albor",
	["The Dawning Isles"] = "Islas del Alba",
	["The Dawning Span"] = "El Puente del Amanecer",
	["The Dawning Square"] = "La Plaza Crepuscular",
	["The Dawning Stair"] = "La Escalera del Albor",
	["The Dawning Valley"] = "El Valle del Amanecer",
	["The Dead Acre"] = "El Campo Funesto",
	["The Dead Field"] = "El Campo Muerto",
	["The Dead Fields"] = "Los Campos Muertos",
	["The Deadmines"] = "Las Minas de la Muerte",
	["The Dead Mire"] = "El Lodo Muerto",
	["The Dead Scar"] = "La Cicatriz Muerta",
	["The Deathforge"] = "La Forja Muerta",
	["The Deathknell Graves"] = "Las Tumbas del Camposanto",
	["The Decrepit Fields"] = "Los Campos Decrépitos",
	["The Decrepit Flow"] = "La Corriente Decrépita",
	["The Deeper"] = "La Zanja",
	["The Deep Reaches"] = "La Hondura Insondable",
	["The Deepwild"] = "La Jungla Salvaje",
	["The Defiant"] = "El Desafiante",
	["The Defiled Chapel"] = "La Capilla Profanada",
	["The Den"] = "El Cubil",
	["The Den of Flame"] = "Cubil de la Llama",
	["The Dens of Dying"] = "Los Cubiles de los Moribundos",
	["The Dens of the Dying"] = "Los Cubiles de los Moribundos",
	["The Descent into Madness"] = "El Descenso a la Locura",
	["The Desecrated Altar"] = "El Altar Profanado",
	["The Devil's Terrace"] = "El Altar Demoniaco",
	["The Devouring Breach"] = "La Brecha Devoradora",
	["The Domicile"] = "Domicilio",
	["The Domicile "] = "Domicilio",
	["The Dooker Dome"] = "La Cúpula del Miko",
	["The Dor'Danil Barrow Den"] = "El Túmulo de Dor'danil",
	["The Dormitory"] = "Los Dormitorios",
	["The Drag"] = "La Calle Mayor",
	["The Dragonmurk"] = "El Pantano del Dragón",
	["The Dragon Wastes"] = "Baldío del Dragón",
	["The Drain"] = "El Vaciado",
	["The Dranosh'ar Blockade"] = "El Bloqueo Dranosh'ar",
	["The Drowned Reef"] = "El Arrecife Hundido",
	["The Drowned Sacellum"] = "El Templete Sumergido",
	["The Drunken Hozen"] = "El Hozen Beodo",
	["The Dry Hills"] = "Las Colinas Áridas",
	["The Dustbowl"] = "Terraseca",
	["The Dust Plains"] = "Los Yermos Polvorientos",
	["The Eastern Earthshrine"] = "El Santuario de la Tierra Oriental",
	["The Elders' Path"] = "El Camino de los Ancestros",
	["The Emerald Summit"] = "La Cumbre Esmeralda",
	["The Emperor's Approach"] = "La Vía del Emperador",
	["The Emperor's Gate"] = "Puerta del Emperador",
	["The Emperor's Reach"] = "El Tramo del Emperador",
	["The Emperor's Step"] = "El Paso del Emperador",
	["The Escape From Durnholde"] = "La Fuga de Durnholde",
	["The Escape from Durnholde Entrance"] = "Entrada de La Fuga de Durnholde",
	["The Eventide"] = "El Manto de la Noche",
	["The Exodar"] = "El Exodar",
	["The Eye"] = "El Ojo",
	["The Eye of Eternity"] = "El Ojo de la Eternidad",
	["The Eye of the Vortex"] = "El Ojo del Vórtice",
	["The Fall of Shan Bu"] = "La Caída de Shan Bu",
	["The Farstrider Lodge"] = "Cabaña del Errante",
	["The Feeding Pits"] = "Las Fosas del Ágape",
	["The Fel Pits"] = "Las Fosas Viles",
	["The Fertile Copse"] = "El Soto Fértil",
	["The Fetid Pool"] = "La Poza Fétida",
	["The Filthy Animal"] = "El Animal Roñoso",
	["The Firehawk"] = "El Halcón de Fuego",
	["The Five Sisters"] = "Las Cinco Hermanas",
	["The Flamewake"] = "La Estela Ardiente",
	["The Fleshwerks"] = "La Factoría de Carne",
	["The Flood Plains"] = "Llanuras Anegadas",
	["The Fold"] = "El Redil",
	["The Foothill Caverns"] = "Cuevas de la Ladera",
	["The Foot of Lei Shen"] = "Atrio de Lei Shen",
	["The Foot Steppes"] = "Las Estepas Inferiores",
	["The Forbidden Jungle"] = "La Jungla Prohibida",
	["The Forbidding Sea"] = "Mar Adusto",
	["The Forest of Shadows"] = "El Bosque de las Sombras",
	["The Forge of Souls"] = "La Forja de Almas",
	["The Forge of Souls Entrance"] = "Entrada de La Forja de Almas",
	["The Forge of Supplication"] = "La Forja de las Súplicas",
	["The Forge of Wills"] = "La Forja de los Deseos",
	["The Forgotten Coast"] = "La Costa Olvidada",
	["The Forgotten Overlook"] = "El Mirador Olvidado",
	["The Forgotten Pool"] = "Las Charcas del Olvido",
	["The Forgotten Pools"] = "Las Charcas del Olvido",
	["The Forgotten Shore"] = "La Orilla Olvidada",
	["The Forlorn Cavern"] = "La Caverna Abandonada",
	["The Forlorn Mine"] = "La Mina Desolada",
	["The Forsaken Front"] = "El Frente Renegado",
	["The Foul Pool"] = "La Poza del Hediondo",
	["The Frigid Tomb"] = "La Tumba Gélida",
	["The Frost Queen's Lair"] = "La Guarida de la Reina de Escarcha",
	["The Frostwing Halls"] = "Las Cámaras de Alaescarcha",
	["The Frozen Glade"] = "El Claro Helado",
	["The Frozen Halls"] = "Las Cámaras Heladas",
	["The Frozen Mine"] = "La Mina Gélida",
	["The Frozen Sea"] = "El Mar Gélido",
	["The Frozen Throne"] = "El Trono Helado",
	["The Fungal Vale"] = "Cuenca Fungal",
	["The Furnace"] = "El Horno",
	["The Gaping Chasm"] = "Sima Abierta",
	["The Gatehouse"] = "Torre de Entrada",
	["The Gatehouse "] = "Torre de Entrada",
	["The Gate of Unending Cycles"] = "La Puerta de los Ciclos Eternos",
	["The Gauntlet"] = "El Guantelete",
	["The Geyser Fields"] = "Los Campos de Géiseres",
	["The Ghastly Confines"] = "Los Confines Espectrales",
	["The Gilded Foyer"] = "El Vestíbulo Dorado",
	["The Gilded Gate"] = "La Puerta Áurea",
	["The Gilding Stream"] = "El Arroyo Áureo",
	["The Glimmering Pillar"] = "El Pilar Iluminado",
	["The Golden Gateway"] = "La Puerta Dorada",
	["The Golden Hall"] = "El Pasillo Dorado",
	["The Golden Lantern"] = "El Farol Áureo",
	["The Golden Pagoda"] = "La Pagoda Dorada",
	["The Golden Plains"] = "Las Llanuras Doradas",
	["The Golden Rose"] = "La Rosa Áurea",
	["The Golden Stair"] = "La Escalera Dorada",
	["The Golden Terrace"] = "La Terraza Áurea",
	["The Gong of Hope"] = "El Gong de la Esperanza",
	["The Grand Ballroom"] = "El Gran Salón de Baile",
	["The Grand Vestibule"] = "El Gran Vestíbulo",
	["The Great Arena"] = "La Gran Arena",
	["The Great Divide"] = "La Gran División",
	["The Great Fissure"] = "La Gran Fisura",
	["The Great Forge"] = "La Gran Fundición",
	["The Great Gate"] = "La Gran Puerta",
	["The Great Lift"] = "El Gran Elevador",
	["The Great Ossuary"] = "El Gran Osario",
	["The Great Sea"] = "Mare Magnum",
	["The Great Tree"] = "El Gran Árbol",
	["The Great Wheel"] = "La Gran Rueda",
	["The Green Belt"] = "La Franja Verde",
	["The Greymane Wall"] = "La Muralla de Cringris",
	["The Grim Guzzler"] = "Tragapenas",
	["The Grinding Quarry"] = "La Cantera Trituradora",
	["The Grizzled Den"] = "El Cubil Pardo",
	["The Grummle Bazaar"] = "El Bazar Grúmel",
	["The Guardhouse"] = "La Cárcel",
	["The Guest Chambers"] = "Los Aposentos de los Invitados",
	["The Gullet"] = "La Garganta",
	["The Halfhill Market"] = "El Mercado del Alcor",
	["The Half Shell"] = "La Media Concha",
	["The Hall of Blood"] = "La Sala de la Sangre",
	["The Hall of Gears"] = "La Sala de Máquinas",
	["The Hall of Lights"] = "La Sala de las Luces",
	["The Hall of Respite"] = "La Sala del Descanso",
	["The Hall of Statues"] = "La Estancia de las Estatuas",
	["The Hall of the Serpent"] = "La Sala del Dragón",
	["The Hall of Tiles"] = "La Estancia Enlosada",
	["The Halls of Reanimation"] = "Las Salas de la Reanimación",
	["The Halls of Winter"] = "Las Cámaras del Invierno",
	["The Hand of Gul'dan"] = "La Mano de Gul'dan",
	["The Harborage"] = "El Puerto",
	["The Hatchery"] = "El Criadero",
	["The Headland"] = "La Punta",
	["The Headlands"] = "Los Cabos",
	["The Heap"] = "La Pila",
	["The Heartland"] = "Los Cultivos Florecientes",
	["The Heart of Acherus"] = "El Corazón de Acherus",
	["The Heart of Jade"] = "El Corazón de Jade",
	["The Hidden Clutch"] = "La Guarida Oculta",
	["The Hidden Grove"] = "La Arboleda Oculta",
	["The Hidden Hollow"] = "La Hondonada Oculta",
	["The Hidden Passage"] = "El Pasaje Oculto",
	["The Hidden Reach"] = "El Tramo Oculto",
	["The Hidden Reef"] = "El Arrecife Oculto",
	["The High Path"] = "El Paso Elevado",
	["The High Road"] = "La Carretera",
	["The High Seat"] = "El Trono",
	["The Hinterlands"] = "Tierras del Interior",
	["The Hoard"] = "El Tesoro Oculto",
	["The Hole"] = "El Agujero",
	["The Horde Valiants' Ring"] = "La Liza de los Valerosos de la Horda",
	["The Horrid March"] = "La Marcha Espectral",
	["The Horsemen's Assembly"] = "La Asamblea de los Jinetes",
	["The Howling Hollow"] = "La Hondonada Aullante",
	["The Howling Oak"] = "El Roble Quejumbroso",
	["The Howling Vale"] = "Vega del Aullido",
	["The Hunter's Reach"] = "El Tramo del Cazador",
	["The Hushed Bank"] = "La Ribera Silente",
	["The Icy Depths"] = "Las Profundidades Heladas",
	["The Immortal Coil"] = "La Espiral Inmortal",
	["The Imperial Exchange"] = "El Intercambio Imperial",
	["The Imperial Granary"] = "El Granero Imperial",
	["The Imperial Mercantile"] = "El Mercado Imperial",
	["The Imperial Seat"] = "El Trono Imperial",
	["The Incursion"] = "La Incursión",
	["The Infectis Scar"] = "La Cicatriz Purulenta",
	["The Inferno"] = "El Averno",
	["The Inner Spire"] = "Aguja Interior",
	["The Intrepid"] = "El Intrépido",
	["The Inventor's Library"] = "La Biblioteca del Inventor",
	["The Iron Crucible"] = "El Crisol de Hierro",
	["The Iron Hall"] = "Cámara de Hierro",
	["The Iron Reaper"] = "La Segadora de Hierro",
	["The Isle of Spears"] = "La Isla de las Lanzas",
	["The Ivar Patch"] = "Los Dominios de Ivar",
	["The Jade Forest"] = "El Bosque de Jade",
	["The Jade Vaults"] = "Las Cámaras de Jade",
	["The Jansen Stead"] = "La Finca de Jansen",
	["The Keggary"] = "La Bodega",
	["The Kennel"] = "El Patio",
	["The Krasari Ruins"] = "Las Ruinas Krasari",
	["The Krazzworks"] = "La Krazzería",
	["The Laboratory"] = "El Laboratorio",
	["The Lady Mehley"] = "El Lady Mehley",
	["The Lagoon"] = "La Laguna",
	["The Laughing Stand"] = "La Playa Rompeolas",
	["The Lazy Turnip"] = "La Naba Perezosa",
	["The Legerdemain Lounge"] = "Salón Juego de Manos",
	["The Legion Front"] = "La Avanzadilla de la Legión",
	["Thelgen Rock"] = "Roca Thelgen",
	["The Librarium"] = "El Librarium",
	["The Library"] = "La Biblioteca",
	["The Lifebinder's Cell"] = "La Celda de la Protectora",
	["The Lifeblood Pillar"] = "El Pilar Sangrevida",
	["The Lightless Reaches"] = "Las Costas Extintas",
	["The Lion's Redoubt"] = "El Reducto del León",
	["The Living Grove"] = "La Arboleda Viviente",
	["The Living Wood"] = "El Bosque Viviente",
	["The LMS Mark II"] = "El LMS Mark II",
	["The Loch"] = "Loch Modan",
	["The Long Wash"] = "Playa del Oleaje",
	["The Lost Fleet"] = "La Flota Perdida",
	["The Lost Fold"] = "El Aprisco Perdido",
	["The Lost Isles"] = "Las Islas Perdidas",
	["The Lost Lands"] = "Las Tierras Perdidas",
	["The Lost Passage"] = "El Pasaje Perdido",
	["The Low Path"] = "El Paso Bajo",
	Thelsamar = "Thelsamar",
	["The Lucky Traveller"] = "La Fortuna del Viajero",
	["The Lyceum"] = "El Lyceum",
	["The Maclure Vineyards"] = "Los Viñedos de Maclure",
	["The Maelstrom"] = "La Vorágine",
	["The Maker's Overlook"] = "El Mirador de los Creadores",
	["The Makers' Overlook"] = "El Mirador de los Creadores",
	["The Makers' Perch"] = "El Pedestal de los Creadores",
	["The Maker's Rise"] = "El Alto de los Creadores",
	["The Maker's Terrace"] = "Bancal del Hacedor",
	["The Manufactory"] = "El Taller",
	["The Marris Stead"] = "Hacienda de Marris",
	["The Marshlands"] = "Los Pantanales",
	["The Masonary"] = "El Masón",
	["The Master's Cellar"] = "El Sótano del Maestro",
	["The Master's Glaive"] = "La Espada del Maestro",
	["The Maul"] = "La Marra",
	["The Maw of Madness"] = "Las Fauces de la Locura",
	["The Mechanar"] = "El Mechanar",
	["The Menagerie"] = "La Sala de las Fieras",
	["The Menders' Stead"] = "La Finca de los Ensalmadores",
	["The Merchant Coast"] = "La Costa Mercante",
	["The Militant Mystic"] = "El Místico Militante",
	["The Military Quarter"] = "El Arrabal Militar",
	["The Military Ward"] = "La Sala Militar",
	["The Mind's Eye"] = "El Ojo de la Mente",
	["The Mirror of Dawn"] = "El Espejo del Alba",
	["The Mirror of Twilight"] = "El Espejo del Crepúsculo",
	["The Molsen Farm"] = "La Granja de Molsen",
	["The Molten Bridge"] = "Puente de Magma",
	["The Molten Core"] = "Núcleo de Magma",
	["The Molten Fields"] = "Los Campos Fundidos",
	["The Molten Flow"] = "La Corriente de Magma",
	["The Molten Span"] = "Luz de Magma",
	["The Mor'shan Rampart"] = "La Empalizada de Mor'shan",
	["The Mor'Shan Ramparts"] = "La Empalizada de Mor'shan",
	["The Mosslight Pillar"] = "El Pilar Musgoluz",
	["The Mountain Den"] = "El Cubil de la Sierra",
	["The Murder Pens"] = "El Matadero",
	["The Mystic Ward"] = "La Sala Mística",
	["The Necrotic Vault"] = "La Cripta Necrótica",
	["The Nexus"] = "El Nexo",
	["The Nexus Entrance"] = "Entrada de El Nexo",
	["The Nightmare Scar"] = "Paraje Pesadilla",
	["The North Coast"] = "La Costa Norte",
	["The North Sea"] = "El Mar del Norte",
	["The Nosebleeds"] = "La Hemorragia",
	["The Noxious Glade"] = "El Claro Ponzoñoso",
	["The Noxious Hollow"] = "Hoya Ponzoñosa",
	["The Noxious Lair"] = "La Guarida Ponzoñosa",
	["The Noxious Pass"] = "El Paso Ponzoñoso",
	["The Oblivion"] = "El Olvido",
	["The Observation Ring"] = "El Círculo de Observación",
	["The Obsidian Sanctum"] = "El Sagrario Obsidiana",
	["The Oculus"] = "El Oculus",
	["The Oculus Entrance"] = "Entrada de El Oculus",
	["The Old Barracks"] = "El Antiguo Cuartel",
	["The Old Dormitory"] = "La Vieja Residencia",
	["The Old Port Authority"] = "Autoridades del Puerto Viejo",
	["The Opera Hall"] = "La Sala de la Ópera",
	["The Oracle Glade"] = "El Claro del Oráculo",
	["The Outer Ring"] = "El Anillo Exterior",
	["The Overgrowth"] = "La Hojarasca",
	["The Overlook"] = "La Dominancia",
	["The Overlook Cliffs"] = "Los Acantilados Dominantes",
	["The Overlook Inn"] = "La Posada del Mirador",
	["The Ox Gate"] = "La Puerta del Buey",
	["The Pale Roost"] = "El Nidal Pálido",
	["The Park"] = "El Parque",
	["The Path of Anguish"] = "El Camino del Tormento",
	["The Path of Conquest"] = "El Sendero de la Conquista",
	["The Path of Corruption"] = "El Sendero de la Corrupción",
	["The Path of Glory"] = "El Camino a la Gloria",
	["The Path of Iron"] = "La Senda de Hierro",
	["The Path of the Lifewarden"] = "La Senda del Guardián de Vida",
	["The Phoenix Hall"] = "La Cámara del Fénix",
	["The Pillar of Ash"] = "El Pilar de Ceniza",
	["The Pipe"] = "La Tubería",
	["The Pit of Criminals"] = "La Fosa de los Criminales",
	["The Pit of Fiends"] = "El Foso de los Mefistos",
	["The Pit of Narjun"] = "El Foso de Narjun",
	["The Pit of Refuse"] = "La Fosa del Rechazo",
	["The Pit of Sacrifice"] = "La Fosa de los Sacrificios",
	["The Pit of Scales"] = "El Foso de Escamas",
	["The Pit of the Fang"] = "El Foso del Colmillo",
	["The Plague Quarter"] = "El Arrabal de la Peste",
	["The Plagueworks"] = "Los Talleres de la Peste",
	["The Pool of Ask'ar"] = "La Alberca de Ask'ar",
	["The Pools of Vision"] = "Pozas de las Visiones",
	["The Prison of Yogg-Saron"] = "La Prisión de Yogg-Saron",
	["The Proving Grounds"] = "El Terreno de Pruebas",
	["The Purple Parlor"] = "El Salón Púrpura",
	["The Quagmire"] = "El Lodazal",
	["The Quaking Fields"] = "Los Campos Convulsos",
	["The Queen's Reprisal"] = "La Represalia de la Reina",
	["The Raging Chasm"] = "La Sima Enfurecida",
	Theramore = "Theramore",
	["Theramore Isle"] = "Isla Theramore",
	["Theramore's Fall"] = "Caída de Theramore",
	["Theramore's Fall (A)"] = "Caída de Theramore (A)",
	["Theramore's Fall (H)"] = "Caída de Theramore (H)",
	["Theramore's Fall Phase"] = "Fase de la Caída de Theramore",
	["The Rangers' Lodge"] = "El Refugio de los Forestales",
	["Therazane's Throne"] = "Trono de Therazane",
	["The Red Reaches"] = "Las Costas Rojas",
	["The Refectory"] = "El Refectorio",
	["The Regrowth"] = "El Brote",
	["The Reliquary"] = "El Relicario",
	["The Repository"] = "El Repositorio",
	["The Reservoir"] = "La Presa",
	["The Restless Front"] = "El Frente Inquieto",
	["The Ridge of Ancient Flame"] = "La Cresta de la Llama Ancestral",
	["The Rift"] = "La Falla",
	["The Ring of Balance"] = "El Círculo del Equilibrio",
	["The Ring of Blood"] = "El Círculo de Sangre",
	["The Ring of Champions"] = "La Liza de los Campeones",
	["The Ring of Inner Focus"] = "El Círculo del Enfoque Interno",
	["The Ring of Trials"] = "El Círculo de los Retos",
	["The Ring of Valor"] = "El Círculo del Valor",
	["The Riptide"] = "Las Mareas Vivas",
	["The Riverblade Den"] = "La Guarida Hojarrío",
	["Thermal Vents"] = "Celosía Termal",
	["The Roiling Gardens"] = "Los Jardines Turbados",
	["The Rolling Gardens"] = "Los Jardines Turbados",
	["The Rolling Plains"] = "Las Llanuras Onduladas",
	["The Rookery"] = "El Grajero",
	["The Rotting Orchard"] = "El Vergel Pútrido",
	["The Rows"] = "El Labrantío",
	["The Royal Exchange"] = "El Intercambio Real",
	["The Ruby Sanctum"] = "El Sagrario Rubí",
	["The Ruined Reaches"] = "Las Ruinas",
	["The Ruins of Kel'Theril"] = "Las Ruinas de Kel'Theril",
	["The Ruins of Ordil'Aran"] = "Las Ruinas de Ordil'Aran",
	["The Ruins of Stardust"] = "Las Ruinas del Polvo Estelar",
	["The Rumble Cage"] = "La Jaula del Rugido",
	["The Rustmaul Dig Site"] = "Excavación Oximelena",
	["The Sacred Grove"] = "La Arboleda Sagrada",
	["The Salty Sailor Tavern"] = "Taberna del Grumete Frito",
	["The Sanctum"] = "El Sagrario",
	["The Sanctum of Blood"] = "El Sagrario de Sangre",
	["The Savage Coast"] = "La Costa Salvaje",
	["The Savage Glen"] = "La Cañada Salvaje",
	["The Savage Thicket"] = "El Matorral Silvestre",
	["The Scalding Chasm"] = "La Sima Escaldante",
	["The Scalding Pools"] = "Las Pozas Escaldantes",
	["The Scarab Dais"] = "Estrado del Escarabajo",
	["The Scarab Wall"] = "El Muro del Escarabajo",
	["The Scarlet Basilica"] = "La Basílica Escarlata",
	["The Scarlet Bastion"] = "El Bastión Escarlata",
	["The Scorched Grove"] = "La Arboleda Agostada",
	["The Scorched Plain"] = "La Llanura Agostada",
	["The Scrap Field"] = "El Campo de Sobras",
	["The Scrapyard"] = "La Chatarrería",
	["The Screaming Hall"] = "La Sala del Grito",
	["The Screaming Reaches"] = "Cuenca de los Gritos",
	["The Screeching Canyon"] = "Cañón del Chirrido",
	["The Scribe of Stormwind"] = "El Escriba de Ventormenta",
	["The Scribes' Sacellum"] = "El Templete de los Escribas",
	["The Scrollkeeper's Sanctum"] = "El Sagrario del Escribiente",
	["The Scullery"] = "La Sala de Limpieza",
	["The Scullery "] = "La Antecocina",
	["The Seabolt"] = "Rayo de los Mares",
	["The Seabreach Flow"] = "El Flujo de la Brecha del Mar",
	["The Sealed Hall"] = "Cámara Sellada",
	["The Sea of Cinders"] = "El Mar de las Cenizas",
	["The Sea Reaver's Run"] = "La Travesía del Atracamar",
	["The Searing Gateway"] = "La Puerta de Fuego",
	["The Sea Wolf"] = "El Lobo de Mar",
	["The Secret Aerie"] = "El Nidal Secreto",
	["The Secret Lab"] = "El Laboratorio Secreto",
	["The Secrets of Ragefire"] = "Los Secretos de Sima Ígnea",
	["The Seer's Library"] = "La Biblioteca del Profeta",
	["The Sepulcher"] = "El Sepulcro",
	["The Severed Span"] = "Tramoduro",
	["The Sewer"] = "La Cloaca",
	["The Shadow Stair"] = "La Escalera Umbría",
	["The Shadow Throne"] = "El Trono de las Sombras",
	["The Shadow Vault"] = "La Cámara de las Sombras",
	["The Shady Nook"] = "El Rincón Lóbrego",
	["The Shaper's Terrace"] = "El Bancal del Creador",
	["The Shattered Halls"] = "Las Salas Arrasadas",
	["The Shattered Strand"] = "La Playa Arrasada",
	["The Shattered Walkway"] = "La Pasarela Devastada",
	["The Shepherd's Gate"] = "La Puerta del Pastor",
	["The Shifting Mire"] = "Lodo Traicionero",
	["The Shimmering Deep"] = "El Piélago de Sal",
	["The Shimmering Flats"] = "El Desierto de Sal",
	["The Shining Strand"] = "La Playa Plateada",
	["The Shrine of Aessina"] = "El Santuario de Aessina",
	["The Shrine of Eldretharr"] = "Santuario de Eldretharr",
	["The Silent Sanctuary"] = "El Santuario Silente",
	["The Silkwood"] = "El Sedal",
	["The Silver Blade"] = "La Espada de Plata",
	["The Silver Enclave"] = "El Enclave de Plata",
	["The Singing Grove"] = "La Arboleda Tonada",
	["The Singing Pools"] = "Las Pozas Cantarinas",
	["The Sin'loren"] = "El Sin'loren",
	["The Skeletal Reef"] = "Arrecife de Huesos",
	["The Skittering Dark"] = "Penumbra de las Celerácnidas",
	["The Skull Warren"] = "El Laberinto de Calaveras",
	["The Skunkworks"] = "La Central Secreta",
	["The Skybreaker"] = "El Rompecielos",
	["The Skyfire"] = "El Abrasacielos",
	["The Skyreach Pillar"] = "El Pilar del Trecho Celestial",
	["The Slag Pit"] = "La Fosa de la Escoria",
	["The Slaughtered Lamb"] = "El Cordero Degollado",
	["The Slaughter House"] = "El Degolladero",
	["The Slave Pens"] = "Recinto de los Esclavos",
	["The Slave Pits"] = "Los Pozos de Esclavos",
	["The Slick"] = "El Escoplo",
	["The Slithering Scar"] = "La Cicatriz Serpenteante",
	["The Slough of Dispair"] = "La Ciénaga de la Desesperación",
	["The Sludge Fen"] = "El Fangal",
	["The Sludge Fields"] = "Los Campos de Lodo",
	["The Sludgewerks"] = "Los Fangados",
	["The Solarium"] = "El Solarium",
	["The Solar Vigil"] = "La Vigilia Solar",
	["The Southern Isles"] = "Las Islas del Sur",
	["The Southern Wall"] = "La Muralla del Sur",
	["The Sparkling Crawl"] = "La Gruta Cristalina",
	["The Spark of Imagination"] = "La Chispa de la Imaginación",
	["The Spawning Glen"] = "La Cañada Emergente",
	["The Spire"] = "La Aguja",
	["The Splintered Path"] = "La Vereda Solitaria",
	["The Spring Road"] = "La Senda Florida",
	["The Stadium"] = "El Estadium",
	["The Stagnant Oasis"] = "El Oasis Estancado",
	["The Staidridge"] = "Crestaserena",
	["The Stair of Destiny"] = "Los Peldaños del Destino",
	["The Stair of Doom"] = "La Escalera Maldita",
	["The Starchaser"] = "Trotamares",
	["The Star's Bazaar"] = "El Bazar de las Estrellas",
	["The Steam Pools"] = "Las Charcas Vaporosas",
	["The Steamvault"] = "La Cámara de Vapor",
	["The Steppe of Life"] = "Las Estepas de la Vida",
	["The Steps of Fate"] = "Los Pasos del Sino",
	["The Stinging Trail"] = "La Senda del Aguijón",
	["The Stockade"] = "Las Mazmorras",
	["The Stockpile"] = "Las Reservas",
	["The Stonecore"] = "El Núcleo Pétreo",
	["The Stonecore Entrance"] = "Entrada de El Núcleo Pétreo",
	["The Stonefield Farm"] = "La Granja Pedregosa",
	["The Stone Vault"] = "El Arca Pétrea",
	["The Storehouse"] = "Almacén",
	["The Stormbreaker"] = "El Rompetormentas",
	["The Stormbridge"] = "Puente de las Tormentas",
	["The Storm Foundry"] = "La Fundición de la Tormenta",
	["The Storm Peaks"] = "Las Cumbres Tormentosas",
	["The Stormspire"] = "La Flecha de la Tormenta",
	["The Stormwright's Shelf"] = "La Plataforma del Tormentoso",
	["The Summer Fields"] = "Los Campos Estivales",
	["The Summer Terrace"] = "El Bancal del Verano",
	["The Sundered Shard"] = "El Fragmento Hendido",
	["The Sundering"] = "El Cataclismo",
	["The Sun Forge"] = "La Forja del Sol",
	["The Sunken Ring"] = "El Anillo Sumergido",
	["The Sunset Brewgarden"] = "Jardín de la Cebada Crepuscular",
	["The Sunspire"] = "La Aguja del Sol",
	["The Suntouched Pillar"] = "El Pilar Toquesol",
	["The Sunwell"] = "La Fuente del Sol",
	["The Swarming Pillar"] = "El Pilar de la Ascensión",
	["The Swollen Vault"] = "La Cripta Solemne",
	["The Tainted Forest"] = "El Bosque Corrupto",
	["The Tainted Scar"] = "Escara Impía",
	["The Talondeep Path"] = "El Paso del Espolón",
	["The Talon Den"] = "El Cubil del Espolón",
	["The Tasting Room"] = "La Sala de Catas",
	["The Tempest Rift"] = "La Falla de la Tempestad",
	["The Temple Gardens"] = "Los Jardines del Templo",
	["The Temple of Atal'Hakkar"] = "El Templo de Atal'Hakkar",
	["The Temple of the Jade Serpent"] = "El Templo del Dragón de Jade",
	["The Terrestrial Watchtower"] = "La Atalaya Terrestre",
	["The Thornsnarl"] = "El Gruñospina",
	["The Threads of Fate"] = "Los Hilos del Destino",
	["The Threshold"] = "El Umbral",
	["The Throne of Flame"] = "El Trono de la Llama",
	["The Thunder Forge"] = "La Forja del Trueno",
	["The Thunder Forges"] = "Las Forjas del Trueno",
	["The Thundering Run"] = "El Paso del Trueno",
	["The Thundering Spire"] = "La Aguja del Trueno",
	["The Thunderspire"] = "La Aguja del Trueno",
	["The Thunderwood"] = "El Bosque del Trueno",
	["The Tidebreaker"] = "El Rompemareas",
	["The Tidus Stair"] = "El Escalón de la Marea",
	["The Tiger's Peak"] = "La Cima del Tigre",
	["The Torjari Pit"] = "La Fosa Torjari",
	["The Tower of Arathor"] = "Torre de Arathor",
	["The Toxic Airfield"] = "La Base Aérea Tóxica",
	["The Trail of Devastation"] = "La Senda de la Devastación",
	["The Tranquil Grove"] = "La Arboleda Tranquila",
	["The Transitus Stair"] = "La Escalera de Tránsito",
	["The Trapper's Enclave"] = "Enclave del Trampero",
	["The Tribunal of Ages"] = "El Tribunal de los Tiempos",
	["The Tundrid Hills"] = "Las Colinas Tundra",
	["The Twilight Breach"] = "La Brecha Crepuscular",
	["The Twilight Caverns"] = "Las Cavernas Crepusculares",
	["The Twilight Citadel"] = "La Ciudadela Crepuscular",
	["The Twilight Enclave"] = "El Enclave Crepuscular",
	["The Twilight Gate"] = "La Puerta Crepuscular",
	["The Twilight Gauntlet"] = "La Vereda Crepuscular",
	["The Twilight Ridge"] = "La Cresta del Crepúsculo",
	["The Twilight Rivulet"] = "El Riachuelo Crepuscular",
	["The Twilight Withering"] = "Quebranto Crepuscular",
	["The Twin Colossals"] = "Los Dos Colosos",
	["The Twisted Glade"] = "El Claro Retorcido",
	["The Twisted Warren"] = "La Gazapera Retuerta",
	["The Two Fisted Brew"] = "Cervecería Dos Puños",
	["The Unbound Thicket"] = "El Matorral Desatado",
	["The Underbelly"] = "Los Bajos Fondos",
	["The Underbog"] = "La Sotiénaga",
	["The Underbough"] = "Ramabaja",
	["The Undercroft"] = "La Subgranja",
	["The Underhalls"] = "Las Cámaras Subterráneas",
	["The Undershell"] = "La Concha Subterránea",
	["The Uplands"] = "Las Tierras Altas",
	["The Upside-down Sinners"] = "Los Pecadores Boca Abajo",
	["The Valley of Fallen Heroes"] = "El Valle de los Héroes Caídos",
	["The Valley of Lost Hope"] = "El Valle de la Esperanza Perdida",
	["The Vault of Lights"] = "El Arca de las Luces",
	["The Vector Coil"] = "La Espiral Vectorial",
	["The Veiled Cleft"] = "La Grieta Velada",
	["The Veiled Sea"] = "Mar de la Bruma",
	["The Veiled Stair"] = "La Escalera Velada",
	["The Venture Co. Mine"] = "Mina Ventura y Cía.",
	["The Verdant Fields"] = "Los Verdegales",
	["The Verdant Thicket"] = "El Matorral Verde",
	["The Verne"] = "El Verne",
	["The Verne - Bridge"] = "El Verne - Puente",
	["The Verne - Entryway"] = "El Verne - Entrada",
	["The Vibrant Glade"] = "El Claro Vibrante",
	["The Vice"] = "El Vicio",
	["The Vicious Vale"] = "El Valle Atroz",
	["The Viewing Room"] = "La Sala de la Visión",
	["The Vile Reef"] = "El Arrecife Mortal",
	["The Violet Citadel"] = "La Ciudadela Violeta",
	["The Violet Citadel Spire"] = "Aguja de La Ciudadela Violeta",
	["The Violet Gate"] = "La Puerta Violeta",
	["The Violet Hold"] = "El Bastión Violeta",
	["The Violet Spire"] = "La Espiral Violeta",
	["The Violet Tower"] = "Torre Violeta",
	["The Vortex Fields"] = "Los Campos del Vórtice",
	["The Vortex Pinnacle"] = "La Cumbre del Vórtice",
	["The Vortex Pinnacle Entrance"] = "Entrada de La Cumbre del Vórtice",
	["The Wailing Caverns"] = "Las Cuevas de los Lamentos",
	["The Wailing Ziggurat"] = "El Zigurat de los Lamentos",
	["The Waking Halls"] = "Las Salas del Despertar",
	["The Wandering Isle"] = "La Isla Errante",
	["The Warlord's Garrison"] = "Cuartel del Señor de la Guerra",
	["The Warlord's Terrace"] = "El Bancal de los Señores de la Guerra",
	["The Warp Fields"] = "Los Campos Alabeados",
	["The Warp Piston"] = "El Pistón de Distorsión",
	["The Wavecrest"] = "La Cresta de la Ola",
	["The Weathered Nook"] = "El Hueco Perdido",
	["The Weeping Cave"] = "La Cueva del Llanto",
	["The Western Earthshrine"] = "El Santuario de la Tierra Occidental",
	["The Westrift"] = "La Falla Oeste",
	["The Whelping Downs"] = "Las Colinas de los Vástagos",
	["The Whipple Estate"] = "El Raquitismo",
	["The Wicked Coil"] = "La Espiral Maldita",
	["The Wicked Grotto"] = "La Gruta Maldita",
	["The Wicked Tunnels"] = "Los Túneles Malditos",
	["The Widening Deep"] = "La Hondonada Creciente",
	["The Widow's Clutch"] = "La Guarida de la Viuda",
	["The Widow's Wail"] = "El Lamento de la Viuda",
	["The Wild Plains"] = "Las Llanuras Salvajes",
	["The Wild Shore"] = "La Orilla Salvaje",
	["The Winding Halls"] = "Las Salas Serpenteantes",
	["The Windrunner"] = "El Brisaveloz",
	["The Windspire"] = "La Espiral de Viento",
	["The Wollerton Stead"] = "La Finca de Wollerton",
	["The Wonderworks"] = "Obras Asombrosas",
	["The Wood of Staves"] = "El Bosque de Bastones",
	["The World Tree"] = "Árbol del Mundo",
	["The Writhing Deep"] = "Las Galerías Retorcidas",
	["The Writhing Haunt"] = "El Tormento",
	["The Yaungol Advance"] = "El Avance Yaungol",
	["The Yorgen Farmstead"] = "La Hacienda Yorgen",
	["The Zandalari Vanguard"] = "La Vanguardia Zandalari",
	["The Zoram Strand"] = "La Ensenada de Zoram",
	["Thieves Camp"] = "Campamento de Ladrones",
	["Thirsty Alley"] = "Callejón Sediento",
	["Thistlefur Hold"] = "Bastión Piel de Cardo",
	["Thistlefur Village"] = "Poblado Piel de Cardo",
	["Thistleshrub Valley"] = "Valle Cardizal",
	["Thondroril River"] = "Río Thondroril",
	["Thoradin's Wall"] = "Muralla de Thoradin",
	["Thorium Advance"] = "Avance del Torio",
	["Thorium Point"] = "Puesto del Torio",
	["Thor Modan"] = "Thor Modan",
	["Thornfang Hill"] = "Colina Colmillespinado",
	["Thorn Hill"] = "Colina Espinosa",
	["Thornmantle's Hideout"] = "La Guarida de Mantospina",
	["Thorson's Post"] = "Puesto de Thorson",
	["Thorvald's Camp"] = "Campamento de Thorvald",
	["Thousand Needles"] = "Las Mil Agujas",
	Thrallmar = "Thrallmar",
	["Thrallmar Mine"] = "Mina de Thrallmar",
	["Three Corners"] = "Tres Caminos",
	["Throne of Ancient Conquerors"] = "Trono de los Antiguos Conquistadores",
	["Throne of Kil'jaeden"] = "Trono de Kil'jaeden",
	["Throne of Neptulon"] = "Trono de Neptulon",
	["Throne of the Apocalypse"] = "Trono del Apocalipsis",
	["Throne of the Damned"] = "Trono de los Condenados",
	["Throne of the Elements"] = "El Trono de los Elementos",
	["Throne of the Four Winds"] = "Trono de los Cuatro Vientos",
	["Throne of the Tides"] = "Trono de las Mareas",
	["Throne of the Tides Entrance"] = "Entrada del Trono de las Mareas",
	["Throne of Thunder"] = "Solio del Trueno",
	["Throne of Tides"] = "Trono de las Mareas",
	["Thrym's End"] = "Fin de Thrym",
	["Thunder Axe Fortress"] = "Fortaleza del Hacha de Trueno",
	Thunderbluff = "Cima del Trueno",
	["Thunder Bluff"] = "Cima del Trueno",
	["Thunderbrew Distillery"] = "Destilería Cebatruenos",
	["Thunder Cleft"] = "Grieta del Trueno",
	Thunderfall = "Truenotoño",
	["Thunder Falls"] = "Cataratas del Trueno",
	["Thunderfoot Farm"] = "Villoría Pie Atronador",
	["Thunderfoot Fields"] = "Granjas Pie Atronador",
	["Thunderfoot Inn"] = "Posada Pie Atronador",
	["Thunderfoot Ranch"] = "Rancho Pie Atronador",
	["Thunder Hold"] = "Bastión del Trueno",
	["Thunderhorn Water Well"] = "Pozo Tronacuerno",
	["Thundering Overlook"] = "Mirador Atronador",
	["Thunder Island Alliance Hub"] = "Centro de la Alianza en la Isla del Trueno",
	["Thunder King Horde Hub"] = "Centro de la Horda en la Isla del Trueno",
	["Thunder King's Citadel"] = "Ciudadela del Rey del Trueno",
	["Thunderlord Stronghold"] = "Bastión Señor del Trueno",
	Thundermar = "Bramal",
	["Thundermar Ruins"] = "Ruinas de Bramal",
	["Thunderpaw Overlook"] = "Mirador Zarpa Atronadora",
	["Thunderpaw Refuge"] = "Refugio Zarpa Atronadora",
	["Thunder Peak"] = "Pico del Trueno",
	["Thunder Ridge"] = "Monte del Trueno",
	["Thunder's Call"] = "Llamada del Trueno",
	["Thunderstrike Mountain"] = "Monte del Rayo",
	["Thunk's Abode"] = "Morada de Thunk",
	["Thuron's Livery"] = "Caballería de Thuron",
	["Tian Monastery"] = "Monasterio Tian",
	["Tidefury Cove"] = "Cala Furiamarea",
	["Tides' Hollow"] = "Hoya de la Marea",
	["Tideview Thicket"] = "Matorral Olavista",
	["Tigers' Wood"] = "Bosque del Tigre",
	["Timbermaw Hold"] = "Bastión Fauces de Madera",
	["Timbermaw Post"] = "Puesto de los Fauces de Madera",
	["Tinkers' Court"] = "Cámara Manitas",
	["Tinker Town"] = "Ciudad Manitas",
	["Tiragarde Keep"] = "Fuerte de Tiragarde",
	["Tirisfal Glades"] = "Claros de Tirisfal",
	["Tirth's Haunt"] = "Refugio de Tirth",
	["Tkashi Ruins"] = "Ruinas de Tkashi",
	["Tol Barad"] = "Tol Barad",
	["Tol Barad Peninsula"] = "Península de Tol Barad",
	["Tol'Vir Arena"] = "Arena de Tol'Vir",
	["Tol'viron Arena"] = "Arena Tol'viron",
	["Tol'Viron Arena"] = "Arena Tol'viron",
	["Tomb of Conquerors"] = "Tumba de los Conquistadores",
	["Tomb of Lights"] = "Tumba de las Luces",
	["Tomb of Secrets"] = "Tumba de los Secretos",
	["Tomb of Shadows"] = "Tumba de las Sombras",
	["Tomb of the Ancients"] = "Tumba de los Ancestros",
	["Tomb of the Earthrager"] = "Tumba del Terracundo",
	["Tomb of the Lost Kings"] = "Tumba de los Reyes Perdidos",
	["Tomb of the Sun King"] = "Tumba del Rey del Sol",
	["Tomb of the Watchers"] = "Tumba de los Vigías",
	["Tombs of the Precursors"] = "Tumbas de los Precursores",
	["Tome of the Unrepentant"] = "Libro de los Impenitentes",
	["Tome of the Unrepentant "] = "Libro de los Impenitentes",
	["Tor'kren Farm"] = "Granja Tor'kren",
	["Torp's Farm"] = "Granja de Torp",
	["Torseg's Rest"] = "Reposo de Torseg",
	["Tor'Watha"] = "Tor'Watha",
	["Toryl Estate"] = "Los Dominios Toryl",
	["Toshley's Station"] = "Estación de Toshley",
	["To the Skies!"] = "¡Hacia los Cielos!",
	["To The Skies!"] = "¡Hacia los Cielos!",
	["Tower of Althalaxx"] = "Torre de Althalaxx",
	["Tower of Azora"] = "Torre de Azora",
	["Tower of Eldara"] = "Torre de Eldara",
	["Tower of Estulan"] = "Torre de Estulan",
	["Tower of Ilgalar"] = "Torre de Ilgalar",
	["Tower of the Damned"] = "Torre de los Condenados",
	["Tower Point"] = "Torre de la Punta",
	["Tower Watch"] = "Avanzada de la Torre",
	["Town-In-A-Box"] = "Ciudad de Bolsillo",
	["Townlong Steppes"] = "Estepas de Tong Long",
	["Town Square"] = "Plaza de la Ciudad",
	["Trade District"] = "Distrito de Mercaderes",
	["Trade Quarter"] = "Barrio del Comercio",
	["Trader's Tier"] = "La Grada de los Mercaderes",
	["Tradesmen's Terrace"] = "Bancal de los Mercaderes",
	["Train Depot"] = "Depósito de Trenes",
	["Training Grounds"] = "Campo de Entrenamiento",
	["Training Quarters"] = "Salas de Entrenamiento",
	["Traitor's Cove"] = "Cala del Traidor",
	["Tranquil Coast"] = "Costa Tranquila",
	["Tranquil Gardens Cemetery"] = "Cementerio del Jardín Sereno",
	["Tranquil Grotto"] = "Confín Sereno",
	Tranquillien = "Tranquillien",
	["Tranquil Shore"] = "Orilla Tranquila",
	["Tranquil Wash"] = "Estela Tranquila",
	Transborea = "Transborea",
	["Transitus Shield"] = "Escudo de Tránsito",
	["Transport: Alliance Gunship"] = "Transporte: Nave de Guerra de la Alianza",
	["Transport: Alliance Gunship (IGB)"] = "Transporte: Nave de Guerra de la Alianza",
	["Transport: Horde Gunship"] = "Transporte: Nave de Guerra de la Horda",
	["Transport: Horde Gunship (IGB)"] = "Transporte: Nave de Guerra de la Horda",
	["Transport: Onyxia/Nefarian Elevator"] = "Transporte - Ascensor Onyxia/Nefarian",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Transporte: El Viento Poderoso (Banda de Ciudadela de la Corona de Hielo)",
	["Trelleum Mine"] = "Mina Trelleum",
	["Trial of Fire"] = "Prueba del Fuego",
	["Trial of Frost"] = "Prueba de Escarcha",
	["Trial of Shadow"] = "Prueba de las Sombras",
	["Trial of the Champion"] = "Prueba del Campeón",
	["Trial of the Champion Entrance"] = "Entrada de la Prueba del Campeón",
	["Trial of the Crusader"] = "Prueba del Cruzado",
	["Trickling Passage"] = "Paso Resbaladizo",
	["Trogma's Claim"] = "La Llamada de Trogma",
	["Trollbane Hall"] = "Bastión de Aterratrols",
	["Troll War Camp Outskirts"] = "Afueras del Campamento de Guerra Trol",
	["Trophy Hall"] = "Cámara de los Trofeos",
	["Troves of the Thunder King"] = "Los Tesoros del Rey del Trueno",
	["Trueshot Point"] = "Punta Alblanco",
	["Tuluman's Landing"] = "Alto de Tuluman",
	["Turtle Beach"] = "Playa de la Tortuga",
	["Tu Shen Burial Ground"] = "Cementerio Tu Shen",
	Tuurem = "Tuurem",
	["Twilight Aerie"] = "Nidal Crepuscular",
	["Twilight Altar of Storms"] = "Altar de la Tempestad Crepuscular",
	["Twilight Base Camp"] = "Campamento Crepúsculo",
	["Twilight Bulwark"] = "Baluarte Crepuscular",
	["Twilight Camp"] = "Campamento Crepuscular",
	["Twilight Command Post"] = "Puesto de Mando Crepuscular",
	["Twilight Crossing"] = "Cruce Crepuscular",
	["Twilight Forge"] = "Forja Crepuscular",
	["Twilight Grove"] = "Arboleda del Crepúsculo",
	["Twilight Highlands"] = "Tierras Altas Crepusculares",
	["Twilight Highlands Dragonmaw Phase"] = "Tierras Altas Crepusculares: Fase de Faucedraco",
	["Twilight Highlands Phased Entrance"] = "Entrada de Tierras Altas Crepusculares en fase",
	["Twilight Highlands Zeppelin 1"] = "Zepelín 1 de Tierras Altas Crepusculares en fase",
	["Twilight Highlands Zeppelin 2"] = "Zepelín 2 de Tierras Altas Crepusculares en fase",
	["Twilight Outpost"] = "Avanzada Crepúsculo",
	["Twilight Overlook"] = "Mirador Crepuscular",
	["Twilight Post"] = "Puesto Crepúsculo",
	["Twilight Precipice"] = "Precipicio Crepuscular",
	["Twilight Shore"] = "Orilla Crepuscular",
	["Twilight's Run"] = "Paseo Crepúsculo",
	["Twilight Terrace"] = "Bancal Crepuscular",
	["Twilight Vale"] = "Vega Crepuscular",
	["Twinbraid's Patrol"] = "Patrulla de Trenzado",
	["Twin Peaks"] = "Cumbres Gemelas",
	["Twin Shores"] = "Las Playas Gemelas",
	["Twinspire Keep"] = "Fortaleza de las Agujas Gemelas",
	["Twinspire Keep Interior"] = "Interior de la Fortaleza de las Agujas Gemelas",
	["Twin Spire Ruins"] = "Ruinas de las Agujas Gemelas",
	["Twisting Nether"] = "El Vacío Abisal",
	["Tyr's Hand"] = "Mano de Tyr",
	["Tyr's Hand Abbey"] = "Abadía de la Mano de Tyr",
	["Tyr's Terrace"] = "Bancal de Tyr",
	["Ufrang's Hall"] = "Sala de Ufrang",
	Uldaman = "Uldaman",
	["Uldaman Entrance"] = "Entrada de Uldaman",
	Uldis = "Uldis",
	Ulduar = "Ulduar",
	["Ulduar Raid - Interior - Insertion Point"] = "Banda Ulduar: Interior: Punto de Entrada",
	["Ulduar Raid - Iron Concourse"] = "Banda Ulduar: Explanada de Hierro",
	Uldum = "Uldum",
	["Uldum Phased Entrance"] = "Entrada de Uldum en fase",
	["Uldum Phase Oasis"] = "Oasis de fase de Uldum",
	["Uldum - Phase Wrecked Camp"] = "Uldum: fase del campamento arrasado",
	["Umbrafen Lake"] = "Lago Umbropantano",
	["Umbrafen Village"] = "Aldea Umbropantano",
	["Uncharted Sea"] = "Mar Inexplorado",
	Undercity = "Entrañas",
	["Underlight Canyon"] = "Cañón Sondaluz",
	["Underlight Mines"] = "Minas Sondaluz",
	["Unearthed Grounds"] = "Campos Desenterrados",
	["Unga Ingoo"] = "Unga Ingoo",
	["Un'Goro Crater"] = "Cráter de Un'Goro",
	["Unu'pe"] = "Unu'pe",
	["Unyielding Garrison"] = "Cuartel Implacable",
	["Upper Silvermarsh"] = "Marjal Argenta Superior",
	["Upper Sumprushes"] = "El Sumidero Superior",
	["Upper Veil Shil'ak"] = "Velo Shil'ak Alto",
	["Ursoc's Den"] = "El Cubil de Ursoc",
	Ursolan = "Ursolan",
	["Utgarde Catacombs"] = "Catacumbas de Utgarde",
	["Utgarde Keep"] = "Fortaleza de Utgarde",
	["Utgarde Keep Entrance"] = "Entrada de la Fortaleza de Utgarde",
	["Utgarde Pinnacle"] = "Pináculo de Utgarde",
	["Utgarde Pinnacle Entrance"] = "Entrada del Pináculo de Utgarde",
	["Uther's Tomb"] = "Tumba de Uther",
	["Valaar's Berth"] = "Atracadero de Valaar",
	["Vale of Eternal Blossoms"] = "Valle de la Flor Eterna",
	["Valgan's Field"] = "Campo de Valgan",
	Valgarde = "Valgarde",
	["Valgarde Port"] = "Puerto de Valgarde",
	Valhalas = "Valhalas",
	["Valiance Keep"] = "Fortaleza Denuedo",
	["Valiance Landing Camp"] = "Campo de Aterrizaje de Denuedo",
	["Valiant Rest"] = "Reposo Audaz",
	Valkyrion = "Valkyrion",
	["Valley of Ancient Winters"] = "Valle de los Viejos Inviernos",
	["Valley of Ashes"] = "Valle de las Cenizas",
	["Valley of Bones"] = "Valle de los Huesos",
	["Valley of Echoes"] = "Valle de los Ecos",
	["Valley of Emperors"] = "Valle de los Emperadores",
	["Valley of Fangs"] = "Valle de los Colmillos",
	["Valley of Heroes"] = "Valle de los Héroes",
	["Valley Of Heroes"] = "Valle de los Héroes",
	["Valley of Honor"] = "Valle del Honor",
	["Valley of Kings"] = "Valle de los Reyes",
	["Valley of Power"] = "Valle del Poder",
	["Valley Of Power - Scenario"] = "Gesta: Valle del Poder",
	["Valley of Spears"] = "Valle de las Lanzas",
	["Valley of Spirits"] = "Valle de los Espíritus",
	["Valley of Strength"] = "Valle de la Fuerza",
	["Valley of the Bloodfuries"] = "Valle Furia Sangrienta",
	["Valley of the Four Winds"] = "Valle de los Cuatro Vientos",
	["Valley of the Watchers"] = "Valle de los Vigías",
	["Valley of Trials"] = "Valle de los Retos",
	["Valley of Wisdom"] = "Valle de la Sabiduría",
	Valormok = "Valormok",
	["Valor's Edge"] = "Frontera del Valor",
	["Valor's Rest"] = "Sosiego del Valor",
	["Valorwind Lake"] = "Lago Ventobravo",
	["Vanguard Infirmary"] = "Enfermería de la Vanguardia",
	["Vanndir Encampment"] = "Campamento Vanndir",
	["Vargoth's Retreat"] = "Reposo de Vargoth",
	["Vashj'elan Spawning Pool"] = "Poza Emergente Vashj'elan",
	["Vashj'ir"] = "Vashj'ir",
	["Vashj'ir Sub - Alliance"] = "Submarino de Vashj'ir: Alianza",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Submarino de Vashj'ir: Alianza circulando por Fauce Abisal",
	["Vashj'ir Sub - Horde"] = "Submarino de Vashj'ir: Horda",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Submarino de Vashj'ir: Horda - Circulando por Fauce Abisal",
	["Vault of Archavon"] = "La Cámara de Archavon",
	["Vault of Ironforge"] = "Las Arcas de Forjaz",
	["Vault of Kings Past"] = "Cámara de los Reyes Inmemoriales",
	["Vault of the Ravenian"] = "Cámara del Devorador",
	["Vault of the Shadowflame"] = "Bóveda de la Llama de las Sombras",
	["Vault of Y'Shaarj"] = "Cámara de Y'Shaarj",
	["Veil Ala'rak"] = "Velo Ala'rak",
	["Veil Harr'ik"] = "Velo Harr'ik",
	["Veil Lashh"] = "Velo Lashh",
	["Veil Lithic"] = "Velo Lítico",
	["Veil Reskk"] = "Velo Reskk",
	["Veil Rhaze"] = "Velo Rhaze",
	["Veil Ruuan"] = "Velo Ruuan",
	["Veil Sethekk"] = "Velo Sethekk",
	["Veil Shalas"] = "Velo Shalas",
	["Veil Shienor"] = "Velo Shienor",
	["Veil Skith"] = "Velo Skith",
	["Veil Vekh"] = "Velo Vekh",
	["Vekhaar Stand"] = "Alto Vekhaar",
	["Velaani's Arcane Goods"] = "Artículos arcanos de Velaani",
	["Vendetta Point"] = "Punta Vendetta",
	["Vengeance Landing"] = "Campo Venganza",
	["Vengeance Landing Inn"] = "Taberna de Campo Venganza",
	["Vengeance Landing Inn, Howling Fjord"] = "Taberna de Campo Venganza, Fiordo Aquilonal",
	["Vengeance Lift"] = "Elevador de Venganza",
	["Vengeance Pass"] = "Paso Venganza",
	["Vengeance Wake"] = "Rastro Venganza",
	["Venomous Ledge"] = "Saliente Venenoso",
	Venomspite = "Rencor Venenoso",
	["Venomsting Pits"] = "Fosas Picaveneno",
	["Venomweb Vale"] = "Vega Venerácnidas",
	["Venture Bay"] = "Bahía Ventura",
	["Venture Co. Base Camp"] = "Base de Ventura y Cía.",
	["Venture Co. Operations Center"] = "Centro de Operaciones de Ventura y Cía.",
	["Verdant Belt"] = "Franja Verdeante",
	["Verdant Highlands"] = "Tierras Altas Verdes",
	["Verdantis River"] = "Río Verdantis",
	["Veridian Point"] = "Punta Veridiana",
	["Verlok Stand"] = "Alto Verlok",
	["Vermillion Redoubt"] = "Reducto Bermellón",
	["Verming Tunnels Micro"] = "Microtúneles Mur",
	["Verrall Delta"] = "Delta del Verrall",
	["Verrall River"] = "Río Verrall",
	["Victor's Point"] = "Paso del Invicto",
	["Vileprey Village"] = "Poblado Presavil",
	["Vim'gol's Circle"] = "Anillo de Vim'gol",
	["Vindicator's Rest"] = "El Reposo del Vindicador",
	["Violet Citadel Balcony"] = "Balcón de la Ciudadela Violeta",
	["Violet Hold"] = "Bastión Violeta",
	["Violet Hold Entrance"] = "Entrada de El Bastión Violeta",
	["Violet Rise"] = "El Alto Violeta",
	["Violet Stand"] = "El Confín Violeta",
	["Virmen Grotto"] = "Gruta Mur",
	["Virmen Nest"] = "Nido Mur",
	["Vir'naal Dam"] = "Presa Vir'naal",
	["Vir'naal Lake"] = "Lago Vir'naal",
	["Vir'naal Oasis"] = "Oasis Vir'naal",
	["Vir'naal River"] = "Río Vir'naal",
	["Vir'naal River Delta"] = "Delta Vir'naal",
	["Void Ridge"] = "Cresta del Vacío",
	["Voidwind Plateau"] = "Meseta del Viento del Vacío",
	["Volcanoth's Lair"] = "Guarida de Volcanoth",
	["Voldrin's Hold"] = "Bastión de Voldrin",
	Voldrune = "Runavold",
	["Voldrune Dwelling"] = "Morada Runavold",
	Voltarus = "Voltarus",
	["Vordrassil Pass"] = "Paso de Vordrassil",
	["Vordrassil's Heart"] = "Corazón de Vordrassil",
	["Vordrassil's Limb"] = "Extremidad de Vordrassil",
	["Vordrassil's Tears"] = "Lágrimas de Vordrassil",
	["Vortex Pinnacle"] = "Cumbre del Vórtice",
	["Vortex Summit"] = "Cumbre del Vórtice",
	["Vul'Gol Ogre Mound"] = "Túmulo de Vul'Gol",
	["Vyletongue Seat"] = "Trono de Lenguavil",
	["Wahl Cottage"] = "Cabaña de Wahl",
	["Wailing Caverns"] = "Cuevas de los Lamentos",
	["Walk of Elders"] = "Camino de los Ancestros",
	["Warbringer's Ring"] = "Liza del Belisario",
	["Warchief's Lookout"] = "Atalaya del Jefe de Guerra",
	["Warden's Cage"] = "Jaula de la Guardiana",
	["Warden's Chambers"] = "Aposentos del Celador",
	["Warden's Vigil"] = "Vigilia del Celador",
	["Warlock Area"] = "Zona de brujos",
	["Warmaul Hill"] = "Colina Mazo de Guerra",
	["Warpwood Quarter"] = "Barrio Alabeo",
	["War Quarter"] = "Barrio de la Guerra",
	["Warrior's Terrace"] = "Bancal del Guerrero",
	["War Room"] = "Sala de Mandos",
	Warship = "Buque de Guerra",
	["Warsong Camp"] = "Campamento Grito de Guerra",
	["Warsong Farms Outpost"] = "Avanzada de las Granjas Grito de Guerra",
	["Warsong Flag Room"] = "Sala de la Bandera Grito de Guerra",
	["Warsong Granary"] = "Granero Grito de Guerra",
	["Warsong Gulch"] = "Garganta Grito de Guerra",
	["Warsong Hold"] = "Bastión Grito de Guerra",
	["Warsong Jetty"] = "Malecón Grito de Guerra",
	["Warsong Labor Camp"] = "Campo de trabajos forzados Grito de Guerra",
	["Warsong Lumber Camp"] = "Aserradero Grito de Guerra",
	["Warsong Lumber Mill"] = "Serrería Grito de Guerra",
	["Warsong Slaughterhouse"] = "Matadero Grito de Guerra",
	["Watcher's Sanctum"] = "Sagrario del Vigía",
	["Watchers' Terrace"] = "Bancal de los Oteadores",
	["Waterspeaker's Sanctuary"] = "Santuario del Orador del Agua",
	["Waterspring Field"] = "Campo del Manantial",
	Waterworks = "Estación de Bombeo",
	["Wavestrider Beach"] = "Playa Baile de las Olas",
	Waxwood = "Bosque de Cera",
	["Wayfarer's Rest"] = "El Descanso del Caminante",
	Waygate = "Puerta",
	["Wayne's Refuge"] = "Refugio de Wayne",
	["Weazel's Crater"] = "Cráter de la Comadreja",
	["Webwinder Hollow"] = "Cuenca de las Tejedoras",
	["Webwinder Path"] = "Senda de las Tejedoras",
	["Weeping Quarry"] = "Cantera Llorosa",
	["Well of Eternity"] = "Pozo de la Eternidad",
	["Well of the Forgotten"] = "Pozo de los Olvidados",
	["Wellson Shipyard"] = "Astillero de Wellson",
	["Wellspring Hovel"] = "Cobertizo Primigenio",
	["Wellspring Lake"] = "Lago Primigenio",
	["Wellspring River"] = "Río Primigenio",
	["Westbrook Garrison"] = "Cuartel de Arroyoeste",
	["Western Bridge"] = "Puente Occidental",
	["Western Plaguelands"] = "Tierras de la Peste del Oeste",
	["Western Strand"] = "Playa del Oeste",
	Westersea = "Maroeste",
	Westfall = "Páramos de Poniente",
	["Westfall Brigade"] = "Brigada de los Páramos de Poniente",
	["Westfall Brigade Encampment"] = "Campamento de la Brigada de los Páramos de Poniente",
	["Westfall Lighthouse"] = "Faro de Poniente",
	["West Garrison"] = "Cuartel del Oeste",
	["Westguard Inn"] = "Taberna de la Guardia Oeste",
	["Westguard Keep"] = "Fortaleza de la Guardia Oeste",
	["Westguard Turret"] = "Torreta de la Guardia Oeste",
	["West Pavilion"] = "Pabellón oeste",
	["West Pillar"] = "Pilar Oeste",
	["West Point Station"] = "Estación de la Punta Oeste",
	["West Point Tower"] = "Torre de la Punta Oeste",
	["Westreach Summit"] = "Cima Tramo Oeste",
	["West Sanctum"] = "Sagrario del Oeste",
	["Westspark Workshop"] = "Taller Chispa Occidental",
	["West Spear Tower"] = "Torre Lanza del Oeste",
	["West Spire"] = "Fortín del Oeste",
	["Westwind Lift"] = "Elevador de Viento Oeste",
	["Westwind Refugee Camp"] = "Campo de Refugiados de Viento Oeste",
	["Westwind Rest"] = "Reposo Viento del Oeste",
	Wetlands = "Los Humedales",
	Wheelhouse = "Timonera",
	["Whelgar's Excavation Site"] = "Excavación de Whelgar",
	["Whelgar's Retreat"] = "Retiro de Whelgar",
	["Whispercloud Rise"] = "Alto de la Nube Susurrante",
	["Whisper Gulch"] = "Garganta Susurro",
	["Whispering Forest"] = "Bosque Susurrante",
	["Whispering Gardens"] = "Jardines de los Susurros",
	["Whispering Inlet"] = "Ensenada de los Susurros",
	["Whispering Shore"] = "Costa Murmurante",
	["Whispering Stones"] = "Rocas Susurrantes",
	["Whisperwind Grove"] = "Arboleda Susurravientos",
	["Whistling Grove"] = "Arboleda Sibilante",
	["Whitebeard's Encampment"] = "Campamento de Barbablanca",
	["Whitepetal Lake"] = "Lago Pétalo Níveo",
	["White Pine Trading Post"] = "Puesto de Venta de Pino Blanco",
	["Whitereach Post"] = "Campamento del Tramo Blanco",
	["Wildbend River"] = "Río Culebra",
	["Wildervar Mine"] = "Mina de Vildervar",
	["Wildflame Point"] = "Alto Punta Salvaje",
	["Wildgrowth Mangal"] = "Manglar Silvestre",
	["Wildhammer Flag Room"] = "Sala de la Bandera Martillo Salvaje",
	["Wildhammer Keep"] = "Fortaleza de los Martillo Salvaje",
	["Wildhammer Stronghold"] = "Bastión Martillo Salvaje",
	["Wildheart Point"] = "Alto de Corazón Salvaje",
	["Wildmane Water Well"] = "Pozo Ferocrín",
	["Wild Overlook"] = "Mirador Salvaje",
	["Wildpaw Cavern"] = "Caverna Zarpa Salvaje",
	["Wildpaw Ridge"] = "Risco Zarpa Salvaje",
	["Wilds' Edge Inn"] = "Posada Confín Salvaje",
	["Wild Shore"] = "Orilla Salvaje",
	["Wildvine Marsh"] = "Marjal de Atriplex",
	["Wildwind Lake"] = "Lago Ventosalvaje",
	["Wildwind Path"] = "Senda Ventosalvaje",
	["Wildwind Peak"] = "Cima Ventosalvaje",
	["Windbreak Canyon"] = "Cañón Rompevientos",
	["Windfury Ridge"] = "Cresta Viento Furioso",
	["Windrunner's Overlook"] = "Mirador Brisaveloz",
	["Windrunner Spire"] = "Aguja Brisaveloz",
	["Windrunner Village"] = "Aldea Brisaveloz",
	["Winds' Edge"] = "Acantilado del Céfiro",
	["Windshear Crag"] = "Risco Cortaviento",
	["Windshear Heights"] = "Altos Cortaviento",
	["Windshear Hold"] = "Bastión Cortaviento",
	["Windshear Mine"] = "Mina Cortaviento",
	["Windshear Valley"] = "Valle Cortaviento",
	["Windspire Bridge"] = "Puente Lanzaviento",
	["Windward Isle"] = "Isla de Barlovento",
	["Windy Bluffs"] = "Riscos Ventosos",
	["Windyreed Pass"] = "Paso Junco Alabeado",
	["Windyreed Village"] = "Aldea Junco Alabeado",
	["Winterax Hold"] = "Fuerte Hacha Invernal",
	["Winterbough Glade"] = "Claro Brote Invernal",
	["Winterfall Village"] = "Poblado Nevada",
	["Winterfin Caverns"] = "Cavernas Aleta Invernal",
	["Winterfin Retreat"] = "Refugio Aleta Invernal",
	["Winterfin Village"] = "Poblado Aleta Invernal",
	["Wintergarde Crypt"] = "Cripta de Hibergarde",
	["Wintergarde Keep"] = "Fortaleza de Hibergarde",
	["Wintergarde Mausoleum"] = "Mausoleo de Hibergarde",
	["Wintergarde Mine"] = "Mina de Hibergarde",
	Wintergrasp = "Conquista del Invierno",
	["Wintergrasp Fortress"] = "Fortaleza de Conquista del Invierno",
	["Wintergrasp River"] = "Río Conquista del Invierno",
	["Winterhoof Water Well"] = "Pozo Pezuña Invernal",
	["Winter's Blossom"] = "Pétalo Glacial",
	["Winter's Breath Lake"] = "Lago Aliento Invernal",
	["Winter's Edge Tower"] = "Torre Filoinvierno",
	["Winter's Heart"] = "Corazón del Invierno",
	Winterspring = "Cuna del Invierno",
	["Winter's Terrace"] = "Bancal del Invierno",
	["Witch Hill"] = "Colina de las Brujas",
	["Witch's Sanctum"] = "Sagrario de la Bruja",
	["Witherbark Caverns"] = "Cuevas Secacorteza",
	["Witherbark Village"] = "Poblado Secacorteza",
	["Withering Thicket"] = "Matorral Abrasador",
	["Wizard Row"] = "Pasaje del Zahorí",
	["Wizard's Sanctum"] = "Sagrario del Mago",
	["Wolf's Run"] = "Senda del Lobo",
	["Woodpaw Den"] = "Guarida de los Zarpaleña",
	["Woodpaw Hills"] = "Colinas Zarpaleña",
	["Wood's End Cabin"] = "Cabaña de la Espesura",
	["Woods of the Lost"] = "Bosque de los Olvidados",
	Workshop = "Taller",
	["Workshop Entrance"] = "Entrada del Taller",
	["World's End Tavern"] = "Taberna del Fin del Mundo",
	["Wrathscale Lair"] = "Guarida Escama de Cólera",
	["Wrathscale Point"] = "Punto Escama de Cólera",
	["Wreckage of the Silver Dawning"] = "Restos del Amanecer de Plata",
	["Wreck of Hellscream's Fist"] = "Restos del Puño de Grito Infernal",
	["Wreck of the Mist-Hopper"] = "Restos de El Saltanieblas",
	["Wreck of the Skyseeker"] = "Restos de El Buscacielos",
	["Wreck of the Vanguard"] = "Restos de La Vanguardia",
	["Writhing Mound"] = "Alcor Tortuoso",
	Writhingwood = "Bosquetormento",
	["Wu-Song Village"] = "Aldea Wu-Song",
	Wyrmbog = "Ciénaga de Fuego",
	["Wyrmbreaker's Rookery"] = "Grajero de Rompevermis",
	["Wyrmrest Summit"] = "Cima del Reposo del Dragón",
	["Wyrmrest Temple"] = "Templo del Reposo del Dragón",
	["Wyrmrest Temple - bottom to middle"] = "Templo del Reposo del Dragón - de abajo a la mitad",
	["Wyrmrest Temple - bottom to top"] = "Templo del Reposo del Dragón - de abajo a arriba",
	["Wyrmrest Temple - middle to bottom"] = "Templo del Reposo del Dragón – de la mitad abajo",
	["Wyrmrest Temple - middle to top"] = "Templo del Reposo del Dragón – de la mitad a arriba",
	["Wyrmrest Temple - top to bottom"] = "Templo del Reposo del Dragón - de arriba a abajo",
	["Wyrmrest Temple - top to middle"] = "Templo del Reposo del Dragón - de arriba a la mitad",
	["Wyrms' Bend"] = "Recodo de Vermis",
	["Wyrmscar Island"] = "Isla Cicatriz de Vermis",
	["Wyrmskull Bridge"] = "Puente Calavermis",
	["Wyrmskull Tunnel"] = "Túnel Calavermis",
	["Wyrmskull Village"] = "Poblado Calavermis",
	["X-2 Pincer"] = "Tenazario X2",
	Xavian = "Xavian",
	["Yan-Zhe River"] = "Río Yan-Zhe",
	["Yeti Mountain Basecamp"] = "Campamento de Montaña Yeti",
	["Yinying Village"] = "Aldea Yinying",
	Ymirheim = "Ymirheim",
	["Ymiron's Seat"] = "Trono de Ymiron",
	["Yojamba Isle"] = "Isla Yojamba",
	["Yowler's Den"] = "Cubil de Ululante",
	["Zabra'jin"] = "Zabra'jin",
	["Zaetar's Choice"] = "Elección de Zaetar",
	["Zaetar's Grave"] = "Tumba de Zaetar",
	["Zalashji's Den"] = "Guarida de Zalashji",
	["Zalazane's Fall"] = "Caída de Zalazane",
	["Zane's Eye Crater"] = "Cráter del Ojo de Zane",
	Zangarmarsh = "Marisma de Zangar",
	["Zangar Ridge"] = "Loma de Zangar",
	["Zan'vess"] = "Zan'vess",
	["Za'Tual"] = "Za'Tual",
	["Zeb'Halak"] = "Zeb'Halak",
	["Zeb'Nowa"] = "Zeb'Nowa",
	["Zeb'Sora"] = "Zeb'Sora",
	["Zeb'Tela"] = "Zeb'Tela",
	["Zeb'tula"] = "Zeb'tula",
	["Zeb'Watha"] = "Zeb'Watha",
	["Zeppelin Crash"] = "Zepelín Caído",
	Zeramas = "Zeramas",
	["Zeth'Gor"] = "Zeth'Gor",
	["Zhu Province"] = "Provincia Zhu",
	["Zhu's Descent"] = "Descenso de Zhu",
	["Zhu's Watch"] = "Atalaya de Zhu",
	["Ziata'jai Ruins"] = "Ruinas de Ziata'jai",
	["Zim'Abwa"] = "Zim'Abwa",
	["Zim'bo's Hideout"] = "Guarida de Zim'bo",
	["Zim'Rhuk"] = "Zim'Rhuk",
	["Zim'Torga"] = "Zim'Torga",
	["Zol'Heb"] = "Zol'Heb",
	["Zol'Maz Stronghold"] = "Bastión de Zol'Maz",
	["Zoram'gar Outpost"] = "Avanzada de Zoram'gar",
	["Zouchin Province"] = "Provincia Zouchin",
	["Zouchin Strand"] = "Playa Zouchin",
	["Zouchin Village"] = "Aldea Zouchin",
	["Zul'Aman"] = "Zul'Aman",
	["Zul'Drak"] = "Zul'Drak",
	["Zul'Farrak"] = "Zul'Farrak",
	["Zul'Farrak Entrance"] = "Entrada de Zul'Farrak",
	["Zul'Gurub"] = "Zul'Gurub",
	["Zul'Mashar"] = "Zul'Mashar",
	["Zun'watha"] = "Zun'watha",
	["Zuuldaia Ruins"] = "Ruinas Zuuldaia",
}

elseif GAME_LOCALE == "esES" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "Campamento base de la Séptima Legión",
	["7th Legion Front"] = "Frente de la Séptima Legión",
	["7th Legion Submarine"] = "Submarino de la Séptima Legión",
	["Abandoned Armory"] = "Armería Abandonada",
	["Abandoned Camp"] = "Campamento Abandonado",
	["Abandoned Mine"] = "Mina Abandonada",
	["Abandoned Reef"] = "Arrecife Abandonado",
	["Above the Frozen Sea"] = "Sobre El Mar Gélido",
	["A Brewing Storm"] = "Cervezas y Truenos",
	["Abyssal Breach"] = "Brecha Abisal",
	["Abyssal Depths"] = "Profundidades Abisales",
	["Abyssal Halls"] = "Cámaras Abisales",
	["Abyssal Maw"] = "Fauce Abisal",
	["Abyssal Maw Exterior"] = "Fauce Abisal Exterior",
	["Abyssal Sands"] = "Arenas Abisales",
	["Abyssion's Lair"] = "Guarida de Abismion",
	["Access Shaft Zeon"] = "Eje de Acceso Zeon",
	["Acherus: The Ebon Hold"] = "Acherus: El Bastión de Ébano",
	["Addle's Stead"] = "Granja de Addle",
	["Aderic's Repose"] = "Reposo de Aderic",
	["Aerie Peak"] = "Pico Nidal",
	["Aeris Landing"] = "Desembarco Aeris",
	["Agamand Family Crypt"] = "Cripta de la Familia Agamand",
	["Agamand Mills"] = "Molinos de Agamand",
	["Agmar's Hammer"] = "Martillo de Agmar",
	["Agmond's End"] = "El Final de Agmond",
	["Agol'watha"] = "Agol'watha",
	["A Hero's Welcome"] = "La Bienvenida de un Héroe",
	["Ahn'kahet: The Old Kingdom"] = "Ahn'kahet: El Antiguo Reino",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Ahn'kahet: Entrada de El Antiguo Reino",
	["Ahn Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj Temple"] = "Templo de Ahn'Qiraj",
	["Ahn'Qiraj Terrace"] = "Bancal de Ahn'Qiraj",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ahn'Qiraj: El Reino Caído",
	["Akhenet Fields"] = "Campos de Akhenet",
	["Aku'mai's Lair"] = "Guarida de Aku'mai",
	["Alabaster Shelf"] = "Saliente Alabastro",
	["Alcaz Island"] = "Isla de Alcaz",
	["Aldor Rise"] = "Alto Aldor",
	Aldrassil = "Aldrassil",
	["Aldur'thar: The Desolation Gate"] = "Aldur'thar: La Puerta de la Desolación",
	["Alexston Farmstead"] = "Hacienda de Alexston",
	["Algaz Gate"] = "Puerta de Algaz",
	["Algaz Station"] = "Estación de Algaz",
	["A Little Patience"] = "Templanza",
	["Allen Farmstead"] = "Hacienda de Allen",
	["Allerian Post"] = "Puesto Allerian",
	["Allerian Stronghold"] = "Bastión Allerian",
	["Alliance Base"] = "Base de la Alianza",
	["Alliance Beach Daily Area"] = "Zona de diarias de playa de la Alianza",
	["Alliance Beachhead"] = "Desembarco de la Alianza",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Centro de la Alianza - Gesta de progresión de la isla mogu",
	["Alliance Keep"] = "Fortaleza de la Alianza",
	["Alliance Mercenary Ship to Vashj'ir"] = "Barco mercenario de la Alianza a Vashj'ir",
	["Alliance PVP Barracks"] = "Cuartel JcJ de la Alianza",
	["All That Glitters Prospecting Co."] = "Prospecciones Todo lo Que Brilla y Cía.",
	["Alonsus Chapel"] = "Capilla de Alonsus",
	["Altar of Ascension"] = "Altar de la Ascensión",
	["Altar of Har'koa"] = "Altar de Har'koa",
	["Altar of Mam'toth"] = "Altar de Mam'toth",
	["Altar of Quetz'lun"] = "Altar de Quetz'lun",
	["Altar of Rhunok"] = "Altar de Rhunok",
	["Altar of Sha'tar"] = "Altar de Sha'tar",
	["Altar of Sseratus"] = "Altar de Sseratus",
	["Altar of Storms"] = "Altar de la Tempestad",
	["Altar of the Blood God"] = "Altar del Dios de la Sangre",
	["Altar of Twilight"] = "Altar del Crepúsculo",
	["Alterac Mountains"] = "Montañas de Alterac",
	["Alterac Valley"] = "Valle de Alterac",
	["Alther's Mill"] = "Molino de Alther",
	["Amani Catacombs"] = "Catacumbas Amani",
	["Amani Mountains"] = "Montañas Amani",
	["Amani Pass"] = "Paso de Amani",
	["Amberfly Bog"] = "Ciénaga Brasacielo",
	["Amberglow Hollow"] = "Cuenca del Resplandor Ámbar",
	["Amber Ledge"] = "El Saliente Ámbar",
	Ambermarsh = "Marjal Ámbar",
	Ambermill = "Molino Ámbar",
	["Amberpine Lodge"] = "Refugio Pino Ámbar",
	["Amber Quarry"] = "Cantera de Ámbar",
	["Amber Research Sanctum"] = "Sagrario de Investigación Ámbar",
	["Ambershard Cavern"] = "Cueva Ambarina",
	["Amberstill Ranch"] = "Granja de Semperámbar",
	["Amberweb Pass"] = "Paso de Redámbar",
	["Ameth'Aran"] = "Ameth'Aran",
	["Ammen Fields"] = "Campos Ammen",
	["Ammen Ford"] = "Vado Ammen",
	["Ammen Vale"] = "Valle Ammen",
	["Amphitheater of Anguish"] = "Anfiteatro de la Angustia",
	["Ampitheater of Anguish"] = "Anfiteatro de la Angustia",
	["Ancestral Grounds"] = "Tierras Ancestrales",
	["Ancestral Rise"] = "Alto Ancestral",
	["Ancient Courtyard"] = "Patio Ancestral",
	["Ancient Zul'Gurub"] = "Antiguo Zul'Gurub",
	["An'daroth"] = "An'daroth",
	["Andilien Estate"] = "Dominios Andilien",
	Andorhal = "Andorhal",
	Andruk = "Andruk",
	["Angerfang Encampment"] = "Campamento Dentellada",
	["Angkhal Pavilion"] = "Pabellón de Angkhal",
	["Anglers Expedition"] = "Expedición de los Pescadores",
	["Anglers Wharf"] = "Muelle de los Pescadores",
	["Angor Fortress"] = "Fortaleza de Angor",
	["Ango'rosh Grounds"] = "Dominios Ango'rosh",
	["Ango'rosh Stronghold"] = "Bastión Ango'rosh",
	["Angrathar the Wrathgate"] = "Angrathar la Puerta de Cólera",
	["Angrathar the Wrath Gate"] = "Angrathar la Puerta de Cólera",
	["An'owyn"] = "An'owyn",
	["An'telas"] = "An'telas",
	["Antonidas Memorial"] = "Monumento de Antonidas",
	Anvilmar = "Yunquemar",
	["Anvil of Conflagration"] = "Yunque de Conflagración",
	["Apex Point"] = "La Cúspide",
	["Apocryphan's Rest"] = "Descanso de Apócrifo",
	["Apothecary Camp"] = "Campamento de los Boticarios",
	["Applebloom Tavern"] = "Taberna Manzana Jugosa",
	["Arathi Basin"] = "Cuenca de Arathi",
	["Arathi Highlands"] = "Tierras Altas de Arathi",
	["Arcane Pinnacle"] = "Pináculo Arcano",
	["Archmage Vargoth's Retreat"] = "Reposo del Archimago Vargoth",
	["Area 52"] = "Área 52",
	["Arena Floor"] = "El Suelo de la Arena",
	["Arena of Annihilation"] = "Arena de la Aniquilación",
	["Argent Pavilion"] = "Pabellón Argenta",
	["Argent Stand"] = "El Confín Argenta",
	["Argent Tournament Grounds"] = "Campos del Torneo Argenta",
	["Argent Vanguard"] = "Vanguardia Argenta",
	["Ariden's Camp"] = "Campamento de Ariden",
	["Arikara's Needle"] = "Aguja de Arikara",
	["Arklonis Ridge"] = "Cresta Arklonis",
	["Arklon Ruins"] = "Ruinas Arklon",
	["Arriga Footbridge"] = "Pasarela de Arriga",
	["Arsad Trade Post"] = "Puesto Comercial de Arsad",
	["Ascendant's Rise"] = "Alto del Ascendiente",
	["Ascent of Swirling Winds"] = "Ascenso de la Espiral de Viento",
	["Ashen Fields"] = "Campos Cinéreos",
	["Ashen Lake"] = "Lago Cinéreo",
	Ashenvale = "Vallefresno",
	["Ashwood Lake"] = "Lago Fresno",
	["Ashwood Post"] = "Puesto Fresno",
	["Aspen Grove Post"] = "Puesto de la Alameda",
	["Assault on Shaol'mara"] = "Asalto a Shaol'mara",
	["Assault on Zan'vess"] = "Asalto a Zan'vess",
	["Assault on Zeb'tula"] = "Asalto a Zeb'tula",
	Astranaar = "Astranaar",
	["Ata'mal Terrace"] = "Bancal de Ata'mal",
	Athenaeum = "El Athenaeum",
	["Atrium of the Heart"] = "Atrio del Corazón",
	["Atulhet's Tomb"] = "Tumba de Atulhet",
	["Auberdine Refugee Camp"] = "Campamento de refugiados de Auberdine",
	["Auburn Bluffs"] = "Cimas Cobrizas",
	["Auchenai Crypts"] = "Criptas Auchenai",
	["Auchenai Grounds"] = "Tierras Auchenai",
	Auchindoun = "Auchindoun",
	["Auchindoun: Auchenai Crypts"] = "Auchindoun: Criptas Auchenai",
	["Auchindoun - Auchenai Crypts Entrance"] = "Auchindoun - Entrada de las Criptas Auchenai",
	["Auchindoun: Mana-Tombs"] = "Auchindoun: Tumbas de Maná",
	["Auchindoun - Mana-Tombs Entrance"] = "Auchindoun - Entrada de las Tumbas de Maná",
	["Auchindoun: Sethekk Halls"] = "Auchindoun: Salas Sethekk",
	["Auchindoun - Sethekk Halls Entrance"] = "Auchindoun - Entrada de las Salas Sethekk",
	["Auchindoun: Shadow Labyrinth"] = "Auchindoun: Laberinto de las Sombras",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Auchindoun - Entrada del Laberinto de las Sombras",
	["Auren Falls"] = "Cascadas Auren",
	["Auren Ridge"] = "Cresta Auren",
	["Autumnshade Ridge"] = "Risco Sombra Otoñal",
	["Avalanchion's Vault"] = "Cámara de Avalanchion",
	Aviary = "El Aviario",
	["Axis of Alignment"] = "Eje de Alineación",
	Axxarien = "Axxarien",
	["Azjol-Nerub"] = "Azjol-Nerub",
	["Azjol-Nerub Entrance"] = "Entrada de Azjol-Nerub",
	Azshara = "Azshara",
	["Azshara Crater"] = "Cráter de Azshara",
	["Azshara's Palace"] = "Palacio de Azshara",
	["Azurebreeze Coast"] = "Costa Bris Azur",
	["Azure Dragonshrine"] = "Santuario de Dragones Azur",
	["Azurelode Mine"] = "Mina Azur",
	["Azuremyst Isle"] = "Isla Bruma Azur",
	["Azure Watch"] = "Avanzada Azur",
	["Backbreaker Bay"] = "Bahía Partedorsales",
	Badlands = "Tierras Inhóspitas",
	["Bael'dun Digsite"] = "Excavación de Bael'dun",
	["Bael'dun Keep"] = "Fortaleza de Bael'dun",
	["Baelgun's Excavation Site"] = "Excavación de Baelgun",
	["Bael Modan"] = "Bael Modan",
	["Bael Modan Excavation"] = "Excavación de Bael Modan",
	["Bahrum's Post"] = "Puesto de Bahrum",
	["Balargarde Fortress"] = "Fortaleza de Balargarde",
	Baleheim = "Baleheim",
	["Balejar Watch"] = "Avanzada Balejar",
	["Balia'mah Ruins"] = "Ruinas de Balia'mah",
	["Bal'lal Ruins"] = "Ruinas de Bal'lal",
	["Balnir Farmstead"] = "Hacienda Balnir",
	Bambala = "Bambala",
	["Band of Acceleration"] = "Anillo de Aceleración",
	["Band of Alignment"] = "Anillo de Alineación",
	["Band of Transmutation"] = "Anillo de Transmutación",
	["Band of Variance"] = "Anillo de Discrepancia",
	["Ban'ethil Barrow Den"] = "Túmulo de Ban'ethil",
	["Ban'ethil Barrow Descent"] = "Descenso del Túmulo de Ban'ethil",
	["Ban'ethil Hollow"] = "Hondonada Ban'ethil",
	Bank = "Banco",
	["Banquet Grounds"] = "Tierras del Festín",
	["Ban'Thallow Barrow Den"] = "Túmulo de Ban'Thallow",
	["Baradin Base Camp"] = "Campamento de Baradin",
	["Baradin Bay"] = "Bahía de Baradin",
	["Baradin Hold"] = "Bastión de Baradin",
	Barbershop = "Peluquería",
	["Barov Family Vault"] = "Cripta de la Familia Barov",
	["Bashal'Aran"] = "Bashal'Aran",
	["Bashal'Aran Collapse"] = "Ocaso de Bashal'Aran",
	["Bash'ir Landing"] = "Alto Bash'ir",
	["Bastion Antechamber"] = "Antecámara del Bastión",
	["Bathran's Haunt"] = "Ruinas de Bathran",
	["Battlefront Provisions"] = "Provisiones del Frente",
	["Battle on the High Seas"] = "Batalla en Alta Mar",
	["Battle Ring"] = "Liza",
	Battlescar = "Marca de Guerra",
	["Battlescar Spire"] = "Cumbre Marca de Guerra",
	["Battlescar Valley"] = "Valle Marca de Guerra",
	["Bay of Echoes"] = "Bahía de los Ecos",
	["Bay of Storms"] = "Bahía de la Tempestad",
	["Bear's Head"] = "Cabeza de Oso",
	["Beauty's Lair"] = "Guarida de Bella",
	["Beeble's Wreck"] = "Siniestro de Beeble",
	["Beezil's Wreck"] = "Siniestro de Beezil",
	["Befouled Terrace"] = "Bancal Infecto",
	["Beggar's Haunt"] = "Refugio de los Mendigos",
	["Beneath The Double Rainbow"] = "Debajo del Arco Iris Doble",
	["Beneath the Pit"] = "Sotofoso",
	["Beren's Peril"] = "El Desafío de Beren",
	["Bernau's Happy Fun Land"] = "El Maravilloso Mundo de Bernau",
	["Beryl Coast"] = "Costa de Berilo",
	["Beryl Egress"] = "Egreso de Berilo",
	["Beryl Point"] = "Alto de Berilo",
	["Beth'mora Ridge"] = "Cresta de Beth'mora",
	["Beth'tilac's Lair"] = "Guarida de Beth'tilac",
	["Biel'aran Ridge"] = "Cresta de Biel'aran",
	["Big Beach Brew Bash"] = "Reyerta de la Gran Playa",
	["Big Blossom Excavation"] = "Excavación de la Gran Flor",
	["Big Blossom Mine"] = "Mina de la Gran Flor",
	["Bilgewater Beach"] = "Playa Pantoque",
	["Bilgewater Harbor"] = "Muelle Pantoque",
	["Bilgewater Lumber Yard"] = "Almacén de Madera Pantoque",
	["Bilgewater Port"] = "Puerto Pantoque",
	["Binan Brew & Stew"] = "Mesón de Binan",
	["Binan Village"] = "Aldea Binan",
	["Bitter Reaches"] = "Costa Amarga",
	["Bittertide Lake"] = "Lago Olamarga",
	["Bizmo's Brawlpub"] = "Club de Lucha de Bizmo",
	["Black Channel Marsh"] = "Pantano del Canal Negro",
	["Blackchar Cave"] = "Cueva Tizonegro",
	["Black Drake Roost"] = "Nidal del Draco Negro",
	["Blackfathom Camp"] = "Campamento Brazanegra",
	["Blackfathom Deeps"] = "Cavernas de Brazanegra",
	["Blackfathom Deeps Entrance"] = "Entrada de las Cavernas de Brazanegra",
	["Blackhoof Village"] = "Poblado Pezuñanegra",
	["Blackhorn's Penance"] = "Penitencia de Cuerno Negro",
	["Blackmaw Hold"] = "Bastión Faucenegra",
	["Black Ox Temple"] = "Templo del Buey Negro",
	["Blackriver Logging Camp"] = "Aserradero Río Negro",
	["Blackrock Caverns"] = "Cavernas Roca Negra",
	["Blackrock Caverns Entrance"] = "Entrada de las Cavernas Roca Negra",
	["Blackrock Depths"] = "Profundidades de Roca Negra",
	["Blackrock Depths Entrance"] = "Entrada de las Profundidades de Roca Negra",
	["Blackrock Mountain"] = "Montaña Roca Negra",
	["Blackrock Pass"] = "Desfiladero de Roca Negra",
	["Blackrock Spire"] = "Cumbre de Roca Negra",
	["Blackrock Spire Entrance"] = "Entrada de la Cumbre de Roca Negra",
	["Blackrock Stadium"] = "Estadio de Roca Negra",
	["Blackrock Stronghold"] = "Bastión de Roca Negra",
	["Blacksand Spillway"] = "Aliviadero Gravanegra",
	["Blacksilt Shore"] = "Costa Cienonegro",
	Blacksmith = "Herrería",
	["Blackstone Span"] = "Tramo Piedranegra",
	["Black Temple"] = "Templo Oscuro",
	["Black Tooth Hovel"] = "Cobertizo Diente Negro",
	Blackwatch = "La Guardia Negra",
	["Blackwater Cove"] = "Cala Aguasnegras",
	["Blackwater Shipwrecks"] = "Naufragios de Aguasnegras",
	["Blackwind Lake"] = "Lago Vientonegro",
	["Blackwind Landing"] = "Alto de los Vientonegro",
	["Blackwind Valley"] = "Valle Vientonegro",
	["Blackwing Coven"] = "Aquelarre Alanegra",
	["Blackwing Descent"] = "Descenso de Alanegra",
	["Blackwing Lair"] = "Guarida de Alanegra",
	["Blackwolf River"] = "Río Lobonegro",
	["Blackwood Camp"] = "Campamento del Bosque Negro",
	["Blackwood Den"] = "Cubil del Bosque Negro",
	["Blackwood Lake"] = "Lago del Bosque Negro",
	["Bladed Gulch"] = "Barranco del Filo",
	["Bladefist Bay"] = "Bahía de Garrafilada",
	["Bladelord's Retreat"] = "Refugio del Señor de las Espadas",
	["Blades & Axes"] = "Espadas y Hachas",
	["Blade's Edge Arena"] = "Arena Filospada",
	["Blade's Edge Mountains"] = "Montañas Filospada",
	["Bladespire Grounds"] = "Dominios Aguja del Filo",
	["Bladespire Hold"] = "Bastión Aguja del Filo",
	["Bladespire Outpost"] = "Avanzada Aguja del Filo",
	["Blades' Run"] = "Camino de las Espadas",
	["Blade Tooth Canyon"] = "Cañón Dientespada",
	Bladewood = "Bosquespada",
	["Blasted Lands"] = "Las Tierras Devastadas",
	["Bleak Hollow"] = "Fosa Lúgubre",
	["Bleeding Hollow Ruins"] = "Ruinas Foso Sangrante",
	["Bleeding Vale"] = "Vega Sangrante",
	["Bleeding Ziggurat"] = "Zigurat Sangrante",
	["Blistering Pool"] = "Poza Virulenta",
	["Bloodcurse Isle"] = "Isla Sangre Maldita",
	["Blood Elf Tower"] = "Torre de los Elfos de Sangre",
	["Bloodfen Burrow"] = "Madriguera de los Cienorrojo",
	Bloodgulch = "Garganta de Sangre",
	["Bloodhoof Village"] = "Poblado Pezuña de Sangre",
	["Bloodied Crossing"] = "Cruce Sangriento",
	["Blood in the Snow"] = "Sangre en la Nieve",
	["Bloodmaul Camp"] = "Campamento Machacasangre",
	["Bloodmaul Outpost"] = "Avanzada Machacasangre",
	["Bloodmaul Ravine"] = "Barranco Machacasangre",
	["Bloodmoon Isle"] = "Isla Luna de Sangre",
	["Bloodmyst Isle"] = "Isla Bruma de Sangre",
	["Bloodscale Enclave"] = "Enclave Escamas de Sangre",
	["Bloodscale Grounds"] = "Tierras Escamas de Sangre",
	["Bloodspore Plains"] = "Llanuras Sanguiespora",
	["Bloodtalon Shore"] = "Costa Garrasangre",
	["Bloodtooth Camp"] = "Asentamiento Sangradientes",
	["Bloodvenom Falls"] = "Cascadas del Veneno",
	["Bloodvenom Post"] = "Puesto del Veneno",
	["Bloodvenom Post "] = "Puesto del Veneno",
	["Bloodvenom River"] = "Río del Veneno",
	["Bloodwash Cavern"] = "Cueva de La Playa de Sangre",
	["Bloodwash Fighting Pits"] = "Fosos de lucha de La Playa de Sangre",
	["Bloodwash Shrine"] = "Santuario de La Playa de Sangre",
	["Blood Watch"] = "Avanzada de Sangre",
	["Bloodwatcher Point"] = "Paso de Mirasangre",
	Bluefen = "Ciénaga Azul",
	["Bluegill Marsh"] = "Pantano Branquiazul",
	["Blue Sky Logging Grounds"] = "Aserradero Cielo Azul",
	["Bluff of the South Wind"] = "Cima del Viento del Sur",
	["Bogen's Ledge"] = "Arrecife de Bogen",
	Bogpaddle = "Chapaleos",
	["Boha'mu Ruins"] = "Ruinas Boha'mu",
	["Bolgan's Hole"] = "Cuenca de Bolgan",
	["Bolyun's Camp"] = "Campamento de Bolyun",
	["Bonechewer Ruins"] = "Ruinas Mascahuesos",
	["Bonesnap's Camp"] = "Campamento Cascahueso",
	["Bones of Grakkarond"] = "Huesos de Grakkarond",
	["Bootlegger Outpost"] = "Avanzada del Contrabandista",
	["Booty Bay"] = "Bahía del Botín",
	["Borean Tundra"] = "Tundra Boreal",
	["Bor'gorok Outpost"] = "Avanzada Bor'gorok",
	["Bor's Breath"] = "Aliento de Bor",
	["Bor's Breath River"] = "Río del Aliento de Bor",
	["Bor's Fall"] = "Caída de Bor",
	["Bor's Fury"] = "La Furia de Bor",
	["Borune Ruins"] = "Ruinas Borune",
	["Bough Shadow"] = "Talloumbrío",
	["Bouldercrag's Refuge"] = "Refugio de Pedruscón",
	["Boulderfist Hall"] = "Sala Puño de Roca",
	["Boulderfist Outpost"] = "Avanzada Puño de Roca",
	["Boulder'gor"] = "Roca'gor",
	["Boulder Hills"] = "Colinas Pedrusco",
	["Boulder Lode Mine"] = "Mina Pedrusco",
	["Boulder'mok"] = "Peña'mok",
	["Boulderslide Cavern"] = "Cueva del Alud",
	["Boulderslide Ravine"] = "Barranco del Alud",
	["Bozzle's Wreck"] = "Siniestro de Bozzle",
	["Brackenwall Village"] = "Poblado Murohelecho",
	["Brackwell Pumpkin Patch"] = "Plantación de Calabazas de Brackwell",
	["Brambleblade Ravine"] = "Barranco Cortazarza",
	Bramblescar = "Rajazarza",
	["Brann's Base-Camp"] = "Campamento base de Brann",
	["Brashtide Attack Fleet"] = "Flota de Asalto Fuertemarea",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Flota de Asalto Fuertemarea (Fuerzas de exterior)",
	["Brave Wind Mesa"] = "Mesa de Viento Bravo",
	["Brawl'gar Arena"] = "Arena Liza'gar",
	["Brazie Farmstead"] = "Granja de Brazie",
	["Brewmoon Festival"] = "Festival de la Cerveza Lunar",
	["Brewnall Village"] = "Las Birras",
	["Bridge of Souls"] = "Puente de las Almas",
	["Brightwater Lake"] = "Lago Aguasclaras",
	["Brightwood Grove"] = "Arboleda del Destello",
	Brill = "Rémol",
	["Brill Town Hall"] = "Concejo de Rémol",
	["Bristlelimb Enclave"] = "Enclave Brazolanudo",
	["Bristlelimb Village"] = "Aldea Brazolanudo",
	["Broken Commons"] = "Ágora",
	["Broken Hill"] = "Cerro Tábido",
	["Broken Pillar"] = "Pilar Partido",
	["Broken Spear Village"] = "Aldea Lanza Partida",
	["Broken Wilds"] = "Landas Tábidas",
	["Broketooth Outpost"] = "Avanzada Dienterroto",
	["Bronzebeard Encampment"] = "Campamento Barbabronce",
	["Bronze Dragonshrine"] = "Santuario de Dragones Bronce",
	["Browman Mill"] = "Molino Cejifrente",
	["Brunnhildar Village"] = "Poblado Brunnhildar",
	["Bucklebree Farm"] = "La granja de Bucklebree",
	["Budd's Dig"] = "Excavación de Budd",
	["Burning Blade Coven"] = "Aquelarre del Filo Ardiente",
	["Burning Blade Ruins"] = "Ruinas Filo Ardiente",
	["Burning Steppes"] = "Las Estepas Ardientes",
	["Butcher's Sanctum"] = "Sagrario del Carnicero",
	["Butcher's Stand"] = "Puesto de Carnicero",
	["Caer Darrow"] = "Castel Darrow",
	["Caldemere Lake"] = "Lago Caldemere",
	["Calston Estate"] = "Dominios de Calston",
	["Camp Aparaje"] = "Campamento Aparaje",
	["Camp Ataya"] = "Campamento Ataya",
	["Camp Boff"] = "Asentamiento Boff",
	["Camp Broketooth"] = "Campamento Dienterroto",
	["Camp Cagg"] = "Asentamiento Cagg",
	["Camp E'thok"] = "Campamento E'thok",
	["Camp Everstill"] = "Campamento Sempiterno",
	["Camp Gormal"] = "Campamento Gormal",
	["Camp Kosh"] = "Asentamiento Kosh",
	["Camp Mojache"] = "Campamento Mojache",
	["Camp Mojache Longhouse"] = "Casa Comunal del Campamento Mojache",
	["Camp Narache"] = "Campamento Narache",
	["Camp Nooka Nooka"] = "Campamento Nooka Nooka",
	["Camp of Boom"] = "Campamento de Bum",
	["Camp Onequah"] = "Campamento Oneqwah",
	["Camp Oneqwah"] = "Campamento Oneqwah",
	["Camp Sungraze"] = "Campamento Rasguño de Sol",
	["Camp Tunka'lo"] = "Campamento Tunka'lo",
	["Camp Una'fe"] = "Campamento Una'fe",
	["Camp Winterhoof"] = "Campamento Pezuña Invernal",
	["Camp Wurg"] = "Asentamiento Wurg",
	Canals = "Canales",
	["Cannon's Inferno"] = "Infierno de Cannon",
	["Cantrips & Crows"] = "Taberna de los Cuervos",
	["Cape of Lost Hope"] = "Cabo de la Esperanza Perdida",
	["Cape of Stranglethorn"] = "El Cabo de Tuercespina",
	["Capital Gardens"] = "Jardines de la Capital",
	["Carrion Hill"] = "Colina Carroña",
	["Cartier & Co. Fine Jewelry"] = "Joyería Fina Cartier y Cía.",
	Cataclysm = "Cataclysm",
	["Cathedral of Darkness"] = "Catedral de la Oscuridad",
	["Cathedral of Light"] = "Catedral de la Luz",
	["Cathedral Quarter"] = "Barrio de la Catedral",
	["Cathedral Square"] = "Plaza de la Catedral",
	["Cattail Lake"] = "Lago de las Eneas",
	["Cauldros Isle"] = "Isla Caldros",
	["Cave of Mam'toth"] = "Cueva de Mam'toth",
	["Cave of Meditation"] = "Cueva de Meditación",
	["Cave of the Crane"] = "Cueva de la Grulla",
	["Cave of Words"] = "Cueva de las Palabras",
	["Cavern of Endless Echoes"] = "Cueva del Eco Infinito",
	["Cavern of Mists"] = "Caverna Vaharada",
	["Caverns of Time"] = "Cavernas del Tiempo",
	["Celestial Enclave"] = "Enclave Celestial",
	["Celestial Ridge"] = "Cresta Celestial",
	["Cenarion Enclave"] = "Enclave Cenarion",
	["Cenarion Hold"] = "Fuerte Cenarion",
	["Cenarion Post"] = "Puesto Cenarion",
	["Cenarion Refuge"] = "Refugio Cenarion",
	["Cenarion Thicket"] = "Matorral Cenarion",
	["Cenarion Watchpost"] = "Puesto de Vigilancia Cenarion",
	["Cenarion Wildlands"] = "Tierras Vírgenes Cenarion",
	["Central Bridge"] = "Puente Central",
	["Chamber of Ancient Relics"] = "Cámara de Reliquias Antiguas",
	["Chamber of Atonement"] = "Cámara Expiatoria",
	["Chamber of Battle"] = "Sala de la Batalla",
	["Chamber of Blood"] = "Cámara Sangrienta",
	["Chamber of Command"] = "Cámara de Mando",
	["Chamber of Enchantment"] = "Cámara del Encantamiento",
	["Chamber of Enlightenment"] = "Cámara de la Iluminación",
	["Chamber of Fanatics"] = "Cámara de los Fanáticos",
	["Chamber of Incineration"] = "Cámara de Incineración",
	["Chamber of Masters"] = "Cámara de los Maestros",
	["Chamber of Prophecy"] = "Sala de la Profecía",
	["Chamber of Reflection"] = "Cámara del Reflejo",
	["Chamber of Respite"] = "Cámara del Descanso",
	["Chamber of Summoning"] = "Cámara de la Invocación",
	["Chamber of Test Namesets"] = "Cámara de Nombres de Prueba",
	["Chamber of the Aspects"] = "Cámara de los Aspectos",
	["Chamber of the Dreamer"] = "Cámara de los Sueños",
	["Chamber of the Moon"] = "Cámara de la Luna",
	["Chamber of the Restless"] = "Cámara de los Sin Sosiego",
	["Chamber of the Stars"] = "Cámara de las Estrellas",
	["Chamber of the Sun"] = "Cámara del Sol",
	["Chamber of Whispers"] = "Cámara de los Susurros",
	["Chamber of Wisdom"] = "Cámara de la Sabiduría",
	["Champion's Hall"] = "Sala de los Campeones",
	["Champions' Hall"] = "Sala de los Campeones",
	["Chapel Gardens"] = "Jardines de la Capilla",
	["Chapel of the Crimson Flame"] = "Capilla de la Llama Carmesí",
	["Chapel Yard"] = "Patio de la Capilla",
	["Charred Outpost"] = "Avanzada Carbonizada",
	["Charred Rise"] = "Alto Carbonizado",
	["Chill Breeze Valley"] = "Valle Escalofrío",
	["Chillmere Coast"] = "Costafría",
	["Chillwind Camp"] = "Campamento del Orvallo",
	["Chillwind Point"] = "Alto del Orvallo",
	Chiselgrip = "Cincelada",
	["Chittering Coast"] = "Costa del Gorjeo",
	["Chow Farmstead"] = "Granja de Tallarín",
	["Churning Gulch"] = "Garganta Bulliciosa",
	["Circle of Blood"] = "Círculo de Sangre",
	["Circle of Blood Arena"] = "Arena del Círculo de Sangre",
	["Circle of Bone"] = "Círculo de Huesos",
	["Circle of East Binding"] = "Círculo de Vínculo Este",
	["Circle of Inner Binding"] = "Círculo de Vínculo Interior",
	["Circle of Outer Binding"] = "Círculo de Vínculo Exterior",
	["Circle of Scale"] = "Círculo de Escamas",
	["Circle of Stone"] = "Círculo de Piedras",
	["Circle of Thorns"] = "Círculo de Espinas",
	["Circle of West Binding"] = "Círculo de Vínculo Oeste",
	["Circle of Wills"] = "Círculo de Voluntades",
	City = "Ciudad",
	["City of Ironforge"] = "Ciudad de Forjaz",
	["City Siege - Mogu Island Progression Scenario"] = "Asedio a la ciudad - Gesta de progresión de la isla mogu",
	["Clan Watch"] = "Avanzada del Clan",
	["Class Quest"] = "Misión de Clase",
	["Claytön's WoWEdit Land"] = "Claytön's WoWEdit Land",
	["Cleft of Shadow"] = "Circo de las Sombras",
	["Cliffspring Falls"] = "Salto de Fonroca",
	["Cliffspring Hollow"] = "Cuenca Fonroca",
	["Cliffspring River"] = "Río Fonroca",
	["Cliffwalker Post"] = "Puesto Caminarrisco",
	["Cloudstrike Dojo"] = "Dojo Golpe Celeste",
	["Cloudtop Terrace"] = "Bancal Altonube",
	["Coast of Echoes"] = "Costa de los Ecos",
	["Coast of Idols"] = "Costa de los Ídolos",
	["Coilfang Reservoir"] = "Reserva Colmillo Torcido",
	["Coilfang: Serpentshrine Cavern"] = "Reserva Colmillo Torcido: Caverna Santuario Serpiente",
	["Coilfang: The Slave Pens"] = "Colmillo Torcido: Recinto de los Esclavos",
	["Coilfang - The Slave Pens Entrance"] = "Colmillo Torcido: Entrada del Recinto de los Esclavos",
	["Coilfang: The Steamvault"] = "Colmillo Torcido: Cámara de Vapor",
	["Coilfang - The Steamvault Entrance"] = "Colmillo Torcido: Entrada de La Cámara de Vapor",
	["Coilfang: The Underbog"] = "Colmillo Torcido: La Sotiénaga",
	["Coilfang - The Underbog Entrance"] = "Colmillo Torcido: Entrada de La Sotiénaga",
	["Coilskar Cistern"] = "Cisterna Cicatriz Espiral",
	["Coilskar Point"] = "Alto Cicatriz Espiral",
	Coldarra = "Gelidar",
	["Coldarra Ledge"] = "Saliente de Gelidar",
	["Coldbite Burrow"] = "Madriguera Muerdefrío",
	["Cold Hearth Manor"] = "Mansión Fríogar",
	["Coldridge Pass"] = "Desfiladero de Crestanevada",
	["Coldridge Valley"] = "Valle de Crestanevada",
	["Coldrock Quarry"] = "Cantera Frioescollo",
	["Coldtooth Mine"] = "Mina Dentefrío",
	["Coldwind Heights"] = "Altos Viento Helado",
	["Coldwind Pass"] = "Pasaje Viento Helado",
	["Collin's Test"] = "Collin's Test",
	["Command Center"] = "Centro de Mando",
	["Commons Hall"] = "Cámara del Pueblo",
	["Condemned Halls"] = "Salas Condenadas",
	["Conqueror's Terrace"] = "Platea del Conquistador",
	["Conquest Hold"] = "Bastión de la Conquista",
	["Containment Core"] = "Pabellón de Aislamiento",
	["Cooper Residence"] = "La Residencia Cooper",
	["Coral Garden"] = "Jardín de Coral",
	["Cordell's Enchanting"] = "Encantamientos de Cordell",
	["Corin's Crossing"] = "Cruce de Corin",
	["Corp'rethar: The Horror Gate"] = "Corp'rethar: La Puerta del Horror",
	["Corrahn's Dagger"] = "Daga de Corrahn",
	Cosmowrench = "Cosmotirón",
	["Court of Bones"] = "El Patio de los Huesos",
	["Court of the Highborne"] = "Corte de los Altonato",
	["Court of the Sun"] = "La Corte del Sol",
	["Courtyard of Lights"] = "Patio de las Luces",
	["Courtyard of the Ancients"] = "Patio de los Ancestros",
	["Cradle of Chi-Ji"] = "Cuna de Chi-Ji",
	["Cradle of the Ancients"] = "Cuna de los Ancestros",
	["Craftsmen's Terrace"] = "Bancal del Artesano",
	["Crag of the Everliving"] = "Risco de los Eternos",
	["Cragpool Lake"] = "Lago del Peñasco",
	["Crane Wing Refuge"] = "Refugio Ala de Grulla",
	["Crash Site"] = "Lugar del Accidente",
	["Crescent Hall"] = "Sala Creciente",
	["Crimson Assembly Hall"] = "La Sala de la Asamblea Carmesí",
	["Crimson Expanse"] = "Extensión Carmesí",
	["Crimson Watch"] = "Atalaya Carmesí",
	Crossroads = "El Cruce",
	["Crowley Orchard"] = "Huerto de Crowley",
	["Crowley Stable Grounds"] = "Tierras del Establo de Crowley",
	["Crown Guard Tower"] = "Torre de la Corona",
	["Crucible of Carnage"] = "Crisol de Matanza",
	["Crumbling Depths"] = "Profundidades Desmoronadas",
	["Crumbling Stones"] = "Rocas Desmoronadas",
	["Crusader Forward Camp"] = "Puesto de Avanzada de los Cruzados",
	["Crusader Outpost"] = "Avanzada de los Cruzados",
	["Crusader's Armory"] = "Arsenal de los Cruzados",
	["Crusader's Chapel"] = "Capilla de los Cruzados",
	["Crusader's Landing"] = "El Tramo del Cruzado",
	["Crusader's Outpost"] = "Avanzada de los Cruzados",
	["Crusaders' Pinnacle"] = "Pináculo de los Cruzados",
	["Crusader's Run"] = "Senda del Cruzado",
	["Crusader's Spire"] = "Espiral de los Cruzados",
	["Crusaders' Square"] = "Plaza de los Cruzados",
	Crushblow = "Machacolpe",
	["Crushcog's Arsenal"] = "Arsenal de Prensadiente",
	["Crushridge Hold"] = "Dominios de los Aplastacresta",
	Crypt = "Cripta",
	["Crypt of Forgotten Kings"] = "Cripta de los Reyes Olvidados",
	["Crypt of Remembrance"] = "Cripta de los Recuerdos",
	["Crystal Lake"] = "Lago de Cristal",
	["Crystalline Quarry"] = "Cantera Cristalina",
	["Crystalsong Forest"] = "Bosque Canto de Cristal",
	["Crystal Spine"] = "Espina de Cristal",
	["Crystalvein Mine"] = "Mina de Cristal",
	["Crystalweb Cavern"] = "Caverna Red de Cristal",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "Curiosidades y Más",
	["Cursed Depths"] = "Profundidades Malditas",
	["Cursed Hollow"] = "Hoya Maldita",
	["Cut-Throat Alley"] = "Callejón Degolladores",
	["Cyclone Summit"] = "Cima del Ciclón",
	["Dabyrie's Farmstead"] = "Granja de Dabyrie",
	["Daggercap Bay"] = "Bahía Cubredaga",
	["Daggerfen Village"] = "Aldea Dagapantano",
	["Dagger in the Dark"] = "Una Daga en la Oscuridad",
	["Daggermaw Canyon"] = "Cañón Faucedaga",
	["Dagger Pass"] = "Paso de la Daga",
	["Dais of Conquerors"] = "Estrado de los Conquistadores",
	Dalaran = "Dalaran",
	["Dalaran Arena"] = "Arena de Dalaran",
	["Dalaran City"] = "Ciudad de Dalaran",
	["Dalaran Crater"] = "Cráter de Dalaran",
	["Dalaran Floating Rocks"] = "Rocas Flotantes de Dalaran",
	["Dalaran Island"] = "Isla de Dalaran",
	["Dalaran Merchant's Bank"] = "Banco de Mercaderes de Dalaran",
	["Dalaran Sewers"] = "Cloacas de Dalaran",
	["Dalaran Visitor Center"] = "Centro de Visitantes de Dalaran",
	["Dalson's Farm"] = "Granja de Dalson",
	["Damplight Cavern"] = "Caverna Luzúmida",
	["Damplight Chamber"] = "Cámara Luzúmida",
	["Dampsoil Burrow"] = "Madriguera Fangosa",
	["Dandred's Fold"] = "Redil de Dandred",
	["Dargath's Demise"] = "Óbito de Dargath",
	["Darkbreak Cove"] = "Cala Brechascura",
	["Darkcloud Pinnacle"] = "Cumbre de la Nube Negra",
	["Darkcrest Enclave"] = "Enclave Cresta Oscura",
	["Darkcrest Shore"] = "Playa Crestanegra",
	["Dark Heart of Pandaria"] = "Corazón Oscuro de Pandaria",
	["Dark Iron Highway"] = "Ruta Hierro Negro",
	["Darkmist Cavern"] = "Cueva Niebla Negra",
	["Darkmist Ruins"] = "Ruinas Niebla Negra",
	["Darkmoon Boardwalk"] = "Paseo marítimo de la Luna Negra",
	["Darkmoon Deathmatch"] = "Combate a muerte de la Feria de la Luna Negra",
	["Darkmoon Deathmatch Pit (PH)"] = "Darkmoon Deathmatch Pit (PH)",
	["Darkmoon Faire"] = "Feria de la Luna Negra",
	["Darkmoon Island"] = "Isla Luna Negra",
	["Darkmoon Island Cave"] = "Cueva de la Isla de la Luna Negra",
	["Darkmoon Path"] = "Senda de la Luna Negra",
	["Darkmoon Pavilion"] = "Pabellón de la Feria de la Luna Negra",
	Darkshire = "Villa Oscura",
	["Darkshire Town Hall"] = "Concejo de Villa Oscura",
	Darkshore = "Costa Oscura",
	["Darkspear Hold"] = "Bastión Lanza Negra",
	["Darkspear Isle"] = "Isla Lanza Negra",
	["Darkspear Shore"] = "Costa Lanza Negra",
	["Darkspear Strand"] = "Playa Lanza Negra",
	["Darkspear Training Grounds"] = "Campo de Entrenamiento Lanza Negra",
	["Darkwhisper Gorge"] = "Garganta Negro Rumor",
	["Darkwhisper Pass"] = "Paso Negro Rumor",
	["Darnassian Base Camp"] = "Campamento Base Darnassiano",
	Darnassus = "Darnassus",
	["Darrow Hill"] = "Colinas de Darrow",
	["Darrowmere Lake"] = "Lago Darrowmere",
	Darrowshire = "Villa Darrow",
	["Darrowshire Hunting Grounds"] = "Terrenos de caza de Villa Darrow",
	["Darsok's Outpost"] = "Avanzada de Darsok",
	["Dawnchaser Retreat"] = "Retiro del Cazador del Alba",
	["Dawning Lane"] = "Calle del Alba",
	["Dawning Wood Catacombs"] = "Catacumbas del Bosque Aurora",
	["Dawnrise Expedition"] = "Expedición Alzalba",
	["Dawn's Blossom"] = "Floralba",
	["Dawnseeker Promontory"] = "Promontorio Buscalba",
	["Dawnseeker's Promontory"] = "Promontorio Buscalba",
	["Dawn's Reach"] = "Tramo del Alba",
	["Dawnstar Spire"] = "Aguja de la Estrella del Alba",
	["Dawnstar Village"] = "Poblado Estrella del Alba",
	["Daxil's Dig"] = "Excavación de Daxil",
	["D-Block"] = "Bloque D",
	["Deadeye Shore"] = "Costa de Mortojo",
	["Deadman's Crossing"] = "Cruce de la Muerte",
	["Dead Man's Hole"] = "El Agujero del Muerto",
	Deadmines = "Minas de la Muerte",
	["Deadtalker's Plateau"] = "Meseta del Espiritista",
	["Deadwind Pass"] = "Paso de la Muerte",
	["Deadwind Ravine"] = "Barranco de la Muerte",
	["Deadwood Village"] = "Aldea Muertobosque",
	["Deathbringer's Rise"] = "Alto del Libramorte",
	["Death Cultist Base Camp"] = "Campamento Cultor de la Muerte",
	["Deathforge Tower"] = "Torre de la Forja Muerta",
	Deathknell = "Camposanto",
	["Deathmatch Pavilion"] = "Pabellón de combate a muerte",
	Deatholme = "Ciudad de la Muerte",
	["Death's Breach"] = "Brecha de la Muerte",
	["Death's Door"] = "Puerta de la Muerte",
	["Death's Hand Encampment"] = "Campamento Mano de la Muerte",
	["Deathspeaker's Watch"] = "Avanzada del Portavoz de la Muerte",
	["Death's Rise"] = "Ascenso de la Muerte",
	["Death's Stand"] = "Confín de la Muerte",
	["Death's Step"] = "Grada de la Muerte",
	["Death's Watch Waystation"] = "Apeadero del Ocelo de la Muerte",
	Deathwing = "Alamuerte",
	["Deathwing's Fall"] = "Caída de Alamuerte",
	["Deep Blue Observatory"] = "Observatorio Azul Profundo",
	["Deep Elem Mine"] = "Mina de Elem",
	["Deepfin Ridge"] = "Cresta de Aleta Profunda",
	Deepholm = "Infralar",
	["Deephome Ceiling"] = "Bóveda de Infralar",
	["Deepmist Grotto"] = "Gruta Brumadensa",
	["Deeprun Tram"] = "Tranvía Subterráneo",
	["Deepwater Tavern"] = "Mesón Aguahonda",
	["Deepwind Gorge"] = "Cañón del Céfiro",
	["Defense of the Alehouse"] = "Defensa de la Taberna",
	["Defense Of The Ale House BG"] = "CDB de Defensa de la Taberna",
	["Defias Hideout"] = "Ladronera de los Defias",
	["Defiler's Den"] = "Guarida de los Rapiñadores",
	["D.E.H.T.A. Encampment"] = "Campamento D.E.H.T.A.",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "Barranco del Demonio",
	["Demon Fall Ridge"] = "Cresta del Demonio",
	["Demont's Place"] = "Paraje de Demont",
	["Den of Defiance"] = "Guarida del Desafío",
	["Den of Dying"] = "Cubil de los Moribundos",
	["Den of Haal'esh"] = "Cubil de Haal'esh",
	["Den of Iniquity"] = "Cubil de Iniquidad",
	["Den of Mortal Delights"] = "Guarida de los Placeres Mortales",
	["Den of Sorrow"] = "Guarida del Pesar",
	["Den of Sseratus"] = "Cubil de Sseratus",
	["Den of the Caller"] = "Cubil del Clamor",
	["Den of the Devourer"] = "Cubil del Devorador",
	["Den of the Disciples"] = "Cubil de los Discípulos",
	["Den of the Unholy"] = "Cubil de los Impuros",
	["Derelict Caravan"] = "Caravana Derelicta",
	["Derelict Manor"] = "Mansión Derelicta",
	["Derelict Strand"] = "Playa Derelicta",
	["Designer Island"] = "Isla del Diseñador",
	Desolace = "Desolace",
	["Desolation Hold"] = "Bastión de la Desolación",
	["Detention Block"] = "Bloque de Detención",
	["Development Land"] = "Tierra de Desarrollo",
	["Diamondhead River"] = "Río Diamante",
	["Diamond Island"] = "Isla Diamante",
	["Dig One"] = "Excavación 1",
	["Dig Three"] = "Excavación 3",
	["Dig Two"] = "Excavación 2",
	["Direforge Hill"] = "Cerro Fraguaferoz",
	["Direhorn Post"] = "Puesto Cuernoatroz",
	["Dire Maul"] = "La Masacre",
	["Dire Maul - Capital Gardens Entrance"] = "La Masacre: Entrada de los Jardines de la Capital",
	["Dire Maul - East"] = "La Masacre: Este",
	["Dire Maul - Gordok Commons Entrance"] = "La Masacre: Entrada del Ágora de Gordok",
	["Dire Maul - North"] = "La Masacre: Norte",
	["Dire Maul - Warpwood Quarter Entrance"] = "La Masacre: Entrada del Barrio Alabeo",
	["Dire Maul - West"] = "La Masacre: Oeste",
	Diremoor = "Malandanza",
	["Dire Strait"] = "Estrecho Temible",
	["Disciple's Enclave"] = "Enclave del Discípulo",
	Docks = "Muelles",
	["Dojani River"] = "Río Dojani",
	Dolanaar = "Dolanaar",
	["Dome Balrissa"] = "Cúpula Balrissa",
	["Domination Point"] = "Punto de Dominio",
	["Donna's Kitty Shack"] = "Casa de gatitos de Donna",
	["DO NOT USE"] = "DO NOT USE",
	["Dookin' Grounds"] = "Campo del Miko",
	["Doom's Vigil"] = "Vigilia de la Fatalidad",
	["Dorian's Outpost"] = "Avanzada de Dorian",
	["Draco'dar"] = "Draco'dar",
	["Draenei Ruins"] = "Ruinas Draenei",
	["Draenethyst Mine"] = "Mina Draenetista",
	["Draenil'dur Village"] = "Aldea Draenil'dur",
	Dragonblight = "Cementerio de Dragones",
	["Dragonflayer Pens"] = "Cercado de Desuelladragones",
	["Dragonmaw Base Camp"] = "Campamento Faucedraco",
	["Dragonmaw Flag Room"] = "Sala de la Bandera Faucedraco",
	["Dragonmaw Forge"] = "Forja Faucedraco",
	["Dragonmaw Fortress"] = "Fortaleza Faucedraco",
	["Dragonmaw Garrison"] = "Cuartel Faucedraco",
	["Dragonmaw Gates"] = "Puertas Faucedraco",
	["Dragonmaw Pass"] = "Paso Faucedraco",
	["Dragonmaw Port"] = "Puerto Faucedraco",
	["Dragonmaw Skyway"] = "Ruta Aérea Faucedraco",
	["Dragonmaw Stronghold"] = "Bastión Faucedraco",
	["Dragons' End"] = "Cabo del Dragón",
	["Dragon's Fall"] = "Caída del Dragón",
	["Dragon's Mouth"] = "Boca del Dragón",
	["Dragon Soul"] = "Alma de Dragón",
	["Dragon Soul Raid - East Sarlac"] = "Banda Alma de Dragón - Este de Sarlac",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Banda de Alma de Dragón - Base del Templo del Reposo del Dragón",
	["Dragonspine Peaks"] = "Cumbres Espinazo de Dragón",
	["Dragonspine Ridge"] = "Cresta Espinazo de Dragón",
	["Dragonspine Tributary"] = "Afluente del Espinazo del Dragón",
	["Dragonspire Hall"] = "Sala Dracopico",
	["Drak'Agal"] = "Drak'Agal",
	["Draka's Fury"] = "Furia de Draka",
	["Drak'atal Passage"] = "Pasaje de Drak'atal",
	["Drakil'jin Ruins"] = "Ruinas de Drakil'jin",
	["Drak'Mabwa"] = "Drak'Mabwa",
	["Drak'Mar Lake"] = "Lago Drak'Mar",
	["Draknid Lair"] = "Guarida Dráknida",
	["Drak'Sotra"] = "Drak'Sotra",
	["Drak'Sotra Fields"] = "Campos Drak'Sotra",
	["Drak'Tharon Keep"] = "Fortaleza de Drak'Tharon",
	["Drak'Tharon Keep Entrance"] = "Entrada de la Fortaleza de Drak'Tharon",
	["Drak'Tharon Overlook"] = "Mirador de Drak'Tharon",
	["Drak'ural"] = "Drak'ural",
	["Dread Clutch"] = "Guarida del Terror",
	["Dread Expanse"] = "Extensión Tremebunda",
	["Dreadmaul Furnace"] = "Horno Machacamiedo",
	["Dreadmaul Hold"] = "Bastión Machacamiedo",
	["Dreadmaul Post"] = "Puesto Machacamiedo",
	["Dreadmaul Rock"] = "Roca Machacamiedo",
	["Dreadmist Camp"] = "Campamento Calígine",
	["Dreadmist Den"] = "Cubil Calígine",
	["Dreadmist Peak"] = "Cima Calígine",
	["Dreadmurk Shore"] = "Playa Tenebruma",
	["Dread Terrace"] = "Tribuna del Terror",
	["Dread Wastes"] = "Desierto del Pavor",
	["Dreadwatch Outpost"] = "Avanzada Velaspanto",
	["Dream Bough"] = "Rama Oniria",
	["Dreamer's Pavilion"] = "Pabellón del Soñador",
	["Dreamer's Rest"] = "Reposo de la Soñadora",
	["Dreamer's Rock"] = "Roca del Soñador",
	Drudgetown = "La Barriada",
	["Drygulch Ravine"] = "Barranco Árido",
	["Drywhisker Gorge"] = "Cañón Mostacho Seco",
	["Dubra'Jin"] = "Dubra'Jin",
	["Dun Algaz"] = "Dun Algaz",
	["Dun Argol"] = "Dun Argol",
	["Dun Baldar"] = "Dun Baldar",
	["Dun Baldar Pass"] = "Paso de Dun Baldar",
	["Dun Baldar Tunnel"] = "Túnel de Dun Baldar",
	["Dunemaul Compound"] = "Base Machacaduna",
	["Dunemaul Recruitment Camp"] = "Campo de Reclutamiento Machacaduna",
	["Dun Garok"] = "Dun Garok",
	["Dun Mandarr"] = "Dun Mandarr",
	["Dun Modr"] = "Dun Modr",
	["Dun Morogh"] = "Dun Morogh",
	["Dun Niffelem"] = "Dun Niffelem",
	["Dunwald Holdout"] = "Resistencia Montocre",
	["Dunwald Hovel"] = "Cobertizo Montocre",
	["Dunwald Market Row"] = "Fila del Mercado Montocre",
	["Dunwald Ruins"] = "Ruinas Montocre",
	["Dunwald Town Square"] = "Plaza Principal Montocre",
	["Durnholde Keep"] = "Castillo de Durnholde",
	Durotar = "Durotar",
	Duskhaven = "Refugio del Ocaso",
	["Duskhowl Den"] = "Cubil Aúllaocaso",
	["Dusklight Bridge"] = "Puente del Anochecer",
	["Dusklight Hollow"] = "Cuenca del Anochecer",
	["Duskmist Shore"] = "Costa Noctuniebla",
	["Duskroot Fen"] = "Fangal Raíz Negra",
	["Duskwither Grounds"] = "Tierras Ocaso Marchito",
	["Duskwither Spire"] = "Aguja Ocaso Marchito",
	Duskwood = "Bosque del Ocaso",
	["Dustback Gorge"] = "Despeñadero Loma Agreste",
	["Dustbelch Grotto"] = "Gruta Rotapolvo",
	["Dustfire Valley"] = "Valle Polvofuego",
	["Dustquill Ravine"] = "Barranco Pluma Polvorienta",
	["Dustwallow Bay"] = "Bahía Revolcafango",
	["Dustwallow Marsh"] = "Marjal Revolcafango",
	["Dustwind Cave"] = "Cueva Viento Seco",
	["Dustwind Dig"] = "Excavación Viento Seco",
	["Dustwind Gulch"] = "Barranco Viento Seco",
	["Dwarven District"] = "Distrito de los Enanos",
	["Eagle's Eye"] = "Ojo de Águila",
	["Earthshatter Cavern"] = "Caverna Rompetierra",
	["Earth Song Falls"] = "Cascadas del Canto de la Tierra",
	["Earth Song Gate"] = "Puerta del Canto de la Tierra",
	["Eastern Bridge"] = "Puente Oriental",
	["Eastern Kingdoms"] = "Reinos del Este",
	["Eastern Plaguelands"] = "Tierras de la Peste del Este",
	["Eastern Strand"] = "Playa del Este",
	["East Garrison"] = "Cuartel del Este",
	["Eastmoon Ruins"] = "Ruinas de Lunaeste",
	["East Pavilion"] = "Pabellón este",
	["East Pillar"] = "Pilar Este",
	["Eastpoint Tower"] = "Torre Oriental",
	["East Sanctum"] = "Sagrario del Este",
	["Eastspark Workshop"] = "Taller Chispa Oriental",
	["East Spire"] = "Fortín del Este",
	["East Supply Caravan"] = "Caravana de Provisiones del Este",
	["Eastvale Logging Camp"] = "Aserradero de la Vega del Este",
	["Eastwall Gate"] = "Puerta de la Muralla del Este",
	["Eastwall Tower"] = "Torre de la Muralla del Este",
	["Eastwind Rest"] = "Reposo Viento del Este",
	["Eastwind Shore"] = "Playa Viento Este",
	["Ebon Hold"] = "El Bastión de Ébano",
	["Ebon Watch"] = "Puesto de Vigilancia de Ébano",
	["Echo Cove"] = "Cala del Eco",
	["Echo Isles"] = "Islas del Eco",
	["Echomok Cavern"] = "Cueva Echomok",
	["Echo Reach"] = "Risco del Eco",
	["Echo Ridge Mine"] = "Mina del Eco",
	["Eclipse Point"] = "Punta Eclipse",
	["Eclipsion Fields"] = "Campos Eclipsianos",
	["Eco-Dome Farfield"] = "Ecodomo Campolejano",
	["Eco-Dome Midrealm"] = "Ecodomo de la Tierra Media",
	["Eco-Dome Skyperch"] = "Ecodomo Altocielo",
	["Eco-Dome Sutheron"] = "Ecodomo Sutheron",
	["Elder Rise"] = "Alto de los Ancestros",
	["Elders' Square"] = "Plaza de los Ancestros",
	["Eldreth Row"] = "Pasaje de Eldreth",
	["Eldritch Heights"] = "Cumbres Fantasmales",
	["Elemental Plateau"] = "Meseta Elemental",
	["Elementium Depths"] = "Profundidades de Elementium",
	Elevator = "Elevador",
	["Elrendar Crossing"] = "Cruce Elrendar",
	["Elrendar Falls"] = "Cascadas Elrendar",
	["Elrendar River"] = "Río Elrendar",
	["Elwynn Forest"] = "Bosque de Elwynn",
	["Ember Clutch"] = "Encierro Ámbar",
	Emberglade = "El Claro de Ascuas",
	["Ember Spear Tower"] = "Torre Lanza Ámbar",
	["Emberstone Mine"] = "Mina Piedra Ígnea",
	["Emberstone Village"] = "Aldea Piedra Ígnea",
	["Emberstrife's Den"] = "Cubil de Brasaliza",
	["Emerald Dragonshrine"] = "Santuario de Dragones Esmeralda",
	["Emerald Dream"] = "Sueño Esmeralda",
	["Emerald Forest"] = "Bosque Esmeralda",
	["Emerald Sanctuary"] = "Santuario Esmeralda",
	["Emperor Rikktik's Rest"] = "Descanso del Emperador Rikktik",
	["Emperor's Omen"] = "Augurio del Emperador",
	["Emperor's Reach"] = "Tramo del Emperador",
	["End Time"] = "Fin de los Días",
	["Engineering Labs"] = "Laboratorios de Ingeniería",
	["Engineering Labs "] = "Laboratorios de Ingeniería",
	["Engine of Nalak'sha"] = "Motor de Nalak'sha",
	["Engine of the Makers"] = "Motor de los Creadores",
	["Entryway of Time"] = "Umbral del Tiempo",
	["Ethel Rethor"] = "Ethel Rethor",
	["Ethereal Corridor"] = "Galería Etérea",
	["Ethereum Staging Grounds"] = "Punto de Escala de El Etereum",
	["Evergreen Trading Post"] = "Puesto de Venta de Siempreverde",
	Evergrove = "Soto Eterno",
	Everlook = "Vista Eterna",
	["Eversong - Duskwither Teleport"] = "Bosque Canción Eterna",
	["Eversong Woods"] = "Bosque Canción Eterna",
	["Excavation Center"] = "Centro de Excavación",
	["Excavation Lift"] = "Elevador de la Excavación",
	["Exclamation Point"] = "Punta del Grito",
	["Expedition Armory"] = "Armería de Expedición",
	["Expedition Base Camp"] = "Campamento Base de la Expedición",
	["Expedition Point"] = "Punta de Expedición",
	["Explorers' League Digsite"] = "Excavación de la Liga de Expedicionarios",
	["Explorers' League Outpost"] = "Avanzada de la Liga de Expedicionarios",
	["Exposition Pavilion"] = "Pabellón de exposición",
	["Eye of Eternity"] = "Ojo de la Eternidad",
	["Eye of the Storm"] = "Ojo de la Tormenta",
	["Fairbreeze Village"] = "Aldea Brisa Pura",
	["Fairbridge Strand"] = "Playa Puentegrato",
	["Falcon Watch"] = "Avanzada del Halcón",
	["Falconwing Inn"] = "Posada Alalcón",
	["Falconwing Square"] = "Plaza Alalcón",
	["Faldir's Cove"] = "Cala de Faldir",
	["Falfarren River"] = "Río Falfarren",
	["Fallen Sky Lake"] = "Lago Cielo Estrellado",
	["Fallen Sky Ridge"] = "Cresta Cielo Estrellado",
	["Fallen Temple of Ahn'kahet"] = "Templo Caído de Ahn'kahet",
	["Fall of Return"] = "Cascada del Retorno",
	["Fallowmere Inn"] = "Taberna de Merobarbecho",
	["Fallow Sanctuary"] = "Retiro Fangoso",
	["Falls of Ymiron"] = "Cataratas de Ymiron",
	["Fallsong Village"] = "Poblado Canción de Otoño",
	["Falthrien Academy"] = "Academia Falthrien",
	Familiars = "Familiares",
	["Faol's Rest"] = "Tumba de Faol",
	["Fargaze Mesa"] = "Colina de Vistalonga",
	["Fargodeep Mine"] = "Mina Abisal",
	Farm = "Granja",
	Farshire = "Lindeallá",
	["Farshire Fields"] = "Campos de Lindeallá",
	["Farshire Lighthouse"] = "Faro de Lindeallá",
	["Farshire Mine"] = "Mina de Lindeallá",
	["Farson Hold"] = "Fortaleza de Farson",
	["Farstrider Enclave"] = "Enclave del Errante",
	["Farstrider Lodge"] = "Cabaña del Errante",
	["Farstrider Retreat"] = "El Retiro del Errante",
	["Farstriders' Enclave"] = "Enclave del Errante",
	["Farstriders' Square"] = "Plaza del Errante",
	["Farwatcher's Glen"] = "Cañada del Vigiaconfines",
	["Farwatch Overlook"] = "Alto de Vigilancia",
	["Far Watch Post"] = "Avanzada del Puente",
	["Fear Clutch"] = "Guarida del Miedo",
	["Featherbeard's Hovel"] = "Cobertizo de Barbapluma",
	Feathermoon = "Plumaluna",
	["Feathermoon Stronghold"] = "Bastión Plumaluna",
	["Fe-Feng Village"] = "Poblado Fe-Feng",
	["Felfire Hill"] = "Cerro Lumbrevil",
	["Felpaw Village"] = "Poblado Zarpavil",
	["Fel Reaver Ruins"] = "Ruinas del Atracador Vil",
	["Fel Rock"] = "Roca Mácula",
	["Felspark Ravine"] = "Barranco Llama Infernal",
	["Felstone Field"] = "Campo de Piedramácula",
	Felwood = "Frondavil",
	["Fenris Isle"] = "Isla de Fenris",
	["Fenris Keep"] = "Castillo de Fenris",
	Feralas = "Feralas",
	["Feralfen Village"] = "Aldea Feropantano",
	["Feral Scar Vale"] = "Vega Cicatriz Feral",
	["Festering Pools"] = "Pozas Purulentas",
	["Festival Lane"] = "Calle del Festival",
	["Feth's Way"] = "Camino de Feth",
	["Field of Korja"] = "Tierra de Korja",
	["Field of Strife"] = "Tierra de Disputa",
	["Fields of Blood"] = "Campos de Sangre",
	["Fields of Honor"] = "Campos de Honor",
	["Fields of Niuzao"] = "Campos de Niuzao",
	Filming = "Grabando",
	["Final Gate - Mogu Island Progression Scenario"] = "Puerta final - Gesta de progresión de la isla mogu",
	["Firebeard Cemetery"] = "Cementerio Barbafuego",
	["Firebeard's Patrol"] = "Patrulla de Barbafuego",
	["Firebough Nook"] = "Rincón Tallo Ardiente",
	["Fire Camp Bataar"] = "Campamento Bataar",
	["Fire Camp Gai-Cho"] = "Campamento Gai-Cho",
	["Fire Camp Ordo"] = "Campamento de Ordo",
	["Fire Camp Osul"] = "Campamento Osul",
	["Fire Camp Ruqin"] = "Campamento Ruqin",
	["Fire Camp Yongqi"] = "Campamento Yongqi",
	["Firegut Furnace"] = "Horno Pirontraña",
	Firelands = "Tierras de Fuego",
	["Firelands Forgeworks"] = "Forja de las Tierras de Fuego",
	["Firelands Hatchery"] = "Criadero de las Tierras de Fuego",
	["Firelands Terrain 2"] = "Firelands Terrain 2",
	["Fireplume Peak"] = "Cima Pluma de Fuego",
	["Fire Plume Ridge"] = "Cresta del Penacho en Llamas",
	["Fireplume Trench"] = "Zanja de Penacho en Llamas",
	["Fire Scar Shrine"] = "Santuario de la Escara",
	["Fire Stone Mesa"] = "Mesa de La Piedra de Fuego",
	["Firestone Point"] = "Punta Piedra de Fuego",
	["Firewatch Ridge"] = "Cresta Vigía",
	["Firewing Point"] = "Alto Ala de Fuego",
	["First Bank of Kezan"] = "Primer Banco de Kezan",
	["First Legion Forward Camp"] = "Puesto de Avanzada de la Primera Legión",
	["First to Your Aid"] = "Te Auxiliamos los Primeros",
	["Fishing Village"] = "Aldea Pesquera",
	["Fizzcrank Airstrip"] = "Pista de Aterrizaje de Palanqueta",
	["Fizzcrank Pumping Station"] = "Estación de Bombeo de Palanqueta",
	["Fizzle & Pozzik's Speedbarge"] = "Barcódromo de Fizzle y Pozzik",
	["Fjorn's Anvil"] = "Yunque de Fjorn",
	Flamebreach = "Brecha Flama",
	["Flame Crest"] = "Peñasco Llamarada",
	["Flamestar Post"] = "Puesto Llamaestrella",
	["Flamewatch Tower"] = "Torre de la Guardia en Llamas",
	["Flavor - Stormwind Harbor - Stop"] = "Flavor - Stormwind Harbor - Stop",
	["Fleshrender's Workshop"] = "Taller del Sacrificador",
	["Foothold Citadel"] = "Ciudadela Garrida",
	["Footman's Armory"] = "Arsenal de los Soldados",
	["Force Interior"] = "Fuerza Interior",
	["Fordragon Hold"] = "Bastión de Fordragón",
	["Forest Heart"] = "Corazón del Bosque",
	["Forest's Edge"] = "Linde del bosque",
	["Forest's Edge Post"] = "Puesto Fronterizo del Bosque",
	["Forest Song"] = "Canción del Bosque",
	["Forge Base: Gehenna"] = "Base Forja: Gehenna",
	["Forge Base: Oblivion"] = "Base Forja: Olvido",
	["Forge Camp: Anger"] = "Campamento Forja: Inquina",
	["Forge Camp: Fear"] = "Campamento Forja: Miedo",
	["Forge Camp: Hate"] = "Campamento Forja: Odio",
	["Forge Camp: Mageddon"] = "Campamento Forja: Mageddon",
	["Forge Camp: Rage"] = "Campamento Forja: Ira",
	["Forge Camp: Terror"] = "Campamento Forja: Terror",
	["Forge Camp: Wrath"] = "Campamento Forja: Cólera",
	["Forge of Fate"] = "Forja del Destino",
	["Forge of the Endless"] = "Forja del Infinito",
	["Forgewright's Tomb"] = "Tumba de Forjador",
	["Forgotten Depths"] = "Abismo de la Desidia",
	["Forgotten Hill"] = "Colina del Olvido",
	["Forgotten Mire"] = "Pantano Olvidado",
	["Forgotten Passageway"] = "Pasadizo Olvidado",
	["Forlorn Cloister"] = "Claustro Abandonado",
	["Forlorn Hut"] = "Cabaña Abandonada",
	["Forlorn Ridge"] = "Loma Desolada",
	["Forlorn Rowe"] = "Loma Inhóspita",
	["Forlorn Spire"] = "Cumbre Inhóspita",
	["Forlorn Woods"] = "El Bosque Desolado",
	["Formation Grounds"] = "Campo de Formación",
	["Forsaken Forward Command"] = "Mando Avanzado Renegado",
	["Forsaken High Command"] = "Alto Mando Renegado",
	["Forsaken Rear Guard"] = "Puesto de Retaguardia Renegado",
	["Fort Livingston"] = "Fuerte Livingston",
	["Fort Silverback"] = "Fuerte Lomoblanco",
	["Fort Triumph"] = "Fuerte Triunfo",
	["Fortune's Fist"] = "Puño de la Fortuna",
	["Fort Wildervar"] = "Fuerte Vildervar",
	["Forward Assault Camp"] = "Campamento de Asalto",
	["Forward Command"] = "Mando de Vanguardia",
	["Foulspore Cavern"] = "Gruta de la Espora Fétida",
	["Foulspore Pools"] = "Pozas de la Espora Fétida",
	["Fountain of the Everseeing"] = "Fuente de la Visión Eterna",
	["Fox Grove"] = "Arboleda del Zorro",
	["Fractured Front"] = "Frente Fracturado",
	["Frayfeather Highlands"] = "Tierras Altas de Plumavieja",
	["Fray Island"] = "Isla de Batalla",
	["Frazzlecraz Motherlode"] = "Filón Catacroquer",
	["Freewind Post"] = "Poblado Viento Libre",
	["Frenzyheart Hill"] = "Colina Corazón Frenético",
	["Frenzyheart River"] = "Río Corazón Frenético",
	["Frigid Breach"] = "Brecha Gélida",
	["Frostblade Pass"] = "Paso Filoescarcha",
	["Frostblade Peak"] = "Pico Filoescarcha",
	["Frostclaw Den"] = "Cubil Garrascarcha",
	["Frost Dagger Pass"] = "Paso de la Daga Escarcha",
	["Frostfield Lake"] = "Lago Campo de Escarcha",
	["Frostfire Hot Springs"] = "Baños de Fuego de Escarcha",
	["Frostfloe Deep"] = "Hondonada Témpano Gélido",
	["Frostgrip's Hollow"] = "Hondonada Puño Helado",
	Frosthold = "Fuerte Escarcha",
	["Frosthowl Cavern"] = "Caverna Aúllaescarcha",
	["Frostmane Front"] = "Frente de Peloescarcha",
	["Frostmane Hold"] = "Poblado Peloescarcha",
	["Frostmane Hovel"] = "Cobertizo Peloescarcha",
	["Frostmane Retreat"] = "Refugio Peloescarcha",
	Frostmourne = "Agonía de Escarcha",
	["Frostmourne Cavern"] = "Caverna Agonía de Escarcha",
	["Frostsaber Rock"] = "Roca Sable de Hielo",
	["Frostwhisper Gorge"] = "Cañón Levescarcha",
	["Frostwing Halls"] = "Las Cámaras de Alaescarcha",
	["Frostwolf Graveyard"] = "Cementerio Lobo Gélido",
	["Frostwolf Keep"] = "Bastión Lobo Gélido",
	["Frostwolf Pass"] = "Paso Lobo Gélido",
	["Frostwolf Tunnel"] = "Túnel de Lobo Gélido",
	["Frostwolf Village"] = "Aldea Lobo Gélido",
	["Frozen Reach"] = "Tramo Helado",
	["Fungal Deep"] = "Profundidades Fungal",
	["Fungal Rock"] = "Roca Fungal",
	["Funggor Cavern"] = "Caverna Funggor",
	["Furien's Post"] = "Puesto de Furien",
	["Furlbrow's Pumpkin Farm"] = "Plantación de Calabazas de Cejade",
	["Furnace of Hate"] = "Horno del Odio",
	["Furywing's Perch"] = "Nido de Alafuria",
	Fuselight = "El Diodo",
	["Fuselight-by-the-Sea"] = "El Diodo de Mar",
	["Fu's Pond"] = "Charca de Fu",
	Gadgetzan = "Gadgetzan",
	["Gahrron's Withering"] = "Gangrena de Gahrron",
	["Gai-Cho Battlefield"] = "Frente Gai-Cho",
	["Galak Hold"] = "Dominios Galak",
	["Galakrond's Rest"] = "Reposo de Galakrond",
	["Galardell Valley"] = "Valle de Galardell",
	["Galen's Fall"] = "Caída de Galen",
	["Galerek's Remorse"] = "Remordimiento de Galerek",
	["Galewatch Lighthouse"] = "Faro Velavento",
	["Gallery of Treasures"] = "Galería de los Tesoros",
	["Gallows' Corner"] = "Camino de la Horca",
	["Gallows' End Tavern"] = "Mesón La Horca",
	["Gallywix Docks"] = "Muelles de Gallywix",
	["Gallywix Labor Mine"] = "Mina de Trabajos Forzados de Gallywix",
	["Gallywix Pleasure Palace"] = "Palacete de Gallywix",
	["Gallywix's Villa"] = "Chalet de Gallywix",
	["Gallywix's Yacht"] = "Yate de Gallywix",
	["Galus' Chamber"] = "Cámara de Galus",
	["Gamesman's Hall"] = "Sala del Tablero",
	Gammoth = "Gammoth",
	["Gao-Ran Battlefront"] = "Frente Gao-Ran",
	Garadar = "Garadar",
	["Gar'gol's Hovel"] = "Casucha de Gar'gol",
	Garm = "Garm",
	["Garm's Bane"] = "Pesadilla de Garm",
	["Garm's Rise"] = "Alto de Garm",
	["Garren's Haunt"] = "Granja de Garren",
	["Garrison Armory"] = "Arsenal del Cuartel",
	["Garrosh'ar Advance"] = "Avance Garrosh'ar",
	["Garrosh'ar Point"] = "Puesto Garrosh'ar",
	["Garrosh's Landing"] = "Desembarco de Garrosh",
	["Garvan's Reef"] = "Arrecife de Garvan",
	["Gate of Echoes"] = "Puerta de los Ecos",
	["Gate of Endless Spring"] = "Puerta de la Primavera Eterna",
	["Gate of Hamatep"] = "Puerta de Hamatep",
	["Gate of Lightning"] = "Puerta de los Rayos",
	["Gate of the August Celestials"] = "Puerta de los Augustos Celestiales",
	["Gate of the Blue Sapphire"] = "Puerta del Zafiro Azul",
	["Gate of the Green Emerald"] = "Puerta de la Esmeralda Verde",
	["Gate of the Purple Amethyst"] = "Puerta de la Amatista Púrpura",
	["Gate of the Red Sun"] = "Puerta del Sol Rojo",
	["Gate of the Setting Sun"] = "Puerta del Sol Poniente",
	["Gate of the Yellow Moon"] = "Puerta de la Luna Amarilla",
	["Gates of Ahn'Qiraj"] = "Puerta de Ahn'Qiraj",
	["Gates of Ironforge"] = "Puertas de Forjaz",
	["Gates of Sothann"] = "Puertas de Sothann",
	["Gauntlet of Flame"] = "Guantelete de Llamas",
	["Gavin's Naze"] = "Saliente de Gavin",
	["Geezle's Camp"] = "Campamento de Geezle",
	["Gelkis Village"] = "Poblado Gelkis",
	["General Goods"] = "Víveres",
	["General's Terrace"] = "Bancal del General",
	["Ghostblade Post"] = "Puesto del Filo Fantasmal",
	Ghostlands = "Tierras Fantasma",
	["Ghost Walker Post"] = "Campamento del Espíritu Errante",
	["Giant's Run"] = "El Paso del Gigante",
	["Giants' Run"] = "El Paso del Gigante",
	["Gilded Fan"] = "El Abanico Dorado",
	["Gillijim's Isle"] = "Isla de Gillijim",
	["Gilnean Coast"] = "Costa de Gilneas",
	["Gilnean Stronghold"] = "Fortaleza de Gilneas",
	Gilneas = "Gilneas",
	Gilneas2 = "Gilneas2",
	["Gilneas City"] = "Ciudad de Gilneas",
	["Gilneas (Do Not Reuse)"] = "Gilneas",
	["Gilneas Liberation Front Base Camp"] = "Campamento base del Frente de Liberación de Gilneas",
	GilneasPhase1 = "GilneasPhase1",
	GilneasPhase2 = "GilneasPhase2",
	["Gimorak's Den"] = "Guarida de Gimorak",
	Gjalerbron = "Gjalerbron",
	Gjalerhorn = "Gjalercorn",
	["Glacial Falls"] = "Cascadas Glaciales",
	["Glimmer Bay"] = "Bahía Titileo",
	["Glimmerdeep Gorge"] = "Barranco Brillohondo",
	["Glittering Strand"] = "Orilla Resplandeciente",
	["Glopgut's Hollow"] = "Foso Tripal",
	["Glorious Goods"] = "Objetos Gloriosos",
	Glory = "Gloria",
	["GM Island"] = "Isla de los MJ",
	["Gnarlpine Hold"] = "Tierras de los Tuercepinos",
	["Gnaws' Boneyard"] = "Fosa de Bocados",
	Gnomeregan = "Gnomeregan",
	["Gobline Mine"] = "Mina Goblin",
	["Goblin Foundry"] = "Fundición Goblin",
	["Goblin Mine"] = "Mina Goblin",
	["Goblin Slums"] = "Suburbios Goblin",
	["Gokk'lok's Grotto"] = "Gruta de Gokk'lok",
	["Gokk'lok Shallows"] = "Arrecifes Gokk'lok",
	["Golakka Hot Springs"] = "Baños de Golakka",
	["Gol'Bolar Quarry"] = "Cantera de Gol'Bolar",
	["Gol'Bolar Quarry Mine"] = "Cantera de Gol'Bolar",
	["Gold Coast Quarry"] = "Mina de la Costa del Oro",
	["Goldenbough Pass"] = "Desfiladero Ramadorada",
	["Goldenmist Village"] = "Aldea Bruma Dorada",
	["Golden Strand"] = "La Ensenada Dorada",
	["Gold Mine"] = "Mina de oro",
	["Gold Road"] = "Camino del Oro",
	["Gold Rush BG"] = "CDB de Fiebre del Oro",
	Goldshire = "Villadorada",
	["Goldtooth's Den"] = "Cubil de Dientes de Oro",
	["Goodgrub Smoking Pit"] = "Foso de Humo de Buenazampa",
	["Gordok's Seat"] = "Trono de Gordok",
	["Gordunni Outpost"] = "Avanzada Gordunni",
	["Gorefiend's Vigil"] = "Vigilia de Sanguino",
	["Gor'gaz Outpost"] = "Avanzada Gor'gaz",
	Gornia = "Gornia",
	["Gorrok's Lament"] = "Lamento de Gorrok",
	["Gorshak War Camp"] = "Campamento de Guerra Gorshak",
	["Go'Shek Farm"] = "Granja Go'shek",
	["Grain Cellar"] = "Almacén de Grano",
	["Grand Courtyard"] = "Gran Patio",
	["Grand Magister's Asylum"] = "Asilo del Gran Magister",
	["Grand Overlook"] = "Gran Mirador",
	["Grand Promenade"] = "Gran Paseo",
	["Grangol'var Village"] = "Poblado Grangol'var",
	["Granite Springs"] = "Manantial de Granito",
	["Grassy Cline"] = "Vega Escarpada",
	["Greatwood Vale"] = "Vega del Gran Bosque",
	["Greengill Coast"] = "Costa Branquia Verde",
	["Greenpaw Village"] = "Poblado Zarpaverde",
	["Greenstone Dojo"] = "Dojo de Verdemar",
	["Greenstone Inn"] = "Posada de Verdemar",
	["Greenstone Masons' Quarter"] = "Barrio de Canteros de Verdemar",
	["Greenstone Quarry"] = "Cantera Verdemar",
	["Greenstone Village"] = "Aldea Verdemar",
	["Greenwarden's Grove"] = "Arboleda del Guardaverde",
	["Greymane Court"] = "Patio de Cringris",
	["Greymane Manor"] = "Mansión de Cringris",
	["Greymist Firth"] = "Ría Brumagris",
	["Grim Batol"] = "Grim Batol",
	["Grim Batol Entrance"] = "Entrada de Grim Batol",
	["Grimesilt Dig Site"] = "Excavación de Limugre",
	["Grimtotem Compound"] = "Dominios Tótem Siniestro",
	["Grimtotem Post"] = "Poblado Tótem Siniestro",
	Grishnath = "Grishnath",
	Grizzlemaw = "Fauceparda",
	["Grizzlepaw Ridge"] = "Fuerte Zarpagris",
	["Grizzly Hills"] = "Colinas Pardas",
	["Grol'dom Farm"] = "Granja de Grol'dom",
	["Grolluk's Grave"] = "Tumba de Grolluk",
	["Grom'arsh Crash-Site"] = "Lugar del accidente de Grom'arsh",
	["Grom'gol"] = "Grom'gol",
	["Grom'gol Base Camp"] = "Campamento Grom'gol",
	["Grommash Hold"] = "Fuerte Grommash",
	["Grookin Hill"] = "Cerro Makaku",
	["Grosh'gok Compound"] = "Dominios Grosh'gok",
	["Grove of Aessina"] = "Arboleda de Aessina",
	["Grove of Falling Blossoms"] = "La Arboleda Florida",
	["Grove of the Ancients"] = "Páramo de los Ancianos",
	["Growless Cave"] = "Caverna Estrecha",
	["Gruul's Lair"] = "Guarida de Gruul",
	["Gryphon Roost"] = "Percha de grifo",
	["Guardian's Library"] = "Biblioteca del Guardián",
	Gundrak = "Gundrak",
	["Gundrak Entrance"] = "Entrada de Gundrak",
	["Gunstan's Dig"] = "Excavación de Dig",
	["Gunstan's Post"] = "Puesto de Gunstan",
	["Gunther's Retreat"] = "Refugio de Gunther",
	["Guo-Lai Halls"] = "Salas de Guo-Lai",
	["Guo-Lai Ritual Chamber"] = "Cámara Ritual de Guo-Lai",
	["Guo-Lai Vault"] = "Cámara de Guo-Lai",
	["Gurboggle's Ledge"] = "Saliente de Guraturdido",
	["Gurubashi Arena"] = "Arena Gurubashi",
	["Gyro-Plank Bridge"] = "Puente Girolámina",
	["Haal'eshi Gorge"] = "Garganta Haal'eshi",
	["Hadronox's Lair"] = "Guarida de Hadronox",
	["Hailwood Marsh"] = "Pantano Bosque del Pedrisco",
	Halaa = "Halaa",
	["Halaani Basin"] = "Cuenca Halaani",
	["Halcyon Egress"] = "Egreso Próspero",
	["Haldarr Encampment"] = "Campamento Haldarr",
	Halfhill = "El Alcor",
	Halgrind = "Haltorboll",
	["Hall of Arms"] = "Sala de Armas",
	["Hall of Binding"] = "Sala de Vínculos",
	["Hall of Blackhand"] = "Sala de Puño Negro",
	["Hall of Blades"] = "Sala de las Espadas",
	["Hall of Bones"] = "Sala de los Huesos",
	["Hall of Champions"] = "Sala de los Campeones",
	["Hall of Command"] = "Sala de Mando",
	["Hall of Crafting"] = "Sala de los Oficios",
	["Hall of Departure"] = "Cámara de Partida",
	["Hall of Explorers"] = "Sala de los Expedicionarios",
	["Hall of Faces"] = "Sala de los Rostros",
	["Hall of Horrors"] = "Cámara de los Horrores",
	["Hall of Illusions"] = "Sala de las Ilusiones",
	["Hall of Kings"] = "Cámara de los Reyes",
	["Hall of Legends"] = "Sala de las Leyendas",
	["Hall of Masks"] = "Sala de las Máscaras",
	["Hall of Memories"] = "Cámara de los Recuerdos",
	["Hall of Mysteries"] = "Sala de los Misterios",
	["Hall of Repose"] = "Sala del Descanso",
	["Hall of Return"] = "Cámara de Regreso",
	["Hall of Ritual"] = "Sala de los Rituales",
	["Hall of Secrets"] = "Sala de los Secretos",
	["Hall of Serpents"] = "Sala de las Serpientes",
	["Hall of Shapers"] = "Sala de Creadores",
	["Hall of Stasis"] = "Cámara de Estasis",
	["Hall of the Brave"] = "Bastión de los Valientes",
	["Hall of the Conquered Kings"] = "Cámara de los Reyes Conquistados",
	["Hall of the Crafters"] = "Sala de los Artesanos",
	["Hall of the Crescent Moon"] = "Sala de la Luna Creciente",
	["Hall of the Crusade"] = "Sala de la Cruzada",
	["Hall of the Cursed"] = "Sala de los Malditos",
	["Hall of the Damned"] = "Sala de los Condenados",
	["Hall of the Defamed"] = "Cámara de los Difamados",
	["Hall of the Exalted"] = "Cámara de los Eminentes",
	["Hall of the Fathers"] = "Cámara de los Patriarcas",
	["Hall of the Frostwolf"] = "Cámara de los Lobo Gélido",
	["Hall of the Grand Imperion"] = "Aposento del Gran Imperión",
	["Hall of the High Father"] = "Cámara del Gran Padre",
	["Hall of the Keepers"] = "Sala de los Guardianes",
	["Hall of the Shaper"] = "Sala del Creador",
	["Hall of the Stormpike"] = "Cámara de los Pico Tormenta",
	["Hall of the Tortured"] = "Cámara de la Tortura",
	["Hall of the Watchers"] = "Cámara de los Vigías",
	["Hall of the Wicked"] = "Cámara de los Malditos",
	["Hall of Tombs"] = "Sala de Tumbas",
	["Hall of Tranquility"] = "Sala de la Quietud",
	["Hall of Tranquillity"] = "Sala de la Quietud",
	["Hall of Twilight"] = "Sala del Crepúsculo",
	["Halls of Anguish"] = "Salas de Angustia",
	["Halls of Awakening"] = "Salas del Despertar",
	["Halls of Binding"] = "Sala de Vínculos",
	["Halls of Destruction"] = "Salas de la Destrucción",
	["Halls of Flesh-Shaping"] = "Cámaras de Modelado de Carne",
	["Halls of Lightning"] = "Cámaras de Relámpagos",
	["Halls of Lightning Entrance"] = "Entrada de Cámaras de Relámpagos",
	["Halls of Mourning"] = "Salas del Luto",
	["Halls of Origination"] = "Cámaras de los Orígenes",
	["Halls of Origination Entrance"] = "Entrada de las Cámaras de los Orígenes",
	["Halls of Reflection"] = "Cámaras de Reflexión",
	["Halls of Reflection Entrance"] = "Entrada de Cámaras de Reflexión",
	["Halls of Silence"] = "Salas del Silencio",
	["Halls of Stone"] = "Cámaras de Piedra",
	["Halls of Stone Entrance"] = "Entrada de Cámaras de Piedra",
	["Halls of Strife"] = "Salas de los Conflictos",
	["Halls of the Ancestors"] = "Salas de los Ancestros",
	["Halls of the Hereafter"] = "Salas del Más Allá",
	["Halls of the Law"] = "Salas de la Ley",
	["Halls of Theory"] = "Galerías de la Teoría",
	["Halycon's Lair"] = "Guarida de Halycon",
	Hammerfall = "Sentencia",
	["Hammertoe's Digsite"] = "Excavación de Piemartillo",
	["Hammond Farmstead"] = "Hacienda de Hammond",
	Hangar = "Hangar",
	["Hardknuckle Clearing"] = "Claro Callonudillo",
	["Hardwrench Hideaway"] = "Escondrijo Malallave",
	["Harkor's Camp"] = "Campamento de Harkor",
	["Hatchet Hills"] = "Colinas Hacha",
	["Hatescale Burrow"] = "Madriguera Escama Odiosa",
	["Hatred's Vice"] = "Corrupción del Odio",
	Havenshire = "Villa Refugio",
	["Havenshire Farms"] = "Granjas de Villa Refugio",
	["Havenshire Lumber Mill"] = "Serrería de Villa Refugio",
	["Havenshire Mine"] = "Mina de Villa Refugio",
	["Havenshire Stables"] = "Establos de Villa Refugio",
	["Hayward Fishery"] = "Caladero Hayward",
	["Headmaster's Retreat"] = "Reposo del Rector",
	["Headmaster's Study"] = "Sala Rectoral",
	Hearthglen = "Vega del Amparo",
	["Heart of Destruction"] = "Corazón de Destrucción",
	["Heart of Fear"] = "Corazón del Miedo",
	["Heart of the Old God Scenario"] = "Gesta del Corazón del Dios Antiguo",
	["Heart of Zan'vess"] = "Corazón de Zan'vess",
	["Heart's Blood Shrine"] = "Santuario Sangre de Corazón",
	["Heartwood Trading Post"] = "Puesto de Venta de Duramen",
	["Heb'Drakkar"] = "Heb'Drakkar",
	["Heb'Valok"] = "Heb'Valok",
	["Hellfire Basin"] = "Cuenca del Fuego Infernal",
	["Hellfire Citadel"] = "Ciudadela del Fuego Infernal",
	["Hellfire Citadel: Ramparts"] = "Ciudadela del Fuego Infernal: Murallas",
	["Hellfire Citadel - Ramparts Entrance"] = "Ciudadela del Fuego Infernal: Entrada de las Murallas",
	["Hellfire Citadel: The Blood Furnace"] = "Ciudadela del Fuego Infernal: Horno de Sangre",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Ciudadela del Fuego Infernal: Entrada de El Horno de Sangre",
	["Hellfire Citadel: The Shattered Halls"] = "Ciudadela del Fuego Infernal: Salas Arrasadas",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Ciudadela del Fuego Infernal: Entrada de Las Salas Arrasadas",
	["Hellfire Peninsula"] = "Península del Fuego Infernal",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Península del Fuego Infernal - Force Camp Beach Head",
	["Hellfire Peninsula - Reaver's Fall"] = "Península del Fuego Infernal - Caída del Atracador Vil",
	["Hellfire Ramparts"] = "Murallas del Fuego Infernal",
	["Hellscream Arena"] = "Arena de Grito Infernal",
	["Hellscream's Camp"] = "Campamento de Grito Infernal",
	["Hellscream's Fist"] = "Puño de Grito Infernal",
	["Hellscream's Grasp"] = "Dominios Grito Infernal",
	["Hellscream's Watch"] = "Avanzada Grito Infernal",
	["Helm's Bed Lake"] = "Lago de Helm",
	["Heroes' Vigil"] = "Vigilia de los Héroes",
	["Hetaera's Clutch"] = "Guarida de Hetaera",
	["Hewn Bog"] = "Ciénaga Talada",
	["Heyman's Hubris"] = "Orgullo de Heyman",
	["Hibernal Cavern"] = "Caverna Hibernal",
	["Hidden Cell"] = "Celda Oculta",
	["Hidden Path"] = "Sendero Oculto",
	Highbank = "Bancalto",
	["High Bank"] = "Bancalto",
	["Highland Forest"] = "Bosque de las Tierras Altas",
	Highperch = "Nido Alto",
	["High Wilderness"] = "Altas Tierras Salvajes",
	Hillsbrad = "Trabalomas",
	["Hillsbrad Fields"] = "Campos de Trabalomas",
	["Hillsbrad Foothills"] = "Laderas de Trabalomas",
	["Hiri'watha Research Station"] = "Estación de Investigación de Hiri'watha",
	["Hive'Ashi"] = "Colmen'Ashi",
	["Hive'Regal"] = "Colmen'Regal",
	["Hive'Zora"] = "Colmen'Zora",
	["Hogger Hill"] = "Colina de Hogger",
	["Hollowed Out Tree"] = "Árbol Hueco",
	["Hollowstone Mine"] = "Mina Piedrahueca",
	["Honeydew Farm"] = "Granja Almíbar",
	["Honeydew Glade"] = "Claro Almíbar",
	["Honeydew Village"] = "Poblado Almíbar",
	["Honor Hold"] = "Bastión del Honor",
	["Honor Hold Mine"] = "Mina Bastión del Honor",
	["Honor Point"] = "Alto del Honor",
	["Honor's Stand"] = "El Alto del Honor",
	["Honor's Tomb"] = "Tumba del Honor",
	["Horde Base Camp"] = "Campamento Base de la Horda",
	["Horde Beach Daily Area"] = "Zona de diarias de playa de la Horda",
	["Horde Encampment"] = "Campamento de la Horda",
	["Horde Keep"] = "Fortaleza de la Horda",
	["Horde Landing"] = "Aterrizaje de la Horda",
	["Horde Landing Site"] = "Lugar del Desembarco de la Horda",
	["Hordemar City"] = "Ciudad Hordemar",
	["Horde PVP Barracks"] = "Cuartel JcJ de la Horda",
	["Horror Clutch"] = "Guarida del Horror",
	["Hour of Twilight"] = "Hora del Crepúsculo",
	["House of Edune"] = "Casa de Edune",
	["Howling Fjord"] = "Fiordo Aquilonal",
	["Howlingwind Cavern"] = "Caverna Viento Aullante",
	["Howlingwind Trail"] = "Senda Viento Aullante",
	["Howling Ziggurat"] = "Zigurat Aullante",
	["Hrothgar's Landing"] = "Desembarco de Hrothgar",
	["Huangtze Falls"] = "Cataratas Huangtze",
	["Hull of the Foebreaker"] = "Casco del Rasgadversarios",
	["Humboldt Conflagration"] = "Conflagración de Humboldt",
	["Hunter Rise"] = "Alto de los Cazadores",
	["Hunter's Hill"] = "Cerro del Cazador",
	["Huntress of the Sun"] = "Cazadora del Sol",
	["Huntsman's Cloister"] = "Claustro del Cazador",
	Hyjal = "Hyjal",
	["Hyjal Barrow Dens"] = "Túmulos de Hyjal",
	["Hyjal Past"] = "El Pasado Hyjal",
	["Hyjal Summit"] = "La Cima Hyjal",
	["Iceblood Garrison"] = "Baluarte Sangrehielo",
	["Iceblood Graveyard"] = "Cementerio Sangrehielo",
	Icecrown = "Corona de Hielo",
	["Icecrown Citadel"] = "Ciudadela de la Corona de Hielo",
	["Icecrown Dungeon - Gunships"] = "Mazmorra de Corona de Hielo",
	["Icecrown Glacier"] = "Glaciar Corona de Hielo",
	["Iceflow Lake"] = "Lago Glacial",
	["Ice Heart Cavern"] = "Caverna Corazón de Hielo",
	["Icemist Falls"] = "Cataratas Bruma de Hielo",
	["Icemist Village"] = "Poblado Bruma de Hielo",
	["Ice Thistle Hills"] = "Colinas Cardo Nevado",
	["Icewing Bunker"] = "Búnker Ala Gélida",
	["Icewing Cavern"] = "Cueva Ala Gélida",
	["Icewing Pass"] = "Paso de Ala Gélida",
	["Idlewind Lake"] = "Lago Soplo",
	["Igneous Depths"] = "Profundidades Ígneas",
	["Ihgaluk Crag"] = "Risco Ihgaluk",
	["Ik'vess"] = "Ik'vess",
	["Ikz'ka Ridge"] = "Cresta Ikz'ka",
	["Illidari Point"] = "Alto Illidari",
	["Illidari Training Grounds"] = "Campo de Entrenamiento Illidari",
	["Indu'le Village"] = "Poblado Indu'le",
	["Infiltrating the Shipyard"] = "Infiltración en el Astillero",
	["Inkgill Mere"] = "Presa Branquias de Tinta",
	Inn = "Posada",
	["Inner Sanctum"] = "Sagrario Interior",
	["Inner Veil"] = "Velo Interior",
	["Insidion's Perch"] = "Nido de Insidion",
	["Invasion Point: Annihilator"] = "Punto de invasión: Aniquilador",
	["Invasion Point: Cataclysm"] = "Punto de Invasión: Cataclismo",
	["Invasion Point: Destroyer"] = "Punto de Invasión: Destructor",
	["Invasion Point: Overlord"] = "Punto de Invasión: Señor Supremo",
	["Ironband's Compound"] = "Complejo Vetaferro",
	["Ironband's Excavation Site"] = "Excavación de Vetaferro",
	["Ironbeard's Tomb"] = "Tumba de Barbaférrea",
	["Ironclad Cove"] = "Cala del Acorazado",
	["Ironclad Garrison"] = "Cuartel del Acorazado",
	["Ironclad Prison"] = "Prisión del Acorazado",
	["Iron Concourse"] = "Explanada de Hierro",
	["Irondeep Mine"] = "Mina Ferrohondo",
	Ironforge = "Forjaz",
	["Ironforge Airfield"] = "Base aérea de Forjaz",
	["Ironstone Camp"] = "Campamento Roca de Hierro",
	["Ironstone Plateau"] = "Meseta Roca de Hierro",
	["Iron Summit"] = "Cima de Hierro",
	["Irontree Cavern"] = "Caverna de Troncoferro",
	["Irontree Clearing"] = "Claro de Troncoferro",
	["Irontree Woods"] = "Bosque de Troncoferro",
	["Ironwall Dam"] = "Presa del Muro de Hierro",
	["Ironwall Rampart"] = "Fortificación del Muro de Hierro",
	["Ironwing Cavern"] = "Caverna de Alahierro",
	Iskaal = "Iskaal",
	["Island of Doctor Lapidis"] = "Isla del Doctor Lapidis",
	["Isle of Conquest"] = "Isla de la Conquista",
	["Isle of Conquest No Man's Land"] = "Tierra de Nadie de Isla de la Conquista",
	["Isle of Dread"] = "Isla del Terror",
	["Isle of Giants"] = "Isla de los Gigantes",
	["Isle of Quel'Danas"] = "Isla de Quel'Danas",
	["Isle of Reckoning"] = "Isla de la Venganza",
	["Isle of Thunder"] = "Isla del Trueno",
	["Isle of Tribulations"] = "Isla de las Tribulaciones",
	["Iso'rath"] = "Iso'rath",
	["Itharius's Cave"] = "Cueva de Itharius",
	["Ivald's Ruin"] = "Ruinas de Ivald",
	["Ix'lar's Domain"] = "Dominio de Ix'lar",
	["Jadefire Glen"] = "Cañada Fuego de Jade",
	["Jadefire Run"] = "Camino Fuego de Jade",
	["Jade Forest Alliance Hub Phase"] = "Fase del centro de la Alianza en El Bosque de Jade",
	["Jade Forest Battlefield Phase"] = "Fase de campo de batalla de El Bosque de Jade",
	["Jade Forest Horde Starting Area"] = "Zona de inicio de la Horda de El Bosque de Jade",
	["Jademir Lake"] = "Lago Jademir",
	["Jade Temple Grounds"] = "Tierras del Templo de Jade",
	Jaedenar = "Jaedenar",
	["Jagged Reef"] = "Arrecife Dentado",
	["Jagged Ridge"] = "Cresta Dentada",
	["Jaggedswine Farm"] = "La Pocilga",
	["Jagged Wastes"] = "Ruinas Dentadas",
	["Jaguero Isle"] = "Isla Jaguero",
	["Jaina Dalaran Scenario"] = "Gesta de Dalaran de Jaina",
	["Janeiro's Point"] = "Cayo de Janeiro",
	["Jangolode Mine"] = "Mina de Jango",
	["Jaquero Isle"] = "Isla Jaquero",
	["Jasperlode Mine"] = "Cantera de Jaspe",
	["Jeff NE Quadrant Changed"] = "Jeff NE Quadrant Changed",
	["Jeff NW Quadrant"] = "Jeff NW Quadrant",
	["Jeff SE Quadrant"] = "Jeff SE Quadrant",
	["Jeff SW Quadrant"] = "Jeff SW Quadrant",
	["Jerod's Landing"] = "Embarcadero de Jerod",
	["Jintha'Alor"] = "Jintha'Alor",
	["Jintha'kalar"] = "Jintha'kalar",
	["Jintha'kalar Passage"] = "Pasaje de Jintha'kalar",
	["Jin Yang Road"] = "Camino Jin Yang",
	Jotunheim = "Jotunheim",
	K3 = "K3",
	["Kaja'mine"] = "Kaja'mina",
	["Kaja'mite Cave"] = "Cueva de Kaja'mita",
	["Kaja'mite Cavern"] = "Caverna de Kaja'mita",
	["Kajaro Field"] = "Campo Kajaro",
	["Kal'ai Ruins"] = "Ruinas de Kal'ai",
	Kalimdor = "Kalimdor",
	Kamagua = "Komawa",
	["Karabor Sewers"] = "Cloacas de Karabor",
	Karazhan = "Karazhan",
	["Kargathia Keep"] = "Fuerte de Kargathia",
	["Karnum's Glade"] = "Claro de Karnum",
	["Kartak's Hold"] = "Bastión de Kartak",
	Kaskala = "Kashala",
	["Kaw's Roost"] = "Percha de Kaw",
	["Kea Krak"] = "Kea Krak",
	["Keelen's Trustworthy Tailoring"] = "La Sastrería Fiable de Keelen",
	["Keel Harbor"] = "Puerto Quilla",
	["Keeshan's Post"] = "Puesto de Keeshan",
	["Kelp'thar Forest"] = "Bosque Kelp'thar",
	["Kel'Thuzad Chamber"] = "Cámara de Kel'Thuzad",
	["Kel'Thuzad's Chamber"] = "Cámara de Kel'Thuzad",
	["Keset Pass"] = "Paso de Keset",
	["Kessel's Crossing"] = "Encrucijada de Kessel",
	Kezan = "Kezan",
	Kharanos = "Kharanos",
	["Khardros' Anvil"] = "Yunque de Khardros",
	["Khartut's Tomb"] = "Tumba de Khartut",
	["Khaz'goroth's Seat"] = "Trono de Khaz'goroth",
	["Ki-Han Brewery"] = "Cervecería Ki-Han",
	["Kili'ua's Atoll"] = "Atolón de Kili'ua",
	["Kil'sorrow Fortress"] = "Fortaleza Mata'penas",
	["King's Gate"] = "Puerta del Rey",
	["King's Harbor"] = "Puerto del Rey",
	["King's Hoard"] = "Reservas del Rey",
	["King's Square"] = "Plaza del Rey",
	["Kirin'Var Village"] = "Poblado Kirin'Var",
	Kirthaven = "Kirthaven",
	["Klaxxi'vess"] = "Klaxxi'vess",
	["Klik'vess"] = "Klik'vess",
	["Knucklethump Hole"] = "Agujero Machakadedo",
	["Kodo Graveyard"] = "Cementerio de Kodos",
	["Kodo Rock"] = "Roca de los Kodos",
	["Kolkar Village"] = "Poblado Kolkar",
	Kolramas = "Kolramas",
	["Kor'kron Vanguard"] = "Vanguardia Kor'kron",
	["Kormek's Hut"] = "Cabaña de Kormek",
	["Koroth's Den"] = "Cubil de Koroth",
	["Korthun's End"] = "Fin de Korthun",
	["Kor'vess"] = "Kor'vess",
	["Kota Basecamp"] = "Campamento Base Kota",
	["Kota Peak"] = "Cumbre Kota",
	["Krasarang Cove"] = "Cala Krasarang",
	["Krasarang River"] = "Río Krasarang",
	["Krasarang Wilds"] = "Espesura Krasarang",
	["Krasari Falls"] = "Cataratas Krasari",
	["Krasus' Landing"] = "Alto de Krasus",
	["Krazzworks Attack Zeppelin"] = "Zepelín de ataque de La Krazzería",
	["Kril'Mandar Point"] = "Punta de Kril'mandar",
	["Kri'vess"] = "Kri'vess",
	["Krolg's Hut"] = "Cabaña de Krolg",
	["Krom'gar Fortress"] = "Fortaleza Krom'gar",
	["Krom's Landing"] = "Puerto de Krom",
	["KTC Headquarters"] = "Central SCK",
	["KTC Oil Platform"] = "Plataforma Petrolera SCK",
	["Kul'galar Keep"] = "Fortaleza de Kul'galar",
	["Kul Tiras"] = "Kul Tiras",
	["Kun-Lai Pass"] = "Paso Kun-Lai",
	["Kun-Lai Summit"] = "Cima Kun-Lai",
	["Kunzen Cave"] = "Cueva Kunzen",
	["Kunzen Village"] = "Poblado Kunzen",
	["Kurzen's Compound"] = "Base de Kurzen",
	["Kypari Ik"] = "Kypari Ik",
	["Kyparite Quarry"] = "Cantera de Kyparita",
	["Kypari Vor"] = "Kypari Vor",
	["Kypari Zar"] = "Kypari Zar",
	["Kzzok Warcamp"] = "Campamento de Guerra Kzzok",
	["Lair of Skiggit"] = "Guarida de Skiggit",
	["Lair of the Beast"] = "Guarida de la Bestia",
	["Lair of the Chosen"] = "Guarida de los Elegidos",
	["Lair of the Jade Witch"] = "Guarida de la Bruja de Jade",
	["Lair of Tortos"] = "Guarida de Tortos",
	["Lake Al'Ameth"] = "Lago Al'Ameth",
	["Lake Cauldros"] = "Lago Caldros",
	["Lake Dumont"] = "Lago Dumont",
	["Lake Edunel"] = "Lago Edunel",
	["Lake Elrendar"] = "Lago Elrendar",
	["Lake Elune'ara"] = "Lago Elune'ara",
	["Lake Ere'Noru"] = "Lago Ere'Noru",
	["Lake Everstill"] = "Lago Sempiterno",
	["Lake Falathim"] = "Lago Falathim",
	["Lake Indu'le"] = "Lago Indu'le",
	["Lake Jorune"] = "Lago Jorune",
	["Lake Kel'Theril"] = "Lago Kel'Theril",
	["Lake Kittitata"] = "Lago Kittitata",
	["Lake Kum'uya"] = "Lago Kum'uya",
	["Lake Mennar"] = "Lago Mennar",
	["Lake Mereldar"] = "Lago Mereldar",
	["Lake Nazferiti"] = "Lago Nazferiti",
	["Lake of Stars"] = "Lago de los Astros",
	["Lakeridge Highway"] = "Camino del Lago",
	Lakeshire = "Villa del Lago",
	["Lakeshire Inn"] = "Posada de Villa del Lago",
	["Lakeshire Town Hall"] = "Concejo de Villa del Lago",
	["Lakeside Landing"] = "Pista del Lago",
	["Lake Sunspring"] = "Lago Primasol",
	["Lakkari Tar Pits"] = "Fosas de Alquitrán Lakkari",
	["Landing Beach"] = "Playa de Desembarco",
	["Landing Site"] = "Lugar del Desembarco",
	["Land's End Beach"] = "Playa Finisterrae",
	["Langrom's Leather & Links"] = "Cuero y Eslabones de Langrom",
	["Lao & Son's Yakwash"] = "Lavadero de Yaks Lao e Hijo",
	["Largo's Overlook"] = "Alto de Largo",
	["Largo's Overlook Tower"] = "Torre del Alto de Largo",
	["Lariss Pavilion"] = "Pabellón de Lariss",
	["Laughing Skull Courtyard"] = "Patio Riecráneos",
	["Laughing Skull Ruins"] = "Ruinas Riecráneos",
	["Launch Bay"] = "Aeropuerto",
	["Legash Encampment"] = "Campamento Legashi",
	["Legendary Leathers"] = "Pieles Legendarias",
	["Legion Hold"] = "Bastión de la Legión",
	["Legion's Fate"] = "Destino de la Legión",
	["Legion's Rest"] = "Reposo de la Legión",
	["Lethlor Ravine"] = "Barranco Lethlor",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "Pesar de Leyara",
	["L'ghorek"] = "L'ghorek",
	["Liang's Retreat"] = "Retiro de Liang",
	["Library Wing"] = "Ala de la Biblioteca",
	Lighthouse = "Faro",
	["Lightning Ascent"] = "Ascenso del Relámpago",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Forja de los relámpagos - Gesta de progresión de la isla mogu",
	["Lightning Ledge"] = "Saliente de Relámpagos",
	["Lightning Promenade"] = "Paseo del Relámpago",
	["Lightning Vein Mine"] = "Mina del Relámpago",
	["Light's Breach"] = "Brecha de la Luz",
	["Light's Dawn Cathedral"] = "Catedral del Alba",
	["Light's Hammer"] = "Martillo de la Luz",
	["Light's Hope Chapel"] = "Capilla de la Esperanza de la Luz",
	["Light's Point"] = "Punta de la Luz",
	["Light's Point Tower"] = "Torre de la Punta de la Luz",
	["Light's Shield Tower"] = "Torre del Escudo de la Luz",
	["Light's Trust"] = "Confianza de la Luz",
	["Like Clockwork"] = "Como un Reloj",
	["Lion's Landing"] = "Desembarco del León",
	["Lion's Pride Inn"] = "Posada Orgullo de León",
	["Livery Outpost"] = "Avanzada de la Caballería",
	["Livery Stables"] = "Caballerizas",
	["Livery Stables "] = "Caballerizas",
	["Llane's Oath"] = "Juramento de Llane",
	["Loading Room"] = "Zona de Carga",
	["Loch Modan"] = "Loch Modan",
	["Loch Verrall"] = "Loch Verrall",
	["Loken's Bargain"] = "Acuerdo de Loken",
	["Lonesome Cove"] = "Cala Solitaria",
	Longshore = "Playa Larga",
	["Longying Outpost"] = "Avanzada Longying",
	["Lordamere Internment Camp"] = "Campo de Reclusión de Lordamere",
	["Lordamere Lake"] = "Lago Lordamere",
	["Lor'danel"] = "Lor'danel",
	["Lorthuna's Gate"] = "Puerta de Lorthuna",
	["Lost Caldera"] = "Caldera Perdida",
	["Lost City of the Tol'vir"] = "Ciudad Perdida de los Tol'vir",
	["Lost City of the Tol'vir Entrance"] = "Entrada de la Ciudad Perdida de los Tol'vir",
	LostIsles = "Las Islas Perdidas",
	["Lost Isles Town in a Box"] = "Ciudad de Bolsillo de Las Islas Perdidas",
	["Lost Isles Volcano Eruption"] = "Erupción de Volcán de Las Islas Perdidas",
	["Lost Peak"] = "Pico Perdido",
	["Lost Point"] = "Punta Perdida",
	["Lost Rigger Cove"] = "Cala del Aparejo Perdido",
	["Lothalor Woodlands"] = "Bosque Lothalor",
	["Lower City"] = "Bajo Arrabal",
	["Lower Silvermarsh"] = "Marjal Argenta Inferior",
	["Lower Sumprushes"] = "El Sumidero Inferior",
	["Lower Veil Shil'ak"] = "Velo Shil'ak Bajo",
	["Lower Wilds"] = "Bajas Tierras Salvajes",
	["Lumber Mill"] = "Aserradero",
	["Lushwater Oasis"] = "Oasis Aguaverde",
	["Lydell's Ambush"] = "Emboscada de Lydell",
	["M.A.C. Diver"] = "Otilius",
	["Maelstrom Deathwing Fight"] = "Lucha de Alamuerte en La Vorágine",
	["Maelstrom Zone"] = "Zona de La Vorágine",
	["Maestra's Post"] = "Atalaya de Maestra",
	["Maexxna's Nest"] = "Nido de Maexxna",
	["Mage Quarter"] = "Barrio de los Magos",
	["Mage Tower"] = "Torre de los Magos",
	["Mag'har Grounds"] = "Dominios Mag'har",
	["Mag'hari Procession"] = "Procesión Mag'hari",
	["Mag'har Post"] = "Puesto Mag'har",
	["Magical Menagerie"] = "Arca Mágica",
	["Magic Quarter"] = "Barrio de la Magia",
	["Magisters Gate"] = "Puerta Magister",
	["Magister's Terrace"] = "Bancal del Magister",
	["Magisters' Terrace"] = "Bancal del Magister",
	["Magisters' Terrace Entrance"] = "Entrada del Bancal del Magister",
	["Magmadar Cavern"] = "Cueva Magmadar",
	["Magma Fields"] = "Campos de Magma",
	["Magma Springs"] = "Fuentes de Magma",
	["Magmaw's Fissure"] = "Fisura de Faucemagma",
	Magmoth = "Magmoth",
	["Magnamoth Caverns"] = "Cavernas Magnamoth",
	["Magram Territory"] = "Territorio Magram",
	["Magtheridon's Lair"] = "Guarida de Magtheridon",
	["Magus Commerce Exchange"] = "Mercado de Magos",
	["Main Chamber"] = "Cámara Principal",
	["Main Gate"] = "Entrada Principal",
	["Main Hall"] = "Sala Principal",
	["Maker's Ascent"] = "Ascenso del Hacedor",
	["Maker's Overlook"] = "El Mirador de los Creadores",
	["Maker's Overlook "] = "El Mirador de los Creadores",
	["Makers' Overlook"] = "El Mirador de los Creadores",
	["Maker's Perch"] = "Pedestal del Creador",
	["Makers' Perch"] = "El Pedestal de los Creadores",
	["Malaka'jin"] = "Malaka'jin",
	["Malden's Orchard"] = "Huerta de Malden",
	Maldraz = "Maldraz",
	["Malfurion's Breach"] = "Brecha de Malfurion",
	["Malicia's Outpost"] = "Avanzada de Malicia",
	["Malykriss: The Vile Hold"] = "Malykriss: El Bastión Inmundo",
	["Mama's Pantry"] = "Despensa de Mamá",
	["Mam'toth Crater"] = "Cráter de Mam'toth",
	["Manaforge Ara"] = "Forja de Maná Ara",
	["Manaforge B'naar"] = "Forja de Maná B'naar",
	["Manaforge Coruu"] = "Forja de Maná Coruu",
	["Manaforge Duro"] = "Forja de Maná Duro",
	["Manaforge Ultris"] = "Forja de Maná Ultris",
	["Mana Tombs"] = "Tumbas de Maná",
	["Mana-Tombs"] = "Tumbas de Maná",
	["Mandokir's Domain"] = "Dominios de Mandokir",
	["Mandori Village"] = "Aldea Mandori",
	["Mannoroc Coven"] = "Aquelarre Mannoroc",
	["Manor Mistmantle"] = "Mansión Mantoniebla",
	["Mantle Rock"] = "Rocamanto",
	["Map Chamber"] = "Cámara del Mapa",
	["Mar'at"] = "Mar'at",
	Maraudon = "Maraudon",
	["Maraudon - Earth Song Falls Entrance"] = "Maraudon: Entrada de las Cascadas del Canto de la Tierra",
	["Maraudon - Foulspore Cavern Entrance"] = "Maraudon: Entrada de la Gruta de la Espora Fétida",
	["Maraudon - The Wicked Grotto Entrance"] = "Maraudon - Entrada de la Gruta Maldita",
	["Mardenholde Keep"] = "Fortaleza de Mardenholde",
	Marista = "Vistamar",
	["Marista's Bait & Brew"] = "Pesca y brebajes de Vistamar",
	["Market Row"] = "Fila del Mercado",
	["Marshal's Refuge"] = "Refugio de Marshal",
	["Marshal's Stand"] = "Alto de Marshal",
	["Marshlight Lake"] = "Lago Luz Pantanosa",
	["Marshtide Watch"] = "Avanzada Marea Pantanosa",
	["Maruadon - The Wicked Grotto Entrance"] = "Maraudon: Entrada de La Gruta Maligna",
	["Mason's Folly"] = "Locura del Albañil",
	["Masters' Gate"] = "Puerta de los Maestros",
	["Master's Terrace"] = "El Bancal del Maestro",
	["Mast Room"] = "Sala del Mástil",
	["Maw of Destruction"] = "Fauces de Destrucción",
	["Maw of Go'rath"] = "Fauces de Go'rath",
	["Maw of Lycanthoth"] = "Fauces de Lycanthoth",
	["Maw of Neltharion"] = "Fauces de Neltharion",
	["Maw of Shu'ma"] = "Fauces de Shu'ma",
	["Maw of the Void"] = "Fauces del Vórtice",
	["Mazra'Alor"] = "Mazra'Alor",
	Mazthoril = "Mazthoril",
	["Mazu's Overlook"] = "Mirador de Mazu",
	["Medivh's Chambers"] = "Estancias de Medivh",
	["Menagerie Wreckage"] = "Restos del Arca",
	["Menethil Bay"] = "Bahía de Menethil",
	["Menethil Harbor"] = "Puerto de Menethil",
	["Menethil Keep"] = "Castillo de Menethil",
	["Merchant Square"] = "Plaza de los Mercaderes",
	Middenvale = "Mediavega",
	["Mid Point Station"] = "Estación de la Punta Central",
	["Midrealm Post"] = "Puesto de la Tierra Media",
	["Midwall Lift"] = "Elevador del Muro Central",
	["Mightstone Quarry"] = "Cantera de Piedra de Poderío",
	["Military District"] = "Distrito Militar",
	["Mimir's Workshop"] = "Taller de Mimir",
	Mine = "Mina",
	Mines = "Minas",
	["Mirage Abyss"] = "Abismo del Espejismo",
	["Mirage Flats"] = "Explanada del Espejismo",
	["Mirage Raceway"] = "Circuito del Espejismo",
	["Mirkfallon Lake"] = "Lago Mirkfallon",
	["Mirkfallon Post"] = "Puesto Mirkfallon",
	["Mirror Lake"] = "Lago Espejo",
	["Mirror Lake Orchard"] = "Vergel del Lago Espejo",
	["Mistblade Den"] = "Guarida Hojaniebla",
	["Mistcaller's Cave"] = "Cueva del Clamaneblina",
	["Mistfall Village"] = "Aldea Bruma Otoñal",
	["Mist's Edge"] = "Cabo de la Niebla",
	["Mistvale Valley"] = "Valle del Velo de Bruma",
	["Mistveil Sea"] = "Mar Velo de Niebla",
	["Mistwhisper Refuge"] = "Refugio Susurraneblina",
	["Misty Pine Refuge"] = "Refugio Pinobruma",
	["Misty Reed Post"] = "Puesto Juncobruma",
	["Misty Reed Strand"] = "Playa Juncobruma",
	["Misty Ridge"] = "Cresta Brumosa",
	["Misty Shore"] = "Costa de la Neblina",
	["Misty Shores"] = "Costa de la Neblina",
	["Misty Valley"] = "Valle Brumoso",
	["Miwana's Longhouse"] = "Casa Comunal de Miwana",
	["Mizjah Ruins"] = "Ruinas de Mizjah",
	["Moa'ki"] = "Puerto Moa'ki",
	["Moa'ki Harbor"] = "Puerto Moa'ki",
	["Moggle Point"] = "Cabo Moggle",
	["Mo'grosh Stronghold"] = "Fortaleza de Mo'grosh",
	["Mogu Island Daily Area"] = "Zona de diarias de la isla mogu",
	["Mogu Island Events - Alliance Base"] = "Eventos de la isla mogu - Base de la Alianza",
	["Mogu Island Events - Horde Base"] = "Eventos de la isla mogu - Base de la Horda",
	["Mogu Island Loot Room"] = "Sala de botín de la isla mogu",
	["Mogu Island Progression Events"] = "Eventos de progresión de la isla mogu",
	Mogujia = "Mogujia",
	["Mogu'shan Palace"] = "Palacio Mogu'shan",
	["Mogu'shan Terrace"] = "Tribuna Mogu'shan",
	["Mogu'shan Vaults"] = "Cámaras Mogu'shan",
	["Mok'Doom"] = "Mok'Doom",
	["Mok'Gordun"] = "Mok'Gordun",
	["Mok'Nathal Village"] = "Aldea Mok'Nathal",
	["Mold Foundry"] = "Fundición del Molde",
	["Molten Core"] = "Núcleo de Magma",
	["Molten Front"] = "Frente de Magma",
	Moonbrook = "Arroyo de la Luna",
	Moonglade = "Claro de la Luna",
	["Moongraze Woods"] = "Bosque Pasto Lunar",
	["Moon Horror Den"] = "Cubil del Horror de la Luna",
	["Moonrest Gardens"] = "Jardines Reposo Lunar",
	["Moonshrine Ruins"] = "Ruinas del Santuario Lunar",
	["Moonshrine Sanctum"] = "Sagrario Lunar",
	["Moontouched Den"] = "Cubil Lunadón",
	["Moonwater Retreat"] = "Retiro Agualuna",
	["Moonwell of Cleansing"] = "Poza de la Luna de Purificación",
	["Moonwell of Purity"] = "Poza de la Luna de Pureza",
	["Moonwing Den"] = "Túmulo Lunala",
	["Mord'rethar: The Death Gate"] = "Mord'rethar: La Puerta de la Muerte",
	["Morgan's Plot"] = "Terreno de Morgan",
	["Morgan's Vigil"] = "Vigilia de Morgan",
	["Morlos'Aran"] = "Morlos'Aran",
	["Morning Breeze Lake"] = "Lago Brisa Temprana",
	["Morning Breeze Village"] = "Aldea Brisa Temprana",
	Morrowchamber = "Cámara del Mañana",
	["Mor'shan Base Camp"] = "Campamento de Mor'shan",
	["Mortal's Demise"] = "Óbito del Mortal",
	["Mortbreath Grotto"] = "Gruta Hálitovil",
	["Mortwake's Tower"] = "Torre Mortoalerta",
	["Mosh'Ogg Ogre Mound"] = "Túmulo Ogro Mosh'Ogg",
	["Mosshide Fen"] = "Pantano Pellejomusgo",
	["Mosswalker Village"] = "Poblado Caminamoho",
	["Mossy Pile"] = "Pilote Musgoso",
	["Motherseed Pit"] = "Foso de la Semilla Madre",
	["Mountainfoot Strip Mine"] = "Cantera de la Ladera",
	["Mount Akher"] = "Monte Akher",
	["Mount Hyjal"] = "Monte Hyjal",
	["Mount Hyjal Phase 1"] = "Mount Hyjal Phase 1",
	["Mount Neverest"] = "Monte Nieverest",
	["Muckscale Grotto"] = "Gruta Mugrescama",
	["Muckscale Shallows"] = "Arrecifes Mugrescama",
	["Mudmug's Place"] = "Hogar de Caolín",
	Mudsprocket = "Piñón de Barro",
	Mulgore = "Mulgore",
	["Murder Row"] = "El Frontal de la Muerte",
	["Murkdeep Cavern"] = "Caverna Negrasombra",
	["Murky Bank"] = "Ribera Turbia",
	["Muskpaw Ranch"] = "Rancho Zarpa Lanuda",
	["Mystral Lake"] = "Lago Mystral",
	Mystwood = "Bosque Bruma",
	Nagrand = "Nagrand",
	["Nagrand Arena"] = "Arena de Nagrand",
	Nahom = "Nahom",
	["Nar'shola Terrace"] = "Bancal de Nar'shola",
	["Narsong Spires"] = "Pináculos de Narsong",
	["Narsong Trench"] = "Zanja de Narsong",
	["Narvir's Cradle"] = "Cuna de Narvir",
	["Nasam's Talon"] = "Garfa de Nasam",
	["Nat's Landing"] = "Embarcadero de Nat",
	["Naval Battle Scenario"] = "Gesta de batalla naval",
	Naxxanar = "Naxxanar",
	Naxxramas = "Naxxramas",
	["Nayeli Lagoon"] = "Laguna Nayeli",
	["Naz'anak: The Forgotten Depths"] = "Naz'anak: Las Profundidades Olvidadas",
	["Nazj'vel"] = "Nazj'vel",
	Nazzivian = "Nazzivian",
	["Nectarbreeze Orchard"] = "Huerto Brisa Dulce",
	["Needlerock Chasm"] = "Sima Rocaguja",
	["Needlerock Slag"] = "Fosa Rocaguja",
	["Nefarian's Lair"] = "Guarida de Nefarian",
	["Nefarian�s Lair"] = "Guarida de Nefarian",
	["Neferset City"] = "Ciudad de Neferset",
	["Neferset City Outskirts"] = "Afueras de la Ciudad de Neferset",
	["Nek'mani Wellspring"] = "Manantial Nek'mani",
	["Neptulon's Rise"] = "Alto de Neptulon",
	["Nesingwary Base Camp"] = "Campamento Base de Nesingwary",
	["Nesingwary Safari"] = "Safari Nesingwary",
	["Nesingwary's Expedition"] = "Expedición de Nesingwary",
	["Nesingwary's Safari"] = "Safari de Nesingwary",
	Nespirah = "Nespirah",
	["Nestlewood Hills"] = "Colinas Cubrebosque",
	["Nestlewood Thicket"] = "Matorral Cubrebosque",
	["Nethander Stead"] = "Granja Nethander",
	["Nethergarde Keep"] = "Castillo de Nethergarde",
	["Nethergarde Mines"] = "Minas de Nethergarde",
	["Nethergarde Supply Camps"] = "Campamento de Suministros de Nethergarde",
	Netherspace = "Espacio Abisal",
	Netherstone = "Piedra Abisal",
	Netherstorm = "Tormenta Abisal",
	["Netherweb Ridge"] = "Cresta Red Abisal",
	["Netherwing Fields"] = "Campos del Ala Abisal",
	["Netherwing Ledge"] = "Arrecife del Ala Abisal",
	["Netherwing Mines"] = "Minas del Ala Abisal",
	["Netherwing Pass"] = "Desfiladero del Ala Abisal",
	["Neverest Basecamp"] = "Campamento Base Nieverest",
	["Neverest Pinnacle"] = "Cumbre del Nieverest",
	["New Agamand"] = "Nuevo Agamand",
	["New Agamand Inn"] = "Posada de Nuevo Agamand",
	["New Avalon"] = "Nuevo Avalon",
	["New Avalon Fields"] = "Campos de Nuevo Avalon",
	["New Avalon Forge"] = "Forja de Nuevo Avalon",
	["New Avalon Orchard"] = "Huerto de Nuevo Avalon",
	["New Avalon Town Hall"] = "Concejo de Nuevo Avalon",
	["New Cifera"] = "Nueva Cifera",
	["New Hearthglen"] = "Nueva Vega del Amparo",
	["New Kargath"] = "Nuevo Kargath",
	["New Thalanaar"] = "Nueva Thalanaar",
	["New Tinkertown"] = "Nueva Ciudad Manitas",
	["Nexus Legendary"] = "Legendario del Nexo",
	Nidavelir = "Nidavelir",
	["Nidvar Stair"] = "Escalera de Nidvar",
	Nifflevar = "Nafsavar",
	["Night Elf Village"] = "Villa Elfo de la Noche",
	Nighthaven = "Amparo de la Noche",
	["Nightingale Lounge"] = "Salón del Ruiseñor",
	["Nightmare Depths"] = "Profundidades de Pesadilla",
	["Nightmare Scar"] = "Paraje Pesadilla",
	["Nightmare Vale"] = "Vega Pesadilla",
	["Night Run"] = "Senda de la Noche",
	["Nightsong Woods"] = "Bosque Arrullanoche",
	["Night Web's Hollow"] = "Hoya Nocturácnidas",
	["Nijel's Point"] = "Punta de Nijel",
	["Nimbus Rise"] = "Alto de Nimbo",
	Nine = "Nine",
	["Niuzao Catacombs"] = "Catacumbas de Niuzao",
	["Niuzao Temple"] = "Templo de Niuzao",
	["Njord's Breath Bay"] = "Bahía Aliento de Njord",
	["Njorndar Village"] = "Poblado Njorndar",
	["Njorn Stair"] = "Escalera de Njorn",
	["Nook of Konk"] = "Caverna de Konk",
	["Noonshade Ruins"] = "Ruinas Sombrasol",
	Nordrassil = "Nordrassil",
	["Nordrassil Inn"] = "Posada de Nordrassil",
	["Nordune Ridge"] = "Cresta Nordune",
	["North Common Hall"] = "Sala Comunal Norte",
	Northdale = "Vallenorte",
	["Northern Barrens"] = "Los Baldíos del Norte",
	["Northern Elwynn Mountains"] = "Montañas de Elwynn del Norte",
	["Northern Headlands"] = "Cabos del Norte",
	["Northern Rampart"] = "Muralla Norte",
	["Northern Rocketway"] = "Cohetepista del Norte",
	["Northern Rocketway Exchange"] = "Intercambiador de la Cohetepista del Norte",
	["Northern Stranglethorn"] = "Norte de la Vega de Tuercespina",
	["Northfold Manor"] = "Mansión Redilnorte",
	["Northgate Breach"] = "Brecha de la Puerta del Norte",
	["North Gate Outpost"] = "Avanzada de la Puerta Norte",
	["North Gate Pass"] = "Paso de la Puerta Norte",
	["Northgate River"] = "Río de la Puerta del Norte",
	["Northgate Woods"] = "Bosque de la Puerta del Norte",
	["Northmaul Tower"] = "Torre Quiebranorte",
	["Northpass Tower"] = "Torre del Paso Norte",
	["North Point Station"] = "Estación de la Punta Norte",
	["North Point Tower"] = "Torre de la Punta Norte",
	Northrend = "Rasganorte",
	["Northridge Lumber Camp"] = "Aserradero Crestanorte",
	["North Sanctum"] = "Sagrario del Norte",
	Northshire = "Villanorte",
	["Northshire Abbey"] = "Abadía de Villanorte",
	["Northshire River"] = "Río de Villanorte",
	["Northshire Valley"] = "Valle de Villanorte",
	["Northshire Vineyards"] = "Viñedos de Villanorte",
	["North Spear Tower"] = "Torre Lanza del Norte",
	["North Tide's Beachhead"] = "Desembarco Mareanorte",
	["North Tide's Run"] = "Cala Mareanorte",
	["Northwatch Expedition Base Camp"] = "Campamento Base de la Expedición del Fuerte del Norte",
	["Northwatch Expedition Base Camp Inn"] = "Taberna del Campamento Base de la Expedición del Fuerte del Norte",
	["Northwatch Foothold"] = "Ciudadela del Fuerte del Norte",
	["Northwatch Hold"] = "Fuerte del Norte",
	["Northwind Cleft"] = "Grieta del Viento Norte",
	["North Wind Tavern"] = "Taberna Vientonorte",
	["Nozzlepot's Outpost"] = "Avanzada de Ollaboquilla",
	["Nozzlerust Post"] = "Puesto Boquilla Oxidada",
	["Oasis of the Fallen Prophet"] = "Oasis del Profeta Caído",
	["Oasis of Vir'sar"] = "Oasis de Vir'sar",
	["Obelisk of the Moon"] = "Obelisco de la Luna",
	["Obelisk of the Stars"] = "Obelisco de las Estrellas",
	["Obelisk of the Sun"] = "Obelisco del Sol",
	["O'Breen's Camp"] = "Campamento de O'Breen",
	["Observance Hall"] = "Cámara de Observancia",
	["Observation Grounds"] = "Sector de Observación",
	["Obsidian Breakers"] = "Rompiente Obsidiana",
	["Obsidian Dragonshrine"] = "Santuario de Dragones Obsidiana",
	["Obsidian Forest"] = "Bosque Obsidiana",
	["Obsidian Lair"] = "Guarida Obsidiana",
	["Obsidia's Perch"] = "Nido de Obsidia",
	["Odesyus' Landing"] = "Desembarco de Odesyus",
	["Ogri'la"] = "Ogri'la",
	["Ogri'La"] = "Ogri'la",
	["Old Hillsbrad Foothills"] = "Antiguas Laderas de Trabalomas",
	["Old Ironforge"] = "Antigua Forjaz",
	["Old Town"] = "Casco Antiguo",
	Olembas = "Olembas",
	["Olivia's Pond"] = "Estanque de Olivia",
	["Olsen's Farthing"] = "Finca de Olsen",
	Oneiros = "Oneiros",
	["One Keg"] = "Barrilia",
	["One More Glass"] = "Una Copa Más",
	["Onslaught Base Camp"] = "Campamento del Embate",
	["Onslaught Harbor"] = "Puerto del Embate",
	["Onyxia's Lair"] = "Guarida de Onyxia",
	["Oomlot Village"] = "Poblado Oomlot",
	["Oona Kagu"] = "Oona Kagu",
	Oostan = "Oostan",
	["Oostan Nord"] = "Oostan Nord",
	["Oostan Ost"] = "Oostan Ost",
	["Oostan Sor"] = "Oostan Sor",
	["Opening of the Dark Portal"] = "Apertura de El Portal Oscuro",
	["Opening of the Dark Portal Entrance"] = "Entrada de la Apertura de El Portal Oscuro",
	["Oratorium of the Voice"] = "Oratorio de la Voz",
	["Oratory of the Damned"] = "Oratorio de los Malditos",
	["Orchid Hollow"] = "Cuenca de la Orquídea",
	["Orebor Harborage"] = "Puerto Orebor",
	["Oregrind's Dig"] = "Excavación de Picamena",
	["Orendil's Retreat"] = "Refugio de Orendil",
	Orgrimmar = "Orgrimmar",
	["Orgrimmar Gunship Pandaria Start"] = "Zona de inicio de Pandaria: nave de guerra de Orgrimmar",
	["Orgrimmar Rear Gate"] = "Puerta Trasera de Orgrimmar",
	["Orgrimmar Rocketway Exchange"] = "Intercambiador de la Cohetepista de Orgrimmar",
	["Orgrim's Hammer"] = "Martillo de Orgrim",
	["Oronok's Farm"] = "Granja de Oronok",
	Orsis = "Orsis",
	["Ortell's Hideout"] = "Guarida de Ortell",
	["Oshu'gun"] = "Oshu'gun",
	["Outdoor Ruins"] = "Ruinas Exteriores",
	Outland = "Terrallende",
	["Overgrown Camp"] = "Campamento Hojarasca",
	["Overgrown Statuary"] = "Recinto de las Grandes Estatuas",
	["Owen's Wishing Well"] = "Pozo de los deseos de Owen",
	["Owl Wing Thicket"] = "Matorral del Ala del Búho",
	["Palace Antechamber"] = "Antecámara del Palacio",
	["Pal'ea"] = "Pal'ea",
	["Palemane Rock"] = "Roca Crines Pálidas",
	["Pandaren Mine"] = "Mina Pandaren",
	Pandaria = "Pandaria",
	["Pang's Stead"] = "Finca de Pang",
	["Panic Clutch"] = "Guarida del Pánico",
	["Paoquan Hollow"] = "Espesura Paoquan",
	["Parhelion Plaza"] = "Plaza del Parhelio",
	["Passage of Lost Fiends"] = "Pasaje de los Malignos Perdidos",
	["Path of a Hundred Steps"] = "Camino de los Cien Pasos",
	["Path of Conquerors"] = "Sendero de los Conquistadores",
	["Path of Enlightenment"] = "Camino de la Iluminación",
	["Path of Serenity"] = "Camino de la Serenidad",
	["Path of the Titans"] = "Senda de los Titanes",
	["Path of Uther"] = "Senda de Uther",
	["Pattymack Land"] = "Tierra de Pattymack",
	["Pauper's Walk"] = "Camino del Indigente",
	["Paur's Pub"] = "Tasca de Paur",
	["Paw'don Glade"] = "Claro Zarpa'don",
	["Paw'don Village"] = "Aldea Zarpa'don",
	["Paw'Don Village"] = "Aldea Zarpa'don", -- Needs review
	["Peak of Serenity"] = "Pico de la Serenidad",
	["Pearlfin Village"] = "Poblado Aleta de Nácar",
	["Pearl Lake"] = "Lago de Nácar",
	["Pedestal of Hope"] = "Pedestal de la Esperanza",
	["Pei-Wu Forest"] = "Bosque Pei-Wu",
	["Pestilent Scar"] = "Cicatriz Pestilente",
	["Pet Battle - Jade Forest"] = "Duelo de mascotas: El Bosque de Jade",
	["Petitioner's Chamber"] = "Cámaras de los Ruegos",
	["Pilgrim's Precipice"] = "Precipicio del Peregrino",
	["Pincer X2"] = "Tenazario X2",
	["Pinnacle of Storms"] = "Pináculo de las Tormentas",
	["Pit of Fangs"] = "Foso de los Colmillos",
	["Pit of Saron"] = "Foso de Saron",
	["Pit of Saron Entrance"] = "Entrada del Foso de Saron",
	["Plaguelands: The Scarlet Enclave"] = "Tierras de la Peste: El Enclave Escarlata",
	["Plaguemist Ravine"] = "Barranco Bruma Enferma",
	Plaguewood = "Bosque de la Peste",
	["Plaguewood Tower"] = "Torre del Bosque de la Peste",
	["Plain of Echoes"] = "Llanura de los Ecos",
	["Plain of Shards"] = "Llanura de los Fragmentos",
	["Plain of Thieves"] = "Llanura de los Ladrones",
	["Plains of Nasam"] = "Llanuras de Nasam",
	["Pod Cluster"] = "La Maraña de Cápsulas",
	["Pod Wreckage"] = "El Cementerio de Cápsulas",
	["Poison Falls"] = "Cascada Hedionda",
	["Pool of Reflection"] = "Charca del Reflejo",
	["Pool of Tears"] = "Charca de Lágrimas",
	["Pool of the Paw"] = "Poza de la Zarpa",
	["Pool of Twisted Reflections"] = "Poza de los Reflejos Distorsionados",
	["Pools of Aggonar"] = "Pozas de Aggonar",
	["Pools of Arlithrien"] = "Estanques de Arlithrien",
	["Pools of Jin'Alai"] = "Pozas de Jin'Alai",
	["Pools of Purity"] = "Pozas de la Pureza",
	["Pools of Youth"] = "Pozas de la Juventud",
	["Pools of Zha'Jin"] = "Pozas de Zha'Jin",
	["Portal Clearing"] = "Portal del Claro",
	["Pranksters' Hollow"] = "Escondrijo de los Bribones",
	["Predator's Perch"] = "Guarida del Depredador",
	["Prison of Immol'thar"] = "Prisión de Immol'thar",
	["Programmer Isle"] = "Isla del Programador",
	["Promontory Point"] = "Alto del Promontorio",
	["Prospector's Point"] = "Altozano del Prospector",
	["Protectorate Watch Post"] = "Avanzada del Protectorado",
	["Proving Grounds"] = "Terreno de Pruebas",
	["Purespring Cavern"] = "Cueva de Manantial",
	["Purgation Isle"] = "Isla del Purgatorio",
	["Pursuing the Black Harvest"] = "Tras la Cosecha Oscura",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Laboratorio Horrores y Risas Alquímicas de Putricidio",
	["Pyrewood Chapel"] = "Capilla Piroleña",
	["Pyrewood Inn"] = "Posada Piroleña",
	["Pyrewood Town Hall"] = "Concejo Piroleña",
	["Pyrewood Village"] = "Aldea Piroleña",
	["Pyrox Flats"] = "Llanos de Pirox",
	["QA and DVD"] = "QA and DVD",
	["Quagg Ridge"] = "Cresta Quagg",
	Quarry = "Cantera",
	["Quartzite Basin"] = "Cuenca de Cuarcita",
	["Queen's Gate"] = "Puerta de la Reina",
	["Quel'Danil Lodge"] = "Avanzada Quel'Danil",
	["Quel'Delar's Rest"] = "Reposo de Quel'Delar",
	["Quel'Dormir Gardens"] = "Jardines de Quel'Dormir",
	["Quel'Dormir Temple"] = "Templo de Quel'Dormir",
	["Quel'Dormir Terrace"] = "Bancal de Quel'Dormir",
	["Quel'Lithien Lodge"] = "Refugio Quel'Lithien",
	["Quel'thalas"] = "Quel'thalas",
	["Quickchop's Lumber Farm"] = "Aserradero de Hachaveloz",
	["Raastok Glade"] = "Claro Raastok",
	["Raceway Ruins"] = "Ruinas del Circuito",
	["Rageclaw Den"] = "Guarida de Garrafuria",
	["Rageclaw Lake"] = "Lago de Garrafuria",
	["Rage Fang Shrine"] = "Santuario Colmillo Iracundo",
	["Ragefeather Ridge"] = "Loma Plumira",
	["Ragefire Caverns"] = "Cavernas de Sima Ígnea",
	["Ragefire Chasm"] = "Sima Ígnea",
	["Ragefire Core"] = "Núcleo de Sima Ígnea",
	["Rage Scar Hold"] = "Dominios de los Cicatriz de Rabia",
	["Ragnaros' Lair"] = "Guarida de Ragnaros",
	["Ragnaros' Reach"] = "Tramo de Ragnaros",
	["Rainspeaker Canopy"] = "Canope de Hablalluvia",
	["Rainspeaker Rapids"] = "Rápidos de Hablalluvia",
	Ramkahen = "Ramkahen",
	["Ramkahen Legion Outpost"] = "Avanzada de la Legión Ramkahen",
	["Rampart of Skulls"] = "La Muralla de las Calaveras",
	["Ranazjar Isle"] = "Isla Ranazjar",
	["Raptor Pens"] = "Cercado de Raptores",
	["Raptor Ridge"] = "Colina del Raptor",
	["Raptor Rise"] = "Alto de Raptores",
	Ratchet = "Trinquete",
	["Rated Eye of the Storm"] = "Ojo de la Tormenta puntuado",
	["Ravaged Caravan"] = "Caravana Devastada",
	["Ravaged Crypt"] = "Cripta Devastada",
	["Ravaged Twilight Camp"] = "Campamento Crepúsculo Devastado",
	["Ravencrest Monument"] = "Monumento Cresta Cuervo",
	["Raven Hill"] = "Cerro del Cuervo",
	["Raven Hill Cemetery"] = "Cementerio del Cerro del Cuervo",
	["Ravenholdt Manor"] = "Mansión Ravenholdt",
	["Raven's Watch"] = "Guardia del Cuervo",
	["Raven's Wood"] = "Bosque del Cuervo",
	["Raynewood Retreat"] = "Refugio de la Algaba",
	["Raynewood Tower"] = "Torre de la Algaba",
	["Razaan's Landing"] = "Zona de Aterrizaje Razaan",
	["Razorfen Downs"] = "Zahúrda Rajacieno",
	["Razorfen Downs Entrance"] = "Entrada de Zahúrda Rajacieno",
	["Razorfen Kraul"] = "Horado Rajacieno",
	["Razorfen Kraul Entrance"] = "Entrada de Horado Rajacieno",
	["Razor Hill"] = "Cerrotajo",
	["Razor Hill Barracks"] = "Cuartel de Cerrotajo",
	["Razor Hill Outskirts"] = "Afueras de Cerrotajo",
	["Razor Hill Watchtower"] = "Torre de vigilancia de Cerrotajo",
	["Razormane Grounds"] = "Tierras Crines de Acero",
	["Razor Ridge"] = "Loma Tajo",
	["Razorscale's Aerie"] = "Nidal de Tajoescama",
	["Razorthorn Rise"] = "Alto Rajaespina",
	["Razorthorn Shelf"] = "Saliente Rajaespina",
	["Razorthorn Trail"] = "Senda Rajaespina",
	["Razorwind Canyon"] = "Cañón del Ventajo",
	["Rear Staging Area"] = "Área de Retaguardia",
	["Reaver's Fall"] = "Caída del Atracador Vil",
	["Reavers' Hall"] = "Cámara de los Atracadores",
	["Rebel Camp"] = "Asentamiento Rebelde",
	["Red Cloud Mesa"] = "Mesa de la Nube Roja",
	["Redpine Dell"] = "Valle Pinorrojo",
	["Redridge - Bridge Phase One"] = "Crestagrana - Primera fase del puente",
	["Redridge - Bridge Phase Two"] = "Crestagrana - Segunda fase del puente",
	["Redridge Canyons"] = "Cañones de Crestagrana",
	["Redridge Mountains"] = "Montañas Crestagrana",
	["Redridge - Orc Bomb"] = "Crestagrana - Bomba de orcos",
	["Red Rocks"] = "Roca Roja",
	["Redwood Trading Post"] = "Puesto de Venta de Madera Roja",
	Refinery = "Refinería",
	["Refugee Caravan"] = "Caravana de Refugiados",
	["Refuge Pointe"] = "Refugio de la Zaga",
	["Refuse Disposal"] = "Vertedero de Residuos",
	["Reliquary of Agony"] = "Relicario de Agonía",
	["Reliquary of Pain"] = "Relicario de Dolor",
	["Remains of Iris Lake"] = "Ruinas del Lago Iris",
	["Remains of the Fleet"] = "Restos de la Flota",
	["Remtravel's Excavation"] = "Excavación de Tripirrem",
	["Render's Camp"] = "Campamento de Render",
	["Render's Crater"] = "Cráter de Render",
	["Render's Rock"] = "Roca de Render",
	["Render's Valley"] = "Valle de Render",
	["Rensai's Watchpost"] = "Vigilancia de Rensai",
	["Rethban Caverns"] = "Cavernas de Rethban",
	["Rethress Sanctum"] = "Sagrario de Rethress",
	Reuse = "REUSE",
	["Reuse Me 7"] = "Reuse Me 7",
	["Revantusk Village"] = "Poblado Sañadiente",
	["Rhea's Camp"] = "Campamento de Rhea",
	["Rhonin's Beard"] = "Barbas de Rhonin",
	["Rhyolith Plateau"] = "Meseta de Piroclasto",
	["Ricket's Folly"] = "Locura de Ricket",
	["Ridge of Laughing Winds"] = "Cresta Viento Risueño",
	["Ridge of Madness"] = "Cresta de la Locura",
	["Ridgepoint Tower"] = "Torre de la Peña",
	Rikkilea = "Rikkilea",
	["Rikkitun Village"] = "Aldea Rikkitun",
	["Rim of the World"] = "Límite del Mundo",
	["Ring of Judgement"] = "El Círculo del Juicio",
	["Ring of Observance"] = "Círculo de la Observancia",
	["Ring of the Elements"] = "Círculo de los Elementos",
	["Ring of the Law"] = "Círculo de la Ley",
	["Riplash Ruins"] = "Ruinas Tralladón",
	["Riplash Strand"] = "Litoral Tralladón",
	["Rise of Suffering"] = "Alto del Sufrimiento",
	["Rise of the Defiler"] = "Alto de los Rapiñadores",
	["Ritual Chamber of Akali"] = "Cámara de Rituales de Akali",
	["Rivendark's Perch"] = "Nido de Desgarro Oscuro",
	Rivenwood = "El Bosque Hendido",
	["River's Heart"] = "Corazón del Río",
	["Rock of Durotan"] = "Roca de Durotan",
	["Rockpool Village"] = "Aldea Pozarroca",
	["Rocktusk Farm"] = "Granja Rocamuela",
	["Roguefeather Den"] = "Guarida Malapluma",
	["Rogues' Quarter"] = "Barrio de los Pícaros",
	["Rohemdal Pass"] = "Paso de Rohemdal",
	["Roland's Doom"] = "Condena de Roland",
	["Room of Hidden Secrets"] = "Sala de los Secretos Ocultos",
	["Roost of Ji-Kun"] = "Nidal de Ji Kun",
	["Rotbrain Encampment"] = "Campamento Pudrecerebro",
	["Royal Amphitheater"] = "Anfiteatro Real",
	["Royal Approach"] = "Senda Real",
	["Royal Exchange Auction House"] = "Casa de subastas de Intercambio Real",
	["Royal Exchange Bank"] = "Banco Real de Cambio",
	["Royal Gallery"] = "Galería Real",
	["Royal Library"] = "Archivo Real",
	["Royal Quarter"] = "Barrio Real",
	["Ruby Dragonshrine"] = "Santuario de Dragones Rubí",
	["Ruined Approach"] = "Acceso en Ruinas",
	["Ruined City Post 01"] = "Puesto 01 de la Ciudad en Ruinas",
	["Ruined Court"] = "Patio en Ruinas",
	["Ruins of Aboraz"] = "Ruinas de Aboraz",
	["Ruins of Ahmtul"] = "Ruinas de Ahmtul",
	["Ruins of Ahn'Qiraj"] = "Ruinas de Ahn'Qiraj",
	["Ruins of Alterac"] = "Ruinas de Alterac",
	["Ruins of Ammon"] = "Ruinas de Ammon",
	["Ruins of Arkkoran"] = "Ruinas de Arkkoran",
	["Ruins of Auberdine"] = "Ruinas de Auberdine",
	["Ruins of Baa'ri"] = "Ruinas de Baa'ri",
	["Ruins of Constellas"] = "Ruinas de Constellas",
	["Ruins of Dojan"] = "Ruinas de Dojan",
	["Ruins of Drakgor"] = "Ruinas de Drakgor",
	["Ruins of Drak'Zin"] = "Ruinas de Drak'Zin",
	["Ruins of Eldarath"] = "Ruinas de Eldarath",
	["Ruins of Eldarath "] = "Ruinas de Eldarath",
	["Ruins of Eldra'nath"] = "Ruinas de Eldra'nath",
	["Ruins of Eldre'thar"] = "Ruinas de Eldre'thar",
	["Ruins of Enkaat"] = "Ruinas de Enkaat",
	["Ruins of Farahlon"] = "Ruinas de Farahlon",
	["Ruins of Feathermoon"] = "Ruinas de Plumaluna",
	["Ruins of Gilneas"] = "Ruinas de Gilneas",
	["Ruins of Gilneas City"] = "Ruinas de la Ciudad de Gilneas",
	["Ruins of Guo-Lai"] = "Ruinas de Guo-Lai",
	["Ruins of Isildien"] = "Ruinas de Isildien",
	["Ruins of Jubuwal"] = "Ruinas de Jubuwal",
	["Ruins of Karabor"] = "Ruinas de Karabor",
	["Ruins of Kargath"] = "Ruinas de Kargath",
	["Ruins of Khintaset"] = "Ruinas de Khintaset",
	["Ruins of Korja"] = "Ruinas de Korja",
	["Ruins of Korune"] = "Ruinas de Korune",
	["Ruins of Lar'donir"] = "Ruinas de Lar'donir",
	["Ruins of Lordaeron"] = "Ruinas de Lordaeron",
	["Ruins of Loreth'Aran"] = "Ruinas de Loreth'Aran",
	["Ruins of Lornesta"] = "Ruinas de Lornesta",
	["Ruins of Mathystra"] = "Ruinas de Mathystra",
	["Ruins of Nordressa"] = "Ruinas de Nordressa",
	["Ruins of Ogudei"] = "Ruinas de Ogudei",
	["Ruins of Ravenwind"] = "Ruinas de Viento Azabache",
	["Ruins of Sha'naar"] = "Ruinas de Sha'naar",
	["Ruins of Shandaral"] = "Ruinas de Shandaral",
	["Ruins of Silvermoon"] = "Ruinas de Lunargenta",
	["Ruins of Solarsal"] = "Ruinas de Solarsal",
	["Ruins of Southshore"] = "Ruinas de Costasur",
	["Ruins of Taurajo"] = "Ruinas de Taurajo",
	["Ruins of Tethys"] = "Ruinas de Tethys",
	["Ruins of Thaurissan"] = "Ruinas de Thaurissan",
	["Ruins of Thelserai Temple"] = "Ruinas del Templo Thelserai",
	["Ruins of Theramore"] = "Ruinas de Theramore",
	["Ruins of the Scarlet Enclave"] = "Ruinas de El Enclave Escarlata",
	["Ruins of Uldum"] = "Ruinas de Uldum",
	["Ruins of Vashj'elan"] = "Ruinas de Vashj'elan",
	["Ruins of Vashj'ir"] = "Ruinas de Vashj'ir",
	["Ruins of Zul'Kunda"] = "Ruinas de Zul'Kunda",
	["Ruins of Zul'Mamwe"] = "Ruinas de Zul'Mamwe",
	["Ruins Rise"] = "Alto de las Ruinas",
	["Rumbling Terrace"] = "Bancal del Fragor",
	["Runestone Falithas"] = "Piedra Rúnica Falithas",
	["Runestone Shan'dor"] = "Piedra Rúnica Shan'dor",
	["Runeweaver Square"] = "Plaza Tejerruna",
	["Rustberg Village"] = "Aldea Monrojo",
	["Rustmaul Dive Site"] = "Excavación Oximelena",
	["Rutsak's Guard"] = "Guardia de Rutsak",
	["Rut'theran Village"] = "Aldea Rut'theran",
	["Ruuan Weald"] = "Foresta Ruuan",
	["Ruuna's Camp"] = "Campamento de Ruuna",
	["Ruuzel's Isle"] = "Isla de Ruuzel",
	["Rygna's Lair"] = "Guarida de Rygna",
	["Sable Ridge"] = "Cumbre Cebellina",
	["Sacrificial Altar"] = "Altar de Sacrificios",
	["Sahket Wastes"] = "Ruinas de Sahket",
	Salabria = "Salabria",
	["Saldean's Farm"] = "Finca de Saldean",
	["Saltheril's Haven"] = "Refugio de Saltheril",
	["Saltspray Glen"] = "Cañada Salobre",
	["Sanctuary of Malorne"] = "Santuario de Malorne",
	["Sanctuary of Shadows"] = "Santuario de las Sombras",
	["Sanctum of Reanimation"] = "Sagrario de Reanimación",
	["Sanctum of Shadows"] = "Sagrario de las Sombras",
	["Sanctum of the Ascended"] = "Sagrario de los Ascendientes",
	["Sanctum of the Fallen God"] = "Sagrario del Dios Caído",
	["Sanctum of the Moon"] = "Sagrario de la Luna",
	["Sanctum of the Prophets"] = "Sagrario de los Profetas",
	["Sanctum of the South Wind"] = "Sagrario del Viento del Sur",
	["Sanctum of the Stars"] = "Sagrario de las Estrellas",
	["Sanctum of the Sun"] = "Sagrario del Sol",
	["Sands of Nasam"] = "Arenas de Nasam",
	["Sandsorrow Watch"] = "Vigía Penas de Arena",
	["Sandy Beach"] = "Playa Arenosa",
	["Sandy Shallows"] = "Arrecifes Arenáceos",
	["Sanguine Chamber"] = "Cámara Sanguina",
	["Sapphire Hive"] = "Enjambre Zafiro",
	["Sapphiron's Lair"] = "Guarida de Sapphiron",
	["Saragosa's Landing"] = "Alto de Saragosa",
	Sarahland = "Sarahlandia",
	["Sardor Isle"] = "Isla de Sardor",
	Sargeron = "Sargeron",
	["Sarjun Depths"] = "Profundidades Sarjun",
	["Saronite Mines"] = "Minas de Saronita",
	["Sar'theris Strand"] = "Playa de Sar'theris",
	Satyrnaar = "Satyrnaar",
	["Saurok Creation Pit"] = "Foso de Producción de Saurok",
	["Savage Ledge"] = "Cornisa Salvaje",
	["Scalawag Point"] = "Cabo Pillastre",
	["Scalding Pools"] = "Pozas Escaldantes",
	["Scalebeard's Cave"] = "Cueva de Barbaescamas",
	["Scalewing Shelf"] = "Plataforma Alaescama",
	["Scarab Terrace"] = "Bancal del Escarabajo",
	["Scarlet Encampment"] = "Campamento Escarlata",
	["Scarlet Halls"] = "Cámaras Escarlata",
	["Scarlet Hold"] = "El Bastión Escarlata",
	["Scarlet Monastery"] = "Monasterio Escarlata",
	["Scarlet Monastery Entrance"] = "Entrada del Monasterio Escarlata",
	["Scarlet Overlook"] = "Mirador Escarlata",
	["Scarlet Palisade"] = "Acantilado Escarlata",
	["Scarlet Point"] = "Punta Escarlata",
	["Scarlet Raven Tavern"] = "Mesón del Cuervo Escarlata",
	["Scarlet Tavern"] = "Taberna Escarlata",
	["Scarlet Tower"] = "Torre Escarlata",
	["Scarlet Watch Post"] = "Atalaya Escarlata",
	["Scarlet Watchtower"] = "Torre de vigilancia Escarlata",
	["Scar of the Worldbreaker"] = "Cicatriz del Rompemundos",
	["Scarred Terrace"] = "Bancal Rajado",
	["Scenario: Alcaz Island"] = "Escenario: Isla de Alcaz",
	["Scenario - Black Ox Temple"] = "Gesta: Templo del Buey Negro",
	["Scenario - Mogu Ruins"] = "Gesta: Ruinas Mogu",
	["Scenic Overlook"] = "Mirador Pintoresco",
	["Schnottz's Frigate"] = "Fragata de Schnottz",
	["Schnottz's Hostel"] = "Hostal de Schnottz",
	["Schnottz's Landing"] = "Embarcadero de Schnottz",
	Scholomance = "Scholomance",
	["Scholomance Entrance"] = "Entrada de Scholomance",
	ScholomanceOLD = "ScholomanceOLD",
	["School of Necromancy"] = "Escuela de Nigromancia",
	["Scorched Gully"] = "Quebrada del Llanto",
	["Scott's Spooky Area"] = "Escalofrío de Scott",
	["Scoured Reach"] = "Tramo de Rozas",
	Scourgehold = "Fuerte de la Plaga",
	Scourgeholme = "Ciudad de la Plaga",
	["Scourgelord's Command"] = "Dominio del Señor de la Plaga",
	["Scrabblescrew's Camp"] = "Campamento de los Mezclatornillos",
	["Screaming Gully"] = "Quebrada del Llanto",
	["Scryer's Tier"] = "Grada del Arúspice",
	["Scuttle Coast"] = "Costa de la Huida",
	Sea = "Mar",
	Seabrush = "Malezamarina",
	["Seafarer's Tomb"] = "Tumba del Navegante",
	["Sealed Chambers"] = "Cámaras Selladas",
	["Seal of the Sun King"] = "Sello del Rey Sol",
	["Sea Mist Ridge"] = "Risco Niebla Marina",
	["Searing Gorge"] = "La Garganta de Fuego",
	["Seaspittle Cove"] = "Cala Marejada",
	["Seaspittle Nook"] = "Rincón de la Marejada",
	["Seat of Destruction"] = "Trono del Caos",
	["Seat of Knowledge"] = "Trono del Saber",
	["Seat of Life"] = "Trono de la Vida",
	["Seat of Magic"] = "Trono de la Magia",
	["Seat of Radiance"] = "Trono del Resplandor",
	["Seat of the Chosen"] = "Trono de los Elegidos",
	["Seat of the Naaru"] = "Trono de los Naaru",
	["Seat of the Spirit Waker"] = "Trono del Invocador",
	["Seeker's Folly"] = "Perdición del Explorador",
	["Seeker's Point"] = "Refugio del Explorador",
	["Sen'jin Village"] = "Poblado Sen'jin",
	["Sen'jin Village Outskirts"] = "Afueras del Poblado Sen'jin",
	["Sentinel Basecamp"] = "Campamento Base de las Centinelas",
	["Sentinel Hill"] = "Colina del Centinela",
	["Sentinel Tower"] = "Torre del Centinela",
	["Sentry Point"] = "Alto del Centinela",
	Seradane = "Seradane",
	["Serenity Falls"] = "Cataratas de la Serenidad",
	["Serpent Lake"] = "Lago Serpiente",
	["Serpent's Coil"] = "Serpiente Enroscada",
	["Serpent's Heart"] = "Corazón del Dragón",
	["Serpentshrine Cavern"] = "Caverna Santuario Serpiente",
	["Serpent's Overlook"] = "Mirador del Dragón",
	["Serpent's Spine"] = "Espinazo del Dragón",
	["Servants' Quarters"] = "Alcobas de los Sirvientes",
	["Service Entrance"] = "Entrada de Servicio",
	["Sethekk Halls"] = "Salas Sethekk",
	["Sethria's Roost"] = "Nidal de Sethria",
	["Setting Sun Garrison"] = "Baluarte del Sol Poniente",
	["Set'vess"] = "Set'vess",
	["Sewer Access Point"] = "Punto de acceso a las Cloacas",
	["Sewer Exit Pipe"] = "Tubería de Salida de las Cloacas",
	Sewers = "Cloacas",
	Shadebough = "Rama Sombría",
	["Shadewood Thicket"] = "Matorral Maderasombra",
	["Shado-Li Basin"] = "Cuenca Shado-Li",
	["Shado-Pan Fallback"] = "Retirada del Shadopan",
	["Shado-Pan Garrison"] = "Cuartel del Shadopan",
	["Shado-Pan Monastery"] = "Monasterio del Shadopan",
	["Shadowbreak Ravine"] = "Barranco Rompesombras",
	["Shadowfang Keep"] = "Castillo de Colmillo Oscuro",
	["Shadowfang Keep Entrance"] = "Entrada del Castillo de Colmillo Oscuro",
	["Shadowfang Tower"] = "Torre de Colmillo Oscuro",
	["Shadowforge City"] = "Ciudad Forjatiniebla",
	Shadowglen = "Cañada Umbría",
	["Shadow Grave"] = "Sepulcro Sombrío",
	["Shadow Hold"] = "Guarida Sombría",
	["Shadow Labyrinth"] = "Laberinto de las Sombras",
	["Shadowlurk Ridge"] = "Cresta Acechumbra",
	["Shadowmoon Valley"] = "Valle Sombraluna",
	["Shadowmoon Village"] = "Aldea Sombraluna",
	["Shadow-Pan Monastery"] = "Monasterio del Shadopan",
	["Shadowprey Village"] = "Aldea Cazasombras",
	["Shadow Ridge"] = "Cresta de las Sombras",
	["Shadowshard Cavern"] = "Cueva Fragmento Oscuro",
	["Shadowsight Tower"] = "Torre de la Vista de las Sombras",
	["Shadowsong Shrine"] = "Santuario Cantosombrío",
	["Shadowthread Cave"] = "Gruta Narácnida",
	["Shadow Tomb"] = "Tumba Umbría",
	["Shadow Wing Lair"] = "Guarida de Alasombra",
	["Shadra'Alor"] = "Shadra'Alor",
	["Shadybranch Pocket"] = "Alameda Ramasombra",
	["Shady Rest Inn"] = "Posada Reposo Umbrío",
	["Shalandis Isle"] = "Isla Shalandis",
	["Shalewind Canyon"] = "Cañón del Viento Calizo",
	["Shallow's End"] = "Confín del Bajío",
	["Shallowstep Pass"] = "Paso de la Senda Lóbrega",
	["Shalzaru's Lair"] = "Guarida de Shalzaru",
	Shamanar = "Shamanar",
	["Sha'naari Wastes"] = "Ruinas Sha'naari",
	["Shang's Stead"] = "Granja de Shang",
	["Shang's Valley"] = "Valle de Shang",
	["Shang Xi Training Grounds"] = "Campos de Entrenamiento de Shang Xi",
	["Shan'ze Dao"] = "Shan'ze Dao",
	["Shaol'mara"] = "Shaol'mara",
	["Shaol'watha"] = "Shaol'watha",
	["Shaper's Terrace"] = "Bancal del Creador",
	["Shaper's Terrace "] = "Bancal del Creador",
	["Shartuul's Transporter"] = "Transportador de Shartuul",
	["Sha'tari Base Camp"] = "Campamento Sha'tari",
	["Sha'tari Outpost"] = "Avanzada Sha'tari",
	["Shattered Convoy"] = "Comitiva Asaltada",
	["Shattered Plains"] = "Llanuras Devastadas",
	["Shattered Straits"] = "Estrecho Devastado",
	["Shattered Sun Staging Area"] = "Zona de Escala de Sol Devastado",
	["Shatter Point"] = "Puesto Devastación",
	["Shatter Scar Vale"] = "Cañada Gran Cicatriz",
	Shattershore = "Costa Quebrada",
	["Shatterspear Pass"] = "Paso Rompelanzas",
	["Shatterspear Vale"] = "Valle Rompelanzas",
	["Shatterspear War Camp"] = "Campamento de Guerra Rompelanzas",
	Shatterstone = "Ruina Pétrea",
	Shattrath = "Shattrath",
	["Shattrath City"] = "Ciudad de Shattrath",
	["Shelf of Mazu"] = "Plataforma de Mazu",
	["Shell Beach"] = "Playa del Molusco",
	["Shield Hill"] = "Colina Escudo",
	["Shields of Silver"] = "Escudos de plata",
	["Shimmering Bog"] = "Ciénaga Bruñida",
	["Shimmering Expanse"] = "Extensión Bruñida",
	["Shimmering Grotto"] = "Gruta Bruñida",
	["Shimmer Ridge"] = "Monte Luz",
	["Shindigger's Camp"] = "Campamento Machacacanillas",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Barco hacia Vashj'ir (Orgrimmar -> Vashj'ir)",
	["Shipwreck Shore"] = "Costa del Naufragio",
	Shipyard = "Astillero",
	["Shipyard - Mogu Island Progression Scenario"] = "Astillero - Gesta de progresión de la isla mogu",
	["Shok'Thokar"] = "Shok'Thokar",
	["Sholazar Basin"] = "Cuenca de Sholazar",
	["Shores of the Well"] = "Orillas del Pozo",
	["Shrine of Aessina"] = "El Santuario de Aessina",
	["Shrine of Aviana"] = "Santuario de Aviana",
	["Shrine of Dath'Remar"] = "Santuario de Dath'Remar",
	["Shrine of Dreaming Stones"] = "Santuario del Risco Soñador",
	["Shrine of Eck"] = "Santuario de Eck",
	["Shrine of Fellowship"] = "Santuario de Avenencia",
	["Shrine of Five Dawns"] = "Santuario de los Cinco Albores",
	["Shrine of Goldrinn"] = "Santuario de Goldrinn",
	["Shrine of Inner-Light"] = "Santuario de la Luz Interior",
	["Shrine of Lost Souls"] = "Santuario de las Almas Perdidas",
	["Shrine of Nala'shi"] = "Santuario de Nala'shi",
	["Shrine of Remembrance"] = "Santuario del Recuerdo",
	["Shrine of Remulos"] = "Santuario de Remulos",
	["Shrine of Scales"] = "Santuario de Escamas",
	["Shrine of Seven Stars"] = "Santuario de las Siete Estrellas",
	["Shrine of Thaurissan"] = "Ruinas de Thaurissan",
	["Shrine of the Dawn"] = "Santuario del Alba",
	["Shrine of the Deceiver"] = "Santuario del Impostor",
	["Shrine of the Dormant Flame"] = "Santuario de la Llama Latente",
	["Shrine of the Eclipse"] = "Santuario del Eclipse",
	["Shrine of the Elements"] = "Santuario de los Elementales",
	["Shrine of the Fallen Warrior"] = "Santuario del Guerrero Caído",
	["Shrine of the Five Khans"] = "Santuario de los Cinco Khans",
	["Shrine of the Merciless One"] = "Santuario del Inclemente",
	["Shrine of the Ox"] = "Santuario del Buey",
	["Shrine of Twin Serpents"] = "Santuario de los Dragones Gemelos",
	["Shrine of Two Moons"] = "Santuario de las Dos Lunas",
	["Shrine of Unending Light"] = "Santuario de Luz Inagotable",
	["Shriveled Oasis"] = "Oasis Árido",
	["Shuddering Spires"] = "Agujas Estremecedoras",
	["SI:7"] = "IV:7",
	["Siege of Niuzao Temple"] = "Asedio del Templo de Niuzao",
	["Siege Vise"] = "Torno de Asedio",
	["Siege Workshop"] = "Taller de Asedio",
	["Sifreldar Village"] = "Poblado Sifreldar",
	["Sik'vess"] = "Sik'vess",
	["Sik'vess Lair"] = "Guarida Sik'vess",
	["Silent Vigil"] = "Vigía Silencioso",
	Silithus = "Silithus",
	["Silken Fields"] = "Campos de Seda",
	["Silken Shore"] = "Costa de la Seda",
	["Silmyr Lake"] = "Lago Silmyr",
	["Silting Shore"] = "La Costa de Cieno",
	Silverbrook = "Arroyoplata",
	["Silverbrook Hills"] = "Colinas de Arroyoplata",
	["Silver Covenant Pavilion"] = "Pabellón de El Pacto de Plata",
	["Silverlight Cavern"] = "Caverna Luz de Plata",
	["Silverline Lake"] = "Lago Lineargenta",
	["Silvermoon City"] = "Ciudad de Lunargenta",
	["Silvermoon City Inn"] = "Posada de Ciudad de Lunargenta",
	["Silvermoon Finery"] = "Galas de Lunargenta",
	["Silvermoon Jewelery"] = "Joyería de Lunargenta",
	["Silvermoon Registry"] = "Registro de Lunargenta",
	["Silvermoon's Pride"] = "Orgullo de Lunargenta",
	["Silvermyst Isle"] = "Isla Bruma de Plata",
	["Silverpine Forest"] = "Bosque de Argénteos",
	["Silvershard Mines"] = "Minas Lonjaplata",
	["Silver Stream Mine"] = "Mina de Fuenteplata",
	["Silver Tide Hollow"] = "Cuenca de Marea Argenta",
	["Silver Tide Trench"] = "Zanja de Marea Argenta",
	["Silverwind Refuge"] = "Refugio Brisa de Plata",
	["Silverwing Flag Room"] = "Sala de la Bandera de Brisa de Plata",
	["Silverwing Grove"] = "Claro Ala de Plata",
	["Silverwing Hold"] = "Bastión Ala de Plata",
	["Silverwing Outpost"] = "Avanzada Ala de Plata",
	["Simply Enchanting"] = "Simplemente Encantador",
	["Sindragosa's Fall"] = "La Caída de Sindragosa",
	["Sindweller's Rise"] = "Alto del Morapecado",
	["Singing Marshes"] = "Marjal Exótico",
	["Singing Ridge"] = "Cresta Canto",
	["Sinner's Folly"] = "Locura del Pecador",
	["Sira'kess Front"] = "Frente de Sira'kess",
	["Sishir Canyon"] = "Cañón Sishir",
	["Sisters Sorcerous"] = "Hermanas Hechiceras",
	Skald = "Skald",
	["Sketh'lon Base Camp"] = "Campamento Sketh'lon",
	["Sketh'lon Wreckage"] = "Ruinas de Sketh'lon",
	["Skethyl Mountains"] = "Montañas Skethyl",
	Skettis = "Skettis",
	["Skitterweb Tunnels"] = "Túneles de Arácnidas",
	Skorn = "Skorn",
	["Skulking Row"] = "El Frontal de la Muerte",
	["Skulk Rock"] = "Roca Oculta",
	["Skull Rock"] = "Roca del Cráneo",
	["Sky Falls"] = "Cascadas del Cielo",
	["Skyguard Outpost"] = "Avanzada de la Guardia del Cielo",
	["Skyline Ridge"] = "Cresta Horizonte",
	Skyrange = "Firmamento",
	["Skysong Lake"] = "Lago Son Celeste",
	["Slabchisel's Survey"] = "Peritaje de Tallalosas",
	["Slag Watch"] = "Vigía de la Escoria",
	Slagworks = "Rescoldos",
	["Slaughter Hollow"] = "Cuenca de la Matanza",
	["Slaughter Square"] = "Plaza Degolladero",
	["Sleeping Gorge"] = "Desfiladero del Letargo",
	["Slicky Stream"] = "Arroyo Manduka",
	["Slingtail Pits"] = "Fosas Colafusta",
	["Slitherblade Shore"] = "Costa Filozante",
	["Slithering Cove"] = "Cala Serpenteante",
	["Slither Rock"] = "Roca Desliz",
	["Sludgeguard Tower"] = "Torre Guardalodo",
	["Smuggler's Scar"] = "Cicatriz del Contrabandista",
	["Snicklefritz Mine"] = "Mina de Tronafritz",
	["Snowblind Hills"] = "Colinas Veloneve",
	["Snowblind Terrace"] = "Bancal Veloneve",
	["Snowden Chalet"] = "Chalet Cubilnevado",
	["Snowdrift Dojo"] = "Dojo Ventisca Algente",
	["Snowdrift Plains"] = "Llanuras Ventisquero",
	["Snowfall Glade"] = "Claro Avalancha",
	["Snowfall Graveyard"] = "Cementerio Avalancha",
	["Socrethar's Seat"] = "Trono de Socrethar",
	["Sofera's Naze"] = "Saliente de Sofera",
	["Soggy's Gamble"] = "Lance de Aguado",
	["Solace Glade"] = "Claro del Consuelo",
	["Solliden Farmstead"] = "Hacienda Solliden",
	["Solstice Village"] = "Poblado Solsticio",
	["Sorlof's Strand"] = "Playa de Sorlof",
	["Sorrow Hill"] = "Colina de las Penas",
	["Sorrow Hill Crypt"] = "Cripta de la Colina de las Penas",
	Sorrowmurk = "Tinieblas de las Penas",
	["Sorrow Wing Point"] = "Punta Alapenas",
	["Soulgrinder's Barrow"] = "Túmulo de Moledor de Almas",
	["Southbreak Shore"] = "Tierras del Sur",
	["South Common Hall"] = "Sala Comunal Sur",
	["Southern Barrens"] = "Los Baldíos del Sur",
	["Southern Gold Road"] = "Camino del Oro Sur",
	["Southern Rampart"] = "Muralla Sur",
	["Southern Rocketway"] = "Cohetepista del Sur",
	["Southern Rocketway Terminus"] = "Terminal de la Cohetepista del Sur",
	["Southern Savage Coast"] = "Costa Salvaje del Sur",
	["Southfury River"] = "Río Furia del Sur",
	["Southfury Watershed"] = "Cuenca Furia del Sur",
	["South Gate Outpost"] = "Avanzada de la Puerta Sur",
	["South Gate Pass"] = "Paso de la Puerta Sur",
	["Southmaul Tower"] = "Torre Quiebrasur",
	["Southmoon Ruins"] = "Ruinas de Lunasur",
	["South Pavilion"] = "Pabellón sur",
	["Southpoint Gate"] = "Puerta Austral",
	["South Point Station"] = "Estación de la Punta Sur",
	["Southpoint Tower"] = "Torre Austral",
	["Southridge Beach"] = "Playa del Arrecife Sur",
	["Southsea Holdfast"] = "Sargazo de los Mares del Sur",
	["South Seas"] = "Mares del Sur",
	Southshore = "Costasur",
	["Southshore Town Hall"] = "Cabildo de Costasur",
	["South Spire"] = "Fortín del Sur",
	["South Tide's Run"] = "Cala Mareasur",
	["Southwind Cleft"] = "Grieta del Viento Sur",
	["Southwind Village"] = "Aldea del Viento del Sur",
	["Sparkrocket Outpost"] = "Avanzada de Chispamisil",
	["Sparksocket Minefield"] = "Campo de Minas Encajebujía",
	["Sparktouched Haven"] = "Retiro Pavesa",
	["Sparring Hall"] = "Sala de Entrenamiento",
	["Spearborn Encampment"] = "Campamento Lanzonato",
	Spearhead = "Punta de Lanza",
	["Speedbarge Bar"] = "Bar del Barcódromo",
	Spellsails = "Sietevelas",
	["Spinebreaker Mountains"] = "Montañas Rompeloma",
	["Spinebreaker Pass"] = "Desfiladero Rompeloma",
	["Spinebreaker Post"] = "Avanzada Rompeloma",
	["Spinebreaker Ridge"] = "Cresta Rompeloma",
	["Spiral of Thorns"] = "Espiral de las Zarzas",
	["Spire of Blood"] = "Aguja de Sangre",
	["Spire of Decay"] = "Aguja de Putrefacción",
	["Spire of Pain"] = "Aguja de Dolor",
	["Spire of Solitude"] = "Aguja de Soledad",
	["Spire Throne"] = "Trono Espiral",
	["Spirit Den"] = "Cubil del Espíritu",
	["Spirit Fields"] = "Campos de Espíritus",
	["Spirit Rise"] = "Alto de los Espíritus",
	["Spirit Rock"] = "Roca de los Espíritus",
	["Spiritsong River"] = "Río Canto Espiritual",
	["Spiritsong's Rest"] = "Reposo Canto Espiritual",
	["Spitescale Cavern"] = "Caverna Escama Maliciosa",
	["Spitescale Cove"] = "Cala Escama Maliciosa",
	["Splinterspear Junction"] = "Cruce Lanzarrota",
	Splintertree = "Hachazo",
	["Splintertree Mine"] = "Mina del Hachazo",
	["Splintertree Post"] = "Puesto del Hachazo",
	["Splithoof Crag"] = "Risco Pezuña Quebrada",
	["Splithoof Heights"] = "Cumbres Pezuña Quebrada",
	["Splithoof Hold"] = "Campamento Pezuña Quebrada",
	Sporeggar = "Esporaggar",
	["Sporewind Lake"] = "Lago Espora Volante",
	["Springtail Crag"] = "Risco Cola Saltarina",
	["Springtail Warren"] = "Gazapera Cola Saltarina",
	["Spruce Point Post"] = "Puesto del Altozano de Píceas",
	["Sra'thik Incursion"] = "Incursión Sra'thik",
	["Sra'thik Swarmdock"] = "Puerto del Enjambre Sra'thik",
	["Sra'vess"] = "Sra'vess",
	["Sra'vess Rootchamber"] = "Cámara de Raíces Sra'vess",
	["Sri-La Inn"] = "Posada de Sri-La",
	["Sri-La Village"] = "Aldea Sri-La",
	Stables = "Establos",
	Stagalbog = "Stagalbog",
	["Stagalbog Cave"] = "Cueva Stagalbog",
	["Stagecoach Crash Site"] = "Lugar del Accidente de la Diligencia",
	["Staghelm Point"] = "Punta de Corzocelada",
	["Staging Balcony"] = "Balcón de Metamorfosis",
	["Stairway to Honor"] = "Escalera del Honor",
	["Starbreeze Village"] = "Aldea Brisa Estelar",
	["Stardust Spire"] = "Aguja del Polvo Estelar",
	["Starfall Village"] = "Aldea Estrella Fugaz",
	["Stars' Rest"] = "Reposo Estelar",
	["Stasis Block: Maximus"] = "Bloque de Estasis: Maximus",
	["Stasis Block: Trion"] = "Bloque de Estasis: Trion",
	["Steam Springs"] = "Manantiales de Vapor",
	["Steamwheedle Port"] = "Puerto Bonvapor",
	["Steel Gate"] = "Las Puertas de Acero",
	["Steelgrill's Depot"] = "Almacén de Brasacerada",
	["Steeljaw's Caravan"] = "Caravana de Quijacero",
	["Steelspark Station"] = "Estación Chispacero",
	["Stendel's Pond"] = "Estanque de Stendel",
	["Stillpine Hold"] = "Bastión Semprepino",
	["Stillwater Pond"] = "Charca Aguaserena",
	["Stillwhisper Pond"] = "Charca Plácido Susurro",
	Stonard = "Rocal",
	["Stonebreaker Camp"] = "Campamento Rompepedras",
	["Stonebreaker Hold"] = "Bastión Rompepedras",
	["Stonebull Lake"] = "Lago Toro de Piedra",
	["Stone Cairn Lake"] = "Lago del Hito",
	Stonehearth = "Hogar Pétreo",
	["Stonehearth Bunker"] = "Búnker Piedrahogar",
	["Stonehearth Graveyard"] = "Cementerio Piedrahogar",
	["Stonehearth Outpost"] = "Avanzada Piedrahogar",
	["Stonemaul Hold"] = "Bastión Quebrantarrocas",
	["Stonemaul Ruins"] = "Ruinas Quebrantarrocas",
	["Stone Mug Tavern"] = "Taberna Jarra Pétrea",
	Stoneplow = "Villarroca",
	["Stoneplow Fields"] = "Campos de Villarroca",
	["Stone Sentinel's Overlook"] = "Mirador del Centinela de Piedra",
	["Stonesplinter Valley"] = "Valle Rompecantos",
	["Stonetalon Bomb"] = "Bomba del Espolón",
	["Stonetalon Mountains"] = "Sierra Espolón",
	["Stonetalon Pass"] = "Paso del Espolón",
	["Stonetalon Peak"] = "Cima del Espolón",
	["Stonewall Canyon"] = "Cañón de la Muralla",
	["Stonewall Lift"] = "Elevador del Muro de Piedra",
	["Stoneward Prison"] = "Prisión Guardapétrea",
	Stonewatch = "Petravista",
	["Stonewatch Falls"] = "Cascadas Petravista",
	["Stonewatch Keep"] = "Fuerte de Petravista",
	["Stonewatch Tower"] = "Torre de Petravista",
	["Stonewrought Dam"] = "Presa de las Tres Cabezas",
	["Stonewrought Pass"] = "Paso de Fraguapiedra",
	["Storm Cliffs"] = "Acantilados de la Tormenta",
	Stormcrest = "Crestormenta",
	["Stormfeather Outpost"] = "Avanzada Tempespluma",
	["Stormglen Village"] = "Poblado Valletormenta",
	["Storm Peaks"] = "Las Cumbres Tormentosas",
	["Stormpike Graveyard"] = "Cementerio Pico Tormenta",
	["Stormrage Barrow Dens"] = "Túmulo de Tempestira",
	["Stormsea Landing"] = "Muelle Aguaturbia",
	["Storm's Fury Wreckage"] = "Restos de la Furia de la Tormenta",
	["Stormstout Brewery"] = "Cervecería del Trueno",
	["Stormstout Brewery Interior"] = "Interior de la Cervecería del Trueno",
	["Stormstout Brewhall"] = "Sala de la Cerveza de Trueno",
	Stormwind = "Ventormenta",
	["Stormwind City"] = "Ciudad de Ventormenta",
	["Stormwind City Cemetery"] = "Cementerio de la Ciudad de Ventormenta",
	["Stormwind City Outskirts"] = "Afueras de la Ciudad de Ventormenta",
	["Stormwind Gunship Pandaria Start Area"] = "Zona de inicio de Pandaria: nave de guerra de Ventormenta",
	["Stormwind Harbor"] = "Puerto de Ventormenta",
	["Stormwind Keep"] = "Castillo de Ventormenta",
	["Stormwind Lake"] = "Lago de Ventormenta",
	["Stormwind Mountains"] = "Montañas de Ventormenta",
	["Stormwind Stockade"] = "Mazmorras de Ventormenta",
	["Stormwind Vault"] = "Cámara de Ventormenta",
	["Stoutlager Inn"] = "Pensión La Cebada",
	Strahnbrad = "Strahnbrad",
	["Strand of the Ancients"] = "Playa de los Ancestros",
	["Stranglethorn Vale"] = "Vega de Tuercespina",
	Stratholme = "Stratholme",
	["Stratholme Entrance"] = "Entrada de Stratholme",
	["Stratholme - Main Gate"] = "Stratholme: Entrada Principal",
	["Stratholme - Service Entrance"] = "Stratholme: Entrada de Servicio",
	["Stratholme Service Entrance"] = "Entrada de Servicio de Stratholme",
	["Stromgarde Keep"] = "Castillo de Stromgarde",
	["Strongarm Airstrip"] = "Pista de Aterrizaje Armafuerte",
	["STV Diamond Mine BG"] = "CB Mina de Diamantes STV",
	["Stygian Bounty"] = "Recompensa Estigia",
	["Sub zone"] = "Subzona",
	["Sulfuron Keep"] = "Fortaleza de Sulfuron",
	["Sulfuron Keep Courtyard"] = "Patio de la Fortaleza de Sulfuron",
	["Sulfuron Span"] = "Puente de Sulfuron",
	["Sulfuron Spire"] = "Aguja de Sulfuron",
	["Sullah's Sideshow"] = "Puesto de Sullah",
	["Summer's Rest"] = "Reposo Estival",
	["Summoners' Tomb"] = "Tumba del Invocador",
	["Sunblossom Hill"] = "Colina Flor de Sol",
	["Suncrown Village"] = "Aldea Corona del Sol",
	["Sundown Marsh"] = "Pantano del Ocaso",
	["Sunfire Point"] = "Punta del Fuego Solar",
	["Sunfury Hold"] = "Bastión Furia del Sol",
	["Sunfury Spire"] = "Aguja Furia del Sol",
	["Sungraze Peak"] = "Cima Rasguño de Sol",
	["Sunken Dig Site"] = "Excavación Sumergida",
	["Sunken Temple"] = "Templo Sumergido",
	["Sunken Temple Entrance"] = "Entrada del Templo Sumergido",
	["Sunreaver Pavilion"] = "Pabellón Atracasol",
	["Sunreaver's Command"] = "Dominio de los Atracasol",
	["Sunreaver's Sanctuary"] = "Santuario Atracasol",
	["Sun Rock Retreat"] = "Refugio Roca del Sol",
	["Sunsail Anchorage"] = "Fondeadero Vela del Sol",
	["Sunsoaked Meadow"] = "Prado Aguasol",
	["Sunsong Ranch"] = "Rancho Cantosol",
	["Sunspring Post"] = "Puesto Primasol",
	["Sun's Reach Armory"] = "Arsenal de Tramo del Sol",
	["Sun's Reach Harbor"] = "Puerto de Tramo del Sol",
	["Sun's Reach Sanctum"] = "Sagrario de Tramo del Sol",
	["Sunstone Terrace"] = "Bancal Piedrasol",
	["Sunstrider Isle"] = "Isla del Caminante del Sol",
	["Sunveil Excursion"] = "Excursión Velosolar",
	["Sunwatcher's Ridge"] = "Monte del Vigía del Sol",
	["Sunwell Plateau"] = "Meseta de La Fuente del Sol",
	["Supply Caravan"] = "Caravana de Provisiones",
	["Surge Needle"] = "Aguja de Flujo",
	["Surveyors' Outpost"] = "Avanzada de vigilantes",
	Surwich = "Mechasur",
	["Svarnos' Cell"] = "Celda de Svarnos",
	["Swamplight Manor"] = "Mansión Cienaluz",
	["Swamp of Sorrows"] = "Pantano de las Penas",
	["Swamprat Post"] = "Avanzada Rata del Pantano",
	["Swiftgear Station"] = "Estación Cambioveloz",
	["Swindlegrin's Dig"] = "Excavación de Timomueca",
	["Swindle Street"] = "Calle del Timo",
	["Sword's Rest"] = "Reposo de la Espada",
	Sylvanaar = "Sylvanaar",
	["Tabetha's Farm"] = "Granja de Tabetha",
	["Taelan's Tower"] = "Torre de Taelan",
	["Tahonda Ruins"] = "Ruinas de Tahonda",
	["Tahret Grounds"] = "Tierras de Tahret",
	["Tal'doren"] = "Tal'doren",
	["Talismanic Textiles"] = "Telas Talismánicas",
	["Tallmug's Camp"] = "Puesto de Jarroalto",
	["Talonbranch Glade"] = "Claro Ramaespolón",
	["Talonbranch Glade "] = "Claro Ramaespolón",
	["Talondeep Pass"] = "Desfiladero del Espolón",
	["Talondeep Vale"] = "Valle del Espolón",
	["Talon Stand"] = "Alto de la Garra",
	Talramas = "Talramas",
	["Talrendis Point"] = "Punta Talrendis",
	Tanaris = "Tanaris",
	["Tanaris Desert"] = "Desierto de Tanaris",
	["Tanks for Everything"] = "Tanques para Todo",
	["Tanner Camp"] = "Base de Peleteros",
	["Tarren Mill"] = "Molino Tarren",
	["Tasters' Arena"] = "Arena de Catadores",
	["Taunka'le Village"] = "Poblado Taunka'le",
	["Tavern in the Mists"] = "Taberna en la Niebla",
	["Tazz'Alaor"] = "Tazz'Alaor",
	["Tear Down This Wall!"] = "¡Abajo la Muralla!",
	["Teegan's Expedition"] = "Expedición de Teegan",
	["Teeming Burrow"] = "Madriguera Fecunda",
	Telaar = "Telaar",
	["Telaari Basin"] = "Cuenca Telaari",
	["Tel'athion's Camp"] = "Campamento de Tel'athion",
	Teldrassil = "Teldrassil",
	Telredor = "Telredor",
	["Tempest Bridge"] = "Puente de la Tempestad",
	["Tempest Keep"] = "El Castillo de la Tempestad",
	["Tempest Keep: The Arcatraz"] = "El Castillo de la Tempestad: El Arcatraz",
	["Tempest Keep - The Arcatraz Entrance"] = "El Castillo de la Tempestad: Entrada de El Arcatraz",
	["Tempest Keep: The Botanica"] = "El Castillo de la Tempestad: El Invernáculo",
	["Tempest Keep - The Botanica Entrance"] = "El Castillo de la Tempestad: Entrada de El Invernáculo",
	["Tempest Keep: The Mechanar"] = "El Castillo de la Tempestad: El Mechanar",
	["Tempest Keep - The Mechanar Entrance"] = "El Castillo de la Tempestad: Entrada de El Mechanar",
	["Tempest's Reach"] = "Tramo de la Tempestad",
	["Temple City of En'kilah"] = "Ciudad Templo de En'kilah",
	["Temple Hall"] = "Sala del Templo",
	["Temple of Ahn'Qiraj"] = "El Templo de Ahn'Qiraj",
	["Temple of Arkkoran"] = "Templo de Arkkoran",
	["Temple of Asaad"] = "Templo de Asaad",
	["Temple of Bethekk"] = "Templo de Bethekk",
	["Temple of Earth"] = "Templo de la Tierra",
	["Temple of Five Dawns"] = "Templo de los Cinco Albores",
	["Temple of Invention"] = "Templo de la Invención",
	["Temple of Kotmogu"] = "Templo de Kotmogu",
	["Temple of Life"] = "Templo de la Vida",
	["Temple of Order"] = "Templo del Orden",
	["Temple of Storms"] = "Templo de las Tormentas",
	["Temple of Telhamat"] = "Templo de Telhamat",
	["Temple of the Forgotten"] = "Templo de los Olvidados",
	["Temple of the Jade Serpent"] = "Templo del Dragón de Jade",
	["Temple of the Moon"] = "Templo de la Luna",
	["Temple of the Red Crane"] = "Templo de la Grulla Roja",
	["Temple of the White Tiger"] = "Templo del Tigre Blanco",
	["Temple of Uldum"] = "Templo de Uldum",
	["Temple of Winter"] = "Templo del Invierno",
	["Temple of Wisdom"] = "Templo de Sabiduría",
	["Temple of Zin-Malor"] = "Templo de Zin-Malor",
	["Temple Summit"] = "Cima del Templo",
	["Tenebrous Cavern"] = "Caverna Tenebrosa",
	["Terokkar Forest"] = "Bosque de Terokkar",
	["Terokk's Rest"] = "Sosiego de Terokk",
	["Terrace of Endless Spring"] = "Veranda de la Primavera Eterna",
	["Terrace of Gurthan"] = "Bancal Gurthan",
	["Terrace of Light"] = "Bancal de la Luz",
	["Terrace of Repose"] = "Bancal del Reposo",
	["Terrace of Ten Thunders"] = "Bancal de los Diez Truenos",
	["Terrace of the Augurs"] = "Bancal de los Augurios",
	["Terrace of the Makers"] = "Bancal de los Creadores",
	["Terrace of the Sun"] = "Bancal del Sol",
	["Terrace of the Tiger"] = "Bancal del Tigre",
	["Terrace of the Twin Dragons"] = "Aposento de los Dragones Gemelos",
	Terrordale = "Valle del Terror",
	["Terror Run"] = "Camino del Terror",
	["Terrorweb Tunnel"] = "Túnel Terroarácnido",
	["Terror Wing Path"] = "Senda del Ala del Terror",
	["Tethris Aran"] = "Tethris Aran",
	Thalanaar = "Thalanaar",
	["Thalassian Pass"] = "Desfiladero Thalassiano",
	["Thalassian Range"] = "Campo de tiro Thalassiano",
	["Thal'darah Grove"] = "Arboleda de Thal'darah",
	["Thal'darah Overlook"] = "Mirador Thal'darah",
	["Thandol Span"] = "Puente Thandol",
	["Thargad's Camp"] = "Campo de Thargad",
	["The Abandoned Reach"] = "El Tramo Abandonado",
	["The Abyssal Maw"] = "Fauce Abisal",
	["The Abyssal Shelf"] = "La Plataforma Abisal",
	["The Admiral's Den"] = "La Guarida del Almirante",
	["The Agronomical Apothecary"] = "La Botica Agronómica",
	["The Alliance Valiants' Ring"] = "La Liza de los Valerosos de la Alianza",
	["The Altar of Damnation"] = "El Altar de Condenación",
	["The Altar of Shadows"] = "El Altar de las Sombras",
	["The Altar of Zul"] = "El Altar de Zul",
	["The Amber Hibernal"] = "El Invernadero Ámbar",
	["The Amber Vault"] = "La Cámara de Ámbar",
	["The Amber Womb"] = "El Resguardo Ámbar",
	["The Ancient Grove"] = "La Antigua Arboleda",
	["The Ancient Lift"] = "El Antiguo Elevador",
	["The Ancient Passage"] = "El Pasaje Antiguo",
	["The Antechamber"] = "La Antecámara",
	["The Anvil of Conflagration"] = "El Yunque de Conflagración",
	["The Anvil of Flame"] = "El Yunque de la Llama",
	["The Apothecarium"] = "El Apothecarium",
	["The Arachnid Quarter"] = "El Arrabal Arácnido",
	["The Arboretum"] = "El Arboretum",
	["The Arcanium"] = "El Arcanium",
	["The Arcanium "] = "El Arcanium",
	["The Arcatraz"] = "El Arcatraz",
	["The Archivum"] = "El Archivum",
	["The Argent Stand"] = "El Confín Argenta",
	["The Argent Valiants' Ring"] = "La Liza de los Valerosos Argenta",
	["The Argent Vanguard"] = "La Vanguardia Argenta",
	["The Arsenal Absolute"] = "El Arsenal Absoluto",
	["The Aspirants' Ring"] = "La Liza de los Aspirantes",
	["The Assembly Chamber"] = "La Cámara de la Asamblea",
	["The Assembly of Iron"] = "La Asamblea de Hierro",
	["The Athenaeum"] = "El Athenaeum",
	["The Autumn Plains"] = "Las Llanuras Otoñales",
	["The Avalanche"] = "La Avalancha",
	["The Azure Front"] = "El Frente Azur",
	["The Bamboo Wilds"] = "Las Tierras de Bambú",
	["The Bank of Dalaran"] = "El Banco de Dalaran",
	["The Bank of Silvermoon"] = "El Banco de Lunargenta",
	["The Banquet Hall"] = "La Sala de Banquetes",
	["The Barrier Hills"] = "Las Colinas Barrera",
	["The Bastion of Twilight"] = "El Bastión del Crepúsculo",
	["The Battleboar Pen"] = "El Cercado de Jabaguerreros",
	["The Battle for Gilneas"] = "La Batalla por Gilneas",
	["The Battle for Gilneas (Old City Map)"] = "La Batalla por Gilneas (Mapa de la antigua ciudad)",
	["The Battle for Mount Hyjal"] = "La Batalla del Monte Hyjal",
	["The Battlefront"] = "El Frente de Batalla",
	["The Bazaar"] = "El Bazar",
	["The Beast Pens"] = "El Cerco de las Bestias",
	["The Beer Garden"] = "La Terraza",
	["The Bite"] = "La Dentellada",
	["The Black Breach"] = "La Brecha Negra",
	["The Black Market"] = "El Mercado Negro",
	["The Black Morass"] = "La Ciénaga Negra",
	["The Black Temple"] = "El Templo Oscuro",
	["The Black Vault"] = "Cámara Negra",
	["The Blackwald"] = "El Monte Negro",
	["The Blazing Strand"] = "La Playa Llameante",
	["The Blighted Pool"] = "La Poza Contagiada",
	["The Blight Line"] = "La Línea de Añublo",
	["The Bloodcursed Reef"] = "El Arrecife Sangre Maldita",
	["The Blood Furnace"] = "El Horno de Sangre",
	["The Bloodmire"] = "Fango de Sangre",
	["The Bloodoath"] = "El Juramento de Sangre",
	["The Blood Trail"] = "El Reguero de Sangre",
	["The Bloodwash"] = "La Playa de Sangre",
	["The Boiling Crustacean"] = "El Crustáceo Hirviente",
	["The Bombardment"] = "El Bombardeo",
	["The Bonefields"] = "Los Campos de Huesos",
	["The Bone Pile"] = "El Montón de Huesos",
	["The Bones of Nozronn"] = "Los Huesos de Nozronn",
	["The Bone Wastes"] = "El Vertedero de Huesos",
	["The Boneyard"] = "El Osario",
	["The Borean Wall"] = "La Muralla Boreal",
	["The Botanica"] = "El Invernáculo",
	["The Bradshaw Mill"] = "Molino Sotogrande",
	["The Breach"] = "La Brecha",
	["The Briny Cutter"] = "El Cúter Salobre",
	["The Briny Muck"] = "La Mugre Salobre",
	["The Briny Pinnacle"] = "El Pináculo Salobre",
	["The Broken Bluffs"] = "Riscos Quebrados",
	["The Broken Front"] = "El Frente Roto",
	["The Broken Hall"] = "Cámara Partida",
	["The Broken Hills"] = "Las Colinas Quebradas",
	["The Broken Stair"] = "La Escalera Quebrada",
	["The Broken Temple"] = "El Templo Quebrado",
	["The Broodmother's Nest"] = "El Nido de la Madre de Linaje",
	["The Brood Pit"] = "La Fosa de la Progenie",
	["The Bulwark"] = "El Baluarte",
	["The Burlap Trail"] = "La Senda Arpillera",
	["The Burlap Valley"] = "El Valle Arpillero",
	["The Burlap Waystation"] = "La Estación Arpillera",
	["The Burning Corridor"] = "El Corredor Ardiente",
	["The Butchery"] = "Carnicería",
	["The Cache of Madness"] = "El Extremo de la Locura",
	["The Caller's Chamber"] = "Cámara de la Llamada",
	["The Canals"] = "Los Canales",
	["The Cape of Stranglethorn"] = "El Cabo de Tuercespina",
	["The Carrion Fields"] = "Los Campos de Carroña",
	["The Catacombs"] = "Las Catacumbas",
	["The Cauldron"] = "La Caldera",
	["The Cauldron of Flames"] = "El Caldero de Llamas",
	["The Cave"] = "La Cueva",
	["The Celestial Planetarium"] = "El Planetario Celestial",
	["The Celestial Vault"] = "La Cámara Celestial",
	["The Celestial Watch"] = "El Mirador Celestial",
	["The Cemetary"] = "El Cementerio",
	["The Cerebrillum"] = "El Cerebelo",
	["The Charred Vale"] = "La Vega Carbonizada",
	["The Chilled Quagmire"] = "El Cenagal Escalofrío",
	["The Chum Bucket"] = "El Cubo de Cebo",
	["The Circle of Cinders"] = "El Círculo de las Cenizas",
	["The Circle of Life"] = "El Círculo de la Vida",
	["The Circle of Suffering"] = "El Círculo de Sufrimiento",
	["The Clarion Bell"] = "La Campana Clarín",
	["The Clash of Thunder"] = "El Fragor del Trueno",
	["The Clean Zone"] = "Punto de Limpieza",
	["The Cleft"] = "La Grieta",
	["The Clockwerk Run"] = "La Rampa del Engranaje",
	["The Clutch"] = "El Encierro",
	["The Clutches of Shek'zeer"] = "La Nidada de Shek'zeer",
	["The Coil"] = "El Serpenteo",
	["The Colossal Forge"] = "La Forja Colosal",
	["The Comb"] = "El Panal",
	["The Commons"] = "Ágora",
	["The Conflagration"] = "La Conflagración",
	["The Conquest Pit"] = "El Foso de la Conquista",
	["The Conservatory"] = "El Vivero",
	["The Conservatory of Life"] = "El Invernadero de Vida",
	["The Construct Quarter"] = "El Arrabal de los Ensamblajes",
	["The Cooper Residence"] = "La Residencia Cooper",
	["The Corridors of Ingenuity"] = "Los Pasillos del Ingenio",
	["The Court of Bones"] = "El Patio de los Huesos",
	["The Court of Skulls"] = "La Corte de las Calaveras",
	["The Coven"] = "El Aquelarre",
	["The Coven "] = "El Aquelarre",
	["The Creeping Ruin"] = "Las Ruinas Abyectas",
	["The Crimson Assembly Hall"] = "La Sala de la Asamblea Carmesí",
	["The Crimson Cathedral"] = "La Catedral Carmesí",
	["The Crimson Dawn"] = "El Alba Carmesí",
	["The Crimson Hall"] = "La Sala Carmesí",
	["The Crimson Reach"] = "El Tramo Carmesí",
	["The Crimson Throne"] = "El Trono Carmesí",
	["The Crimson Treader"] = "Viajero Carmesí",
	["The Crimson Veil"] = "El Velo Carmesí",
	["The Crossroads"] = "El Cruce",
	["The Crucible"] = "El Crisol",
	["The Crucible of Flame"] = "El Crisol de Llamas",
	["The Crumbling Waste"] = "Las Ruinas Desmoronadas",
	["The Cryo-Core"] = "El Crionúcleo",
	["The Crystal Hall"] = "La Sala de Cristal",
	["The Crystal Shore"] = "La Costa de Cristal",
	["The Crystal Vale"] = "La Vega de Cristal",
	["The Crystal Vice"] = "Vicio de Cristal",
	["The Culling of Stratholme"] = "La Matanza de Stratholme",
	["The Culling of Stratholme Entrance"] = "Entrada de La Matanza de Stratholme",
	["The Cursed Landing"] = "El Embarcadero Maldito",
	["The Dagger Hills"] = "Las Colinas Afiladas",
	["The Dai-Lo Farmstead"] = "La Granja de Dai-Lo",
	["The Damsel's Luck"] = "La Damisela Afortunada",
	["The Dancing Serpent"] = "El Dragón Danzante",
	["The Dark Approach"] = "El Trayecto Oscuro",
	["The Dark Defiance"] = "El Desafío Oscuro",
	["The Darkened Bank"] = "La Ribera Lóbrega",
	["The Dark Hollow"] = "El Foso Oscuro",
	["The Darkmoon Faire"] = "La Feria de la Luna Negra",
	["The Dark Portal"] = "El Portal Oscuro",
	["The Dark Rookery"] = "El Dominio Lúgubre",
	["The Darkwood"] = "Leñoscuro",
	["The Dawnchaser"] = "El Cazador del Albor",
	["The Dawning Isles"] = "Islas del Alba",
	["The Dawning Span"] = "El Puente del Amanecer",
	["The Dawning Square"] = "La Plaza Crepuscular",
	["The Dawning Stair"] = "La Escalera del Albor",
	["The Dawning Valley"] = "El Valle del Amanecer",
	["The Dead Acre"] = "El Campo Funesto",
	["The Dead Field"] = "El Campo Muerto",
	["The Dead Fields"] = "Los Campos Muertos",
	["The Deadmines"] = "Las Minas de la Muerte",
	["The Dead Mire"] = "El Lodo Muerto",
	["The Dead Scar"] = "La Cicatriz Muerta",
	["The Deathforge"] = "La Forja Muerta",
	["The Deathknell Graves"] = "Las Tumbas del Camposanto",
	["The Decrepit Fields"] = "Los Campos Decrépitos",
	["The Decrepit Flow"] = "La Corriente Decrépita",
	["The Deeper"] = "La Zanja",
	["The Deep Reaches"] = "La Hondura Insondable",
	["The Deepwild"] = "La Jungla Salvaje",
	["The Defiant"] = "El Desafiante",
	["The Defiled Chapel"] = "La Capilla Profanada",
	["The Den"] = "El Cubil",
	["The Den of Flame"] = "Cubil de la Llama",
	["The Dens of Dying"] = "Los Cubiles de los Moribundos",
	["The Dens of the Dying"] = "Los Cubiles de los Moribundos",
	["The Descent into Madness"] = "El Descenso a la Locura",
	["The Desecrated Altar"] = "El Altar Profanado",
	["The Devil's Terrace"] = "El Altar Demoniaco",
	["The Devouring Breach"] = "La Brecha Devoradora",
	["The Domicile"] = "Domicilio",
	["The Domicile "] = "Domicilio",
	["The Dooker Dome"] = "La Cúpula del Miko",
	["The Dor'Danil Barrow Den"] = "El Túmulo de Dor'danil",
	["The Dormitory"] = "Los Dormitorios",
	["The Drag"] = "La Calle Mayor",
	["The Dragonmurk"] = "El Pantano del Dragón",
	["The Dragon Wastes"] = "Baldío del Dragón",
	["The Drain"] = "El Vaciado",
	["The Dranosh'ar Blockade"] = "El Bloqueo Dranosh'ar",
	["The Drowned Reef"] = "El Arrecife Hundido",
	["The Drowned Sacellum"] = "El Templete Sumergido",
	["The Drunken Hozen"] = "El Hozen Beodo",
	["The Dry Hills"] = "Las Colinas Áridas",
	["The Dustbowl"] = "Terraseca",
	["The Dust Plains"] = "Los Yermos Polvorientos",
	["The Eastern Earthshrine"] = "El Santuario de la Tierra Oriental",
	["The Elders' Path"] = "El Camino de los Ancestros",
	["The Emerald Summit"] = "La Cumbre Esmeralda",
	["The Emperor's Approach"] = "La Vía del Emperador",
	["The Emperor's Gate"] = "Puerta del Emperador",
	["The Emperor's Reach"] = "El Tramo del Emperador",
	["The Emperor's Step"] = "El Paso del Emperador",
	["The Escape From Durnholde"] = "La Fuga de Durnholde",
	["The Escape from Durnholde Entrance"] = "Entrada de La Fuga de Durnholde",
	["The Eventide"] = "El Manto de la Noche",
	["The Exodar"] = "El Exodar",
	["The Eye"] = "El Ojo",
	["The Eye of Eternity"] = "El Ojo de la Eternidad",
	["The Eye of the Vortex"] = "El Ojo del Vórtice",
	["The Fall of Shan Bu"] = "La Caída de Shan Bu",
	["The Farstrider Lodge"] = "Cabaña del Errante",
	["The Feeding Pits"] = "Las Fosas del Ágape",
	["The Fel Pits"] = "Las Fosas Viles",
	["The Fertile Copse"] = "El Soto Fértil",
	["The Fetid Pool"] = "La Poza Fétida",
	["The Filthy Animal"] = "El Animal Roñoso",
	["The Firehawk"] = "El Halcón de Fuego",
	["The Five Sisters"] = "Las Cinco Hermanas",
	["The Flamewake"] = "La Estela Ardiente",
	["The Fleshwerks"] = "La Factoría de Carne",
	["The Flood Plains"] = "Llanuras Anegadas",
	["The Fold"] = "El Redil",
	["The Foothill Caverns"] = "Cuevas de la Ladera",
	["The Foot of Lei Shen"] = "Atrio de Lei Shen",
	["The Foot Steppes"] = "Las Estepas Inferiores",
	["The Forbidden Jungle"] = "La Jungla Prohibida",
	["The Forbidding Sea"] = "Mar Adusto",
	["The Forest of Shadows"] = "El Bosque de las Sombras",
	["The Forge of Souls"] = "La Forja de Almas",
	["The Forge of Souls Entrance"] = "Entrada de La Forja de Almas",
	["The Forge of Supplication"] = "La Forja de las Súplicas",
	["The Forge of Wills"] = "La Forja de los Deseos",
	["The Forgotten Coast"] = "La Costa Olvidada",
	["The Forgotten Overlook"] = "El Mirador Olvidado",
	["The Forgotten Pool"] = "Las Charcas del Olvido",
	["The Forgotten Pools"] = "Las Charcas del Olvido",
	["The Forgotten Shore"] = "La Orilla Olvidada",
	["The Forlorn Cavern"] = "La Caverna Abandonada",
	["The Forlorn Mine"] = "La Mina Desolada",
	["The Forsaken Front"] = "El Frente Renegado",
	["The Foul Pool"] = "La Poza del Hediondo",
	["The Frigid Tomb"] = "La Tumba Gélida",
	["The Frost Queen's Lair"] = "La Guarida de la Reina de Escarcha",
	["The Frostwing Halls"] = "Las Cámaras de Alaescarcha",
	["The Frozen Glade"] = "El Claro Helado",
	["The Frozen Halls"] = "Las Cámaras Heladas",
	["The Frozen Mine"] = "La Mina Gélida",
	["The Frozen Sea"] = "El Mar Gélido",
	["The Frozen Throne"] = "El Trono Helado",
	["The Fungal Vale"] = "Cuenca Fungal",
	["The Furnace"] = "El Horno",
	["The Gaping Chasm"] = "Sima Abierta",
	["The Gatehouse"] = "Torre de Entrada",
	["The Gatehouse "] = "Torre de Entrada",
	["The Gate of Unending Cycles"] = "La Puerta de los Ciclos Eternos",
	["The Gauntlet"] = "El Guantelete",
	["The Geyser Fields"] = "Los Campos de Géiseres",
	["The Ghastly Confines"] = "Los Confines Espectrales",
	["The Gilded Foyer"] = "El Vestíbulo Dorado",
	["The Gilded Gate"] = "La Puerta Áurea",
	["The Gilding Stream"] = "El Arroyo Áureo",
	["The Glimmering Pillar"] = "El Pilar Iluminado",
	["The Golden Gateway"] = "La Puerta Dorada",
	["The Golden Hall"] = "El Pasillo Dorado",
	["The Golden Lantern"] = "El Farol Áureo",
	["The Golden Pagoda"] = "La Pagoda Dorada",
	["The Golden Plains"] = "Las Llanuras Doradas",
	["The Golden Rose"] = "La Rosa Áurea",
	["The Golden Stair"] = "La Escalera Dorada",
	["The Golden Terrace"] = "La Terraza Áurea",
	["The Gong of Hope"] = "El Gong de la Esperanza",
	["The Grand Ballroom"] = "El Gran Salón de Baile",
	["The Grand Vestibule"] = "El Gran Vestíbulo",
	["The Great Arena"] = "La Gran Arena",
	["The Great Divide"] = "La Gran División",
	["The Great Fissure"] = "La Gran Fisura",
	["The Great Forge"] = "La Gran Fundición",
	["The Great Gate"] = "La Gran Puerta",
	["The Great Lift"] = "El Gran Elevador",
	["The Great Ossuary"] = "El Gran Osario",
	["The Great Sea"] = "Mare Magnum",
	["The Great Tree"] = "El Gran Árbol",
	["The Great Wheel"] = "La Gran Rueda",
	["The Green Belt"] = "La Franja Verde",
	["The Greymane Wall"] = "La Muralla de Cringris",
	["The Grim Guzzler"] = "Tragapenas",
	["The Grinding Quarry"] = "La Cantera Trituradora",
	["The Grizzled Den"] = "El Cubil Pardo",
	["The Grummle Bazaar"] = "El Bazar Grúmel",
	["The Guardhouse"] = "La Cárcel",
	["The Guest Chambers"] = "Los Aposentos de los Invitados",
	["The Gullet"] = "La Garganta",
	["The Halfhill Market"] = "El Mercado del Alcor",
	["The Half Shell"] = "La Media Concha",
	["The Hall of Blood"] = "La Sala de la Sangre",
	["The Hall of Gears"] = "La Sala de Máquinas",
	["The Hall of Lights"] = "La Sala de las Luces",
	["The Hall of Respite"] = "La Sala del Descanso",
	["The Hall of Statues"] = "La Estancia de las Estatuas",
	["The Hall of the Serpent"] = "La Sala del Dragón",
	["The Hall of Tiles"] = "La Estancia Enlosada",
	["The Halls of Reanimation"] = "Las Salas de la Reanimación",
	["The Halls of Winter"] = "Las Cámaras del Invierno",
	["The Hand of Gul'dan"] = "La Mano de Gul'dan",
	["The Harborage"] = "El Puerto",
	["The Hatchery"] = "El Criadero",
	["The Headland"] = "La Punta",
	["The Headlands"] = "Los Cabos",
	["The Heap"] = "La Pila",
	["The Heartland"] = "Los Cultivos Florecientes",
	["The Heart of Acherus"] = "El Corazón de Acherus",
	["The Heart of Jade"] = "El Corazón de Jade",
	["The Hidden Clutch"] = "La Guarida Oculta",
	["The Hidden Grove"] = "La Arboleda Oculta",
	["The Hidden Hollow"] = "La Hondonada Oculta",
	["The Hidden Passage"] = "El Pasaje Oculto",
	["The Hidden Reach"] = "El Tramo Oculto",
	["The Hidden Reef"] = "El Arrecife Oculto",
	["The High Path"] = "El Paso Elevado",
	["The High Road"] = "La Carretera",
	["The High Seat"] = "El Trono",
	["The Hinterlands"] = "Tierras del Interior",
	["The Hoard"] = "El Tesoro Oculto",
	["The Hole"] = "El Agujero",
	["The Horde Valiants' Ring"] = "La Liza de los Valerosos de la Horda",
	["The Horrid March"] = "La Marcha Espectral",
	["The Horsemen's Assembly"] = "La Asamblea de los Jinetes",
	["The Howling Hollow"] = "La Hondonada Aullante",
	["The Howling Oak"] = "El Roble Quejumbroso",
	["The Howling Vale"] = "Vega del Aullido",
	["The Hunter's Reach"] = "El Tramo del Cazador",
	["The Hushed Bank"] = "La Ribera Silente",
	["The Icy Depths"] = "Las Profundidades Heladas",
	["The Immortal Coil"] = "La Espiral Inmortal",
	["The Imperial Exchange"] = "El Intercambio Imperial",
	["The Imperial Granary"] = "El Granero Imperial",
	["The Imperial Mercantile"] = "El Mercado Imperial",
	["The Imperial Seat"] = "El Trono Imperial",
	["The Incursion"] = "La Incursión",
	["The Infectis Scar"] = "La Cicatriz Purulenta",
	["The Inferno"] = "El Averno",
	["The Inner Spire"] = "Aguja Interior",
	["The Intrepid"] = "El Intrépido",
	["The Inventor's Library"] = "La Biblioteca del Inventor",
	["The Iron Crucible"] = "El Crisol de Hierro",
	["The Iron Hall"] = "Cámara de Hierro",
	["The Iron Reaper"] = "La Segadora de Hierro",
	["The Isle of Spears"] = "La Isla de las Lanzas",
	["The Ivar Patch"] = "Los Dominios de Ivar",
	["The Jade Forest"] = "El Bosque de Jade",
	["The Jade Vaults"] = "Las Cámaras de Jade",
	["The Jansen Stead"] = "La Finca de Jansen",
	["The Keggary"] = "La Bodega",
	["The Kennel"] = "El Patio",
	["The Krasari Ruins"] = "Las Ruinas Krasari",
	["The Krazzworks"] = "La Krazzería",
	["The Laboratory"] = "El Laboratorio",
	["The Lady Mehley"] = "El Lady Mehley",
	["The Lagoon"] = "La Laguna",
	["The Laughing Stand"] = "La Playa Rompeolas",
	["The Lazy Turnip"] = "La Naba Perezosa",
	["The Legerdemain Lounge"] = "Salón Juego de Manos",
	["The Legion Front"] = "La Avanzadilla de la Legión",
	["Thelgen Rock"] = "Roca Thelgen",
	["The Librarium"] = "El Librarium",
	["The Library"] = "La Biblioteca",
	["The Lifebinder's Cell"] = "La Celda de la Protectora",
	["The Lifeblood Pillar"] = "El Pilar Sangrevida",
	["The Lightless Reaches"] = "Las Costas Extintas",
	["The Lion's Redoubt"] = "El Reducto del León",
	["The Living Grove"] = "La Arboleda Viviente",
	["The Living Wood"] = "El Bosque Viviente",
	["The LMS Mark II"] = "El LMS Mark II",
	["The Loch"] = "Loch Modan",
	["The Long Wash"] = "Playa del Oleaje",
	["The Lost Fleet"] = "La Flota Perdida",
	["The Lost Fold"] = "El Aprisco Perdido",
	["The Lost Isles"] = "Las Islas Perdidas",
	["The Lost Lands"] = "Las Tierras Perdidas",
	["The Lost Passage"] = "El Pasaje Perdido",
	["The Low Path"] = "El Paso Bajo",
	Thelsamar = "Thelsamar",
	["The Lucky Traveller"] = "La Fortuna del Viajero",
	["The Lyceum"] = "El Lyceum",
	["The Maclure Vineyards"] = "Los Viñedos de Maclure",
	["The Maelstrom"] = "La Vorágine",
	["The Maker's Overlook"] = "El Mirador de los Creadores",
	["The Makers' Overlook"] = "El Mirador de los Creadores",
	["The Makers' Perch"] = "El Pedestal de los Creadores",
	["The Maker's Rise"] = "El Alto de los Creadores",
	["The Maker's Terrace"] = "Bancal del Hacedor",
	["The Manufactory"] = "El Taller",
	["The Marris Stead"] = "Hacienda de Marris",
	["The Marshlands"] = "Los Pantanales",
	["The Masonary"] = "El Masón",
	["The Master's Cellar"] = "El Sótano del Maestro",
	["The Master's Glaive"] = "La Espada del Maestro",
	["The Maul"] = "La Marra",
	["The Maw of Madness"] = "Las Fauces de la Locura",
	["The Mechanar"] = "El Mechanar",
	["The Menagerie"] = "La Sala de las Fieras",
	["The Menders' Stead"] = "La Finca de los Ensalmadores",
	["The Merchant Coast"] = "La Costa Mercante",
	["The Militant Mystic"] = "El Místico Militante",
	["The Military Quarter"] = "El Arrabal Militar",
	["The Military Ward"] = "La Sala Militar",
	["The Mind's Eye"] = "El Ojo de la Mente",
	["The Mirror of Dawn"] = "El Espejo del Alba",
	["The Mirror of Twilight"] = "El Espejo del Crepúsculo",
	["The Molsen Farm"] = "La Granja de Molsen",
	["The Molten Bridge"] = "Puente de Magma",
	["The Molten Core"] = "Núcleo de Magma",
	["The Molten Fields"] = "Los Campos Fundidos",
	["The Molten Flow"] = "La Corriente de Magma",
	["The Molten Span"] = "Luz de Magma",
	["The Mor'shan Rampart"] = "La Empalizada de Mor'shan",
	["The Mor'Shan Ramparts"] = "La Empalizada de Mor'shan",
	["The Mosslight Pillar"] = "El Pilar Musgoluz",
	["The Mountain Den"] = "El Cubil de la Sierra",
	["The Murder Pens"] = "El Matadero",
	["The Mystic Ward"] = "La Sala Mística",
	["The Necrotic Vault"] = "La Cripta Necrótica",
	["The Nexus"] = "El Nexo",
	["The Nexus Entrance"] = "Entrada de El Nexo",
	["The Nightmare Scar"] = "Paraje Pesadilla",
	["The North Coast"] = "La Costa Norte",
	["The North Sea"] = "El Mar del Norte",
	["The Nosebleeds"] = "La Hemorragia",
	["The Noxious Glade"] = "El Claro Ponzoñoso",
	["The Noxious Hollow"] = "Hoya Ponzoñosa",
	["The Noxious Lair"] = "La Guarida Ponzoñosa",
	["The Noxious Pass"] = "El Paso Ponzoñoso",
	["The Oblivion"] = "El Olvido",
	["The Observation Ring"] = "El Círculo de Observación",
	["The Obsidian Sanctum"] = "El Sagrario Obsidiana",
	["The Oculus"] = "El Oculus",
	["The Oculus Entrance"] = "Entrada de El Oculus",
	["The Old Barracks"] = "El Antiguo Cuartel",
	["The Old Dormitory"] = "La Vieja Residencia",
	["The Old Port Authority"] = "Autoridades del Puerto Viejo",
	["The Opera Hall"] = "La Sala de la Ópera",
	["The Oracle Glade"] = "El Claro del Oráculo",
	["The Outer Ring"] = "El Anillo Exterior",
	["The Overgrowth"] = "La Hojarasca",
	["The Overlook"] = "La Dominancia",
	["The Overlook Cliffs"] = "Los Acantilados Dominantes",
	["The Overlook Inn"] = "La Posada del Mirador",
	["The Ox Gate"] = "La Puerta del Buey",
	["The Pale Roost"] = "El Nidal Pálido",
	["The Park"] = "El Parque",
	["The Path of Anguish"] = "El Camino del Tormento",
	["The Path of Conquest"] = "El Sendero de la Conquista",
	["The Path of Corruption"] = "El Sendero de la Corrupción",
	["The Path of Glory"] = "El Camino a la Gloria",
	["The Path of Iron"] = "La Senda de Hierro",
	["The Path of the Lifewarden"] = "La Senda del Guardián de Vida",
	["The Phoenix Hall"] = "La Cámara del Fénix",
	["The Pillar of Ash"] = "El Pilar de Ceniza",
	["The Pipe"] = "La Tubería",
	["The Pit of Criminals"] = "La Fosa de los Criminales",
	["The Pit of Fiends"] = "El Foso de los Mefistos",
	["The Pit of Narjun"] = "El Foso de Narjun",
	["The Pit of Refuse"] = "La Fosa del Rechazo",
	["The Pit of Sacrifice"] = "La Fosa de los Sacrificios",
	["The Pit of Scales"] = "El Foso de Escamas",
	["The Pit of the Fang"] = "El Foso del Colmillo",
	["The Plague Quarter"] = "El Arrabal de la Peste",
	["The Plagueworks"] = "Los Talleres de la Peste",
	["The Pool of Ask'ar"] = "La Alberca de Ask'ar",
	["The Pools of Vision"] = "Pozas de las Visiones",
	["The Prison of Yogg-Saron"] = "La Prisión de Yogg-Saron",
	["The Proving Grounds"] = "El Terreno de Pruebas",
	["The Purple Parlor"] = "El Salón Púrpura",
	["The Quagmire"] = "El Lodazal",
	["The Quaking Fields"] = "Los Campos Convulsos",
	["The Queen's Reprisal"] = "La Represalia de la Reina",
	["The Raging Chasm"] = "La Sima Enfurecida",
	Theramore = "Theramore",
	["Theramore Isle"] = "Isla Theramore",
	["Theramore's Fall"] = "Caída de Theramore",
	["Theramore's Fall (A)"] = "Caída de Theramore (A)",
	["Theramore's Fall (H)"] = "Caída de Theramore (H)",
	["Theramore's Fall Phase"] = "Fase de la Caída de Theramore",
	["The Rangers' Lodge"] = "El Refugio de los Forestales",
	["Therazane's Throne"] = "Trono de Therazane",
	["The Red Reaches"] = "Las Costas Rojas",
	["The Refectory"] = "El Refectorio",
	["The Regrowth"] = "El Brote",
	["The Reliquary"] = "El Relicario",
	["The Repository"] = "El Repositorio",
	["The Reservoir"] = "La Presa",
	["The Restless Front"] = "El Frente Inquieto",
	["The Ridge of Ancient Flame"] = "La Cresta de la Llama Ancestral",
	["The Rift"] = "La Falla",
	["The Ring of Balance"] = "El Círculo del Equilibrio",
	["The Ring of Blood"] = "El Círculo de Sangre",
	["The Ring of Champions"] = "La Liza de los Campeones",
	["The Ring of Inner Focus"] = "El Círculo del Enfoque Interno",
	["The Ring of Trials"] = "El Círculo de los Retos",
	["The Ring of Valor"] = "El Círculo del Valor",
	["The Riptide"] = "Las Mareas Vivas",
	["The Riverblade Den"] = "La Guarida Hojarrío",
	["Thermal Vents"] = "Celosía Termal",
	["The Roiling Gardens"] = "Los Jardines Turbados",
	["The Rolling Gardens"] = "Los Jardines Turbados",
	["The Rolling Plains"] = "Las Llanuras Onduladas",
	["The Rookery"] = "El Grajero",
	["The Rotting Orchard"] = "El Vergel Pútrido",
	["The Rows"] = "El Labrantío",
	["The Royal Exchange"] = "El Intercambio Real",
	["The Ruby Sanctum"] = "El Sagrario Rubí",
	["The Ruined Reaches"] = "Las Ruinas",
	["The Ruins of Kel'Theril"] = "Las Ruinas de Kel'Theril",
	["The Ruins of Ordil'Aran"] = "Las Ruinas de Ordil'Aran",
	["The Ruins of Stardust"] = "Las Ruinas del Polvo Estelar",
	["The Rumble Cage"] = "La Jaula del Rugido",
	["The Rustmaul Dig Site"] = "Excavación Oximelena",
	["The Sacred Grove"] = "La Arboleda Sagrada",
	["The Salty Sailor Tavern"] = "Taberna del Grumete Frito",
	["The Sanctum"] = "El Sagrario",
	["The Sanctum of Blood"] = "El Sagrario de Sangre",
	["The Savage Coast"] = "La Costa Salvaje",
	["The Savage Glen"] = "La Cañada Salvaje",
	["The Savage Thicket"] = "El Matorral Silvestre",
	["The Scalding Chasm"] = "La Sima Escaldante",
	["The Scalding Pools"] = "Las Pozas Escaldantes",
	["The Scarab Dais"] = "Estrado del Escarabajo",
	["The Scarab Wall"] = "El Muro del Escarabajo",
	["The Scarlet Basilica"] = "La Basílica Escarlata",
	["The Scarlet Bastion"] = "El Bastión Escarlata",
	["The Scorched Grove"] = "La Arboleda Agostada",
	["The Scorched Plain"] = "La Llanura Agostada",
	["The Scrap Field"] = "El Campo de Sobras",
	["The Scrapyard"] = "La Chatarrería",
	["The Screaming Hall"] = "La Sala del Grito",
	["The Screaming Reaches"] = "Cuenca de los Gritos",
	["The Screeching Canyon"] = "Cañón del Chirrido",
	["The Scribe of Stormwind"] = "El Escriba de Ventormenta",
	["The Scribes' Sacellum"] = "El Templete de los Escribas",
	["The Scrollkeeper's Sanctum"] = "El Sagrario del Escribiente",
	["The Scullery"] = "La Sala de Limpieza",
	["The Scullery "] = "La Antecocina",
	["The Seabolt"] = "Rayo de los Mares",
	["The Seabreach Flow"] = "El Flujo de la Brecha del Mar",
	["The Sealed Hall"] = "Cámara Sellada",
	["The Sea of Cinders"] = "El Mar de las Cenizas",
	["The Sea Reaver's Run"] = "La Travesía del Atracamar",
	["The Searing Gateway"] = "La Puerta de Fuego",
	["The Sea Wolf"] = "El Lobo de Mar",
	["The Secret Aerie"] = "El Nidal Secreto",
	["The Secret Lab"] = "El Laboratorio Secreto",
	["The Secrets of Ragefire"] = "Los Secretos de Sima Ígnea",
	["The Seer's Library"] = "La Biblioteca del Profeta",
	["The Sepulcher"] = "El Sepulcro",
	["The Severed Span"] = "Tramoduro",
	["The Sewer"] = "La Cloaca",
	["The Shadow Stair"] = "La Escalera Umbría",
	["The Shadow Throne"] = "El Trono de las Sombras",
	["The Shadow Vault"] = "La Cámara de las Sombras",
	["The Shady Nook"] = "El Rincón Lóbrego",
	["The Shaper's Terrace"] = "El Bancal del Creador",
	["The Shattered Halls"] = "Las Salas Arrasadas",
	["The Shattered Strand"] = "La Playa Arrasada",
	["The Shattered Walkway"] = "La Pasarela Devastada",
	["The Shepherd's Gate"] = "La Puerta del Pastor",
	["The Shifting Mire"] = "Lodo Traicionero",
	["The Shimmering Deep"] = "El Piélago de Sal",
	["The Shimmering Flats"] = "El Desierto de Sal",
	["The Shining Strand"] = "La Playa Plateada",
	["The Shrine of Aessina"] = "El Santuario de Aessina",
	["The Shrine of Eldretharr"] = "Santuario de Eldretharr",
	["The Silent Sanctuary"] = "El Santuario Silente",
	["The Silkwood"] = "El Sedal",
	["The Silver Blade"] = "La Espada de Plata",
	["The Silver Enclave"] = "El Enclave de Plata",
	["The Singing Grove"] = "La Arboleda Tonada",
	["The Singing Pools"] = "Las Pozas Cantarinas",
	["The Sin'loren"] = "El Sin'loren",
	["The Skeletal Reef"] = "Arrecife de Huesos",
	["The Skittering Dark"] = "Penumbra de las Celerácnidas",
	["The Skull Warren"] = "El Laberinto de Calaveras",
	["The Skunkworks"] = "La Central Secreta",
	["The Skybreaker"] = "El Rompecielos",
	["The Skyfire"] = "El Abrasacielos",
	["The Skyreach Pillar"] = "El Pilar del Trecho Celestial",
	["The Slag Pit"] = "La Fosa de la Escoria",
	["The Slaughtered Lamb"] = "El Cordero Degollado",
	["The Slaughter House"] = "El Degolladero",
	["The Slave Pens"] = "Recinto de los Esclavos",
	["The Slave Pits"] = "Los Pozos de Esclavos",
	["The Slick"] = "El Escoplo",
	["The Slithering Scar"] = "La Cicatriz Serpenteante",
	["The Slough of Dispair"] = "La Ciénaga de la Desesperación",
	["The Sludge Fen"] = "El Fangal",
	["The Sludge Fields"] = "Los Campos de Lodo",
	["The Sludgewerks"] = "Los Fangados",
	["The Solarium"] = "El Solarium",
	["The Solar Vigil"] = "La Vigilia Solar",
	["The Southern Isles"] = "Las Islas del Sur",
	["The Southern Wall"] = "La Muralla del Sur",
	["The Sparkling Crawl"] = "La Gruta Cristalina",
	["The Spark of Imagination"] = "La Chispa de la Imaginación",
	["The Spawning Glen"] = "La Cañada Emergente",
	["The Spire"] = "La Aguja",
	["The Splintered Path"] = "La Vereda Solitaria",
	["The Spring Road"] = "La Senda Florida",
	["The Stadium"] = "El Estadium",
	["The Stagnant Oasis"] = "El Oasis Estancado",
	["The Staidridge"] = "Crestaserena",
	["The Stair of Destiny"] = "Los Peldaños del Destino",
	["The Stair of Doom"] = "La Escalera Maldita",
	["The Starchaser"] = "Trotamares",
	["The Star's Bazaar"] = "El Bazar de las Estrellas",
	["The Steam Pools"] = "Las Charcas Vaporosas",
	["The Steamvault"] = "La Cámara de Vapor",
	["The Steppe of Life"] = "Las Estepas de la Vida",
	["The Steps of Fate"] = "Los Pasos del Sino",
	["The Stinging Trail"] = "La Senda del Aguijón",
	["The Stockade"] = "Las Mazmorras",
	["The Stockpile"] = "Las Reservas",
	["The Stonecore"] = "El Núcleo Pétreo",
	["The Stonecore Entrance"] = "Entrada de El Núcleo Pétreo",
	["The Stonefield Farm"] = "La Granja Pedregosa",
	["The Stone Vault"] = "El Arca Pétrea",
	["The Storehouse"] = "Almacén",
	["The Stormbreaker"] = "El Rompetormentas",
	["The Stormbridge"] = "Puente de las Tormentas",
	["The Storm Foundry"] = "La Fundición de la Tormenta",
	["The Storm Peaks"] = "Las Cumbres Tormentosas",
	["The Stormspire"] = "La Flecha de la Tormenta",
	["The Stormwright's Shelf"] = "La Plataforma del Tormentoso",
	["The Summer Fields"] = "Los Campos Estivales",
	["The Summer Terrace"] = "El Bancal del Verano",
	["The Sundered Shard"] = "El Fragmento Hendido",
	["The Sundering"] = "El Cataclismo",
	["The Sun Forge"] = "La Forja del Sol",
	["The Sunken Ring"] = "El Anillo Sumergido",
	["The Sunset Brewgarden"] = "Jardín de la Cebada Crepuscular",
	["The Sunspire"] = "La Aguja del Sol",
	["The Suntouched Pillar"] = "El Pilar Toquesol",
	["The Sunwell"] = "La Fuente del Sol",
	["The Swarming Pillar"] = "El Pilar de la Ascensión",
	["The Swollen Vault"] = "La Cripta Solemne",
	["The Tainted Forest"] = "El Bosque Corrupto",
	["The Tainted Scar"] = "Escara Impía",
	["The Talondeep Path"] = "El Paso del Espolón",
	["The Talon Den"] = "El Cubil del Espolón",
	["The Tasting Room"] = "La Sala de Catas",
	["The Tempest Rift"] = "La Falla de la Tempestad",
	["The Temple Gardens"] = "Los Jardines del Templo",
	["The Temple of Atal'Hakkar"] = "El Templo de Atal'Hakkar",
	["The Temple of the Jade Serpent"] = "El Templo del Dragón de Jade",
	["The Terrestrial Watchtower"] = "La Atalaya Terrestre",
	["The Thornsnarl"] = "El Gruñospina",
	["The Threads of Fate"] = "Los Hilos del Destino",
	["The Threshold"] = "El Umbral",
	["The Throne of Flame"] = "El Trono de la Llama",
	["The Thunder Forge"] = "La Forja del Trueno",
	["The Thunder Forges"] = "Las Forjas del Trueno",
	["The Thundering Run"] = "El Paso del Trueno",
	["The Thundering Spire"] = "La Aguja del Trueno",
	["The Thunderspire"] = "La Aguja del Trueno",
	["The Thunderwood"] = "El Bosque del Trueno",
	["The Tidebreaker"] = "El Rompemareas",
	["The Tidus Stair"] = "El Escalón de la Marea",
	["The Tiger's Peak"] = "La Cima del Tigre",
	["The Torjari Pit"] = "La Fosa Torjari",
	["The Tower of Arathor"] = "Torre de Arathor",
	["The Toxic Airfield"] = "La Base Aérea Tóxica",
	["The Trail of Devastation"] = "La Senda de la Devastación",
	["The Tranquil Grove"] = "La Arboleda Tranquila",
	["The Transitus Stair"] = "La Escalera de Tránsito",
	["The Trapper's Enclave"] = "Enclave del Trampero",
	["The Tribunal of Ages"] = "El Tribunal de los Tiempos",
	["The Tundrid Hills"] = "Las Colinas Tundra",
	["The Twilight Breach"] = "La Brecha Crepuscular",
	["The Twilight Caverns"] = "Las Cavernas Crepusculares",
	["The Twilight Citadel"] = "La Ciudadela Crepuscular",
	["The Twilight Enclave"] = "El Enclave Crepuscular",
	["The Twilight Gate"] = "La Puerta Crepuscular",
	["The Twilight Gauntlet"] = "La Vereda Crepuscular",
	["The Twilight Ridge"] = "La Cresta del Crepúsculo",
	["The Twilight Rivulet"] = "El Riachuelo Crepuscular",
	["The Twilight Withering"] = "Quebranto Crepuscular",
	["The Twin Colossals"] = "Los Dos Colosos",
	["The Twisted Glade"] = "El Claro Retorcido",
	["The Twisted Warren"] = "La Gazapera Retuerta",
	["The Two Fisted Brew"] = "Cervecería Dos Puños",
	["The Unbound Thicket"] = "El Matorral Desatado",
	["The Underbelly"] = "Los Bajos Fondos",
	["The Underbog"] = "La Sotiénaga",
	["The Underbough"] = "Ramabaja",
	["The Undercroft"] = "La Subgranja",
	["The Underhalls"] = "Las Cámaras Subterráneas",
	["The Undershell"] = "La Concha Subterránea",
	["The Uplands"] = "Las Tierras Altas",
	["The Upside-down Sinners"] = "Los Pecadores Boca Abajo",
	["The Valley of Fallen Heroes"] = "El Valle de los Héroes Caídos",
	["The Valley of Lost Hope"] = "El Valle de la Esperanza Perdida",
	["The Vault of Lights"] = "El Arca de las Luces",
	["The Vector Coil"] = "La Espiral Vectorial",
	["The Veiled Cleft"] = "La Grieta Velada",
	["The Veiled Sea"] = "Mar de la Bruma",
	["The Veiled Stair"] = "La Escalera Velada",
	["The Venture Co. Mine"] = "Mina Ventura y Cía.",
	["The Verdant Fields"] = "Los Verdegales",
	["The Verdant Thicket"] = "El Matorral Verde",
	["The Verne"] = "El Verne",
	["The Verne - Bridge"] = "El Verne - Puente",
	["The Verne - Entryway"] = "El Verne - Entrada",
	["The Vibrant Glade"] = "El Claro Vibrante",
	["The Vice"] = "El Vicio",
	["The Vicious Vale"] = "El Valle Atroz",
	["The Viewing Room"] = "La Sala de la Visión",
	["The Vile Reef"] = "El Arrecife Mortal",
	["The Violet Citadel"] = "La Ciudadela Violeta",
	["The Violet Citadel Spire"] = "Aguja de La Ciudadela Violeta",
	["The Violet Gate"] = "La Puerta Violeta",
	["The Violet Hold"] = "El Bastión Violeta",
	["The Violet Spire"] = "La Espiral Violeta",
	["The Violet Tower"] = "Torre Violeta",
	["The Vortex Fields"] = "Los Campos del Vórtice",
	["The Vortex Pinnacle"] = "La Cumbre del Vórtice",
	["The Vortex Pinnacle Entrance"] = "Entrada de La Cumbre del Vórtice",
	["The Wailing Caverns"] = "Las Cuevas de los Lamentos",
	["The Wailing Ziggurat"] = "El Zigurat de los Lamentos",
	["The Waking Halls"] = "Las Salas del Despertar",
	["The Wandering Isle"] = "La Isla Errante",
	["The Warlord's Garrison"] = "Cuartel del Señor de la Guerra",
	["The Warlord's Terrace"] = "El Bancal de los Señores de la Guerra",
	["The Warp Fields"] = "Los Campos Alabeados",
	["The Warp Piston"] = "El Pistón de Distorsión",
	["The Wavecrest"] = "La Cresta de la Ola",
	["The Weathered Nook"] = "El Hueco Perdido",
	["The Weeping Cave"] = "La Cueva del Llanto",
	["The Western Earthshrine"] = "El Santuario de la Tierra Occidental",
	["The Westrift"] = "La Falla Oeste",
	["The Whelping Downs"] = "Las Colinas de los Vástagos",
	["The Whipple Estate"] = "El Raquitismo",
	["The Wicked Coil"] = "La Espiral Maldita",
	["The Wicked Grotto"] = "La Gruta Maldita",
	["The Wicked Tunnels"] = "Los Túneles Malditos",
	["The Widening Deep"] = "La Hondonada Creciente",
	["The Widow's Clutch"] = "La Guarida de la Viuda",
	["The Widow's Wail"] = "El Lamento de la Viuda",
	["The Wild Plains"] = "Las Llanuras Salvajes",
	["The Wild Shore"] = "La Orilla Salvaje",
	["The Winding Halls"] = "Las Salas Serpenteantes",
	["The Windrunner"] = "El Brisaveloz",
	["The Windspire"] = "La Espiral de Viento",
	["The Wollerton Stead"] = "La Finca de Wollerton",
	["The Wonderworks"] = "Obras Asombrosas",
	["The Wood of Staves"] = "El Bosque de Bastones",
	["The World Tree"] = "Árbol del Mundo",
	["The Writhing Deep"] = "Las Galerías Retorcidas",
	["The Writhing Haunt"] = "El Tormento",
	["The Yaungol Advance"] = "El Avance Yaungol",
	["The Yorgen Farmstead"] = "La Hacienda Yorgen",
	["The Zandalari Vanguard"] = "La Vanguardia Zandalari",
	["The Zoram Strand"] = "La Ensenada de Zoram",
	["Thieves Camp"] = "Campamento de Ladrones",
	["Thirsty Alley"] = "Callejón Sediento",
	["Thistlefur Hold"] = "Bastión Piel de Cardo",
	["Thistlefur Village"] = "Poblado Piel de Cardo",
	["Thistleshrub Valley"] = "Valle Cardizal",
	["Thondroril River"] = "Río Thondroril",
	["Thoradin's Wall"] = "Muralla de Thoradin",
	["Thorium Advance"] = "Avance del Torio",
	["Thorium Point"] = "Puesto del Torio",
	["Thor Modan"] = "Thor Modan",
	["Thornfang Hill"] = "Colina Colmillespinado",
	["Thorn Hill"] = "Colina Espinosa",
	["Thornmantle's Hideout"] = "La Guarida de Mantospina",
	["Thorson's Post"] = "Puesto de Thorson",
	["Thorvald's Camp"] = "Campamento de Thorvald",
	["Thousand Needles"] = "Las Mil Agujas",
	Thrallmar = "Thrallmar",
	["Thrallmar Mine"] = "Mina de Thrallmar",
	["Three Corners"] = "Tres Caminos",
	["Throne of Ancient Conquerors"] = "Trono de los Antiguos Conquistadores",
	["Throne of Kil'jaeden"] = "Trono de Kil'jaeden",
	["Throne of Neptulon"] = "Trono de Neptulon",
	["Throne of the Apocalypse"] = "Trono del Apocalipsis",
	["Throne of the Damned"] = "Trono de los Condenados",
	["Throne of the Elements"] = "El Trono de los Elementos",
	["Throne of the Four Winds"] = "Trono de los Cuatro Vientos",
	["Throne of the Tides"] = "Trono de las Mareas",
	["Throne of the Tides Entrance"] = "Entrada del Trono de las Mareas",
	["Throne of Thunder"] = "Solio del Trueno",
	["Throne of Tides"] = "Trono de las Mareas",
	["Thrym's End"] = "Fin de Thrym",
	["Thunder Axe Fortress"] = "Fortaleza del Hacha de Trueno",
	Thunderbluff = "Cima del Trueno",
	["Thunder Bluff"] = "Cima del Trueno",
	["Thunderbrew Distillery"] = "Destilería Cebatruenos",
	["Thunder Cleft"] = "Grieta del Trueno",
	Thunderfall = "Truenotoño",
	["Thunder Falls"] = "Cataratas del Trueno",
	["Thunderfoot Farm"] = "Villoría Pie Atronador",
	["Thunderfoot Fields"] = "Granjas Pie Atronador",
	["Thunderfoot Inn"] = "Posada Pie Atronador",
	["Thunderfoot Ranch"] = "Rancho Pie Atronador",
	["Thunder Hold"] = "Bastión del Trueno",
	["Thunderhorn Water Well"] = "Pozo Tronacuerno",
	["Thundering Overlook"] = "Mirador Atronador",
	["Thunder Island Alliance Hub"] = "Centro de la Alianza en la Isla del Trueno",
	["Thunder King Horde Hub"] = "Centro de la Horda en la Isla del Trueno",
	["Thunder King's Citadel"] = "Ciudadela del Rey del Trueno",
	["Thunderlord Stronghold"] = "Bastión Señor del Trueno",
	Thundermar = "Bramal",
	["Thundermar Ruins"] = "Ruinas de Bramal",
	["Thunderpaw Overlook"] = "Mirador Zarpa Atronadora",
	["Thunderpaw Refuge"] = "Refugio Zarpa Atronadora",
	["Thunder Peak"] = "Pico del Trueno",
	["Thunder Ridge"] = "Monte del Trueno",
	["Thunder's Call"] = "Llamada del Trueno",
	["Thunderstrike Mountain"] = "Monte del Rayo",
	["Thunk's Abode"] = "Morada de Thunk",
	["Thuron's Livery"] = "Caballería de Thuron",
	["Tian Monastery"] = "Monasterio Tian",
	["Tidefury Cove"] = "Cala Furiamarea",
	["Tides' Hollow"] = "Hoya de la Marea",
	["Tideview Thicket"] = "Matorral Olavista",
	["Tigers' Wood"] = "Bosque del Tigre",
	["Timbermaw Hold"] = "Bastión Fauces de Madera",
	["Timbermaw Post"] = "Puesto de los Fauces de Madera",
	["Tinkers' Court"] = "Cámara Manitas",
	["Tinker Town"] = "Ciudad Manitas",
	["Tiragarde Keep"] = "Fuerte de Tiragarde",
	["Tirisfal Glades"] = "Claros de Tirisfal",
	["Tirth's Haunt"] = "Refugio de Tirth",
	["Tkashi Ruins"] = "Ruinas de Tkashi",
	["Tol Barad"] = "Tol Barad",
	["Tol Barad Peninsula"] = "Península de Tol Barad",
	["Tol'Vir Arena"] = "Arena de Tol'Vir",
	["Tol'viron Arena"] = "Arena Tol'viron",
	["Tol'Viron Arena"] = "Arena Tol'viron",
	["Tomb of Conquerors"] = "Tumba de los Conquistadores",
	["Tomb of Lights"] = "Tumba de las Luces",
	["Tomb of Secrets"] = "Tumba de los Secretos",
	["Tomb of Shadows"] = "Tumba de las Sombras",
	["Tomb of the Ancients"] = "Tumba de los Ancestros",
	["Tomb of the Earthrager"] = "Tumba del Terracundo",
	["Tomb of the Lost Kings"] = "Tumba de los Reyes Perdidos",
	["Tomb of the Sun King"] = "Tumba del Rey del Sol",
	["Tomb of the Watchers"] = "Tumba de los Vigías",
	["Tombs of the Precursors"] = "Tumbas de los Precursores",
	["Tome of the Unrepentant"] = "Libro de los Impenitentes",
	["Tome of the Unrepentant "] = "Libro de los Impenitentes",
	["Tor'kren Farm"] = "Granja Tor'kren",
	["Torp's Farm"] = "Granja de Torp",
	["Torseg's Rest"] = "Reposo de Torseg",
	["Tor'Watha"] = "Tor'Watha",
	["Toryl Estate"] = "Los Dominios Toryl",
	["Toshley's Station"] = "Estación de Toshley",
	["To the Skies!"] = "¡Hacia los Cielos!",
	["To The Skies!"] = "¡Hacia los Cielos!",
	["Tower of Althalaxx"] = "Torre de Althalaxx",
	["Tower of Azora"] = "Torre de Azora",
	["Tower of Eldara"] = "Torre de Eldara",
	["Tower of Estulan"] = "Torre de Estulan",
	["Tower of Ilgalar"] = "Torre de Ilgalar",
	["Tower of the Damned"] = "Torre de los Condenados",
	["Tower Point"] = "Torre de la Punta",
	["Tower Watch"] = "Avanzada de la Torre",
	["Town-In-A-Box"] = "Ciudad de Bolsillo",
	["Townlong Steppes"] = "Estepas de Tong Long",
	["Town Square"] = "Plaza de la Ciudad",
	["Trade District"] = "Distrito de Mercaderes",
	["Trade Quarter"] = "Barrio del Comercio",
	["Trader's Tier"] = "La Grada de los Mercaderes",
	["Tradesmen's Terrace"] = "Bancal de los Mercaderes",
	["Train Depot"] = "Depósito de Trenes",
	["Training Grounds"] = "Campo de Entrenamiento",
	["Training Quarters"] = "Salas de Entrenamiento",
	["Traitor's Cove"] = "Cala del Traidor",
	["Tranquil Coast"] = "Costa Tranquila",
	["Tranquil Gardens Cemetery"] = "Cementerio del Jardín Sereno",
	["Tranquil Grotto"] = "Confín Sereno",
	Tranquillien = "Tranquillien",
	["Tranquil Shore"] = "Orilla Tranquila",
	["Tranquil Wash"] = "Estela Tranquila",
	Transborea = "Transborea",
	["Transitus Shield"] = "Escudo de Tránsito",
	["Transport: Alliance Gunship"] = "Transporte: Nave de Guerra de la Alianza",
	["Transport: Alliance Gunship (IGB)"] = "Transporte: Nave de Guerra de la Alianza",
	["Transport: Horde Gunship"] = "Transporte: Nave de Guerra de la Horda",
	["Transport: Horde Gunship (IGB)"] = "Transporte: Nave de Guerra de la Horda",
	["Transport: Onyxia/Nefarian Elevator"] = "Transporte - Ascensor Onyxia/Nefarian",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Transporte: El Viento Poderoso (Banda de Ciudadela de la Corona de Hielo)",
	["Trelleum Mine"] = "Mina Trelleum",
	["Trial of Fire"] = "Prueba del Fuego",
	["Trial of Frost"] = "Prueba de Escarcha",
	["Trial of Shadow"] = "Prueba de las Sombras",
	["Trial of the Champion"] = "Prueba del Campeón",
	["Trial of the Champion Entrance"] = "Entrada de la Prueba del Campeón",
	["Trial of the Crusader"] = "Prueba del Cruzado",
	["Trickling Passage"] = "Paso Resbaladizo",
	["Trogma's Claim"] = "La Llamada de Trogma",
	["Trollbane Hall"] = "Bastión de Aterratrols",
	["Troll War Camp Outskirts"] = "Afueras del Campamento de Guerra Trol",
	["Trophy Hall"] = "Cámara de los Trofeos",
	["Troves of the Thunder King"] = "Los Tesoros del Rey del Trueno",
	["Trueshot Point"] = "Punta Alblanco",
	["Tuluman's Landing"] = "Alto de Tuluman",
	["Turtle Beach"] = "Playa de la Tortuga",
	["Tu Shen Burial Ground"] = "Cementerio Tu Shen",
	Tuurem = "Tuurem",
	["Twilight Aerie"] = "Nidal Crepuscular",
	["Twilight Altar of Storms"] = "Altar de la Tempestad Crepuscular",
	["Twilight Base Camp"] = "Campamento Crepúsculo",
	["Twilight Bulwark"] = "Baluarte Crepuscular",
	["Twilight Camp"] = "Campamento Crepuscular",
	["Twilight Command Post"] = "Puesto de Mando Crepuscular",
	["Twilight Crossing"] = "Cruce Crepuscular",
	["Twilight Forge"] = "Forja Crepuscular",
	["Twilight Grove"] = "Arboleda del Crepúsculo",
	["Twilight Highlands"] = "Tierras Altas Crepusculares",
	["Twilight Highlands Dragonmaw Phase"] = "Tierras Altas Crepusculares: Fase de Faucedraco",
	["Twilight Highlands Phased Entrance"] = "Entrada de Tierras Altas Crepusculares en fase",
	["Twilight Highlands Zeppelin 1"] = "Zepelín 1 de Tierras Altas Crepusculares en fase",
	["Twilight Highlands Zeppelin 2"] = "Zepelín 2 de Tierras Altas Crepusculares en fase",
	["Twilight Outpost"] = "Avanzada Crepúsculo",
	["Twilight Overlook"] = "Mirador Crepuscular",
	["Twilight Post"] = "Puesto Crepúsculo",
	["Twilight Precipice"] = "Precipicio Crepuscular",
	["Twilight Shore"] = "Orilla Crepuscular",
	["Twilight's Run"] = "Paseo Crepúsculo",
	["Twilight Terrace"] = "Bancal Crepuscular",
	["Twilight Vale"] = "Vega Crepuscular",
	["Twinbraid's Patrol"] = "Patrulla de Trenzado",
	["Twin Peaks"] = "Cumbres Gemelas",
	["Twin Shores"] = "Las Playas Gemelas",
	["Twinspire Keep"] = "Fortaleza de las Agujas Gemelas",
	["Twinspire Keep Interior"] = "Interior de la Fortaleza de las Agujas Gemelas",
	["Twin Spire Ruins"] = "Ruinas de las Agujas Gemelas",
	["Twisting Nether"] = "El Vacío Abisal",
	["Tyr's Hand"] = "Mano de Tyr",
	["Tyr's Hand Abbey"] = "Abadía de la Mano de Tyr",
	["Tyr's Terrace"] = "Bancal de Tyr",
	["Ufrang's Hall"] = "Sala de Ufrang",
	Uldaman = "Uldaman",
	["Uldaman Entrance"] = "Entrada de Uldaman",
	Uldis = "Uldis",
	Ulduar = "Ulduar",
	["Ulduar Raid - Interior - Insertion Point"] = "Banda Ulduar: Interior: Punto de Entrada",
	["Ulduar Raid - Iron Concourse"] = "Banda Ulduar: Explanada de Hierro",
	Uldum = "Uldum",
	["Uldum Phased Entrance"] = "Entrada de Uldum en fase",
	["Uldum Phase Oasis"] = "Oasis de fase de Uldum",
	["Uldum - Phase Wrecked Camp"] = "Uldum: fase del campamento arrasado",
	["Umbrafen Lake"] = "Lago Umbropantano",
	["Umbrafen Village"] = "Aldea Umbropantano",
	["Uncharted Sea"] = "Mar Inexplorado",
	Undercity = "Entrañas",
	["Underlight Canyon"] = "Cañón Sondaluz",
	["Underlight Mines"] = "Minas Sondaluz",
	["Unearthed Grounds"] = "Campos Desenterrados",
	["Unga Ingoo"] = "Unga Ingoo",
	["Un'Goro Crater"] = "Cráter de Un'Goro",
	["Unu'pe"] = "Unu'pe",
	["Unyielding Garrison"] = "Cuartel Implacable",
	["Upper Silvermarsh"] = "Marjal Argenta Superior",
	["Upper Sumprushes"] = "El Sumidero Superior",
	["Upper Veil Shil'ak"] = "Velo Shil'ak Alto",
	["Ursoc's Den"] = "El Cubil de Ursoc",
	Ursolan = "Ursolan",
	["Utgarde Catacombs"] = "Catacumbas de Utgarde",
	["Utgarde Keep"] = "Fortaleza de Utgarde",
	["Utgarde Keep Entrance"] = "Entrada de la Fortaleza de Utgarde",
	["Utgarde Pinnacle"] = "Pináculo de Utgarde",
	["Utgarde Pinnacle Entrance"] = "Entrada del Pináculo de Utgarde",
	["Uther's Tomb"] = "Tumba de Uther",
	["Valaar's Berth"] = "Atracadero de Valaar",
	["Vale of Eternal Blossoms"] = "Valle de la Flor Eterna",
	["Valgan's Field"] = "Campo de Valgan",
	Valgarde = "Valgarde",
	["Valgarde Port"] = "Puerto de Valgarde",
	Valhalas = "Valhalas",
	["Valiance Keep"] = "Fortaleza Denuedo",
	["Valiance Landing Camp"] = "Campo de Aterrizaje de Denuedo",
	["Valiant Rest"] = "Reposo Audaz",
	Valkyrion = "Valkyrion",
	["Valley of Ancient Winters"] = "Valle de los Viejos Inviernos",
	["Valley of Ashes"] = "Valle de las Cenizas",
	["Valley of Bones"] = "Valle de los Huesos",
	["Valley of Echoes"] = "Valle de los Ecos",
	["Valley of Emperors"] = "Valle de los Emperadores",
	["Valley of Fangs"] = "Valle de los Colmillos",
	["Valley of Heroes"] = "Valle de los Héroes",
	["Valley Of Heroes"] = "Valle de los Héroes",
	["Valley of Honor"] = "Valle del Honor",
	["Valley of Kings"] = "Valle de los Reyes",
	["Valley of Power"] = "Valle del Poder",
	["Valley Of Power - Scenario"] = "Gesta: Valle del Poder",
	["Valley of Spears"] = "Valle de las Lanzas",
	["Valley of Spirits"] = "Valle de los Espíritus",
	["Valley of Strength"] = "Valle de la Fuerza",
	["Valley of the Bloodfuries"] = "Valle Furia Sangrienta",
	["Valley of the Four Winds"] = "Valle de los Cuatro Vientos",
	["Valley of the Watchers"] = "Valle de los Vigías",
	["Valley of Trials"] = "Valle de los Retos",
	["Valley of Wisdom"] = "Valle de la Sabiduría",
	Valormok = "Valormok",
	["Valor's Edge"] = "Frontera del Valor",
	["Valor's Rest"] = "Sosiego del Valor",
	["Valorwind Lake"] = "Lago Ventobravo",
	["Vanguard Infirmary"] = "Enfermería de la Vanguardia",
	["Vanndir Encampment"] = "Campamento Vanndir",
	["Vargoth's Retreat"] = "Reposo de Vargoth",
	["Vashj'elan Spawning Pool"] = "Poza Emergente Vashj'elan",
	["Vashj'ir"] = "Vashj'ir",
	["Vashj'ir Sub - Alliance"] = "Submarino de Vashj'ir: Alianza",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Submarino de Vashj'ir: Alianza circulando por Fauce Abisal",
	["Vashj'ir Sub - Horde"] = "Submarino de Vashj'ir: Horda",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Submarino de Vashj'ir: Horda - Circulando por Fauce Abisal",
	["Vault of Archavon"] = "La Cámara de Archavon",
	["Vault of Ironforge"] = "Las Arcas de Forjaz",
	["Vault of Kings Past"] = "Cámara de los Reyes Inmemoriales",
	["Vault of the Ravenian"] = "Cámara del Devorador",
	["Vault of the Shadowflame"] = "Bóveda de la Llama de las Sombras",
	["Vault of Y'Shaarj"] = "Cámara de Y'Shaarj",
	["Veil Ala'rak"] = "Velo Ala'rak",
	["Veil Harr'ik"] = "Velo Harr'ik",
	["Veil Lashh"] = "Velo Lashh",
	["Veil Lithic"] = "Velo Lítico",
	["Veil Reskk"] = "Velo Reskk",
	["Veil Rhaze"] = "Velo Rhaze",
	["Veil Ruuan"] = "Velo Ruuan",
	["Veil Sethekk"] = "Velo Sethekk",
	["Veil Shalas"] = "Velo Shalas",
	["Veil Shienor"] = "Velo Shienor",
	["Veil Skith"] = "Velo Skith",
	["Veil Vekh"] = "Velo Vekh",
	["Vekhaar Stand"] = "Alto Vekhaar",
	["Velaani's Arcane Goods"] = "Artículos arcanos de Velaani",
	["Vendetta Point"] = "Punta Vendetta",
	["Vengeance Landing"] = "Campo Venganza",
	["Vengeance Landing Inn"] = "Taberna de Campo Venganza",
	["Vengeance Landing Inn, Howling Fjord"] = "Taberna de Campo Venganza, Fiordo Aquilonal",
	["Vengeance Lift"] = "Elevador de Venganza",
	["Vengeance Pass"] = "Paso Venganza",
	["Vengeance Wake"] = "Rastro Venganza",
	["Venomous Ledge"] = "Saliente Venenoso",
	Venomspite = "Rencor Venenoso",
	["Venomsting Pits"] = "Fosas Picaveneno",
	["Venomweb Vale"] = "Vega Venerácnidas",
	["Venture Bay"] = "Bahía Ventura",
	["Venture Co. Base Camp"] = "Base de Ventura y Cía.",
	["Venture Co. Operations Center"] = "Centro de Operaciones de Ventura y Cía.",
	["Verdant Belt"] = "Franja Verdeante",
	["Verdant Highlands"] = "Tierras Altas Verdes",
	["Verdantis River"] = "Río Verdantis",
	["Veridian Point"] = "Punta Veridiana",
	["Verlok Stand"] = "Alto Verlok",
	["Vermillion Redoubt"] = "Reducto Bermellón",
	["Verming Tunnels Micro"] = "Microtúneles Mur",
	["Verrall Delta"] = "Delta del Verrall",
	["Verrall River"] = "Río Verrall",
	["Victor's Point"] = "Paso del Invicto",
	["Vileprey Village"] = "Poblado Presavil",
	["Vim'gol's Circle"] = "Anillo de Vim'gol",
	["Vindicator's Rest"] = "El Reposo del Vindicador",
	["Violet Citadel Balcony"] = "Balcón de la Ciudadela Violeta",
	["Violet Hold"] = "Bastión Violeta",
	["Violet Hold Entrance"] = "Entrada de El Bastión Violeta",
	["Violet Rise"] = "El Alto Violeta",
	["Violet Stand"] = "El Confín Violeta",
	["Virmen Grotto"] = "Gruta Mur",
	["Virmen Nest"] = "Nido Mur",
	["Vir'naal Dam"] = "Presa Vir'naal",
	["Vir'naal Lake"] = "Lago Vir'naal",
	["Vir'naal Oasis"] = "Oasis Vir'naal",
	["Vir'naal River"] = "Río Vir'naal",
	["Vir'naal River Delta"] = "Delta Vir'naal",
	["Void Ridge"] = "Cresta del Vacío",
	["Voidwind Plateau"] = "Meseta del Viento del Vacío",
	["Volcanoth's Lair"] = "Guarida de Volcanoth",
	["Voldrin's Hold"] = "Bastión de Voldrin",
	Voldrune = "Runavold",
	["Voldrune Dwelling"] = "Morada Runavold",
	Voltarus = "Voltarus",
	["Vordrassil Pass"] = "Paso de Vordrassil",
	["Vordrassil's Heart"] = "Corazón de Vordrassil",
	["Vordrassil's Limb"] = "Extremidad de Vordrassil",
	["Vordrassil's Tears"] = "Lágrimas de Vordrassil",
	["Vortex Pinnacle"] = "Cumbre del Vórtice",
	["Vortex Summit"] = "Cumbre del Vórtice",
	["Vul'Gol Ogre Mound"] = "Túmulo de Vul'Gol",
	["Vyletongue Seat"] = "Trono de Lenguavil",
	["Wahl Cottage"] = "Cabaña de Wahl",
	["Wailing Caverns"] = "Cuevas de los Lamentos",
	["Walk of Elders"] = "Camino de los Ancestros",
	["Warbringer's Ring"] = "Liza del Belisario",
	["Warchief's Lookout"] = "Atalaya del Jefe de Guerra",
	["Warden's Cage"] = "Jaula de la Guardiana",
	["Warden's Chambers"] = "Aposentos del Celador",
	["Warden's Vigil"] = "Vigilia del Celador",
	["Warlock Area"] = "Zona de brujos",
	["Warmaul Hill"] = "Colina Mazo de Guerra",
	["Warpwood Quarter"] = "Barrio Alabeo",
	["War Quarter"] = "Barrio de la Guerra",
	["Warrior's Terrace"] = "Bancal del Guerrero",
	["War Room"] = "Sala de Mandos",
	Warship = "Buque de Guerra",
	["Warsong Camp"] = "Campamento Grito de Guerra",
	["Warsong Farms Outpost"] = "Avanzada de las Granjas Grito de Guerra",
	["Warsong Flag Room"] = "Sala de la Bandera Grito de Guerra",
	["Warsong Granary"] = "Granero Grito de Guerra",
	["Warsong Gulch"] = "Garganta Grito de Guerra",
	["Warsong Hold"] = "Bastión Grito de Guerra",
	["Warsong Jetty"] = "Malecón Grito de Guerra",
	["Warsong Labor Camp"] = "Campo de trabajos forzados Grito de Guerra",
	["Warsong Lumber Camp"] = "Aserradero Grito de Guerra",
	["Warsong Lumber Mill"] = "Serrería Grito de Guerra",
	["Warsong Slaughterhouse"] = "Matadero Grito de Guerra",
	["Watcher's Sanctum"] = "Sagrario del Vigía",
	["Watchers' Terrace"] = "Bancal de los Oteadores",
	["Waterspeaker's Sanctuary"] = "Santuario del Orador del Agua",
	["Waterspring Field"] = "Campo del Manantial",
	Waterworks = "Estación de Bombeo",
	["Wavestrider Beach"] = "Playa Baile de las Olas",
	Waxwood = "Bosque de Cera",
	["Wayfarer's Rest"] = "El Descanso del Caminante",
	Waygate = "Puerta",
	["Wayne's Refuge"] = "Refugio de Wayne",
	["Weazel's Crater"] = "Cráter de la Comadreja",
	["Webwinder Hollow"] = "Cuenca de las Tejedoras",
	["Webwinder Path"] = "Senda de las Tejedoras",
	["Weeping Quarry"] = "Cantera Llorosa",
	["Well of Eternity"] = "Pozo de la Eternidad",
	["Well of the Forgotten"] = "Pozo de los Olvidados",
	["Wellson Shipyard"] = "Astillero de Wellson",
	["Wellspring Hovel"] = "Cobertizo Primigenio",
	["Wellspring Lake"] = "Lago Primigenio",
	["Wellspring River"] = "Río Primigenio",
	["Westbrook Garrison"] = "Cuartel de Arroyoeste",
	["Western Bridge"] = "Puente Occidental",
	["Western Plaguelands"] = "Tierras de la Peste del Oeste",
	["Western Strand"] = "Playa del Oeste",
	Westersea = "Maroeste",
	Westfall = "Páramos de Poniente",
	["Westfall Brigade"] = "Brigada de los Páramos de Poniente",
	["Westfall Brigade Encampment"] = "Campamento de la Brigada de los Páramos de Poniente",
	["Westfall Lighthouse"] = "Faro de Poniente",
	["West Garrison"] = "Cuartel del Oeste",
	["Westguard Inn"] = "Taberna de la Guardia Oeste",
	["Westguard Keep"] = "Fortaleza de la Guardia Oeste",
	["Westguard Turret"] = "Torreta de la Guardia Oeste",
	["West Pavilion"] = "Pabellón oeste",
	["West Pillar"] = "Pilar Oeste",
	["West Point Station"] = "Estación de la Punta Oeste",
	["West Point Tower"] = "Torre de la Punta Oeste",
	["Westreach Summit"] = "Cima Tramo Oeste",
	["West Sanctum"] = "Sagrario del Oeste",
	["Westspark Workshop"] = "Taller Chispa Occidental",
	["West Spear Tower"] = "Torre Lanza del Oeste",
	["West Spire"] = "Fortín del Oeste",
	["Westwind Lift"] = "Elevador de Viento Oeste",
	["Westwind Refugee Camp"] = "Campo de Refugiados de Viento Oeste",
	["Westwind Rest"] = "Reposo Viento del Oeste",
	Wetlands = "Los Humedales",
	Wheelhouse = "Timonera",
	["Whelgar's Excavation Site"] = "Excavación de Whelgar",
	["Whelgar's Retreat"] = "Retiro de Whelgar",
	["Whispercloud Rise"] = "Alto de la Nube Susurrante",
	["Whisper Gulch"] = "Garganta Susurro",
	["Whispering Forest"] = "Bosque Susurrante",
	["Whispering Gardens"] = "Jardines de los Susurros",
	["Whispering Inlet"] = "Ensenada de los Susurros",
	["Whispering Shore"] = "Costa Murmurante",
	["Whispering Stones"] = "Rocas Susurrantes",
	["Whisperwind Grove"] = "Arboleda Susurravientos",
	["Whistling Grove"] = "Arboleda Sibilante",
	["Whitebeard's Encampment"] = "Campamento de Barbablanca",
	["Whitepetal Lake"] = "Lago Pétalo Níveo",
	["White Pine Trading Post"] = "Puesto de Venta de Pino Blanco",
	["Whitereach Post"] = "Campamento del Tramo Blanco",
	["Wildbend River"] = "Río Culebra",
	["Wildervar Mine"] = "Mina de Vildervar",
	["Wildflame Point"] = "Alto Punta Salvaje",
	["Wildgrowth Mangal"] = "Manglar Silvestre",
	["Wildhammer Flag Room"] = "Sala de la Bandera Martillo Salvaje",
	["Wildhammer Keep"] = "Fortaleza de los Martillo Salvaje",
	["Wildhammer Stronghold"] = "Bastión Martillo Salvaje",
	["Wildheart Point"] = "Alto de Corazón Salvaje",
	["Wildmane Water Well"] = "Pozo Ferocrín",
	["Wild Overlook"] = "Mirador Salvaje",
	["Wildpaw Cavern"] = "Caverna Zarpa Salvaje",
	["Wildpaw Ridge"] = "Risco Zarpa Salvaje",
	["Wilds' Edge Inn"] = "Posada Confín Salvaje",
	["Wild Shore"] = "Orilla Salvaje",
	["Wildvine Marsh"] = "Marjal de Atriplex",
	["Wildwind Lake"] = "Lago Ventosalvaje",
	["Wildwind Path"] = "Senda Ventosalvaje",
	["Wildwind Peak"] = "Cima Ventosalvaje",
	["Windbreak Canyon"] = "Cañón Rompevientos",
	["Windfury Ridge"] = "Cresta Viento Furioso",
	["Windrunner's Overlook"] = "Mirador Brisaveloz",
	["Windrunner Spire"] = "Aguja Brisaveloz",
	["Windrunner Village"] = "Aldea Brisaveloz",
	["Winds' Edge"] = "Acantilado del Céfiro",
	["Windshear Crag"] = "Risco Cortaviento",
	["Windshear Heights"] = "Altos Cortaviento",
	["Windshear Hold"] = "Bastión Cortaviento",
	["Windshear Mine"] = "Mina Cortaviento",
	["Windshear Valley"] = "Valle Cortaviento",
	["Windspire Bridge"] = "Puente Lanzaviento",
	["Windward Isle"] = "Isla de Barlovento",
	["Windy Bluffs"] = "Riscos Ventosos",
	["Windyreed Pass"] = "Paso Junco Alabeado",
	["Windyreed Village"] = "Aldea Junco Alabeado",
	["Winterax Hold"] = "Fuerte Hacha Invernal",
	["Winterbough Glade"] = "Claro Brote Invernal",
	["Winterfall Village"] = "Poblado Nevada",
	["Winterfin Caverns"] = "Cavernas Aleta Invernal",
	["Winterfin Retreat"] = "Refugio Aleta Invernal",
	["Winterfin Village"] = "Poblado Aleta Invernal",
	["Wintergarde Crypt"] = "Cripta de Hibergarde",
	["Wintergarde Keep"] = "Fortaleza de Hibergarde",
	["Wintergarde Mausoleum"] = "Mausoleo de Hibergarde",
	["Wintergarde Mine"] = "Mina de Hibergarde",
	Wintergrasp = "Conquista del Invierno",
	["Wintergrasp Fortress"] = "Fortaleza de Conquista del Invierno",
	["Wintergrasp River"] = "Río Conquista del Invierno",
	["Winterhoof Water Well"] = "Pozo Pezuña Invernal",
	["Winter's Blossom"] = "Pétalo Glacial",
	["Winter's Breath Lake"] = "Lago Aliento Invernal",
	["Winter's Edge Tower"] = "Torre Filoinvierno",
	["Winter's Heart"] = "Corazón del Invierno",
	Winterspring = "Cuna del Invierno",
	["Winter's Terrace"] = "Bancal del Invierno",
	["Witch Hill"] = "Colina de las Brujas",
	["Witch's Sanctum"] = "Sagrario de la Bruja",
	["Witherbark Caverns"] = "Cuevas Secacorteza",
	["Witherbark Village"] = "Poblado Secacorteza",
	["Withering Thicket"] = "Matorral Abrasador",
	["Wizard Row"] = "Pasaje del Zahorí",
	["Wizard's Sanctum"] = "Sagrario del Mago",
	["Wolf's Run"] = "Senda del Lobo",
	["Woodpaw Den"] = "Guarida de los Zarpaleña",
	["Woodpaw Hills"] = "Colinas Zarpaleña",
	["Wood's End Cabin"] = "Cabaña de la Espesura",
	["Woods of the Lost"] = "Bosque de los Olvidados",
	Workshop = "Taller",
	["Workshop Entrance"] = "Entrada del Taller",
	["World's End Tavern"] = "Taberna del Fin del Mundo",
	["Wrathscale Lair"] = "Guarida Escama de Cólera",
	["Wrathscale Point"] = "Punto Escama de Cólera",
	["Wreckage of the Silver Dawning"] = "Restos del Amanecer de Plata",
	["Wreck of Hellscream's Fist"] = "Restos del Puño de Grito Infernal",
	["Wreck of the Mist-Hopper"] = "Restos de El Saltanieblas",
	["Wreck of the Skyseeker"] = "Restos de El Buscacielos",
	["Wreck of the Vanguard"] = "Restos de La Vanguardia",
	["Writhing Mound"] = "Alcor Tortuoso",
	Writhingwood = "Bosquetormento",
	["Wu-Song Village"] = "Aldea Wu-Song",
	Wyrmbog = "Ciénaga de Fuego",
	["Wyrmbreaker's Rookery"] = "Grajero de Rompevermis",
	["Wyrmrest Summit"] = "Cima del Reposo del Dragón",
	["Wyrmrest Temple"] = "Templo del Reposo del Dragón",
	["Wyrmrest Temple - bottom to middle"] = "Templo del Reposo del Dragón - de abajo a la mitad",
	["Wyrmrest Temple - bottom to top"] = "Templo del Reposo del Dragón - de abajo a arriba",
	["Wyrmrest Temple - middle to bottom"] = "Templo del Reposo del Dragón – de la mitad abajo",
	["Wyrmrest Temple - middle to top"] = "Templo del Reposo del Dragón – de la mitad a arriba",
	["Wyrmrest Temple - top to bottom"] = "Templo del Reposo del Dragón - de arriba a abajo",
	["Wyrmrest Temple - top to middle"] = "Templo del Reposo del Dragón - de arriba a la mitad",
	["Wyrms' Bend"] = "Recodo de Vermis",
	["Wyrmscar Island"] = "Isla Cicatriz de Vermis",
	["Wyrmskull Bridge"] = "Puente Calavermis",
	["Wyrmskull Tunnel"] = "Túnel Calavermis",
	["Wyrmskull Village"] = "Poblado Calavermis",
	["X-2 Pincer"] = "Tenazario X2",
	Xavian = "Xavian",
	["Yan-Zhe River"] = "Río Yan-Zhe",
	["Yeti Mountain Basecamp"] = "Campamento de Montaña Yeti",
	["Yinying Village"] = "Aldea Yinying",
	Ymirheim = "Ymirheim",
	["Ymiron's Seat"] = "Trono de Ymiron",
	["Yojamba Isle"] = "Isla Yojamba",
	["Yowler's Den"] = "Cubil de Ululante",
	["Zabra'jin"] = "Zabra'jin",
	["Zaetar's Choice"] = "Elección de Zaetar",
	["Zaetar's Grave"] = "Tumba de Zaetar",
	["Zalashji's Den"] = "Guarida de Zalashji",
	["Zalazane's Fall"] = "Caída de Zalazane",
	["Zane's Eye Crater"] = "Cráter del Ojo de Zane",
	Zangarmarsh = "Marisma de Zangar",
	["Zangar Ridge"] = "Loma de Zangar",
	["Zan'vess"] = "Zan'vess",
	["Za'Tual"] = "Za'Tual",
	["Zeb'Halak"] = "Zeb'Halak",
	["Zeb'Nowa"] = "Zeb'Nowa",
	["Zeb'Sora"] = "Zeb'Sora",
	["Zeb'Tela"] = "Zeb'Tela",
	["Zeb'tula"] = "Zeb'tula",
	["Zeb'Watha"] = "Zeb'Watha",
	["Zeppelin Crash"] = "Zepelín Caído",
	Zeramas = "Zeramas",
	["Zeth'Gor"] = "Zeth'Gor",
	["Zhu Province"] = "Provincia Zhu",
	["Zhu's Descent"] = "Descenso de Zhu",
	["Zhu's Watch"] = "Atalaya de Zhu",
	["Ziata'jai Ruins"] = "Ruinas de Ziata'jai",
	["Zim'Abwa"] = "Zim'Abwa",
	["Zim'bo's Hideout"] = "Guarida de Zim'bo",
	["Zim'Rhuk"] = "Zim'Rhuk",
	["Zim'Torga"] = "Zim'Torga",
	["Zol'Heb"] = "Zol'Heb",
	["Zol'Maz Stronghold"] = "Bastión de Zol'Maz",
	["Zoram'gar Outpost"] = "Avanzada de Zoram'gar",
	["Zouchin Province"] = "Provincia Zouchin",
	["Zouchin Strand"] = "Playa Zouchin",
	["Zouchin Village"] = "Aldea Zouchin",
	["Zul'Aman"] = "Zul'Aman",
	["Zul'Drak"] = "Zul'Drak",
	["Zul'Farrak"] = "Zul'Farrak",
	["Zul'Farrak Entrance"] = "Entrada de Zul'Farrak",
	["Zul'Gurub"] = "Zul'Gurub",
	["Zul'Mashar"] = "Zul'Mashar",
	["Zun'watha"] = "Zun'watha",
	["Zuuldaia Ruins"] = "Ruinas Zuuldaia",
}

elseif GAME_LOCALE == "frFR" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "Campement de la 7e Légion",
	["7th Legion Front"] = "Front de la 7e Légion",
	["7th Legion Submarine"] = "Sous-marin de la 7e Légion",
	["Abandoned Armory"] = "Armurerie Abandonnée",
	["Abandoned Camp"] = "Camp Abandonné",
	["Abandoned Mine"] = "Mine Abandonnée",
	["Abandoned Reef"] = "Récif Abandonné",
	["Above the Frozen Sea"] = "Survol de la mer Gelée",
	["A Brewing Storm"] = "Une bière foudroyante",
	["Abyssal Breach"] = "Brèche Abyssale",
	["Abyssal Depths"] = "Profondeurs Abyssales",
	["Abyssal Halls"] = "Salles Abyssales",
	["Abyssal Maw"] = "Gueule des abysses",
	["Abyssal Maw Exterior"] = "Extérieur de la Gueule des abysses",
	["Abyssal Sands"] = "Désert Abysséen",
	["Abyssion's Lair"] = "Repaire d’Abyssion",
	["Access Shaft Zeon"] = "Puits d’accès Zéon",
	["Acherus: The Ebon Hold"] = "Achérus : le fort d’Ébène",
	["Addle's Stead"] = "Ferme des Addle",
	["Aderic's Repose"] = "Repos d’Aderic",
	["Aerie Peak"] = "Nid-de-l’Aigle",
	["Aeris Landing"] = "Point d’ancrage Aeris",
	["Agamand Family Crypt"] = "Crypte de la famille Agamand",
	["Agamand Mills"] = "Moulins d’Agamand",
	["Agmar's Hammer"] = "Marteau d’Agmar",
	["Agmond's End"] = "Fin d’Agmond",
	["Agol'watha"] = "Agol’watha",
	["A Hero's Welcome"] = "L'échoppe des héros",
	["Ahn'kahet: The Old Kingdom"] = "Ahn’kahet : l’Ancien royaume",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Entrée d’Ahn’kahet : l’Ancien royaume",
	["Ahn Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj"] = "Ahn’Qiraj",
	["Ahn'Qiraj Temple"] = "Temple d’Ahn’Qiraj",
	["Ahn'Qiraj Terrace"] = "Terrasse d’Ahn’Qiraj",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ahn’Qiraj : le royaume Déchu",
	["Akhenet Fields"] = "Champs d’Akhenet",
	["Aku'mai's Lair"] = "Repaire d'Aku'mai",
	["Alabaster Shelf"] = "Corniche d’Albâtre",
	["Alcaz Island"] = "Île d’Alcaz",
	["Aldor Rise"] = "Éminence de l’Aldor",
	Aldrassil = "Aldrassil",
	["Aldur'thar: The Desolation Gate"] = "Aldur’thar : la Porte de la Désolation",
	["Alexston Farmstead"] = "Ferme des Alexston",
	["Algaz Gate"] = "Porte d’Algaz",
	["Algaz Station"] = "Poste d’Algaz",
	["A Little Patience"] = "Un peu de patience",
	["Allen Farmstead"] = "Ferme des Allen",
	["Allerian Post"] = "Poste Allérien",
	["Allerian Stronghold"] = "Bastion Allérien",
	["Alliance Base"] = "Base de l’Alliance",
	["Alliance Beach Daily Area"] = "Plage de l’Alliance - Zone de quêtes journalières",
	["Alliance Beachhead"] = "Tête de pont de l’Alliance",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Phase alliance - Scénario de progression de l’île mogu",
	["Alliance Keep"] = "Donjon de l’Alliance",
	["Alliance Mercenary Ship to Vashj'ir"] = "Navire mercenaire de l’Alliance vers Vashj’ir",
	["Alliance PVP Barracks"] = "Baraquements Alliance JcJ",
	["All That Glitters Prospecting Co."] = "Prospection tout ce qui brille",
	["Alonsus Chapel"] = "Chapelle d'Alonsus",
	["Altar of Ascension"] = "Autel de l’Ascension",
	["Altar of Har'koa"] = "Autel de Har’koa",
	["Altar of Mam'toth"] = "Autel de Mam’toth",
	["Altar of Quetz'lun"] = "Autel de Quetz’lun",
	["Altar of Rhunok"] = "Autel de Rhunok",
	["Altar of Sha'tar"] = "Autel de Sha’tar",
	["Altar of Sseratus"] = "Autel de Sseratus",
	["Altar of Storms"] = "Autel des Tempêtes",
	["Altar of the Blood God"] = "Autel du Dieu sanglant",
	["Altar of Twilight"] = "Autel du Crépuscule",
	["Alterac Mountains"] = "Montagnes d’Alterac",
	["Alterac Valley"] = "Vallée d’Alterac",
	["Alther's Mill"] = "Scierie d’Alther",
	["Amani Catacombs"] = "Catacombes des Amani",
	["Amani Mountains"] = "Montagnes des Amani",
	["Amani Pass"] = "Passage des Amani",
	["Amberfly Bog"] = "Tourbières d’Ambraile",
	["Amberglow Hollow"] = "Creux de Luisambre",
	["Amber Ledge"] = "Escarpement d’Ambre",
	Ambermarsh = "Marais d’Ambre",
	Ambermill = "Moulin-de-l’Ambre",
	["Amberpine Lodge"] = "Gîte Ambrepin",
	["Amber Quarry"] = "Carrière d’ambre",
	["Amber Research Sanctum"] = "Sanctum de Recherche ambre",
	["Ambershard Cavern"] = "Caverne d'Ambréclat",
	["Amberstill Ranch"] = "Ferme des Distillambre",
	["Amberweb Pass"] = "Passe d’Ambretoile",
	["Ameth'Aran"] = "Ameth’Aran",
	["Ammen Fields"] = "Champs d’Ammen",
	["Ammen Ford"] = "Gué d’Ammen",
	["Ammen Vale"] = "Val d’Ammen",
	["Amphitheater of Anguish"] = "Amphithéâtre de l’Angoisse",
	["Ampitheater of Anguish"] = "Amphithéâtre de l'Angoisse",
	["Ancestral Grounds"] = "Terres Ancestrales",
	["Ancestral Rise"] = "Cime Ancestrale",
	["Ancient Courtyard"] = "Cour Antique",
	["Ancient Zul'Gurub"] = "L’antique Zul'Gurub",
	["An'daroth"] = "An’daroth",
	["Andilien Estate"] = "Domaine d’Andilien",
	Andorhal = "Andorhal",
	Andruk = "Andruk",
	["Angerfang Encampment"] = "Campement de Hargnecroc",
	["Angkhal Pavilion"] = "Pavillon d’Angkhal",
	["Anglers Expedition"] = "Expédition des Hameçonneurs",
	["Anglers Wharf"] = "Quai des Hameçonneurs",
	["Angor Fortress"] = "Forteresse d’Angor",
	["Ango'rosh Grounds"] = "Terres Ango’rosh",
	["Ango'rosh Stronghold"] = "Bastion Ango’rosh",
	["Angrathar the Wrathgate"] = "Angrathar, le portail du Courroux",
	["Angrathar the Wrath Gate"] = "Angrathar, le portail du Courroux",
	["An'owyn"] = "An’owyn",
	["An'telas"] = "An’telas",
	["Antonidas Memorial"] = "Monument à Antonidas",
	Anvilmar = "Courbenclume",
	["Anvil of Conflagration"] = "Enclume de la Déflagration",
	["Apex Point"] = "Halte de l'apogée",
	["Apocryphan's Rest"] = "Repos d’Apocryphan",
	["Apothecary Camp"] = "Camp des Apothicaires",
	["Applebloom Tavern"] = "Taverne Fleur de Pommier",
	["Arathi Basin"] = "Bassin Arathi",
	["Arathi Highlands"] = "Hautes-terres Arathies",
	["Arcane Pinnacle"] = "Cime des Arcanes",
	["Archmage Vargoth's Retreat"] = "Retraite de l'archimage Vargoth",
	["Area 52"] = "Zone 52",
	["Arena Floor"] = "Sol de l’arène",
	["Arena of Annihilation"] = "Arène de l’Annihilation",
	["Argent Pavilion"] = "Pavillon d’Argent",
	["Argent Stand"] = "Séjour d'Argent",
	["Argent Tournament Grounds"] = "Enceinte du tournoi d’Argent",
	["Argent Vanguard"] = "L’avant-garde d’Argent",
	["Ariden's Camp"] = "Camp d’Ariden",
	["Arikara's Needle"] = "Aiguille d’Arikara",
	["Arklonis Ridge"] = "Crête d’Arklonis",
	["Arklon Ruins"] = "Ruines Arklon",
	["Arriga Footbridge"] = "Passerelle Arriga",
	["Arsad Trade Post"] = "Comptoir d’Arsad",
	["Ascendant's Rise"] = "Cime de l’Ascendant",
	["Ascent of Swirling Winds"] = "Ascension des Vents tourbillonnants",
	["Ashen Fields"] = "Champs des Cendres",
	["Ashen Lake"] = "Lac des Cendres",
	Ashenvale = "Orneval",
	["Ashwood Lake"] = "Lac du Frêne",
	["Ashwood Post"] = "Poste du Frêne",
	["Aspen Grove Post"] = "Poste de la Tremblaie",
	["Assault on Shaol'mara"] = "L’assaut de Shaol’mara",
	["Assault on Zan'vess"] = "L’assaut de Zan’vess",
	["Assault on Zeb'tula"] = "L’assaut de Zeb’tula",
	Astranaar = "Astranaar",
	["Ata'mal Terrace"] = "Terrasse Ata’mal",
	Athenaeum = "Athenaeum",
	["Atrium of the Heart"] = "Atrium du Cœur",
	["Atulhet's Tomb"] = "Tombe d’Atulhet",
	["Auberdine Refugee Camp"] = "Camp de réfugiés d’Auberdine",
	["Auburn Bluffs"] = "Pitons Acajou",
	["Auchenai Crypts"] = "Cryptes Auchenaï",
	["Auchenai Grounds"] = "Terres Auchenaï",
	Auchindoun = "Auchindoun",
	["Auchindoun: Auchenai Crypts"] = "Auchindoun : Cryptes Auchenaï",
	["Auchindoun - Auchenai Crypts Entrance"] = "Auchindoun - Entrée des cryptes Auchenaï",
	["Auchindoun: Mana-Tombs"] = "Auchindoun : Tombes-mana",
	["Auchindoun - Mana-Tombs Entrance"] = "Auchindoun - Entrée des Tombes-Mana",
	["Auchindoun: Sethekk Halls"] = "Auchindoun : Salles des Sethekk",
	["Auchindoun - Sethekk Halls Entrance"] = "Auchindoun - Entrée des salles des Sethekk",
	["Auchindoun: Shadow Labyrinth"] = "Auchindoun : Labyrinthe des ombres",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Auchindoun - Entrée du labyrinthe des Ombres",
	["Auren Falls"] = "Chutes d’Auren",
	["Auren Ridge"] = "Crête d’Auren",
	["Autumnshade Ridge"] = "Crête de Noir-Automne",
	["Avalanchion's Vault"] = "Caveau d’Avalanchion",
	Aviary = "Volière",
	["Axis of Alignment"] = "Axe d’alignement",
	Axxarien = "Axxarien",
	["Azjol-Nerub"] = "Azjol-Nérub",
	["Azjol-Nerub Entrance"] = "Entrée d’Azjol-Nérub",
	Azshara = "Azshara",
	["Azshara Crater"] = "Cratère d’Azshara",
	["Azshara's Palace"] = "Palais d’Azshara",
	["Azurebreeze Coast"] = "Côte de Brise-d’Azur",
	["Azure Dragonshrine"] = "Sanctuaire draconique Azur",
	["Azurelode Mine"] = "Mine de Veine-Azur",
	["Azuremyst Isle"] = "Île de Brume-Azur",
	["Azure Watch"] = "Guet d’azur",
	["Backbreaker Bay"] = "Baie des Brise-Dos",
	Badlands = "Terres Ingrates",
	["Bael'dun Digsite"] = "Site de fouilles de Bael’Dun",
	["Bael'dun Keep"] = "Donjon de Bael’dun",
	["Baelgun's Excavation Site"] = "Excavations de Baelgun",
	["Bael Modan"] = "Bael Modan",
	["Bael Modan Excavation"] = "Excavation de Bael Modan",
	["Bahrum's Post"] = "Poste de Bahrum",
	["Balargarde Fortress"] = "Forteresse de Balargarde",
	Baleheim = "Torvheim",
	["Balejar Watch"] = "Guet de Balejar",
	["Balia'mah Ruins"] = "Ruines de Balia’mah",
	["Bal'lal Ruins"] = "Ruines de Bal’lal",
	["Balnir Farmstead"] = "Ferme des Balnir",
	Bambala = "Bambala",
	["Band of Acceleration"] = "Bague d’accélération",
	["Band of Alignment"] = "Bague d’alignement",
	["Band of Transmutation"] = "Bague de transmutation",
	["Band of Variance"] = "Bague de variance",
	["Ban'ethil Barrow Den"] = "Refuge des saisons de Ban’ethil",
	["Ban'ethil Barrow Descent"] = "Descente vers le refuge des saisons de Ban’ethil",
	["Ban'ethil Hollow"] = "Creux de Ban’ethil",
	Bank = "Banque",
	["Banquet Grounds"] = "Cour du Banquet",
	["Ban'Thallow Barrow Den"] = "Refuge des saisons de Ban’Thallow",
	["Baradin Base Camp"] = "Campement de Baradin",
	["Baradin Bay"] = "Baie de Baradin",
	["Baradin Hold"] = "Bastion de Baradin",
	Barbershop = "Salon de coiffure",
	["Barov Family Vault"] = "Caveau de la famille Barov",
	["Bashal'Aran"] = "Bashal’Aran",
	["Bashal'Aran Collapse"] = "Effondrement de Bashal’Aran",
	["Bash'ir Landing"] = "Point d’ancrage de Bash’ir",
	["Bastion Antechamber"] = "Antichambre du Bastion",
	["Bathran's Haunt"] = "Repaire de Bathran",
	["Battlefront Provisions"] = "Provisions de la Ligne de front",
	["Battle on the High Seas"] = "Bataille en haute mer",
	["Battle Ring"] = "L’arène",
	Battlescar = "La Balafre",
	["Battlescar Spire"] = "Flèche de la Balafre",
	["Battlescar Valley"] = "Vallée de la Balafre",
	["Bay of Echoes"] = "Baie des Échos",
	["Bay of Storms"] = "Baie des Tempêtes",
	["Bear's Head"] = "Tête d’ours",
	["Beauty's Lair"] = "Repaire de la Belle",
	["Beeble's Wreck"] = "Épave de Bibi",
	["Beezil's Wreck"] = "Épave de Beezil",
	["Befouled Terrace"] = "Terrasse Souillée",
	["Beggar's Haunt"] = "Repaire des Mendiants",
	["Beneath The Double Rainbow"] = "Sous le double arc-en-ciel",
	["Beneath the Pit"] = "Sous la fosse",
	["Beren's Peril"] = "Péril de Beren",
	["Bernau's Happy Fun Land"] = "Pays du bonheur de Bernau",
	["Beryl Coast"] = "La côte de Béryl",
	["Beryl Egress"] = "Émergence de Béryl",
	["Beryl Point"] = "Halte de Béryl",
	["Beth'mora Ridge"] = "Crête de Beth’mora",
	["Beth'tilac's Lair"] = "Repaire de Beth’tilac",
	["Biel'aran Ridge"] = "Crête de Biel’aran",
	["Big Beach Brew Bash"] = "Bonne biture des brasseurs",
	["Big Blossom Excavation"] = "Excavations du Grand Printemps",
	["Big Blossom Mine"] = "Mine du Grand Printemps",
	["Bilgewater Beach"] = "Plage Baille-Fonds",
	["Bilgewater Harbor"] = "Havre Baille-Fonds",
	["Bilgewater Lumber Yard"] = "Dépôt de bois Baille-Fonds",
	["Bilgewater Port"] = "Port Baille-Fonds",
	["Binan Brew & Stew"] = "Aux brouets de Binan",
	["Binan Village"] = "Binan",
	["Bitter Reaches"] = "Confins Amers",
	["Bittertide Lake"] = "Lac de Flot-Amer",
	["Bizmo's Brawlpub"] = "Bar-Tabasse de Bizmo",
	["Black Channel Marsh"] = "Marais des Eaux-Noires",
	["Blackchar Cave"] = "Caverne de Noircharbon",
	["Black Drake Roost"] = "Perchoir du Drake noir",
	["Blackfathom Camp"] = "Camp de Brassenoire",
	["Blackfathom Deeps"] = "Profondeurs de Brassenoire",
	["Blackfathom Deeps Entrance"] = "Entrée des profondeurs de Brassenoire",
	["Blackhoof Village"] = "Sabot-Noir",
	["Blackhorn's Penance"] = "Pénitence de Corne-Noire",
	["Blackmaw Hold"] = "Repaire des Noiregueules",
	["Black Ox Temple"] = "Temple du Buffle noir",
	["Blackriver Logging Camp"] = "Camp de bûcherons de la Rivière noire",
	["Blackrock Caverns"] = "Cavernes de Rochenoire",
	["Blackrock Caverns Entrance"] = "Entrée des cavernes de Rochenoire",
	["Blackrock Depths"] = "Profondeurs de Rochenoire",
	["Blackrock Depths Entrance"] = "Entrée des profondeurs de Rochenoire",
	["Blackrock Mountain"] = "Mont Rochenoire",
	["Blackrock Pass"] = "Défilé des Rochenoires",
	["Blackrock Spire"] = "Pic Rochenoire",
	["Blackrock Spire Entrance"] = "Entrée du pic Rochenoire",
	["Blackrock Stadium"] = "Stade Rochenoire",
	["Blackrock Stronghold"] = "Bastion Rochenoire",
	["Blacksand Spillway"] = "Déversoir de Noirsang",
	["Blacksilt Shore"] = "Le rivage de Vase noire",
	Blacksmith = "Forge",
	["Blackstone Span"] = "Viaduc de Noirepierre",
	["Black Temple"] = "Temple Noir",
	["Black Tooth Hovel"] = "Taudis de Noirdent",
	Blackwatch = "Guet Noir",
	["Blackwater Cove"] = "Crique des Flots noirs",
	["Blackwater Shipwrecks"] = "Épaves des Flots noirs",
	["Blackwind Lake"] = "Lac Noirvent",
	["Blackwind Landing"] = "Le Raie’odrome de Noirvent",
	["Blackwind Valley"] = "Vallée de Noirvent",
	["Blackwing Coven"] = "Convent de l’Aile noire",
	["Blackwing Descent"] = "Descente de l’Aile noire",
	["Blackwing Lair"] = "Repaire de l’Aile noire",
	["Blackwolf River"] = "Fleuve Loup-Noir",
	["Blackwood Camp"] = "Camp des Noirbois",
	["Blackwood Den"] = "Tanière des Noirbois",
	["Blackwood Lake"] = "Lac de Noirbois",
	["Bladed Gulch"] = "Goulet des Lames",
	["Bladefist Bay"] = "Baie de Lamepoing",
	["Bladelord's Retreat"] = "Retraite du Seigneur des lames",
	["Blades & Axes"] = "Lames & Haches",
	["Blade's Edge Arena"] = "Arène des Tranchantes",
	["Blade's Edge Mountains"] = "Les Tranchantes",
	["Bladespire Grounds"] = "Terres de la Flèchelame",
	["Bladespire Hold"] = "Bastion de Flèchelame",
	["Bladespire Outpost"] = "Avant-poste Flèchelame",
	["Blades' Run"] = "Défilé des lames",
	["Blade Tooth Canyon"] = "Canyon de Lamecroc",
	Bladewood = "Bois des Lames",
	["Blasted Lands"] = "Terres Foudroyées",
	["Bleak Hollow"] = "Le Morne Creux",
	["Bleeding Hollow Ruins"] = "Ruines de l’Orbite sanglante",
	["Bleeding Vale"] = "Val Sanglant",
	["Bleeding Ziggurat"] = "Ziggourat Sanguinolente",
	["Blistering Pool"] = "Bassin Caustique",
	["Bloodcurse Isle"] = "Île du Sang maudit",
	["Blood Elf Tower"] = "Tour des elfes de sang",
	["Bloodfen Burrow"] = "Terrier des Rougefanges",
	Bloodgulch = "Goulet Sanglant",
	["Bloodhoof Village"] = "Sabot-de-Sang",
	["Bloodied Crossing"] = "La croisée Ensanglantée",
	["Blood in the Snow"] = "Du sang dans la neige",
	["Bloodmaul Camp"] = "Camp de la Masse-sanglante",
	["Bloodmaul Outpost"] = "Avant-poste de la Masse-sanglante",
	["Bloodmaul Ravine"] = "Ravin de la Masse-sanglante",
	["Bloodmoon Isle"] = "Île de la Lune sanguine",
	["Bloodmyst Isle"] = "Île de Brume-Sang",
	["Bloodscale Enclave"] = "Enclave des Écailles-sanglantes",
	["Bloodscale Grounds"] = "Terres des Écailles-sanglantes",
	["Bloodspore Plains"] = "Plaines de Spore-sang",
	["Bloodtalon Shore"] = "Rivage Griffesang",
	["Bloodtooth Camp"] = "Camp de Dent-Rouge",
	["Bloodvenom Falls"] = "Chutes de la Vénéneuse",
	["Bloodvenom Post"] = "Poste de la Vénéneuse",
	["Bloodvenom Post "] = "Poste de la Vénéneuse",
	["Bloodvenom River"] = "La Vénéneuse",
	["Bloodwash Cavern"] = "Caverne du Reflux sanglant",
	["Bloodwash Fighting Pits"] = "Fosses de combat du Reflux sanglant",
	["Bloodwash Shrine"] = "Sanctuaire du Reflux sanglant",
	["Blood Watch"] = "Guet du sang",
	["Bloodwatcher Point"] = "Halte de Guettesang",
	Bluefen = "Marais Bleu",
	["Bluegill Marsh"] = "Marais des Branchies-bleues",
	["Blue Sky Logging Grounds"] = "Chantier d’abattage du Ciel bleu",
	["Bluff of the South Wind"] = "Promontoire du vent du Sud",
	["Bogen's Ledge"] = "Escarpement de Bogen",
	Bogpaddle = "Brasse-Tourbe",
	["Boha'mu Ruins"] = "Ruines de Boha’mu",
	["Bolgan's Hole"] = "Trou de Bolgan",
	["Bolyun's Camp"] = "Camp de Bolyun",
	["Bonechewer Ruins"] = "Ruines Mâche-les-os",
	["Bonesnap's Camp"] = "Camp de Bris’os",
	["Bones of Grakkarond"] = "Restes de Grakkarond",
	["Bootlegger Outpost"] = "Avant-poste des Contrebandiers",
	["Booty Bay"] = "Baie-du-Butin",
	["Borean Tundra"] = "Toundra Boréenne",
	["Bor'gorok Outpost"] = "Avant-poste de Bor’gorok",
	["Bor's Breath"] = "Souffle de Bor",
	["Bor's Breath River"] = "Le Souffle de Bor",
	["Bor's Fall"] = "Chute de Bor",
	["Bor's Fury"] = "Furie de Bor",
	["Borune Ruins"] = "Ruines de Borune",
	["Bough Shadow"] = "L’Ombrage",
	["Bouldercrag's Refuge"] = "Refuge de Rochecombe",
	["Boulderfist Hall"] = "Hall Rochepoing",
	["Boulderfist Outpost"] = "Avant-poste rochepoing",
	["Boulder'gor"] = "Roche’gor",
	["Boulder Hills"] = "Collines du Rocher",
	["Boulder Lode Mine"] = "Mine des Pierriers",
	["Boulder'mok"] = "Roche’mok",
	["Boulderslide Cavern"] = "Caverne des Éboulis",
	["Boulderslide Ravine"] = "Ravin des Éboulis",
	["Bozzle's Wreck"] = "Épave de Bozo",
	["Brackenwall Village"] = "Mur-de-Fougères",
	["Brackwell Pumpkin Patch"] = "Champ de potirons des Saumepuits",
	["Brambleblade Ravine"] = "Ravin de Roncelame",
	Bramblescar = "Ronceplaie",
	["Brann's Base-Camp"] = "Campement de Brann",
	["Brashtide Attack Fleet"] = "Flotte d’attaque des Fiers-à-flot",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Flotte d'attaque des Fiers-à-flot (Force à l'extérieur)",
	["Brave Wind Mesa"] = "Mesa de Brave-Vent",
	["Brawl'gar Arena"] = "Arène de Castagn’ar",
	["Brazie Farmstead"] = "Ferme de Brazie",
	["Brewmoon Festival"] = "Festival de Brasse-Lune",
	["Brewnall Village"] = "Brassetout",
	["Bridge of Souls"] = "Le pont des âmes",
	["Brightwater Lake"] = "Lac Étincelant",
	["Brightwood Grove"] = "Bosquet de Clairbois",
	Brill = "Brill",
	["Brill Town Hall"] = "Hôtel de ville de Brill",
	["Bristlelimb Enclave"] = "L’enclave des Bras-hirsutes",
	["Bristlelimb Village"] = "Village des Bras-hirsutes",
	["Broken Commons"] = "Communs en ruine",
	["Broken Hill"] = "Colline Brisée",
	["Broken Pillar"] = "Pilier Brisé",
	["Broken Spear Village"] = "Village de la Lance brisée",
	["Broken Wilds"] = "Landes Brisées",
	["Broketooth Outpost"] = "Avant-poste de Casse-Dent",
	["Bronzebeard Encampment"] = "Campement de Barbe-de-bronze",
	["Bronze Dragonshrine"] = "Sanctuaire draconique Bronze",
	["Browman Mill"] = "Scierie de Browman",
	["Brunnhildar Village"] = "Brunnhildar",
	["Bucklebree Farm"] = "Ferme des Bucklebree",
	["Budd's Dig"] = "Site de fouilles de Budd",
	["Burning Blade Coven"] = "Convent de la Lame ardente",
	["Burning Blade Ruins"] = "Ruines de la Lame ardente",
	["Burning Steppes"] = "Steppes Ardentes",
	["Butcher's Sanctum"] = "Sanctum du Boucher",
	["Butcher's Stand"] = "Étal du boucher",
	["Caer Darrow"] = "Caer Darrow",
	["Caldemere Lake"] = "Lac Caldemere",
	["Calston Estate"] = "Domaine Calston",
	["Camp Aparaje"] = "Camp Aparaje",
	["Camp Ataya"] = "Camp Ataya",
	["Camp Boff"] = "Camp Boff",
	["Camp Broketooth"] = "Camp Casse-Dent",
	["Camp Cagg"] = "Camp Cagg",
	["Camp E'thok"] = "Camp E’thok",
	["Camp Everstill"] = "Camp Placide",
	["Camp Gormal"] = "Camp de Gormal",
	["Camp Kosh"] = "Camp Kosh",
	["Camp Mojache"] = "Camp Mojache",
	["Camp Mojache Longhouse"] = "Maison longue du camp Mojache",
	["Camp Narache"] = "Camp Narache",
	["Camp Nooka Nooka"] = "Camp Nouka Nouka",
	["Camp of Boom"] = "Camp de Boum",
	["Camp Onequah"] = "Camp Onequah",
	["Camp Oneqwah"] = "Camp Oneqwah",
	["Camp Sungraze"] = "Camp Frôle-Soleil",
	["Camp Tunka'lo"] = "Camp Tunka’lo",
	["Camp Una'fe"] = "Camp Una’fe",
	["Camp Winterhoof"] = "Camp Sabot-d’Hiver",
	["Camp Wurg"] = "Camp Wurg",
	Canals = "Canaux",
	["Cannon's Inferno"] = "Poudrière de Canon",
	["Cantrips & Crows"] = "Caboulot des corbeaux",
	["Cape of Lost Hope"] = "Cap de l’Espoir perdu",
	["Cape of Stranglethorn"] = "Cap Strangleronce",
	["Capital Gardens"] = "Grands jardins",
	["Carrion Hill"] = "Colline des Charognes",
	["Cartier & Co. Fine Jewelry"] = "Joaillerie de luxe Kartier & Co.",
	Cataclysm = "Cataclysme",
	["Cathedral of Darkness"] = "Cathédrale des Ténèbres",
	["Cathedral of Light"] = "Cathédrale de la Lumière",
	["Cathedral Quarter"] = "Quartier de la Cathédrale",
	["Cathedral Square"] = "Place de la Cathédrale",
	["Cattail Lake"] = "Lac aux Roseaux",
	["Cauldros Isle"] = "Île Calderos",
	["Cave of Mam'toth"] = "Caverne de Mam'toth",
	["Cave of Meditation"] = "Caverne des Méditations",
	["Cave of the Crane"] = "Caverne de la Grue",
	["Cave of Words"] = "Caverne des Palabres",
	["Cavern of Endless Echoes"] = "Caverne des Échos sans fin",
	["Cavern of Mists"] = "Caverne des Brumes",
	["Caverns of Time"] = "Grottes du Temps",
	["Celestial Enclave"] = "Enclave céleste",
	["Celestial Ridge"] = "Crête Céleste",
	["Cenarion Enclave"] = "Enclave Cénarienne",
	["Cenarion Hold"] = "Fort Cénarien",
	["Cenarion Post"] = "Poste Cénarien",
	["Cenarion Refuge"] = "Refuge Cénarien",
	["Cenarion Thicket"] = "Fourré Cénarien",
	["Cenarion Watchpost"] = "Poste de garde Cénarien",
	["Cenarion Wildlands"] = "Terres sauvages Cénariennes",
	["Central Bridge"] = "Pont central",
	["Chamber of Ancient Relics"] = "Chambre des anciennes reliques",
	["Chamber of Atonement"] = "Chambre de l'expiation",
	["Chamber of Battle"] = "Chambre de guerre",
	["Chamber of Blood"] = "Chambre du Sang",
	["Chamber of Command"] = "Chambre de commandement",
	["Chamber of Enchantment"] = "Chambre des enchantements",
	["Chamber of Enlightenment"] = "Salle de l’Illumination",
	["Chamber of Fanatics"] = "Chambre des Fanatiques",
	["Chamber of Incineration"] = "Salle d'incinération",
	["Chamber of Masters"] = "Chambre des Maîtres",
	["Chamber of Prophecy"] = "Chambre de la Prophétie",
	["Chamber of Reflection"] = "Chambre des Reflets",
	["Chamber of Respite"] = "Chambre du Répit",
	["Chamber of Summoning"] = "Chambre d'invocation",
	["Chamber of Test Namesets"] = "Chamber of Test Namesets",
	["Chamber of the Aspects"] = "La chambre des Aspects",
	["Chamber of the Dreamer"] = "Chambre du rêveur",
	["Chamber of the Moon"] = "Chambre de la Lune",
	["Chamber of the Restless"] = "La chambre des Sans-repos",
	["Chamber of the Stars"] = "Chambre des Étoiles",
	["Chamber of the Sun"] = "Chambre du Soleil",
	["Chamber of Whispers"] = "Chambre des Murmures",
	["Chamber of Wisdom"] = "Chambre de la Sagesse",
	["Champion's Hall"] = "Hall des champions",
	["Champions' Hall"] = "Hall des Champions",
	["Chapel Gardens"] = "Jardins de la Chapelle",
	["Chapel of the Crimson Flame"] = "Chapelle de la Flamme cramoisie",
	["Chapel Yard"] = "Cour de la Chapelle",
	["Charred Outpost"] = "Avant-poste Calciné",
	["Charred Rise"] = "Cime Calcinée",
	["Chill Breeze Valley"] = "Vallée de la Bise",
	["Chillmere Coast"] = "Côte de Frissonde",
	["Chillwind Camp"] = "Camp du Noroît",
	["Chillwind Point"] = "Pointe du Noroît",
	Chiselgrip = "Cisepoigne",
	["Chittering Coast"] = "La côte Cliquetante",
	["Chow Farmstead"] = "Ferme de Chow",
	["Churning Gulch"] = "Goulet Bouillonnant",
	["Circle of Blood"] = "Cercle de sang",
	["Circle of Blood Arena"] = "Arène du Cercle de sang",
	["Circle of Bone"] = "Cercle d’os",
	["Circle of East Binding"] = "Cercle de Lien oriental",
	["Circle of Inner Binding"] = "Cercle de Lien intérieur",
	["Circle of Outer Binding"] = "Cercle de Lien extérieur",
	["Circle of Scale"] = "Cercle d’écailles",
	["Circle of Stone"] = "Cercle de pierre",
	["Circle of Thorns"] = "Cercle d’Épines",
	["Circle of West Binding"] = "Cercle de Lien occidental",
	["Circle of Wills"] = "Le cercle des Volontés",
	City = "Capitales",
	["City of Ironforge"] = "Cité de Forgefer",
	["City Siege - Mogu Island Progression Scenario"] = "Siège de la ville - Scénario de progression de l’île mogu",
	["Clan Watch"] = "Guet des Clans",
	["Class Quest"] = "Quête de classe",
	["Claytön's WoWEdit Land"] = "Claytön’s WoWEdit Land",
	["Cleft of Shadow"] = "Faille de l’Ombre",
	["Cliffspring Falls"] = "Chutes de la Bondissante",
	["Cliffspring Hollow"] = "Val de la Bondissante",
	["Cliffspring River"] = "La Bondissante",
	["Cliffwalker Post"] = "Poste de Rôde-Falaise",
	["Cloudstrike Dojo"] = "Dojo de Foudre des Nuages",
	["Cloudtop Terrace"] = "Terrasse des Nuages",
	["Coast of Echoes"] = "Côte des Échos",
	["Coast of Idols"] = "Côte des Idoles",
	["Coilfang Reservoir"] = "Réservoir de Glissecroc",
	["Coilfang: Serpentshrine Cavern"] = "Glissecroc : caverne du sanctuaire du Serpent",
	["Coilfang: The Slave Pens"] = "Glissecroc : les Enclos aux esclaves",
	["Coilfang - The Slave Pens Entrance"] = "Glissecroc - Entrée des enclos aux esclaves",
	["Coilfang: The Steamvault"] = "Glissecroc : le Caveau de la vapeur",
	["Coilfang - The Steamvault Entrance"] = "Glissecroc - Entrée du caveau de la Vapeur",
	["Coilfang: The Underbog"] = "Glissecroc : la Basse-tourbière",
	["Coilfang - The Underbog Entrance"] = "Glissecroc - Entrée de la Basse-Tourbière",
	["Coilskar Cistern"] = "Citerne de Glissentaille",
	["Coilskar Point"] = "Halte de Glissentaille",
	Coldarra = "Frimarra",
	["Coldarra Ledge"] = "Escarpement de Frimarra",
	["Coldbite Burrow"] = "Terrier des Morsubises",
	["Cold Hearth Manor"] = "Manoir du Foyer froid",
	["Coldridge Pass"] = "Passe des Frigères",
	["Coldridge Valley"] = "Vallée des Frigères",
	["Coldrock Quarry"] = "Carrière de Rochefroide",
	["Coldtooth Mine"] = "Mine de Froide-Dent",
	["Coldwind Heights"] = "Hauts de Vent-Froid",
	["Coldwind Pass"] = "Passe de Vent-Froid",
	["Collin's Test"] = "Test de Collin",
	["Command Center"] = "Centre de commandement",
	["Commons Hall"] = "Communs",
	["Condemned Halls"] = "Salles Condamnées",
	["Conqueror's Terrace"] = "Terrasse des Conquérants",
	["Conquest Hold"] = "Bastion de la Conquête",
	["Containment Core"] = "Cœur de confinement",
	["Cooper Residence"] = "La résidence des Tonnelier",
	["Coral Garden"] = "Jardin de corail",
	["Cordell's Enchanting"] = "Enchantement de Cordell",
	["Corin's Crossing"] = "La Croisée de Corin",
	["Corp'rethar: The Horror Gate"] = "Corp’rethar : la Porte de l’Horreur",
	["Corrahn's Dagger"] = "Dague de Corrahn",
	Cosmowrench = "Cosmovrille",
	["Court of Bones"] = "Cour des Ossements",
	["Court of the Highborne"] = "Cour des Bien-nés",
	["Court of the Sun"] = "Cour du Soleil",
	["Courtyard of Lights"] = "Cour des Lumières",
	["Courtyard of the Ancients"] = "Cour des Anciens",
	["Cradle of Chi-Ji"] = "Berceau de Chi Ji",
	["Cradle of the Ancients"] = "Berceau des Anciens",
	["Craftsmen's Terrace"] = "Terrasse des Artisans",
	["Crag of the Everliving"] = "Combe des Éternels",
	["Cragpool Lake"] = "Lac de la Combe",
	["Crane Wing Refuge"] = "Refuge des Aile-de-Grue",
	["Crash Site"] = "Point d’impact",
	["Crescent Hall"] = "Hall du Croissant",
	["Crimson Assembly Hall"] = "Salle de l’Assemblée cramoisie",
	["Crimson Expanse"] = "Étendues Cramoisies",
	["Crimson Watch"] = "Guet Cramoisi",
	Crossroads = "La Croisée",
	["Crowley Orchard"] = "Verger de Crowley",
	["Crowley Stable Grounds"] = "Écuries des Crowley",
	["Crown Guard Tower"] = "Tour de garde de la Couronne",
	["Crucible of Carnage"] = "Creuset du carnage",
	["Crumbling Depths"] = "Les profondeurs Désagrégées",
	["Crumbling Stones"] = "Les Pierres effondrées",
	["Crusader Forward Camp"] = "Camp avancé des Croisés",
	["Crusader Outpost"] = "Avant-poste des Croisés",
	["Crusader's Armory"] = "Armurerie des Croisés",
	["Crusader's Chapel"] = "Chapelle des Croisés",
	["Crusader's Landing"] = "L’accostage du Croisé",
	["Crusader's Outpost"] = "Avant-poste des Croisés",
	["Crusaders' Pinnacle"] = "Cime des Croisés",
	["Crusader's Run"] = "Défilé du Croisé",
	["Crusader's Spire"] = "Flèche des Croisés",
	["Crusaders' Square"] = "Place des croisés",
	Crushblow = "Frakass",
	["Crushcog's Arsenal"] = "Arsenal de Brisedent",
	["Crushridge Hold"] = "Bastion Cassecrête",
	Crypt = "Crypte",
	["Crypt of Forgotten Kings"] = "Crypte des Rois oubliés",
	["Crypt of Remembrance"] = "La crypte du Souvenir",
	["Crystal Lake"] = "Lac de Cristal",
	["Crystalline Quarry"] = "Carrière cristalline",
	["Crystalsong Forest"] = "Forêt du Chant de cristal",
	["Crystal Spine"] = "Éperon de cristal",
	["Crystalvein Mine"] = "Mine aux Cristaux",
	["Crystalweb Cavern"] = "Caverne de la Toile cristalline",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "Les Objets de la Moore",
	["Cursed Depths"] = "Profondeurs Maudites",
	["Cursed Hollow"] = "Creux Maudit",
	["Cut-Throat Alley"] = "Ruelle du Coupe-gorge",
	["Cyclone Summit"] = "Sommet du cyclone",
	["Dabyrie's Farmstead"] = "Ferme des Dabyrie",
	["Daggercap Bay"] = "Baie de Coiffedague",
	["Daggerfen Village"] = "Tourbedague",
	["Dagger in the Dark"] = "Une dague dans la nuit",
	["Daggermaw Canyon"] = "Canyon des Crocs-lames",
	["Dagger Pass"] = "Passe de la Dague",
	["Dais of Conquerors"] = "Tribune des Conquérants",
	Dalaran = "Dalaran",
	["Dalaran Arena"] = "Arène de Dalaran",
	["Dalaran City"] = "Dalaran",
	["Dalaran Crater"] = "Cratère de Dalaran",
	["Dalaran Floating Rocks"] = "Rochers flottants de Dalaran",
	["Dalaran Island"] = "Île de Dalaran",
	["Dalaran Merchant's Bank"] = "Banque des marchands de Dalaran",
	["Dalaran Sewers"] = "Égouts de Dalaran",
	["Dalaran Visitor Center"] = "Accueil des visiteurs de Dalaran",
	["Dalson's Farm"] = "Ferme de Dalson",
	["Damplight Cavern"] = "Caverne du Clair-Obscur",
	["Damplight Chamber"] = "Chambre du clair-obscur",
	["Dampsoil Burrow"] = "Terrier de Ruisse-Sol",
	["Dandred's Fold"] = "Clos de Dandred",
	["Dargath's Demise"] = "La Fin de Dargath",
	["Darkbreak Cove"] = "Crique du Sombre brisant",
	["Darkcloud Pinnacle"] = "Cime de Noir-Nuage",
	["Darkcrest Enclave"] = "Enclave des Sombrecrêtes",
	["Darkcrest Shore"] = "Rivage des Sombrecrêtes",
	["Dark Heart of Pandaria"] = "Le sombre cœur de la Pandarie",
	["Dark Iron Highway"] = "Grand-route des Sombrefers",
	["Darkmist Cavern"] = "Caverne de Sombrebrume",
	["Darkmist Ruins"] = "Ruines de Sombrebrume",
	["Darkmoon Boardwalk"] = "Promenade de Sombrelune",
	["Darkmoon Deathmatch"] = "Combats à mort de Sombrelune",
	["Darkmoon Deathmatch Pit (PH)"] = "Fosse des combats à mort de Sombrelune [PH]",
	["Darkmoon Faire"] = "Foire de Sombrelune",
	["Darkmoon Island"] = "Île de Sombrelune",
	["Darkmoon Island Cave"] = "Grotte de l’île de Sombrelune",
	["Darkmoon Path"] = "Chemin de Sombrelune",
	["Darkmoon Pavilion"] = "Pavillon de Sombrelune",
	Darkshire = "Sombre-Comté",
	["Darkshire Town Hall"] = "Hôtel de ville de Sombre-comté",
	Darkshore = "Sombrivage",
	["Darkspear Hold"] = "Bastion des Sombrelances",
	["Darkspear Isle"] = "Île des Sombrelances",
	["Darkspear Shore"] = "Rivage des Sombrelances",
	["Darkspear Strand"] = "Grève des Sombrelances",
	["Darkspear Training Grounds"] = "Terrain d’entraînement des Sombrelances",
	["Darkwhisper Gorge"] = "Gorge du Sombre murmure",
	["Darkwhisper Pass"] = "Passage du Sombre murmure",
	["Darnassian Base Camp"] = "Camp de base Darnassien",
	Darnassus = "Darnassus",
	["Darrow Hill"] = "Colline de Darrow",
	["Darrowmere Lake"] = "Lac Darrowmere",
	Darrowshire = "Comté-de-Darrow",
	["Darrowshire Hunting Grounds"] = "Terrain de chasse de Comté-de-Darrow",
	["Darsok's Outpost"] = "Avant-poste de Darsok",
	["Dawnchaser Retreat"] = "Retraite des Chasselaube",
	["Dawning Lane"] = "Allée du Point-du-Jour",
	["Dawning Wood Catacombs"] = "Catacombes du Bois-de-l’aube",
	["Dawnrise Expedition"] = "Expédition Montelaube",
	["Dawn's Blossom"] = "Fleur-de-l’Aurore",
	["Dawnseeker Promontory"] = "Promontoire de Cherchelaube",
	["Dawnseeker's Promontory"] = "Promontoire de Cherchelaube",
	["Dawn's Reach"] = "Confins de l’Aube",
	["Dawnstar Spire"] = "Flèche d’Aubétoile",
	["Dawnstar Village"] = "Aubétoile",
	["Daxil's Dig"] = "Site de fouilles de Daxil",
	["D-Block"] = "Bloc D",
	["Deadeye Shore"] = "Rivage d’Œil-Mort",
	["Deadman's Crossing"] = "Croisée de l’Homme mort",
	["Dead Man's Hole"] = "Gouffre du Mort",
	Deadmines = "Mortemines",
	["Deadtalker's Plateau"] = "Plateau du Parlemort",
	["Deadwind Pass"] = "Défilé de Deuillevent",
	["Deadwind Ravine"] = "Ravin de Deuillevent",
	["Deadwood Village"] = "Village des Mort-bois",
	["Deathbringer's Rise"] = "Cime du Porte-mort",
	["Death Cultist Base Camp"] = "Campement du Sectateur de la mort",
	["Deathforge Tower"] = "Tour de la Forgemort",
	Deathknell = "Le Glas",
	["Deathmatch Pavilion"] = "Pavillon du combat à mort",
	Deatholme = "Mortholme",
	["Death's Breach"] = "Brèche-de-Mort",
	["Death's Door"] = "Porte de la Mort",
	["Death's Hand Encampment"] = "Campement de la Main de mort",
	["Deathspeaker's Watch"] = "Le guet du Nécrorateur",
	["Death's Rise"] = "Cime de la Mort",
	["Death's Stand"] = "Le séjour de la Mort",
	["Death's Step"] = "Pas de la mort",
	["Death's Watch Waystation"] = "Relais du Guet de mort",
	Deathwing = "Aile de mort",
	["Deathwing's Fall"] = "La Chute d’Aile de mort",
	["Deep Blue Observatory"] = "Observatoire du Grand bleu",
	["Deep Elem Mine"] = "Mine du gouffre d’Elem",
	["Deepfin Ridge"] = "Crête Nagegouffre",
	Deepholm = "Le Tréfonds",
	["Deephome Ceiling"] = "Toit du Tréfonds",
	["Deepmist Grotto"] = "Grotte Brume-épaisse",
	["Deeprun Tram"] = "Tram des profondeurs",
	["Deepwater Tavern"] = "Taverne de l’Eau-Profonde",
	["Deepwind Gorge"] = "Gorge de Vent-Caverneux",
	["Defense of the Alehouse"] = "Défense de la taverne",
	["Defense Of The Ale House BG"] = "Défense de la taverne",
	["Defias Hideout"] = "Repaire des Défias",
	["Defiler's Den"] = "L’antre des Profanateurs",
	["D.E.H.T.A. Encampment"] = "Campement de la SdPA",
	["Delete ME"] = "Supprimez-MOI",
	["Demon Fall Canyon"] = "Canyon de la Malechute",
	["Demon Fall Ridge"] = "Crête de la Malechute",
	["Demont's Place"] = "Maison de Demont",
	["Den of Defiance"] = "Tanière de la Défiance",
	["Den of Dying"] = "Tanières du Trépas",
	["Den of Haal'esh"] = "Tanière des Haal’esh",
	["Den of Iniquity"] = "Antre de l'iniquité",
	["Den of Mortal Delights"] = "Tanière des délices mortels",
	["Den of Sorrow"] = "Tanière de la Mélancolie",
	["Den of Sseratus"] = "Tanière de Sseratus",
	["Den of the Caller"] = "Refuge de l'Invocateur",
	["Den of the Devourer"] = "Tanière du Dévoreur",
	["Den of the Disciples"] = "Tanière des Disciples",
	["Den of the Unholy"] = "L'Antre des impies",
	["Derelict Caravan"] = "Caravane Abandonnée",
	["Derelict Manor"] = "Manoir Abandonné",
	["Derelict Strand"] = "Grève des Épaves",
	["Designer Island"] = "Île des Concepteurs",
	Desolace = "Désolace",
	["Desolation Hold"] = "Fort de la Désolation",
	["Detention Block"] = "Le mitard",
	["Development Land"] = "Terrain en développement",
	["Diamondhead River"] = "Rivière Diamondhead",
	["Diamond Island"] = "L’île Diamant",
	["Dig One"] = "Fouille n°1",
	["Dig Three"] = "Fouille n°3",
	["Dig Two"] = "Fouille n°2",
	["Direforge Hill"] = "Colline de Morneforge",
	["Direhorn Post"] = "Poste de Navrecorne",
	["Dire Maul"] = "Hache-Tripes",
	["Dire Maul - Capital Gardens Entrance"] = "Hache-Tripes - Entrée des grands jardins",
	["Dire Maul - East"] = "Haches-Tripes - Est",
	["Dire Maul - Gordok Commons Entrance"] = "Hache-Tripes - Entrée des communs gordok",
	["Dire Maul - North"] = "Haches-Tripes - Nord",
	["Dire Maul - Warpwood Quarter Entrance"] = "Hache-Tripes - Entrée du quartier de Crochebois",
	["Dire Maul - West"] = "Haches-Tripes - Ouest",
	Diremoor = "La morne Lande",
	["Dire Strait"] = "La Mauvaise passe",
	["Disciple's Enclave"] = "Enclave du Disciple",
	Docks = "Docks",
	["Dojani River"] = "Rivière Dojani",
	Dolanaar = "Dolanaar",
	["Dome Balrissa"] = "Dôme Balrissa",
	["Domination Point"] = "Halte de la Domination",
	["Donna's Kitty Shack"] = "Kitty Shack de Donna",
	["DO NOT USE"] = "NE PAS UTILISER",
	["Dookin' Grounds"] = "Terres Dookin",
	["Doom's Vigil"] = "Veille du Destin",
	["Dorian's Outpost"] = "Avant-poste de Dorian",
	["Draco'dar"] = "Draco’dar",
	["Draenei Ruins"] = "Ruines Draeneï",
	["Draenethyst Mine"] = "Mine de Draenéthyste",
	["Draenil'dur Village"] = "Village de Draenil’dur",
	Dragonblight = "Désolation des dragons",
	["Dragonflayer Pens"] = "Enclos des Écorche-dragon",
	["Dragonmaw Base Camp"] = "Campement des Gueules-de-dragon",
	["Dragonmaw Flag Room"] = "Salle du drapeau des Gueules-de-dragon",
	["Dragonmaw Forge"] = "Forge des Gueules-de-Dragon",
	["Dragonmaw Fortress"] = "Forteresse Gueule-de-dragon",
	["Dragonmaw Garrison"] = "Garnison des Gueules-de-dragon",
	["Dragonmaw Gates"] = "Portes des Gueules-de-dragon",
	["Dragonmaw Pass"] = "Passe des Gueules-de-dragon",
	["Dragonmaw Port"] = "Port Gueule-de-dragon",
	["Dragonmaw Skyway"] = "Couloir aérien des Gueules-de-dragon",
	["Dragonmaw Stronghold"] = "Bastion Gueule-de-dragon",
	["Dragons' End"] = "Fin des dragons",
	["Dragon's Fall"] = "Chute du dragon",
	["Dragon's Mouth"] = "La Gueule du dragon",
	["Dragon Soul"] = "L’Âme des dragons",
	["Dragon Soul Raid - East Sarlac"] = "Raid de l’Âme des dragons - Est de Sarlac",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Raid de l’Âme des dragons - Base du temple du Repos du ver",
	["Dragonspine Peaks"] = "Pics de l’Épine-de-Dragon",
	["Dragonspine Ridge"] = "Crête de l’Épine-de-Dragon",
	["Dragonspine Tributary"] = "Affluent de l’Épine-de-Dragon",
	["Dragonspire Hall"] = "Hall de la Flèche des dragons",
	["Drak'Agal"] = "Drak’Agal",
	["Draka's Fury"] = "La Fureur de Draka",
	["Drak'atal Passage"] = "Passage de Drak’atal",
	["Drakil'jin Ruins"] = "Ruines de Drakil’jin",
	["Drak'Mabwa"] = "Drak’Mabwa",
	["Drak'Mar Lake"] = "Lac Drak’Mar",
	["Draknid Lair"] = "Antre draknide",
	["Drak'Sotra"] = "Drak’Sotra",
	["Drak'Sotra Fields"] = "Champs de Drak’Sotra",
	["Drak'Tharon Keep"] = "Donjon de Drak’Tharon",
	["Drak'Tharon Keep Entrance"] = "Entrée du donjon de Drak’Tharon",
	["Drak'Tharon Overlook"] = "Surplomb de Drak’Tharon",
	["Drak'ural"] = "Drak’ural",
	["Dread Clutch"] = "Étreinte de l’angoisse",
	["Dread Expanse"] = "Étendues Effroyables",
	["Dreadmaul Furnace"] = "Fournaise Cognepeur",
	["Dreadmaul Hold"] = "Bastion Cognepeur",
	["Dreadmaul Post"] = "Poste Cognepeur",
	["Dreadmaul Rock"] = "Rocher des Cognepeurs",
	["Dreadmist Camp"] = "Campement de Brume-Funeste",
	["Dreadmist Den"] = "Refuge de Brume-Funeste",
	["Dreadmist Peak"] = "Pic de Brume-Funeste",
	["Dreadmurk Shore"] = "Rivage de Troubleffroi",
	["Dread Terrace"] = "Terrasse de l’Effroi",
	["Dread Wastes"] = "Terres de l’Angoisse",
	["Dreadwatch Outpost"] = "Avant-poste du Guet-de-l’Effroi",
	["Dream Bough"] = "Bosquet du Rêve",
	["Dreamer's Pavilion"] = "Pavillon du Rêveur",
	["Dreamer's Rest"] = "Repos du Rêveur",
	["Dreamer's Rock"] = "Rocher du Rêveur",
	Drudgetown = "Trimeville",
	["Drygulch Ravine"] = "Ravin Asséché",
	["Drywhisker Gorge"] = "Gorge des Sèches-moustaches",
	["Dubra'Jin"] = "Dubra’Jin",
	["Dun Algaz"] = "Dun Algaz",
	["Dun Argol"] = "Dun Argol",
	["Dun Baldar"] = "Dun Baldar",
	["Dun Baldar Pass"] = "Col de Dun Baldar",
	["Dun Baldar Tunnel"] = "Tunnel de Dun Baldar",
	["Dunemaul Compound"] = "Base des Cognedunes",
	["Dunemaul Recruitment Camp"] = "Camp de recrutement Cognedune",
	["Dun Garok"] = "Dun Garok",
	["Dun Mandarr"] = "Dun Mandarr",
	["Dun Modr"] = "Dun Modr",
	["Dun Morogh"] = "Dun Morogh",
	["Dun Niffelem"] = "Dun Niffelem",
	["Dunwald Holdout"] = "Butte-Dunwald",
	["Dunwald Hovel"] = "Taudis des Dunwald",
	["Dunwald Market Row"] = "Allée du Marché de Dunwald",
	["Dunwald Ruins"] = "Ruines de Dunwald",
	["Dunwald Town Square"] = "Place centrale de Dunwald",
	["Durnholde Keep"] = "Donjon de Fort-de-Durn",
	Durotar = "Durotar",
	Duskhaven = "Havre-du-Soir",
	["Duskhowl Den"] = "Tanière des Hurlesoir",
	["Dusklight Bridge"] = "Pont de Lumière-du-Soir",
	["Dusklight Hollow"] = "Creux de Lumière-du-Soir",
	["Duskmist Shore"] = "Rivage de Brume-Soir",
	["Duskroot Fen"] = "Marécage de Point-du-Couchant",
	["Duskwither Grounds"] = "Terres de Ternesoir",
	["Duskwither Spire"] = "Flèche de Ternesoir",
	Duskwood = "Bois de la Pénombre",
	["Dustback Gorge"] = "Gorge de Saléchine",
	["Dustbelch Grotto"] = "Grotte de Crache-Poussière",
	["Dustfire Valley"] = "Vallée des Escarbilles",
	["Dustquill Ravine"] = "Ravin de Plumepoussière",
	["Dustwallow Bay"] = "Baie d’Âprefange",
	["Dustwallow Marsh"] = "Marécage d’Âprefange",
	["Dustwind Cave"] = "Caverne des Terrevent",
	["Dustwind Dig"] = "Site de fouilles de la Bourrasque",
	["Dustwind Gulch"] = "Goulet de la Bourrasque",
	["Dwarven District"] = "Quartier des Nains",
	["Eagle's Eye"] = "Oeil de l’aigle",
	["Earthshatter Cavern"] = "Caverne de Brise-terre",
	["Earth Song Falls"] = "Chutes de Chanteterre",
	["Earth Song Gate"] = "Porte de Chanteterre",
	["Eastern Bridge"] = "Pont de l’est",
	["Eastern Kingdoms"] = "Royaumes de l'est",
	["Eastern Plaguelands"] = "Maleterres de l’Est",
	["Eastern Strand"] = "Rivage Oriental",
	["East Garrison"] = "Garnison de l'Est",
	["Eastmoon Ruins"] = "Ruines d’Estelune",
	["East Pavilion"] = "Pavillon est",
	["East Pillar"] = "Pilier Est",
	["Eastpoint Tower"] = "Tour du Point de l’Est",
	["East Sanctum"] = "Sanctum Oriental",
	["Eastspark Workshop"] = "Atelier de l’Estincelle",
	["East Spire"] = "Flèche Est",
	["East Supply Caravan"] = "Caravane de ravitaillement de l’Est",
	["Eastvale Logging Camp"] = "Camp de bûcherons du val d’Est",
	["Eastwall Gate"] = "Porte du Mur d’Est",
	["Eastwall Tower"] = "Tour du mur d’Est",
	["Eastwind Rest"] = "Repos du Vent de l’Est",
	["Eastwind Shore"] = "Rivage d’Estevent",
	["Ebon Hold"] = "Le fort d'Ébène",
	["Ebon Watch"] = "Guet d’Ébène",
	["Echo Cove"] = "Crique de l’Écho",
	["Echo Isles"] = "Îles de l’Écho",
	["Echomok Cavern"] = "Caverne d'Echomok",
	["Echo Reach"] = "Les confins de l’Écho",
	["Echo Ridge Mine"] = "Mine de la crête aux Échos",
	["Eclipse Point"] = "Halte de l’Éclipse",
	["Eclipsion Fields"] = "Champs Éclipsions",
	["Eco-Dome Farfield"] = "Écodôme Champlointain",
	["Eco-Dome Midrealm"] = "Écodôme Terres-Médianes",
	["Eco-Dome Skyperch"] = "Écodôme Percheciel",
	["Eco-Dome Sutheron"] = "Écodôme Sudron",
	["Elder Rise"] = "Cime des Anciens",
	["Elders' Square"] = "Place des Anciens",
	["Eldreth Row"] = "Allée d'Eldreth",
	["Eldritch Heights"] = "Les hauts Surréels",
	["Elemental Plateau"] = "Plateau Élémentaire",
	["Elementium Depths"] = "Profondeurs d’Élémentium",
	Elevator = "Ascenseur",
	["Elrendar Crossing"] = "Passage de l’Elrendar",
	["Elrendar Falls"] = "Chutes de l’Elrendar",
	["Elrendar River"] = "L’Elrendar",
	["Elwynn Forest"] = "Forêt d’Elwynn",
	["Ember Clutch"] = "Étreinte de braise",
	Emberglade = "Clairière de Braise",
	["Ember Spear Tower"] = "Tour de la Lance de braise",
	["Emberstone Mine"] = "Mine de Pierrebraise",
	["Emberstone Village"] = "Pierrebraise",
	["Emberstrife's Den"] = "Tanière de Brandeguerre",
	["Emerald Dragonshrine"] = "Sanctuaire draconique Émeraude",
	["Emerald Dream"] = "Rêve d'émeraude",
	["Emerald Forest"] = "Forêt d’Émeraude",
	["Emerald Sanctuary"] = "Sanctuaire d’Émeraude",
	["Emperor Rikktik's Rest"] = "Repos de l’empereur Rikktik",
	["Emperor's Omen"] = "Présage de l’empereur",
	["Emperor's Reach"] = "Confins de l’Empereur",
	["End Time"] = "La Fin des temps",
	["Engineering Labs"] = "Labos d'ingénierie",
	["Engineering Labs "] = "Labos d'ingénierie",
	["Engine of Nalak'sha"] = "Moteur de Nalak’sha",
	["Engine of the Makers"] = "Moteur des Faiseurs",
	["Entryway of Time"] = "Entrée du Temps",
	["Ethel Rethor"] = "Ethel Rethor",
	["Ethereal Corridor"] = "Couloir éthérien",
	["Ethereum Staging Grounds"] = "Lieu de rassemblement de l’Ethereum",
	["Evergreen Trading Post"] = "Comptoir des Conifères",
	Evergrove = "Bosquet Éternel",
	Everlook = "Long-Guet",
	["Eversong - Duskwither Teleport"] = "Téléporteur Chants éternels - Ternesoir",
	["Eversong Woods"] = "Bois des Chants éternels",
	["Excavation Center"] = "Excavation centrale",
	["Excavation Lift"] = "Ascenseur de l'excavation",
	["Exclamation Point"] = "Point d’Exclamation",
	["Expedition Armory"] = "Armurerie de l’Expédition",
	["Expedition Base Camp"] = "Camp de base de l’Expédition",
	["Expedition Point"] = "Halte de l’Expédition",
	["Explorers' League Digsite"] = "Site de fouilles de la Ligue des explorateurs",
	["Explorers' League Outpost"] = "Avant-poste de la Ligue des explorateurs",
	["Exposition Pavilion"] = "Pavillon d’exposition",
	["Eye of Eternity"] = "L’Œil de l’éternité",
	["Eye of the Storm"] = "L’Œil du cyclone",
	["Fairbreeze Village"] = "Brise-Clémente",
	["Fairbridge Strand"] = "Rivage de Pontgallant",
	["Falcon Watch"] = "Guet de l’Épervier",
	["Falconwing Inn"] = "Auberge de l’Épervier",
	["Falconwing Square"] = "Place de l’Épervier",
	["Faldir's Cove"] = "Crique de Faldir",
	["Falfarren River"] = "La Falfarren",
	["Fallen Sky Lake"] = "Lac Tombeciel",
	["Fallen Sky Ridge"] = "Crête Tombeciel",
	["Fallen Temple of Ahn'kahet"] = "Temple déchu d’Ahn’kahet",
	["Fall of Return"] = "Hall du retour",
	["Fallowmere Inn"] = "Auberge d’Aiguebrune",
	["Fallow Sanctuary"] = "Sanctuaire des Friches",
	["Falls of Ymiron"] = "Chutes d’Ymiron",
	["Fallsong Village"] = "Chant-des-Flots",
	["Falthrien Academy"] = "Académie de Falthrien",
	Familiars = "Familiers",
	["Faol's Rest"] = "Repos de Faol",
	["Fargaze Mesa"] = "Mesa de Mireloin",
	["Fargodeep Mine"] = "Mine de Fondugouffre",
	Farm = "Ferme",
	Farshire = "Comté-Lointaine",
	["Farshire Fields"] = "Champs de Comté-Lointaine",
	["Farshire Lighthouse"] = "Phare de Comté-Lointaine",
	["Farshire Mine"] = "Mine de Comté-Lointaine",
	["Farson Hold"] = "Bastion de Farson",
	["Farstrider Enclave"] = "Enclave des Pérégrins",
	["Farstrider Lodge"] = "Pavillon des Pérégrins",
	["Farstrider Retreat"] = "Retraite des Pérégrins",
	["Farstriders' Enclave"] = "Enclave des Pérégrins",
	["Farstriders' Square"] = "Place des Pérégrins",
	["Farwatcher's Glen"] = "Vallon du Long-Guetteur",
	["Farwatch Overlook"] = "Surplomb de Guette-Loin",
	["Far Watch Post"] = "Poste de Guet-Lointain",
	["Fear Clutch"] = "Étreinte de la peur",
	["Featherbeard's Hovel"] = "Taudis de Barbe-de-plumes",
	Feathermoon = "Pennelune",
	["Feathermoon Stronghold"] = "Bastion de Pennelune",
	["Fe-Feng Village"] = "Fe-Feng",
	["Felfire Hill"] = "Colline Gangrefeu",
	["Felpaw Village"] = "Village de Gangrepatte",
	["Fel Reaver Ruins"] = "Ruines des Saccageurs gangrenés",
	["Fel Rock"] = "Gangreroche",
	["Felspark Ravine"] = "Ravin de Gangrétincelle",
	["Felstone Field"] = "Champ de Gangrepierre",
	Felwood = "Gangrebois",
	["Fenris Isle"] = "Île de Fenris",
	["Fenris Keep"] = "Donjon de Fenris",
	Feralas = "Féralas",
	["Feralfen Village"] = "Tourbe-Farouche",
	["Feral Scar Vale"] = "Val des Griffes farouches",
	["Festering Pools"] = "Les bassins Purulents",
	["Festival Lane"] = "Allée du festival",
	["Feth's Way"] = "Voie de Feth",
	["Field of Korja"] = "Champ de Korja",
	["Field of Strife"] = "Champ Sanglant",
	["Fields of Blood"] = "Champs du Sang",
	["Fields of Honor"] = "Champs d’Honneur",
	["Fields of Niuzao"] = "Champs de Niuzao",
	Filming = "On filme",
	["Final Gate - Mogu Island Progression Scenario"] = "Dernière porte - Scénario de progression de l’île mogu",
	["Firebeard Cemetery"] = "Cimetière de Barbe-en-feu",
	["Firebeard's Patrol"] = "Patrouille de Barbe-en-feu",
	["Firebough Nook"] = "Retraite de Rameau-de-Feu",
	["Fire Camp Bataar"] = "Campement Bataar",
	["Fire Camp Gai-Cho"] = "Campement Gai-Cho",
	["Fire Camp Ordo"] = "Campement d’Ordo",
	["Fire Camp Osul"] = "Campement d’Osul",
	["Fire Camp Ruqin"] = "Campement Ruqin",
	["Fire Camp Yongqi"] = "Campement Yongqi",
	["Firegut Furnace"] = "Fournaise Brûlentrailles",
	Firelands = "Terres de Feu",
	["Firelands Forgeworks"] = "Haut-fourneau des terres de Feu",
	["Firelands Hatchery"] = "Couvoir des terres de Feu",
	["Firelands Terrain 2"] = "Terrain 2 de Terres de Feu",
	["Fireplume Peak"] = "Pic du Panache de feu",
	["Fire Plume Ridge"] = "Crête de la Fournaise",
	["Fireplume Trench"] = "Tranchée du Panache de feu",
	["Fire Scar Shrine"] = "Sanctuaire de Scarfeu",
	["Fire Stone Mesa"] = "Mesa de Pierrefeu",
	["Firestone Point"] = "Halte de Pierre-feu",
	["Firewatch Ridge"] = "Crête de Guet-du-Feu",
	["Firewing Point"] = "Halte Aile-de-feu",
	["First Bank of Kezan"] = "Banque Centrale de Kezan",
	["First Legion Forward Camp"] = "Camp avancé de la Première légion",
	["First to Your Aid"] = "Premier à votre secours",
	["Fishing Village"] = "Village de pêcheurs",
	["Fizzcrank Airstrip"] = "Piste d’atterrissage de Spumelevier",
	["Fizzcrank Pumping Station"] = "Station de pompage de Spumelevier",
	["Fizzle & Pozzik's Speedbarge"] = "Péniche de course de Féplouf et Pozzik",
	["Fjorn's Anvil"] = "L’enclume de Fjorn",
	Flamebreach = "Flammebrèche",
	["Flame Crest"] = "Corniche des Flammes",
	["Flamestar Post"] = "Poste de Flammétoile",
	["Flamewatch Tower"] = "Tour Guetteflamme",
	["Flavor - Stormwind Harbor - Stop"] = "Ambiance - Port de Hurlevent - Arrivée",
	["Fleshrender's Workshop"] = "Atelier de tranchechair",
	["Foothold Citadel"] = "Citadelle de Theramore",
	["Footman's Armory"] = "Armurerie des fantassins",
	["Force Interior"] = "Force intérieure",
	["Fordragon Hold"] = "Bastion Fordragon",
	["Forest Heart"] = "Cœur de la Forêt",
	["Forest's Edge"] = "La Lisière",
	["Forest's Edge Post"] = "Poste de la Lisière",
	["Forest Song"] = "Chant des forêts",
	["Forge Base: Gehenna"] = "Base de forge : Géhenne",
	["Forge Base: Oblivion"] = "Base de forge : Oubli",
	["Forge Camp: Anger"] = "Camp de forge : Colère",
	["Forge Camp: Fear"] = "Camp de forge : Peur",
	["Forge Camp: Hate"] = "Camp de forge : Haine",
	["Forge Camp: Mageddon"] = "Camp de forge : Mageddon",
	["Forge Camp: Rage"] = "Camp de forge : Rage",
	["Forge Camp: Terror"] = "Camp de forge : Terreur",
	["Forge Camp: Wrath"] = "Camp de forge : Courroux",
	["Forge of Fate"] = "La forge du Destin",
	["Forge of the Endless"] = "Forge des Éternels",
	["Forgewright's Tomb"] = "Tombe du Forgebusier",
	["Forgotten Depths"] = "Profondeurs oubliées",
	["Forgotten Hill"] = "La colline Oubliée",
	["Forgotten Mire"] = "Le bourbier Oublié",
	["Forgotten Passageway"] = "Le passage Oublié",
	["Forlorn Cloister"] = "Cloître solitaire",
	["Forlorn Hut"] = "La hutte Lugubre",
	["Forlorn Ridge"] = "La crête Lugubre",
	["Forlorn Rowe"] = "La masure Lugubre",
	["Forlorn Spire"] = "La flèche Lugubre",
	["Forlorn Woods"] = "Bois Lugubre",
	["Formation Grounds"] = "Champ d’Entraînement",
	["Forsaken Forward Command"] = "Quartier général avancé des Réprouvés",
	["Forsaken High Command"] = "Haut-commandement Réprouvé",
	["Forsaken Rear Guard"] = "Arrière-garde des Réprouvés",
	["Fort Livingston"] = "Fort-Livingston",
	["Fort Silverback"] = "Fort Dos-Argenté",
	["Fort Triumph"] = "Fort-Triomphe",
	["Fortune's Fist"] = "Le Poing de la fortune",
	["Fort Wildervar"] = "Fort Hardivar",
	["Forward Assault Camp"] = "Camp d’assaut Avancé",
	["Forward Command"] = "Quartier général Avancé",
	["Foulspore Cavern"] = "Caverne Vilespore",
	["Foulspore Pools"] = "Bassins Vilespore",
	["Fountain of the Everseeing"] = "Fontaine des Témoins éternels",
	["Fox Grove"] = "Bosquet du Renard",
	["Fractured Front"] = "Front Ravagé",
	["Frayfeather Highlands"] = "Hautes-terres des Aigreplumes",
	["Fray Island"] = "Île de la Dispute",
	["Frazzlecraz Motherlode"] = "Veine de Folcrame",
	["Freewind Post"] = "Poste de Librevent",
	["Frenzyheart Hill"] = "Colline de Frénécœur",
	["Frenzyheart River"] = "Rivière de Frénécœur",
	["Frigid Breach"] = "Brèche Algide",
	["Frostblade Pass"] = "Passe de Givrelame",
	["Frostblade Peak"] = "Pic de Givrelame",
	["Frostclaw Den"] = "Tanière Griffe-de-Givre",
	["Frost Dagger Pass"] = "Défilé de la Dague de givre",
	["Frostfield Lake"] = "Lac du Champ-gelé",
	["Frostfire Hot Springs"] = "Sources de Givrefeu",
	["Frostfloe Deep"] = "Gouffre du Sérac",
	["Frostgrip's Hollow"] = "Creux de Poignegivre",
	Frosthold = "Fort du Givre",
	["Frosthowl Cavern"] = "Caverne des Hurlegivres",
	["Frostmane Front"] = "Front Crins-de-Givre",
	["Frostmane Hold"] = "Repaire des Crins-de-Givre",
	["Frostmane Hovel"] = "Taudis des Crins-de-Givre",
	["Frostmane Retreat"] = "Retraite des Crins-de-Givre",
	Frostmourne = "Deuillegivre",
	["Frostmourne Cavern"] = "Caverne de Deuillegivre",
	["Frostsaber Rock"] = "Roc des Sabres-de-Givre",
	["Frostwhisper Gorge"] = "Gorge du Blanc murmure",
	["Frostwing Halls"] = "Salles de l'Aile de givre",
	["Frostwolf Graveyard"] = "Cimetière Loup-de-givre",
	["Frostwolf Keep"] = "Donjon Loup-de-givre",
	["Frostwolf Pass"] = "Col Loup-de-givre",
	["Frostwolf Tunnel"] = "Tunnel des Loups-de-givre",
	["Frostwolf Village"] = "Village Loup-de-givre",
	["Frozen Reach"] = "Les confins Gelés",
	["Fungal Deep"] = "Les profondeurs Fongiques",
	["Fungal Rock"] = "Rocher Fongique",
	["Funggor Cavern"] = "Caverne de Funggor",
	["Furien's Post"] = "Poste de Furien",
	["Furlbrow's Pumpkin Farm"] = "Ferme de potirons des Froncebouille",
	["Furnace of Hate"] = "Fournaise de la haine",
	["Furywing's Perch"] = "Perchoir d’Aile-furie",
	Fuselight = "Lumèche",
	["Fuselight-by-the-Sea"] = "Lumèche-sur-Mer",
	["Fu's Pond"] = "Étang de Fu",
	Gadgetzan = "Gadgetzan",
	["Gahrron's Withering"] = "La Flétrissure de Gahrron",
	["Gai-Cho Battlefield"] = "Champ de bataille de Gai Cho",
	["Galak Hold"] = "Repaire des Galak",
	["Galakrond's Rest"] = "Le Repos de Galakrond",
	["Galardell Valley"] = "Vallée de Galardell",
	["Galen's Fall"] = "Chute de Galen",
	["Galerek's Remorse"] = "Le remords de Galerek",
	["Galewatch Lighthouse"] = "Phare de Garde-trombe",
	["Gallery of Treasures"] = "Galerie des trésors",
	["Gallows' Corner"] = "Fourche du Gibet",
	["Gallows' End Tavern"] = "Taverne des Pendus",
	["Gallywix Docks"] = "Quais de Gallywix",
	["Gallywix Labor Mine"] = "Mine de travail de Gallywix",
	["Gallywix Pleasure Palace"] = "Palais des plaisirs de Gallywix",
	["Gallywix's Villa"] = "Villa de Gallywix",
	["Gallywix's Yacht"] = "Voilier de Gallywix",
	["Galus' Chamber"] = "Chambre de Galus",
	["Gamesman's Hall"] = "Hall du Flambeur",
	Gammoth = "Gammoth",
	["Gao-Ran Battlefront"] = "Ligne de front de Gao Ran",
	Garadar = "Garadar",
	["Gar'gol's Hovel"] = "Taudis de Gar’gol",
	Garm = "Garm",
	["Garm's Bane"] = "Plaie-de-Garm",
	["Garm's Rise"] = "Cime de Garm",
	["Garren's Haunt"] = "Antre de Garren",
	["Garrison Armory"] = "Armurerie de la garnison",
	["Garrosh'ar Advance"] = "Base avancée Garrosh’ar",
	["Garrosh'ar Point"] = "Point Garrosh’ar",
	["Garrosh's Landing"] = "Point d’accostage de Garrosh",
	["Garvan's Reef"] = "Récif de Garvan",
	["Gate of Echoes"] = "Porte des Échos",
	["Gate of Endless Spring"] = "Porte Printanière",
	["Gate of Hamatep"] = "Porte d’Hamatep",
	["Gate of Lightning"] = "Porte de la Foudre",
	["Gate of the August Celestials"] = "Porte des Astres vénérables",
	["Gate of the Blue Sapphire"] = "Porte du Saphir bleu",
	["Gate of the Green Emerald"] = "Porte de l’Émeraude verte",
	["Gate of the Purple Amethyst"] = "Porte de l’Améthyste violette",
	["Gate of the Red Sun"] = "Porte du Soleil rouge",
	["Gate of the Setting Sun"] = "Porte du Soleil couchant",
	["Gate of the Yellow Moon"] = "Porte de la Lune jaune",
	["Gates of Ahn'Qiraj"] = "Portes d’Ahn’Qiraj",
	["Gates of Ironforge"] = "Portes de Forgefer",
	["Gates of Sothann"] = "Portes de Sothann",
	["Gauntlet of Flame"] = "Le Défi de la flamme",
	["Gavin's Naze"] = "Promontoire de Gavin",
	["Geezle's Camp"] = "Camp de Geezle",
	["Gelkis Village"] = "Village des Gelkis",
	["General Goods"] = "Fournitures générales",
	["General's Terrace"] = "Terrasse du Général",
	["Ghostblade Post"] = "Poste de la Lame-fantôme",
	Ghostlands = "Les terres Fantômes",
	["Ghost Walker Post"] = "Poste de Rôdeur-fantôme",
	["Giant's Run"] = "La piste des Géants",
	["Giants' Run"] = "La piste des Géants",
	["Gilded Fan"] = "Le delta Doré",
	["Gillijim's Isle"] = "Île de Gillijim",
	["Gilnean Coast"] = "Côte Gilnéenne",
	["Gilnean Stronghold"] = "Bastion Gilnéen",
	Gilneas = "Gilnéas",
	Gilneas2 = "Gilnéas 2",
	["Gilneas City"] = "Gilnéas",
	["Gilneas (Do Not Reuse)"] = "Gilnéas",
	["Gilneas Liberation Front Base Camp"] = "Campement du Front de libération de Gilnéas",
	GilneasPhase1 = "Gilnéas phase 1",
	GilneasPhase2 = "Gilnéas phase 2",
	["Gimorak's Den"] = "Tanière de Gimorak",
	Gjalerbron = "Gjalerbron",
	Gjalerhorn = "Gjalercorne",
	["Glacial Falls"] = "Chutes Glaciales",
	["Glimmer Bay"] = "Baie Scintillante",
	["Glimmerdeep Gorge"] = "Gorge du Gouffre scintillant",
	["Glittering Strand"] = "Grève Lumineuse",
	["Glopgut's Hollow"] = "Creux des Crassentrailles",
	["Glorious Goods"] = "Fournitures glorieuses",
	Glory = "Gloire",
	["GM Island"] = "Île des MJ",
	["Gnarlpine Hold"] = "Camp des Pins-tordus",
	["Gnaws' Boneyard"] = "Charnier de Ronge-la-mort",
	Gnomeregan = "Gnomeregan",
	["Gobline Mine"] = "Mine gobeline",
	["Goblin Foundry"] = "Fonderie des gobelins",
	["Goblin Mine"] = "Mine gobeline",
	["Goblin Slums"] = "Bas-fonds des Gobelins",
	["Gokk'lok's Grotto"] = "Grotte de Gokk’lok",
	["Gokk'lok Shallows"] = "Hauts-fonds de Gokk’lok",
	["Golakka Hot Springs"] = "Sources de Golakka",
	["Gol'Bolar Quarry"] = "Carrière de Gol’Bolar",
	["Gol'Bolar Quarry Mine"] = "Mine de la carrière de Gol’Bolar",
	["Gold Coast Quarry"] = "Carrière de la Côte de l’or",
	["Goldenbough Pass"] = "Passe du Rameau d’or",
	["Goldenmist Village"] = "Brume-d’or",
	["Golden Strand"] = "Grève dorée",
	["Gold Mine"] = "Mine d’or",
	["Gold Road"] = "Route de l’Or",
	["Gold Rush BG"] = "CdB ruée vers l’or",
	Goldshire = "Comté-de-l’Or",
	["Goldtooth's Den"] = "Tanière de Dent-d’or",
	["Goodgrub Smoking Pit"] = "Fosse de fumage de Bonrata",
	["Gordok's Seat"] = "Trône gordok",
	["Gordunni Outpost"] = "Avant-poste des Gordunni",
	["Gorefiend's Vigil"] = "Veillée de Fielsang",
	["Gor'gaz Outpost"] = "Avant-poste de Gor’gaz",
	Gornia = "Gornia",
	["Gorrok's Lament"] = "Lamentation de Gorrok",
	["Gorshak War Camp"] = "Camp de guerre Gorshak",
	["Go'Shek Farm"] = "Ferme de Go’Shek",
	["Grain Cellar"] = "Silo à Grains",
	["Grand Courtyard"] = "La Grande cour",
	["Grand Magister's Asylum"] = "Asile du grand magistère",
	["Grand Overlook"] = "Le Grand surplomb",
	["Grand Promenade"] = "La Grande promenade",
	["Grangol'var Village"] = "Grangol’var",
	["Granite Springs"] = "Sources de Granit",
	["Grassy Cline"] = "Versant Verdoyant",
	["Greatwood Vale"] = "Val de Grandbois",
	["Greengill Coast"] = "Côte de Verte-branchie",
	["Greenpaw Village"] = "Village des Pattes-vertes",
	["Greenstone Dojo"] = "Dojo de Pierre-Verte",
	["Greenstone Inn"] = "Auberge de Pierre-Verte",
	["Greenstone Masons' Quarter"] = "Quartier des Maçons de Pierre-Verte",
	["Greenstone Quarry"] = "Carrière de Pierre-Verte",
	["Greenstone Village"] = "Pierre-Verte",
	["Greenwarden's Grove"] = "Bosquet du Gardien vert",
	["Greymane Court"] = "Cour de Grisetête",
	["Greymane Manor"] = "Manoir de Grisetête",
	["Greymist Firth"] = "Estuaire de Grisebrume",
	["Grim Batol"] = "Grim Batol",
	["Grim Batol Entrance"] = "Entrée de Grim Batol",
	["Grimesilt Dig Site"] = "Site de fouilles de Crasseboue",
	["Grimtotem Compound"] = "Base des Totems-sinistres",
	["Grimtotem Post"] = "Poste Totem-sinistre",
	Grishnath = "Grishnath",
	Grizzlemaw = "Grisegueule",
	["Grizzlepaw Ridge"] = "Falaise de Vieillegriffe",
	["Grizzly Hills"] = "Les Grisonnes",
	["Grol'dom Farm"] = "Ferme de Grol’dom",
	["Grolluk's Grave"] = "Tombe de Grolluk",
	["Grom'arsh Crash-Site"] = "Point d’impact de Grom’arsh",
	["Grom'gol"] = "Grom'gol",
	["Grom'gol Base Camp"] = "Campement Grom’gol",
	["Grommash Hold"] = "Fort Grommash",
	["Grookin Hill"] = "Tertre des Groukards",
	["Grosh'gok Compound"] = "Base des Grosh’gok",
	["Grove of Aessina"] = "Bosquet d’Aessina",
	["Grove of Falling Blossoms"] = "Bosquet des Fleurs fanées",
	["Grove of the Ancients"] = "Bosquet des Anciens",
	["Growless Cave"] = "Caverne Stérile",
	["Gruul's Lair"] = "Repaire de Gruul",
	["Gryphon Roost"] = "Perchoir des griffons",
	["Guardian's Library"] = "Bibliothèque du Gardien",
	Gundrak = "Gundrak",
	["Gundrak Entrance"] = "Entrée de Gundrak",
	["Gunstan's Dig"] = "Site de fouilles de Gunstan",
	["Gunstan's Post"] = "Poste de Gunstan",
	["Gunther's Retreat"] = "Retraite de Gunther",
	["Guo-Lai Halls"] = "Salles de Guo-Lai",
	["Guo-Lai Ritual Chamber"] = "Chambre rituelle de Guo-Lai",
	["Guo-Lai Vault"] = "Caveau de Guo-Lai",
	["Gurboggle's Ledge"] = "Escarpement de Globulle",
	["Gurubashi Arena"] = "Arène des Gurubashi",
	["Gyro-Plank Bridge"] = "Pont de Gyro-passerelles",
	["Haal'eshi Gorge"] = "Gorge Haal’eshi",
	["Hadronox's Lair"] = "Le repaire d'Hadronox",
	["Hailwood Marsh"] = "Marais de Bois-grêlé",
	Halaa = "Halaa",
	["Halaani Basin"] = "Bassin Halaani",
	["Halcyon Egress"] = "Émergence d’Halcyon",
	["Haldarr Encampment"] = "Campement des Haldarr",
	Halfhill = "Micolline",
	Halgrind = "Halegrince",
	["Hall of Arms"] = "Salle d’armes",
	["Hall of Binding"] = "Hall des liens",
	["Hall of Blackhand"] = "Hall de Main-noire",
	["Hall of Blades"] = "La salle des épées",
	["Hall of Bones"] = "Hall des Ossements",
	["Hall of Champions"] = "Hall des Champions",
	["Hall of Command"] = "Salle de commande",
	["Hall of Crafting"] = "Chambre de l'artisanat",
	["Hall of Departure"] = "Hall du départ",
	["Hall of Explorers"] = "Hall des Explorateurs",
	["Hall of Faces"] = "Hall des visages",
	["Hall of Horrors"] = "Salle des Horreurs",
	["Hall of Illusions"] = "Salle des Illusions",
	["Hall of Kings"] = "Salle des Rois",
	["Hall of Legends"] = "Hall des Légendes",
	["Hall of Masks"] = "Hall des masques",
	["Hall of Memories"] = "Salle des souvenirs",
	["Hall of Mysteries"] = "Hall des mystères",
	["Hall of Repose"] = "Hall de la quiétude",
	["Hall of Return"] = "Hall du retour",
	["Hall of Ritual"] = "Hall du rituel",
	["Hall of Secrets"] = "Hall des secrets",
	["Hall of Serpents"] = "Hall des serpents",
	["Hall of Shapers"] = "Hall des Modeleurs",
	["Hall of Stasis"] = "Hall de la stase",
	["Hall of the Brave"] = "Hall des Braves",
	["Hall of the Conquered Kings"] = "Salle des Rois conquis",
	["Hall of the Crafters"] = "Hall des Artisans",
	["Hall of the Crescent Moon"] = "Salle du Croissant de lune",
	["Hall of the Crusade"] = "Salle de la Croisade",
	["Hall of the Cursed"] = "Hall des maudits",
	["Hall of the Damned"] = "Hall des damnés",
	["Hall of the Defamed"] = "Salle des Décriés",
	["Hall of the Exalted"] = "Salle des Exaltés",
	["Hall of the Fathers"] = "La salle des Pères",
	["Hall of the Frostwolf"] = "Hall des Loups-de-givre",
	["Hall of the Grand Imperion"] = "Salle du Grand impérion",
	["Hall of the High Father"] = "La salle du Haut père",
	["Hall of the Keepers"] = "Hall des Gardiens",
	["Hall of the Shaper"] = "Hall du Façonneur",
	["Hall of the Stormpike"] = "Hall des Foudrepiques",
	["Hall of the Tortured"] = "Hall des Suppliciés",
	["Hall of the Watchers"] = "Hall des Guetteurs",
	["Hall of the Wicked"] = "Hall des Malveillants",
	["Hall of Tombs"] = "Salle des Tombeaux",
	["Hall of Tranquility"] = "Salle de la Tranquillité",
	["Hall of Tranquillity"] = "Hall de la Tranquillité",
	["Hall of Twilight"] = "Hall du Crépuscule",
	["Halls of Anguish"] = "Les salles de l’Angoisse",
	["Halls of Awakening"] = "Salles de l'Éveil",
	["Halls of Binding"] = "Salles de Lien",
	["Halls of Destruction"] = "Halls de la Destruction",
	["Halls of Flesh-Shaping"] = "Salles des Sculpte-Chair",
	["Halls of Lightning"] = "Les salles de Foudre",
	["Halls of Lightning Entrance"] = "Entrée des salles de Foudre",
	["Halls of Mourning"] = "Les salles du Deuil",
	["Halls of Origination"] = "Salles de l’Origine",
	["Halls of Origination Entrance"] = "Entrée des salles de l’Origine",
	["Halls of Reflection"] = "Salles des Reflets",
	["Halls of Reflection Entrance"] = "Entrée des salles des Reflets",
	["Halls of Silence"] = "Les salles du Silence",
	["Halls of Stone"] = "Les salles de Pierre",
	["Halls of Stone Entrance"] = "Entrée des salles de Pierre",
	["Halls of Strife"] = "Halls des conflits",
	["Halls of the Ancestors"] = "Salles des Ancêtres",
	["Halls of the Hereafter"] = "Les salles de l'Après-vie",
	["Halls of the Law"] = "Halls de la loi",
	["Halls of Theory"] = "Les salles de théorie",
	["Halycon's Lair"] = "Antre d'Halycon",
	Hammerfall = "Trépas-d’Orgrim",
	["Hammertoe's Digsite"] = "Site de fouilles de Martèlorteil",
	["Hammond Farmstead"] = "Ferme des Hammond",
	Hangar = "Hangar",
	["Hardknuckle Clearing"] = "Clairière des Poings-durs",
	["Hardwrench Hideaway"] = "Planque de Serrelavis",
	["Harkor's Camp"] = "Camp de Harkor",
	["Hatchet Hills"] = "Collines de la Cognée",
	["Hatescale Burrow"] = "Terrier Hainécaille",
	["Hatred's Vice"] = "Étau de la haine",
	Havenshire = "Havre-Comté",
	["Havenshire Farms"] = "Fermes de Havre-Comté",
	["Havenshire Lumber Mill"] = "Scierie de Havre-Comté",
	["Havenshire Mine"] = "Mine de Havre-Comté",
	["Havenshire Stables"] = "Écurie de Havre-Comté",
	["Hayward Fishery"] = "Pêcheries Hayward",
	["Headmaster's Retreat"] = "Retraite du Maître",
	["Headmaster's Study"] = "Bureau du proviseur",
	Hearthglen = "Âtreval",
	["Heart of Destruction"] = "Cœur de la destruction",
	["Heart of Fear"] = "Cœur de la peur",
	["Heart of the Old God Scenario"] = "Scénario du Cœur des Dieux très anciens",
	["Heart of Zan'vess"] = "Cœur de Zan’vess",
	["Heart's Blood Shrine"] = "Sanctuaire du Sang du cœur",
	["Heartwood Trading Post"] = "Comptoir de Cœur-du-bois",
	["Heb'Drakkar"] = "Heb’Drakkar",
	["Heb'Valok"] = "Heb’Valok",
	["Hellfire Basin"] = "Bassin des Flammes infernales",
	["Hellfire Citadel"] = "Citadelle des Flammes infernales",
	["Hellfire Citadel: Ramparts"] = "Citadelle des Flammes infernales : les Remparts",
	["Hellfire Citadel - Ramparts Entrance"] = "Citadelle des Flammes infernales - Entrée des remparts",
	["Hellfire Citadel: The Blood Furnace"] = "Citadelle des Flammes infernales : la Fournaise du sang",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Citadelle des Flammes infernales - Entrée de la Fournaise du sang",
	["Hellfire Citadel: The Shattered Halls"] = "Citadelle des Flammes infernales : les Salles brisées",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Citadelle des Flammes infernales - Entrée des salles Brisées",
	["Hellfire Peninsula"] = "Péninsule des Flammes infernales",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Péninsule des Flammes infernales",
	["Hellfire Peninsula - Reaver's Fall"] = "Péninsule des Flammes infernales - Trépas du saccageur",
	["Hellfire Ramparts"] = "Remparts des Flammes infernales",
	["Hellscream Arena"] = "Arène de Hurlenfer",
	["Hellscream's Camp"] = "Campement de Hurlenfer",
	["Hellscream's Fist"] = "Poing de Hurlenfer",
	["Hellscream's Grasp"] = "Emprise de Hurlenfer",
	["Hellscream's Watch"] = "Guet de Hurlenfer",
	["Helm's Bed Lake"] = "Lac du Lit d’Helm",
	["Heroes' Vigil"] = "Veillée des héros",
	["Hetaera's Clutch"] = "Frai d’Hetaera",
	["Hewn Bog"] = "Tourbière Taillée",
	["Heyman's Hubris"] = "L’orgueil de Heyman",
	["Hibernal Cavern"] = "Caverne de l’Hibernation",
	["Hidden Cell"] = "Cellule secrète",
	["Hidden Path"] = "Chemin Secret",
	Highbank = "Hauterive",
	["High Bank"] = "Hauterive",
	["Highland Forest"] = "Forêt des Hautes-terres",
	Highperch = "Haut-Perchoir",
	["High Wilderness"] = "Les plateaux Sauvages",
	Hillsbrad = "Hautebrande",
	["Hillsbrad Fields"] = "Champs de Hautebrande",
	["Hillsbrad Foothills"] = "Contreforts de Hautebrande",
	["Hiri'watha Research Station"] = "Centre de recherche d’Hiri’watha",
	["Hive'Ashi"] = "Ruche’Ashi",
	["Hive'Regal"] = "Ruche’Regal",
	["Hive'Zora"] = "Ruche’Zora",
	["Hogger Hill"] = "Colline de Lardeur",
	["Hollowed Out Tree"] = "L’Arbre creux",
	["Hollowstone Mine"] = "Mine de la Pierre creuse",
	["Honeydew Farm"] = "Ferme Rosée-de-Miel",
	["Honeydew Glade"] = "Clairière de Rosée-de-Miel",
	["Honeydew Village"] = "Rosée-de-Miel",
	["Honor Hold"] = "Bastion de l’Honneur",
	["Honor Hold Mine"] = "Mine du bastion de l'Honneur",
	["Honor Point"] = "Halte de l'Honneur",
	["Honor's Stand"] = "Le Séjour de l’honneur",
	["Honor's Tomb"] = "Tombe de l’Honneur",
	["Horde Base Camp"] = "Camp de base de la Horde",
	["Horde Beach Daily Area"] = "Plage de la Horde - Zone de quêtes journalières",
	["Horde Encampment"] = "Campement de la Horde",
	["Horde Keep"] = "Donjon de la Horde",
	["Horde Landing"] = "Arrivée de la Horde",
	["Horde Landing Site"] = "Lieu de débarquement de la Horde",
	["Hordemar City"] = "Cité d'Hordemar",
	["Horde PVP Barracks"] = "Baraquements Horde JcJ",
	["Horror Clutch"] = "Étreinte de l’horreur",
	["Hour of Twilight"] = "L’Heure du Crépuscule",
	["House of Edune"] = "Maison d’Edune",
	["Howling Fjord"] = "Fjord Hurlant",
	["Howlingwind Cavern"] = "Caverne du Vent hurlant",
	["Howlingwind Trail"] = "Piste du Vent hurlant",
	["Howling Ziggurat"] = "Ziggourat Hurlante",
	["Hrothgar's Landing"] = "Accostage de Hrothgar",
	["Huangtze Falls"] = "Chutes de Huangtze",
	["Hull of the Foebreaker"] = "Coque du Tranche-menace",
	["Humboldt Conflagration"] = "Déflagration de Humboldt",
	["Hunter Rise"] = "Cime des Chasseurs",
	["Hunter's Hill"] = "Colline du Chasseur",
	["Huntress of the Sun"] = "Chasseresse du soleil",
	["Huntsman's Cloister"] = "Cloître du veneur",
	Hyjal = "Hyjal",
	["Hyjal Barrow Dens"] = "Refuge des saisons d’Hyjal",
	["Hyjal Past"] = "Passé d’Hyjal",
	["Hyjal Summit"] = "Sommet d’Hyjal",
	["Iceblood Garrison"] = "Garnison de Glace-sang",
	["Iceblood Graveyard"] = "Cimetière de Glace-sang",
	Icecrown = "La Couronne de glace",
	["Icecrown Citadel"] = "Citadelle de la Couronne de glace",
	["Icecrown Dungeon - Gunships"] = "Donjon de la couronne de glace - Canonnières",
	["Icecrown Glacier"] = "Glacier de la Couronne de glace",
	["Iceflow Lake"] = "Lac Glacial",
	["Ice Heart Cavern"] = "Caverne du Cœur de glace",
	["Icemist Falls"] = "Chutes de Brume-glace",
	["Icemist Village"] = "Brume-glace",
	["Ice Thistle Hills"] = "Collines des Chardons de glace",
	["Icewing Bunker"] = "Fortin de l’Aile de glace",
	["Icewing Cavern"] = "Caverne de l’Aile de glace",
	["Icewing Pass"] = "Défilé de l’Aile de glace",
	["Idlewind Lake"] = "Lac Idlewind",
	["Igneous Depths"] = "Profondeurs ignées",
	["Ihgaluk Crag"] = "Combe d’Ihgaluk",
	["Ik'vess"] = "Ik’vess",
	["Ikz'ka Ridge"] = "Crête d’Ikz’ka",
	["Illidari Point"] = "Halte Illidari",
	["Illidari Training Grounds"] = "Terrain d’entraînement Illidari",
	["Indu'le Village"] = "Indu’le",
	["Infiltrating the Shipyard"] = "Infiltrer le chantier naval",
	["Inkgill Mere"] = "Étang des Branchies-d’encre",
	Inn = "Auberge",
	["Inner Sanctum"] = "Sanctum intérieur",
	["Inner Veil"] = "Voile intérieur",
	["Insidion's Perch"] = "Perchoir d’Insidion",
	["Invasion Point: Annihilator"] = "Site d’invasion : Annihilateur",
	["Invasion Point: Cataclysm"] = "Site d’invasion : Cataclysme",
	["Invasion Point: Destroyer"] = "Site d’invasion : Destructeur",
	["Invasion Point: Overlord"] = "Site d’invasion : Suzerain",
	["Ironband's Compound"] = "Base de Baguefer",
	["Ironband's Excavation Site"] = "Excavations de Baguefer",
	["Ironbeard's Tomb"] = "Tombe de Barbe-de-fer",
	["Ironclad Cove"] = "Crique du Cuirassé",
	["Ironclad Garrison"] = "Garnison du Cuirassé",
	["Ironclad Prison"] = "Prison du Cuirassé",
	["Iron Concourse"] = "Corridor de Fer",
	["Irondeep Mine"] = "Mine de Gouffrefer",
	Ironforge = "Forgefer",
	["Ironforge Airfield"] = "Aérodrome de Forgefer",
	["Ironstone Camp"] = "Camp Rochefer",
	["Ironstone Plateau"] = "Plateau de Rochefer",
	["Iron Summit"] = "Sommet de Fer",
	["Irontree Cavern"] = "Caverne d’Arbrefer",
	["Irontree Clearing"] = "Clairière d’Arbrefer",
	["Irontree Woods"] = "Bois d’Arbrefer",
	["Ironwall Dam"] = "Barrage Mur-de-fer",
	["Ironwall Rampart"] = "Rempart Mur-de-fer",
	["Ironwing Cavern"] = "Grotte Aile-de-fer",
	Iskaal = "Iskaal",
	["Island of Doctor Lapidis"] = "Île du docteur Lapidis",
	["Isle of Conquest"] = "Île des Conquérants",
	["Isle of Conquest No Man's Land"] = "No man’s land de l’île des Conquérants",
	["Isle of Dread"] = "Île de l’Effroi",
	["Isle of Giants"] = "Île des Géants",
	["Isle of Quel'Danas"] = "Île de Quel’Danas",
	["Isle of Reckoning"] = "L’île du Jugement",
	["Isle of Thunder"] = "Île du Tonnerre",
	["Isle of Tribulations"] = "Île des Tribulations",
	["Iso'rath"] = "Iso’rath",
	["Itharius's Cave"] = "Caverne d'Itharius",
	["Ivald's Ruin"] = "Ruines d’Ivald",
	["Ix'lar's Domain"] = "Domaine d’Ix’lar",
	["Jadefire Glen"] = "Vallon des Jadefeu",
	["Jadefire Run"] = "Défilé des Jadefeu",
	["Jade Forest Alliance Hub Phase"] = "Phase Alliance de la forêt de Jade",
	["Jade Forest Battlefield Phase"] = "Phase champ de bataille de la forêt de Jade",
	["Jade Forest Horde Starting Area"] = "Zone de départ de la Horde dans la forêt de Jade",
	["Jademir Lake"] = "Lac Jademir",
	["Jade Temple Grounds"] = "Jardins du Temple de jade",
	Jaedenar = "Jaedenar",
	["Jagged Reef"] = "Récif Déchiqueté",
	["Jagged Ridge"] = "La crête Dentelée",
	["Jaggedswine Farm"] = "Ferme Rêche-pourceau",
	["Jagged Wastes"] = "Désert Déchiqueté",
	["Jaguero Isle"] = "Île aux Jagueros",
	["Jaina Dalaran Scenario"] = "Scénario : Jaina à Dalaran",
	["Janeiro's Point"] = "Cap Janeiro",
	["Jangolode Mine"] = "Mine Veine-de-Jango",
	["Jaquero Isle"] = "Île aux jagueros",
	["Jasperlode Mine"] = "Mine Veine-de-Jaspe",
	["Jeff NE Quadrant Changed"] = "Quadrant NE de Jeff modifié",
	["Jeff NW Quadrant"] = "Quadrant de Jeff NO",
	["Jeff SE Quadrant"] = "Quadrant de Jeff SE",
	["Jeff SW Quadrant"] = "Quadrant de Jeff SO",
	["Jerod's Landing"] = "Le débarcadère de Jerod",
	["Jintha'Alor"] = "Jintha’Alor",
	["Jintha'kalar"] = "Jintha’kalar",
	["Jintha'kalar Passage"] = "Passage de Jintha’kalar",
	["Jin Yang Road"] = "Route de Jin Yang",
	Jotunheim = "Jotunheim",
	K3 = "K3",
	["Kaja'mine"] = "Kaja’mine",
	["Kaja'mite Cave"] = "Grotte de Kaja'mite",
	["Kaja'mite Cavern"] = "Caverne de Kaja’mite",
	["Kajaro Field"] = "Parc des Princes marchands",
	["Kal'ai Ruins"] = "Ruines de Kal’ai",
	Kalimdor = "Kalimdor",
	Kamagua = "Kamagua",
	["Karabor Sewers"] = "Égouts de Karabor",
	Karazhan = "Karazhan",
	["Kargathia Keep"] = "Donjon de Kargathia",
	["Karnum's Glade"] = "Clairière de Karnum",
	["Kartak's Hold"] = "Bastion de Kartak",
	Kaskala = "Kaskala",
	["Kaw's Roost"] = "Perchoir de Kaw",
	["Kea Krak"] = "Krak de Kea",
	["Keelen's Trustworthy Tailoring"] = "Haute couture de Keelen",
	["Keel Harbor"] = "Quilleport",
	["Keeshan's Post"] = "Poste de Keeshan",
	["Kelp'thar Forest"] = "Forêt de Varech’thar",
	["Kel'Thuzad Chamber"] = "Appartements de Kel'Thuzad",
	["Kel'Thuzad's Chamber"] = "Appartements de Kel'Thuzad",
	["Keset Pass"] = "Passe de Keset",
	["Kessel's Crossing"] = "La croisée de Kessel",
	Kezan = "Kezan",
	Kharanos = "Kharanos",
	["Khardros' Anvil"] = "L'enclume de Khardros",
	["Khartut's Tomb"] = "Tombe de Khartut",
	["Khaz'goroth's Seat"] = "Siège de Khaz'goroth",
	["Ki-Han Brewery"] = "Brasserie Ki-Han",
	["Kili'ua's Atoll"] = "Atoll de Kili’ua",
	["Kil'sorrow Fortress"] = "Forteresse Kil’sorrau",
	["King's Gate"] = "Porte du Roi",
	["King's Harbor"] = "Port-royal",
	["King's Hoard"] = "Trésor royal",
	["King's Square"] = "Place du Roi",
	["Kirin'Var Village"] = "Kirin’Var",
	Kirthaven = "Havran’iliz",
	["Klaxxi'vess"] = "Klaxxi’vess",
	["Klik'vess"] = "Klik’vess",
	["Knucklethump Hole"] = "Trou des Coups-de-poing",
	["Kodo Graveyard"] = "Cimetière des Kodos",
	["Kodo Rock"] = "Rocher des Kodos",
	["Kolkar Village"] = "Village des Kolkars",
	Kolramas = "Kolramas",
	["Kor'kron Vanguard"] = "Avant-garde Kor’kronne",
	["Kormek's Hut"] = "Hutte de Kormek",
	["Koroth's Den"] = "Tanière de Koroth",
	["Korthun's End"] = "Fin de Korthun",
	["Kor'vess"] = "Kor’vess",
	["Kota Basecamp"] = "Camp de base de Kota",
	["Kota Peak"] = "Pic de Kota",
	["Krasarang Cove"] = "Crique de Krasarang",
	["Krasarang River"] = "Rivière de Krasarang",
	["Krasarang Wilds"] = "Étendues sauvages de Krasarang",
	["Krasari Falls"] = "Chutes Krasari",
	["Krasus' Landing"] = "Aire de Krasus",
	["Krazzworks Attack Zeppelin"] = "Zeppelin d'attaque du Kraazar",
	["Kril'Mandar Point"] = "Halte de Kril’Mandar",
	["Kri'vess"] = "Kri’vess",
	["Krolg's Hut"] = "Hutte de Krolg",
	["Krom'gar Fortress"] = "Forteresse Krom’gar",
	["Krom's Landing"] = "Point d’ancrage de Krom",
	["KTC Headquarters"] = "Quartier général de la SCK",
	["KTC Oil Platform"] = "Plate-forme pétrolière de la SCK",
	["Kul'galar Keep"] = "Donjon de Kul’galar",
	["Kul Tiras"] = "Kul Tiras",
	["Kun-Lai Pass"] = "Passage de Kun-Lai",
	["Kun-Lai Summit"] = "Sommet de Kun-Lai",
	["Kunzen Cave"] = "Caverne des Kunzen",
	["Kunzen Village"] = "Kunzen",
	["Kurzen's Compound"] = "Base de Kurzen",
	["Kypari Ik"] = "Kypari Ik",
	["Kyparite Quarry"] = "Carrière de kyparite",
	["Kypari Vor"] = "Kypari Vor",
	["Kypari Zar"] = "Kypari Zar",
	["Kzzok Warcamp"] = "Camp de guerre Kzzok",
	["Lair of Skiggit"] = "Repaire de Skiggit",
	["Lair of the Beast"] = "Le repaire de la Bête",
	["Lair of the Chosen"] = "Repaire de l’Élu",
	["Lair of the Jade Witch"] = "Repaire de la Sorcière de jade",
	["Lair of Tortos"] = "Repaire de Tortos",
	["Lake Al'Ameth"] = "Lac Al’Ameth",
	["Lake Cauldros"] = "Lac Calderos",
	["Lake Dumont"] = "Lac Dumont",
	["Lake Edunel"] = "Lac Edunel",
	["Lake Elrendar"] = "Lac Elrendar",
	["Lake Elune'ara"] = "Lac Élune’ara",
	["Lake Ere'Noru"] = "Lac Ere’Noru",
	["Lake Everstill"] = "Lac Placide",
	["Lake Falathim"] = "Lac Falathim",
	["Lake Indu'le"] = "Lac Indu’le",
	["Lake Jorune"] = "Lac Jorune",
	["Lake Kel'Theril"] = "Lac Kel’Theril",
	["Lake Kittitata"] = "Lac Kittitata",
	["Lake Kum'uya"] = "Lac Kum’uya",
	["Lake Mennar"] = "Lac Mennar",
	["Lake Mereldar"] = "Lac Mereldar",
	["Lake Nazferiti"] = "Lac Nazfériti",
	["Lake of Stars"] = "Lac aux Étoiles",
	["Lakeridge Highway"] = "Grand-route de la crête du Lac",
	Lakeshire = "Comté-du-Lac",
	["Lakeshire Inn"] = "Auberge de Comté-du-Lac",
	["Lakeshire Town Hall"] = "Hôtel de ville de Comté-du-Lac",
	["Lakeside Landing"] = "Terrain d’atterrissage de Rive-du-lac",
	["Lake Sunspring"] = "Lac Berceau-de-l’Été",
	["Lakkari Tar Pits"] = "Fosses de goudron de Lakkari",
	["Landing Beach"] = "Plage de Débarquement",
	["Landing Site"] = "Site d’Atterrissage",
	["Land's End Beach"] = "Plage du Bout-du-Monde",
	["Langrom's Leather & Links"] = "Cuirs & Mailles de Langrom",
	["Lao & Son's Yakwash"] = "Lavage de yacks Lao et fils",
	["Largo's Overlook"] = "Surplomb de Largo",
	["Largo's Overlook Tower"] = "Tour du surplomb de Largo",
	["Lariss Pavilion"] = "Pavillon de Lariss",
	["Laughing Skull Courtyard"] = "Cour du Crâne ricanant",
	["Laughing Skull Ruins"] = "Ruines du Crâne ricanant",
	["Launch Bay"] = "Baie de lancement",
	["Legash Encampment"] = "Campement Legashi",
	["Legendary Leathers"] = "Au Dur à Cuir",
	["Legion Hold"] = "Bastion de la Légion",
	["Legion's Fate"] = "Le Destin de la Légion",
	["Legion's Rest"] = "Le Repos de la Légion",
	["Lethlor Ravine"] = "Ravin de Lethlor",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "Chagrin de Leyara",
	["L'ghorek"] = "L’ghorek",
	["Liang's Retreat"] = "Retraite de Liang",
	["Library Wing"] = "Aile de la Bibliothèque",
	Lighthouse = "Phare",
	["Lightning Ascent"] = "Ascension de la Foudre",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Forge de foudre - Scénario de progression de l’île mogu",
	["Lightning Ledge"] = "Escarpement de Foudre",
	["Lightning Promenade"] = "Promenade de la Foudre",
	["Lightning Vein Mine"] = "Veine de Foudremine",
	["Light's Breach"] = "La Brèche de Lumière",
	["Light's Dawn Cathedral"] = "Cathédrale de l’Aube de Lumière",
	["Light's Hammer"] = "Marteau de Lumière",
	["Light's Hope Chapel"] = "Chapelle de l’Espoir de Lumière",
	["Light's Point"] = "Halte de la Lumière",
	["Light's Point Tower"] = "Tour de la halte de la Lumière",
	["Light's Shield Tower"] = "Tour du bouclier de la Lumière",
	["Light's Trust"] = "La Confiance de Lumière",
	["Like Clockwork"] = "Comme une horloge",
	["Lion's Landing"] = "Territoire du Lion",
	["Lion's Pride Inn"] = "Auberge de la Fierté du lion",
	["Livery Outpost"] = "Avant-poste de l’écurie",
	["Livery Stables"] = "Écuries",
	["Livery Stables "] = "Écuries",
	["Llane's Oath"] = "Serment de Llane",
	["Loading Room"] = "Salle de chargement",
	["Loch Modan"] = "Loch Modan",
	["Loch Verrall"] = "Loch Verralle",
	["Loken's Bargain"] = "Marché de Loken",
	["Lonesome Cove"] = "Crique Inhabitée",
	Longshore = "Longrivage",
	["Longying Outpost"] = "Avant-poste de Longying",
	["Lordamere Internment Camp"] = "Camp d'internement de Lordamere",
	["Lordamere Lake"] = "Lac Lordamere",
	["Lor'danel"] = "Lor’danel",
	["Lorthuna's Gate"] = "Porte de Lorthuna",
	["Lost Caldera"] = "La caldeira Perdue",
	["Lost City of the Tol'vir"] = "Cité perdue des Tol’vir",
	["Lost City of the Tol'vir Entrance"] = "Entrée de la cité perdue des Tol’vir",
	LostIsles = "Îles perdues",
	["Lost Isles Town in a Box"] = "Îles perdues Ville-en-Boîte",
	["Lost Isles Volcano Eruption"] = "Éruption volcanique des îles Perdues",
	["Lost Peak"] = "Le Pic-perdu",
	["Lost Point"] = "Halte Perdue",
	["Lost Rigger Cove"] = "Crique des Gréements",
	["Lothalor Woodlands"] = "Forêt de Lothalor",
	["Lower City"] = "Ville Basse",
	["Lower Silvermarsh"] = "Marécage Argenté inférieur",
	["Lower Sumprushes"] = "Marais des Joncs inférieur",
	["Lower Veil Shil'ak"] = "Voile Shil’ak inférieur",
	["Lower Wilds"] = "Étendues Sauvages",
	["Lumber Mill"] = "Scierie",
	["Lushwater Oasis"] = "Oasis Luxuriante",
	["Lydell's Ambush"] = "Embuscade de Lydell",
	["M.A.C. Diver"] = "Plongeur C.O.U.A.C.",
	["Maelstrom Deathwing Fight"] = "Combat contre Aile de mort dans le Maelström",
	["Maelstrom Zone"] = "Région du maelström",
	["Maestra's Post"] = "Poste de Maestra",
	["Maexxna's Nest"] = "Nid de Maexxna",
	["Mage Quarter"] = "Quartier des Mages",
	["Mage Tower"] = "Tour des Mages",
	["Mag'har Grounds"] = "Terres Mag’har",
	["Mag'hari Procession"] = "Procession Mag’hari",
	["Mag'har Post"] = "Poste Mag’har",
	["Magical Menagerie"] = "Ménagerie magique",
	["Magic Quarter"] = "Quartier de la Magie",
	["Magisters Gate"] = "Porte du Magistère",
	["Magister's Terrace"] = "Terrasse des magistères",
	["Magisters' Terrace"] = "Terrasse des Magistères",
	["Magisters' Terrace Entrance"] = "Entrée de la terrasse des Magistères",
	["Magmadar Cavern"] = "Caverne de Magmadar",
	["Magma Fields"] = "Champs de Magma",
	["Magma Springs"] = "Sources de Magma",
	["Magmaw's Fissure"] = "Fissure de Magmagueule",
	Magmoth = "Magmoth",
	["Magnamoth Caverns"] = "Cavernes de Magnamoth",
	["Magram Territory"] = "Territoire Magram",
	["Magtheridon's Lair"] = "Le repaire de Magtheridon",
	["Magus Commerce Exchange"] = "Halle des Mages",
	["Main Chamber"] = "Chambre principale",
	["Main Gate"] = "Porte principale",
	["Main Hall"] = "Grand hall",
	["Maker's Ascent"] = "Ascension des Faiseurs",
	["Maker's Overlook"] = "Surplomb du Faiseur",
	["Maker's Overlook "] = "Surplomb du Faiseur",
	["Makers' Overlook"] = "Surplomb du Faiseur",
	["Maker's Perch"] = "Perchoir du Faiseur",
	["Makers' Perch"] = "Perchoir du Faiseur",
	["Malaka'jin"] = "Malaka’jin",
	["Malden's Orchard"] = "Verger de Malden",
	Maldraz = "Maldraz",
	["Malfurion's Breach"] = "Brèche de Malfurion",
	["Malicia's Outpost"] = "Avant-poste de Malicia",
	["Malykriss: The Vile Hold"] = "Malykriss : le Fort infâme",
	["Mama's Pantry"] = "Garde-manger de Mama",
	["Mam'toth Crater"] = "Cratère de Mam’toth",
	["Manaforge Ara"] = "Manaforge Ara",
	["Manaforge B'naar"] = "Manaforge B’naar",
	["Manaforge Coruu"] = "Manaforge Coruu",
	["Manaforge Duro"] = "Manaforge Duro",
	["Manaforge Ultris"] = "Manaforge Ultris",
	["Mana Tombs"] = "Tombes-mana",
	["Mana-Tombs"] = "Tombes-mana",
	["Mandokir's Domain"] = "Domaine de Mandokir",
	["Mandori Village"] = "Mandori",
	["Mannoroc Coven"] = "Convent de Mannoroc",
	["Manor Mistmantle"] = "Manoir Mantebrume",
	["Mantle Rock"] = "Roche du Manteau",
	["Map Chamber"] = "Chambre des cartes",
	["Mar'at"] = "Mar’at",
	Maraudon = "Maraudon",
	["Maraudon - Earth Song Falls Entrance"] = "Maraudon - Entrée des chutes de Chanteterre",
	["Maraudon - Foulspore Cavern Entrance"] = "Maraudon - Entrée de la caverne Vilespore",
	["Maraudon - The Wicked Grotto Entrance"] = "Maraudon - Entrée de la grotte Maudite",
	["Mardenholde Keep"] = "Donjon de Mardenholde",
	Marista = "Marista",
	["Marista's Bait & Brew"] = "À la Pêche au bar",
	["Market Row"] = "Allée du marché",
	["Marshal's Refuge"] = "Refuge des Marshal",
	["Marshal's Stand"] = "Camp retranché des Marshal",
	["Marshlight Lake"] = "Lac des Furoles",
	["Marshtide Watch"] = "Guet de l’Estran",
	["Maruadon - The Wicked Grotto Entrance"] = "Maraudon - Entrée de la grotte Maudite",
	["Mason's Folly"] = "La Folie du maçon",
	["Masters' Gate"] = "Porte des Maîtres",
	["Master's Terrace"] = "Terrasse du maître",
	["Mast Room"] = "Salle du Mât",
	["Maw of Destruction"] = "Gueule de la destruction",
	["Maw of Go'rath"] = "Gueule de Go’rath",
	["Maw of Lycanthoth"] = "Gueule de Lycanthoth",
	["Maw of Neltharion"] = "Gueule de Neltharion",
	["Maw of Shu'ma"] = "Gueule de Shu’ma",
	["Maw of the Void"] = "Gueule du Vide",
	["Mazra'Alor"] = "Mazra’Alor",
	Mazthoril = "Mazthoril",
	["Mazu's Overlook"] = "Surplomb de Mazu",
	["Medivh's Chambers"] = "Appartements de Medivh",
	["Menagerie Wreckage"] = "Débris de la ménagerie",
	["Menethil Bay"] = "Baie de Menethil",
	["Menethil Harbor"] = "Port de Menethil",
	["Menethil Keep"] = "Donjon de Menethil",
	["Merchant Square"] = "Place des Marchands",
	Middenvale = "Ordeval",
	["Mid Point Station"] = "Poste de la Halte du centre",
	["Midrealm Post"] = "Comptoir des Terres-médianes",
	["Midwall Lift"] = "Ascenseur de Mimuraille",
	["Mightstone Quarry"] = "Carrière de Pierres de pouvoir",
	["Military District"] = "Secteur Militaire",
	["Mimir's Workshop"] = "Atelier de Mimir",
	Mine = "Mine",
	Mines = "Les Mines",
	["Mirage Abyss"] = "Abysse des Mirages",
	["Mirage Flats"] = "Vallée des Mirages",
	["Mirage Raceway"] = "Piste des Mirages",
	["Mirkfallon Lake"] = "Lac Mirkfallon",
	["Mirkfallon Post"] = "Poste de Mirkfallon",
	["Mirror Lake"] = "Lac Miroir",
	["Mirror Lake Orchard"] = "Verger du lac Miroir",
	["Mistblade Den"] = "Tanière des Lame-de-Brume",
	["Mistcaller's Cave"] = "Grotte du mandebrume",
	["Mistfall Village"] = "Tombe-Brume",
	["Mist's Edge"] = "La lisière des Brumes",
	["Mistvale Valley"] = "Valbrume",
	["Mistveil Sea"] = "La mer du Voile de brume",
	["Mistwhisper Refuge"] = "Le refuge de Murmebrume",
	["Misty Pine Refuge"] = "Refuge de Brumepins",
	["Misty Reed Post"] = "Poste de Brumejonc",
	["Misty Reed Strand"] = "Grève de Brumejonc",
	["Misty Ridge"] = "Crête Brumeuse",
	["Misty Shore"] = "Rivage Brumeux",
	["Misty Shores"] = "Rivages Brumeux",
	["Misty Valley"] = "Vallée des Brumes",
	["Miwana's Longhouse"] = "Maison longue de Miwana",
	["Mizjah Ruins"] = "Ruines de Mizjah",
	["Moa'ki"] = "Moa'ki",
	["Moa'ki Harbor"] = "Port-Moa’ki",
	["Moggle Point"] = "Cap Moggle",
	["Mo'grosh Stronghold"] = "Bastion des Mo’grosh",
	["Mogu Island Daily Area"] = "Île mogu - Zone de quêtes journalières",
	["Mogu Island Events - Alliance Base"] = "Évènements de l’île mogu - Base Alliance",
	["Mogu Island Events - Horde Base"] = "Évènements de l’île mogu - Base Horde",
	["Mogu Island Loot Room"] = "Salle du butin de l’île mogu",
	["Mogu Island Progression Events"] = "Évènements de progression de l’île mogu",
	Mogujia = "Mogujia",
	["Mogu'shan Palace"] = "Palais Mogu’shan",
	["Mogu'shan Terrace"] = "Terrasse Mogu’shan",
	["Mogu'shan Vaults"] = "Caveaux Mogu’shan",
	["Mok'Doom"] = "Mok'Deuil",
	["Mok'Gordun"] = "Mok’Gordun",
	["Mok'Nathal Village"] = "Mok’Nathal",
	["Mold Foundry"] = "La fonderie",
	["Molten Core"] = "Cœur du Magma",
	["Molten Front"] = "Front du Magma",
	Moonbrook = "Ruisselune",
	Moonglade = "Reflet-de-Lune",
	["Moongraze Woods"] = "Bois Frôle-lune",
	["Moon Horror Den"] = "Antre de l’Horreur lunaire",
	["Moonrest Gardens"] = "Jardins de Repos-de-Lune",
	["Moonshrine Ruins"] = "Ruines d’Écrin-de-Lune",
	["Moonshrine Sanctum"] = "Sanctuaire d’Écrin-de-Lune",
	["Moontouched Den"] = "Tanière des Frôlelunes",
	["Moonwater Retreat"] = "Retraite d’Aiguelune",
	["Moonwell of Cleansing"] = "Puits de Lune de purification",
	["Moonwell of Purity"] = "Puits de Lune de pureté",
	["Moonwing Den"] = "Tanière Aile-de-lune",
	["Mord'rethar: The Death Gate"] = "Mord’rethar : la Porte de la Mort",
	["Morgan's Plot"] = "Le lopin de Morgan",
	["Morgan's Vigil"] = "Veille de Morgan",
	["Morlos'Aran"] = "Morlos’Aran",
	["Morning Breeze Lake"] = "Lac de Brise-du-Matin",
	["Morning Breeze Village"] = "Brise-du-Matin",
	Morrowchamber = "Chambre des Demains",
	["Mor'shan Base Camp"] = "Campement de Mor’shan",
	["Mortal's Demise"] = "Trépas du mortel",
	["Mortbreath Grotto"] = "Grotte de Morthaleine",
	["Mortwake's Tower"] = "Tour de Morteveille",
	["Mosh'Ogg Ogre Mound"] = "Tertre des Ogres mosh’Ogg",
	["Mosshide Fen"] = "Marais des Poils-moussus",
	["Mosswalker Village"] = "Marchemousse",
	["Mossy Pile"] = "Tertre Moussu",
	["Motherseed Pit"] = "Fosse des graines-mères",
	["Mountainfoot Strip Mine"] = "Mine à ciel ouvert du Puy-du-Pied",
	["Mount Akher"] = "Mont Akher",
	["Mount Hyjal"] = "Mont Hyjal",
	["Mount Hyjal Phase 1"] = "Mont Hyjal Phase 1",
	["Mount Neverest"] = "Mont Sans-Repos",
	["Muckscale Grotto"] = "Grotte Fangécaille",
	["Muckscale Shallows"] = "Hauts-fonds Fangécaille",
	["Mudmug's Place"] = "Maison de Gueule de Boue",
	Mudsprocket = "Bourbe-à-brac",
	Mulgore = "Mulgore",
	["Murder Row"] = "Allée du meurtre",
	["Murkdeep Cavern"] = "Caverne de Fondeboue",
	["Murky Bank"] = "Rive Bourbeuse",
	["Muskpaw Ranch"] = "Élevage Patte Musquée",
	["Mystral Lake"] = "Lac Mystral",
	Mystwood = "Bois Brumeux",
	Nagrand = "Nagrand",
	["Nagrand Arena"] = "Arène de Nagrand",
	Nahom = "Nahom",
	["Nar'shola Terrace"] = "Terrasse de Nar’shola",
	["Narsong Spires"] = "Flèches de Narsong",
	["Narsong Trench"] = "Tranchée de Narsong",
	["Narvir's Cradle"] = "Le Berceau de Narvir",
	["Nasam's Talon"] = "La serre de Nasam",
	["Nat's Landing"] = "Point d’accostage de Nat",
	["Naval Battle Scenario"] = "Scénario : bataille navale",
	Naxxanar = "Naxxanar",
	Naxxramas = "Naxxramas",
	["Nayeli Lagoon"] = "Lagon de Nayeli",
	["Naz'anak: The Forgotten Depths"] = "Naz’anak : les profondeurs Oubliées",
	["Nazj'vel"] = "Nazj’vel",
	Nazzivian = "Nazzivian",
	["Nectarbreeze Orchard"] = "Verger de Brise-de-Nectar",
	["Needlerock Chasm"] = "Gouffre de Rochepointe",
	["Needlerock Slag"] = "Scories-de-Rochepointe",
	["Nefarian's Lair"] = "Antre de Nefarian",
	["Nefarian�s Lair"] = "Antre de Nefarian",
	["Neferset City"] = "Neferset",
	["Neferset City Outskirts"] = "Faubourgs de Neferset",
	["Nek'mani Wellspring"] = "Fontaine des Nek’mani",
	["Neptulon's Rise"] = "Cime de Neptulon",
	["Nesingwary Base Camp"] = "Camp de base de Nesingwary",
	["Nesingwary Safari"] = "Safari de Nesingwary",
	["Nesingwary's Expedition"] = "Expédition de Nesingwary",
	["Nesingwary's Safari"] = "Safari de Nesingwary",
	Nespirah = "Nespirah",
	["Nestlewood Hills"] = "Collines des Nidebois",
	["Nestlewood Thicket"] = "Fourré des Nidebois",
	["Nethander Stead"] = "Ferme des Nethander",
	["Nethergarde Keep"] = "Rempart-du-Néant",
	["Nethergarde Mines"] = "Mines de Rempart-du-Néant",
	["Nethergarde Supply Camps"] = "Camps de ravitaillement de Rempart-du-Néant",
	Netherspace = "Néantespace",
	Netherstone = "Pierre-de-Néant",
	Netherstorm = "Raz-de-Néant",
	["Netherweb Ridge"] = "Crête de Toile-néant",
	["Netherwing Fields"] = "Champs de l’Aile-du-Néant",
	["Netherwing Ledge"] = "Escarpement de l’Aile-du-Néant",
	["Netherwing Mines"] = "Mines de l’Aile-du-Néant",
	["Netherwing Pass"] = "Défilé de l’Aile-du-Néant",
	["Neverest Basecamp"] = "Camp de base Sans-Repos",
	["Neverest Pinnacle"] = "Cime Sans-Repos",
	["New Agamand"] = "Nouvelle-Agamand",
	["New Agamand Inn"] = "Auberge de la Nouvelle-Agamand",
	["New Avalon"] = "Nouvelle-Avalon",
	["New Avalon Fields"] = "Champs de la Nouvelle-Avalon",
	["New Avalon Forge"] = "Forge de la Nouvelle-Avalon",
	["New Avalon Orchard"] = "Vergers de la Nouvelle-Avalon",
	["New Avalon Town Hall"] = "Hôtel de ville de la Nouvelle-Avalon",
	["New Cifera"] = "Nouvelle-Cifera",
	["New Hearthglen"] = "Nouvelle-Âtreval",
	["New Kargath"] = "Nouvelle-Kargath",
	["New Thalanaar"] = "Nouvelle-Thalanaar",
	["New Tinkertown"] = "La Nouvelle-Brikabrok",
	["Nexus Legendary"] = "Nexus (légendaire)",
	Nidavelir = "Nidavelir",
	["Nidvar Stair"] = "Escalier de Nidvar",
	Nifflevar = "Nifflevar",
	["Night Elf Village"] = "Village elfe de la nuit",
	Nighthaven = "Havrenuit",
	["Nightingale Lounge"] = "Salon de thé de Rossignol",
	["Nightmare Depths"] = "Profondeurs du Cauchemar",
	["Nightmare Scar"] = "Balafre du Cauchemar",
	["Nightmare Vale"] = "Vallée des Cauchemars",
	["Night Run"] = "Défilé de la nuit",
	["Nightsong Woods"] = "Bois de Chantenuit",
	["Night Web's Hollow"] = "Grottes des Tisse-nuit",
	["Nijel's Point"] = "Combe de Nijel",
	["Nimbus Rise"] = "Cime du Nimbus",
	Nine = "Neuf",
	["Niuzao Catacombs"] = "Catacombes de Niuzao",
	["Niuzao Temple"] = "Temple de Niuzao",
	["Njord's Breath Bay"] = "Baie du Souffle de Njord",
	["Njorndar Village"] = "Njorndar",
	["Njorn Stair"] = "Escalier de Njorn",
	["Nook of Konk"] = "Recoin de Konk",
	["Noonshade Ruins"] = "Ruines d’Ombre-du-Zénith",
	Nordrassil = "Nordrassil",
	["Nordrassil Inn"] = "Auberge de Nordrassil",
	["Nordune Ridge"] = "Crête de Nordune",
	["North Common Hall"] = "Les communs du nord",
	Northdale = "Valnord",
	["Northern Barrens"] = "Tarides du Nord",
	["Northern Elwynn Mountains"] = "Chaîne boréale d’Elwynn",
	["Northern Headlands"] = "L’éminence du Nord",
	["Northern Rampart"] = "Rempart du Nord",
	["Northern Rocketway"] = "Fusorail nord",
	["Northern Rocketway Exchange"] = "Station Nord du fusorail",
	["Northern Stranglethorn"] = "Strangleronce septentrionale",
	["Northfold Manor"] = "Manoir de Nordclos",
	["Northgate Breach"] = "Brèche de la Porte",
	["North Gate Outpost"] = "Avant-poste de la Porte Nord",
	["North Gate Pass"] = "Passage de la Porte Nord",
	["Northgate River"] = "Fleuve de la Porte",
	["Northgate Woods"] = "Bois de la Porte",
	["Northmaul Tower"] = "Tour Nord-sanglante",
	["Northpass Tower"] = "Tour du Col du Nord",
	["North Point Station"] = "Poste de la Halte du Nord",
	["North Point Tower"] = "Tour de la Halte Nord",
	Northrend = "Norfendre",
	["Northridge Lumber Camp"] = "Camp de bûcherons de la Crête du Nord",
	["North Sanctum"] = "Sanctum Septentrional",
	Northshire = "Comté-du-Nord",
	["Northshire Abbey"] = "Abbaye de Comté-du-Nord",
	["Northshire River"] = "Fleuve Comté-du-Nord",
	["Northshire Valley"] = "Vallée de Comté-du-Nord",
	["Northshire Vineyards"] = "Vignoble de Comté-du-Nord",
	["North Spear Tower"] = "Tour de la Lance du Nord",
	["North Tide's Beachhead"] = "Tête de pont de la Côte Nord",
	["North Tide's Run"] = "La côte Nord",
	["Northwatch Expedition Base Camp"] = "Camp de base de l’expédition de Guet-du-Nord",
	["Northwatch Expedition Base Camp Inn"] = "Auberge du camp de base de l’expédition de Guet-du-Nord",
	["Northwatch Foothold"] = "Tête de pont de Guet-du-Nord",
	["Northwatch Hold"] = "Fort de Guet-du-Nord",
	["Northwind Cleft"] = "Faille de Norsevent",
	["North Wind Tavern"] = "Taverne du Vent du Nord",
	["Nozzlepot's Outpost"] = "Avant-poste de Potuyère",
	["Nozzlerust Post"] = "Poste de Rouilletuyère",
	["Oasis of the Fallen Prophet"] = "Oasis du Prophète déchu",
	["Oasis of Vir'sar"] = "Oasis de Vir’sar",
	["Obelisk of the Moon"] = "Obélisque de la Lune",
	["Obelisk of the Stars"] = "Obélisque des Étoiles",
	["Obelisk of the Sun"] = "Obélisque du Soleil",
	["O'Breen's Camp"] = "Camp de O’Breen",
	["Observance Hall"] = "Salle d’observance",
	["Observation Grounds"] = "Terrain d'observation",
	["Obsidian Breakers"] = "Brisants d’Obsidienne",
	["Obsidian Dragonshrine"] = "Sanctuaire draconique Obsidien",
	["Obsidian Forest"] = "Forêt Obsidienne",
	["Obsidian Lair"] = "Repaire Obsidien",
	["Obsidia's Perch"] = "Perchoir d’Obsidia",
	["Odesyus' Landing"] = "Point d’accostage d’Odesyus",
	["Ogri'la"] = "Ogri’la",
	["Ogri'La"] = "Ogri'La",
	["Old Hillsbrad Foothills"] = "Contreforts de Hautebrande d’antan",
	["Old Ironforge"] = "Vieux Forgefer",
	["Old Town"] = "Vieille ville",
	Olembas = "Olembas",
	["Olivia's Pond"] = "Étang d’Olivia",
	["Olsen's Farthing"] = "Essarts des Olsen",
	Oneiros = "Oneiros",
	["One Keg"] = "Monofu",
	["One More Glass"] = "Un dernier pour la route",
	["Onslaught Base Camp"] = "Camp de base de l’Assaut",
	["Onslaught Harbor"] = "Port de l’Assaut",
	["Onyxia's Lair"] = "Repaire d’Onyxia",
	["Oomlot Village"] = "Oomlot",
	["Oona Kagu"] = "Ouna Kagu",
	Oostan = "Oostan",
	["Oostan Nord"] = "Oostan Nord",
	["Oostan Ost"] = "Oostan Ost",
	["Oostan Sor"] = "Oostan Sor",
	["Opening of the Dark Portal"] = "Ouverture de la Porte des ténèbres",
	["Opening of the Dark Portal Entrance"] = "Entrée de l’Ouverture de la Porte des ténèbres",
	["Oratorium of the Voice"] = "Oratoire de la Voix",
	["Oratory of the Damned"] = "Oratoire des damnés",
	["Orchid Hollow"] = "Creux de l’Orchidée",
	["Orebor Harborage"] = "Havre d’Orebor",
	["Oregrind's Dig"] = "Site de fouilles de Grézik Rochégrise",
	["Orendil's Retreat"] = "Retraite d’Orendil",
	Orgrimmar = "Orgrimmar",
	["Orgrimmar Gunship Pandaria Start"] = "Départ pour la Pandarie dans la canonnière d’Orgrimmar",
	["Orgrimmar Rear Gate"] = "Porte d’Azshara",
	["Orgrimmar Rocketway Exchange"] = "Station d’Orgrimmar du fusorail",
	["Orgrim's Hammer"] = "Le Marteau d’Orgrim",
	["Oronok's Farm"] = "Ferme d’Oronok",
	Orsis = "Orsis",
	["Ortell's Hideout"] = "La planque d’Ortell",
	["Oshu'gun"] = "Oshu’gun",
	["Outdoor Ruins"] = "Ruines extérieures",
	Outland = "Outreterre",
	["Overgrown Camp"] = "Camp envahi par la végétation",
	["Overgrown Statuary"] = "Jardin de sculptures abandonné",
	["Owen's Wishing Well"] = "Puits à souhaits d’Owen",
	["Owl Wing Thicket"] = "Fourré de l’Aile de la chouette",
	["Palace Antechamber"] = "Antichambre du Palais",
	["Pal'ea"] = "Pal’ea",
	["Palemane Rock"] = "Rocher des Crins-Pâles",
	["Pandaren Mine"] = "Mine pandarène",
	Pandaria = "Pandarie",
	["Pang's Stead"] = "Ferme de Pang",
	["Panic Clutch"] = "Étreinte de la panique",
	["Paoquan Hollow"] = "Creux de Paoquan",
	["Parhelion Plaza"] = "Place Parhélion",
	["Passage of Lost Fiends"] = "Passage des Démons perdus",
	["Path of a Hundred Steps"] = "La voie des Cent marches",
	["Path of Conquerors"] = "Voie des Conquérants",
	["Path of Enlightenment"] = "Le chemin de l’Illumination",
	["Path of Serenity"] = "Voie de la Sérénité",
	["Path of the Titans"] = "Voie des Titans",
	["Path of Uther"] = "Voie d’Uther",
	["Pattymack Land"] = "Terres de Pattymack",
	["Pauper's Walk"] = "Croisée du pauvre",
	["Paur's Pub"] = "Pub de Paur",
	["Paw'don Glade"] = "Clairière de Pao’don",
	["Paw'don Village"] = "Pao’don",
	["Paw'Don Village"] = "Pao’don",
	["Peak of Serenity"] = "Pic de la Sérénité",
	["Pearlfin Village"] = "Nageperle",
	["Pearl Lake"] = "Lac de Perle",
	["Pedestal of Hope"] = "Piédestal de l’Espoir",
	["Pei-Wu Forest"] = "Forêt de Pei-Wu",
	["Pestilent Scar"] = "Balafre Pestilentielle",
	["Pet Battle - Jade Forest"] = "Combat de mascottes - La forêt de jade",
	["Petitioner's Chamber"] = "Chambre du Requérant",
	["Pilgrim's Precipice"] = "Précipice du Pèlerin",
	["Pincer X2"] = "Pinceur X2",
	["Pinnacle of Storms"] = "Cime des Tempêtes",
	["Pit of Fangs"] = "Abîme des Crocs",
	["Pit of Saron"] = "Fosse de Saron",
	["Pit of Saron Entrance"] = "Entrée de la fosse de Saron",
	["Plaguelands: The Scarlet Enclave"] = "Maleterres : l’enclave Écarlate",
	["Plaguemist Ravine"] = "Ravin de Pestebrume",
	Plaguewood = "Pestebois",
	["Plaguewood Tower"] = "Tour de Pestebois",
	["Plain of Echoes"] = "Plaine des Échos",
	["Plain of Shards"] = "Plaine des Éclats",
	["Plain of Thieves"] = "Plaine des Voleurs",
	["Plains of Nasam"] = "Les plaines de Nasam",
	["Pod Cluster"] = "Grappe de capsules",
	["Pod Wreckage"] = "Débris de Capsule",
	["Poison Falls"] = "Chutes empoisonnées",
	["Pool of Reflection"] = "Étang de la Réflexion",
	["Pool of Tears"] = "Bassin des Larmes",
	["Pool of the Paw"] = "Bassin de la Patte",
	["Pool of Twisted Reflections"] = "Bassin des Reflets distordus",
	["Pools of Aggonar"] = "Bassins d’Aggonar",
	["Pools of Arlithrien"] = "Bassins d’Arlithrien",
	["Pools of Jin'Alai"] = "Bassins de Jin’Alai",
	["Pools of Purity"] = "Bassins de la Pureté",
	["Pools of Youth"] = "Bassins de la Jeunesse",
	["Pools of Zha'Jin"] = "Bassins de Zha’Jin",
	["Portal Clearing"] = "Clairière du Portail",
	["Pranksters' Hollow"] = "Creux des Farceurs",
	["Predator's Perch"] = "Eminence du Prédateur",
	["Prison of Immol'thar"] = "Prison d'Immol'thar",
	["Programmer Isle"] = "Île des Programmeurs",
	["Promontory Point"] = "Le Promontoire",
	["Prospector's Point"] = "Pointe du Prospecteur",
	["Protectorate Watch Post"] = "Poste de garde du Protectorat",
	["Proving Grounds"] = "Ordalie",
	["Purespring Cavern"] = "Caverne de la Source pure",
	["Purgation Isle"] = "Île de la Purification",
	["Pursuing the Black Harvest"] = "À la poursuite de la Sombre récolte",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Laboratoire des Désopilantes atrocités alchimiques de Putricide",
	["Pyrewood Chapel"] = "Chapelle de Bois-du-Bûcher",
	["Pyrewood Inn"] = "Auberge de Bois-du-Bûcher",
	["Pyrewood Town Hall"] = "Hôtel de ville de Bois-du-Bûcher",
	["Pyrewood Village"] = "Bois-du-Bûcher",
	["Pyrox Flats"] = "Plaine de Pyrox",
	["QA and DVD"] = "AQ et DVD",
	["Quagg Ridge"] = "Crête des Boues",
	Quarry = "Carrière",
	["Quartzite Basin"] = "Bassin de Quartzite",
	["Queen's Gate"] = "Porte de la Reine",
	["Quel'Danil Lodge"] = "Gîte de Quel’Danil",
	["Quel'Delar's Rest"] = "Repos de Quel’Delar",
	["Quel'Dormir Gardens"] = "Jardins de Quel’Dormir",
	["Quel'Dormir Temple"] = "Temple de Quel’Dormir",
	["Quel'Dormir Terrace"] = "Terrasse de Quel’Dormir",
	["Quel'Lithien Lodge"] = "Gîte de Quel’Lithien",
	["Quel'thalas"] = "Quel’thalas",
	["Quickchop's Lumber Farm"] = "Ferme d’abattage de Hachémenu",
	["Raastok Glade"] = "Clairière de Raastok",
	["Raceway Ruins"] = "Ruines de la Piste",
	["Rageclaw Den"] = "Tanière Grifferage",
	["Rageclaw Lake"] = "Lac Grifferage",
	["Rage Fang Shrine"] = "Sanctuaire du Croc rageur",
	["Ragefeather Ridge"] = "Crête des Rageplumes",
	["Ragefire Caverns"] = "Cavernes de Ragefeu",
	["Ragefire Chasm"] = "Gouffre de Ragefeu",
	["Ragefire Core"] = "Cœur de Ragefeu",
	["Rage Scar Hold"] = "Repaire des Griffes féroces",
	["Ragnaros' Lair"] = "Antre de Ragnaros",
	["Ragnaros' Reach"] = "Emprise de Ragnaros",
	["Rainspeaker Canopy"] = "La canopée Parlepluie",
	["Rainspeaker Rapids"] = "Rapides Parlepluie",
	Ramkahen = "Ramkahen",
	["Ramkahen Legion Outpost"] = "Avant-poste de la légion Ramkahen",
	["Rampart of Skulls"] = "Rempart des Crânes",
	["Ranazjar Isle"] = "Île de Ranazjar",
	["Raptor Pens"] = "Enclos à raptors",
	["Raptor Ridge"] = "Crête des Raptors",
	["Raptor Rise"] = "Cime des Raptors",
	Ratchet = "Cabestan",
	["Rated Eye of the Storm"] = "L'Œil du cyclone coté",
	["Ravaged Caravan"] = "Caravane dévastée",
	["Ravaged Crypt"] = "Crypte dévastée",
	["Ravaged Twilight Camp"] = "Camp du Crépuscule ravagé",
	["Ravencrest Monument"] = "Colosse de Crête-du-corbeau",
	["Raven Hill"] = "Colline-aux-Corbeaux",
	["Raven Hill Cemetery"] = "Cimetière de Colline-aux-Corbeaux",
	["Ravenholdt Manor"] = "Manoir de Ravenholdt",
	["Raven's Watch"] = "Guet du Corbeau",
	["Raven's Wood"] = "Bois aux Corbeaux",
	["Raynewood Retreat"] = "Retraite de Raynebois",
	["Raynewood Tower"] = "Tour de Raynebois",
	["Razaan's Landing"] = "Point d’ancrage de Razaan",
	["Razorfen Downs"] = "Souilles de Tranchebauge",
	["Razorfen Downs Entrance"] = "Entrée des souilles de Tranchebauge",
	["Razorfen Kraul"] = "Kraal de Tranchebauge",
	["Razorfen Kraul Entrance"] = "Entrée du kraal de Tranchebauge",
	["Razor Hill"] = "Tranchecolline",
	["Razor Hill Barracks"] = "Caserne de Tranchecolline",
	["Razor Hill Outskirts"] = "Faubourgs de Tranchecolline",
	["Razor Hill Watchtower"] = "Tour de guet de Tranchecolline",
	["Razormane Grounds"] = "Terres des Tranchecrins",
	["Razor Ridge"] = "Tranchecrête",
	["Razorscale's Aerie"] = "Nichoir de Tranchécaille",
	["Razorthorn Rise"] = "Éminence de Tranchépine",
	["Razorthorn Shelf"] = "Saillie de Tranchépine",
	["Razorthorn Trail"] = "Piste de Tranchépine",
	["Razorwind Canyon"] = "Canyon de Tranchevent",
	["Rear Staging Area"] = "Zone arrière de Rassemblement",
	["Reaver's Fall"] = "Le Trépas du saccageur",
	["Reavers' Hall"] = "Salle des saccageurs",
	["Rebel Camp"] = "Camp Rebelle",
	["Red Cloud Mesa"] = "Mesa de Nuage rouge",
	["Redpine Dell"] = "Cluse des Rougepins",
	["Redridge - Bridge Phase One"] = "Carmines - pont phase 1",
	["Redridge - Bridge Phase Two"] = "Carmines - pont phase 2",
	["Redridge Canyons"] = "Canyons des Carmines",
	["Redridge Mountains"] = "Les Carmines",
	["Redridge - Orc Bomb"] = "Carmines - bombe orc",
	["Red Rocks"] = "Rochers Rouges",
	["Redwood Trading Post"] = "Comptoir du Cèdre",
	Refinery = "Raffinerie",
	["Refugee Caravan"] = "Caravane de réfugiés",
	["Refuge Pointe"] = "Refuge de l’Ornière",
	["Refuse Disposal"] = "Centre de traitement des déchets",
	["Reliquary of Agony"] = "Reliquaire d’agonie",
	["Reliquary of Pain"] = "Reliquaire de souffrance",
	["Remains of Iris Lake"] = "Vestiges du lac Iris",
	["Remains of the Fleet"] = "Vestiges de la flotte",
	["Remtravel's Excavation"] = "Excavations de Songerrance",
	["Render's Camp"] = "Camp des Étripeurs",
	["Render's Crater"] = "Cratère des Étripeurs",
	["Render's Rock"] = "Rocher des Étripeurs",
	["Render's Valley"] = "Vallée des Étripeurs",
	["Rensai's Watchpost"] = "Poste de garde de Rensai",
	["Rethban Caverns"] = "Cavernes de Rethban",
	["Rethress Sanctum"] = "Sanctuaire de Rethress",
	Reuse = "Réutiliser",
	["Reuse Me 7"] = "Reuse Me 7",
	["Revantusk Village"] = "Village des Vengebroches",
	["Rhea's Camp"] = "Campement de Rhea",
	["Rhonin's Beard"] = "Barbe de Rhonin",
	["Rhyolith Plateau"] = "Plateau de Rhyolith",
	["Ricket's Folly"] = "La Folie de Ricket",
	["Ridge of Laughing Winds"] = "Crête des Vents rieurs",
	["Ridge of Madness"] = "Crête de la Folie",
	["Ridgepoint Tower"] = "Tour de la Crête",
	Rikkilea = "Rikkiléa",
	["Rikkitun Village"] = "Rikkitun",
	["Rim of the World"] = "Bord-du-monde",
	["Ring of Judgement"] = "L'arène du Jugement",
	["Ring of Observance"] = "Cercle d’observance",
	["Ring of the Elements"] = "Cercle des éléments",
	["Ring of the Law"] = "Cercle de la loi",
	["Riplash Ruins"] = "Ruines des Courcinglants",
	["Riplash Strand"] = "Grève des Courcinglants",
	["Rise of Suffering"] = "Cime de Souffrance",
	["Rise of the Defiler"] = "Cime du Souilleur",
	["Ritual Chamber of Akali"] = "Chambre rituelle d'Akali",
	["Rivendark's Perch"] = "Perchoir de Clivenuit",
	Rivenwood = "Clivebois",
	["River's Heart"] = "Le Cœur du fleuve",
	["Rock of Durotan"] = "Rocher de Durotan",
	["Rockpool Village"] = "Rochecave",
	["Rocktusk Farm"] = "Ferme Brochepierre",
	["Roguefeather Den"] = "Tanière des Volplumes",
	["Rogues' Quarter"] = "Quartier des Voleurs",
	["Rohemdal Pass"] = "Passe de Rohemdal",
	["Roland's Doom"] = "Destin de Roland",
	["Room of Hidden Secrets"] = "Chambre des Secrets cachés",
	["Roost of Ji-Kun"] = "Perchoir de Ji Kun",
	["Rotbrain Encampment"] = "Camp de Putresprit",
	["Royal Amphitheater"] = "Amphithéâtre royal",
	["Royal Approach"] = "La marche Royale",
	["Royal Exchange Auction House"] = "Hôtel des ventes de la Bourse royale",
	["Royal Exchange Bank"] = "Banque de la Bourse royale",
	["Royal Gallery"] = "Galerie royale",
	["Royal Library"] = "Bibliothèque royale",
	["Royal Quarter"] = "Quartier royal",
	["Ruby Dragonshrine"] = "Sanctuaire draconique Rubis",
	["Ruined Approach"] = "La marche Dévastée",
	["Ruined City Post 01"] = "Halte 1 de la ville en ruine",
	["Ruined Court"] = "La cour dévastée",
	["Ruins of Aboraz"] = "Ruines d’Aboraz",
	["Ruins of Ahmtul"] = "Ruines d’Ahmtul",
	["Ruins of Ahn'Qiraj"] = "Ruines d’Ahn’Qiraj",
	["Ruins of Alterac"] = "Ruines d’Alterac",
	["Ruins of Ammon"] = "Ruines d’Ammon",
	["Ruins of Arkkoran"] = "Ruines d’Arkkoran",
	["Ruins of Auberdine"] = "Ruines d’Auberdine",
	["Ruins of Baa'ri"] = "Ruines de Baa’ri",
	["Ruins of Constellas"] = "Ruines de Constellas",
	["Ruins of Dojan"] = "Ruines de Dojan",
	["Ruins of Drakgor"] = "Ruines de Drakgor",
	["Ruins of Drak'Zin"] = "Ruines de Drak’Zin",
	["Ruins of Eldarath"] = "Ruines d'Eldarath",
	["Ruins of Eldarath "] = "Ruines d’Eldarath",
	["Ruins of Eldra'nath"] = "Ruines d’Eldra’nath",
	["Ruins of Eldre'thar"] = "Ruines d’Eldre’thar",
	["Ruins of Enkaat"] = "Ruines d’Enkaat",
	["Ruins of Farahlon"] = "Ruines de Farahlon",
	["Ruins of Feathermoon"] = "Ruines de Pennelune",
	["Ruins of Gilneas"] = "Ruines de Gilnéas",
	["Ruins of Gilneas City"] = "Ruines de Gilnéas (ville)",
	["Ruins of Guo-Lai"] = "Ruines de Guo-Lai",
	["Ruins of Isildien"] = "Ruines d’Isildien",
	["Ruins of Jubuwal"] = "Ruines de Jubuwal",
	["Ruins of Karabor"] = "Ruines de Karabor",
	["Ruins of Kargath"] = "Ruines de Kargath",
	["Ruins of Khintaset"] = "Ruines de Khintaset",
	["Ruins of Korja"] = "Ruines de Korja",
	["Ruins of Korune"] = "Ruines de Korune",
	["Ruins of Lar'donir"] = "Ruines de Lar’donir",
	["Ruins of Lordaeron"] = "Ruines de Lordaeron",
	["Ruins of Loreth'Aran"] = "Ruines de Loreth’Aran",
	["Ruins of Lornesta"] = "Ruines de Lornesta",
	["Ruins of Mathystra"] = "Ruines de Mathystra",
	["Ruins of Nordressa"] = "Ruines de Nordressa",
	["Ruins of Ogudei"] = "Ruines d’Ogudei",
	["Ruins of Ravenwind"] = "Ruines de Vent-du-Corbeau",
	["Ruins of Sha'naar"] = "Ruines de Sha’naar",
	["Ruins of Shandaral"] = "Ruines de Shandaral",
	["Ruins of Silvermoon"] = "Ruines de Lune-d’Argent",
	["Ruins of Solarsal"] = "Ruines de Solarsal",
	["Ruins of Southshore"] = "Ruines d’Austrivage",
	["Ruins of Taurajo"] = "Ruines de Taurajo",
	["Ruins of Tethys"] = "Ruines de Téthys",
	["Ruins of Thaurissan"] = "Ruines de Thaurissan",
	["Ruins of Thelserai Temple"] = "Ruines du temple de Thelserai",
	["Ruins of Theramore"] = "Ruines de Theramore",
	["Ruins of the Scarlet Enclave"] = "Ruines de l’enclave Écarlate",
	["Ruins of Uldum"] = "Ruines d’Uldum",
	["Ruins of Vashj'elan"] = "Ruines de Vashj’elan",
	["Ruins of Vashj'ir"] = "Ruines de Vashj’ir",
	["Ruins of Zul'Kunda"] = "Ruines de Zul’Kunda",
	["Ruins of Zul'Mamwe"] = "Ruines de Zul’Mamwe",
	["Ruins Rise"] = "Cime des Ruines",
	["Rumbling Terrace"] = "Terrasse Grondante",
	["Runestone Falithas"] = "Pierre runique Falithas",
	["Runestone Shan'dor"] = "Pierre runique Shan’dor",
	["Runeweaver Square"] = "Place Tisserune",
	["Rustberg Village"] = "Rouillemont",
	["Rustmaul Dive Site"] = "Site de plongée de Cognerouille",
	["Rutsak's Guard"] = "Garde de Rutsak",
	["Rut'theran Village"] = "Rut’theran",
	["Ruuan Weald"] = "Sylve Ruuan",
	["Ruuna's Camp"] = "Camp de Ruuna",
	["Ruuzel's Isle"] = "Île de Ruuzel",
	["Rygna's Lair"] = "Repaire de Rygna",
	["Sable Ridge"] = "Crête Fuligineuse",
	["Sacrificial Altar"] = "Autel sacrificiel",
	["Sahket Wastes"] = "Désert de Sahket",
	Salabria = "Salabria",
	["Saldean's Farm"] = "Ferme des Saldean",
	["Saltheril's Haven"] = "Havre de Saltheril",
	["Saltspray Glen"] = "Vallon des Embruns",
	["Sanctuary of Malorne"] = "Sanctuaire de Malorne",
	["Sanctuary of Shadows"] = "Sanctuaire des ombres",
	["Sanctum of Reanimation"] = "Sanctum de Réanimation",
	["Sanctum of Shadows"] = "Sanctum des ombres",
	["Sanctum of the Ascended"] = "Sanctum de l'Ascension",
	["Sanctum of the Fallen God"] = "Sanctuaire du dieu déchu",
	["Sanctum of the Moon"] = "Sanctum de la Lune",
	["Sanctum of the Prophets"] = "Sanctum des Prophètes",
	["Sanctum of the South Wind"] = "Sanctum du Vent du Sud",
	["Sanctum of the Stars"] = "Sanctum des Étoiles",
	["Sanctum of the Sun"] = "Sanctum du Soleil",
	["Sands of Nasam"] = "Sables de Nasam",
	["Sandsorrow Watch"] = "Guet de Tristesable",
	["Sandy Beach"] = "Plage Sablonneuse",
	["Sandy Shallows"] = "Hauts-fonds Sablonneux",
	["Sanguine Chamber"] = "Salle sanguine",
	["Sapphire Hive"] = "La ruche de Saphir",
	["Sapphiron's Lair"] = "Repaire de Saphiron",
	["Saragosa's Landing"] = "Aire de Saragosa",
	Sarahland = "Sarahland",
	["Sardor Isle"] = "Île de Sardor",
	Sargeron = "Sargeron",
	["Sarjun Depths"] = "Profondeurs de Sarjun",
	["Saronite Mines"] = "Mines de Saronite",
	["Sar'theris Strand"] = "Grève de Sar’theris",
	Satyrnaar = "Satyrnaar",
	["Saurok Creation Pit"] = "Fosse de création des Sauroks",
	["Savage Ledge"] = "L’escarpement Sauvage",
	["Scalawag Point"] = "Cap du Forban",
	["Scalding Pools"] = "Bassins Brûlants",
	["Scalebeard's Cave"] = "Caverne de Barbe-d’écailles",
	["Scalewing Shelf"] = "Saillie Ailécaille",
	["Scarab Terrace"] = "Terrasse du Scarabée",
	["Scarlet Encampment"] = "Campement Écarlate",
	["Scarlet Halls"] = "Salles Écarlates",
	["Scarlet Hold"] = "Fort Écarlate",
	["Scarlet Monastery"] = "Monastère Écarlate",
	["Scarlet Monastery Entrance"] = "Entrée du Monastère Écarlate",
	["Scarlet Overlook"] = "Le surplomb Écarlate",
	["Scarlet Palisade"] = "Palissade Écarlate",
	["Scarlet Point"] = "Halte Écarlate",
	["Scarlet Raven Tavern"] = "Taverne du Corbeau écarlate",
	["Scarlet Tavern"] = "Taverne Écarlate",
	["Scarlet Tower"] = "Tour Écarlate",
	["Scarlet Watch Post"] = "Poste de garde de la Croisade",
	["Scarlet Watchtower"] = "Tour de guet Écarlate",
	["Scar of the Worldbreaker"] = "Balafre du Brise-monde",
	["Scarred Terrace"] = "Terrasse Balafrée",
	["Scenario: Alcaz Island"] = "Scénario : île d’Alcaz",
	["Scenario - Black Ox Temple"] = "Scénario - Temple du Buffle noir",
	["Scenario - Mogu Ruins"] = "Scénario - Ruines mogu",
	["Scenic Overlook"] = "Surplomb panoramique",
	["Schnottz's Frigate"] = "Frégate de Schnottz",
	["Schnottz's Hostel"] = "Foyer de Schnottz",
	["Schnottz's Landing"] = "Accostage de Schnottz",
	Scholomance = "Scholomance",
	["Scholomance Entrance"] = "Entrée de la Scholomance",
	ScholomanceOLD = "Scholomance",
	["School of Necromancy"] = "École de Nécromancie",
	["Scorched Gully"] = "Goulet Incendié",
	["Scott's Spooky Area"] = "Zone sinistre de Scott",
	["Scoured Reach"] = "Les confins Creusés",
	Scourgehold = "Fort-Fléau",
	Scourgeholme = "Fléaulme",
	["Scourgelord's Command"] = "Quartier général du Seigneur du Fléau",
	["Scrabblescrew's Camp"] = "Camp de Fouillevis",
	["Screaming Gully"] = "Ravine hurlante",
	["Scryer's Tier"] = "Degré des Clairvoyants",
	["Scuttle Coast"] = "Côte des Naufrages",
	Sea = "Mer",
	Seabrush = "Frôlemer",
	["Seafarer's Tomb"] = "Tombe du marin",
	["Sealed Chambers"] = "Chambres scellées",
	["Seal of the Sun King"] = "Sceau du roi-soleil",
	["Sea Mist Ridge"] = "Crête de la Brume de mer",
	["Searing Gorge"] = "Gorge des Vents brûlants",
	["Seaspittle Cove"] = "Crique Écume-de-Mer",
	["Seaspittle Nook"] = "Niche Écume-de-Mer",
	["Seat of Destruction"] = "Siège de la destruction",
	["Seat of Knowledge"] = "Siège de la Connaissance",
	["Seat of Life"] = "Siège de la vie",
	["Seat of Magic"] = "Siège de la magie",
	["Seat of Radiance"] = "Siège de la radiance",
	["Seat of the Chosen"] = "Siège de l’Élu",
	["Seat of the Naaru"] = "Siège du naaru",
	["Seat of the Spirit Waker"] = "Siège de l’éveilleur d’esprits",
	["Seeker's Folly"] = "Folie du chercheur",
	["Seeker's Point"] = "Halte du Chercheur",
	["Sen'jin Village"] = "Village de Sen’jin",
	["Sen'jin Village Outskirts"] = "Faubourgs de Sen’jin",
	["Sentinel Basecamp"] = "Camp de base des Sentinelles",
	["Sentinel Hill"] = "Colline des Sentinelles",
	["Sentinel Tower"] = "Tour des sentinelles",
	["Sentry Point"] = "Halte de la Vigie",
	Seradane = "Seradane",
	["Serenity Falls"] = "Chutes de la Sérénité",
	["Serpent Lake"] = "Lac des Serpents",
	["Serpent's Coil"] = "Anneaux du serpent",
	["Serpent's Heart"] = "Cœur du serpent",
	["Serpentshrine Cavern"] = "Caverne du sanctuaire du Serpent",
	["Serpent's Overlook"] = "Surplomb du Serpent",
	["Serpent's Spine"] = "Échine du Serpent",
	["Servants' Quarters"] = "Quartiers des serviteurs",
	["Service Entrance"] = "Entrée de service",
	["Sethekk Halls"] = "Les salles des Sethekk",
	["Sethria's Roost"] = "Perchoir de Sethria",
	["Setting Sun Garrison"] = "Garnison du Soleil couchant",
	["Set'vess"] = "Set’vess",
	["Sewer Access Point"] = "Point d’accès aux égoûts",
	["Sewer Exit Pipe"] = "Tunnel de sortie des égouts",
	Sewers = "Egouts",
	Shadebough = "Ramures ombragées",
	["Shadewood Thicket"] = "Fourré d’Ombrebois",
	["Shado-Li Basin"] = "Bassin Shado-Li",
	["Shado-Pan Fallback"] = "Retraite des Pandashan",
	["Shado-Pan Garrison"] = "Garnison des Pandashan",
	["Shado-Pan Monastery"] = "Monastère des Pandashan",
	["Shadowbreak Ravine"] = "Ravin de Brèche-de-l’Ombre",
	["Shadowfang Keep"] = "Donjon d’Ombrecroc",
	["Shadowfang Keep Entrance"] = "Entrée du donjon d’Ombrecroc",
	["Shadowfang Tower"] = "Tour d’Ombrecroc",
	["Shadowforge City"] = "Ville des Ombreforges",
	Shadowglen = "Sombrevallon",
	["Shadow Grave"] = "Tombeau des Ombres",
	["Shadow Hold"] = "Fort des Ombres",
	["Shadow Labyrinth"] = "Labyrinthe des Ombres",
	["Shadowlurk Ridge"] = "Crête d’Ombrerôde",
	["Shadowmoon Valley"] = "Vallée d’Ombrelune",
	["Shadowmoon Village"] = "Village d’Ombrelune",
	["Shadow-Pan Monastery"] = "Monastère des Pandashan",
	["Shadowprey Village"] = "Proie-de-l’Ombre",
	["Shadow Ridge"] = "Ombrecrête",
	["Shadowshard Cavern"] = "Caverne des Ombréclats",
	["Shadowsight Tower"] = "Tour d’Ombrevue",
	["Shadowsong Shrine"] = "Sanctuaire de Chantelombre",
	["Shadowthread Cave"] = "Grotte de Sombrefil",
	["Shadow Tomb"] = "Tombe des Ombres",
	["Shadow Wing Lair"] = "Repaire de l'Aile de l'ombre",
	["Shadra'Alor"] = "Shadra’Alor",
	["Shadybranch Pocket"] = "L’enclave Ombragée",
	["Shady Rest Inn"] = "Auberge du Repos ombragé",
	["Shalandis Isle"] = "Île de Shalandis",
	["Shalewind Canyon"] = "Canyon Vent-de-schiste",
	["Shallow's End"] = "Les Hauts-Fonds",
	["Shallowstep Pass"] = "Chemin du Pas léger",
	["Shalzaru's Lair"] = "Antre de Shalzaru",
	Shamanar = "Shamanar",
	["Sha'naari Wastes"] = "Le désert Sha’naari",
	["Shang's Stead"] = "Ferme de Shang",
	["Shang's Valley"] = "Vallée de Shang",
	["Shang Xi Training Grounds"] = "École de Shang Xi",
	["Shan'ze Dao"] = "Dao Shan’ze",
	["Shaol'mara"] = "Shaol’mara",
	["Shaol'watha"] = "Shaol’watha",
	["Shaper's Terrace"] = "Terrasse du Façonneur",
	["Shaper's Terrace "] = "Terrasse du Façonneur",
	["Shartuul's Transporter"] = "Transporteur de Shartuul",
	["Sha'tari Base Camp"] = "Camp de base Sha’tari",
	["Sha'tari Outpost"] = "Avant-poste Sha’tari",
	["Shattered Convoy"] = "Convoi brisé",
	["Shattered Plains"] = "Les plaines Brisées",
	["Shattered Straits"] = "Les détroits Fracassés",
	["Shattered Sun Staging Area"] = "Zone de rassemblement du Soleil brisé",
	["Shatter Point"] = "Halte du Fracas",
	["Shatter Scar Vale"] = "Val Grêlé",
	Shattershore = "Rivage Ravagé",
	["Shatterspear Pass"] = "Passe des Briselances",
	["Shatterspear Vale"] = "La vallée des Briselances",
	["Shatterspear War Camp"] = "Camp de guerre des Briselances",
	Shatterstone = "Ruinepierre",
	Shattrath = "Shattrath",
	["Shattrath City"] = "Shattrath",
	["Shelf of Mazu"] = "Saillie de Mazu",
	["Shell Beach"] = "Plage aux Coquillages",
	["Shield Hill"] = "Colline du Bouclier",
	["Shields of Silver"] = "Boucliers d'argent",
	["Shimmering Bog"] = "La tourbière Chatoyante",
	["Shimmering Expanse"] = "Étendues Chatoyantes",
	["Shimmering Grotto"] = "Grotte Chatoyante",
	["Shimmer Ridge"] = "Crête Scintillante",
	["Shindigger's Camp"] = "Camp de Croquejarret",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Vaisseau vers Vashj'ir (Orgrimmar -> Vashj'ir)",
	["Shipwreck Shore"] = "Rivage de l’Épave",
	Shipyard = "Chantier naval",
	["Shipyard - Mogu Island Progression Scenario"] = "Chantier naval - Scénario de progression de l’île mogu",
	["Shok'Thokar"] = "Shok’Thokar",
	["Sholazar Basin"] = "Bassin de Sholazar",
	["Shores of the Well"] = "Rivages du Puits",
	["Shrine of Aessina"] = "Sanctuaire d'Aessina",
	["Shrine of Aviana"] = "Sanctuaire d’Aviana",
	["Shrine of Dath'Remar"] = "Sanctuaire de Dath’Remar",
	["Shrine of Dreaming Stones"] = "Sanctuaire des Pierres des songes",
	["Shrine of Eck"] = "Sanctuaire d'Eck",
	["Shrine of Fellowship"] = "Sanctuaire de la Fraternité",
	["Shrine of Five Dawns"] = "Sanctuaire des Cinq matins",
	["Shrine of Goldrinn"] = "Sanctuaire de Goldrinn",
	["Shrine of Inner-Light"] = "Sanctuaire de la Lumière intérieure",
	["Shrine of Lost Souls"] = "Sanctuaire des âmes perdues",
	["Shrine of Nala'shi"] = "Sanctuaire de Nala’shi",
	["Shrine of Remembrance"] = "Sanctuaire du Souvenir",
	["Shrine of Remulos"] = "Sanctuaire de Remulos",
	["Shrine of Scales"] = "Sanctuaire des Écailles",
	["Shrine of Seven Stars"] = "Sanctuaire des Sept-Étoiles",
	["Shrine of Thaurissan"] = "Sanctuaire de Thaurissan",
	["Shrine of the Dawn"] = "Sanctuaire de l’Aube",
	["Shrine of the Deceiver"] = "Sanctuaire du Trompeur",
	["Shrine of the Dormant Flame"] = "Autel de la Flamme dormante",
	["Shrine of the Eclipse"] = "Sanctuaire de l'éclipse",
	["Shrine of the Elements"] = "Autel des Éléments",
	["Shrine of the Fallen Warrior"] = "Autel du Guerrier mort",
	["Shrine of the Five Khans"] = "Sanctuaire des Cinq khans",
	["Shrine of the Merciless One"] = "Sanctuaire du Sans-pitié",
	["Shrine of the Ox"] = "Sanctuaire du Buffle",
	["Shrine of Twin Serpents"] = "Sanctuaire des Serpents-Jumeaux",
	["Shrine of Two Moons"] = "Sanctuaire des Deux-Lunes",
	["Shrine of Unending Light"] = "Sanctuaire de la Lumière perpétuelle",
	["Shriveled Oasis"] = "L’oasis Tarie",
	["Shuddering Spires"] = "Flèches Frissonnantes",
	["SI:7"] = "SI:7",
	["Siege of Niuzao Temple"] = "Siège du temple de Niuzao",
	["Siege Vise"] = "L’étau du Siège",
	["Siege Workshop"] = "Atelier de siège",
	["Sifreldar Village"] = "Sifreldar",
	["Sik'vess"] = "Sik’vess",
	["Sik'vess Lair"] = "Repaire Sik’vess",
	["Silent Vigil"] = "Veille Silencieuse",
	Silithus = "Silithus",
	["Silken Fields"] = "Les champs Soyeux",
	["Silken Shore"] = "Rivage Soyeux",
	["Silmyr Lake"] = "Lac Silmyr",
	["Silting Shore"] = "Rivage Envasé",
	Silverbrook = "Ruissargent",
	["Silverbrook Hills"] = "Collines de Ruissargent",
	["Silver Covenant Pavilion"] = "Pavillon du Concordat argenté",
	["Silverlight Cavern"] = "Caverne de Luisargent",
	["Silverline Lake"] = "Lac Rivargent",
	["Silvermoon City"] = "Lune-d’Argent",
	["Silvermoon City Inn"] = "Auberge de Lune-d’Argent",
	["Silvermoon Finery"] = "Atours de Lune-d’Argent",
	["Silvermoon Jewelery"] = "Joaillerie de Lune-d’Argent",
	["Silvermoon Registry"] = "Bureau d'enregistrement de Lune-d’Argent",
	["Silvermoon's Pride"] = "La Fierté de Lune-d’Argent",
	["Silvermyst Isle"] = "Île de Brume-argent",
	["Silverpine Forest"] = "Forêt des Pins-Argentés",
	["Silvershard Mines"] = "Mines d’Éclargent",
	["Silver Stream Mine"] = "Mine du Ru d’argent",
	["Silver Tide Hollow"] = "Creux des Flots argentés",
	["Silver Tide Trench"] = "Tranchée des Flots argentés",
	["Silverwind Refuge"] = "Refuge de Vent-d’Argent",
	["Silverwing Flag Room"] = "Salle du drapeau des Ailes-argent",
	["Silverwing Grove"] = "Bosquet d’Aile-argent",
	["Silverwing Hold"] = "Fort d’Aile-argent",
	["Silverwing Outpost"] = "Avant-poste d’Aile-argent",
	["Simply Enchanting"] = "Comme par enchantement",
	["Sindragosa's Fall"] = "La chute de Sindragosa",
	["Sindweller's Rise"] = "Cime de Hante-stupre",
	["Singing Marshes"] = "Marais Chantants",
	["Singing Ridge"] = "Crête Chantante",
	["Sinner's Folly"] = "Folie du pécheur",
	["Sira'kess Front"] = "Front de Sira’kess",
	["Sishir Canyon"] = "Canyon de Sishir",
	["Sisters Sorcerous"] = "Aux Sœurs sorcières",
	Skald = "Skald",
	["Sketh'lon Base Camp"] = "Campement Sketh’lon",
	["Sketh'lon Wreckage"] = "Débris Sketh’lon",
	["Skethyl Mountains"] = "Monts Skethyl",
	Skettis = "Skettis",
	["Skitterweb Tunnels"] = "Tunnels de Toile-grouillante",
	Skorn = "Mörg",
	["Skulking Row"] = "Allée de la Rôdaille",
	["Skulk Rock"] = "Rocher de l’Affût",
	["Skull Rock"] = "Rocher du Crâne",
	["Sky Falls"] = "Chutes du Ciel",
	["Skyguard Outpost"] = "Avant-poste de la Garde-ciel",
	["Skyline Ridge"] = "Crête de l’Horizon",
	Skyrange = "Chaîne des Cieux",
	["Skysong Lake"] = "Lac Chanteciel",
	["Slabchisel's Survey"] = "Mission de Cisepierre",
	["Slag Watch"] = "Guet des Scories",
	Slagworks = "Forgeresse",
	["Slaughter Hollow"] = "Creux du Massacre",
	["Slaughter Square"] = "Place du Massacre",
	["Sleeping Gorge"] = "Gorge Endormie",
	["Slicky Stream"] = "La Poisseuse",
	["Slingtail Pits"] = "Fosses de Queutapulte",
	["Slitherblade Shore"] = "Rivage des Ondulames",
	["Slithering Cove"] = "Crique Sinueuse",
	["Slither Rock"] = "Roc Sinueux",
	["Sludgeguard Tower"] = "Tour de Gardefange",
	["Smuggler's Scar"] = "Balafre du contrebandier",
	["Snicklefritz Mine"] = "Mine de Galapiat",
	["Snowblind Hills"] = "Collines du Voile blanc",
	["Snowblind Terrace"] = "Terrasse du Voile blanc",
	["Snowden Chalet"] = "Chalet Antre-des-Neiges",
	["Snowdrift Dojo"] = "Dojo de Banc de Neige",
	["Snowdrift Plains"] = "Plaines des Congères",
	["Snowfall Glade"] = "Clairière de Tombeneige",
	["Snowfall Graveyard"] = "Cimetière des Neiges",
	["Socrethar's Seat"] = "Siège de Socrethar",
	["Sofera's Naze"] = "Promontoire de Sofera",
	["Soggy's Gamble"] = "Pari de Trempette",
	["Solace Glade"] = "Prairie de Solace",
	["Solliden Farmstead"] = "Ferme des Solliden",
	["Solstice Village"] = "Solstice",
	["Sorlof's Strand"] = "La grève de Sorlof",
	["Sorrow Hill"] = "Colline des Chagrins",
	["Sorrow Hill Crypt"] = "Crypte de la Colline des chagrins",
	Sorrowmurk = "Noirchagrin",
	["Sorrow Wing Point"] = "Halte Aile-du-chagrin",
	["Soulgrinder's Barrow"] = "Le refuge du Broyeur-d’âme",
	["Southbreak Shore"] = "Rivage de Brisesud",
	["South Common Hall"] = "Les communs du sud",
	["Southern Barrens"] = "Tarides du Sud",
	["Southern Gold Road"] = "Route de l’Or méridionale",
	["Southern Rampart"] = "Rempart du Sud",
	["Southern Rocketway"] = "Fusorail sud",
	["Southern Rocketway Terminus"] = "Terminus Sud du fusorail",
	["Southern Savage Coast"] = "Côte Sauvage du Sud",
	["Southfury River"] = "La Furie-du-Sud",
	["Southfury Watershed"] = "Débord de la Furie-du-Sud",
	["South Gate Outpost"] = "Avant-poste de la Porte Sud",
	["South Gate Pass"] = "Passage de la Porte Sud",
	["Southmaul Tower"] = "Tour Sud-sanglante",
	["Southmoon Ruins"] = "Ruines de Sudelune",
	["South Pavilion"] = "Pavillon sud",
	["Southpoint Gate"] = "Porte de la Pointe du Midi",
	["South Point Station"] = "Poste de la Halte du Sud",
	["Southpoint Tower"] = "Tour de la Pointe du Midi",
	["Southridge Beach"] = "Plage des Crêtes du sud",
	["Southsea Holdfast"] = "Redoute des mers du Sud",
	["South Seas"] = "Mers du Sud",
	Southshore = "Austrivage",
	["Southshore Town Hall"] = "Hôtel de ville d’Austrivage",
	["South Spire"] = "Flèche Sud",
	["South Tide's Run"] = "La côte Sud",
	["Southwind Cleft"] = "Faille de Sudevent",
	["Southwind Village"] = "Village de Sudevent",
	["Sparkrocket Outpost"] = "Avant-poste de Grilletorpille",
	["Sparksocket Minefield"] = "Champ de mines de Grilledouille",
	["Sparktouched Haven"] = "Le havre Touchétincelle",
	["Sparring Hall"] = "La salle d'entraînement",
	["Spearborn Encampment"] = "Campement Né-des-lances",
	Spearhead = "Fer-de-lance",
	["Speedbarge Bar"] = "Bar de la péniche de course",
	Spellsails = "La Voile Enchantée",
	["Spinebreaker Mountains"] = "Montagnes Brise-échine",
	["Spinebreaker Pass"] = "Passage des Brise-échine",
	["Spinebreaker Post"] = "Poste de Brise-échine",
	["Spinebreaker Ridge"] = "Crête Brise-échine",
	["Spiral of Thorns"] = "Spirale des épines",
	["Spire of Blood"] = "Flèche du Sang",
	["Spire of Decay"] = "Flèche de la Décomposition",
	["Spire of Pain"] = "Flèche de la Douleur",
	["Spire of Solitude"] = "Cime de la Solitude",
	["Spire Throne"] = "Trône du Pic",
	["Spirit Den"] = "Antre des Esprits",
	["Spirit Fields"] = "Champs des Esprits",
	["Spirit Rise"] = "Cime des Esprits",
	["Spirit Rock"] = "Rocher des Esprits",
	["Spiritsong River"] = "Rivière Chantesprit",
	["Spiritsong's Rest"] = "Repos de Chantesprit",
	["Spitescale Cavern"] = "Caverne des Vexécailles",
	["Spitescale Cove"] = "Crique des Vexécailles",
	["Splinterspear Junction"] = "Croisement de Lance-brisée",
	Splintertree = "Bois-Brisé",
	["Splintertree Mine"] = "Mine de Bois-Brisé",
	["Splintertree Post"] = "Poste de Bois-Brisé",
	["Splithoof Crag"] = "Combe du Sabot fendu",
	["Splithoof Heights"] = "Hauteurs du Sabot fendu",
	["Splithoof Hold"] = "Bastion du Sabot fendu",
	Sporeggar = "Sporeggar",
	["Sporewind Lake"] = "Lac Ventespore",
	["Springtail Crag"] = "Combe des Queubrioles",
	["Springtail Warren"] = "Garenne Queubriole",
	["Spruce Point Post"] = "Poste du cap de l’Epicéa",
	["Sra'thik Incursion"] = "L’incursion Sra’thik",
	["Sra'thik Swarmdock"] = "Appontement de l’essaim Sra’thik",
	["Sra'vess"] = "Sra’vess",
	["Sra'vess Rootchamber"] = "Chambracine Sra’vess",
	["Sri-La Inn"] = "Auberge de Sri-La",
	["Sri-La Village"] = "Sri-La",
	Stables = "Écuries",
	Stagalbog = "Stagalbog",
	["Stagalbog Cave"] = "Caverne de Stagalbog",
	["Stagecoach Crash Site"] = "Diligence accidentée",
	["Staghelm Point"] = "Halte de Forteramure",
	["Staging Balcony"] = "Balcon du Rassemblement",
	["Stairway to Honor"] = "Escalier de l’Honneur",
	["Starbreeze Village"] = "Brise-Stellaire",
	["Stardust Spire"] = "Flèche de Chimétoile",
	["Starfall Village"] = "Pluie-d’Étoiles",
	["Stars' Rest"] = "Repos des étoiles",
	["Stasis Block: Maximus"] = "Bloc de stase : Maximus",
	["Stasis Block: Trion"] = "Bloc de stase : Trion",
	["Steam Springs"] = "Sources de Vapeur",
	["Steamwheedle Port"] = "Port Gentepression",
	["Steel Gate"] = "Porte d’Acier",
	["Steelgrill's Depot"] = "Dépôt de Grillacier",
	["Steeljaw's Caravan"] = "Caravane de Mâchoire-d’acier",
	["Steelspark Station"] = "Poste d’Étinçacier",
	["Stendel's Pond"] = "Étang de Stendel",
	["Stillpine Hold"] = "Repaire des Calmepins",
	["Stillwater Pond"] = "Étang Immobile",
	["Stillwhisper Pond"] = "Étang des Murmures-sereins",
	Stonard = "Pierrêche",
	["Stonebreaker Camp"] = "Camp des Brise-pierres",
	["Stonebreaker Hold"] = "Fort des Brise-pierres",
	["Stonebull Lake"] = "Lac Taureau-de-Pierre",
	["Stone Cairn Lake"] = "Lac du Cairn",
	Stonehearth = "Âtrepierre",
	["Stonehearth Bunker"] = "Fortin de Gîtepierre",
	["Stonehearth Graveyard"] = "Cimetière de Gîtepierre",
	["Stonehearth Outpost"] = "Avant-poste de Gîtepierre",
	["Stonemaul Hold"] = "Bastion Cognepierre",
	["Stonemaul Ruins"] = "Ruines Cognepierres",
	["Stone Mug Tavern"] = "Taverne de la Chope de pierre",
	Stoneplow = "Chasse-Pierre",
	["Stoneplow Fields"] = "Champs de Chasse-Pierre",
	["Stone Sentinel's Overlook"] = "Surplomb de la sentinelle de pierre",
	["Stonesplinter Valley"] = "Vallée des Brisepierre",
	["Stonetalon Bomb"] = "Bombe des Serres-Rocheuses",
	["Stonetalon Mountains"] = "Les Serres-Rocheuses",
	["Stonetalon Pass"] = "Passe des Serres-Rocheuses",
	["Stonetalon Peak"] = "Pic des Serres-Rocheuses",
	["Stonewall Canyon"] = "Canyon de la Muraille",
	["Stonewall Lift"] = "Ascenseur de la Muraille",
	["Stoneward Prison"] = "Prison de Gardepierre",
	Stonewatch = "Guet-de-pierre",
	["Stonewatch Falls"] = "Chutes de Guet-de-pierre",
	["Stonewatch Keep"] = "Donjon de Guet-de-pierre",
	["Stonewatch Tower"] = "Tour de Guet-de-pierre",
	["Stonewrought Dam"] = "Barrage de Formepierre",
	["Stonewrought Pass"] = "Passage de Formepierre",
	["Storm Cliffs"] = "Falaises de la Tempête",
	Stormcrest = "Foudrecrête",
	["Stormfeather Outpost"] = "Avant-poste de Plumorage",
	["Stormglen Village"] = "Val-Tempête",
	["Storm Peaks"] = "Les pics Foudroyés",
	["Stormpike Graveyard"] = "Cimetière Foudrepique",
	["Stormrage Barrow Dens"] = "Refuge des saisons de Malfurion",
	["Stormsea Landing"] = "Débarcadère de la mer des Tempêtes",
	["Storm's Fury Wreckage"] = "Épave de la Furie de l’orage",
	["Stormstout Brewery"] = "Brasserie Brune d’Orage",
	["Stormstout Brewery Interior"] = "Intérieur de la brasserie Brune d’Orage",
	["Stormstout Brewhall"] = "Salle de brassage Brune d’Orage",
	Stormwind = "Hurlevent",
	["Stormwind City"] = "Hurlevent",
	["Stormwind City Cemetery"] = "Cimetière de Hurlevent",
	["Stormwind City Outskirts"] = "Faubourgs de Hurlevent",
	["Stormwind Gunship Pandaria Start Area"] = "Zone de départ de la Pandarie, canonnière de Hurlevent",
	["Stormwind Harbor"] = "Port de Hurlevent",
	["Stormwind Keep"] = "Donjon de Hurlevent",
	["Stormwind Lake"] = "Lac de Hurlevent",
	["Stormwind Mountains"] = "Monts Hurlevent",
	["Stormwind Stockade"] = "Prison de Hurlevent",
	["Stormwind Vault"] = "Banque de Hurlevent",
	["Stoutlager Inn"] = "Auberge de la Fortebière",
	Strahnbrad = "Strahnbrande",
	["Strand of the Ancients"] = "Rivage des Anciens",
	["Stranglethorn Vale"] = "Vallée de Strangleronce",
	Stratholme = "Stratholme",
	["Stratholme Entrance"] = "Entrée de Stratholme",
	["Stratholme - Main Gate"] = "Stratholme - Grande porte",
	["Stratholme - Service Entrance"] = "Stratholme - Entrée de service",
	["Stratholme Service Entrance"] = "Entrée de service de Stratholme",
	["Stromgarde Keep"] = "Donjon de Stromgarde",
	["Strongarm Airstrip"] = "Piste d’atterrissage de Gros-Bras",
	["STV Diamond Mine BG"] = "CdB Mine de diamants",
	["Stygian Bounty"] = "Bonnet stygien",
	["Sub zone"] = "Sous-zone",
	["Sulfuron Keep"] = "Donjon de Sulfuron",
	["Sulfuron Keep Courtyard"] = "Cour du donjon de Sulfuron",
	["Sulfuron Span"] = "Viaduc de Sulfuron",
	["Sulfuron Spire"] = "Flèche de Sulfuron",
	["Sullah's Sideshow"] = "Stand de Sullah",
	["Summer's Rest"] = "Repos de l’été",
	["Summoners' Tomb"] = "Tombe des invocateurs",
	["Sunblossom Hill"] = "Colline de Fleur-du-Soleil",
	["Suncrown Village"] = "Solcouronne",
	["Sundown Marsh"] = "Marais du Couchant",
	["Sunfire Point"] = "Halte du Feu solaire",
	["Sunfury Hold"] = "Bastion des Solfurie",
	["Sunfury Spire"] = "Flèche de Solfurie",
	["Sungraze Peak"] = "Pic de Frôle-soleil",
	["Sunken Dig Site"] = "Site de fouilles englouti",
	["Sunken Temple"] = "Temple englouti",
	["Sunken Temple Entrance"] = "Entrée du Temple englouti",
	["Sunreaver Pavilion"] = "Pavillon de Saccage-soleil",
	["Sunreaver's Command"] = "Quartier général de Saccage-soleil",
	["Sunreaver's Sanctuary"] = "Sanctuaire de Saccage-soleil",
	["Sun Rock Retreat"] = "Retraite de Roche-Soleil",
	["Sunsail Anchorage"] = "Mouillage des Voiles du soleil",
	["Sunsoaked Meadow"] = "Prairie d’Aquasoleil",
	["Sunsong Ranch"] = "Ferme Chant du Soleil",
	["Sunspring Post"] = "Poste de Berceau-de-l’Été",
	["Sun's Reach Armory"] = "Armurerie des Confins du soleil",
	["Sun's Reach Harbor"] = "Port des Confins du soleil",
	["Sun's Reach Sanctum"] = "Sanctum des Confins du soleil",
	["Sunstone Terrace"] = "Terrasse Solpierre",
	["Sunstrider Isle"] = "Île de Haut-Soleil",
	["Sunveil Excursion"] = "Expédition de Solevoile",
	["Sunwatcher's Ridge"] = "Crête du Guette-soleil",
	["Sunwell Plateau"] = "Plateau du Puits de soleil",
	["Supply Caravan"] = "Caravane de ravitaillement",
	["Surge Needle"] = "Capteur tellurique",
	["Surveyors' Outpost"] = "Avant-poste des géomètres",
	Surwich = "Surwich",
	["Svarnos' Cell"] = "Cellule de Svarnos",
	["Swamplight Manor"] = "Manoir des Flammeroles",
	["Swamp of Sorrows"] = "Marais des Chagrins",
	["Swamprat Post"] = "Poste du Rat des marais",
	["Swiftgear Station"] = "Poste de Vifembraye",
	["Swindlegrin's Dig"] = "Site de fouilles de Ricarnaque",
	["Swindle Street"] = "Rue de la Fauche",
	["Sword's Rest"] = "Le Repos de l'épée",
	Sylvanaar = "Sylvanaar",
	["Tabetha's Farm"] = "Ferme de Tabetha",
	["Taelan's Tower"] = "Tour de Taelan",
	["Tahonda Ruins"] = "Ruines de Tahonda",
	["Tahret Grounds"] = "Terres de Tahret",
	["Tal'doren"] = "Tal’doren",
	["Talismanic Textiles"] = "Textiles talismaniques",
	["Tallmug's Camp"] = "Camp de Grande Tasse",
	["Talonbranch Glade"] = "Clairière de Griffebranche",
	["Talonbranch Glade "] = "Clairière de Griffebranche",
	["Talondeep Pass"] = "Passe des Serres",
	["Talondeep Vale"] = "Vallée de la Perce des serres",
	["Talon Stand"] = "Séjour des serres",
	Talramas = "Talramas",
	["Talrendis Point"] = "Halte de Talrendis",
	Tanaris = "Tanaris",
	["Tanaris Desert"] = "Désert de Tanaris",
	["Tanks for Everything"] = "Tank il y a de la vie",
	["Tanner Camp"] = "Camp de Tanner",
	["Tarren Mill"] = "Moulin-de-Tarren",
	["Tasters' Arena"] = "Arène des Goûteurs",
	["Taunka'le Village"] = "Taunka’le",
	["Tavern in the Mists"] = "Taverne dans les Brumes",
	["Tazz'Alaor"] = "Tazz'Alaor",
	["Tear Down This Wall!"] = "Démolissez ce mur !",
	["Teegan's Expedition"] = "Expédition de Teegan",
	["Teeming Burrow"] = "Terrier grouillant",
	Telaar = "Telaar",
	["Telaari Basin"] = "Bassin Telaari",
	["Tel'athion's Camp"] = "Camp de Tel’athion",
	Teldrassil = "Teldrassil",
	Telredor = "Telredor",
	["Tempest Bridge"] = "Pont de la Tempête",
	["Tempest Keep"] = "Donjon de la Tempête",
	["Tempest Keep: The Arcatraz"] = "Donjon de la Tempête : l'Arcatraz",
	["Tempest Keep - The Arcatraz Entrance"] = "Donjon de la Tempête - Entrée de l’Arcatraz",
	["Tempest Keep: The Botanica"] = "Donjon de la Tempête : la Botanica",
	["Tempest Keep - The Botanica Entrance"] = "Donjon de la Tempête - Entrée de la Botanica",
	["Tempest Keep: The Mechanar"] = "Donjon de la Tempête : le Méchanar",
	["Tempest Keep - The Mechanar Entrance"] = "Donjon de la Tempête - Entrée du Méchanar",
	["Tempest's Reach"] = "Confins de la Tourmente",
	["Temple City of En'kilah"] = "Ville-temple d’En’kilah",
	["Temple Hall"] = "Hall du Temple",
	["Temple of Ahn'Qiraj"] = "Le temple d'Ahn'Qiraj",
	["Temple of Arkkoran"] = "Temple d'Arkkoran",
	["Temple of Asaad"] = "Temple d'Asaad",
	["Temple of Bethekk"] = "Temple de Bethekk",
	["Temple of Earth"] = "Temple de la Terre",
	["Temple of Five Dawns"] = "Temple des Cinq matins",
	["Temple of Invention"] = "Temple de l’Innovation",
	["Temple of Kotmogu"] = "Temple de Kotmogu",
	["Temple of Life"] = "Temple de la Vie",
	["Temple of Order"] = "Temple de l’Ordre",
	["Temple of Storms"] = "Temple des Tempêtes",
	["Temple of Telhamat"] = "Temple de Telhamat",
	["Temple of the Forgotten"] = "Temple des oubliés",
	["Temple of the Jade Serpent"] = "Temple du Serpent de jade",
	["Temple of the Moon"] = "Temple de la Lune",
	["Temple of the Red Crane"] = "Temple de la Grue rouge",
	["Temple of the White Tiger"] = "Temple du Tigre blanc",
	["Temple of Uldum"] = "Temple d’Uldum",
	["Temple of Winter"] = "Temple de l’Hiver",
	["Temple of Wisdom"] = "Temple de la Sagesse",
	["Temple of Zin-Malor"] = "Temple de Zin-Malor",
	["Temple Summit"] = "Sommet du temple",
	["Tenebrous Cavern"] = "Caverne Ténébreuse",
	["Terokkar Forest"] = "Forêt de Terokkar",
	["Terokk's Rest"] = "Repos de Terokk",
	["Terrace of Endless Spring"] = "Terrasse Printanière",
	["Terrace of Gurthan"] = "Terrasse de Gurthan",
	["Terrace of Light"] = "Terrasse de la Lumière",
	["Terrace of Repose"] = "Terrasse de la Quiétude",
	["Terrace of Ten Thunders"] = "Terrasse des Cent tonnerres",
	["Terrace of the Augurs"] = "Terrasse des Augures",
	["Terrace of the Makers"] = "Terrasse des Faiseurs",
	["Terrace of the Sun"] = "Terrasse du soleil",
	["Terrace of the Tiger"] = "Terrasse du Tigre",
	["Terrace of the Twin Dragons"] = "Terrasse des Dragons jumeaux",
	Terrordale = "Val-Terreur",
	["Terror Run"] = "Coteaux de la Terreur",
	["Terrorweb Tunnel"] = "Tunnel de Tisse-terreur",
	["Terror Wing Path"] = "Chemin de l’Aile de la terreur",
	["Tethris Aran"] = "Tethris Aran",
	Thalanaar = "Thalanaar",
	["Thalassian Pass"] = "Passe Thalassienne",
	["Thalassian Range"] = "Chaîne Thalassienne",
	["Thal'darah Grove"] = "Bosquet de Thal’darah",
	["Thal'darah Overlook"] = "Surplomb de Thal’darah",
	["Thandol Span"] = "Viaduc de Thandol",
	["Thargad's Camp"] = "Camp de Thargad",
	["The Abandoned Reach"] = "Les confins Abandonnés",
	["The Abyssal Maw"] = "La Gueule des abysses",
	["The Abyssal Shelf"] = "La saillie Abyssale",
	["The Admiral's Den"] = "La tanière de l’Amiral",
	["The Agronomical Apothecary"] = "L'apothicaire agronomique",
	["The Alliance Valiants' Ring"] = "La lice des vaillants de l’Alliance",
	["The Altar of Damnation"] = "L’autel de la Damnation",
	["The Altar of Shadows"] = "L’autel des Ombres",
	["The Altar of Zul"] = "L’Autel de Zul",
	["The Amber Hibernal"] = "L’ambre Hibernal",
	["The Amber Vault"] = "Caveau de l’Ambre",
	["The Amber Womb"] = "Les Entrailles de l’ambre",
	["The Ancient Grove"] = "Le bosquet Antique",
	["The Ancient Lift"] = "L’Antique élévateur",
	["The Ancient Passage"] = "L’ancien Passage",
	["The Antechamber"] = "L'antichambre",
	["The Anvil of Conflagration"] = "Enclume de la Déflagration",
	["The Anvil of Flame"] = "Enclume des Flammes",
	["The Apothecarium"] = "L'Apothicarium",
	["The Arachnid Quarter"] = "Le quartier des Arachnides",
	["The Arboretum"] = "L’Arboretum",
	["The Arcanium"] = "L'Arcanium",
	["The Arcanium "] = "L'Arcanium",
	["The Arcatraz"] = "L’Arcatraz",
	["The Archivum"] = "L’Archivum",
	["The Argent Stand"] = "Le séjour d’Argent",
	["The Argent Valiants' Ring"] = "La lice des vaillants d’Argent",
	["The Argent Vanguard"] = "L’avant-garde d’Argent",
	["The Arsenal Absolute"] = "L'Arsenal absolu",
	["The Aspirants' Ring"] = "La lice des aspirants",
	["The Assembly Chamber"] = "Salle capitulaire",
	["The Assembly of Iron"] = "L'assemblée du Fer",
	["The Athenaeum"] = "L'Athenaeum",
	["The Autumn Plains"] = "Les plaines de l’automne",
	["The Avalanche"] = "L’Avalanche",
	["The Azure Front"] = "Le front Azur",
	["The Bamboo Wilds"] = "La bambouseraie Sauvage",
	["The Bank of Dalaran"] = "Banque de Dalaran",
	["The Bank of Silvermoon"] = "Banque de Lune-d'argent",
	["The Banquet Hall"] = "La salle de banquet",
	["The Barrier Hills"] = "La Barrière",
	["The Bastion of Twilight"] = "Le bastion du Crépuscule",
	["The Battleboar Pen"] = "Enclos des Sangliers de guerre",
	["The Battle for Gilneas"] = "La bataille de Gilnéas",
	["The Battle for Gilneas (Old City Map)"] = "La bataille de Gilnéas (ancienne carte de la ville)",
	["The Battle for Mount Hyjal"] = "La bataille du mont Hyjal",
	["The Battlefront"] = "La Ligne de front",
	["The Bazaar"] = "Le Bazar",
	["The Beast Pens"] = "Les enclos à bêtes",
	["The Beer Garden"] = "La guinguette",
	["The Bite"] = "La Morsure",
	["The Black Breach"] = "La brèche Noire",
	["The Black Market"] = "Le marché Noir",
	["The Black Morass"] = "Le Noir marécage",
	["The Black Temple"] = "Le temple Noir",
	["The Black Vault"] = "La Voûte noire",
	["The Blackwald"] = "La forêt Noire",
	["The Blazing Strand"] = "La grève Flamboyante",
	["The Blighted Pool"] = "L’étang Chancreux",
	["The Blight Line"] = "La Ligne de la désolation",
	["The Bloodcursed Reef"] = "Le récif du Sang maudit",
	["The Blood Furnace"] = "La Fournaise du sang",
	["The Bloodmire"] = "Le bourbier Sanglant",
	["The Bloodoath"] = "Le Serment de sang",
	["The Blood Trail"] = "La traînée de Sang",
	["The Bloodwash"] = "Le reflux Sanglant",
	["The Boiling Crustacean"] = "Le crustacé bouillant",
	["The Bombardment"] = "Le Bombardement",
	["The Bonefields"] = "Les champs d’Ossements",
	["The Bone Pile"] = "Le Tas d'os",
	["The Bones of Nozronn"] = "Les os de Nozronn",
	["The Bone Wastes"] = "Le désert des Ossements",
	["The Boneyard"] = "Le Charnier",
	["The Borean Wall"] = "Le mur Boréen",
	["The Botanica"] = "La Botanica",
	["The Bradshaw Mill"] = "Le moulin de Bradshaw",
	["The Breach"] = "La Brèche",
	["The Briny Cutter"] = "Le Fend-les-flots",
	["The Briny Muck"] = "Bourbe saumâtre",
	["The Briny Pinnacle"] = "Cime Saumâtre",
	["The Broken Bluffs"] = "Les pitons Brisés",
	["The Broken Front"] = "Le front Brisé",
	["The Broken Hall"] = "Le Hall brisé",
	["The Broken Hills"] = "Les collines brisées",
	["The Broken Stair"] = "L'Escalier brisé",
	["The Broken Temple"] = "Le temple Brisé",
	["The Broodmother's Nest"] = "Le nid de la Mère des couvées",
	["The Brood Pit"] = "La Fosse des couvées",
	["The Bulwark"] = "La Barricade",
	["The Burlap Trail"] = "La piste de la Toile de jute",
	["The Burlap Valley"] = "La vallée de la Toile de jute",
	["The Burlap Waystation"] = "Le relais de la Toile de jute",
	["The Burning Corridor"] = "Le couloir Brûlant",
	["The Butchery"] = "La Boucherie",
	["The Cache of Madness"] = "L’antre de la Folie",
	["The Caller's Chamber"] = "La chambre de l'Invocateur",
	["The Canals"] = "Les Canaux",
	["The Cape of Stranglethorn"] = "Cap Strangleronce",
	["The Carrion Fields"] = "Les champs de la Charogne",
	["The Catacombs"] = "Les catacombes",
	["The Cauldron"] = "Le Chaudron",
	["The Cauldron of Flames"] = "Le Chaudron des flammes",
	["The Cave"] = "La Grotte",
	["The Celestial Planetarium"] = "Le planétarium céleste",
	["The Celestial Vault"] = "Le caveau des Astres",
	["The Celestial Watch"] = "Le Guet céleste",
	["The Cemetary"] = "Le Cimetière",
	["The Cerebrillum"] = "Le Cervellium",
	["The Charred Vale"] = "Le val Calciné",
	["The Chilled Quagmire"] = "Le bourbier Glacial",
	["The Chum Bucket"] = "Le Seau gaillard",
	["The Circle of Cinders"] = "Le cercle des Braises",
	["The Circle of Life"] = "Le cercle de Vie",
	["The Circle of Suffering"] = "Cercle de Souffrance",
	["The Clarion Bell"] = "La cloche Cristalline",
	["The Clash of Thunder"] = "Le Fracas du tonnerre",
	["The Clean Zone"] = "La zone propre",
	["The Cleft"] = "La Faille",
	["The Clockwerk Run"] = "La Fuite du temps",
	["The Clutch"] = "L’Étreinte",
	["The Clutches of Shek'zeer"] = "Nids de Shek’zeer",
	["The Coil"] = "L’Anneau",
	["The Colossal Forge"] = "La Forge colossale",
	["The Comb"] = "Les Rayons",
	["The Commons"] = "Les communs",
	["The Conflagration"] = "La Déflagration",
	["The Conquest Pit"] = "La fosse des Conquérants",
	["The Conservatory"] = "Le jardin d'hiver",
	["The Conservatory of Life"] = "Le jardin de la Vie",
	["The Construct Quarter"] = "Le quartier des Assemblages",
	["The Cooper Residence"] = "La résidence des Tonnelier",
	["The Corridors of Ingenuity"] = "Les couloirs d'Ingéniosité",
	["The Court of Bones"] = "La cour des Ossements",
	["The Court of Skulls"] = "La cour des Crânes",
	["The Coven"] = "Le Convent",
	["The Coven "] = "Le Convent",
	["The Creeping Ruin"] = "Les ruines aux Rampants",
	["The Crimson Assembly Hall"] = "Salle de l’Assemblée cramoisie",
	["The Crimson Cathedral"] = "La cathédrale Cramoisie",
	["The Crimson Dawn"] = "L'Aube cramoisie",
	["The Crimson Hall"] = "La salle Cramoisie",
	["The Crimson Reach"] = "Les confins Cramoisis",
	["The Crimson Throne"] = "Le Trône cramoisi",
	["The Crimson Treader"] = "La Gouverne cramoisie",
	["The Crimson Veil"] = "La Voile cramoisie",
	["The Crossroads"] = "La Croisée",
	["The Crucible"] = "Le Creuset",
	["The Crucible of Flame"] = "Le Creuset des flammes",
	["The Crumbling Waste"] = "La Désagrégation",
	["The Cryo-Core"] = "Le Cryocœur",
	["The Crystal Hall"] = "Hall de Cristal",
	["The Crystal Shore"] = "Le rivage de Cristal",
	["The Crystal Vale"] = "La vallée des Cristaux",
	["The Crystal Vice"] = "L’Étau de cristal",
	["The Culling of Stratholme"] = "L’Épuration de Stratholme",
	["The Culling of Stratholme Entrance"] = "L’entrée de l’Épuration de Stratholme",
	["The Cursed Landing"] = "L’accostage Maudit",
	["The Dagger Hills"] = "Les collines de la Dague",
	["The Dai-Lo Farmstead"] = "Ferme Dai-Lo",
	["The Damsel's Luck"] = "La Chance de la demoiselle",
	["The Dancing Serpent"] = "Au Serpent qui danse",
	["The Dark Approach"] = "La Sombre marche",
	["The Dark Defiance"] = "Le Noir défi",
	["The Darkened Bank"] = "La rive Sombre",
	["The Dark Hollow"] = "Le creux Obscur",
	["The Darkmoon Faire"] = "Foire de Sombrelune",
	["The Dark Portal"] = "La porte des Ténèbres",
	["The Dark Rookery"] = "La sombre Colonie",
	["The Darkwood"] = "Le Sombrebois",
	["The Dawnchaser"] = "Le Chasselaube",
	["The Dawning Isles"] = "Les îles de l’Aube",
	["The Dawning Span"] = "L’arche du Point-du-Jour",
	["The Dawning Square"] = "Place du Point-du-jour",
	["The Dawning Stair"] = "L’escalier du Point-du-Jour",
	["The Dawning Valley"] = "Vallée du Point-du-Jour",
	["The Dead Acre"] = "L’acre Mort",
	["The Dead Field"] = "Le champ des Morts",
	["The Dead Fields"] = "Les champs des Morts",
	["The Deadmines"] = "Les Mortemines",
	["The Dead Mire"] = "La Morte-bourbe",
	["The Dead Scar"] = "La Malebrèche",
	["The Deathforge"] = "La Forgemort",
	["The Deathknell Graves"] = "Les tombeaux du Glas",
	["The Decrepit Fields"] = "Les champs Délabrés",
	["The Decrepit Flow"] = "Le courant Stagnant",
	["The Deeper"] = "La Fosse",
	["The Deep Reaches"] = "Le Fin-fond",
	["The Deepwild"] = "Profondeurs sauvages",
	["The Defiant"] = "L’Insurgé",
	["The Defiled Chapel"] = "La chapelle Profanée",
	["The Den"] = "L’Antre",
	["The Den of Flame"] = "L’antre des Flammes",
	["The Dens of Dying"] = "Les tanières du Trépas",
	["The Dens of the Dying"] = "Les tanières du Trépas",
	["The Descent into Madness"] = "La Descente dans la folie",
	["The Desecrated Altar"] = "L’autel Désacralisé",
	["The Devil's Terrace"] = "La terrasse du Diable",
	["The Devouring Breach"] = "La brèche Dévorante",
	["The Domicile"] = "Le Domicile",
	["The Domicile "] = "Le Domicile",
	["The Dooker Dome"] = "Le dome Doukacque",
	["The Dor'Danil Barrow Den"] = "Refuge des saisons de Dor’danil",
	["The Dormitory"] = "Le dortoir",
	["The Drag"] = "La Herse",
	["The Dragonmurk"] = "Le cloaque aux Dragons",
	["The Dragon Wastes"] = "Le désert des Dragons",
	["The Drain"] = "La Vidange",
	["The Dranosh'ar Blockade"] = "Barricade de Dranosh’ar",
	["The Drowned Reef"] = "Le récif Englouti",
	["The Drowned Sacellum"] = "Le sacellum Englouti",
	["The Drunken Hozen"] = "L’ivresse du Hozen",
	["The Dry Hills"] = "Les collines Arides",
	["The Dustbowl"] = "Vallée de la Poussière",
	["The Dust Plains"] = "Les plaines de Poussière",
	["The Eastern Earthshrine"] = "Le sanctuaire Terrestre de l’Est",
	["The Elders' Path"] = "La voie des Anciens",
	["The Emerald Summit"] = "Le sommet d’Émeraude",
	["The Emperor's Approach"] = "La marche de l’Empereur",
	["The Emperor's Gate"] = "La Porte de l’empereur",
	["The Emperor's Reach"] = "Confins de l’Empereur",
	["The Emperor's Step"] = "Le Pas de l’empereur",
	["The Escape From Durnholde"] = "L'évasion de Fort-de-Durn",
	["The Escape from Durnholde Entrance"] = "Entrée de l’évasion de Fort-de-Durn",
	["The Eventide"] = "Le Brunant",
	["The Exodar"] = "L’Exodar",
	["The Eye"] = "L'Œil",
	["The Eye of Eternity"] = "L’Œil de l’éternité",
	["The Eye of the Vortex"] = "L’Œil du Vortex",
	["The Fall of Shan Bu"] = "La chute de Shan Bu",
	["The Farstrider Lodge"] = "Le pavillon des Pérégrins",
	["The Feeding Pits"] = "La Mange-Fosse",
	["The Fel Pits"] = "Les Gangrefosses",
	["The Fertile Copse"] = "Taillis Fertile",
	["The Fetid Pool"] = "Le bassin Fétide",
	["The Filthy Animal"] = "À la sale bête",
	["The Firehawk"] = "Le Faucon-de-feu",
	["The Five Sisters"] = "Les Cinq Sœurs",
	["The Flamewake"] = "Le Sillage des flammes",
	["The Fleshwerks"] = "La Charognerie",
	["The Flood Plains"] = "Les plaines Inondées",
	["The Fold"] = "Le Repli",
	["The Foothill Caverns"] = "Les cavernes des Contreforts",
	["The Foot of Lei Shen"] = "Le Seuil de Lei Shen",
	["The Foot Steppes"] = "Le Pied-Mont",
	["The Forbidden Jungle"] = "La jungle Interdite",
	["The Forbidding Sea"] = "La mer Interdite",
	["The Forest of Shadows"] = "La forêt des Ombres",
	["The Forge of Souls"] = "La Forge des Âmes",
	["The Forge of Souls Entrance"] = "Entrée de la forge des Âmes",
	["The Forge of Supplication"] = "Forge de la Supplique",
	["The Forge of Wills"] = "La Forge des volontés",
	["The Forgotten Coast"] = "La côte Oubliée",
	["The Forgotten Overlook"] = "Le surplomb Oublié",
	["The Forgotten Pool"] = "Les bassins Oubliés",
	["The Forgotten Pools"] = "Les bassins Oubliés",
	["The Forgotten Shore"] = "La côte Oubliée",
	["The Forlorn Cavern"] = "La caverne Lugubre",
	["The Forlorn Mine"] = "La mine Lugubre",
	["The Forsaken Front"] = "Le front des Réprouvés",
	["The Foul Pool"] = "Le bassin Souillé",
	["The Frigid Tomb"] = "La tombe Algide",
	["The Frost Queen's Lair"] = "Le repaire de la Reine du Givre",
	["The Frostwing Halls"] = "Les salles de l’Aile de givre",
	["The Frozen Glade"] = "La clairière Gelée",
	["The Frozen Halls"] = "Les salles Gelées",
	["The Frozen Mine"] = "La mine Gelée",
	["The Frozen Sea"] = "La mer Gelée",
	["The Frozen Throne"] = "Le Trône de glace",
	["The Fungal Vale"] = "La vallée des Fongus",
	["The Furnace"] = "La Fournaise",
	["The Gaping Chasm"] = "Le gouffre Béant",
	["The Gatehouse"] = "La Conciergerie",
	["The Gatehouse "] = "La Conciergerie",
	["The Gate of Unending Cycles"] = "La porte des Cycles infinis",
	["The Gauntlet"] = "Le Défi",
	["The Geyser Fields"] = "Les champs de Geysers",
	["The Ghastly Confines"] = "Les confins Fantomatiques",
	["The Gilded Foyer"] = "Le foyer Doré",
	["The Gilded Gate"] = "La Porte dorée",
	["The Gilding Stream"] = "Le ruisseau Doré",
	["The Glimmering Pillar"] = "Le pilier Scintillant",
	["The Golden Gateway"] = "Les portes Mordorées",
	["The Golden Hall"] = "La salle d’Or",
	["The Golden Lantern"] = "La Lanterne ambrée",
	["The Golden Pagoda"] = "La Pagode dorée",
	["The Golden Plains"] = "Les plaines Dorées",
	["The Golden Rose"] = "La Rose d’or",
	["The Golden Stair"] = "L’escalier Doré",
	["The Golden Terrace"] = "La terrasse d’Or",
	["The Gong of Hope"] = "Le Gong de l’Espoir",
	["The Grand Ballroom"] = "La grande salle de bal",
	["The Grand Vestibule"] = "Grand Vestibule",
	["The Great Arena"] = "La Grande arène",
	["The Great Divide"] = "La Grande division",
	["The Great Fissure"] = "La Grande fissure",
	["The Great Forge"] = "La Grande forge",
	["The Great Gate"] = "La Grande porte",
	["The Great Lift"] = "La Grande élévation",
	["The Great Ossuary"] = "Le Grand ossuaire",
	["The Great Sea"] = "La Grande mer",
	["The Great Tree"] = "Le Grand arbre",
	["The Great Wheel"] = "La Grande Roue",
	["The Green Belt"] = "La Ceinture verte",
	["The Greymane Wall"] = "Le mur de Grisetête",
	["The Grim Guzzler"] = "Le Sinistre écluseur",
	["The Grinding Quarry"] = "La Carrière grinçante",
	["The Grizzled Den"] = "L’antre Gris",
	["The Grummle Bazaar"] = "Le bazar des grumelots",
	["The Guardhouse"] = "Le Corps de garde",
	["The Guest Chambers"] = "Les Appartements des hôtes",
	["The Gullet"] = "Le Gosier",
	["The Halfhill Market"] = "Marché de Micolline",
	["The Half Shell"] = "La Demi-coquille",
	["The Hall of Blood"] = "Le hall du Sang",
	["The Hall of Gears"] = "Le Hall des engrenages",
	["The Hall of Lights"] = "Le Hall des lumières",
	["The Hall of Respite"] = "Les salles du Répit",
	["The Hall of Statues"] = "La salle des Statues",
	["The Hall of the Serpent"] = "La salle du Serpent",
	["The Hall of Tiles"] = "La salle des Tuiles",
	["The Halls of Reanimation"] = "Les salles de réanimation",
	["The Halls of Winter"] = "Les salles de l'Hiver",
	["The Hand of Gul'dan"] = "La Main de Gul’dan",
	["The Harborage"] = "Le havre Boueux",
	["The Hatchery"] = "La chambre des Œufs",
	["The Headland"] = "L’Avancée",
	["The Headlands"] = "L’Éminence",
	["The Heap"] = "Le Monceau",
	["The Heartland"] = "Le Giron",
	["The Heart of Acherus"] = "Le cœur d'Achérus",
	["The Heart of Jade"] = "Le Cœur de jade",
	["The Hidden Clutch"] = "La Couvée cachée",
	["The Hidden Grove"] = "Le bosquet Caché",
	["The Hidden Hollow"] = "Le creux Caché",
	["The Hidden Passage"] = "Le passage Secret",
	["The Hidden Reach"] = "La voie cachée",
	["The Hidden Reef"] = "Le récif Caché",
	["The High Path"] = "Le Haut chemin",
	["The High Road"] = "La Haute-route",
	["The High Seat"] = "Le Haut Siège",
	["The Hinterlands"] = "Les Hinterlands",
	["The Hoard"] = "Le Trésor",
	["The Hole"] = "Le Trou",
	["The Horde Valiants' Ring"] = "La lice des vaillants de la Horde",
	["The Horrid March"] = "La Sente épouvantable",
	["The Horsemen's Assembly"] = "L'assemblée des Cavaliers",
	["The Howling Hollow"] = "Le creux Hurlant",
	["The Howling Oak"] = "Le Chêne hurlant",
	["The Howling Vale"] = "Le val Hurlant",
	["The Hunter's Reach"] = "La Portée du chasseur",
	["The Hushed Bank"] = "La rive Silencieuse",
	["The Icy Depths"] = "Les Profondeurs glacées",
	["The Immortal Coil"] = "La Glène immortelle",
	["The Imperial Exchange"] = "La Bourse impériale",
	["The Imperial Granary"] = "Le grenier Impérial",
	["The Imperial Mercantile"] = "Le Commerce impérial",
	["The Imperial Seat"] = "Le Siège impérial",
	["The Incursion"] = "L’Incursion",
	["The Infectis Scar"] = "La Balafre infecte",
	["The Inferno"] = "L’Ignescence",
	["The Inner Spire"] = "La flèche Intérieure",
	["The Intrepid"] = "L’Intrépide",
	["The Inventor's Library"] = "Bibliothèque de l’Inventeur",
	["The Iron Crucible"] = "Le creuset de Fer",
	["The Iron Hall"] = "Le Hall de fer",
	["The Iron Reaper"] = "La Faucheuse de fer",
	["The Isle of Spears"] = "L’île des Lances",
	["The Ivar Patch"] = "Le lopin d’Ivar",
	["The Jade Forest"] = "La forêt de Jade",
	["The Jade Vaults"] = "Les caveaux de Jade",
	["The Jansen Stead"] = "La ferme des Jansen",
	["The Keggary"] = "La Tonnellerie",
	["The Kennel"] = "Le Chenil",
	["The Krasari Ruins"] = "Les ruines Krasari",
	["The Krazzworks"] = "Le Kraazar",
	["The Laboratory"] = "Le Laboratoire",
	["The Lady Mehley"] = "La Dame Mehley",
	["The Lagoon"] = "Le Lagon",
	["The Laughing Stand"] = "La grève Rieuse",
	["The Lazy Turnip"] = "Le Navet fainéant",
	["The Legerdemain Lounge"] = "L'Abracadabar",
	["The Legion Front"] = "Le front de la Légion",
	["Thelgen Rock"] = "Rocher de Thelgen",
	["The Librarium"] = "Le Librarium",
	["The Library"] = "La Bibliothèque",
	["The Lifebinder's Cell"] = "Cellule de la Lieuse-de-vie",
	["The Lifeblood Pillar"] = "Le pilier Sang-de-vie",
	["The Lightless Reaches"] = "Les confins Enténébrés",
	["The Lion's Redoubt"] = "La redoute du Lion",
	["The Living Grove"] = "Le bosquet Vivant",
	["The Living Wood"] = "Le bois Vivant",
	["The LMS Mark II"] = "Le LMS Mod. II",
	["The Loch"] = "Le Loch",
	["The Long Wash"] = "Le Lent reflux",
	["The Lost Fleet"] = "La flotte Perdue",
	["The Lost Fold"] = "Le Repli perdu",
	["The Lost Isles"] = "Les îles Perdues",
	["The Lost Lands"] = "Les terres Perdues",
	["The Lost Passage"] = "Le passage Perdu",
	["The Low Path"] = "Le Bas chemin",
	Thelsamar = "Thelsamar",
	["The Lucky Traveller"] = "Au petit Bonheur la chance",
	["The Lyceum"] = "Le Lyceum",
	["The Maclure Vineyards"] = "Vignes des Maclure",
	["The Maelstrom"] = "Le Maelström",
	["The Maker's Overlook"] = "Surplomb du Faiseur",
	["The Makers' Overlook"] = "Le surplomb du Faiseur",
	["The Makers' Perch"] = "Perchoir du Faiseur",
	["The Maker's Rise"] = "Cime du Faiseur",
	["The Maker's Terrace"] = "La terrasse du Faiseur",
	["The Manufactory"] = "La Manufacture",
	["The Marris Stead"] = "La ferme des Marris",
	["The Marshlands"] = "La Fondrière",
	["The Masonary"] = "La Maçonnerie",
	["The Master's Cellar"] = "La cave du maître",
	["The Master's Glaive"] = "Le Glaive du maître",
	["The Maul"] = "L’Étripoir",
	["The Maw of Madness"] = "L’antre de la Folie",
	["The Mechanar"] = "Le Méchanar",
	["The Menagerie"] = "La Ménagerie",
	["The Menders' Stead"] = "Le bivouac des Soigneurs",
	["The Merchant Coast"] = "La côte des Marchands",
	["The Militant Mystic"] = "Le Mystique belliqueux",
	["The Military Quarter"] = "Le quartier Militaire",
	["The Military Ward"] = "La Garde militaire",
	["The Mind's Eye"] = "La Vue de l'esprit",
	["The Mirror of Dawn"] = "Le Miroir de l’aube",
	["The Mirror of Twilight"] = "Le Miroir du crépuscule",
	["The Molsen Farm"] = "La ferme des Molsen",
	["The Molten Bridge"] = "Le pont de magma",
	["The Molten Core"] = "Le Cœur du Magma",
	["The Molten Fields"] = "Les champs Liquéfiés",
	["The Molten Flow"] = "Le courant du Magma",
	["The Molten Span"] = "Le viaduc du magma",
	["The Mor'shan Rampart"] = "Le Rempart de Mor’shan",
	["The Mor'Shan Ramparts"] = "Le rempart de Mor'shan",
	["The Mosslight Pillar"] = "Le pilier Mousselume",
	["The Mountain Den"] = "La tanière du Mont",
	["The Murder Pens"] = "Les enclos meurtriers",
	["The Mystic Ward"] = "La Garde mystique",
	["The Necrotic Vault"] = "Le caveau nécrotique",
	["The Nexus"] = "Le Nexus",
	["The Nexus Entrance"] = "Entrée du Nexus",
	["The Nightmare Scar"] = "La Balafre du Cauchemar",
	["The North Coast"] = "La côte Nord",
	["The North Sea"] = "La mer Boréale",
	["The Nosebleeds"] = "Les Gueules-Cassées",
	["The Noxious Glade"] = "La clairière Nocive",
	["The Noxious Hollow"] = "Le creux empoisonné",
	["The Noxious Lair"] = "Le repaire Nuisible",
	["The Noxious Pass"] = "La passe Nocive",
	["The Oblivion"] = "L'Oubli",
	["The Observation Ring"] = "le cercle d'observation",
	["The Obsidian Sanctum"] = "Le sanctum Obsidien",
	["The Oculus"] = "L’Oculus",
	["The Oculus Entrance"] = "Entrée de l’Oculus",
	["The Old Barracks"] = "La Vieille caserne",
	["The Old Dormitory"] = "L'ancien dortoir",
	["The Old Port Authority"] = "L'ancienne capitainerie",
	["The Opera Hall"] = "L'Opéra",
	["The Oracle Glade"] = "La clairière de l’Oracle",
	["The Outer Ring"] = "Le cercle extérieur",
	["The Overgrowth"] = "Le Lacis",
	["The Overlook"] = "Le Surplomb",
	["The Overlook Cliffs"] = "Les Hauts-Surplombs",
	["The Overlook Inn"] = "Auberge du Surplomb",
	["The Ox Gate"] = "La porte du Buffle",
	["The Pale Roost"] = "Le perchoir Diaphane",
	["The Park"] = "Le Parc",
	["The Path of Anguish"] = "Le chemin de l’Angoisse",
	["The Path of Conquest"] = "La voie de la Conquête",
	["The Path of Corruption"] = "La voie de la Corruption",
	["The Path of Glory"] = "Le sentier de la Gloire",
	["The Path of Iron"] = "Le sentier du Fer",
	["The Path of the Lifewarden"] = "Le chemin de la Gardienne de la vie",
	["The Phoenix Hall"] = "Le hall du Phénix",
	["The Pillar of Ash"] = "Le Pilier de cendres",
	["The Pipe"] = "La Conduite",
	["The Pit of Criminals"] = "La Fosse des criminels",
	["The Pit of Fiends"] = "La fosse aux Démons",
	["The Pit of Narjun"] = "La fosse de Narjun",
	["The Pit of Refuse"] = "La Fosse aux ordures",
	["The Pit of Sacrifice"] = "La Fosse aux sacrifices",
	["The Pit of Scales"] = "La fosse des Écailles",
	["The Pit of the Fang"] = "La fosse du Croc",
	["The Plague Quarter"] = "Le quartier de la Peste",
	["The Plagueworks"] = "La Pesterie",
	["The Pool of Ask'ar"] = "Le Bassin d'Ask'ar",
	["The Pools of Vision"] = "Les bassins de la Vision",
	["The Prison of Yogg-Saron"] = "La prison de Yogg-Saron",
	["The Proving Grounds"] = "Le terrain d’Essai",
	["The Purple Parlor"] = "Le salon Violet",
	["The Quagmire"] = "Le Bourbier",
	["The Quaking Fields"] = "Les fonds Tremblants",
	["The Queen's Reprisal"] = "La Riposte de la reine",
	["The Raging Chasm"] = "Le gouffre Déchaîné",
	Theramore = "Theramore",
	["Theramore Isle"] = "Île de Theramore",
	["Theramore's Fall"] = "La chute de Theramore",
	["Theramore's Fall (A)"] = "Chute de Theramore (A)",
	["Theramore's Fall (H)"] = "Chute de Theramore (H)",
	["Theramore's Fall Phase"] = "Phase de la chute de Theramore",
	["The Rangers' Lodge"] = "Pavillon des forestiers",
	["Therazane's Throne"] = "Trône de Therazane",
	["The Red Reaches"] = "Les confins Rouges",
	["The Refectory"] = "Le réfectoire",
	["The Regrowth"] = "Le Renouveau",
	["The Reliquary"] = "Le Reliquaire",
	["The Repository"] = "Le Dépôt",
	["The Reservoir"] = "Le Réservoir",
	["The Restless Front"] = "Le front Sans-Repos",
	["The Ridge of Ancient Flame"] = "La crête de la Flamme antique",
	["The Rift"] = "La Faille",
	["The Ring of Balance"] = "L’arène de l’Équilibre",
	["The Ring of Blood"] = "L’arène de Sang",
	["The Ring of Champions"] = "La lice des Champions",
	["The Ring of Inner Focus"] = "L’arène de la Focalisation intérieure",
	["The Ring of Trials"] = "L’arène des Épreuves",
	["The Ring of Valor"] = "L’arène des Valeureux",
	["The Riptide"] = "Le Courant",
	["The Riverblade Den"] = "Antre des Rivelames",
	["Thermal Vents"] = "Puits aérifères",
	["The Roiling Gardens"] = "Les jardins Mouvants",
	["The Rolling Gardens"] = "Les jardins Mouvants",
	["The Rolling Plains"] = "Les plaines Vallonnées",
	["The Rookery"] = "La colonie",
	["The Rotting Orchard"] = "Le verger Pourrissant",
	["The Rows"] = "Les Travées",
	["The Royal Exchange"] = "La Bourse royale",
	["The Ruby Sanctum"] = "Le sanctum Rubis",
	["The Ruined Reaches"] = "Les confins Dévastés",
	["The Ruins of Kel'Theril"] = "Les ruines de Kel’Theril",
	["The Ruins of Ordil'Aran"] = "Les ruines d’Ordil’Aran",
	["The Ruins of Stardust"] = "Les ruines de Chimétoile",
	["The Rumble Cage"] = "La Cage des grondements",
	["The Rustmaul Dig Site"] = "Site de fouilles de Cognerouille",
	["The Sacred Grove"] = "Le bosquet Sacré",
	["The Salty Sailor Tavern"] = "La taverne du Loup de mer",
	["The Sanctum"] = "Le sanctum",
	["The Sanctum of Blood"] = "Le sanctum du Sang",
	["The Savage Coast"] = "La côte Sauvage",
	["The Savage Glen"] = "Le vallon Sauvage",
	["The Savage Thicket"] = "Le fourré Sauvage",
	["The Scalding Chasm"] = "Le gouffre Brûlant",
	["The Scalding Pools"] = "Les bassins Brûlants",
	["The Scarab Dais"] = "L’Estrade du scarabée",
	["The Scarab Wall"] = "Le mur du Scarabée",
	["The Scarlet Basilica"] = "La basilique Écarlate",
	["The Scarlet Bastion"] = "Le Bastion écarlate",
	["The Scorched Grove"] = "Le bosquet Incendié",
	["The Scorched Plain"] = "La plaine Incendiée",
	["The Scrap Field"] = "La Ferraille",
	["The Scrapyard"] = "La Ferraillerie",
	["The Screaming Hall"] = "Le hall hurlant",
	["The Screaming Reaches"] = "Les confins Hurlants",
	["The Screeching Canyon"] = "Canyon des Hurlements",
	["The Scribe of Stormwind"] = "Au scribe de Hurlevent",
	["The Scribes' Sacellum"] = "Le sacellum du scribe",
	["The Scrollkeeper's Sanctum"] = "Sanctum du Gardien des parchemins",
	["The Scullery"] = "Les cuisines",
	["The Scullery "] = "Les cuisines",
	["The Seabolt"] = "L’Ouragan des mers",
	["The Seabreach Flow"] = "Le courant de la Brèche",
	["The Sealed Hall"] = "Le Hall scellé",
	["The Sea of Cinders"] = "La mer de Braises",
	["The Sea Reaver's Run"] = "Le trajet du Saccageur des mers",
	["The Searing Gateway"] = "Les portes Brûlantes",
	["The Sea Wolf"] = "Le Loup de mer",
	["The Secret Aerie"] = "Le recoin Secret",
	["The Secret Lab"] = "Le laboratoire secret",
	["The Secrets of Ragefire"] = "Les secrets de Ragefeu",
	["The Seer's Library"] = "Bibliothèque du Voyant",
	["The Sepulcher"] = "Le Sépulcre",
	["The Severed Span"] = "Le viaduc Rompu",
	["The Sewer"] = "Les égouts",
	["The Shadow Stair"] = "L’escalier de l’Ombre",
	["The Shadow Throne"] = "Le trône des Ombres",
	["The Shadow Vault"] = "Le caveau des Ombres",
	["The Shady Nook"] = "Le creux Ombragé",
	["The Shaper's Terrace"] = "La terrasse du Façonneur",
	["The Shattered Halls"] = "Les salles Brisées",
	["The Shattered Strand"] = "La grève Fracassée",
	["The Shattered Walkway"] = "Le passage Brisé",
	["The Shepherd's Gate"] = "Porte du Berger",
	["The Shifting Mire"] = "Le bourbier Changeant",
	["The Shimmering Deep"] = "Les profondeurs Salines",
	["The Shimmering Flats"] = "Les Salines",
	["The Shining Strand"] = "Le rivage Rayonnant",
	["The Shrine of Aessina"] = "Le sanctuaire d’Aessina",
	["The Shrine of Eldretharr"] = "Le sanctuaire d'Eldretharr",
	["The Silent Sanctuary"] = "Le sanctuaire du Silence",
	["The Silkwood"] = "Sylvesoie",
	["The Silver Blade"] = "La Lame argentée",
	["The Silver Enclave"] = "Enclave Argentée",
	["The Singing Grove"] = "Le bosquet Chantant",
	["The Singing Pools"] = "Bassins Chantants",
	["The Sin'loren"] = "Le Sin’loren",
	["The Skeletal Reef"] = "Le récif Squelettique",
	["The Skittering Dark"] = "Le Grouillement",
	["The Skull Warren"] = "Le dédale du Crâne",
	["The Skunkworks"] = "La Bidouillerie",
	["The Skybreaker"] = "Le Brise-ciel",
	["The Skyfire"] = "Le Brûleciel",
	["The Skyreach Pillar"] = "Le pilier Confins-du-Ciel",
	["The Slag Pit"] = "La fosse aux Scories",
	["The Slaughtered Lamb"] = "L'Agneau assassiné",
	["The Slaughter House"] = "L'Abattoir",
	["The Slave Pens"] = "Les enclos aux esclaves",
	["The Slave Pits"] = "Les fosses à esclaves",
	["The Slick"] = "La Glissade",
	["The Slithering Scar"] = "La Balafre sinueuse",
	["The Slough of Dispair"] = "Le Marais du désespoir",
	["The Sludge Fen"] = "La Videfange",
	["The Sludge Fields"] = "Champs Fangeux",
	["The Sludgewerks"] = "La Vidangerie",
	["The Solarium"] = "Le Solarium",
	["The Solar Vigil"] = "La veillée solaire",
	["The Southern Isles"] = "Les îles du Sud",
	["The Southern Wall"] = "Le mur Austral",
	["The Sparkling Crawl"] = "La Serpentine étincelante",
	["The Spark of Imagination"] = "L'Étincelle d'imagination",
	["The Spawning Glen"] = "Le vallon des Pontes",
	["The Spire"] = "La Flèche",
	["The Splintered Path"] = "Le sentier de Bois-Cassé",
	["The Spring Road"] = "La coulée du Printemps",
	["The Stadium"] = "Le Stade",
	["The Stagnant Oasis"] = "L’oasis Stagnante",
	["The Staidridge"] = "La corniche Austère",
	["The Stair of Destiny"] = "L’escalier du Destin",
	["The Stair of Doom"] = "L’escalier de la Fatalité",
	["The Starchaser"] = "Le Course-Étoiles",
	["The Star's Bazaar"] = "Le bazar de l'Étoile",
	["The Steam Pools"] = "Les bassins de Vapeur",
	["The Steamvault"] = "Le caveau de la Vapeur",
	["The Steppe of Life"] = "Les steppes de la Vie",
	["The Steps of Fate"] = "Les marches du Destin",
	["The Stinging Trail"] = "La piste Brûlante",
	["The Stockade"] = "La Prison",
	["The Stockpile"] = "La Réserve",
	["The Stonecore"] = "Le Cœur-de-Pierre",
	["The Stonecore Entrance"] = "Entrée du Cœur-de-Pierre",
	["The Stonefield Farm"] = "Ferme des Champierreux",
	["The Stone Vault"] = "Caveau de pierre",
	["The Storehouse"] = "L'entrepôt",
	["The Stormbreaker"] = "Le Brise-tempête",
	["The Stormbridge"] = "Le Pont-des-Tempêtes",
	["The Storm Foundry"] = "La fonderie des Tempêtes",
	["The Storm Peaks"] = "Les pics Foudroyés",
	["The Stormspire"] = "La Foudreflèche",
	["The Stormwright's Shelf"] = "La saillie de Forgetempête",
	["The Summer Fields"] = "Les champs de l’Été",
	["The Summer Terrace"] = "La terrasse Estivale",
	["The Sundered Shard"] = "L’Éclat scindé",
	["The Sundering"] = "La Fracture",
	["The Sun Forge"] = "La forge du Soleil",
	["The Sunken Ring"] = "L’arène Engloutie",
	["The Sunset Brewgarden"] = "Le Chai du couchant",
	["The Sunspire"] = "La Flèche solaire",
	["The Suntouched Pillar"] = "Le pilier Solegrâce",
	["The Sunwell"] = "Le Puits de soleil",
	["The Swarming Pillar"] = "Le pilier grouillant",
	["The Swollen Vault"] = "Le Caveau démesuré",
	["The Tainted Forest"] = "La forêt Impure",
	["The Tainted Scar"] = "La Balafre impure",
	["The Talondeep Path"] = "La Perce des serres",
	["The Talon Den"] = "L’antre des Serres",
	["The Tasting Room"] = "Chambre de Dégustation",
	["The Tempest Rift"] = "La faille des Tempêtes",
	["The Temple Gardens"] = "Les jardins du Temple",
	["The Temple of Atal'Hakkar"] = "Le temple d’Atal’Hakkar",
	["The Temple of the Jade Serpent"] = "Temple du Serpent de jade",
	["The Terrestrial Watchtower"] = "La tour de guet terrestre",
	["The Thornsnarl"] = "Grognépine",
	["The Threads of Fate"] = "Le Fil du destin",
	["The Threshold"] = "Le Seuil",
	["The Throne of Flame"] = "Le Trône des Flammes",
	["The Thunder Forge"] = "La forge du Tonnerre",
	["The Thunder Forges"] = "Forges du Tonnerre",
	["The Thundering Run"] = "La piste Tonitruante",
	["The Thundering Spire"] = "La flèche du Tonnerre",
	["The Thunderspire"] = "La Flèche-Tonnerre",
	["The Thunderwood"] = "Le bois du Tonnerre",
	["The Tidebreaker"] = "La Déferlante",
	["The Tidus Stair"] = "L’escalier des Marées",
	["The Tiger's Peak"] = "Le croc du Tigre",
	["The Torjari Pit"] = "La fosse Torjari",
	["The Tower of Arathor"] = "La tour d’Arathor",
	["The Toxic Airfield"] = "L’aérodrome Toxique",
	["The Trail of Devastation"] = "La piste Dévastée",
	["The Tranquil Grove"] = "Bosquet Paisible",
	["The Transitus Stair"] = "L’escalier Transitus",
	["The Trapper's Enclave"] = "L’enclave du Trappeur",
	["The Tribunal of Ages"] = "Le tribunal des Âges",
	["The Tundrid Hills"] = "Les collines de Tundrid",
	["The Twilight Breach"] = "La Brèche du Crépuscule",
	["The Twilight Caverns"] = "Les cavernes du Crépuscule",
	["The Twilight Citadel"] = "La citadelle du Crépuscule",
	["The Twilight Enclave"] = "L'enclave du Crépuscule",
	["The Twilight Gate"] = "La porte du Crépuscule",
	["The Twilight Gauntlet"] = "L’Épreuve du Crépuscule",
	["The Twilight Ridge"] = "La crête du Crépuscule",
	["The Twilight Rivulet"] = "Le ruisselet du Crépuscule",
	["The Twilight Withering"] = "La Flétrissure du Crépuscule",
	["The Twin Colossals"] = "Les Colosses jumeaux",
	["The Twisted Glade"] = "La clairière Tordue",
	["The Twisted Warren"] = "La garenne Tordue",
	["The Two Fisted Brew"] = "Au Soiffard ambidextre",
	["The Unbound Thicket"] = "Le fourré Délié",
	["The Underbelly"] = "Les Entrailles",
	["The Underbog"] = "La Basse-tourbière",
	["The Underbough"] = "Le Sous-Bois",
	["The Undercroft"] = "Le caveau de Zaeldarr",
	["The Underhalls"] = "Les Basses-salles",
	["The Undershell"] = "La Coquoyeuse",
	["The Uplands"] = "Les Hauteurs",
	["The Upside-down Sinners"] = "Les Pécheurs fous",
	["The Valley of Fallen Heroes"] = "La vallée des Héros défunts",
	["The Valley of Lost Hope"] = "La vallée de l’Espoir perdu",
	["The Vault of Lights"] = "La Voûte des lumières",
	["The Vector Coil"] = "La Bobine vectorielle",
	["The Veiled Cleft"] = "La faille Voilée",
	["The Veiled Sea"] = "La mer Voilée",
	["The Veiled Stair"] = "L’escalier Dérobé",
	["The Venture Co. Mine"] = "Mine de la KapitalRisk",
	["The Verdant Fields"] = "Les champs Verdoyants",
	["The Verdant Thicket"] = "Le fourré Verdoyant",
	["The Verne"] = "Le Verni",
	["The Verne - Bridge"] = "Le Verni - Pont",
	["The Verne - Entryway"] = "Le Verni - Entrée",
	["The Vibrant Glade"] = "La clairière Vibrante",
	["The Vice"] = "L’Étau",
	["The Vicious Vale"] = "Le val Vicieux",
	["The Viewing Room"] = "La Chambre des visions",
	["The Vile Reef"] = "Le récif Infâme",
	["The Violet Citadel"] = "Citadelle Pourpre",
	["The Violet Citadel Spire"] = "Fléche de la citadelle Pourpre",
	["The Violet Gate"] = "La porte Pourpre",
	["The Violet Hold"] = "Fort Pourpre",
	["The Violet Spire"] = "La flèche Pourpre",
	["The Violet Tower"] = "La tour Pourpre",
	["The Vortex Fields"] = "Les champs du vortex",
	["The Vortex Pinnacle"] = "La cime du Vortex",
	["The Vortex Pinnacle Entrance"] = "Entrée de la cime du Vortex",
	["The Wailing Caverns"] = "Les cavernes des Lamentations",
	["The Wailing Ziggurat"] = "La ziggourat Gémissante",
	["The Waking Halls"] = "Les salles de l’Éveil",
	["The Wandering Isle"] = "L’île Vagabonde",
	["The Warlord's Garrison"] = "La garnison du Seigneur de guerre",
	["The Warlord's Terrace"] = "La terrasse du Seigneur de guerre",
	["The Warp Fields"] = "Les champs de Distorsion",
	["The Warp Piston"] = "Le Piston de distorsion",
	["The Wavecrest"] = "Le Hautevague",
	["The Weathered Nook"] = "La niche Érodée",
	["The Weeping Cave"] = "La grotte des Pleurs",
	["The Western Earthshrine"] = "Le sanctuaire Terrestre de l’Ouest",
	["The Westrift"] = "La Faille-Ouest",
	["The Whelping Downs"] = "Butte aux Dragonnets",
	["The Whipple Estate"] = "Le domaine de Whipple",
	["The Wicked Coil"] = "La Spirale pernicieuse",
	["The Wicked Grotto"] = "La grotte Maudite",
	["The Wicked Tunnels"] = "Les tunnels Maudits",
	["The Widening Deep"] = "Les profondeurs Béantes",
	["The Widow's Clutch"] = "Le Nid de la veuve",
	["The Widow's Wail"] = "Les Sanglots de la veuve",
	["The Wild Plains"] = "Les plaines Sauvages",
	["The Wild Shore"] = "Le rivage Cruel",
	["The Winding Halls"] = "Les salles Tortueuses",
	["The Windrunner"] = "Le Coursevent",
	["The Windspire"] = "Flèche du Vent",
	["The Wollerton Stead"] = "Ferme des Wollerton",
	["The Wonderworks"] = "La Miraclerie",
	["The Wood of Staves"] = "Forêt des Mille bâtons",
	["The World Tree"] = "L’Arbre-Monde",
	["The Writhing Deep"] = "Gouffre Grouillant",
	["The Writhing Haunt"] = "Le repaire Putride",
	["The Yaungol Advance"] = "Base avancée Yaungole",
	["The Yorgen Farmstead"] = "La ferme des Yorgen",
	["The Zandalari Vanguard"] = "L’avant-garde Zandalari",
	["The Zoram Strand"] = "La grève de Zoram",
	["Thieves Camp"] = "Camp des Voleurs",
	["Thirsty Alley"] = "Rue de la soif",
	["Thistlefur Hold"] = "Repaire des Crins-de-Chardon",
	["Thistlefur Village"] = "Village des Crins-de-Chardon",
	["Thistleshrub Valley"] = "Vallée des Chardonniers",
	["Thondroril River"] = "La Thondroril",
	["Thoradin's Wall"] = "Mur de Thoradin",
	["Thorium Advance"] = "Base avancée du Thorium",
	["Thorium Point"] = "Halte du Thorium",
	["Thor Modan"] = "Thor Modan",
	["Thornfang Hill"] = "Colline de Roncecroc",
	["Thorn Hill"] = "Colline des Épines",
	["Thornmantle's Hideout"] = "Planque de Mantépine",
	["Thorson's Post"] = "Poste de Thorson",
	["Thorvald's Camp"] = "Camp de Thorvald",
	["Thousand Needles"] = "Mille pointes",
	Thrallmar = "Thrallmar",
	["Thrallmar Mine"] = "Mine de Thrallmar",
	["Three Corners"] = "Trois chemins",
	["Throne of Ancient Conquerors"] = "Trône des anciens Conquérants",
	["Throne of Kil'jaeden"] = "Trône de Kil’jaeden",
	["Throne of Neptulon"] = "Trône de Neptulon",
	["Throne of the Apocalypse"] = "Trône de l'Apocalypse",
	["Throne of the Damned"] = "Trône des damnés",
	["Throne of the Elements"] = "Trône des éléments",
	["Throne of the Four Winds"] = "Trône des quatre vents",
	["Throne of the Tides"] = "Trône des marées",
	["Throne of the Tides Entrance"] = "Entrée du Trône des marées",
	["Throne of Thunder"] = "Trône du tonnerre",
	["Throne of Tides"] = "Trône des marées",
	["Thrym's End"] = "Fin de Thrym",
	["Thunder Axe Fortress"] = "Forteresse de Hache-Tonnerre",
	Thunderbluff = "Les Pitons-du-Tonnerre",
	["Thunder Bluff"] = "Les Pitons-du-Tonnerre",
	["Thunderbrew Distillery"] = "Distillerie Tonnebière",
	["Thunder Cleft"] = "Faille du Tonnerre",
	Thunderfall = "Chute-tonnerre",
	["Thunder Falls"] = "Chutes du Tonnerre",
	["Thunderfoot Farm"] = "Ferme Pied de Foudre",
	["Thunderfoot Fields"] = "Champs Pied de Foudre",
	["Thunderfoot Inn"] = "Auberge des Pied de Foudre",
	["Thunderfoot Ranch"] = "Élevage Pied de Foudre",
	["Thunder Hold"] = "Bastion du Tonnerre",
	["Thunderhorn Water Well"] = "Puits Corne-tonnerre",
	["Thundering Overlook"] = "Le surplomb Foudroyant",
	["Thunder Island Alliance Hub"] = "Plateforme de l’Alliance de l’île du tonnerre",
	["Thunder King Horde Hub"] = "Plateforme de la Horde du roi-tonnerre",
	["Thunder King's Citadel"] = "Citadelle du Roi-tonnerre",
	["Thunderlord Stronghold"] = "Bastion des Sire-tonnerre",
	Thundermar = "Tonnemar",
	["Thundermar Ruins"] = "Ruines de Tonnemar",
	["Thunderpaw Overlook"] = "Surplomb Patte-du-Tonnerre",
	["Thunderpaw Refuge"] = "Refuge Patte-du-Tonnerre",
	["Thunder Peak"] = "Le Pic-Tonnerre",
	["Thunder Ridge"] = "Falaises du Tonnerre",
	["Thunder's Call"] = "L’appel du Tonnerre",
	["Thunderstrike Mountain"] = "Mont Frappe-tonnerre",
	["Thunk's Abode"] = "Demeure de Thunk",
	["Thuron's Livery"] = "Écurie de Thuron",
	["Tian Monastery"] = "Monastère de Tian",
	["Tidefury Cove"] = "Crique du Mascaret",
	["Tides' Hollow"] = "Creux de la marée",
	["Tideview Thicket"] = "Fourré de Point-des-Marées",
	["Tigers' Wood"] = "Bois des Tigres",
	["Timbermaw Hold"] = "Repaire des Grumegueules",
	["Timbermaw Post"] = "Poste des Grumegueules",
	["Tinkers' Court"] = "Cour du Bricoleur",
	["Tinker Town"] = "Brikabrok",
	["Tiragarde Keep"] = "Donjon de Tiragarde",
	["Tirisfal Glades"] = "Clairières de Tirisfal",
	["Tirth's Haunt"] = "Antre de Tirth",
	["Tkashi Ruins"] = "Ruines de Tkashi",
	["Tol Barad"] = "Tol Barad",
	["Tol Barad Peninsula"] = "Péninsule de Tol Barad",
	["Tol'Vir Arena"] = "Arène des tol’vir",
	["Tol'viron Arena"] = "Arène Tol’viron",
	["Tol'Viron Arena"] = "Arène Tol’viron",
	["Tomb of Conquerors"] = "Tombe des Conquérants",
	["Tomb of Lights"] = "Tombeau des Lumières",
	["Tomb of Secrets"] = "Tombe des Secrets",
	["Tomb of Shadows"] = "Tombe des Ombres",
	["Tomb of the Ancients"] = "Tombeau des Anciens",
	["Tomb of the Earthrager"] = "Tombeau de l’Enrageterre",
	["Tomb of the Lost Kings"] = "Tombeau des Rois perdus",
	["Tomb of the Sun King"] = "Tombeau du roi-soleil",
	["Tomb of the Watchers"] = "Tombeau des Gardiens",
	["Tombs of the Precursors"] = "Tombes des Précurseurs",
	["Tome of the Unrepentant"] = "Tome du Relaps",
	["Tome of the Unrepentant "] = "Tome du Relaps",
	["Tor'kren Farm"] = "Ferme de Tor’kren",
	["Torp's Farm"] = "Ferme de Torp",
	["Torseg's Rest"] = "Le Repos de Torseg",
	["Tor'Watha"] = "Tor’Watha",
	["Toryl Estate"] = "Domaine de Toryl",
	["Toshley's Station"] = "Poste de Toshley",
	["To the Skies!"] = "En route vers les cieux !",
	["To The Skies!"] = "En route vers les cieux !",
	["Tower of Althalaxx"] = "Tour d’Althalaxx",
	["Tower of Azora"] = "Tour d’Azora",
	["Tower of Eldara"] = "Tour d’Eldara",
	["Tower of Estulan"] = "Tour d’Estulan",
	["Tower of Ilgalar"] = "Tour d’Ilgalar",
	["Tower of the Damned"] = "Tour des Damnés",
	["Tower Point"] = "Tour de la Halte",
	["Tower Watch"] = "Tour de guet",
	["Town-In-A-Box"] = "Ville-en-Boîte",
	["Townlong Steppes"] = "Steppes de Tanglong",
	["Town Square"] = "Place Centrale",
	["Trade District"] = "Quartier commerçant",
	["Trade Quarter"] = "Quartier des Marchands",
	["Trader's Tier"] = "L'Étage des commerces",
	["Tradesmen's Terrace"] = "Terrasse des Marchands",
	["Train Depot"] = "Dépôt des trains",
	["Training Grounds"] = "Terrain d’entraînement",
	["Training Quarters"] = "Quartiers d’entraînement",
	["Traitor's Cove"] = "Crique du traître",
	["Tranquil Coast"] = "Côte Tranquille",
	["Tranquil Gardens Cemetery"] = "Cimetière des Jardins paisibles",
	["Tranquil Grotto"] = "Grotte Paisible",
	Tranquillien = "Tranquillien",
	["Tranquil Shore"] = "Rivage Paisible",
	["Tranquil Wash"] = "Le reflux Tranquille",
	Transborea = "Transborée",
	["Transitus Shield"] = "Bouclier Transitus",
	["Transport: Alliance Gunship"] = "Transport : canonnière de l’Alliance",
	["Transport: Alliance Gunship (IGB)"] = "Transport: canonnière de l’Alliance (IGB)",
	["Transport: Horde Gunship"] = "Transport : canonnière de la Horde",
	["Transport: Horde Gunship (IGB)"] = "Transport : canonnière de la Horde(IGB)",
	["Transport: Onyxia/Nefarian Elevator"] = "Transport : ascenseur Onyxia/Nefarian",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Transport : le Grand vent (raid de la Couronne de glace)",
	["Trelleum Mine"] = "Mine de Trelleum",
	["Trial of Fire"] = "L’Épreuve du Feu",
	["Trial of Frost"] = "L’Épreuve du Givre",
	["Trial of Shadow"] = "L’Épreuve de l’Ombre",
	["Trial of the Champion"] = "L’épreuve du champion",
	["Trial of the Champion Entrance"] = "Entrée de l’Épreuve du champion",
	["Trial of the Crusader"] = "L’épreuve du croisé",
	["Trickling Passage"] = "Passage Suintant",
	["Trogma's Claim"] = "La Prétention de Trogma",
	["Trollbane Hall"] = "Manoir de Trollemort",
	["Troll War Camp Outskirts"] = "Environs du camp de guerre troll",
	["Trophy Hall"] = "Salle du Trophée",
	["Troves of the Thunder King"] = "Le fabuleux trésor du roi-tonnerre",
	["Trueshot Point"] = "Pointe de Tir-précis",
	["Tuluman's Landing"] = "Point d’ancrage de Tuluman",
	["Turtle Beach"] = "Plage aux Tortues",
	["Tu Shen Burial Ground"] = "Terres sacrées de Tu Shen",
	Tuurem = "Tuurem",
	["Twilight Aerie"] = "Nichoir du Crépuscule",
	["Twilight Altar of Storms"] = "Autel des tempêtes du Crépuscule",
	["Twilight Base Camp"] = "Camp de base du Crépuscule",
	["Twilight Bulwark"] = "Barricade du Crépuscule",
	["Twilight Camp"] = "Campement du Crépuscule",
	["Twilight Command Post"] = "Poste de commandement du Crépuscule",
	["Twilight Crossing"] = "Carrefour du Crépuscule",
	["Twilight Forge"] = "La forge du Crépuscule",
	["Twilight Grove"] = "Bosquet crépusculaire",
	["Twilight Highlands"] = "Hautes-terres du Crépuscule",
	["Twilight Highlands Dragonmaw Phase"] = "Phase Gueule-de-dragons des hautes-terres du Crépuscule",
	["Twilight Highlands Phased Entrance"] = "Entrée phasée des Hautes-terres du Crépuscule",
	["Twilight Highlands Zeppelin 1"] = "Zeppelin des Hautes-terres du Crépuscule 1",
	["Twilight Highlands Zeppelin 2"] = "Zeppelin des Hautes-terres du Crépuscule 2",
	["Twilight Outpost"] = "Avant-poste du Crépuscule",
	["Twilight Overlook"] = "Surplomb du Crépuscule",
	["Twilight Post"] = "Poste du Crépuscule",
	["Twilight Precipice"] = "Précipice du Crépuscule",
	["Twilight Shore"] = "Rivage du Crépuscule",
	["Twilight's Run"] = "Défilé du Crépuscule",
	["Twilight Terrace"] = "Terrasse du Crépuscule",
	["Twilight Vale"] = "Vallée du Crépuscule",
	["Twinbraid's Patrol"] = "Patrouille de Doublenattes",
	["Twin Peaks"] = "Pics-Jumeaux",
	["Twin Shores"] = "Rivages Jumeaux",
	["Twinspire Keep"] = "Donjon des Flèches jumelles",
	["Twinspire Keep Interior"] = "Intérieur du donjon des Flèches jumelles",
	["Twin Spire Ruins"] = "Ruines des Flèches jumelles",
	["Twisting Nether"] = "Le Néant distordu",
	["Tyr's Hand"] = "Main de Tyr",
	["Tyr's Hand Abbey"] = "Abbaye de la Main de Tyr",
	["Tyr's Terrace"] = "Terrasse de Tyr",
	["Ufrang's Hall"] = "Salle d’Ufrang",
	Uldaman = "Uldaman",
	["Uldaman Entrance"] = "Entrée d’Uldaman",
	Uldis = "Uldis",
	Ulduar = "Ulduar",
	["Ulduar Raid - Interior - Insertion Point"] = "Raid d'Ulduar - Intérieur - Point d'insertion",
	["Ulduar Raid - Iron Concourse"] = "Raid d'Ulduar - Corridor de fer",
	Uldum = "Uldum",
	["Uldum Phased Entrance"] = "Entrée phasée d'Uldum",
	["Uldum Phase Oasis"] = "Oasis phasée d'Uldum",
	["Uldum - Phase Wrecked Camp"] = "Uldum - Phase du camp démoli",
	["Umbrafen Lake"] = "Lac Umbretourbe",
	["Umbrafen Village"] = "Umbretourbe",
	["Uncharted Sea"] = "Mer inconnue",
	Undercity = "Fossoyeuse",
	["Underlight Canyon"] = "Canyon de Terradiance",
	["Underlight Mines"] = "Mines de Terradiance",
	["Unearthed Grounds"] = "Terres Exhumées",
	["Unga Ingoo"] = "Unga Ingou",
	["Un'Goro Crater"] = "Cratère d’Un’Goro",
	["Unu'pe"] = "Unu’pe",
	["Unyielding Garrison"] = "Garnison inflexible",
	["Upper Silvermarsh"] = "Marécage Argenté supérieur",
	["Upper Sumprushes"] = "Marais des Joncs supérieur",
	["Upper Veil Shil'ak"] = "Voile Shil’ak supérieur",
	["Ursoc's Den"] = "Tanière d’Ursoc",
	Ursolan = "Ursolan",
	["Utgarde Catacombs"] = "Catacombes d’Utgarde",
	["Utgarde Keep"] = "Donjon d’Utgarde",
	["Utgarde Keep Entrance"] = "Entrée du donjon d’Utgarde",
	["Utgarde Pinnacle"] = "Cime d’Utgarde",
	["Utgarde Pinnacle Entrance"] = "Entrée de la cime d’Utgarde",
	["Uther's Tomb"] = "Tombeau d’Uther",
	["Valaar's Berth"] = "Amarrage de Valaar",
	["Vale of Eternal Blossoms"] = "Val de l’Éternel printemps",
	["Valgan's Field"] = "Champ de Valgan",
	Valgarde = "Valgarde",
	["Valgarde Port"] = "Port-Valgarde",
	Valhalas = "Valhalas",
	["Valiance Keep"] = "Donjon de la Bravoure",
	["Valiance Landing Camp"] = "Terrain d'atterrissage de la Bravoure",
	["Valiant Rest"] = "Le repos des Vaillants",
	Valkyrion = "Valkyrion",
	["Valley of Ancient Winters"] = "La vallée des Anciens hivers",
	["Valley of Ashes"] = "Vallées des Cendres",
	["Valley of Bones"] = "Vallée des Ossements",
	["Valley of Echoes"] = "Vallée des Échos",
	["Valley of Emperors"] = "Vallée des Empereurs",
	["Valley of Fangs"] = "Vallée des Crocs",
	["Valley of Heroes"] = "Vallée des Héros",
	["Valley Of Heroes"] = "Vallée des Héros",
	["Valley of Honor"] = "Vallée de l’Honneur",
	["Valley of Kings"] = "Vallée des Rois",
	["Valley of Power"] = "Vallée de la puissance",
	["Valley Of Power - Scenario"] = "Vallée de la puissance - Scénario",
	["Valley of Spears"] = "Vallée des Lances",
	["Valley of Spirits"] = "Vallée des Esprits",
	["Valley of Strength"] = "Vallée de la Force",
	["Valley of the Bloodfuries"] = "Vallée des Rouges-furies",
	["Valley of the Four Winds"] = "Vallée des Quatre vents",
	["Valley of the Watchers"] = "Vallée des Guetteurs",
	["Valley of Trials"] = "Vallée des Épreuves",
	["Valley of Wisdom"] = "Vallée de la Sagesse",
	Valormok = "Valormok",
	["Valor's Edge"] = "Éperon des Vaillants",
	["Valor's Rest"] = "Le Repos des vaillants",
	["Valorwind Lake"] = "Lac Vent-vaillant",
	["Vanguard Infirmary"] = "Infirmerie de l’avant-garde",
	["Vanndir Encampment"] = "Campement de Vanndir",
	["Vargoth's Retreat"] = "Retraite de Vargoth",
	["Vashj'elan Spawning Pool"] = "Bassin de ponte de Vashj’elan",
	["Vashj'ir"] = "Vashj’ir",
	["Vashj'ir Sub - Alliance"] = "Sous-marin de Vashj'ir - Alliance",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Sous-marin de Vashj'ir - Alliance autour de la Gueule des abysses",
	["Vashj'ir Sub - Horde"] = "Sous-marin de Vashj'ir - Horde",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Sous-marin de Vashj'ir - Horde autour de la Gueule des abysses",
	["Vault of Archavon"] = "Caveau d’Archavon",
	["Vault of Ironforge"] = "Chambre forte de Forgefer",
	["Vault of Kings Past"] = "Caveau des Rois d’antan",
	["Vault of the Ravenian"] = "Caveau du Voracien",
	["Vault of the Shadowflame"] = "Caveau de l'Ombreflamme",
	["Vault of Y'Shaarj"] = "Caveau d’Y’Shaarj",
	["Veil Ala'rak"] = "Voile Ala’rak",
	["Veil Harr'ik"] = "Voile Harr’ik",
	["Veil Lashh"] = "Voile Lashh",
	["Veil Lithic"] = "Voile Lithic",
	["Veil Reskk"] = "Voile Reskk",
	["Veil Rhaze"] = "Voile Rhaze",
	["Veil Ruuan"] = "Voile Ruuan",
	["Veil Sethekk"] = "Voile Sethekk",
	["Veil Shalas"] = "Voile Shalas",
	["Veil Shienor"] = "Voile Shienor",
	["Veil Skith"] = "Voile Skith",
	["Veil Vekh"] = "Voile Vekh",
	["Vekhaar Stand"] = "Le séjour de Vekhaar",
	["Velaani's Arcane Goods"] = "Articles arcaniques de Velaani",
	["Vendetta Point"] = "Halte de la Vendetta",
	["Vengeance Landing"] = "Accostage de la Vengeance",
	["Vengeance Landing Inn"] = "Auberge de l’accostage de la Vengeance",
	["Vengeance Landing Inn, Howling Fjord"] = "Auberge de l'accostage de la Vengeance, fjord Hurlant",
	["Vengeance Lift"] = "Ascenseur de la vengeance",
	["Vengeance Pass"] = "Défilé de la Vengeance",
	["Vengeance Wake"] = "Le Vogue-Vengeance",
	["Venomous Ledge"] = "L’escarpement Venimeux",
	Venomspite = "Vexevenin",
	["Venomsting Pits"] = "Fosses des Dards venimeux",
	["Venomweb Vale"] = "Vallée de Tissevenin",
	["Venture Bay"] = "Baie de la KapitalRisk",
	["Venture Co. Base Camp"] = "Campement de la KapitalRisk",
	["Venture Co. Operations Center"] = "Centre d’opérations de la KapitalRisk",
	["Verdant Belt"] = "Ceinture Verdoyante",
	["Verdant Highlands"] = "Hautes-terres Verdoyantes",
	["Verdantis River"] = "La Verdantis",
	["Veridian Point"] = "Cap viridien",
	["Verlok Stand"] = "Séjour des verloks",
	["Vermillion Redoubt"] = "La redoute Vermillon",
	["Verming Tunnels Micro"] = "Tunnels des virmens",
	["Verrall Delta"] = "Delta de la Verralle",
	["Verrall River"] = "La Verralle",
	["Victor's Point"] = "Halte de la Victoire",
	["Vileprey Village"] = "Vileproie",
	["Vim'gol's Circle"] = "Le cercle de Vim’gol",
	["Vindicator's Rest"] = "Repos du redresseur de torts",
	["Violet Citadel Balcony"] = "Balcon de la citadelle Pourpre",
	["Violet Hold"] = "Le fort Pourpre",
	["Violet Hold Entrance"] = "Entrée du fort Pourpre",
	["Violet Rise"] = "Cime Pourpre",
	["Violet Stand"] = "Le Séjour pourpre",
	["Virmen Grotto"] = "Grotte des virmens",
	["Virmen Nest"] = "Nid des virmens",
	["Vir'naal Dam"] = "Barrage de la Vir’naal",
	["Vir'naal Lake"] = "Lac de la Vir’naal",
	["Vir'naal Oasis"] = "Oasis de la Vir’naal",
	["Vir'naal River"] = "La Vir’naal",
	["Vir'naal River Delta"] = "Delta de la Vir’naal",
	["Void Ridge"] = "Crête du Vide",
	["Voidwind Plateau"] = "Le plateau Vent-du-Vide",
	["Volcanoth's Lair"] = "Repaire de Volcanoth",
	["Voldrin's Hold"] = "Bastion de Voldrin",
	Voldrune = "Voldrune",
	["Voldrune Dwelling"] = "Logis de Voldrune",
	Voltarus = "Voltarus",
	["Vordrassil Pass"] = "Passe de Vordrassil",
	["Vordrassil's Heart"] = "Cœur de Vordrassil",
	["Vordrassil's Limb"] = "Branche de Vordrassil",
	["Vordrassil's Tears"] = "Larmes de Vordrassil",
	["Vortex Pinnacle"] = "Cime du Vortex",
	["Vortex Summit"] = "Sommet du Vortex",
	["Vul'Gol Ogre Mound"] = "Tertre des Ogres vul’gol",
	["Vyletongue Seat"] = "Siège de Vylelangue",
	["Wahl Cottage"] = "Cottage des Wahl",
	["Wailing Caverns"] = "Cavernes des Lamentations",
	["Walk of Elders"] = "Promenade des Anciens",
	["Warbringer's Ring"] = "L'arène du Porteguerre",
	["Warchief's Lookout"] = "Poste de guet du Chef de guerre",
	["Warden's Cage"] = "La Cage de la gardienne",
	["Warden's Chambers"] = "Chambres du Gardien",
	["Warden's Vigil"] = "Veille des Gardiens",
	["Warlock Area"] = "Zone des démonistes",
	["Warmaul Hill"] = "Colline des Cogneguerre",
	["Warpwood Quarter"] = "Quartier de Crochebois",
	["War Quarter"] = "Quartier de la Guerre",
	["Warrior's Terrace"] = "Terrasse des Guerriers",
	["War Room"] = "Salle de guerre",
	Warship = "Navire de guerre",
	["Warsong Camp"] = "Camp chanteguerre",
	["Warsong Farms Outpost"] = "Avant-poste des Fermes chanteguerres",
	["Warsong Flag Room"] = "Salle du drapeau des Chanteguerres",
	["Warsong Granary"] = "Grenier Chanteguerre",
	["Warsong Gulch"] = "Goulet des Chanteguerres",
	["Warsong Hold"] = "Bastion Chanteguerre",
	["Warsong Jetty"] = "Jetée Chanteguerre",
	["Warsong Labor Camp"] = "Camp de travail Chanteguerre",
	["Warsong Lumber Camp"] = "Camp de bûcherons Chanteguerre",
	["Warsong Lumber Mill"] = "Scierie des Chanteguerres",
	["Warsong Slaughterhouse"] = "Abattoir Chanteguerre",
	["Watcher's Sanctum"] = "Sanctum du Gardien",
	["Watchers' Terrace"] = "Terrasse des Guetteurs",
	["Waterspeaker's Sanctuary"] = "Sanctuaire de l’Eauracle",
	["Waterspring Field"] = "Champ des Puisatiers",
	Waterworks = "Moulin à eau",
	["Wavestrider Beach"] = "Plage des Déferlantes",
	Waxwood = "Forêt de Troènes",
	["Wayfarer's Rest"] = "Au repos du voyageur",
	Waygate = "Portail d’Accès",
	["Wayne's Refuge"] = "Refuge de Wayne",
	["Weazel's Crater"] = "Cratère de Fouignard",
	["Webwinder Hollow"] = "Creux des Tisseuses",
	["Webwinder Path"] = "Sentier des Tisseuses",
	["Weeping Quarry"] = "Carrière des Larmes",
	["Well of Eternity"] = "Puits d’éternité",
	["Well of the Forgotten"] = "Puits de l'Oublié",
	["Wellson Shipyard"] = "Chantier naval de Wellson",
	["Wellspring Hovel"] = "Taudis d’Aigue-vive",
	["Wellspring Lake"] = "Lac d’Aigue-vive",
	["Wellspring River"] = "L’Aigue-vive",
	["Westbrook Garrison"] = "Garnison du ruisseau de l’Ouest",
	["Western Bridge"] = "Pont de l’ouest",
	["Western Plaguelands"] = "Maleterres de l’Ouest",
	["Western Strand"] = "Rivage Occidental",
	Westersea = "Mer du Ponant",
	Westfall = "Marche de l’Ouest",
	["Westfall Brigade"] = "Brigade de la marche de l'Ouest",
	["Westfall Brigade Encampment"] = "Campement de la brigade de la marche de l’Ouest",
	["Westfall Lighthouse"] = "Phare de l’Ouest",
	["West Garrison"] = "Garnison de l'Ouest",
	["Westguard Inn"] = "Auberge de la Garde de l’Ouest",
	["Westguard Keep"] = "Donjon de la Garde de l’Ouest",
	["Westguard Turret"] = "Tourelle de la Garde de l’Ouest",
	["West Pavilion"] = "Pavillon ouest",
	["West Pillar"] = "Pilier Ouest",
	["West Point Station"] = "Poste de la Halte de l’Ouest",
	["West Point Tower"] = "Tour du Cap Ouest",
	["Westreach Summit"] = "Sommet Occidental",
	["West Sanctum"] = "Sanctum Occidental",
	["Westspark Workshop"] = "Atelier de l’Ouestincelle",
	["West Spear Tower"] = "Tour de la Lance de l’Ouest",
	["West Spire"] = "Flèche Ouest",
	["Westwind Lift"] = "Ascenseur de Ponevent",
	["Westwind Refugee Camp"] = "Camp de réfugiés de Ponevent",
	["Westwind Rest"] = "Repos du Vent de l’Ouest",
	Wetlands = "Les Paluns",
	Wheelhouse = "Timonerie",
	["Whelgar's Excavation Site"] = "Excavations de Whelgar",
	["Whelgar's Retreat"] = "Retraite de Whelgar",
	["Whispercloud Rise"] = "Cime du Murmure-de-Nuage",
	["Whisper Gulch"] = "Goulet des Murmures",
	["Whispering Forest"] = "Forêt des Murmures",
	["Whispering Gardens"] = "Jardins des Murmures",
	["Whispering Inlet"] = "Anse des Murmures",
	["Whispering Shore"] = "Rivage des Murmures",
	["Whispering Stones"] = "Pierres Murmurantes",
	["Whisperwind Grove"] = "Bosquet de Murmevent",
	["Whistling Grove"] = "Bosquet Sifflant",
	["Whitebeard's Encampment"] = "Campement de Blanchebarbe",
	["Whitepetal Lake"] = "Lac Blanc-Pétale",
	["White Pine Trading Post"] = "Comptoir du Pin blanc",
	["Whitereach Post"] = "Poste de Blanc-relais",
	["Wildbend River"] = "La Sinueuse",
	["Wildervar Mine"] = "Mine Hardivar",
	["Wildflame Point"] = "Halte de Flamme-Sauvage",
	["Wildgrowth Mangal"] = "Mangrove de la Croissance sauvage",
	["Wildhammer Flag Room"] = "Salle du drapeau des Marteaux-hardis",
	["Wildhammer Keep"] = "Donjon des Marteaux-hardis",
	["Wildhammer Stronghold"] = "Bastion des Marteaux-hardis",
	["Wildheart Point"] = "Halte de Cœur-Sauvage",
	["Wildmane Water Well"] = "Puits Crin-sauvage",
	["Wild Overlook"] = "Surplomb Sauvage",
	["Wildpaw Cavern"] = "Caverne des Follepattes",
	["Wildpaw Ridge"] = "Crête des Follepattes",
	["Wilds' Edge Inn"] = "Auberge en fin d’Étendues",
	["Wild Shore"] = "Le rivage Cruel",
	["Wildvine Marsh"] = "Marais des Sauvageonnes",
	["Wildwind Lake"] = "Lac des Rafales",
	["Wildwind Path"] = "Sentier du Vent-sauvage",
	["Wildwind Peak"] = "Pic Vent-sauvage",
	["Windbreak Canyon"] = "Canyon de Brisevent",
	["Windfury Ridge"] = "Crête des Furies-des-vents",
	["Windrunner's Overlook"] = "Surplomb de Coursevent",
	["Windrunner Spire"] = "Flèche de Coursevent",
	["Windrunner Village"] = "Coursevent",
	["Winds' Edge"] = "Arête des Vents",
	["Windshear Crag"] = "Combe des Cisailles",
	["Windshear Heights"] = "Hauts des Cisailles",
	["Windshear Hold"] = "Bastion des Cisailles",
	["Windshear Mine"] = "Mine des Cisailles",
	["Windshear Valley"] = "Vallée des Cisailles",
	["Windspire Bridge"] = "Pont de la Flèche du vent",
	["Windward Isle"] = "Île Front-du-Vent",
	["Windy Bluffs"] = "Les pitons Venteux",
	["Windyreed Pass"] = "Passe de Ventejonc",
	["Windyreed Village"] = "Ventejonc",
	["Winterax Hold"] = "Repaire des Haches-d’hiver",
	["Winterbough Glade"] = "Clairière de Rameau-de-l’Hiver",
	["Winterfall Village"] = "Village des Tombe-hiver",
	["Winterfin Caverns"] = "Cavernes des Ailerons-d’hiver",
	["Winterfin Retreat"] = "Retraite des Ailerons-d’hiver",
	["Winterfin Village"] = "Aileron-d’hiver",
	["Wintergarde Crypt"] = "Crypte de Garde-Hiver",
	["Wintergarde Keep"] = "Donjon de Garde-Hiver",
	["Wintergarde Mausoleum"] = "Mausolée de Garde-Hiver",
	["Wintergarde Mine"] = "Mine de Garde-Hiver",
	Wintergrasp = "Joug-d’Hiver",
	["Wintergrasp Fortress"] = "Forteresse de Joug-d’Hiver",
	["Wintergrasp River"] = "Le Joug-d’Hiver",
	["Winterhoof Water Well"] = "Puits Sabot-d’Hiver",
	["Winter's Blossom"] = "Fleur-de-l’Hiver",
	["Winter's Breath Lake"] = "Lac du Souffle de l’hiver",
	["Winter's Edge Tower"] = "Tour Bornehiver",
	["Winter's Heart"] = "Cœur de l’hiver",
	Winterspring = "Berceau-de-l’Hiver",
	["Winter's Terrace"] = "Terrasse de l’Hiver",
	["Witch Hill"] = "Colline des Sorcières",
	["Witch's Sanctum"] = "Sanctum de la Sorcière",
	["Witherbark Caverns"] = "Cavernes Fanécorces",
	["Witherbark Village"] = "Fanécorce",
	["Withering Thicket"] = "Le fourré Flétri",
	["Wizard Row"] = "Allée des Sorciers",
	["Wizard's Sanctum"] = "Sanctuaire du sorcier",
	["Wolf's Run"] = "Piste du Loup",
	["Woodpaw Den"] = "Tanière des Griffebois",
	["Woodpaw Hills"] = "Collines des Griffebois",
	["Wood's End Cabin"] = "Cabane de Bout-du-bois",
	["Woods of the Lost"] = "Bois des Perdus",
	Workshop = "Atelier",
	["Workshop Entrance"] = "Entrée de l'atelier",
	["World's End Tavern"] = "Taverne de la fin du monde",
	["Wrathscale Lair"] = "Repaire des Irécailles",
	["Wrathscale Point"] = "Cap des Irécailles",
	["Wreckage of the Silver Dawning"] = "Épave de l’Aube argentée",
	["Wreck of Hellscream's Fist"] = "Épave du Poing de Hurlenfer",
	["Wreck of the Mist-Hopper"] = "Épave du Fend-la-Brume",
	["Wreck of the Skyseeker"] = "Épave du Chercheciel",
	["Wreck of the Vanguard"] = "Épave de l’Avant-garde",
	["Writhing Mound"] = "Monticule Grouillant",
	Writhingwood = "Bois Grouillant",
	["Wu-Song Village"] = "Wu-Song",
	Wyrmbog = "Tourbière du Ver",
	["Wyrmbreaker's Rookery"] = "La colonie de Brise-wyrm",
	["Wyrmrest Summit"] = "Sommet du Repos du ver",
	["Wyrmrest Temple"] = "Temple du Repos du ver",
	["Wyrmrest Temple - bottom to middle"] = "Temple du Repos du ver - bas au milieu",
	["Wyrmrest Temple - bottom to top"] = "Temple du Repos du ver - bas en haut",
	["Wyrmrest Temple - middle to bottom"] = "Temple du Repos du ver - milieu en bas",
	["Wyrmrest Temple - middle to top"] = "Temple du Repos du ver - milieu en haut",
	["Wyrmrest Temple - top to bottom"] = "Temple du Repos du ver - haut en bas",
	["Wyrmrest Temple - top to middle"] = "Temple du Repos du ver - haut au milieu",
	["Wyrms' Bend"] = "Tournant du Wyrm",
	["Wyrmscar Island"] = "Île Balafre-du-ver",
	["Wyrmskull Bridge"] = "Pont Crâne-du-ver",
	["Wyrmskull Tunnel"] = "Tunnel Crâne-du-ver",
	["Wyrmskull Village"] = "Crâne-du-ver",
	["X-2 Pincer"] = "Pinceur X-2",
	Xavian = "Xavian",
	["Yan-Zhe River"] = "La Yan-Zhe",
	["Yeti Mountain Basecamp"] = "Camp de base de la montagne aux yétis",
	["Yinying Village"] = "Yinying",
	Ymirheim = "Ymirheim",
	["Ymiron's Seat"] = "Siège d’Ymiron",
	["Yojamba Isle"] = "Île de Yojamba",
	["Yowler's Den"] = "Tanière de Couineur",
	["Zabra'jin"] = "Zabra’jin",
	["Zaetar's Choice"] = "Le choix de Zaetar",
	["Zaetar's Grave"] = "Tombe de Zaetar",
	["Zalashji's Den"] = "Tanière de Zalashji",
	["Zalazane's Fall"] = "Chute de Zalazane",
	["Zane's Eye Crater"] = "Cratère de l’Oeil de Zane",
	Zangarmarsh = "Marécage de Zangar",
	["Zangar Ridge"] = "Crête de Zangar",
	["Zan'vess"] = "Zan’vess",
	["Za'Tual"] = "Za’Tual",
	["Zeb'Halak"] = "Zeb’Halak",
	["Zeb'Nowa"] = "Zeb’Nowa",
	["Zeb'Sora"] = "Zeb’Sora",
	["Zeb'Tela"] = "Zeb’Tela",
	["Zeb'tula"] = "Zeb’tula",
	["Zeb'Watha"] = "Zeb’Watha",
	["Zeppelin Crash"] = "L’Épave du zeppelin",
	Zeramas = "Zeramas",
	["Zeth'Gor"] = "Zeth’Gor",
	["Zhu Province"] = "Province de Zhu",
	["Zhu's Descent"] = "Descente de Zhu",
	["Zhu's Watch"] = "Guet de Zhu",
	["Ziata'jai Ruins"] = "Ruines de Ziata’jai",
	["Zim'Abwa"] = "Zim’Abwa",
	["Zim'bo's Hideout"] = "Planque de Zim’bo",
	["Zim'Rhuk"] = "Zim’Rhuk",
	["Zim'Torga"] = "Zim’Torga",
	["Zol'Heb"] = "Zol’Heb",
	["Zol'Maz Stronghold"] = "Bastion de Zol’Maz",
	["Zoram'gar Outpost"] = "Avant-poste de Zoram’gar",
	["Zouchin Province"] = "Province de Zouchin",
	["Zouchin Strand"] = "Grève de Zouchin",
	["Zouchin Village"] = "Zouchin",
	["Zul'Aman"] = "Zul’Aman",
	["Zul'Drak"] = "Zul’Drak",
	["Zul'Farrak"] = "Zul’Farrak",
	["Zul'Farrak Entrance"] = "Entrée de Zul’Farrak",
	["Zul'Gurub"] = "Zul’Gurub",
	["Zul'Mashar"] = "Zul’Mashar",
	["Zun'watha"] = "Zun’watha",
	["Zuuldaia Ruins"] = "Ruines de Zuuldaia",
}

elseif GAME_LOCALE == "koKR" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "7군단 주둔지",
	["7th Legion Front"] = "7군단 전초지",
	["7th Legion Submarine"] = "7군단 잠수함",
	["Abandoned Armory"] = "버려진 무기고",
	["Abandoned Camp"] = "버려진 야영지",
	["Abandoned Mine"] = "버려진 광산",
	["Abandoned Reef"] = "버려진 모래톱",
	["Above the Frozen Sea"] = "얼어붙은 바다의 창공",
	["A Brewing Storm"] = "양조 폭풍",
	["Abyssal Breach"] = "심연의 틈",
	["Abyssal Depths"] = "심연의 나락",
	["Abyssal Halls"] = "심연의 전당",
	["Abyssal Maw"] = "심연의 구렁",
	["Abyssal Maw Exterior"] = "심연의 구렁 외부",
	["Abyssal Sands"] = "끝없는 사막",
	["Abyssion's Lair"] = "어비시온의 보금자리",
	["Access Shaft Zeon"] = "지온 작업 갱도",
	["Acherus: The Ebon Hold"] = "아케루스: 칠흑의 요새",
	["Addle's Stead"] = "애들 농장",
	["Aderic's Repose"] = "아데릭의 안식처",
	["Aerie Peak"] = "맹금의 봉우리",
	["Aeris Landing"] = "에어리스 착륙지",
	["Agamand Family Crypt"] = "아가만드가 납골당",
	["Agamand Mills"] = "아가만드 제분소",
	["Agmar's Hammer"] = "아그마르의 망치",
	["Agmond's End"] = "아그몬드의 최후",
	["Agol'watha"] = "아골와타",
	["A Hero's Welcome"] = "영웅의 쉼터 여관",
	["Ahn'kahet: The Old Kingdom"] = "안카헤트: 고대 왕국",
	["Ahn'kahet: The Old Kingdom Entrance"] = "안카헤트: 고대 왕국 입구",
	["Ahn Qiraj"] = "안퀴라즈",
	["Ahn'Qiraj"] = "안퀴라즈",
	["Ahn'Qiraj Temple"] = "안퀴라즈 사원",
	["Ahn'Qiraj Terrace"] = "안퀴라즈 정원",
	["Ahn'Qiraj: The Fallen Kingdom"] = "안퀴라즈: 무너진 왕국",
	["Akhenet Fields"] = "아케네트 농장",
	["Aku'mai's Lair"] = "아쿠마이의 둥지",
	["Alabaster Shelf"] = "무쇠 벼랑",
	["Alcaz Island"] = "알카즈 섬",
	["Aldor Rise"] = "알도르 마루",
	Aldrassil = "알드랏실",
	["Aldur'thar: The Desolation Gate"] = "알두르타르: 황폐의 관문",
	["Alexston Farmstead"] = "알렉스턴 농장",
	["Algaz Gate"] = "알가즈 관문",
	["Algaz Station"] = "알가즈 주둔지",
	["A Little Patience"] = "약간의 참을성",
	["Allen Farmstead"] = "알렌 농장",
	["Allerian Post"] = "알레리아 초소",
	["Allerian Stronghold"] = "알레리아 성채",
	["Alliance Base"] = "얼라이언스 주둔지",
	["Alliance Beach Daily Area"] = "얼라이언스 해변 일일 지역",
	["Alliance Beachhead"] = "얼라이언스 교두보",
	["Alliance Hub - Mogu Island Progression Scenario"] = "얼라이언스 중심지 - 모구 섬 진행 시나리오",
	["Alliance Keep"] = "얼라이언스 요새",
	["Alliance Mercenary Ship to Vashj'ir"] = "바쉬르행 얼라이언스 용병선",
	["Alliance PVP Barracks"] = "얼라이언스 연합 병영",
	["All That Glitters Prospecting Co."] = "반짝이 수집광",
	["Alonsus Chapel"] = "알론서스 교회",
	["Altar of Ascension"] = "승천의 제단",
	["Altar of Har'koa"] = "하르코아의 제단",
	["Altar of Mam'toth"] = "맘토스의 제단",
	["Altar of Quetz'lun"] = "쿠에츠룬의 제단",
	["Altar of Rhunok"] = "루노크의 제단",
	["Altar of Sha'tar"] = "샤타르 제단",
	["Altar of Sseratus"] = "세라투스의 제단",
	["Altar of Storms"] = "폭풍의 제단",
	["Altar of the Blood God"] = "혈신의 제단",
	["Altar of Twilight"] = "황혼의 제단",
	["Alterac Mountains"] = "알터랙 산맥",
	["Alterac Valley"] = "알터랙 계곡",
	["Alther's Mill"] = "앨더의 제재소",
	["Amani Catacombs"] = "아마니 지하묘지",
	["Amani Mountains"] = "아마니 산맥",
	["Amani Pass"] = "아마니 고개",
	["Amberfly Bog"] = "호박말벌 수렁",
	["Amberglow Hollow"] = "호박빛 동굴",
	["Amber Ledge"] = "호박석 절벽",
	Ambermarsh = "호박빛 습지대",
	Ambermill = "호박색 농장",
	["Amberpine Lodge"] = "호박빛소나무 오두막",
	["Amber Quarry"] = "호박석 채석장",
	["Amber Research Sanctum"] = "호박석 연구 성소",
	["Ambershard Cavern"] = "호박석 동굴",
	["Amberstill Ranch"] = "앰버스틸 목장",
	["Amberweb Pass"] = "호박그물 고개",
	["Ameth'Aran"] = "아메스아란",
	["Ammen Fields"] = "암멘 들판",
	["Ammen Ford"] = "암멘 여울",
	["Ammen Vale"] = "암멘 골짜기",
	["Amphitheater of Anguish"] = "고뇌의 투기장",
	["Ampitheater of Anguish"] = "고뇌의 투기장",
	["Ancestral Grounds"] = "선조의 터",
	["Ancestral Rise"] = "선조의 봉우리",
	["Ancient Courtyard"] = "고대의 광장",
	["Ancient Zul'Gurub"] = "고대 줄구룹",
	["An'daroth"] = "안다로스",
	["Andilien Estate"] = "안딜리엔 영지",
	Andorhal = "안돌할",
	Andruk = "안드루크",
	["Angerfang Encampment"] = "성난송곳니 야영지",
	["Angkhal Pavilion"] = "앙카할 정자",
	["Anglers Expedition"] = "강태공 원정대",
	["Anglers Wharf"] = "강태공 부두",
	["Angor Fortress"] = "고통의 요새",
	["Ango'rosh Grounds"] = "앙고로쉬 영토",
	["Ango'rosh Stronghold"] = "앙고로쉬 소굴",
	["Angrathar the Wrathgate"] = "분노의 관문 앙그라타르",
	["Angrathar the Wrath Gate"] = "분노의 관문 앙그라타르",
	["An'owyn"] = "안오윈",
	["An'telas"] = "안텔라스",
	["Antonidas Memorial"] = "안토니다스 기념지",
	Anvilmar = "앤빌마",
	["Anvil of Conflagration"] = "용암천지의 모루",
	["Apex Point"] = "태양 향점",
	["Apocryphan's Rest"] = "아포크리판의 안식처",
	["Apothecary Camp"] = "연금술사 야영지",
	["Applebloom Tavern"] = "사과꽃 주점",
	["Arathi Basin"] = "아라시 분지",
	["Arathi Highlands"] = "아라시 고원",
	["Arcane Pinnacle"] = "비전 봉우리",
	["Archmage Vargoth's Retreat"] = "대마법사 바르고스의 은거지",
	["Area 52"] = "52번 구역",
	["Arena Floor"] = "투기장",
	["Arena of Annihilation"] = "파멸의 투기장",
	["Argent Pavilion"] = "은빛십자군 막사",
	["Argent Stand"] = "은빛십자군 격전지",
	["Argent Tournament Grounds"] = "은빛십자군 마상시합 광장",
	["Argent Vanguard"] = "은빛십자군 선봉기지",
	["Ariden's Camp"] = "아리덴의 야영지",
	["Arikara's Needle"] = "아리카라의 봉우리",
	["Arklonis Ridge"] = "아클로니스 마루",
	["Arklon Ruins"] = "알클론 폐허",
	["Arriga Footbridge"] = "아리가 교각",
	["Arsad Trade Post"] = "알사드 교역 거점",
	["Ascendant's Rise"] = "승천의 마루",
	["Ascent of Swirling Winds"] = "소용돌이치는 바람의 오르막길",
	["Ashen Fields"] = "잿빛 벌판",
	["Ashen Lake"] = "잿빛 호수",
	Ashenvale = "잿빛 골짜기",
	["Ashwood Lake"] = "잿빛나무 호수",
	["Ashwood Post"] = "잿빛나무 초소",
	["Aspen Grove Post"] = "미루나무 숲 초소",
	["Assault on Shaol'mara"] = "샤올마라 강습",
	["Assault on Zan'vess"] = "잔베스 강습",
	["Assault on Zeb'tula"] = "제브툴라 강습",
	Astranaar = "아스트라나르",
	["Ata'mal Terrace"] = "아타말 언덕",
	Athenaeum = "도서관",
	["Atrium of the Heart"] = "심방",
	["Atulhet's Tomb"] = "아툴헤트의 무덤",
	["Auberdine Refugee Camp"] = "아우버다인 피난민 야영지",
	["Auburn Bluffs"] = "적갈빛 절벽",
	["Auchenai Crypts"] = "아키나이 납골당",
	["Auchenai Grounds"] = "아키나이 영지",
	Auchindoun = "아킨둔",
	["Auchindoun: Auchenai Crypts"] = "아킨둔: 아키나이 납골당",
	["Auchindoun - Auchenai Crypts Entrance"] = "아킨둔 - 아키나이 납골당 입구",
	["Auchindoun: Mana-Tombs"] = "아킨둔: 마나 무덤",
	["Auchindoun - Mana-Tombs Entrance"] = "아킨둔 - 마나 무덤 입구",
	["Auchindoun: Sethekk Halls"] = "아킨둔: 세데크 전당",
	["Auchindoun - Sethekk Halls Entrance"] = "아킨둔 - 세데크 전당 입구",
	["Auchindoun: Shadow Labyrinth"] = "아킨둔: 어둠의 미궁",
	["Auchindoun - Shadow Labyrinth Entrance"] = "아킨둔 - 어둠의 미궁 입구",
	["Auren Falls"] = "아우렌 폭포",
	["Auren Ridge"] = "아우렌 마루",
	["Autumnshade Ridge"] = "가을그늘 마루",
	["Avalanchion's Vault"] = "아발란치온의 석굴",
	Aviary = "박쥐 사육장",
	["Axis of Alignment"] = "정렬의 축",
	Axxarien = "악사리엔",
	["Azjol-Nerub"] = "아졸네룹",
	["Azjol-Nerub Entrance"] = "아졸네룹 입구",
	Azshara = "아즈샤라",
	["Azshara Crater"] = "아즈샤라 분화구",
	["Azshara's Palace"] = "아즈샤라의 궁전",
	["Azurebreeze Coast"] = "하늘바람 해안",
	["Azure Dragonshrine"] = "청금석 용제단",
	["Azurelode Mine"] = "청금석 광산",
	["Azuremyst Isle"] = "하늘안개 섬",
	["Azure Watch"] = "하늘 감시초소",
	["Backbreaker Bay"] = "척추파쇄 만",
	Badlands = "황야의 땅",
	["Bael'dun Digsite"] = "바엘던 발굴현장",
	["Bael'dun Keep"] = "바엘던 요새",
	["Baelgun's Excavation Site"] = "바엘군의 발굴현장",
	["Bael Modan"] = "바엘 모단",
	["Bael Modan Excavation"] = "바엘 모단 발굴현장",
	["Bahrum's Post"] = "바룸의 초소",
	["Balargarde Fortress"] = "발라르가드 요새",
	Baleheim = "베일하임",
	["Balejar Watch"] = "베일야르 감시초소",
	["Balia'mah Ruins"] = "발리아마 폐허",
	["Bal'lal Ruins"] = "발랄 폐허",
	["Balnir Farmstead"] = "발니르 농장",
	Bambala = "밤발라",
	["Band of Acceleration"] = "가속의 고리",
	["Band of Alignment"] = "정렬의 고리",
	["Band of Transmutation"] = "변환의 고리",
	["Band of Variance"] = "변화의 고리",
	["Ban'ethil Barrow Den"] = "바네실 지하굴",
	["Ban'ethil Barrow Descent"] = "바네실 지하굴 내리막길",
	["Ban'ethil Hollow"] = "바네실 동굴",
	Bank = "은행",
	["Banquet Grounds"] = "연회장",
	["Ban'Thallow Barrow Den"] = "반탈로우 지하굴",
	["Baradin Base Camp"] = "바라딘 주둔지",
	["Baradin Bay"] = "바라딘 만",
	["Baradin Hold"] = "바라딘 요새",
	Barbershop = "미용실",
	["Barov Family Vault"] = "바로브 가문 납골당",
	["Bashal'Aran"] = "바샬아란",
	["Bashal'Aran Collapse"] = "바샬아란 붕괴지",
	["Bash'ir Landing"] = "바시르 영지",
	["Bastion Antechamber"] = "요새 대기실",
	["Bathran's Haunt"] = "배스랜 서식지",
	["Battlefront Provisions"] = "최전선 병참기지",
	["Battle on the High Seas"] = "공해 상에서의 전투",
	["Battle Ring"] = "전투장",
	Battlescar = "전투의 흉터",
	["Battlescar Spire"] = "전투의 흉터 첨탑",
	["Battlescar Valley"] = "전투의 흉터 계곡",
	["Bay of Echoes"] = "메아리의 만",
	["Bay of Storms"] = "폭풍의 만",
	["Bear's Head"] = "곰마루",
	["Beauty's Lair"] = "아름이의 보금자리",
	["Beeble's Wreck"] = "비블의 추락지",
	["Beezil's Wreck"] = "비질의 추락지",
	["Befouled Terrace"] = "더럽혀진 단상",
	["Beggar's Haunt"] = "부랑자 소굴",
	["Beneath The Double Rainbow"] = "쌍무지개 마을",
	["Beneath the Pit"] = "구덩이 아래",
	["Beren's Peril"] = "베렌의 동굴",
	["Bernau's Happy Fun Land"] = "버나우의 놀이동산",
	["Beryl Coast"] = "녹주석 해안",
	["Beryl Egress"] = "녹주석 출구",
	["Beryl Point"] = "녹주석 거점",
	["Beth'mora Ridge"] = "베스모라 마루",
	["Beth'tilac's Lair"] = "베스틸락의 둥지",
	["Biel'aran Ridge"] = "비엘아란 마루",
	["Big Beach Brew Bash"] = "넓은 해변 맥주 깨기",
	["Big Blossom Excavation"] = "만개화 발굴현장",
	["Big Blossom Mine"] = "만개화 광산",
	["Bilgewater Beach"] = "빌지워터 해변",
	["Bilgewater Harbor"] = "빌지워터 항만",
	["Bilgewater Lumber Yard"] = "빌지워터 야적장",
	["Bilgewater Port"] = "빌지워터 항구",
	["Binan Brew & Stew"] = "빈안 맥주와 스튜",
	["Binan Village"] = "빈안 마을",
	["Bitter Reaches"] = "시련의 산마루",
	["Bittertide Lake"] = "거센물결 호수",
	["Bizmo's Brawlpub"] = "비즈모의 싸움굴",
	["Black Channel Marsh"] = "검은바닥 습지대",
	["Blackchar Cave"] = "검은재 동굴",
	["Black Drake Roost"] = "검은 비룡 보금자리",
	["Blackfathom Camp"] = "검은심연 야영지",
	["Blackfathom Deeps"] = "검은심연 나락",
	["Blackfathom Deeps Entrance"] = "검은심연 나락 입구",
	["Blackhoof Village"] = "검은발굽 마을",
	["Blackhorn's Penance"] = "블랙혼의 참회지",
	["Blackmaw Hold"] = "검은아귀 요새",
	["Black Ox Temple"] = "흑우사",
	["Blackriver Logging Camp"] = "검은강 벌목지",
	["Blackrock Caverns"] = "검은바위 동굴",
	["Blackrock Caverns Entrance"] = "검은바위 동굴 입구",
	["Blackrock Depths"] = "검은바위 나락",
	["Blackrock Depths Entrance"] = "검은바위 나락 입구",
	["Blackrock Mountain"] = "검은바위 산",
	["Blackrock Pass"] = "검은바위 고개",
	["Blackrock Spire"] = "검은바위 첨탑",
	["Blackrock Spire Entrance"] = "검은바위 첨탑 입구",
	["Blackrock Stadium"] = "검은바위 투기장",
	["Blackrock Stronghold"] = "검은바위 요새",
	["Blacksand Spillway"] = "검은모래 여수로",
	["Blacksilt Shore"] = "검은진흙 해안",
	Blacksmith = "대장간",
	["Blackstone Span"] = "검은돌 교각",
	["Black Temple"] = "검은 사원",
	["Black Tooth Hovel"] = "검은니 오두막",
	Blackwatch = "어둠의 감시초소",
	["Blackwater Cove"] = "검은바다 만",
	["Blackwater Shipwrecks"] = "검은바다 난파지",
	["Blackwind Lake"] = "검은바람 호수",
	["Blackwind Landing"] = "검은바람 비행기지",
	["Blackwind Valley"] = "검은바람 계곡",
	["Blackwing Coven"] = "검은날개 소굴",
	["Blackwing Descent"] = "검은날개 강림지",
	["Blackwing Lair"] = "검은날개 둥지",
	["Blackwolf River"] = "검은늑대 강",
	["Blackwood Camp"] = "검은나무 야영지",
	["Blackwood Den"] = "검은나무 소굴",
	["Blackwood Lake"] = "검은나무 호수",
	["Bladed Gulch"] = "칼날 협곡",
	["Bladefist Bay"] = "칼날주먹 만",
	["Bladelord's Retreat"] = "칼날군주의 은신처",
	["Blades & Axes"] = "칼과 도끼 전문점",
	["Blade's Edge Arena"] = "칼날 투기장",
	["Blade's Edge Mountains"] = "칼날 산맥",
	["Bladespire Grounds"] = "칼날첨탑 영토",
	["Bladespire Hold"] = "칼날첨탑 요새",
	["Bladespire Outpost"] = "칼날첨탑 전초기지",
	["Blades' Run"] = "칼날 고개",
	["Blade Tooth Canyon"] = "칼날이빨 대협곡",
	Bladewood = "칼날숲",
	["Blasted Lands"] = "저주받은 땅",
	["Bleak Hollow"] = "싸늘한 동굴",
	["Bleeding Hollow Ruins"] = "피눈물 폐허",
	["Bleeding Vale"] = "피투성이 계곡",
	["Bleeding Ziggurat"] = "피투성이 지구라트",
	["Blistering Pool"] = "부글거리는 웅덩이",
	["Bloodcurse Isle"] = "핏빛저주의 섬",
	["Blood Elf Tower"] = "블러드 엘프 경비탑",
	["Bloodfen Burrow"] = "붉은늪지 동굴",
	Bloodgulch = "피투성이 협곡",
	["Bloodhoof Village"] = "블러드후프 마을",
	["Bloodied Crossing"] = "선혈의 십자로",
	["Blood in the Snow"] = "피로 얼룩진 설원",
	["Bloodmaul Camp"] = "피망치 야영지",
	["Bloodmaul Outpost"] = "피망치 전초기지",
	["Bloodmaul Ravine"] = "피망치 협곡",
	["Bloodmoon Isle"] = "핏빛달 섬",
	["Bloodmyst Isle"] = "핏빛안개 섬",
	["Bloodscale Enclave"] = "피비늘 군락",
	["Bloodscale Grounds"] = "피비늘 영토",
	["Bloodspore Plains"] = "핏빛포자 평원",
	["Bloodtalon Shore"] = "붉은발톱 해안",
	["Bloodtooth Camp"] = "핏빛이빨 야영지",
	["Bloodvenom Falls"] = "피멍울 폭포",
	["Bloodvenom Post"] = "피멍울 초소",
	["Bloodvenom Post "] = "피멍울 초소",
	["Bloodvenom River"] = "피멍울 강",
	["Bloodwash Cavern"] = "핏빛여울 동굴",
	["Bloodwash Fighting Pits"] = "핏빛여울 전투 구덩이",
	["Bloodwash Shrine"] = "핏빛여울 제단",
	["Blood Watch"] = "핏빛 감시초소",
	["Bloodwatcher Point"] = "피감시자 거점",
	Bluefen = "푸른늪지",
	["Bluegill Marsh"] = "푸른아가미 습지대",
	["Blue Sky Logging Grounds"] = "푸른 하늘 벌목장",
	["Bluff of the South Wind"] = "남풍의 절벽",
	["Bogen's Ledge"] = "보겐의 절벽",
	Bogpaddle = "수렁진흙탕",
	["Boha'mu Ruins"] = "보하무 폐허",
	["Bolgan's Hole"] = "볼간의 굴",
	["Bolyun's Camp"] = "볼윤의 야영지",
	["Bonechewer Ruins"] = "해골이빨 폐허",
	["Bonesnap's Camp"] = "본스냅 야영지",
	["Bones of Grakkarond"] = "그락카론드의 무덤",
	["Bootlegger Outpost"] = "밀조장이 전초기지",
	["Booty Bay"] = "무법항",
	["Borean Tundra"] = "북풍의 땅",
	["Bor'gorok Outpost"] = "보르고로크 전초기지",
	["Bor's Breath"] = "보르의 숨결",
	["Bor's Breath River"] = "보르의 숨결 강",
	["Bor's Fall"] = "보르의 폭포",
	["Bor's Fury"] = "보르의 분노호",
	["Borune Ruins"] = "보룬 폐허",
	["Bough Shadow"] = "어둠의 나무",
	["Bouldercrag's Refuge"] = "볼더크랙의 은거처",
	["Boulderfist Hall"] = "돌주먹 소굴",
	["Boulderfist Outpost"] = "돌주먹 전초기지",
	["Boulder'gor"] = "돌주먹 언덕",
	["Boulder Hills"] = "바위 언덕",
	["Boulder Lode Mine"] = "돌무더기 광산",
	["Boulder'mok"] = "볼더모크",
	["Boulderslide Cavern"] = "구릉바위 동굴",
	["Boulderslide Ravine"] = "구릉바위 협곡",
	["Bozzle's Wreck"] = "보즐의 난파지",
	["Brackenwall Village"] = "담쟁이 마을",
	["Brackwell Pumpkin Patch"] = "브랙웰 호박밭",
	["Brambleblade Ravine"] = "칼날가시 협곡",
	Bramblescar = "가시덩굴 벌판",
	["Brann's Base-Camp"] = "브란의 기지",
	["Brashtide Attack Fleet"] = "난폭파도 공격 함대",
	["Brashtide Attack Fleet (Force Outdoors)"] = "난폭파도 공격 함대 (외부 부대)",
	["Brave Wind Mesa"] = "용사의 바람절벽",
	["Brawl'gar Arena"] = "싸울가르 투기장",
	["Brazie Farmstead"] = "브레이지 농장",
	["Brewmoon Festival"] = "맥주달 축제",
	["Brewnall Village"] = "브루날 마을",
	["Bridge of Souls"] = "영혼의 다리",
	["Brightwater Lake"] = "청명 호수",
	["Brightwood Grove"] = "밝은나무 숲",
	Brill = "브릴",
	["Brill Town Hall"] = "브릴 마을회관",
	["Bristlelimb Enclave"] = "뾰족가지 군락",
	["Bristlelimb Village"] = "뾰족가지 마을",
	["Broken Commons"] = "파괴된 광장",
	["Broken Hill"] = "무너진 언덕",
	["Broken Pillar"] = "무너진 기둥",
	["Broken Spear Village"] = "부러진창 마을",
	["Broken Wilds"] = "파괴된 벌판",
	["Broketooth Outpost"] = "조각니 전초기지",
	["Bronzebeard Encampment"] = "브론즈비어드 야영지",
	["Bronze Dragonshrine"] = "청동 용제단",
	["Browman Mill"] = "브라우만 제분소",
	["Brunnhildar Village"] = "브룬힐다르 마을",
	["Bucklebree Farm"] = "버클브리 농장",
	["Budd's Dig"] = "버드의 발굴지",
	["Burning Blade Coven"] = "불타는 칼날단 소굴",
	["Burning Blade Ruins"] = "불타는 칼날단 폐허",
	["Burning Steppes"] = "불타는 평원",
	["Butcher's Sanctum"] = "도살자의 성소",
	["Butcher's Stand"] = "집행자의 보루",
	["Caer Darrow"] = "카엘 다로우",
	["Caldemere Lake"] = "칼더미어 호수",
	["Calston Estate"] = "칼스턴 영지",
	["Camp Aparaje"] = "아파라제 야영지",
	["Camp Ataya"] = "아타야 야영지",
	["Camp Boff"] = "보프 야영지",
	["Camp Broketooth"] = "조각니 야영지",
	["Camp Cagg"] = "카그 야영지",
	["Camp E'thok"] = "에톡 야영지",
	["Camp Everstill"] = "영원고요 야영지",
	["Camp Gormal"] = "고르말 야영지",
	["Camp Kosh"] = "코쉬 야영지",
	["Camp Mojache"] = "모자케 야영지",
	["Camp Mojache Longhouse"] = "모자케 야영지 공동주택",
	["Camp Narache"] = "나라체 야영지",
	["Camp Nooka Nooka"] = "누카 누카 야영지",
	["Camp of Boom"] = "붐의 야영지",
	["Camp Onequah"] = "원크와 야영지",
	["Camp Oneqwah"] = "원크와 야영지",
	["Camp Sungraze"] = "해넘이 기지",
	["Camp Tunka'lo"] = "툰카로 야영지",
	["Camp Una'fe"] = "우나페 야영지",
	["Camp Winterhoof"] = "겨울발굽 야영지",
	["Camp Wurg"] = "우르그 야영지",
	Canals = "용수로",
	["Cannon's Inferno"] = "군주 캐논의 지옥불",
	["Cantrips & Crows"] = "마법과 까마귀 선술집",
	["Cape of Lost Hope"] = "잃어버린 희망의 곶",
	["Cape of Stranglethorn"] = "가시덤불 곶",
	["Capital Gardens"] = "수도 정원",
	["Carrion Hill"] = "부패의 언덕",
	["Cartier & Co. Fine Jewelry"] = "까르티엘 보석공예품",
	Cataclysm = "대격변",
	["Cathedral of Darkness"] = "어둠의 대성당",
	["Cathedral of Light"] = "빛의 대성당",
	["Cathedral Quarter"] = "대성당 지구",
	["Cathedral Square"] = "대성당 광장",
	["Cattail Lake"] = "부들개지 호수",
	["Cauldros Isle"] = "카울드로스 섬",
	["Cave of Mam'toth"] = "맘토스의 동굴",
	["Cave of Meditation"] = "명상의 동굴",
	["Cave of the Crane"] = "주학의 동굴",
	["Cave of Words"] = "이야기의 동굴",
	["Cavern of Endless Echoes"] = "끝없는 메아리의 동굴",
	["Cavern of Mists"] = "안개 동굴",
	["Caverns of Time"] = "시간의 동굴",
	["Celestial Enclave"] = "천신의 안식처",
	["Celestial Ridge"] = "하늘 마루",
	["Cenarion Enclave"] = "세나리온 자치령",
	["Cenarion Hold"] = "세나리온 요새",
	["Cenarion Post"] = "세나리온 초소",
	["Cenarion Refuge"] = "세나리온 야영지",
	["Cenarion Thicket"] = "세나리온 수풀",
	["Cenarion Watchpost"] = "세나리온 감시초소",
	["Cenarion Wildlands"] = "세나리온 자생지",
	["Central Bridge"] = "중앙 다리",
	["Chamber of Ancient Relics"] = "고대 유물의 방",
	["Chamber of Atonement"] = "속죄의 방",
	["Chamber of Battle"] = "전투의 방",
	["Chamber of Blood"] = "피의 집회장",
	["Chamber of Command"] = "지휘의 방",
	["Chamber of Enchantment"] = "마법의 방",
	["Chamber of Enlightenment"] = "깨달음의 방",
	["Chamber of Fanatics"] = "광신자의 방",
	["Chamber of Incineration"] = "소각의 방",
	["Chamber of Masters"] = "대가의 방",
	["Chamber of Prophecy"] = "예언의 방",
	["Chamber of Reflection"] = "투영의 방",
	["Chamber of Respite"] = "유예의 방",
	["Chamber of Summoning"] = "소환의 방",
	["Chamber of Test Namesets"] = "시험용 이름모음의 방",
	["Chamber of the Aspects"] = "위상의 방",
	["Chamber of the Dreamer"] = "꿈꾸는 자의 방",
	["Chamber of the Moon"] = "달의 방",
	["Chamber of the Restless"] = "안식을 찾지 못한 자의 석실",
	["Chamber of the Stars"] = "별의 방",
	["Chamber of the Sun"] = "해의 방",
	["Chamber of Whispers"] = "속삭임의 방",
	["Chamber of Wisdom"] = "지혜의 방",
	["Champion's Hall"] = "용사의 전당",
	["Champions' Hall"] = "용사의 전당",
	["Chapel Gardens"] = "예배당 정원",
	["Chapel of the Crimson Flame"] = "진홍불꽃의 예배당",
	["Chapel Yard"] = "예배당 지구",
	["Charred Outpost"] = "잿더미 전초기지",
	["Charred Rise"] = "잿더미 마루",
	["Chill Breeze Valley"] = "찬바람 골짜기",
	["Chillmere Coast"] = "서릿발 해안",
	["Chillwind Camp"] = "서리바람 야영지",
	["Chillwind Point"] = "서리바람 거점",
	Chiselgrip = "끌잡이 거점",
	["Chittering Coast"] = "지저귀는 해안",
	["Chow Farmstead"] = "초우 농장",
	["Churning Gulch"] = "휘몰이 협곡",
	["Circle of Blood"] = "피의 원",
	["Circle of Blood Arena"] = "피의 투기장",
	["Circle of Bone"] = "뼈의 원",
	["Circle of East Binding"] = "동쪽 봉인의 마법진",
	["Circle of Inner Binding"] = "내부 봉인의 마법진",
	["Circle of Outer Binding"] = "외부 봉인의 마법진",
	["Circle of Scale"] = "비늘의 원",
	["Circle of Stone"] = "바위의 원",
	["Circle of Thorns"] = "고난의 원",
	["Circle of West Binding"] = "서쪽 봉인의 마법진",
	["Circle of Wills"] = "의지의 투기장",
	City = "도시",
	["City of Ironforge"] = "아이언포지",
	["City Siege - Mogu Island Progression Scenario"] = "도시 공성전 - 모구 섬 진행 시나리오",
	["Clan Watch"] = "부족 초소",
	["Class Quest"] = "직업 퀘스트",
	["Claytön's WoWEdit Land"] = "클레이튼의 섬",
	["Cleft of Shadow"] = "어둠의 틈",
	["Cliffspring Falls"] = "절벽 폭포",
	["Cliffspring Hollow"] = "폭포수 동굴",
	["Cliffspring River"] = "폭포수 강",
	["Cliffwalker Post"] = "절벽지기 초소",
	["Cloudstrike Dojo"] = "클라우드스트라이크 도장",
	["Cloudtop Terrace"] = "구름꼭대기 정원",
	["Coast of Echoes"] = "메아리 해안",
	["Coast of Idols"] = "우상 해안",
	["Coilfang Reservoir"] = "갈퀴송곳니 저수지",
	["Coilfang: Serpentshrine Cavern"] = "갈퀴송곳니 저수지: 불뱀 제단",
	["Coilfang: The Slave Pens"] = "갈퀴송곳니 저수지: 강제 노역소",
	["Coilfang - The Slave Pens Entrance"] = "갈퀴송곳니 저수지 - 강제 노역소 입구",
	["Coilfang: The Steamvault"] = "갈퀴송곳니 저수지: 증기 저장고",
	["Coilfang - The Steamvault Entrance"] = "갈퀴송곳니 저수지 - 증기 저장고 입구",
	["Coilfang: The Underbog"] = "갈퀴송곳니 저수지: 지하수렁",
	["Coilfang - The Underbog Entrance"] = "갈퀴송곳니 저수지 - 지하수렁 입구",
	["Coilskar Cistern"] = "갈퀴흉터 저수지",
	["Coilskar Point"] = "갈퀴흉터 거점",
	Coldarra = "콜다라",
	["Coldarra Ledge"] = "콜다라 절벽",
	["Coldbite Burrow"] = "시린이빨 동굴",
	["Cold Hearth Manor"] = "버려진 장원",
	["Coldridge Pass"] = "눈마루 통로",
	["Coldridge Valley"] = "눈마루 골짜기",
	["Coldrock Quarry"] = "얼음바위 채석장",
	["Coldtooth Mine"] = "얼음이빨 광산",
	["Coldwind Heights"] = "눈바람 언덕",
	["Coldwind Pass"] = "눈바람 고개",
	["Collin's Test"] = "콜린의 시험용",
	["Command Center"] = "사령부",
	["Commons Hall"] = "대강당",
	["Condemned Halls"] = "낙인의 전당",
	["Conqueror's Terrace"] = "정복자의 정원",
	["Conquest Hold"] = "정복의 요새",
	["Containment Core"] = "중앙 격리실",
	["Cooper Residence"] = "쿠퍼 저택",
	["Coral Garden"] = "산호 정원",
	["Cordell's Enchanting"] = "코르델의 마법부여점",
	["Corin's Crossing"] = "코린 삼거리",
	["Corp'rethar: The Horror Gate"] = "코프레타르: 공포의 관문",
	["Corrahn's Dagger"] = "코란의 비수",
	Cosmowrench = "비틀린 우주",
	["Court of Bones"] = "망자의 궁정",
	["Court of the Highborne"] = "명가의 궁정",
	["Court of the Sun"] = "태양 궁정",
	["Courtyard of Lights"] = "빛의 광장",
	["Courtyard of the Ancients"] = "고대의 안마당",
	["Cradle of Chi-Ji"] = "츠지의 요람",
	["Cradle of the Ancients"] = "고대정령의 요람",
	["Craftsmen's Terrace"] = "장인의 정원",
	["Crag of the Everliving"] = "영생의 바위굴",
	["Cragpool Lake"] = "바위웅덩이 호수",
	["Crane Wing Refuge"] = "학날개 은거지",
	["Crash Site"] = "추락 지점",
	["Crescent Hall"] = "초승달 전당",
	["Crimson Assembly Hall"] = "진홍빛 회합 전당",
	["Crimson Expanse"] = "진홍 벌판",
	["Crimson Watch"] = "붉은 감시초소",
	Crossroads = "십자로",
	["Crowley Orchard"] = "크롤리 과수원",
	["Crowley Stable Grounds"] = "크롤리 말 조련장",
	["Crown Guard Tower"] = "산마루 경비탑",
	["Crucible of Carnage"] = "대학살의 도가니",
	["Crumbling Depths"] = "무너지는 심연",
	["Crumbling Stones"] = "무너지는 암석",
	["Crusader Forward Camp"] = "십자군 전진기지",
	["Crusader Outpost"] = "붉은십자군 전초기지",
	["Crusader's Armory"] = "십자군 무기고",
	["Crusader's Chapel"] = "십자군 예배당",
	["Crusader's Landing"] = "십자군 정박지",
	["Crusader's Outpost"] = "십자군 전초기지",
	["Crusaders' Pinnacle"] = "십자군 봉우리",
	["Crusader's Run"] = "십자군의 터",
	["Crusader's Spire"] = "십자군 첨탑",
	["Crusaders' Square"] = "십자군 광장",
	Crushblow = "박살의 땅",
	["Crushcog's Arsenal"] = "크러쉬코그의 무기고",
	["Crushridge Hold"] = "산사태 오우거 소굴",
	Crypt = "납골당",
	["Crypt of Forgotten Kings"] = "잊혀진 왕의 납골당",
	["Crypt of Remembrance"] = "기념 납골당",
	["Crystal Lake"] = "수정 호수",
	["Crystalline Quarry"] = "수정 채석장",
	["Crystalsong Forest"] = "수정노래 숲",
	["Crystal Spine"] = "수정 돌기",
	["Crystalvein Mine"] = "수정 광산",
	["Crystalweb Cavern"] = "수정그물 동굴",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "무어의 골동품점",
	["Cursed Depths"] = "저주받은 나락",
	["Cursed Hollow"] = "저주받은 골짜기",
	["Cut-Throat Alley"] = "자객의 뒷골목",
	["Cyclone Summit"] = "회오리 꼭대기",
	["Dabyrie's Farmstead"] = "다비리 농장",
	["Daggercap Bay"] = "비수집 만",
	["Daggerfen Village"] = "비수늪 마을",
	["Dagger in the Dark"] = "어둠 속의 비수",
	["Daggermaw Canyon"] = "비수아귀 협곡",
	["Dagger Pass"] = "비수 고개",
	["Dais of Conquerors"] = "정복자의 연단",
	Dalaran = "달라란",
	["Dalaran Arena"] = "달라란 투기장",
	["Dalaran City"] = "달라란",
	["Dalaran Crater"] = "달라란 구덩이",
	["Dalaran Floating Rocks"] = "달라란 떠다니는 바위",
	["Dalaran Island"] = "달라란 섬",
	["Dalaran Merchant's Bank"] = "달라란 상업 은행",
	["Dalaran Sewers"] = "달라란 하수도",
	["Dalaran Visitor Center"] = "달라란 관광 안내소",
	["Dalson's Farm"] = "달슨 농장",
	["Damplight Cavern"] = "안개빛 동굴",
	["Damplight Chamber"] = "안개빛 방",
	["Dampsoil Burrow"] = "습토 구덩이",
	["Dandred's Fold"] = "단드레드 장원",
	["Dargath's Demise"] = "다르가스의 최후",
	["Darkbreak Cove"] = "어둠돌파 동굴",
	["Darkcloud Pinnacle"] = "먹구름 봉우리",
	["Darkcrest Enclave"] = "암흑갈기 군락",
	["Darkcrest Shore"] = "암흑갈기 호숫가",
	["Dark Heart of Pandaria"] = "판다리아의 검은 심장",
	["Dark Iron Highway"] = "검은무쇠 대로",
	["Darkmist Cavern"] = "암흑안개 굴",
	["Darkmist Ruins"] = "암흑안개 폐허",
	["Darkmoon Boardwalk"] = "다크문 판잣길",
	["Darkmoon Deathmatch"] = "다크문 사투장",
	["Darkmoon Deathmatch Pit (PH)"] = "다크문 사투장 (PH)",
	["Darkmoon Faire"] = "다크문 축제",
	["Darkmoon Island"] = "다크문 섬",
	["Darkmoon Island Cave"] = "다크문 섬 동굴",
	["Darkmoon Path"] = "다크문 길",
	["Darkmoon Pavilion"] = "다크문 천막",
	Darkshire = "어둠골",
	["Darkshire Town Hall"] = "어둠골 마을회관",
	Darkshore = "어둠해안",
	["Darkspear Hold"] = "검은창 요새",
	["Darkspear Isle"] = "검은창 섬",
	["Darkspear Shore"] = "검은창 해변",
	["Darkspear Strand"] = "검은창 해안",
	["Darkspear Training Grounds"] = "검은창 훈련장",
	["Darkwhisper Gorge"] = "검은속삭임 협곡",
	["Darkwhisper Pass"] = "검은속삭임 고개",
	["Darnassian Base Camp"] = "다르나서스 주둔지",
	Darnassus = "다르나서스",
	["Darrow Hill"] = "다로우 언덕",
	["Darrowmere Lake"] = "다로우미어 호수",
	Darrowshire = "다로우골",
	["Darrowshire Hunting Grounds"] = "다로우골 사냥터",
	["Darsok's Outpost"] = "다르속의 전초기지",
	["Dawnchaser Retreat"] = "돈체이서 은거처",
	["Dawning Lane"] = "새벽길",
	["Dawning Wood Catacombs"] = "새벽숲 지하묘지",
	["Dawnrise Expedition"] = "새벽녘 원정대",
	["Dawn's Blossom"] = "새벽의 꽃",
	["Dawnseeker Promontory"] = "돈시커 곶",
	["Dawnseeker's Promontory"] = "돈시커 곶",
	["Dawn's Reach"] = "십자군 주둔지",
	["Dawnstar Spire"] = "돈스타 첨탑",
	["Dawnstar Village"] = "돈스타 마을",
	["Daxil's Dig"] = "닥실의 채굴지",
	["D-Block"] = "D 구역",
	["Deadeye Shore"] = "데드아이 해안",
	["Deadman's Crossing"] = "사자의 길",
	["Dead Man's Hole"] = "사자의 구멍",
	Deadmines = "죽음의 폐광",
	["Deadtalker's Plateau"] = "죽음부름 고원",
	["Deadwind Pass"] = "저승바람 고개",
	["Deadwind Ravine"] = "죽음의 협곡",
	["Deadwood Village"] = "마른가지 마을",
	["Deathbringer's Rise"] = "죽음의 인도자 마루",
	["Death Cultist Base Camp"] = "죽음의 이교도 주둔지",
	["Deathforge Tower"] = "죽음의 괴철로 탑",
	Deathknell = "죽음의 종소리 마을",
	["Deathmatch Pavilion"] = "사투장 천막",
	Deatholme = "데솔름",
	["Death's Breach"] = "죽음의 틈",
	["Death's Door"] = "죽음의 문",
	["Death's Hand Encampment"] = "죽음의 손 야영지",
	["Deathspeaker's Watch"] = "죽음예언자 감시초소",
	["Death's Rise"] = "죽음의 마루",
	["Death's Stand"] = "죽음의 언덕",
	["Death's Step"] = "죽음의 발자취",
	["Death's Watch Waystation"] = "죽음의 감시자 중계지",
	Deathwing = "데스윙",
	["Deathwing's Fall"] = "데스윙의 몰락지",
	["Deep Blue Observatory"] = "짙푸른 관측소",
	["Deep Elem Mine"] = "심원 광산",
	["Deepfin Ridge"] = "심해지느러미 마루",
	Deepholm = "심원의 영지",
	["Deephome Ceiling"] = "심원의 영지 천장",
	["Deepmist Grotto"] = "깊은안개 종유동",
	["Deeprun Tram"] = "깊은굴 지하철",
	["Deepwater Tavern"] = "깊은바다 선술집",
	["Deepwind Gorge"] = "깊은바람 협곡",
	["Defense of the Alehouse"] = "선술집 방어",
	["Defense Of The Ale House BG"] = "선술집 방어 전장",
	["Defias Hideout"] = "데피아즈단 은신처",
	["Defiler's Den"] = "파멸의 전당",
	["D.E.H.T.A. Encampment"] = "동물보호협회 야영지",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "악마벼락 협곡",
	["Demon Fall Ridge"] = "악마벼락 마루",
	["Demont's Place"] = "데몬트의 집터",
	["Den of Defiance"] = "저항의 동굴",
	["Den of Dying"] = "사자의 동굴",
	["Den of Haal'esh"] = "하알에쉬 소굴",
	["Den of Iniquity"] = "부정의 소굴",
	["Den of Mortal Delights"] = "향락의 소굴",
	["Den of Sorrow"] = "슬픔의 동굴",
	["Den of Sseratus"] = "세라투스의 동굴",
	["Den of the Caller"] = "소환사의 방",
	["Den of the Devourer"] = "포식자의 굴",
	["Den of the Disciples"] = "사도의 동굴",
	["Den of the Unholy"] = "부정의 굴",
	["Derelict Caravan"] = "버려진 짐마차",
	["Derelict Manor"] = "버려진 장원",
	["Derelict Strand"] = "적막한 해안",
	["Designer Island"] = "디자이너의 섬",
	Desolace = "잊혀진 땅",
	["Desolation Hold"] = "황폐의 요새",
	["Detention Block"] = "감금 구역",
	["Development Land"] = "진화의 대지",
	["Diamondhead River"] = "다이아몬드 강",
	["Diamond Island"] = "다이아몬드 섬",
	["Dig One"] = "제1 발굴지",
	["Dig Three"] = "제3 발굴지",
	["Dig Two"] = "제2 발굴지",
	["Direforge Hill"] = "공포철로 언덕",
	["Direhorn Post"] = "공포뿔 거점",
	["Dire Maul"] = "혈투의 전장",
	["Dire Maul - Capital Gardens Entrance"] = "혈투의 전장 - 수도 정원 입구",
	["Dire Maul - East"] = "혈투의 전장 - 동쪽",
	["Dire Maul - Gordok Commons Entrance"] = "혈투의 전장 - 고르독 광장 입구",
	["Dire Maul - North"] = "혈투의 전장 - 북쪽",
	["Dire Maul - Warpwood Quarter Entrance"] = "혈투의 전장 - 굽이나무 지구 입구",
	["Dire Maul - West"] = "혈투의 전장 - 서쪽",
	Diremoor = "불길한 습지",
	["Dire Strait"] = "혈투의 해협",
	["Disciple's Enclave"] = "문하생의 동굴",
	Docks = "부두",
	["Dojani River"] = "도자니 강",
	Dolanaar = "돌라나르",
	["Dome Balrissa"] = "발리사 전당",
	["Domination Point"] = "지배령 거점",
	["Donna's Kitty Shack"] = "도나의 고양이집",
	["DO NOT USE"] = "미사용",
	["Dookin' Grounds"] = "두끼끼의 땅",
	["Doom's Vigil"] = "멸망의 망루",
	["Dorian's Outpost"] = "도리안의 전초기지",
	["Draco'dar"] = "드라코다르",
	["Draenei Ruins"] = "드레나이 폐허",
	["Draenethyst Mine"] = "드레니시스트 광산",
	["Draenil'dur Village"] = "드레닐두르 마을",
	Dragonblight = "용의 안식처",
	["Dragonflayer Pens"] = "용약탈 우리",
	["Dragonmaw Base Camp"] = "용아귀 주둔지",
	["Dragonmaw Flag Room"] = "용아귀 깃발 보관실",
	["Dragonmaw Forge"] = "용아귀 제련소",
	["Dragonmaw Fortress"] = "용아귀 요새",
	["Dragonmaw Garrison"] = "용아귀 주둔지",
	["Dragonmaw Gates"] = "용아귀 관문",
	["Dragonmaw Pass"] = "용아귀 고개",
	["Dragonmaw Port"] = "용아귀 항구",
	["Dragonmaw Skyway"] = "용아귀 하늘길",
	["Dragonmaw Stronghold"] = "용아귀 요충지",
	["Dragons' End"] = "용의 무덤",
	["Dragon's Fall"] = "용사냥 마루",
	["Dragon's Mouth"] = "용의 입",
	["Dragon Soul"] = "용의 영혼",
	["Dragon Soul Raid - East Sarlac"] = "용의 영혼 공격대",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "용의 영혼 공격대",
	["Dragonspine Peaks"] = "용돌기 봉우리",
	["Dragonspine Ridge"] = "용돌기 마루",
	["Dragonspine Tributary"] = "용돌기 강",
	["Dragonspire Hall"] = "용첨탑 전당",
	["Drak'Agal"] = "드락아갈",
	["Draka's Fury"] = "드라카의 분노호",
	["Drak'atal Passage"] = "드라카탈 통로",
	["Drakil'jin Ruins"] = "드라킬진 폐허",
	["Drak'Mabwa"] = "드락마브와",
	["Drak'Mar Lake"] = "드락마 호수",
	["Draknid Lair"] = "드라크니드 둥지",
	["Drak'Sotra"] = "드락소트라",
	["Drak'Sotra Fields"] = "드락소트라 농장",
	["Drak'Tharon Keep"] = "드락타론 성채",
	["Drak'Tharon Keep Entrance"] = "드락타론 성채 입구",
	["Drak'Tharon Overlook"] = "드락타론 전망대",
	["Drak'ural"] = "드락우랄",
	["Dread Clutch"] = "공포의 손아귀",
	["Dread Expanse"] = "공포의 광장",
	["Dreadmaul Furnace"] = "우레망치 용광로",
	["Dreadmaul Hold"] = "우레망치 요새",
	["Dreadmaul Post"] = "우레망치 주둔지",
	["Dreadmaul Rock"] = "우레망치 바위굴",
	["Dreadmist Camp"] = "공포안개 야영지",
	["Dreadmist Den"] = "공포안개 굴",
	["Dreadmist Peak"] = "공포안개 봉우리",
	["Dreadmurk Shore"] = "몸서리 해안",
	["Dread Terrace"] = "두려움의 난간뜰",
	["Dread Wastes"] = "공포의 황무지",
	["Dreadwatch Outpost"] = "공포망루 전초기지",
	["Dream Bough"] = "꿈나무",
	["Dreamer's Pavilion"] = "꿈꾸는 자의 정자",
	["Dreamer's Rest"] = "꿈꾸는 자의 휴식처",
	["Dreamer's Rock"] = "꿈꾸는 자의 바위",
	Drudgetown = "노역마을",
	["Drygulch Ravine"] = "모래바람 협곡",
	["Drywhisker Gorge"] = "마른수염 골짜기",
	["Dubra'Jin"] = "두브라진",
	["Dun Algaz"] = "던 알가즈",
	["Dun Argol"] = "던 아르골",
	["Dun Baldar"] = "던 발다르",
	["Dun Baldar Pass"] = "던 발다르 고개",
	["Dun Baldar Tunnel"] = "던 발다르 동굴",
	["Dunemaul Compound"] = "모래망치 주둔지",
	["Dunemaul Recruitment Camp"] = "모래망치 모집 야영장",
	["Dun Garok"] = "던 가록",
	["Dun Mandarr"] = "던 만다르",
	["Dun Modr"] = "던 모드르",
	["Dun Morogh"] = "던 모로",
	["Dun Niffelem"] = "던 니펠렘",
	["Dunwald Holdout"] = "둔왈트 항거지",
	["Dunwald Hovel"] = "둔왈트 오두막",
	["Dunwald Market Row"] = "둔왈트 상가",
	["Dunwald Ruins"] = "둔왈트 폐허",
	["Dunwald Town Square"] = "둔왈트 마을 광장",
	["Durnholde Keep"] = "던홀드 요새",
	Durotar = "듀로타",
	Duskhaven = "어스름 안식처",
	["Duskhowl Den"] = "그늘울음 동굴",
	["Dusklight Bridge"] = "그늘빛 다리",
	["Dusklight Hollow"] = "그늘빛 공터",
	["Duskmist Shore"] = "그늘안개 해안",
	["Duskroot Fen"] = "그늘뿌리 늪",
	["Duskwither Grounds"] = "더스크위더 정원",
	["Duskwither Spire"] = "더스크위더 첨탑",
	Duskwood = "그늘숲",
	["Dustback Gorge"] = "먼지등 협곡",
	["Dustbelch Grotto"] = "먼지목도리 소굴",
	["Dustfire Valley"] = "먼지불 골짜기",
	["Dustquill Ravine"] = "먼지깃 협곡",
	["Dustwallow Bay"] = "먼지진흙 만",
	["Dustwallow Marsh"] = "먼지진흙 습지대",
	["Dustwind Cave"] = "먼지바람 동굴",
	["Dustwind Dig"] = "먼지바람 발굴지",
	["Dustwind Gulch"] = "먼지바람 협곡",
	["Dwarven District"] = "드워프 지구",
	["Eagle's Eye"] = "독수리의 눈",
	["Earthshatter Cavern"] = "지축이동 동굴",
	["Earth Song Falls"] = "대지노래 폭포",
	["Earth Song Gate"] = "대지노래 관문",
	["Eastern Bridge"] = "동쪽 다리",
	["Eastern Kingdoms"] = "동부 왕국",
	["Eastern Plaguelands"] = "동부 역병지대",
	["Eastern Strand"] = "동부 해안",
	["East Garrison"] = "동쪽 주둔지",
	["Eastmoon Ruins"] = "동쪽 달 폐허",
	["East Pavilion"] = "동쪽 천막",
	["East Pillar"] = "동쪽 기둥",
	["Eastpoint Tower"] = "동부경비 탑",
	["East Sanctum"] = "동부 성소",
	["Eastspark Workshop"] = "동부불꽃 작업장",
	["East Spire"] = "동쪽 첨탑",
	["East Supply Caravan"] = "동쪽 보급 짐마차",
	["Eastvale Logging Camp"] = "동쪽계곡 벌목지",
	["Eastwall Gate"] = "동부방벽 관문",
	["Eastwall Tower"] = "동부방벽 경비탑",
	["Eastwind Rest"] = "동풍의 쉼터",
	["Eastwind Shore"] = "샛바람 해안",
	["Ebon Hold"] = "칠흑의 요새",
	["Ebon Watch"] = "칠흑의 감시초소",
	["Echo Cove"] = "메아리 동굴",
	["Echo Isles"] = "메아리 섬",
	["Echomok Cavern"] = "메아리 동굴",
	["Echo Reach"] = "메아리치는 바다",
	["Echo Ridge Mine"] = "메아리 광산",
	["Eclipse Point"] = "해그늘 주둔지",
	["Eclipsion Fields"] = "해그늘 벌판",
	["Eco-Dome Farfield"] = "외곽 생태지구",
	["Eco-Dome Midrealm"] = "중앙 생태지구",
	["Eco-Dome Skyperch"] = "하늘마루 생태지구",
	["Eco-Dome Sutheron"] = "수데론 생태지구",
	["Elder Rise"] = "장로의 봉우리",
	["Elders' Square"] = "장로의 광장",
	["Eldreth Row"] = "엘드레스 관문",
	["Eldritch Heights"] = "으스스한 언덕",
	["Elemental Plateau"] = "정령의 고원",
	["Elementium Depths"] = "엘레멘티움 나락",
	Elevator = "승강기",
	["Elrendar Crossing"] = "엘렌다르 건널목",
	["Elrendar Falls"] = "엘렌다르 폭포",
	["Elrendar River"] = "엘렌다르 강",
	["Elwynn Forest"] = "엘윈 숲",
	["Ember Clutch"] = "잿불의 손아귀",
	Emberglade = "잿불숲",
	["Ember Spear Tower"] = "잿불창 경비탑",
	["Emberstone Mine"] = "잿불석 광산",
	["Emberstone Village"] = "잿불석 마을",
	["Emberstrife's Den"] = "엠버스트라이프의 굴",
	["Emerald Dragonshrine"] = "에메랄드 용제단",
	["Emerald Dream"] = "에메랄드의 꿈",
	["Emerald Forest"] = "에메랄드 숲",
	["Emerald Sanctuary"] = "에메랄드 성소",
	["Emperor Rikktik's Rest"] = "황제 리크틱의 안식처",
	["Emperor's Omen"] = "황제의 예언",
	["Emperor's Reach"] = "황제의 세력지",
	["End Time"] = "시간의 끝",
	["Engineering Labs"] = "기계공학 연구소",
	["Engineering Labs "] = "기계공학 연구소",
	["Engine of Nalak'sha"] = "나락샤의 동력장치",
	["Engine of the Makers"] = "창조주의 기계",
	["Entryway of Time"] = "시간의 진입로",
	["Ethel Rethor"] = "에텔 레소르",
	["Ethereal Corridor"] = "에테리얼 회랑",
	["Ethereum Staging Grounds"] = "에테리움 작전 지역",
	["Evergreen Trading Post"] = "사철나무 교역소",
	Evergrove = "영원의 숲",
	Everlook = "눈망루 마을",
	["Eversong - Duskwither Teleport"] = "영원노래 숲",
	["Eversong Woods"] = "영원노래 숲",
	["Excavation Center"] = "유적발굴 지휘본부",
	["Excavation Lift"] = "유적발굴지 승강장",
	["Exclamation Point"] = "느낌표",
	["Expedition Armory"] = "원정대 무기고",
	["Expedition Base Camp"] = "원정대 기지",
	["Expedition Point"] = "원정대 거점",
	["Explorers' League Digsite"] = "탐험가 연맹 발굴현장",
	["Explorers' League Outpost"] = "탐험가 연맹 전초기지",
	["Exposition Pavilion"] = "박람회 천막",
	["Eye of Eternity"] = "영원의 눈",
	["Eye of the Storm"] = "폭풍의 눈",
	["Fairbreeze Village"] = "산들바람 마을",
	["Fairbridge Strand"] = "구름다리 해변",
	["Falcon Watch"] = "매의 감시탑",
	["Falconwing Inn"] = "매날개 여관",
	["Falconwing Square"] = "매날개 광장",
	["Faldir's Cove"] = "팔디르의 만",
	["Falfarren River"] = "팔파렌 강",
	["Fallen Sky Lake"] = "유성 호수",
	["Fallen Sky Ridge"] = "무너진 하늘 마루",
	["Fallen Temple of Ahn'kahet"] = "무너진 안카헤트 신전",
	["Fall of Return"] = "귀환의 전당",
	["Fallowmere Inn"] = "팰로우미어 여관",
	["Fallow Sanctuary"] = "드레노어 성역",
	["Falls of Ymiron"] = "이미론의 폭포",
	["Fallsong Village"] = "가을노래 마을",
	["Falthrien Academy"] = "팔스리엔 마법학회",
	Familiars = "친숙한 땅",
	["Faol's Rest"] = "파올의 안식처",
	["Fargaze Mesa"] = "아득한 응시의 고원",
	["Fargodeep Mine"] = "개미굴 광산",
	Farm = "농장",
	Farshire = "아득골",
	["Farshire Fields"] = "아득골 농장",
	["Farshire Lighthouse"] = "아득골 등대",
	["Farshire Mine"] = "아득골 광산",
	["Farson Hold"] = "파슨 요새",
	["Farstrider Enclave"] = "원정순찰대 초소",
	["Farstrider Lodge"] = "원정순찰대 오두막",
	["Farstrider Retreat"] = "원정순찰대 산장",
	["Farstriders' Enclave"] = "원정순찰대 초소",
	["Farstriders' Square"] = "원정순찰대 광장",
	["Farwatcher's Glen"] = "천리감시자 골짜기",
	["Farwatch Overlook"] = "천리감시 전망대",
	["Far Watch Post"] = "천리길 경비초소",
	["Fear Clutch"] = "두려움의 손아귀",
	["Featherbeard's Hovel"] = "페더비어드의 오두막",
	Feathermoon = "페더문 요새",
	["Feathermoon Stronghold"] = "페더문 요새",
	["Fe-Feng Village"] = "페펑 마을",
	["Felfire Hill"] = "악령불 언덕",
	["Felpaw Village"] = "악령발 마을",
	["Fel Reaver Ruins"] = "지옥절단기 폐허",
	["Fel Rock"] = "악마 바위굴",
	["Felspark Ravine"] = "지옥불꽃 협곡",
	["Felstone Field"] = "펠스톤 농장",
	Felwood = "악령숲",
	["Fenris Isle"] = "펜리스 섬",
	["Fenris Keep"] = "펜리스 요새",
	Feralas = "페랄라스",
	["Feralfen Village"] = "야생늪 마을",
	["Feral Scar Vale"] = "거친흉터 골짜기",
	["Festering Pools"] = "썩은 웅덩이",
	["Festival Lane"] = "축제의 거리",
	["Feth's Way"] = "페스의 길",
	["Field of Korja"] = "코르자의 들판",
	["Field of Strife"] = "투쟁의 벌판",
	["Fields of Blood"] = "피의 들판",
	["Fields of Honor"] = "명예의 들판",
	["Fields of Niuzao"] = "니우짜오의 들판",
	Filming = "촬영",
	["Final Gate - Mogu Island Progression Scenario"] = "마지막 관문 - 모구 섬 진행 시나리오",
	["Firebeard Cemetery"] = "파이어비어드 묘지",
	["Firebeard's Patrol"] = "파이어비어드의 지구대",
	["Firebough Nook"] = "파이어바우 변두리마을",
	["Fire Camp Bataar"] = "불의 야영지 바타르",
	["Fire Camp Gai-Cho"] = "불의 야영지 가이초",
	["Fire Camp Ordo"] = "불의 야영지 오르도",
	["Fire Camp Osul"] = "불의 야영지 오술",
	["Fire Camp Ruqin"] = "불의 야영지 루친",
	["Fire Camp Yongqi"] = "불의 야영지 용치",
	["Firegut Furnace"] = "불자루 용광로",
	Firelands = "불의 땅",
	["Firelands Forgeworks"] = "불의 땅 제련작업장",
	["Firelands Hatchery"] = "불의 땅 부화장",
	["Firelands Terrain 2"] = "불의 땅 지형 2",
	["Fireplume Peak"] = "불꽃깃털 봉우리",
	["Fire Plume Ridge"] = "불기둥 마루",
	["Fireplume Trench"] = "화염깃털 협곡",
	["Fire Scar Shrine"] = "불타버린 신전",
	["Fire Stone Mesa"] = "부싯돌 고원",
	["Firestone Point"] = "화염석 거점",
	["Firewatch Ridge"] = "불망루 마루",
	["Firewing Point"] = "불꽃날개 거점",
	["First Bank of Kezan"] = "케잔 일등 은행",
	["First Legion Forward Camp"] = "1군단 전진기지",
	["First to Your Aid"] = "응급치료의 모든 것",
	["Fishing Village"] = "고기잡이 마을",
	["Fizzcrank Airstrip"] = "피즈크랭크 비행장",
	["Fizzcrank Pumping Station"] = "피즈크랭크 채굴 현장",
	["Fizzle & Pozzik's Speedbarge"] = "피즐과 포직의 쾌속선",
	["Fjorn's Anvil"] = "피요른의 모루",
	Flamebreach = "불꽃틈새",
	["Flame Crest"] = "화염 마루",
	["Flamestar Post"] = "불꽃별 초소",
	["Flamewatch Tower"] = "불꽃감시 경비탑",
	["Flavor - Stormwind Harbor - Stop"] = "스톰윈드 항구",
	["Fleshrender's Workshop"] = "살점분리자의 작업장",
	["Foothold Citadel"] = "거점 요새",
	["Footman's Armory"] = "보병 무기고",
	["Force Interior"] = "내부 강제",
	["Fordragon Hold"] = "폴드라곤 요새",
	["Forest Heart"] = "숲의 심장",
	["Forest's Edge"] = "숲 가장자리",
	["Forest's Edge Post"] = "숲 가장자리 초소",
	["Forest Song"] = "숲의 노래",
	["Forge Base: Gehenna"] = "지옥의 괴철로 주둔지",
	["Forge Base: Oblivion"] = "망각의 괴철로 주둔지",
	["Forge Camp: Anger"] = "고통의 괴철로 기지",
	["Forge Camp: Fear"] = "경악의 괴철로 기지",
	["Forge Camp: Hate"] = "증오의 괴철로 기지",
	["Forge Camp: Mageddon"] = "멸망의 괴철로 기지",
	["Forge Camp: Rage"] = "분노의 괴철로 기지",
	["Forge Camp: Terror"] = "공포의 괴철로 기지",
	["Forge Camp: Wrath"] = "격노의 괴철로 기지",
	["Forge of Fate"] = "운명의 용광로",
	["Forge of the Endless"] = "무한의 제련소",
	["Forgewright's Tomb"] = "포지라이트의 무덤",
	["Forgotten Depths"] = "잊혀진 심연",
	["Forgotten Hill"] = "잊어버린 언덕",
	["Forgotten Mire"] = "잊혀진 늪",
	["Forgotten Passageway"] = "잊혀진 통로",
	["Forlorn Cloister"] = "쓸쓸한 회랑",
	["Forlorn Hut"] = "쓸쓸한 오두막",
	["Forlorn Ridge"] = "쓸쓸한 마루",
	["Forlorn Rowe"] = "버려진 흉가",
	["Forlorn Spire"] = "쓸쓸한 첨탑",
	["Forlorn Woods"] = "쓸쓸한 숲",
	["Formation Grounds"] = "전투대형 훈련장",
	["Forsaken Forward Command"] = "포세이큰 전방 지휘소",
	["Forsaken High Command"] = "포세이큰 고위 사령부",
	["Forsaken Rear Guard"] = "포세이큰 후방 경비소",
	["Fort Livingston"] = "리빙스턴 요새",
	["Fort Silverback"] = "은빛등 요새",
	["Fort Triumph"] = "승전의 요새",
	["Fortune's Fist"] = "운명의 주먹",
	["Fort Wildervar"] = "빌더바르 요새",
	["Forward Assault Camp"] = "최전방 야영지",
	["Forward Command"] = "전방 지휘소",
	["Foulspore Cavern"] = "썩은포자 동굴",
	["Foulspore Pools"] = "썩은포자 웅덩이",
	["Fountain of the Everseeing"] = "예지자의 분수",
	["Fox Grove"] = "여우 숲",
	["Fractured Front"] = "무너진 전초지",
	["Frayfeather Highlands"] = "공작날개 고원",
	["Fray Island"] = "격투의 섬",
	["Frazzlecraz Motherlode"] = "프라즐크라즈 광맥",
	["Freewind Post"] = "높새바람 봉우리",
	["Frenzyheart Hill"] = "광란심장 언덕",
	["Frenzyheart River"] = "광란심장 강",
	["Frigid Breach"] = "얼어붙은 틈",
	["Frostblade Pass"] = "서릿날 고개",
	["Frostblade Peak"] = "서릿날 봉우리",
	["Frostclaw Den"] = "서리발톱 동굴",
	["Frost Dagger Pass"] = "서리비수 고개",
	["Frostfield Lake"] = "서리평원 호수",
	["Frostfire Hot Springs"] = "얼음불꽃 온천",
	["Frostfloe Deep"] = "거대한 유빙",
	["Frostgrip's Hollow"] = "서리손아귀 동굴",
	Frosthold = "서리요새",
	["Frosthowl Cavern"] = "서리울음 동굴",
	["Frostmane Front"] = "서리갈기 싸움터",
	["Frostmane Hold"] = "서리갈기 소굴",
	["Frostmane Hovel"] = "서슬갈기 거처",
	["Frostmane Retreat"] = "서리갈기 은신처",
	Frostmourne = "서리한",
	["Frostmourne Cavern"] = "서리한 동굴",
	["Frostsaber Rock"] = "눈호랑이 바위",
	["Frostwhisper Gorge"] = "서리속삭임 골짜기",
	["Frostwing Halls"] = "서리날개 전당",
	["Frostwolf Graveyard"] = "서리늑대 무덤",
	["Frostwolf Keep"] = "서리늑대 요새",
	["Frostwolf Pass"] = "서리늑대 고개",
	["Frostwolf Tunnel"] = "서리늑대 동굴",
	["Frostwolf Village"] = "서리늑대 마을",
	["Frozen Reach"] = "얼어붙은 해안",
	["Fungal Deep"] = "버섯 골짜기",
	["Fungal Rock"] = "버섯 바위굴",
	["Funggor Cavern"] = "버섯 동굴",
	["Furien's Post"] = "퓨리엔의 거점",
	["Furlbrow's Pumpkin Farm"] = "펄브라우 호박밭",
	["Furnace of Hate"] = "증오의 용광로",
	["Furywing's Perch"] = "퓨리윙의 둥지",
	Fuselight = "점화등 마을",
	["Fuselight-by-the-Sea"] = "점화등 바닷가마을",
	["Fu's Pond"] = "푸의 연못",
	Gadgetzan = "가젯잔",
	["Gahrron's Withering"] = "가론의 흉가",
	["Gai-Cho Battlefield"] = "가이초 전장",
	["Galak Hold"] = "갈라크 소굴",
	["Galakrond's Rest"] = "갈라크론드의 안식처",
	["Galardell Valley"] = "갈라델 골짜기",
	["Galen's Fall"] = "갈렌의 타락지",
	["Galerek's Remorse"] = "갈레렉의 후회호",
	["Galewatch Lighthouse"] = "질풍감시 등대",
	["Gallery of Treasures"] = "보물 전시실",
	["Gallows' Corner"] = "교수대 삼거리",
	["Gallows' End Tavern"] = "교수대끝 선술집",
	["Gallywix Docks"] = "갤리윅스 부두",
	["Gallywix Labor Mine"] = "갤리윅스 노동광산",
	["Gallywix Pleasure Palace"] = "갤리윅스 아방궁",
	["Gallywix's Villa"] = "갤리윅스의 별장",
	["Gallywix's Yacht"] = "갤리윅스의 쾌속선",
	["Galus' Chamber"] = "갈루스의 방",
	["Gamesman's Hall"] = "승부사의 전당",
	Gammoth = "감모스",
	["Gao-Ran Battlefront"] = "가오란 최전선",
	Garadar = "가라다르",
	["Gar'gol's Hovel"] = "가르골의 거처",
	Garm = "가름",
	["Garm's Bane"] = "가름의 파멸",
	["Garm's Rise"] = "가름의 마루",
	["Garren's Haunt"] = "가렌의 흉가",
	["Garrison Armory"] = "요새 무기고",
	["Garrosh'ar Advance"] = "가로쉬아르 진군지",
	["Garrosh'ar Point"] = "가로쉬아르 거점",
	["Garrosh's Landing"] = "가로쉬의 상륙지",
	["Garvan's Reef"] = "가반의 산호초",
	["Gate of Echoes"] = "메아리 관문",
	["Gate of Endless Spring"] = "영원한 봄의 문",
	["Gate of Hamatep"] = "하마텝 관문",
	["Gate of Lightning"] = "번개의 관문",
	["Gate of the August Celestials"] = "위대한 천신회의 관문",
	["Gate of the Blue Sapphire"] = "푸른 사파이어 관문",
	["Gate of the Green Emerald"] = "초록 에메랄드 관문",
	["Gate of the Purple Amethyst"] = "보라 자수정 관문",
	["Gate of the Red Sun"] = "붉은 태양 관문",
	["Gate of the Setting Sun"] = "석양문",
	["Gate of the Yellow Moon"] = "노란 달 관문",
	["Gates of Ahn'Qiraj"] = "안퀴라즈 성문",
	["Gates of Ironforge"] = "아이언포지 성문",
	["Gates of Sothann"] = "소단 관문",
	["Gauntlet of Flame"] = "불타는 시련의 통로",
	["Gavin's Naze"] = "가빈 절벽",
	["Geezle's Camp"] = "기즐의 야영지",
	["Gelkis Village"] = "겔키스 마을",
	["General Goods"] = "일용품점",
	["General's Terrace"] = "장군의 정원",
	["Ghostblade Post"] = "유령칼날 초소",
	Ghostlands = "유령의 땅",
	["Ghost Walker Post"] = "침묵의 초소",
	["Giant's Run"] = "거인의 터",
	["Giants' Run"] = "거인의 터",
	["Gilded Fan"] = "금빛 선상지",
	["Gillijim's Isle"] = "길리짐의 섬",
	["Gilnean Coast"] = "길니아스 해안",
	["Gilnean Stronghold"] = "길니아스 요새",
	Gilneas = "길니아스",
	Gilneas2 = "길니아스2",
	["Gilneas City"] = "길니아스 시",
	["Gilneas (Do Not Reuse)"] = "길니아스",
	["Gilneas Liberation Front Base Camp"] = "길니아스 해방전선 기지",
	GilneasPhase1 = "길니아스1단계",
	GilneasPhase2 = "길니아스2단계",
	["Gimorak's Den"] = "기모라크의 동굴",
	Gjalerbron = "샬레르브론",
	Gjalerhorn = "샬레르호른",
	["Glacial Falls"] = "빙하 폭포",
	["Glimmer Bay"] = "깜박임 만",
	["Glimmerdeep Gorge"] = "흐린심연 골짜기",
	["Glittering Strand"] = "반짝이는 해안",
	["Glopgut's Hollow"] = "출렁배 동굴",
	["Glorious Goods"] = "영광의 일용품점",
	Glory = "영광의 땅",
	["GM Island"] = "GM의 안식처",
	["Gnarlpine Hold"] = "나무옹이 요새",
	["Gnaws' Boneyard"] = "질겅이의 뼈무덤",
	Gnomeregan = "놈리건",
	["Gobline Mine"] = "고블린 광산",
	["Goblin Foundry"] = "고블린 주물 공장",
	["Goblin Mine"] = "고블린 광산",
	["Goblin Slums"] = "고블린 뒷골목",
	["Gokk'lok's Grotto"] = "고크로크의 동굴",
	["Gokk'lok Shallows"] = "고크로크 여울",
	["Golakka Hot Springs"] = "골락카 간헐천",
	["Gol'Bolar Quarry"] = "골볼라 채석장",
	["Gol'Bolar Quarry Mine"] = "골볼라 채석장",
	["Gold Coast Quarry"] = "황금해안 채석장",
	["Goldenbough Pass"] = "황금가지 고개",
	["Goldenmist Village"] = "황금안개 마을",
	["Golden Strand"] = "황금 해안",
	["Gold Mine"] = "금광",
	["Gold Road"] = "황금길",
	["Gold Rush BG"] = "황금 쟁탈전 전장",
	Goldshire = "황금골",
	["Goldtooth's Den"] = "황금니 소굴",
	["Goodgrub Smoking Pit"] = "굿그럽 연기 구덩이",
	["Gordok's Seat"] = "고르독의 권좌",
	["Gordunni Outpost"] = "골두니 전초기지",
	["Gorefiend's Vigil"] = "고어핀드의 경비초소",
	["Gor'gaz Outpost"] = "고르가즈 전초기지",
	Gornia = "고르니아",
	["Gorrok's Lament"] = "고로크의 슬픈 바다",
	["Gorshak War Camp"] = "고르샤크 전쟁 기지",
	["Go'Shek Farm"] = "고셰크 농장",
	["Grain Cellar"] = "곡물 지하 저장고",
	["Grand Courtyard"] = "대광장",
	["Grand Magister's Asylum"] = "대마법학자의 피신처",
	["Grand Overlook"] = "광풍로",
	["Grand Promenade"] = "대정원",
	["Grangol'var Village"] = "그란골바르 마을",
	["Granite Springs"] = "화강암 웅덩이",
	["Grassy Cline"] = "잔디 언덕",
	["Greatwood Vale"] = "큰소나무 계곡",
	["Greengill Coast"] = "초록아가미 해안",
	["Greenpaw Village"] = "푸른발 마을",
	["Greenstone Dojo"] = "녹옥 도장",
	["Greenstone Inn"] = "녹옥 여관",
	["Greenstone Masons' Quarter"] = "녹옥 석공의 집",
	["Greenstone Quarry"] = "녹옥 채석장",
	["Greenstone Village"] = "녹옥 마을",
	["Greenwarden's Grove"] = "신록수호자의 숲",
	["Greymane Court"] = "그레이메인 궁정",
	["Greymane Manor"] = "그레이메인 장원",
	["Greymist Firth"] = "회색안개 만",
	["Grim Batol"] = "그림 바톨",
	["Grim Batol Entrance"] = "그림 바톨 입구",
	["Grimesilt Dig Site"] = "검댕가루 작업현장",
	["Grimtotem Compound"] = "그림토템 주둔지",
	["Grimtotem Post"] = "그림토템 초소",
	Grishnath = "그리쉬나스",
	Grizzlemaw = "회색구렁 요새",
	["Grizzlepaw Ridge"] = "곰발바닥 마루",
	["Grizzly Hills"] = "회색 구릉지",
	["Grol'dom Farm"] = "그롤돔 농장",
	["Grolluk's Grave"] = "그롤루크의 무덤",
	["Grom'arsh Crash-Site"] = "그롬아쉬 추락 지점",
	["Grom'gol"] = "그롬골",
	["Grom'gol Base Camp"] = "그롬골 주둔지",
	["Grommash Hold"] = "그롬마쉬 요새",
	["Grookin Hill"] = "그루끼끼 언덕",
	["Grosh'gok Compound"] = "그로쉬고크 주둔지",
	["Grove of Aessina"] = "아에시나의 숲",
	["Grove of Falling Blossoms"] = "떨어지는 꽃의 숲",
	["Grove of the Ancients"] = "고대정령의 숲",
	["Growless Cave"] = "침묵의 동굴",
	["Gruul's Lair"] = "그룰의 둥지",
	["Gryphon Roost"] = "그리핀 횃대",
	["Guardian's Library"] = "수호자의 도서관",
	Gundrak = "군드락",
	["Gundrak Entrance"] = "군드락 입구",
	["Gunstan's Dig"] = "건스탠의 발굴현장",
	["Gunstan's Post"] = "건스탠의 야영지",
	["Gunther's Retreat"] = "군터의 은거지",
	["Guo-Lai Halls"] = "구오라이 전당",
	["Guo-Lai Ritual Chamber"] = "구오라이 의식의 방",
	["Guo-Lai Vault"] = "구오라이 금고",
	["Gurboggle's Ledge"] = "거보글 절벽",
	["Gurubashi Arena"] = "구루바시 투기장",
	["Gyro-Plank Bridge"] = "자이로 교각",
	["Haal'eshi Gorge"] = "하알에쉬 협곡",
	["Hadronox's Lair"] = "하드로녹스의 둥지",
	["Hailwood Marsh"] = "싸락눈숲 수렁",
	Halaa = "할라아",
	["Halaani Basin"] = "할라아니 분지",
	["Halcyon Egress"] = "평온의 출구",
	["Haldarr Encampment"] = "할다르 야영지",
	Halfhill = "언덕골",
	Halgrind = "할그린드",
	["Hall of Arms"] = "전투의 전당",
	["Hall of Binding"] = "속박의 전당",
	["Hall of Blackhand"] = "검은손 전당",
	["Hall of Blades"] = "칼날의 전당",
	["Hall of Bones"] = "뼈의 전당",
	["Hall of Champions"] = "용사의 전당",
	["Hall of Command"] = "지휘의 광장",
	["Hall of Crafting"] = "장인의 전당",
	["Hall of Departure"] = "출사의 전당",
	["Hall of Explorers"] = "탐험가의 전당",
	["Hall of Faces"] = "얼굴의 전당",
	["Hall of Horrors"] = "공포의 전당",
	["Hall of Illusions"] = "환영의 전당",
	["Hall of Kings"] = "왕의 전당",
	["Hall of Legends"] = "전설의 전당",
	["Hall of Masks"] = "가면의 전당",
	["Hall of Memories"] = "기억의 전당",
	["Hall of Mysteries"] = "신비의 전당",
	["Hall of Repose"] = "영면의 전당",
	["Hall of Return"] = "귀환의 전당",
	["Hall of Ritual"] = "의식의 전당",
	["Hall of Secrets"] = "비밀의 전당",
	["Hall of Serpents"] = "뱀의 전당",
	["Hall of Shapers"] = "구체자의 전당",
	["Hall of Stasis"] = "정지의 전당",
	["Hall of the Brave"] = "용사의 전당",
	["Hall of the Conquered Kings"] = "정복당한 왕들의 전당",
	["Hall of the Crafters"] = "장인의 전당",
	["Hall of the Crescent Moon"] = "초승달의 전당",
	["Hall of the Crusade"] = "십자군의 전당",
	["Hall of the Cursed"] = "저주받은 자의 전당",
	["Hall of the Damned"] = "저주받은 자의 전당",
	["Hall of the Defamed"] = "몰락한 자의 전당",
	["Hall of the Exalted"] = "고귀한 자의 전당",
	["Hall of the Fathers"] = "선조의 전당",
	["Hall of the Frostwolf"] = "서리늑대 전당",
	["Hall of the Grand Imperion"] = "위대한 통치자의 전당",
	["Hall of the High Father"] = "고대 선조의 전당",
	["Hall of the Keepers"] = "수호자의 전당",
	["Hall of the Shaper"] = "구체자의 전당",
	["Hall of the Stormpike"] = "스톰파이크 전당",
	["Hall of the Tortured"] = "고문당한 자들의 전당",
	["Hall of the Watchers"] = "감시자의 전당",
	["Hall of the Wicked"] = "사악한 자의 전당",
	["Hall of Tombs"] = "무덤의 전당",
	["Hall of Tranquility"] = "평온의 전당",
	["Hall of Tranquillity"] = "평온의 전당",
	["Hall of Twilight"] = "황혼의 전당",
	["Halls of Anguish"] = "고뇌의 전당",
	["Halls of Awakening"] = "각성의 전당",
	["Halls of Binding"] = "구속의 전당",
	["Halls of Destruction"] = "파괴의 전당",
	["Halls of Flesh-Shaping"] = "살점구체자의 전당",
	["Halls of Lightning"] = "번개의 전당",
	["Halls of Lightning Entrance"] = "번개의 전당 입구",
	["Halls of Mourning"] = "애도의 전당",
	["Halls of Origination"] = "시초의 전당",
	["Halls of Origination Entrance"] = "시초의 전당 입구",
	["Halls of Reflection"] = "투영의 전당",
	["Halls of Reflection Entrance"] = "투영의 전당 입구",
	["Halls of Silence"] = "침묵의 전당",
	["Halls of Stone"] = "돌의 전당",
	["Halls of Stone Entrance"] = "돌의 전당 입구",
	["Halls of Strife"] = "투쟁의 전당",
	["Halls of the Ancestors"] = "선조의 전당",
	["Halls of the Hereafter"] = "내세의 전당",
	["Halls of the Law"] = "법의 전당",
	["Halls of Theory"] = "이론의 전당",
	["Halycon's Lair"] = "할리콘의 둥지",
	Hammerfall = "망치 주둔지",
	["Hammertoe's Digsite"] = "해머토의 발굴현장",
	["Hammond Farmstead"] = "해몬드 농장",
	Hangar = "격납고",
	["Hardknuckle Clearing"] = "바위돌기고릴라 폐허",
	["Hardwrench Hideaway"] = "하드렌치 은신처",
	["Harkor's Camp"] = "하코르의 야영지",
	["Hatchet Hills"] = "손도끼 언덕",
	["Hatescale Burrow"] = "증오비늘 동굴",
	["Hatred's Vice"] = "증오의 소굴",
	Havenshire = "안식골",
	["Havenshire Farms"] = "안식골 농장",
	["Havenshire Lumber Mill"] = "안식골 제재소",
	["Havenshire Mine"] = "안식골 광산",
	["Havenshire Stables"] = "안식골 마구간",
	["Hayward Fishery"] = "헤이워드 양어장",
	["Headmaster's Retreat"] = "교장의 은거처",
	["Headmaster's Study"] = "교장의 연구실",
	Hearthglen = "하스글렌",
	["Heart of Destruction"] = "파괴의 심장",
	["Heart of Fear"] = "공포의 심장",
	["Heart of the Old God Scenario"] = "고대신의 심장 시나리오",
	["Heart of Zan'vess"] = "잔베스 중심부",
	["Heart's Blood Shrine"] = "혈심장 제단",
	["Heartwood Trading Post"] = "심재 교역소",
	["Heb'Drakkar"] = "헤브드라카",
	["Heb'Valok"] = "헤브발로크",
	["Hellfire Basin"] = "지옥불 분지",
	["Hellfire Citadel"] = "지옥불 성채",
	["Hellfire Citadel: Ramparts"] = "지옥불 성채: 지옥불 성루",
	["Hellfire Citadel - Ramparts Entrance"] = "지옥불 성채 - 지옥불 성루 입구",
	["Hellfire Citadel: The Blood Furnace"] = "지옥불 성채: 피의 용광로",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "지옥불 성채 - 피의 용광로 입구",
	["Hellfire Citadel: The Shattered Halls"] = "지옥불 성채: 으스러진 손의 전당",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "지옥불 성채 - 으스러진 손의 전당 입구",
	["Hellfire Peninsula"] = "지옥불 반도",
	["Hellfire Peninsula - Force Camp Beach Head"] = "교두보 거점",
	["Hellfire Peninsula - Reaver's Fall"] = "지옥절단기 함락지",
	["Hellfire Ramparts"] = "지옥불 성루",
	["Hellscream Arena"] = "헬스크림 투기장",
	["Hellscream's Camp"] = "헬스크림 감시초소",
	["Hellscream's Fist"] = "헬스크림의 철권호",
	["Hellscream's Grasp"] = "헬스크림의 손아귀",
	["Hellscream's Watch"] = "헬스크림 감시초소",
	["Helm's Bed Lake"] = "투구바닥 호수",
	["Heroes' Vigil"] = "수호영웅의 안식처",
	["Hetaera's Clutch"] = "헤타에라의 손아귀",
	["Hewn Bog"] = "벌거벗은 수렁",
	["Heyman's Hubris"] = "헤이먼의 오만함",
	["Hibernal Cavern"] = "겨울 동굴",
	["Hidden Cell"] = "숨겨진 감방",
	["Hidden Path"] = "비밀의 길",
	Highbank = "높은 둑",
	["High Bank"] = "높은 둑",
	["Highland Forest"] = "고원 숲",
	Highperch = "마루둥지",
	["High Wilderness"] = "높은벌",
	Hillsbrad = "언덕마루",
	["Hillsbrad Fields"] = "언덕마루 농장",
	["Hillsbrad Foothills"] = "언덕마루 구릉지",
	["Hiri'watha Research Station"] = "히리와타 연구 기지",
	["Hive'Ashi"] = "하이브아쉬",
	["Hive'Regal"] = "하이브레갈",
	["Hive'Zora"] = "하이브조라",
	["Hogger Hill"] = "들창코 언덕",
	["Hollowed Out Tree"] = "속을 파낸 나무",
	["Hollowstone Mine"] = "빈돌 광산",
	["Honeydew Farm"] = "꿀이슬 농장",
	["Honeydew Glade"] = "꿀이슬 숲",
	["Honeydew Village"] = "꿀이슬 마을",
	["Honor Hold"] = "명예의 요새",
	["Honor Hold Mine"] = "명예의 요새 광산",
	["Honor Point"] = "명예 거점",
	["Honor's Stand"] = "명예의 감시탑",
	["Honor's Tomb"] = "명예의 무덤",
	["Horde Base Camp"] = "호드 주둔지",
	["Horde Beach Daily Area"] = "호드 해변 일일 지역",
	["Horde Encampment"] = "호드 야영지",
	["Horde Keep"] = "호드 요새",
	["Horde Landing"] = "호드 착륙장",
	["Horde Landing Site"] = "호드 상륙지",
	["Hordemar City"] = "호드마르 도시",
	["Horde PVP Barracks"] = "호드 연합 병영",
	["Horror Clutch"] = "무서움의 손아귀",
	["Hour of Twilight"] = "황혼의 시간",
	["House of Edune"] = "에듄의 집",
	["Howling Fjord"] = "울부짖는 협만",
	["Howlingwind Cavern"] = "울부짖는 바람의 동굴",
	["Howlingwind Trail"] = "울부짖는 바람의 길",
	["Howling Ziggurat"] = "울부짖는 지구라트",
	["Hrothgar's Landing"] = "흐로스가르 상륙지",
	["Huangtze Falls"] = "황지 폭포",
	["Hull of the Foebreaker"] = "원수파괴자호 선체",
	["Humboldt Conflagration"] = "훔볼트 불자리",
	["Hunter Rise"] = "수렵의 봉우리",
	["Hunter's Hill"] = "수색대 언덕",
	["Huntress of the Sun"] = "태양의 여사냥꾼",
	["Huntsman's Cloister"] = "사냥꾼의 회랑",
	Hyjal = "하이잘",
	["Hyjal Barrow Dens"] = "하이잘 지하굴",
	["Hyjal Past"] = "과거의 하이잘",
	["Hyjal Summit"] = "하이잘 정상",
	["Iceblood Garrison"] = "얼음피 주둔지",
	["Iceblood Graveyard"] = "얼음피 무덤",
	Icecrown = "얼음왕관",
	["Icecrown Citadel"] = "얼음왕관 성채",
	["Icecrown Dungeon - Gunships"] = "얼음왕관 던전",
	["Icecrown Glacier"] = "얼음왕관 빙하",
	["Iceflow Lake"] = "얼음 호수",
	["Ice Heart Cavern"] = "얼음 심장 동굴",
	["Icemist Falls"] = "얼음안개 폭포",
	["Icemist Village"] = "얼음안개 마을",
	["Ice Thistle Hills"] = "얼음엉겅퀴 언덕",
	["Icewing Bunker"] = "얼음날개 참호",
	["Icewing Cavern"] = "얼음날개 동굴",
	["Icewing Pass"] = "얼음날개 고개",
	["Idlewind Lake"] = "산들바람 호수",
	["Igneous Depths"] = "타오르는 나락",
	["Ihgaluk Crag"] = "이갈룩 바위산",
	["Ik'vess"] = "이크베스",
	["Ikz'ka Ridge"] = "이크즈카 마루",
	["Illidari Point"] = "일리다리 거점",
	["Illidari Training Grounds"] = "일리다리 훈련장",
	["Indu'le Village"] = "인두르 마을",
	["Infiltrating the Shipyard"] = "항만 침입",
	["Inkgill Mere"] = "먹물아가미 호수",
	Inn = "여관",
	["Inner Sanctum"] = "내부 성소",
	["Inner Veil"] = "내부 장막",
	["Insidion's Perch"] = "인시디온의 둥지",
	["Invasion Point: Annihilator"] = "파멸자의 침공 거점",
	["Invasion Point: Cataclysm"] = "대재앙의 침공 거점",
	["Invasion Point: Destroyer"] = "파괴자의 침공 거점",
	["Invasion Point: Overlord"] = "대군주의 침공 거점",
	["Ironband's Compound"] = "아이언밴드 야영지",
	["Ironband's Excavation Site"] = "아이언밴드의 발굴현장",
	["Ironbeard's Tomb"] = "아이언비어드의 고분",
	["Ironclad Cove"] = "철갑 동굴",
	["Ironclad Garrison"] = "철갑 주둔지",
	["Ironclad Prison"] = "철갑 감옥",
	["Iron Concourse"] = "무쇠 대열 광장",
	["Irondeep Mine"] = "깊은무쇠 광산",
	Ironforge = "아이언포지",
	["Ironforge Airfield"] = "아이언포지 비행장",
	["Ironstone Camp"] = "강철바위 야영지",
	["Ironstone Plateau"] = "강철바위 고원",
	["Iron Summit"] = "강철 멧부리",
	["Irontree Cavern"] = "강철나무 굴",
	["Irontree Clearing"] = "강철나무 공터",
	["Irontree Woods"] = "강철나무 숲",
	["Ironwall Dam"] = "무쇠벽 둑",
	["Ironwall Rampart"] = "무쇠벽 성채",
	["Ironwing Cavern"] = "무쇠날개 동굴",
	Iskaal = "이스카알",
	["Island of Doctor Lapidis"] = "학자 라피디스의 섬",
	["Isle of Conquest"] = "정복의 섬",
	["Isle of Conquest No Man's Land"] = "정복의 섬 접근 금지",
	["Isle of Dread"] = "공포의 섬",
	["Isle of Giants"] = "괴수의 섬",
	["Isle of Quel'Danas"] = "쿠엘다나스 섬",
	["Isle of Reckoning"] = "징벌의 섬",
	["Isle of Thunder"] = "천둥의 섬",
	["Isle of Tribulations"] = "고행의 섬",
	["Iso'rath"] = "이소라스",
	["Itharius's Cave"] = "이타리우스의 동굴",
	["Ivald's Ruin"] = "이발드의 폐허",
	["Ix'lar's Domain"] = "익스라의 영지",
	["Jadefire Glen"] = "비취불꽃 숲",
	["Jadefire Run"] = "비취불꽃 비탈",
	["Jade Forest Alliance Hub Phase"] = "비취 숲 얼라이언스 중심지 위상",
	["Jade Forest Battlefield Phase"] = "비취 숲 전장 위상",
	["Jade Forest Horde Starting Area"] = "비취 숲 호드 시작 지역",
	["Jademir Lake"] = "비취비늘 호수",
	["Jade Temple Grounds"] = "옥룡사 정원",
	Jaedenar = "제데나르",
	["Jagged Reef"] = "톱니 산호초",
	["Jagged Ridge"] = "뾰족 마루",
	["Jaggedswine Farm"] = "톱니멧돼지 농장",
	["Jagged Wastes"] = "톱니 황무지",
	["Jaguero Isle"] = "자구에로 섬",
	["Jaina Dalaran Scenario"] = "제이나 달라란 시나리오",
	["Janeiro's Point"] = "자네이로 섬",
	["Jangolode Mine"] = "장고로드 광산",
	["Jaquero Isle"] = "자구에로 섬",
	["Jasperlode Mine"] = "벽옥맥 광산",
	["Jeff NE Quadrant Changed"] = "제프의 북동 사분면",
	["Jeff NW Quadrant"] = "제프의 북서 사분면",
	["Jeff SE Quadrant"] = "제프의 남동 사분면",
	["Jeff SW Quadrant"] = "제프의 남서 사분면",
	["Jerod's Landing"] = "제로드 선착장",
	["Jintha'Alor"] = "진타알로",
	["Jintha'kalar"] = "진타칼라르",
	["Jintha'kalar Passage"] = "진타칼라르 통로",
	["Jin Yang Road"] = "진 양의 길",
	Jotunheim = "요툰하임",
	K3 = "K3",
	["Kaja'mine"] = "카자 광산",
	["Kaja'mite Cave"] = "카자마이트 굴",
	["Kaja'mite Cavern"] = "카자마이트 동굴",
	["Kajaro Field"] = "카자로 경기장",
	["Kal'ai Ruins"] = "칼아이 폐허",
	Kalimdor = "칼림도어",
	Kamagua = "카마구아",
	["Karabor Sewers"] = "카라보르 하수도",
	Karazhan = "카라잔",
	["Kargathia Keep"] = "카르가시아 요새",
	["Karnum's Glade"] = "카눔의 숲",
	["Kartak's Hold"] = "카르탁의 요새",
	Kaskala = "카스칼라",
	["Kaw's Roost"] = "카우의 보금자리",
	["Kea Krak"] = "키 크락",
	["Keelen's Trustworthy Tailoring"] = "킬렌의 믿을 수 있는 재봉술 상점",
	["Keel Harbor"] = "용골 항구",
	["Keeshan's Post"] = "키샨의 전초기지",
	["Kelp'thar Forest"] = "켈프타르 숲",
	["Kel'Thuzad Chamber"] = "켈투자드의 방",
	["Kel'Thuzad's Chamber"] = "켈투자드의 방",
	["Keset Pass"] = "케세트 고개",
	["Kessel's Crossing"] = "케셀의 길목",
	Kezan = "케잔",
	Kharanos = "카라노스",
	["Khardros' Anvil"] = "카드로스의 모루",
	["Khartut's Tomb"] = "카르투트의 무덤",
	["Khaz'goroth's Seat"] = "카즈고로스의 왕좌",
	["Ki-Han Brewery"] = "키한 양조장",
	["Kili'ua's Atoll"] = "킬리우아의 산호섬",
	["Kil'sorrow Fortress"] = "킬소로우 요새",
	["King's Gate"] = "왕의 관문",
	["King's Harbor"] = "왕의 항구",
	["King's Hoard"] = "보물 저장실",
	["King's Square"] = "왕의 광장",
	["Kirin'Var Village"] = "키린바르 마을",
	Kirthaven = "영면의 안식처",
	["Klaxxi'vess"] = "클락시베스",
	["Klik'vess"] = "크릭베스",
	["Knucklethump Hole"] = "돌기주먹 굴",
	["Kodo Graveyard"] = "코도 무덤",
	["Kodo Rock"] = "코도 바위",
	["Kolkar Village"] = "콜카르 마을",
	Kolramas = "콜라마스",
	["Kor'kron Vanguard"] = "코르크론 선봉기지",
	["Kormek's Hut"] = "코르메크의 오두막",
	["Koroth's Den"] = "코로스의 동굴",
	["Korthun's End"] = "코르툰의 최후",
	["Kor'vess"] = "코르베스",
	["Kota Basecamp"] = "코타 주둔지",
	["Kota Peak"] = "코타 봉우리",
	["Krasarang Cove"] = "크라사랑 만",
	["Krasarang River"] = "크라사랑 강",
	["Krasarang Wilds"] = "크라사랑 밀림",
	["Krasari Falls"] = "크라사리 폭포",
	["Krasus' Landing"] = "크라서스 착륙장",
	["Krazzworks Attack Zeppelin"] = "크라즈작업장 공격 비행선",
	["Kril'Mandar Point"] = "크릴만다르 섬",
	["Kri'vess"] = "크리베스",
	["Krolg's Hut"] = "크롤그의 오두막",
	["Krom'gar Fortress"] = "크롬가르 요새",
	["Krom's Landing"] = "크롬의 정박지",
	["KTC Headquarters"] = "케잔 무역 회사 본사",
	["KTC Oil Platform"] = "케잔 무역 회사 굴착대",
	["Kul'galar Keep"] = "쿨갈라르 성채",
	["Kul Tiras"] = "쿨 티라스",
	["Kun-Lai Pass"] = "쿤라이 길",
	["Kun-Lai Summit"] = "쿤라이 봉우리",
	["Kunzen Cave"] = "쿤젠 동굴",
	["Kunzen Village"] = "쿤젠 마을",
	["Kurzen's Compound"] = "쿠르젠 주둔지",
	["Kypari Ik"] = "키파리 이크",
	["Kyparite Quarry"] = "키파라이트 채석장",
	["Kypari Vor"] = "키파리 보르",
	["Kypari Zar"] = "키파리 자르",
	["Kzzok Warcamp"] = "크조크 전투주둔지",
	["Lair of Skiggit"] = "꽥꽥이의 굴",
	["Lair of the Beast"] = "야수의 둥지",
	["Lair of the Chosen"] = "선택받은 자의 보금자리",
	["Lair of the Jade Witch"] = "옥의 마녀의 은신처",
	["Lair of Tortos"] = "토르토스의 바위굴",
	["Lake Al'Ameth"] = "알아메스 호수",
	["Lake Cauldros"] = "카울드로스 호수",
	["Lake Dumont"] = "듀몬트 호수",
	["Lake Edunel"] = "에듀넬 호수",
	["Lake Elrendar"] = "엘렌다르 호수",
	["Lake Elune'ara"] = "엘룬아라 호수",
	["Lake Ere'Noru"] = "에레노루 호수",
	["Lake Everstill"] = "영원고요 호수",
	["Lake Falathim"] = "팔라딤 호수",
	["Lake Indu'le"] = "인두르 호수",
	["Lake Jorune"] = "조룬 호수",
	["Lake Kel'Theril"] = "켈테릴 호수",
	["Lake Kittitata"] = "키티타타 호수",
	["Lake Kum'uya"] = "쿰우야 호수",
	["Lake Mennar"] = "멘나르 호수",
	["Lake Mereldar"] = "메렐다르 호수",
	["Lake Nazferiti"] = "나즈페리티 호수",
	["Lake of Stars"] = "별의 호수",
	["Lakeridge Highway"] = "호수마루 오솔길",
	Lakeshire = "호숫골",
	["Lakeshire Inn"] = "호숫골 여관",
	["Lakeshire Town Hall"] = "호숫골 마을회관",
	["Lakeside Landing"] = "호반의 착륙장",
	["Lake Sunspring"] = "태양여울 호수",
	["Lakkari Tar Pits"] = "락카리 잿구덩이",
	["Landing Beach"] = "해안 선착장",
	["Landing Site"] = "착륙지",
	["Land's End Beach"] = "끝자락 해안",
	["Langrom's Leather & Links"] = "랭롬의 가죽 및 사슬 방어구 상점",
	["Lao & Son's Yakwash"] = "라오 부자의 야크 세척장",
	["Largo's Overlook"] = "라르고 전망대",
	["Largo's Overlook Tower"] = "라르고 전망대 탑",
	["Lariss Pavilion"] = "라리스 정자",
	["Laughing Skull Courtyard"] = "웃는 해골 광장",
	["Laughing Skull Ruins"] = "웃는 해골 폐허",
	["Launch Bay"] = "출격실",
	["Legash Encampment"] = "레가쉬 야영지",
	["Legendary Leathers"] = "전설의 가죽방어구",
	["Legion Hold"] = "불타는 군단 요새",
	["Legion's Fate"] = "군단의 운명",
	["Legion's Rest"] = "군단의 안식처",
	["Lethlor Ravine"] = "레슬로 협곡",
	["Level Design Land - Dev Only"] = "레벨 디자인의 땅 - 개발용",
	["Leyara's Sorrow"] = "레이아라의 슬픔",
	["L'ghorek"] = "고레크",
	["Liang's Retreat"] = "리앙의 은거지",
	["Library Wing"] = "서재",
	Lighthouse = "등대",
	["Lightning Ascent"] = "승천로",
	["Lightning Forge - Mogu Island Progression Scenario"] = "천둥 제련소 - 모구 섬 진행 시나리오",
	["Lightning Ledge"] = "번개치는 절벽",
	["Lightning Promenade"] = "번개의 산책로",
	["Lightning Vein Mine"] = "번개 광맥 광산",
	["Light's Breach"] = "빛의 틈",
	["Light's Dawn Cathedral"] = "새벽빛 대성당",
	["Light's Hammer"] = "빛의 망치",
	["Light's Hope Chapel"] = "희망의 빛 예배당",
	["Light's Point"] = "빛의 거점",
	["Light's Point Tower"] = "빛의 거점탑",
	["Light's Shield Tower"] = "빛의 방패 경비탑",
	["Light's Trust"] = "믿음의 빛 거점",
	["Like Clockwork"] = "나사 풀린 태엽",
	["Lion's Landing"] = "사자의 상륙지",
	["Lion's Pride Inn"] = "사자무리 여관",
	["Livery Outpost"] = "말훈련 전초기지",
	["Livery Stables"] = "마구간",
	["Livery Stables "] = "마구간",
	["Llane's Oath"] = "레인의 서약지",
	["Loading Room"] = "선적실",
	["Loch Modan"] = "모단 호수",
	["Loch Verrall"] = "베랄 호수",
	["Loken's Bargain"] = "로켄의 거래물",
	["Lonesome Cove"] = "쓸쓸한 만",
	Longshore = "기나긴 해안",
	["Longying Outpost"] = "롱잉 전초기지",
	["Lordamere Internment Camp"] = "로다미어 포로수용소",
	["Lordamere Lake"] = "로다미어 호수",
	["Lor'danel"] = "로르다넬",
	["Lorthuna's Gate"] = "로르투나의 문",
	["Lost Caldera"] = "잃어버린 함몰지",
	["Lost City of the Tol'vir"] = "톨비르의 잃어버린 도시",
	["Lost City of the Tol'vir Entrance"] = "톨비르의 잃어버린 도시 입구",
	LostIsles = "잃어버린 섬",
	["Lost Isles Town in a Box"] = "잃어버린 섬 상자 마을",
	["Lost Isles Volcano Eruption"] = "잃어버린 섬 화산 분출",
	["Lost Peak"] = "잃어버린 봉우리",
	["Lost Point"] = "버려진 경비탑",
	["Lost Rigger Cove"] = "해적단 소굴",
	["Lothalor Woodlands"] = "로탈로르 숲",
	["Lower City"] = "고난의 거리",
	["Lower Silvermarsh"] = "은빛늪지 하류",
	["Lower Sumprushes"] = "진흙구렁 하류",
	["Lower Veil Shil'ak"] = "장막의 쉴라크",
	["Lower Wilds"] = "낮은벌",
	["Lumber Mill"] = "제재소",
	["Lushwater Oasis"] = "푸른 오아시스",
	["Lydell's Ambush"] = "리델의 매복지",
	["M.A.C. Diver"] = "M.A.C. 잠수지",
	["Maelstrom Deathwing Fight"] = "혼돈의 소용돌이 데스윙 전투지",
	["Maelstrom Zone"] = "소용돌이 지역",
	["Maestra's Post"] = "마에스트라 주둔지",
	["Maexxna's Nest"] = "맥스나의 둥지",
	["Mage Quarter"] = "마법사 지구",
	["Mage Tower"] = "마법사 탑",
	["Mag'har Grounds"] = "마그하르 영토",
	["Mag'hari Procession"] = "마그하리 행렬",
	["Mag'har Post"] = "마그하르 거점",
	["Magical Menagerie"] = "마법 동물원",
	["Magic Quarter"] = "마법 지구",
	["Magisters Gate"] = "마법학자 관문",
	["Magister's Terrace"] = "마법학자의 정원",
	["Magisters' Terrace"] = "마법학자의 정원",
	["Magisters' Terrace Entrance"] = "마법학자의 정원 입구",
	["Magmadar Cavern"] = "마그마다르 용암굴",
	["Magma Fields"] = "용암 지대",
	["Magma Springs"] = "용암 간헐천",
	["Magmaw's Fissure"] = "용암아귀의 균열",
	Magmoth = "마그모스",
	["Magnamoth Caverns"] = "마그나모스 동글",
	["Magram Territory"] = "마그람 영토",
	["Magtheridon's Lair"] = "마그테리돈의 둥지",
	["Magus Commerce Exchange"] = "마법사 교역소",
	["Main Chamber"] = "본관",
	["Main Gate"] = "정문",
	["Main Hall"] = "주전당",
	["Maker's Ascent"] = "창조주의 오르막길",
	["Maker's Overlook"] = "창조주의 전망대",
	["Maker's Overlook "] = "창조주의 전망대",
	["Makers' Overlook"] = "창조주의 전망대",
	["Maker's Perch"] = "창조주의 감시대",
	["Makers' Perch"] = "창조주의 감시대",
	["Malaka'jin"] = "말라카진",
	["Malden's Orchard"] = "말덴의 과수원",
	Maldraz = "말드라즈",
	["Malfurion's Breach"] = "말퓨리온의 돌파구",
	["Malicia's Outpost"] = "말리시아의 전초기지",
	["Malykriss: The Vile Hold"] = "말리크리스: 타락의 요새",
	["Mama's Pantry"] = "큰엄마의 식료품 저장고",
	["Mam'toth Crater"] = "맘토스 분화구",
	["Manaforge Ara"] = "아라 마나괴철로",
	["Manaforge B'naar"] = "브나르 마나괴철로",
	["Manaforge Coruu"] = "코루 마나괴철로",
	["Manaforge Duro"] = "듀로 마나괴철로",
	["Manaforge Ultris"] = "울트리스 마나괴철로",
	["Mana Tombs"] = "마나 무덤",
	["Mana-Tombs"] = "마나 무덤",
	["Mandokir's Domain"] = "만도키르의 영지",
	["Mandori Village"] = "만도리 마을",
	["Mannoroc Coven"] = "만노로크 소굴",
	["Manor Mistmantle"] = "미스트맨틀 장원",
	["Mantle Rock"] = "바람막이 바위",
	["Map Chamber"] = "발굴 지도실",
	["Mar'at"] = "말아트",
	Maraudon = "마라우돈",
	["Maraudon - Earth Song Falls Entrance"] = "마라우돈 - 대지노래 폭포 입구",
	["Maraudon - Foulspore Cavern Entrance"] = "마라우돈 - 썩은포자 동굴 입구",
	["Maraudon - The Wicked Grotto Entrance"] = "마라우돈 - 악의 동굴 입구",
	["Mardenholde Keep"] = "마르덴홀드 요새",
	Marista = "마리스타",
	["Marista's Bait & Brew"] = "마리스타의 미끼와 맥주",
	["Market Row"] = "상가",
	["Marshal's Refuge"] = "마샬의 야영지",
	["Marshal's Stand"] = "마샬의 격전지",
	["Marshlight Lake"] = "수렁등불 호수",
	["Marshtide Watch"] = "습지너울 감시초소",
	["Maruadon - The Wicked Grotto Entrance"] = "마라우돈 - 악의 동굴 입구",
	["Mason's Folly"] = "석공의 우둔함",
	["Masters' Gate"] = "지배자의 관문",
	["Master's Terrace"] = "주인의 테라스",
	["Mast Room"] = "목재 작업장",
	["Maw of Destruction"] = "파괴의 아귀",
	["Maw of Go'rath"] = "고라스의 아귀",
	["Maw of Lycanthoth"] = "라이칸토스의 턱",
	["Maw of Neltharion"] = "넬타리온의 턱",
	["Maw of Shu'ma"] = "슈마의 아귀",
	["Maw of the Void"] = "공허의 구렁텅이",
	["Mazra'Alor"] = "마즈라알로",
	Mazthoril = "마즈소릴",
	["Mazu's Overlook"] = "마쭈의 전망대",
	["Medivh's Chambers"] = "메디브의 방",
	["Menagerie Wreckage"] = "화물선 잔해",
	["Menethil Bay"] = "메네실 만",
	["Menethil Harbor"] = "메네실 항구",
	["Menethil Keep"] = "메네실 요새",
	["Merchant Square"] = "상업 지구",
	Middenvale = "무지렁이 골짜기",
	["Mid Point Station"] = "중부 거점",
	["Midrealm Post"] = "중앙 생태지구 주둔지",
	["Midwall Lift"] = "중앙벽 승강장",
	["Mightstone Quarry"] = "퇴마석 채석장",
	["Military District"] = "군사 지구",
	["Mimir's Workshop"] = "미미르의 작업장",
	Mine = "광산",
	Mines = "광산",
	["Mirage Abyss"] = "신기루 심연",
	["Mirage Flats"] = "신기루 벌판",
	["Mirage Raceway"] = "신기루 경주장",
	["Mirkfallon Lake"] = "땅거미 호수",
	["Mirkfallon Post"] = "땅거미 주둔지",
	["Mirror Lake"] = "거울 호수",
	["Mirror Lake Orchard"] = "거울 호수 과수원",
	["Mistblade Den"] = "안개칼날 동굴",
	["Mistcaller's Cave"] = "안개부름이의 동굴",
	["Mistfall Village"] = "안개내림 마을",
	["Mist's Edge"] = "안개 해안",
	["Mistvale Valley"] = "안개계곡 골짜기",
	["Mistveil Sea"] = "안개장막 바다",
	["Mistwhisper Refuge"] = "안개속삭임 야영지",
	["Misty Pine Refuge"] = "안개소나무 은거처",
	["Misty Reed Post"] = "안개갈대 주둔지",
	["Misty Reed Strand"] = "안개갈대 해안",
	["Misty Ridge"] = "안개 마루",
	["Misty Shore"] = "물안개 호숫가",
	["Misty Shores"] = "안개 어린 해안가",
	["Misty Valley"] = "안개 골짜기",
	["Miwana's Longhouse"] = "미와나의 공동주택",
	["Mizjah Ruins"] = "미즈자 폐허",
	["Moa'ki"] = "모아키 항구",
	["Moa'ki Harbor"] = "모아키 항구",
	["Moggle Point"] = "모글 야영지",
	["Mo'grosh Stronghold"] = "모그로쉬 소굴",
	["Mogu Island Daily Area"] = "모구 섬 일일 퀘스트 지역",
	["Mogu Island Events - Alliance Base"] = "모구 섬 이벤트 - 얼라이언스 기지",
	["Mogu Island Events - Horde Base"] = "모구 섬 이벤트 - 호드 기지",
	["Mogu Island Loot Room"] = "모구 섬 전리품 방",
	["Mogu Island Progression Events"] = "모구 섬 진행 이벤트",
	Mogujia = "모구지아",
	["Mogu'shan Palace"] = "모구샨 궁전",
	["Mogu'shan Terrace"] = "모구샨 난간뜰",
	["Mogu'shan Vaults"] = "모구샨 금고",
	["Mok'Doom"] = "모크둠",
	["Mok'Gordun"] = "모크골둔",
	["Mok'Nathal Village"] = "모크나탈 마을",
	["Mold Foundry"] = "거푸집 주조소",
	["Molten Core"] = "화산 심장부",
	["Molten Front"] = "녹아내린 전초지",
	Moonbrook = "달빛시내 마을",
	Moonglade = "달숲",
	["Moongraze Woods"] = "달새김 숲",
	["Moon Horror Den"] = "공포의 달빛 동굴",
	["Moonrest Gardens"] = "달쉼터 정원",
	["Moonshrine Ruins"] = "달의 제단 폐허",
	["Moonshrine Sanctum"] = "달의 제단 성소",
	["Moontouched Den"] = "달빛마루 동굴",
	["Moonwater Retreat"] = "달빛물 은거지",
	["Moonwell of Cleansing"] = "정화의 달샘",
	["Moonwell of Purity"] = "정화의 달샘",
	["Moonwing Den"] = "달날개 소굴",
	["Mord'rethar: The Death Gate"] = "모드레타르: 죽음의 관문",
	["Morgan's Plot"] = "모건의 터",
	["Morgan's Vigil"] = "모건의 망루",
	["Morlos'Aran"] = "모를로스아란",
	["Morning Breeze Lake"] = "아침 바람 호수",
	["Morning Breeze Village"] = "아침 바람 마을",
	Morrowchamber = "여명의 방",
	["Mor'shan Base Camp"] = "몰샨 주둔지",
	["Mortal's Demise"] = "필멸자의 최후",
	["Mortbreath Grotto"] = "죽음숨결 동굴",
	["Mortwake's Tower"] = "몰트웨이크의 탑",
	["Mosh'Ogg Ogre Mound"] = "모쉬오그 오우거 소굴",
	["Mosshide Fen"] = "이끼가죽 수렁",
	["Mosswalker Village"] = "이끼걸음 마을",
	["Mossy Pile"] = "이끼 더미",
	["Motherseed Pit"] = "어머니씨앗 구덩이",
	["Mountainfoot Strip Mine"] = "산기슭 노천광산",
	["Mount Akher"] = "아케르 산",
	["Mount Hyjal"] = "하이잘 산",
	["Mount Hyjal Phase 1"] = "하이잘 산 1단계",
	["Mount Neverest"] = "네베레스트 산",
	["Muckscale Grotto"] = "진흙비늘 동굴",
	["Muckscale Shallows"] = "진흙비늘 여울",
	["Mudmug's Place"] = "머드머그네 집",
	Mudsprocket = "진흙톱니 거점",
	Mulgore = "멀고어",
	["Murder Row"] = "죽음의 골목",
	["Murkdeep Cavern"] = "먹구렁 동굴",
	["Murky Bank"] = "진흙 둑",
	["Muskpaw Ranch"] = "머스크포우 목장",
	["Mystral Lake"] = "미스트랄 호수",
	Mystwood = "안개숲",
	Nagrand = "나그란드",
	["Nagrand Arena"] = "나그란드 투기장",
	Nahom = "나홈",
	["Nar'shola Terrace"] = "나르숄라 계단지",
	["Narsong Spires"] = "나르송 봉우리",
	["Narsong Trench"] = "나르송 해구",
	["Narvir's Cradle"] = "나르비르의 요람",
	["Nasam's Talon"] = "나삼의 발톱",
	["Nat's Landing"] = "내트의 정박지",
	["Naval Battle Scenario"] = "해상 전투 시나리오",
	Naxxanar = "낙사나르",
	Naxxramas = "낙스라마스",
	["Nayeli Lagoon"] = "나옐리 바다호수",
	["Naz'anak: The Forgotten Depths"] = "나즈아낙: 망각의 심연",
	["Nazj'vel"] = "나즈벨",
	Nazzivian = "나지비안",
	["Nectarbreeze Orchard"] = "감로바람 과수원",
	["Needlerock Chasm"] = "가시바위 협곡",
	["Needlerock Slag"] = "가시바위 잔여지",
	["Nefarian's Lair"] = "네파리안의 둥지",
	["Nefarian�s Lair"] = "네파리안의 둥지",
	["Neferset City"] = "네페르세트 도시",
	["Neferset City Outskirts"] = "네페르세트 도시 교외",
	["Nek'mani Wellspring"] = "네크마니 수원지",
	["Neptulon's Rise"] = "넵튤론의 오름길",
	["Nesingwary Base Camp"] = "네싱워리 주둔지",
	["Nesingwary Safari"] = "네싱워리 탐험대",
	["Nesingwary's Expedition"] = "네싱워리 원정대",
	["Nesingwary's Safari"] = "네싱워리 탐험대",
	Nespirah = "네스피라",
	["Nestlewood Hills"] = "다닥나무 언덕",
	["Nestlewood Thicket"] = "다닥나무 숲",
	["Nethander Stead"] = "네산더 농장",
	["Nethergarde Keep"] = "네더가드 요새",
	["Nethergarde Mines"] = "네더가드 광산",
	["Nethergarde Supply Camps"] = "네더가드 보급 기지",
	Netherspace = "황천의 영역",
	Netherstone = "황천의 돌무지",
	Netherstorm = "황천의 폭풍",
	["Netherweb Ridge"] = "황천그물 마루",
	["Netherwing Fields"] = "황천날개 벌판",
	["Netherwing Ledge"] = "황천날개 마루",
	["Netherwing Mines"] = "황천날개 광산",
	["Netherwing Pass"] = "황천날개 고개",
	["Neverest Basecamp"] = "네베레스트 탐험기지",
	["Neverest Pinnacle"] = "네베레스트 봉우리",
	["New Agamand"] = "신 아가만드",
	["New Agamand Inn"] = "신 아가만드 여관",
	["New Avalon"] = "신 아발론",
	["New Avalon Fields"] = "신 아발론 농장",
	["New Avalon Forge"] = "신 아발론 대장간",
	["New Avalon Orchard"] = "신 아발론 과수원",
	["New Avalon Town Hall"] = "신 아발론 마을회관",
	["New Cifera"] = "신 사이페라",
	["New Hearthglen"] = "신 하스글렌",
	["New Kargath"] = "신 카르가스",
	["New Thalanaar"] = "신 탈라나르",
	["New Tinkertown"] = "신 땜장이 마을",
	["Nexus Legendary"] = "마력의 탑 전설",
	Nidavelir = "니다벨리르",
	["Nidvar Stair"] = "니드바르 계단",
	Nifflevar = "니플바르",
	["Night Elf Village"] = "나이트 엘프 마을",
	Nighthaven = "밤의 안식처",
	["Nightingale Lounge"] = "꾀꼬리 휴게실",
	["Nightmare Depths"] = "악몽의 나락",
	["Nightmare Scar"] = "악몽의 흉터",
	["Nightmare Vale"] = "악몽의 골짜기",
	["Night Run"] = "어둠의 터",
	["Nightsong Woods"] = "별빛노래 숲",
	["Night Web's Hollow"] = "검은그물 거미굴",
	["Nijel's Point"] = "나이젤의 야영지",
	["Nimbus Rise"] = "빛구름 마루",
	Nine = "나인",
	["Niuzao Catacombs"] = "니우짜오 지하묘지",
	["Niuzao Temple"] = "니우짜오 사원",
	["Njord's Breath Bay"] = "요르드의 숨결 만",
	["Njorndar Village"] = "요른다르 마을",
	["Njorn Stair"] = "요른 계단",
	["Nook of Konk"] = "콩크의 동굴",
	["Noonshade Ruins"] = "해그늘 폐허",
	Nordrassil = "놀드랏실",
	["Nordrassil Inn"] = "놀드랏실 여관",
	["Nordune Ridge"] = "노르둔 마루",
	["North Common Hall"] = "북쪽 대전당",
	Northdale = "노스데일",
	["Northern Barrens"] = "북부 불모의 땅",
	["Northern Elwynn Mountains"] = "엘윈 산 북부",
	["Northern Headlands"] = "북부 마루터기",
	["Northern Rampart"] = "북쪽 성루",
	["Northern Rocketway"] = "북부 로켓길",
	["Northern Rocketway Exchange"] = "북부 로켓길 교역소",
	["Northern Stranglethorn"] = "북부 가시덤불",
	["Northfold Manor"] = "북부습곡 장원",
	["Northgate Breach"] = "북문 틈",
	["North Gate Outpost"] = "북부 관문 전초기지",
	["North Gate Pass"] = "북부 관문 통행로",
	["Northgate River"] = "북문 강",
	["Northgate Woods"] = "북문 숲",
	["Northmaul Tower"] = "북녘망치 탑",
	["Northpass Tower"] = "북부관문 경비탑",
	["North Point Station"] = "북부 거점",
	["North Point Tower"] = "북부 경비탑",
	Northrend = "노스렌드",
	["Northridge Lumber Camp"] = "북마루 벌목지",
	["North Sanctum"] = "북부 성소",
	Northshire = "북녘골",
	["Northshire Abbey"] = "북녘골 수도원",
	["Northshire River"] = "북녘골 강",
	["Northshire Valley"] = "북녘골 계곡",
	["Northshire Vineyards"] = "북녘골 포도밭",
	["North Spear Tower"] = "북부창 경비탑",
	["North Tide's Beachhead"] = "북부 해안 교두보",
	["North Tide's Run"] = "북부 해안가",
	["Northwatch Expedition Base Camp"] = "북부감시 원정대 기지",
	["Northwatch Expedition Base Camp Inn"] = "북부감시 원정대 기지 여관",
	["Northwatch Foothold"] = "북부감시 거점",
	["Northwatch Hold"] = "북부감시 요새",
	["Northwind Cleft"] = "북새바람 동굴",
	["North Wind Tavern"] = "북풍 주점",
	["Nozzlepot's Outpost"] = "노즐팟의 전초기지",
	["Nozzlerust Post"] = "녹주둥이 전초기지",
	["Oasis of the Fallen Prophet"] = "쓰러진 예언자의 오아시스",
	["Oasis of Vir'sar"] = "비르사르 오아시스",
	["Obelisk of the Moon"] = "달의 방첨탑",
	["Obelisk of the Stars"] = "별의 방첨탑",
	["Obelisk of the Sun"] = "해의 방첨탑",
	["O'Breen's Camp"] = "오브린의 야영지",
	["Observance Hall"] = "규율의 전당",
	["Observation Grounds"] = "관측 지구",
	["Obsidian Breakers"] = "흑요석 파괴자",
	["Obsidian Dragonshrine"] = "흑요석 용제단",
	["Obsidian Forest"] = "흑요석 숲",
	["Obsidian Lair"] = "흑요석 둥지",
	["Obsidia's Perch"] = "옵시디아의 둥지",
	["Odesyus' Landing"] = "오디시우스의 정박지",
	["Ogri'la"] = "오그릴라",
	["Ogri'La"] = "오그릴라",
	["Old Hillsbrad Foothills"] = "옛 언덕마루 구릉지",
	["Old Ironforge"] = "구 아이언포지",
	["Old Town"] = "구 시가지",
	Olembas = "올렘바스",
	["Olivia's Pond"] = "올리비아의 연못",
	["Olsen's Farthing"] = "올슨 농장",
	Oneiros = "오네이로스",
	["One Keg"] = "맥주통 휴게소",
	["One More Glass"] = "한 잔 더 상점",
	["Onslaught Base Camp"] = "붉은돌격대 주둔지",
	["Onslaught Harbor"] = "붉은돌격대 항구",
	["Onyxia's Lair"] = "오닉시아의 둥지",
	["Oomlot Village"] = "움로트 마을",
	["Oona Kagu"] = "우나 카구",
	Oostan = "우스탄",
	["Oostan Nord"] = "우스탄 놀드",
	["Oostan Ost"] = "우스탄 오스트",
	["Oostan Sor"] = "우스탄 소르",
	["Opening of the Dark Portal"] = "어둠의 문 열기",
	["Opening of the Dark Portal Entrance"] = "어둠의 문 열기 입구",
	["Oratorium of the Voice"] = "목소리의 경당",
	["Oratory of the Damned"] = "저주받은 자들의 기도실",
	["Orchid Hollow"] = "붓꽃 벌판",
	["Orebor Harborage"] = "오레보르 피난처",
	["Oregrind's Dig"] = "오어그라인드의 채굴지",
	["Orendil's Retreat"] = "오렌딜 수행지",
	Orgrimmar = "오그리마",
	["Orgrimmar Gunship Pandaria Start"] = "오그리마 비행포격선 판다리아 시작",
	["Orgrimmar Rear Gate"] = "오그리마 뒷문",
	["Orgrimmar Rocketway Exchange"] = "오그리마 로켓길 교역소",
	["Orgrim's Hammer"] = "오그림의 망치호",
	["Oronok's Farm"] = "오로노크의 농장",
	Orsis = "오르시스",
	["Ortell's Hideout"] = "오르텔의 은신처",
	["Oshu'gun"] = "오슈군",
	["Outdoor Ruins"] = "야외 폐허",
	Outland = "아웃랜드",
	["Overgrown Camp"] = "우거진 야영지",
	["Overgrown Statuary"] = "무성한 전장",
	["Owen's Wishing Well"] = "오웬의 소원성취 우물",
	["Owl Wing Thicket"] = "올빼미날개 숲",
	["Palace Antechamber"] = "궁전 대기실",
	["Pal'ea"] = "팔에아",
	["Palemane Rock"] = "회색갈기 바위굴",
	["Pandaren Mine"] = "판다렌 광산",
	Pandaria = "판다리아",
	["Pang's Stead"] = "팡의 처소",
	["Panic Clutch"] = "공황의 손아귀",
	["Paoquan Hollow"] = "파오취앤 대나무숲",
	["Parhelion Plaza"] = "무리해 광장",
	["Passage of Lost Fiends"] = "잃어버린 악마의 통로",
	["Path of a Hundred Steps"] = "백 걸음의 길",
	["Path of Conquerors"] = "정복자의 길",
	["Path of Enlightenment"] = "깨달음의 길",
	["Path of Serenity"] = "평온의 길",
	["Path of the Titans"] = "티탄의 길",
	["Path of Uther"] = "우서의 길",
	["Pattymack Land"] = "패티맥의 땅",
	["Pauper's Walk"] = "빈민가",
	["Paur's Pub"] = "파우어의 선술집",
	["Paw'don Glade"] = "포우돈 숲",
	["Paw'don Village"] = "포우돈 마을",
	["Paw'Don Village"] = "포우돈 마을", -- Needs review
	["Peak of Serenity"] = "평온의 봉우리",
	["Pearlfin Village"] = "진주지느러미 마을",
	["Pearl Lake"] = "진주 호수",
	["Pedestal of Hope"] = "희망의 단상",
	["Pei-Wu Forest"] = "페이우 숲",
	["Pestilent Scar"] = "전염의 흉터",
	["Pet Battle - Jade Forest"] = "애완동물 대전 - 비취 숲",
	["Petitioner's Chamber"] = "왕국 민원실",
	["Pilgrim's Precipice"] = "순례자의 낭떠러지",
	["Pincer X2"] = "쌍집게발호",
	["Pinnacle of Storms"] = "폭풍의 첨탑",
	["Pit of Fangs"] = "송곳니 구덩이",
	["Pit of Saron"] = "사론의 구덩이",
	["Pit of Saron Entrance"] = "사론의 구덩이 입구",
	["Plaguelands: The Scarlet Enclave"] = "동부 역병지대: 붉은십자군 초소",
	["Plaguemist Ravine"] = "역병안개 협곡",
	Plaguewood = "역병숲",
	["Plaguewood Tower"] = "역병숲 경비탑",
	["Plain of Echoes"] = "메아리 평원",
	["Plain of Shards"] = "수정 들판",
	["Plain of Thieves"] = "도둑의 평원",
	["Plains of Nasam"] = "나삼의 평원",
	["Pod Cluster"] = "탈출선 착륙지",
	["Pod Wreckage"] = "탈출선 잔해",
	["Poison Falls"] = "맹독 폭포",
	["Pool of Reflection"] = "투영의 웅덩이",
	["Pool of Tears"] = "눈물의 연못",
	["Pool of the Paw"] = "발바닥 웅덩이",
	["Pool of Twisted Reflections"] = "뒤틀린 환영의 웅덩이",
	["Pools of Aggonar"] = "아고나르의 웅덩이",
	["Pools of Arlithrien"] = "아리스리엔 연못",
	["Pools of Jin'Alai"] = "진알라이의 웅덩이",
	["Pools of Purity"] = "순수의 웅덩이",
	["Pools of Youth"] = "젊음의 웅덩이",
	["Pools of Zha'Jin"] = "자진의 웅덩이",
	["Portal Clearing"] = "차원문 폐허",
	["Pranksters' Hollow"] = "장난꾸러기의 동굴",
	["Predator's Perch"] = "약탈자의 주둔지",
	["Prison of Immol'thar"] = "이몰타르의 감옥",
	["Programmer Isle"] = "프로그래머의 섬",
	["Promontory Point"] = "낭떠러지 거점",
	["Prospector's Point"] = "발굴단 거점",
	["Protectorate Watch Post"] = "자유연합 경비초소",
	["Proving Grounds"] = "수련의 장",
	["Purespring Cavern"] = "맑은샘 동굴",
	["Purgation Isle"] = "속죄의 섬",
	["Pursuing the Black Harvest"] = "암흑의 수확을 쫓아서",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "공포와 재미가 넘치는 퓨트리사이드의 연금술 실험실",
	["Pyrewood Chapel"] = "장작나무 예배당",
	["Pyrewood Inn"] = "장작나무 여관",
	["Pyrewood Town Hall"] = "장작나무 마을회관",
	["Pyrewood Village"] = "장작나무 마을",
	["Pyrox Flats"] = "휘석 평원",
	["QA and DVD"] = "QA 및 DVD",
	["Quagg Ridge"] = "쿠아그 마루",
	Quarry = "채석장",
	["Quartzite Basin"] = "규암 분지",
	["Queen's Gate"] = "여왕의 관문",
	["Quel'Danil Lodge"] = "쿠엘다닐 오두막",
	["Quel'Delar's Rest"] = "쿠엘델라의 쉼터",
	["Quel'Dormir Gardens"] = "쿠엘도르미르 정원",
	["Quel'Dormir Temple"] = "쿠엘도르미르 사원",
	["Quel'Dormir Terrace"] = "쿠엘도르미르 단상",
	["Quel'Lithien Lodge"] = "쿠엘리시엔 오두막",
	["Quel'thalas"] = "쿠엘탈라스",
	["Quickchop's Lumber Farm"] = "퀵촙의 목재소",
	["Raastok Glade"] = "라스토크 숲",
	["Raceway Ruins"] = "경주장 폐허",
	["Rageclaw Den"] = "성난발톱 소굴",
	["Rageclaw Lake"] = "성난발톱 호수",
	["Rage Fang Shrine"] = "분노의 송곳니 제단",
	["Ragefeather Ridge"] = "성난깃털 마루",
	["Ragefire Caverns"] = "성난불길 동굴",
	["Ragefire Chasm"] = "성난불길 협곡",
	["Ragefire Core"] = "성난불길 심장부",
	["Rage Scar Hold"] = "무쇠설인 소굴",
	["Ragnaros' Lair"] = "라그나로스의 둥지",
	["Ragnaros' Reach"] = "라그나로스의 세력지",
	["Rainspeaker Canopy"] = "구름몰이 거처",
	["Rainspeaker Rapids"] = "구름몰이 여울목",
	Ramkahen = "람카헨",
	["Ramkahen Legion Outpost"] = "람카헨 군단 전초기지",
	["Rampart of Skulls"] = "해골 망루",
	["Ranazjar Isle"] = "라나즈자르 섬",
	["Raptor Pens"] = "랩터 우리",
	["Raptor Ridge"] = "랩터 마루",
	["Raptor Rise"] = "랩터 마루",
	Ratchet = "톱니항",
	["Rated Eye of the Storm"] = "평점제 폭풍의 눈",
	["Ravaged Caravan"] = "습격당한 짐마차 행렬",
	["Ravaged Crypt"] = "파괴된 납골당",
	["Ravaged Twilight Camp"] = "파괴된 황혼의 야영지",
	["Ravencrest Monument"] = "레이븐크레스트 기념비",
	["Raven Hill"] = "까마귀 언덕",
	["Raven Hill Cemetery"] = "까마귀 언덕 묘지",
	["Ravenholdt Manor"] = "라벤홀트 장원",
	["Raven's Watch"] = "까마귀 망루",
	["Raven's Wood"] = "까마귀 숲",
	["Raynewood Retreat"] = "레인나무 은신처",
	["Raynewood Tower"] = "레인나무 탑",
	["Razaan's Landing"] = "라잔의 영지",
	["Razorfen Downs"] = "가시덩굴 구릉",
	["Razorfen Downs Entrance"] = "가시덩굴 구릉 입구",
	["Razorfen Kraul"] = "가시덩굴 우리",
	["Razorfen Kraul Entrance"] = "가시덩굴 우리 입구",
	["Razor Hill"] = "칼바위 언덕",
	["Razor Hill Barracks"] = "칼바위 언덕 병영",
	["Razor Hill Outskirts"] = "칼바위 언덕 교외",
	["Razor Hill Watchtower"] = "칼바위 언덕 감시탑",
	["Razormane Grounds"] = "서슬갈기 영토",
	["Razor Ridge"] = "칼날 마루",
	["Razorscale's Aerie"] = "칼날비늘의 둥지",
	["Razorthorn Rise"] = "서슬가시 언덕",
	["Razorthorn Shelf"] = "서슬가시 벼랑",
	["Razorthorn Trail"] = "서슬가시 고개",
	["Razorwind Canyon"] = "칼끝바람 협곡",
	["Rear Staging Area"] = "후방 집결지",
	["Reaver's Fall"] = "지옥절단기 함락지",
	["Reavers' Hall"] = "파괴자의 전당",
	["Rebel Camp"] = "반란군 야영지",
	["Red Cloud Mesa"] = "붉은구름 고원",
	["Redpine Dell"] = "붉은소나무 골짜기",
	["Redridge - Bridge Phase One"] = "붉은마루 산맥 - 다리 1 단계",
	["Redridge - Bridge Phase Two"] = "붉은마루 산맥 - 다리 2 단계",
	["Redridge Canyons"] = "붉은마루 협곡",
	["Redridge Mountains"] = "붉은마루 산맥",
	["Redridge - Orc Bomb"] = "붉은마루 산맥 - 오크 폭탄",
	["Red Rocks"] = "붉은 바위 언덕",
	["Redwood Trading Post"] = "붉은나무 교역소",
	Refinery = "정제소",
	["Refugee Caravan"] = "피난민 행렬",
	["Refuge Pointe"] = "임시 주둔지",
	["Refuse Disposal"] = "성채 하수도",
	["Reliquary of Agony"] = "고뇌의 성물함",
	["Reliquary of Pain"] = "고통의 성물함",
	["Remains of Iris Lake"] = "아이리스 호수의 흔적",
	["Remains of the Fleet"] = "함대의 잔해",
	["Remtravel's Excavation"] = "렘트래블의 발굴현장",
	["Render's Camp"] = "약탈의 야영지",
	["Render's Crater"] = "약탈의 분화구",
	["Render's Rock"] = "약탈의 바위굴",
	["Render's Valley"] = "약탈의 계곡",
	["Rensai's Watchpost"] = "런싸이의 감시초소",
	["Rethban Caverns"] = "레스밴 동굴",
	["Rethress Sanctum"] = "레스리스 성소",
	Reuse = "재사용",
	["Reuse Me 7"] = "재사용",
	["Revantusk Village"] = "깨진엄니 마을",
	["Rhea's Camp"] = "레아의 야영지",
	["Rhonin's Beard"] = "로닌의 수염호",
	["Rhyolith Plateau"] = "라이올리스 고원",
	["Ricket's Folly"] = "리켓의 로켓 썰매",
	["Ridge of Laughing Winds"] = "웃는 바람의 마루",
	["Ridge of Madness"] = "광기의 마루",
	["Ridgepoint Tower"] = "마루목 감시탑",
	Rikkilea = "리키리아",
	["Rikkitun Village"] = "리키툰 마을",
	["Rim of the World"] = "세상의 테두리",
	["Ring of Judgement"] = "심판의 투기장",
	["Ring of Observance"] = "규율의 광장",
	["Ring of the Elements"] = "정령의 너른땅",
	["Ring of the Law"] = "법의 심판장",
	["Riplash Ruins"] = "채찍파도 폐허",
	["Riplash Strand"] = "채찍파도 해안",
	["Rise of Suffering"] = "고통의 언덕",
	["Rise of the Defiler"] = "파멸자의 봉우리",
	["Ritual Chamber of Akali"] = "아칼리의 의식의 방",
	["Rivendark's Perch"] = "리븐다크의 둥지",
	Rivenwood = "비틀린 숲",
	["River's Heart"] = "강의 심장부",
	["Rock of Durotan"] = "듀로탄 바위",
	["Rockpool Village"] = "바위웅덩이 마을",
	["Rocktusk Farm"] = "바위엄니 농장",
	["Roguefeather Den"] = "하피 동굴",
	["Rogues' Quarter"] = "도적 지구",
	["Rohemdal Pass"] = "로헴달 고개",
	["Roland's Doom"] = "롤랜드 광산",
	["Room of Hidden Secrets"] = "숨겨진 비밀의 방",
	["Roost of Ji-Kun"] = "지쿤의 보금자리",
	["Rotbrain Encampment"] = "썩은뇌수 야영지",
	["Royal Amphitheater"] = "왕실 투기장",
	["Royal Approach"] = "왕실 진입로",
	["Royal Exchange Auction House"] = "왕궁 교역소 경매장",
	["Royal Exchange Bank"] = "왕궁 교역소 은행",
	["Royal Gallery"] = "왕실 회랑",
	["Royal Library"] = "왕실 도서관",
	["Royal Quarter"] = "왕실",
	["Ruby Dragonshrine"] = "루비 용제단",
	["Ruined Approach"] = "무너진 진입로",
	["Ruined City Post 01"] = "줄드락 폐허",
	["Ruined Court"] = "버려진 궁정",
	["Ruins of Aboraz"] = "아보라즈의 폐허",
	["Ruins of Ahmtul"] = "암툴 폐허",
	["Ruins of Ahn'Qiraj"] = "안퀴라즈 폐허",
	["Ruins of Alterac"] = "알터랙 폐허",
	["Ruins of Ammon"] = "암몬 폐허",
	["Ruins of Arkkoran"] = "아크코란의 폐허",
	["Ruins of Auberdine"] = "아우버다인 폐허",
	["Ruins of Baa'ri"] = "바아리 폐허",
	["Ruins of Constellas"] = "콘스텔라스 폐허",
	["Ruins of Dojan"] = "도잔의 폐허",
	["Ruins of Drakgor"] = "드락고르 폐허",
	["Ruins of Drak'Zin"] = "드락진 폐허",
	["Ruins of Eldarath"] = "엘다라스 폐허",
	["Ruins of Eldarath "] = "엘다라스 폐허",
	["Ruins of Eldra'nath"] = "엘드라나스 폐허",
	["Ruins of Eldre'thar"] = "엘드레타르 폐허",
	["Ruins of Enkaat"] = "엔카트 폐허",
	["Ruins of Farahlon"] = "파랄론 폐허",
	["Ruins of Feathermoon"] = "페더문 폐허",
	["Ruins of Gilneas"] = "길니아스 폐허",
	["Ruins of Gilneas City"] = "길니아스 시 폐허",
	["Ruins of Guo-Lai"] = "구오라이 폐허",
	["Ruins of Isildien"] = "이실디엔 폐허",
	["Ruins of Jubuwal"] = "주부왈의 폐허",
	["Ruins of Karabor"] = "카라보르 폐허",
	["Ruins of Kargath"] = "카르가스 폐허",
	["Ruins of Khintaset"] = "킨타세트 폐허",
	["Ruins of Korja"] = "코르자의 폐허",
	["Ruins of Korune"] = "코룬의 폐허",
	["Ruins of Lar'donir"] = "라르도니르 폐허",
	["Ruins of Lordaeron"] = "로데론의 폐허",
	["Ruins of Loreth'Aran"] = "로레스아란 폐허",
	["Ruins of Lornesta"] = "로른스타의 폐허",
	["Ruins of Mathystra"] = "마시스트라 폐허",
	["Ruins of Nordressa"] = "놀드렛사의 폐허",
	["Ruins of Ogudei"] = "오구데이 폐허",
	["Ruins of Ravenwind"] = "까마귀바람 폐허",
	["Ruins of Sha'naar"] = "샤나르 폐허",
	["Ruins of Shandaral"] = "샨다랄 폐허",
	["Ruins of Silvermoon"] = "실버문 폐허",
	["Ruins of Solarsal"] = "솔라살 폐허",
	["Ruins of Southshore"] = "남녘해안 폐허",
	["Ruins of Taurajo"] = "타우라조 폐허",
	["Ruins of Tethys"] = "테시스의 폐허",
	["Ruins of Thaurissan"] = "타우릿산의 폐허",
	["Ruins of Thelserai Temple"] = "텔세라이 사원 폐허",
	["Ruins of Theramore"] = "테라모어의 폐허",
	["Ruins of the Scarlet Enclave"] = "붉은십자군 폐허",
	["Ruins of Uldum"] = "울둠 폐허",
	["Ruins of Vashj'elan"] = "바쉬엘란 폐허",
	["Ruins of Vashj'ir"] = "바쉬르 폐허",
	["Ruins of Zul'Kunda"] = "줄쿤다의 폐허",
	["Ruins of Zul'Mamwe"] = "줄맘웨의 폐허",
	["Ruins Rise"] = "폐허 마루",
	["Rumbling Terrace"] = "우르릉 초원",
	["Runestone Falithas"] = "팔리타스 마법석",
	["Runestone Shan'dor"] = "샨도르 마법석",
	["Runeweaver Square"] = "룬위버 광장",
	["Rustberg Village"] = "녹슨산림 마을",
	["Rustmaul Dive Site"] = "녹슨망치 잠수지",
	["Rutsak's Guard"] = "루트삭의 경비소",
	["Rut'theran Village"] = "루테란 마을",
	["Ruuan Weald"] = "루안 숲",
	["Ruuna's Camp"] = "루나의 야영지",
	["Ruuzel's Isle"] = "루젤의 섬",
	["Rygna's Lair"] = "라이그나의 둥지",
	["Sable Ridge"] = "검은담비 마루",
	["Sacrificial Altar"] = "희생의 제단",
	["Sahket Wastes"] = "사케트 황무지",
	Salabria = "살라브리아호",
	["Saldean's Farm"] = "살딘 농장",
	["Saltheril's Haven"] = "살데릴의 안식처",
	["Saltspray Glen"] = "소금물 습지대",
	["Sanctuary of Malorne"] = "말로른의 성역",
	["Sanctuary of Shadows"] = "어둠의 성역",
	["Sanctum of Reanimation"] = "부활의 성소",
	["Sanctum of Shadows"] = "어둠의 성소",
	["Sanctum of the Ascended"] = "승천자의 성소",
	["Sanctum of the Fallen God"] = "죽은 신의 성소",
	["Sanctum of the Moon"] = "달의 성소",
	["Sanctum of the Prophets"] = "예언자의 성소",
	["Sanctum of the South Wind"] = "남풍의 성소",
	["Sanctum of the Stars"] = "별의 성소",
	["Sanctum of the Sun"] = "태양의 성소",
	["Sands of Nasam"] = "나삼의 갯벌",
	["Sandsorrow Watch"] = "슬픈모래 감시탑",
	["Sandy Beach"] = "모래사장",
	["Sandy Shallows"] = "모래 여울",
	["Sanguine Chamber"] = "붉은 방",
	["Sapphire Hive"] = "사파이어 부화장",
	["Sapphiron's Lair"] = "서리고룡의 방",
	["Saragosa's Landing"] = "사라고사의 영지",
	Sarahland = "사라의 땅",
	["Sardor Isle"] = "살도르 섬",
	Sargeron = "살게론",
	["Sarjun Depths"] = "사르준 나락",
	["Saronite Mines"] = "사로나이트 광산",
	["Sar'theris Strand"] = "살데리스 해안",
	Satyrnaar = "사티르나르",
	["Saurok Creation Pit"] = "사우록 창조의 터",
	["Savage Ledge"] = "야만전사의 절벽",
	["Scalawag Point"] = "해적 야영지",
	["Scalding Pools"] = "끓어오르는 웅덩이",
	["Scalebeard's Cave"] = "비늘수염 동굴",
	["Scalewing Shelf"] = "비늘날개 절벽",
	["Scarab Terrace"] = "스카라베 정원",
	["Scarlet Encampment"] = "진홍빛 야영지",
	["Scarlet Halls"] = "붉은십자군 전당",
	["Scarlet Hold"] = "붉은십자군 요새",
	["Scarlet Monastery"] = "붉은십자군 수도원",
	["Scarlet Monastery Entrance"] = "붉은십자군 수도원 입구",
	["Scarlet Overlook"] = "붉은십자군 전망대",
	["Scarlet Palisade"] = "단홍빛 울타리",
	["Scarlet Point"] = "붉은돌격대 초소",
	["Scarlet Raven Tavern"] = "진홍 까마귀 선술집",
	["Scarlet Tavern"] = "붉은십자군 선술집",
	["Scarlet Tower"] = "붉은십자군 경비탑",
	["Scarlet Watch Post"] = "붉은십자군 경비초소",
	["Scarlet Watchtower"] = "진홍빛 감시탑",
	["Scar of the Worldbreaker"] = "세계파괴자의 흉터",
	["Scarred Terrace"] = "상처받은 단상",
	["Scenario: Alcaz Island"] = "각본: 알카즈 섬",
	["Scenario - Black Ox Temple"] = "시나리오 - 흑우사",
	["Scenario - Mogu Ruins"] = "시나리오 - 모구 폐허",
	["Scenic Overlook"] = "경치 좋은 전망대",
	["Schnottz's Frigate"] = "슈노츠의 구축함",
	["Schnottz's Hostel"] = "슈노츠의 쉼터",
	["Schnottz's Landing"] = "슈노츠 비행기지",
	Scholomance = "스칼로맨스",
	["Scholomance Entrance"] = "스칼로맨스 입구",
	ScholomanceOLD = "스칼로맨스",
	["School of Necromancy"] = "강령술 학교",
	["Scorched Gully"] = "불타버린 협곡",
	["Scott's Spooky Area"] = "스콧의 으스스한 지역",
	["Scoured Reach"] = "세찬물결 굽이",
	Scourgehold = "스컬지 요새",
	Scourgeholme = "스컬지홀름",
	["Scourgelord's Command"] = "스컬지군주의 지휘소",
	["Scrabblescrew's Camp"] = "스크래블스크류의 야영지",
	["Screaming Gully"] = "울부짖는 협곡",
	["Scryer's Tier"] = "점술가 언덕",
	["Scuttle Coast"] = "가라앉은 해안",
	Sea = "바다",
	Seabrush = "바다덤불",
	["Seafarer's Tomb"] = "뱃사람의 무덤",
	["Sealed Chambers"] = "봉인된 방",
	["Seal of the Sun King"] = "태양왕의 봉인",
	["Sea Mist Ridge"] = "바다 안개 마루",
	["Searing Gorge"] = "이글거리는 협곡",
	["Seaspittle Cove"] = "바닷물보라 동굴",
	["Seaspittle Nook"] = "바닷물보라 동굴",
	["Seat of Destruction"] = "파괴의 보좌",
	["Seat of Knowledge"] = "지식의 연단",
	["Seat of Life"] = "생명의 보좌",
	["Seat of Magic"] = "마법의 보좌",
	["Seat of Radiance"] = "광휘의 보좌",
	["Seat of the Chosen"] = "선택받은 자의 보좌",
	["Seat of the Naaru"] = "나루의 보좌",
	["Seat of the Spirit Waker"] = "영혼을 깨우는 자의 터",
	["Seeker's Folly"] = "구도자의 우둔함",
	["Seeker's Point"] = "구도자의 정상",
	["Sen'jin Village"] = "센진 마을",
	["Sen'jin Village Outskirts"] = "센진 마을 교외",
	["Sentinel Basecamp"] = "파수꾼 주둔지",
	["Sentinel Hill"] = "감시의 언덕",
	["Sentinel Tower"] = "감시탑",
	["Sentry Point"] = "감시초소",
	Seradane = "세라데인",
	["Serenity Falls"] = "평온의 폭포",
	["Serpent Lake"] = "물갈퀴 호수",
	["Serpent's Coil"] = "뱀의 보금자리",
	["Serpent's Heart"] = "용의 심장",
	["Serpentshrine Cavern"] = "불뱀 제단",
	["Serpent's Overlook"] = "용의 전망대",
	["Serpent's Spine"] = "용의 척추",
	["Servants' Quarters"] = "하인 숙소",
	["Service Entrance"] = "공무용 입구",
	["Sethekk Halls"] = "세데크 전당",
	["Sethria's Roost"] = "세스리아의 보금자리",
	["Setting Sun Garrison"] = "석양 주둔지",
	["Set'vess"] = "세트베스",
	["Sewer Access Point"] = "하수구 접근점",
	["Sewer Exit Pipe"] = "하수도 배출관",
	Sewers = "하수구",
	Shadebough = "그늘가지",
	["Shadewood Thicket"] = "그늘나무 숲",
	["Shado-Li Basin"] = "음영리 분지",
	["Shado-Pan Fallback"] = "음영파 퇴각지",
	["Shado-Pan Garrison"] = "음영파 주둔지",
	["Shado-Pan Monastery"] = "음영파 수도원",
	["Shadowbreak Ravine"] = "동트는 협곡",
	["Shadowfang Keep"] = "그림자송곳니 성채",
	["Shadowfang Keep Entrance"] = "그림자송곳니 성채 입구",
	["Shadowfang Tower"] = "그림자송곳니 탑",
	["Shadowforge City"] = "어둠괴철로 도시",
	Shadowglen = "그늘 협곡",
	["Shadow Grave"] = "암흑의 무덤",
	["Shadow Hold"] = "어둠의 요새",
	["Shadow Labyrinth"] = "어둠의 미궁",
	["Shadowlurk Ridge"] = "그림자그늘 마루",
	["Shadowmoon Valley"] = "어둠달 골짜기",
	["Shadowmoon Village"] = "어둠달 마을",
	["Shadow-Pan Monastery"] = "음영파 수도원",
	["Shadowprey Village"] = "그늘수렵 마을",
	["Shadow Ridge"] = "어둠 마루",
	["Shadowshard Cavern"] = "음영석 동굴",
	["Shadowsight Tower"] = "그늘눈 경비탑",
	["Shadowsong Shrine"] = "섀도송 제단",
	["Shadowthread Cave"] = "그늘 거미굴",
	["Shadow Tomb"] = "어둠의 무덤",
	["Shadow Wing Lair"] = "그림자날개 둥지",
	["Shadra'Alor"] = "샤드라알로",
	["Shadybranch Pocket"] = "그늘가지 지구",
	["Shady Rest Inn"] = "그늘 쉼터 여관",
	["Shalandis Isle"] = "샬란디스 섬",
	["Shalewind Canyon"] = "혈암풍 협곡",
	["Shallow's End"] = "여울의 끝자락",
	["Shallowstep Pass"] = "살금걸음 고개",
	["Shalzaru's Lair"] = "샬자루의 둥지",
	Shamanar = "샤마나르",
	["Sha'naari Wastes"] = "샤나아리 황무지",
	["Shang's Stead"] = "샹의 처소",
	["Shang's Valley"] = "샹의 골짜기",
	["Shang Xi Training Grounds"] = "샹 시 수련장",
	["Shan'ze Dao"] = "샨쩌 다오",
	["Shaol'mara"] = "샤올마라",
	["Shaol'watha"] = "샤올와타",
	["Shaper's Terrace"] = "구체자의 정원",
	["Shaper's Terrace "] = "구체자의 정원",
	["Shartuul's Transporter"] = "샤툴의 순간이동기",
	["Sha'tari Base Camp"] = "샤타리 주둔지",
	["Sha'tari Outpost"] = "샤타리 전초기지",
	["Shattered Convoy"] = "부서진 호송대",
	["Shattered Plains"] = "부서진 평원",
	["Shattered Straits"] = "부서진 해협",
	["Shattered Sun Staging Area"] = "무너진 태양 집결지",
	["Shatter Point"] = "징검다리 거점",
	["Shatter Scar Vale"] = "불벼락 골짜기",
	Shattershore = "산산조각 바닷가",
	["Shatterspear Pass"] = "뾰족창 고개",
	["Shatterspear Vale"] = "뾰족창 골짜기",
	["Shatterspear War Camp"] = "뾰족창 전쟁 기지",
	Shatterstone = "산산조각바위",
	Shattrath = "샤트라스",
	["Shattrath City"] = "샤트라스",
	["Shelf of Mazu"] = "마쭈의 대륙붕",
	["Shell Beach"] = "조개껍질 해안",
	["Shield Hill"] = "방패 언덕",
	["Shields of Silver"] = "은빛 방패 상점",
	["Shimmering Bog"] = "흐린빛 수렁",
	["Shimmering Expanse"] = "흐린빛 벌판",
	["Shimmering Grotto"] = "흐린빛 종유동",
	["Shimmer Ridge"] = "아지랑이 마루",
	["Shindigger's Camp"] = "신디거의 야영지",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "바쉬르행 선박 (오그리마 -> 바쉬르)",
	["Shipwreck Shore"] = "난파 해안",
	Shipyard = "항만",
	["Shipyard - Mogu Island Progression Scenario"] = "항만 - 모구 섬 진행 시나리오",
	["Shok'Thokar"] = "쇼크토카르",
	["Sholazar Basin"] = "숄라자르 분지",
	["Shores of the Well"] = "샘 기슭",
	["Shrine of Aessina"] = "아에시나의 제단",
	["Shrine of Aviana"] = "아비아나의 제단",
	["Shrine of Dath'Remar"] = "다트리마의 제단",
	["Shrine of Dreaming Stones"] = "꿈꾸는 돌의 제단",
	["Shrine of Eck"] = "엑크의 제단",
	["Shrine of Fellowship"] = "동지애의 제단",
	["Shrine of Five Dawns"] = "다섯 새벽 제단",
	["Shrine of Goldrinn"] = "골드린의 제단",
	["Shrine of Inner-Light"] = "내면의 빛 제단",
	["Shrine of Lost Souls"] = "길 잃은 영혼의 제단",
	["Shrine of Nala'shi"] = "날라시의 제단",
	["Shrine of Remembrance"] = "기억의 제단",
	["Shrine of Remulos"] = "레물로스의 제단",
	["Shrine of Scales"] = "비늘 제단",
	["Shrine of Seven Stars"] = "일곱 별의 제단",
	["Shrine of Thaurissan"] = "타우릿산의 제단",
	["Shrine of the Dawn"] = "새벽의 제단",
	["Shrine of the Deceiver"] = "기만자의 사원",
	["Shrine of the Dormant Flame"] = "희미한 불꽃의 제단",
	["Shrine of the Eclipse"] = "일식 제단",
	["Shrine of the Elements"] = "정령의 제단",
	["Shrine of the Fallen Warrior"] = "전사한 용사의 제단",
	["Shrine of the Five Khans"] = "다섯 칸의 제단",
	["Shrine of the Merciless One"] = "무자비한 자의 제단",
	["Shrine of the Ox"] = "흑우의 제단",
	["Shrine of Twin Serpents"] = "쌍둥이 용의 제단",
	["Shrine of Two Moons"] = "두 달의 제단",
	["Shrine of Unending Light"] = "영원한 빛의 제단",
	["Shriveled Oasis"] = "말라빠진 오아시스",
	["Shuddering Spires"] = "몸서리 첨탑",
	["SI:7"] = "SI:7",
	["Siege of Niuzao Temple"] = "니우짜오 사원 공성전투",
	["Siege Vise"] = "공성 격전장",
	["Siege Workshop"] = "공성 작업장",
	["Sifreldar Village"] = "시프렐다르 마을",
	["Sik'vess"] = "시크베스",
	["Sik'vess Lair"] = "시크베스 둥지",
	["Silent Vigil"] = "침묵의 망루",
	Silithus = "실리더스",
	["Silken Fields"] = "비단촌",
	["Silken Shore"] = "비단결 해안",
	["Silmyr Lake"] = "실미르 호수",
	["Silting Shore"] = "개펄 해안",
	Silverbrook = "은빛시내 마을",
	["Silverbrook Hills"] = "은빛시내 언덕",
	["Silver Covenant Pavilion"] = "은빛 서약단 막사",
	["Silverlight Cavern"] = "은빛 동굴",
	["Silverline Lake"] = "희망의 호수",
	["Silvermoon City"] = "실버문",
	["Silvermoon City Inn"] = "실버문 여관",
	["Silvermoon Finery"] = "실버문 의복 상점",
	["Silvermoon Jewelery"] = "실버문 보석상점",
	["Silvermoon Registry"] = "실버문 길드 사무소",
	["Silvermoon's Pride"] = "실버문의 긍지호",
	["Silvermyst Isle"] = "은빛안개 섬",
	["Silverpine Forest"] = "은빛소나무 숲",
	["Silvershard Mines"] = "은빛수정 광산",
	["Silver Stream Mine"] = "은여울 광산",
	["Silver Tide Hollow"] = "은빛 너울 동굴",
	["Silver Tide Trench"] = "은빛 너울 협곡",
	["Silverwind Refuge"] = "실바람 산장",
	["Silverwing Flag Room"] = "은빛날개 깃발 보관실",
	["Silverwing Grove"] = "은빛날개 숲",
	["Silverwing Hold"] = "은빛날개 요새",
	["Silverwing Outpost"] = "은빛날개 전초기지",
	["Simply Enchanting"] = "마법부여 전문점",
	["Sindragosa's Fall"] = "신드라고사의 추락지",
	["Sindweller's Rise"] = "신드웰러 마루",
	["Singing Marshes"] = "노래하는 습지대",
	["Singing Ridge"] = "노래하는 마루",
	["Sinner's Folly"] = "불신자의 만용호",
	["Sira'kess Front"] = "시라케스 전초지",
	["Sishir Canyon"] = "시쉬르 협곡",
	["Sisters Sorcerous"] = "자매 마술사",
	Skald = "불타버린 언덕",
	["Sketh'lon Base Camp"] = "스케슬론 주둔지",
	["Sketh'lon Wreckage"] = "스케슬론 폐허",
	["Skethyl Mountains"] = "스키실 산맥",
	Skettis = "스케티스",
	["Skitterweb Tunnels"] = "그물걸이 통로",
	Skorn = "스코른",
	["Skulking Row"] = "위험한 거리",
	["Skulk Rock"] = "굼벵이 바위굴",
	["Skull Rock"] = "해골 바위굴",
	["Sky Falls"] = "하늘 폭포",
	["Skyguard Outpost"] = "하늘경비대 전초기지",
	["Skyline Ridge"] = "지평선 마루",
	Skyrange = "하늘능선",
	["Skysong Lake"] = "하늘노래 호수",
	["Slabchisel's Survey"] = "슬랩치즐의 측량지",
	["Slag Watch"] = "잿가루 감시초소",
	Slagworks = "잿가루작업장",
	["Slaughter Hollow"] = "살육의 동굴",
	["Slaughter Square"] = "학살의 광장",
	["Sleeping Gorge"] = "수면의 협곡",
	["Slicky Stream"] = "미끈고기 개울",
	["Slingtail Pits"] = "줄꼬리 구덩이",
	["Slitherblade Shore"] = "뱀갈퀴 해안",
	["Slithering Cove"] = "갈래굽이 만",
	["Slither Rock"] = "뱀갈퀴 바위굴",
	["Sludgeguard Tower"] = "진흙방비 탑",
	["Smuggler's Scar"] = "밀수업자의 흉터",
	["Snicklefritz Mine"] = "스니클프릿츠 광산",
	["Snowblind Hills"] = "설맹의 언덕",
	["Snowblind Terrace"] = "설맹의 언덕 길목",
	["Snowden Chalet"] = "눈구덩이 오두막",
	["Snowdrift Dojo"] = "스노우드리프트 도장",
	["Snowdrift Plains"] = "눈더미 평원",
	["Snowfall Glade"] = "눈사태 숲",
	["Snowfall Graveyard"] = "눈사태 무덤",
	["Socrethar's Seat"] = "소크레타르의 옥좌",
	["Sofera's Naze"] = "소페라 절벽",
	["Soggy's Gamble"] = "흠뻑이의 요행수",
	["Solace Glade"] = "위안의 숲",
	["Solliden Farmstead"] = "솔리덴 농장",
	["Solstice Village"] = "극지 마을",
	["Sorlof's Strand"] = "소를로프의 해안",
	["Sorrow Hill"] = "슬픔의 언덕",
	["Sorrow Hill Crypt"] = "슬픔의 언덕 납골당",
	Sorrowmurk = "슬픔의 그늘",
	["Sorrow Wing Point"] = "슬픔의 날개 거점",
	["Soulgrinder's Barrow"] = "영혼분쇄자의 은신처",
	["Southbreak Shore"] = "거친파도 해안",
	["South Common Hall"] = "남쪽 대전당",
	["Southern Barrens"] = "남부 불모의 땅",
	["Southern Gold Road"] = "남부 황금길",
	["Southern Rampart"] = "남쪽 성루",
	["Southern Rocketway"] = "남부 로켓길",
	["Southern Rocketway Terminus"] = "남부 로켓길 종착지",
	["Southern Savage Coast"] = "폭풍 해안 남부",
	["Southfury River"] = "성난남녘 강",
	["Southfury Watershed"] = "성난남녘 분수령",
	["South Gate Outpost"] = "남부 관문 전초기지",
	["South Gate Pass"] = "남부 관문 통행로",
	["Southmaul Tower"] = "남녘망치 탑",
	["Southmoon Ruins"] = "남쪽 달 폐허",
	["South Pavilion"] = "남쪽 천막",
	["Southpoint Gate"] = "남부경비 관문",
	["South Point Station"] = "남부 거점",
	["Southpoint Tower"] = "남부경비 탑",
	["Southridge Beach"] = "남녘마루 해안",
	["Southsea Holdfast"] = "남쪽바다 철통절벽",
	["South Seas"] = "남쪽 바다",
	Southshore = "남녘해안",
	["Southshore Town Hall"] = "남녘해안 마을회관",
	["South Spire"] = "남쪽 첨탑",
	["South Tide's Run"] = "남부 해안가",
	["Southwind Cleft"] = "마파람 동굴",
	["Southwind Village"] = "마파람 마을",
	["Sparkrocket Outpost"] = "스파크로켓 전초기지",
	["Sparksocket Minefield"] = "스파크소켓의 지뢰밭",
	["Sparktouched Haven"] = "번개불꽃 안식처",
	["Sparring Hall"] = "훈련의 전당",
	["Spearborn Encampment"] = "작살사냥꾼 야영지",
	Spearhead = "최전선",
	["Speedbarge Bar"] = "쾌속선 주점",
	Spellsails = "주문돛대호",
	["Spinebreaker Mountains"] = "해골망치 산맥",
	["Spinebreaker Pass"] = "해골망치 고개",
	["Spinebreaker Post"] = "해골망치 초소",
	["Spinebreaker Ridge"] = "해골망치 마루",
	["Spiral of Thorns"] = "가시덩굴 소용돌이",
	["Spire of Blood"] = "피의 첨탑",
	["Spire of Decay"] = "부패의 첨탑",
	["Spire of Pain"] = "고통의 첨탑",
	["Spire of Solitude"] = "고독의 봉우리",
	["Spire Throne"] = "첨탑 사령실",
	["Spirit Den"] = "정기의 동굴",
	["Spirit Fields"] = "정기의 들판",
	["Spirit Rise"] = "정기의 봉우리",
	["Spirit Rock"] = "정기 바위",
	["Spiritsong River"] = "정령노래 강",
	["Spiritsong's Rest"] = "정령노래의 쉼터",
	["Spitescale Cavern"] = "원한비늘 동굴",
	["Spitescale Cove"] = "원한비늘 만",
	["Splinterspear Junction"] = "부러진창 교차로",
	Splintertree = "토막나무",
	["Splintertree Mine"] = "토막나무 광산",
	["Splintertree Post"] = "토막나무 주둔지",
	["Splithoof Crag"] = "갈래발굽 바윗골",
	["Splithoof Heights"] = "갈래발굽 언덕",
	["Splithoof Hold"] = "갈래발굽 소굴",
	Sporeggar = "스포어가르",
	["Sporewind Lake"] = "포자바람 호수",
	["Springtail Crag"] = "껑충꼬리 바위굴",
	["Springtail Warren"] = "껑충꼬리 소굴",
	["Spruce Point Post"] = "전나무 거점 주둔지",
	["Sra'thik Incursion"] = "스라티크 습격지",
	["Sra'thik Swarmdock"] = "스라티크 무리거점",
	["Sra'vess"] = "스라베스",
	["Sra'vess Rootchamber"] = "스라베스 뿌리의 방",
	["Sri-La Inn"] = "스리라 여관",
	["Sri-La Village"] = "스리라 마을",
	Stables = "마구간",
	Stagalbog = "진흙수렁",
	["Stagalbog Cave"] = "진흙수렁 동굴",
	["Stagecoach Crash Site"] = "역마차 충돌 지점",
	["Staghelm Point"] = "스태그헬름 거점",
	["Staging Balcony"] = "집결점 난간",
	["Stairway to Honor"] = "명예로 가는 계단",
	["Starbreeze Village"] = "별바람 마을",
	["Stardust Spire"] = "별가루 첨탑",
	["Starfall Village"] = "별똥별 마을",
	["Stars' Rest"] = "별의 쉼터",
	["Stasis Block: Maximus"] = "막시무스 감금 구역",
	["Stasis Block: Trion"] = "트리온 감금 구역",
	["Steam Springs"] = "증기 온천",
	["Steamwheedle Port"] = "스팀휘들 항구",
	["Steel Gate"] = "강철 관문",
	["Steelgrill's Depot"] = "스틸그릴의 정비소",
	["Steeljaw's Caravan"] = "스틸조의 짐마차",
	["Steelspark Station"] = "강철불꽃 거점",
	["Stendel's Pond"] = "스텐들의 연못",
	["Stillpine Hold"] = "너울소나무 요새",
	["Stillwater Pond"] = "청정 연못",
	["Stillwhisper Pond"] = "잔잔한 속삭임 연못",
	Stonard = "스토나드",
	["Stonebreaker Camp"] = "돌망치 야영지",
	["Stonebreaker Hold"] = "돌망치 요새",
	["Stonebull Lake"] = "황소바위 호수",
	["Stone Cairn Lake"] = "돌무덤 호수",
	Stonehearth = "돌난로",
	["Stonehearth Bunker"] = "돌난로 참호",
	["Stonehearth Graveyard"] = "돌난로 무덤",
	["Stonehearth Outpost"] = "돌난로 전초기지",
	["Stonemaul Hold"] = "돌망치 요새",
	["Stonemaul Ruins"] = "돌망치 폐허",
	["Stone Mug Tavern"] = "돌 맥주잔 주점",
	Stoneplow = "돌밭",
	["Stoneplow Fields"] = "돌밭 지대",
	["Stone Sentinel's Overlook"] = "바위 파수대의 전망대",
	["Stonesplinter Valley"] = "가루바위 골짜기",
	["Stonetalon Bomb"] = "돌발톱 폭탄",
	["Stonetalon Mountains"] = "돌발톱 산맥",
	["Stonetalon Pass"] = "돌발톱 고개",
	["Stonetalon Peak"] = "돌발톱 봉우리",
	["Stonewall Canyon"] = "돌담 협곡",
	["Stonewall Lift"] = "절벽 승강장",
	["Stoneward Prison"] = "바위봉쇄 감옥",
	Stonewatch = "돌망루 요새",
	["Stonewatch Falls"] = "돌망루 언덕",
	["Stonewatch Keep"] = "돌망루 요새",
	["Stonewatch Tower"] = "돌망루 탑",
	["Stonewrought Dam"] = "돌다지 댐",
	["Stonewrought Pass"] = "돌다지 고개",
	["Storm Cliffs"] = "폭풍 절벽",
	Stormcrest = "폭풍마루",
	["Stormfeather Outpost"] = "폭풍깃털 전초기지",
	["Stormglen Village"] = "폭풍협곡 마을",
	["Storm Peaks"] = "폭풍우 봉우리",
	["Stormpike Graveyard"] = "스톰파이크 무덤",
	["Stormrage Barrow Dens"] = "스톰레이지 지하굴",
	["Stormsea Landing"] = "폭풍바다 선착장",
	["Storm's Fury Wreckage"] = "폭풍 강타호 잔해",
	["Stormstout Brewery"] = "스톰스타우트 양조장",
	["Stormstout Brewery Interior"] = "스톰스타우트 양조장 내부",
	["Stormstout Brewhall"] = "스톰스타우트 양조실",
	Stormwind = "스톰윈드",
	["Stormwind City"] = "스톰윈드",
	["Stormwind City Cemetery"] = "스톰윈드 묘지",
	["Stormwind City Outskirts"] = "스톰윈드 교외",
	["Stormwind Gunship Pandaria Start Area"] = "스톰윈드 비행포격선 판다리아 시작 지역",
	["Stormwind Harbor"] = "스톰윈드 항구",
	["Stormwind Keep"] = "스톰윈드 왕궁",
	["Stormwind Lake"] = "스톰윈드 호수",
	["Stormwind Mountains"] = "스톰윈드 산맥",
	["Stormwind Stockade"] = "스톰윈드 지하감옥",
	["Stormwind Vault"] = "스톰윈드 은행",
	["Stoutlager Inn"] = "스타우트라거 여관",
	Strahnbrad = "스트란브래드",
	["Strand of the Ancients"] = "고대의 해안",
	["Stranglethorn Vale"] = "가시덤불 골짜기",
	Stratholme = "스트라솔름",
	["Stratholme Entrance"] = "스트라솔름 입구",
	["Stratholme - Main Gate"] = "스트라솔름 - 정문",
	["Stratholme - Service Entrance"] = "스트라솔름 - 공무용 입구",
	["Stratholme Service Entrance"] = "스트라솔름 공무용 입구",
	["Stromgarde Keep"] = "스트롬가드 요새",
	["Strongarm Airstrip"] = "우격다짐 비행장",
	["STV Diamond Mine BG"] = "STV 다이아몬드 광산 전장",
	["Stygian Bounty"] = "저승의 자비호",
	["Sub zone"] = "세부 지역",
	["Sulfuron Keep"] = "설퍼론 요새",
	["Sulfuron Keep Courtyard"] = "설퍼론 요새 광장",
	["Sulfuron Span"] = "설퍼론 교각",
	["Sulfuron Spire"] = "설퍼론 첨탑",
	["Sullah's Sideshow"] = "술라의 소공연장",
	["Summer's Rest"] = "여름의 쉼터",
	["Summoners' Tomb"] = "소환사의 무덤",
	["Sunblossom Hill"] = "태양꽃 언덕",
	["Suncrown Village"] = "태양왕관 마을",
	["Sundown Marsh"] = "해몰이 늪",
	["Sunfire Point"] = "태양불꽃 거점",
	["Sunfury Hold"] = "성난태양 주둔지",
	["Sunfury Spire"] = "성난태양 첨탑",
	["Sungraze Peak"] = "해넘이 봉우리",
	["Sunken Dig Site"] = "가라앉은 발굴현장",
	["Sunken Temple"] = "가라앉은 사원",
	["Sunken Temple Entrance"] = "가라앉은 사원 입구",
	["Sunreaver Pavilion"] = "선리버 막사",
	["Sunreaver's Command"] = "선리버 지휘초소",
	["Sunreaver's Sanctuary"] = "선리버 성소",
	["Sun Rock Retreat"] = "해바위 야영지",
	["Sunsail Anchorage"] = "해돋이 부두",
	["Sunsoaked Meadow"] = "녹아드는 햇살의 초원",
	["Sunsong Ranch"] = "태양노래 농장",
	["Sunspring Post"] = "태양여울 주둔지",
	["Sun's Reach Armory"] = "태양너울 무기고",
	["Sun's Reach Harbor"] = "태양너울 항구",
	["Sun's Reach Sanctum"] = "태양너울 성소",
	["Sunstone Terrace"] = "태양석 단상",
	["Sunstrider Isle"] = "선스트라이더 섬",
	["Sunveil Excursion"] = "해가림 탐험지",
	["Sunwatcher's Ridge"] = "태양감시자 마루",
	["Sunwell Plateau"] = "태양샘 고원",
	["Supply Caravan"] = "보급 짐마차",
	["Surge Needle"] = "폭풍 바늘",
	["Surveyors' Outpost"] = "측량사의 전초기지",
	Surwich = "수르위치",
	["Svarnos' Cell"] = "스바노스의 감옥",
	["Swamplight Manor"] = "늪지기 오두막",
	["Swamp of Sorrows"] = "슬픔의 늪",
	["Swamprat Post"] = "늪쥐 감시초소",
	["Swiftgear Station"] = "날쌘톱니 기지",
	["Swindlegrin's Dig"] = "스윈들그린의 채굴현장",
	["Swindle Street"] = "덤터기 거리",
	["Sword's Rest"] = "검의 안식처",
	Sylvanaar = "실바나르",
	["Tabetha's Farm"] = "타베사의 농장",
	["Taelan's Tower"] = "탤런의 탑",
	["Tahonda Ruins"] = "타혼다 폐허",
	["Tahret Grounds"] = "타레트 영토",
	["Tal'doren"] = "탈도렌",
	["Talismanic Textiles"] = "마법의 옷가게",
	["Tallmug's Camp"] = "큰잔의 야영지",
	["Talonbranch Glade"] = "갈퀴가지 숲",
	["Talonbranch Glade "] = "갈퀴가지 숲",
	["Talondeep Pass"] = "갈퀴자국 고개",
	["Talondeep Vale"] = "갈퀴자국 골짜기",
	["Talon Stand"] = "갈퀴발톱 언덕",
	Talramas = "탈라마스",
	["Talrendis Point"] = "탈렌디스 초소",
	Tanaris = "타나리스",
	["Tanaris Desert"] = "타나리스 사막",
	["Tanks for Everything"] = "무적의 방어구 상점",
	["Tanner Camp"] = "무두장이 야영지",
	["Tarren Mill"] = "타렌 제분소",
	["Tasters' Arena"] = "시음가의 투기장",
	["Taunka'le Village"] = "타운카르 마을",
	["Tavern in the Mists"] = "안개 속의 주점",
	["Tazz'Alaor"] = "타즈알라올",
	["Tear Down This Wall!"] = "성벽을 무너뜨려라!",
	["Teegan's Expedition"] = "티간의 원정대",
	["Teeming Burrow"] = "우글우글 동굴",
	Telaar = "텔라아르",
	["Telaari Basin"] = "텔라아리 분지",
	["Tel'athion's Camp"] = "텔아시온의 야영지",
	Teldrassil = "텔드랏실",
	Telredor = "텔레도르",
	["Tempest Bridge"] = "폭풍우 함교",
	["Tempest Keep"] = "폭풍우 요새",
	["Tempest Keep: The Arcatraz"] = "폭풍우 요새: 알카트라즈",
	["Tempest Keep - The Arcatraz Entrance"] = "폭풍우 요새 - 알카트라즈 입구",
	["Tempest Keep: The Botanica"] = "폭풍우 요새: 신록의 정원",
	["Tempest Keep - The Botanica Entrance"] = "폭풍우 요새 - 신록의 정원 입구",
	["Tempest Keep: The Mechanar"] = "폭풍우 요새: 메카나르",
	["Tempest Keep - The Mechanar Entrance"] = "폭풍우 요새 - 메카나르 입구",
	["Tempest's Reach"] = "폭풍우 해안",
	["Temple City of En'kilah"] = "엔킬라 사원",
	["Temple Hall"] = "신전 전당",
	["Temple of Ahn'Qiraj"] = "안퀴라즈 사원",
	["Temple of Arkkoran"] = "아크코란의 신전",
	["Temple of Asaad"] = "아사드 사원",
	["Temple of Bethekk"] = "베데크 신전",
	["Temple of Earth"] = "대지의 사원",
	["Temple of Five Dawns"] = "다섯 새벽 사원",
	["Temple of Invention"] = "발명의 신전",
	["Temple of Kotmogu"] = "코트모구의 사원",
	["Temple of Life"] = "생명의 신전",
	["Temple of Order"] = "질서의 신전",
	["Temple of Storms"] = "폭풍의 신전",
	["Temple of Telhamat"] = "텔하마트 사원",
	["Temple of the Forgotten"] = "망자의 신전",
	["Temple of the Jade Serpent"] = "옥룡사",
	["Temple of the Moon"] = "달의 신전",
	["Temple of the Red Crane"] = "주학사",
	["Temple of the White Tiger"] = "백호사",
	["Temple of Uldum"] = "울둠 사원",
	["Temple of Winter"] = "겨울의 신전",
	["Temple of Wisdom"] = "지혜의 신전",
	["Temple of Zin-Malor"] = "진말로의 신전",
	["Temple Summit"] = "사원 정상",
	["Tenebrous Cavern"] = "음침한 동굴",
	["Terokkar Forest"] = "테로카르 숲",
	["Terokk's Rest"] = "테로크의 안식처",
	["Terrace of Endless Spring"] = "영원한 봄의 정원",
	["Terrace of Gurthan"] = "구르단 정원",
	["Terrace of Light"] = "빛의 정원",
	["Terrace of Repose"] = "평온의 정원",
	["Terrace of Ten Thunders"] = "열 천둥의 정원",
	["Terrace of the Augurs"] = "전조의 단상",
	["Terrace of the Makers"] = "창조주의 거처",
	["Terrace of the Sun"] = "태양의 정원",
	["Terrace of the Tiger"] = "호랑이의 정원",
	["Terrace of the Twin Dragons"] = "쌍둥이 용의 정원",
	Terrordale = "테러데일",
	["Terror Run"] = "공포의 터",
	["Terrorweb Tunnel"] = "공포의 거미굴",
	["Terror Wing Path"] = "공포의 날개 골짜기",
	["Tethris Aran"] = "테드리스 아란",
	Thalanaar = "탈라나르",
	["Thalassian Pass"] = "탈라시안 고개",
	["Thalassian Range"] = "탈라시안 산줄기",
	["Thal'darah Grove"] = "탈다라 숲",
	["Thal'darah Overlook"] = "탈다라 전망대",
	["Thandol Span"] = "탄돌 교각",
	["Thargad's Camp"] = "타르가드 야영지",
	["The Abandoned Reach"] = "버려진 해안",
	["The Abyssal Maw"] = "심연의 구렁",
	["The Abyssal Shelf"] = "심연의 절벽",
	["The Admiral's Den"] = "제독의 동굴",
	["The Agronomical Apothecary"] = "농업공학 연금술점",
	["The Alliance Valiants' Ring"] = "얼라이언스 용맹전사의 투기장",
	["The Altar of Damnation"] = "저주의 제단",
	["The Altar of Shadows"] = "어둠의 제단",
	["The Altar of Zul"] = "줄의 제단",
	["The Amber Hibernal"] = "겨울 호박석",
	["The Amber Vault"] = "호박석 저장고",
	["The Amber Womb"] = "호박석 부화장",
	["The Ancient Grove"] = "고대 숲",
	["The Ancient Lift"] = "고대 승강장",
	["The Ancient Passage"] = "고대의 통로",
	["The Antechamber"] = "대기실",
	["The Anvil of Conflagration"] = "용암천지의 모루",
	["The Anvil of Flame"] = "불꽃 모루",
	["The Apothecarium"] = "연금술 실험실",
	["The Arachnid Quarter"] = "거미 지구",
	["The Arboretum"] = "도원",
	["The Arcanium"] = "비전 소환실",
	["The Arcanium "] = "비전 소환실",
	["The Arcatraz"] = "알카트라즈",
	["The Archivum"] = "고대 기록관",
	["The Argent Stand"] = "은빛십자군 격전지",
	["The Argent Valiants' Ring"] = "은빛십자군 용맹전사의 투기장",
	["The Argent Vanguard"] = "은빛십자군 선봉기지",
	["The Arsenal Absolute"] = "절대무기",
	["The Aspirants' Ring"] = "지원자의 투기장",
	["The Assembly Chamber"] = "회합실",
	["The Assembly of Iron"] = "무쇠 회합실",
	["The Athenaeum"] = "도서관",
	["The Autumn Plains"] = "가을 평원",
	["The Avalanche"] = "눈사태 언덕",
	["The Azure Front"] = "하늘빛 전초지",
	["The Bamboo Wilds"] = "대나무 밀림",
	["The Bank of Dalaran"] = "달라란 은행",
	["The Bank of Silvermoon"] = "실버문 은행",
	["The Banquet Hall"] = "연회장",
	["The Barrier Hills"] = "울타리 언덕",
	["The Bastion of Twilight"] = "황혼의 요새",
	["The Battleboar Pen"] = "전투멧돼지 우리",
	["The Battle for Gilneas"] = "길니아스 전투지",
	["The Battle for Gilneas (Old City Map)"] = "길니아스 전투지 (구 도시 지도)",
	["The Battle for Mount Hyjal"] = "하이잘 산 전투",
	["The Battlefront"] = "최전선",
	["The Bazaar"] = "시장",
	["The Beast Pens"] = "야수 조련소",
	["The Beer Garden"] = "노천 술집",
	["The Bite"] = "에이는 땅",
	["The Black Breach"] = "검은 틈",
	["The Black Market"] = "암시장",
	["The Black Morass"] = "검은늪",
	["The Black Temple"] = "검은 사원",
	["The Black Vault"] = "검은 금고",
	["The Blackwald"] = "검은숲",
	["The Blazing Strand"] = "타오르는 해안",
	["The Blighted Pool"] = "파멸의 웅덩이",
	["The Blight Line"] = "파멸의 역병지",
	["The Bloodcursed Reef"] = "핏빛저주의 산호초",
	["The Blood Furnace"] = "피의 용광로",
	["The Bloodmire"] = "피구렁",
	["The Bloodoath"] = "피의 맹세호",
	["The Blood Trail"] = "핏방울 오솔길",
	["The Bloodwash"] = "핏빛여울",
	["The Boiling Crustacean"] = "보글보글 집게발",
	["The Bombardment"] = "폭격지",
	["The Bonefields"] = "뼈의 언덕",
	["The Bone Pile"] = "뼈의 산",
	["The Bones of Nozronn"] = "노즈론의 무덤",
	["The Bone Wastes"] = "해골 무덤",
	["The Boneyard"] = "뼈무덤",
	["The Borean Wall"] = "북풍의 벽",
	["The Botanica"] = "신록의 정원",
	["The Bradshaw Mill"] = "브래드쇼 제재소",
	["The Breach"] = "거대한 틈",
	["The Briny Cutter"] = "갯바람호",
	["The Briny Muck"] = "소금물 갯벌",
	["The Briny Pinnacle"] = "소금바위 봉우리",
	["The Broken Bluffs"] = "부서진 절벽",
	["The Broken Front"] = "파괴된 싸움터",
	["The Broken Hall"] = "파괴된 전당",
	["The Broken Hills"] = "뒤틀린 언덕",
	["The Broken Stair"] = "부서진 계단",
	["The Broken Temple"] = "파괴된 신전",
	["The Broodmother's Nest"] = "여왕 둥지",
	["The Brood Pit"] = "부화의 구덩이",
	["The Bulwark"] = "보루",
	["The Burlap Trail"] = "삼베길",
	["The Burlap Valley"] = "삼베 계곡",
	["The Burlap Waystation"] = "삼베 중계지",
	["The Burning Corridor"] = "불타는 회랑",
	["The Butchery"] = "도살장",
	["The Cache of Madness"] = "광란의 은닉처",
	["The Caller's Chamber"] = "강령술 집회장",
	["The Canals"] = "대운하",
	["The Cape of Stranglethorn"] = "가시덤불 곶",
	["The Carrion Fields"] = "부패의 벌판",
	["The Catacombs"] = "지하묘지",
	["The Cauldron"] = "용광로",
	["The Cauldron of Flames"] = "불길의 가마솥",
	["The Cave"] = "동굴",
	["The Celestial Planetarium"] = "별자리 투영관",
	["The Celestial Vault"] = "하늘 금고",
	["The Celestial Watch"] = "천문대",
	["The Cemetary"] = "묘지",
	["The Cerebrillum"] = "두뇌실",
	["The Charred Vale"] = "잿더미 계곡",
	["The Chilled Quagmire"] = "얼어붙은 수렁",
	["The Chum Bucket"] = "미끼 식당",
	["The Circle of Cinders"] = "잿더미 땅",
	["The Circle of Life"] = "생명의 순환계",
	["The Circle of Suffering"] = "고통의 투기장",
	["The Clarion Bell"] = "청명의 종",
	["The Clash of Thunder"] = "천둥의 울림",
	["The Clean Zone"] = "정화 지역",
	["The Cleft"] = "바위 동굴",
	["The Clockwerk Run"] = "태엽장치 통로",
	["The Clutch"] = "구속의 손아귀",
	["The Clutches of Shek'zeer"] = "셰크지르의 손아귀",
	["The Coil"] = "증오의 똬리",
	["The Colossal Forge"] = "거대 제련실",
	["The Comb"] = "안퀴라즈 둥지",
	["The Commons"] = "광장",
	["The Conflagration"] = "끝없는 불길",
	["The Conquest Pit"] = "정복의 요새 투기장",
	["The Conservatory"] = "고요의 정원",
	["The Conservatory of Life"] = "생명의 정원",
	["The Construct Quarter"] = "피조물 지구",
	["The Cooper Residence"] = "쿠퍼 저택",
	["The Corridors of Ingenuity"] = "창의성의 회랑",
	["The Court of Bones"] = "뼈의 궁정",
	["The Court of Skulls"] = "해골 궁정",
	["The Coven"] = "집회실",
	["The Coven "] = "집회실",
	["The Creeping Ruin"] = "굼벵이 폐허",
	["The Crimson Assembly Hall"] = "진홍빛 회합 전당",
	["The Crimson Cathedral"] = "진홍빛 성당",
	["The Crimson Dawn"] = "진홍빛 서광호",
	["The Crimson Hall"] = "진홍빛 전당",
	["The Crimson Reach"] = "진홍 해안",
	["The Crimson Throne"] = "진홍십자군 사령실",
	["The Crimson Treader"] = "진홍빛 여행자호",
	["The Crimson Veil"] = "주홍빛 장막호",
	["The Crossroads"] = "십자로",
	["The Crucible"] = "도가니",
	["The Crucible of Flame"] = "불꽃의 도가니",
	["The Crumbling Waste"] = "부서진 잔해",
	["The Cryo-Core"] = "극저온 핵",
	["The Crystal Hall"] = "수정 전당",
	["The Crystal Shore"] = "수정 해안",
	["The Crystal Vale"] = "수정 골짜기",
	["The Crystal Vice"] = "수정 계곡",
	["The Culling of Stratholme"] = "옛 스트라솔름",
	["The Culling of Stratholme Entrance"] = "옛 스트라솔름 입구",
	["The Cursed Landing"] = "저주받은 선착장",
	["The Dagger Hills"] = "비수 언덕",
	["The Dai-Lo Farmstead"] = "다이로 농장",
	["The Damsel's Luck"] = "아가씨의 행운호",
	["The Dancing Serpent"] = "춤추는 용",
	["The Dark Approach"] = "어둠의 진입로",
	["The Dark Defiance"] = "어둠의 도전호",
	["The Darkened Bank"] = "어스름 강둑",
	["The Dark Hollow"] = "어둠의 동굴",
	["The Darkmoon Faire"] = "다크문 축제",
	["The Dark Portal"] = "어둠의 문",
	["The Dark Rookery"] = "검은 부화장",
	["The Darkwood"] = "어둠숲",
	["The Dawnchaser"] = "새벽추적자호",
	["The Dawning Isles"] = "여명의 섬",
	["The Dawning Span"] = "새벽의 교각",
	["The Dawning Square"] = "새벽 광장",
	["The Dawning Stair"] = "새벽의 계단",
	["The Dawning Valley"] = "새벽의 골짜기",
	["The Dead Acre"] = "메마른 논밭",
	["The Dead Field"] = "죽음의 농장",
	["The Dead Fields"] = "죽음의 들판",
	["The Deadmines"] = "죽음의 폐광",
	["The Dead Mire"] = "죽음의 늪",
	["The Dead Scar"] = "죽음의 흉터",
	["The Deathforge"] = "죽음의 괴철로",
	["The Deathknell Graves"] = "죽음의 종소리 무덤",
	["The Decrepit Fields"] = "오래된 들판",
	["The Decrepit Flow"] = "이울어진 물줄기",
	["The Deeper"] = "깊은 굴",
	["The Deep Reaches"] = "깊은 산마루",
	["The Deepwild"] = "깊은밀림",
	["The Defiant"] = "무법자호",
	["The Defiled Chapel"] = "부정한 예배당",
	["The Den"] = "동굴 막사",
	["The Den of Flame"] = "화염의 둥지",
	["The Dens of Dying"] = "사자의 동굴",
	["The Dens of the Dying"] = "사자의 동굴",
	["The Descent into Madness"] = "광기의 내리막길",
	["The Desecrated Altar"] = "모독의 제단",
	["The Devil's Terrace"] = "악마의 단상",
	["The Devouring Breach"] = "탐식의 틈",
	["The Domicile"] = "거주지",
	["The Domicile "] = "거주지",
	["The Dooker Dome"] = "응가쟁이 전당",
	["The Dor'Danil Barrow Den"] = "도르다닐 지하굴",
	["The Dormitory"] = "거주 지구",
	["The Drag"] = "골목길",
	["The Dragonmurk"] = "용의 늪",
	["The Dragon Wastes"] = "용의 황무지",
	["The Drain"] = "배수로",
	["The Dranosh'ar Blockade"] = "드라노쉬아르 봉쇄선",
	["The Drowned Reef"] = "가라앉은 산호초",
	["The Drowned Sacellum"] = "가라앉은 제단",
	["The Drunken Hozen"] = "술 취한 호젠",
	["The Dry Hills"] = "메마른 언덕",
	["The Dustbowl"] = "먼지받이",
	["The Dust Plains"] = "먼지 언덕",
	["The Eastern Earthshrine"] = "동부 대지제단",
	["The Elders' Path"] = "장로의 길",
	["The Emerald Summit"] = "에메랄드 정상",
	["The Emperor's Approach"] = "황제의 진입로",
	["The Emperor's Gate"] = "황제의 관문",
	["The Emperor's Reach"] = "황제의 세력지",
	["The Emperor's Step"] = "황제의 계단",
	["The Escape From Durnholde"] = "던홀드 탈출",
	["The Escape from Durnholde Entrance"] = "던홀드 탈출 입구",
	["The Eventide"] = "어스름 거리",
	["The Exodar"] = "엑소다르",
	["The Eye"] = "눈",
	["The Eye of Eternity"] = "영원의 눈",
	["The Eye of the Vortex"] = "소용돌이의 눈",
	["The Fall of Shan Bu"] = "샨 부의 몰락",
	["The Farstrider Lodge"] = "원정순찰대 오두막",
	["The Feeding Pits"] = "탐식의 구덩이",
	["The Fel Pits"] = "지옥의 구덩이",
	["The Fertile Copse"] = "비옥한 수풀",
	["The Fetid Pool"] = "악취나는 웅덩이",
	["The Filthy Animal"] = "불결한 야수 여관",
	["The Firehawk"] = "불꽃매호",
	["The Five Sisters"] = "다섯 자매 바위",
	["The Flamewake"] = "불꽃의 흔적",
	["The Fleshwerks"] = "살덩이작업장",
	["The Flood Plains"] = "범람 평야",
	["The Fold"] = "습곡",
	["The Foothill Caverns"] = "구릉지 동굴",
	["The Foot of Lei Shen"] = "레이 션의 발치",
	["The Foot Steppes"] = "눈봉우리 분지",
	["The Forbidden Jungle"] = "금지된 밀림",
	["The Forbidding Sea"] = "성난 바다",
	["The Forest of Shadows"] = "그늘진 수풀",
	["The Forge of Souls"] = "영혼의 제련소",
	["The Forge of Souls Entrance"] = "영혼의 제련소 입구",
	["The Forge of Supplication"] = "탄원의 용광로",
	["The Forge of Wills"] = "의지의 용광로",
	["The Forgotten Coast"] = "잊혀진 해안",
	["The Forgotten Overlook"] = "잊혀진 전망대",
	["The Forgotten Pool"] = "잊혀진 웅덩이",
	["The Forgotten Pools"] = "잊혀진 웅덩이",
	["The Forgotten Shore"] = "망각의 해변",
	["The Forlorn Cavern"] = "쓸쓸한 뒷골목",
	["The Forlorn Mine"] = "쓸쓸한 광산",
	["The Forsaken Front"] = "포세이큰 전초지",
	["The Foul Pool"] = "타락의 웅덩이",
	["The Frigid Tomb"] = "얼어붙은 무덤",
	["The Frost Queen's Lair"] = "서리 여왕의 둥지",
	["The Frostwing Halls"] = "서리날개 전당",
	["The Frozen Glade"] = "얼어붙은 숲",
	["The Frozen Halls"] = "얼어붙은 전당",
	["The Frozen Mine"] = "얼어붙은 광산",
	["The Frozen Sea"] = "얼어붙은 바다",
	["The Frozen Throne"] = "얼어붙은 왕좌",
	["The Fungal Vale"] = "곰팡이 계곡",
	["The Furnace"] = "용광로",
	["The Gaping Chasm"] = "모래지옥 협곡",
	["The Gatehouse"] = "현관",
	["The Gatehouse "] = "현관",
	["The Gate of Unending Cycles"] = "영원한 순환의 관문",
	["The Gauntlet"] = "투쟁의 거리",
	["The Geyser Fields"] = "간헐천 지대",
	["The Ghastly Confines"] = "무시무시한 감금지",
	["The Gilded Foyer"] = "호화로운 현관",
	["The Gilded Gate"] = "빛나는 관문",
	["The Gilding Stream"] = "금빛 개울",
	["The Glimmering Pillar"] = "미명의 봉우리",
	["The Golden Gateway"] = "황금 관문",
	["The Golden Hall"] = "황금 전당",
	["The Golden Lantern"] = "황금 등불",
	["The Golden Pagoda"] = "황금탑",
	["The Golden Plains"] = "황금 초원",
	["The Golden Rose"] = "황금 장미",
	["The Golden Stair"] = "황금 계단",
	["The Golden Terrace"] = "황금 정원",
	["The Gong of Hope"] = "희망의 징",
	["The Grand Ballroom"] = "대무도회장",
	["The Grand Vestibule"] = "수도원 현관",
	["The Great Arena"] = "대형 투기장",
	["The Great Divide"] = "거대한 분수령",
	["The Great Fissure"] = "거대한 균열",
	["The Great Forge"] = "대용광로",
	["The Great Gate"] = "대 관문",
	["The Great Lift"] = "구름 승강장",
	["The Great Ossuary"] = "대형 납골당",
	["The Great Sea"] = "대해",
	["The Great Tree"] = "거대 고목",
	["The Great Wheel"] = "거대 바퀴",
	["The Green Belt"] = "녹지대",
	["The Greymane Wall"] = "그레이메인 성벽",
	["The Grim Guzzler"] = "험상궂은 주정뱅이 선술집",
	["The Grinding Quarry"] = "갈음질 채석장",
	["The Grizzled Den"] = "은빛 동굴",
	["The Grummle Bazaar"] = "그루멀 시장",
	["The Guardhouse"] = "위병소",
	["The Guest Chambers"] = "객실",
	["The Gullet"] = "예비 갱도",
	["The Halfhill Market"] = "언덕골 시장",
	["The Half Shell"] = "반쪽 껍질",
	["The Hall of Blood"] = "피의 전당",
	["The Hall of Gears"] = "톱니바퀴의 전당",
	["The Hall of Lights"] = "빛의 회랑",
	["The Hall of Respite"] = "유예의 전당",
	["The Hall of Statues"] = "조각상의 전당",
	["The Hall of the Serpent"] = "용의 전당",
	["The Hall of Tiles"] = "돌바닥 전당",
	["The Halls of Reanimation"] = "부활의 전당",
	["The Halls of Winter"] = "겨울의 전당",
	["The Hand of Gul'dan"] = "굴단의 손아귀",
	["The Harborage"] = "피난처",
	["The Hatchery"] = "부화장",
	["The Headland"] = "마루터기",
	["The Headlands"] = "마루터기",
	["The Heap"] = "고철더미",
	["The Heartland"] = "심장지",
	["The Heart of Acherus"] = "아케루스 심장부",
	["The Heart of Jade"] = "옥의 심장",
	["The Hidden Clutch"] = "숨겨진 손아귀",
	["The Hidden Grove"] = "숨겨진 숲",
	["The Hidden Hollow"] = "숨겨진 동굴",
	["The Hidden Passage"] = "숨겨진 통로",
	["The Hidden Reach"] = "비밀 장소",
	["The Hidden Reef"] = "숨은 산호초",
	["The High Path"] = "높은길",
	["The High Road"] = "높은 길",
	["The High Seat"] = "왕좌",
	["The Hinterlands"] = "동부 내륙지",
	["The Hoard"] = "병참부",
	["The Hole"] = "깊은 구멍",
	["The Horde Valiants' Ring"] = "호드 용맹전사의 투기장",
	["The Horrid March"] = "끔찍한 행진",
	["The Horsemen's Assembly"] = "기사단 회합실",
	["The Howling Hollow"] = "울부짖는 동굴",
	["The Howling Oak"] = "울부짖는 참나무",
	["The Howling Vale"] = "울부짖는 골짜기",
	["The Hunter's Reach"] = "사냥꾼의 활시위",
	["The Hushed Bank"] = "고요의 강둑",
	["The Icy Depths"] = "얼어붙은 심연",
	["The Immortal Coil"] = "불멸의 똬리호",
	["The Imperial Exchange"] = "황실 교역소",
	["The Imperial Granary"] = "황실 곡물창고",
	["The Imperial Mercantile"] = "황실 상업소",
	["The Imperial Seat"] = "옥좌",
	["The Incursion"] = "원정지",
	["The Infectis Scar"] = "오염의 흉터",
	["The Inferno"] = "지옥불",
	["The Inner Spire"] = "내부 첨탑",
	["The Intrepid"] = "용감무쌍호",
	["The Inventor's Library"] = "발명가의 도서관",
	["The Iron Crucible"] = "무쇠 용광로",
	["The Iron Hall"] = "철의 전당",
	["The Iron Reaper"] = "무쇠 사신호",
	["The Isle of Spears"] = "작살잡이 섬",
	["The Ivar Patch"] = "이바르 호박밭",
	["The Jade Forest"] = "비취 숲",
	["The Jade Vaults"] = "비취 금고",
	["The Jansen Stead"] = "얀센 농장",
	["The Keggary"] = "맥주창고",
	["The Kennel"] = "사육장",
	["The Krasari Ruins"] = "크라사리 폐허",
	["The Krazzworks"] = "크라즈작업장",
	["The Laboratory"] = "연구소",
	["The Lady Mehley"] = "멜리호",
	["The Lagoon"] = "바다자리 호수",
	["The Laughing Stand"] = "웃음소리 해안",
	["The Lazy Turnip"] = "게으른 순무",
	["The Legerdemain Lounge"] = "요술쟁이 휴게실",
	["The Legion Front"] = "군단 전초지",
	["Thelgen Rock"] = "텔겐 바위굴",
	["The Librarium"] = "기록 보존소",
	["The Library"] = "도서관",
	["The Lifebinder's Cell"] = "생명의 어머니 석실",
	["The Lifeblood Pillar"] = "생명의 피 봉우리",
	["The Lightless Reaches"] = "어두컴컴 굽이",
	["The Lion's Redoubt"] = "사자의 보루",
	["The Living Grove"] = "생명의 숲",
	["The Living Wood"] = "생명의 숲",
	["The LMS Mark II"] = "LMS 2호",
	["The Loch"] = "대호수",
	["The Long Wash"] = "침식지",
	["The Lost Fleet"] = "잃어버린 해안",
	["The Lost Fold"] = "잃어버린 언덕",
	["The Lost Isles"] = "잃어버린 섬",
	["The Lost Lands"] = "잃어버린 땅",
	["The Lost Passage"] = "잃어버린 통로",
	["The Low Path"] = "낮은길",
	Thelsamar = "텔사마",
	["The Lucky Traveller"] = "운 좋은 여행자",
	["The Lyceum"] = "훈련강당",
	["The Maclure Vineyards"] = "매클루어 포도밭",
	["The Maelstrom"] = "혼돈의 소용돌이",
	["The Maker's Overlook"] = "창조주의 전망대",
	["The Makers' Overlook"] = "창조주의 전망대",
	["The Makers' Perch"] = "창조주의 감시대",
	["The Maker's Rise"] = "창조주의 오름길",
	["The Maker's Terrace"] = "창조주의 정원",
	["The Manufactory"] = "제조 공장",
	["The Marris Stead"] = "매리스 농장",
	["The Marshlands"] = "늪지대",
	["The Masonary"] = "석공 작업장",
	["The Master's Cellar"] = "지배자의 지하실",
	["The Master's Glaive"] = "지배자의 고대검",
	["The Maul"] = "검투장",
	["The Maw of Madness"] = "광기의 구렁텅이",
	["The Mechanar"] = "메카나르",
	["The Menagerie"] = "박물관",
	["The Menders' Stead"] = "치유사의 처소",
	["The Merchant Coast"] = "무역 해안",
	["The Militant Mystic"] = "신비스러운 투사의 무기점",
	["The Military Quarter"] = "군사 지구",
	["The Military Ward"] = "군사 지구",
	["The Mind's Eye"] = "마음의 눈",
	["The Mirror of Dawn"] = "새벽의 거울",
	["The Mirror of Twilight"] = "황혼의 거울",
	["The Molsen Farm"] = "몰센 농장",
	["The Molten Bridge"] = "작열하는 다리",
	["The Molten Core"] = "화산 심장부",
	["The Molten Fields"] = "녹아내린 들판",
	["The Molten Flow"] = "녹아내린 용암",
	["The Molten Span"] = "작열하는 교각",
	["The Mor'shan Rampart"] = "몰샨의 망루",
	["The Mor'Shan Ramparts"] = "몰샨의 망루",
	["The Mosslight Pillar"] = "이끼빛 봉우리",
	["The Mountain Den"] = "산속 동굴",
	["The Murder Pens"] = "학살의 울타리",
	["The Mystic Ward"] = "마법 지구",
	["The Necrotic Vault"] = "죽음의 감옥",
	["The Nexus"] = "마력의 탑",
	["The Nexus Entrance"] = "마력의 탑 입구",
	["The Nightmare Scar"] = "악몽의 흉터",
	["The North Coast"] = "북부 해안",
	["The North Sea"] = "북해",
	["The Nosebleeds"] = "혈전의 땅",
	["The Noxious Glade"] = "맹독의 숲",
	["The Noxious Hollow"] = "맹독의 동굴",
	["The Noxious Lair"] = "맹독의 둥지",
	["The Noxious Pass"] = "맹독의 길",
	["The Oblivion"] = "망각호",
	["The Observation Ring"] = "관찰 지구",
	["The Obsidian Sanctum"] = "흑요석 성소",
	["The Oculus"] = "마력의 눈",
	["The Oculus Entrance"] = "마력의 눈 입구",
	["The Old Barracks"] = "옛 병영",
	["The Old Dormitory"] = "옛 거주 지구",
	["The Old Port Authority"] = "구 항만공사",
	["The Opera Hall"] = "오페라 극장",
	["The Oracle Glade"] = "신탁의 숲",
	["The Outer Ring"] = "외곽 지구",
	["The Overgrowth"] = "우거진 땅",
	["The Overlook"] = "전망대",
	["The Overlook Cliffs"] = "전망대 절벽",
	["The Overlook Inn"] = "전망대 여관",
	["The Ox Gate"] = "흑우의 문",
	["The Pale Roost"] = "으스름 보금자리",
	["The Park"] = "스톰윈드 공원",
	["The Path of Anguish"] = "고통의 길",
	["The Path of Conquest"] = "정복의 길",
	["The Path of Corruption"] = "타락의 길",
	["The Path of Glory"] = "영광의 길",
	["The Path of Iron"] = "무쇠단의 길",
	["The Path of the Lifewarden"] = "생명 감시자의 길",
	["The Phoenix Hall"] = "불사조 전당",
	["The Pillar of Ash"] = "잿빛 기둥",
	["The Pipe"] = "도관",
	["The Pit of Criminals"] = "범죄의 소굴",
	["The Pit of Fiends"] = "악마의 구덩이",
	["The Pit of Narjun"] = "나르준의 구덩이",
	["The Pit of Refuse"] = "앙금의 구덩이",
	["The Pit of Sacrifice"] = "희생의 구덩이",
	["The Pit of Scales"] = "비늘 구덩이",
	["The Pit of the Fang"] = "송곳니 구덩이",
	["The Plague Quarter"] = "역병 지구",
	["The Plagueworks"] = "역병작업장",
	["The Pool of Ask'ar"] = "아스카르 연못",
	["The Pools of Vision"] = "예언의 웅덩이",
	["The Prison of Yogg-Saron"] = "요그사론의 감옥",
	["The Proving Grounds"] = "발명품 실험장",
	["The Purple Parlor"] = "화려한 응접실",
	["The Quagmire"] = "먼지 수렁",
	["The Quaking Fields"] = "전율하는 들판",
	["The Queen's Reprisal"] = "여왕의 복수호",
	["The Raging Chasm"] = "분노의 협곡",
	Theramore = "테라모어 섬",
	["Theramore Isle"] = "테라모어 섬",
	["Theramore's Fall"] = "테라모어의 몰락",
	["Theramore's Fall (A)"] = "테라모어의 몰락 (얼라이언스)",
	["Theramore's Fall (H)"] = "테라모어의 몰락 (호드)",
	["Theramore's Fall Phase"] = "테라모어의 몰락 단계",
	["The Rangers' Lodge"] = "순찰대 오두막",
	["Therazane's Throne"] = "테라제인의 옥좌",
	["The Red Reaches"] = "붉은 굽이",
	["The Refectory"] = "대강당",
	["The Regrowth"] = "재생의 땅",
	["The Reliquary"] = "성골 보관실",
	["The Repository"] = "보관소",
	["The Reservoir"] = "안퀴라즈 저장실",
	["The Restless Front"] = "안식 없는 전초지",
	["The Ridge of Ancient Flame"] = "고대의 불꽃 마루",
	["The Rift"] = "균열의 공간",
	["The Ring of Balance"] = "조화의 투기장",
	["The Ring of Blood"] = "피의 투기장",
	["The Ring of Champions"] = "용사의 투기장",
	["The Ring of Inner Focus"] = "내면의 집중 투기장",
	["The Ring of Trials"] = "시험의 투기장",
	["The Ring of Valor"] = "용맹의 투기장",
	["The Riptide"] = "격정의 파도호",
	["The Riverblade Den"] = "갈퀴칼날 소굴",
	["Thermal Vents"] = "열기 배출구",
	["The Roiling Gardens"] = "휘도는 정원",
	["The Rolling Gardens"] = "휘도는 정원",
	["The Rolling Plains"] = "구릉 초원",
	["The Rookery"] = "부화장",
	["The Rotting Orchard"] = "오염된 과수원",
	["The Rows"] = "층층밭",
	["The Royal Exchange"] = "왕궁 교역소",
	["The Ruby Sanctum"] = "루비 성소",
	["The Ruined Reaches"] = "버려진 착륙장",
	["The Ruins of Kel'Theril"] = "켈테릴의 폐허",
	["The Ruins of Ordil'Aran"] = "오르딜아란의 폐허",
	["The Ruins of Stardust"] = "별가루의 폐허",
	["The Rumble Cage"] = "싸움 우리",
	["The Rustmaul Dig Site"] = "녹슨망치 발굴현장",
	["The Sacred Grove"] = "신성한 숲",
	["The Salty Sailor Tavern"] = "뱃사공의 선술집",
	["The Sanctum"] = "성소",
	["The Sanctum of Blood"] = "피의 성소",
	["The Savage Coast"] = "폭풍 해안",
	["The Savage Glen"] = "야만의 골짜기",
	["The Savage Thicket"] = "야만의 숲",
	["The Scalding Chasm"] = "끓어오르는 협곡",
	["The Scalding Pools"] = "끓어오르는 웅덩이",
	["The Scarab Dais"] = "스카라베 제단",
	["The Scarab Wall"] = "스카라베 성벽",
	["The Scarlet Basilica"] = "붉은십자군 대성당",
	["The Scarlet Bastion"] = "붉은십자군 성채",
	["The Scorched Grove"] = "불타버린 숲",
	["The Scorched Plain"] = "불타버린 평원",
	["The Scrap Field"] = "고철 지대",
	["The Scrapyard"] = "고철 야적장",
	["The Screaming Hall"] = "울부짖는 전당",
	["The Screaming Reaches"] = "비명굽이 산마루",
	["The Screeching Canyon"] = "비명 협곡",
	["The Scribe of Stormwind"] = "스톰윈드 각인소",
	["The Scribes' Sacellum"] = "각인사의 성소",
	["The Scrollkeeper's Sanctum"] = "두루마리 관리인의 성소",
	["The Scullery"] = "주방",
	["The Scullery "] = "주방",
	["The Seabolt"] = "바다화살호",
	["The Seabreach Flow"] = "바닷길 여울",
	["The Sealed Hall"] = "봉인된 전당",
	["The Sea of Cinders"] = "잿더미 바다",
	["The Sea Reaver's Run"] = "바다 학살자의 터",
	["The Searing Gateway"] = "이글거리는 관문",
	["The Sea Wolf"] = "바다늑대호",
	["The Secret Aerie"] = "비밀의 둥지",
	["The Secret Lab"] = "비밀 실험실",
	["The Secrets of Ragefire"] = "성난불길의 비밀",
	["The Seer's Library"] = "현자의 도서관",
	["The Sepulcher"] = "공동묘지",
	["The Severed Span"] = "부러진 교각",
	["The Sewer"] = "배수로",
	["The Shadow Stair"] = "어둠의 계단",
	["The Shadow Throne"] = "어둠의 왕좌",
	["The Shadow Vault"] = "어둠의 무기고",
	["The Shady Nook"] = "그늘 동굴",
	["The Shaper's Terrace"] = "구체자의 정원",
	["The Shattered Halls"] = "으스러진 손의 전당",
	["The Shattered Strand"] = "조각난 해안",
	["The Shattered Walkway"] = "부서진 산책로",
	["The Shepherd's Gate"] = "수호자의 관문",
	["The Shifting Mire"] = "변화의 늪",
	["The Shimmering Deep"] = "흐린빛 구덩이",
	["The Shimmering Flats"] = "소금 평원",
	["The Shining Strand"] = "반짝이는 호숫가",
	["The Shrine of Aessina"] = "아에시나의 제단",
	["The Shrine of Eldretharr"] = "엘드레사르 제단",
	["The Silent Sanctuary"] = "침묵의 성역",
	["The Silkwood"] = "명주숲",
	["The Silver Blade"] = "은빛 칼날호",
	["The Silver Enclave"] = "은빛 자치구",
	["The Singing Grove"] = "노래하는 숲",
	["The Singing Pools"] = "노래하는 웅덩이",
	["The Sin'loren"] = "신로렌호",
	["The Skeletal Reef"] = "해골 암초",
	["The Skittering Dark"] = "암흑 땅거미굴",
	["The Skull Warren"] = "해골 밀집지",
	["The Skunkworks"] = "비밀 실험실",
	["The Skybreaker"] = "하늘파괴자호",
	["The Skyfire"] = "하늘불꽃호",
	["The Skyreach Pillar"] = "하늘길 봉우리",
	["The Slag Pit"] = "잿가루 채석장",
	["The Slaughtered Lamb"] = "어둠의 희생양 선술집",
	["The Slaughter House"] = "도살장",
	["The Slave Pens"] = "강제 노역소",
	["The Slave Pits"] = "노예 구덩이",
	["The Slick"] = "매끈한 땅",
	["The Slithering Scar"] = "갈래굽이 구렁",
	["The Slough of Dispair"] = "절망의 구덩이",
	["The Sludge Fen"] = "진흙 늪",
	["The Sludge Fields"] = "진흙 농장",
	["The Sludgewerks"] = "진흙작업장",
	["The Solarium"] = "태양의 전당",
	["The Solar Vigil"] = "태양 망루",
	["The Southern Isles"] = "남쪽 섬",
	["The Southern Wall"] = "남쪽 벽",
	["The Sparkling Crawl"] = "광채의 흔적",
	["The Spark of Imagination"] = "상상의 작업실",
	["The Spawning Glen"] = "부화의 골짜기",
	["The Spire"] = "첨탑",
	["The Splintered Path"] = "갈라진 길",
	["The Spring Road"] = "봄길",
	["The Stadium"] = "경기장",
	["The Stagnant Oasis"] = "죽은 오아시스",
	["The Staidridge"] = "평온마루",
	["The Stair of Destiny"] = "운명의 계단",
	["The Stair of Doom"] = "파멸의 계단",
	["The Starchaser"] = "별추적자호",
	["The Star's Bazaar"] = "별의 시장",
	["The Steam Pools"] = "증기 웅덩이",
	["The Steamvault"] = "증기 저장고",
	["The Steppe of Life"] = "생명의 평원",
	["The Steps of Fate"] = "운명의 계단",
	["The Stinging Trail"] = "바늘길",
	["The Stockade"] = "스톰윈드 지하감옥",
	["The Stockpile"] = "보급창",
	["The Stonecore"] = "바위심장부",
	["The Stonecore Entrance"] = "바위심장부 입구",
	["The Stonefield Farm"] = "스톤필드 농장",
	["The Stone Vault"] = "지하 석실",
	["The Storehouse"] = "창고",
	["The Stormbreaker"] = "폭풍파괴자호",
	["The Stormbridge"] = "폭풍교",
	["The Storm Foundry"] = "폭풍 주조소",
	["The Storm Peaks"] = "폭풍우 봉우리",
	["The Stormspire"] = "폭풍 첨탑",
	["The Stormwright's Shelf"] = "폭풍전령 바위",
	["The Summer Fields"] = "여름벌",
	["The Summer Terrace"] = "여름 난간뜰",
	["The Sundered Shard"] = "갈라진 수정동굴",
	["The Sundering"] = "세계의 분리",
	["The Sun Forge"] = "태양 괴철로",
	["The Sunken Ring"] = "가라앉은 경기장",
	["The Sunset Brewgarden"] = "일몰 양조정원",
	["The Sunspire"] = "태양 첨탑",
	["The Suntouched Pillar"] = "해마루 봉우리",
	["The Sunwell"] = "태양샘",
	["The Swarming Pillar"] = "벌레무리 기둥",
	["The Swollen Vault"] = "축축한 금고",
	["The Tainted Forest"] = "오염된 숲",
	["The Tainted Scar"] = "타락의 흉터",
	["The Talondeep Path"] = "갈퀴자국 토굴길",
	["The Talon Den"] = "갈퀴발톱굴",
	["The Tasting Room"] = "시음실",
	["The Tempest Rift"] = "폭풍우 균열",
	["The Temple Gardens"] = "신전 정원",
	["The Temple of Atal'Hakkar"] = "아탈학카르 신전",
	["The Temple of the Jade Serpent"] = "옥룡사",
	["The Terrestrial Watchtower"] = "현세의 감시탑",
	["The Thornsnarl"] = "가시타래",
	["The Threads of Fate"] = "운명의 실타래",
	["The Threshold"] = "문턱",
	["The Throne of Flame"] = "불꽃의 왕좌",
	["The Thunder Forge"] = "천둥 제련소",
	["The Thunder Forges"] = "천둥 제련소",
	["The Thundering Run"] = "천둥의 터",
	["The Thundering Spire"] = "천둥의 첨탑",
	["The Thunderspire"] = "천둥의 첨탑",
	["The Thunderwood"] = "천둥숲",
	["The Tidebreaker"] = "너울파괴자호",
	["The Tidus Stair"] = "타이더스 계단",
	["The Tiger's Peak"] = "범의 봉우리",
	["The Torjari Pit"] = "토자리 구덩이",
	["The Tower of Arathor"] = "아라소르의 탑",
	["The Toxic Airfield"] = "맹독 비행장",
	["The Trail of Devastation"] = "참담한 오솔길",
	["The Tranquil Grove"] = "고요한 숲",
	["The Transitus Stair"] = "변위의 계단",
	["The Trapper's Enclave"] = "덫사냥꾼 자치구",
	["The Tribunal of Ages"] = "시대의 심판장",
	["The Tundrid Hills"] = "툰드리드 언덕",
	["The Twilight Breach"] = "황혼의 틈",
	["The Twilight Caverns"] = "황혼 동굴",
	["The Twilight Citadel"] = "황혼 성채",
	["The Twilight Enclave"] = "황혼 자치구",
	["The Twilight Gate"] = "황혼 관문",
	["The Twilight Gauntlet"] = "황혼의 시련",
	["The Twilight Ridge"] = "황혼의 마루",
	["The Twilight Rivulet"] = "황혼의 개울",
	["The Twilight Withering"] = "황혼의 마른땅",
	["The Twin Colossals"] = "쌍둥이 바위산",
	["The Twisted Glade"] = "뒤틀린 숲",
	["The Twisted Warren"] = "뒤틀린 소굴",
	["The Two Fisted Brew"] = "두 주먹 맥주",
	["The Unbound Thicket"] = "해방의 숲",
	["The Underbelly"] = "마법의 뒤안길",
	["The Underbog"] = "지하수렁",
	["The Underbough"] = "아랫가지",
	["The Undercroft"] = "지하 납골당",
	["The Underhalls"] = "지하 전당",
	["The Undershell"] = "지하껍질",
	["The Uplands"] = "고원",
	["The Upside-down Sinners"] = "속죄의 방",
	["The Valley of Fallen Heroes"] = "전사한 영웅의 계곡",
	["The Valley of Lost Hope"] = "잃어버린 희망의 계곡",
	["The Vault of Lights"] = "빛의 전당",
	["The Vector Coil"] = "벡터 코일",
	["The Veiled Cleft"] = "장막의 틈",
	["The Veiled Sea"] = "장막의 바다",
	["The Veiled Stair"] = "장막의 계단",
	["The Venture Co. Mine"] = "투자개발회사 광산",
	["The Verdant Fields"] = "신록의 들판",
	["The Verdant Thicket"] = "신록의 숲",
	["The Verne"] = "베른호",
	["The Verne - Bridge"] = "베른호 - 함교",
	["The Verne - Entryway"] = "베른호 - 출입 통로",
	["The Vibrant Glade"] = "활력의 숲",
	["The Vice"] = "악의 소굴",
	["The Vicious Vale"] = "악의 골짜기",
	["The Viewing Room"] = "스칼로맨스 강당",
	["The Vile Reef"] = "썩은내 산호초",
	["The Violet Citadel"] = "보랏빛 성채",
	["The Violet Citadel Spire"] = "보랏빛 성채 첨탑",
	["The Violet Gate"] = "보랏빛 관문",
	["The Violet Hold"] = "보랏빛 요새",
	["The Violet Spire"] = "보랏빛 첨탑",
	["The Violet Tower"] = "보랏빛 탑",
	["The Vortex Fields"] = "소용돌이 지대",
	["The Vortex Pinnacle"] = "소용돌이 누각",
	["The Vortex Pinnacle Entrance"] = "소용돌이 누각 입구",
	["The Wailing Caverns"] = "통곡의 동굴",
	["The Wailing Ziggurat"] = "통곡의 지구라트",
	["The Waking Halls"] = "각성의 전당",
	["The Wandering Isle"] = "유랑도",
	["The Warlord's Garrison"] = "대장군의 주둔지",
	["The Warlord's Terrace"] = "대장군의 단상",
	["The Warp Fields"] = "일그러진 벌판",
	["The Warp Piston"] = "초공간 추진기",
	["The Wavecrest"] = "물마루호",
	["The Weathered Nook"] = "비바람 바위굴",
	["The Weeping Cave"] = "진흙탕 동굴",
	["The Western Earthshrine"] = "서부 대지제단",
	["The Westrift"] = "서부 균열",
	["The Whelping Downs"] = "새끼용 구릉",
	["The Whipple Estate"] = "휘플가 저택",
	["The Wicked Coil"] = "악의 똬리",
	["The Wicked Grotto"] = "악의 동굴",
	["The Wicked Tunnels"] = "악의 통로",
	["The Widening Deep"] = "깊어지는 나락",
	["The Widow's Clutch"] = "과부의 손아귀",
	["The Widow's Wail"] = "과부의 통곡",
	["The Wild Plains"] = "야생 초원",
	["The Wild Shore"] = "거친 해안",
	["The Winding Halls"] = "굽이진 전당",
	["The Windrunner"] = "윈드러너호",
	["The Windspire"] = "바람봉",
	["The Wollerton Stead"] = "월러튼 농장",
	["The Wonderworks"] = "신기한 장난감 상점",
	["The Wood of Staves"] = "지팡이의 숲",
	["The World Tree"] = "세계수",
	["The Writhing Deep"] = "고통의 구덩이",
	["The Writhing Haunt"] = "고통의 흉가",
	["The Yaungol Advance"] = "야운골 진군지",
	["The Yorgen Farmstead"] = "요르겐 농장",
	["The Zandalari Vanguard"] = "잔달라 선봉기지",
	["The Zoram Strand"] = "조람 해안",
	["Thieves Camp"] = "도둑 야영지",
	["Thirsty Alley"] = "갈증의 길",
	["Thistlefur Hold"] = "엉겅퀴 소굴",
	["Thistlefur Village"] = "엉겅퀴 마을",
	["Thistleshrub Valley"] = "덤불나무 골짜기",
	["Thondroril River"] = "톤드로릴 강",
	["Thoradin's Wall"] = "소라딘의 성벽",
	["Thorium Advance"] = "토륨 진군지",
	["Thorium Point"] = "토륨 거점",
	["Thor Modan"] = "토르 모단",
	["Thornfang Hill"] = "가시송곳니 언덕",
	["Thorn Hill"] = "가시덩굴 언덕",
	["Thornmantle's Hideout"] = "가시목도리의 은신처",
	["Thorson's Post"] = "토르손의 전초기지",
	["Thorvald's Camp"] = "토르발트의 야영지",
	["Thousand Needles"] = "버섯구름 봉우리",
	Thrallmar = "스랄마",
	["Thrallmar Mine"] = "스랄마 광산",
	["Three Corners"] = "붉은마루 삼거리",
	["Throne of Ancient Conquerors"] = "고대 정복자의 왕좌",
	["Throne of Kil'jaeden"] = "킬제덴의 옥좌",
	["Throne of Neptulon"] = "넵튤론의 왕좌",
	["Throne of the Apocalypse"] = "대재앙의 권좌",
	["Throne of the Damned"] = "저주받은 자의 옥좌",
	["Throne of the Elements"] = "정령의 옥좌",
	["Throne of the Four Winds"] = "네 바람의 왕좌",
	["Throne of the Tides"] = "파도의 왕좌",
	["Throne of the Tides Entrance"] = "파도의 왕좌 입구",
	["Throne of Thunder"] = "천둥의 왕좌",
	["Throne of Tides"] = "파도의 왕좌",
	["Thrym's End"] = "스림의 최후",
	["Thunder Axe Fortress"] = "천둥도끼 요새",
	Thunderbluff = "썬더 블러프",
	["Thunder Bluff"] = "썬더 블러프",
	["Thunderbrew Distillery"] = "썬더브루 양조장",
	["Thunder Cleft"] = "천둥 틈새",
	Thunderfall = "천둥 골짜기",
	["Thunder Falls"] = "천둥 폭포",
	["Thunderfoot Farm"] = "썬더풋 농장",
	["Thunderfoot Fields"] = "썬더풋 방목지",
	["Thunderfoot Inn"] = "썬더풋 여관",
	["Thunderfoot Ranch"] = "썬더풋 사육장",
	["Thunder Hold"] = "천둥 요새",
	["Thunderhorn Water Well"] = "썬더혼 우물",
	["Thundering Overlook"] = "천둥 전망대",
	["Thunder Island Alliance Hub"] = "천둥왕 얼라이언스 중심지",
	["Thunder King Horde Hub"] = "천둥왕 호드 중심지",
	["Thunder King's Citadel"] = "천둥왕의 성채",
	["Thunderlord Stronghold"] = "천둥군주 요새",
	Thundermar = "썬더마",
	["Thundermar Ruins"] = "썬더마 폐허",
	["Thunderpaw Overlook"] = "썬더포우 전망대",
	["Thunderpaw Refuge"] = "썬더포우 은거처",
	["Thunder Peak"] = "천둥 봉우리",
	["Thunder Ridge"] = "천둥 마루",
	["Thunder's Call"] = "천둥의 부름",
	["Thunderstrike Mountain"] = "천둥쐐기 산",
	["Thunk's Abode"] = "성크의 거처",
	["Thuron's Livery"] = "투론의 매타조 훈련장",
	["Tian Monastery"] = "티엔 수도원",
	["Tidefury Cove"] = "성난파도 만",
	["Tides' Hollow"] = "파도 동굴",
	["Tideview Thicket"] = "파도바라기 수풀",
	["Tigers' Wood"] = "호랑이숲",
	["Timbermaw Hold"] = "나무구렁 요새",
	["Timbermaw Post"] = "나무구렁 야영지",
	["Tinkers' Court"] = "땜장이 왕실",
	["Tinker Town"] = "땜장이 마을",
	["Tiragarde Keep"] = "타이라가드 요새",
	["Tirisfal Glades"] = "티리스팔 숲",
	["Tirth's Haunt"] = "틸스의 거처",
	["Tkashi Ruins"] = "트카시 폐허",
	["Tol Barad"] = "톨 바라드",
	["Tol Barad Peninsula"] = "톨 바라드 반도",
	["Tol'Vir Arena"] = "톨비르 투기장",
	["Tol'viron Arena"] = "톨비론 투기장",
	["Tol'Viron Arena"] = "톨비론 투기장",
	["Tomb of Conquerors"] = "정복자의 무덤",
	["Tomb of Lights"] = "빛의 무덤",
	["Tomb of Secrets"] = "비밀의 무덤",
	["Tomb of Shadows"] = "그림자의 무덤",
	["Tomb of the Ancients"] = "선조의 무덤",
	["Tomb of the Earthrager"] = "대지전복자의 무덤",
	["Tomb of the Lost Kings"] = "왕의 무덤",
	["Tomb of the Sun King"] = "태양왕의 무덤",
	["Tomb of the Watchers"] = "감시자의 무덤",
	["Tombs of the Precursors"] = "선도자의 무덤",
	["Tome of the Unrepentant"] = "죄악의 무덤",
	["Tome of the Unrepentant "] = "죄악의 무덤",
	["Tor'kren Farm"] = "톨크렌 농장",
	["Torp's Farm"] = "토르프의 농장",
	["Torseg's Rest"] = "토르섹의 쉼터",
	["Tor'Watha"] = "토르와타",
	["Toryl Estate"] = "토릴 영지",
	["Toshley's Station"] = "토쉴리의 연구기지",
	["To the Skies!"] = "하늘 높이!",
	["To The Skies!"] = "하늘 높이!",
	["Tower of Althalaxx"] = "알살락스의 탑",
	["Tower of Azora"] = "아조라의 탑",
	["Tower of Eldara"] = "엘다라의 탑",
	["Tower of Estulan"] = "에스툴란의 탑",
	["Tower of Ilgalar"] = "일갈라의 탑",
	["Tower of the Damned"] = "저주받은 자의 탑",
	["Tower Point"] = "거점 보초탑",
	["Tower Watch"] = "탑 감시초소",
	["Town-In-A-Box"] = "상자 마을",
	["Townlong Steppes"] = "탕랑 평원",
	["Town Square"] = "마을 광장",
	["Trade District"] = "상업 지구",
	["Trade Quarter"] = "상업 지구",
	["Trader's Tier"] = "교역 지구",
	["Tradesmen's Terrace"] = "상인의 정원",
	["Train Depot"] = "병참 보급창",
	["Training Grounds"] = "훈련장",
	["Training Quarters"] = "훈련 지구",
	["Traitor's Cove"] = "배신자의 만",
	["Tranquil Coast"] = "평온의 해안",
	["Tranquil Gardens Cemetery"] = "고요의 정원 묘지",
	["Tranquil Grotto"] = "평온의 사당",
	Tranquillien = "트랜퀼리엔",
	["Tranquil Shore"] = "평온의 해변",
	["Tranquil Wash"] = "평온의 침식지",
	Transborea = "북풍길",
	["Transitus Shield"] = "변위의 보호막",
	["Transport: Alliance Gunship"] = "수송: 얼라이언스 비행포격선",
	["Transport: Alliance Gunship (IGB)"] = "수송: 얼라이언스 비행포격선",
	["Transport: Horde Gunship"] = "수송: 호드 비행포격선",
	["Transport: Horde Gunship (IGB)"] = "수송: 호드 비행포격선",
	["Transport: Onyxia/Nefarian Elevator"] = "이동: 오닉시아/네파리안 승강기",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "이동: 질풍호 (얼음왕관 성채 공격대)",
	["Trelleum Mine"] = "트렐리움 광산",
	["Trial of Fire"] = "불의 시험장",
	["Trial of Frost"] = "서리의 시험장",
	["Trial of Shadow"] = "암흑의 시험장",
	["Trial of the Champion"] = "용사의 시험장",
	["Trial of the Champion Entrance"] = "용사의 시험장 입구",
	["Trial of the Crusader"] = "십자군의 시험장",
	["Trickling Passage"] = "물방울 통로",
	["Trogma's Claim"] = "트로그마의 점령지",
	["Trollbane Hall"] = "트롤베인 전당",
	["Troll War Camp Outskirts"] = "트롤 전쟁 기지 교외",
	["Trophy Hall"] = "전리품 전당",
	["Troves of the Thunder King"] = "천둥왕의 보물",
	["Trueshot Point"] = "정조준 초소",
	["Tuluman's Landing"] = "툴루만의 교역지",
	["Turtle Beach"] = "거북 해안",
	["Tu Shen Burial Ground"] = "투 셴 묘지",
	Tuurem = "투렘",
	["Twilight Aerie"] = "황혼의 맹금요새",
	["Twilight Altar of Storms"] = "폭풍의 황혼 제단",
	["Twilight Base Camp"] = "황혼의 주둔지",
	["Twilight Bulwark"] = "황혼의 보루",
	["Twilight Camp"] = "황혼의 야영지",
	["Twilight Command Post"] = "황혼의 지휘 초소",
	["Twilight Crossing"] = "황혼의 교차점",
	["Twilight Forge"] = "황혼의 제련소",
	["Twilight Grove"] = "황혼의 숲",
	["Twilight Highlands"] = "황혼의 고원",
	["Twilight Highlands Dragonmaw Phase"] = "황혼의 고원 용아귀 단계",
	["Twilight Highlands Phased Entrance"] = "황혼의 고원 단계적 입구",
	["Twilight Highlands Zeppelin 1"] = "황혼의 고원 비행선 1",
	["Twilight Highlands Zeppelin 2"] = "황혼의 고원 비행선 2",
	["Twilight Outpost"] = "황혼의 전초기지",
	["Twilight Overlook"] = "황혼 전망대",
	["Twilight Post"] = "황혼의 초소",
	["Twilight Precipice"] = "황혼의 낭떠러지",
	["Twilight Shore"] = "황혼 해안",
	["Twilight's Run"] = "황혼의 터",
	["Twilight Terrace"] = "황혼의 단상",
	["Twilight Vale"] = "황혼의 계곡",
	["Twinbraid's Patrol"] = "트윈브레이드 지구대",
	["Twin Peaks"] = "쌍둥이 봉우리",
	["Twin Shores"] = "쌍둥이 해안",
	["Twinspire Keep"] = "쌍둥이 첨탑 요새",
	["Twinspire Keep Interior"] = "쌍둥이 첨탑 요새 내부",
	["Twin Spire Ruins"] = "쌍둥이 첨탑 폐허",
	["Twisting Nether"] = "뒤틀린 황천",
	["Tyr's Hand"] = "티르의 손 수도원",
	["Tyr's Hand Abbey"] = "티르의 손 수도회당",
	["Tyr's Terrace"] = "티르의 단상",
	["Ufrang's Hall"] = "우프랑의 전당",
	Uldaman = "울다만",
	["Uldaman Entrance"] = "울다만 입구",
	Uldis = "울디스",
	Ulduar = "울두아르",
	["Ulduar Raid - Interior - Insertion Point"] = "울두아르 공격대",
	["Ulduar Raid - Iron Concourse"] = "울두아르 공격대",
	Uldum = "울둠",
	["Uldum Phased Entrance"] = "울둠 단계적 입구",
	["Uldum Phase Oasis"] = "울둠 차원의 오아시스",
	["Uldum - Phase Wrecked Camp"] = "울둠 - 파괴된 야영지 단계",
	["Umbrafen Lake"] = "그늘늪 호수",
	["Umbrafen Village"] = "그늘늪 마을",
	["Uncharted Sea"] = "미지의 바다",
	Undercity = "언더시티",
	["Underlight Canyon"] = "미명 협곡",
	["Underlight Mines"] = "미명 광산",
	["Unearthed Grounds"] = "발굴된 땅",
	["Unga Ingoo"] = "웅가 잉구",
	["Un'Goro Crater"] = "운고로 분화구",
	["Unu'pe"] = "우누페",
	["Unyielding Garrison"] = "불굴의 주둔지",
	["Upper Silvermarsh"] = "은빛늪지 상류",
	["Upper Sumprushes"] = "진흙구렁 상류",
	["Upper Veil Shil'ak"] = "장막의 쉴라크 언덕",
	["Ursoc's Den"] = "우르속의 동굴",
	Ursolan = "우르솔란",
	["Utgarde Catacombs"] = "우트가드 지하묘지",
	["Utgarde Keep"] = "우트가드 성채",
	["Utgarde Keep Entrance"] = "우트가드 성채 입구",
	["Utgarde Pinnacle"] = "우트가드 첨탑",
	["Utgarde Pinnacle Entrance"] = "우트가드 첨탑 입구",
	["Uther's Tomb"] = "우서 경의 무덤",
	["Valaar's Berth"] = "발라르의 나루",
	["Vale of Eternal Blossoms"] = "영원꽃 골짜기",
	["Valgan's Field"] = "발간 농장",
	Valgarde = "발가드",
	["Valgarde Port"] = "발가드 항만",
	Valhalas = "발할라스",
	["Valiance Keep"] = "용맹의 성채",
	["Valiance Landing Camp"] = "용맹의 주둔지",
	["Valiant Rest"] = "용맹의 쉼터",
	Valkyrion = "발키리온",
	["Valley of Ancient Winters"] = "고대의 겨울 계곡",
	["Valley of Ashes"] = "재의 계곡",
	["Valley of Bones"] = "뼈의 골짜기",
	["Valley of Echoes"] = "메아리 골짜기",
	["Valley of Emperors"] = "황제의 골짜기",
	["Valley of Fangs"] = "송곳니 골짜기",
	["Valley of Heroes"] = "영웅의 계곡",
	["Valley Of Heroes"] = "영웅의 계곡",
	["Valley of Honor"] = "명예의 골짜기",
	["Valley of Kings"] = "왕의 계곡",
	["Valley of Power"] = "무력의 골짜기",
	["Valley Of Power - Scenario"] = "무력의 골짜기 - 시나리오",
	["Valley of Spears"] = "뾰족바위 골짜기",
	["Valley of Spirits"] = "정기의 골짜기",
	["Valley of Strength"] = "힘의 골짜기",
	["Valley of the Bloodfuries"] = "혈폭풍 일족의 골짜기",
	["Valley of the Four Winds"] = "네 바람의 계곡",
	["Valley of the Watchers"] = "감시자의 골짜기",
	["Valley of Trials"] = "시험의 골짜기",
	["Valley of Wisdom"] = "지혜의 골짜기",
	Valormok = "발로르모크",
	["Valor's Edge"] = "용맹의 칼날호",
	["Valor's Rest"] = "용사의 안식처",
	["Valorwind Lake"] = "돌개바람 호수",
	["Vanguard Infirmary"] = "선봉기지 치료소",
	["Vanndir Encampment"] = "반디르 야영지",
	["Vargoth's Retreat"] = "바르고스의 은거지",
	["Vashj'elan Spawning Pool"] = "바쉬엘란 산란못",
	["Vashj'ir"] = "바쉬르",
	["Vashj'ir Sub - Alliance"] = "바쉬르 잠수함 - 얼라이언스",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "바쉬르 잠수함 - 얼라이언스 - 심연의 구렁 선회",
	["Vashj'ir Sub - Horde"] = "바쉬르 잠수함 - 호드",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "바쉬르 잠수함 - 호드 - 심연의 구렁 선회",
	["Vault of Archavon"] = "아카본 석실",
	["Vault of Ironforge"] = "아이언포지 사설금고",
	["Vault of Kings Past"] = "지나간 왕들의 금고",
	["Vault of the Ravenian"] = "라베니안 납골당",
	["Vault of the Shadowflame"] = "암흑불길 석실",
	["Vault of Y'Shaarj"] = "이샤라즈 금고",
	["Veil Ala'rak"] = "장막의 알라라크",
	["Veil Harr'ik"] = "장막의 하리크",
	["Veil Lashh"] = "장막의 래쉬",
	["Veil Lithic"] = "장막의 리디크",
	["Veil Reskk"] = "장막의 레스크",
	["Veil Rhaze"] = "장막의 라제",
	["Veil Ruuan"] = "장막의 루안",
	["Veil Sethekk"] = "장막의 세데크",
	["Veil Shalas"] = "장막의 샬라스",
	["Veil Shienor"] = "장막의 쉬에노르",
	["Veil Skith"] = "장막의 스키스",
	["Veil Vekh"] = "장막의 베크",
	["Vekhaar Stand"] = "베크하르 고원",
	["Velaani's Arcane Goods"] = "벨라아니 비전 상점",
	["Vendetta Point"] = "원한의 거점",
	["Vengeance Landing"] = "복수의 상륙지",
	["Vengeance Landing Inn"] = "복수의 상륙지 여관",
	["Vengeance Landing Inn, Howling Fjord"] = "복수의 상륙지 여관 (울부짖는 협만)",
	["Vengeance Lift"] = "복수의 승강장",
	["Vengeance Pass"] = "복수의 고개",
	["Vengeance Wake"] = "복수의 흔적호",
	["Venomous Ledge"] = "맹독 절벽",
	Venomspite = "원한의 초소",
	["Venomsting Pits"] = "독침 구덩이",
	["Venomweb Vale"] = "독그물 골짜기",
	["Venture Bay"] = "투자개발 만",
	["Venture Co. Base Camp"] = "투자개발회사 탐사기지",
	["Venture Co. Operations Center"] = "투자개발회사 기계조작실",
	["Verdant Belt"] = "신록지대",
	["Verdant Highlands"] = "신록의 고원",
	["Verdantis River"] = "베르단티스 강",
	["Veridian Point"] = "청록 해안",
	["Verlok Stand"] = "베를로크 바윗부리",
	["Vermillion Redoubt"] = "주홍빛 보루",
	["Verming Tunnels Micro"] = "토깽 지하굴 초소형",
	["Verrall Delta"] = "베랄 삼각주",
	["Verrall River"] = "베랄 강",
	["Victor's Point"] = "승리자 거점",
	["Vileprey Village"] = "썩은수렵 마을",
	["Vim'gol's Circle"] = "빔골의 마법진",
	["Vindicator's Rest"] = "구원자의 안식처",
	["Violet Citadel Balcony"] = "보랏빛 성채 발코니",
	["Violet Hold"] = "보랏빛 요새",
	["Violet Hold Entrance"] = "보랏빛 요새 입구",
	["Violet Rise"] = "보랏빛 마루",
	["Violet Stand"] = "보랏빛 단",
	["Virmen Grotto"] = "토깽 소굴",
	["Virmen Nest"] = "토깽의 보금자리",
	["Vir'naal Dam"] = "비르나알 둑",
	["Vir'naal Lake"] = "비르나알 호수",
	["Vir'naal Oasis"] = "비르나알 오아시스",
	["Vir'naal River"] = "비르나알 강",
	["Vir'naal River Delta"] = "비르나알 강 삼각주",
	["Void Ridge"] = "공허의 마루",
	["Voidwind Plateau"] = "공허의 바람 고원",
	["Volcanoth's Lair"] = "볼카노스의 굴",
	["Voldrin's Hold"] = "볼드린의 장악호",
	Voldrune = "볼드룬",
	["Voldrune Dwelling"] = "볼드룬 주거지",
	Voltarus = "볼타루스",
	["Vordrassil Pass"] = "볼드랏실 고개",
	["Vordrassil's Heart"] = "볼드랏실의 심장",
	["Vordrassil's Limb"] = "볼드랏실의 가지",
	["Vordrassil's Tears"] = "볼드랏실의 눈물",
	["Vortex Pinnacle"] = "소용돌이 누각",
	["Vortex Summit"] = "소용돌이 꼭대기",
	["Vul'Gol Ogre Mound"] = "벌골 오우거 소굴",
	["Vyletongue Seat"] = "바일텅의 왕좌",
	["Wahl Cottage"] = "왈 산장",
	["Wailing Caverns"] = "통곡의 동굴",
	["Walk of Elders"] = "장로의 거리",
	["Warbringer's Ring"] = "전쟁인도자 광장",
	["Warchief's Lookout"] = "대족장의 망루",
	["Warden's Cage"] = "감시자의 수용소",
	["Warden's Chambers"] = "감시자의 방",
	["Warden's Vigil"] = "감시자의 망루",
	["Warlock Area"] = "흑마법사 지역",
	["Warmaul Hill"] = "전쟁망치 언덕",
	["Warpwood Quarter"] = "굽이나무 지구",
	["War Quarter"] = "군사 지구",
	["Warrior's Terrace"] = "전사의 정원",
	["War Room"] = "전략 회의실",
	Warship = "전함",
	["Warsong Camp"] = "전쟁노래 야영지",
	["Warsong Farms Outpost"] = "전쟁노래 농장 전진기지",
	["Warsong Flag Room"] = "전쟁노래 깃발 보관실",
	["Warsong Granary"] = "전쟁노래 곡물창고",
	["Warsong Gulch"] = "전쟁노래 협곡",
	["Warsong Hold"] = "전쟁노래 요새",
	["Warsong Jetty"] = "전쟁노래 부두",
	["Warsong Labor Camp"] = "전쟁노래 노동기지",
	["Warsong Lumber Camp"] = "전쟁노래 벌목기지",
	["Warsong Lumber Mill"] = "전쟁노래 제재소",
	["Warsong Slaughterhouse"] = "전쟁노래 도살장",
	["Watcher's Sanctum"] = "감시자의 성소",
	["Watchers' Terrace"] = "감시자의 정원",
	["Waterspeaker's Sanctuary"] = "물예언자의 성소",
	["Waterspring Field"] = "샘솟는 벌판",
	Waterworks = "수력작업장",
	["Wavestrider Beach"] = "파도타기 해안",
	Waxwood = "광나무숲",
	["Wayfarer's Rest"] = "나그네의 쉼터",
	Waygate = "차원문",
	["Wayne's Refuge"] = "웨인의 은거처",
	["Weazel's Crater"] = "위젤의 분화구",
	["Webwinder Hollow"] = "그물누비 동굴",
	["Webwinder Path"] = "그물누비 고개",
	["Weeping Quarry"] = "진흙탕 채석장",
	["Well of Eternity"] = "영원의 샘",
	["Well of the Forgotten"] = "망각의 샘",
	["Wellson Shipyard"] = "웰슨 조선소",
	["Wellspring Hovel"] = "생명의 오두막",
	["Wellspring Lake"] = "생명의 호수",
	["Wellspring River"] = "생명의 강",
	["Westbrook Garrison"] = "서쪽시내 주둔지",
	["Western Bridge"] = "서쪽 다리",
	["Western Plaguelands"] = "서부 역병지대",
	["Western Strand"] = "서부 해안",
	Westersea = "서해",
	Westfall = "서부 몰락지대",
	["Westfall Brigade"] = "서부 몰락지대 여단",
	["Westfall Brigade Encampment"] = "서부 몰락지대 여단 야영지",
	["Westfall Lighthouse"] = "서부 몰락지대 등대",
	["West Garrison"] = "서쪽 주둔지",
	["Westguard Inn"] = "서부경비대 여관",
	["Westguard Keep"] = "서부경비대 성채",
	["Westguard Turret"] = "서부경비대 포탑",
	["West Pavilion"] = "서쪽 천막",
	["West Pillar"] = "서쪽 기둥",
	["West Point Station"] = "서부 거점",
	["West Point Tower"] = "서부 경비탑",
	["Westreach Summit"] = "하늬자락 꼭대기",
	["West Sanctum"] = "서부 성소",
	["Westspark Workshop"] = "서부불꽃 작업장",
	["West Spear Tower"] = "서부창 경비탑",
	["West Spire"] = "서쪽 첨탑",
	["Westwind Lift"] = "서풍의 승강장",
	["Westwind Refugee Camp"] = "서풍의 피난민 행렬",
	["Westwind Rest"] = "서풍의 쉼터",
	Wetlands = "저습지",
	Wheelhouse = "물레방앗간",
	["Whelgar's Excavation Site"] = "웰가르의 발굴현장",
	["Whelgar's Retreat"] = "웰가르의 은거지",
	["Whispercloud Rise"] = "구름속삭임 전망대",
	["Whisper Gulch"] = "속삭임 협곡",
	["Whispering Forest"] = "속삭이는 숲",
	["Whispering Gardens"] = "속삭임의 정원",
	["Whispering Inlet"] = "속삭이는 만",
	["Whispering Shore"] = "속삭임의 해안",
	["Whispering Stones"] = "속삭이는 암석",
	["Whisperwind Grove"] = "바람속삭임 숲",
	["Whistling Grove"] = "휘파람 숲",
	["Whitebeard's Encampment"] = "화이트비어드 야영지",
	["Whitepetal Lake"] = "흰꽃잎 호수",
	["White Pine Trading Post"] = "흰 소나무 교역소",
	["Whitereach Post"] = "백사장 야영지",
	["Wildbend River"] = "성난굽이 강",
	["Wildervar Mine"] = "빌더바르 광산",
	["Wildflame Point"] = "거친불꽃 거점",
	["Wildgrowth Mangal"] = "야생수풀 늪지대",
	["Wildhammer Flag Room"] = "와일드해머 깃발 보관실",
	["Wildhammer Keep"] = "와일드해머 요새",
	["Wildhammer Stronghold"] = "와일드해머 성채",
	["Wildheart Point"] = "거친심장 거점",
	["Wildmane Water Well"] = "와일드메인 우물",
	["Wild Overlook"] = "황량한 전망대",
	["Wildpaw Cavern"] = "자갈발 동굴",
	["Wildpaw Ridge"] = "자갈발 마루",
	["Wilds' Edge Inn"] = "밀림의 끝자락 여관",
	["Wild Shore"] = "거친 해안",
	["Wildvine Marsh"] = "야생덩굴 습지대",
	["Wildwind Lake"] = "갈기바람 호수",
	["Wildwind Path"] = "갈기바람 길",
	["Wildwind Peak"] = "갈기바람 봉우리",
	["Windbreak Canyon"] = "갈기바람 협곡",
	["Windfury Ridge"] = "성난바람 마루",
	["Windrunner's Overlook"] = "윈드러너 전망대",
	["Windrunner Spire"] = "윈드러너 첨탑",
	["Windrunner Village"] = "윈드러너 마을",
	["Winds' Edge"] = "바람의 절벽",
	["Windshear Crag"] = "칼바람 바위산",
	["Windshear Heights"] = "칼바람 언덕",
	["Windshear Hold"] = "칼바람 요새",
	["Windshear Mine"] = "칼바람 광산",
	["Windshear Valley"] = "칼바람 골짜기",
	["Windspire Bridge"] = "바람봉 다리",
	["Windward Isle"] = "바람맞이 섬",
	["Windy Bluffs"] = "바람 절벽",
	["Windyreed Pass"] = "바람갈대 고개",
	["Windyreed Village"] = "바람갈대 마을",
	["Winterax Hold"] = "겨울도끼 요새",
	["Winterbough Glade"] = "겨울가지 숲",
	["Winterfall Village"] = "겨울눈 마을",
	["Winterfin Caverns"] = "겨울지느러미 동굴",
	["Winterfin Retreat"] = "겨울지느러미 은신처",
	["Winterfin Village"] = "겨울지느러미 마을",
	["Wintergarde Crypt"] = "윈터가드 납골당",
	["Wintergarde Keep"] = "윈터가드 성채",
	["Wintergarde Mausoleum"] = "윈터가드 묘지",
	["Wintergarde Mine"] = "윈터가드 광산",
	Wintergrasp = "겨울손아귀 호수",
	["Wintergrasp Fortress"] = "겨울손아귀 요새",
	["Wintergrasp River"] = "겨울손아귀 강",
	["Winterhoof Water Well"] = "윈터후프 우물",
	["Winter's Blossom"] = "겨울의 꽃",
	["Winter's Breath Lake"] = "겨울의 숨결 호수",
	["Winter's Edge Tower"] = "겨울 칼날 경비탑",
	["Winter's Heart"] = "겨울의 심장",
	Winterspring = "여명의 설원",
	["Winter's Terrace"] = "겨울 단상",
	["Witch Hill"] = "마녀 언덕",
	["Witch's Sanctum"] = "마녀의 성소",
	["Witherbark Caverns"] = "마른나무껍질 동굴",
	["Witherbark Village"] = "마른나무껍질 마을",
	["Withering Thicket"] = "메마른 숲",
	["Wizard Row"] = "마법사 지구",
	["Wizard's Sanctum"] = "마법사의 성소",
	["Wolf's Run"] = "늑대의 터",
	["Woodpaw Den"] = "덩굴발 소굴",
	["Woodpaw Hills"] = "덩굴발 언덕",
	["Wood's End Cabin"] = "막다른 숲 오두막",
	["Woods of the Lost"] = "길 잃은 자의 숲",
	Workshop = "작업장",
	["Workshop Entrance"] = "작업장 입구",
	["World's End Tavern"] = "세상의 끝 선술집",
	["Wrathscale Lair"] = "성난비늘 둥지",
	["Wrathscale Point"] = "성난비늘 거점",
	["Wreckage of the Silver Dawning"] = "은빛 새벽호의 잔해",
	["Wreck of Hellscream's Fist"] = "헬스크림의 철권호의 잔해",
	["Wreck of the Mist-Hopper"] = "안개돌이호의 잔해",
	["Wreck of the Skyseeker"] = "하늘추적자호의 잔해",
	["Wreck of the Vanguard"] = "선봉대호의 잔해",
	["Writhing Mound"] = "고뇌의 언덕",
	Writhingwood = "고통숲",
	["Wu-Song Village"] = "우쏭 마을",
	Wyrmbog = "용의 둥지",
	["Wyrmbreaker's Rookery"] = "고룡파괴자의 부화장",
	["Wyrmrest Summit"] = "고룡쉼터 정상",
	["Wyrmrest Temple"] = "고룡쉼터 사원",
	["Wyrmrest Temple - bottom to middle"] = "고룡쉼터 사원",
	["Wyrmrest Temple - bottom to top"] = "고룡쉼터 사원",
	["Wyrmrest Temple - middle to bottom"] = "고룡쉼터 사원",
	["Wyrmrest Temple - middle to top"] = "고룡쉼터 사원",
	["Wyrmrest Temple - top to bottom"] = "고룡쉼터 사원",
	["Wyrmrest Temple - top to middle"] = "고룡쉼터 사원",
	["Wyrms' Bend"] = "고룡굽이",
	["Wyrmscar Island"] = "고룡흉터 섬",
	["Wyrmskull Bridge"] = "고룡해골 다리",
	["Wyrmskull Tunnel"] = "고룡해골 굴",
	["Wyrmskull Village"] = "고룡해골 마을",
	["X-2 Pincer"] = "쌍집게발호",
	Xavian = "사비안",
	["Yan-Zhe River"] = "옌저 강",
	["Yeti Mountain Basecamp"] = "설인산 주둔지",
	["Yinying Village"] = "인잉 마을",
	Ymirheim = "이미르하임",
	["Ymiron's Seat"] = "이미론의 왕좌",
	["Yojamba Isle"] = "요잠바 섬",
	["Yowler's Den"] = "요울러의 소굴",
	["Zabra'jin"] = "자브라진",
	["Zaetar's Choice"] = "재타르의 선택",
	["Zaetar's Grave"] = "재타르의 무덤",
	["Zalashji's Den"] = "잘라쉬지의 굴",
	["Zalazane's Fall"] = "잘라제인의 몰락지",
	["Zane's Eye Crater"] = "제인의 눈동자 분화구",
	Zangarmarsh = "장가르 습지대",
	["Zangar Ridge"] = "장가르 마루",
	["Zan'vess"] = "잔베스",
	["Za'Tual"] = "자투알",
	["Zeb'Halak"] = "제브할락",
	["Zeb'Nowa"] = "제브노와",
	["Zeb'Sora"] = "제브소라",
	["Zeb'Tela"] = "제브텔라",
	["Zeb'tula"] = "제브툴라",
	["Zeb'Watha"] = "제브와타",
	["Zeppelin Crash"] = "비행선 추락지",
	Zeramas = "제라마스",
	["Zeth'Gor"] = "제스고르",
	["Zhu Province"] = "쥬 지구",
	["Zhu's Descent"] = "쥬의 내리막길",
	["Zhu's Watch"] = "쥬의 감시초소",
	["Ziata'jai Ruins"] = "지아타자이 폐허",
	["Zim'Abwa"] = "짐아브와",
	["Zim'bo's Hideout"] = "짐보의 은신처",
	["Zim'Rhuk"] = "짐루크",
	["Zim'Torga"] = "짐토르가",
	["Zol'Heb"] = "졸헤브",
	["Zol'Maz Stronghold"] = "졸마즈 요새",
	["Zoram'gar Outpost"] = "조람가르 전초기지",
	["Zouchin Province"] = "조우친 지구",
	["Zouchin Strand"] = "조우친 해안",
	["Zouchin Village"] = "조우친 마을",
	["Zul'Aman"] = "줄아만",
	["Zul'Drak"] = "줄드락",
	["Zul'Farrak"] = "줄파락",
	["Zul'Farrak Entrance"] = "줄파락 입구",
	["Zul'Gurub"] = "줄구룹",
	["Zul'Mashar"] = "줄마샤르",
	["Zun'watha"] = "준와타",
	["Zuuldaia Ruins"] = "줄다이아 폐허",
}

elseif GAME_LOCALE == "ptBR" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "Campo-base da 7ª Legião",
	["7th Legion Front"] = "Front da 7ª Legião",
	["7th Legion Submarine"] = "Submarino da 7ª Legião",
	["Abandoned Armory"] = "Armaria Abandonada",
	["Abandoned Camp"] = "Acampamento Abandonado",
	["Abandoned Mine"] = "Mina Abandonada",
	["Abandoned Reef"] = "Recife Abandonado",
	["Above the Frozen Sea"] = "Acima do Mar Congelado",
	["A Brewing Storm"] = "Tempestade Cervejeira",
	["Abyssal Breach"] = "Brecha Abissal",
	["Abyssal Depths"] = "Profundezas Abissais",
	["Abyssal Halls"] = "Salões Abissais",
	["Abyssal Maw"] = "Oceano Abissal",
	["Abyssal Maw Exterior"] = "Exterior do Oceano Abissal",
	["Abyssal Sands"] = "Areias Abissais",
	["Abyssion's Lair"] = "Covil de Abyssion",
	["Access Shaft Zeon"] = "Poço de Acesso Zeon",
	["Acherus: The Ebon Hold"] = "Áquerus: A Fortaleza de Ébano",
	["Addle's Stead"] = "Quinta dos Aguiar",
	["Aderic's Repose"] = "Repouso de Aderic",
	["Aerie Peak"] = "Ninho da Águia",
	["Aeris Landing"] = "Posto Aeris",
	["Agamand Family Crypt"] = "Cripta da Família Agamand",
	["Agamand Mills"] = "Moinhos dos Agamand",
	["Agmar's Hammer"] = "Martelo de Agmar",
	["Agmond's End"] = "Ruína de Agmundo",
	["Agol'watha"] = "Agol'watha",
	["A Hero's Welcome"] = "Recanto dos Heróis",
	["Ahn'kahet: The Old Kingdom"] = "Ahn'kahet: O Velho Reino",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Entrada de Ahn'kahet: O Velho Reino",
	["Ahn Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj"] = "Ahn'Qiraj",
	["Ahn'Qiraj Temple"] = "Templo de Ahn'Qiraj",
	["Ahn'Qiraj Terrace"] = "Terraço de Ahn'Qiraj",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ahn'Qiraj: O Reino Derrotado",
	["Akhenet Fields"] = "Campos Akhenet",
	["Aku'mai's Lair"] = "Covil de Aku'mai",
	["Alabaster Shelf"] = "Planalto de Alabastro",
	["Alcaz Island"] = "Ilha Alcaz",
	["Aldor Rise"] = "Terraço dos Aldor",
	Aldrassil = "Aldrassil",
	["Aldur'thar: The Desolation Gate"] = "Aldur'thar: O Portão da Desolação",
	["Alexston Farmstead"] = "Fazenda dos Aleixo",
	["Algaz Gate"] = "Portão de Algaz",
	["Algaz Station"] = "Estação Algaz",
	["A Little Patience"] = "Um Pouco de Paciência",
	["Allen Farmstead"] = "Fazenda dos Allen",
	["Allerian Post"] = "Posto Alleriano",
	["Allerian Stronghold"] = "Fortaleza Alleriana",
	["Alliance Base"] = "Base da Aliança",
	["Alliance Beach Daily Area"] = "Área de Missões Diárias da Praia da Aliança",
	["Alliance Beachhead"] = "Ponto de Desembarque da Aliança",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Centro da Aliança - Progressão do Cenário da Ilha Mogu",
	["Alliance Keep"] = "Bastilha da Aliança",
	["Alliance Mercenary Ship to Vashj'ir"] = "Nau Mercenária da Aliança para Vashj'ir",
	["Alliance PVP Barracks"] = "Quartel JxJ da Aliança",
	["All That Glitters Prospecting Co."] = "Tudo que Reluz Prospecções S.A",
	["Alonsus Chapel"] = "Capela Alonsus",
	["Altar of Ascension"] = "Altar da Ascensão",
	["Altar of Har'koa"] = "Altar de Har'koa",
	["Altar of Mam'toth"] = "Altar de Mam'toth",
	["Altar of Quetz'lun"] = "Altar de Quetz'lun",
	["Altar of Rhunok"] = "Altar de Rhunok",
	["Altar of Sha'tar"] = "Altar de Sha'tar",
	["Altar of Sseratus"] = "Altar de Sseratus",
	["Altar of Storms"] = "Altar das Tempestades",
	["Altar of the Blood God"] = "Altar do Deus Sanguinário",
	["Altar of Twilight"] = "Altar do Crepúsculo",
	["Alterac Mountains"] = "Montanhas de Alterac",
	["Alterac Valley"] = "Vale Alterac",
	["Alther's Mill"] = "Serraria Alther",
	["Amani Catacombs"] = "Catacumbas Amani",
	["Amani Mountains"] = "Montanhas Amani",
	["Amani Pass"] = "Desfiladeiro Amani",
	["Amberfly Bog"] = "Brejo Moscâmbar",
	["Amberglow Hollow"] = "Ravina Brilhâmbar",
	["Amber Ledge"] = "Promontório Âmbar",
	Ambermarsh = "Charco de Âmbar",
	Ambermill = "Lenhâmbar",
	["Amberpine Lodge"] = "Chalé do Pinho Âmbar",
	["Amber Quarry"] = "Mina de Âmbar",
	["Amber Research Sanctum"] = "Câmara de Pesquisas em Âmbar",
	["Ambershard Cavern"] = "Caverna Lascâmbar",
	["Amberstill Ranch"] = "Rancho Ambarmanso",
	["Amberweb Pass"] = "Desfiladeiro da Teia Âmbar",
	["Ameth'Aran"] = "Ameth'Aran",
	["Ammen Fields"] = "Campos Ammen",
	["Ammen Ford"] = "Vau Ammen",
	["Ammen Vale"] = "Vale Ammen",
	["Amphitheater of Anguish"] = "Anfiteatro da Angústia",
	-- ["Ampitheater of Anguish"] = "",
	["Ancestral Grounds"] = "Terras Ancestrais",
	["Ancestral Rise"] = "Colina Ancestral",
	["Ancient Courtyard"] = "Pátio dos Anciãos",
	["Ancient Zul'Gurub"] = "Antiga Zul'Gurub",
	["An'daroth"] = "An'daroth",
	["Andilien Estate"] = "Propriedade Andilien",
	Andorhal = "Andorhal",
	Andruk = "Andruk",
	["Angerfang Encampment"] = "Acampamento Presirada",
	["Angkhal Pavilion"] = "Pavilhão Angkhal",
	["Anglers Expedition"] = "Expedição dos Pescadores",
	["Anglers Wharf"] = "Cais dos Pescadores",
	["Angor Fortress"] = "Fortaleza Angor",
	["Ango'rosh Grounds"] = "Terras de Ango'rosh",
	["Ango'rosh Stronghold"] = "Fortaleza Ango'rosh",
	["Angrathar the Wrathgate"] = "Angrathar, o Portão da Ira",
	["Angrathar the Wrath Gate"] = "Angrathar, o Portão da Ira",
	["An'owyn"] = "An'owyn",
	["An'telas"] = "An'telas",
	["Antonidas Memorial"] = "Memorial a Antônidas",
	Anvilmar = "Sidermar",
	["Anvil of Conflagration"] = "Bigorna da Conflagração",
	["Apex Point"] = "Apogeu",
	["Apocryphan's Rest"] = "Descanso do Apócrifo",
	["Apothecary Camp"] = "Acampamento da Sociedade dos Boticários",
	["Applebloom Tavern"] = "Taberna Flor de Maçã",
	["Arathi Basin"] = "Bacia Arathi",
	["Arathi Highlands"] = "Planalto Arathi",
	["Arcane Pinnacle"] = "Pináculo Arcano",
	["Archmage Vargoth's Retreat"] = "Retiro do Arquimago Vargoth",
	["Area 52"] = "Área 52",
	["Arena Floor"] = "Pátio da Arena",
	["Arena of Annihilation"] = "Arena da Aniquilação",
	["Argent Pavilion"] = "Pavilhão Argênteo",
	["Argent Stand"] = "Fortaleza Argêntea",
	["Argent Tournament Grounds"] = "Campos do Torneio Argênteo",
	["Argent Vanguard"] = "Vanguarda Argêntea",
	["Ariden's Camp"] = "Acampamento de Ariden",
	["Arikara's Needle"] = "Agulha de Arikara",
	["Arklonis Ridge"] = "Pico Arklonis",
	["Arklon Ruins"] = "Ruínas Arklon",
	["Arriga Footbridge"] = "Pinguela do Arriga",
	["Arsad Trade Post"] = "Entreposto Arsad",
	["Ascendant's Rise"] = "Promontório do Ascendente",
	["Ascent of Swirling Winds"] = "Ascensão dos Ventos Revoltos",
	["Ashen Fields"] = "Campo das Cinzas",
	["Ashen Lake"] = "Lago Pálido",
	Ashenvale = "Vale Gris",
	["Ashwood Lake"] = "Lago Freixo",
	["Ashwood Post"] = "Posto Freixo",
	["Aspen Grove Post"] = "Posto Álamo",
	["Assault on Shaol'mara"] = "Ataque a Shaol'mara",
	["Assault on Zan'vess"] = "Ataque a Zan'vess",
	["Assault on Zeb'tula"] = "Ataque a Zeb'tula",
	Astranaar = "Astranaar",
	["Ata'mal Terrace"] = "Terraço de Ata'mal",
	Athenaeum = "Ateneu",
	["Atrium of the Heart"] = "Átrio do Coração",
	["Atulhet's Tomb"] = "Tumba de Atul-het",
	["Auberdine Refugee Camp"] = "Acampamento de Refugiados de Auberdine",
	["Auburn Bluffs"] = "Penhascos Ruivos",
	["Auchenai Crypts"] = "Catacumbas Auchenai",
	["Auchenai Grounds"] = "Território Auchenai",
	Auchindoun = "Auchindoun",
	["Auchindoun: Auchenai Crypts"] = "Auchindoun: Catacumbas Auchenai",
	["Auchindoun - Auchenai Crypts Entrance"] = "Entrada de Auchindoun: Catacumbas Auchenai",
	["Auchindoun: Mana-Tombs"] = "Auchindoun: Tumbas de Mana",
	["Auchindoun - Mana-Tombs Entrance"] = "Entrada de Auchindoun: Tumbas de Mana",
	["Auchindoun: Sethekk Halls"] = "Auchindoun: Salões dos Sethekk",
	["Auchindoun - Sethekk Halls Entrance"] = "Entrada de Auchindoun: Salões dos Sethekk",
	["Auchindoun: Shadow Labyrinth"] = "Auchindoun: Labirinto Soturno",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Entrada de Auchindoun: Labirinto Soturno",
	["Auren Falls"] = "Cachoeira Auren",
	["Auren Ridge"] = "Pico Auren",
	["Autumnshade Ridge"] = "Cordilheira Sombra do Outono",
	["Avalanchion's Vault"] = "Abóbada de Avalanchion",
	Aviary = "Aviário",
	["Axis of Alignment"] = "Eixo do Alinhamento",
	Axxarien = "Axxarien",
	["Azjol-Nerub"] = "Azjol-Nerub",
	["Azjol-Nerub Entrance"] = "Entrada de Azjol-Nerub",
	Azshara = "Azshara",
	["Azshara Crater"] = "Cratera de Azshara",
	["Azshara's Palace"] = "Palácio de Azshara",
	["Azurebreeze Coast"] = "Costa da Brisa Azul",
	["Azure Dragonshrine"] = "Santuário Dragônico Lazúli",
	["Azurelode Mine"] = "Mina Veioazul",
	["Azuremyst Isle"] = "Ilha Névoa Lazúli",
	["Azure Watch"] = "Entreposto Lazúli",
	["Backbreaker Bay"] = "Baía Quebradorso",
	Badlands = "Ermos",
	["Bael'dun Digsite"] = "Sítio de Escavação de Bael'Dun",
	["Bael'dun Keep"] = "Bastilha Bael'Dun",
	["Baelgun's Excavation Site"] = "Sítio de Escavação de Baelgun",
	["Bael Modan"] = "Bael Modan",
	["Bael Modan Excavation"] = "Sítio Arqueológico Bael Modan",
	["Bahrum's Post"] = "Posto de Bahrum",
	["Balargarde Fortress"] = "Fortaleza Balargarde",
	Baleheim = "Baleheim",
	["Balejar Watch"] = "Posto Balejar",
	["Balia'mah Ruins"] = "Ruínas de Balia'mah",
	["Bal'lal Ruins"] = "Ruínas de Bal'lal",
	["Balnir Farmstead"] = "Fazenda dos Balnir",
	Bambala = "Bambala",
	["Band of Acceleration"] = "Faixa de Aceleração",
	["Band of Alignment"] = "Faixa de Alinhamento",
	["Band of Transmutation"] = "Faixa de Transmutação",
	["Band of Variance"] = "Faixa de Alternância",
	["Ban'ethil Barrow Den"] = "Gruta de Ban'ethil",
	["Ban'ethil Barrow Descent"] = "Descida da Gruta de Ban'ethil",
	["Ban'ethil Hollow"] = "Ravina de Ban'ethil",
	Bank = "Banco",
	["Banquet Grounds"] = "Sala de Banquetes",
	["Ban'Thallow Barrow Den"] = "Gruta de Ban'Thallow",
	["Baradin Base Camp"] = "Base de Operações de Baradin",
	["Baradin Bay"] = "Baía de Baradin",
	["Baradin Hold"] = "Guarnição Baradin",
	Barbershop = "Barbearia",
	["Barov Family Vault"] = "Catacumba da Família Barov",
	["Bashal'Aran"] = "Bashal'Aran",
	["Bashal'Aran Collapse"] = "Colapso de Bashal'Aran",
	["Bash'ir Landing"] = "Patamar de Bash'ir",
	["Bastion Antechamber"] = "Antecâmara do Bastião",
	["Bathran's Haunt"] = "Refúgio de Bathran",
	["Battlefront Provisions"] = "Provisões da Frente de Batalha",
	["Battle on the High Seas"] = "Batalha em Alto Mar",
	["Battle Ring"] = "Ringue de Batalha",
	Battlescar = "Chaga de Guerra",
	["Battlescar Spire"] = "Pináculo Chaga de Guerra",
	["Battlescar Valley"] = "Vale Chaga de Guerra",
	["Bay of Echoes"] = "Baía dos Ecos",
	["Bay of Storms"] = "Baía das Tempestades",
	["Bear's Head"] = "Campo dos Ursos",
	["Beauty's Lair"] = "Covil da Beleza",
	["Beeble's Wreck"] = "Destroços do Beeble",
	["Beezil's Wreck"] = "Destroços de Beezil",
	["Befouled Terrace"] = "Terraço Conspurcado",
	["Beggar's Haunt"] = "Refúgio dos Mendigos",
	["Beneath The Double Rainbow"] = "Sob o Arco-íris Duplo",
	["Beneath the Pit"] = "Abaixo do Fosso",
	["Beren's Peril"] = "Cilada de Beren",
	["Bernau's Happy Fun Land"] = "Divertilândia de Bernau",
	["Beryl Coast"] = "Costa Berília",
	["Beryl Egress"] = "Egresso de Berília",
	["Beryl Point"] = "Penhasco de Berília",
	["Beth'mora Ridge"] = "Pico Beth'mora",
	["Beth'tilac's Lair"] = "Covil de Beth'tilac",
	["Biel'aran Ridge"] = "Crista Biel'aran",
	["Big Beach Brew Bash"] = "Cacetada de Cerveja na Costa",
	["Big Blossom Excavation"] = "Escavação do Florescer Perene",
	["Big Blossom Mine"] = "Mina Florescer Perene",
	["Bilgewater Beach"] = "Praia Borraquilha",
	["Bilgewater Harbor"] = "Ancoradouro Borraquilha",
	["Bilgewater Lumber Yard"] = "Serraria Borraquilha",
	["Bilgewater Port"] = "Porto Borraquilha",
	["Binan Brew & Stew"] = "Cocções e Infusões de Binan",
	["Binan Village"] = "Vila Binan",
	["Bitter Reaches"] = "Confins Amargos",
	["Bittertide Lake"] = "Lago Maremarga",
	["Bizmo's Brawlpub"] = "Bar Brigalhada do Bizmo",
	["Black Channel Marsh"] = "Pântano do Canal Negro",
	["Blackchar Cave"] = "Caverna Calcinar",
	["Black Drake Roost"] = "Poleiro do Draco Preto",
	["Blackfathom Camp"] = "Acampamento das Profundezas Negras",
	["Blackfathom Deeps"] = "Profundezas Negras",
	["Blackfathom Deeps Entrance"] = "Entrada de Profundezas Negras",
	["Blackhoof Village"] = "Aldeia Casco Negro",
	["Blackhorn's Penance"] = "Penitência do Chifre Negro",
	["Blackmaw Hold"] = "Gruta Bocanera",
	["Black Ox Temple"] = "Templo do Boi Negro",
	["Blackriver Logging Camp"] = "Madeireira Rio Negro",
	["Blackrock Caverns"] = "Caverna Rocha Negra",
	["Blackrock Caverns Entrance"] = "Entrada da Caverna Rocha Negra",
	["Blackrock Depths"] = "Abismo Rocha Negra",
	["Blackrock Depths Entrance"] = "Entrada do Abismo Rocha Negra",
	["Blackrock Mountain"] = "Montanha Rocha Negra",
	["Blackrock Pass"] = "Estreito Rocha Negra",
	["Blackrock Spire"] = "Pico da Rocha Negra",
	["Blackrock Spire Entrance"] = "Entrada do Pico da Rocha Negra",
	["Blackrock Stadium"] = "Estádio Rocha Negra",
	["Blackrock Stronghold"] = "Fortaleza Rocha Negra",
	["Blacksand Spillway"] = "Vertedouro Areia Negra",
	["Blacksilt Shore"] = "Praia Trevareia",
	Blacksmith = "Ferraria",
	["Blackstone Span"] = "Arcada Pedranegra",
	["Black Temple"] = "Templo Negro",
	["Black Tooth Hovel"] = "Casebre Dente Preto",
	Blackwatch = "Guarda Negra",
	["Blackwater Cove"] = "Angra Aguanegra",
	["Blackwater Shipwrecks"] = "Destroços de Aguanegra",
	["Blackwind Lake"] = "Lago Ventonegro",
	["Blackwind Landing"] = "Campo de Pouso Ventonegro",
	["Blackwind Valley"] = "Vale Ventonegro",
	["Blackwing Coven"] = "Conciliábulo do Asa Negra",
	["Blackwing Descent"] = "Descenso do Asa Negra",
	["Blackwing Lair"] = "Covil Asa Negra",
	["Blackwolf River"] = "Rio Lobonegro",
	["Blackwood Camp"] = "Aldeia Bosquenero",
	["Blackwood Den"] = "Antro dos Bosqueneros",
	["Blackwood Lake"] = "Lago Bosquenero",
	["Bladed Gulch"] = "Ravina das Lâminas",
	["Bladefist Bay"] = "Baía Carpunhal",
	["Bladelord's Retreat"] = "Refúgio do Mestre das Lâminas",
	["Blades & Axes"] = "Lâminas e Machados",
	["Blade's Edge Arena"] = "Arena da Lâmina Afiada",
	["Blade's Edge Mountains"] = "Montanhas da Lâmina Afiada",
	["Bladespire Grounds"] = "Terras dos Giralança",
	["Bladespire Hold"] = "Bastião Giralança",
	["Bladespire Outpost"] = "Acampamento Giralança",
	["Blades' Run"] = "Ladeira Afiada",
	["Blade Tooth Canyon"] = "Garganta da Presa Cortante",
	Bladewood = "Mata Cortante",
	["Blasted Lands"] = "Barreira do Inferno",
	["Bleak Hollow"] = "Vale Desolado",
	["Bleeding Hollow Ruins"] = "Ruínas dos Olhos Sangrentos",
	["Bleeding Vale"] = "Vale Sangrento",
	["Bleeding Ziggurat"] = "Zigurate Sangrento",
	["Blistering Pool"] = "Poço Virulento",
	["Bloodcurse Isle"] = "Ilha do Sangue Maldito",
	["Blood Elf Tower"] = "Torre dos Elfos Sangrentos",
	["Bloodfen Burrow"] = "Antro do Dinossangue",
	Bloodgulch = "Ravina de Sangue",
	["Bloodhoof Village"] = "Aldeia Casco Sangrento",
	["Bloodied Crossing"] = "Encruzilhada Rubra",
	["Blood in the Snow"] = "Sangue na Neve",
	["Bloodmaul Camp"] = "Base dos Malho Sangrento",
	["Bloodmaul Outpost"] = "Posto Avançado Malho Sangrento",
	["Bloodmaul Ravine"] = "Barranco Malho Sangrento",
	["Bloodmoon Isle"] = "Ilha Sangreluna",
	["Bloodmyst Isle"] = "Ilha Névoa Rubra",
	["Bloodscale Enclave"] = "Enclave Sangrescama",
	["Bloodscale Grounds"] = "Terras dos Sangrescamas",
	["Bloodspore Plains"] = "Planícies Sanguesporo",
	["Bloodtalon Shore"] = "Praia do Garrassangre",
	["Bloodtooth Camp"] = "Aldeia Dente Sangrento",
	["Bloodvenom Falls"] = "Salto da Peçonha",
	["Bloodvenom Post"] = "Bloodvenom Post",
	["Bloodvenom Post "] = "Posto Peçonha",
	["Bloodvenom River"] = "Rio Peçonha",
	["Bloodwash Cavern"] = "Caverna da Maré Sangrenta",
	["Bloodwash Fighting Pits"] = "Fossos de Luta Maré Sangrenta",
	["Bloodwash Shrine"] = "Ermida da Praia Maré Sangrenta",
	["Blood Watch"] = "Entreposto Rubro",
	["Bloodwatcher Point"] = "Posto Vigília de Sangue",
	Bluefen = "Charneca Azul",
	["Bluegill Marsh"] = "Pântano Peixeazul",
	["Blue Sky Logging Grounds"] = "Madeireira Céu Azul",
	["Bluff of the South Wind"] = "Penhasco do Vento do Sul",
	["Bogen's Ledge"] = "Covil do Bogen",
	Bogpaddle = "Brejo do Goblin",
	["Boha'mu Ruins"] = "Ruínas de Boha'mu",
	["Bolgan's Hole"] = "Covil do Bolgan",
	["Bolyun's Camp"] = "Acampamento do Bolyun",
	["Bonechewer Ruins"] = "Ruínas Mascaosso",
	["Bonesnap's Camp"] = "Acampamento do Quebraossos",
	["Bones of Grakkarond"] = "Ossos de Grakkarond",
	["Bootlegger Outpost"] = "Vilarejo dos Falsários",
	["Booty Bay"] = "Angra do Butim",
	["Borean Tundra"] = "Tundra Boreana",
	["Bor'gorok Outpost"] = "Posto Avançado Bor'gorok",
	["Bor's Breath"] = "Vale de Bor",
	["Bor's Breath River"] = "Rio Vale de Bor",
	["Bor's Fall"] = "Cascata de Bor",
	["Bor's Fury"] = "Fúria de Bor",
	["Borune Ruins"] = "Ruínas de Borune",
	["Bough Shadow"] = "Sombrarrama",
	["Bouldercrag's Refuge"] = "Refúgio do Petrenedo",
	["Boulderfist Hall"] = "Forte Punho de Pedra",
	["Boulderfist Outpost"] = "Posto Avançado Punho de Pedra",
	["Boulder'gor"] = "Pedre'gor",
	["Boulder Hills"] = "Montes dos Penedos",
	["Boulder Lode Mine"] = "Mina Veio do Pedregulho",
	["Boulder'mok"] = "Rocha'mok",
	["Boulderslide Cavern"] = "Caverna da Avalanche",
	["Boulderslide Ravine"] = "Ravina da Avalanche",
	["Bozzle's Wreck"] = "Destroços do Bozó",
	["Brackenwall Village"] = "Aldeia Muralha Verde",
	["Brackwell Pumpkin Patch"] = "Plantação de Abóboras dos Braga",
	["Brambleblade Ravine"] = "Ravina da Lâmina Espinhenta",
	Bramblescar = "Espinheira",
	["Brann's Base-Camp"] = "Acampamento do Brann",
	["Brashtide Attack Fleet"] = "Esquadra de Assalto da Mareforte",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Esquadra de Assalto da Mareforte (Força de Fora)",
	["Brave Wind Mesa"] = "Chapada Vento Valente",
	["Brawl'gar Arena"] = "Arena de Brig'ga Fea",
	["Brazie Farmstead"] = "Fazenda do Zeca Rioka",
	["Brewmoon Festival"] = "Festival da Cerveja da Lua",
	["Brewnall Village"] = "Aldeia da Cevada",
	["Bridge of Souls"] = "Ponte das Almas",
	["Brightwater Lake"] = "Lago Águas Claras",
	["Brightwood Grove"] = "Bosque Brilhante",
	Brill = "Montalvo",
	["Brill Town Hall"] = "Prefeitura de Montalvo",
	["Bristlelimb Enclave"] = "Enclave dos Ericerdos",
	["Bristlelimb Village"] = "Aldeia dos Ericerdos",
	["Broken Commons"] = "Pátio Partido",
	["Broken Hill"] = "Monte Partido",
	["Broken Pillar"] = "Pilar Partido",
	["Broken Spear Village"] = "Vila da Lança Partida",
	["Broken Wilds"] = "Espinhaço Inóspito",
	["Broketooth Outpost"] = "Entreposto Presa Quebrada",
	["Bronzebeard Encampment"] = "Acampamento Barbabronze",
	["Bronze Dragonshrine"] = "Santuário Dragônico Bronze",
	["Browman Mill"] = "Engenho Assombrado",
	["Brunnhildar Village"] = "Aldeia Brunnhildar",
	["Bucklebree Farm"] = "Fazenda dos Bucklebree",
	["Budd's Dig"] = "Sítio de Escavação de Bino",
	["Burning Blade Coven"] = "Covil da Lâmina Ardente",
	["Burning Blade Ruins"] = "Ruínas da Lâmina Ardente",
	["Burning Steppes"] = "Estepes Ardentes",
	["Butcher's Sanctum"] = "Sala do Carniceiro",
	["Butcher's Stand"] = "Barraca do Açougueiro",
	["Caer Darrow"] = "Castro das Flechas",
	["Caldemere Lake"] = "Lago Caldemere",
	["Calston Estate"] = "Propriedade Calston",
	["Camp Aparaje"] = "Aldeia Apareje",
	["Camp Ataya"] = "Aldeia Ataya",
	["Camp Boff"] = "Acampamento Barf",
	["Camp Broketooth"] = "Aldeia Presa Quebrada",
	["Camp Cagg"] = "Acampamento Cang",
	["Camp E'thok"] = "Aldeia E'thok",
	["Camp Everstill"] = "Acampamento Lago Plácido",
	["Camp Gormal"] = "Acampamento Gormal",
	["Camp Kosh"] = "Acampamento Kosh",
	["Camp Mojache"] = "Aldeia Mojache",
	["Camp Mojache Longhouse"] = "Casa Comunal da Aldeia Mojache",
	["Camp Narache"] = "Aldeia Narache",
	["Camp Nooka Nooka"] = "Aldeia Nuka Nuka",
	["Camp of Boom"] = "Acampamento do Dr. Cabum",
	["Camp Onequah"] = "Aldeia Onequah",
	["Camp Oneqwah"] = "Aldeia Oneqwah",
	["Camp Sungraze"] = "Acampamento Triscassol",
	["Camp Tunka'lo"] = "Aldeia Tunka'lo",
	["Camp Una'fe"] = "Aldeia Una'fe",
	["Camp Winterhoof"] = "Aldeia Casco Invernal",
	["Camp Wurg"] = "Acampamento Wurg",
	Canals = "Canais",
	["Cannon's Inferno"] = "Labaredas do Canhão",
	["Cantrips & Crows"] = "Urubus e Urucubacas",
	["Cape of Lost Hope"] = "Cabo da Má Esperança",
	["Cape of Stranglethorn"] = "Cabo do Espinhaço",
	["Capital Gardens"] = "Jardins Capitais",
	["Carrion Hill"] = "Monte Carniçal",
	["Cartier & Co. Fine Jewelry"] = "Joias Finas Cartier e Associados",
	Cataclysm = "Cataclismo", -- Needs review
	["Cathedral of Darkness"] = "Catedral das Trevas",
	["Cathedral of Light"] = "Catedral da Luz",
	["Cathedral Quarter"] = "Distrito da Catedral",
	["Cathedral Square"] = "Praça da Catedral",
	["Cattail Lake"] = "Lago Taboa",
	["Cauldros Isle"] = "Ilha Cauldros",
	["Cave of Mam'toth"] = "Caverna de Mam'toth",
	["Cave of Meditation"] = "Caverna da Meditação",
	["Cave of the Crane"] = "Caverna da Garça",
	["Cave of Words"] = "Caverna das Palavras",
	["Cavern of Endless Echoes"] = "Caverna dos Ecos Infinitos",
	["Cavern of Mists"] = "Caverna das Brumas",
	["Caverns of Time"] = "Cavernas do Tempo",
	["Celestial Enclave"] = "Enclave Celestial",
	["Celestial Ridge"] = "Pico Celestial",
	["Cenarion Enclave"] = "Enclave Cenariano",
	["Cenarion Hold"] = "Forte Cenariano",
	["Cenarion Post"] = "Posto Cenariano",
	["Cenarion Refuge"] = "Refúgio Cenariano",
	["Cenarion Thicket"] = "Mata Cenariana",
	["Cenarion Watchpost"] = "Guarita Cenariana",
	["Cenarion Wildlands"] = "Terras Virgens Cenarianas",
	["Central Bridge"] = "Ponte Central",
	["Chamber of Ancient Relics"] = "Câmara das Relíquias Ancestrais",
	["Chamber of Atonement"] = "Câmara da Redenção",
	["Chamber of Battle"] = "Câmara de Batalha",
	["Chamber of Blood"] = "Câmara de Sangue",
	["Chamber of Command"] = "Câmara de Comando",
	["Chamber of Enchantment"] = "Câmara do Encantamento",
	["Chamber of Enlightenment"] = "Câmara da Iluminação",
	["Chamber of Fanatics"] = "Câmara dos Fanáticos",
	["Chamber of Incineration"] = "Câmara de Incineração",
	["Chamber of Masters"] = "Câmara dos Mestres",
	["Chamber of Prophecy"] = "Câmara da Profecia",
	["Chamber of Reflection"] = "Câmara da Reflexão",
	["Chamber of Respite"] = "Câmara da Trégua",
	["Chamber of Summoning"] = "Câmara de Evocação",
	["Chamber of Test Namesets"] = "Câmara de Testar Namesets",
	["Chamber of the Aspects"] = "Câmara dos Aspectos",
	["Chamber of the Dreamer"] = "Câmara do Sonhador",
	["Chamber of the Moon"] = "Câmara da Lua",
	["Chamber of the Restless"] = "Câmara dos Incansáveis",
	["Chamber of the Stars"] = "Câmara das Estrelas",
	["Chamber of the Sun"] = "Câmara do Sol",
	["Chamber of Whispers"] = "Câmara dos Sussurros",
	["Chamber of Wisdom"] = "Câmara da Sabedoria",
	["Champion's Hall"] = "Salão dos Campeões",
	["Champions' Hall"] = "Salão dos Campeões",
	["Chapel Gardens"] = "Jardins da Capela",
	["Chapel of the Crimson Flame"] = "Capela da Chama Carmesim",
	["Chapel Yard"] = "Pátio da Capela",
	["Charred Outpost"] = "Posto Calcinado",
	["Charred Rise"] = "Alto Calcinado",
	["Chill Breeze Valley"] = "Vale Brisa Álgida",
	["Chillmere Coast"] = "Costa da Água Fria",
	["Chillwind Camp"] = "Acampamento Ventogelante",
	["Chillwind Point"] = "Morro do Ventogelante",
	Chiselgrip = "Laceragarra",
	["Chittering Coast"] = "Costa Trêmula",
	["Chow Farmstead"] = "Fazenda do Chow",
	["Churning Gulch"] = "Ravina Trêmula",
	["Circle of Blood"] = "Círculo Sangrento",
	["Circle of Blood Arena"] = "Arena do Círculo Sangrento",
	["Circle of Bone"] = "Círculo de Ossos",
	["Circle of East Binding"] = "Círculo de União Oriental",
	["Circle of Inner Binding"] = "Círculo de União Interno",
	["Circle of Outer Binding"] = "Círculo de União Externo",
	["Circle of Scale"] = "Círculo de Escamas",
	["Circle of Stone"] = "Círculo de Pedras",
	["Circle of Thorns"] = "Círculo de Espinhos",
	["Circle of West Binding"] = "Círculo de União Ocidental",
	["Circle of Wills"] = "Círculo dos Desejos",
	City = "Cidade",
	["City of Ironforge"] = "Cidade de Altaforja",
	["City Siege - Mogu Island Progression Scenario"] = "Cerco à Cidade - Progressão do Cenário da Ilha Mogu",
	["Clan Watch"] = "Vila dos Clãs",
	["Class Quest"] = "Missão de Classe",
	["Claytön's WoWEdit Land"] = "Terra do WoWEdit do Claytön",
	["Cleft of Shadow"] = "Antro das Sombras",
	["Cliffspring Falls"] = "Quedas de Fontescarpa",
	["Cliffspring Hollow"] = "Antro de Fontescarpa",
	["Cliffspring River"] = "Rio Fontescarpa",
	["Cliffwalker Post"] = "Posto Andarilho da Montanha",
	["Cloudstrike Dojo"] = "Dojo Golpe da Nuvem",
	["Cloudtop Terrace"] = "Terraço das Nuvens",
	["Coast of Echoes"] = "Costa do Eco",
	["Coast of Idols"] = "Costa dos Ídolos",
	["Coilfang Reservoir"] = "Reservatório Presacurva",
	["Coilfang: Serpentshrine Cavern"] = "Presacurva: Caverna do Serpentário",
	["Coilfang: The Slave Pens"] = "Presacurva: Pátio dos Escravos",
	["Coilfang - The Slave Pens Entrance"] = "Entrada de Presacurva: Pátio dos Escravos",
	["Coilfang: The Steamvault"] = "Presacurva: Câmara dos Vapores",
	["Coilfang - The Steamvault Entrance"] = "Entrada de Presacurva: Câmara dos Vapores",
	["Coilfang: The Underbog"] = "Presacurva: Brejo Oculto",
	["Coilfang - The Underbog Entrance"] = "Entrada de Presacurva: Brejo Oculto",
	["Coilskar Cistern"] = "Cisterna Serpentálios",
	["Coilskar Point"] = "Pontal dos Serpentálios",
	Coldarra = "Gelarra",
	["Coldarra Ledge"] = "Plataforma Gelarra",
	["Coldbite Burrow"] = "Toca da Mordida Gelada",
	["Cold Hearth Manor"] = "Casarão Lar Glacial",
	["Coldridge Pass"] = "Caminho de Cristálgida",
	["Coldridge Valley"] = "Vale Cristálgida",
	["Coldrock Quarry"] = "Pedreira da Rocha Fria",
	["Coldtooth Mine"] = "Mina Dentefrio",
	["Coldwind Heights"] = "Planalto Vento Frio",
	["Coldwind Pass"] = "Desfiladeiro do Vento Frio",
	["Collin's Test"] = "Teste de Collin",
	["Command Center"] = "Centro de Comando",
	["Commons Hall"] = "Câmara dos Comuns",
	["Condemned Halls"] = "Salões Condenados",
	["Conqueror's Terrace"] = "Terraço do Conquistador",
	["Conquest Hold"] = "Forte da Conquista",
	["Containment Core"] = "Núcleo de Contenção",
	["Cooper Residence"] = "Residência dos Curvelo",
	["Coral Garden"] = "Jardim dos Corais",
	["Cordell's Enchanting"] = "Encantamento de Cordel",
	["Corin's Crossing"] = "Cruzamento de Corin",
	["Corp'rethar: The Horror Gate"] = "Corp'rethar: O Portão do Horror",
	["Corrahn's Dagger"] = "Adaga de Corrahn",
	Cosmowrench = "Chave do Cosmos",
	["Court of Bones"] = "Paço dos Ossos",
	["Court of the Highborne"] = "A Corte dos Altaneiros",
	["Court of the Sun"] = "Pátio do Sol",
	["Courtyard of Lights"] = "Pátio das Luzes",
	["Courtyard of the Ancients"] = "Pátio dos Anciãos",
	["Cradle of Chi-Ji"] = "Berço de Chi-Ji",
	["Cradle of the Ancients"] = "Berço dos Anciãos",
	["Craftsmen's Terrace"] = "Terraço dos Artesãos",
	["Crag of the Everliving"] = "Rochedo do Sempre-vivo",
	["Cragpool Lake"] = "Lago do Rochedo",
	["Crane Wing Refuge"] = "Refúgio Asa da Garça",
	["Crash Site"] = "Ponto de Impacto",
	["Crescent Hall"] = "Salão do Crescente",
	["Crimson Assembly Hall"] = "Auditório Carmesim",
	["Crimson Expanse"] = "Vastidão Carmesim",
	["Crimson Watch"] = "Vigília Carmesim",
	Crossroads = "Encruzilhada", -- Needs review
	["Crowley Orchard"] = "Horto dos Crowley",
	["Crowley Stable Grounds"] = "Estábulo dos Crowley",
	["Crown Guard Tower"] = "Torre da Coroa",
	["Crucible of Carnage"] = "Caldeirão da Carnificina",
	["Crumbling Depths"] = "Abismos Esfacelados",
	["Crumbling Stones"] = "Pedras Esfaceladas",
	["Crusader Forward Camp"] = "Campo Avançado dos Cruzados",
	["Crusader Outpost"] = "Guarita dos Cruzados",
	["Crusader's Armory"] = "Armaria do Cruzado",
	["Crusader's Chapel"] = "Capela do Cruzado",
	["Crusader's Landing"] = "Ancoradouro dos Cruzados",
	["Crusader's Outpost"] = "Guarita do Cruzado",
	["Crusaders' Pinnacle"] = "Pináculo dos Cruzados",
	["Crusader's Run"] = "Caminho do Cruzado",
	["Crusader's Spire"] = "Pináculo dos Cruzados",
	["Crusaders' Square"] = "Praça dos Cruzados",
	Crushblow = "Cachamorra",
	["Crushcog's Arsenal"] = "Arsenal do Esmagrenagem",
	["Crushridge Hold"] = "Bastilha Esmagaterra",
	Crypt = "Masca",
	["Crypt of Forgotten Kings"] = "Cripta dos Reis Esquecidos",
	["Crypt of Remembrance"] = "Cripta da Memória",
	["Crystal Lake"] = "Lago de Cristal",
	["Crystalline Quarry"] = "Pedreira Cristalina",
	["Crystalsong Forest"] = "Floresta do Canto Cristalino",
	["Crystal Spine"] = "Serra dos Cristais",
	["Crystalvein Mine"] = "Mina Veia de Cristal",
	["Crystalweb Cavern"] = "Caverna da Teia de Cristal",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "Casa dos Bricabraques",
	["Cursed Depths"] = "Profundezas Amaldiçoadas",
	["Cursed Hollow"] = "Clareira Maldita",
	["Cut-Throat Alley"] = "Beco do Degolador",
	["Cyclone Summit"] = "Pico do Ciclone",
	["Dabyrie's Farmstead"] = "Fazenda dos Dabyrie",
	["Daggercap Bay"] = "Baía das Adagas",
	["Daggerfen Village"] = "Aldeia Lamadaga",
	["Dagger in the Dark"] = "Adaga no Escuro",
	["Daggermaw Canyon"] = "Garganta Gorjadaga",
	["Dagger Pass"] = "Desfiladeiro da Adaga",
	["Dais of Conquerors"] = "Tribuna dos Conquistadores",
	Dalaran = "Dalaran",
	["Dalaran Arena"] = "Arena de Dalaran",
	["Dalaran City"] = "Dalaran",
	["Dalaran Crater"] = "Cratera de Dalaran",
	["Dalaran Floating Rocks"] = "Pedras Flutuantes de Dalaran",
	["Dalaran Island"] = "Ilha de Dalaran",
	["Dalaran Merchant's Bank"] = "Banco Mercantil de Dalaran",
	["Dalaran Sewers"] = "Esgotos de Dalaran",
	["Dalaran Visitor Center"] = "Centro para Visitantes de Dalaran",
	["Dalson's Farm"] = "Fazenda dos Dalson",
	["Damplight Cavern"] = "Caverna Lúmida",
	["Damplight Chamber"] = "Câmara Lúmida",
	["Dampsoil Burrow"] = "Túneis Terra Molhada",
	["Dandred's Fold"] = "Nicho de Dandred",
	["Dargath's Demise"] = "Destino de Dargath",
	["Darkbreak Cove"] = "Covil do Abismo Sombrio",
	["Darkcloud Pinnacle"] = "Pináculo da Nuvem Negra",
	["Darkcrest Enclave"] = "Enclave Cristanegra",
	["Darkcrest Shore"] = "Praia da Cristanegra",
	["Dark Heart of Pandaria"] = "Coração Sombrio de Pandária",
	["Dark Iron Highway"] = "Estrada do Ferro Negro",
	["Darkmist Cavern"] = "Caverna Névoa Negra",
	["Darkmist Ruins"] = "Ruínas Névoa Negra",
	["Darkmoon Boardwalk"] = "Tablado de Negraluna",
	["Darkmoon Deathmatch"] = "Vale-tudo de Negraluna",
	["Darkmoon Deathmatch Pit (PH)"] = "Ringue do Vale-tudo de Negraluna (PH)",
	["Darkmoon Faire"] = "Feira de Negraluna",
	["Darkmoon Island"] = "Ilha de Negraluna",
	["Darkmoon Island Cave"] = "Caverna da Ilha de Negraluna",
	["Darkmoon Path"] = "Trilha de Negraluna",
	["Darkmoon Pavilion"] = "Pavilhão de Negraluna",
	Darkshire = "Vila Sombria",
	["Darkshire Town Hall"] = "Prefeitura de Vila Sombria",
	Darkshore = "Costa Negra",
	["Darkspear Hold"] = "Cidadela dos Lançanegra",
	["Darkspear Isle"] = "Ilha Lançanegra",
	["Darkspear Shore"] = "Praia dos Lançanegra",
	["Darkspear Strand"] = "Praia Lançanegra",
	["Darkspear Training Grounds"] = "Campo de Treinamento Lançanegra",
	["Darkwhisper Gorge"] = "Garganta do Sussurro Sombrio",
	["Darkwhisper Pass"] = "Desfiladeiro do Sussurro Sombrio",
	["Darnassian Base Camp"] = "Base Darnassiana",
	Darnassus = "Darnassus",
	["Darrow Hill"] = "Monte das Flechas",
	["Darrowmere Lake"] = "Lago das Flechas",
	Darrowshire = "Vila das Flechas",
	["Darrowshire Hunting Grounds"] = "Campos de Caça da Vila das Flechas",
	["Darsok's Outpost"] = "Posto Avançado de Darsok",
	["Dawnchaser Retreat"] = "Refúgio Caça-manhã",
	["Dawning Lane"] = "Alameda Alvorecescente",
	["Dawning Wood Catacombs"] = "Catacumbas do Bosque da Aurora",
	["Dawnrise Expedition"] = "Expedição Alvorada",
	["Dawn's Blossom"] = "Flor da Manhã",
	["Dawnseeker Promontory"] = "Promontório Buscalva",
	["Dawnseeker's Promontory"] = "Promontório Buscalva",
	["Dawn's Reach"] = "Confins da Aurora",
	["Dawnstar Spire"] = "Torre Aurestela",
	["Dawnstar Village"] = "Vila Aurestela",
	["Daxil's Dig"] = "Escavação de Daxil",
	["D-Block"] = "Bloco D",
	["Deadeye Shore"] = "Praia do Olho Seco",
	["Deadman's Crossing"] = "Encruzilhada do Defunto",
	["Dead Man's Hole"] = "Antro do Morto",
	Deadmines = "Minas Mortas",
	["Deadtalker's Plateau"] = "Platô dos Parlamorte",
	["Deadwind Pass"] = "Trilha do Vento Morto",
	["Deadwind Ravine"] = "Garganta do Vento Morto",
	["Deadwood Village"] = "Vila da Lenha Morta",
	["Deathbringer's Rise"] = "Teleporte para o Alto do Mortífero",
	["Death Cultist Base Camp"] = "Campo-base do Sectário da Morte",
	["Deathforge Tower"] = "Torre da Forja da Morte",
	Deathknell = "Plangemortis",
	["Deathmatch Pavilion"] = "Pavilhão do Vale-tudo",
	Deatholme = "Cidadela da Morte",
	["Death's Breach"] = "Vanguarda da Morte",
	["Death's Door"] = "Porta da Morte",
	["Death's Hand Encampment"] = "Posto Avançado Mão da Morte",
	["Deathspeaker's Watch"] = "Vigília do Morta-voz",
	["Death's Rise"] = "Beiral da Morte",
	["Death's Stand"] = "Campo da Morte",
	["Death's Step"] = "Degrau da Morte",
	["Death's Watch Waystation"] = "Estação Vigia da Morte",
	Deathwing = "Asa da Morte",
	["Deathwing's Fall"] = "Queda do Asa da Morte",
	["Deep Blue Observatory"] = "Observatório Azul do Mar",
	["Deep Elem Mine"] = "Mina Elenfunda",
	["Deepfin Ridge"] = "Crista das Barbatanas",
	Deepholm = "Geodomo",
	["Deephome Ceiling"] = "Teto de Geodomo",
	["Deepmist Grotto"] = "Gruta Densanévoa",
	["Deeprun Tram"] = "Metrô Correfundo",
	["Deepwater Tavern"] = "Taberna Aguafunda",
	["Deepwind Gorge"] = "Desfiladeiro do Vendaval",
	["Defense of the Alehouse"] = "Defesa da Taberna",
	["Defense Of The Ale House BG"] = "Defesa da Taberna CB",
	["Defias Hideout"] = "Esconderijo Défias",
	["Defiler's Den"] = "Covil do Profanador",
	["D.E.H.T.A. Encampment"] = "Acampamento da DruiPA",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "Cânion do Demônio Caído",
	["Demon Fall Ridge"] = "Serra do Demônio Caído",
	["Demont's Place"] = "Recanto de Demont",
	["Den of Defiance"] = "Covil do Desafio",
	["Den of Dying"] = "Tocas da Morte",
	["Den of Haal'esh"] = "Antro de Haal'esh",
	["Den of Iniquity"] = "Covil da Inquietude",
	["Den of Mortal Delights"] = "Covil dos Prazeres Mortais",
	["Den of Sorrow"] = "Covil da Tristeza",
	["Den of Sseratus"] = "Antro de Sseratus",
	["Den of the Caller"] = "Covil do Arauto",
	["Den of the Devourer"] = "Covil do Devorador",
	["Den of the Disciples"] = "Covil dos Discípulos",
	["Den of the Unholy"] = "Covil do Profano",
	["Derelict Caravan"] = "Caravana Abandonada",
	["Derelict Manor"] = "Mansão Arruinada",
	["Derelict Strand"] = "Praia do Naufrágio",
	["Designer Island"] = "Ilha dos Designers",
	Desolace = "Desolação",
	["Desolation Hold"] = "Forte da Desolação",
	["Detention Block"] = "Bloco de Detenção",
	["Development Land"] = "Área em Desenvolvimento",
	["Diamondhead River"] = "Rio Diamante",
	["Diamond Island"] = "Ilha Diamante",
	["Dig One"] = "Sítio Um",
	["Dig Three"] = "Sítio Três",
	["Dig Two"] = "Sítio Dois",
	["Direforge Hill"] = "Monte Umbraforja",
	["Direhorn Post"] = "Posto Chifrebravo",
	["Dire Maul"] = "Gládio Cruel",
	["Dire Maul - Capital Gardens Entrance"] = "Entrada do Gládio Cruel - Jardins Capitais",
	["Dire Maul - East"] = "Gládio Cruel – Leste",
	["Dire Maul - Gordok Commons Entrance"] = "Entrada do Gládio Cruel - Pátio Gordok",
	["Dire Maul - North"] = "Gládio Cruel – Norte",
	["Dire Maul - Warpwood Quarter Entrance"] = "Entrada do Gládio Cruel - Distrito Lenhatorta",
	["Dire Maul - West"] = "Gládio Cruel – Oeste",
	Diremoor = "Charneca Turva",
	["Dire Strait"] = "Estreito Hostil",
	["Disciple's Enclave"] = "Enclave do Discípulo",
	Docks = "Docas",
	["Dojani River"] = "Rio Dojani",
	Dolanaar = "Dolanaar",
	["Dome Balrissa"] = "Domo Balrissa",
	["Domination Point"] = "Ponto de Dominação",
	["Donna's Kitty Shack"] = "Casinha do Gatinho da Dina",
	["DO NOT USE"] = "DO NOT USE",
	["Dookin' Grounds"] = "Baixios Toletudis",
	["Doom's Vigil"] = "Vigia do Destino",
	["Dorian's Outpost"] = "Posto Avançado de Dorian",
	["Draco'dar"] = "Draco'dar",
	["Draenei Ruins"] = "Ruínas Draeneicas",
	["Draenethyst Mine"] = "Mina de Draenetista",
	["Draenil'dur Village"] = "Vila Draenil'dur",
	Dragonblight = "Ermo das Serpes",
	["Dragonflayer Pens"] = "Pátio do Esfola-dragão",
	["Dragonmaw Base Camp"] = "Campo-base Presa do Dragão",
	["Dragonmaw Flag Room"] = "Sala da Bandeira Presa do Dragão",
	["Dragonmaw Forge"] = "Forja Presa do Dragão",
	["Dragonmaw Fortress"] = "Fortaleza Presa do Dragão",
	["Dragonmaw Garrison"] = "Guarnição Presa do Dragão",
	["Dragonmaw Gates"] = "Portões Presa do Dragão",
	["Dragonmaw Pass"] = "Desfiladeiro da Presa do Dragão",
	["Dragonmaw Port"] = "Porto Presa do Dragão",
	["Dragonmaw Skyway"] = "Ponte Aérea Presa do Dragão",
	["Dragonmaw Stronghold"] = "Fortaleza Presa do Dragão",
	["Dragons' End"] = "Findragões",
	["Dragon's Fall"] = "Aldeia do Dragão Arruinado",
	["Dragon's Mouth"] = "Boca do Dragão",
	["Dragon Soul"] = "Alma Dragônica",
	["Dragon Soul Raid - East Sarlac"] = "Raide da Alma Dragônica – Sarlac Leste",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Raide da Alma Dragônica – Base do Templo do Repouso das Serpes",
	["Dragonspine Peaks"] = "Pico Espinodraco",
	["Dragonspine Ridge"] = "Serra de Espinodraco",
	["Dragonspine Tributary"] = "Afluente Espinodraco",
	["Dragonspire Hall"] = "Salão do Espinodrago",
	["Drak'Agal"] = "Draz'Agal",
	["Draka's Fury"] = "Fúria de Draka",
	["Drak'atal Passage"] = "Passagem de Drak'atal",
	["Drakil'jin Ruins"] = "Ruínas de Drakil'jin",
	["Drak'Mabwa"] = "Drak'Mabwa",
	["Drak'Mar Lake"] = "Lago Drak'Mar",
	["Draknid Lair"] = "Covil Draconídeo",
	["Drak'Sotra"] = "Drak'Sotra",
	["Drak'Sotra Fields"] = "Campos de Drak'Sotra",
	["Drak'Tharon Keep"] = "Bastilha Drak'Tharon",
	["Drak'Tharon Keep Entrance"] = "Entrada da Bastilha Drak'Tharon",
	["Drak'Tharon Overlook"] = "Mirante Drak'Tharon",
	["Drak'ural"] = "Drak'ural",
	["Dread Clutch"] = "Garra do Pavor",
	["Dread Expanse"] = "Vastidão Medonha",
	["Dreadmaul Furnace"] = "Fornalha Malhorrendo",
	["Dreadmaul Hold"] = "Domínio de Malhorrendo",
	["Dreadmaul Post"] = "Posto Malhorrendo",
	["Dreadmaul Rock"] = "Rochedo Malhorrendo",
	["Dreadmist Camp"] = "Acampamento Brumedo",
	["Dreadmist Den"] = "Covil de Brumedo",
	["Dreadmist Peak"] = "Morro de Brumedo",
	["Dreadmurk Shore"] = "Costa Tenebrosa",
	["Dread Terrace"] = "Terraço do Medo",
	["Dread Wastes"] = "Ermo do Medo",
	["Dreadwatch Outpost"] = "Posto Mirante do Medo",
	["Dream Bough"] = "Ramo de Morfeu",
	["Dreamer's Pavilion"] = "Pavilhão do Sonhador",
	["Dreamer's Rest"] = "Repouso do Sonhador",
	["Dreamer's Rock"] = "Rocha do Sonhador",
	Drudgetown = "Labútia",
	["Drygulch Ravine"] = "Barranco da Ravina Seca",
	["Drywhisker Gorge"] = "Garganta Seca",
	["Dubra'Jin"] = "Dubra'Jin",
	["Dun Algaz"] = "Dun Algaz",
	["Dun Argol"] = "Dun Argol",
	["Dun Baldar"] = "Dun Baldar",
	["Dun Baldar Pass"] = "Desfiladeiro de Dun Baldar",
	["Dun Baldar Tunnel"] = "Túnel de Dun Baldar",
	["Dunemaul Compound"] = "Complexo Dunamalho",
	["Dunemaul Recruitment Camp"] = "Campo de Recrutamento de Dunamalho",
	["Dun Garok"] = "Dun Garok",
	["Dun Mandarr"] = "Dun Mandarr",
	["Dun Modr"] = "Dun Modr",
	["Dun Morogh"] = "Dun Morogh",
	["Dun Niffelem"] = "Dun Niffelem",
	["Dunwald Holdout"] = "Abrigo dos Dunwald",
	["Dunwald Hovel"] = "Cabana de Dunwald",
	["Dunwald Market Row"] = "Travessa do Comércio de Dunwald",
	["Dunwald Ruins"] = "Ruínas Dunwald",
	["Dunwald Town Square"] = "Praça da Cidade de Dunwald",
	["Durnholde Keep"] = "Forte do Desterro",
	Durotar = "Durotar",
	Duskhaven = "Refúgio do Ocaso",
	["Duskhowl Den"] = "Gruta do Uivo da Noite",
	["Dusklight Bridge"] = "Ponte Luz do Poente",
	["Dusklight Hollow"] = "Clareira Luz do Poente",
	["Duskmist Shore"] = "Praia da Névoa Crepuscular",
	["Duskroot Fen"] = "Pântano da Raiz do Ocaso",
	["Duskwither Grounds"] = "Terras do Ocaso",
	["Duskwither Spire"] = "Torre do Ocaso",
	Duskwood = "Floresta do Crepúsculo",
	["Dustback Gorge"] = "Garganta Poenta",
	["Dustbelch Grotto"] = "Gruta Arrota-pó",
	["Dustfire Valley"] = "Vale Calcinado",
	["Dustquill Ravine"] = "Ravina do Pó de Espinheiro",
	["Dustwallow Bay"] = "Baía de Vadeoso",
	["Dustwallow Marsh"] = "Pântano Vadeoso",
	["Dustwind Cave"] = "Caverna Sopravento",
	["Dustwind Dig"] = "Escavação de Sopravento",
	["Dustwind Gulch"] = "Ravina de Sopravento",
	["Dwarven District"] = "Distrito dos Anões",
	["Eagle's Eye"] = "Olho da Águia",
	["Earthshatter Cavern"] = "Caverna Quebraterra",
	["Earth Song Falls"] = "Cachoeiras do Canção Telúrica",
	["Earth Song Gate"] = "Portal da Canção da Terra",
	["Eastern Bridge"] = "Ponte Oriental",
	["Eastern Kingdoms"] = "Reinos do Leste",
	["Eastern Plaguelands"] = "Terras Pestilentas Orientais",
	["Eastern Strand"] = "Praia Oriental",
	["East Garrison"] = "Guarnição Leste",
	["Eastmoon Ruins"] = "Ruínas de Lunaleste",
	["East Pavilion"] = "Pavilhão Leste",
	["East Pillar"] = "Pilar Leste",
	["Eastpoint Tower"] = "Torre Leste",
	["East Sanctum"] = "Sacrário do Leste",
	["Eastspark Workshop"] = "Oficina do Parque Leste",
	["East Spire"] = "Torre Leste",
	["East Supply Caravan"] = "Caravana Oriental de Suprimentos",
	["Eastvale Logging Camp"] = "Madeireira Vale do Leste",
	["Eastwall Gate"] = "Portão da Muralha Leste",
	["Eastwall Tower"] = "Torre da Muralha Leste",
	["Eastwind Rest"] = "Repouso do Vento Leste",
	["Eastwind Shore"] = "Costa da Lestada",
	["Ebon Hold"] = "Fortaleza de Ébano",
	["Ebon Watch"] = "Posto Ébano",
	["Echo Cove"] = "Angra do Eco",
	["Echo Isles"] = "Ilhas do Eco",
	["Echomok Cavern"] = "Caverna Ecomok",
	["Echo Reach"] = "Rincão do Eco",
	["Echo Ridge Mine"] = "Mina da Serra do Eco",
	["Eclipse Point"] = "Ponta do Eclipse",
	["Eclipsion Fields"] = "Campos Eclipsion",
	["Eco-Dome Farfield"] = "Eco-domo Campolonge",
	["Eco-Dome Midrealm"] = "Eco-domo Terramédia",
	["Eco-Dome Skyperch"] = "Eco-domo Pouso do Céu",
	["Eco-Dome Sutheron"] = "Eco-domo Sutheron",
	["Elder Rise"] = "Platô dos Anciãos",
	["Elders' Square"] = "Praça dos Anciãos",
	["Eldreth Row"] = "Travessa Eldreth",
	["Eldritch Heights"] = "Cerro Lúgubre",
	["Elemental Plateau"] = "Platô Elemental",
	["Elementium Depths"] = "Profundezas de Elemêntio",
	Elevator = "Elevador",
	["Elrendar Crossing"] = "Passagem de Elrendar",
	["Elrendar Falls"] = "Cachoeira Elrendar",
	["Elrendar River"] = "Rio Elrendar",
	["Elwynn Forest"] = "Floresta de Elwynn",
	["Ember Clutch"] = "Ninho Incandescente",
	Emberglade = "Campo das Cinzas",
	["Ember Spear Tower"] = "Torre da Lança Incandescente",
	["Emberstone Mine"] = "Mina da Pedra Incandescente",
	["Emberstone Village"] = "Vila da Pedra Incandescente",
	["Emberstrife's Den"] = "Covil de Ardeluta",
	["Emerald Dragonshrine"] = "Santuário Dragônico Esmeralda",
	["Emerald Dream"] = "Sonho Esmeralda",
	["Emerald Forest"] = "Floresta Esmeralda",
	["Emerald Sanctuary"] = "Santuário Esmeralda",
	["Emperor Rikktik's Rest"] = "Descanso do Imperador Rikktik",
	["Emperor's Omen"] = "Agouro do Imperador",
	["Emperor's Reach"] = "Domínio do Imperador",
	["End Time"] = "Fim dos Tempos",
	["Engineering Labs"] = "Laboratório de Engenharia", -- Needs review
	["Engineering Labs "] = "Laboratório de Engenharia",
	["Engine of Nalak'sha"] = "Engenho de Nalak'sha",
	["Engine of the Makers"] = "Maquinário dos Criadores",
	["Entryway of Time"] = "Entrada do Tempo",
	["Ethel Rethor"] = "Ethel Rethor",
	["Ethereal Corridor"] = "Corredor Etéreo",
	["Ethereum Staging Grounds"] = "Bivaques do Eteréum",
	["Evergreen Trading Post"] = "Entreposto Perene",
	Evergrove = "Arvoredo Eterno",
	Everlook = "Visteterna",
	["Eversong - Duskwither Teleport"] = "Canto Eterno - Teleporte de Ocaso",
	["Eversong Woods"] = "Floresta do Canto Eterno",
	["Excavation Center"] = "Centro de Escavações",
	["Excavation Lift"] = "Elevador da Escavação",
	["Exclamation Point"] = "Ponto de Exclamação",
	["Expedition Armory"] = "Arsenal da Expedição",
	["Expedition Base Camp"] = "Acampamento da Expedição",
	["Expedition Point"] = "Posto da Expedição",
	["Explorers' League Digsite"] = "Escavação da Liga dos Exploradores",
	["Explorers' League Outpost"] = "Posto Avançado da Liga dos Exploradores",
	["Exposition Pavilion"] = "Pavilhão de Exposição",
	["Eye of Eternity"] = "Olho da Eternidade",
	["Eye of the Storm"] = "Olho da Tormenta 2.0",
	["Fairbreeze Village"] = "Vila de Brisabela",
	["Fairbridge Strand"] = "Praia Pontebela",
	["Falcon Watch"] = "Vigília do Falcão",
	["Falconwing Inn"] = "Estalagem da Asa do Falcão",
	["Falconwing Square"] = "Praça Asa do Falcão",
	["Faldir's Cove"] = "Enseada de Faldir",
	["Falfarren River"] = "Rio Felfarren",
	["Fallen Sky Lake"] = "Lago Céu Caído",
	["Fallen Sky Ridge"] = "Serra do Céu Caído",
	["Fallen Temple of Ahn'kahet"] = "Templo de Ahn'kahet",
	["Fall of Return"] = "Queda do Retorno",
	["Fallowmere Inn"] = "Estalagem Marárida",
	["Fallow Sanctuary"] = "Retiro Alqueivado",
	["Falls of Ymiron"] = "Salto de Ymiron",
	["Fallsong Village"] = "Vila Canção do Outono",
	["Falthrien Academy"] = "Academia Falthrien",
	Familiars = "Familiares",
	["Faol's Rest"] = "Repouso de Faol",
	["Fargaze Mesa"] = "Chapada Vista-longa",
	["Fargodeep Mine"] = "Mina Vailafundo",
	Farm = "Fazenda",
	Farshire = "Algures",
	["Farshire Fields"] = "Campos de Algures",
	["Farshire Lighthouse"] = "Farol de Algures",
	["Farshire Mine"] = "Mina de Algures",
	["Farson Hold"] = "Forte Farson",
	["Farstrider Enclave"] = "Enclave dos Andarilhos",
	["Farstrider Lodge"] = "Pavilhão dos Andarilhos",
	["Farstrider Retreat"] = "Retiro dos Andarilhos",
	["Farstriders' Enclave"] = "Enclave dos Andarilhos",
	["Farstriders' Square"] = "Largo dos Andarilhos",
	["Farwatcher's Glen"] = "Vale do Atalaia",
	["Farwatch Overlook"] = "Mirante do Atalaia",
	["Far Watch Post"] = "Posto Remoto",
	["Fear Clutch"] = "Garra do Medo",
	["Featherbeard's Hovel"] = "Casa de Barbapena",
	Feathermoon = "Plumaluna",
	["Feathermoon Stronghold"] = "Domínio de Plumaluna",
	["Fe-Feng Village"] = "Vila de Fe-Feng",
	["Felfire Hill"] = "Monte Fogovil",
	["Felpaw Village"] = "Aldeia Patavil",
	["Fel Reaver Ruins"] = "Ruínas do Aníquilus",
	["Fel Rock"] = "Pedra Vil",
	["Felspark Ravine"] = "Ravina de Vil Fagulha",
	["Felstone Field"] = "Campo Pedravil",
	Felwood = "Selva Maleva",
	["Fenris Isle"] = "Ilha de Fenris",
	["Fenris Keep"] = "Castelo Fenris",
	Feralas = "Feralas",
	["Feralfen Village"] = "Vila do Charco das Feras",
	["Feral Scar Vale"] = "Vale dos Abomináveis",
	["Festering Pools"] = "Poços Purulentos",
	["Festival Lane"] = "Alameda do Festival",
	["Feth's Way"] = "Trilha de Feth",
	["Field of Korja"] = "Campo de Korja",
	["Field of Strife"] = "Campo de Disputa",
	["Fields of Blood"] = "Campos de Sangue",
	["Fields of Honor"] = "Campos de Honra",
	["Fields of Niuzao"] = "Campos de Niuzao",
	Filming = "Filmagem",
	["Final Gate - Mogu Island Progression Scenario"] = "Portão Final - Progressão do Cenário da Ilha Mogu",
	["Firebeard Cemetery"] = "Cemitério de Barbarruiva",
	["Firebeard's Patrol"] = "Patrulha do Barbarruiva",
	["Firebough Nook"] = "Gruta Galhareda",
	["Fire Camp Bataar"] = "Guarnição Avançada Bataar",
	["Fire Camp Gai-Cho"] = "Guarnição Avançada Gai-Cho",
	["Fire Camp Ordo"] = "Guarnição Avançada Ordo",
	["Fire Camp Osul"] = "Guarnição Avançada Osul",
	["Fire Camp Ruqin"] = "Guarnição Avançada Ruqin",
	["Fire Camp Yongqi"] = "Guarnição Avançada Yongqi",
	["Firegut Furnace"] = "Fornalha Pirobucho",
	Firelands = "Terras do Fogo",
	["Firelands Forgeworks"] = "Forjas das Terras do Fogo",
	["Firelands Hatchery"] = "Ninhal das Terras do Fogo",
	["Firelands Terrain 2"] = "Terreno 3 das Terras do Fogo",
	["Fireplume Peak"] = "Pico da Coluna de Fogo",
	["Fire Plume Ridge"] = "Pico Penacho de Fogo",
	["Fireplume Trench"] = "Vala Penacho de Fogo", -- Needs review
	["Fire Scar Shrine"] = "Santuário Cicatriz de Fogo",
	["Fire Stone Mesa"] = "Chapada Rocha de Fogo",
	["Firestone Point"] = "Posto Pedra de Fogo",
	["Firewatch Ridge"] = "Cerro da Sentinela de Fogo",
	["Firewing Point"] = "Pontal Asardente",
	["First Bank of Kezan"] = "Banco Central de Kezan",
	["First Legion Forward Camp"] = "Acampamento Avançado da Primeira Legião",
	["First to Your Aid"] = "Socorro em Primeiro Lugar",
	["Fishing Village"] = "Colônia de Pescadores",
	["Fizzcrank Airstrip"] = "Pista de Pouso do Biela",
	["Fizzcrank Pumping Station"] = "Estação Bombeadora do Biela",
	["Fizzle & Pozzik's Speedbarge"] = "Barcódromo do Xabu e do Relé",
	["Fjorn's Anvil"] = "Bigorna de Fjorn",
	Flamebreach = "Fenda das Chamas",
	["Flame Crest"] = "Monte Candente",
	["Flamestar Post"] = "Posto Flamestrela",
	["Flamewatch Tower"] = "Torre da Guarda Ígnea",
	["Flavor - Stormwind Harbor - Stop"] = "Flavor - Porto de Ventobravo - Fim",
	["Fleshrender's Workshop"] = "Oficina do Imolador",
	["Foothold Citadel"] = "Cidadela do Esteio",
	["Footman's Armory"] = "Armaria do Soldado",
	["Force Interior"] = "Força Interior",
	["Fordragon Hold"] = "Forte Fordragon",
	["Forest Heart"] = "Coração da Floresta",
	["Forest's Edge"] = "Boca da Mata",
	["Forest's Edge Post"] = "Posto Boca da Mata",
	["Forest Song"] = "Cantilenda",
	["Forge Base: Gehenna"] = "Base-forja: Geena",
	["Forge Base: Oblivion"] = "Base-forja: Oblívio",
	["Forge Camp: Anger"] = "Campo-forja: Fúria",
	["Forge Camp: Fear"] = "Campo-forja: Medo",
	["Forge Camp: Hate"] = "Campo-forja: Ódio",
	["Forge Camp: Mageddon"] = "Campo-forja: Megido",
	["Forge Camp: Rage"] = "Campo-forja: Raiva",
	["Forge Camp: Terror"] = "Campo-forja: Terror",
	["Forge Camp: Wrath"] = "Campo-forja: Ira",
	["Forge of Fate"] = "Forja do Destino",
	["Forge of the Endless"] = "Forja dos Eternos",
	["Forgewright's Tomb"] = "Tumba do Forjífice",
	["Forgotten Depths"] = "Profundezas Abandonadas",
	["Forgotten Hill"] = "Colina Esquecida",
	["Forgotten Mire"] = "Charco Esquecido",
	["Forgotten Passageway"] = "Passadiço Esquecido",
	["Forlorn Cloister"] = "Claustro Esquecido",
	["Forlorn Hut"] = "Cabana do Eremita",
	["Forlorn Ridge"] = "Cordilheira Esquecida",
	["Forlorn Rowe"] = "Morro dos Esquecidos",
	["Forlorn Spire"] = "Espiral Solitária",
	["Forlorn Woods"] = "Bosque Esquecido",
	["Formation Grounds"] = "Campos de Formação",
	["Forsaken Forward Command"] = "Comando Avançado dos Renegados",
	["Forsaken High Command"] = "Alto Comando dos Renegados",
	["Forsaken Rear Guard"] = "Retaguarda dos Renegados",
	["Fort Livingston"] = "Forte Pedraviva",
	["Fort Silverback"] = "Forte Costalva",
	["Fort Triumph"] = "Forte Triunfo",
	["Fortune's Fist"] = "Punho da Sorte",
	["Fort Wildervar"] = "Forte Vildervar",
	["Forward Assault Camp"] = "Base de Ataque Dianteira",
	["Forward Command"] = "Comando Avançado",
	["Foulspore Cavern"] = "Caverna Esporelama",
	["Foulspore Pools"] = "Poços Esporelama",
	["Fountain of the Everseeing"] = "Fonte da Vidência Eterna",
	["Fox Grove"] = "Bosque da Raposa",
	["Fractured Front"] = "Front Partido",
	["Frayfeather Highlands"] = "Planalto Esfiapluma",
	["Fray Island"] = "Ilha da Peleja",
	["Frazzlecraz Motherlode"] = "Veio Lufa-lufa",
	["Freewind Post"] = "Aldeia Vento Livre",
	["Frenzyheart Hill"] = "Morro dos Feralma",
	["Frenzyheart River"] = "Rio dos Feralma",
	["Frigid Breach"] = "Pontal Frio",
	["Frostblade Pass"] = "Desfiladeiro de Cunhalva",
	["Frostblade Peak"] = "Pico de Cunhalva",
	["Frostclaw Den"] = "Covil do Garra de Gelo",
	["Frost Dagger Pass"] = "Desfiladeiro Punhal de Gelo",
	["Frostfield Lake"] = "Lago Congelado",
	["Frostfire Hot Springs"] = "Fontes Termais de Fogofrio",
	["Frostfloe Deep"] = "Caverna Flotagelo",
	["Frostgrip's Hollow"] = "Ravina Gélida",
	Frosthold = "Fortaleza Gelada",
	["Frosthowl Cavern"] = "Caverna Uivo de Gelo",
	["Frostmane Front"] = "Front Jubafria",
	["Frostmane Hold"] = "Fortaleza Jubafria",
	["Frostmane Hovel"] = "Choupana Jubafria",
	["Frostmane Retreat"] = "Refúgio Jubafria",
	Frostmourne = "Gélido Lamento",
	["Frostmourne Cavern"] = "Caverna Gélido Lamento",
	["Frostsaber Rock"] = "Pedra Sabre-de-gelo",
	["Frostwhisper Gorge"] = "Garganta dos Sussurros Gelados",
	["Frostwing Halls"] = "Salões da Asa Gélida",
	["Frostwolf Graveyard"] = "Cemitério Lobo do Gelo",
	["Frostwolf Keep"] = "Bastilha Lobo do Gelo",
	["Frostwolf Pass"] = "Desfiladeiro Lobo do Gelo",
	["Frostwolf Tunnel"] = "Túnel do Lobo do Gelo",
	["Frostwolf Village"] = "Aldeia Lobo do Gelo",
	["Frozen Reach"] = "Confins Glaciais",
	["Fungal Deep"] = "Abismo do Limo",
	["Fungal Rock"] = "Pedra do Limo",
	["Funggor Cavern"] = "Caverna Fungor",
	["Furien's Post"] = "Posto de Furien",
	["Furlbrow's Pumpkin Farm"] = "Plantação de Abóboras do Taturana",
	["Furnace of Hate"] = "Fornalha do Destino",
	["Furywing's Perch"] = "Ninho do Furialada",
	Fuselight = "Fazfagulha",
	["Fuselight-by-the-Sea"] = "Fazfagulha Litorânea",
	["Fu's Pond"] = "Lago de Fu",
	Gadgetzan = "Geringontzan",
	["Gahrron's Withering"] = "Aridez de Garrão",
	["Gai-Cho Battlefield"] = "Campo de Batalha Gai-Cho",
	["Galak Hold"] = "Castelo Galath",
	["Galakrond's Rest"] = "Repouso de Galakrond",
	["Galardell Valley"] = "Vale Galardell",
	["Galen's Fall"] = "Ruína de Galen",
	["Galerek's Remorse"] = "Remorso de Galerek",
	["Galewatch Lighthouse"] = "Farol de Ventinela",
	["Gallery of Treasures"] = "Galeria dos Tesouros",
	["Gallows' Corner"] = "Canto da Forca",
	["Gallows' End Tavern"] = "Taberna Finda Forca",
	["Gallywix Docks"] = "Docas de Gallywix",
	["Gallywix Labor Mine"] = "Mina de Trabalhos Forçados de Gallywix",
	["Gallywix Pleasure Palace"] = "Palacete de Gallywix",
	["Gallywix's Villa"] = "Mansão do Gallywix",
	["Gallywix's Yacht"] = "Iate de Gallywix",
	["Galus' Chamber"] = "Câmara de Galus",
	["Gamesman's Hall"] = "Salão de Jogos",
	Gammoth = "Gamute",
	["Gao-Ran Battlefront"] = "Front de Gao-Ran",
	Garadar = "Garadar",
	["Gar'gol's Hovel"] = "Casebre do Gar'gol",
	Garm = "Garm",
	["Garm's Bane"] = "Perdição de Garm",
	["Garm's Rise"] = "Ladeira de Garm",
	["Garren's Haunt"] = "Sítio dos Garren",
	["Garrison Armory"] = "Armaria da Guarnição",
	["Garrosh'ar Advance"] = "Avanço Garrosh'ar",
	["Garrosh'ar Point"] = "Posto Garrosh'ar",
	["Garrosh's Landing"] = "Ancoradouro de Garrosh",
	["Garvan's Reef"] = "Recife Garvan",
	["Gate of Echoes"] = "Portão dos Ecos",
	["Gate of Endless Spring"] = "Portão da Primavera Eterna",
	["Gate of Hamatep"] = "Portões de Hamatep",
	["Gate of Lightning"] = "Pórtico dos Relâmpagos",
	["Gate of the August Celestials"] = "Portão dos Celestiais Majestosos",
	["Gate of the Blue Sapphire"] = "Pórtico da Safira Azul",
	["Gate of the Green Emerald"] = "Pórtico da Esmeralda Verde",
	["Gate of the Purple Amethyst"] = "Pórtico da Ametista Roxa",
	["Gate of the Red Sun"] = "Pórtico do Sol Escarlate",
	["Gate of the Setting Sun"] = "Portal do Sol Poente",
	["Gate of the Yellow Moon"] = "Pórtico da Lua Amarela",
	["Gates of Ahn'Qiraj"] = "Portões de Ahn'Qiraj",
	["Gates of Ironforge"] = "Portões de Altaforja",
	["Gates of Sothann"] = "Portões de Sothann",
	["Gauntlet of Flame"] = "Castigo das Chamas",
	["Gavin's Naze"] = "Promontório de Gavin",
	["Geezle's Camp"] = "Acampamento do Zé Ruela",
	["Gelkis Village"] = "Aldeia Gelkis",
	["General Goods"] = "Mercadorias Diversas",
	["General's Terrace"] = "Terraço do General",
	["Ghostblade Post"] = "Posto Lâmina Espectral",
	Ghostlands = "Terra Fantasma",
	["Ghost Walker Post"] = "Entreposto do Espírito que Anda",
	["Giant's Run"] = "Passo do Gigante", -- Needs review
	["Giants' Run"] = "Passo do Gigante",
	["Gilded Fan"] = "Leque Dourado",
	["Gillijim's Isle"] = "Ilha de Gillijim",
	["Gilnean Coast"] = "Costa Guilneana",
	["Gilnean Stronghold"] = "Fortaleza Guilneana",
	Gilneas = "Guilnéas",
	Gilneas2 = "Guilnéas3",
	["Gilneas City"] = "Guilnéas",
	["Gilneas (Do Not Reuse)"] = "Guilnéas (Do Not Reuse)",
	["Gilneas Liberation Front Base Camp"] = "Campo-base da Frente de Libertação de Guilnéas",
	GilneasPhase1 = "GuilnéasFase1",
	GilneasPhase2 = "GuilnéasFase2",
	["Gimorak's Den"] = "Covil de Gimorak",
	Gjalerbron = "Gjalerbron",
	Gjalerhorn = "Gjalehorn",
	["Glacial Falls"] = "Cachoeira Glacial",
	["Glimmer Bay"] = "Baía Tremeluzente",
	["Glimmerdeep Gorge"] = "Abismo das Profundezas Cintilantes",
	["Glittering Strand"] = "Praia Reluzente",
	["Glopgut's Hollow"] = "Ravina do Tripasseca",
	["Glorious Goods"] = "Tudo de Bom",
	Glory = "Triunfo",
	["GM Island"] = "Ilha dos MJs",
	["Gnarlpine Hold"] = "Acampamento Masca-pinho",
	["Gnaws' Boneyard"] = "Ossário do Roedor",
	Gnomeregan = "Gnomeregan",
	["Gobline Mine"] = "Mina Goblínica",
	["Goblin Foundry"] = "Fundição dos Goblins",
	["Goblin Mine"] = "Mina Goblínica",
	["Goblin Slums"] = "Beco do Goblin",
	["Gokk'lok's Grotto"] = "Grota do Gokk'lok",
	["Gokk'lok Shallows"] = "Banco de Areia de Gokk'lok",
	["Golakka Hot Springs"] = "Fontes Termais Golakka",
	["Gol'Bolar Quarry"] = "Pedreira Gol'Bolar",
	["Gol'Bolar Quarry Mine"] = "Mina da Pedreira Gol'Bolar",
	["Gold Coast Quarry"] = "Pedreira Costa Dourada",
	["Goldenbough Pass"] = "Caminho Ramadouro",
	["Goldenmist Village"] = "Vila de Aurinévoa",
	["Golden Strand"] = "Areal Dourado",
	["Gold Mine"] = "Mina de Ouro",
	["Gold Road"] = "Estrada do Ouro",
	["Gold Rush BG"] = "Corrida do Ouro CB",
	Goldshire = "Vila d'Ouro",
	["Goldtooth's Den"] = "Covil do Dentadouro",
	["Goodgrub Smoking Pit"] = "Fumeiro do Ralador",
	["Gordok's Seat"] = "Trono do Gordok",
	["Gordunni Outpost"] = "Assentamento Gordunni",
	["Gorefiend's Vigil"] = "Vigia do Sanguinávido",
	["Gor'gaz Outpost"] = "Acampamento Gor'gaz",
	Gornia = "Górnia",
	["Gorrok's Lament"] = "Pranto de Gorrok",
	["Gorshak War Camp"] = "Acampamento de Guerra Gorshak",
	["Go'Shek Farm"] = "Fazenda Go'Shek",
	["Grain Cellar"] = "Celeiro de Grãos",
	["Grand Courtyard"] = "Grande Pátio",
	["Grand Magister's Asylum"] = "Asilo do Grão-Magíster",
	["Grand Overlook"] = "Grande Terraço",
	["Grand Promenade"] = "Grande Passeio",
	["Grangol'var Village"] = "Aldeia Grangol'var",
	["Granite Springs"] = "Fontes Graníticas",
	["Grassy Cline"] = "Ladeira Relvada",
	["Greatwood Vale"] = "Vale Matagrande",
	["Greengill Coast"] = "Costa Guelraverde",
	["Greenpaw Village"] = "Aldeia Pataverde",
	["Greenstone Dojo"] = "Dojo Rocha Verde",
	["Greenstone Inn"] = "Estalagem Rocha Verde",
	["Greenstone Masons' Quarter"] = "Distrito dos Pedreiros de Rocha Verde",
	["Greenstone Quarry"] = "Pedreira Rocha Verde",
	["Greenstone Village"] = "Aldeia Rocha Verde",
	["Greenwarden's Grove"] = "Bosque do Verdião",
	["Greymane Court"] = "Paço Greymane",
	["Greymane Manor"] = "Solar dos Greymane",
	["Greymist Firth"] = "Estuário Brumagris",
	["Grim Batol"] = "Grim Batol",
	["Grim Batol Entrance"] = "Entrada de Grim Batol",
	["Grimesilt Dig Site"] = "Escavação Pedrassuja",
	["Grimtotem Compound"] = "Complexo do Temível Totem",
	["Grimtotem Post"] = "Aldeia do Temível Totem",
	Grishnath = "Grishnath",
	Grizzlemaw = "Bocaina Velha",
	["Grizzlepaw Ridge"] = "Serra Garracinza",
	["Grizzly Hills"] = "Serra Gris",
	["Grol'dom Farm"] = "Fazenda Grol'dom",
	["Grolluk's Grave"] = "Túmulo de Grolluk",
	["Grom'arsh Crash-Site"] = "Local da Queda de Grom'arsh",
	["Grom'gol"] = "Grom'gol",
	["Grom'gol Base Camp"] = "Acampamento Grom'gol",
	["Grommash Hold"] = "Castelo Grommash",
	["Grookin Hill"] = "Morro Bagarai",
	["Grosh'gok Compound"] = "Complexo Grosh'gok",
	["Grove of Aessina"] = "Bosque de Aessina",
	["Grove of Falling Blossoms"] = "Alameda das Flores Cadentes",
	["Grove of the Ancients"] = "Bosque dos Ancientes",
	["Growless Cave"] = "Caverna Rugido",
	["Gruul's Lair"] = "Covil de Gruul",
	["Gryphon Roost"] = "Poleiro de Grifos",
	["Guardian's Library"] = "Biblioteca do Guardião",
	Gundrak = "Gundrak",
	["Gundrak Entrance"] = "Entrada de Gundrak",
	["Gunstan's Dig"] = "Escavação de Gunstan",
	["Gunstan's Post"] = "Posto de Gunstan",
	["Gunther's Retreat"] = "Refúgio de Tertuliano",
	["Guo-Lai Halls"] = "Salões de Guo-Lai",
	["Guo-Lai Ritual Chamber"] = "Câmara Ritualística de Guo-Lai",
	["Guo-Lai Vault"] = "Câmara de Guo-Lai",
	["Gurboggle's Ledge"] = "Salto de Gurboggle",
	["Gurubashi Arena"] = "Arena de Gurubashi",
	["Gyro-Plank Bridge"] = "Ponte Giroprancha",
	["Haal'eshi Gorge"] = "Desfiladeiro Haal'eshi",
	["Hadronox's Lair"] = "Covil de Hadronox",
	["Hailwood Marsh"] = "Pântano do Bosque de Granizo",
	Halaa = "Halaa",
	["Halaani Basin"] = "Bacia Halaani",
	["Halcyon Egress"] = "Egresso Halcion",
	["Haldarr Encampment"] = "Assentamento Haldarr",
	Halfhill = "Meia Colina",
	Halgrind = "Halgrind",
	["Hall of Arms"] = "Salão das Armas",
	["Hall of Binding"] = "Salão da Vinculação",
	["Hall of Blackhand"] = "Salão do Mão Negra",
	["Hall of Blades"] = "Salão das Lâminas",
	["Hall of Bones"] = "Salão dos Ossos",
	["Hall of Champions"] = "Salão dos Campeões",
	["Hall of Command"] = "Salão de Comando",
	["Hall of Crafting"] = "Salão da Criação",
	["Hall of Departure"] = "Salão da Despedida",
	["Hall of Explorers"] = "Salão dos Exploradores",
	["Hall of Faces"] = "Salão dos Rostos",
	["Hall of Horrors"] = "Salão dos Horrores",
	["Hall of Illusions"] = "Salão das Ilusões",
	["Hall of Kings"] = "Salão dos Reis",
	["Hall of Legends"] = "Salão dos Lendários",
	["Hall of Masks"] = "Salão das Máscaras",
	["Hall of Memories"] = "Salão das Memórias",
	["Hall of Mysteries"] = "Salão dos Mistérios",
	["Hall of Repose"] = "Salão do Repouso",
	["Hall of Return"] = "Salão do Retorno",
	["Hall of Ritual"] = "Salão do Ritual",
	["Hall of Secrets"] = "Salão dos Segredos",
	["Hall of Serpents"] = "Salão das Serpentes",
	["Hall of Shapers"] = "Salão dos Formadores",
	["Hall of Stasis"] = "Salão da Estase",
	["Hall of the Brave"] = "Salão dos Bravos",
	["Hall of the Conquered Kings"] = "Salão dos Reis Derrotados",
	["Hall of the Crafters"] = "Salão dos Artesãos",
	["Hall of the Crescent Moon"] = "Salão da Lua Crescente",
	["Hall of the Crusade"] = "Salão da Cruzada",
	["Hall of the Cursed"] = "Salão dos Amaldiçoados",
	["Hall of the Damned"] = "Salão dos Malditos",
	["Hall of the Defamed"] = "Salão dos Difamados",
	["Hall of the Exalted"] = "Salão dos Exaltados",
	["Hall of the Fathers"] = "Salão dos Patriarcas",
	["Hall of the Frostwolf"] = "Salão do Lobo do Gelo",
	["Hall of the Grand Imperion"] = "Salão do Grande Impérion",
	["Hall of the High Father"] = "Salão do Grande Pai",
	["Hall of the Keepers"] = "Salão dos Guardiões",
	["Hall of the Shaper"] = "Salão do Formador",
	["Hall of the Stormpike"] = "Salão de Lançatroz",
	["Hall of the Tortured"] = "Salão dos Torturados",
	["Hall of the Watchers"] = "Salão dos Observadores",
	["Hall of the Wicked"] = "Salão dos Perversos",
	["Hall of Tombs"] = "Salão das Tumbas",
	["Hall of Tranquility"] = "Salão da Tranquilidade",
	["Hall of Tranquillity"] = "Salão da Tranquilidade",
	["Hall of Twilight"] = "Salão do Crepúsculo",
	["Halls of Anguish"] = "Salões da Angústia",
	["Halls of Awakening"] = "Salões do Despertar",
	["Halls of Binding"] = "Salões do Confinamento",
	["Halls of Destruction"] = "Salões da Destruição",
	["Halls of Flesh-Shaping"] = "Salões da Carne Moldada",
	["Halls of Lightning"] = "Salões Relampejantes",
	["Halls of Lightning Entrance"] = "Entrada dos Salões Relampejantes",
	["Halls of Mourning"] = "Salões da Lamentação",
	["Halls of Origination"] = "Salões Primordiais",
	["Halls of Origination Entrance"] = "Entrada dos Salões Primordiais",
	["Halls of Reflection"] = "Salões da Reflexão",
	["Halls of Reflection Entrance"] = "Entrada dos Salões da Reflexão",
	["Halls of Silence"] = "Salões do Silêncio",
	["Halls of Stone"] = "Salões Rochosos",
	["Halls of Stone Entrance"] = "Entrada dos Salões Rochosos",
	["Halls of Strife"] = "Salões da Contenda",
	["Halls of the Ancestors"] = "Salões dos Antepassados",
	["Halls of the Hereafter"] = "Salões do Porvir",
	["Halls of the Law"] = "Salões da Lei",
	["Halls of Theory"] = "Salões da Teoria",
	["Halycon's Lair"] = "Covil de Halycon",
	Hammerfall = "Ruína do Martelo",
	["Hammertoe's Digsite"] = "Sítio de Escavação do Pé-de-malho",
	["Hammond Farmstead"] = "Fazenda dos Hammond",
	Hangar = "Hangar",
	["Hardknuckle Clearing"] = "Clareira do Nodo",
	["Hardwrench Hideaway"] = "Esconderijo da Chaveforte",
	["Harkor's Camp"] = "Acampamento do Harkor",
	["Hatchet Hills"] = "Serra da Machadinha",
	["Hatescale Burrow"] = "Toca dos Escamódios",
	["Hatred's Vice"] = "Torno do Ódio",
	Havenshire = "Vila do Amparo",
	["Havenshire Farms"] = "Fazendas da Vila do Amparo",
	["Havenshire Lumber Mill"] = "Serraria Vila do Amparo",
	["Havenshire Mine"] = "Mina da Vila do Amparo",
	["Havenshire Stables"] = "Estábulos da Vila do Amparo",
	["Hayward Fishery"] = "Colônia de Pesca Hayward",
	["Headmaster's Retreat"] = "Retiro do Diretor",
	["Headmaster's Study"] = "Gabinete do Diretor",
	Hearthglen = "Amparo",
	["Heart of Destruction"] = "Âmago da Destruição",
	["Heart of Fear"] = "Coração do Medo",
	["Heart of the Old God Scenario"] = "Cenário Coração do Deus Antigo",
	["Heart of Zan'vess"] = "Coração de Zan'vess",
	["Heart's Blood Shrine"] = "Ermida Verossangue",
	["Heartwood Trading Post"] = "Entreposto Alburno",
	["Heb'Drakkar"] = "Heb'Drakkar",
	["Heb'Valok"] = "Heb'Valok",
	["Hellfire Basin"] = "Bacia Fogo do Inferno",
	["Hellfire Citadel"] = "Cidadela Fogo do Inferno",
	["Hellfire Citadel: Ramparts"] = "Cidadela Fogo do Inferno: Muralha",
	["Hellfire Citadel - Ramparts Entrance"] = "Entrada da Cidadela Fogo do Inferno: Muralha",
	["Hellfire Citadel: The Blood Furnace"] = "Cidadela Fogo do Inferno: Fornalha de Sangue",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Entrada da Cidadela Fogo do Inferno: Fornalha de Sangue",
	["Hellfire Citadel: The Shattered Halls"] = "Cidadela Fogo do Inferno: Salões Despedaçados",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Entrada da Cidadela Fogo do Inferno: Salões Despedaçados",
	["Hellfire Peninsula"] = "Península Fogo do Inferno",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Península Fogo do Inferno - Campo de Força Cabeça de Praia",
	["Hellfire Peninsula - Reaver's Fall"] = "Península Fogo do Inferno",
	["Hellfire Ramparts"] = "Muralha Fogo do Inferno",
	["Hellscream Arena"] = "Arena Grito Infernal",
	-- ["Hellscream's Camp"] = "",
	["Hellscream's Fist"] = "Punho de Grito Infernal",
	["Hellscream's Grasp"] = "Domínio do Grito Infernal",
	["Hellscream's Watch"] = "Posto de Vigia Grito Infernal",
	["Helm's Bed Lake"] = "Lago Helm",
	["Heroes' Vigil"] = "Vigia dos Heróis",
	["Hetaera's Clutch"] = "Ninho de Hetaera",
	["Hewn Bog"] = "Brejo Ceifado",
	["Heyman's Hubris"] = "Ambição de Heyman",
	["Hibernal Cavern"] = "Caverna Hibérnia",
	["Hidden Cell"] = "Cela Oculta",
	["Hidden Path"] = "Caminho Oculto",
	Highbank = "Beiralta",
	["High Bank"] = " Beiralta", -- Needs review
	["Highland Forest"] = "Floresta do Planalto",
	Highperch = "Alcândora",
	["High Wilderness"] = "Selva Alta",
	Hillsbrad = "Eira dos Montes",
	["Hillsbrad Fields"] = "Campos de Eira dos Montes",
	["Hillsbrad Foothills"] = "Contraforte de Eira dos Montes",
	["Hiri'watha Research Station"] = "Estação de Pesquisa Hiri'watha",
	["Hive'Ashi"] = "Colme'Ashi",
	["Hive'Regal"] = "Colme'Régia",
	["Hive'Zora"] = "Colme'Zora",
	["Hogger Hill"] = "Morro do Hogger",
	["Hollowed Out Tree"] = "Árvore Oca",
	["Hollowstone Mine"] = "Mina da Pedra Oca",
	["Honeydew Farm"] = "Fazenda do Mel",
	["Honeydew Glade"] = "Clareira do Mel",
	["Honeydew Village"] = "Aldeia do Mel",
	["Honor Hold"] = "Fortaleza da Honra",
	["Honor Hold Mine"] = "Mina da Fortaleza da Honra",
	["Honor Point"] = "Ponto da Honra", -- Needs review
	["Honor's Stand"] = "Posto da Honra",
	["Honor's Tomb"] = "Tumba de Honra",
	["Horde Base Camp"] = "Campo-base da Horda",
	["Horde Beach Daily Area"] = "Área de Missões Diárias da Praia da Horda",
	["Horde Encampment"] = "Acampamento da Horda",
	["Horde Keep"] = "Bastilha da Horda",
	["Horde Landing"] = "Local de Pouso da Horda",
	["Horde Landing Site"] = "Local de Pouso da Horda",
	["Hordemar City"] = "Hordamar",
	["Horde PVP Barracks"] = "Quartel JxJ da Horda",
	["Horror Clutch"] = "Garra do Horror",
	["Hour of Twilight"] = "Hora do Crepúsculo",
	["House of Edune"] = "Casa de Edune",
	["Howling Fjord"] = "Fiorde Uivante",
	["Howlingwind Cavern"] = "Caverna do Vento Uivante",
	["Howlingwind Trail"] = "Trilha do Vento Uivante",
	["Howling Ziggurat"] = "Zigurate Uivante",
	["Hrothgar's Landing"] = "Porto de Hrothgar",
	["Huangtze Falls"] = "Cataratas de Huangtze",
	["Hull of the Foebreaker"] = "Casco do Devastador",
	["Humboldt Conflagration"] = "Conflagração de Humboldt",
	["Hunter Rise"] = "Platô dos Caçadores",
	["Hunter's Hill"] = "Morro dos Caçadores",
	["Huntress of the Sun"] = "Caçadora do Sol",
	["Huntsman's Cloister"] = "Claustro do Guarda-caça",
	Hyjal = "Hyjal", -- Needs review
	["Hyjal Barrow Dens"] = "Retiro Hyjal",
	["Hyjal Past"] = "Hyjal Antigo",
	["Hyjal Summit"] = "Pico Hyjal",
	["Iceblood Garrison"] = "Guarnição Sanguefrio",
	["Iceblood Graveyard"] = "Cemitério Sanguefrio",
	Icecrown = "Coroa de Gelo",
	["Icecrown Citadel"] = "Cidadela da Coroa de Gelo",
	["Icecrown Dungeon - Gunships"] = "Masmorra da Coroa de Gelo - Belonaves",
	["Icecrown Glacier"] = "Glaciar Coroa de Gelo",
	["Iceflow Lake"] = "Lago Nevado",
	["Ice Heart Cavern"] = "Caverna Gelocórdia",
	["Icemist Falls"] = "Cachoeira Bruma Boreal",
	["Icemist Village"] = "Aldeia Bruma Boreal",
	["Ice Thistle Hills"] = "Serra Cardo de Gelo",
	["Icewing Bunker"] = "Casamata Asálgida",
	["Icewing Cavern"] = "Caverna Asálgida",
	["Icewing Pass"] = "Desfiladeiro Asálgida",
	["Idlewind Lake"] = "Lago Soprocioso",
	["Igneous Depths"] = "Abismos Ígneos",
	["Ihgaluk Crag"] = "Penhasco Ihgaluk",
	["Ik'vess"] = "Ik'vess",
	["Ikz'ka Ridge"] = "Cordilheira Ikz'ka",
	["Illidari Point"] = "Pontal Illidari",
	["Illidari Training Grounds"] = "Campo de Treinamento Illidari",
	["Indu'le Village"] = "Aldeia Indu'le",
	["Infiltrating the Shipyard"] = "Infiltrando-se no Estaleiro",
	["Inkgill Mere"] = "Lagoa Guelra-pintada",
	Inn = "Estalagem",
	["Inner Sanctum"] = "Sanctum Sanctorum",
	["Inner Veil"] = "Véu Interior",
	["Insidion's Perch"] = "Ninho do Insidion",
	["Invasion Point: Annihilator"] = "Ponto de Invasão: Extirpador",
	["Invasion Point: Cataclysm"] = "Ponto de Invasão: Cataclismo",
	["Invasion Point: Destroyer"] = "Ponto de Invasão: Destruidor",
	["Invasion Point: Overlord"] = "Ponto de Invasão: Lorde supremo",
	["Ironband's Compound"] = "Complexo de Bandaferro",
	["Ironband's Excavation Site"] = "Sítio de Escavação de Bandaferro",
	["Ironbeard's Tomb"] = "Tumba dos Barbaférreos",
	["Ironclad Cove"] = "Covil Encouraçado",
	["Ironclad Garrison"] = "Guarnição Encouraçada",
	["Ironclad Prison"] = "Prisão Encouraçado",
	["Iron Concourse"] = "Junção de Ferro",
	["Irondeep Mine"] = "Mina Ferrofundo",
	Ironforge = "Altaforja",
	["Ironforge Airfield"] = "Base Aérea de Altaforja",
	["Ironstone Camp"] = "Acampamento Petraferro",
	["Ironstone Plateau"] = "Platô Petraferro",
	["Iron Summit"] = "Auge Férreo",
	["Irontree Cavern"] = "Caverna Ferrárbol",
	["Irontree Clearing"] = "Clareira Ferrárbol",
	["Irontree Woods"] = "Floresta Ferrárbol",
	["Ironwall Dam"] = "Dique da Muralha de Ferro",
	["Ironwall Rampart"] = "Muralha de Ferro",
	["Ironwing Cavern"] = "Caverna Asaférrea",
	Iskaal = "Iskaal",
	["Island of Doctor Lapidis"] = "Ilha do Doutor Lapidis",
	["Isle of Conquest"] = "Ilha da Conquista",
	["Isle of Conquest No Man's Land"] = "Terra de Ninguém da Ilha da Conquista",
	["Isle of Dread"] = "Ilha do Medo",
	["Isle of Giants"] = "Ilha de Gigantes",
	["Isle of Quel'Danas"] = "Ilha de Quel'Danas",
	["Isle of Reckoning"] = "Ilha da Desforra",
	["Isle of Thunder"] = "Ilha do Trovão",
	["Isle of Tribulations"] = "Ilha das Tribulações",
	["Iso'rath"] = "Iso'rath",
	["Itharius's Cave"] = "Caverna de Itharius",
	["Ivald's Ruin"] = "Ruína de Ivald",
	["Ix'lar's Domain"] = "Domínio de Ix'lar",
	["Jadefire Glen"] = "Grota Flamejade",
	["Jadefire Run"] = "Aldeia Flamejade",
	["Jade Forest Alliance Hub Phase"] = "Fase de Hub da Aliança Floresta de Jade",
	["Jade Forest Battlefield Phase"] = "Fase de Campo de Batalha Floresta de Jade",
	["Jade Forest Horde Starting Area"] = "Área Inicial da Horda - Floresta de Jade",
	["Jademir Lake"] = "Lago Jademir",
	["Jade Temple Grounds"] = "Pátio do Templo de Jade",
	Jaedenar = "Jaedenar",
	["Jagged Reef"] = "Costa Rasgada",
	["Jagged Ridge"] = "Serra dos Espigões",
	["Jaggedswine Farm"] = "Fazenda do Beberrão",
	["Jagged Wastes"] = "Deserto Dentado",
	["Jaguero Isle"] = "Ilha Jaguara",
	["Jaina Dalaran Scenario"] = "Cenário Jaina Dalaran",
	["Janeiro's Point"] = "Pontal de Janeiro",
	["Jangolode Mine"] = "Mina Veiojango",
	-- ["Jaquero Isle"] = "",
	["Jasperlode Mine"] = "Mina de Jaspe",
	["Jeff NE Quadrant Changed"] = "Quadrante NE Alterado do Jeff",
	["Jeff NW Quadrant"] = "Quadrante NW do Jeff",
	["Jeff SE Quadrant"] = "Quadrante SE do Jeff",
	["Jeff SW Quadrant"] = "Quadrante SW do Jeff",
	["Jerod's Landing"] = "Ancoradouro de Jerod",
	["Jintha'Alor"] = "Jintha'Alor",
	["Jintha'kalar"] = "Jintha'kalar",
	["Jintha'kalar Passage"] = "Passagem de Jintha'kalar",
	["Jin Yang Road"] = "Estrada Jin Yang",
	Jotunheim = "Jotunheim",
	K3 = "K3",
	["Kaja'mine"] = "Jakamina",
	["Kaja'mite Cave"] = "Caverna Jakamita",
	["Kaja'mite Cavern"] = "Caverna Jakamita",
	["Kajaro Field"] = "Campo Jakaro",
	["Kal'ai Ruins"] = "Ruínas de Kal'ai",
	Kalimdor = "Kalimdor",
	Kamagua = "Kamagua",
	["Karabor Sewers"] = "Esgotos de Karabor",
	Karazhan = "Karazhan",
	["Kargathia Keep"] = "Bastilha Karrathia",
	["Karnum's Glade"] = "Clareira de Karnum",
	["Kartak's Hold"] = "Aldeia de Kartak",
	Kaskala = "Kaskala",
	["Kaw's Roost"] = "Mirante de Kaw",
	["Kea Krak"] = "Kea Krak",
	["Keelen's Trustworthy Tailoring"] = "Alfaiataria de Confiança do Marko",
	["Keel Harbor"] = "Porto Quilha",
	["Keeshan's Post"] = "Posto do Keeshan",
	["Kelp'thar Forest"] = "Floresta Kelp'thar",
	["Kel'Thuzad Chamber"] = "Câmara de Kel'Thuzad",
	["Kel'Thuzad's Chamber"] = "Câmara de Kel'Thuzad",
	["Keset Pass"] = "Desfiladeiro de Keset",
	["Kessel's Crossing"] = "Travessia de Kessel",
	Kezan = "Kezan",
	Kharanos = "Kharanos",
	["Khardros' Anvil"] = "Bigorna de Khardros",
	["Khartut's Tomb"] = "Tumba de Khartut",
	["Khaz'goroth's Seat"] = "Trono de Khaz'Goroth",
	["Ki-Han Brewery"] = "Cervejaria Ki-Han",
	["Kili'ua's Atoll"] = "Atol de Kili'ua",
	["Kil'sorrow Fortress"] = "Fortaleza Kil'pesar",
	["King's Gate"] = "Portão do Rei",
	["King's Harbor"] = "Porto Real",
	["King's Hoard"] = "Tesouro do Rei",
	["King's Square"] = "Praça Real",
	["Kirin'Var Village"] = "Vila Kirin'Var",
	Kirthaven = "Kirthaven",
	["Klaxxi'vess"] = "Klaxxi'vess",
	["Klik'vess"] = "Klik'vess",
	["Knucklethump Hole"] = "Buraco da Cotovelada",
	["Kodo Graveyard"] = "Cemitério dos Kodos",
	["Kodo Rock"] = "Rocha dos Kodos",
	["Kolkar Village"] = "Aldeia Kolkar",
	Kolramas = "Kolramas",
	["Kor'kron Vanguard"] = "Vanguarda Kor'kron",
	["Kormek's Hut"] = "Barraco do Kormek",
	["Koroth's Den"] = "Covil de Koroth",
	["Korthun's End"] = "Ruína de Korthun",
	["Kor'vess"] = "Kor'vess",
	["Kota Basecamp"] = "Acampamento Kota",
	["Kota Peak"] = "Monte Kota",
	["Krasarang Cove"] = "Angra de Krasarang",
	["Krasarang River"] = "Rio Krasarang",
	["Krasarang Wilds"] = "Selva de Krasarang",
	["Krasari Falls"] = "Cachoeira Krasari",
	["Krasus' Landing"] = "Plataforma de Krasus",
	["Krazzworks Attack Zeppelin"] = "Zepelim de Ataque dos Krazzodutos",
	["Kril'Mandar Point"] = "Posto Kril'Mandar",
	["Kri'vess"] = "Kri'vess",
	["Krolg's Hut"] = "Cabana do Krolg",
	["Krom'gar Fortress"] = "Fortaleza Krom'gar",
	["Krom's Landing"] = "Porto de Krom",
	["KTC Headquarters"] = "Sede da CCJ",
	["KTC Oil Platform"] = "Plataforma de Petróleo da CCJ",
	["Kul'galar Keep"] = "Forte Kul'galar",
	["Kul Tiras"] = "Kul Tiraz",
	["Kun-Lai Pass"] = "Desfiladeiro Kun-Lai",
	["Kun-Lai Summit"] = "Monte Kun-Lai",
	["Kunzen Cave"] = "Caverna Kunzen",
	["Kunzen Village"] = "Vila Kunzen",
	["Kurzen's Compound"] = "Complexo do Kurzen",
	["Kypari Ik"] = "Kypari Ik",
	["Kyparite Quarry"] = "Mina de Kyparita",
	["Kypari Vor"] = "Kypari Vor",
	["Kypari Zar"] = "Kypari Zar",
	["Kzzok Warcamp"] = "Campo de Guerra Kzzok",
	["Lair of Skiggit"] = "Antro de Skiggit",
	["Lair of the Beast"] = "Covil da Fera",
	["Lair of the Chosen"] = "Covil dos Escolhidos",
	["Lair of the Jade Witch"] = "Covil da Bruxa de Jade",
	["Lair of Tortos"] = "Covil de Tórtus",
	["Lake Al'Ameth"] = "Lago Al'Ameth",
	["Lake Cauldros"] = "Lago Cauldros",
	["Lake Dumont"] = "Lago Dumont",
	["Lake Edunel"] = "Lago Edunel",
	["Lake Elrendar"] = "Lago Elrendar",
	["Lake Elune'ara"] = "Lago Eluna'ara",
	["Lake Ere'Noru"] = "Lago Ere'Noru",
	["Lake Everstill"] = "Lago Plácido",
	["Lake Falathim"] = "Lago Falathim",
	["Lake Indu'le"] = "Lago Indu'le",
	["Lake Jorune"] = "Lago Dorune",
	["Lake Kel'Theril"] = "Lago Kel'Theril",
	["Lake Kittitata"] = "Lago Kittitata",
	["Lake Kum'uya"] = "Lago Kum'uya",
	["Lake Mennar"] = "Lago Mennar",
	["Lake Mereldar"] = "Lago Mereldar",
	["Lake Nazferiti"] = "Lago Nazferiti",
	["Lake of Stars"] = "Lago das Estrelas",
	["Lakeridge Highway"] = "Estrada Beira-lago",
	Lakeshire = "Vila Plácida",
	["Lakeshire Inn"] = "Estalagem da Vila Plácida",
	["Lakeshire Town Hall"] = "Prefeitura de Vila Plácida",
	["Lakeside Landing"] = "Giroporto do Lago",
	["Lake Sunspring"] = "Lago Solavera",
	["Lakkari Tar Pits"] = "Poços de Piche Lakkari",
	["Landing Beach"] = "Praia do Desembarque",
	["Landing Site"] = "Local de Pouso",
	["Land's End Beach"] = "Praia do Fim do Mundo",
	["Langrom's Leather & Links"] = "Ligas e Couros do Langrom",
	["Lao & Son's Yakwash"] = "Lavaiaque Lao & Filho",
	["Largo's Overlook"] = "Mirante do Largo",
	["Largo's Overlook Tower"] = "Torre do Mirante do Largo",
	["Lariss Pavilion"] = "Pavilhão Lariss",
	["Laughing Skull Courtyard"] = "Pátio Gargaveira",
	["Laughing Skull Ruins"] = "Ruínas Gargaveira",
	["Launch Bay"] = "Baia de Lançamento",
	["Legash Encampment"] = "Assentamento Legash",
	["Legendary Leathers"] = "Couros Lendários",
	["Legion Hold"] = "Cidadela da Legião",
	["Legion's Fate"] = "Destino da Legião",
	["Legion's Rest"] = "Repouso da Legião",
	["Lethlor Ravine"] = "Ravina Lethlor",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "Infortúnio de Leyara",
	["L'ghorek"] = "L'ghorek",
	["Liang's Retreat"] = "Retiro de Liang",
	["Library Wing"] = "Ala da Biblioteca",
	Lighthouse = "Farol",
	["Lightning Ascent"] = "Subida do Relâmpago",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Forja do Relâmpago - Progressão do Cenário da Ilha Mogu",
	["Lightning Ledge"] = "Salto Relâmpago",
	["Lightning Promenade"] = "Passeio do Relâmpago",
	["Lightning Vein Mine"] = "Mina do Veio Relampejante",
	["Light's Breach"] = "Campo da Luz",
	["Light's Dawn Cathedral"] = "Catedral Aurora da Luz",
	["Light's Hammer"] = "Martelo da Luz",
	["Light's Hope Chapel"] = "Capela Esperança da Luz",
	["Light's Point"] = "Pontal da Luz",
	["Light's Point Tower"] = "Torre Ponto de Luz",
	["Light's Shield Tower"] = "Torre Escudo da Luz",
	["Light's Trust"] = "Guarda da Luz",
	["Like Clockwork"] = "Parafuso a Mais",
	["Lion's Landing"] = "Ancoradouro do Leão",
	["Lion's Pride Inn"] = "Estalagem do Leão Orgulhoso",
	["Livery Outpost"] = "Cocheiras",
	["Livery Stables"] = "Estábulo de Aluguel", -- Needs review
	["Livery Stables "] = "Estábulo de Aluguel",
	["Llane's Oath"] = "Jura de Llane",
	["Loading Room"] = "Galpão de Carregamento",
	["Loch Modan"] = "Loch Modan",
	["Loch Verrall"] = "Loch Verrall",
	["Loken's Bargain"] = "Barganha de Loken",
	["Lonesome Cove"] = "Enseada Solitária",
	Longshore = "Praia Grande",
	["Longying Outpost"] = "Entreposto Longoying",
	-- ["Lordamere Internment Camp"] = "",
	["Lordamere Lake"] = "Espelho de Lordaeron",
	["Lor'danel"] = "Lor'danel",
	["Lorthuna's Gate"] = "Portão de Lorthuna",
	["Lost Caldera"] = "Caldeira Perdida",
	["Lost City of the Tol'vir"] = "Cidade Perdida dos Tol'vir",
	["Lost City of the Tol'vir Entrance"] = "Entrada da Cidade Perdida dos Tol'vir",
	LostIsles = "Ilhas Perdidas",
	["Lost Isles Town in a Box"] = "Cidade Portátil das Ilhas Perdidas",
	["Lost Isles Volcano Eruption"] = "Erupção do Vulcão das Ilhas Perdidas",
	["Lost Peak"] = "Pico Perdido",
	["Lost Point"] = "Posto Perdido",
	["Lost Rigger Cove"] = "Enseada do Armador Perdido",
	["Lothalor Woodlands"] = "Bosques de Lothalor",
	["Lower City"] = "Bairro Inferior",
	["Lower Silvermarsh"] = "Baixo Pântano de Prata",
	["Lower Sumprushes"] = "Reservatórios de Baixo",
	["Lower Veil Shil'ak"] = "Véu Shil'ak Inferior",
	["Lower Wilds"] = "Baixio Selvagem",
	["Lumber Mill"] = "Serraria",
	["Lushwater Oasis"] = "Oásis das Águas Claras",
	["Lydell's Ambush"] = "Cilada de Lídio",
	["M.A.C. Diver"] = "Submarino M.A.C.",
	["Maelstrom Deathwing Fight"] = "Combate contra o Asa da Morte na Voragem",
	["Maelstrom Zone"] = "Zona da Voragem",
	["Maestra's Post"] = "Entreposto de Maestra",
	["Maexxna's Nest"] = "Ninho de Maexxna",
	["Mage Quarter"] = "Distrito dos Magos",
	["Mage Tower"] = "Torre dos Magos",
	["Mag'har Grounds"] = "Terras de Mag'har",
	["Mag'hari Procession"] = "Cortejo Fúnebre Mag'hari",
	["Mag'har Post"] = "Posto Mag'har",
	["Magical Menagerie"] = "A Arca Mágica",
	["Magic Quarter"] = "Distrito da Magia",
	["Magisters Gate"] = "Portão dos Magísteres",
	["Magister's Terrace"] = "Terraço dos Magísteres",
	["Magisters' Terrace"] = "Terraço dos Magísteres",
	["Magisters' Terrace Entrance"] = "Entrada do Terraço dos Magísteres",
	["Magmadar Cavern"] = "Caverna de Magmadar",
	["Magma Fields"] = "Campos de Magma",
	["Magma Springs"] = "Poços de Magma",
	["Magmaw's Fissure"] = "Rachadura de Magorja",
	Magmoth = "Magmute",
	["Magnamoth Caverns"] = "Caverna Magnatraça",
	["Magram Territory"] = "Território Magram",
	["Magtheridon's Lair"] = "Covil de Magtheridon",
	["Magus Commerce Exchange"] = "Área Comercial Magus",
	["Main Chamber"] = "Câmara Principal",
	["Main Gate"] = "Portão Principal",
	["Main Hall"] = "Salão Principal",
	["Maker's Ascent"] = "Encosta do Criador",
	["Maker's Overlook"] = "Mirante dos Criadores", -- Needs review
	["Maker's Overlook "] = "Mirante do Criador",
	["Makers' Overlook"] = "Mirante dos Criadores",
	["Maker's Perch"] = "Ninho do Criador",
	["Makers' Perch"] = "Ninho do Criador", -- Needs review
	["Malaka'jin"] = "Malaka'jin",
	["Malden's Orchard"] = "Horto dos Maldonado",
	Maldraz = "Maldraz",
	["Malfurion's Breach"] = "Ruptura de Malfurion",
	["Malicia's Outpost"] = "Posto de Malicia",
	["Malykriss: The Vile Hold"] = "Malykriss: O Forte Torpe",
	["Mama's Pantry"] = "Despensa da Vovó",
	["Mam'toth Crater"] = "Cratera de Mam'toth",
	["Manaforge Ara"] = "Manaforja Ara",
	["Manaforge B'naar"] = "Manaforja B'naar",
	["Manaforge Coruu"] = "Manaforja Coruu",
	["Manaforge Duro"] = "Manaforja Dúria",
	["Manaforge Ultris"] = "Manaforja Ultris",
	["Mana Tombs"] = "Tumbas de Mana",
	["Mana-Tombs"] = "Tumbas de Mana",
	["Mandokir's Domain"] = "Domínio de Mandokir",
	["Mandori Village"] = "Vilarejo Mandori",
	["Mannoroc Coven"] = "Ruínas de Mannoroc",
	["Manor Mistmantle"] = "Casarão dos Brumanto",
	["Mantle Rock"] = "Manto de Rocha",
	["Map Chamber"] = "Câmara do Mapa",
	["Mar'at"] = "Mar'at",
	Maraudon = "Maraudon",
	["Maraudon - Earth Song Falls Entrance"] = "Entrada de Maraudon - Cachoeiras da Canção Telúrica",
	["Maraudon - Foulspore Cavern Entrance"] = "Entrada de Maraudon - Caverna Esporelama",
	["Maraudon - The Wicked Grotto Entrance"] = "Maraudon - Entrada da Gruta Nociva",
	["Mardenholde Keep"] = "Bastilha Mardenforte",
	Marista = "Marista",
	["Marista's Bait & Brew"] = "Iscas e Biritas da Marista",
	["Market Row"] = "Travessa do Comércio",
	["Marshal's Refuge"] = "Refúgio do Marshal",
	["Marshal's Stand"] = "Posto Avançado do Marshal",
	["Marshlight Lake"] = "Lago Pantanoso",
	["Marshtide Watch"] = "Posto Maré do Pântano",
	["Maruadon - The Wicked Grotto Entrance"] = "Entrada de Maraudon - Gruta Malévola",
	["Mason's Folly"] = "Loucura do Alvanel",
	["Masters' Gate"] = "Portão do Mestre",
	["Master's Terrace"] = "Terraço do Mestre",
	["Mast Room"] = "Sala do Mastro",
	["Maw of Destruction"] = "Gorja da Destruição",
	["Maw of Go'rath"] = "Gorja de Go'rath",
	["Maw of Lycanthoth"] = "Bocarra de Licantote",
	["Maw of Neltharion"] = "Bocarra de Neltharion",
	["Maw of Shu'ma"] = "Gorja de Shu'ma",
	["Maw of the Void"] = "Garganta do Caos",
	["Mazra'Alor"] = "Mazra'Alor",
	Mazthoril = "Mazthoril",
	["Mazu's Overlook"] = "Mirante de Mazu",
	["Medivh's Chambers"] = "Aposentos do Medivh",
	["Menagerie Wreckage"] = "Destroços da Arca",
	["Menethil Bay"] = "Baía de Menethil",
	["Menethil Harbor"] = "Porto de Menethil",
	["Menethil Keep"] = "Bastilha Menethil",
	["Merchant Square"] = "Praça dos Mercadores",
	Middenvale = "Vale da Podridão",
	["Mid Point Station"] = "Estação Central",
	["Midrealm Post"] = "Posto Terramédia",
	["Midwall Lift"] = "Elevador do Muro do Meio",
	["Mightstone Quarry"] = "Pedreira do Megalito",
	["Military District"] = "Distrito Militar",
	["Mimir's Workshop"] = "Oficina do Mimir",
	Mine = "Mina",
	Mines = "Minas",
	["Mirage Abyss"] = "Abismo Ilusório",
	["Mirage Flats"] = "Chapada da Ilusão",
	["Mirage Raceway"] = "Circuito da Ilusão",
	["Mirkfallon Lake"] = "Lago Mirkfallon",
	["Mirkfallon Post"] = "Posto Mirkfallon",
	["Mirror Lake"] = "Lago Espelhado",
	["Mirror Lake Orchard"] = "Pomar do Lago Espelhado",
	["Mistblade Den"] = "Covil dos Lâmina da Névoa",
	["Mistcaller's Cave"] = "Caverna do Chamabruma",
	["Mistfall Village"] = "Vila do Cair da Bruma",
	["Mist's Edge"] = "Beira das Névoas",
	["Mistvale Valley"] = "Vale da Névoa",
	["Mistveil Sea"] = "Mar Nebuloso",
	["Mistwhisper Refuge"] = "Refúgio Brumurmúria",
	["Misty Pine Refuge"] = "Refúgio Pinhal das Brumas",
	["Misty Reed Post"] = "Posto Brumalga",
	["Misty Reed Strand"] = "Praia Brumalga",
	["Misty Ridge"] = "Pico da Neblina",
	["Misty Shore"] = "Costa da Bruma",
	["Misty Shores"] = "Costa da Bruma",
	["Misty Valley"] = "Vale Nebuloso",
	["Miwana's Longhouse"] = "Casa Grande de Miwana",
	["Mizjah Ruins"] = "Ruínas de Nizjah",
	["Moa'ki"] = "Moa'ki",
	["Moa'ki Harbor"] = "Porto Moa'ki",
	["Moggle Point"] = "Cabo Moggle",
	["Mo'grosh Stronghold"] = "Fortaleza Mo'grosh",
	["Mogu Island Daily Area"] = "Área Diária da Ilha Mogu",
	["Mogu Island Events - Alliance Base"] = "Eventos da Ilha Mogu - Base da Aliança",
	["Mogu Island Events - Horde Base"] = "Eventos da Ilha Mogu - Base da Horda",
	["Mogu Island Loot Room"] = "Sala do Tesouro da Ilha Mogu",
	["Mogu Island Progression Events"] = "Eventos de Progressão da Ilha Mogu",
	Mogujia = "Mogujia",
	["Mogu'shan Palace"] = "Palácio Mogu'shan",
	["Mogu'shan Terrace"] = "Terraço Mogu'shan",
	["Mogu'shan Vaults"] = "Galerias Mogu'shan",
	["Mok'Doom"] = "Mok'Doom",
	["Mok'Gordun"] = "Mok'Gordun",
	["Mok'Nathal Village"] = "Vila de Mok'nathal",
	["Mold Foundry"] = "Fundição dos Moldes",
	["Molten Core"] = "Núcleo Derretido",
	["Molten Front"] = "Front Ígneo",
	Moonbrook = "Arroio da Lua",
	Moonglade = "Clareira da Lua",
	["Moongraze Woods"] = "Matas do Pasto Lunar",
	["Moon Horror Den"] = "Antro Lunorror",
	["Moonrest Gardens"] = "Jardins Lua Serena",
	["Moonshrine Ruins"] = "Ruínas do Sacrário Lunar",
	["Moonshrine Sanctum"] = "Sacrário Lunar",
	["Moontouched Den"] = "Gruta Lunamarca",
	["Moonwater Retreat"] = "Recanto Aqualuna",
	["Moonwell of Cleansing"] = "Poço Lunar da Purificação",
	["Moonwell of Purity"] = "Poço Lunar da Pureza",
	["Moonwing Den"] = "Covil dos Coruscantes",
	["Mord'rethar: The Death Gate"] = "Mord'rethar: O Portão da Morte",
	["Morgan's Plot"] = "Terreno de Morgan",
	["Morgan's Vigil"] = "Vigia de Morgan",
	["Morlos'Aran"] = "Morlos'Aran",
	["Morning Breeze Lake"] = "Lago Brisa da Manhã",
	["Morning Breeze Village"] = "Vila Brisa da Manhã",
	Morrowchamber = "Câmara do Porvir",
	["Mor'shan Base Camp"] = "Campo-base Mor'shan",
	["Mortal's Demise"] = "Fronteira da Morte",
	["Mortbreath Grotto"] = "Gruta Canto da Morte",
	["Mortwake's Tower"] = "Torre do Pinel",
	["Mosh'Ogg Ogre Mound"] = "Gruta de Mosh'Ogg",
	["Mosshide Fen"] = "Charco Pelemusgo",
	["Mosswalker Village"] = "Aldeia Mofâmbulo",
	["Mossy Pile"] = "Viga Musgosa",
	["Motherseed Pit"] = "Fosso Semente-mãe",
	["Mountainfoot Strip Mine"] = "Mina do Sopé",
	["Mount Akher"] = "Monte Akher",
	["Mount Hyjal"] = "Monte Hyjal",
	["Mount Hyjal Phase 1"] = "Monte Hyjal Fase 2",
	["Mount Neverest"] = "Monte Neverest",
	["Muckscale Grotto"] = "Gruta Escamamuco",
	["Muckscale Shallows"] = "Praia Escamamuco",
	["Mudmug's Place"] = "Venda do Caneca de Barro",
	Mudsprocket = "Coroa de Barro",
	Mulgore = "Mulgore",
	["Murder Row"] = "Travessa do Assassino",
	["Murkdeep Cavern"] = "Caverna Lodofundo",
	["Murky Bank"] = "Costa Obscura",
	["Muskpaw Ranch"] = "Rancho do Almiscarado",
	["Mystral Lake"] = "Lago Mistral",
	Mystwood = "Bosque das Névoas",
	Nagrand = "Nagrand",
	["Nagrand Arena"] = "Arena de Nagrand",
	Nahom = "Nahom",
	["Nar'shola Terrace"] = "Terraço de Nar'shola",
	["Narsong Spires"] = "Torres Narcanto",
	["Narsong Trench"] = "Trincheira Narcanto",
	["Narvir's Cradle"] = "Berço de Narvir",
	["Nasam's Talon"] = "Garra de Nasam",
	["Nat's Landing"] = "Píer do Nat",
	["Naval Battle Scenario"] = "Cenário da Batalha Naval",
	Naxxanar = "Naxxanar",
	Naxxramas = "Naxxramas",
	["Nayeli Lagoon"] = "Lagoa Nayeli",
	["Naz'anak: The Forgotten Depths"] = "Naz'anak: As Profundezas Abandonadas",
	["Nazj'vel"] = "Nazj'vel",
	Nazzivian = "Nazzivian",
	["Nectarbreeze Orchard"] = "Pomar Sopro de Néctar",
	["Needlerock Chasm"] = "Fenda Pedragulha",
	["Needlerock Slag"] = "Vila Pedragulha",
	["Nefarian's Lair"] = "Covil do Nefarian",
	["Nefarian�s Lair"] = "Covil do Nefarian",
	["Neferset City"] = "Cidade dos Neferset",
	["Neferset City Outskirts"] = "Arredores da Cidade dos Neferset",
	["Nek'mani Wellspring"] = "Olho-d'água Nek'mani",
	["Neptulon's Rise"] = "Beiral de Neptulon",
	["Nesingwary Base Camp"] = "Acampamento do Rosarães",
	["Nesingwary Safari"] = "Safári Rosarães",
	["Nesingwary's Expedition"] = "Expedição do Rosarães",
	["Nesingwary's Safari"] = "Safári do Rosarães",
	Nespirah = "Nespirah",
	["Nestlewood Hills"] = "Serra do Ninhal",
	["Nestlewood Thicket"] = "Mata Ninhal",
	["Nethander Stead"] = "Sítio de Nethander",
	["Nethergarde Keep"] = "Bastilha de Etergarde",
	["Nethergarde Mines"] = "Minas de Etergarde",
	["Nethergarde Supply Camps"] = "Bases de Suprimentos de Etergarde",
	Netherspace = "Eterespaço",
	Netherstone = "Pedra Etérea",
	Netherstorm = "Eternévoa",
	["Netherweb Ridge"] = "Serra Redetérea",
	["Netherwing Fields"] = "Campos da Asa Etérea",
	["Netherwing Ledge"] = "Plataforma da Asa Etérea",
	["Netherwing Mines"] = "Minas da Asa Etérea",
	["Netherwing Pass"] = "Trilha da Asa Etérea",
	["Neverest Basecamp"] = "Acampamento Neverest",
	["Neverest Pinnacle"] = "Pináculo Neverest",
	["New Agamand"] = "Nova Agamand",
	["New Agamand Inn"] = "Estalagem de Nova Agamand",
	["New Avalon"] = "Nova Avalon",
	["New Avalon Fields"] = "Campos de Nova Avalon",
	["New Avalon Forge"] = "Forja de Nova Avalon",
	["New Avalon Orchard"] = "Pomar de Nova Avalon",
	["New Avalon Town Hall"] = "Prefeitura de Nova Avalon",
	["New Cifera"] = "Nova Cifera",
	["New Hearthglen"] = "Nova Amparo",
	["New Kargath"] = "Nova Karrath",
	["New Thalanaar"] = "Nova Thalanaar",
	["New Tinkertown"] = "Vila da Gambiarra",
	["Nexus Legendary"] = "Nexus Lendária",
	Nidavelir = "Nidavelir",
	["Nidvar Stair"] = "Escadaria Nidvar",
	Nifflevar = "Niffelvar",
	["Night Elf Village"] = "Vila dos Elfos Noturnos",
	Nighthaven = "Refúgio Noturno",
	["Nightingale Lounge"] = "Descanso do Rouxinol",
	["Nightmare Depths"] = "Abismo dos Pesadelos",
	["Nightmare Scar"] = "Garganta do Pesadelo",
	["Nightmare Vale"] = "Vale do Pesadelo",
	["Night Run"] = "Trilha da Noite",
	["Nightsong Woods"] = "Floresta Noturcanto",
	["Night Web's Hollow"] = "Vale Teia da Noite",
	["Nijel's Point"] = "Posto do Nijel",
	["Nimbus Rise"] = "Beiral do Nimbo",
	Nine = "Nove",
	["Niuzao Catacombs"] = "Catacumbas Niuzao",
	["Niuzao Temple"] = "Templo Niuzao",
	["Njord's Breath Bay"] = "Baía do Bafo de Njord",
	["Njorndar Village"] = "Vila Njorndar",
	["Njorn Stair"] = "Escadaria Njorn",
	["Nook of Konk"] = "Covil de Konk",
	["Noonshade Ruins"] = "Ruínas da Sombrassolar",
	Nordrassil = "Nordrassil",
	["Nordrassil Inn"] = "Estalagem de Nordrassil",
	["Nordune Ridge"] = "Pico de Nordune",
	["North Common Hall"] = "Saguão Norte",
	Northdale = "Vilarejo do Norte",
	["Northern Barrens"] = "Sertões Setentrionais",
	["Northern Elwynn Mountains"] = "Montanhas do Norte de Elwynn",
	["Northern Headlands"] = "Promontório Setentrional",
	["Northern Rampart"] = "Muralha do Norte",
	["Northern Rocketway"] = "Foguetovia Norte",
	["Northern Rocketway Exchange"] = "Estação Norte da Foguetovia",
	["Northern Stranglethorn"] = "Selva do Espinhaço Setentrional",
	["Northfold Manor"] = "Casa Grande do Norte",
	["Northgate Breach"] = "Brecha do Portal Norte",
	["North Gate Outpost"] = "Posto de Guarda do Portão Norte",
	["North Gate Pass"] = "Desfiladeiro do Portão Norte",
	["Northgate River"] = "Rio do Portal Norte",
	["Northgate Woods"] = "Floresta do Portal Norte",
	["Northmaul Tower"] = "Torre Martelo do Norte",
	["Northpass Tower"] = "Torre do Passo Norte",
	["North Point Station"] = "Estação Norte",
	["North Point Tower"] = "Torre Norte",
	Northrend = "Nortúndria",
	["Northridge Lumber Camp"] = "Madeireira Beiranorte",
	["North Sanctum"] = "Sacrário do Norte",
	Northshire = "Vila Norte",
	["Northshire Abbey"] = "Abadia de Vila Norte",
	["Northshire River"] = "Rio Vila Norte",
	["Northshire Valley"] = "Vale de Vila Norte",
	["Northshire Vineyards"] = "Vinhedos de Vila Norte",
	["North Spear Tower"] = "Torre da Lança Norte",
	["North Tide's Beachhead"] = "Atracadouro da Maré do Norte",
	["North Tide's Run"] = "Costa da Maré do Norte",
	["Northwatch Expedition Base Camp"] = "Base da Expedição Guardanorte",
	["Northwatch Expedition Base Camp Inn"] = "Estalagem da Base da Expedição Guardanorte",
	["Northwatch Foothold"] = "Base da Guardanorte",
	["Northwatch Hold"] = "Fortaleza da Guardanorte",
	["Northwind Cleft"] = "Fenda do Vento Norte",
	["North Wind Tavern"] = "Taverna do Vento Norte",
	["Nozzlepot's Outpost"] = "Acampamento do Macambúzio",
	["Nozzlerust Post"] = "Posto Ferrugem",
	["Oasis of the Fallen Prophet"] = "Oásis do Profeta Caído",
	["Oasis of Vir'sar"] = "Oásis de Vir'sar",
	["Obelisk of the Moon"] = "Obelisco da Lua",
	["Obelisk of the Stars"] = "Obelisco das Estrelas",
	["Obelisk of the Sun"] = "Obelisco do Sol",
	["O'Breen's Camp"] = "Acampamento do Nabrava",
	["Observance Hall"] = "Salão da Obediência",
	["Observation Grounds"] = "Campos de Observação",
	["Obsidian Breakers"] = "Quebradas Obsidianas",
	["Obsidian Dragonshrine"] = "Santuário Dragônico Obsidiano",
	["Obsidian Forest"] = "Floresta Obsidiana",
	["Obsidian Lair"] = "Covil Obsidiano",
	["Obsidia's Perch"] = "Ninho de Obsídia",
	["Odesyus' Landing"] = "Assentamento de Odisseu",
	["Ogri'la"] = "Ogri'la",
	["Ogri'La"] = "Ogri'la",
	["Old Hillsbrad Foothills"] = "Antigo Contraforte de Eira dos Montes",
	["Old Ironforge"] = "Antiga Altaforja",
	["Old Town"] = "Cidade Velha",
	Olembas = "Olembas",
	["Olivia's Pond"] = "Lago de Olívia",
	["Olsen's Farthing"] = "Miséria de Olsen",
	Oneiros = "Oneiros",
	["One Keg"] = "Barriluno",
	["One More Glass"] = "Desce a Saideira",
	["Onslaught Base Camp"] = "Base da Ofensiva",
	["Onslaught Harbor"] = "Porto da Ofensiva",
	["Onyxia's Lair"] = "Covil da Onyxia",
	["Oomlot Village"] = "Vila Trema-trema",
	["Oona Kagu"] = "Uná Kagu",
	Oostan = "Oostan",
	["Oostan Nord"] = "Oostan Nord",
	["Oostan Ost"] = "Oostan Ost",
	["Oostan Sor"] = "Oostan Sor",
	["Opening of the Dark Portal"] = "Abertura do Portal Negro",
	["Opening of the Dark Portal Entrance"] = "Entrada da Abertura do Portal Negro",
	["Oratorium of the Voice"] = "Tribuna da Voz",
	["Oratory of the Damned"] = "Oratório dos Malditos",
	["Orchid Hollow"] = "Clareira da Orquídea",
	["Orebor Harborage"] = "Porto Orebor",
	["Oregrind's Dig"] = "Escavação de Quebraferro",
	["Orendil's Retreat"] = "Retiro de Orendil",
	Orgrimmar = "Orgrimmar",
	["Orgrimmar Gunship Pandaria Start"] = "Orgrimmar Gunship Pandaria Start",
	["Orgrimmar Rear Gate"] = "Portão Traseiro de Orgrimmar",
	["Orgrimmar Rocketway Exchange"] = "Estação da Foguetovia de Orgrimmar",
	["Orgrim's Hammer"] = "Martelo de Orgrim",
	["Oronok's Farm"] = "Fazenda de Oronok",
	Orsis = "Orsis",
	["Ortell's Hideout"] = "Esconderijo de Ortell",
	["Oshu'gun"] = "Oshu'gun",
	["Outdoor Ruins"] = "Ruínas Externas",
	Outland = "Terralém",
	["Overgrown Camp"] = "Acampamento Baldio",
	["Overgrown Statuary"] = "Estatuaria Exuberante",
	["Owen's Wishing Well"] = "Poço dos Desejos do Anísio",
	["Owl Wing Thicket"] = "Matagal da Asa da Coruja",
	["Palace Antechamber"] = "Antecâmara do Palácio",
	["Pal'ea"] = "Pal'ea",
	["Palemane Rock"] = "Rochedo Jubalba",
	["Pandaren Mine"] = "Mina Pandarênica",
	Pandaria = "Pandária",
	["Pang's Stead"] = "Fazenda do Pang",
	["Panic Clutch"] = "Garra do Pânico",
	["Paoquan Hollow"] = "Ravina Paoquan",
	["Parhelion Plaza"] = "Praça Parélio",
	["Passage of Lost Fiends"] = "Passagem dos Demônios Perdidos",
	["Path of a Hundred Steps"] = "Caminho dos Cem Passos",
	["Path of Conquerors"] = "Caminho dos Conquistadores",
	["Path of Enlightenment"] = "Caminho da Iluminação",
	["Path of Serenity"] = "Caminho da Serenidade",
	["Path of the Titans"] = "Caminho dos Titãs",
	["Path of Uther"] = "Caminho de Uther",
	["Pattymack Land"] = "Terra de Pattymack",
	["Pauper's Walk"] = "Alameda do Indigente",
	["Paur's Pub"] = "Pub do Paur",
	["Paw'don Glade"] = "Clareira Pata'don",
	["Paw'don Village"] = "Aldeia Pata'don",
	["Paw'Don Village"] = "Aldeia Pata'don", -- Needs review
	["Peak of Serenity"] = "Pico da Serenidade",
	["Pearlfin Village"] = "Aldeia Barbatana de Pérola",
	["Pearl Lake"] = "Lago Pérola",
	["Pedestal of Hope"] = "Pedestal da Esperança",
	["Pei-Wu Forest"] = "Floresta de Pei-Wu",
	["Pestilent Scar"] = "Cicatriz Pestilenta",
	["Pet Battle - Jade Forest"] = "Batalha de Mascotes - Floresta de Jade",
	["Petitioner's Chamber"] = "Câmara do Requerente",
	["Pilgrim's Precipice"] = "Precipício do Peregrino",
	["Pincer X2"] = "Tenaz X2",
	["Pinnacle of Storms"] = "Pináculo das Tempestades",
	["Pit of Fangs"] = "Fosso das Presas",
	["Pit of Saron"] = "Fosso de Saron",
	["Pit of Saron Entrance"] = "Entrada do Fosso de Saron",
	["Plaguelands: The Scarlet Enclave"] = "Terras Pestilentas: Enclave Escarlate",
	["Plaguemist Ravine"] = "Trilha da Névoa Pestilenta",
	Plaguewood = "Bosque Pestilento",
	["Plaguewood Tower"] = "Torre do Bosque Pestilento",
	["Plain of Echoes"] = "Planície dos Ecos",
	["Plain of Shards"] = "Planície dos Fragmentos",
	["Plain of Thieves"] = "Planície dos Ladrões",
	["Plains of Nasam"] = "Planícies de Nasam",
	["Pod Cluster"] = "Módulos Espaciais",
	["Pod Wreckage"] = "Destroços do Módulo Espacial",
	["Poison Falls"] = "Cachoeira Venenosa",
	["Pool of Reflection"] = "Lago da Reflexão",
	["Pool of Tears"] = "Poço de Lágrimas",
	["Pool of the Paw"] = "Poço da Garra",
	["Pool of Twisted Reflections"] = "Reservatório das Reflexões Distorcidas",
	["Pools of Aggonar"] = "Poços de Aggonar",
	["Pools of Arlithrien"] = "Águas de Arlithrien",
	["Pools of Jin'Alai"] = "Poços de Jin'Alai",
	["Pools of Purity"] = "Lagoas da Pureza",
	["Pools of Youth"] = "Fontes da Juventude",
	["Pools of Zha'Jin"] = "Poços de Zha'Jin",
	["Portal Clearing"] = "Clareira do Portal",
	["Pranksters' Hollow"] = "Antro dos Galhofeiros",
	["Predator's Perch"] = "Ninho do Predador",
	["Prison of Immol'thar"] = "Prisão de Immol'thar",
	["Programmer Isle"] = "Ilha dos Programadores",
	["Promontory Point"] = "Promontório",
	["Prospector's Point"] = "Mirante do Minerador",
	["Protectorate Watch Post"] = "Posto de Guarda do Protetorado",
	["Proving Grounds"] = "Campo de testes",
	["Purespring Cavern"] = "Caverna Fonte Clara",
	["Purgation Isle"] = "Ilha da Purgação",
	["Pursuing the Black Harvest"] = "Em Busca da Colheita Negra",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Laboratório de Horrores e Diversões Alquímicas do Putricídio",
	["Pyrewood Chapel"] = "Capela de Lenhardente",
	["Pyrewood Inn"] = "Taberna de Lenhardente",
	["Pyrewood Town Hall"] = "Prefeitura de Lenhardente",
	["Pyrewood Village"] = "Vilarejo Lenhardente",
	["Pyrox Flats"] = "Planícies Pyrox",
	["QA and DVD"] = "QA e DVD",
	["Quagg Ridge"] = "Serra Quagg",
	Quarry = "Pedreira",
	["Quartzite Basin"] = "Bacia de Quartzito",
	["Queen's Gate"] = "Portão da Rainha",
	["Quel'Danil Lodge"] = "Pavilhão Quel'Danil",
	["Quel'Delar's Rest"] = "Repouso de Quel'Delar",
	["Quel'Dormir Gardens"] = "Jardins de Quel'Durmar",
	["Quel'Dormir Temple"] = "Templo de Quel'Durmar",
	["Quel'Dormir Terrace"] = "Terraço de Quel'Durmar",
	["Quel'Lithien Lodge"] = "Abrigo Quel'Lithien",
	["Quel'thalas"] = "Quel'thalas",
	["Quickchop's Lumber Farm"] = "Fazenda da Serraria de Zino Picadinho",
	["Raastok Glade"] = "Clareira Raastok",
	["Raceway Ruins"] = "Ruínas do Autódromo",
	["Rageclaw Den"] = "Covil Patafúria",
	["Rageclaw Lake"] = "Lago Patafúria",
	["Rage Fang Shrine"] = "Ermida Presa Raivosa",
	["Ragefeather Ridge"] = "Crista Penabrava",
	["Ragefire Caverns"] = "Cavernas Ígneas",
	["Ragefire Chasm"] = "Cavernas Ígneas",
	["Ragefire Core"] = "Núcleo das Cavernas Ígneas",
	["Rage Scar Hold"] = "Bastilha Cortifúria",
	["Ragnaros' Lair"] = "Covil de Ragnaros",
	["Ragnaros' Reach"] = "Confins de Ragnaros",
	["Rainspeaker Canopy"] = "Frondes Voz-da-chuva",
	["Rainspeaker Rapids"] = "Cachoeiras de Voz-da-chuva",
	Ramkahen = "Ramkahen",
	["Ramkahen Legion Outpost"] = "Posto Avançado da Legião de Ramkahen",
	["Rampart of Skulls"] = "Paliçada de Crânios",
	["Ranazjar Isle"] = "Ilha Ranazjar",
	["Raptor Pens"] = "Redil dos Raptores",
	["Raptor Ridge"] = "Serra dos Raptores",
	["Raptor Rise"] = "Ladeira dos Raptores",
	Ratchet = "Vila Catraca",
	["Rated Eye of the Storm"] = "Olho da Tormenta Ranqueado",
	["Ravaged Caravan"] = "Caravana Devastada",
	["Ravaged Crypt"] = "Cripta Assolada",
	["Ravaged Twilight Camp"] = "Acampamento Arrasado do Crepúsculo",
	["Ravencrest Monument"] = "Monumento a Cristacorvo",
	["Raven Hill"] = "Monte Corvo",
	["Raven Hill Cemetery"] = "Cemitério de Monte Corvo",
	["Ravenholdt Manor"] = "Mansão de Corvoforte",
	["Raven's Watch"] = "Mirante do Corvo",
	["Raven's Wood"] = "Mata do Corvo",
	["Raynewood Retreat"] = "Refúgio Bosque Real",
	["Raynewood Tower"] = "Torre do Bosque Real",
	["Razaan's Landing"] = "Campo de Razaan",
	["Razorfen Downs"] = "Urzal dos Mortos",
	["Razorfen Downs Entrance"] = "Entrada de Urzal dos Mortos",
	["Razorfen Kraul"] = "Urzal dos Tuscos",
	["Razorfen Kraul Entrance"] = "Entrada de Urzal dos Tuscos",
	["Razor Hill"] = "Monte Navalha",
	["Razor Hill Barracks"] = "Guarnição do Monte Navalha",
	["Razor Hill Outskirts"] = "Arredores do Monte Navalha",
	["Razor Hill Watchtower"] = "Torre de Vigia do Monte Navalha",
	["Razormane Grounds"] = "Terras Crinavalha",
	["Razor Ridge"] = "Espinhaço Cortante",
	["Razorscale's Aerie"] = "Refúgio da Navalhada",
	["Razorthorn Rise"] = "Morro Espinhoso",
	["Razorthorn Shelf"] = "Passagem Espinhosa",
	["Razorthorn Trail"] = "Trilha Espinhosa",
	["Razorwind Canyon"] = "Garganta do Vento Cortante",
	["Rear Staging Area"] = "Área de Concentração da Retaguarda",
	["Reaver's Fall"] = "Posto dos Destroços",
	["Reavers' Hall"] = "Salão dos Aniquiladores",
	["Rebel Camp"] = "Acampamento dos Rebeldes",
	["Red Cloud Mesa"] = "Chapada Nuvem Vermelha",
	["Redpine Dell"] = "Vale Pinhorrubro",
	["Redridge - Bridge Phase One"] = "Cristarrubra - Fase Um da Ponte",
	["Redridge - Bridge Phase Two"] = "Cristarrubra - Fase Dois da Ponte",
	["Redridge Canyons"] = "Garganta Cristarrubra",
	["Redridge Mountains"] = "Montanhas Cristarrubra",
	["Redridge - Orc Bomb"] = "Cristarrubra - Bomba de Orc",
	["Red Rocks"] = "Rochedo Vermelho",
	["Redwood Trading Post"] = "Entreposto Sequoia",
	Refinery = "Refinaria",
	["Refugee Caravan"] = "Caravana dos Refugiados",
	["Refuge Pointe"] = "Ponta do Refúgio",
	["Refuse Disposal"] = "Fossa de Refugos",
	["Reliquary of Agony"] = "Relicário da Agonia",
	["Reliquary of Pain"] = "Relicário da Dor",
	["Remains of Iris Lake"] = "Resquícios do Lago Íris",
	["Remains of the Fleet"] = "Destroços da Frota",
	["Remtravel's Excavation"] = "Escavação de Trilheiro",
	["Render's Camp"] = "Acampamento dos Laceradores",
	["Render's Crater"] = "Cratera dos Laceradores",
	["Render's Rock"] = "Rocha dos Laceradores",
	["Render's Valley"] = "Vale dos Laceradores",
	["Rensai's Watchpost"] = "Posto de Guarda Rensai",
	["Rethban Caverns"] = "Cavernas Retibanas",
	["Rethress Sanctum"] = "Sacrário de Rethress",
	Reuse = "Reutilizar",
	["Reuse Me 7"] = "Reuse-me 7",
	["Revantusk Village"] = "Aldeia Revatusco",
	["Rhea's Camp"] = "Acampamento de Rhea",
	["Rhonin's Beard"] = "Barba de Rhonin",
	["Rhyolith Plateau"] = "Platô de Rhyolith",
	["Ricket's Folly"] = "O Erro da Ricket",
	["Ridge of Laughing Winds"] = "Serra dos Ventos Risonhos",
	["Ridge of Madness"] = "Pico da Loucura",
	["Ridgepoint Tower"] = "Torre Serrana",
	Rikkilea = "Rikkilea",
	["Rikkitun Village"] = "Vila de Rikkitun",
	["Rim of the World"] = "Perímetro do Mundo",
	["Ring of Judgement"] = "Ringue do Julgamento",
	["Ring of Observance"] = "Círculo da Obediência",
	["Ring of the Elements"] = "Círculo dos Elementos",
	["Ring of the Law"] = "Círculo da Lei",
	["Riplash Ruins"] = "Ruínas Quebramar",
	["Riplash Strand"] = "Areal Quebramar",
	["Rise of Suffering"] = "Beira do Sofrimento",
	["Rise of the Defiler"] = "Cerro do Profanador",
	["Ritual Chamber of Akali"] = "Câmara Ritualística de Akali",
	["Rivendark's Perch"] = "Ninho do Rivenegro",
	Rivenwood = "Bosque Fendido",
	["River's Heart"] = "Coração do Rio",
	["Rock of Durotan"] = "Rocha de Durotan",
	["Rockpool Village"] = "Vila de Poçapétrea",
	["Rocktusk Farm"] = "Fazenda Petradente",
	["Roguefeather Den"] = "Covil Plumerrante",
	["Rogues' Quarter"] = "Distrito dos Ladinos",
	["Rohemdal Pass"] = "Desfiladeiro de Rohemdal",
	["Roland's Doom"] = "O Descanso de Rolando",
	["Room of Hidden Secrets"] = "Sala dos Segredos Escondidos",
	["Roost of Ji-Kun"] = "Aposentos de Ji-Kun",
	["Rotbrain Encampment"] = "Acampamento Miolo Podre",
	["Royal Amphitheater"] = "Anfiteatro Real",
	["Royal Approach"] = "Caminho Real",
	["Royal Exchange Auction House"] = "Casa de Leilões do Real Erário",
	["Royal Exchange Bank"] = "Banco do Real Erário",
	["Royal Gallery"] = "Galeria Real",
	["Royal Library"] = "Biblioteca Real",
	["Royal Quarter"] = "Distrito Real",
	["Ruby Dragonshrine"] = "Santuário Dragônico Rubi",
	["Ruined Approach"] = "Acesso em Ruínas",
	["Ruined City Post 01"] = "Posto 01 da Cidade Arruinada",
	["Ruined Court"] = "Pátio Arruinado",
	["Ruins of Aboraz"] = "Ruínas de Aboraz",
	["Ruins of Ahmtul"] = "Ruínas de Ahmtul",
	["Ruins of Ahn'Qiraj"] = "Ruínas de Ahn'Qiraj",
	["Ruins of Alterac"] = "Ruínas de Alterac",
	["Ruins of Ammon"] = "Ruínas de Ammon",
	["Ruins of Arkkoran"] = "Ruínas de Arkkoran",
	["Ruins of Auberdine"] = "Ruínas de Auberdine",
	["Ruins of Baa'ri"] = "Ruínas de Baa'ri",
	["Ruins of Constellas"] = "Ruínas de Constellas",
	["Ruins of Dojan"] = "Ruínas de Dojan",
	["Ruins of Drakgor"] = "Ruínas de Drakgor",
	["Ruins of Drak'Zin"] = "Ruínas de Drak'Zin",
	["Ruins of Eldarath"] = "Ruínas de Eldarath", -- Needs review
	["Ruins of Eldarath "] = "Ruínas de Eldarath",
	["Ruins of Eldra'nath"] = "Ruínas de Eldra'nath",
	["Ruins of Eldre'thar"] = "Ruínas de Eldre'thar",
	["Ruins of Enkaat"] = "Ruínas de Enkaat",
	["Ruins of Farahlon"] = "Ruínas de Farahlon",
	["Ruins of Feathermoon"] = "Ruínas de Plumaluna",
	["Ruins of Gilneas"] = "Ruínas de Guilnéas",
	["Ruins of Gilneas City"] = "Ruínas da Cidade de Guilnéas",
	["Ruins of Guo-Lai"] = "Ruínas de Guo-Lai",
	["Ruins of Isildien"] = "Ruínas de Isildien",
	["Ruins of Jubuwal"] = "Ruínas de Jubuwal",
	["Ruins of Karabor"] = "Ruínas de Karabor",
	["Ruins of Kargath"] = "Ruínas de Karrath",
	["Ruins of Khintaset"] = "Ruínas de Khintaset",
	["Ruins of Korja"] = "Ruínas de Korja",
	["Ruins of Korune"] = "Ruínas de Korune",
	["Ruins of Lar'donir"] = "Ruínas de Lar'donir",
	["Ruins of Lordaeron"] = "Ruínas de Lordaeron",
	["Ruins of Loreth'Aran"] = "Ruínas de Loreth'Aran",
	["Ruins of Lornesta"] = "Ruínas de Lornesta",
	["Ruins of Mathystra"] = "Ruínas de Mathistra",
	["Ruins of Nordressa"] = "Ruínas de Nordressa",
	["Ruins of Ogudei"] = "Ruínas de Ogudei",
	["Ruins of Ravenwind"] = "Ruínas dos Ventos Corvejantes",
	["Ruins of Sha'naar"] = "Ruínas de Sha'naar",
	["Ruins of Shandaral"] = "Ruínas de Shandaral",
	["Ruins of Silvermoon"] = "Ruínas de Luaprata",
	["Ruins of Solarsal"] = "Ruínas de Solarsal",
	["Ruins of Southshore"] = "Ruínas da Costa Sul",
	["Ruins of Taurajo"] = "Ruínas de Taurajo",
	["Ruins of Tethys"] = "Ruínas de Tethys",
	["Ruins of Thaurissan"] = "Ruínas de Thaurissan",
	["Ruins of Thelserai Temple"] = "Ruínas do Templo Thelserai",
	["Ruins of Theramore"] = "Ruínas de Theramore",
	["Ruins of the Scarlet Enclave"] = "Ruínas do Enclave Escarlate",
	["Ruins of Uldum"] = "Ruínas de Uldum",
	["Ruins of Vashj'elan"] = "Ruínas de Vashj'elan",
	["Ruins of Vashj'ir"] = "Ruínas de Vashj'ir",
	["Ruins of Zul'Kunda"] = "Ruínas de Zul'Kanda",
	["Ruins of Zul'Mamwe"] = "Ruínas de Zul'Mamwe",
	["Ruins Rise"] = "Alto das Ruínas",
	["Rumbling Terrace"] = "Terraço Retumbante",
	["Runestone Falithas"] = "Pedra Rúnica Falithas",
	["Runestone Shan'dor"] = "Pedra Rúnica Shan'dor",
	["Runeweaver Square"] = "Praça Fiarruna",
	["Rustberg Village"] = "Vila Montanha da Ferrugem",
	["Rustmaul Dive Site"] = "Local de Mergulho Velhomalho",
	["Rutsak's Guard"] = "Guarda de Rutsak",
	["Rut'theran Village"] = "Vila de Rut'theran",
	["Ruuan Weald"] = "Bosque Ruuan",
	["Ruuna's Camp"] = "Acampamento da Ruuna",
	["Ruuzel's Isle"] = "Ilha de Ruuzel",
	["Rygna's Lair"] = "Covil de Rygna",
	["Sable Ridge"] = "Serra Zibelina",
	["Sacrificial Altar"] = "Altar de Sacrifícios",
	["Sahket Wastes"] = "Deserto Sahket",
	Salabria = "Salábria",
	["Saldean's Farm"] = "Fazenda dos Saldanha",
	["Saltheril's Haven"] = "Refúgio de Saltheril",
	["Saltspray Glen"] = "Vale Espuma de Sal",
	["Sanctuary of Malorne"] = "Santuário de Malorne",
	["Sanctuary of Shadows"] = "Santuário das Sombras",
	["Sanctum of Reanimation"] = "Sacrário da Reanimação",
	["Sanctum of Shadows"] = "Sacrário das Sombras",
	["Sanctum of the Ascended"] = "Sacrário dos Elevados",
	["Sanctum of the Fallen God"] = "Sacrário do Deus Caído",
	["Sanctum of the Moon"] = "Sacrário Lunar",
	["Sanctum of the Prophets"] = "Sacrário dos Profetas",
	["Sanctum of the South Wind"] = "Sacrário do Vento Sul",
	["Sanctum of the Stars"] = "Sacrário Estelar",
	["Sanctum of the Sun"] = "Sacrário Solar",
	["Sands of Nasam"] = "Areias de Nasam",
	["Sandsorrow Watch"] = "Posto Silitriste",
	["Sandy Beach"] = "Praia Arenosa",
	["Sandy Shallows"] = "Baixio Arenoso",
	["Sanguine Chamber"] = "Câmara Sanguínea",
	["Sapphire Hive"] = "Colmeia Safira",
	["Sapphiron's Lair"] = "Covil do Sapphiron",
	["Saragosa's Landing"] = "Patamar de Saragosa",
	Sarahland = "Saralândia",
	["Sardor Isle"] = "Ilha de Sardor",
	Sargeron = "Sargeron",
	["Sarjun Depths"] = "Fosso Sarjun",
	["Saronite Mines"] = "Minas de Saronita",
	["Sar'theris Strand"] = "Praia de Sar'theris",
	Satyrnaar = "Satyrnaar",
	["Saurok Creation Pit"] = "Vala de Criação Saurok",
	["Savage Ledge"] = "Plataforma Selvagem",
	["Scalawag Point"] = "Angra dos Malandros",
	["Scalding Pools"] = "Lagos Escaldantes",
	["Scalebeard's Cave"] = "Caverna do Barbescama",
	["Scalewing Shelf"] = "Planalto Escamasa",
	["Scarab Terrace"] = "Terraço dos Escaravelhos",
	["Scarlet Encampment"] = "Acampamento Escarlate",
	["Scarlet Halls"] = "Salões Escarlates",
	["Scarlet Hold"] = "Castelo Escarlate",
	["Scarlet Monastery"] = "Monastério Escarlate",
	["Scarlet Monastery Entrance"] = "Entrada do Monastério Escarlate",
	["Scarlet Overlook"] = "Penhasco Escarlate",
	["Scarlet Palisade"] = "Paliçada Escarlate",
	["Scarlet Point"] = "Vista Escarlate",
	["Scarlet Raven Tavern"] = "Taberna Corvo Escarlate",
	["Scarlet Tavern"] = "Taberna Escarlate",
	["Scarlet Tower"] = "Torre Escarlate",
	["Scarlet Watch Post"] = "Posto da Vigília Escarlate",
	["Scarlet Watchtower"] = "Mirante Escarlate",
	["Scar of the Worldbreaker"] = "Cicatriz do Quebramundo",
	["Scarred Terrace"] = "Terraço de Cicatrizes",
	["Scenario: Alcaz Island"] = "Cenário: Ilha Alcaz",
	["Scenario - Black Ox Temple"] = "Cenário - Templo do Boi Negro",
	["Scenario - Mogu Ruins"] = "Cenário - Ruínas Mogu",
	["Scenic Overlook"] = "Mirante Panorâmico",
	["Schnottz's Frigate"] = "Fragata do Schnottz",
	["Schnottz's Hostel"] = "Albergue do Schnottz",
	["Schnottz's Landing"] = "Porto de Schnottz",
	Scholomance = "Scolomântia",
	["Scholomance Entrance"] = "Entrada de Scolomântia",
	ScholomanceOLD = "ScolomântiaOLD",
	["School of Necromancy"] = "Escola de Necromancia",
	["Scorched Gully"] = "Barranca Assolada",
	["Scott's Spooky Area"] = "Área Assombrada do Scott",
	["Scoured Reach"] = "Borda Limpa",
	Scourgehold = "Fortaleza do Flagelo",
	Scourgeholme = "Forte do Flagelo",
	["Scourgelord's Command"] = "Comando do Senhor do Flagelo",
	["Scrabblescrew's Camp"] = "Acampamento do Rabiscafuso",
	["Screaming Gully"] = "Barranca Estridente",
	["Scryer's Tier"] = "Terraço dos Áugures",
	["Scuttle Coast"] = "Praia do Bota-a-pique",
	Sea = "Mar",
	Seabrush = "Onda do Mar",
	["Seafarer's Tomb"] = "Tumba do Marinheiro",
	["Sealed Chambers"] = "Câmaras Seladas",
	["Seal of the Sun King"] = "Selo do Rei Sol",
	["Sea Mist Ridge"] = "Serra da Névoa Marinha",
	["Searing Gorge"] = "Garganta Abrasadora",
	["Seaspittle Cove"] = "Angra Cuspe Marinho",
	["Seaspittle Nook"] = "Antro Cuspe Marinho",
	["Seat of Destruction"] = "Trono da Destruição",
	["Seat of Knowledge"] = "Trono do Conhecimento",
	["Seat of Life"] = "Trono da Vida",
	["Seat of Magic"] = "Trono da Magia",
	["Seat of Radiance"] = "Trono do Esplendor",
	["Seat of the Chosen"] = "Trono dos Escolhidos",
	["Seat of the Naaru"] = "Sede dos Naarus",
	["Seat of the Spirit Waker"] = "Trono do Agitador de Espíritos",
	["Seeker's Folly"] = "Delírio do Buscador",
	["Seeker's Point"] = "Posto do Buscador",
	["Sen'jin Village"] = "Aldeia Sen'jin",
	["Sen'jin Village Outskirts"] = "Arredores da Aldeia Sen'jin",
	["Sentinel Basecamp"] = "Base Sentinela",
	["Sentinel Hill"] = "Morro da Sentinela",
	["Sentinel Tower"] = "Torre Sentinela",
	["Sentry Point"] = "Pontal de Vigília",
	Seradane = "Seradane",
	["Serenity Falls"] = "Cataratas da Serenidade",
	["Serpent Lake"] = "Lago Serpente",
	["Serpent's Coil"] = "Cavernas Serpeantes",
	["Serpent's Heart"] = "Coração da Serpente",
	["Serpentshrine Cavern"] = "Caverna do Serpentário",
	["Serpent's Overlook"] = "Mirante da Serpente",
	["Serpent's Spine"] = "Espinhaço da Serpente",
	["Servants' Quarters"] = "Área dos Serviçais",
	["Service Entrance"] = "Entrada de Serviço",
	["Sethekk Halls"] = "Salões dos Sethekk",
	["Sethria's Roost"] = "Mirante de Sethria",
	["Setting Sun Garrison"] = "Guarnição do Sol Poente",
	["Set'vess"] = "Set'vess",
	["Sewer Access Point"] = "Ponto de Acesso ao Esgoto",
	["Sewer Exit Pipe"] = "Cano de Saída dos Esgotos",
	Sewers = "Esgotos",
	Shadebough = "Ramo Sombrio",
	["Shadewood Thicket"] = "Bosque das Sombras",
	["Shado-Li Basin"] = "Bacia Shado-Li",
	["Shado-Pan Fallback"] = "Refúgio Shado-Pan",
	["Shado-Pan Garrison"] = "Guarnição Shado-Pan",
	["Shado-Pan Monastery"] = "Monastério Shado-pan",
	["Shadowbreak Ravine"] = "Ravina da Sombra Partida",
	["Shadowfang Keep"] = "Bastilha da Presa Negra",
	["Shadowfang Keep Entrance"] = "Entrada da Bastilha da Presa Negra",
	["Shadowfang Tower"] = "Torre da Presa Negra",
	["Shadowforge City"] = "Cidade de Umbraforja",
	Shadowglen = "Umbravale",
	["Shadow Grave"] = "Sepulcro Sombrio",
	["Shadow Hold"] = "Fortaleza do Concílio das Sombras",
	["Shadow Labyrinth"] = "Labirinto Soturno",
	["Shadowlurk Ridge"] = "Serra da Cordilheira Sombria",
	["Shadowmoon Valley"] = "Vale da Lua Negra",
	["Shadowmoon Village"] = "Aldeia Lua Negra",
	["Shadow-Pan Monastery"] = "Monastério Shado-Pan",
	["Shadowprey Village"] = "Aldeia Pescassombra",
	["Shadow Ridge"] = "Serra das Sombras",
	["Shadowshard Cavern"] = "Caverna Lascanegra",
	["Shadowsight Tower"] = "Mirante Negro",
	["Shadowsong Shrine"] = "Ermida Cantonegro",
	["Shadowthread Cave"] = "Caverna Fionumbra",
	["Shadow Tomb"] = "Tumba Sombria",
	["Shadow Wing Lair"] = "Covil do Asa Sombria",
	["Shadra'Alor"] = "Shadra'Alor",
	["Shadybranch Pocket"] = "Bolsão Galho Sombrio",
	["Shady Rest Inn"] = "Estalagem Pouso do Umbral",
	["Shalandis Isle"] = "Ilha Shalandis",
	["Shalewind Canyon"] = "Garganta do Barro Seco",
	["Shallow's End"] = "Beira Fundo",
	["Shallowstep Pass"] = "Passo Leve",
	["Shalzaru's Lair"] = "Covil de Shalzaru",
	Shamanar = "Shamanar",
	["Sha'naari Wastes"] = "Deserto Sha'naari",
	["Shang's Stead"] = "Fazenda do Shang",
	["Shang's Valley"] = "Vale de Shang",
	["Shang Xi Training Grounds"] = "Campo de Treinamento de Shang Xi",
	["Shan'ze Dao"] = "Shan'ze Dao",
	["Shaol'mara"] = "Shaol'mara",
	["Shaol'watha"] = "Shaol'watha",
	["Shaper's Terrace"] = "Terraço do Moldador", -- Needs review
	["Shaper's Terrace "] = "Terraço do Moldador",
	["Shartuul's Transporter"] = "Transporte de Shartuul",
	["Sha'tari Base Camp"] = "Acampamento Sha'tari",
	["Sha'tari Outpost"] = "Posto Sha'tari",
	["Shattered Convoy"] = "Caravana Despedaçada",
	["Shattered Plains"] = "Platô Despedaçado",
	["Shattered Straits"] = "Estreito dos Estilhaços",
	["Shattered Sun Staging Area"] = "Bivaque Sol Partido",
	["Shatter Point"] = "Posto Despedaçado",
	["Shatter Scar Vale"] = "Vale das Escaras Pungentes",
	Shattershore = "Costa Partida",
	["Shatterspear Pass"] = "Desfiladeiro da Lança Partida",
	["Shatterspear Vale"] = "Vale da Lança Partida",
	["Shatterspear War Camp"] = "Acampamento de Guerra Lança Partida",
	Shatterstone = "Rachapedra",
	Shattrath = "Shattrath",
	["Shattrath City"] = "Shattrath",
	["Shelf of Mazu"] = "Croa de Mazu",
	["Shell Beach"] = "Praia da Concha",
	["Shield Hill"] = "Monte Égide",
	["Shields of Silver"] = "Escudos de Prata",
	["Shimmering Bog"] = "Brejo Cintilante",
	["Shimmering Expanse"] = "Vastidão Cintilante",
	["Shimmering Grotto"] = "Gruta Cintilante",
	["Shimmer Ridge"] = "Cordilheira Cintilante",
	["Shindigger's Camp"] = "Alambique do Borracho",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Barco para Vashj'ir (Orgrimmar -> Vashj'ir)",
	["Shipwreck Shore"] = "Costa do Naufrágio",
	Shipyard = "Estaleiro",
	["Shipyard - Mogu Island Progression Scenario"] = "Estaleiro - Progressão do Cenário da Ilha Mogu",
	["Shok'Thokar"] = "Shok'Thokar",
	["Sholazar Basin"] = "Bacia Sholazar",
	["Shores of the Well"] = "Bordas da Nascente",
	["Shrine of Aessina"] = "Altar de Aessina", -- Needs review
	["Shrine of Aviana"] = "Santuário de Aviana",
	["Shrine of Dath'Remar"] = "Altar de Dath'Remar",
	["Shrine of Dreaming Stones"] = "Altar das Pedras Sonhadoras",
	["Shrine of Eck"] = "Santuário de Eck",
	["Shrine of Fellowship"] = "Santuário da Amizade",
	["Shrine of Five Dawns"] = "Altar das Cinco Auroras",
	["Shrine of Goldrinn"] = "Santuário de Goldrinn",
	["Shrine of Inner-Light"] = "Santuário da Luz Interior",
	["Shrine of Lost Souls"] = "Santuário das Almas Perdidas",
	["Shrine of Nala'shi"] = "Santuário de Nala'shi",
	["Shrine of Remembrance"] = "Templo da Lembrança",
	["Shrine of Remulos"] = "Santuário de Remulos",
	["Shrine of Scales"] = "Altar das Escamas",
	["Shrine of Seven Stars"] = "Santuário das Sete Estrelas",
	["Shrine of Thaurissan"] = "Santuário de Thaurissan",
	["Shrine of the Dawn"] = "Templo da Aurora",
	["Shrine of the Deceiver"] = "Santuário do Embusteiro",
	["Shrine of the Dormant Flame"] = "Altar da Chama Latente",
	["Shrine of the Eclipse"] = "Santuário do Eclipse",
	["Shrine of the Elements"] = "Santuário dos Elementos",
	["Shrine of the Fallen Warrior"] = "Altar do Guerreiro Caído",
	["Shrine of the Five Khans"] = "Santuário dos Cinco Khans",
	["Shrine of the Merciless One"] = "Altar do Impiedoso",
	["Shrine of the Ox"] = "Templo do Boi",
	["Shrine of Twin Serpents"] = "Santuário das Serpentes Gêmeas",
	["Shrine of Two Moons"] = "Santuário das Duas Luas",
	["Shrine of Unending Light"] = "Templo da Luz Perene",
	["Shriveled Oasis"] = "Oásis Murcho",
	["Shuddering Spires"] = "Agulhas Tremulantes",
	["SI:7"] = "AVIN",
	["Siege of Niuzao Temple"] = "Cerco ao Templo Niuzao",
	["Siege Vise"] = "Torno de Cerco",
	["Siege Workshop"] = "Oficina de Cerco",
	["Sifreldar Village"] = "Aldeia Sifreldar",
	["Sik'vess"] = "Sik'vess",
	["Sik'vess Lair"] = "Covil de Sik'vess",
	["Silent Vigil"] = "Vigia Silente",
	Silithus = "Silithus",
	["Silken Fields"] = "Campos de Seda",
	["Silken Shore"] = "Costa Sedosa",
	["Silmyr Lake"] = "Lago Silmyr",
	["Silting Shore"] = "Baía do Limo",
	Silverbrook = "Arroio Prateado",
	["Silverbrook Hills"] = "Serra do Arroio Prateado",
	["Silver Covenant Pavilion"] = "Pavilhão do Pacto de Prata",
	["Silverlight Cavern"] = "Caverna da Luz Prateada",
	["Silverline Lake"] = "Lago da Linha Prateada",
	["Silvermoon City"] = "Luaprata",
	["Silvermoon City Inn"] = "Estalagem de Luaprata",
	["Silvermoon Finery"] = "DasLuna Moda Fashion",
	["Silvermoon Jewelery"] = "Joalheria de Luaprata",
	["Silvermoon Registry"] = "Cartório de Luaprata",
	["Silvermoon's Pride"] = "Orgulho de Luaprata",
	["Silvermyst Isle"] = "Ilha Nevoaprata",
	["Silverpine Forest"] = "Floresta de Pinhaprata",
	["Silvershard Mines"] = "Minas Estilhaço Prateado",
	["Silver Stream Mine"] = "Mina da Prata",
	["Silver Tide Hollow"] = "Antro da Maré Prateada",
	["Silver Tide Trench"] = "Trincheira da Maré Prateada",
	["Silverwind Refuge"] = "Refúgio Brisaprata",
	["Silverwing Flag Room"] = "Sala da Bandeira Asa de Prata",
	["Silverwing Grove"] = "Bosque Asa de Prata",
	["Silverwing Hold"] = "Castelo Asa de Prata",
	["Silverwing Outpost"] = "Posto Avançado Asa de Prata",
	["Simply Enchanting"] = "Simplesmente Encantador",
	["Sindragosa's Fall"] = "Queda de Sindragosa",
	["Sindweller's Rise"] = "Promontório do Vicíssitus",
	["Singing Marshes"] = "Pântanos Cantantes",
	["Singing Ridge"] = "Platô Harmônico",
	["Sinner's Folly"] = "Extravagância do Pecador",
	["Sira'kess Front"] = "Front Sira'kess",
	["Sishir Canyon"] = "Desfiladeiro Sishir",
	["Sisters Sorcerous"] = "Irmãs Bruxedas",
	Skald = "Skald",
	["Sketh'lon Base Camp"] = "Base Sketh'lon",
	["Sketh'lon Wreckage"] = "Ruínas de Sketh'lon",
	["Skethyl Mountains"] = "Montanhas Skethil",
	Skettis = "Skettis",
	["Skitterweb Tunnels"] = "Túneis Tremeteia",
	Skorn = "Skorn",
	["Skulking Row"] = "Passeio Furtivo",
	["Skulk Rock"] = "Rocha Oculta",
	["Skull Rock"] = "Rocha da Caveira",
	["Sky Falls"] = "Cachoeira Celeste",
	["Skyguard Outpost"] = "Posto Avançado da Guarda Aérea",
	["Skyline Ridge"] = "Serra do Horizonte",
	Skyrange = "Serra do Céu",
	["Skysong Lake"] = "Lago Celicanto",
	["Slabchisel's Survey"] = "Guarda de Cinzelaje",
	["Slag Watch"] = "Mirante da Escória",
	Slagworks = "Escoriodutos",
	["Slaughter Hollow"] = "Antro do Massacre",
	["Slaughter Square"] = "Praça do Massacre",
	["Sleeping Gorge"] = "Garganta Adormecida",
	["Slicky Stream"] = "Córrego dos Muçuns",
	["Slingtail Pits"] = "Fossos Bodoqueiros",
	["Slitherblade Shore"] = "Praia Sibilâmina",
	["Slithering Cove"] = "Angra do Resvalo",
	["Slither Rock"] = "Rocha Coleante",
	["Sludgeguard Tower"] = "Torre da Guardalodo",
	["Smuggler's Scar"] = "Fenda do Contrabandista",
	["Snicklefritz Mine"] = "Mina de Snicklefritz",
	["Snowblind Hills"] = "Serra Ceganeve",
	["Snowblind Terrace"] = "Terraço Ceganeve",
	["Snowden Chalet"] = "Chalé Covaneve",
	["Snowdrift Dojo"] = "Dojo Monte de Neve",
	["Snowdrift Plains"] = "Planícies Nevadas",
	["Snowfall Glade"] = "Clareira Nevada",
	["Snowfall Graveyard"] = "Cemitério Nevado",
	["Socrethar's Seat"] = "Trono de Socrethar",
	["Sofera's Naze"] = "Promontório de Sofera",
	["Soggy's Gamble"] = "Gambito do Encharco",
	["Solace Glade"] = "Clareira da Consolação",
	["Solliden Farmstead"] = "Fazenda dos Solliden",
	["Solstice Village"] = "Aldeia Solstício",
	["Sorlof's Strand"] = "Praia de Sorlof",
	["Sorrow Hill"] = "Colina do Pesar",
	["Sorrow Hill Crypt"] = "Cripta da Colina do Pesar",
	Sorrowmurk = "Penumbra das Mágoas",
	["Sorrow Wing Point"] = "Ilha Pesarasa",
	["Soulgrinder's Barrow"] = "Tumba do Trituralma",
	["Southbreak Shore"] = "Costa Quebra-sul",
	["South Common Hall"] = "Saguão Sul",
	["Southern Barrens"] = "Sertões Meridionais",
	["Southern Gold Road"] = "Estrada do Ouro Sul",
	["Southern Rampart"] = "Muralha do Sul",
	["Southern Rocketway"] = "Foguetovia Sul",
	["Southern Rocketway Terminus"] = "Terminal Sul da Foguetovia",
	["Southern Savage Coast"] = "Costa Selvagem Sul",
	["Southfury River"] = "Rio Furiaustral",
	["Southfury Watershed"] = "Bacia Furiaustral",
	["South Gate Outpost"] = "Posto de Guarda do Portão Sul",
	["South Gate Pass"] = "Desfiladeiro do Portão Sul",
	["Southmaul Tower"] = "Torre Martelo do Sul",
	["Southmoon Ruins"] = "Ruínas de Lunassul",
	["South Pavilion"] = "Pavilhão Sul",
	["Southpoint Gate"] = "Portão do Sul",
	["South Point Station"] = "Estação Sul",
	["Southpoint Tower"] = "Torre do Sul",
	["Southridge Beach"] = "Praia do Recife Sul",
	["Southsea Holdfast"] = "Raízes dos Mares do Sul",
	["South Seas"] = "Mares do Sul",
	Southshore = "Costa Sul",
	["Southshore Town Hall"] = "Prefeitura da Costa Sul",
	["South Spire"] = "Torre Sul",
	["South Tide's Run"] = "Costa da Maré do Sul",
	["Southwind Cleft"] = "Fenda do Vento Sul",
	["Southwind Village"] = "Vila do Vento Sul",
	["Sparkrocket Outpost"] = "Posto Avançado Foguetelouco",
	["Sparksocket Minefield"] = "Campo Minado do Curtomada",
	["Sparktouched Haven"] = "Refúgio Piscabrilha",
	["Sparring Hall"] = "Salão da Disputa",
	["Spearborn Encampment"] = "Assentamento do Povo da Lança",
	Spearhead = "Ponta de Lança",
	["Speedbarge Bar"] = "Bar do Barcódromo",
	Spellsails = "Magivelas",
	["Spinebreaker Mountains"] = "Montanhas Quebra-espinha",
	["Spinebreaker Pass"] = "Desfiladeiro Quebra-espinha",
	["Spinebreaker Post"] = "Acampamento Quebra-espinha",
	["Spinebreaker Ridge"] = "Cordilheira Quebra-Espinha",
	["Spiral of Thorns"] = "Espiral de Espinhos",
	["Spire of Blood"] = "Torre Sangrenta",
	["Spire of Decay"] = "Torre da Decomposição",
	["Spire of Pain"] = "Torre da Dor",
	["Spire of Solitude"] = "Pináculo da Solidão",
	["Spire Throne"] = "Trono da Espícula",
	["Spirit Den"] = "Covil dos Espíritos",
	["Spirit Fields"] = "Campos dos Espíritos",
	["Spirit Rise"] = "Platô dos Espíritos",
	["Spirit Rock"] = "Rocha dos Espíritos",
	["Spiritsong River"] = "Rio da Canção espiritual",
	["Spiritsong's Rest"] = "Repouso da Canção Espiritual",
	["Spitescale Cavern"] = "Caverna das Escamas Odiosas",
	["Spitescale Cove"] = "Covil dos Escamas Odiosas",
	["Splinterspear Junction"] = "Entroncamento da Lança Lascada",
	Splintertree = "Machadada",
	["Splintertree Mine"] = "Mina Machadada",
	["Splintertree Post"] = "Posto Machadada",
	["Splithoof Crag"] = "Rochedo do Casco Fendido",
	["Splithoof Heights"] = "Serra do Casco Fendido",
	["Splithoof Hold"] = "Castelo do Casco Fendido",
	Sporeggar = "Sporeggar",
	["Sporewind Lake"] = "Lago dos Esporos",
	["Springtail Crag"] = "Rochedo Cauda-de-mola",
	["Springtail Warren"] = "Toca dos Cauda-de-mola",
	["Spruce Point Post"] = "Posto Ponta do Pinheiro",
	["Sra'thik Incursion"] = "Incursão Sra'thik",
	["Sra'thik Swarmdock"] = "Cais do Enxame Sra'thik",
	["Sra'vess"] = "Sra'vess",
	["Sra'vess Rootchamber"] = "Câmara das Raízes Sra'vess",
	["Sri-La Inn"] = "Estalagem Sri-La",
	["Sri-La Village"] = "Aldeia Sri-La",
	Stables = "Estábulos",
	Stagalbog = "Pantanal dos Cervos",
	["Stagalbog Cave"] = "Caverna Pantanal dos Cervos",
	["Stagecoach Crash Site"] = "Acidente da Diligência",
	["Staghelm Point"] = "Posto Guenelmo",
	["Staging Balcony"] = "Plataforma de Comando",
	["Stairway to Honor"] = "Escadaria da Honra",
	["Starbreeze Village"] = "Vilarejo Brisastral",
	["Stardust Spire"] = "Torre Poeira Estelar",
	["Starfall Village"] = "Aldeia Chuva Estelar",
	["Stars' Rest"] = "Recanto das Estrelas",
	["Stasis Block: Maximus"] = "Quadra de Estase: Maximus",
	["Stasis Block: Trion"] = "Quadra de Estase: Trion",
	["Steam Springs"] = "Fontes Vaporosas",
	["Steamwheedle Port"] = "Porto de Bondebico",
	["Steel Gate"] = "Portão de Aço",
	["Steelgrill's Depot"] = "Garagem do Gradaço",
	["Steeljaw's Caravan"] = "Caravana do Queixoduro",
	["Steelspark Station"] = "Estação Fagulhaço",
	["Stendel's Pond"] = "Lago Stendel",
	["Stillpine Hold"] = "Aldeia de Pinhoquieto",
	["Stillwater Pond"] = "Lagoa das Águas Paradas",
	["Stillwhisper Pond"] = "Lagoa do Eterno Sussurro",
	Stonard = "Pedregal",
	["Stonebreaker Camp"] = "Acampamento Quebrapedra",
	["Stonebreaker Hold"] = "Vila de Quebrapedra",
	["Stonebull Lake"] = "Lago da Ferradura",
	["Stone Cairn Lake"] = "Lago do Monumento",
	Stonehearth = "Larpétreo",
	["Stonehearth Bunker"] = "Casamata Larpétreo",
	["Stonehearth Graveyard"] = "Cemitério Larpétreo",
	["Stonehearth Outpost"] = "Posto Avançado Larpétreo",
	["Stonemaul Hold"] = "Acampamento dos Pedramalho",
	["Stonemaul Ruins"] = "Ruínas Pedramalho",
	["Stone Mug Tavern"] = "Taberna Caneca de Pedra",
	Stoneplow = "Arado de Pedra",
	["Stoneplow Fields"] = "Campos do Arado de Pedra",
	["Stone Sentinel's Overlook"] = "Mirante da Sentinela Pétrea",
	["Stonesplinter Valley"] = "Vale Lascapedra",
	["Stonetalon Bomb"] = "Bomba das Torres de Pedra",
	["Stonetalon Mountains"] = "Cordilheira das Torres de Pedra",
	["Stonetalon Pass"] = "Desfiladeiro das Torres de Pedra",
	["Stonetalon Peak"] = "Morro das Torres de Pedra",
	["Stonewall Canyon"] = "Garganta de Pedra",
	["Stonewall Lift"] = "Elevador do Muro-de-pedra",
	["Stoneward Prison"] = "Prisão Guardapétrea",
	Stonewatch = "Mirante de Pedra",
	["Stonewatch Falls"] = "Cachoeira do Mirante de Pedra",
	["Stonewatch Keep"] = "Bastilha Mirante de Pedra",
	["Stonewatch Tower"] = "Torre Mirante de Pedra",
	["Stonewrought Dam"] = "Dique Lapidado",
	["Stonewrought Pass"] = "Galeria Lapidada",
	["Storm Cliffs"] = "Penhascos Tempestuosos",
	Stormcrest = "Pico Crista de Gelo",
	["Stormfeather Outpost"] = "Posto Avançado Penafúria",
	["Stormglen Village"] = "Aldeia Vale Tormenta",
	["Storm Peaks"] = "Picos Tempestuosos", -- Needs review
	["Stormpike Graveyard"] = "Cemitério Lançatroz",
	["Stormrage Barrow Dens"] = "Templos de Tempesfúria",
	["Stormsea Landing"] = "Ancoradouro do Mar Revolto",
	["Storm's Fury Wreckage"] = "Destroços do Fúria da Tempestade",
	["Stormstout Brewery"] = "Cervejaria Malte do Trovão",
	["Stormstout Brewery Interior"] = "Interior da Cervejaria Malte do Trovão",
	["Stormstout Brewhall"] = "Salão da Cerveja Malte do Trovão",
	Stormwind = "Ventobravo",
	["Stormwind City"] = "Ventobravo",
	["Stormwind City Cemetery"] = "Cemitério de Ventobravo",
	["Stormwind City Outskirts"] = "Arredores de Ventobravo",
	["Stormwind Gunship Pandaria Start Area"] = "Stormwind Gunship Pandaria Start Area",
	["Stormwind Harbor"] = "Porto de Ventobravo",
	["Stormwind Keep"] = "Bastilha Ventobravo",
	["Stormwind Lake"] = "Lago de Ventobravo",
	["Stormwind Mountains"] = "Montanhas de Ventobravo",
	["Stormwind Stockade"] = "Cárcere de Ventobravo",
	["Stormwind Vault"] = "Prisão de Ventobravo",
	["Stoutlager Inn"] = "Estalagem Pilsen",
	Strahnbrad = "Strahnbrad",
	["Strand of the Ancients"] = "Baía dos Ancestrais",
	["Stranglethorn Vale"] = "Selva do Espinhaço",
	Stratholme = "Stratholme",
	["Stratholme Entrance"] = "Entrada de Stratholme",
	["Stratholme - Main Gate"] = "Stratholme – Portão Principal",
	["Stratholme - Service Entrance"] = "Stratholme – Entrada de Serviço",
	["Stratholme Service Entrance"] = "Entrada de Stratholme - Entrada de Serviço",
	["Stromgarde Keep"] = "Bastilha de Stromgarde",
	["Strongarm Airstrip"] = "Pista de Pouso Pulso Firme",
	["STV Diamond Mine BG"] = "VC CB Mina de Diamantes",
	["Stygian Bounty"] = "Recompensa Estígia",
	["Sub zone"] = "Subárea",
	["Sulfuron Keep"] = "Fortaleza de Sulfuron",
	["Sulfuron Keep Courtyard"] = "Pátio da Fortaleza de Sulfuron",
	["Sulfuron Span"] = "Ponte de Sulfuron",
	["Sulfuron Spire"] = "Torre de Sulfuron",
	["Sullah's Sideshow"] = "Espetáculo de Sullah",
	["Summer's Rest"] = "Repouso do Verão",
	["Summoners' Tomb"] = "Tumba dos Evocadores",
	["Sunblossom Hill"] = "Colina Flor do Sol",
	["Suncrown Village"] = "Vila Corona Solar",
	["Sundown Marsh"] = "Pântano do Ocaso",
	["Sunfire Point"] = "Pontal do Fogo Solar",
	["Sunfury Hold"] = "Acampamento Solfúria",
	["Sunfury Spire"] = "Torre Solfúria",
	["Sungraze Peak"] = "Monte Triscassol",
	["Sunken Dig Site"] = "Sítio Arqueológico Submerso",
	["Sunken Temple"] = "Sunken Temple",
	["Sunken Temple Entrance"] = "Entrada do Templo Submerso",
	["Sunreaver Pavilion"] = "Pavilhão Fendessol",
	["Sunreaver's Command"] = "Comando Fendessol",
	["Sunreaver's Sanctuary"] = "Santuário Fendessol",
	["Sun Rock Retreat"] = "Retiro Rocha do Sol",
	["Sunsail Anchorage"] = "Ancoradouro Velaclara",
	["Sunsoaked Meadow"] = "Prado Ensolarado",
	["Sunsong Ranch"] = "Fazenda Sol Cantante",
	["Sunspring Post"] = "Posto Solavera",
	["Sun's Reach Armory"] = "Armaria de Beirassol",
	["Sun's Reach Harbor"] = "Porto de Beirassol",
	["Sun's Reach Sanctum"] = "Sacrário Beirassol",
	["Sunstone Terrace"] = "Terraço da Pedra Solar",
	["Sunstrider Isle"] = "Ilha Andassol",
	["Sunveil Excursion"] = "Acampamento Clarovéu",
	["Sunwatcher's Ridge"] = "Cume de Solarguarda",
	["Sunwell Plateau"] = "Platô da Nascente do Sol",
	["Supply Caravan"] = "Caravana de Suprimentos",
	["Surge Needle"] = "Agulha de Mana",
	["Surveyors' Outpost"] = "Guarita do Topógrafo",
	Surwich = "Mecassur",
	["Svarnos' Cell"] = "Prisão de Svarnos",
	["Swamplight Manor"] = "Casarão do Pantanal Iluminado",
	["Swamp of Sorrows"] = "Pântano das Mágoas",
	["Swamprat Post"] = "Mocó do Rato Lamacento",
	["Swiftgear Station"] = "Estação Entrós",
	["Swindlegrin's Dig"] = "Escavação do Caloteiro",
	["Swindle Street"] = "Rua dos Pilantras",
	["Sword's Rest"] = "Repouso da Espada",
	Sylvanaar = "Sylvanaar",
	["Tabetha's Farm"] = "Fazenda de Tabetha",
	["Taelan's Tower"] = "Torre de Taelan",
	["Tahonda Ruins"] = "Ruínas de Tahonda",
	["Tahret Grounds"] = "Terras de Tahret",
	["Tal'doren"] = "Tal'doren",
	["Talismanic Textiles"] = "Tecidos Talismânicos",
	["Tallmug's Camp"] = "Acampamento de Copo Alto",
	["Talonbranch Glade"] = "Clareira da Galhaça",
	["Talonbranch Glade "] = "Clareira da Galhaça",
	["Talondeep Pass"] = "Trilha Garracava",
	["Talondeep Vale"] = "Vale Garracava",
	["Talon Stand"] = "Planalto da Garra",
	Talramas = "Talramas",
	["Talrendis Point"] = "Campo Talrendis",
	Tanaris = "Tanaris",
	["Tanaris Desert"] = " Deserto de Tanaris", -- Needs review
	["Tanks for Everything"] = "Metal Pesado",
	["Tanner Camp"] = "Acampamento Curtume",
	["Tarren Mill"] = "Serraria Tarren",
	["Tasters' Arena"] = "Arena dos Provadores",
	["Taunka'le Village"] = "Aldeia Taunka'le",
	["Tavern in the Mists"] = "Taberna nas Nuvens",
	["Tazz'Alaor"] = "Tazz'Alaor",
	["Tear Down This Wall!"] = "Derrubem a Muralha!",
	["Teegan's Expedition"] = "Expedição de Timeu",
	["Teeming Burrow"] = "Toca Apinhada",
	Telaar = "Telaar",
	["Telaari Basin"] = "Bacia Telaari",
	["Tel'athion's Camp"] = "Acampamento do Tel'athion",
	Teldrassil = "Teldrassil",
	Telredor = "Telredor",
	["Tempest Bridge"] = "Ponte Tempesto",
	["Tempest Keep"] = "Bastilha da Tormenta",
	["Tempest Keep: The Arcatraz"] = "Bastilha da Tormenta: Arcatraz",
	["Tempest Keep - The Arcatraz Entrance"] = "Entrada da Bastilha da Tormenta: Arcatraz",
	["Tempest Keep: The Botanica"] = "Bastilha da Tormenta: Jardim Botânico",
	["Tempest Keep - The Botanica Entrance"] = "Entrada da Bastilha da Tormenta: Jardim Botânico",
	["Tempest Keep: The Mechanar"] = "Bastilha da Tormenta: Mecanar",
	["Tempest Keep - The Mechanar Entrance"] = "Entrada da Bastilha da Tormenta: Mecanar",
	["Tempest's Reach"] = "Tempestária",
	["Temple City of En'kilah"] = "Cidade-templo de En'kilah",
	["Temple Hall"] = "Salão do Templo",
	["Temple of Ahn'Qiraj"] = "Templo de Ahn'Qiraj", -- Needs review
	["Temple of Arkkoran"] = "Templo de Arkkoran",
	["Temple of Asaad"] = "Templo de Asaad",
	["Temple of Bethekk"] = "Templo de Bethekk",
	["Temple of Earth"] = "Templo da Terra",
	["Temple of Five Dawns"] = "Templo das Cinco Auroras",
	["Temple of Invention"] = "Templo da Invenção",
	["Temple of Kotmogu"] = "Templo de Kotmogu",
	["Temple of Life"] = "Templo da Vida",
	["Temple of Order"] = "Templo da Ordem",
	["Temple of Storms"] = "Templo das Tempestades",
	["Temple of Telhamat"] = "Templo de Telhamat",
	["Temple of the Forgotten"] = "Templo dos Esquecidos",
	["Temple of the Jade Serpent"] = "Templo da Serpente de Jade",
	["Temple of the Moon"] = "Templo da Lua",
	["Temple of the Red Crane"] = "Templo da Garça Vermelha",
	["Temple of the White Tiger"] = "Templo do Tigre Branco",
	["Temple of Uldum"] = "Templo de Uldum",
	["Temple of Winter"] = "Templo do Inverno",
	["Temple of Wisdom"] = "Templo da Sabedoria",
	["Temple of Zin-Malor"] = "Templo de Zin-Malor",
	["Temple Summit"] = "Ápice do Templo",
	["Tenebrous Cavern"] = "Caverna Tenebrosa",
	["Terokkar Forest"] = "Mata Terokkar",
	["Terokk's Rest"] = "Repouso de Terokk",
	["Terrace of Endless Spring"] = "Terraço da Primavera Eterna",
	["Terrace of Gurthan"] = "Terraço de Gurthan",
	["Terrace of Light"] = "Terraço da Luz",
	["Terrace of Repose"] = "Terraço do Repouso",
	["Terrace of Ten Thunders"] = "Terraço dos Dez Trovões",
	["Terrace of the Augurs"] = "Terraço dos Áugures",
	["Terrace of the Makers"] = "Terraço dos Criadores",
	["Terrace of the Sun"] = "Terraço do Sol",
	["Terrace of the Tiger"] = "Terraço do Tigre",
	["Terrace of the Twin Dragons"] = "Terraço dos Dragões Gêmeos",
	Terrordale = "Várzea do Medo",
	["Terror Run"] = "Terroral",
	["Terrorweb Tunnel"] = "Túnel Terrorteia",
	["Terror Wing Path"] = "Vale Asa do Terror",
	["Tethris Aran"] = "Tethris Aran",
	Thalanaar = "Thalanaar",
	["Thalassian Pass"] = "Caminho Thalassiano",
	["Thalassian Range"] = "Serra Talassiana",
	["Thal'darah Grove"] = "Bosque de Thal'darah",
	["Thal'darah Overlook"] = "Mirante de Thal'darah",
	["Thandol Span"] = "Ponte Thandol",
	["Thargad's Camp"] = "Acampamento de Thargad",
	["The Abandoned Reach"] = "Os Confins Abandonados",
	["The Abyssal Maw"] = "Oceano Abissal",
	["The Abyssal Shelf"] = "Prateleira Abissal",
	["The Admiral's Den"] = "Toca do Almirante",
	["The Agronomical Apothecary"] = "A Boticária Agronômica",
	["The Alliance Valiants' Ring"] = "Arena dos Valentes da Aliança",
	["The Altar of Damnation"] = "Altar da Danação",
	["The Altar of Shadows"] = "Altar das Sombras",
	["The Altar of Zul"] = "Altar de Zul",
	["The Amber Hibernal"] = "Âmbar Invernal",
	["The Amber Vault"] = "Salão de Âmbar",
	["The Amber Womb"] = "Ventre de âmbar",
	["The Ancient Grove"] = "Bosque Antigo",
	["The Ancient Lift"] = "Elevador Ancestral",
	["The Ancient Passage"] = "Passagem Antiga",
	["The Antechamber"] = "A Antecâmara",
	["The Anvil of Conflagration"] = "A Bigorna da Conflagração",
	["The Anvil of Flame"] = "A Bigorna das Chamas",
	["The Apothecarium"] = "Boticarium",
	["The Arachnid Quarter"] = "O Distrito dos Aracnídeos",
	["The Arboretum"] = "Arboreto",
	["The Arcanium"] = "O Arcanium", -- Needs review
	["The Arcanium "] = "O Arcanium",
	["The Arcatraz"] = "Arcatraz",
	["The Archivum"] = "Archivum",
	["The Argent Stand"] = "Fortaleza Argêntea",
	["The Argent Valiants' Ring"] = "Arena dos Valentes Argênteos",
	["The Argent Vanguard"] = "Vanguarda Argêntea",
	["The Arsenal Absolute"] = "O Arsenal Absoluto",
	["The Aspirants' Ring"] = "Arena dos Aspirantes",
	["The Assembly Chamber"] = "A Câmara da Assembleia",
	["The Assembly of Iron"] = "A Assembleia de Ferro",
	["The Athenaeum"] = "O Ateneu",
	["The Autumn Plains"] = "Planície do Outono",
	["The Avalanche"] = "A Avalanche",
	["The Azure Front"] = "Front Lazúli",
	["The Bamboo Wilds"] = "Bambuzais Selvagens",
	["The Bank of Dalaran"] = "Banco de Dalaran",
	["The Bank of Silvermoon"] = "Banco de Luaprata",
	["The Banquet Hall"] = "O Salão de Banquete",
	["The Barrier Hills"] = "Picos da Barreira",
	["The Bastion of Twilight"] = "Bastião do Crepúsculo",
	["The Battleboar Pen"] = "Cercado dos Javaliços",
	["The Battle for Gilneas"] = "A Batalha por Guilnéas",
	["The Battle for Gilneas (Old City Map)"] = "A Batalha por Guilnéas (Mapa da Cidade Velha)",
	["The Battle for Mount Hyjal"] = "A Batalha pelo Monte Hyjal",
	["The Battlefront"] = "A Frente de Batalha",
	["The Bazaar"] = "Bazar",
	["The Beast Pens"] = "Cercado das Feras",
	["The Beer Garden"] = "O Jardim da Cerveja",
	["The Bite"] = "A Mordida",
	["The Black Breach"] = "Lacuna Negra",
	["The Black Market"] = "Mercado Negro",
	["The Black Morass"] = "Lamaçal Negro",
	["The Black Temple"] = "Templo Negro",
	["The Black Vault"] = "O Cofre Negro",
	["The Blackwald"] = "Floresta Negra",
	["The Blazing Strand"] = "Margem Fulgurante",
	["The Blighted Pool"] = "Tanque Empesteado",
	["The Blight Line"] = "Confim da Praga",
	["The Bloodcursed Reef"] = "Recife do Sangue Maldito",
	["The Blood Furnace"] = "Fornalha de Sangue",
	["The Bloodmire"] = "Lamaçal Maldito",
	["The Bloodoath"] = "O Pacto de Sangue",
	["The Blood Trail"] = "Trilha de Sangue",
	["The Bloodwash"] = "Maré Sangrenta",
	["The Boiling Crustacean"] = "O Crustáceo Fervido",
	["The Bombardment"] = "O Bombardeio",
	["The Bonefields"] = "Os Campos de Ossos",
	["The Bone Pile"] = "A Pilha de Ossos",
	["The Bones of Nozronn"] = "Ossos de Nozronn",
	["The Bone Wastes"] = "Deserto de Ossos",
	["The Boneyard"] = "Ossário",
	["The Borean Wall"] = "Muralha Boreana",
	["The Botanica"] = "Jardim Botânico",
	["The Bradshaw Mill"] = "Serraria Bradshaw",
	["The Breach"] = "A Brecha",
	["The Briny Cutter"] = "Cortassal",
	["The Briny Muck"] = "Alagados",
	["The Briny Pinnacle"] = "Morro Salgado",
	["The Broken Bluffs"] = "Penhascos Inóspitos",
	["The Broken Front"] = "O Front Partido",
	["The Broken Hall"] = "Salão Partido",
	["The Broken Hills"] = "Montes Partidos",
	["The Broken Stair"] = "A Escadaria Partida",
	["The Broken Temple"] = "Templo Partido",
	["The Broodmother's Nest"] = "Ninho da Prolemadre",
	["The Brood Pit"] = "Fosso da Ninhada",
	["The Bulwark"] = "O Baluarte",
	["The Burlap Trail"] = "Trilha da Juta",
	["The Burlap Valley"] = "Vale da Juta",
	["The Burlap Waystation"] = "Estação da Juta",
	["The Burning Corridor"] = "O Corredor Flamejante",
	["The Butchery"] = "O Matadouro",
	["The Cache of Madness"] = "Antro da Loucura",
	["The Caller's Chamber"] = "A Câmara do Arauto",
	["The Canals"] = "Os Canais",
	["The Cape of Stranglethorn"] = "Cabo do Espinhaço",
	["The Carrion Fields"] = "Campos de Carniça",
	["The Catacombs"] = "Catacumbas",
	["The Cauldron"] = "O Caldeirão",
	["The Cauldron of Flames"] = "Caldeirão das Chamas",
	["The Cave"] = "A Caverna",
	["The Celestial Planetarium"] = "O Planetário Celestial",
	["The Celestial Vault"] = "Abóbada Celestial",
	["The Celestial Watch"] = "A Vigília Celestial",
	["The Cemetary"] = "O Cemitério",
	["The Cerebrillum"] = "O Cerebrilho",
	["The Charred Vale"] = "Vale Carbonizado",
	["The Chilled Quagmire"] = "Pântano Gelado",
	["The Chum Bucket"] = "Balde de Isca",
	["The Circle of Cinders"] = "O Círculo das Brasas",
	["The Circle of Life"] = "Círculo da Vida",
	["The Circle of Suffering"] = "Círculo dos Sofrimentos",
	["The Clarion Bell"] = "Sino da Convocação",
	["The Clash of Thunder"] = "Estrondo do Trovão",
	["The Clean Zone"] = "A Zona Limpa",
	["The Cleft"] = "A Fenda",
	["The Clockwerk Run"] = "Corredor dos Mecanismos",
	["The Clutch"] = "A Amarra",
	["The Clutches of Shek'zeer"] = "Ninhal de Shek'zeer",
	["The Coil"] = "A Espiral",
	["The Colossal Forge"] = "Forja Colossal",
	["The Comb"] = "O Cortiço",
	["The Commons"] = "Área Pública",
	["The Conflagration"] = "A Conflagração",
	["The Conquest Pit"] = "Fosso da Conquista",
	["The Conservatory"] = "O Conservatório",
	["The Conservatory of Life"] = "Reserva Biológica",
	["The Construct Quarter"] = "O Distrito dos Constructos",
	["The Cooper Residence"] = "Residência dos Curvelo",
	["The Corridors of Ingenuity"] = "Os Corredores da Ingenuidade",
	["The Court of Bones"] = "O Paço dos Ossos",
	["The Court of Skulls"] = "Castelo das Caveiras",
	["The Coven"] = "O Covil",
	["The Coven "] = "O Covil",
	["The Creeping Ruin"] = "Ruína Assustadora",
	["The Crimson Assembly Hall"] = "Auditório Carmesim",
	["The Crimson Cathedral"] = "Catedral Carmesim",
	["The Crimson Dawn"] = "Aurora Escarlate",
	["The Crimson Hall"] = "Salão Carmesim",
	["The Crimson Reach"] = "Rincão Rubro",
	["The Crimson Throne"] = "O Trono Carmesim",
	["The Crimson Treader"] = "Trilha Carmesim",
	["The Crimson Veil"] = "Véu Carmesim",
	["The Crossroads"] = "A Encruzilhada",
	["The Crucible"] = "O Caldeirão",
	["The Crucible of Flame"] = "Caldeira das Chamas",
	["The Crumbling Waste"] = "Ermo Esfacelado",
	["The Cryo-Core"] = "Crio-núcleo",
	["The Crystal Hall"] = "Salão de Cristal",
	["The Crystal Shore"] = "Praia Cristalina",
	["The Crystal Vale"] = "Vale de Cristal",
	["The Crystal Vice"] = "Fenda Cristalina",
	["The Culling of Stratholme"] = "Expurgo de Stratholme",
	["The Culling of Stratholme Entrance"] = "Entrada do Expurgo de Stratholme",
	["The Cursed Landing"] = "Porto Amaldiçoado",
	["The Dagger Hills"] = "Os Obeliscos",
	["The Dai-Lo Farmstead"] = "Fazenda Dai-Lo",
	["The Damsel's Luck"] = "O Sorte da Donzela",
	["The Dancing Serpent"] = "A Serpente Dançante",
	["The Dark Approach"] = "Entrada Negra",
	["The Dark Defiance"] = "O Desafio Sombrio",
	["The Darkened Bank"] = "Margem Escurecida",
	["The Dark Hollow"] = "Vazio Negro",
	["The Darkmoon Faire"] = "A Feira de Negraluna",
	["The Dark Portal"] = "Portal Negro",
	["The Dark Rookery"] = "Viveiro Negro",
	["The Darkwood"] = "Lenhanegra",
	["The Dawnchaser"] = "Conquistador da Aurora",
	["The Dawning Isles"] = "Ilhas da Aurora",
	["The Dawning Span"] = "Vastidão do Alvorecer",
	["The Dawning Square"] = "Praça da Aurora",
	["The Dawning Stair"] = "Escada do Alvorecer",
	["The Dawning Valley"] = "Vale do Alvorecer",
	["The Dead Acre"] = "O Alqueire Morto",
	["The Dead Field"] = "Campo Morto",
	["The Dead Fields"] = "Campos Estéreis",
	["The Deadmines"] = "Minas Mortas",
	["The Dead Mire"] = "O Charco Fantasma",
	["The Dead Scar"] = "A Trilha da Morte",
	["The Deathforge"] = "Forja da Morte",
	["The Deathknell Graves"] = "As Tumbas de Plangemortis",
	["The Decrepit Fields"] = "Campos Apodrecidos",
	["The Decrepit Flow"] = "Córrego Decrépito",
	["The Deeper"] = "O Profundo",
	["The Deep Reaches"] = "As Entranhas da Terra",
	["The Deepwild"] = "Ermo Profundo",
	["The Defiant"] = "A desafiadora",
	["The Defiled Chapel"] = "A Capela Profanada",
	["The Den"] = "O Covil",
	["The Den of Flame"] = "Antro das Chamas",
	["The Dens of Dying"] = "Tocas da Morte",
	["The Dens of the Dying"] = [=[ 
Tocas da Morte]=], -- Needs review
	["The Descent into Madness"] = "A Espiral da Loucura",
	["The Desecrated Altar"] = "Altar Profanado",
	["The Devil's Terrace"] = "Terraço do Demônio",
	["The Devouring Breach"] = "A Brecha Devoradora",
	["The Domicile"] = "O Domicílio", -- Needs review
	["The Domicile "] = "O Domicílio",
	["The Dooker Dome"] = "Domo do Toleteiro",
	["The Dor'Danil Barrow Den"] = "Retiro de Dor'Danil",
	["The Dormitory"] = "Alojamentos",
	["The Drag"] = "O Bazar",
	["The Dragonmurk"] = "Draconumbra",
	["The Dragon Wastes"] = "Ermos Dragônicos",
	["The Drain"] = "O Escoadouro",
	["The Dranosh'ar Blockade"] = "Barreira Dranosh'ar",
	["The Drowned Reef"] = "Recife dos Afogados",
	["The Drowned Sacellum"] = "O Sacelo Inundado",
	["The Drunken Hozen"] = "O Hozen Bêbado",
	["The Dry Hills"] = "Montes Áridos",
	["The Dustbowl"] = "Terrasseca",
	["The Dust Plains"] = "Planícies do Pó",
	["The Eastern Earthshrine"] = "Santuário Oriental da Terra",
	["The Elders' Path"] = "Trilha dos Anciãos",
	["The Emerald Summit"] = "Pico da Esmeralda",
	["The Emperor's Approach"] = "Caminho do Imperador",
	["The Emperor's Gate"] = "Portão do Imperador",
	["The Emperor's Reach"] = "Domínio do Imperador",
	["The Emperor's Step"] = "Passo do Imperador",
	["The Escape From Durnholde"] = "A Fuga de Forte do Desterro",
	["The Escape from Durnholde Entrance"] = "Entrada da Fuga do Forte do Desterro",
	["The Eventide"] = "Anoitecer",
	["The Exodar"] = "Exodar",
	["The Eye"] = "O olho", -- Needs review
	["The Eye of Eternity"] = "Olho da Eternidade",
	["The Eye of the Vortex"] = "Olho do Vórtice",
	["The Fall of Shan Bu"] = "A Queda de Shan Bu",
	["The Farstrider Lodge"] = "Pavilhão dos Andarilhos",
	["The Feeding Pits"] = "Fossos de Alimentação",
	["The Fel Pits"] = "Poços Fétidos",
	["The Fertile Copse"] = "Bosque Fértil",
	["The Fetid Pool"] = "Lago Fétido",
	["The Filthy Animal"] = "O Animal Imundo",
	["The Firehawk"] = "O Falcão de Fogo",
	["The Five Sisters"] = "As Cinco Irmãs",
	["The Flamewake"] = "A Ardilanta",
	["The Fleshwerks"] = "Usina de Carne",
	["The Flood Plains"] = "Planícies Inundadas",
	["The Fold"] = "O Nicho",
	["The Foothill Caverns"] = "Caverna do Pé da Serra",
	["The Foot of Lei Shen"] = "Pé de Lei Shen",
	["The Foot Steppes"] = "Estepes do Sopé",
	["The Forbidden Jungle"] = "Selva Proibida",
	["The Forbidding Sea"] = "O Mar Proibido",
	["The Forest of Shadows"] = "Floresta das Sombras",
	["The Forge of Souls"] = "Forja das Almas",
	["The Forge of Souls Entrance"] = "Entrada da Forja das Almas",
	["The Forge of Supplication"] = "Forja da Súplica",
	["The Forge of Wills"] = "Forja da Vontade",
	["The Forgotten Coast"] = "Costa Esquecida",
	["The Forgotten Overlook"] = "Mirante Esquecido",
	["The Forgotten Pool"] = "Charcos Esquecidos",
	["The Forgotten Pools"] = "Os Charcos Esquecidos",
	["The Forgotten Shore"] = "Costa Abandonada",
	["The Forlorn Cavern"] = "Caverna Esquecida",
	["The Forlorn Mine"] = "Mina Esquecida",
	["The Forsaken Front"] = "Linha de Frente dos Renegados",
	["The Foul Pool"] = "O Lago Pútrido",
	["The Frigid Tomb"] = "Tumba Frígida",
	["The Frost Queen's Lair"] = "Covil da Rainha Gélida",
	["The Frostwing Halls"] = "Salões da Asa Gélida",
	["The Frozen Glade"] = "A Clareira Congelada",
	["The Frozen Halls"] = "Salões Gelados",
	["The Frozen Mine"] = "Mina Congelada",
	["The Frozen Sea"] = "Mar Congelado",
	["The Frozen Throne"] = "O Trono de Gelo",
	["The Fungal Vale"] = "Vale Fungi",
	["The Furnace"] = "A Fornalha",
	["The Gaping Chasm"] = "Fenda Hazzali",
	["The Gatehouse"] = "O Vestíbulo",
	["The Gatehouse "] = "O Vestíbulo",
	["The Gate of Unending Cycles"] = "Portão dos Ciclos sem Fim",
	["The Gauntlet"] = "Forquilha",
	["The Geyser Fields"] = "Campos de Gêiser",
	["The Ghastly Confines"] = "Confins Assombrados",
	["The Gilded Foyer"] = "Salão Dourado",
	["The Gilded Gate"] = "Portão Dourado",
	["The Gilding Stream"] = "Riacho Dourador",
	["The Glimmering Pillar"] = "Pilar Rutilante",
	["The Golden Gateway"] = "Portão Dourado",
	["The Golden Hall"] = "Salão Dourado",
	["The Golden Lantern"] = "Lanterna Dourada",
	["The Golden Pagoda"] = "Pagode Dourado",
	["The Golden Plains"] = "Planícies Douradas",
	["The Golden Rose"] = "Rosa Dourada",
	["The Golden Stair"] = "Escada Dourada",
	["The Golden Terrace"] = "Terraço Dourado",
	["The Gong of Hope"] = "Gongo da Esperança",
	["The Grand Ballroom"] = "O Salão de Baile",
	["The Grand Vestibule"] = "O Grande Vestíbulo",
	["The Great Arena"] = "A Grande Arena",
	["The Great Divide"] = "A Grande Divisória",
	["The Great Fissure"] = "A Grande Fenda",
	["The Great Forge"] = "A Grande Forja",
	["The Great Gate"] = "O Grande Portão",
	["The Great Lift"] = "O Grande Elevador",
	["The Great Ossuary"] = "O Grande Ossário",
	["The Great Sea"] = "Grande Oceano",
	["The Great Tree"] = "A Grande Árvore",
	["The Great Wheel"] = "A Grande Roda",
	["The Green Belt"] = "Zona Verde",
	["The Greymane Wall"] = "Muralha Greymane",
	["The Grim Guzzler"] = "O Glutão Implacável",
	["The Grinding Quarry"] = "Pedreira Extenuante",
	["The Grizzled Den"] = "Covil Cinzento",
	["The Grummle Bazaar"] = "Bazar dos Grômulos",
	["The Guardhouse"] = "Sala da Vigília",
	["The Guest Chambers"] = "Aposentos de Hóspedes",
	["The Gullet"] = "A Gorja",
	["The Halfhill Market"] = "Mercado da Meia Colina",
	["The Half Shell"] = "A Carapaça",
	["The Hall of Blood"] = "O Salão de Sangue",
	["The Hall of Gears"] = "Salão das Engrenagens",
	["The Hall of Lights"] = "O Salão das Luzes",
	["The Hall of Respite"] = "Salão da Pausa",
	["The Hall of Statues"] = "Salão das Estátuas",
	["The Hall of the Serpent"] = "Salão da Serpente",
	["The Hall of Tiles"] = "Salão dos Ladrilhos",
	["The Halls of Reanimation"] = "Os Salões da Reanimação",
	["The Halls of Winter"] = "Os Salões do Inverno",
	["The Hand of Gul'dan"] = "A Mão de Gul'dan",
	["The Harborage"] = "O Refúgio",
	["The Hatchery"] = "Incubadora",
	["The Headland"] = "Terralta",
	["The Headlands"] = "Os Promontórios",
	["The Heap"] = "Os Destroços",
	["The Heartland"] = "Coração da Terra",
	["The Heart of Acherus"] = "O Coração de Áquerus",
	["The Heart of Jade"] = "Coração de Jade",
	["The Hidden Clutch"] = "O Ninho Escondido",
	["The Hidden Grove"] = "Bosque Oculto",
	["The Hidden Hollow"] = "Vazio Oculto",
	["The Hidden Passage"] = "Passagem Secreta",
	["The Hidden Reach"] = "Confins Ocultos",
	["The Hidden Reef"] = "Recife Oculto",
	["The High Path"] = "Caminho Alto",
	["The High Road"] = "Estrada Alta",
	["The High Seat"] = "A Sala do Trono",
	["The Hinterlands"] = "Terras Agrestes",
	["The Hoard"] = "O Cofre",
	["The Hole"] = "Presídio da Grande Ilha",
	["The Horde Valiants' Ring"] = "Arena dos Valentes da Horda",
	["The Horrid March"] = "Marcha Terrível",
	["The Horsemen's Assembly"] = "A Assembleia dos Cavaleiros",
	["The Howling Hollow"] = "Vazio Uivante",
	["The Howling Oak"] = "O Carvalho Uivante",
	["The Howling Vale"] = "Vale Uivante",
	["The Hunter's Reach"] = "O Recanto do Caçador",
	["The Hushed Bank"] = "Margem Silenciada",
	["The Icy Depths"] = "Profundezas Geladas",
	["The Immortal Coil"] = "Espiral Imortal",
	["The Imperial Exchange"] = "Comércio Imperial",
	["The Imperial Granary"] = "Celeiro Imperial",
	["The Imperial Mercantile"] = "A Imperial Mercantil",
	["The Imperial Seat"] = "O Trono Imperial",
	["The Incursion"] = "A Incursão",
	["The Infectis Scar"] = "Fenda Infectis",
	["The Inferno"] = "Inferno",
	["The Inner Spire"] = "O Pináculo Interno",
	["The Intrepid"] = "O Intrépido",
	["The Inventor's Library"] = "Biblioteca do Inventor",
	["The Iron Crucible"] = "O Caldeirão de Ferro",
	["The Iron Hall"] = "O Salão de Ferro",
	["The Iron Reaper"] = "A Foice de Ferro",
	["The Isle of Spears"] = "Ilha das Lanças",
	["The Ivar Patch"] = "Plantação do Ivar",
	["The Jade Forest"] = "Floresta de Jade",
	["The Jade Vaults"] = "Cofres de Jade",
	["The Jansen Stead"] = "Sítio dos Jansen",
	["The Keggary"] = "Adega",
	["The Kennel"] = "O Canil",
	["The Krasari Ruins"] = "Ruínas Krasari",
	["The Krazzworks"] = "Os Krazzodutos",
	["The Laboratory"] = "O Laboratório",
	["The Lady Mehley"] = "Lady Mehley",
	["The Lagoon"] = "A Lagoa",
	["The Laughing Stand"] = "Ponta Gargalhante",
	["The Lazy Turnip"] = "O Nabo Preguiçoso",
	["The Legerdemain Lounge"] = "Saguão da Destreza",
	["The Legion Front"] = "O Front da Legião",
	["Thelgen Rock"] = "Rocha de Thelgen",
	["The Librarium"] = "O Livrário",
	["The Library"] = "A Biblioteca",
	["The Lifebinder's Cell"] = "A Prisão do Ligavidas",
	["The Lifeblood Pillar"] = "Pilar Sangue da Vida",
	["The Lightless Reaches"] = "Confins da Escuridão",
	["The Lion's Redoubt"] = "Reduto do Leão",
	["The Living Grove"] = "Bosque Vicejante",
	["The Living Wood"] = "Floresta Viva",
	["The LMS Mark II"] = "O LMS Versão II",
	["The Loch"] = "Loch",
	["The Long Wash"] = "Praia da Ressaca",
	["The Lost Fleet"] = "Frota Perdida",
	["The Lost Fold"] = "Recôncavo Perdido",
	["The Lost Isles"] = "Ilhas Perdidas",
	["The Lost Lands"] = "Terras Perdidas",
	["The Lost Passage"] = "Passagem Perdida",
	["The Low Path"] = "Estrada Baixa",
	Thelsamar = "Thelsamar",
	["The Lucky Traveller"] = "O Viajante Sortudo",
	["The Lyceum"] = "O Liceu",
	["The Maclure Vineyards"] = "Vinhedos dos Madruga",
	["The Maelstrom"] = "Voragem",
	["The Maker's Overlook"] = "Mirante do Criador",
	["The Makers' Overlook"] = "Mirante dos Criadores",
	["The Makers' Perch"] = "Alcândora dos Criadores",
	["The Maker's Rise"] = "O Beiral do Criador",
	["The Maker's Terrace"] = "Terraço do Criador",
	["The Manufactory"] = "A Fábrica",
	["The Marris Stead"] = "Sítio dos Marris",
	["The Marshlands"] = "Os Pântanos",
	["The Masonary"] = "Oficina de Alvenaria",
	["The Master's Cellar"] = "Porão do Senhorio",
	["The Master's Glaive"] = "Glaive do Mestre",
	["The Maul"] = "A Arena",
	["The Maw of Madness"] = "Ventre da Loucura",
	["The Mechanar"] = "Mecanar",
	["The Menagerie"] = "O Viveiro",
	["The Menders' Stead"] = "O Acampamento dos Restauradores",
	["The Merchant Coast"] = "Costa dos Mercadores",
	["The Militant Mystic"] = "O Militante Místico",
	["The Military Quarter"] = "O Distrito Militar",
	["The Military Ward"] = "Ala Militar",
	["The Mind's Eye"] = "Olho da Mente",
	["The Mirror of Dawn"] = "Espelho da Aurora",
	["The Mirror of Twilight"] = "Espelho do Crepúsculo",
	["The Molsen Farm"] = "Fazenda dos Peçanha",
	["The Molten Bridge"] = "A Ponte Derretida",
	["The Molten Core"] = "O Núcleo Derretido",
	["The Molten Fields"] = "Campos de Magma",
	["The Molten Flow"] = "Córrego das Chamas",
	["The Molten Span"] = "A Vastidão Derretida",
	["The Mor'shan Rampart"] = "Paliçada Mor'shan",
	["The Mor'Shan Ramparts"] = "Paliçada Mor'shan",
	["The Mosslight Pillar"] = "Pilar Verdeluz",
	["The Mountain Den"] = "Covil da Montanha",
	["The Murder Pens"] = "Os Redis da Morte",
	["The Mystic Ward"] = "Ala Mística",
	["The Necrotic Vault"] = "A Câmara Necrótica",
	["The Nexus"] = "Nexus - Missão Lendária",
	["The Nexus Entrance"] = "Entrada do Nexus",
	["The Nightmare Scar"] = "A Garganta do Pesadelo",
	["The North Coast"] = "Costa Norte",
	["The North Sea"] = "Mar do Norte",
	["The Nosebleeds"] = "Os Epistaxes",
	["The Noxious Glade"] = "Clareira Nociva",
	["The Noxious Hollow"] = "O Vale Nocivo",
	["The Noxious Lair"] = "Covil Nóxio",
	["The Noxious Pass"] = "Estrada Nociva",
	["The Oblivion"] = "O Oblívio",
	["The Observation Ring"] = "O Círculo de Observação",
	["The Obsidian Sanctum"] = "Santuário Obsidiano",
	["The Oculus"] = "Óculus",
	["The Oculus Entrance"] = "Entrada de Óculus",
	["The Old Barracks"] = "A Antiga Guarnição",
	["The Old Dormitory"] = "O Antigo Dormitório",
	["The Old Port Authority"] = "Capitania do Velho Porto",
	["The Opera Hall"] = "Salão de Ópera",
	["The Oracle Glade"] = "Clareira do Oráculo",
	["The Outer Ring"] = "O Círculo Externo",
	["The Overgrowth"] = "Profusão Verde",
	["The Overlook"] = "Mirante",
	["The Overlook Cliffs"] = "Penhascos Panorâmicos",
	["The Overlook Inn"] = "Estalagem do Mirante",
	["The Ox Gate"] = "O Portão do Boi",
	["The Pale Roost"] = "Alcândor Pálido",
	["The Park"] = "O Parque",
	["The Path of Anguish"] = "O Caminho da Angústia",
	["The Path of Conquest"] = "O Caminho da Conquista",
	["The Path of Corruption"] = "O Caminho da Corrupção",
	["The Path of Glory"] = "Caminho da Glória",
	["The Path of Iron"] = "Caminho de Ferro",
	["The Path of the Lifewarden"] = "Caminho da Guardiã da Vida",
	["The Phoenix Hall"] = "O Salão da Fênix",
	["The Pillar of Ash"] = "Pilar de Cinzas",
	["The Pipe"] = "O Encanamento",
	["The Pit of Criminals"] = "O Fosso dos Criminosos",
	["The Pit of Fiends"] = "Fosso dos Demônios",
	["The Pit of Narjun"] = "Fosso de Narjun",
	["The Pit of Refuse"] = "O Poço de Refugo",
	["The Pit of Sacrifice"] = "O Fosso do Sacrifício",
	["The Pit of Scales"] = "O Fosso das Escamas",
	["The Pit of the Fang"] = "Fosso da Presa",
	["The Plague Quarter"] = "O Distrito da Peste",
	["The Plagueworks"] = "Antro da Peste",
	["The Pool of Ask'ar"] = "O Poço de Ask'Ar",
	["The Pools of Vision"] = "Poços das Visões",
	["The Prison of Yogg-Saron"] = "Prisão de Yogg-Saron",
	["The Proving Grounds"] = "Campo de Testes",
	["The Purple Parlor"] = "Salão Púrpura",
	["The Quagmire"] = "O Atoleiro",
	["The Quaking Fields"] = "Campos Sísmicos",
	["The Queen's Reprisal"] = "O Vingança da Rainha",
	["The Raging Chasm"] = "Abismo Atroz",
	Theramore = "Theramore",
	["Theramore Isle"] = "Ilha Theramore",
	["Theramore's Fall"] = "Queda de Theramore",
	["Theramore's Fall (A)"] = "Queda de Theramore (A)",
	["Theramore's Fall (H)"] = "Queda de Theramore (H)",
	["Theramore's Fall Phase"] = "Fase da Queda de Theramore",
	["The Rangers' Lodge"] = "Pavilhão dos Patrulheiros",
	["Therazane's Throne"] = "Trono de Therazane",
	["The Red Reaches"] = "Recôndito Vermelho",
	["The Refectory"] = "O Refeitório",
	["The Regrowth"] = "O Recrescer",
	["The Reliquary"] = "Relicário",
	["The Repository"] = "O Repositório",
	["The Reservoir"] = "O Reservatório",
	["The Restless Front"] = "O Front Incansável",
	["The Ridge of Ancient Flame"] = "Serra da Chama Antiga",
	["The Rift"] = "A Fissura",
	["The Ring of Balance"] = "Círculo do Equilíbrio",
	["The Ring of Blood"] = "Ringue de Sangue",
	["The Ring of Champions"] = "Arena dos Campeões",
	["The Ring of Inner Focus"] = "Círculo da Concentração Interior",
	["The Ring of Trials"] = "Ringue da Provação",
	["The Ring of Valor"] = "Ringue dos Valorosos",
	["The Riptide"] = "O Rasgamar",
	["The Riverblade Den"] = "Covil Fluviaço",
	["Thermal Vents"] = "Fontes Termais",
	["The Roiling Gardens"] = "Jardins Turbulentos",
	["The Rolling Gardens"] = "Os Jardins Turbulentos", -- Needs review
	["The Rolling Plains"] = "Morros Ondulantes",
	["The Rookery"] = "O Viveiro",
	["The Rotting Orchard"] = "O Horto Pútrido",
	["The Rows"] = "As Fileiras",
	["The Royal Exchange"] = "O Real Erário",
	["The Ruby Sanctum"] = "Santuário Rubi",
	["The Ruined Reaches"] = "Profundezas Devastadas",
	["The Ruins of Kel'Theril"] = "Ruínas de Kel'Theril",
	["The Ruins of Ordil'Aran"] = "Ruínas de Ordil'Aran",
	["The Ruins of Stardust"] = "Ruínas de Poeira Estelar",
	["The Rumble Cage"] = "Jaula Troante",
	["The Rustmaul Dig Site"] = "Sítio de Escavação Velhomalho",
	["The Sacred Grove"] = "Bosque Sagrado",
	["The Salty Sailor Tavern"] = "Taberna do Lobo do Mar",
	["The Sanctum"] = "O Sacrário",
	["The Sanctum of Blood"] = "Sacrário de Sangue",
	["The Savage Coast"] = "Costa Selvagem",
	["The Savage Glen"] = "Vale Selvagem",
	["The Savage Thicket"] = "Floresta Selvagem",
	["The Scalding Chasm"] = "Abismo Escaldante",
	["The Scalding Pools"] = "Lagos Escaldantes",
	["The Scarab Dais"] = "Palanque do Escaravelho",
	["The Scarab Wall"] = "Muralha do Escaravelho",
	["The Scarlet Basilica"] = "Basílica Escarlate",
	["The Scarlet Bastion"] = "O Bastião Escarlate",
	["The Scorched Grove"] = "Mata Queimada",
	["The Scorched Plain"] = "Terra Queimada",
	["The Scrap Field"] = "Campo dos Refugos",
	["The Scrapyard"] = "O Ferro Velho",
	["The Screaming Hall"] = "Salão Estridente",
	["The Screaming Reaches"] = "Costa dos Gritos",
	["The Screeching Canyon"] = "Garganta Uivante",
	["The Scribe of Stormwind"] = "O Escriba Ventobravo",
	["The Scribes' Sacellum"] = "O Sacelo dos Escribas",
	["The Scrollkeeper's Sanctum"] = "Sacrário do Guardião dos Pergaminhos",
	["The Scullery"] = "Área de Serviço", -- Needs review
	["The Scullery "] = "Área de Serviço",
	["The Seabolt"] = "Raio do Mar",
	["The Seabreach Flow"] = "Arroio Quebra-mar",
	["The Sealed Hall"] = "O Salão Lacrado",
	["The Sea of Cinders"] = "Mar de Cinzas",
	["The Sea Reaver's Run"] = "Estreito do Aniquilador Marítimo",
	["The Searing Gateway"] = "Acesso Causticante",
	["The Sea Wolf"] = "Lobo do Mar",
	["The Secret Aerie"] = "Ninho Secreto",
	["The Secret Lab"] = "Laboratório Secreto",
	["The Secrets of Ragefire"] = "Os Segredos das Cavernas Ígneas",
	["The Seer's Library"] = "A Biblioteca do Vidente",
	["The Sepulcher"] = "O Sepulcro",
	["The Severed Span"] = "Promontório Partido",
	["The Sewer"] = "Esgoto",
	["The Shadow Stair"] = "Escada das Sombras",
	["The Shadow Throne"] = "O Trono das Sombras",
	["The Shadow Vault"] = "Abóbada das Sombras",
	["The Shady Nook"] = "Gruta Escura",
	["The Shaper's Terrace"] = "O Terraço do Moldador",
	["The Shattered Halls"] = "Salões Despedaçados",
	["The Shattered Strand"] = "Areal Despedaçado",
	["The Shattered Walkway"] = "A Passarela Despedaçada",
	["The Shepherd's Gate"] = "Portão do Pastor",
	["The Shifting Mire"] = "Lodaçal Mutante",
	["The Shimmering Deep"] = "Abismo Cintilante",
	["The Shimmering Flats"] = "Chapada Cintilante",
	["The Shining Strand"] = "Margem Brilhante",
	["The Shrine of Aessina"] = "Altar de Aessina",
	["The Shrine of Eldretharr"] = "Altar de Eldretharr",
	["The Silent Sanctuary"] = "Santuário Silencioso",
	["The Silkwood"] = "Lenhasseda",
	["The Silver Blade"] = "Gume de Prata",
	["The Silver Enclave"] = "Enclave Prateado",
	["The Singing Grove"] = "Bosque da Canção",
	["The Singing Pools"] = "Lagos Cantantes",
	["The Sin'loren"] = "O Sin'lonren",
	["The Skeletal Reef"] = "Recife Esquelético",
	["The Skittering Dark"] = "Penumbra Furtiva",
	["The Skull Warren"] = "O Abrigo da Caveira",
	["The Skunkworks"] = "Buraco do Tatu",
	["The Skybreaker"] = "O Rompe-céus",
	["The Skyfire"] = "O Celesfogo",
	["The Skyreach Pillar"] = "Pilar Beira-céu",
	["The Slag Pit"] = "Fosso de Lava",
	["The Slaughtered Lamb"] = "O Cordeiro Imolado",
	["The Slaughter House"] = "O Matadouro",
	["The Slave Pens"] = "Pátio dos Escravos",
	["The Slave Pits"] = "Buraco do Escravo",
	["The Slick"] = "A Mancha",
	["The Slithering Scar"] = "Fenda Coleante",
	["The Slough of Dispair"] = "O Lamaçal do Desespero",
	["The Sludge Fen"] = "Charco de Lodo",
	["The Sludge Fields"] = "Campos Lodosos",
	["The Sludgewerks"] = "Barreiro",
	["The Solarium"] = "O Solarium",
	["The Solar Vigil"] = "A Vigia Solar",
	["The Southern Isles"] = "Ilhas do Sul",
	["The Southern Wall"] = "Muralha Sul",
	["The Sparkling Crawl"] = "O Reservatório Cintilante",
	["The Spark of Imagination"] = "Centelha da Imaginação",
	["The Spawning Glen"] = "Vale dos Rebentos",
	["The Spire"] = "O Pináculo",
	["The Splintered Path"] = "Caminho Espinhoso",
	["The Spring Road"] = "Estrada da Primavera",
	["The Stadium"] = "O Estádio",
	["The Stagnant Oasis"] = "O Oásis Estagnado",
	["The Staidridge"] = "Cume Pacífico",
	["The Stair of Destiny"] = "Degraus do Destino",
	["The Stair of Doom"] = "Degraus da Perdição",
	["The Starchaser"] = "Caça-estrelas",
	["The Star's Bazaar"] = "Bazar da Estrela",
	["The Steam Pools"] = "Lagos Vaporíferos",
	["The Steamvault"] = "Câmara dos Vapores",
	["The Steppe of Life"] = "Estepe da Vida",
	["The Steps of Fate"] = "Passos do Destino",
	["The Stinging Trail"] = "Trilha Cortante",
	["The Stockade"] = "O Cárcere",
	["The Stockpile"] = "O Arsenal",
	["The Stonecore"] = "Litocerne",
	["The Stonecore Entrance"] = "Entrada do Litocerne",
	["The Stonefield Farm"] = "Fazenda dos Campedra",
	["The Stone Vault"] = "Galeria de Pedra",
	["The Storehouse"] = "O Armazém",
	["The Stormbreaker"] = "O Rompe-procelas",
	["The Stormbridge"] = "Pontempesta",
	["The Storm Foundry"] = "Fundição da Tempestade",
	["The Storm Peaks"] = "Picos Tempestuosos",
	["The Stormspire"] = "Pináculo da Tempestade",
	["The Stormwright's Shelf"] = "Prateleira do Criador da Tempestade",
	["The Summer Fields"] = "Campos do Verão",
	["The Summer Terrace"] = "Terraço do Verão",
	["The Sundered Shard"] = "Estilhaço Partido",
	["The Sundering"] = "A Cisão",
	["The Sun Forge"] = "Forja do Sol",
	["The Sunken Ring"] = "Ringue Enterrado",
	["The Sunset Brewgarden"] = "Parque Cervejeiro do Poente",
	["The Sunspire"] = "Torre do Sol",
	["The Suntouched Pillar"] = "Pilar Tocado pelo Sol",
	["The Sunwell"] = "A Nascente do Sol",
	["The Swarming Pillar"] = "Pilar Enxameante",
	["The Swollen Vault"] = "Salão Abaulado",
	["The Tainted Forest"] = "Floresta Maculada",
	["The Tainted Scar"] = "Rasgo Infecto",
	["The Talondeep Path"] = "Túnel Garracava",
	["The Talon Den"] = "Retiro do Gadanho",
	["The Tasting Room"] = "Sala de Degustação",
	["The Tempest Rift"] = "Fenda Tempestuosa",
	["The Temple Gardens"] = "Jardins do Templo",
	["The Temple of Atal'Hakkar"] = "Templo de Atal'Hakkar",
	["The Temple of the Jade Serpent"] = "Templo da Serpente de Jade",
	["The Terrestrial Watchtower"] = "Torre de Vigilância",
	["The Thornsnarl"] = "O Rugespinho",
	["The Threads of Fate"] = "Os Fios do Destino",
	["The Threshold"] = "O Limiar",
	["The Throne of Flame"] = "Trono das Chamas",
	["The Thunder Forge"] = "A Forja do Trovão",
	["The Thunder Forges"] = "Forjas do Trovão",
	["The Thundering Run"] = "Caminho Trovejante",
	["The Thundering Spire"] = "Pináculo Trovejante",
	["The Thunderspire"] = "Pináculo do Trovão",
	["The Thunderwood"] = "Bosque do Trovão",
	["The Tidebreaker"] = "O Quebraondas",
	["The Tidus Stair"] = "Escadaria de Tidus",
	["The Tiger's Peak"] = "O Pico do Tigre",
	["The Torjari Pit"] = "Poço Torjari",
	["The Tower of Arathor"] = "Torre de Arathor",
	["The Toxic Airfield"] = "Aeroporto Tóxico",
	["The Trail of Devastation"] = "Trilha da Devastação",
	["The Tranquil Grove"] = "Bosque Tranquilo",
	["The Transitus Stair"] = "Escada Transitus",
	["The Trapper's Enclave"] = "O Enclave do Coureador",
	["The Tribunal of Ages"] = "Tribunal das Eras",
	["The Tundrid Hills"] = "Montes Túndricos",
	["The Twilight Breach"] = "Lacuna Crepuscular",
	["The Twilight Caverns"] = "Caverna do Crepúsculo",
	["The Twilight Citadel"] = "Cidadela do Crepúsculo",
	["The Twilight Enclave"] = "Enclave do Crepúsculo",
	["The Twilight Gate"] = "O Portão do Crepúsculo",
	["The Twilight Gauntlet"] = "Forquilha do Crepúsculo",
	["The Twilight Ridge"] = "Cordilheira do Crepúsculo",
	["The Twilight Rivulet"] = "Regato do Crepúsculo",
	["The Twilight Withering"] = "O Definhar do Crepúsculo",
	["The Twin Colossals"] = "Colossos Gêmeos",
	["The Twisted Glade"] = "Clareira Deformada",
	["The Twisted Warren"] = "Toca Torta",
	["The Two Fisted Brew"] = "A Cerveja dos Dois Punhos",
	["The Unbound Thicket"] = "Selva Franca",
	["The Underbelly"] = "Os Esgotos",
	["The Underbog"] = "Brejo Oculto",
	["The Underbough"] = "Ramo Inferior",
	["The Undercroft"] = "Chácara Secreta",
	["The Underhalls"] = "Salões Subterrâneos",
	["The Undershell"] = "Concha Subterrânea",
	["The Uplands"] = "As Terras Altas",
	["The Upside-down Sinners"] = "Os Pecadores Pendurados",
	["The Valley of Fallen Heroes"] = "Vale dos Heróis Caídos",
	["The Valley of Lost Hope"] = "Vale das Esperanças Perdidas",
	["The Vault of Lights"] = "Cripta das Luzes",
	["The Vector Coil"] = "Espiral Vetorial",
	["The Veiled Cleft"] = "Fenda Oculta",
	["The Veiled Sea"] = "Mar Velado",
	["The Veiled Stair"] = "Escadaria Oculta",
	["The Venture Co. Mine"] = "Mina da Empreendimentos S.A.",
	["The Verdant Fields"] = "Campos Verdejantes",
	["The Verdant Thicket"] = "Selva Verdejante",
	["The Verne"] = "O Verne",
	["The Verne - Bridge"] = "O Verne – Ponte",
	["The Verne - Entryway"] = "O Verne – Passagem de Entrada",
	["The Vibrant Glade"] = "Clareira Vibrante",
	["The Vice"] = "A Garra",
	["The Vicious Vale"] = "O Vale Vil",
	["The Viewing Room"] = "Sala de Exibição",
	["The Vile Reef"] = "O Arrecife Torpe",
	["The Violet Citadel"] = "A Cidadela Violeta",
	["The Violet Citadel Spire"] = "Torre da Cidadela Violeta",
	["The Violet Gate"] = "Portão Violeta",
	["The Violet Hold"] = "Castelo Violeta",
	["The Violet Spire"] = "O Pináculo Violeta",
	["The Violet Tower"] = "Torre Violeta",
	["The Vortex Fields"] = "Campos de Vórtice",
	["The Vortex Pinnacle"] = "Pináculo do Vórtice",
	["The Vortex Pinnacle Entrance"] = "Entrada do Pináculo do Vórtice",
	["The Wailing Caverns"] = "Caverna Ululante",
	["The Wailing Ziggurat"] = "Zigurate dos Lamentos",
	["The Waking Halls"] = "Salões do Despertar",
	["The Wandering Isle"] = "Ilha Errante",
	["The Warlord's Garrison"] = "Guarnição do Senhor da Guerra",
	["The Warlord's Terrace"] = "Terraço do Senhor da Guerra",
	["The Warp Fields"] = "Campos Dimensionais",
	["The Warp Piston"] = "Pistão Dimensional",
	["The Wavecrest"] = "Olacrístia",
	["The Weathered Nook"] = "Gruta Velha",
	["The Weeping Cave"] = "Caverna das Lágrimas",
	["The Western Earthshrine"] = "Santuário Ocidental da Terra",
	["The Westrift"] = "Fenda Ocidental",
	["The Whelping Downs"] = "Colina dos Dragonetes",
	["The Whipple Estate"] = "Propriedade dos Whipple",
	["The Wicked Coil"] = "Espiral Perversa",
	["The Wicked Grotto"] = "Gruta Malévola",
	["The Wicked Tunnels"] = "Túneis Malévolos",
	["The Widening Deep"] = "Profundezas Andantes",
	["The Widow's Clutch"] = "O Ninho da Viúva",
	["The Widow's Wail"] = "Lamento da Viúva",
	["The Wild Plains"] = "Planície Selvagem",
	["The Wild Shore"] = "A Praia Selvagem", -- Needs review
	["The Winding Halls"] = "Os Salões Sinuosos",
	["The Windrunner"] = "O Correventos",
	["The Windspire"] = "Torre de Vento",
	["The Wollerton Stead"] = "Sítio dos Wollerton",
	["The Wonderworks"] = "Reinações",
	["The Wood of Staves"] = "Bosque dos Cajados",
	["The World Tree"] = "A Árvore do Mundo",
	["The Writhing Deep"] = "Profundeza Atormentada",
	["The Writhing Haunt"] = "O Antro Repelente",
	["The Yaungol Advance"] = "Vanguarda Yaungol",
	["The Yorgen Farmstead"] = "Fazenda dos Figueira",
	["The Zandalari Vanguard"] = "Vanguarda Zandalari",
	["The Zoram Strand"] = "Praia de Zoram",
	["Thieves Camp"] = "Acampamento dos Ladrões",
	["Thirsty Alley"] = "Beco da Sede",
	["Thistlefur Hold"] = "Covil dos Pelocardo",
	["Thistlefur Village"] = "Aldeia dos Pelocardo",
	["Thistleshrub Valley"] = "Vale Moitagulhas",
	["Thondroril River"] = "Rio Thondroril",
	["Thoradin's Wall"] = "Muralha de Thoradin",
	["Thorium Advance"] = "Avanço de Tório",
	["Thorium Point"] = "Posto de Tório",
	["Thor Modan"] = "Thor Modan",
	["Thornfang Hill"] = "Monte Presacúleo",
	["Thorn Hill"] = "Morro dos Espinhos",
	["Thornmantle's Hideout"] = "Esconderijo do Mantospinho",
	["Thorson's Post"] = "Posto de Thorson",
	["Thorvald's Camp"] = "Acampamento do Thorvald",
	["Thousand Needles"] = "Mil Agulhas",
	Thrallmar = "Thrallmar",
	["Thrallmar Mine"] = "Mina de Thrallmar",
	["Three Corners"] = "Três Caminhos",
	["Throne of Ancient Conquerors"] = "Trono dos Conquistadores Antigos",
	["Throne of Kil'jaeden"] = "Trono de Kil'jaeden",
	["Throne of Neptulon"] = "Trono de Neptulon",
	["Throne of the Apocalypse"] = "Trono do Apocalipse",
	["Throne of the Damned"] = "Trono dos Malditos",
	["Throne of the Elements"] = "Trono dos Elementos",
	["Throne of the Four Winds"] = "Trono dos Quatro Ventos",
	["Throne of the Tides"] = "Trono das Marés",
	["Throne of the Tides Entrance"] = "Entrada do Trono das Marés",
	["Throne of Thunder"] = "Trono do Trovão",
	["Throne of Tides"] = "Trono das Marés",
	["Thrym's End"] = "Ruína de Thrym",
	["Thunder Axe Fortress"] = "Fortaleza Machado do Trovão",
	Thunderbluff = "Penhasco do Trovão",
	["Thunder Bluff"] = "Penhasco do Trovão",
	["Thunderbrew Distillery"] = "Destilaria Cervaforte",
	["Thunder Cleft"] = "Grota do Trovão",
	Thunderfall = "Tormentério",
	["Thunder Falls"] = "Cachoeira do Trovão",
	["Thunderfoot Farm"] = "Fazenda Pé de Trovão",
	["Thunderfoot Fields"] = "Campos Pé de Trovão",
	["Thunderfoot Inn"] = "Estalagem Pé de Trovão",
	["Thunderfoot Ranch"] = "Rancho Pé de Trovão",
	["Thunder Hold"] = "Forte do Trovão",
	["Thunderhorn Water Well"] = "Poço Chifre Troante",
	["Thundering Overlook"] = "Mirante do Trovão",
	["Thunder Island Alliance Hub"] = "Centro da Aliança da Ilha do Trovão",
	["Thunder King Horde Hub"] = "Centro da Horda do Rei Trovão",
	["Thunder King's Citadel"] = "Cidadela do Rei Trovão",
	["Thunderlord Stronghold"] = "Cidadela do Senhor do Trovão",
	Thundermar = "Trondamar",
	["Thundermar Ruins"] = "Ruínas Trondamar",
	["Thunderpaw Overlook"] = "Mirante Pata de Trovão",
	["Thunderpaw Refuge"] = "Refúgio Pata de Trovão",
	["Thunder Peak"] = "Pico do Trovão",
	["Thunder Ridge"] = "Desfiladeiro do Trovão",
	["Thunder's Call"] = "Chamado do Trovão",
	["Thunderstrike Mountain"] = "Montanha Golpeforte",
	["Thunk's Abode"] = "Morada de Thunk",
	["Thuron's Livery"] = "Cocheira de Thuron",
	["Tian Monastery"] = "Monastério de Tian",
	["Tidefury Cove"] = "Enseada da Fúria das Marés",
	["Tides' Hollow"] = "Gruta das Marés",
	["Tideview Thicket"] = "Mata Mirante da Maré",
	["Tigers' Wood"] = "Bosque dos Tigres",
	["Timbermaw Hold"] = "Domínio dos Presamatos",
	["Timbermaw Post"] = "Posto Presamatos",
	["Tinkers' Court"] = "Paço dos Faz-tudo",
	["Tinker Town"] = "Beco da Gambiarra",
	["Tiragarde Keep"] = "Bastilha Tiragarde",
	["Tirisfal Glades"] = "Clareiras de Tirisfal",
	["Tirth's Haunt"] = "Refúgio de Tirth",
	["Tkashi Ruins"] = "Ruínas de Tkashi",
	["Tol Barad"] = "Tol Barad",
	["Tol Barad Peninsula"] = "Península de Tol Barad",
	["Tol'Vir Arena"] = "Arena Tol'vírica",
	["Tol'viron Arena"] = "Arena Tol'viron",
	["Tol'Viron Arena"] = "Arena Tol'viron",
	["Tomb of Conquerors"] = "Tumba dos Conquistadores",
	["Tomb of Lights"] = "Tumba das Luzes",
	["Tomb of Secrets"] = "Tumba dos Segredos",
	["Tomb of Shadows"] = "Tumba das Sombras",
	["Tomb of the Ancients"] = "Tumba dos Anciãos",
	["Tomb of the Earthrager"] = "Tumba dos Furitérreo",
	["Tomb of the Lost Kings"] = "Tumba dos Reis Perdidos",
	["Tomb of the Sun King"] = "Tumba do Rei Sol",
	["Tomb of the Watchers"] = "Tumba dos Observadores",
	["Tombs of the Precursors"] = "Tumbas dos Antecessores",
	["Tome of the Unrepentant"] = "Tomo dos Impenitentes", -- Needs review
	["Tome of the Unrepentant "] = "Tomo dos Impenitentes",
	["Tor'kren Farm"] = "Fazenda Tor'kren",
	["Torp's Farm"] = "Fazenda dos Torp",
	["Torseg's Rest"] = "Repouso de Torseg",
	["Tor'Watha"] = "Tor'Watha",
	["Toryl Estate"] = "Propriedade Toryl",
	["Toshley's Station"] = "Estação do Tocha",
	["To the Skies!"] = "Para os Céus!",
	["To The Skies!"] = "Para os Céus!",
	["Tower of Althalaxx"] = "Torre de Althalaxx",
	["Tower of Azora"] = "Torre de Azora",
	["Tower of Eldara"] = "Torre de Eldara",
	["Tower of Estulan"] = "Torre de Estulan",
	["Tower of Ilgalar"] = "Torre de Ilgalar",
	["Tower of the Damned"] = "Torre dos Malditos",
	["Tower Point"] = "Torre do Pontal",
	["Tower Watch"] = "Torre Vigilante",
	["Town-In-A-Box"] = "Cidade Portátil",
	["Townlong Steppes"] = "Estepes de Taolong",
	["Town Square"] = "Praça da Cidade",
	["Trade District"] = "Distrito Comercial",
	["Trade Quarter"] = "Distrito Comercial",
	["Trader's Tier"] = "Setor Comercial",
	["Tradesmen's Terrace"] = "Terraço dos Mercadores",
	["Train Depot"] = "Depósito Ferroviário",
	["Training Grounds"] = "Campo de Treinamento",
	["Training Quarters"] = "Salões de Treino",
	["Traitor's Cove"] = "Angra do Traidor",
	["Tranquil Coast"] = "Costa da Bonança",
	["Tranquil Gardens Cemetery"] = "Cemitério Jardins da Paz",
	["Tranquil Grotto"] = "Grota Tranquila",
	Tranquillien = "Tranquillien",
	["Tranquil Shore"] = "Costa Plácida",
	["Tranquil Wash"] = "Praia Tranquila",
	Transborea = "Transbórea",
	["Transitus Shield"] = "Escudo de Transitus",
	["Transport: Alliance Gunship"] = "Transporte: Belonave da Aliança",
	["Transport: Alliance Gunship (IGB)"] = "Transporte: Belonave da Aliança (IGB)",
	["Transport: Horde Gunship"] = "Transporte: Belonave da Horda",
	["Transport: Horde Gunship (IGB)"] = "Transporte: Belonave da Horda (IGB)",
	["Transport: Onyxia/Nefarian Elevator"] = "Transporte: Elevador Onyxia/Nefarian",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Transporte: Vigoroso Vento (Raide Cidadela da Coroa de Gelo)",
	["Trelleum Mine"] = "Mina Trelleum",
	["Trial of Fire"] = "Prova de Fogo",
	["Trial of Frost"] = "Prova de Gelo",
	["Trial of Shadow"] = "Prova das Sombras",
	["Trial of the Champion"] = "Prova do Campeão",
	["Trial of the Champion Entrance"] = "Entrada da Prova do Campeão",
	["Trial of the Crusader"] = "Prova do Cruzado",
	["Trickling Passage"] = "Galeria Gotejante",
	["Trogma's Claim"] = "Mina de Trogma",
	["Trollbane Hall"] = "Salão dos Matatroll",
	["Troll War Camp Outskirts"] = "Limites do Acampamento de Guerra Trólico",
	["Trophy Hall"] = "Salão do Troféu",
	["Troves of the Thunder King"] = "Tesouros do Rei Trovão",
	["Trueshot Point"] = "Ponta da Precisão",
	["Tuluman's Landing"] = "Acampamento do Tuluman",
	["Turtle Beach"] = "Praia da Tartaruga",
	["Tu Shen Burial Ground"] = "Solo Sagrado Tu Shen",
	Tuurem = "Tuurem",
	["Twilight Aerie"] = "Refúgio do Crepúsculo",
	["Twilight Altar of Storms"] = "Altar Crepuscular das Tempestades",
	["Twilight Base Camp"] = "Acampamento do Crepúsculo",
	["Twilight Bulwark"] = "Baluarte do Crepúsculo",
	["Twilight Camp"] = "Acampamento do Crepúsculo",
	["Twilight Command Post"] = "Posto de Comando do Crepúsculo",
	["Twilight Crossing"] = "Encruzilhada do Crepúsculo",
	["Twilight Forge"] = "Forja do Crepúsculo",
	["Twilight Grove"] = "Bosque do Crepúsculo",
	["Twilight Highlands"] = "Planalto do Crepúsculo",
	["Twilight Highlands Dragonmaw Phase"] = "Fase da Presa do Dragão no Planalto do Crepúsculo",
	["Twilight Highlands Phased Entrance"] = "Entrada Defasada do Planalto do Crepúsculo",
	["Twilight Highlands Zeppelin 1"] = "Zepelim 1 do Planalto do Crepúsculo",
	["Twilight Highlands Zeppelin 2"] = "Zepelim 2 do Planalto do Crepúsculo",
	["Twilight Outpost"] = "Posto Avançado do Crepúsculo",
	["Twilight Overlook"] = "Mirante do Crepúsculo",
	["Twilight Post"] = "Posto Crepúsculo",
	["Twilight Precipice"] = "Abismo do Crepúsculo",
	["Twilight Shore"] = "Costa do Crepúsculo",
	["Twilight's Run"] = "Passeio do Crepúsculo",
	["Twilight Terrace"] = "Terraço do Crepúsculo",
	["Twilight Vale"] = "Vale do Crepúsculo",
	["Twinbraid's Patrol"] = "Patrulha Duas-tranças",
	["Twin Peaks"] = "Montes Gêmeos",
	["Twin Shores"] = "Praias Gêmeas",
	["Twinspire Keep"] = "Bastilha das Agulhas Gêmeas",
	["Twinspire Keep Interior"] = "Bastilha das Agulhas Gêmeas - Interior",
	["Twin Spire Ruins"] = "Ruínas das Agulhas Gêmeas",
	["Twisting Nether"] = "Espiral Etérea",
	["Tyr's Hand"] = "Manopla de Tyr",
	["Tyr's Hand Abbey"] = "Abadia da Manopla de Tyr",
	["Tyr's Terrace"] = "Terraço de Tyr",
	["Ufrang's Hall"] = "Salão de Ufrang",
	Uldaman = "Uldaman",
	["Uldaman Entrance"] = "Entrada de Uldaman",
	Uldis = "Uldis",
	Ulduar = "Ulduar",
	["Ulduar Raid - Interior - Insertion Point"] = "Raide de Ulduar - Interior - Ponto de Inserção",
	["Ulduar Raid - Iron Concourse"] = "Raide de Ulduar - Junção de Ferro",
	Uldum = "Uldum",
	["Uldum Phased Entrance"] = "Entrada Defasada de Uldum",
	["Uldum Phase Oasis"] = "Fase Oásis em Uldum",
	["Uldum - Phase Wrecked Camp"] = "Uldum - Fase Acampamento Destruído",
	["Umbrafen Lake"] = "Lago Charco Sombrio",
	["Umbrafen Village"] = "Aldeia do Charco Sombrio",
	["Uncharted Sea"] = "Mar Desconhecido",
	Undercity = "Cidade Baixa",
	["Underlight Canyon"] = "Garganta Telúmina",
	["Underlight Mines"] = "Minas Telúminas",
	["Unearthed Grounds"] = "Terras Escavadas",
	["Unga Ingoo"] = "Ungá Ingô",
	["Un'Goro Crater"] = "Cratera Un'Goro",
	["Unu'pe"] = "Unu'pe",
	["Unyielding Garrison"] = "Guarnição Obstinada",
	["Upper Silvermarsh"] = "Alto Pântano de Prata",
	["Upper Sumprushes"] = "Reservatórios de Cima",
	["Upper Veil Shil'ak"] = "Véu Shil'ak Superior",
	["Ursoc's Den"] = "Covil de Ursoc",
	Ursolan = "Ursolan",
	["Utgarde Catacombs"] = "Catacumbas de Utgarde",
	["Utgarde Keep"] = "Bastilha Utgarde",
	["Utgarde Keep Entrance"] = "Entrada da Bastilha Utgarde",
	["Utgarde Pinnacle"] = "Pináculo Utgarde",
	["Utgarde Pinnacle Entrance"] = "Entrada do Pináculo Utgarde",
	["Uther's Tomb"] = "Tumba de Uther",
	["Valaar's Berth"] = "Atracadouro de Valaar",
	["Vale of Eternal Blossoms"] = "Vale das Flores Eternas",
	["Valgan's Field"] = "Sítio do Valgan",
	Valgarde = "Valgarde",
	["Valgarde Port"] = "Porto de Valgarde",
	Valhalas = "Valhalas",
	["Valiance Keep"] = "Bastilha Valentia",
	["Valiance Landing Camp"] = "Campo de Pouso Valentia",
	["Valiant Rest"] = "Repouso do Valente",
	Valkyrion = "Valkyrion",
	["Valley of Ancient Winters"] = "Vale dos Antigos Invernos",
	["Valley of Ashes"] = "Vale das Cinzas",
	["Valley of Bones"] = "Vale dos Ossos",
	["Valley of Echoes"] = "Vale dos Ecos",
	["Valley of Emperors"] = "Vale dos Imperadores",
	["Valley of Fangs"] = "Vale das Presas",
	["Valley of Heroes"] = "Vale dos Heróis",
	["Valley Of Heroes"] = "Vale dos Heróis",
	["Valley of Honor"] = "Vale da Honra",
	["Valley of Kings"] = "Vale dos Reis",
	["Valley of Power"] = "Vale do Poder",
	["Valley Of Power - Scenario"] = "Vale do Poder - Cenário",
	["Valley of Spears"] = "Vale das Lanças",
	["Valley of Spirits"] = "Vale dos Espíritos",
	["Valley of Strength"] = "Vale da Força",
	["Valley of the Bloodfuries"] = "Vale Furissangue",
	["Valley of the Four Winds"] = "Vale dos Quatro Ventos",
	["Valley of the Watchers"] = "Vale dos Vigilantes",
	["Valley of Trials"] = "Vale das Provações",
	["Valley of Wisdom"] = "Vale da Sabedoria",
	Valormok = "Valormok",
	["Valor's Edge"] = "Fio do Valor",
	["Valor's Rest"] = "Repouso dos Valorosos",
	["Valorwind Lake"] = "Lago Valovento",
	["Vanguard Infirmary"] = "Enfermaria da Vanguarda",
	["Vanndir Encampment"] = "Acampamento Vanndir",
	["Vargoth's Retreat"] = "Retiro de Vargoth",
	["Vashj'elan Spawning Pool"] = "Berçário Naga de Vashj'elan",
	["Vashj'ir"] = "Vashj'ir",
	["Vashj'ir Sub - Alliance"] = "Submarino de Vashj'ir - Aliança",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Submarino de Vashj'ir - Aliança - Circulando o Oceano Abissal",
	["Vashj'ir Sub - Horde"] = "Submarino de Vashj'ir - Horda",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Submarino de Vashj'ir - Horda - Circulandoo Oceano Abissal",
	["Vault of Archavon"] = "Abóbada de Arcavon",
	["Vault of Ironforge"] = "Cofre de Altaforja",
	["Vault of Kings Past"] = "Salão dos Reis do Passado",
	["Vault of the Ravenian"] = "Abóbada do Corvino",
	["Vault of the Shadowflame"] = "Abóbada da Chama Sombria",
	["Vault of Y'Shaarj"] = "Salão de Y'Sharrj",
	["Veil Ala'rak"] = "Véu Ala'rak",
	["Veil Harr'ik"] = "Véu Harr'ik",
	["Veil Lashh"] = "Véu Lashh",
	["Veil Lithic"] = "Véu Lithic",
	["Veil Reskk"] = "Véu Reskk",
	["Veil Rhaze"] = "Véu Rhaze",
	["Veil Ruuan"] = "Véu Ruuan",
	["Veil Sethekk"] = "Véu Sethekk",
	["Veil Shalas"] = "Véu Shalas",
	["Veil Shienor"] = "Véu Shienor",
	["Veil Skith"] = "Véu Skith",
	["Veil Vekh"] = "Véu Vekh",
	["Vekhaar Stand"] = "Bosque de Vekhaar",
	["Velaani's Arcane Goods"] = "Mercadorias Arcanas de Velaani",
	["Vendetta Point"] = "Ponta Vendeta",
	["Vengeance Landing"] = "Porto Vendeta",
	["Vengeance Landing Inn"] = "Estalagem de Porto Vendeta",
	["Vengeance Landing Inn, Howling Fjord"] = "Estalagem de Porto Vendeta, Fiorde Uivante",
	["Vengeance Lift"] = "Elevador da Vingança",
	["Vengeance Pass"] = "Desfiladeiro da Vingança",
	["Vengeance Wake"] = "Vigília da Vingança",
	["Venomous Ledge"] = "Plataforma da Peçonha",
	Venomspite = "Perfídia",
	["Venomsting Pits"] = "Fossos Escorpião-jamanta",
	["Venomweb Vale"] = "Vale Veneracnídeo",
	["Venture Bay"] = "Baía dos Empreendimentos",
	["Venture Co. Base Camp"] = "Base da Empreendimentos S.A.",
	["Venture Co. Operations Center"] = "Centro de Operações da Empreendimentos S.A.",
	["Verdant Belt"] = "Cinturão Verde",
	["Verdant Highlands"] = "Planalto Verdejante",
	["Verdantis River"] = "Rio Verdantis",
	["Veridian Point"] = "Ponta Viridiana",
	["Verlok Stand"] = "Posto Verlok",
	["Vermillion Redoubt"] = "Rubro Reduto",
	["Verming Tunnels Micro"] = "Túneis dos Vermingues Micro",
	["Verrall Delta"] = "Delta do Verrall",
	["Verrall River"] = "Rio Verrall",
	["Victor's Point"] = "Pontal do Vencedor",
	["Vileprey Village"] = "Aldeia Presabjeta",
	["Vim'gol's Circle"] = "Círculo de Vim'gol",
	["Vindicator's Rest"] = "Recanto do Vindicante",
	["Violet Citadel Balcony"] = "Varanda da Cidadela Violeta",
	["Violet Hold"] = "Castelo Violeta",
	["Violet Hold Entrance"] = "Entrada do Castelo Violeta",
	["Violet Rise"] = "Pico Violeta",
	["Violet Stand"] = "Fortaleza Violácea",
	["Virmen Grotto"] = "Gruta dos Vermingues",
	["Virmen Nest"] = "Ninho dos Vermingues",
	["Vir'naal Dam"] = "Dique Vir'naal",
	["Vir'naal Lake"] = "Lago Vir'naal",
	["Vir'naal Oasis"] = "Oásis Vir'naal",
	["Vir'naal River"] = "Rio Vir'naal",
	["Vir'naal River Delta"] = "Delta do Rio Vir'naal",
	["Void Ridge"] = "Escarpa do Caos",
	["Voidwind Plateau"] = "Platô dos Ventos do Caos",
	["Volcanoth's Lair"] = "Covil de Volcanoth",
	["Voldrin's Hold"] = "Castelo de Voldrin",
	Voldrune = "Runavold",
	["Voldrune Dwelling"] = "Residência de Runavold",
	Voltarus = "Voltarus",
	["Vordrassil Pass"] = "Desfiladeiro de Vordrassil",
	["Vordrassil's Heart"] = "Coração de Vordrassil",
	["Vordrassil's Limb"] = "Rama de Vordrassil",
	["Vordrassil's Tears"] = "Lágrimas de Vordrassil",
	["Vortex Pinnacle"] = "Pináculo do Vórtice", -- Needs review
	["Vortex Summit"] = "Auge do Vórtice",
	["Vul'Gol Ogre Mound"] = "Gruta de Vul'Gol",
	["Vyletongue Seat"] = "Trono do Torpelíngua",
	["Wahl Cottage"] = "Cabana dos Wahl",
	["Wailing Caverns"] = "Caverna Ululante",
	["Walk of Elders"] = "Passeio dos Anciãos",
	["Warbringer's Ring"] = "Arena do Armipotente",
	["Warchief's Lookout"] = "Guarita do Chefe Guerreiro",
	["Warden's Cage"] = "Jaula do Carcereiro",
	["Warden's Chambers"] = "Câmara dos Responsáveis",
	["Warden's Vigil"] = "Vigia do Guardião",
	["Warlock Area"] = "Área de Bruxo",
	["Warmaul Hill"] = "Morro Guerramalho",
	["Warpwood Quarter"] = "Distrito Lenhatorta",
	["War Quarter"] = "Distrito Bélico",
	["Warrior's Terrace"] = "Terraço dos Guerreiros",
	["War Room"] = "Sala de Guerra",
	Warship = "Navio de Guerra",
	["Warsong Camp"] = "Acampamento Brado Guerreiro",
	["Warsong Farms Outpost"] = "Acampamento das Fazendas Brado Guerreiro",
	["Warsong Flag Room"] = "Sala da Bandeira Brado Guerreiro",
	["Warsong Granary"] = "Celeiro Brado Guerreiro",
	["Warsong Gulch"] = "Ravina Brado Guerreiro",
	["Warsong Hold"] = "Fortaleza Brado Guerreiro",
	["Warsong Jetty"] = "Quebra-mar Brado Guerreiro",
	["Warsong Labor Camp"] = "Campo de Trabalho Brado Guerreiro",
	["Warsong Lumber Camp"] = "Acampamento de Lenhadores Brado Guerreiro",
	["Warsong Lumber Mill"] = "Serraria Brado Guerreiro",
	["Warsong Slaughterhouse"] = "Matadouro Brado Guerreiro",
	["Watcher's Sanctum"] = "Sacrário do Observador",
	["Watchers' Terrace"] = "Terraço dos Vigilantes",
	["Waterspeaker's Sanctuary"] = "Santuário do Parláguas",
	["Waterspring Field"] = "Campo das Minas d'Água",
	Waterworks = "Usina Hidráulica",
	["Wavestrider Beach"] = "Praia das Sete Ondas",
	Waxwood = "Floresta de Cera",
	["Wayfarer's Rest"] = "Recanto do Viajor",
	Waygate = "Pórtico",
	["Wayne's Refuge"] = "Refúgio de Wayne",
	["Weazel's Crater"] = "Cratera do Furão",
	["Webwinder Hollow"] = "Antro Enrediço",
	["Webwinder Path"] = "Passagem Tramateia",
	["Weeping Quarry"] = "Pedreira dos Lamentos",
	["Well of Eternity"] = "Nascente da Eternidade",
	["Well of the Forgotten"] = "Poço dos Esquecidos",
	["Wellson Shipyard"] = "Estaleiro Bonfilho",
	["Wellspring Hovel"] = "Casebre Olho-d'Água",
	["Wellspring Lake"] = "Lago Olho-d'Água",
	["Wellspring River"] = "Rio Olho-d'Água",
	["Westbrook Garrison"] = "Guarnição da Ribeira d'Oeste",
	["Western Bridge"] = "Ponte Ocidental",
	["Western Plaguelands"] = "Terras Pestilentas Ocidentais",
	["Western Strand"] = "Praia Ocidental",
	Westersea = "Mar do Oeste",
	Westfall = "Cerro Oeste",
	["Westfall Brigade"] = "Brigada do Cerro Oeste",
	["Westfall Brigade Encampment"] = "Acampamento da Brigada de Cerro Oeste",
	["Westfall Lighthouse"] = "Farol de Cerro Oeste",
	["West Garrison"] = "Guarnição Oeste",
	["Westguard Inn"] = "Estalagem da Guarda Oeste",
	["Westguard Keep"] = "Bastilha da Guarda Oeste",
	["Westguard Turret"] = "Torreta da Guarda Oeste",
	["West Pavilion"] = "Pavilhão Oeste",
	["West Pillar"] = "Pilar Oeste",
	["West Point Station"] = "Estação Oeste",
	["West Point Tower"] = "Torre Oeste",
	["Westreach Summit"] = "Pico dos Confins do Oeste",
	["West Sanctum"] = "Sacrário do Oeste",
	["Westspark Workshop"] = "Oficina do Parque Oeste",
	["West Spear Tower"] = "Torre da Lança Oeste",
	["West Spire"] = "Torre Oeste",
	["Westwind Lift"] = "Elevador de Zefirália",
	["Westwind Refugee Camp"] = "Campo de Refugiados de Zefirália",
	["Westwind Rest"] = "Repouso do Vento Oeste",
	Wetlands = "Pantanal",
	Wheelhouse = "Casa do Leme",
	["Whelgar's Excavation Site"] = "Sítio de Escavação de Whelgar",
	["Whelgar's Retreat"] = "Refúgio de Whelgar",
	["Whispercloud Rise"] = "Cerro das Nuvens Sussurrantes",
	["Whisper Gulch"] = "Desfiladeiro dos Sussurros",
	["Whispering Forest"] = "Floresta do Sussurro",
	["Whispering Gardens"] = "Jardins Murmurantes",
	["Whispering Inlet"] = "Enseada dos Suspiros",
	["Whispering Shore"] = "Praia Sibilante",
	["Whispering Stones"] = "Pedras Susurrantes",
	["Whisperwind Grove"] = "Bosque Murmuréolo",
	["Whistling Grove"] = "Bosque Silvante",
	["Whitebeard's Encampment"] = "Acampamento do Barbabranca",
	["Whitepetal Lake"] = "Lago Pétala Branca",
	["White Pine Trading Post"] = "Entreposto Pinheiro Branco",
	["Whitereach Post"] = "Posto Confinalvo",
	["Wildbend River"] = "Rio Crenado",
	["Wildervar Mine"] = "Mina Vildervar",
	["Wildflame Point"] = "Pontal da Chama Indômita",
	["Wildgrowth Mangal"] = "Mangue Verdejante",
	["Wildhammer Flag Room"] = "Sala da Bandeira Martelo Feroz",
	["Wildhammer Keep"] = "Bastilha Martelo Feroz",
	["Wildhammer Stronghold"] = "Fortaleza Martelo Feroz",
	["Wildheart Point"] = "Pontal do Coração Selvagem",
	["Wildmane Water Well"] = "Poço Juba Agreste",
	["Wild Overlook"] = "Mirante Selvagem",
	["Wildpaw Cavern"] = "Caverna Garragreste",
	["Wildpaw Ridge"] = "Cordilheira Garragreste",
	["Wilds' Edge Inn"] = "Estalagem da Beira da Selva",
	["Wild Shore"] = "Praia Selvagem",
	["Wildvine Marsh"] = "Charco da Vinha Selvagem",
	["Wildwind Lake"] = "Lago Vento Selvagem",
	["Wildwind Path"] = "Trilha Vento Selvagem",
	["Wildwind Peak"] = "Morro Vento Selvagem",
	["Windbreak Canyon"] = "Garganta do Quebravento",
	["Windfury Ridge"] = "Serra Ventofúria",
	["Windrunner's Overlook"] = "Penhasco Correventos",
	["Windrunner Spire"] = "Pico dos Correventos",
	["Windrunner Village"] = "Vila dos Correventos",
	["Winds' Edge"] = "Beirada do Vento",
	["Windshear Crag"] = "Rochedo Cortavento",
	["Windshear Heights"] = "Alto de Cortavento",
	["Windshear Hold"] = "Vila de Cortavento",
	["Windshear Mine"] = "Mina Cortavento",
	["Windshear Valley"] = "Vale Cortavento",
	["Windspire Bridge"] = "Ponte da Torre de Vento",
	["Windward Isle"] = "Ilha Ventaneira",
	["Windy Bluffs"] = "Penhasco dos Ventos",
	["Windyreed Pass"] = "Desfiladeiro Canavento",
	["Windyreed Village"] = "Aldeia Canavento",
	["Winterax Hold"] = "Fortaleza Invernacha",
	["Winterbough Glade"] = "Clareira Galho Invernal",
	["Winterfall Village"] = "Aldeia dos Invernosos",
	["Winterfin Caverns"] = "Caverna Falésia Invernal",
	["Winterfin Retreat"] = "Retiro da Falésia Invernal",
	["Winterfin Village"] = "Aldeia Falésia Invernal",
	["Wintergarde Crypt"] = "Cripta de Invergarde",
	["Wintergarde Keep"] = "Bastilha Invergarde",
	["Wintergarde Mausoleum"] = "Mausoléu de Invergarde",
	["Wintergarde Mine"] = "Mina Invergarde",
	Wintergrasp = "Invérnia",
	["Wintergrasp Fortress"] = "Fortaleza Invérnia",
	["Wintergrasp River"] = "Rio Invérnia",
	["Winterhoof Water Well"] = "Poço Casco Invernal",
	["Winter's Blossom"] = "Flor de Inverno",
	["Winter's Breath Lake"] = "Lago Sopro Invernal",
	["Winter's Edge Tower"] = "Torre da Borda Invernal",
	["Winter's Heart"] = "Coração do Inverno",
	Winterspring = "Hibérnia",
	["Winter's Terrace"] = "Terraço do Inverno",
	["Witch Hill"] = "Morro das Bruxas",
	["Witch's Sanctum"] = "Sacrário da Bruxa",
	["Witherbark Caverns"] = "Caverna Cascasseca",
	["Witherbark Village"] = "Aldeia Cascasseca",
	["Withering Thicket"] = "Mata Murcha",
	["Wizard Row"] = "Estreito do Teurgo",
	["Wizard's Sanctum"] = "Sacrário dos Teurgos",
	["Wolf's Run"] = "Trilha do Lobo",
	["Woodpaw Den"] = "Covil dos Patábua",
	["Woodpaw Hills"] = "Serra dos Patábua",
	["Wood's End Cabin"] = "Cabana de Findamata",
	["Woods of the Lost"] = "Mata dos Perdidos",
	Workshop = "Oficina",
	["Workshop Entrance"] = "Entrada da Oficina",
	["World's End Tavern"] = "Taberna do Fim do Mundo",
	["Wrathscale Lair"] = "Covil dos Escamódios",
	["Wrathscale Point"] = "Posto Escamódio",
	["Wreckage of the Silver Dawning"] = "Destroços do Aurora Prateada",
	["Wreck of Hellscream's Fist"] = "Destroços do Punho de Grito Infernal.",
	["Wreck of the Mist-Hopper"] = "Destroços do Salta-névoa",
	["Wreck of the Skyseeker"] = "Destroços do Busca-céu",
	["Wreck of the Vanguard"] = "Destroços do Vanguarda",
	["Writhing Mound"] = "Morro Retorcido",
	Writhingwood = "Bosque Retorcido",
	["Wu-Song Village"] = "Vila de Wu-Song",
	Wyrmbog = "Pântano da Serpe",
	["Wyrmbreaker's Rookery"] = "Viveiro do Quebra-serpe",
	["Wyrmrest Summit"] = "Topo do Repouso das Serpes",
	["Wyrmrest Temple"] = "Templo do Repouso das Serpes",
	-- ["Wyrmrest Temple - bottom to middle"] = "",
	-- ["Wyrmrest Temple - bottom to top"] = "",
	-- ["Wyrmrest Temple - middle to bottom"] = "",
	-- ["Wyrmrest Temple - middle to top"] = "",
	-- ["Wyrmrest Temple - top to bottom"] = "",
	-- ["Wyrmrest Temple - top to middle"] = "",
	["Wyrms' Bend"] = "Curva das Serpes",
	["Wyrmscar Island"] = "Ilha Mal-da-serpe",
	["Wyrmskull Bridge"] = "Ponte da Caveira de Dragão",
	["Wyrmskull Tunnel"] = "Túnel Caveira de Dragão",
	["Wyrmskull Village"] = "Aldeia Caveira de Dragão",
	["X-2 Pincer"] = "Tenaz X-2",
	Xavian = "Xavian",
	["Yan-Zhe River"] = "Rio Yan-Zhe",
	["Yeti Mountain Basecamp"] = "Acampamento do Monte Yeti",
	["Yinying Village"] = "Vila Yinying",
	Ymirheim = "Ymarheim",
	["Ymiron's Seat"] = "Trono de Ymiron",
	["Yojamba Isle"] = "Ilha Yojamba",
	["Yowler's Den"] = "Covil de Berrante",
	["Zabra'jin"] = "Zabra'jin",
	["Zaetar's Choice"] = "Escolha de Zaetar",
	["Zaetar's Grave"] = "Túmulo de Zaetar",
	["Zalashji's Den"] = "Covil de Zalashji",
	["Zalazane's Fall"] = "Ruína de Zalazane",
	["Zane's Eye Crater"] = "Cratera Olho do Zane",
	Zangarmarsh = "Pântano Zíngaro",
	["Zangar Ridge"] = "Crista Zíngara",
	["Zan'vess"] = "Zan'vess",
	["Za'Tual"] = "Za'Tual",
	["Zeb'Halak"] = "Zeb'Halak",
	["Zeb'Nowa"] = "Zeb'Nowa",
	["Zeb'Sora"] = "Zeb'Sora",
	["Zeb'Tela"] = "Zeb'Tela",
	["Zeb'tula"] = "Zeb'tula",
	["Zeb'Watha"] = "Zeb'Watha",
	["Zeppelin Crash"] = "Zepelim Caído",
	Zeramas = "Zeramas",
	["Zeth'Gor"] = "Zeth'Gor",
	["Zhu Province"] = "Província de Zhu",
	["Zhu's Descent"] = "Descenso de Zhu",
	["Zhu's Watch"] = "Vigia de Zhu",
	["Ziata'jai Ruins"] = "Ruínas Ziata'jai",
	["Zim'Abwa"] = "Zim'Abwa",
	["Zim'bo's Hideout"] = "Esconderijo de Zim'bo",
	["Zim'Rhuk"] = "Zim'Rhuk",
	["Zim'Torga"] = "Zim'Torga",
	["Zol'Heb"] = "Zol'Heb",
	["Zol'Maz Stronghold"] = "Fortaleza de Zol'Maz",
	["Zoram'gar Outpost"] = "Assentamento Zoram'gar",
	["Zouchin Province"] = "Província Zouchin",
	["Zouchin Strand"] = "Praia Zouchin",
	["Zouchin Village"] = "Vila Zouchin",
	["Zul'Aman"] = "Zul'Aman",
	["Zul'Drak"] = "Zul'Drak",
	["Zul'Farrak"] = "Zul'Farrak",
	["Zul'Farrak Entrance"] = "Entrada de Zul'Farrak",
	["Zul'Gurub"] = "Zul'Gurub",
	["Zul'Mashar"] = "Zul'Mashar",
	["Zun'watha"] = "Zun'watha",
	["Zuuldaia Ruins"] = "Ruínas Zuuldaia",
}

elseif GAME_LOCALE == "ruRU" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "Лагерь 7-го легиона",
	["7th Legion Front"] = "Передовая 7-го легиона",
	["7th Legion Submarine"] = "Подводная лодка 7-го легиона",
	["Abandoned Armory"] = "Заброшенная оружейня",
	["Abandoned Camp"] = "Заброшенный лагерь",
	["Abandoned Mine"] = "Заброшенная шахта",
	["Abandoned Reef"] = "Запустелый риф",
	["Above the Frozen Sea"] = "Над Ледяным морем",
	["A Brewing Storm"] = "Хмельная буря",
	["Abyssal Breach"] = "Обрыв над бездной",
	["Abyssal Depths"] = "Бездонные глубины",
	["Abyssal Halls"] = "Глубинные залы",
	["Abyssal Maw"] = "Бездонная пучина",
	["Abyssal Maw Exterior"] = "Внешняя сторона Бездонной пучины",
	["Abyssal Sands"] = "Безбрежные пески",
	["Abyssion's Lair"] = "Логово Абиссия",
	["Access Shaft Zeon"] = "Вход в шахту Зеон",
	["Acherus: The Ebon Hold"] = "Акерус: Черный оплот",
	["Addle's Stead"] = "Участок Эддла",
	["Aderic's Repose"] = "Покой Адерика",
	["Aerie Peak"] = "Заоблачный пик",
	["Aeris Landing"] = "Небесный лагерь",
	["Agamand Family Crypt"] = "Семейная усыпальница Агамондов",
	["Agamand Mills"] = "Мельницы Агамондов",
	["Agmar's Hammer"] = "Молот Агмара",
	["Agmond's End"] = "Удел Эгмонда",
	["Agol'watha"] = "Агол'вата",
	["A Hero's Welcome"] = "Благодарность за отвагу",
	["Ahn'kahet: The Old Kingdom"] = "Ан'кахет: Старое Королевство",
	["Ahn'kahet: The Old Kingdom Entrance"] = "Ан'кахет: Старое Королевство",
	["Ahn Qiraj"] = "Ан'Кираж",
	["Ahn'Qiraj"] = "Ан'Кираж",
	["Ahn'Qiraj Temple"] = "Храм Ан'Киража",
	["Ahn'Qiraj Terrace"] = "Терраса Ан'Киража",
	["Ahn'Qiraj: The Fallen Kingdom"] = "Ан'Кираж: Павшее Королевство",
	["Akhenet Fields"] = "Поля Акхенет",
	["Aku'mai's Lair"] = "Логово Аку'май",
	["Alabaster Shelf"] = "Алебастровый шельф",
	["Alcaz Island"] = "Остров Алькац",
	["Aldor Rise"] = "Возвышенность Алдоров",
	Aldrassil = "Альдрассил",
	["Aldur'thar: The Desolation Gate"] = "Алдур'тар: Врата Горя",
	["Alexston Farmstead"] = "Поместье Алекстона",
	["Algaz Gate"] = "Врата Альгаза",
	["Algaz Station"] = "Станция Альгаз",
	["A Little Patience"] = "Немного терпения",
	["Allen Farmstead"] = "Ферма Аллена",
	["Allerian Post"] = "Застава Аллерии",
	["Allerian Stronghold"] = "Бастион Аллерии",
	["Alliance Base"] = "База Альянса",
	["Alliance Beach Daily Area"] = "База Альянса на пляже - ежедневные задания",
	["Alliance Beachhead"] = "Плацдарм Альянса",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Alliance Hub - Mogu Island Progression Scenario",
	["Alliance Keep"] = "Крепость Альянса",
	["Alliance Mercenary Ship to Vashj'ir"] = "Корабль наемников Альянса до Вайш'ира",
	["Alliance PVP Barracks"] = "Казармы Альянса",
	["All That Glitters Prospecting Co."] = "Все, что блестит",
	["Alonsus Chapel"] = "Часовня Алонсия",
	["Altar of Ascension"] = "Алтарь Перерожденных",
	["Altar of Har'koa"] = "Алтарь Хар'коа",
	["Altar of Mam'toth"] = "Алтарь Мам'Тота",
	["Altar of Quetz'lun"] = "Алтарь Кетц'лун",
	["Altar of Rhunok"] = "Алтарь Рунока",
	["Altar of Sha'tar"] = "Алтарь Ша'тар",
	["Altar of Sseratus"] = "Алтарь Шшератуса",
	["Altar of Storms"] = "Алтарь Бурь",
	["Altar of the Blood God"] = "Алтарь Бога Крови",
	["Altar of Twilight"] = "Сумеречный алтарь",
	["Alterac Mountains"] = "Альтеракские горы",
	["Alterac Valley"] = "Альтеракская долина",
	["Alther's Mill"] = "Лесопилка Альтера",
	["Amani Catacombs"] = "Катакомбы Амани",
	["Amani Mountains"] = "Аманийские горы",
	["Amani Pass"] = "Перевал Амани",
	["Amberfly Bog"] = "Трясина янтарных мух",
	["Amberglow Hollow"] = "Янтарный зал",
	["Amber Ledge"] = "Янтарная гряда",
	Ambermarsh = "Янтарная топь",
	Ambermill = "Янтарная мельница",
	["Amberpine Lodge"] = "Приют Янтарной Сосны",
	["Amber Quarry"] = "Янтарные копи",
	["Amber Research Sanctum"] = "Комната янтарной алхимии",
	["Ambershard Cavern"] = "Пещера Янтарных Осколков",
	["Amberstill Ranch"] = "Ферма Янтарленов",
	["Amberweb Pass"] = "Перевал Янтарной Паутины",
	["Ameth'Aran"] = "Амет'Аран",
	["Ammen Fields"] = "Поля Аммен",
	["Ammen Ford"] = "Переправа Аммен",
	["Ammen Vale"] = "Долина Аммен",
	["Amphitheater of Anguish"] = "Амфитеатр Страданий",
	["Ampitheater of Anguish"] = "Амфитеатр Страданий",
	["Ancestral Grounds"] = "Земли Предков",
	["Ancestral Rise"] = "Плато предков",
	["Ancient Courtyard"] = "Двор Древних",
	["Ancient Zul'Gurub"] = "Старый Зул'Гуруб",
	["An'daroth"] = "Ан'дарот",
	["Andilien Estate"] = "Поместье Андилиен",
	Andorhal = "Андорал",
	Andruk = "Андрук",
	["Angerfang Encampment"] = "Лагерь Злого Клыка",
	["Angkhal Pavilion"] = "Павильон Ангхал",
	["Anglers Expedition"] = "Рыболовная экспедиция",
	["Anglers Wharf"] = "Деревня рыболовов",
	["Angor Fortress"] = "Крепость Ангор",
	["Ango'rosh Grounds"] = "Земли Анго'рош",
	["Ango'rosh Stronghold"] = "Крепость Анго'рош",
	["Angrathar the Wrathgate"] = "Ангратар, Врата Гнева",
	["Angrathar the Wrath Gate"] = "Ангратар, Врата Гнева",
	["An'owyn"] = "Ан'овин",
	["An'telas"] = "Ан'телас",
	["Antonidas Memorial"] = "Памятник Антонидасу",
	Anvilmar = "Старая Наковальня",
	["Anvil of Conflagration"] = "Огненная Наковальня",
	["Apex Point"] = "Высшая Точка",
	["Apocryphan's Rest"] = "Скелет Апокрифана",
	["Apothecary Camp"] = "Аптекарский поселок",
	["Applebloom Tavern"] = "Таверна Яблоневого Цвета",
	["Arathi Basin"] = "Низина Арати",
	["Arathi Highlands"] = "Нагорье Арати",
	["Arcane Pinnacle"] = "Волшебный замок",
	["Archmage Vargoth's Retreat"] = "Укрытие верховного мага Варгота",
	["Area 52"] = "Зона 52",
	["Arena Floor"] = "Ринг арены",
	["Arena of Annihilation"] = "Арена Истребления",
	["Argent Pavilion"] = "Серебряный павильон",
	["Argent Stand"] = "Серебряная застава",
	["Argent Tournament Grounds"] = "Ристалище Серебряного турнира",
	["Argent Vanguard"] = "Оплот Серебряного Авангарда",
	["Ariden's Camp"] = "Лагерь Аридена",
	["Arikara's Needle"] = "Шпиль Арикары",
	["Arklonis Ridge"] = "Гряда Арклонис",
	["Arklon Ruins"] = "Руины Арклон",
	["Arriga Footbridge"] = "Мост Аррига",
	["Arsad Trade Post"] = "Торговая лавка Арсад",
	["Ascendant's Rise"] = "Вершина Перерожденых",
	["Ascent of Swirling Winds"] = "Возвышенность Кружащихся Ветров",
	["Ashen Fields"] = "Пепельные поля",
	["Ashen Lake"] = "Пепельное озеро",
	Ashenvale = "Ясеневый лес",
	["Ashwood Lake"] = "Ясеневое озеро",
	["Ashwood Post"] = "Ясеневая застава",
	["Aspen Grove Post"] = "Застава Тополиной рощи",
	["Assault on Shaol'mara"] = "Атака на Шаол'мару",
	["Assault on Zan'vess"] = "Атака на Зан'весс",
	["Assault on Zeb'tula"] = "Атака на Зеб'тул",
	Astranaar = "Астранаар",
	["Ata'mal Terrace"] = "Терраса Ата'мала",
	Athenaeum = "Читальня",
	["Atrium of the Heart"] = "Атриум",
	["Atulhet's Tomb"] = "Гробница Атулхета",
	["Auberdine Refugee Camp"] = "Аубердинский лагерь беженцев",
	["Auburn Bluffs"] = "Золотые утесы",
	["Auchenai Crypts"] = "Аукенайские гробницы",
	["Auchenai Grounds"] = "Аукенайские земли",
	Auchindoun = "Аукиндон",
	["Auchindoun: Auchenai Crypts"] = "Аукиндон: Аукенайские гробницы",
	["Auchindoun - Auchenai Crypts Entrance"] = "Аукиндон - вход в Аукенайские гробницы",
	["Auchindoun: Mana-Tombs"] = "Аукиндон: Гробницы Маны",
	["Auchindoun - Mana-Tombs Entrance"] = "Аукиндон - вход в Гробницы Маны",
	["Auchindoun: Sethekk Halls"] = "Аукиндон: Сетеккские залы",
	["Auchindoun - Sethekk Halls Entrance"] = "Аукиндон - вход в Сетеккские залы",
	["Auchindoun: Shadow Labyrinth"] = "Аукиндон: Темный лабиринт",
	["Auchindoun - Shadow Labyrinth Entrance"] = "Аукиндон - вход в Темный лабиринт",
	["Auren Falls"] = "Водопад Аурен",
	["Auren Ridge"] = "Гряда Аурен",
	["Autumnshade Ridge"] = "Хребет Осенней Тени",
	["Avalanchion's Vault"] = "Пещера Лавиниона",
	Aviary = "Птичник",
	["Axis of Alignment"] = "Ось Выравнивания",
	Axxarien = "Аксариен",
	["Azjol-Nerub"] = "Азжол-Неруб",
	["Azjol-Nerub Entrance"] = "Вход в Азжол-Неруб",
	Azshara = "Азшара",
	["Azshara Crater"] = "Кратер Азшары",
	["Azshara's Palace"] = "Дворец Азшары",
	["Azurebreeze Coast"] = "Побережье Лазурного Ветра",
	["Azure Dragonshrine"] = "Лазуритовое святилище драконов",
	["Azurelode Mine"] = "Лазуритовый рудник",
	["Azuremyst Isle"] = "Остров Лазурной Дымки",
	["Azure Watch"] = "Лазурная застава",
	["Backbreaker Bay"] = "Бухта Спинолома",
	Badlands = "Бесплодные земли",
	["Bael'dun Digsite"] = "Раскопки Бейл'дана",
	["Bael'dun Keep"] = "Крепость Бейл'дан",
	["Baelgun's Excavation Site"] = "Раскопки Бейлгуна",
	["Bael Modan"] = "Бейл Модан",
	["Bael Modan Excavation"] = "Раскопки Бейл Модана",
	["Bahrum's Post"] = "Лагерь Бахрума",
	["Balargarde Fortress"] = "Цитадель Балагарда",
	Baleheim = "Гибльхейм",
	["Balejar Watch"] = "Застава Баледжара",
	["Balia'mah Ruins"] = "Руины Балиа'ма",
	["Bal'lal Ruins"] = "Руины Бал'лал",
	["Balnir Farmstead"] = "Усадьба Балнира",
	Bambala = "Бамбала",
	["Band of Acceleration"] = "Кольцо ускорения",
	["Band of Alignment"] = "Кольцо управления",
	["Band of Transmutation"] = "Кольцо трансмутации",
	["Band of Variance"] = "Кольцо отклонения",
	["Ban'ethil Barrow Den"] = "Обитель Бен'этиль",
	["Ban'ethil Barrow Descent"] = "Спуск в обитель Бен'этиль",
	["Ban'ethil Hollow"] = "Лощина Бен'этиль",
	Bank = "Банк",
	["Banquet Grounds"] = "Площадка для пиршества",
	["Ban'Thallow Barrow Den"] = "Берлога Бен'Таллоу",
	["Baradin Base Camp"] = "Лагерь Барадин",
	["Baradin Bay"] = "Бухта Барадин",
	["Baradin Hold"] = "Крепость Барадин",
	Barbershop = "Парикмахерская",
	["Barov Family Vault"] = "Семейный склеп Баровых",
	["Bashal'Aran"] = "Башал'Аран",
	["Bashal'Aran Collapse"] = "Разлом Башал'Аран",
	["Bash'ir Landing"] = "Лагерь Баш'ира",
	["Bastion Antechamber"] = "Холл бастиона",
	["Bathran's Haunt"] = "Убежище Батрана",
	["Battlefront Provisions"] = "Припасы линии фронта",
	["Battle on the High Seas"] = "Битва в открытом море",
	["Battle Ring"] = "Ринг",
	Battlescar = "Боевой Шрам",
	["Battlescar Spire"] = "Вершина Боевого Шрама",
	["Battlescar Valley"] = "Долина Боевого Шрама",
	["Bay of Echoes"] = "Бухта Отголосков",
	["Bay of Storms"] = "Залив Бурь",
	["Bear's Head"] = "Медвежий угол",
	["Beauty's Lair"] = "Логово Красавицы",
	["Beeble's Wreck"] = "Место крушения Библа",
	["Beezil's Wreck"] = "Место крушения дирижабля Бизила",
	["Befouled Terrace"] = "Опоганенная терраса",
	["Beggar's Haunt"] = "Приют Бродяги",
	["Beneath The Double Rainbow"] = "Сень радуги",
	["Beneath the Pit"] = "Лестница под ямой",
	["Beren's Peril"] = "Погибель Берена",
	["Bernau's Happy Fun Land"] = "Страна веселья Берно",
	["Beryl Coast"] = "Берилловое побережье",
	["Beryl Egress"] = "Берилловый Удел",
	["Beryl Point"] = "Берилловый лагерь",
	["Beth'mora Ridge"] = "Гряда Бет'мора",
	["Beth'tilac's Lair"] = "Логово Бет'тилак",
	["Biel'aran Ridge"] = "Гряда Бейл'аран",
	["Big Beach Brew Bash"] = "Прибрежная битва за хмель",
	["Big Blossom Excavation"] = "Прииски Пышного Цветения",
	["Big Blossom Mine"] = "Рудник Пышного Цветения",
	["Bilgewater Beach"] = "Пляж Трюмных Вод",
	["Bilgewater Harbor"] = "Гавань Трюмных Вод",
	["Bilgewater Lumber Yard"] = "Вырубки картеля",
	["Bilgewater Port"] = "Порт Трюмных Вод",
	["Binan Brew & Stew"] = "Бинанские деликатесы",
	["Binan Village"] = "Деревня Бинан",
	["Bitter Reaches"] = "Горькие плесы",
	["Bittertide Lake"] = "Озеро Горьких Волн",
	["Bizmo's Brawlpub"] = "Потасовочная У Бизмо",
	["Black Channel Marsh"] = "Черная трясина",
	["Blackchar Cave"] = "Обугленная пещера",
	["Black Drake Roost"] = "Гнездовье черных драконов",
	["Blackfathom Camp"] = "Лагерь у Непроглядной Пучины",
	["Blackfathom Deeps"] = "Непроглядная Пучина",
	["Blackfathom Deeps Entrance"] = "Непроглядная Пучина",
	["Blackhoof Village"] = "Деревня Черного Копыта",
	["Blackhorn's Penance"] = "Башня Покаяния Чернорога",
	["Blackmaw Hold"] = "Крепость Черночревов",
	["Black Ox Temple"] = "Храм Черного Быка",
	["Blackriver Logging Camp"] = "Лесопилка Черноречья",
	["Blackrock Caverns"] = "Пещеры Черной горы",
	["Blackrock Caverns Entrance"] = "Пещеры Черной горы",
	["Blackrock Depths"] = "Глубины Черной горы",
	["Blackrock Depths Entrance"] = "Глубины Черной горы",
	["Blackrock Mountain"] = "Черная гора",
	["Blackrock Pass"] = "Перевал Черной горы",
	["Blackrock Spire"] = "Пик Черной горы",
	["Blackrock Spire Entrance"] = "Пик Черной горы",
	["Blackrock Stadium"] = "Стадион Черной горы",
	["Blackrock Stronghold"] = "Крепость Черной горы",
	["Blacksand Spillway"] = "Водослив Черных Песков",
	["Blacksilt Shore"] = "Берег Черного Ила",
	Blacksmith = "Кузница",
	["Blackstone Span"] = "Провал черного камня",
	["Black Temple"] = "Черный храм",
	["Black Tooth Hovel"] = "Загон Черного Зуба",
	Blackwatch = "Черный дозор",
	["Blackwater Cove"] = "Бухта Черноводья",
	["Blackwater Shipwrecks"] = "Обломки судов Черноводья",
	["Blackwind Lake"] = "Озеро Черного Ветра",
	["Blackwind Landing"] = "Лагерь Черного Ветра",
	["Blackwind Valley"] = "Долина Черного Ветра",
	["Blackwing Coven"] = "Пещера Крыла Тьмы",
	["Blackwing Descent"] = "Твердыня Крыла Тьмы",
	["Blackwing Lair"] = "Логово Крыла Тьмы",
	["Blackwolf River"] = "Волчья река",
	["Blackwood Camp"] = "Лагерь Чернолесья",
	["Blackwood Den"] = "Берлога в Чернолесье",
	["Blackwood Lake"] = "Озеро Чернолесья",
	["Bladed Gulch"] = "Лощина Клинков",
	["Bladefist Bay"] = "Бухта Острорука",
	["Bladelord's Retreat"] = "Покои Повелителя Клинка",
	["Blades & Axes"] = "Клинки и топоры",
	["Blade's Edge Arena"] = "Арена Острогорья",
	["Blade's Edge Mountains"] = "Острогорье",
	["Bladespire Grounds"] = "Земли Камнерогов",
	["Bladespire Hold"] = "Форт Камнерогов",
	["Bladespire Outpost"] = "Застава Камнерогов",
	["Blades' Run"] = "Скалистая тропа",
	["Blade Tooth Canyon"] = "Каньон Острого Зуба",
	Bladewood = "Лес Клинков",
	["Blasted Lands"] = "Выжженные земли",
	["Bleak Hollow"] = "Мрачная пещера",
	["Bleeding Hollow Ruins"] = "Руины Кровавой Глазницы",
	["Bleeding Vale"] = "Кровоточащая долина",
	["Bleeding Ziggurat"] = "Кровоточащий зиккурат",
	["Blistering Pool"] = "Кипящий пруд",
	["Bloodcurse Isle"] = "Остров Проклятой Крови",
	["Blood Elf Tower"] = "Башня эльфов крови",
	["Bloodfen Burrow"] = "Логово Кровавой Топи",
	Bloodgulch = "Кровавое ущелье",
	["Bloodhoof Village"] = "Деревня Кровавого Копыта",
	["Bloodied Crossing"] = "Кровавый перекресток",
	["Blood in the Snow"] = "Кровь на снегу",
	["Bloodmaul Camp"] = "Лагерь Кровавого Молота",
	["Bloodmaul Outpost"] = "Застава Кровавого Молота",
	["Bloodmaul Ravine"] = "Лощина Кровавого Молота",
	["Bloodmoon Isle"] = "Остров Кровавой Луны",
	["Bloodmyst Isle"] = "Остров Кровавой Дымки",
	["Bloodscale Enclave"] = "Анклав Кровавой Чешуи",
	["Bloodscale Grounds"] = "Земли Кровавой Чешуи",
	["Bloodspore Plains"] = "Равнины Кровавых Спор",
	["Bloodtalon Shore"] = "Берег Кровавого Когтя",
	["Bloodtooth Camp"] = "Лагерь Кровавого Клыка",
	["Bloodvenom Falls"] = "Водопад Отравленной Крови",
	["Bloodvenom Post"] = "Застава Отравленной Крови",
	["Bloodvenom Post "] = "Застава Отравленной Крови",
	["Bloodvenom River"] = "Река Отравленной Крови",
	["Bloodwash Cavern"] = "Пещера Кровавого Прибоя",
	["Bloodwash Fighting Pits"] = "Боевые ямы Кровавого Прибоя",
	["Bloodwash Shrine"] = "Святилище Кровавого Прибоя",
	["Blood Watch"] = "Кровавая застава",
	["Bloodwatcher Point"] = "Лагерь Кровавого Взора",
	Bluefen = "Синяя топь",
	["Bluegill Marsh"] = "Болота Синежабрых",
	["Blue Sky Logging Grounds"] = "Лесозаготовки Синего Неба",
	["Bluff of the South Wind"] = "Утес Южного Ветра",
	["Bogen's Ledge"] = "Грот Богена",
	Bogpaddle = "Веслотопь",
	["Boha'mu Ruins"] = "Руины Боха'му",
	["Bolgan's Hole"] = "Пещера Болгана",
	["Bolyun's Camp"] = "Лагерь Больюна",
	["Bonechewer Ruins"] = "Руины Костеглодов",
	["Bonesnap's Camp"] = "Лагерь Костехвата",
	["Bones of Grakkarond"] = "Кости Граккаронда",
	["Bootlegger Outpost"] = "Стоянка бутлегеров",
	["Booty Bay"] = "Пиратская Бухта",
	["Borean Tundra"] = "Борейская тундра",
	["Bor'gorok Outpost"] = "Застава Бор'горока",
	["Bor's Breath"] = "Дыхание Бора",
	["Bor's Breath River"] = "Река Дыхания Бора",
	["Bor's Fall"] = "Водопад Бора",
	["Bor's Fury"] = "Ярость Бора",
	["Borune Ruins"] = "Руины Боруна",
	["Bough Shadow"] = "Тенистая Крона",
	["Bouldercrag's Refuge"] = "Приют Глыбоскала",
	["Boulderfist Hall"] = "Крепость Тяжелого Кулака",
	["Boulderfist Outpost"] = "Аванпост Тяжелого Кулака",
	["Boulder'gor"] = "Камен'гор",
	["Boulder Hills"] = "Каменистые холмы",
	["Boulder Lode Mine"] = "Каменный карьер",
	["Boulder'mok"] = "Камен'мок",
	["Boulderslide Cavern"] = "Пещера Камнепадов",
	["Boulderslide Ravine"] = "Ущелье Камнепадов",
	["Bozzle's Wreck"] = "Место крушения Боззла",
	["Brackenwall Village"] = "Деревня Гиблотопь",
	["Brackwell Pumpkin Patch"] = "Тыквенное поле Бреквеллов",
	["Brambleblade Ravine"] = "Ежевичная лощина",
	Bramblescar = "Ежевичный овраг",
	["Brann's Base-Camp"] = "Базовый лагерь Бранна",
	["Brashtide Attack Fleet"] = "Военный флот Крушащей Волны",
	["Brashtide Attack Fleet (Force Outdoors)"] = "Военный флот Крушащей Волны",
	["Brave Wind Mesa"] = "Плато Дерзкого Ветра",
	["Brawl'gar Arena"] = "Арена Морд’Бой",
	["Brazie Farmstead"] = "Усадьба Брейзи",
	["Brewmoon Festival"] = "Фестиваль Хмельнолуния",
	["Brewnall Village"] = "Поселок Пивоваров",
	["Bridge of Souls"] = "Мост Душ",
	["Brightwater Lake"] = "Озеро Ясноводное",
	["Brightwood Grove"] = "Светлая роща",
	Brill = "Брилл",
	["Brill Town Hall"] = "Ратуша Брилла",
	["Bristlelimb Enclave"] = "Анклав Косолапов",
	["Bristlelimb Village"] = "Деревня Косолапов",
	["Broken Commons"] = "Разоренные земли",
	["Broken Hill"] = "Изрезанный холм",
	["Broken Pillar"] = "Разбитая Колонна",
	["Broken Spear Village"] = "Деревня Сломанного Копья",
	["Broken Wilds"] = "Скалистые пустоши",
	["Broketooth Outpost"] = "Застава Ломаного Зуба",
	["Bronzebeard Encampment"] = "Лагерь Бронзоборода",
	["Bronze Dragonshrine"] = "Бронзовое святилище драконов",
	["Browman Mill"] = "Лесопилка Бровача",
	["Brunnhildar Village"] = "Деревня Бруннхильдар",
	["Bucklebree Farm"] = "Ферма Баклбри",
	["Budd's Dig"] = "Раскопки Бадда",
	["Burning Blade Coven"] = "Грот Пылающего Клинка",
	["Burning Blade Ruins"] = "Руины Пылающего Клинка",
	["Burning Steppes"] = "Пылающие степи",
	["Butcher's Sanctum"] = "Цех мясника",
	["Butcher's Stand"] = "Застава кровопролития",
	["Caer Darrow"] = "Каэр Дарроу",
	["Caldemere Lake"] = "Озеро Холдомир",
	["Calston Estate"] = "Поместье Калстона",
	["Camp Aparaje"] = "Лагерь Апарахе",
	["Camp Ataya"] = "Лагерь Атайа",
	["Camp Boff"] = "Лагерь Бофф",
	["Camp Broketooth"] = "Лагерь Ломаного Зуба",
	["Camp Cagg"] = "Лагерь Кэгг",
	["Camp E'thok"] = "Лагерь Э'Ток",
	["Camp Everstill"] = "Лагерь Безмолвия",
	["Camp Gormal"] = "Лагерь Гормал",
	["Camp Kosh"] = "Лагерь Кош",
	["Camp Mojache"] = "Лагерь Мохаче",
	["Camp Mojache Longhouse"] = "Большой дом Мохаче",
	["Camp Narache"] = "Лагерь Нараче",
	["Camp Nooka Nooka"] = "Лагерь Нука-Нука",
	["Camp of Boom"] = "Лагерь Бума",
	["Camp Onequah"] = "Camp Onequah",
	["Camp Oneqwah"] = "Лагерь Уанква",
	["Camp Sungraze"] = "Лагерь Солнечного Пастбища",
	["Camp Tunka'lo"] = "Лагерь Тунка’ло",
	["Camp Una'fe"] = "Лагерь Уна'фе",
	["Camp Winterhoof"] = "Лагерь Заиндевевшего Копыта",
	["Camp Wurg"] = "Лагерь Вург",
	Canals = "Каналы",
	["Cannon's Inferno"] = "Преисподняя Прожара",
	["Cantrips & Crows"] = "Ведьма и ворон",
	["Cape of Lost Hope"] = "Мыс Потерянной Надежды",
	["Cape of Stranglethorn"] = "Мыс Тернистой долины",
	["Capital Gardens"] = "Центральный сад",
	["Carrion Hill"] = "Холм Падальщика",
	["Cartier & Co. Fine Jewelry"] = "Ювелирный магазин Картье и компании",
	Cataclysm = "Cataclysm",
	["Cathedral of Darkness"] = "Собор Тьмы",
	["Cathedral of Light"] = "Собор Света",
	["Cathedral Quarter"] = "Соборный квартал",
	["Cathedral Square"] = "Соборная площадь",
	["Cattail Lake"] = "Камышовое озеро",
	["Cauldros Isle"] = "Остров Колдрос",
	["Cave of Mam'toth"] = "Пещера Мам'тота",
	["Cave of Meditation"] = "Пещера Медитации",
	["Cave of the Crane"] = "Пещера Журавля",
	["Cave of Words"] = "Пещера Слов",
	["Cavern of Endless Echoes"] = "Пещера Бесконечного Эха",
	["Cavern of Mists"] = "Пещера Туманов",
	["Caverns of Time"] = "Пещеры Времени",
	["Celestial Enclave"] = "Небесный анклав",
	["Celestial Ridge"] = "Небесная гряда",
	["Cenarion Enclave"] = "Анклав Кенария",
	["Cenarion Hold"] = "Крепость Кенария",
	["Cenarion Post"] = "Кенарийская застава",
	["Cenarion Refuge"] = "Кенарийский оплот",
	["Cenarion Thicket"] = "Перелесок Кенария",
	["Cenarion Watchpost"] = "Кенарийский караульный пост",
	["Cenarion Wildlands"] = "Кенарийские Заросли",
	["Central Bridge"] = "Центральный мост",
	["Chamber of Ancient Relics"] = "Комната древних святынь",
	["Chamber of Atonement"] = "Чертог Искупления",
	["Chamber of Battle"] = "Чертог Битвы",
	["Chamber of Blood"] = "Чертог Крови",
	["Chamber of Command"] = "Чертог Власти",
	["Chamber of Enchantment"] = "Колдовской чертог",
	["Chamber of Enlightenment"] = "Зал Просвещения",
	["Chamber of Fanatics"] = "Комната фанатиков",
	["Chamber of Incineration"] = "Чертог Испепеления",
	["Chamber of Masters"] = "Зал ремесленников",
	["Chamber of Prophecy"] = "Зал Пророчеств",
	["Chamber of Reflection"] = "Зал созерцания",
	["Chamber of Respite"] = "Зал Покоя",
	["Chamber of Summoning"] = "Чертог Призыва",
	["Chamber of Test Namesets"] = "Зал тестовых названий",
	["Chamber of the Aspects"] = "Драконьи чертоги",
	["Chamber of the Dreamer"] = "Чертог Дремлющего",
	["Chamber of the Moon"] = "Зал Луны",
	["Chamber of the Restless"] = "Чертог Неупокоенных",
	["Chamber of the Stars"] = "Зал Звезд",
	["Chamber of the Sun"] = "Зал Солнца",
	["Chamber of Whispers"] = "Зал Шептаний",
	["Chamber of Wisdom"] = "Зал Мудрости",
	["Champion's Hall"] = "Палаты Героев",
	["Champions' Hall"] = "Зал Защитника",
	["Chapel Gardens"] = "Церковные сады",
	["Chapel of the Crimson Flame"] = "Часовня Багрового Пламени",
	["Chapel Yard"] = "Церковный двор",
	["Charred Outpost"] = "Обуглившаяся застава",
	["Charred Rise"] = "Обугленная вершина",
	["Chill Breeze Valley"] = "Долина Промозглого Ветра",
	["Chillmere Coast"] = "Берег Стылой Межи",
	["Chillwind Camp"] = "Лагерь Промозглого Ветра",
	["Chillwind Point"] = "Берег Промозглого Ветра",
	Chiselgrip = "Узкоклинье",
	["Chittering Coast"] = "Щебечущий Берег",
	["Chow Farmstead"] = "Ферма Чоу",
	["Churning Gulch"] = "Беспокойная лощина",
	["Circle of Blood"] = "Круг Крови",
	["Circle of Blood Arena"] = "Арена в Круге Крови",
	["Circle of Bone"] = "Круг Кости",
	["Circle of East Binding"] = "Восточный Круг Обуздания",
	["Circle of Inner Binding"] = "Внутренний Круг Обуздания",
	["Circle of Outer Binding"] = "Внешний Круг Обуздания",
	["Circle of Scale"] = "Круг Чешуи",
	["Circle of Stone"] = "Круг Камня",
	["Circle of Thorns"] = "Кольцо Шипов",
	["Circle of West Binding"] = "Западный Круг Обуздания",
	["Circle of Wills"] = "Круг Воли",
	City = "Город",
	["City of Ironforge"] = "Стальгорн",
	["City Siege - Mogu Island Progression Scenario"] = "City Siege - Mogu Island Progression Scenario",
	["Clan Watch"] = "Клановая Стража",
	["Class Quest"] = "Классовое задание",
	["Claytön's WoWEdit Land"] = "Claytön's WoWEdit Land",
	["Cleft of Shadow"] = "Расселина Теней",
	["Cliffspring Falls"] = "Водопад Скалистый",
	["Cliffspring Hollow"] = "Скалистая пещера",
	["Cliffspring River"] = "Река Скалистая",
	["Cliffwalker Post"] = "Плато Скалоступов",
	["Cloudstrike Dojo"] = "Додзё Небесного Удара",
	["Cloudtop Terrace"] = "Подзвездная терраса",
	["Coast of Echoes"] = "Берег Эха",
	["Coast of Idols"] = "Берег истуканов",
	["Coilfang Reservoir"] = "Резервуар Кривого Клыка",
	["Coilfang: Serpentshrine Cavern"] = "Кривой Клык: Змеиное святилище",
	["Coilfang: The Slave Pens"] = "Кривой Клык: Узилище",
	["Coilfang - The Slave Pens Entrance"] = "Кривой Клык: Узилище",
	["Coilfang: The Steamvault"] = "Кривой Клык: Паровое подземелье",
	["Coilfang - The Steamvault Entrance"] = "Кривой Клык: Паровое подземелье",
	["Coilfang: The Underbog"] = "Кривой Клык: Нижетопь",
	["Coilfang - The Underbog Entrance"] = "Кривой Клык: Нижетопь",
	["Coilskar Cistern"] = "Водохранилище Змеиных Колец",
	["Coilskar Point"] = "Лагерь Змеиных Колец",
	Coldarra = "Хладарра",
	["Coldarra Ledge"] = "Кряж Хладарры",
	["Coldbite Burrow"] = "Логово хладогрызов",
	["Cold Hearth Manor"] = "Поместье Остывший Очаг",
	["Coldridge Pass"] = "Туннель Холодной долины",
	["Coldridge Valley"] = "Холодная долина",
	["Coldrock Quarry"] = "Карьер Ледяного Булыжника",
	["Coldtooth Mine"] = "Рудник Ледяного Зуба",
	["Coldwind Heights"] = "Морозные выси",
	["Coldwind Pass"] = "Перевал Холодного Ветра",
	["Collin's Test"] = "Тест Коллина",
	["Command Center"] = "Ставка Командования",
	["Commons Hall"] = "Общий зал",
	["Condemned Halls"] = "Обвалившийся зал",
	["Conqueror's Terrace"] = "Терраса Завоевателя",
	["Conquest Hold"] = "Крепость Завоевателей",
	["Containment Core"] = "Ядро Сдерживания",
	["Cooper Residence"] = "Имение Купера",
	["Coral Garden"] = "Коралловый сад",
	["Cordell's Enchanting"] = "Чародейская школа Корделлов",
	["Corin's Crossing"] = "Перекресток Корина",
	["Corp'rethar: The Horror Gate"] = "Корп'ретар: Врата Ужаса",
	["Corrahn's Dagger"] = "Уступ Коррана",
	Cosmowrench = "Космоворот",
	["Court of Bones"] = "Двор Костей",
	["Court of the Highborne"] = "Двор высокорожденных",
	["Court of the Sun"] = "Площадь Солнца",
	["Courtyard of Lights"] = "Двор Света",
	["Courtyard of the Ancients"] = "Двор Древних",
	["Cradle of Chi-Ji"] = "Колыбель Чи-Цзи",
	["Cradle of the Ancients"] = "Колыбель Древних",
	["Craftsmen's Terrace"] = "Терраса Ремесленников",
	["Crag of the Everliving"] = "Утес Вечноживущего",
	["Cragpool Lake"] = "Скалистое озеро",
	["Crane Wing Refuge"] = "Укрытие Журавлиного Крыла",
	["Crash Site"] = "Место Крушения",
	["Crescent Hall"] = "Зал Полумесяца",
	["Crimson Assembly Hall"] = "Алый зал собраний",
	["Crimson Expanse"] = "Багровый зал",
	["Crimson Watch"] = "Кровавый Дозор",
	Crossroads = "Перекресток",
	["Crowley Orchard"] = "Сад Краули",
	["Crowley Stable Grounds"] = "Конюшни Краули",
	["Crown Guard Tower"] = "Башня королевской стражи",
	["Crucible of Carnage"] = "Горнило Крови",
	["Crumbling Depths"] = "Гремящие глубины",
	["Crumbling Stones"] = "Гремящие камни",
	["Crusader Forward Camp"] = "Передовой лагерь рыцарей",
	["Crusader Outpost"] = "Застава Алого Ордена",
	["Crusader's Armory"] = "Оружейная рыцарей",
	["Crusader's Chapel"] = "Часовня Рыцаря",
	["Crusader's Landing"] = "Стоянка рыцарей",
	["Crusader's Outpost"] = "Застава Алого ордена",
	["Crusaders' Pinnacle"] = "Вершина Рыцарей",
	["Crusader's Run"] = "Путь Рыцаря",
	["Crusader's Spire"] = "Вершина Рыцаря",
	["Crusaders' Square"] = "Площадь рыцарей",
	Crushblow = "Тукмак",
	["Crushcog's Arsenal"] = "Арсенал Шестерямстера",
	["Crushridge Hold"] = "Логово Раздробленного Хребта",
	Crypt = "Склеп",
	["Crypt of Forgotten Kings"] = "Гробница Забытых Королей",
	["Crypt of Remembrance"] = "Склеп Воспоминаний",
	["Crystal Lake"] = "Озеро Хрустальное",
	["Crystalline Quarry"] = "Кристальный карьер",
	["Crystalsong Forest"] = "Лес Хрустальной Песни",
	["Crystal Spine"] = "Хрустальное поле",
	["Crystalvein Mine"] = "Хрустальная шахта",
	["Crystalweb Cavern"] = "Пещера Хрустальной Паутины",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "Диковины и редкости",
	["Cursed Depths"] = "Проклятые глубины",
	["Cursed Hollow"] = "Окаянная лощина",
	["Cut-Throat Alley"] = "Закоулок Головорезов",
	["Cyclone Summit"] = "Вершина Циклона",
	["Dabyrie's Farmstead"] = "Усадьба Дабири",
	["Daggercap Bay"] = "Бухта Кинжалов",
	["Daggerfen Village"] = "Деревня Остротопь",
	["Dagger in the Dark"] = "Кинжал во тьме",
	["Daggermaw Canyon"] = "Каньон Кинжальной Пасти",
	["Dagger Pass"] = "Перевал Клинка",
	["Dais of Conquerors"] = "Круг Завоевателей",
	Dalaran = "Даларан",
	["Dalaran Arena"] = "Арена Даларана",
	["Dalaran City"] = "Даларан",
	["Dalaran Crater"] = "Даларанский кратер",
	["Dalaran Floating Rocks"] = "Даларанские парящие камни",
	["Dalaran Island"] = "Остров Даларан",
	["Dalaran Merchant's Bank"] = "Даларанский торговый банк",
	["Dalaran Sewers"] = "Стоки Даларана",
	["Dalaran Visitor Center"] = "Гостевые покои Даларана",
	["Dalson's Farm"] = "Ферма Далсона",
	["Damplight Cavern"] = "Грот Затуманенного Света",
	["Damplight Chamber"] = "Грот Затуманенного Света",
	["Dampsoil Burrow"] = "Логово Сыроземья",
	["Dandred's Fold"] = "Овчарня Дандреда",
	["Dargath's Demise"] = "Погибель Даргата",
	["Darkbreak Cove"] = "Темная пещера",
	["Darkcloud Pinnacle"] = "Пик Темного Облака",
	["Darkcrest Enclave"] = "Анклав Темного Гребня",
	["Darkcrest Shore"] = "Побережье Темного Гребня",
	["Dark Heart of Pandaria"] = "Темное сердце Пандарии",
	["Dark Iron Highway"] = "Тракт Черного Железа",
	["Darkmist Cavern"] = "Мглистая пещера",
	["Darkmist Ruins"] = "Руины Мглистой пещеры",
	["Darkmoon Boardwalk"] = "Набережная ярмарки Новолуния",
	["Darkmoon Deathmatch"] = "Арена ярмарки Новолуния",
	["Darkmoon Deathmatch Pit (PH)"] = "Арена ярмарки Новолуния",
	["Darkmoon Faire"] = "Ярмарка Новолуния",
	["Darkmoon Island"] = "Остров Новолуния",
	["Darkmoon Island Cave"] = "Пещера Острова Новолуния",
	["Darkmoon Path"] = "Дорога ярмарки Новолуния",
	["Darkmoon Pavilion"] = "Павильон ярмарки Новолуния",
	Darkshire = "Темнолесье",
	["Darkshire Town Hall"] = "Ратуша Темнолесья",
	Darkshore = "Темные берега",
	["Darkspear Hold"] = "Крепость Черного Копья",
	["Darkspear Isle"] = "Остров Черного Копья",
	["Darkspear Shore"] = "Дюны Черного Копья",
	["Darkspear Strand"] = "Побережье Черного Копья",
	["Darkspear Training Grounds"] = "Тренировочная площадка Черного Копья",
	["Darkwhisper Gorge"] = "Теснина Зловещего Шепота",
	["Darkwhisper Pass"] = "Тропа Зловещего Шепота",
	["Darnassian Base Camp"] = "Лагерь дарнасских эльфов",
	Darnassus = "Дарнас",
	["Darrow Hill"] = "Холм Дарроу",
	["Darrowmere Lake"] = "Озеро Дарроумир",
	Darrowshire = "Дарроушир",
	["Darrowshire Hunting Grounds"] = "Охотничьи угодья Дарроушира",
	["Darsok's Outpost"] = "Лагерь Дарсока",
	["Dawnchaser Retreat"] = "Укрытие Искателей Зари",
	["Dawning Lane"] = "Рассветная улица",
	["Dawning Wood Catacombs"] = "Катакомбы Утреннего Леса",
	["Dawnrise Expedition"] = "Экспедиция Восхода Солнца",
	["Dawn's Blossom"] = "Цветущая Заря",
	["Dawnseeker Promontory"] = "Мыс Искателя Рассвета",
	["Dawnseeker's Promontory"] = "Мыс Искателя Рассвета",
	["Dawn's Reach"] = "Рассветный край",
	["Dawnstar Spire"] = "Башня Утренней Звезды",
	["Dawnstar Village"] = "Деревня Утренней Звезды",
	["Daxil's Dig"] = "Карьер Дакси",
	["D-Block"] = "Блок Д",
	["Deadeye Shore"] = "Взморье Мертвого Глаза",
	["Deadman's Crossing"] = "Перекресток Мертвеца",
	["Dead Man's Hole"] = "Нора Мертвеца",
	Deadmines = "Мертвые копи",
	["Deadtalker's Plateau"] = "Плато Говорящего с Мертвыми",
	["Deadwind Pass"] = "Перевал Мертвого Ветра",
	["Deadwind Ravine"] = "Овраг Мертвого Ветра",
	["Deadwood Village"] = "Деревня Мертвого Леса",
	["Deathbringer's Rise"] = "Подъем Смертоносного",
	["Death Cultist Base Camp"] = "Лагерь сектантов Смерти",
	["Deathforge Tower"] = "Башня Кузницы Смерти",
	Deathknell = "Похоронный Звон",
	["Deathmatch Pavilion"] = "Бойцовский павильон",
	Deatholme = "Смертхольм",
	["Death's Breach"] = "Разлом Смерти",
	["Death's Door"] = "Врата Смерти",
	["Death's Hand Encampment"] = "Лагерь Руки Смерти",
	["Deathspeaker's Watch"] = "Застава Вестника Смерти",
	["Death's Rise"] = "Уступ Смерти",
	["Death's Stand"] = "Стоянка Смерти",
	["Death's Step"] = "Ступени Смерти",
	["Death's Watch Waystation"] = "Лагерь стражей смерти",
	Deathwing = "Смертокрыл",
	["Deathwing's Fall"] = "Кратер Смертокрыла",
	["Deep Blue Observatory"] = "Глубоководная обсерватория",
	["Deep Elem Mine"] = "Серебряный рудник",
	["Deepfin Ridge"] = "Гряда Глубинных Плавников",
	Deepholm = "Подземье",
	["Deephome Ceiling"] = "Купол Подземья",
	["Deepmist Grotto"] = "Дымчатый грот",
	["Deeprun Tram"] = "Подземный поезд",
	["Deepwater Tavern"] = "Таверна Большая вода",
	["Deepwind Gorge"] = "Каньон Суровых Ветров",
	["Defense of the Alehouse"] = "Защита паба",
	["Defense Of The Ale House BG"] = "Defense Of The Ale House BG",
	["Defias Hideout"] = "Убежище Братства Справедливости",
	["Defiler's Den"] = "Логово Осквернителя",
	["D.E.H.T.A. Encampment"] = "Лагерь Д.Э.Г.О.Ж.",
	["Delete ME"] = "Удалите МЕНЯ",
	["Demon Fall Canyon"] = "Каньон Гибели Демона",
	["Demon Fall Ridge"] = "Гряда Гибели Демона",
	["Demont's Place"] = "Участок Демонта",
	["Den of Defiance"] = "Логово Непокорных",
	["Den of Dying"] = "Кельи Смерти",
	["Den of Haal'esh"] = "Логово Хаал'еш",
	["Den of Iniquity"] = "Логово Беззакония",
	["Den of Mortal Delights"] = "Приют Земных Наслаждений",
	["Den of Sorrow"] = "Логово Печали",
	["Den of Sseratus"] = "Нора Шшератуса",
	["Den of the Caller"] = "Зал Взывающего",
	["Den of the Devourer"] = "Логово Пожирателя",
	["Den of the Disciples"] = "Пещера учеников",
	["Den of the Unholy"] = "Убежище Нечистого",
	["Derelict Caravan"] = "Брошенный Караван",
	["Derelict Manor"] = "Заброшенное поместье",
	["Derelict Strand"] = "Обнажившееся дно",
	["Designer Island"] = "Остров Дизайнера",
	Desolace = "Пустоши",
	["Desolation Hold"] = "Крепость Отчаяния",
	["Detention Block"] = "Тюремный блок",
	["Development Land"] = "Зона разработчика",
	["Diamondhead River"] = "Река Алмазная",
	["Diamond Island"] = "Алмазный остров",
	["Dig One"] = "Первый раскоп",
	["Dig Three"] = "Третий раскоп",
	["Dig Two"] = "Второй раскоп",
	["Direforge Hill"] = "Зловещий холм",
	["Direhorn Post"] = "Застава Дикого Рога",
	["Dire Maul"] = "Забытый Город",
	["Dire Maul - Capital Gardens Entrance"] = "Забытый Город - Центральный сад",
	["Dire Maul - East"] = "Забытый город – восток",
	["Dire Maul - Gordok Commons Entrance"] = "Забытый Город - Палаты Гордока",
	["Dire Maul - North"] = "Забытый город – север",
	["Dire Maul - Warpwood Quarter Entrance"] = "Забытый Город - Квартал Криводревов",
	["Dire Maul - West"] = "Забытый город – запад",
	Diremoor = "Мрачные топи",
	["Dire Strait"] = "Зловещий пролив",
	["Disciple's Enclave"] = "Анклав Послушника",
	Docks = "Причал",
	["Dojani River"] = "Река Доцзян",
	Dolanaar = "Доланаар",
	["Dome Balrissa"] = "Купол Балрисса",
	["Domination Point"] = "Крепость Покорителей",
	["Donna's Kitty Shack"] = "Домик для кошки Донны",
	["DO NOT USE"] = "НЕ ИСПОЛЬЗУЕТСЯ",
	["Dookin' Grounds"] = "Дуковы поля",
	["Doom's Vigil"] = "Застава Судьбы",
	["Dorian's Outpost"] = "Форпост Дориана",
	["Draco'dar"] = "Драко'дар",
	["Draenei Ruins"] = "Дренейские руины",
	["Draenethyst Mine"] = "Дренетистовые копи",
	["Draenil'dur Village"] = "Деревня Дренил'дур",
	Dragonblight = "Драконий Погост",
	["Dragonflayer Pens"] = "Стойла укрощенных драконов",
	["Dragonmaw Base Camp"] = "Лагерь Драконьей Пасти",
	["Dragonmaw Flag Room"] = "Флаговая комната Драконьей Пасти",
	["Dragonmaw Forge"] = "Кузница Драконьей Пасти",
	["Dragonmaw Fortress"] = "Крепость Драконьей Пасти",
	["Dragonmaw Garrison"] = "Гарнизон Драконьей Пасти",
	["Dragonmaw Gates"] = "Врата Драконьей Пасти",
	["Dragonmaw Pass"] = "Тропа Драконьей Пасти",
	["Dragonmaw Port"] = "Порт Драконьей Пасти",
	["Dragonmaw Skyway"] = "Заоблачная тропа Драконьей Пасти",
	["Dragonmaw Stronghold"] = "Форт Драконьей Пасти",
	["Dragons' End"] = "Драконья Пагуба",
	["Dragon's Fall"] = "Драконья погибель",
	["Dragon's Mouth"] = "Драконья Пасть",
	["Dragon Soul"] = "Душа Дракона",
	["Dragon Soul Raid - East Sarlac"] = "Рейд Душа Дракона - Восточный сарлак",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "Рейд Душа Дракона - Храм Драконьего Покоя",
	["Dragonspine Peaks"] = "Драконьи пики",
	["Dragonspine Ridge"] = "Драконий хребет",
	["Dragonspine Tributary"] = "Кладовая Драконьего Хребта",
	["Dragonspire Hall"] = "Зал Драконов",
	["Drak'Agal"] = "Драк'Агал",
	["Draka's Fury"] = "Ярость Дреки",
	["Drak'atal Passage"] = "Перевал Драк'атала",
	["Drakil'jin Ruins"] = "Руины Дракил'джин",
	["Drak'Mabwa"] = "Драк'Мабва",
	["Drak'Mar Lake"] = "Озеро Драк'Мар",
	["Draknid Lair"] = "Логово Дракнида",
	["Drak'Sotra"] = "Драк'Сотра",
	["Drak'Sotra Fields"] = "Поля Драк'Сотры",
	["Drak'Tharon Keep"] = "Крепость Драк'Тарон",
	["Drak'Tharon Keep Entrance"] = "Крепость Драк'Тарон",
	["Drak'Tharon Overlook"] = "Дозорное укрепление Драк'Тарона",
	["Drak'ural"] = "Драк'урал",
	["Dread Clutch"] = "Обитель Ужаса",
	["Dread Expanse"] = "Жуткая Пучина",
	["Dreadmaul Furnace"] = "Горн Молота Ужаса",
	["Dreadmaul Hold"] = "Форт Молота Ужаса",
	["Dreadmaul Post"] = "Стоянка Молота Ужаса",
	["Dreadmaul Rock"] = "Скала Молота Ужаса",
	["Dreadmist Camp"] = "Лагерь Багрового Тумана",
	["Dreadmist Den"] = "Пещера Багрового Тумана",
	["Dreadmist Peak"] = "Вершина Багрового Тумана",
	["Dreadmurk Shore"] = "Зловещий берег",
	["Dread Terrace"] = "Терраса Ужаса",
	["Dread Wastes"] = "Жуткие пустоши",
	["Dreadwatch Outpost"] = "Зловещая застава",
	["Dream Bough"] = "Сонные Ветви",
	["Dreamer's Pavilion"] = "Павильон Мечтателя",
	["Dreamer's Rest"] = "Покои Дремлющего",
	["Dreamer's Rock"] = "Скала Дремлющего",
	Drudgetown = "Рабочий квартал",
	["Drygulch Ravine"] = "Сухая лощина",
	["Drywhisker Gorge"] = "Теснина Сухоусов",
	["Dubra'Jin"] = "Дубра'джин",
	["Dun Algaz"] = "Дун Альгаз",
	["Dun Argol"] = "Дун Аргол",
	["Dun Baldar"] = "Дун Болдар",
	["Dun Baldar Pass"] = "Перевал Дун Болдар",
	["Dun Baldar Tunnel"] = "Туннель Дун Болдар",
	["Dunemaul Compound"] = "Поселение Песчаного Молота",
	["Dunemaul Recruitment Camp"] = "Вербовочный лагерь Песчаного Молота",
	["Dun Garok"] = "Дун Гарок",
	["Dun Mandarr"] = "Дун Мандарр",
	["Dun Modr"] = "Дун Модр",
	["Dun Morogh"] = "Дун Морог",
	["Dun Niffelem"] = "Дун Ниффелем",
	["Dunwald Holdout"] = "Укрытие Дунвальда",
	["Dunwald Hovel"] = "Склады Дунвальда",
	["Dunwald Market Row"] = "Рынок Дунвальда",
	["Dunwald Ruins"] = "Развалины Дунвальда",
	["Dunwald Town Square"] = "Городская площадь Дунвальда",
	["Durnholde Keep"] = "Крепость Дарнхольд",
	Durotar = "Дуротар",
	Duskhaven = "Темная Гавань",
	["Duskhowl Den"] = "Логово Ночного Воя",
	["Dusklight Bridge"] = "Мост Тусклого Света",
	["Dusklight Hollow"] = "Ложбина Тусклого Света",
	["Duskmist Shore"] = "Берег Вечернего Тумана",
	["Duskroot Fen"] = "Топь Темного Корня",
	["Duskwither Grounds"] = "Земли Блеклых Сумерек",
	["Duskwither Spire"] = "Замок Блеклых Сумерек",
	Duskwood = "Сумеречный лес",
	["Dustback Gorge"] = "Серое ущелье",
	["Dustbelch Grotto"] = "Грот Гнилобрюхих",
	["Dustfire Valley"] = "Выжженная долина",
	["Dustquill Ravine"] = "Лощина Пыльного Пера",
	["Dustwallow Bay"] = "Пылевая бухта",
	["Dustwallow Marsh"] = "Пылевые топи",
	["Dustwind Cave"] = "Пещера Пыльного Ветра",
	["Dustwind Dig"] = "Раскопки Пыльного Ветра",
	["Dustwind Gulch"] = "Лощина Пыльного Ветра",
	["Dwarven District"] = "Квартал Дворфов",
	["Eagle's Eye"] = "Орлиный глаз",
	["Earthshatter Cavern"] = "Пещера землекрушителя",
	["Earth Song Falls"] = "Поющие водопады",
	["Earth Song Gate"] = "Врата Поющих водопадов",
	["Eastern Bridge"] = "Восточный мост",
	["Eastern Kingdoms"] = "Восточные королевства",
	["Eastern Plaguelands"] = "Восточные Чумные земли",
	["Eastern Strand"] = "Восточное побережье",
	["East Garrison"] = "Восточный гарнизон",
	["Eastmoon Ruins"] = "Руины Восточной Луны",
	["East Pavilion"] = "Восточный павильон",
	["East Pillar"] = "Восточная колонна",
	["Eastpoint Tower"] = "Восточная башня",
	["East Sanctum"] = "Восточное святилище",
	["Eastspark Workshop"] = "Мастерская на востоке парка",
	["East Spire"] = "Восточный шпиль",
	["East Supply Caravan"] = "Восточный караван",
	["Eastvale Logging Camp"] = "Лесопилка Восточной долины",
	["Eastwall Gate"] = "Восточные ворота",
	["Eastwall Tower"] = "Восточная башня",
	["Eastwind Rest"] = "Приют Восточного Ветра",
	["Eastwind Shore"] = "Побережье Восточного Ветра",
	["Ebon Hold"] = "Черный оплот",
	["Ebon Watch"] = "Черная застава",
	["Echo Cove"] = "Бухта Эха",
	["Echo Isles"] = "Острова Эха",
	["Echomok Cavern"] = "Пещера Эхомок",
	["Echo Reach"] = "Край Эха",
	["Echo Ridge Mine"] = "Рудник Горного Эха",
	["Eclipse Point"] = "Лагерь Затмения",
	["Eclipsion Fields"] = "Поля Затмения",
	["Eco-Dome Farfield"] = "Заповедник Дальнее поле",
	["Eco-Dome Midrealm"] = "Заповедник Срединные земли",
	["Eco-Dome Skyperch"] = "Заповедник Высь",
	["Eco-Dome Sutheron"] = "Заповедник Сатерон",
	["Elder Rise"] = "Вершина Старейшин",
	["Elders' Square"] = "Площадь Старейшин",
	["Eldreth Row"] = "Путь Элдрета",
	["Eldritch Heights"] = "Зловещая возвышенность",
	["Elemental Plateau"] = "Плато Стихий",
	["Elementium Depths"] = "Элементиевые глубины",
	Elevator = "Подъемник",
	["Elrendar Crossing"] = "Перекресток Элрендар",
	["Elrendar Falls"] = "Водопад Элрендар",
	["Elrendar River"] = "Река Элрендар",
	["Elwynn Forest"] = "Элвиннский лес",
	["Ember Clutch"] = "Пылающее Гнездовье",
	Emberglade = "Тлеющая поляна",
	["Ember Spear Tower"] = "Тлеющая башня",
	["Emberstone Mine"] = "Шахта Тлеющего Угля",
	["Emberstone Village"] = "Деревня Тлеющего Угля",
	["Emberstrife's Den"] = "Логово Огнебора",
	["Emerald Dragonshrine"] = "Изумрудное святилище драконов",
	["Emerald Dream"] = "Изумрудный Сон",
	["Emerald Forest"] = "Изумрудный лес",
	["Emerald Sanctuary"] = "Изумрудное святилище",
	["Emperor Rikktik's Rest"] = "Гробница императора Рикктика",
	["Emperor's Omen"] = "Знамение Императора",
	["Emperor's Reach"] = "Крыло императора",
	["End Time"] = "Конец Времен",
	["Engineering Labs"] = "Инженерные лаборатории",
	["Engineering Labs "] = "Инженерные лаборатории",
	["Engine of Nalak'sha"] = "Двигатель Налак'ша",
	["Engine of the Makers"] = "Машина Творцов",
	["Entryway of Time"] = "Врата Времени",
	["Ethel Rethor"] = "Этель-Ретор",
	["Ethereal Corridor"] = "Коридор эфириалов",
	["Ethereum Staging Grounds"] = "Испытательный полигон Эфириума",
	["Evergreen Trading Post"] = "Торговая лавка Вечнозеленого леса",
	Evergrove = "Вечная роща",
	Everlook = "Круговзор",
	["Eversong - Duskwither Teleport"] = "Вечная Песня - телепорт Блеклых Сумерек",
	["Eversong Woods"] = "Леса Вечной Песни",
	["Excavation Center"] = "Центральный раскоп",
	["Excavation Lift"] = "Подъемник у раскопок",
	["Exclamation Point"] = "Место вскрика",
	["Expedition Armory"] = "Оружейная Экспедиция",
	["Expedition Base Camp"] = "Главный лагерь экспедиции",
	["Expedition Point"] = "Лагерь экспедиции",
	["Explorers' League Digsite"] = "Раскопки Лиги исследователей",
	["Explorers' League Outpost"] = "Лагерь Лиги исследователей",
	["Exposition Pavilion"] = "Выставочный павильон",
	["Eye of Eternity"] = "Око Вечности",
	["Eye of the Storm"] = "Око Бури",
	["Fairbreeze Village"] = "Деревня Легкий Ветерок",
	["Fairbridge Strand"] = "Берег у Крепкого моста",
	["Falcon Watch"] = "Соколиный Дозор",
	["Falconwing Inn"] = "Таверна Соколиных Крыльев",
	["Falconwing Square"] = "Площадь Соколиных Крыльев",
	["Faldir's Cove"] = "Бухта Фальдира",
	["Falfarren River"] = "Река Фалфаррен",
	["Fallen Sky Lake"] = "Зеркало Небес",
	["Fallen Sky Ridge"] = "Гряда Упавшего Неба",
	["Fallen Temple of Ahn'kahet"] = "Павший храм Ан'кахета",
	["Fall of Return"] = "Пропасть Возвращения",
	["Fallowmere Inn"] = "Таверна Болотной Пахоты",
	["Fallow Sanctuary"] = "Болотное пристанище",
	["Falls of Ymiron"] = "Водопады Имирона",
	["Fallsong Village"] = "Деревня Поющего Водопада",
	["Falthrien Academy"] = "Академия Фалтриена",
	Familiars = "Нечистое",
	["Faol's Rest"] = "Могила Фаола",
	["Fargaze Mesa"] = "Плато Востроглазой",
	["Fargodeep Mine"] = "Рудник Подземных Глубин",
	Farm = "Ферма",
	Farshire = "Далечье",
	["Farshire Fields"] = "Поля Далечья",
	["Farshire Lighthouse"] = "Маяк Далечья",
	["Farshire Mine"] = "Шахта Далечья",
	["Farson Hold"] = "Крепость Фарсона",
	["Farstrider Enclave"] = "Анклав Странников",
	["Farstrider Lodge"] = "Приют Странников",
	["Farstrider Retreat"] = "Обитель Странников",
	["Farstriders' Enclave"] = "Анклав Странников",
	["Farstriders' Square"] = "Площадь Странников",
	["Farwatcher's Glen"] = "Плато Наблюдателей",
	["Farwatch Overlook"] = "Наблюдательный пункт",
	["Far Watch Post"] = "Дальняя застава",
	["Fear Clutch"] = "Обитель Страха",
	["Featherbeard's Hovel"] = "Домик Пероборода",
	Feathermoon = "Крепость Оперенной Луны",
	["Feathermoon Stronghold"] = "Крепость Оперенной Луны",
	["Fe-Feng Village"] = "Деревня Фэ-Фан",
	["Felfire Hill"] = "Холм Демонического Огня",
	["Felpaw Village"] = "Деревня Сквернолапов",
	["Fel Reaver Ruins"] = "Обломки Сквернобота",
	["Fel Rock"] = "Пещера Бесов",
	["Felspark Ravine"] = "Лощина Вспышки Скверны",
	["Felstone Field"] = "Поле Джанис",
	Felwood = "Оскверненный лес",
	["Fenris Isle"] = "Остров Фенриса",
	["Fenris Keep"] = "Крепость Фенриса",
	Feralas = "Фералас",
	["Feralfen Village"] = "Деревня Дикотопь",
	["Feral Scar Vale"] = "Долина Свирепого Утеса",
	["Festering Pools"] = "Гнойные пруды",
	["Festival Lane"] = "Праздничная улица",
	["Feth's Way"] = "Путь Фета",
	["Field of Korja"] = "Прогалина Корцзя",
	["Field of Strife"] = "Поле брани",
	["Fields of Blood"] = "Кровавые поля",
	["Fields of Honor"] = "Поля Славы",
	["Fields of Niuzao"] = "Поля Нюцзао",
	Filming = "Съемочная площадка",
	["Final Gate - Mogu Island Progression Scenario"] = "Final Gate - Mogu Island Progression Scenario",
	["Firebeard Cemetery"] = "Кладбище Огнебородов",
	["Firebeard's Patrol"] = "Дозор Огнебородов",
	["Firebough Nook"] = "Убежище Огненной Ветви",
	["Fire Camp Bataar"] = "Огненный лагерь Батаар",
	["Fire Camp Gai-Cho"] = "Огненный лагерь Гай-Чо",
	["Fire Camp Ordo"] = "Огненный лагерь Ордо",
	["Fire Camp Osul"] = "Огненный лагерь осулов",
	["Fire Camp Ruqin"] = "Огненный лагерь Жу-Цзинь",
	["Fire Camp Yongqi"] = "Огненный лагерь Юнци",
	["Firegut Furnace"] = "Очаг Огненного Чрева",
	Firelands = "Огненные Просторы",
	["Firelands Forgeworks"] = "Кузня Огненных Просторов",
	["Firelands Hatchery"] = "Инкубатор Огненных Просторов",
	["Firelands Terrain 2"] = "Рельеф Огненных Просторов",
	["Fireplume Peak"] = "Пик Огненного Венца",
	["Fire Plume Ridge"] = "Вулкан Огненного Венца",
	["Fireplume Trench"] = "Вулкан Огненного Венца",
	["Fire Scar Shrine"] = "Святилище Огненной Расщелины",
	["Fire Stone Mesa"] = "Плато Огненного Камня",
	["Firestone Point"] = "Кремневый лагерь",
	["Firewatch Ridge"] = "Гряда Огненной стражи",
	["Firewing Point"] = "Лагерь Огнекрылов",
	["First Bank of Kezan"] = "Первый банк Кезана",
	["First Legion Forward Camp"] = "Лагерь сопротивления первого легиона",
	["First to Your Aid"] = "Спешим на помощь",
	["Fishing Village"] = "Рыбацкий поселок",
	["Fizzcrank Airstrip"] = "Взлетная полоса Выкрутеня",
	["Fizzcrank Pumping Station"] = "Насосная станция Выкрутеня",
	["Fizzle & Pozzik's Speedbarge"] = "Гоночная баржа Пшикса и Поззика",
	["Fjorn's Anvil"] = "Наковальня Фьорна",
	Flamebreach = "Огненный портал",
	["Flame Crest"] = "Пламенеющий Стяг",
	["Flamestar Post"] = "Лагерь Пламени Звезд",
	["Flamewatch Tower"] = "Башня Огненного Дозора",
	["Flavor - Stormwind Harbor - Stop"] = "Flavor - Stormwind Harbor - Stop",
	["Fleshrender's Workshop"] = "Мастерская Плотереза",
	["Foothold Citadel"] = "Цитадель",
	["Footman's Armory"] = "Оружейная пехотинцев",
	["Force Interior"] = "Интерьер силы",
	["Fordragon Hold"] = "Крепость Фордрагона",
	["Forest Heart"] = "Сердце леса",
	["Forest's Edge"] = "Лесная опушка",
	["Forest's Edge Post"] = "Застава на опушке",
	["Forest Song"] = "Лесная Песнь",
	["Forge Base: Gehenna"] = "База Легиона: Геенна",
	["Forge Base: Oblivion"] = "База Легиона: Забвение",
	["Forge Camp: Anger"] = "Лагерь Легиона: Злоба",
	["Forge Camp: Fear"] = "Лагерь Легиона: Страх",
	["Forge Camp: Hate"] = "Лагерь Легиона: Ненависть",
	["Forge Camp: Mageddon"] = "Лагерь Легиона: Магеддон",
	["Forge Camp: Rage"] = "Лагерь Легиона: Ярость",
	["Forge Camp: Terror"] = "Лагерь Легиона: Ужас",
	["Forge Camp: Wrath"] = "Лагерь Легиона: Гнев",
	["Forge of Fate"] = "Кузня судьбы",
	["Forge of the Endless"] = "Кузня Бесконечности",
	["Forgewright's Tomb"] = "Гробница Искусника",
	["Forgotten Depths"] = "Забытые глубины",
	["Forgotten Hill"] = "Забытый холм",
	["Forgotten Mire"] = "Позабытая трясина",
	["Forgotten Passageway"] = "Забытый ход",
	["Forlorn Cloister"] = "Покинутый двор",
	["Forlorn Hut"] = "Одинокая хижина",
	["Forlorn Ridge"] = "Одинокая вершина",
	["Forlorn Rowe"] = "Покинутая усадьба",
	["Forlorn Spire"] = "Одинокая башня",
	["Forlorn Woods"] = "Опустевшие леса",
	["Formation Grounds"] = "Плац",
	["Forsaken Forward Command"] = "Передовой отряд Отрекшихся",
	["Forsaken High Command"] = "Ставка Отрекшихся",
	["Forsaken Rear Guard"] = "Арьергард Отрекшихся",
	["Fort Livingston"] = "Форт Ливингстон",
	["Fort Silverback"] = "Крепость Седоспинов",
	["Fort Triumph"] = "Форт Триумфа",
	["Fortune's Fist"] = "Рука Судьбы",
	["Fort Wildervar"] = "Крепость Вилдервар",
	["Forward Assault Camp"] = "Передовые укрепления",
	["Forward Command"] = "Передовая ставка",
	["Foulspore Cavern"] = "Зловонная пещера",
	["Foulspore Pools"] = "Зловонные пруды",
	["Fountain of the Everseeing"] = "Фонтан Всевидения",
	["Fox Grove"] = "Лисья роща",
	["Fractured Front"] = "Разбитая передовая",
	["Frayfeather Highlands"] = "Высокогорье Блеклых Перьев",
	["Fray Island"] = "Остров Битв",
	["Frazzlecraz Motherlode"] = "Шахтерский городок Дранфикса",
	["Freewind Post"] = "Застава Вольного Ветра",
	["Frenzyheart Hill"] = "Холм Бешеного Сердца",
	["Frenzyheart River"] = "Река Бешеного Сердца",
	["Frigid Breach"] = "Хладный разлом",
	["Frostblade Pass"] = "Перевал Ледяного Клинка",
	["Frostblade Peak"] = "Вершина Ледяного Клинка",
	["Frostclaw Den"] = "Логово Ледяного Когтя",
	["Frost Dagger Pass"] = "Перевал Ледяного Клинка",
	["Frostfield Lake"] = "Промерзшее озеро",
	["Frostfire Hot Springs"] = "Источники Ледяного огня",
	["Frostfloe Deep"] = "Ледяные глубины",
	["Frostgrip's Hollow"] = "Пещера Ледохвата",
	Frosthold = "Ледяная крепость",
	["Frosthowl Cavern"] = "Пещера Ледяного Воя",
	["Frostmane Front"] = "Передовая Мерзлогривов",
	["Frostmane Hold"] = "Форт Мерзлогривов",
	["Frostmane Hovel"] = "Пещера Мерзлогривов",
	["Frostmane Retreat"] = "Укрытие Мерзлогривов",
	Frostmourne = "Ледяная Скорбь",
	["Frostmourne Cavern"] = "Пещера Ледяной Скорби",
	["Frostsaber Rock"] = "Уступ Ледопардов",
	["Frostwhisper Gorge"] = "Теснина Ледяного Шепота",
	["Frostwing Halls"] = "Залы Ледокрылых",
	["Frostwolf Graveyard"] = "Кладбище Северного Волка",
	["Frostwolf Keep"] = "Крепость Северного Волка",
	["Frostwolf Pass"] = "Перевал Северного Волка",
	["Frostwolf Tunnel"] = "Туннель Северного Волка",
	["Frostwolf Village"] = "Деревня Северного Волка",
	["Frozen Reach"] = "Студеный предел",
	["Fungal Deep"] = "Грибные Глубины",
	["Fungal Rock"] = "Пещера Лишайников",
	["Funggor Cavern"] = "Пещера Грибгор",
	["Furien's Post"] = "Пост Фуриена",
	["Furlbrow's Pumpkin Farm"] = "Тыквенная ферма Хмуроброва",
	["Furnace of Hate"] = "Горнило Ненависти",
	["Furywing's Perch"] = "Гнездовье Ярокрыла",
	Fuselight = "Фюзель",
	["Fuselight-by-the-Sea"] = "Фюзель-на-водах",
	["Fu's Pond"] = "Пруд Фу",
	Gadgetzan = "Прибамбасск",
	["Gahrron's Withering"] = "Пустошь Гаррона",
	["Gai-Cho Battlefield"] = "Поле битвы Гай-Чо",
	["Galak Hold"] = "Форт Галак",
	["Galakrond's Rest"] = "Покой Галакронда",
	["Galardell Valley"] = "Долина Галарделл",
	["Galen's Fall"] = "Удел Галена",
	["Galerek's Remorse"] = "Раскаяние Галерека",
	["Galewatch Lighthouse"] = "Штормовой маяк",
	["Gallery of Treasures"] = "Сокровищница",
	["Gallows' Corner"] = "Перекресток Висельников",
	["Gallows' End Tavern"] = "Таверна Петля висельника",
	["Gallywix Docks"] = "Верфь Галливикса",
	["Gallywix Labor Mine"] = "Исправительная шахта Галливикса",
	["Gallywix Pleasure Palace"] = "Дворец удовольствий Галливикса",
	["Gallywix's Villa"] = "Вилла Галливикса",
	["Gallywix's Yacht"] = "Яхта Галливикса",
	["Galus' Chamber"] = "Зал Галия",
	["Gamesman's Hall"] = "Игровой зал",
	Gammoth = "Гаммот",
	["Gao-Ran Battlefront"] = "Застава Гао-Жаня",
	Garadar = "Гарадар",
	["Gar'gol's Hovel"] = "Схрон Гар'гола",
	Garm = "Гарм",
	["Garm's Bane"] = "Побоище Гарма",
	["Garm's Rise"] = "Подъем Гарма",
	["Garren's Haunt"] = "Ферма Гаррена",
	["Garrison Armory"] = "Мастерские Гарнизона",
	["Garrosh'ar Advance"] = "Передовая Гаррош'ар",
	["Garrosh'ar Point"] = "Лагерь Гаррош'ар",
	["Garrosh's Landing"] = "Лагерь Гарроша",
	["Garvan's Reef"] = "Риф Гарвана",
	["Gate of Echoes"] = "Врата эха",
	["Gate of Endless Spring"] = "Врата Вечной Весны",
	["Gate of Hamatep"] = "Врата Хаматепа",
	["Gate of Lightning"] = "Врата молнии",
	["Gate of the August Celestials"] = "Врата Августейших Небожителей",
	["Gate of the Blue Sapphire"] = "Врата Синего Сапфира",
	["Gate of the Green Emerald"] = "Врата Зеленого Изумруда",
	["Gate of the Purple Amethyst"] = "Врата Лилового Аметиста",
	["Gate of the Red Sun"] = "Врата Красного Солнца",
	["Gate of the Setting Sun"] = "Врата Заходящего Солнца",
	["Gate of the Yellow Moon"] = "Врата Желтой Луны",
	["Gates of Ahn'Qiraj"] = "Врата Ан'Киража",
	["Gates of Ironforge"] = "Врата Стальгорна",
	["Gates of Sothann"] = "Врата Созанна",
	["Gauntlet of Flame"] = "Испытание Огнем",
	["Gavin's Naze"] = "Возвышенность Гэвина",
	["Geezle's Camp"] = "Лагерь Гизла",
	["Gelkis Village"] = "Деревня Гелкис",
	["General Goods"] = "Потребительские товары",
	["General's Terrace"] = "Терраса Генерала",
	["Ghostblade Post"] = "Застава Призрачного Клинка",
	Ghostlands = "Призрачные земли",
	["Ghost Walker Post"] = "Застава Скитающихся Духов",
	["Giant's Run"] = "Тропа великанов",
	["Giants' Run"] = "Тропа Великанов",
	["Gilded Fan"] = "Золоченый Веер",
	["Gillijim's Isle"] = "Остров Гиллиджима",
	["Gilnean Coast"] = "Побережье Гилнеаса",
	["Gilnean Stronghold"] = "Гилнеасский лагерь",
	Gilneas = "Гилнеас",
	Gilneas2 = "Гилнеас",
	["Gilneas City"] = "Гилнеас",
	["Gilneas (Do Not Reuse)"] = "Гилнеас",
	["Gilneas Liberation Front Base Camp"] = "Лагерь фронта освобождения Гилнеаса",
	GilneasPhase1 = "GilneasPhase1",
	GilneasPhase2 = "GilneasPhase2",
	["Gimorak's Den"] = "Логово Гиморака",
	Gjalerbron = "Гьялерброн",
	Gjalerhorn = "Гьялерхорн",
	["Glacial Falls"] = "Ледопады",
	["Glimmer Bay"] = "Мерцающая бухта",
	["Glimmerdeep Gorge"] = "Теснина Мерцающих Глубин",
	["Glittering Strand"] = "Сверкающее взморье",
	["Glopgut's Hollow"] = "Ложбина клана Помойных Потрохов",
	["Glorious Goods"] = "Великолепные товары",
	Glory = "Слава",
	["GM Island"] = "Остров ГМ",
	["Gnarlpine Hold"] = "Лагерь у Кривой Сосны",
	["Gnaws' Boneyard"] = "Двор Костеглода",
	Gnomeregan = "Гномреган",
	["Gobline Mine"] = "Рудник гоблинов",
	["Goblin Foundry"] = "Гоблинский цех",
	["Goblin Mine"] = "Рудник гоблинов",
	["Goblin Slums"] = "Гоблинские трущобы",
	["Gokk'lok's Grotto"] = "Грот Гокк'лок",
	["Gokk'lok Shallows"] = "Отмели Гокк'лок",
	["Golakka Hot Springs"] = "Горячие источники Голакка",
	["Gol'Bolar Quarry"] = "Карьер Гол'Болар",
	["Gol'Bolar Quarry Mine"] = "Карьер Гол'Болар",
	["Gold Coast Quarry"] = "Прииск на Золотом Берегу",
	["Goldenbough Pass"] = "Тропа Золотой Ветви",
	["Goldenmist Village"] = "Деревня Золотистой Дымки",
	["Golden Strand"] = "Золотистое взморье",
	["Gold Mine"] = "Золотой рудник",
	["Gold Road"] = "Золотой Путь",
	["Gold Rush BG"] = "Gold Rush BG",
	Goldshire = "Златоземье",
	["Goldtooth's Den"] = "Берлога Фикса",
	["Goodgrub Smoking Pit"] = "Коптильня Скороцапа",
	["Gordok's Seat"] = "Трон Гордока",
	["Gordunni Outpost"] = "Поселение Гордунни",
	["Gorefiend's Vigil"] = "Пост Кровожада",
	["Gor'gaz Outpost"] = "Форт Гор'газ",
	Gornia = "Горния",
	["Gorrok's Lament"] = "Курган Горрока",
	["Gorshak War Camp"] = "Военный лагерь Горшака",
	["Go'Shek Farm"] = "Ферма Го'Шека",
	["Grain Cellar"] = "Зерновой амбар",
	["Grand Courtyard"] = "Большой внутренний двор",
	["Grand Magister's Asylum"] = "Пристанище Великого Магистра",
	["Grand Overlook"] = "Наблюдательная площадка",
	["Grand Promenade"] = "Центральная аллея",
	["Grangol'var Village"] = "Деревня Грангол'вар",
	["Granite Springs"] = "Гранитные ключи",
	["Grassy Cline"] = "Травянистый склон",
	["Greatwood Vale"] = "Долина Высокого леса",
	["Greengill Coast"] = "Залив Зеленожабрых",
	["Greenpaw Village"] = "Деревня Зеленой Лапы",
	["Greenstone Dojo"] = "Додзё Зеленой Скалы",
	["Greenstone Inn"] = "Таверна Зеленой Скалы",
	["Greenstone Masons' Quarter"] = "Поселок Каменщиков Зеленой Скалы",
	["Greenstone Quarry"] = "Каменоломня Зеленой Скалы",
	["Greenstone Village"] = "Деревня Зеленой Скалы",
	["Greenwarden's Grove"] = "Роща Стража Природы",
	["Greymane Court"] = "Площадь Седогрива",
	["Greymane Manor"] = "Поместье Седогрива",
	["Greymist Firth"] = "Бухта Серой Мглы",
	["Grim Batol"] = "Грим Батол",
	["Grim Batol Entrance"] = "Грим Батол",
	["Grimesilt Dig Site"] = "Карьер Грязнули",
	["Grimtotem Compound"] = "Лагерь Зловещего Тотема",
	["Grimtotem Post"] = "Застава Зловещего Тотема",
	Grishnath = "Гришнат",
	Grizzlemaw = "Седая Пасть",
	["Grizzlepaw Ridge"] = "Хребет Седых Лап",
	["Grizzly Hills"] = "Седые холмы",
	["Grol'dom Farm"] = "Ферма Гроль'дома",
	["Grolluk's Grave"] = "Могила Гроллука",
	["Grom'arsh Crash-Site"] = "Место крушения Гром'арша",
	["Grom'gol"] = "Гром'гол",
	["Grom'gol Base Camp"] = "Лагерь Гром'гол",
	["Grommash Hold"] = "Крепость Громмаш",
	["Grookin Hill"] = "Холм Грукин",
	["Grosh'gok Compound"] = "Поселок Грош'гок",
	["Grove of Aessina"] = "Роща Эссины",
	["Grove of Falling Blossoms"] = "Роща Опадающих Лепестков",
	["Grove of the Ancients"] = "Роща Древних",
	["Growless Cave"] = "Промерзшая пещера",
	["Gruul's Lair"] = "Логово Груула",
	["Gryphon Roost"] = "Грифоний насест",
	["Guardian's Library"] = "Библиотека Стража",
	Gundrak = "Гундрак",
	["Gundrak Entrance"] = "Гундрак",
	["Gunstan's Dig"] = "Раскопки Ганстена",
	["Gunstan's Post"] = "Застава Ганстена",
	["Gunther's Retreat"] = "Приют Гюнтера",
	["Guo-Lai Halls"] = "Залы Го-Лай",
	["Guo-Lai Ritual Chamber"] = "Ритуальный зал Го-Лай",
	["Guo-Lai Vault"] = "Сокровищница Го-Лай",
	["Gurboggle's Ledge"] = "Шельф Гурбоггла",
	["Gurubashi Arena"] = "Арена Гурубаши",
	["Gyro-Plank Bridge"] = "Гиро-балочный мост",
	["Haal'eshi Gorge"] = "Теснина Хаал'еши",
	["Hadronox's Lair"] = "Логово Хадронокса",
	["Hailwood Marsh"] = "Хейлвудская трясина",
	Halaa = "Халаа",
	["Halaani Basin"] = "Котловина Халаани",
	["Halcyon Egress"] = "Предел Безмятежности",
	["Haldarr Encampment"] = "Лагерь Халдарр",
	Halfhill = "Полугорье",
	Halgrind = "Халгринд",
	["Hall of Arms"] = "Оружейная",
	["Hall of Binding"] = "Зал Оков",
	["Hall of Blackhand"] = "Зал Чернорука",
	["Hall of Blades"] = "Зал Лезвий",
	["Hall of Bones"] = "Зал Костей",
	["Hall of Champions"] = "Чертог Защитников",
	["Hall of Command"] = "Зал Власти",
	["Hall of Crafting"] = "Зал Ремесла",
	["Hall of Departure"] = "Зал Расставания",
	["Hall of Explorers"] = "Зал Исследователей",
	["Hall of Faces"] = "Зал Ликов",
	["Hall of Horrors"] = "Зал Ужасов",
	["Hall of Illusions"] = "Зал иллюзий",
	["Hall of Kings"] = "Зал Королей",
	["Hall of Legends"] = "Зал Легенд",
	["Hall of Masks"] = "Зал Масок",
	["Hall of Memories"] = "Зал Воспоминаний",
	["Hall of Mysteries"] = "Зал Тайн",
	["Hall of Repose"] = "Зал Спокойствия",
	["Hall of Return"] = "Зал Возвращения",
	["Hall of Ritual"] = "Ритуальный зал",
	["Hall of Secrets"] = "Зал Тайн",
	["Hall of Serpents"] = "Зал Змей",
	["Hall of Shapers"] = "Зал Творцов",
	["Hall of Stasis"] = "Зал Покоя",
	["Hall of the Brave"] = "Зал Отважных",
	["Hall of the Conquered Kings"] = "Зал побежденных королей",
	["Hall of the Crafters"] = "Зал Ремесленников",
	["Hall of the Crescent Moon"] = "Зал Полумесяца",
	["Hall of the Crusade"] = "Зал ордена",
	["Hall of the Cursed"] = "Зал Проклятых",
	["Hall of the Damned"] = "Зал Проклятых",
	["Hall of the Defamed"] = "Зал Обесславленных",
	["Hall of the Exalted"] = "Зал Превознесения",
	["Hall of the Fathers"] = "Зал Отцов",
	["Hall of the Frostwolf"] = "Зал Северного Волка",
	["Hall of the Grand Imperion"] = "Зал Великого Правителя",
	["Hall of the High Father"] = "Зал Высшего Прародителя",
	["Hall of the Keepers"] = "Зал Хранителей",
	["Hall of the Shaper"] = "Зал Творца",
	["Hall of the Stormpike"] = "Зал Грозовой Вершины",
	["Hall of the Tortured"] = "Зал Измученных",
	["Hall of the Watchers"] = "Зал Стражей",
	["Hall of the Wicked"] = "Зал Злобной Сущности",
	["Hall of Tombs"] = "Зал гробниц",
	["Hall of Tranquility"] = "Зал Спокойствия",
	["Hall of Tranquillity"] = "Зал Умиротворения",
	["Hall of Twilight"] = "Зал Сумерек",
	["Halls of Anguish"] = "Залы Страданий",
	["Halls of Awakening"] = "Залы Пробуждения",
	["Halls of Binding"] = "Залы Оков",
	["Halls of Destruction"] = "Гибельные залы",
	["Halls of Flesh-Shaping"] = "Залы Искажения Плоти",
	["Halls of Lightning"] = "Чертоги Молний",
	["Halls of Lightning Entrance"] = "Чертоги Молний",
	["Halls of Mourning"] = "Залы Плача",
	["Halls of Origination"] = "Чертоги Созидания",
	["Halls of Origination Entrance"] = "Чертоги Созидания",
	["Halls of Reflection"] = "Залы Отражений",
	["Halls of Reflection Entrance"] = "Залы Отражений",
	["Halls of Silence"] = "Залы Безмолвия",
	["Halls of Stone"] = "Чертоги Камня",
	["Halls of Stone Entrance"] = "Чертоги Камня",
	["Halls of Strife"] = "Залы Раздора",
	["Halls of the Ancestors"] = "Залы Предков",
	["Halls of the Hereafter"] = "Потусторонние залы",
	["Halls of the Law"] = "Галереи Правосудия",
	["Halls of Theory"] = "Залы Теории",
	["Halycon's Lair"] = "Логово Халикона",
	Hammerfall = "Павший Молот",
	["Hammertoe's Digsite"] = "Карьер Тяжелоступа",
	["Hammond Farmstead"] = "Ферма Хэммондов",
	Hangar = "Ангар",
	["Hardknuckle Clearing"] = "Зачистка барабанчей",
	["Hardwrench Hideaway"] = "Укрытие Кофельнагель",
	["Harkor's Camp"] = "Лагерь Харкора",
	["Hatchet Hills"] = "Холмы Томагавков",
	["Hatescale Burrow"] = "Логово клана Грозной Чешуи",
	["Hatred's Vice"] = "Хватка Ненависти",
	Havenshire = "Тихоземье",
	["Havenshire Farms"] = "Тихоземские фермы",
	["Havenshire Lumber Mill"] = "Тихоземская лесопилка",
	["Havenshire Mine"] = "Тихоземская шахта",
	["Havenshire Stables"] = "Тихоземские стойла",
	["Hayward Fishery"] = "Рыбное хозяйство Хейварда",
	["Headmaster's Retreat"] = "Покои наставника",
	["Headmaster's Study"] = "Кабинет ректора",
	Hearthglen = "Дольный Очаг",
	["Heart of Destruction"] = "Сердце Разрушения",
	["Heart of Fear"] = "Сердце Страха",
	["Heart of the Old God Scenario"] = "Сценарий - Сердце древнего бога",
	["Heart of Zan'vess"] = "Сердце Зан'весса",
	["Heart's Blood Shrine"] = "Святилище Кровавого Сердца",
	["Heartwood Trading Post"] = "Торговая лавка Чащи Леса",
	["Heb'Drakkar"] = "Хеб'Драккар",
	["Heb'Valok"] = "Хеб'Валок",
	["Hellfire Basin"] = "Яма Адского Пламени",
	["Hellfire Citadel"] = "Цитадель Адского Пламени",
	["Hellfire Citadel: Ramparts"] = "Цитадель Адского Пламени: Бастионы",
	["Hellfire Citadel - Ramparts Entrance"] = "Цитадель Адского Пламени: Бастионы Адского Пламени",
	["Hellfire Citadel: The Blood Furnace"] = "Цитадель Адского Пламени: Кузня Крови",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "Цитадель Адского Пламени: Кузня Крови",
	["Hellfire Citadel: The Shattered Halls"] = "Цитадель Адского Пламени: Разрушенные залы",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "Цитадель Адского Пламени: Разрушенные залы",
	["Hellfire Peninsula"] = "Полуостров Адского Пламени",
	["Hellfire Peninsula - Force Camp Beach Head"] = "Полуостров Адского Пламени - Береговой плацдарм Силового Лагеря",
	["Hellfire Peninsula - Reaver's Fall"] = "Полуостров Адского Пламени - Гибель Сквернобота",
	["Hellfire Ramparts"] = "Бастионы Адского Пламени",
	["Hellscream Arena"] = "Арена Адского Крика",
	["Hellscream's Camp"] = "Лагерь Адского Крика",
	["Hellscream's Fist"] = "Кулак Адского Крика",
	["Hellscream's Grasp"] = "Хватка Адского Крика",
	["Hellscream's Watch"] = "Дозор Адского Крика",
	["Helm's Bed Lake"] = "Озеро Хельмово Ложе",
	["Heroes' Vigil"] = "Часовые Вечности",
	["Hetaera's Clutch"] = "Гнездо Хетайры",
	["Hewn Bog"] = "Болотные вырубки",
	["Heyman's Hubris"] = "Спесь Хеймана",
	["Hibernal Cavern"] = "Пещера зимней спячки",
	["Hidden Cell"] = "Потайная темница",
	["Hidden Path"] = "Потайная тропа",
	Highbank = "Высокий берег",
	["High Bank"] = "Высокий берег",
	["Highland Forest"] = "Лес нагорья",
	Highperch = "Скальное гнездовье",
	["High Wilderness"] = "Высокогорные дебри",
	Hillsbrad = "Хилсбрад",
	["Hillsbrad Fields"] = "Хилсбрадские поля",
	["Hillsbrad Foothills"] = "Предгорья Хилсбрада",
	["Hiri'watha Research Station"] = "Исследовательская станция Хири'вата",
	["Hive'Ashi"] = "Улей Аши",
	["Hive'Regal"] = "Улей Регал",
	["Hive'Zora"] = "Улей Зора",
	["Hogger Hill"] = "Холм Дробителя",
	["Hollowed Out Tree"] = "Полое дерево",
	["Hollowstone Mine"] = "Рудник Полого Камня",
	["Honeydew Farm"] = "Ферма Медовой Росы",
	["Honeydew Glade"] = "Поляна Медовой Росы",
	["Honeydew Village"] = "Деревня Медовой Росы",
	["Honor Hold"] = "Оплот Чести",
	["Honor Hold Mine"] = "Копи Оплота Чести",
	["Honor Point"] = "Пик Чести",
	["Honor's Stand"] = "Застава Чести",
	["Honor's Tomb"] = "Гробница Доблести",
	["Horde Base Camp"] = "Главный лагерь Орды",
	["Horde Beach Daily Area"] = "База Орды на пляже - ежедневные задания",
	["Horde Encampment"] = "Стоянка Орды",
	["Horde Keep"] = "Крепость Орды",
	["Horde Landing"] = "Высадка Орды",
	["Horde Landing Site"] = "Точка высадки Орды",
	["Hordemar City"] = "Ордамар",
	["Horde PVP Barracks"] = "Казармы Орды",
	["Horror Clutch"] = "Обитель Кошмара",
	["Hour of Twilight"] = "Время Сумерек",
	["House of Edune"] = "Дом Эдьюнов",
	["Howling Fjord"] = "Ревущий фьорд",
	["Howlingwind Cavern"] = "Пещера Ревущего Ветра",
	["Howlingwind Trail"] = "Тропа Ревущего Ветра",
	["Howling Ziggurat"] = "Воющий зиккурат",
	["Hrothgar's Landing"] = "Лагерь Хротгара",
	["Huangtze Falls"] = "Водопады Хуаньцзы",
	["Hull of the Foebreaker"] = "Остов Крушителя Врагов",
	["Humboldt Conflagration"] = "Пожарище Гумбольдта",
	["Hunter Rise"] = "Вершина Охотников",
	["Hunter's Hill"] = "Охотничий холм",
	["Huntress of the Sun"] = "Солнечная Охотница",
	["Huntsman's Cloister"] = "Двор охотника",
	Hyjal = "Хиджал",
	["Hyjal Barrow Dens"] = "Кельи Хиджала",
	["Hyjal Past"] = "Прошлое Хиджала",
	["Hyjal Summit"] = "Вершина Хиджала",
	["Iceblood Garrison"] = "Гарнизон Стылой Крови",
	["Iceblood Graveyard"] = "Кладбище Стылой Крови",
	Icecrown = "Ледяная Корона",
	["Icecrown Citadel"] = "Цитадель Ледяной Короны",
	["Icecrown Dungeon - Gunships"] = "Ледяная Корона - боевой корабль",
	["Icecrown Glacier"] = "Ледник Ледяная Корона",
	["Iceflow Lake"] = "Заледеневшее озеро",
	["Ice Heart Cavern"] = "Пещера Ледяного Сердца",
	["Icemist Falls"] = "Водопады Ледяной Пыли",
	["Icemist Village"] = "Деревня Ледяной Пыли",
	["Ice Thistle Hills"] = "Холмы Ледополоха",
	["Icewing Bunker"] = "Укрытие Ледяного Крыла",
	["Icewing Cavern"] = "Пещера Ледяного Крыла",
	["Icewing Pass"] = "Перевал Ледяного Крыла",
	["Idlewind Lake"] = "Озеро Тихого Ветра",
	["Igneous Depths"] = "Вулканические глубины",
	["Ihgaluk Crag"] = "Утесы Ихгалук",
	["Ik'vess"] = "Ик'весс",
	["Ikz'ka Ridge"] = "Взгорье Икз'ка",
	["Illidari Point"] = "Аванпост Иллидари",
	["Illidari Training Grounds"] = "Тренировочная площадка",
	["Indu'le Village"] = "Деревня Инду'ле",
	["Infiltrating the Shipyard"] = "Проникновение на пристань",
	["Inkgill Mere"] = "Озеро Чернильной Жабры",
	Inn = "Таверна",
	["Inner Sanctum"] = "Центр города",
	["Inner Veil"] = "Внутренняя Завеса",
	["Insidion's Perch"] = "Гнездо Инсидиона",
	["Invasion Point: Annihilator"] = "Точка вторжения: Аннигилятор",
	["Invasion Point: Cataclysm"] = "Точка вторжения: Катаклизм",
	["Invasion Point: Destroyer"] = "Точка вторжения: Разрушение",
	["Invasion Point: Overlord"] = "Точка вторжения: Властитель",
	["Ironband's Compound"] = "Мастерская Сталекрута",
	["Ironband's Excavation Site"] = "Раскопки Сталекрута",
	["Ironbeard's Tomb"] = "Гробница Железноборода",
	["Ironclad Cove"] = "Потайная бухта",
	["Ironclad Garrison"] = "Железный гарнизон",
	["Ironclad Prison"] = "Потайная бухта",
	["Iron Concourse"] = "Железный двор",
	["Irondeep Mine"] = "Железный рудник",
	Ironforge = "Стальгорн",
	["Ironforge Airfield"] = "Аэродром Стальгорна",
	["Ironstone Camp"] = "Лагерь Железного Камня",
	["Ironstone Plateau"] = "Плато Железного Камня",
	["Iron Summit"] = "Железная вершина",
	["Irontree Cavern"] = "Пещера Железнолесья",
	["Irontree Clearing"] = "Прогалина Железнолесья",
	["Irontree Woods"] = "Железнолесье",
	["Ironwall Dam"] = "Железная плотина",
	["Ironwall Rampart"] = "Железный вал",
	["Ironwing Cavern"] = "Пещера Стального Крыла",
	Iskaal = "Искаал",
	["Island of Doctor Lapidis"] = "Остров доктора Лапидиса",
	["Isle of Conquest"] = "Остров Завоеваний",
	["Isle of Conquest No Man's Land"] = "Остров Завоеваний нейтральная территория",
	["Isle of Dread"] = "Остров Ужаса",
	["Isle of Giants"] = "Остров Великанов",
	["Isle of Quel'Danas"] = "Остров Кель'Данас",
	["Isle of Reckoning"] = "Остров Расплаты",
	["Isle of Thunder"] = "Остров Грома",
	["Isle of Tribulations"] = "Остров Напастей",
	["Iso'rath"] = "Изо'рат",
	["Itharius's Cave"] = "Пещера Итара",
	["Ivald's Ruin"] = "Руины Ивальда",
	["Ix'lar's Domain"] = "Владения Икс'лара",
	["Jadefire Glen"] = "Долина Нефритового Пламени",
	["Jadefire Run"] = "Холм Нефритового Пламени",
	["Jade Forest Alliance Hub Phase"] = "Jade Forest Alliance Hub Phase",
	["Jade Forest Battlefield Phase"] = "Jade Forest Battlefield Phase",
	["Jade Forest Horde Starting Area"] = "Jade Forest Horde Starting Area",
	["Jademir Lake"] = "Нефритовое озеро",
	["Jade Temple Grounds"] = "Земли Нефритового храма",
	Jaedenar = "Джеденар",
	["Jagged Reef"] = "Острые рифы",
	["Jagged Ridge"] = "Зазубренная гряда",
	["Jaggedswine Farm"] = "Свиноферма",
	["Jagged Wastes"] = "Бугристые пустоши",
	["Jaguero Isle"] = "Остров Жагуаро",
	["Jaina Dalaran Scenario"] = "Джайна в Даларане - сценарий",
	["Janeiro's Point"] = "Остров Жанейро",
	["Jangolode Mine"] = "Рудник Янго",
	["Jaquero Isle"] = "Остров Жагуаро",
	["Jasperlode Mine"] = "Яшмовая шахта",
	["Jeff NE Quadrant Changed"] = "Джефф СВ Измененный квадрант",
	["Jeff NW Quadrant"] = "Джефф СЗ Квадрант",
	["Jeff SE Quadrant"] = "Джефф ЮВ Квадрант",
	["Jeff SW Quadrant"] = "Джефф ЮЗ Квадрант",
	["Jerod's Landing"] = "Лагерь Джерода",
	["Jintha'Alor"] = "Джинта'Алор",
	["Jintha'kalar"] = "Джинта'калар",
	["Jintha'kalar Passage"] = "Джинта'каларский проход",
	["Jin Yang Road"] = "Дорога Цзинь Ян",
	Jotunheim = "Йотунхейм",
	K3 = "К-3",
	["Kaja'mine"] = "Каджа'митовая шахта",
	["Kaja'mite Cave"] = "Каджа'митовая пещера",
	["Kaja'mite Cavern"] = "Каджа'митовая пещера",
	["Kajaro Field"] = "Площадка Каджаро",
	["Kal'ai Ruins"] = "Руины Кал'аи",
	Kalimdor = "Калимдор",
	Kamagua = "Камагуа",
	["Karabor Sewers"] = "Канализация",
	Karazhan = "Каражан",
	["Kargathia Keep"] = "Крепость Каргатия",
	["Karnum's Glade"] = "Просека Карнума",
	["Kartak's Hold"] = "Форт Картака",
	Kaskala = "Каскала",
	["Kaw's Roost"] = "Гнездо Кау",
	["Kea Krak"] = "Ки Крак",
	["Keelen's Trustworthy Tailoring"] = "Почтенное ателье Килена",
	["Keel Harbor"] = "Килевая гавань",
	["Keeshan's Post"] = "Лагерь Кишана",
	["Kelp'thar Forest"] = "Лес Келп’тар",
	["Kel'Thuzad Chamber"] = "Зал Кел'Тузада",
	["Kel'Thuzad's Chamber"] = "Зал Кел'Тузада",
	["Keset Pass"] = "Тропа Кесета",
	["Kessel's Crossing"] = "Перекресток Кессела",
	Kezan = "Кезан",
	Kharanos = "Каранос",
	["Khardros' Anvil"] = "Наковальня Кардроса",
	["Khartut's Tomb"] = "Гробница Хартута",
	["Khaz'goroth's Seat"] = "Трон Каз'горота",
	["Ki-Han Brewery"] = "Хмелеварня Ци-Хань",
	["Kili'ua's Atoll"] = "Атолл Кили'уа",
	["Kil'sorrow Fortress"] = "Бастион Вечной Скорби",
	["King's Gate"] = "Врата короля",
	["King's Harbor"] = "Королевская гавань",
	["King's Hoard"] = "Королевское хранилище",
	["King's Square"] = "Королевская площадь",
	["Kirin'Var Village"] = "Деревня Кирин'Вар",
	Kirthaven = "Кирт",
	["Klaxxi'vess"] = "Клакси'весс",
	["Klik'vess"] = "Клик'весс",
	["Knucklethump Hole"] = "Логово Тяжелого Когтя",
	["Kodo Graveyard"] = "Кладбище кодо",
	["Kodo Rock"] = "Дольмен Кодо",
	["Kolkar Village"] = "Деревня Колкар",
	Kolramas = "Колрамас",
	["Kor'kron Vanguard"] = "Отряд кор'крона",
	["Kormek's Hut"] = "Хижина Кормека",
	["Koroth's Den"] = "Логово Корота",
	["Korthun's End"] = "Край Кортуна",
	["Kor'vess"] = "Кор'весс",
	["Kota Basecamp"] = "Лагерь Коту",
	["Kota Peak"] = "Пик Коту",
	["Krasarang Cove"] = "Красарангская бухта",
	["Krasarang River"] = "Река Красаранг",
	["Krasarang Wilds"] = "Красарангские джунгли",
	["Krasari Falls"] = "Красарангский водопад",
	["Krasus' Landing"] = "Площадка Краса",
	["Krazzworks Attack Zeppelin"] = "Krazzworks Attack Zeppelin",
	["Kril'Mandar Point"] = "Точка Крил'Мандар",
	["Kri'vess"] = "Кри'весс",
	["Krolg's Hut"] = "Хижина Кролга",
	["Krom'gar Fortress"] = "Крепость Кром'гар",
	["Krom's Landing"] = "Лагерь Крома",
	["KTC Headquarters"] = "Штаб-квартира ТКК",
	["KTC Oil Platform"] = "Нефтяная платформа ТКК",
	["Kul'galar Keep"] = "Крепость Кул'галар",
	["Kul Tiras"] = "Кул-Тирас",
	["Kun-Lai Pass"] = "Куньлайская дорога",
	["Kun-Lai Summit"] = "Вершина Кунь-Лай",
	["Kunzen Cave"] = "Пещера Куньцзэнь",
	["Kunzen Village"] = "Деревня Куньцзэнь",
	["Kurzen's Compound"] = "Лагерь Курцена",
	["Kypari Ik"] = "Кипари Ик",
	["Kyparite Quarry"] = "Кипаритовый карьер",
	["Kypari Vor"] = "Кипари Вор",
	["Kypari Zar"] = "Кипари Зар",
	["Kzzok Warcamp"] = "Военный лагерь Кззок",
	["Lair of Skiggit"] = "Логово Скиггита",
	["Lair of the Beast"] = "Логово чудовища",
	["Lair of the Chosen"] = "Обитель Избранного",
	["Lair of the Jade Witch"] = "Хижина нефритовой ведьмы",
	["Lair of Tortos"] = "Логово Тортоса",
	["Lake Al'Ameth"] = "Озеро Аль'Амет",
	["Lake Cauldros"] = "Озеро Колдрос",
	["Lake Dumont"] = "Озеро Дюмон",
	["Lake Edunel"] = "Озеро Эдунель",
	["Lake Elrendar"] = "Озеро Элрендар",
	["Lake Elune'ara"] = "Озеро Элуне'ара",
	["Lake Ere'Noru"] = "Озеро Эре'Нору",
	["Lake Everstill"] = "Озеро Безмолвия",
	["Lake Falathim"] = "Озеро Фалатим",
	["Lake Indu'le"] = "Озеро Инду'ле",
	["Lake Jorune"] = "Озеро Иорун",
	["Lake Kel'Theril"] = "Озеро Кел'Терил",
	["Lake Kittitata"] = "Озеро Киттитата",
	["Lake Kum'uya"] = "Озеро Кум'уа",
	["Lake Mennar"] = "Озеро Меннар",
	["Lake Mereldar"] = "Озеро Мерельдар",
	["Lake Nazferiti"] = "Озеро Назферити",
	["Lake of Stars"] = "Озеро Звезд",
	["Lakeridge Highway"] = "Озерный тракт",
	Lakeshire = "Приозерье",
	["Lakeshire Inn"] = "Таверна Приозерья",
	["Lakeshire Town Hall"] = "Ратуша Приозерья",
	["Lakeside Landing"] = "Лагерь у озера",
	["Lake Sunspring"] = "Озеро Солнечного Источника",
	["Lakkari Tar Pits"] = "Смоляные ямы Лаккари",
	["Landing Beach"] = "Береговая станция",
	["Landing Site"] = "Место высадки",
	["Land's End Beach"] = "Пляж на Краю Света",
	["Langrom's Leather & Links"] = "Кожа и кольчуги от Лангрома",
	["Lao & Son's Yakwash"] = "Якомойка Лао и сын",
	["Largo's Overlook"] = "Дозорный пункт Ларго",
	["Largo's Overlook Tower"] = "Дозорная башня Ларго",
	["Lariss Pavilion"] = "Павильон Лорисс",
	["Laughing Skull Courtyard"] = "Внутренний двор Веселого Черепа",
	["Laughing Skull Ruins"] = "Руины Веселого Черепа",
	["Launch Bay"] = "Пусковая установка",
	["Legash Encampment"] = "Лагерь Легаш",
	["Legendary Leathers"] = "Шикарные шкурки",
	["Legion Hold"] = "Форт Легиона",
	["Legion's Fate"] = "Судьба Легиона",
	["Legion's Rest"] = "База Легиона",
	["Lethlor Ravine"] = "Долина Летлор",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "Печаль Лиары",
	["L'ghorek"] = "Л'горек",
	["Liang's Retreat"] = "Пристанище Ляна",
	["Library Wing"] = "Библиотечное крыло",
	Lighthouse = "Маяк",
	["Lightning Ascent"] = "Подъем Молний",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Lightning Forge - Mogu Island Progression Scenario",
	["Lightning Ledge"] = "Уступ Молний",
	["Lightning Promenade"] = "Грозовой двор",
	["Lightning Vein Mine"] = "Шахта Молний",
	["Light's Breach"] = "Разлом Света",
	["Light's Dawn Cathedral"] = "Собор Рассвета",
	["Light's Hammer"] = "Молот Света",
	["Light's Hope Chapel"] = "Часовня Последней Надежды",
	["Light's Point"] = "Застава Света",
	["Light's Point Tower"] = "Башня Заставы Света",
	["Light's Shield Tower"] = "Башня Защиты Света",
	["Light's Trust"] = "Опора Света",
	["Like Clockwork"] = "Как часы",
	["Lion's Landing"] = "Львиный лагерь",
	["Lion's Pride Inn"] = "Таверна Гордость льва",
	["Livery Outpost"] = "Пост у стойл",
	["Livery Stables"] = "Стойла",
	["Livery Stables "] = "Стойла",
	["Llane's Oath"] = "Присяга Ллейна",
	["Loading Room"] = "Погрузочная",
	["Loch Modan"] = "Лок Модан",
	["Loch Verrall"] = "Озеро Лок Вералл",
	["Loken's Bargain"] = "Сделка Локена",
	["Lonesome Cove"] = "Одинокая бухта",
	Longshore = "Бескрайний берег",
	["Longying Outpost"] = "Укрепления Лун-Ин",
	["Lordamere Internment Camp"] = "Лордамерские выселки",
	["Lordamere Lake"] = "Озеро Лордамер",
	["Lor'danel"] = "Лор'данел",
	["Lorthuna's Gate"] = "Врата Лортуны",
	["Lost Caldera"] = "Затерянный кратер",
	["Lost City of the Tol'vir"] = "Затерянный город Тол'вир",
	["Lost City of the Tol'vir Entrance"] = "Затерянный город Тол'вир",
	LostIsles = "Затерянные острова",
	["Lost Isles Town in a Box"] = "Затерянные острова макет города",
	["Lost Isles Volcano Eruption"] = "Извержение вулкана Затерянных островов",
	["Lost Peak"] = "Затерянный пик",
	["Lost Point"] = "Разрушенная башня",
	["Lost Rigger Cove"] = "Бухта Сорванных Парусов",
	["Lothalor Woodlands"] = "Лоталорское редколесье",
	["Lower City"] = "Нижний Город",
	["Lower Silvermarsh"] = "Низина Серебристой топи",
	["Lower Sumprushes"] = "Нижние Камышовые топи",
	["Lower Veil Shil'ak"] = "Нижнее гнездовье Шил'ак",
	["Lower Wilds"] = "Низинные чащобы",
	["Lumber Mill"] = "Лесопилка",
	["Lushwater Oasis"] = "Цветущий оазис",
	["Lydell's Ambush"] = "Засада Лиделла",
	["M.A.C. Diver"] = "МАК Водолаз",
	["Maelstrom Deathwing Fight"] = "Водоворот, бой со Смертокрылом",
	["Maelstrom Zone"] = "Область Водоворота",
	["Maestra's Post"] = "Застава Мейстры",
	["Maexxna's Nest"] = "Гнездо Мексны",
	["Mage Quarter"] = "Квартал Магов",
	["Mage Tower"] = "Башня Магов",
	["Mag'har Grounds"] = "Земли маг'харов",
	["Mag'hari Procession"] = "Похоронная процессия маг'харов",
	["Mag'har Post"] = "Застава маг'харов",
	["Magical Menagerie"] = "Волшебный зверинец",
	["Magic Quarter"] = "Квартал Магов",
	["Magisters Gate"] = "Врата Магистров",
	["Magister's Terrace"] = "Терраса Магистров",
	["Magisters' Terrace"] = "Терраса Магистров",
	["Magisters' Terrace Entrance"] = "Терраса Магистров",
	["Magmadar Cavern"] = "Пещера Магмадара",
	["Magma Fields"] = "Магмовые поля",
	["Magma Springs"] = "Магматические ключи",
	["Magmaw's Fissure"] = "Излом Магмаря",
	Magmoth = "Магмот",
	["Magnamoth Caverns"] = "Пещеры Магнамух",
	["Magram Territory"] = "Территория Маграм",
	["Magtheridon's Lair"] = "Логово Магтеридона",
	["Magus Commerce Exchange"] = "Торговая палата волшебников",
	["Main Chamber"] = "Главный зал",
	["Main Gate"] = "Главные врата",
	["Main Hall"] = "Главный зал",
	["Maker's Ascent"] = "Возвышение Творца",
	["Maker's Overlook"] = "Дозор Творцов",
	["Maker's Overlook "] = "Дозор Творцов",
	["Makers' Overlook"] = "Дозор Творцов",
	["Maker's Perch"] = "Обитель Творцов",
	["Makers' Perch"] = "Обитель Творцов",
	["Malaka'jin"] = "Малака'джин",
	["Malden's Orchard"] = "Сад Мальдена",
	Maldraz = "Малдраз",
	["Malfurion's Breach"] = "Аванпост Малфуриона",
	["Malicia's Outpost"] = "Застава Коварнессы",
	["Malykriss: The Vile Hold"] = "Маликрисс: Зловещая Крепость",
	["Mama's Pantry"] = "Кладовая мамаши",
	["Mam'toth Crater"] = "Кратер Мам'Тота",
	["Manaforge Ara"] = "Манагорн Ара",
	["Manaforge B'naar"] = "Манагорн Б'наар",
	["Manaforge Coruu"] = "Манагорн Коруу",
	["Manaforge Duro"] = "Манагорн Даро",
	["Manaforge Ultris"] = "Манагорн Ультрис",
	["Mana Tombs"] = "Гробницы Маны",
	["Mana-Tombs"] = "Гробницы Маны",
	["Mandokir's Domain"] = "Владения Мандокира",
	["Mandori Village"] = "Деревня Мандори",
	["Mannoroc Coven"] = "Поле Маннорок",
	["Manor Mistmantle"] = "Поместье Мистмантла",
	["Mantle Rock"] = "Скала Мантия",
	["Map Chamber"] = "Зал Карт",
	["Mar'at"] = "Мар'ат",
	Maraudon = "Мародон",
	["Maraudon - Earth Song Falls Entrance"] = "Мародон: Поющие водопады",
	["Maraudon - Foulspore Cavern Entrance"] = "Мародон: Зловонная пещера",
	["Maraudon - The Wicked Grotto Entrance"] = "Мародон: Оскверненный грот",
	["Mardenholde Keep"] = "Крепость Марденхольд",
	Marista = "Мариста",
	["Marista's Bait & Brew"] = "Еда и напитки Маристы",
	["Market Row"] = "Торговый ряд",
	["Marshal's Refuge"] = "Укрытие Маршалла",
	["Marshal's Stand"] = "Застава Маршалла",
	["Marshlight Lake"] = "Озеро Болотных Огоньков",
	["Marshtide Watch"] = "Застава Болотной Воды",
	["Maruadon - The Wicked Grotto Entrance"] = "Мародон: Оскверненный грот",
	["Mason's Folly"] = "Причуда Камнетеса",
	["Masters' Gate"] = "Врата Мастеров",
	["Master's Terrace"] = "Терраса Мастера",
	["Mast Room"] = "Мачтовая мастерская",
	["Maw of Destruction"] = "Утроба Разрушения",
	["Maw of Go'rath"] = "Утроба Го'рата",
	["Maw of Lycanthoth"] = "Утроба Ликантота",
	["Maw of Neltharion"] = "Пасть Нелтариона",
	["Maw of Shu'ma"] = "Утроба Шу'мы",
	["Maw of the Void"] = "Чрево Пустоты",
	["Mazra'Alor"] = "Мазра'Алор",
	Mazthoril = "Мазторил",
	["Mazu's Overlook"] = "Застава Мацзу",
	["Medivh's Chambers"] = "Покои Медива",
	["Menagerie Wreckage"] = "Останки Зверинца",
	["Menethil Bay"] = "Бухта Менетилов",
	["Menethil Harbor"] = "Гавань Менетилов",
	["Menethil Keep"] = "Крепость Менетилов",
	["Merchant Square"] = "Торговая площадь",
	Middenvale = "Прелая долина",
	["Mid Point Station"] = "Центральная станция",
	["Midrealm Post"] = "Застава срединных земель",
	["Midwall Lift"] = "Подъемник Средней стены",
	["Mightstone Quarry"] = "Карьер Камня Силы",
	["Military District"] = "Военный квартал",
	["Mimir's Workshop"] = "Мастерская Мимира",
	Mine = "Рудник",
	Mines = "Рудник",
	["Mirage Abyss"] = "Бездна миражей",
	["Mirage Flats"] = "Маревые равнины",
	["Mirage Raceway"] = "Виражи на Миражах",
	["Mirkfallon Lake"] = "Мутное озеро",
	["Mirkfallon Post"] = "Пост на Мутном озере",
	["Mirror Lake"] = "Зеркальное озеро",
	["Mirror Lake Orchard"] = "Сад у Зеркального озера",
	["Mistblade Den"] = "Берлога Туманного Клинка",
	["Mistcaller's Cave"] = "Пещера призывателя туманов",
	["Mistfall Village"] = "Деревня Туманного Водопада",
	["Mist's Edge"] = "Туманный Предел",
	["Mistvale Valley"] = "Мглистая долина",
	["Mistveil Sea"] = "Море Туманной Дымки",
	["Mistwhisper Refuge"] = "Убежище Шепота Тумана",
	["Misty Pine Refuge"] = "Сторожка у заснеженной сосны",
	["Misty Reed Post"] = "Тростниковая застава",
	["Misty Reed Strand"] = "Тростниковый берег",
	["Misty Ridge"] = "Туманная гряда",
	["Misty Shore"] = "Мглистый берег",
	["Misty Shores"] = "Туманные берега",
	["Misty Valley"] = "Туманная долина",
	["Miwana's Longhouse"] = "Большой дом Миваны",
	["Mizjah Ruins"] = "Руины Мизжа",
	["Moa'ki"] = "Моа'ки",
	["Moa'ki Harbor"] = "Гавань Моа'ки",
	["Moggle Point"] = "Вершина Моггл",
	["Mo'grosh Stronghold"] = "Оплот Мо'грош",
	["Mogu Island Daily Area"] = "Mogu Island Daily Area",
	["Mogu Island Events - Alliance Base"] = "Mogu Island Events - Alliance Base",
	["Mogu Island Events - Horde Base"] = "Mogu Island Events - Horde Base",
	["Mogu Island Loot Room"] = "Mogu Island Loot Room",
	["Mogu Island Progression Events"] = "Mogu Island Progression Events",
	Mogujia = "Могуцзя",
	["Mogu'shan Palace"] = "Дворец Могу'шан",
	["Mogu'shan Terrace"] = "Терраса Могу'шан",
	["Mogu'shan Vaults"] = "Подземелья Могу'шан",
	["Mok'Doom"] = "Мок'Дум",
	["Mok'Gordun"] = "Мок'Гордун",
	["Mok'Nathal Village"] = "Деревня Мок'Натал",
	["Mold Foundry"] = "Литейная",
	["Molten Core"] = "Огненные Недра",
	["Molten Front"] = "Огненная передовая",
	Moonbrook = "Луноречье",
	Moonglade = "Лунная поляна",
	["Moongraze Woods"] = "Леса Лунного Оленя",
	["Moon Horror Den"] = "Обитель Лунного Ужаса",
	["Moonrest Gardens"] = "Сады Лунного Покоя",
	["Moonshrine Ruins"] = "Руины святилища Луны",
	["Moonshrine Sanctum"] = "Алтарь святилища Луны",
	["Moontouched Den"] = "Осененная луной берлога",
	["Moonwater Retreat"] = "Приют Лунной Воды",
	["Moonwell of Cleansing"] = "Лунный колодец очищения",
	["Moonwell of Purity"] = "Лунный колодец чистоты",
	["Moonwing Den"] = "Прибежище Лунных Крыльев",
	["Mord'rethar: The Death Gate"] = "Морд'ретар: Врата Смерти",
	["Morgan's Plot"] = "Надел Моргана",
	["Morgan's Vigil"] = "Дозор Морганы",
	["Morlos'Aran"] = "Морлос'Аран",
	["Morning Breeze Lake"] = "Озеро Утреннего Бриза",
	["Morning Breeze Village"] = "Деревня Утреннего Бриза",
	Morrowchamber = "Зал Потоков",
	["Mor'shan Base Camp"] = "Лагерь Мор'шан",
	["Mortal's Demise"] = "Погибель Смертных",
	["Mortbreath Grotto"] = "Грот смертосмрадов",
	["Mortwake's Tower"] = "Башня Мортвейка",
	["Mosh'Ogg Ogre Mound"] = "Холм Мош'Огг",
	["Mosshide Fen"] = "Болото Мохошкуров",
	["Mosswalker Village"] = "Деревня Мохобродов",
	["Mossy Pile"] = "Мшистая горка",
	["Motherseed Pit"] = "Яма для семян",
	["Mountainfoot Strip Mine"] = "Карьер у подножья горы",
	["Mount Akher"] = "Гора Акер",
	["Mount Hyjal"] = "Гора Хиджал",
	["Mount Hyjal Phase 1"] = "Гора Хиджал, фаза 1",
	["Mount Neverest"] = "Гора Неутомимых",
	["Muckscale Grotto"] = "Грот Грязной Чешуи",
	["Muckscale Shallows"] = "Мелководье Грязной Чешуи",
	["Mudmug's Place"] = "Участок Грязной Кружки",
	Mudsprocket = "Шестермуть",
	Mulgore = "Мулгор",
	["Murder Row"] = "Закоулок Душегубов",
	["Murkdeep Cavern"] = "Пещера Глубомрака",
	["Murky Bank"] = "Грязный берег",
	["Muskpaw Ranch"] = "Ферма Мускусной Лапы",
	["Mystral Lake"] = "Озеро Мистраль",
	Mystwood = "Таинственная роща",
	Nagrand = "Награнд",
	["Nagrand Arena"] = "Арена Награнда",
	Nahom = "Нахом",
	["Nar'shola Terrace"] = "Терраса Нар'шолы",
	["Narsong Spires"] = "Поющие Вершины",
	["Narsong Trench"] = "Поющая Котловина",
	["Narvir's Cradle"] = "Колыбель Нарвира",
	["Nasam's Talon"] = "Коготь Назама",
	["Nat's Landing"] = "Лагерь Ната",
	["Naval Battle Scenario"] = "Морская битва - сценарий",
	Naxxanar = "Наксанар",
	Naxxramas = "Наксрамас",
	["Nayeli Lagoon"] = "Лагуна Найели",
	["Naz'anak: The Forgotten Depths"] = "Наз'анак: Забытые глубины",
	["Nazj'vel"] = "Назж'вел",
	Nazzivian = "Наззивиан",
	["Nectarbreeze Orchard"] = "Сад Сладкого Ветерка",
	["Needlerock Chasm"] = "Провал Каменных Игл",
	["Needlerock Slag"] = "Шлаковый зал",
	["Nefarian's Lair"] = "Логово Нефариана",
	["Nefarian�s Lair"] = "Логово Нефариана",
	["Neferset City"] = "Неферсет",
	["Neferset City Outskirts"] = "Окраины Неферсета",
	["Nek'mani Wellspring"] = "Родник Нек'Мани",
	["Neptulon's Rise"] = "Подъем Нептулона",
	["Nesingwary Base Camp"] = "Лагерь Эрнестуэя",
	["Nesingwary Safari"] = "Охотничий лагерь Эрнестуэя",
	["Nesingwary's Expedition"] = "Экспедиция Эрнестуэя",
	["Nesingwary's Safari"] = "Охотничий лагерь Эрнестуэя",
	Nespirah = "Неспира",
	["Nestlewood Hills"] = "Совиные холмы",
	["Nestlewood Thicket"] = "Совиная чаща",
	["Nethander Stead"] = "Владение Нетандера",
	["Nethergarde Keep"] = "Крепость Стражей Пустоты",
	["Nethergarde Mines"] = "Рудники Гарнизона",
	["Nethergarde Supply Camps"] = "Лагерь поддержки Гарнизона",
	Netherspace = "Пустомарь",
	Netherstone = "Осколки Пустоты",
	Netherstorm = "Пустоверть",
	["Netherweb Ridge"] = "Гряда Пустопутов",
	["Netherwing Fields"] = "Поля Крыльев Пустоты",
	["Netherwing Ledge"] = "Кряж Крыльев Пустоты",
	["Netherwing Mines"] = "Копи Крыльев Пустоты",
	["Netherwing Pass"] = "Перевал Крыльев Пустоты",
	["Neverest Basecamp"] = "Горный лагерь Пика Неутомимых",
	["Neverest Pinnacle"] = "Пик Неутомимых",
	["New Agamand"] = "Новый Агамонд",
	["New Agamand Inn"] = "Таверна Нового Агамонда",
	["New Avalon"] = "Новый Авалон",
	["New Avalon Fields"] = "Поля Нового Авалона",
	["New Avalon Forge"] = "Кузня Нового Авалона",
	["New Avalon Orchard"] = "Сад Нового Авалона",
	["New Avalon Town Hall"] = "Ратуша Нового Авалона",
	["New Cifera"] = "Новая Цифера",
	["New Hearthglen"] = "Новый Дольный Очаг",
	["New Kargath"] = "Новый Каргат",
	["New Thalanaar"] = "Новый Таланаар",
	["New Tinkertown"] = "Новый Город Механиков",
	["Nexus Legendary"] = "Нексус, получение посоха",
	Nidavelir = "Нидавелир",
	["Nidvar Stair"] = "Лестница Нидвара",
	Nifflevar = "Ниффлвар",
	["Night Elf Village"] = "Деревня ночных эльфов",
	Nighthaven = "Ночная Гавань",
	["Nightingale Lounge"] = "Соловьиная гостиная",
	["Nightmare Depths"] = "Глубины Кошмаров",
	["Nightmare Scar"] = "Ров Кошмаров",
	["Nightmare Vale"] = "Долина Кошмаров",
	["Night Run"] = "Ночная поляна",
	["Nightsong Woods"] = "Леса Ночной Песни",
	["Night Web's Hollow"] = "Паучья низина",
	["Nijel's Point"] = "Высота Найджела",
	["Nimbus Rise"] = "Возвышенность Сияния",
	Nine = "Девять",
	["Niuzao Catacombs"] = "Катакомбы Нюцзао",
	["Niuzao Temple"] = "Храм Нюцзао",
	["Njord's Breath Bay"] = "Бухта Дыхания Ньорда",
	["Njorndar Village"] = "Деревня Ньорндар",
	["Njorn Stair"] = "Лестница Ньорна",
	["Nook of Konk"] = "Закуток Конка",
	["Noonshade Ruins"] = "Руины Полуденной Тени",
	Nordrassil = "Нордрассил",
	["Nordrassil Inn"] = "Таверна Нордрассила",
	["Nordune Ridge"] = "Утес Нордун",
	["North Common Hall"] = "Северный зал",
	Northdale = "Северный Дол",
	["Northern Barrens"] = "Северные Степи",
	["Northern Elwynn Mountains"] = "Северные Элвиннские горы",
	["Northern Headlands"] = "Северный каменистый мыс",
	["Northern Rampart"] = "Северный бастион",
	["Northern Rocketway"] = "Северная ракетная дорога",
	["Northern Rocketway Exchange"] = "Северная пересадочная станция ракетной дороги",
	["Northern Stranglethorn"] = "Северная Тернистая долина",
	["Northfold Manor"] = "Северное поместье",
	["Northgate Breach"] = "Пролом Северных врат",
	["North Gate Outpost"] = "Застава у Северных врат",
	["North Gate Pass"] = "Северные врата",
	["Northgate River"] = "Река Северных врат",
	["Northgate Woods"] = "Лес Северных врат",
	["Northmaul Tower"] = "Башня Северного Молота",
	["Northpass Tower"] = "Башня Северного перевала",
	["North Point Station"] = "Северная станция",
	["North Point Tower"] = "Северная башня",
	Northrend = "Нордскол",
	["Northridge Lumber Camp"] = "Лесопилка Северного Кряжа",
	["North Sanctum"] = "Северное святилище",
	Northshire = "Североземье",
	["Northshire Abbey"] = "Аббатство Североземья",
	["Northshire River"] = "Река Североземья",
	["Northshire Valley"] = "Долина Североземья",
	["Northshire Vineyards"] = "Виноградники Североземья",
	["North Spear Tower"] = "Северная башня",
	["North Tide's Beachhead"] = "Северная приливная низина",
	["North Tide's Run"] = "Берег Северного прилива",
	["Northwatch Expedition Base Camp"] = "Лагерь экспедиции Северной Стражи",
	["Northwatch Expedition Base Camp Inn"] = "Гостиница экспедиции Северной Стражи",
	["Northwatch Foothold"] = "Крепь Северной Стражи",
	["Northwatch Hold"] = "Крепость Северной Стражи",
	["Northwind Cleft"] = "Расщелина Северного Ветра",
	["North Wind Tavern"] = "Таверна На северных ветрах",
	["Nozzlepot's Outpost"] = "Лагерь Котельника",
	["Nozzlerust Post"] = "Лагерь Соплозабилось",
	["Oasis of the Fallen Prophet"] = "Оазис павшего пророка",
	["Oasis of Vir'sar"] = "Оазис Вир'сара",
	["Obelisk of the Moon"] = "Обелиск Луны",
	["Obelisk of the Stars"] = "Обелиск Звезд",
	["Obelisk of the Sun"] = "Обелиск Солнца",
	["O'Breen's Camp"] = "Лагерь О'Брина",
	["Observance Hall"] = "Ритуальный зал",
	["Observation Grounds"] = "Обзорная площадка",
	["Obsidian Breakers"] = "Обсидиановые рифы",
	["Obsidian Dragonshrine"] = "Обсидиановое святилище драконов",
	["Obsidian Forest"] = "Обсидиановый лес",
	["Obsidian Lair"] = "Обсидиановое логово",
	["Obsidia's Perch"] = "Гнездо Обсидии",
	["Odesyus' Landing"] = "Лагерь Одиссия",
	["Ogri'la"] = "Огри'ла",
	["Ogri'La"] = "Огри'ла",
	["Old Hillsbrad Foothills"] = "Старые предгорья Хилсбрада",
	["Old Ironforge"] = "Старый Стальгорн",
	["Old Town"] = "Старый город",
	Olembas = "Олембас",
	["Olivia's Pond"] = "Пруд Оливии",
	["Olsen's Farthing"] = "Удел Ольсена",
	Oneiros = "Онейрос",
	["One Keg"] = "Пэй-Лэй",
	["One More Glass"] = "Еще по сто",
	["Onslaught Base Camp"] = "Лагерь Алого Натиска",
	["Onslaught Harbor"] = "Гавань Натиска",
	["Onyxia's Lair"] = "Логово Ониксии",
	["Oomlot Village"] = "Деревня Умлот",
	["Oona Kagu"] = "Уна Кагу",
	Oostan = "Устан",
	["Oostan Nord"] = "Устан север",
	["Oostan Ost"] = "Устан восток",
	["Oostan Sor"] = "Устан юг",
	["Opening of the Dark Portal"] = "Открытие Темного портала",
	["Opening of the Dark Portal Entrance"] = "Открытие Темного портала",
	["Oratorium of the Voice"] = "Ораторий",
	["Oratory of the Damned"] = "Молельня Проклятых",
	["Orchid Hollow"] = "Ложбина Орхидей",
	["Orebor Harborage"] = "Прибежище Оребор",
	["Oregrind's Dig"] = "Карьер Рудогрызя",
	["Orendil's Retreat"] = "Укрытие Орендила",
	Orgrimmar = "Оргриммар",
	["Orgrimmar Gunship Pandaria Start"] = "Orgrimmar Gunship Pandaria Start",
	["Orgrimmar Rear Gate"] = "Задние врата Оргриммара",
	["Orgrimmar Rocketway Exchange"] = "Оргриммарская пересадочная станция ракетной дороги",
	["Orgrim's Hammer"] = "Молот Оргрима",
	["Oronok's Farm"] = "Ферма Оронока",
	Orsis = "Орсис",
	["Ortell's Hideout"] = "Укрытие Ортелла",
	["Oshu'gun"] = "Ошу'гун",
	["Outdoor Ruins"] = "Руины",
	Outland = "Запределье",
	["Overgrown Camp"] = "Заросший лагерь",
	["Overgrown Statuary"] = "Площадь Каменных Статуй",
	["Owen's Wishing Well"] = "Волшебный колодец Оуэна",
	["Owl Wing Thicket"] = "Совиная чаща",
	["Palace Antechamber"] = "Дворцовый вестибюль",
	["Pal'ea"] = "Пал'иа",
	["Palemane Rock"] = "Утес Бледногривов",
	["Pandaren Mine"] = "Рудник пандаренов",
	Pandaria = "Пандария",
	["Pang's Stead"] = "Усадьба Пана",
	["Panic Clutch"] = "Обитель Паники",
	["Paoquan Hollow"] = "Лощина Паоцюань",
	["Parhelion Plaza"] = "Площадь Паргелия",
	["Passage of Lost Fiends"] = "Перевал Заблудившихся Злодеев",
	["Path of a Hundred Steps"] = "Путь Сотни Ступеней",
	["Path of Conquerors"] = "Путь Завоевателей",
	["Path of Enlightenment"] = "Путь Просвещения",
	["Path of Serenity"] = "Путь Спокойствия",
	["Path of the Titans"] = "Путь Титанов",
	["Path of Uther"] = "Путь Утера",
	["Pattymack Land"] = "Земли Пэттимака",
	["Pauper's Walk"] = "Путь Бедняка",
	["Paur's Pub"] = "Таверна Паура",
	["Paw'don Glade"] = "Роща Лап'дон",
	["Paw'don Village"] = "Деревня Лап'дон",
	["Paw'Don Village"] = "Деревня Лап'дон", -- Needs review
	["Peak of Serenity"] = "Пик Безмятежности",
	["Pearlfin Village"] = "Деревня Жемчужного Плавника",
	["Pearl Lake"] = "Жемчужное озеро",
	["Pedestal of Hope"] = "Пьедестал Надежды",
	["Pei-Wu Forest"] = "Лес Пэй-У",
	["Pestilent Scar"] = "Моровой овраг",
	["Pet Battle - Jade Forest"] = "Битва питомцев - Нефритовый лес",
	["Petitioner's Chamber"] = "Зал Просителей",
	["Pilgrim's Precipice"] = "Пропасть Пилигрима",
	["Pincer X2"] = "Хват X2",
	["Pinnacle of Storms"] = "Вершина Бурь",
	["Pit of Fangs"] = "Змеиная яма",
	["Pit of Saron"] = "Яма Сарона",
	["Pit of Saron Entrance"] = "Яма Сарона",
	["Plaguelands: The Scarlet Enclave"] = "Чумные земли: Анклав Алого ордена",
	["Plaguemist Ravine"] = "Чумная лощина",
	Plaguewood = "Чумной лес",
	["Plaguewood Tower"] = "Башня Чумного леса",
	["Plain of Echoes"] = "Равнина эха",
	["Plain of Shards"] = "Долина Осколков",
	["Plain of Thieves"] = "Равнина воров",
	["Plains of Nasam"] = "Равнины Назама",
	["Pod Cluster"] = "Отсек Капсулы",
	["Pod Wreckage"] = "Обломки Капсулы",
	["Poison Falls"] = "Ядопады",
	["Pool of Reflection"] = "Пруд Созерцания",
	["Pool of Tears"] = "Озеро Слез",
	["Pool of the Paw"] = "Пруд Лапы",
	["Pool of Twisted Reflections"] = "Пруд искаженных отражений",
	["Pools of Aggonar"] = "Пруды Аггонара",
	["Pools of Arlithrien"] = "Пруды Арлитриэна",
	["Pools of Jin'Alai"] = "Бассейн Джин'Алаи",
	["Pools of Purity"] = "Пруды Чистоты",
	["Pools of Youth"] = "Пруд Молодости",
	["Pools of Zha'Jin"] = "Озера Жа'Джина",
	["Portal Clearing"] = "Прогалина с порталом",
	["Pranksters' Hollow"] = "Пещера шаловливых духов",
	["Predator's Perch"] = "Гнездо хищника",
	["Prison of Immol'thar"] = "Тюрьма Бессмер'тера",
	["Programmer Isle"] = "Остров Программиста",
	["Promontory Point"] = "Подводный выступ",
	["Prospector's Point"] = "Лагерь горняков",
	["Protectorate Watch Post"] = "Застава Стражей Протектората",
	["Proving Grounds"] = "Арена испытаний",
	["Purespring Cavern"] = "Пещера Чистого Источника",
	["Purgation Isle"] = "Остров Очищения",
	["Pursuing the Black Harvest"] = "В погоне за Мрачной Жатвой",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "Лаборатория алхимических ужасов и забав",
	["Pyrewood Chapel"] = "Часовня Погребальных Костров",
	["Pyrewood Inn"] = "Таверна Погребальных Костров",
	["Pyrewood Town Hall"] = "Ратуша Погребальных Костров",
	["Pyrewood Village"] = "Деревня Погребальных Костров",
	["Pyrox Flats"] = "Пироксовые равнины",
	["QA and DVD"] = "QA and DVD",
	["Quagg Ridge"] = "Гряда Квагг",
	Quarry = "Каменоломня",
	["Quartzite Basin"] = "Кварцитовая впадина",
	["Queen's Gate"] = "Врата Королевы",
	["Quel'Danil Lodge"] = "Сторожка Кель'Данил",
	["Quel'Delar's Rest"] = "Покой Кель'Делара",
	["Quel'Dormir Gardens"] = "Сады Кель'Дормир",
	["Quel'Dormir Temple"] = "Храм Кель'Дормир",
	["Quel'Dormir Terrace"] = "Терраса Кель'Дормир",
	["Quel'Lithien Lodge"] = "Сторожка Кель'Литиен",
	["Quel'thalas"] = "Кель'Талас",
	["Quickchop's Lumber Farm"] = "Лесопилка Скоротяпеля",
	["Raastok Glade"] = "Прогалина Раасток",
	["Raceway Ruins"] = "Разрушенная гоночная полоса",
	["Rageclaw Den"] = "Логово Яростного Когтя",
	["Rageclaw Lake"] = "Озеро Яростного Когтя",
	["Rage Fang Shrine"] = "Святилище Красного Клыка",
	["Ragefeather Ridge"] = "Хребет Яростного Пера",
	["Ragefire Caverns"] = "Пещеры Огненной Пропасти",
	["Ragefire Chasm"] = "Огненная Пропасть",
	["Ragefire Core"] = "Сердце Огненной Пропасти",
	["Rage Scar Hold"] = "Пещера Бешеного оврага",
	["Ragnaros' Lair"] = "Логово Рагнароса",
	["Ragnaros' Reach"] = "Владения Рагнароса",
	["Rainspeaker Canopy"] = "Прибежище Гласа Дождя",
	["Rainspeaker Rapids"] = "Водопады Гласа Дождя",
	Ramkahen = "Рамкахен",
	["Ramkahen Legion Outpost"] = "Застава рамкахенов",
	["Rampart of Skulls"] = "Черепной вал",
	["Ranazjar Isle"] = "Остров Раназжар",
	["Raptor Pens"] = "Ямы ящеров",
	["Raptor Ridge"] = "Гряда Ящеров",
	["Raptor Rise"] = "Утес Ящеров",
	Ratchet = "Кабестан",
	["Rated Eye of the Storm"] = "Око Бури (рейтинговое)",
	["Ravaged Caravan"] = "Разграбленный караван",
	["Ravaged Crypt"] = "Разграбленный склеп",
	["Ravaged Twilight Camp"] = "Разоренный Сумеречный лагерь",
	["Ravencrest Monument"] = "Памятник Гребню Ворона",
	["Raven Hill"] = "Вороний Холм",
	["Raven Hill Cemetery"] = "Кладбище Вороньего Холма",
	["Ravenholdt Manor"] = "Поместье Черного Ворона",
	["Raven's Watch"] = "Вороний дозор",
	["Raven's Wood"] = "Лес Ворона",
	["Raynewood Retreat"] = "Приют в Ночных Лесах",
	["Raynewood Tower"] = "Башня в Ночных лесах",
	["Razaan's Landing"] = "Лагерь Разаана",
	["Razorfen Downs"] = "Курганы Иглошкурых",
	["Razorfen Downs Entrance"] = "Курганы Иглошкурых",
	["Razorfen Kraul"] = "Лабиринты Иглошкурых",
	["Razorfen Kraul Entrance"] = "Лабиринты Иглошкурых",
	["Razor Hill"] = "Колючий Холм",
	["Razor Hill Barracks"] = "Казармы Колючего Холма",
	["Razor Hill Outskirts"] = "Окраины Колючего Холма",
	["Razor Hill Watchtower"] = "Сторожевая башня Колючего Холма",
	["Razormane Grounds"] = "Земли Иглогривых",
	["Razor Ridge"] = "Островерхий гребень",
	["Razorscale's Aerie"] = "Гнездо Острокрылой",
	["Razorthorn Rise"] = "Уступ Острого Шипа",
	["Razorthorn Shelf"] = "Обрыв Острого Шипа",
	["Razorthorn Trail"] = "Дорога Острого Шипа",
	["Razorwind Canyon"] = "Каньон Колючего Ветра",
	["Rear Staging Area"] = "Тыловая точка сбора",
	["Reaver's Fall"] = "Гибель Сквернобота",
	["Reavers' Hall"] = "Зал Разорителей",
	["Rebel Camp"] = "Лагерь Повстанцев",
	["Red Cloud Mesa"] = "Плато Красного Облака",
	["Redpine Dell"] = "Лощина Красной Сосны",
	["Redridge - Bridge Phase One"] = "Красногорье - первая фаза, мост",
	["Redridge - Bridge Phase Two"] = "Красногорье - вторая фаза, мост",
	["Redridge Canyons"] = "Каньоны Красногорья",
	["Redridge Mountains"] = "Красногорье",
	["Redridge - Orc Bomb"] = "Красногорье - орочья бомба",
	["Red Rocks"] = "Красные скалы",
	["Redwood Trading Post"] = "Торговая лавка Красного леса",
	Refinery = "Нефтезавод",
	["Refugee Caravan"] = "Караван Беженцев",
	["Refuge Pointe"] = "Опорный пункт",
	["Refuse Disposal"] = "Стоки",
	["Reliquary of Agony"] = "Реликварий Агонии",
	["Reliquary of Pain"] = "Реликварий Боли",
	["Remains of Iris Lake"] = "Обмелевшее озеро Ирис",
	["Remains of the Fleet"] = "Остатки Флота",
	["Remtravel's Excavation"] = "Раскопки Сомнамбулера",
	["Render's Camp"] = "Лагерь Ренда",
	["Render's Crater"] = "Кратер Ренда",
	["Render's Rock"] = "Скала Ренда",
	["Render's Valley"] = "Долина Ренда",
	["Rensai's Watchpost"] = "Дозорный пункт Жэнь-сая",
	["Rethban Caverns"] = "Пещеры Ретбана",
	["Rethress Sanctum"] = "Святилище Ретресса",
	Reuse = "Reuse",
	["Reuse Me 7"] = "Используй меня повторно 7",
	["Revantusk Village"] = "Деревня Сломанного Клыка",
	["Rhea's Camp"] = "Лагерь Реа",
	["Rhonin's Beard"] = "Борода Ронина",
	["Rhyolith Plateau"] = "Плато Риолита",
	["Ricket's Folly"] = "Просторы Рикет",
	["Ridge of Laughing Winds"] = "Хребет Смеющихся Ветров",
	["Ridge of Madness"] = "Гряда Безумия",
	["Ridgepoint Tower"] = "Дозорная башня",
	Rikkilea = "Риккили",
	["Rikkitun Village"] = "Деревня Риккитун",
	["Rim of the World"] = "Край света",
	["Ring of Judgement"] = "Круг Правосудия",
	["Ring of Observance"] = "Ритуальный Круг",
	["Ring of the Elements"] = "Круг Стихий",
	["Ring of the Law"] = "Зал Правосудия",
	["Riplash Ruins"] = "Руины Терзающего Бича",
	["Riplash Strand"] = "Берег Терзающего Бича",
	["Rise of Suffering"] = "Высота Страдания",
	["Rise of the Defiler"] = "Утес Осквернителя",
	["Ritual Chamber of Akali"] = "Ритуальная комната Акали",
	["Rivendark's Perch"] = "Гнездо Чернокрыла",
	Rivenwood = "Вырубки",
	["River's Heart"] = "Слияние рек",
	["Rock of Durotan"] = "Обелиск Дуротана",
	["Rockpool Village"] = "Деревня Каменистого Озера",
	["Rocktusk Farm"] = "Ферма Каменного Клыка",
	["Roguefeather Den"] = "Логово Легкоперых",
	["Rogues' Quarter"] = "Квартал Разбойников",
	["Rohemdal Pass"] = "Рохемдальский проход",
	["Roland's Doom"] = "Погибель Роланда",
	["Room of Hidden Secrets"] = "Комната с секретами",
	["Roost of Ji-Kun"] = "Насест Цзи-Кунь",
	["Rotbrain Encampment"] = "Лагерь гнилодумов",
	["Royal Amphitheater"] = "Королевский амфитеатр",
	["Royal Approach"] = "Королевский коридор",
	["Royal Exchange Auction House"] = "Аукционный дом Королевской биржи",
	["Royal Exchange Bank"] = "Королевский Валютный банк",
	["Royal Gallery"] = "Королевская галерея",
	["Royal Library"] = "Королевская библиотека",
	["Royal Quarter"] = "Королевский квартал",
	["Ruby Dragonshrine"] = "Рубиновое святилище драконов",
	["Ruined Approach"] = "Разрушенный проход",
	["Ruined City Post 01"] = "Ruined City Post 01",
	["Ruined Court"] = "Разрушенный двор",
	["Ruins of Aboraz"] = "Руины Абораза",
	["Ruins of Ahmtul"] = "Руины Амтула",
	["Ruins of Ahn'Qiraj"] = "Руины Ан'Киража",
	["Ruins of Alterac"] = "Руины Альтерака",
	["Ruins of Ammon"] = "Руины Аммона",
	["Ruins of Arkkoran"] = "Руины храма Арккоран",
	["Ruins of Auberdine"] = "Руины Аубердина",
	["Ruins of Baa'ri"] = "Руины Баа'ри",
	["Ruins of Constellas"] = "Руины Констелласа",
	["Ruins of Dojan"] = "Руины Доцзян",
	["Ruins of Drakgor"] = "Руины Дракгора",
	["Ruins of Drak'Zin"] = "Руины Драк'Зина",
	["Ruins of Eldarath"] = "Руины Эльдарата",
	["Ruins of Eldarath "] = "Руины Эльдарата",
	["Ruins of Eldra'nath"] = "Руины Элдра'ната",
	["Ruins of Eldre'thar"] = "Руины Эльдре'тара",
	["Ruins of Enkaat"] = "Руины Энкаата",
	["Ruins of Farahlon"] = "Руины Фаралона",
	["Ruins of Feathermoon"] = "Руины крепости",
	["Ruins of Gilneas"] = "Руины Гилнеаса",
	["Ruins of Gilneas City"] = "Гилнеас",
	["Ruins of Guo-Lai"] = "Руины Го-Лай",
	["Ruins of Isildien"] = "Руины Исильдиэна",
	["Ruins of Jubuwal"] = "Руины Жубуваля",
	["Ruins of Karabor"] = "Руины Карабора",
	["Ruins of Kargath"] = "Руины Каргата",
	["Ruins of Khintaset"] = "Руины Кинтасета",
	["Ruins of Korja"] = "Руины Корцзя",
	["Ruins of Korune"] = "Руины клана Корун",
	["Ruins of Lar'donir"] = "Руины Лар'донира",
	["Ruins of Lordaeron"] = "Руины Лордерона",
	["Ruins of Loreth'Aran"] = "Развалины Лорет'Арана",
	["Ruins of Lornesta"] = "Руины Лорнесты",
	["Ruins of Mathystra"] = "Руины Матистры",
	["Ruins of Nordressa"] = "Руины Нордрессы",
	["Ruins of Ogudei"] = "Руины Огудея",
	["Ruins of Ravenwind"] = "Руины Яростного Ветра",
	["Ruins of Sha'naar"] = "Руины Ша'наара",
	["Ruins of Shandaral"] = "Руины Шандарала",
	["Ruins of Silvermoon"] = "Руины Луносвета",
	["Ruins of Solarsal"] = "Руины Соларсаля",
	["Ruins of Southshore"] = "Руины Южнобережья",
	["Ruins of Taurajo"] = "Руины Таурахо",
	["Ruins of Tethys"] = "Руины Тетиса",
	["Ruins of Thaurissan"] = "Руины Тауриссана",
	["Ruins of Thelserai Temple"] = "Руины храма Телсерай",
	["Ruins of Theramore"] = "Руины Терамора",
	["Ruins of the Scarlet Enclave"] = "Руины анклава Алого ордена",
	["Ruins of Uldum"] = "Руины Ульдума",
	["Ruins of Vashj'elan"] = "Руины Вайш'элана",
	["Ruins of Vashj'ir"] = "Руины Вайш'ира",
	["Ruins of Zul'Kunda"] = "Руины Зул'Кунды",
	["Ruins of Zul'Mamwe"] = "Руины Зул'Мамве",
	["Ruins Rise"] = "Холм Руин",
	["Rumbling Terrace"] = "Гулкая терраса",
	["Runestone Falithas"] = "Рунический камень Фалитас",
	["Runestone Shan'dor"] = "Рунический камень Шан'дор",
	["Runeweaver Square"] = "Площадь Руноплета",
	["Rustberg Village"] = "Растберг",
	["Rustmaul Dive Site"] = "Бассейн Ржавой Кувалды",
	["Rutsak's Guard"] = "Сторожка Рутсака",
	["Rut'theran Village"] = "Деревня Рут'теран",
	["Ruuan Weald"] = "Чащоба Рууан",
	["Ruuna's Camp"] = "Лагерь Рууны",
	["Ruuzel's Isle"] = "Остров Руузель",
	["Rygna's Lair"] = "Логово Ригны",
	["Sable Ridge"] = "Черная гряда",
	["Sacrificial Altar"] = "Жертвенный алтарь",
	["Sahket Wastes"] = "Пустоши Сакет",
	Salabria = "Салабрия",
	["Saldean's Farm"] = "Ферма Сальдена",
	["Saltheril's Haven"] = "Вилла Салтерила",
	["Saltspray Glen"] = "Долина Солевого Тумана",
	["Sanctuary of Malorne"] = "Святилище Малорна",
	["Sanctuary of Shadows"] = "Святилище Теней",
	["Sanctum of Reanimation"] = "Святилище воскрешения",
	["Sanctum of Shadows"] = "Внутреннее Святилище Теней",
	["Sanctum of the Ascended"] = "Святилище Перерожденных",
	["Sanctum of the Fallen God"] = "Святилище Падшего Бога",
	["Sanctum of the Moon"] = "Святилище Луны",
	["Sanctum of the Prophets"] = "Святилище Прорицателей",
	["Sanctum of the South Wind"] = "Святилище Южного Ветра",
	["Sanctum of the Stars"] = "Святилище Звезд",
	["Sanctum of the Sun"] = "Святилище Солнца",
	["Sands of Nasam"] = "Пески Назама",
	["Sandsorrow Watch"] = "Застава Скорбных Песков",
	["Sandy Beach"] = "Песчаный пляж",
	["Sandy Shallows"] = "Песчаные мели",
	["Sanguine Chamber"] = "Багряный чертог",
	["Sapphire Hive"] = "Сапфирный улей",
	["Sapphiron's Lair"] = "Логово Сапфирона",
	["Saragosa's Landing"] = "Лагерь Сарагосы",
	Sarahland = "Земля Сары",
	["Sardor Isle"] = "Остров Сардор",
	Sargeron = "Саргерон",
	["Sarjun Depths"] = "Сарджунские Глубины",
	["Saronite Mines"] = "Саронитовые шахты",
	["Sar'theris Strand"] = "Побережье Сар'Терис",
	Satyrnaar = "Сатирнаар",
	["Saurok Creation Pit"] = "Яма создания сауроков",
	["Savage Ledge"] = "Дикий уступ",
	["Scalawag Point"] = "Лагерь Скалаваг",
	["Scalding Pools"] = "Жгучие пруды",
	["Scalebeard's Cave"] = "Пещера Чешуеборода",
	["Scalewing Shelf"] = "Склон Чешуекрылых",
	["Scarab Terrace"] = "Терраса Скарабея",
	["Scarlet Encampment"] = "Застава Алого ордена",
	["Scarlet Halls"] = "Залы Алого ордена",
	["Scarlet Hold"] = "Крепость Алого ордена",
	["Scarlet Monastery"] = "Монастырь Алого ордена",
	["Scarlet Monastery Entrance"] = "Монастырь Алого ордена",
	["Scarlet Overlook"] = "Дозорное укрепление Алого ордена",
	["Scarlet Palisade"] = "Палисад Алого ордена",
	["Scarlet Point"] = "Застава Алого ордена",
	["Scarlet Raven Tavern"] = "Таверна Алый ворон",
	["Scarlet Tavern"] = "Таверна Алого ордена",
	["Scarlet Tower"] = "Алая башня",
	["Scarlet Watch Post"] = "Сторожевой пост Алого ордена",
	["Scarlet Watchtower"] = "Сторожевая башня Алого ордена",
	["Scar of the Worldbreaker"] = "Разлом разрушителя миров",
	["Scarred Terrace"] = "Обрушенная терраса",
	["Scenario: Alcaz Island"] = "Остров Алькац",
	["Scenario - Black Ox Temple"] = "Сценарий - Храм Черного Быка",
	["Scenario - Mogu Ruins"] = "Сценарий - Руины могу",
	["Scenic Overlook"] = "Утес дивного вида",
	["Schnottz's Frigate"] = "Фрегат Шнотца",
	["Schnottz's Hostel"] = "Таверна Шнотца",
	["Schnottz's Landing"] = "Лагерь Шнотца",
	Scholomance = "Некроситет",
	["Scholomance Entrance"] = "Некроситет",
	ScholomanceOLD = "Некроситет",
	["School of Necromancy"] = "Школа некромантии",
	["Scorched Gully"] = "Выгоревший овраг",
	["Scott's Spooky Area"] = "Страшное место Скотта",
	["Scoured Reach"] = "Размытый берег",
	Scourgehold = "Оплот Плети",
	Scourgeholme = "Плетхольм",
	["Scourgelord's Command"] = "Смотровая площадка",
	["Scrabblescrew's Camp"] = "Лагерь Заржавня",
	["Screaming Gully"] = "Овраг Воплей",
	["Scryer's Tier"] = "Ярус Провидцев",
	["Scuttle Coast"] = "Берег Разбитых Кораблей",
	Sea = "Море",
	Seabrush = "Донные заросли",
	["Seafarer's Tomb"] = "Гробница Мореплавателя",
	["Sealed Chambers"] = "Закрытые покои",
	["Seal of the Sun King"] = "Печать Солнечного короля",
	["Sea Mist Ridge"] = "Гряда Морских туманов",
	["Searing Gorge"] = "Тлеющее ущелье",
	["Seaspittle Cove"] = "Пенящаяся бухта",
	["Seaspittle Nook"] = "Пенистый залив",
	["Seat of Destruction"] = "Трон Разрушения",
	["Seat of Knowledge"] = "Обитель Мудрости",
	["Seat of Life"] = "Трон Жизни",
	["Seat of Magic"] = "Трон Магии",
	["Seat of Radiance"] = "Трон Сияния",
	["Seat of the Chosen"] = "Совет Избранных",
	["Seat of the Naaru"] = "Трон Наару",
	["Seat of the Spirit Waker"] = "Трон Пробудителя Духов",
	["Seeker's Folly"] = "Причуда Искателя",
	["Seeker's Point"] = "Лагерь Искателя",
	["Sen'jin Village"] = "Деревня Сен'джин",
	["Sen'jin Village Outskirts"] = "Окраины деревни Сен'джин",
	["Sentinel Basecamp"] = "Лагерь Часовых",
	["Sentinel Hill"] = "Сторожевой холм",
	["Sentinel Tower"] = "Сторожевая башня",
	["Sentry Point"] = "Сторожевой пост",
	Seradane = "Серадан",
	["Serenity Falls"] = "Водопады Спокойствия",
	["Serpent Lake"] = "Змеиное озеро",
	["Serpent's Coil"] = "Змеиные Кольца",
	["Serpent's Heart"] = "Змеиное Сердце",
	["Serpentshrine Cavern"] = "Змеиное святилище",
	["Serpent's Overlook"] = "Площадка с видом на Нефритовую Змею",
	["Serpent's Spine"] = "Змеиный Хребет",
	["Servants' Quarters"] = "Комнаты слуг",
	["Service Entrance"] = "Черный ход",
	["Sethekk Halls"] = "Сетеккские залы",
	["Sethria's Roost"] = "Гнездо Сетрии",
	["Setting Sun Garrison"] = "Гарнизон Заходящего Солнца",
	["Set'vess"] = "Сет'весс",
	["Sewer Access Point"] = "Вход в канализацию",
	["Sewer Exit Pipe"] = "Выход из сточной трубы",
	Sewers = "Стоки",
	Shadebough = "Тень Ветвей",
	["Shadewood Thicket"] = "Чаща Лесного Сумрака",
	["Shado-Li Basin"] = "Низина Шадо-Ли",
	["Shado-Pan Fallback"] = "Оплот Шадо-Пан",
	["Shado-Pan Garrison"] = "Гарнизон Шадо-Пан",
	["Shado-Pan Monastery"] = "Монастырь Шадо-Пан",
	["Shadowbreak Ravine"] = "Лощина Тьмы",
	["Shadowfang Keep"] = "Крепость Темного Клыка",
	["Shadowfang Keep Entrance"] = "Крепость Темного Клыка",
	["Shadowfang Tower"] = "Башня Темного Клыка",
	["Shadowforge City"] = "Тенегорн",
	Shadowglen = "Тенистая долина",
	["Shadow Grave"] = "Мрачный склеп",
	["Shadow Hold"] = "Оплот Теней",
	["Shadow Labyrinth"] = "Темный лабиринт",
	["Shadowlurk Ridge"] = "Гряда Затаившейся Тьмы",
	["Shadowmoon Valley"] = "Долина Призрачной Луны",
	["Shadowmoon Village"] = "Деревня Призрачной Луны",
	["Shadow-Pan Monastery"] = "Монастырь Шадо-Пан",
	["Shadowprey Village"] = "Деревня Ночных Охотников",
	["Shadow Ridge"] = "Хребет Теней",
	["Shadowshard Cavern"] = "Пещера Темных Осколков",
	["Shadowsight Tower"] = "Башня Темного Взора",
	["Shadowsong Shrine"] = "Святилище Песни Теней",
	["Shadowthread Cave"] = "Паучье логово",
	["Shadow Tomb"] = "Гробница Тени",
	["Shadow Wing Lair"] = "Логово Крыла Тени",
	["Shadra'Alor"] = "Шадра'Алор",
	["Shadybranch Pocket"] = "Тенистая поляна",
	["Shady Rest Inn"] = "Таверна Последний привал",
	["Shalandis Isle"] = "Остров Шаландис",
	["Shalewind Canyon"] = "Каньон Глинистого Ветра",
	["Shallow's End"] = "Конец отмели",
	["Shallowstep Pass"] = "Путь Неверного Шага",
	["Shalzaru's Lair"] = "Убежище Шалзару",
	Shamanar = "Шаманар",
	["Sha'naari Wastes"] = "Пустоши Ша'наари",
	["Shang's Stead"] = "Усадьба Шана",
	["Shang's Valley"] = "Долина Шана",
	["Shang Xi Training Grounds"] = "Тренировочная площадка Шан Си",
	["Shan'ze Dao"] = "Шань'цзэ Дао",
	["Shaol'mara"] = "Шаол'мара",
	["Shaol'watha"] = "Шаол'вата",
	["Shaper's Terrace"] = "Терраса Создателя",
	["Shaper's Terrace "] = "Терраса Создателя",
	["Shartuul's Transporter"] = "Транспортер Шартуула",
	["Sha'tari Base Camp"] = "Лагерь Ша'тар",
	["Sha'tari Outpost"] = "Застава Ша'тар",
	["Shattered Convoy"] = "Разбитый конвой",
	["Shattered Plains"] = "Разоренные равнины",
	["Shattered Straits"] = "Пролив Кораблекрушений",
	["Shattered Sun Staging Area"] = "Подготовительный плацдарм Расколотого Солнца",
	["Shatter Point"] = "Парящая застава",
	["Shatter Scar Vale"] = "Долина Рваных Ран",
	Shattershore = "Берег Обломков",
	["Shatterspear Pass"] = "Тропа Пронзающего Копья",
	["Shatterspear Vale"] = "Долина Пронзающего Копья",
	["Shatterspear War Camp"] = "Боевой лагерь Пронзающего Копья",
	Shatterstone = "Каменный Венец",
	Shattrath = "Шаттрат",
	["Shattrath City"] = "Шаттрат",
	["Shelf of Mazu"] = "Шельф Мацзу",
	["Shell Beach"] = "Ракушечный пляж",
	["Shield Hill"] = "Заградительный холм",
	["Shields of Silver"] = "Серебряные щиты",
	["Shimmering Bog"] = "Мерцающая топь",
	["Shimmering Expanse"] = "Мерцающий простор",
	["Shimmering Grotto"] = "Мерцающий грот",
	["Shimmer Ridge"] = "Мерцающий хребет",
	["Shindigger's Camp"] = "Лагерь Выпивохи",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "Корабль до Вайш'ира (Оргриммар -> Вайш'ир)",
	["Shipwreck Shore"] = "Берег Кораблекрушения",
	Shipyard = "Пристань",
	["Shipyard - Mogu Island Progression Scenario"] = "Shipyard - Mogu Island Progression Scenario",
	["Shok'Thokar"] = "Шок'Токар",
	["Sholazar Basin"] = "Низина Шолазар",
	["Shores of the Well"] = "Берега Источника Вечности",
	["Shrine of Aessina"] = "Святилище Эссины",
	["Shrine of Aviana"] = "Святилище Авианы",
	["Shrine of Dath'Remar"] = "Святилище Дат'Ремара",
	["Shrine of Dreaming Stones"] = "Святилище Дремлющих Камней",
	["Shrine of Eck"] = "Святилище Эка",
	["Shrine of Fellowship"] = "Святилище Братства",
	["Shrine of Five Dawns"] = "Святилище Пяти Рассветов",
	["Shrine of Goldrinn"] = "Святилище Голдринна",
	["Shrine of Inner-Light"] = "Святилище Внутреннего Света",
	["Shrine of Lost Souls"] = "Святилище Потерянных Душ",
	["Shrine of Nala'shi"] = "Святилище Нала'ши",
	["Shrine of Remembrance"] = "Святилище Воспоминаний",
	["Shrine of Remulos"] = "Святилище Ремула",
	["Shrine of Scales"] = "Святилище Чешуи",
	["Shrine of Seven Stars"] = "Святилище Семи Звезд",
	["Shrine of Thaurissan"] = "Святилище Тауриссана",
	["Shrine of the Dawn"] = "Святилище Рассвета",
	["Shrine of the Deceiver"] = "Святилище Искусителя",
	["Shrine of the Dormant Flame"] = "Святилище Дремлющего Пламени",
	["Shrine of the Eclipse"] = "Святилище Затмения",
	["Shrine of the Elements"] = "Святилище стихий",
	["Shrine of the Fallen Warrior"] = "Святилище Павшего Воина",
	["Shrine of the Five Khans"] = "Святилище Пяти Ханов",
	["Shrine of the Merciless One"] = "Святилище Безжалостного",
	["Shrine of the Ox"] = "Святилище Быка",
	["Shrine of Twin Serpents"] = "Святилище Двух Змеев",
	["Shrine of Two Moons"] = "Святилище Двух Лун",
	["Shrine of Unending Light"] = "Святилище Вечного Света",
	["Shriveled Oasis"] = "Высохший оазис",
	["Shuddering Spires"] = "Дрожащие Вершины",
	["SI:7"] = "ШРУ",
	["Siege of Niuzao Temple"] = "Осада храма Нюцзао",
	["Siege Vise"] = "Тиски Осады",
	["Siege Workshop"] = "Мастерская осадных машин",
	["Sifreldar Village"] = "Деревня Сифрельдар",
	["Sik'vess"] = "Сик'весс",
	["Sik'vess Lair"] = "Логово Сик'весс",
	["Silent Vigil"] = "Молчаливое Бдение",
	Silithus = "Силитус",
	["Silken Fields"] = "Шелковые поля",
	["Silken Shore"] = "Шелковый берег",
	["Silmyr Lake"] = "Озеро Силмир",
	["Silting Shore"] = "Илистый Берег",
	Silverbrook = "Среброречье",
	["Silverbrook Hills"] = "Холмы Среброречья",
	["Silver Covenant Pavilion"] = "Павильон Серебряного союза",
	["Silverlight Cavern"] = "Пещера Серебряного Света",
	["Silverline Lake"] = "Серебристое озеро",
	["Silvermoon City"] = "Луносвет",
	["Silvermoon City Inn"] = "Таверна Луносвета",
	["Silvermoon Finery"] = "Луносветский убор",
	["Silvermoon Jewelery"] = "Ювелиры Луносвета",
	["Silvermoon Registry"] = "Канцелярия Луносвета",
	["Silvermoon's Pride"] = "Гордость Луносвета",
	["Silvermyst Isle"] = "Остров Серебристой Дымки",
	["Silverpine Forest"] = "Серебряный бор",
	["Silvershard Mines"] = "Сверкающие копи",
	["Silver Stream Mine"] = "Серебряные копи",
	["Silver Tide Hollow"] = "Пещера Серебряной Волны",
	["Silver Tide Trench"] = "Котловина Серебряной Волны",
	["Silverwind Refuge"] = "Приют Серебряного Ветра",
	["Silverwing Flag Room"] = "Флаговая комната Среброкрылых",
	["Silverwing Grove"] = "Роща Среброкрылых",
	["Silverwing Hold"] = "Крепость Среброкрылых",
	["Silverwing Outpost"] = "Аванпост Среброкрылых",
	["Simply Enchanting"] = "Наложение чар",
	["Sindragosa's Fall"] = "Каньон Гибели Синдрагосы",
	["Sindweller's Rise"] = "Холм Греховодника",
	["Singing Marshes"] = "Поющие болота",
	["Singing Ridge"] = "Звенящий гребень",
	["Sinner's Folly"] = "Глупость Грешника",
	["Sira'kess Front"] = "Берег Сира'кесс",
	["Sishir Canyon"] = "Сиширский каньон",
	["Sisters Sorcerous"] = "Ведовские сестрички",
	Skald = "Гарь",
	["Sketh'lon Base Camp"] = "Лагерь Скет'лона",
	["Sketh'lon Wreckage"] = "Развалины Скет'лона",
	["Skethyl Mountains"] = "Горы Скетил",
	Skettis = "Скеттис",
	["Skitterweb Tunnels"] = "Паучий лабиринт",
	Skorn = "Скорн",
	["Skulking Row"] = "Обводной путь",
	["Skulk Rock"] = "Осклизлая скала",
	["Skull Rock"] = "Скала Черепа",
	["Sky Falls"] = "Небесный водопад",
	["Skyguard Outpost"] = "Застава Стражи Небес",
	["Skyline Ridge"] = "Гряда на горизонте",
	Skyrange = "Небогорье",
	["Skysong Lake"] = "Озеро Небесной Песни",
	["Slabchisel's Survey"] = "Привал Крепкой Стамески",
	["Slag Watch"] = "Вышка на золе",
	Slagworks = "Шлакозавод",
	["Slaughter Hollow"] = "Кровавая низина",
	["Slaughter Square"] = "Площадь Живодерни",
	["Sleeping Gorge"] = "Спящая теснина",
	["Slicky Stream"] = "Река Безмятежная",
	["Slingtail Pits"] = "Ямы Ловкого Хвоста",
	["Slitherblade Shore"] = "Берег Скользящего Плавника",
	["Slithering Cove"] = "Скользкая бухта",
	["Slither Rock"] = "Скользкая скала",
	["Sludgeguard Tower"] = "Башня Топей",
	["Smuggler's Scar"] = "Пещера контрабандистов",
	["Snicklefritz Mine"] = "Шахтерский городок Зарубеня",
	["Snowblind Hills"] = "Холмы Снежной Слепоты",
	["Snowblind Terrace"] = "Терраса Снежной Слепоты",
	["Snowden Chalet"] = "Снегонор",
	["Snowdrift Dojo"] = "Додзё Снежного Вихря",
	["Snowdrift Plains"] = "Снежные равнины",
	["Snowfall Glade"] = "Поляна Снегопада",
	["Snowfall Graveyard"] = "Кладбище Снегопада",
	["Socrethar's Seat"] = "Трон Сокретара",
	["Sofera's Naze"] = "Возвышенность Соферы",
	["Soggy's Gamble"] = "Приют капитана",
	["Solace Glade"] = "Поляна Утешения",
	["Solliden Farmstead"] = "Усадьба Соллиден",
	["Solstice Village"] = "Деревня Солнцестояния",
	["Sorlof's Strand"] = "Берег Сорлофа",
	["Sorrow Hill"] = "Холм Печали",
	["Sorrow Hill Crypt"] = "Крипта холма Печали",
	Sorrowmurk = "Горемрак",
	["Sorrow Wing Point"] = "Вершина Крыльев Скорби",
	["Soulgrinder's Barrow"] = "Холм Разрушителя Душ",
	["Southbreak Shore"] = "Берег за Южной грядой",
	["South Common Hall"] = "Южный зал",
	["Southern Barrens"] = "Южные Степи",
	["Southern Gold Road"] = "Южный Золотой Путь",
	["Southern Rampart"] = "Южный бастион",
	["Southern Rocketway"] = "Южная ракетная дорога",
	["Southern Rocketway Terminus"] = "Южная конечная станция ракетной дороги",
	["Southern Savage Coast"] = "Южный Гибельный берег",
	["Southfury River"] = "Река Строптивая",
	["Southfury Watershed"] = "Разлив Строптивой",
	["South Gate Outpost"] = "Застава у Южных врат",
	["South Gate Pass"] = "Южные врата",
	["Southmaul Tower"] = "Башня Южного Молота",
	["Southmoon Ruins"] = "Руины Южной Луны",
	["South Pavilion"] = "Южный павильон",
	["Southpoint Gate"] = "Южные врата",
	["South Point Station"] = "Южная станция",
	["Southpoint Tower"] = "Южная башня",
	["Southridge Beach"] = "Южный пляж",
	["Southsea Holdfast"] = "Укрепление Южных морей",
	["South Seas"] = "Южные моря",
	Southshore = "Южнобережье",
	["Southshore Town Hall"] = "Ратуша Южнобережья",
	["South Spire"] = "Южный шпиль",
	["South Tide's Run"] = "Берег Южного прилива",
	["Southwind Cleft"] = "Расщелина Южного Ветра",
	["Southwind Village"] = "Деревня Южного Ветра",
	["Sparkrocket Outpost"] = "Аванпост Искрожига",
	["Sparksocket Minefield"] = "Минное поле Свечекрута",
	["Sparktouched Haven"] = "Заиндевелая гавань",
	["Sparring Hall"] = "Зал Поединков",
	["Spearborn Encampment"] = "Лагерь Копьеносца",
	Spearhead = "Острие копья",
	["Speedbarge Bar"] = "Бар гоночной баржи",
	Spellsails = "Зачарованный парус",
	["Spinebreaker Mountains"] = "Горы Хребтолома",
	["Spinebreaker Pass"] = "Перевал Хребтолома",
	["Spinebreaker Post"] = "Застава Хребтолома",
	["Spinebreaker Ridge"] = "Гребень Хребтолома",
	["Spiral of Thorns"] = "Тернистый серпантин",
	["Spire of Blood"] = "Шпиль Крови",
	["Spire of Decay"] = "Шпиль Порчи",
	["Spire of Pain"] = "Шпиль Боли",
	["Spire of Solitude"] = "Шпиль Уединения",
	["Spire Throne"] = "Верховный трон",
	["Spirit Den"] = "Пещера Духов",
	["Spirit Fields"] = "Поля Духов",
	["Spirit Rise"] = "Вершина Духов",
	["Spirit Rock"] = "Священный Камень",
	["Spiritsong River"] = "Река Поющих Духов",
	["Spiritsong's Rest"] = "Покой Поющих Духов",
	["Spitescale Cavern"] = "Пещера Злобной Чешуи",
	["Spitescale Cove"] = "Грот Злобной Чешуи",
	["Splinterspear Junction"] = "Развилка Расщепленного Копья",
	Splintertree = "Расщепленное Дерево",
	["Splintertree Mine"] = "Шахта Расщепленного Дерева",
	["Splintertree Post"] = "Застава Расщепленного Дерева",
	["Splithoof Crag"] = "Скала Треснувшего Копыта",
	["Splithoof Heights"] = "Утес Треснувшего Копыта",
	["Splithoof Hold"] = "Оплот Треснувшего Копыта",
	Sporeggar = "Спореггар",
	["Sporewind Lake"] = "Озеро Спороветра",
	["Springtail Crag"] = "Утес прыгохвостов",
	["Springtail Warren"] = "Садок прыгохвостов",
	["Spruce Point Post"] = "Застава еловой макушки",
	["Sra'thik Incursion"] = "Место вторжения шра'тиков",
	["Sra'thik Swarmdock"] = "Роильня шра'тиков",
	["Sra'vess"] = "Шра'весс",
	["Sra'vess Rootchamber"] = "Корни Шра'весс",
	["Sri-La Inn"] = "Таверна Шри-Ла",
	["Sri-La Village"] = "Деревня Шри-Ла",
	Stables = "Стойла",
	Stagalbog = "Вязкая топь",
	["Stagalbog Cave"] = "Пещера у Вязкой топи",
	["Stagecoach Crash Site"] = "Место крушения Дилижанса",
	["Staghelm Point"] = "Лагерь Оленьего Шлема",
	["Staging Balcony"] = "Ложа",
	["Stairway to Honor"] = "Лестница Почета",
	["Starbreeze Village"] = "Деревня Звездного Ветра",
	["Stardust Spire"] = "Башня Звездной Пыли",
	["Starfall Village"] = "Деревня Звездопада",
	["Stars' Rest"] = "Покой Звезд",
	["Stasis Block: Maximus"] = "Изоляционная камера: Максимус",
	["Stasis Block: Trion"] = "Изоляционная камера: Трион",
	["Steam Springs"] = "Кипящие Источники",
	["Steamwheedle Port"] = "Порт Хитрой Шестеренки",
	["Steel Gate"] = "Стальные ворота",
	["Steelgrill's Depot"] = "Поселок Сталежара",
	["Steeljaw's Caravan"] = "Караван Стальной Челюсти",
	["Steelspark Station"] = "Станция Стализвон",
	["Stendel's Pond"] = "Пруд Стенделя",
	["Stillpine Hold"] = "Логово клана Тихвой",
	["Stillwater Pond"] = "Тихий Омут",
	["Stillwhisper Pond"] = "Пруд Тихого Шелеста",
	Stonard = "Каменор",
	["Stonebreaker Camp"] = "Лагерь Камнеломов",
	["Stonebreaker Hold"] = "Форт Камнеломов",
	["Stonebull Lake"] = "Озеро Каменного Быка",
	["Stone Cairn Lake"] = "Озеро Каменных Столбов",
	Stonehearth = "Каменный очаг",
	["Stonehearth Bunker"] = "Укрытие Каменного Очага",
	["Stonehearth Graveyard"] = "Кладбище Каменного Очага",
	["Stonehearth Outpost"] = "Форт Каменного Очага",
	["Stonemaul Hold"] = "Крепость Каменного Молота",
	["Stonemaul Ruins"] = "Руины Деревни Каменного Молота",
	["Stone Mug Tavern"] = "Таверна Каменная кружка",
	Stoneplow = "Каменный Плуг",
	["Stoneplow Fields"] = "Поля Каменного Плуга",
	["Stone Sentinel's Overlook"] = "Дозор каменных часовых",
	["Stonesplinter Valley"] = "Долина Камнедробов",
	["Stonetalon Bomb"] = "Бомба Каменного Когтя",
	["Stonetalon Mountains"] = "Когтистые горы",
	["Stonetalon Pass"] = "Тропа Каменного Когтя",
	["Stonetalon Peak"] = "Пик Каменного Когтя",
	["Stonewall Canyon"] = "Каньон Каменной Стены",
	["Stonewall Lift"] = "Подъемник Каменной стены",
	["Stoneward Prison"] = "Каменная тюрьма",
	Stonewatch = "Крепость Каменной Стражи",
	["Stonewatch Falls"] = "Водопад Каменной Стражи",
	["Stonewatch Keep"] = "Крепость Каменной Стражи",
	["Stonewatch Tower"] = "Башня Каменной Стражи",
	["Stonewrought Dam"] = "Каменная Плотина",
	["Stonewrought Pass"] = "Подгорная тропа",
	["Storm Cliffs"] = "Штормовые утесы",
	Stormcrest = "Грозовесье",
	["Stormfeather Outpost"] = "Лагерь Грозового Крыла",
	["Stormglen Village"] = "Грозовой Перевал",
	["Storm Peaks"] = "Грозовую Гряду",
	["Stormpike Graveyard"] = "Кладбище Грозовой Вершины",
	["Stormrage Barrow Dens"] = "Кельи Малфуриона",
	["Stormsea Landing"] = "Пристань Бушующих Волн",
	["Storm's Fury Wreckage"] = "Место крушения Неистовства Бури",
	["Stormstout Brewery"] = "Хмелеварня Буйных Портеров",
	["Stormstout Brewery Interior"] = "Внутренняя часть Хмелеварни Буйных Портеров",
	["Stormstout Brewhall"] = "Хмелеваренный зал Буйных Портеров",
	Stormwind = "Штормград",
	["Stormwind City"] = "Штормград",
	["Stormwind City Cemetery"] = "Городское кладбище Штормграда",
	["Stormwind City Outskirts"] = "Окраины Штормграда",
	["Stormwind Gunship Pandaria Start Area"] = "Stormwind Gunship Pandaria Start Area",
	["Stormwind Harbor"] = "Порт Штормграда",
	["Stormwind Keep"] = "Крепость Штормграда",
	["Stormwind Lake"] = "Озеро Штормграда",
	["Stormwind Mountains"] = "Горы Штормграда",
	["Stormwind Stockade"] = "Тюрьма Штормграда",
	["Stormwind Vault"] = "Подземелья Штормграда",
	["Stoutlager Inn"] = "Таверна Крепкое пойло",
	Strahnbrad = "Странбрад",
	["Strand of the Ancients"] = "Берег Древних",
	["Stranglethorn Vale"] = "Тернистая долина",
	Stratholme = "Стратхольм",
	["Stratholme Entrance"] = "Стратхольм",
	["Stratholme - Main Gate"] = "Стратхольм – Главные врата",
	["Stratholme - Service Entrance"] = "Стратхольм – Черный ход",
	["Stratholme Service Entrance"] = "Стратхольм - черный ход",
	["Stromgarde Keep"] = "Крепость Стромгард",
	["Strongarm Airstrip"] = "Взлетная полоса Сильной Руки",
	["STV Diamond Mine BG"] = "Алмазная шахта",
	["Stygian Bounty"] = "Стигийская Награда",
	["Sub zone"] = "Sub zone",
	["Sulfuron Keep"] = "Крепость Сульфурона",
	["Sulfuron Keep Courtyard"] = "Двор крепости Сульфурона",
	["Sulfuron Span"] = "Мост Сульфурона",
	["Sulfuron Spire"] = "Шпиль Сульфурона",
	["Sullah's Sideshow"] = "Цирк Суллы",
	["Summer's Rest"] = "Обитель Лета",
	["Summoners' Tomb"] = "Гробница Заклинателей",
	["Sunblossom Hill"] = "Холм Летнего Цветения",
	["Suncrown Village"] = "Деревня Солнечной Короны",
	["Sundown Marsh"] = "Закатное болото",
	["Sunfire Point"] = "Пик Солнечного Пламени",
	["Sunfury Hold"] = "Форт Ярости Солнца",
	["Sunfury Spire"] = "Дворец Ярости Солнца",
	["Sungraze Peak"] = "Пик Солнечного Пастбища",
	["Sunken Dig Site"] = "Затопленные раскопки",
	["Sunken Temple"] = "Затонувший храм",
	["Sunken Temple Entrance"] = "Затонувший храм",
	["Sunreaver Pavilion"] = "Павильон Похитителей Солнца",
	["Sunreaver's Command"] = "Лагерь Похитителя Солнца",
	["Sunreaver's Sanctuary"] = "Прибежище Похитителя Солнца",
	["Sun Rock Retreat"] = "Приют у Солнечного Камня",
	["Sunsail Anchorage"] = "Причал Солнечного Паруса",
	["Sunsoaked Meadow"] = "Солнечный луг",
	["Sunsong Ranch"] = "Ферма Солнечной Песни",
	["Sunspring Post"] = "Застава Солнечного Источника",
	["Sun's Reach Armory"] = "Оружейная Солнечного Края",
	["Sun's Reach Harbor"] = "Гавань Солнечного Края",
	["Sun's Reach Sanctum"] = "Святилище Солнечного Края",
	["Sunstone Terrace"] = "Терраса Солнечного Камня",
	["Sunstrider Isle"] = "Остров Солнечного Скитальца",
	["Sunveil Excursion"] = "Экспедиция Солнечного Паруса",
	["Sunwatcher's Ridge"] = "Хребет Стражей Солнца",
	["Sunwell Plateau"] = "Плато Солнечного Колодца",
	["Supply Caravan"] = "Караван",
	["Surge Needle"] = "Волноловы",
	["Surveyors' Outpost"] = "Лагерь геодезистов",
	Surwich = "Сурвич",
	["Svarnos' Cell"] = "Келья Сварноса",
	["Swamplight Manor"] = "Сторожка Болотный огонек",
	["Swamp of Sorrows"] = "Болото Печали",
	["Swamprat Post"] = "Застава Болотной Крысы",
	["Swiftgear Station"] = "Станция Бынструмента",
	["Swindlegrin's Dig"] = "Раскоп Хитрохмыла",
	["Swindle Street"] = "Переулок дельцов",
	["Sword's Rest"] = "Покои Клинка",
	Sylvanaar = "Сильванаар",
	["Tabetha's Farm"] = "Ферма Табеты",
	["Taelan's Tower"] = "Башня Телана",
	["Tahonda Ruins"] = "Руины Тахонды",
	["Tahret Grounds"] = "Угодья Тарет",
	["Tal'doren"] = "Тал'дорен",
	["Talismanic Textiles"] = "Охранные ткани",
	["Tallmug's Camp"] = "Лагерь Долгопоя",
	["Talonbranch Glade"] = "Поляна Когтистых Ветвей",
	["Talonbranch Glade "] = "Поляна Когтистых Ветвей",
	["Talondeep Pass"] = "Тропа Когтя",
	["Talondeep Vale"] = "Дол Когтя",
	["Talon Stand"] = "Холм Когтя",
	Talramas = "Талрамас",
	["Talrendis Point"] = "Застава Талрендис",
	Tanaris = "Танарис",
	["Tanaris Desert"] = "Пустыня Танарис",
	["Tanks for Everything"] = "Танки – наше все",
	["Tanner Camp"] = "Палатка Дубильщицы",
	["Tarren Mill"] = "Мельница Таррен",
	["Tasters' Arena"] = "Арена Дегустаторов",
	["Taunka'le Village"] = "Деревня Таунка'ле",
	["Tavern in the Mists"] = "Таверна В туманах",
	["Tazz'Alaor"] = "Тазз'Алаор",
	["Tear Down This Wall!"] = "Разрушить эту стену!",
	["Teegan's Expedition"] = "Экспедиция Тигана",
	["Teeming Burrow"] = "Забитая нора",
	Telaar = "Телаар",
	["Telaari Basin"] = "Котловина Телаари",
	["Tel'athion's Camp"] = "Лагерь Тел'атиона",
	Teldrassil = "Тельдрассил",
	Telredor = "Телредор",
	["Tempest Bridge"] = "Навигационный зал",
	["Tempest Keep"] = "Крепость Бурь",
	["Tempest Keep: The Arcatraz"] = "Крепость Бурь: Аркатрац",
	["Tempest Keep - The Arcatraz Entrance"] = "Крепость Бурь: Аркатрац",
	["Tempest Keep: The Botanica"] = "Крепость Бурь: Ботаника",
	["Tempest Keep - The Botanica Entrance"] = "Крепость Бурь: Ботаника",
	["Tempest Keep: The Mechanar"] = "Крепость Бурь: Механар",
	["Tempest Keep - The Mechanar Entrance"] = "Крепость Бурь: Механар",
	["Tempest's Reach"] = "Предел бури",
	["Temple City of En'kilah"] = "Храмовый город Эн'кила",
	["Temple Hall"] = "Храмовый зал",
	["Temple of Ahn'Qiraj"] = "Храм Ан'Кираж",
	["Temple of Arkkoran"] = "Храм Арккоран",
	["Temple of Asaad"] = "Храм Асаада",
	["Temple of Bethekk"] = "Храм Бетекк",
	["Temple of Earth"] = "Храм Земли",
	["Temple of Five Dawns"] = "Храм Пяти Рассветов",
	["Temple of Invention"] = "Храм Изобретений",
	["Temple of Kotmogu"] = "Храм Котмогу",
	["Temple of Life"] = "Храм Жизни",
	["Temple of Order"] = "Храм Порядка",
	["Temple of Storms"] = "Храм Штормов",
	["Temple of Telhamat"] = "Храм Телхамата",
	["Temple of the Forgotten"] = "Храм Забытых",
	["Temple of the Jade Serpent"] = "Храм Нефритовой Змеи",
	["Temple of the Moon"] = "Храм Луны",
	["Temple of the Red Crane"] = "Храм Красного Журавля",
	["Temple of the White Tiger"] = "Храм Белого Тигра",
	["Temple of Uldum"] = "Храм Ульдума",
	["Temple of Winter"] = "Храм Зимы",
	["Temple of Wisdom"] = "Храм Мудрости",
	["Temple of Zin-Malor"] = "Храм Зин-Малор",
	["Temple Summit"] = "Храмовая вершина",
	["Tenebrous Cavern"] = "Зловещий грот",
	["Terokkar Forest"] = "Лес Тероккар",
	["Terokk's Rest"] = "Покой Терокка",
	["Terrace of Endless Spring"] = "Терраса Вечной Весны",
	["Terrace of Gurthan"] = "Терраса Гуртан",
	["Terrace of Light"] = "Терраса Света",
	["Terrace of Repose"] = "Терраса Покоя",
	["Terrace of Ten Thunders"] = "Терраса Десяти Громов",
	["Terrace of the Augurs"] = "Терраса Авгуров",
	["Terrace of the Makers"] = "Терраса Творцов",
	["Terrace of the Sun"] = "Терраса Солнца",
	["Terrace of the Tiger"] = "Тигриная терраса",
	["Terrace of the Twin Dragons"] = "Терраса Драконов-близнецов",
	Terrordale = "Долина Ужаса",
	["Terror Run"] = "Путь Ужаса",
	["Terrorweb Tunnel"] = "Туннель Ужаса",
	["Terror Wing Path"] = "Тропа Крылатого Ужаса",
	["Tethris Aran"] = "Тефрис-Аран",
	Thalanaar = "Таланаар",
	["Thalassian Pass"] = "Талассийский перевал",
	["Thalassian Range"] = "Талассийская гряда",
	["Thal'darah Grove"] = "Роща Тал'дара",
	["Thal'darah Overlook"] = "Дозорный холм Тал'дара",
	["Thandol Span"] = "Мост Тандола",
	["Thargad's Camp"] = "Лагерь Таргада",
	["The Abandoned Reach"] = "Покинутый предел",
	["The Abyssal Maw"] = "Бездонная пучина",
	["The Abyssal Shelf"] = "Косогор Бездны",
	["The Admiral's Den"] = "Укрытие адмирала",
	["The Agronomical Apothecary"] = "Аптека агронома",
	["The Alliance Valiants' Ring"] = "Арена искателей славы из Альянса",
	["The Altar of Damnation"] = "Алтарь Проклятия",
	["The Altar of Shadows"] = "Алтарь Теней",
	["The Altar of Zul"] = "Алтарь Зула",
	["The Amber Hibernal"] = "Янтарная усыпальница",
	["The Amber Vault"] = "Янтарный зал",
	["The Amber Womb"] = "Янтарное Чрево",
	["The Ancient Grove"] = "Древняя роща",
	["The Ancient Lift"] = "Древний подъемник",
	["The Ancient Passage"] = "Древний проход",
	["The Antechamber"] = "Вестибюль",
	["The Anvil of Conflagration"] = "Огненная Наковальня",
	["The Anvil of Flame"] = "Кузня Пламени",
	["The Apothecarium"] = "Район Фармацевтов",
	["The Arachnid Quarter"] = "Паучий квартал",
	["The Arboretum"] = "Дендрарий",
	["The Arcanium"] = "Арканиум",
	["The Arcanium "] = "Арканиум",
	["The Arcatraz"] = "Аркатрац",
	["The Archivum"] = "Архив",
	["The Argent Stand"] = "Серебряная застава",
	["The Argent Valiants' Ring"] = "Арена искателей славы Серебряного Авангарда",
	["The Argent Vanguard"] = "Оплот Серебряного Авангарда",
	["The Arsenal Absolute"] = "Полный арсенал",
	["The Aspirants' Ring"] = "Арена претендентов",
	["The Assembly Chamber"] = "Чертог собраний",
	["The Assembly of Iron"] = "Железное Собрание",
	["The Athenaeum"] = "Читальня",
	["The Autumn Plains"] = "Осенние равнины",
	["The Avalanche"] = "Застывшая лавина",
	["The Azure Front"] = "Лазурная передовая",
	["The Bamboo Wilds"] = "Бамбуковая чаща",
	["The Bank of Dalaran"] = "Банк Даларана",
	["The Bank of Silvermoon"] = "Банк Луносвета",
	["The Banquet Hall"] = "Пиршественный зал",
	["The Barrier Hills"] = "Пограничные холмы",
	["The Bastion of Twilight"] = "Сумеречный бастион",
	["The Battleboar Pen"] = "Загон боевых вепрей",
	["The Battle for Gilneas"] = "Битва за Гилнеас",
	["The Battle for Gilneas (Old City Map)"] = "Битва за Гилнеас (старая карта города)",
	["The Battle for Mount Hyjal"] = "Битва за гору Хиджал",
	["The Battlefront"] = "Передовая",
	["The Bazaar"] = "Базар",
	["The Beast Pens"] = "Загоны для зверей",
	["The Beer Garden"] = "Пивной дворик",
	["The Bite"] = "Укус",
	["The Black Breach"] = "Черный разлом",
	["The Black Market"] = "Черный рынок",
	["The Black Morass"] = "Черные топи",
	["The Black Temple"] = "Черный храм",
	["The Black Vault"] = "Черное Хранилище",
	["The Blackwald"] = "Черная дубрава",
	["The Blazing Strand"] = "Искристый берег",
	["The Blighted Pool"] = "Гнилостный пруд",
	["The Blight Line"] = "Увядшая поляна",
	["The Bloodcursed Reef"] = "Заговоренный риф",
	["The Blood Furnace"] = "Кузня Крови",
	["The Bloodmire"] = "Кровавая топь",
	["The Bloodoath"] = "Кровавая Клятва",
	["The Blood Trail"] = "Кровавая тропа",
	["The Bloodwash"] = "Кровавый Прибой",
	["The Boiling Crustacean"] = "Кипящие Раки",
	["The Bombardment"] = "Зона бомбардировки",
	["The Bonefields"] = "Поля Костей",
	["The Bone Pile"] = "Груда костей",
	["The Bones of Nozronn"] = "Скелет Нозронна",
	["The Bone Wastes"] = "Костяные пустоши",
	["The Boneyard"] = "Двор",
	["The Borean Wall"] = "Борейская стена",
	["The Botanica"] = "Ботаника",
	["The Bradshaw Mill"] = "Мельница Брэдшоу",
	["The Breach"] = "Пролом",
	["The Briny Cutter"] = "Морской Кортик",
	["The Briny Muck"] = "Соленая отмель",
	["The Briny Pinnacle"] = "Соленая вершина",
	["The Broken Bluffs"] = "Изрезанные утесы",
	["The Broken Front"] = "Прорванный фронт",
	["The Broken Hall"] = "Разрушенный зал",
	["The Broken Hills"] = "Изрезанные холмы",
	["The Broken Stair"] = "Разрушенная лестница",
	["The Broken Temple"] = "Павший храм",
	["The Broodmother's Nest"] = "Гнездо праматери",
	["The Brood Pit"] = "Родовая яма",
	["The Bulwark"] = "Бастион",
	["The Burlap Trail"] = "Джутовый Путь",
	["The Burlap Valley"] = "Джутовая долина",
	["The Burlap Waystation"] = "Путевая станция Джутового Пути",
	["The Burning Corridor"] = "Горящий коридор",
	["The Butchery"] = "Бойня",
	["The Cache of Madness"] = "Тайник Безумия",
	["The Caller's Chamber"] = "Зал Призыва",
	["The Canals"] = "Каналы",
	["The Cape of Stranglethorn"] = "Мыс Тернистой долины",
	["The Carrion Fields"] = "Поля Падальщиков",
	["The Catacombs"] = "Катакомбы",
	["The Cauldron"] = "Котлован",
	["The Cauldron of Flames"] = "Огненная котловина",
	["The Cave"] = "Пещера",
	["The Celestial Planetarium"] = "Священный планетарий",
	["The Celestial Vault"] = "Небесное хранилище",
	["The Celestial Watch"] = "Обсерватория",
	["The Cemetary"] = "Кладбище",
	["The Cerebrillum"] = "Церебриллий",
	["The Charred Vale"] = "Обугленная долина",
	["The Chilled Quagmire"] = "Холодная трясина",
	["The Chum Bucket"] = "Дружеский ковшик",
	["The Circle of Cinders"] = "Круг Огней",
	["The Circle of Life"] = "Круг Жизни",
	["The Circle of Suffering"] = "Круг Страдания",
	["The Clarion Bell"] = "Звонкий Колокол",
	["The Clash of Thunder"] = "Раскаты Грома",
	["The Clean Zone"] = "Безопасная зона",
	["The Cleft"] = "Расселина",
	["The Clockwerk Run"] = "Часовой ход",
	["The Clutch"] = "Жемчужная ферма",
	["The Clutches of Shek'zeer"] = "Владения Шек'зир",
	["The Coil"] = "Змеиное Кольцо",
	["The Colossal Forge"] = "Гигантская кузня",
	["The Comb"] = "Соты",
	["The Commons"] = "Общий зал",
	["The Conflagration"] = "Пожарище",
	["The Conquest Pit"] = "Бойцовская яма",
	["The Conservatory"] = "Зимний сад",
	["The Conservatory of Life"] = "Оранжерея Жизни",
	["The Construct Quarter"] = "Квартал Мерзости",
	["The Cooper Residence"] = "Имение Купера",
	["The Corridors of Ingenuity"] = "Коридоры Изобретательности",
	["The Court of Bones"] = "Двор Костей",
	["The Court of Skulls"] = "Двор Черепов",
	["The Coven"] = "Ведьмин зал",
	["The Coven "] = "Ведьмин зал",
	["The Creeping Ruin"] = "Ползучие руины",
	["The Crimson Assembly Hall"] = "Алый зал собраний",
	["The Crimson Cathedral"] = "Багровый собор",
	["The Crimson Dawn"] = "Багровый Рассвет",
	["The Crimson Hall"] = "Багровый зал",
	["The Crimson Reach"] = "Кровавый берег",
	["The Crimson Throne"] = "Кровавый трон",
	["The Crimson Treader"] = "Алый Путник",
	["The Crimson Veil"] = "Кровавая Завеса",
	["The Crossroads"] = "Перекресток",
	["The Crucible"] = "Зал Испытаний",
	["The Crucible of Flame"] = "Раскаленный тигель",
	["The Crumbling Waste"] = "Гиблый пустырь",
	["The Cryo-Core"] = "Криогенный блок",
	["The Crystal Hall"] = "Кристальный зал",
	["The Crystal Shore"] = "Хрустальное взморье",
	["The Crystal Vale"] = "Долина Кристаллов",
	["The Crystal Vice"] = "Ущелье порочных кристаллов",
	["The Culling of Stratholme"] = "Очищение Стратхольма",
	["The Culling of Stratholme Entrance"] = "Очищение Стратхольма",
	["The Cursed Landing"] = "Проклятый лагерь",
	["The Dagger Hills"] = "Холмы Кинжалов",
	["The Dai-Lo Farmstead"] = "Крестьянский двор Дай-Ло",
	["The Damsel's Luck"] = "Госпожа Удача",
	["The Dancing Serpent"] = "Танцующий змей",
	["The Dark Approach"] = "Темный Подступ",
	["The Dark Defiance"] = "Мрачная непокорность",
	["The Darkened Bank"] = "Темный берег",
	["The Dark Hollow"] = "Темная пещера",
	["The Darkmoon Faire"] = "Ярмарка Новолуния",
	["The Dark Portal"] = "Темный портал",
	["The Dark Rookery"] = "Темное гнездовье",
	["The Darkwood"] = "Мрачный лес",
	["The Dawnchaser"] = "Рассветный Охотник",
	["The Dawning Isles"] = "Рассветные острова",
	["The Dawning Span"] = "Рассветный мост",
	["The Dawning Square"] = "Рассветная площадь",
	["The Dawning Stair"] = "Рассветная лестница",
	["The Dawning Valley"] = "Рассветная долина",
	["The Dead Acre"] = "Мертвая пашня",
	["The Dead Field"] = "Мертвое поле",
	["The Dead Fields"] = "Мертвые поля",
	["The Deadmines"] = "Мертвые копи",
	["The Dead Mire"] = "Мертвая трясина",
	["The Dead Scar"] = "Тропа Мертвых",
	["The Deathforge"] = "Кузница Смерти",
	["The Deathknell Graves"] = "Кладбище Похоронного Звона",
	["The Decrepit Fields"] = "Старая пашня",
	["The Decrepit Flow"] = "Замерший поток",
	["The Deeper"] = "Глубокая пещера",
	["The Deep Reaches"] = "Глубокие плёсы",
	["The Deepwild"] = "Дикие заросли",
	["The Defiant"] = "Непокорный",
	["The Defiled Chapel"] = "Оскверненная часовня",
	["The Den"] = "Логово",
	["The Den of Flame"] = "Огненное логово",
	["The Dens of Dying"] = "Кельи Смерти",
	["The Dens of the Dying"] = "Кельи Смерти",
	["The Descent into Madness"] = "Провал Безумия",
	["The Desecrated Altar"] = "Оскверненный алтарь",
	["The Devil's Terrace"] = "Терраса Дьявола",
	["The Devouring Breach"] = "Пожирающий разлом",
	["The Domicile"] = "Жилой квартал",
	["The Domicile "] = "Жилой квартал",
	["The Dooker Dome"] = "Дукерский Купол",
	["The Dor'Danil Barrow Den"] = "Обитель Дор'Данил",
	["The Dormitory"] = "Спальни",
	["The Drag"] = "Волок",
	["The Dragonmurk"] = "Земля Драконов",
	["The Dragon Wastes"] = "Драконьи пустоши",
	["The Drain"] = "Проток",
	["The Dranosh'ar Blockade"] = "Застава Дранош'ар",
	["The Drowned Reef"] = "Подводный риф",
	["The Drowned Sacellum"] = "Затопленная часовня",
	["The Drunken Hozen"] = "Пьяный хозен",
	["The Dry Hills"] = "Сухие холмы",
	["The Dustbowl"] = "Знойные Пески",
	["The Dust Plains"] = "Пыльные равнины",
	["The Eastern Earthshrine"] = "Восточное святилище Земли",
	["The Elders' Path"] = "Путь Старейшин",
	["The Emerald Summit"] = "Изумрудная вершина",
	["The Emperor's Approach"] = "Императорский проход",
	["The Emperor's Gate"] = "Врата Императора",
	["The Emperor's Reach"] = "Крыло императора",
	["The Emperor's Step"] = "Императорский подъем",
	["The Escape From Durnholde"] = "Побег из Дарнхольда",
	["The Escape from Durnholde Entrance"] = "Побег из Дарнхольда",
	["The Eventide"] = "Вечерняя Заря",
	["The Exodar"] = "Экзодар",
	["The Eye"] = "Око",
	["The Eye of Eternity"] = "Око Вечности",
	["The Eye of the Vortex"] = "Око Урагана",
	["The Fall of Shan Bu"] = "Падение Шань-Бу",
	["The Farstrider Lodge"] = "Приют Странников",
	["The Feeding Pits"] = "Кормовые ямы",
	["The Fel Pits"] = "Ямы Скверны",
	["The Fertile Copse"] = "Обильная поросль",
	["The Fetid Pool"] = "Зловонный пруд",
	["The Filthy Animal"] = "Грязное животное",
	["The Firehawk"] = "Огненный Ястреб",
	["The Five Sisters"] = "Пять Сестер",
	["The Flamewake"] = "Негаснущий пожар",
	["The Fleshwerks"] = "Мясопилка",
	["The Flood Plains"] = "Затопленные равнины",
	["The Fold"] = "Изгиб",
	["The Foothill Caverns"] = "Пещеры предгорий",
	["The Foot of Lei Shen"] = "Подступы ко дворцу Лэй Шэня",
	["The Foot Steppes"] = "Подножие",
	["The Forbidden Jungle"] = "Запретные джунгли",
	["The Forbidding Sea"] = "Зловещее море",
	["The Forest of Shadows"] = "Лес Теней",
	["The Forge of Souls"] = "Кузня Душ",
	["The Forge of Souls Entrance"] = "Кузня Душ",
	["The Forge of Supplication"] = "Кузня Мольбы",
	["The Forge of Wills"] = "Кузня Воли",
	["The Forgotten Coast"] = "Забытый берег",
	["The Forgotten Overlook"] = "Забытая высота",
	["The Forgotten Pool"] = "Забытый пруд",
	["The Forgotten Pools"] = "Забытые пруды",
	["The Forgotten Shore"] = "Забытое взморье",
	["The Forlorn Cavern"] = "Заброшенный грот",
	["The Forlorn Mine"] = "Заброшенный рудник",
	["The Forsaken Front"] = "Передовая Отрекшихся",
	["The Foul Pool"] = "Смрадный пруд",
	["The Frigid Tomb"] = "Стылый склеп",
	["The Frost Queen's Lair"] = "Логово Королевы Льда",
	["The Frostwing Halls"] = "Залы Ледокрылых",
	["The Frozen Glade"] = "Заиндевевшая поляна",
	["The Frozen Halls"] = "Ледяные залы",
	["The Frozen Mine"] = "Застывшая шахта",
	["The Frozen Sea"] = "Ледяное море",
	["The Frozen Throne"] = "Ледяной Трон",
	["The Fungal Vale"] = "Грибная долина",
	["The Furnace"] = "Горнило",
	["The Gaping Chasm"] = "Зияющая бездна",
	["The Gatehouse"] = "Вестибюль",
	["The Gatehouse "] = "Вестибюль",
	["The Gate of Unending Cycles"] = "Врата Бесконечного Цикла",
	["The Gauntlet"] = "Улица Испытаний",
	["The Geyser Fields"] = "Поле Гейзеров",
	["The Ghastly Confines"] = "Жуткие пределы",
	["The Gilded Foyer"] = "Золотой холл",
	["The Gilded Gate"] = "Золоченые врата",
	["The Gilding Stream"] = "Золотистая река",
	["The Glimmering Pillar"] = "Мерцающая колонна",
	["The Golden Gateway"] = "Золотые врата",
	["The Golden Hall"] = "Золотой зал",
	["The Golden Lantern"] = "Золотой фонарь",
	["The Golden Pagoda"] = "Золотая Пагода",
	["The Golden Plains"] = "Золотые равнины",
	["The Golden Rose"] = "Золотая Роза",
	["The Golden Stair"] = "Золотая лестница",
	["The Golden Terrace"] = "Золотая терраса",
	["The Gong of Hope"] = "Гонг Надежды",
	["The Grand Ballroom"] = "Большой бальный зал",
	["The Grand Vestibule"] = "Большой зал",
	["The Great Arena"] = "Большая арена",
	["The Great Divide"] = "Великий Раздел",
	["The Great Fissure"] = "Глубокий Разлом",
	["The Great Forge"] = "Великая Кузня",
	["The Great Gate"] = "Великие врата",
	["The Great Lift"] = "Великий подъемник",
	["The Great Ossuary"] = "Главный склеп",
	["The Great Sea"] = "Великое море",
	["The Great Tree"] = "Великое Древо",
	["The Great Wheel"] = "Водяное колесо",
	["The Green Belt"] = "Зеленый Пояс",
	["The Greymane Wall"] = "Стена Седогрива",
	["The Grim Guzzler"] = "Трактир Угрюмый обжора",
	["The Grinding Quarry"] = "Шлифовальня",
	["The Grizzled Den"] = "Серая берлога",
	["The Grummle Bazaar"] = "Базар груммелей",
	["The Guardhouse"] = "Караульня",
	["The Guest Chambers"] = "Гостевые комнаты",
	["The Gullet"] = "Глотка",
	["The Halfhill Market"] = "Рынок Полугорья",
	["The Half Shell"] = "Половина Оболочки",
	["The Hall of Blood"] = "Зал Крови",
	["The Hall of Gears"] = "Машинный зал",
	["The Hall of Lights"] = "Зал Света",
	["The Hall of Respite"] = "Зал Отдыха",
	["The Hall of Statues"] = "Зал Статуй",
	["The Hall of the Serpent"] = "Зал Змеи",
	["The Hall of Tiles"] = "Мозаичный зал",
	["The Halls of Reanimation"] = "Залы воскрешения",
	["The Halls of Winter"] = "Залы Зимы",
	["The Hand of Gul'dan"] = "Рука Гул'дана",
	["The Harborage"] = "Убежище",
	["The Hatchery"] = "Инкубатор",
	["The Headland"] = "Высокий отрог",
	["The Headlands"] = "Каменистый мыс",
	["The Heap"] = "Груда",
	["The Heartland"] = "Плодородные земли",
	["The Heart of Acherus"] = "Сердце Акеруса",
	["The Heart of Jade"] = "Нефритовое Сердце",
	["The Hidden Clutch"] = "Потайная кладка",
	["The Hidden Grove"] = "Сокрытая роща",
	["The Hidden Hollow"] = "Скрытая пещера",
	["The Hidden Passage"] = "Потайной ход",
	["The Hidden Reach"] = "Потайной проход",
	["The Hidden Reef"] = "Подводный риф",
	["The High Path"] = "Верхний путь",
	["The High Road"] = "Верхний путь",
	["The High Seat"] = "Высокий трон",
	["The Hinterlands"] = "Внутренние земли",
	["The Hoard"] = "Арсенал",
	["The Hole"] = "Яма",
	["The Horde Valiants' Ring"] = "Арена искателей славы из Орды",
	["The Horrid March"] = "Подступы Ужаса",
	["The Horsemen's Assembly"] = "Ассамблея наездников",
	["The Howling Hollow"] = "Воющая пещера",
	["The Howling Oak"] = "Воющий дуб",
	["The Howling Vale"] = "Воющая долина",
	["The Hunter's Reach"] = "Охотничий прицел",
	["The Hushed Bank"] = "Затихший берег",
	["The Icy Depths"] = "Ледяные глубины",
	["The Immortal Coil"] = "Серпантин Бессмертного",
	["The Imperial Exchange"] = "Императорская биржа",
	["The Imperial Granary"] = "Императорское хранилище зерна",
	["The Imperial Mercantile"] = "Императорский торговый зал",
	["The Imperial Seat"] = "Императорский Трон",
	["The Incursion"] = "Экспедиция ночных эльфов",
	["The Infectis Scar"] = "Чумной овраг",
	["The Inferno"] = "Пекло",
	["The Inner Spire"] = "Башня Сульфурона",
	["The Intrepid"] = "Отважный",
	["The Inventor's Library"] = "Библиотека Изобретателя",
	["The Iron Crucible"] = "Железный тигель",
	["The Iron Hall"] = "Железный зал",
	["The Iron Reaper"] = "Железный Жнец",
	["The Isle of Spears"] = "Остров Копий",
	["The Ivar Patch"] = "Делянка Ивара",
	["The Jade Forest"] = "Нефритовый лес",
	["The Jade Vaults"] = "Нефритовое хранилище",
	["The Jansen Stead"] = "Владение Янсена",
	["The Keggary"] = "Бочечная",
	["The Kennel"] = "Псарня",
	["The Krasari Ruins"] = "Красарангские руины",
	["The Krazzworks"] = "Психходельня",
	["The Laboratory"] = "Лаборатория",
	["The Lady Mehley"] = "Леди Мели",
	["The Lagoon"] = "Лагуна",
	["The Laughing Stand"] = "Веселая стоянка",
	["The Lazy Turnip"] = "Ленивая репа",
	["The Legerdemain Lounge"] = "Приют фокусника",
	["The Legion Front"] = "Передовая Легиона",
	["Thelgen Rock"] = "Пещера Тельгена",
	["The Librarium"] = "Библиотека",
	["The Library"] = "Библиотека",
	["The Lifebinder's Cell"] = "Темница Хранительницы Жизни",
	["The Lifeblood Pillar"] = "Колонна Жизненной Силы",
	["The Lightless Reaches"] = "Бездна Кромешной Тьмы",
	["The Lion's Redoubt"] = "Оплот Защитника",
	["The Living Grove"] = "Живая роща",
	["The Living Wood"] = "Живой лес",
	["The LMS Mark II"] = "ЛМС, модель II",
	["The Loch"] = "Озеро Лок",
	["The Long Wash"] = "Длинный пролив",
	["The Lost Fleet"] = "Погибший Флот",
	["The Lost Fold"] = "Затерянная Падь",
	["The Lost Isles"] = "Затерянные острова",
	["The Lost Lands"] = "Затерянные земли",
	["The Lost Passage"] = "Забытый проход",
	["The Low Path"] = "Нижний путь",
	Thelsamar = "Телсамар",
	["The Lucky Traveller"] = "Счастливый путник",
	["The Lyceum"] = "Лицей",
	["The Maclure Vineyards"] = "Виноградники Маклура",
	["The Maelstrom"] = "Водоворот",
	["The Maker's Overlook"] = "Дозор Творцов",
	["The Makers' Overlook"] = "Дозор Творцов",
	["The Makers' Perch"] = "Обитель Творцов",
	["The Maker's Rise"] = "Платформа Творца",
	["The Maker's Terrace"] = "Терраса Творца",
	["The Manufactory"] = "Фабрика",
	["The Marris Stead"] = "Поместье Маррисов",
	["The Marshlands"] = "Топи",
	["The Masonary"] = "Каменоломня",
	["The Master's Cellar"] = "Хозяйский погреб",
	["The Master's Glaive"] = "Меч Властителя",
	["The Maul"] = "Ристалище",
	["The Maw of Madness"] = "Бездна Безумия",
	["The Mechanar"] = "Механар",
	["The Menagerie"] = "Галерея",
	["The Menders' Stead"] = "Участок Целителей Земли",
	["The Merchant Coast"] = "Торговое побережье",
	["The Militant Mystic"] = "Воинствующий мистик",
	["The Military Quarter"] = "Военный квартал",
	["The Military Ward"] = "Палаты Войны",
	["The Mind's Eye"] = "Глаз разума",
	["The Mirror of Dawn"] = "Зеркало Рассвета",
	["The Mirror of Twilight"] = "Зеркало Сумерек",
	["The Molsen Farm"] = "Ферма Мольсена",
	["The Molten Bridge"] = "Огненный мост",
	["The Molten Core"] = "Огненные Недра",
	["The Molten Fields"] = "Раскаленные поля",
	["The Molten Flow"] = "Расплавленный поток",
	["The Molten Span"] = "Огненный путь",
	["The Mor'shan Rampart"] = "Застава Мор'шан",
	["The Mor'Shan Ramparts"] = "Застава Мор'шан",
	["The Mosslight Pillar"] = "Колонна Мохосвета",
	["The Mountain Den"] = "Горная берлога",
	["The Murder Pens"] = "Камеры обреченных",
	["The Mystic Ward"] = "Палаты Магии",
	["The Necrotic Vault"] = "Мертвые Своды",
	["The Nexus"] = "Нексус",
	["The Nexus Entrance"] = "Нексус",
	["The Nightmare Scar"] = "Ров Кошмаров",
	["The North Coast"] = "Северное побережье",
	["The North Sea"] = "Северное море",
	["The Nosebleeds"] = "Верхотура",
	["The Noxious Glade"] = "Ядовитая поляна",
	["The Noxious Hollow"] = "Ядовитая низина",
	["The Noxious Lair"] = "Ядовитый улей",
	["The Noxious Pass"] = "Гибельный путь",
	["The Oblivion"] = "Забвение",
	["The Observation Ring"] = "Круг Наблюдения",
	["The Obsidian Sanctum"] = "Обсидиановое святилище",
	["The Oculus"] = "Окулус",
	["The Oculus Entrance"] = "Окулус",
	["The Old Barracks"] = "Старые казармы",
	["The Old Dormitory"] = "Старая спальня",
	["The Old Port Authority"] = "Здание портовой инспекции",
	["The Opera Hall"] = "Оперный зал",
	["The Oracle Glade"] = "Поляна Оракула",
	["The Outer Ring"] = "Внешнее кольцо",
	["The Overgrowth"] = "Буйные заросли",
	["The Overlook"] = "Обзорная площадка",
	["The Overlook Cliffs"] = "Отвесные скалы",
	["The Overlook Inn"] = "Таверна на смотровой площадке",
	["The Ox Gate"] = "Врата Быка",
	["The Pale Roost"] = "Белое гнездовье",
	["The Park"] = "Парк",
	["The Path of Anguish"] = "Путь Страданий",
	["The Path of Conquest"] = "Путь Завоевания",
	["The Path of Corruption"] = "Порочный путь",
	["The Path of Glory"] = "Путь Славы",
	["The Path of Iron"] = "Путь Железа",
	["The Path of the Lifewarden"] = "Путь Хранителя Жизни",
	["The Phoenix Hall"] = "Зал Феникса",
	["The Pillar of Ash"] = "Башня Пепла",
	["The Pipe"] = "Труба",
	["The Pit of Criminals"] = "Яма для злодеев",
	["The Pit of Fiends"] = "Яма чудовищ",
	["The Pit of Narjun"] = "Провал Наржуна",
	["The Pit of Refuse"] = "Мусорная яма",
	["The Pit of Sacrifice"] = "Жертвенный колодец",
	["The Pit of Scales"] = "Ров Чешуи",
	["The Pit of the Fang"] = "Яма Клыка",
	["The Plague Quarter"] = "Чумной квартал",
	["The Plagueworks"] = "Чумодельня",
	["The Pool of Ask'ar"] = "Пруд Аск'ара",
	["The Pools of Vision"] = "Пруды Видений",
	["The Prison of Yogg-Saron"] = "Темница Йогг-Сарона",
	["The Proving Grounds"] = "Испытательный полигон",
	["The Purple Parlor"] = "Лиловая гостиная",
	["The Quagmire"] = "Трясина",
	["The Quaking Fields"] = "Грот Обвалов",
	["The Queen's Reprisal"] = "Месть Королевы",
	["The Raging Chasm"] = "Бушующая пропасть",
	Theramore = "Терамор",
	["Theramore Isle"] = "Остров Терамор",
	["Theramore's Fall"] = "Падение Терамора",
	["Theramore's Fall (A)"] = "Падение Терамора",
	["Theramore's Fall (H)"] = "Падение Терамора",
	["Theramore's Fall Phase"] = "Theramore's Fall Phase",
	["The Rangers' Lodge"] = "Приют следопытов",
	["Therazane's Throne"] = "Трон Теразан",
	["The Red Reaches"] = "Красные берега",
	["The Refectory"] = "Трапезная",
	["The Regrowth"] = "Молодой лес",
	["The Reliquary"] = "Хранилище реликвий",
	["The Repository"] = "Хранилище",
	["The Reservoir"] = "Резервуар",
	["The Restless Front"] = "Передовая Неупокоенных",
	["The Ridge of Ancient Flame"] = "Гряда Древнего Пламени",
	["The Rift"] = "Разлом",
	["The Ring of Balance"] = "Круг Равновесия",
	["The Ring of Blood"] = "Кольцо Крови",
	["The Ring of Champions"] = "Арена чемпионов",
	["The Ring of Inner Focus"] = "Круг Внутреннего Сосредоточения",
	["The Ring of Trials"] = "Круг Испытаний",
	["The Ring of Valor"] = "Арена Доблести",
	["The Riptide"] = "Бурун",
	["The Riverblade Den"] = "Убежище Речного Клинка",
	["Thermal Vents"] = "Отдушины",
	["The Roiling Gardens"] = "Тревожные сады",
	["The Rolling Gardens"] = "Тревожные сады",
	["The Rolling Plains"] = "Холмистые равнины",
	["The Rookery"] = "Гнездовье",
	["The Rotting Orchard"] = "Гниющий сад",
	["The Rows"] = "Огороды",
	["The Royal Exchange"] = "Королевская Биржа",
	["The Ruby Sanctum"] = "Рубиновое святилище",
	["The Ruined Reaches"] = "Опустошенный берег",
	["The Ruins of Kel'Theril"] = "Руины Кел'Терила",
	["The Ruins of Ordil'Aran"] = "Руины Ордил'Арана",
	["The Ruins of Stardust"] = "Руины Звездной Пыли",
	["The Rumble Cage"] = "Гремящая Клеть",
	["The Rustmaul Dig Site"] = "Карьер Ржавой Кувалды",
	["The Sacred Grove"] = "Священная роща",
	["The Salty Sailor Tavern"] = "Таверна Старый моряк",
	["The Sanctum"] = "Святилище",
	["The Sanctum of Blood"] = "Святилище Крови",
	["The Savage Coast"] = "Гибельный берег",
	["The Savage Glen"] = "Дикая лощина",
	["The Savage Thicket"] = "Дикая чаща",
	["The Scalding Chasm"] = "Жгучий провал",
	["The Scalding Pools"] = "Жгучие пруды",
	["The Scarab Dais"] = "Помост Скарабея",
	["The Scarab Wall"] = "Стена Скарабея",
	["The Scarlet Basilica"] = "Алая Базилика",
	["The Scarlet Bastion"] = "Бастион Алого ордена",
	["The Scorched Grove"] = "Выжженная роща",
	["The Scorched Plain"] = "Выжженная равнина",
	["The Scrap Field"] = "Захламленное поле",
	["The Scrapyard"] = "Мусорная свалка",
	["The Screaming Hall"] = "Зал Воплей",
	["The Screaming Reaches"] = "Вопящие плёсы",
	["The Screeching Canyon"] = "Каньон Визга",
	["The Scribe of Stormwind"] = "Свитки Штормграда",
	["The Scribes' Sacellum"] = "Скрипторий",
	["The Scrollkeeper's Sanctum"] = "Святилище хранителя свитков",
	["The Scullery"] = "Судомойня",
	["The Scullery "] = "Кухня",
	["The Seabolt"] = "Морская Стрела",
	["The Seabreach Flow"] = "Разлом Морского Потока",
	["The Sealed Hall"] = "Запечатанный зал",
	["The Sea of Cinders"] = "Пепельное Море",
	["The Sea Reaver's Run"] = "Пролив Грозы Морей",
	["The Searing Gateway"] = "Пылающие врата",
	["The Sea Wolf"] = "Морской волк",
	["The Secret Aerie"] = "Тайное поселение",
	["The Secret Lab"] = "Секретная лаборатория",
	["The Secrets of Ragefire"] = "Секреты Огненной Пропасти",
	["The Seer's Library"] = "Библиотека Провидца",
	["The Sepulcher"] = "Гробница",
	["The Severed Span"] = "Раздробленный надел",
	["The Sewer"] = "Стоки",
	["The Shadow Stair"] = "Лестница Теней",
	["The Shadow Throne"] = "Темный трон",
	["The Shadow Vault"] = "Мрачный Свод",
	["The Shady Nook"] = "Тенистый закоулок",
	["The Shaper's Terrace"] = "Терраса Создателя",
	["The Shattered Halls"] = "Разрушенные залы",
	["The Shattered Strand"] = "Разоренное побережье",
	["The Shattered Walkway"] = "Обвалившаяся галерея",
	["The Shepherd's Gate"] = "Врата Пастыря",
	["The Shifting Mire"] = "Ползучая трясина",
	["The Shimmering Deep"] = "Мерцающие глубины",
	["The Shimmering Flats"] = "Мерцающая равнина",
	["The Shining Strand"] = "Сияющий берег",
	["The Shrine of Aessina"] = "Святилище Эссины",
	["The Shrine of Eldretharr"] = "Святилище Элдретарра",
	["The Silent Sanctuary"] = "Тихий приют",
	["The Silkwood"] = "Шелкодревный лес",
	["The Silver Blade"] = "Серебряный Клинок",
	["The Silver Enclave"] = "Серебряный Анклав",
	["The Singing Grove"] = "Звенящая роща",
	["The Singing Pools"] = "Поющие пруды",
	["The Sin'loren"] = "Син'лорен",
	["The Skeletal Reef"] = "Риф Скелетов",
	["The Skittering Dark"] = "Оплетающая Тьма",
	["The Skull Warren"] = "Лабиринт Черепа",
	["The Skunkworks"] = "Производственный цех",
	["The Skybreaker"] = "Усмиритель небес",
	["The Skyfire"] = "Небесный огонь",
	["The Skyreach Pillar"] = "Колонна Небесного Пути",
	["The Slag Pit"] = "Шлаковая Яма",
	["The Slaughtered Lamb"] = "Таверна Забитый ягненок",
	["The Slaughter House"] = "Живодерня",
	["The Slave Pens"] = "Узилище",
	["The Slave Pits"] = "Ямы рабов",
	["The Slick"] = "Нефтяной разлив",
	["The Slithering Scar"] = "Скользкий овраг",
	["The Slough of Dispair"] = "Трясина Отчаяния",
	["The Sludge Fen"] = "Нефтяное болото",
	["The Sludge Fields"] = "Топкие поля",
	["The Sludgewerks"] = "Илоразработки",
	["The Solarium"] = "Зал Звездочета",
	["The Solar Vigil"] = "Застава Солнца",
	["The Southern Isles"] = "Южные острова",
	["The Southern Wall"] = "Южная стена",
	["The Sparkling Crawl"] = "Сверкающий ход",
	["The Spark of Imagination"] = "Искра Воображения",
	["The Spawning Glen"] = "Грибная поляна",
	["The Spire"] = "Шпиль",
	["The Splintered Path"] = "Валежный лес",
	["The Spring Road"] = "Весенняя тропа",
	["The Stadium"] = "Ристалище",
	["The Stagnant Oasis"] = "Застывший оазис",
	["The Staidridge"] = "Незыблемый утес",
	["The Stair of Destiny"] = "Ступени Судьбы",
	["The Stair of Doom"] = "Ступени Фатума",
	["The Starchaser"] = "Звездолов",
	["The Star's Bazaar"] = "Звездный Базар",
	["The Steam Pools"] = "Дымящиеся озера",
	["The Steamvault"] = "Паровое подземелье",
	["The Steppe of Life"] = "Степь Жизни",
	["The Steps of Fate"] = "Шаги Судьбы",
	["The Stinging Trail"] = "Жгучая тропа",
	["The Stockade"] = "Тюрьма",
	["The Stockpile"] = "Схрон",
	["The Stonecore"] = "Каменные Недра",
	["The Stonecore Entrance"] = "Каменные Недра",
	["The Stonefield Farm"] = "Ферма Стоунфилдов",
	["The Stone Vault"] = "Каменный свод",
	["The Storehouse"] = "Кладовая",
	["The Stormbreaker"] = "Рассекатель туч",
	["The Stormbridge"] = "Мост штормов",
	["The Storm Foundry"] = "Плавильня штормов",
	["The Storm Peaks"] = "Грозовая Гряда",
	["The Stormspire"] = "Штормовая Вершина",
	["The Stormwright's Shelf"] = "Уступ Ваятеля Бурь",
	["The Summer Fields"] = "Летние поля",
	["The Summer Terrace"] = "Летняя терраса",
	["The Sundered Shard"] = "Одинокий осколок",
	["The Sundering"] = "Разлом",
	["The Sun Forge"] = "Кузня Солнца",
	["The Sunken Ring"] = "Затопленный Круг",
	["The Sunset Brewgarden"] = "Хмелеваренный дворик На закате",
	["The Sunspire"] = "Солнечный Шпиль",
	["The Suntouched Pillar"] = "Колонна Солнечного Благословения",
	["The Sunwell"] = "Солнечный Колодец",
	["The Swarming Pillar"] = "Роящаяся вершина",
	["The Swollen Vault"] = "Древнее хранилище",
	["The Tainted Forest"] = "Проклятый лес",
	["The Tainted Scar"] = "Гниющий Шрам",
	["The Talondeep Path"] = "Туннель Когтя",
	["The Talon Den"] = "Логово Когтя",
	["The Tasting Room"] = "Дегустационная",
	["The Tempest Rift"] = "Пояс Бурь",
	["The Temple Gardens"] = "Храмовые сады",
	["The Temple of Atal'Hakkar"] = "Храм Атал'Хаккара",
	["The Temple of the Jade Serpent"] = "Храм Нефритовой Змеи",
	["The Terrestrial Watchtower"] = "Земная сторожевая башня",
	["The Thornsnarl"] = "Шипастая западня",
	["The Threads of Fate"] = "Нити судьбы",
	["The Threshold"] = "Граница",
	["The Throne of Flame"] = "Трон Пламени",
	["The Thunder Forge"] = "Кузня Грома",
	["The Thunder Forges"] = "Кузня Грома",
	["The Thundering Run"] = "Грозовой Путь",
	["The Thundering Spire"] = "Грохочущий шпиль",
	["The Thunderspire"] = "Шпиль Грома",
	["The Thunderwood"] = "Громовой лес",
	["The Tidebreaker"] = "Рассекающий Волны",
	["The Tidus Stair"] = "Лестница Прилива",
	["The Tiger's Peak"] = "Пик Тигра",
	["The Torjari Pit"] = "Тораджарская яма",
	["The Tower of Arathor"] = "Башня Аратора",
	["The Toxic Airfield"] = "Зараженный аэродром",
	["The Trail of Devastation"] = "Тропа Опустошения",
	["The Tranquil Grove"] = "Тихая роща",
	["The Transitus Stair"] = "Промежуточная лестница",
	["The Trapper's Enclave"] = "Владения Зверолова",
	["The Tribunal of Ages"] = "Трибунал Веков",
	["The Tundrid Hills"] = "Холмы Тандрид",
	["The Twilight Breach"] = "Сумеречный разлом",
	["The Twilight Caverns"] = "Сумеречные гроты",
	["The Twilight Citadel"] = "Сумеречная крепость",
	["The Twilight Enclave"] = "Владения Сумеречного Молота",
	["The Twilight Gate"] = "Сумеречные врата",
	["The Twilight Gauntlet"] = "Сумеречный ход",
	["The Twilight Ridge"] = "Сумеречная гряда",
	["The Twilight Rivulet"] = "Сумеречный ручей",
	["The Twilight Withering"] = "Сумеречная пустошь",
	["The Twin Colossals"] = "Два Колосса",
	["The Twisted Glade"] = "Холмистая поляна",
	["The Twisted Warren"] = "Извилистая нора",
	["The Two Fisted Brew"] = "У Двойного Кулака",
	["The Unbound Thicket"] = "Дикая чаща",
	["The Underbelly"] = "Клоака",
	["The Underbog"] = "Нижетопь",
	["The Underbough"] = "Подветвь",
	["The Undercroft"] = "Крипта",
	["The Underhalls"] = "Глубинные чертоги",
	["The Undershell"] = "Донный грот",
	["The Uplands"] = "Высокогорье",
	["The Upside-down Sinners"] = "Грешники на головах",
	["The Valley of Fallen Heroes"] = "Долина Павших Героев",
	["The Valley of Lost Hope"] = "Долина Потерянной Надежды",
	["The Vault of Lights"] = "Чертог Огней",
	["The Vector Coil"] = "Энергоблок",
	["The Veiled Cleft"] = "Сокрытое ущелье",
	["The Veiled Sea"] = "Сокрытое море",
	["The Veiled Stair"] = "Сокрытая лестница",
	["The Venture Co. Mine"] = "Рудник Торговой Компании",
	["The Verdant Fields"] = "Зеленеющие поля",
	["The Verdant Thicket"] = "Зеленая чаща",
	["The Verne"] = "Верн",
	["The Verne - Bridge"] = "Верн",
	["The Verne - Entryway"] = "Верн",
	["The Vibrant Glade"] = "Светлая поляна",
	["The Vice"] = "Погань",
	["The Vicious Vale"] = "Гибельная долина",
	["The Viewing Room"] = "Демонстрационная комната",
	["The Vile Reef"] = "Коварный риф",
	["The Violet Citadel"] = "Аметистовая цитадель",
	["The Violet Citadel Spire"] = "Шпиль Аметистовой цитадели",
	["The Violet Gate"] = "Аметистовые врата",
	["The Violet Hold"] = "Аметистовая крепость",
	["The Violet Spire"] = "Аметистовый шпиль",
	["The Violet Tower"] = "Аметистовая башня",
	["The Vortex Fields"] = "Вихревые поля",
	["The Vortex Pinnacle"] = "Вершина Смерча",
	["The Vortex Pinnacle Entrance"] = "Вход на Вершину Смерча",
	["The Wailing Caverns"] = "Пещеры Стенаний",
	["The Wailing Ziggurat"] = "Стонущий зиккурат",
	["The Waking Halls"] = "Чертоги Пробуждения",
	["The Wandering Isle"] = "Скитающийся остров",
	["The Warlord's Garrison"] = "Гарнизон Вождя",
	["The Warlord's Terrace"] = "Терраса Полководца",
	["The Warp Fields"] = "Искривленные поля",
	["The Warp Piston"] = "Сверхускоритель",
	["The Wavecrest"] = "Гребень Волны",
	["The Weathered Nook"] = "Угол Семи Ветров",
	["The Weeping Cave"] = "Грот Слез",
	["The Western Earthshrine"] = "Западное святилище Земли",
	["The Westrift"] = "Западная расселина",
	["The Whelping Downs"] = "Ясельные холмы",
	["The Whipple Estate"] = "Имение Уиппл",
	["The Wicked Coil"] = "Пагубный Серпантин",
	["The Wicked Grotto"] = "Оскверненный грот",
	["The Wicked Tunnels"] = "Оскверненные коридоры",
	["The Widening Deep"] = "Глубокий провал",
	["The Widow's Clutch"] = "Кладка Вдовы",
	["The Widow's Wail"] = "Плач Вдовы",
	["The Wild Plains"] = "Дикие равнины",
	["The Wild Shore"] = "Пустынный берег",
	["The Winding Halls"] = "Петляющие коридоры",
	["The Windrunner"] = "Ветрокрылая",
	["The Windspire"] = "Ветряной Шпиль",
	["The Wollerton Stead"] = "Ферма Уоллертона",
	["The Wonderworks"] = "Чудо чудное",
	["The Wood of Staves"] = "Лес Посохов",
	["The World Tree"] = "Древо Жизни",
	["The Writhing Deep"] = "Гудящая Бездна",
	["The Writhing Haunt"] = "Удел Страданий",
	["The Yaungol Advance"] = "Стоянка яунголов",
	["The Yorgen Farmstead"] = "Усадьба Йоргена",
	["The Zandalari Vanguard"] = "Авангард зандаларов",
	["The Zoram Strand"] = "Зорамское взморье",
	["Thieves Camp"] = "Воровской лагерь",
	["Thirsty Alley"] = "Переулок голодающих",
	["Thistlefur Hold"] = "Берлога Колючего Меха",
	["Thistlefur Village"] = "Деревня Колючего Меха",
	["Thistleshrub Valley"] = "Долина Кактусов",
	["Thondroril River"] = "Река Тондрорил",
	["Thoradin's Wall"] = "Стена Торадина",
	["Thorium Advance"] = "Передовая Братства Тория",
	["Thorium Point"] = "Лагерь Братства Тория",
	["Thor Modan"] = "Тор Модан",
	["Thornfang Hill"] = "Холм Колючего Клыка",
	["Thorn Hill"] = "Тернистый холм",
	["Thornmantle's Hideout"] = "Логово Терновой Мантии",
	["Thorson's Post"] = "Застава Торсона",
	["Thorvald's Camp"] = "Лагерь Торвальда",
	["Thousand Needles"] = "Тысяча Игл",
	Thrallmar = "Траллмар",
	["Thrallmar Mine"] = "Копи Траллмара",
	["Three Corners"] = "Три Угла",
	["Throne of Ancient Conquerors"] = "Трон древних завоевателей",
	["Throne of Kil'jaeden"] = "Трон Кил'джедена",
	["Throne of Neptulon"] = "Трон Нептулона",
	["Throne of the Apocalypse"] = "Трон Апокалипсиса",
	["Throne of the Damned"] = "Трон Проклятых",
	["Throne of the Elements"] = "Трон Стихий",
	["Throne of the Four Winds"] = "Трон Четырех Ветров",
	["Throne of the Tides"] = "Трон Приливов",
	["Throne of the Tides Entrance"] = "Трон Приливов",
	["Throne of Thunder"] = "Престол Гроз",
	["Throne of Tides"] = "Трон Приливов",
	["Thrym's End"] = "Тупик Трыма",
	["Thunder Axe Fortress"] = "Крепость Громового Топора",
	Thunderbluff = "Громовой Утес",
	["Thunder Bluff"] = "Громовой Утес",
	["Thunderbrew Distillery"] = "Таверна Громоварка",
	["Thunder Cleft"] = "Громовая Расселина",
	Thunderfall = "Громовержье",
	["Thunder Falls"] = "Ревущий водопад",
	["Thunderfoot Farm"] = "Ферма Громовой Пяты",
	["Thunderfoot Fields"] = "Луга Громовой Пяты",
	["Thunderfoot Inn"] = "Таверна Громовой Пяты",
	["Thunderfoot Ranch"] = "Ранчо Громовой Пяты",
	["Thunder Hold"] = "Громовая крепость",
	["Thunderhorn Water Well"] = "Колодец Громового Рога",
	["Thundering Overlook"] = "Дозорное укрепление Грохочущего Грома",
	["Thunder Island Alliance Hub"] = "Thunder Island Alliance Hub",
	["Thunder King Horde Hub"] = "Thunder King Horde Hub",
	["Thunder King's Citadel"] = "Цитадель Властелина Грома",
	["Thunderlord Stronghold"] = "Оплот Громоборцев",
	Thundermar = "Громтар",
	["Thundermar Ruins"] = "Руины Громтара",
	["Thunderpaw Overlook"] = "Пик Громовой Лапы",
	["Thunderpaw Refuge"] = "Укрытие Громовой Лапы",
	["Thunder Peak"] = "Громовая вершина",
	["Thunder Ridge"] = "Громовой хребет",
	["Thunder's Call"] = "Громовой Зов",
	["Thunderstrike Mountain"] = "Гора Громового Удара",
	["Thunk's Abode"] = "Обитель Тунка",
	["Thuron's Livery"] = "Стойла Турона",
	["Tian Monastery"] = "Монастырь Тянь",
	["Tidefury Cove"] = "Залив Яростных Волн",
	["Tides' Hollow"] = "Пещера Приливов",
	["Tideview Thicket"] = "Чаща Приливов",
	["Tigers' Wood"] = "Тигриный лес",
	["Timbermaw Hold"] = "Крепость Древобрюхов",
	["Timbermaw Post"] = "Застава Древобрюхов",
	["Tinkers' Court"] = "Двор Механиков",
	["Tinker Town"] = "Город Механиков",
	["Tiragarde Keep"] = "Крепость Тирагард",
	["Tirisfal Glades"] = "Тирисфальские леса",
	["Tirth's Haunt"] = "Откос Тирта",
	["Tkashi Ruins"] = "Руины Ткаши",
	["Tol Barad"] = "Тол Барад",
	["Tol Barad Peninsula"] = "Полуостров Тол Барад",
	["Tol'Vir Arena"] = "Арена Тол'вира",
	["Tol'viron Arena"] = "Арена Тол'вир",
	["Tol'Viron Arena"] = "Арена Тол'вир",
	["Tomb of Conquerors"] = "Гробница Завоевателей",
	["Tomb of Lights"] = "Гробница Света",
	["Tomb of Secrets"] = "Гробница Секретов",
	["Tomb of Shadows"] = "Гробница Теней",
	["Tomb of the Ancients"] = "Могила Древних",
	["Tomb of the Earthrager"] = "Гробница Ярости Земли",
	["Tomb of the Lost Kings"] = "Могила Побежденных Королей",
	["Tomb of the Sun King"] = "Гробница Солнечного короля",
	["Tomb of the Watchers"] = "Гробница Стражей",
	["Tombs of the Precursors"] = "Гробницы Предтеч",
	["Tome of the Unrepentant"] = "Фолиант Нераскаявшегося",
	["Tome of the Unrepentant "] = "Фолиант Нераскаявшегося",
	["Tor'kren Farm"] = "Ферма Тор'кренов",
	["Torp's Farm"] = "Ферма Торпа",
	["Torseg's Rest"] = "Покой Торсега",
	["Tor'Watha"] = "Тор'Вата",
	["Toryl Estate"] = "Имение Торила",
	["Toshley's Station"] = "Станция Тошли",
	["To the Skies!"] = "В небо!",
	["To The Skies!"] = "В небо!",
	["Tower of Althalaxx"] = "Башня Алталакса",
	["Tower of Azora"] = "Башня Азоры",
	["Tower of Eldara"] = "Башня Эльдары",
	["Tower of Estulan"] = "Башня Эстулана",
	["Tower of Ilgalar"] = "Башня Илгалара",
	["Tower of the Damned"] = "Башня Проклятых",
	["Tower Point"] = "Смотровая башня",
	["Tower Watch"] = "Часовая башня",
	["Town-In-A-Box"] = "Городок-из-табакерки",
	["Townlong Steppes"] = "Танлунские степи",
	["Town Square"] = "Городская площадь",
	["Trade District"] = "Торговый квартал",
	["Trade Quarter"] = "Торговый квартал",
	["Trader's Tier"] = "Торговый ряд",
	["Tradesmen's Terrace"] = "Терраса Торговцев",
	["Train Depot"] = "Депо",
	["Training Grounds"] = "Тренировочная площадка",
	["Training Quarters"] = "Тренировочные залы",
	["Traitor's Cove"] = "Бухта Изменника",
	["Tranquil Coast"] = "Тихий берег",
	["Tranquil Gardens Cemetery"] = "Безмятежное кладбище",
	["Tranquil Grotto"] = "Уголок Спокойствия",
	Tranquillien = "Транквиллион",
	["Tranquil Shore"] = "Безмятежный берег",
	["Tranquil Wash"] = "Тихий залив",
	Transborea = "Трансборея",
	["Transitus Shield"] = "Маскировочный щит",
	["Transport: Alliance Gunship"] = "Транспорт: боевой корабль Альянса",
	["Transport: Alliance Gunship (IGB)"] = "Транспорт: боевой корабль Альянса (IGB)",
	["Transport: Horde Gunship"] = "Транспорт: боевой корабль Орды",
	["Transport: Horde Gunship (IGB)"] = "Транспорт: боевой корабль Орды (IGB)",
	["Transport: Onyxia/Nefarian Elevator"] = "Транспорт: подъемник от Ониксии к Нефариану",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Транспорт: Могучий ветер (Цитадель Ледяной Короны, рейд)",
	["Trelleum Mine"] = "Рудник Треллеума",
	["Trial of Fire"] = "Испытание Огнем",
	["Trial of Frost"] = "Испытание холодом",
	["Trial of Shadow"] = "Испытание Тьмой",
	["Trial of the Champion"] = "Испытание чемпиона",
	["Trial of the Champion Entrance"] = "Испытание чемпиона",
	["Trial of the Crusader"] = "Испытание крестоносца",
	["Trickling Passage"] = "Сырой проход",
	["Trogma's Claim"] = "Участок Трогмы",
	["Trollbane Hall"] = "Зал Троллебоя",
	["Troll War Camp Outskirts"] = "Окраины военного лагеря троллей",
	["Trophy Hall"] = "Зал трофеев",
	["Troves of the Thunder King"] = "Сокровищница Властелина Грома",
	["Trueshot Point"] = "Лагерь Меткого Выстрела",
	["Tuluman's Landing"] = "Лагерь Тулумана",
	["Turtle Beach"] = "Черепаший пляж",
	["Tu Shen Burial Ground"] = "Кладбище Ту-Шэнь",
	Tuurem = "Туурем",
	["Twilight Aerie"] = "Сумеречное гнездилище",
	["Twilight Altar of Storms"] = "Сумеречный Алтарь Бурь",
	["Twilight Base Camp"] = "Сумеречный лагерь",
	["Twilight Bulwark"] = "Бастион Сумрака",
	["Twilight Camp"] = "Сумеречный лагерь",
	["Twilight Command Post"] = "Командный лагерь Сумеречного Молота",
	["Twilight Crossing"] = "Сумеречный перекресток",
	["Twilight Forge"] = "Сумеречная кузня",
	["Twilight Grove"] = "Мглистая роща",
	["Twilight Highlands"] = "Сумеречное нагорье",
	["Twilight Highlands Dragonmaw Phase"] = "Сумеречное нагорье, фаза Драконьей Пасти",
	["Twilight Highlands Phased Entrance"] = "Twilight Highlands Phased Entrance",
	["Twilight Highlands Zeppelin 1"] = "Twilight Highlands Zeppelin 1",
	["Twilight Highlands Zeppelin 2"] = "Twilight Highlands Zeppelin 2",
	["Twilight Outpost"] = "Сумеречный форт",
	["Twilight Overlook"] = "Дозорный холм Сумеречного Молота",
	["Twilight Post"] = "Сумеречная застава",
	["Twilight Precipice"] = "Сумеречная пропасть",
	["Twilight Shore"] = "Сумеречный берег",
	["Twilight's Run"] = "Сумеречная пещера",
	["Twilight Terrace"] = "Сумеречная терраса",
	["Twilight Vale"] = "Сумеречная долина",
	["Twinbraid's Patrol"] = "Обход Двукоссы",
	["Twin Peaks"] = "Два Пика",
	["Twin Shores"] = "Два берега",
	["Twinspire Keep"] = "Крепость Двух Башен",
	["Twinspire Keep Interior"] = "Внутрення часть Крепости Двух Башен",
	["Twin Spire Ruins"] = "Руины Двух Башен",
	["Twisting Nether"] = "Круговерть Пустоты",
	["Tyr's Hand"] = "Длань Тира",
	["Tyr's Hand Abbey"] = "Аббатство Длани Тира",
	["Tyr's Terrace"] = "Терраса Тира",
	["Ufrang's Hall"] = "Зал Уфранга",
	Uldaman = "Ульдаман",
	["Uldaman Entrance"] = "Ульдаман",
	Uldis = "Ульдис",
	Ulduar = "Ульдуар",
	["Ulduar Raid - Interior - Insertion Point"] = "Ульдуар рейд - внутреннее помещение - точка входа",
	["Ulduar Raid - Iron Concourse"] = "Ульдуар рейд - Железный двор",
	Uldum = "Ульдум",
	["Uldum Phased Entrance"] = "Uldum Phased Entrance",
	["Uldum Phase Oasis"] = "Ульдум фаза оазиса",
	["Uldum - Phase Wrecked Camp"] = "Uldum - Phase Wrecked Camp",
	["Umbrafen Lake"] = "Озеро Тенетопь",
	["Umbrafen Village"] = "Деревня Тенетопь",
	["Uncharted Sea"] = "Неведанное море",
	Undercity = "Подгород",
	["Underlight Canyon"] = "Затемненная впадина",
	["Underlight Mines"] = "Беспросветные рудники",
	["Unearthed Grounds"] = "Место раскопок",
	["Unga Ingoo"] = "Унга-Ингу",
	["Un'Goro Crater"] = "Кратер Ун'Горо",
	["Unu'pe"] = "Уну'пе",
	["Unyielding Garrison"] = "Стойкий гарнизон",
	["Upper Silvermarsh"] = "Верховье Серебристой топи",
	["Upper Sumprushes"] = "Верхние Камышовые топи",
	["Upper Veil Shil'ak"] = "Верхнее гнездовье Шил'ак",
	["Ursoc's Den"] = "Логово Урсока",
	Ursolan = "Урсолан",
	["Utgarde Catacombs"] = "Катакомбы Утгард",
	["Utgarde Keep"] = "Крепость Утгард",
	["Utgarde Keep Entrance"] = "Крепость Утгард",
	["Utgarde Pinnacle"] = "Вершина Утгард",
	["Utgarde Pinnacle Entrance"] = "Вершина Утгард",
	["Uther's Tomb"] = "Гробница Утера",
	["Valaar's Berth"] = "Причал Валаара",
	["Vale of Eternal Blossoms"] = "Вечноцветущий дол",
	["Valgan's Field"] = "Поле Валгана",
	Valgarde = "Валгард",
	["Valgarde Port"] = "Валгардский порт",
	Valhalas = "Валхалас",
	["Valiance Keep"] = "Крепость Отваги",
	["Valiance Landing Camp"] = "Лагерь Отваги",
	["Valiant Rest"] = "Приют храбрецов",
	Valkyrion = "Валькирион",
	["Valley of Ancient Winters"] = "Долина Древних Зим",
	["Valley of Ashes"] = "Долина пепла",
	["Valley of Bones"] = "Долина Костей",
	["Valley of Echoes"] = "Долина Эха",
	["Valley of Emperors"] = "Долина Императоров",
	["Valley of Fangs"] = "Долина Клыков",
	["Valley of Heroes"] = "Аллея Героев",
	["Valley Of Heroes"] = "Аллея Героев",
	["Valley of Honor"] = "Аллея Чести",
	["Valley of Kings"] = "Долина Королей",
	["Valley of Power"] = "Долина Силы",
	["Valley Of Power - Scenario"] = "Долина Силы - сценарий",
	["Valley of Spears"] = "Долина Копий",
	["Valley of Spirits"] = "Аллея Духов",
	["Valley of Strength"] = "Аллея Силы",
	["Valley of the Bloodfuries"] = "Долина Кровавой Ярости",
	["Valley of the Four Winds"] = "Долина Четырех Ветров",
	["Valley of the Watchers"] = "Долина Стражей",
	["Valley of Trials"] = "Долина Испытаний",
	["Valley of Wisdom"] = "Аллея Мудрости",
	Valormok = "Храбростан",
	["Valor's Edge"] = "Клинок Доблести",
	["Valor's Rest"] = "Погост Отважных",
	["Valorwind Lake"] = "Озеро Доблести",
	["Vanguard Infirmary"] = "Лазарет Оплота",
	["Vanndir Encampment"] = "Лагерь Ванндир",
	["Vargoth's Retreat"] = "Укрытие Варгота",
	["Vashj'elan Spawning Pool"] = "Лягушатник Вайш'элана",
	["Vashj'ir"] = "Вайш'ир",
	["Vashj'ir Sub - Alliance"] = "Vashj'ir Sub - Alliance",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "Vashj'ir Sub - Alliance circling Abyssal Maw",
	["Vashj'ir Sub - Horde"] = "Vashj'ir Sub - Horde",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "Vashj'ir Sub - Horde - Circling Abyssal Maw",
	["Vault of Archavon"] = "Склеп Аркавона",
	["Vault of Ironforge"] = "Банк Стальгорна",
	["Vault of Kings Past"] = "Королевское хранилище",
	["Vault of the Ravenian"] = "Склеп Равениана",
	["Vault of the Shadowflame"] = "Склеп Пламени Тьмы",
	["Vault of Y'Shaarj"] = "Склеп И'Шараджа",
	["Veil Ala'rak"] = "Гнездовье Ала'рак",
	["Veil Harr'ik"] = "Гнездовье Харр'ик",
	["Veil Lashh"] = "Гнездовье Лашш",
	["Veil Lithic"] = "Гнездовье Литик",
	["Veil Reskk"] = "Гнездовье Ресск",
	["Veil Rhaze"] = "Гнездовье Рейз",
	["Veil Ruuan"] = "Гнездовье Рууан",
	["Veil Sethekk"] = "Гнездовье Сетекк",
	["Veil Shalas"] = "Гнездовье Шалас",
	["Veil Shienor"] = "Гнездовье Шиенор",
	["Veil Skith"] = "Гнездовье Скит",
	["Veil Vekh"] = "Гнездовье Векх",
	["Vekhaar Stand"] = "Перелесок Векхаар",
	["Velaani's Arcane Goods"] = "Чародейские товары Велаани",
	["Vendetta Point"] = "Лагерь Вендетты",
	["Vengeance Landing"] = "Лагерь Возмездия",
	["Vengeance Landing Inn"] = "Таверна Лагеря возмездия",
	["Vengeance Landing Inn, Howling Fjord"] = "Таверна Лагеря возмездия, Ревущий фьорд",
	["Vengeance Lift"] = "Подъемник лагеря Возмездия",
	["Vengeance Pass"] = "Перевал Возмездия",
	["Vengeance Wake"] = "Караул Возмездия",
	["Venomous Ledge"] = "Ядовитая гряда",
	Venomspite = "Ядозлобь",
	["Venomsting Pits"] = "Ямы ядохвостов",
	["Venomweb Vale"] = "Долина ядовитых пауков",
	["Venture Bay"] = "Бухта торговцев",
	["Venture Co. Base Camp"] = "Главный лагерь Торговой Компании",
	["Venture Co. Operations Center"] = "Штаб-квартира Торговой Компании",
	["Verdant Belt"] = "Луговые угодья",
	["Verdant Highlands"] = "Зеленеющее нагорье",
	["Verdantis River"] = "Река Вердантис",
	["Veridian Point"] = "Вершина Веридиан",
	["Verlok Stand"] = "Верлок",
	["Vermillion Redoubt"] = "Гранатовый редут",
	["Verming Tunnels Micro"] = "Малые туннели гну-синей",
	["Verrall Delta"] = "Дельта Вералла",
	["Verrall River"] = "Река Вералл",
	["Victor's Point"] = "Лагерь Победителя",
	["Vileprey Village"] = "Деревня Жестокой Травли",
	["Vim'gol's Circle"] = "Круг Вим'гола",
	["Vindicator's Rest"] = "Привал Защитника",
	["Violet Citadel Balcony"] = "Балкон Аметистовой цитадели",
	["Violet Hold"] = "Аметистовая крепость",
	["Violet Hold Entrance"] = "Аметистовая крепость",
	["Violet Rise"] = "Аметистовый утес",
	["Violet Stand"] = "Аметистовая застава",
	["Virmen Grotto"] = "Укрытие гну-синей",
	["Virmen Nest"] = "Гнездо гну-синей",
	["Vir'naal Dam"] = "Запруда Вир'наал",
	["Vir'naal Lake"] = "Озеро Вир'наал",
	["Vir'naal Oasis"] = "Оазис Вир'наал",
	["Vir'naal River"] = "Река Вир'наал",
	["Vir'naal River Delta"] = "Дельта Вир'наала",
	["Void Ridge"] = "Пустынный обрыв",
	["Voidwind Plateau"] = "Плато Пустынного Ветра",
	["Volcanoth's Lair"] = "Пещера Вулканота",
	["Voldrin's Hold"] = "Крепость Волдрина",
	Voldrune = "Волдрун",
	["Voldrune Dwelling"] = "Поселение Волдрун",
	Voltarus = "Волтар",
	["Vordrassil Pass"] = "Перевал Фордрассил",
	["Vordrassil's Heart"] = "Сердце Фордрассила",
	["Vordrassil's Limb"] = "Ветви Фордрассила",
	["Vordrassil's Tears"] = "Слезы Фордрассила",
	["Vortex Pinnacle"] = "Вершина смерча",
	["Vortex Summit"] = "Вершина Смерча",
	["Vul'Gol Ogre Mound"] = "Лощина Вул'Гол",
	["Vyletongue Seat"] = "Палата Злоязыкого",
	["Wahl Cottage"] = "Домик Валь",
	["Wailing Caverns"] = "Пещеры Стенаний",
	["Walk of Elders"] = "Путь Старейшин",
	["Warbringer's Ring"] = "Арена Завоевателя",
	["Warchief's Lookout"] = "Дозорный пункт вождя",
	["Warden's Cage"] = "Клеть Стражницы",
	["Warden's Chambers"] = "Комнаты стражей",
	["Warden's Vigil"] = "Пост Стража",
	["Warlock Area"] = "Warlock Area",
	["Warmaul Hill"] = "Холм Боевого Молота",
	["Warpwood Quarter"] = "Квартал Криводревов",
	["War Quarter"] = "Квартал Воинов",
	["Warrior's Terrace"] = "Терраса Воинов",
	["War Room"] = "Зал Войны",
	Warship = "Боевой корабль",
	["Warsong Camp"] = "Лагерь Песни Войны",
	["Warsong Farms Outpost"] = "Застава у ферм Песни войны",
	["Warsong Flag Room"] = "Флаговая комната Песни Войны",
	["Warsong Granary"] = "Амбар Песни Войны",
	["Warsong Gulch"] = "Ущелье Песни Войны",
	["Warsong Hold"] = "Крепость Песни Войны",
	["Warsong Jetty"] = "Пристань Песни Войны",
	["Warsong Labor Camp"] = "Рабочий лагерь Песни Войны",
	["Warsong Lumber Camp"] = "Лесозаготовки Песни Войны",
	["Warsong Lumber Mill"] = "Лесопилка Песни Войны",
	["Warsong Slaughterhouse"] = "Скотобойня Песни Войны",
	["Watcher's Sanctum"] = "Святилище наблюдателя",
	["Watchers' Terrace"] = "Терраса Стражей",
	["Waterspeaker's Sanctuary"] = "Святилище говорящих с водой",
	["Waterspring Field"] = "Родниковое поле",
	Waterworks = "Водокачка",
	["Wavestrider Beach"] = "Берег Морского Бродяги",
	Waxwood = "Буковый лес",
	["Wayfarer's Rest"] = "Приют скитальца",
	Waygate = "Связующая спираль",
	["Wayne's Refuge"] = "Приют Уэйна",
	["Weazel's Crater"] = "Кратер Криворука",
	["Webwinder Hollow"] = "Паучья лощина",
	["Webwinder Path"] = "Паучий тракт",
	["Weeping Quarry"] = "Саронитовый карьер",
	["Well of Eternity"] = "Источник Вечности",
	["Well of the Forgotten"] = "Колодец Забытых",
	["Wellson Shipyard"] = "Верфь Веллсона",
	["Wellspring Hovel"] = "Родниковый шалаш",
	["Wellspring Lake"] = "Родниковое озеро",
	["Wellspring River"] = "Родниковая река",
	["Westbrook Garrison"] = "Гарнизон у Западного ручья",
	["Western Bridge"] = "Западный мост",
	["Western Plaguelands"] = "Западные Чумные земли",
	["Western Strand"] = "Западное побережье",
	Westersea = "Западное море",
	Westfall = "Западный Край",
	["Westfall Brigade"] = "Westfall Brigade",
	["Westfall Brigade Encampment"] = "Лагерь дружины Западного Края",
	["Westfall Lighthouse"] = "Маяк в Западном Крае",
	["West Garrison"] = "Западный гарнизон",
	["Westguard Inn"] = "Таверна Западной Стражи",
	["Westguard Keep"] = "Крепость Западной Стражи",
	["Westguard Turret"] = "Башня Западной Стражи",
	["West Pavilion"] = "Западный павильон",
	["West Pillar"] = "Западная колонна",
	["West Point Station"] = "Западная станция",
	["West Point Tower"] = "Западная башня",
	["Westreach Summit"] = "Вершина Западного Предела",
	["West Sanctum"] = "Западное святилище",
	["Westspark Workshop"] = "Мастерская на западе парка",
	["West Spear Tower"] = "Западная башня",
	["West Spire"] = "Западный шпиль",
	["Westwind Lift"] = "Подъемник Западного Ветра",
	["Westwind Refugee Camp"] = "Лагерь беженцев Западного Ветра",
	["Westwind Rest"] = "Приют Западного Ветра",
	Wetlands = "Болотина",
	Wheelhouse = "Рулевая рубка",
	["Whelgar's Excavation Site"] = "Раскопки Вельгара",
	["Whelgar's Retreat"] = "Укрытие Вельгара",
	["Whispercloud Rise"] = "Вершина Шепота Облака",
	["Whisper Gulch"] = "Шепчущая теснина",
	["Whispering Forest"] = "Шепчущий лес",
	["Whispering Gardens"] = "Шепчущие сады",
	["Whispering Inlet"] = "Бухта Шепотов",
	["Whispering Shore"] = "Шепчущий берег",
	["Whispering Stones"] = "Шепчущие Камни",
	["Whisperwind Grove"] = "Роща Шелеста Ветра",
	["Whistling Grove"] = "Роща Трелей",
	["Whitebeard's Encampment"] = "Лагерь Белоборода",
	["Whitepetal Lake"] = "Озеро Белых Лепестков",
	["White Pine Trading Post"] = "Торговая лавка Белой Сосны",
	["Whitereach Post"] = "Застава Белого Плеса",
	["Wildbend River"] = "Петляющая река",
	["Wildervar Mine"] = "Вилдерварская шахта",
	["Wildflame Point"] = "Лагерь Возгорания",
	["Wildgrowth Mangal"] = "Дикие мангровые заросли",
	["Wildhammer Flag Room"] = "Флаговая комната Громового Молота",
	["Wildhammer Keep"] = "Крепость Громового Молота",
	["Wildhammer Stronghold"] = "Цитадель Громового Молота",
	["Wildheart Point"] = "Лагерь Дикого Сердца",
	["Wildmane Water Well"] = "Колодец Буйногривых",
	["Wild Overlook"] = "Лесной наблюдательный пункт",
	["Wildpaw Cavern"] = "Пещера Дикой Лапы",
	["Wildpaw Ridge"] = "Гряда Дикой Лапы",
	["Wilds' Edge Inn"] = "Таверна На краю леса",
	["Wild Shore"] = "Пустынный берег",
	["Wildvine Marsh"] = "Болото Дикой лозы",
	["Wildwind Lake"] = "Штормовое озеро",
	["Wildwind Path"] = "Штормовой путь",
	["Wildwind Peak"] = "Штормовой Пик",
	["Windbreak Canyon"] = "Безветренный каньон",
	["Windfury Ridge"] = "Гряда Неистовства Ветра",
	["Windrunner's Overlook"] = "Дозор Ветрокрылой",
	["Windrunner Spire"] = "Шпили Ветрокрылых",
	["Windrunner Village"] = "Деревня Ветрокрылых",
	["Winds' Edge"] = "Край ветров",
	["Windshear Crag"] = "Утес Ветрорезов",
	["Windshear Heights"] = "Высота Ветрорезов",
	["Windshear Hold"] = "Крепость Ветрорезов",
	["Windshear Mine"] = "Рудник Ветрорезов",
	["Windshear Valley"] = "Долина Ветрорезов",
	["Windspire Bridge"] = "Мост Ветряного Шпиля",
	["Windward Isle"] = "Наветренный остров",
	["Windy Bluffs"] = "Ветряные утесы",
	["Windyreed Pass"] = "Перевал Трепещущего Тростника",
	["Windyreed Village"] = "Деревня Трепещущего Тростника",
	["Winterax Hold"] = "Форт Ледяной Секиры",
	["Winterbough Glade"] = "Опушка Зимней Ветви",
	["Winterfall Village"] = "Деревня Зимней Спячки",
	["Winterfin Caverns"] = "Пещеры Зимних Плавников",
	["Winterfin Retreat"] = "Приют Зимних Плавников",
	["Winterfin Village"] = "Деревня Зимних Плавников",
	["Wintergarde Crypt"] = "Склеп Стражей Зимы",
	["Wintergarde Keep"] = "Крепость Стражей Зимы",
	["Wintergarde Mausoleum"] = "Усыпальница Стражей Зимы",
	["Wintergarde Mine"] = "Рудник Стражей Зимы",
	Wintergrasp = "Озеро Ледяных Оков",
	["Wintergrasp Fortress"] = "Крепость Ледяных Оков",
	["Wintergrasp River"] = "Река Ледяных Оков",
	["Winterhoof Water Well"] = "Колодец Заиндевевшего Копыта",
	["Winter's Blossom"] = "Лагерь Зимнего Цветения",
	["Winter's Breath Lake"] = "Озеро Дыхания Зимы",
	["Winter's Edge Tower"] = "Башня Клинка Зимы",
	["Winter's Heart"] = "Сердце зимы",
	Winterspring = "Зимние Ключи",
	["Winter's Terrace"] = "Зимняя терраса",
	["Witch Hill"] = "Ведьмин холм",
	["Witch's Sanctum"] = "Ведьмино убежище",
	["Witherbark Caverns"] = "Пещеры Сухокожих",
	["Witherbark Village"] = "Деревня Сухокожих",
	["Withering Thicket"] = "Увядающая роща",
	["Wizard Row"] = "Путь Волшебника",
	["Wizard's Sanctum"] = "Башня магов",
	["Wolf's Run"] = "Волчья Тропа",
	["Woodpaw Den"] = "Логово Древолапов",
	["Woodpaw Hills"] = "Холмы Древолапов",
	["Wood's End Cabin"] = "Охотничий домик на краю леса",
	["Woods of the Lost"] = "Леса Потерянных",
	Workshop = "Мастерская",
	["Workshop Entrance"] = "Вход в мастерскую",
	["World's End Tavern"] = "Таверна На краю земли",
	["Wrathscale Lair"] = "Логово клана Зловещей Чешуи",
	["Wrathscale Point"] = "Руины клана Зловещей Чешуи",
	["Wreckage of the Silver Dawning"] = "Место крушения Серебряной Зари",
	["Wreck of Hellscream's Fist"] = "Место падения Кулака Адского Крика",
	["Wreck of the Mist-Hopper"] = "Обломки Туманного Кузнечика",
	["Wreck of the Skyseeker"] = "Место падения Небесного искателя",
	["Wreck of the Vanguard"] = "Обломки Авангарда",
	["Writhing Mound"] = "Перекопанный курган",
	Writhingwood = "Кривое дерево",
	["Wu-Song Village"] = "Деревня У-Сун",
	Wyrmbog = "Драконьи топи",
	["Wyrmbreaker's Rookery"] = "Площадка Халфия",
	["Wyrmrest Summit"] = "Вершина Храма Драконьего Покоя",
	["Wyrmrest Temple"] = "Храм Драконьего Покоя",
	["Wyrmrest Temple - bottom to middle"] = "Wyrmrest Temple - bottom to middle",
	["Wyrmrest Temple - bottom to top"] = "Wyrmrest Temple - bottom to top",
	["Wyrmrest Temple - middle to bottom"] = "Wyrmrest Temple - middle to bottom",
	["Wyrmrest Temple - middle to top"] = "Wyrmrest Temple - middle to top",
	["Wyrmrest Temple - top to bottom"] = "Wyrmrest Temple - top to bottom",
	["Wyrmrest Temple - top to middle"] = "Wyrmrest Temple - top to middle",
	["Wyrms' Bend"] = "Излучина Змея",
	["Wyrmscar Island"] = "Остров Драконьей Скорби",
	["Wyrmskull Bridge"] = "Мост Драконьего Черепа",
	["Wyrmskull Tunnel"] = "Туннель Драконьего Черепа",
	["Wyrmskull Village"] = "Деревня Драконьего Черепа",
	["X-2 Pincer"] = "Хват X2",
	Xavian = "Ксавиан",
	["Yan-Zhe River"] = "Река Янь-Цзэ",
	["Yeti Mountain Basecamp"] = "Лагерь горных йети",
	["Yinying Village"] = "Деревенька Иньин",
	Ymirheim = "Имирхейм",
	["Ymiron's Seat"] = "Трон Имирона",
	["Yojamba Isle"] = "Остров Йоджамба",
	["Yowler's Den"] = "Логово Изувоя",
	["Zabra'jin"] = "Забра'джин",
	["Zaetar's Choice"] = "Выбор Зейтара",
	["Zaetar's Grave"] = "Могила Зейтара",
	["Zalashji's Den"] = "Логово Залашьи",
	["Zalazane's Fall"] = "Падение Залазана",
	["Zane's Eye Crater"] = "Око Зейна",
	Zangarmarsh = "Зангартопь",
	["Zangar Ridge"] = "Гряда Зангара",
	["Zan'vess"] = "Зан'весс",
	["Za'Tual"] = "За'Туал",
	["Zeb'Halak"] = "Зеб'Халак",
	["Zeb'Nowa"] = "Зеб'Нова",
	["Zeb'Sora"] = "Зеб'Сора",
	["Zeb'Tela"] = "Зеб'Тела",
	["Zeb'tula"] = "Зеб'тул",
	["Zeb'Watha"] = "Зеб'Вата",
	["Zeppelin Crash"] = "Место крушения дирижабля",
	Zeramas = "Зерамас",
	["Zeth'Gor"] = "Зет'Гор",
	["Zhu Province"] = "Провинция Чжу",
	["Zhu's Descent"] = "Спуск Чжу",
	["Zhu's Watch"] = "Дозор Чжу",
	["Ziata'jai Ruins"] = "Руины Зиата'джаи",
	["Zim'Abwa"] = "Зим'Абва",
	["Zim'bo's Hideout"] = "Убежище Зим'бо",
	["Zim'Rhuk"] = "Зим'Рук",
	["Zim'Torga"] = "Зим'Торга",
	["Zol'Heb"] = "Зол'Хеб",
	["Zol'Maz Stronghold"] = "Крепость Зол'Маз",
	["Zoram'gar Outpost"] = "Застава Зорам'гар",
	["Zouchin Province"] = "Провинция Цзоучин",
	["Zouchin Strand"] = "Берег Цзоучин",
	["Zouchin Village"] = "Деревня Цзоучин",
	["Zul'Aman"] = "Зул'Аман",
	["Zul'Drak"] = "Зул'Драк",
	["Zul'Farrak"] = "Зул'Фаррак",
	["Zul'Farrak Entrance"] = "Вход в Зул'Фаррак",
	["Zul'Gurub"] = "Зул'Гуруб",
	["Zul'Mashar"] = "Зул'Машар",
	["Zun'watha"] = "Зун'вата",
	["Zuuldaia Ruins"] = "Руины Зуулдая",
}

elseif GAME_LOCALE == "zhCN" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "第七军团营地",
	["7th Legion Front"] = "第七军团前线",
	["7th Legion Submarine"] = "第七军团潜艇",
	["Abandoned Armory"] = "废弃的军械库",
	["Abandoned Camp"] = "被遗弃的营地",
	["Abandoned Mine"] = "被遗弃的矿洞",
	["Abandoned Reef"] = "被遗弃的珊瑚礁",
	["Above the Frozen Sea"] = "冰冻之海上空",
	["A Brewing Storm"] = "酝酿风暴",
	["Abyssal Breach"] = "深渊裂口",
	["Abyssal Depths"] = "无底海渊",
	["Abyssal Halls"] = "深渊大厅",
	["Abyssal Maw"] = "深渊之喉",
	["Abyssal Maw Exterior"] = "深渊之喉外部",
	["Abyssal Sands"] = "深沙平原",
	["Abyssion's Lair"] = "艾比希昂的巢穴",
	["Access Shaft Zeon"] = "瑟安竖井",
	["Acherus: The Ebon Hold"] = "阿彻鲁斯：黑锋要塞",
	["Addle's Stead"] = "腐草农场",
	["Aderic's Repose"] = "埃德里奇的安息地",
	["Aerie Peak"] = "鹰巢山",
	["Aeris Landing"] = "埃瑞斯码头",
	["Agamand Family Crypt"] = "阿加曼德家族墓穴",
	["Agamand Mills"] = "阿加曼德磨坊",
	["Agmar's Hammer"] = "阿格玛之锤",
	["Agmond's End"] = "阿戈莫德的营地",
	["Agol'watha"] = "亚戈瓦萨",
	["A Hero's Welcome"] = "英雄之家",
	["Ahn'kahet: The Old Kingdom"] = "安卡赫特：古代王国",
	["Ahn'kahet: The Old Kingdom Entrance"] = "安卡赫特：古代王国入口",
	["Ahn Qiraj"] = "安其拉",
	["Ahn'Qiraj"] = "安其拉",
	["Ahn'Qiraj Temple"] = "安其拉神殿",
	["Ahn'Qiraj Terrace"] = "安其拉平台",
	["Ahn'Qiraj: The Fallen Kingdom"] = "安其拉：堕落王国",
	["Akhenet Fields"] = "埃卡赫莱平原",
	["Aku'mai's Lair"] = "阿库麦尔的巢穴",
	["Alabaster Shelf"] = "雪玉岩床",
	["Alcaz Island"] = "奥卡兹岛",
	["Aldor Rise"] = "奥尔多高地",
	Aldrassil = "奥达希尔",
	["Aldur'thar: The Desolation Gate"] = "荒凉之门奥尔杜萨",
	["Alexston Farmstead"] = "阿历克斯顿农场",
	["Algaz Gate"] = "奥加兹大门",
	["Algaz Station"] = "奥加兹岗哨",
	["A Little Patience"] = "王者的耐心",
	["Allen Farmstead"] = "艾伦农场",
	["Allerian Post"] = "奥蕾莉亚岗哨",
	["Allerian Stronghold"] = "奥蕾莉亚要塞",
	["Alliance Base"] = "联盟基地",
	["Alliance Beach Daily Area"] = "联盟海滩日常区域",
	["Alliance Beachhead"] = "联盟滩头",
	["Alliance Hub - Mogu Island Progression Scenario"] = "Alliance Hub - Mogu Island Progression Scenario",
	["Alliance Keep"] = "联盟要塞",
	["Alliance Mercenary Ship to Vashj'ir"] = "前往瓦丝琪尔的联盟商船",
	["Alliance PVP Barracks"] = "联盟PvP兵营",
	["All That Glitters Prospecting Co."] = "亮晶晶矿业公司",
	["Alonsus Chapel"] = "阿隆索斯礼拜堂",
	["Altar of Ascension"] = "升腾祭坛",
	["Altar of Har'koa"] = "哈克娅祭坛",
	["Altar of Mam'toth"] = "犸托斯祭坛",
	["Altar of Quetz'lun"] = "奎丝鲁恩祭坛",
	["Altar of Rhunok"] = "伦诺克祭坛",
	["Altar of Sha'tar"] = "沙塔尔祭坛",
	["Altar of Sseratus"] = "西莱图斯祭坛",
	["Altar of Storms"] = "风暴祭坛",
	["Altar of the Blood God"] = "血神祭坛",
	["Altar of Twilight"] = "暮光祭坛",
	["Alterac Mountains"] = "奥特兰克山脉",
	["Alterac Valley"] = "奥特兰克山谷",
	["Alther's Mill"] = "奥瑟尔伐木场",
	["Amani Catacombs"] = "阿曼尼墓穴",
	["Amani Mountains"] = "阿曼尼山岭",
	["Amani Pass"] = "阿曼尼小径",
	["Amberfly Bog"] = "珀蝇沼",
	["Amberglow Hollow"] = "珀光裂谷",
	["Amber Ledge"] = "琥珀崖",
	Ambermarsh = "琥珀泽",
	Ambermill = "安伯米尔",
	["Amberpine Lodge"] = "琥珀松木营地",
	["Amber Quarry"] = "琥珀采掘场",
	["Amber Research Sanctum"] = "琥珀研究圣所",
	["Ambershard Cavern"] = "琥珀碎片洞穴",
	["Amberstill Ranch"] = "冻石农场",
	["Amberweb Pass"] = "琥珀蛛网小径",
	["Ameth'Aran"] = "亚米萨兰",
	["Ammen Fields"] = "埃门平原",
	["Ammen Ford"] = "埃门海滩",
	["Ammen Vale"] = "埃门谷",
	["Amphitheater of Anguish"] = "痛苦斗兽场",
	["Ampitheater of Anguish"] = "痛苦斗兽场",
	["Ancestral Grounds"] = "先祖之地",
	["Ancestral Rise"] = "祖宗高地",
	["Ancient Courtyard"] = "先祖庭院",
	["Ancient Zul'Gurub"] = "古城祖尔格拉布",
	["An'daroth"] = "安达洛斯",
	["Andilien Estate"] = "安迪尔林庄园",
	Andorhal = "安多哈尔",
	Andruk = "安德鲁克",
	["Angerfang Encampment"] = "怒牙营地",
	["Angkhal Pavilion"] = "安卡阁",
	["Anglers Expedition"] = "垂钓翁探险营",
	["Anglers Wharf"] = "渔人码头",
	["Angor Fortress"] = "苦痛堡垒",
	["Ango'rosh Grounds"] = "安葛洛什营地",
	["Ango'rosh Stronghold"] = "安葛洛什要塞",
	["Angrathar the Wrathgate"] = "天谴之门安加萨",
	["Angrathar the Wrath Gate"] = "天谴之门安加萨",
	["An'owyn"] = "安欧维恩",
	["An'telas"] = "安泰拉斯",
	["Antonidas Memorial"] = "安东尼达斯纪念碑",
	Anvilmar = "安威玛尔",
	["Anvil of Conflagration"] = "厄火铁砧",
	["Apex Point"] = "巅峰之台",
	["Apocryphan's Rest"] = "圣者之陵",
	["Apothecary Camp"] = "药剂师营地",
	["Applebloom Tavern"] = "苹花酒馆",
	["Arathi Basin"] = "阿拉希盆地",
	["Arathi Highlands"] = "阿拉希高地",
	["Arcane Pinnacle"] = "奥术之巅",
	["Archmage Vargoth's Retreat"] = "大法师瓦格斯的居所",
	["Area 52"] = "52区",
	["Arena Floor"] = "竞技场",
	["Arena of Annihilation"] = "破军比武场",
	["Argent Pavilion"] = "银色大帐",
	["Argent Stand"] = "银色前沿",
	["Argent Tournament Grounds"] = "银色比武场",
	["Argent Vanguard"] = "银色前线基地",
	["Ariden's Camp"] = "埃瑞丁营地",
	["Arikara's Needle"] = "阿利卡拉针石",
	["Arklonis Ridge"] = "阿尔科隆山脉",
	["Arklon Ruins"] = "阿尔科隆废墟",
	["Arriga Footbridge"] = "埃雷加之桥",
	["Arsad Trade Post"] = "阿萨德贸易站",
	["Ascendant's Rise"] = "升腾者高地",
	["Ascent of Swirling Winds"] = "旋风高地",
	["Ashen Fields"] = "灰烬旷野",
	["Ashen Lake"] = "暗灰湖",
	Ashenvale = "灰谷",
	["Ashwood Lake"] = "灰木湖",
	["Ashwood Post"] = "灰木哨站",
	["Aspen Grove Post"] = "白杨商栈",
	["Assault on Shaol'mara"] = "突袭绍尔马拉",
	["Assault on Zan'vess"] = "突袭扎尼维斯",
	["Assault on Zeb'tula"] = "突袭赞布图拉",
	Astranaar = "阿斯特兰纳",
	["Ata'mal Terrace"] = "阿塔玛平台",
	Athenaeum = "图书馆",
	["Atrium of the Heart"] = "心之中庭",
	["Atulhet's Tomb"] = "阿图希特陵墓",
	["Auberdine Refugee Camp"] = "奥伯丁难民营",
	["Auburn Bluffs"] = "褐崖",
	["Auchenai Crypts"] = "奥金尼地穴",
	["Auchenai Grounds"] = "奥金尼废墟",
	Auchindoun = "奥金顿",
	["Auchindoun: Auchenai Crypts"] = "奥金顿：奥金尼地穴",
	["Auchindoun - Auchenai Crypts Entrance"] = "奥金顿 - 奥金尼地穴入口",
	["Auchindoun: Mana-Tombs"] = "奥金顿：法力墓穴",
	["Auchindoun - Mana-Tombs Entrance"] = "奥金顿 - 法力陵墓入口",
	["Auchindoun: Sethekk Halls"] = "奥金顿：塞泰克大厅",
	["Auchindoun - Sethekk Halls Entrance"] = "奥金顿 - 塞泰克大厅入口",
	["Auchindoun: Shadow Labyrinth"] = "奥金顿：暗影迷宫",
	["Auchindoun - Shadow Labyrinth Entrance"] = "奥金顿 - 暗影迷宫入口",
	["Auren Falls"] = "奥伦瀑布",
	["Auren Ridge"] = "奥伦山脊",
	["Autumnshade Ridge"] = "秋荫山",
	["Avalanchion's Vault"] = "阿瓦兰奇奥的地穴",
	Aviary = "蝙蝠笼",
	["Axis of Alignment"] = "校准之轴",
	Axxarien = "阿克萨林",
	["Azjol-Nerub"] = "艾卓-尼鲁布",
	["Azjol-Nerub Entrance"] = "艾卓-尼鲁布入口",
	Azshara = "艾萨拉",
	["Azshara Crater"] = "艾萨拉巨坑",
	["Azshara's Palace"] = "艾萨拉的宫殿",
	["Azurebreeze Coast"] = "碧风海岸",
	["Azure Dragonshrine"] = "碧蓝巨龙圣地",
	["Azurelode Mine"] = "碧玉矿洞",
	["Azuremyst Isle"] = "秘蓝岛",
	["Azure Watch"] = "碧蓝岗哨",
	["Backbreaker Bay"] = "碎脊湾",
	Badlands = "荒芜之地",
	["Bael'dun Digsite"] = "巴尔丹挖掘场",
	["Bael'dun Keep"] = "巴尔丹城堡",
	["Baelgun's Excavation Site"] = "巴尔古挖掘场",
	["Bael Modan"] = "巴尔莫丹",
	["Bael Modan Excavation"] = "巴尔莫丹挖掘场",
	["Bahrum's Post"] = "巴赫隆岗哨",
	["Balargarde Fortress"] = "巴拉加德堡垒",
	Baleheim = "拜尔海姆",
	["Balejar Watch"] = "拜尔亚岗哨",
	["Balia'mah Ruins"] = "巴里亚曼废墟",
	["Bal'lal Ruins"] = "巴拉尔废墟",
	["Balnir Farmstead"] = "巴尼尔农场",
	Bambala = "邦巴拉",
	["Band of Acceleration"] = "加速之环",
	["Band of Alignment"] = "校准之环",
	["Band of Transmutation"] = "转化之环",
	["Band of Variance"] = "突变之环",
	["Ban'ethil Barrow Den"] = "班尼希尔兽穴",
	["Ban'ethil Barrow Descent"] = "班尼希尔兽穴下层区",
	["Ban'ethil Hollow"] = "班尼希尔山谷",
	Bank = "银行",
	["Banquet Grounds"] = "宴会地",
	["Ban'Thallow Barrow Den"] = "班萨罗兽穴",
	["Baradin Base Camp"] = "巴拉丁营地",
	["Baradin Bay"] = "巴拉丁海湾",
	["Baradin Hold"] = "巴拉丁监狱",
	Barbershop = "理发店",
	["Barov Family Vault"] = "巴罗夫家族宝库",
	["Bashal'Aran"] = "巴莎兰",
	["Bashal'Aran Collapse"] = "巴莎兰废墟",
	["Bash'ir Landing"] = "巴什伊尔码头",
	["Bastion Antechamber"] = "堡垒前厅",
	["Bathran's Haunt"] = "巴斯兰鬼屋",
	["Battlefront Provisions"] = "前线辎重营",
	["Battle on the High Seas"] = "公海激战",
	["Battle Ring"] = "大竞技场",
	Battlescar = "战斗之痕",
	["Battlescar Spire"] = "战痕尖塔",
	["Battlescar Valley"] = "战痕谷",
	["Bay of Echoes"] = "回音湾",
	["Bay of Storms"] = "风暴海湾",
	["Bear's Head"] = "熊头",
	["Beauty's Lair"] = "如花的巢穴",
	["Beeble's Wreck"] = "比波尔的失事点",
	["Beezil's Wreck"] = "比吉尔的飞艇残骸",
	["Befouled Terrace"] = "被玷污的平台",
	["Beggar's Haunt"] = "乞丐鬼屋",
	["Beneath The Double Rainbow"] = "双虹之下",
	["Beneath the Pit"] = "深渊之下",
	["Beren's Peril"] = "博伦的巢穴",
	["Bernau's Happy Fun Land"] = "Bernau's Happy Fun Land",
	["Beryl Coast"] = "贝里尔海湾",
	["Beryl Egress"] = "蓝玉避难所",
	["Beryl Point"] = "蓝玉营地",
	["Beth'mora Ridge"] = "贝斯莫拉山",
	["Beth'tilac's Lair"] = "贝丝缇拉克的巢穴",
	["Biel'aran Ridge"] = "贝耶拉兰山",
	["Big Beach Brew Bash"] = "抢滩夺酒",
	["Big Blossom Excavation"] = "繁盛挖掘场",
	["Big Blossom Mine"] = "繁盛矿洞",
	["Bilgewater Beach"] = "锈水海滩",
	["Bilgewater Harbor"] = "锈水港",
	["Bilgewater Lumber Yard"] = "锈水木材场",
	["Bilgewater Port"] = "锈水码头",
	["Binan Brew & Stew"] = "滨岸酒肉坊",
	["Binan Village"] = "滨岸村",
	["Bitter Reaches"] = "痛苦海岸",
	["Bittertide Lake"] = "苦潮湖",
	["Bizmo's Brawlpub"] = "比兹莫搏击俱乐部",
	["Black Channel Marsh"] = "黑水沼泽",
	["Blackchar Cave"] = "黑炭谷",
	["Black Drake Roost"] = "黑龙栖山",
	["Blackfathom Camp"] = "黑渊营地",
	["Blackfathom Deeps"] = "黑暗深渊",
	["Blackfathom Deeps Entrance"] = "黑暗深渊入口",
	["Blackhoof Village"] = "黑蹄村",
	["Blackhorn's Penance"] = "黑角赎罪地",
	["Blackmaw Hold"] = "黑喉要塞",
	["Black Ox Temple"] = "玄牛寺",
	["Blackriver Logging Camp"] = "黑水伐木场",
	["Blackrock Caverns"] = "黑石岩窟",
	["Blackrock Caverns Entrance"] = "黑石岩窟入口",
	["Blackrock Depths"] = "黑石深渊",
	["Blackrock Depths Entrance"] = "黑石深渊入口",
	["Blackrock Mountain"] = "黑石山",
	["Blackrock Pass"] = "黑石小径",
	["Blackrock Spire"] = "黑石塔",
	["Blackrock Spire Entrance"] = "黑石塔入口",
	["Blackrock Stadium"] = "黑石竞技场",
	["Blackrock Stronghold"] = "黑石要塞",
	["Blacksand Spillway"] = "黑沙河口",
	["Blacksilt Shore"] = "黑沙海岸",
	Blacksmith = "铁匠铺",
	["Blackstone Span"] = "布莱克斯通大桥",
	["Black Temple"] = "黑暗神殿",
	["Black Tooth Hovel"] = "黑齿营地",
	Blackwatch = "黑色观察站",
	["Blackwater Cove"] = "黑水湾",
	["Blackwater Shipwrecks"] = "黑水湾沉船",
	["Blackwind Lake"] = "黑风湖",
	["Blackwind Landing"] = "黑风码头",
	["Blackwind Valley"] = "黑风谷",
	["Blackwing Coven"] = "黑翼集会所",
	["Blackwing Descent"] = "黑翼血环",
	["Blackwing Lair"] = "黑翼之巢",
	["Blackwolf River"] = "黑狼河",
	["Blackwood Camp"] = "黑木营地",
	["Blackwood Den"] = "黑木洞穴",
	["Blackwood Lake"] = "黑木湖",
	["Bladed Gulch"] = "刀刃峡谷",
	["Bladefist Bay"] = "刃拳海湾",
	["Bladelord's Retreat"] = "刀剑侯侧殿",
	["Blades & Axes"] = "剑刃与利斧",
	["Blade's Edge Arena"] = "刀锋山竞技场",
	["Blade's Edge Mountains"] = "刀锋山",
	["Bladespire Grounds"] = "刀塔平原",
	["Bladespire Hold"] = "刀塔要塞",
	["Bladespire Outpost"] = "刀塔哨站",
	["Blades' Run"] = "刀锋之路",
	["Blade Tooth Canyon"] = "刃齿峡谷",
	Bladewood = "刀林",
	["Blasted Lands"] = "诅咒之地",
	["Bleak Hollow"] = "阴冷洞窟",
	["Bleeding Hollow Ruins"] = "血环废墟",
	["Bleeding Vale"] = "鲜血谷",
	["Bleeding Ziggurat"] = "鲜血通灵塔",
	["Blistering Pool"] = "毒泡水池",
	["Bloodcurse Isle"] = "血咒岛",
	["Blood Elf Tower"] = "血精灵塔",
	["Bloodfen Burrow"] = "鲜血沼泽墓穴",
	Bloodgulch = "溅血谷地",
	["Bloodhoof Village"] = "血蹄村",
	["Bloodied Crossing"] = "血腥岔路口",
	["Blood in the Snow"] = "雪山血战",
	["Bloodmaul Camp"] = "血槌营地",
	["Bloodmaul Outpost"] = "血槌哨站",
	["Bloodmaul Ravine"] = "血槌峡谷",
	["Bloodmoon Isle"] = "血月岛",
	["Bloodmyst Isle"] = "秘血岛",
	["Bloodscale Enclave"] = "血鳞领地",
	["Bloodscale Grounds"] = "血鳞浅滩",
	["Bloodspore Plains"] = "血孢平原",
	["Bloodtalon Shore"] = "血爪海滩",
	["Bloodtooth Camp"] = "血牙营地",
	["Bloodvenom Falls"] = "血毒瀑布",
	["Bloodvenom Post"] = "血毒河",
	["Bloodvenom Post "] = "血毒岗哨",
	["Bloodvenom River"] = "血毒河",
	["Bloodwash Cavern"] = "血浪洞穴",
	["Bloodwash Fighting Pits"] = "血浪角斗场",
	["Bloodwash Shrine"] = "血浪神殿",
	["Blood Watch"] = "秘血岗哨",
	["Bloodwatcher Point"] = "血望者营地",
	Bluefen = "蓝色沼泽",
	["Bluegill Marsh"] = "蓝腮沼泽",
	["Blue Sky Logging Grounds"] = "蓝天伐木场",
	["Bluff of the South Wind"] = "南风之崖",
	["Bogen's Ledge"] = "伯根的棚屋",
	Bogpaddle = "沼桨镇",
	["Boha'mu Ruins"] = "博哈姆废墟",
	["Bolgan's Hole"] = "波尔甘的洞穴",
	["Bolyun's Camp"] = "波尔温营地",
	["Bonechewer Ruins"] = "噬骨废墟",
	["Bonesnap's Camp"] = "博斯纳普的营地",
	["Bones of Grakkarond"] = "格拉卡隆之骨",
	["Bootlegger Outpost"] = "商旅哨站",
	["Booty Bay"] = "藏宝海湾",
	["Borean Tundra"] = "北风苔原",
	["Bor'gorok Outpost"] = "博古洛克前哨站",
	["Bor's Breath"] = "伯尔之息",
	["Bor's Breath River"] = "伯尔之息河",
	["Bor's Fall"] = "伯尔瀑布",
	["Bor's Fury"] = "伯尔之怒号",
	["Borune Ruins"] = "博鲁恩废墟",
	["Bough Shadow"] = "大树荫",
	["Bouldercrag's Refuge"] = "布德克拉格庇护所",
	["Boulderfist Hall"] = "石拳大厅",
	["Boulderfist Outpost"] = "石拳岗哨",
	["Boulder'gor"] = "博德戈尔",
	["Boulder Hills"] = "巨石丘陵",
	["Boulder Lode Mine"] = "石矿洞",
	["Boulder'mok"] = "砾石营地",
	["Boulderslide Cavern"] = "滚岩洞穴",
	["Boulderslide Ravine"] = "滚岩峡谷",
	["Bozzle's Wreck"] = "波兹尔的失事点",
	["Brackenwall Village"] = "蕨墙村",
	["Brackwell Pumpkin Patch"] = "布莱克威尔南瓜田",
	["Brambleblade Ravine"] = "刺刃峡谷",
	Bramblescar = "棘痕平原",
	["Brann's Base-Camp"] = "布莱恩的营地",
	["Brashtide Attack Fleet"] = "急浪攻击舰队",
	["Brashtide Attack Fleet (Force Outdoors)"] = "急浪攻击舰队",
	["Brave Wind Mesa"] = "强风台地",
	["Brawl'gar Arena"] = "搏击竞技场",
	["Brazie Farmstead"] = "布雷泽农场",
	["Brewmoon Festival"] = "酿月祭",
	["Brewnall Village"] = "烈酒村",
	["Bridge of Souls"] = "灵魂之桥",
	["Brightwater Lake"] = "澈水湖",
	["Brightwood Grove"] = "阳光树林",
	Brill = "布瑞尔",
	["Brill Town Hall"] = "布瑞尔城镇大厅",
	["Bristlelimb Enclave"] = "刺臂领地",
	["Bristlelimb Village"] = "刺臂村",
	["Broken Commons"] = "平民区废墟",
	["Broken Hill"] = "碎石岭",
	["Broken Pillar"] = "破碎石柱",
	["Broken Spear Village"] = "断矛村",
	["Broken Wilds"] = "破碎荒野",
	["Broketooth Outpost"] = "断牙哨站",
	["Bronzebeard Encampment"] = "铜须营地",
	["Bronze Dragonshrine"] = "青铜巨龙圣地",
	["Browman Mill"] = "布洛米尔",
	["Brunnhildar Village"] = "布伦希尔达村",
	["Bucklebree Farm"] = "巴克布雷农场",
	["Budd's Dig"] = "巴德的挖掘场",
	["Burning Blade Coven"] = "火刃集会所",
	["Burning Blade Ruins"] = "火刃废墟",
	["Burning Steppes"] = "燃烧平原",
	["Butcher's Sanctum"] = "屠夫密室",
	["Butcher's Stand"] = "屠夫之台",
	["Caer Darrow"] = "凯尔达隆",
	["Caldemere Lake"] = "凯德米尔湖",
	["Calston Estate"] = "卡尔斯通庄园",
	["Camp Aparaje"] = "阿帕拉耶营地",
	["Camp Ataya"] = "阿塔亚营地",
	["Camp Boff"] = "博夫营地",
	["Camp Broketooth"] = "断牙营地",
	["Camp Cagg"] = "卡格营地",
	["Camp E'thok"] = "伊索克营地",
	["Camp Everstill"] = "止水湖营地",
	["Camp Gormal"] = "格玛尔营地",
	["Camp Kosh"] = "柯什营地",
	["Camp Mojache"] = "莫沙彻营地",
	["Camp Mojache Longhouse"] = "莫沙彻营地长屋",
	["Camp Narache"] = "纳拉其营地",
	["Camp Nooka Nooka"] = "努卡努卡营地",
	["Camp of Boom"] = "砰砰博士的营地",
	["Camp Onequah"] = "Camp Onequah, Grizzly Hills (Quest)",
	["Camp Oneqwah"] = "欧尼瓦营地",
	["Camp Sungraze"] = "阳痕营地",
	["Camp Tunka'lo"] = "唐卡洛营地",
	["Camp Una'fe"] = "乌纳菲营地",
	["Camp Winterhoof"] = "冬蹄营地",
	["Camp Wurg"] = "瓦格营地",
	Canals = "运河",
	["Cannon's Inferno"] = "加农的火海",
	["Cantrips & Crows"] = "咒语和乌鸦旅店",
	["Cape of Lost Hope"] = "失落希望海角",
	["Cape of Stranglethorn"] = "荆棘谷海角",
	["Capital Gardens"] = "中心花园",
	["Carrion Hill"] = "腐臭山",
	["Cartier & Co. Fine Jewelry"] = "卡蒂亚珠宝店",
	Cataclysm = "大灾变",
	["Cathedral of Darkness"] = "黑暗大教堂",
	["Cathedral of Light"] = "光明大教堂",
	["Cathedral Quarter"] = "教堂区",
	["Cathedral Square"] = "教堂广场",
	["Cattail Lake"] = "香蒲湖",
	["Cauldros Isle"] = "考杜斯岛",
	["Cave of Mam'toth"] = "犸托斯洞穴",
	["Cave of Meditation"] = "冥想洞穴",
	["Cave of the Crane"] = "白鹤洞",
	["Cave of Words"] = "千言洞",
	["Cavern of Endless Echoes"] = "无尽回声洞窟",
	["Cavern of Mists"] = "迷雾洞穴",
	["Caverns of Time"] = "时光之穴",
	["Celestial Enclave"] = "天界领域",
	["Celestial Ridge"] = "苍穹之脊",
	["Cenarion Enclave"] = "塞纳里奥区",
	["Cenarion Hold"] = "塞纳里奥要塞",
	["Cenarion Post"] = "塞纳里奥哨站",
	["Cenarion Refuge"] = "塞纳里奥庇护所",
	["Cenarion Thicket"] = "塞纳里奥树林",
	["Cenarion Watchpost"] = "塞纳里奥岗哨",
	["Cenarion Wildlands"] = "塞纳里奥旷野",
	["Central Bridge"] = "中部桥梁",
	["Chamber of Ancient Relics"] = "上古遗产大厅",
	["Chamber of Atonement"] = "忏悔室",
	["Chamber of Battle"] = "战斗之厅",
	["Chamber of Blood"] = "鲜血之厅",
	["Chamber of Command"] = "命令大厅",
	["Chamber of Enchantment"] = "魔法之厅",
	["Chamber of Enlightenment"] = "启迪之厅",
	["Chamber of Fanatics"] = "狂信者之厅",
	["Chamber of Incineration"] = "焚烧之厅",
	["Chamber of Masters"] = "师匠大厅",
	["Chamber of Prophecy"] = "预言之厅",
	["Chamber of Reflection"] = "沉思之厅",
	["Chamber of Respite"] = "安息之厅",
	["Chamber of Summoning"] = "召唤大厅",
	["Chamber of Test Namesets"] = "正名密室",
	["Chamber of the Aspects"] = "龙神之厅",
	["Chamber of the Dreamer"] = "沉睡者之厅",
	["Chamber of the Moon"] = "月亮密室",
	["Chamber of the Restless"] = "无眠者之厅",
	["Chamber of the Stars"] = "群星密室",
	["Chamber of the Sun"] = "太阳密室",
	["Chamber of Whispers"] = "风语厅",
	["Chamber of Wisdom"] = "智慧密室",
	["Champion's Hall"] = "勇士大厅",
	["Champions' Hall"] = "勇士大厅",
	["Chapel Gardens"] = "教堂花园",
	["Chapel of the Crimson Flame"] = "赤色烈焰礼拜堂",
	["Chapel Yard"] = "礼拜堂广场",
	["Charred Outpost"] = "被烧毁的前哨站",
	["Charred Rise"] = "焦土高地",
	["Chill Breeze Valley"] = "寒风峡谷",
	["Chillmere Coast"] = "切米尔海岸",
	["Chillwind Camp"] = "寒风营地",
	["Chillwind Point"] = "冰风岗",
	Chiselgrip = "凿握据点",
	["Chittering Coast"] = "虫鸣海湾",
	["Chow Farmstead"] = "周家农田",
	["Churning Gulch"] = "沸土峡谷",
	["Circle of Blood"] = "鲜血之环",
	["Circle of Blood Arena"] = "鲜血之环竞技场",
	["Circle of Bone"] = "骨之环",
	["Circle of East Binding"] = "东部禁锢法阵",
	["Circle of Inner Binding"] = "内禁锢法阵",
	["Circle of Outer Binding"] = "外禁锢法阵",
	["Circle of Scale"] = "鳞之环",
	["Circle of Stone"] = "石之环",
	["Circle of Thorns"] = "荆棘法阵",
	["Circle of West Binding"] = "西部禁锢法阵",
	["Circle of Wills"] = "意志竞技场",
	City = "城市",
	["City of Ironforge"] = "铁炉堡",
	["City Siege - Mogu Island Progression Scenario"] = "City Siege - Mogu Island Progression Scenario",
	["Clan Watch"] = "氏族岗哨",
	["Class Quest"] = "职业任务",
	["Claytön's WoWEdit Land"] = "Clayton's WoWEdit Land",
	["Cleft of Shadow"] = "暗影裂口",
	["Cliffspring Falls"] = "峭壁之泉",
	["Cliffspring Hollow"] = "峭泉洞",
	["Cliffspring River"] = "壁泉河",
	["Cliffwalker Post"] = "峭壁行者哨站",
	["Cloudstrike Dojo"] = "穿云道场",
	["Cloudtop Terrace"] = "云巅之台",
	["Coast of Echoes"] = "回音海岸",
	["Coast of Idols"] = "巨像海岸",
	["Coilfang Reservoir"] = "盘牙水库",
	["Coilfang: Serpentshrine Cavern"] = "盘牙湖泊：毒蛇神殿",
	["Coilfang: The Slave Pens"] = "盘牙湖泊：奴隶围栏",
	["Coilfang - The Slave Pens Entrance"] = "盘牙 - 奴隶围栏入口",
	["Coilfang: The Steamvault"] = "盘牙湖泊：蒸汽地窟",
	["Coilfang - The Steamvault Entrance"] = "盘牙 - 蒸汽地窟入口",
	["Coilfang: The Underbog"] = "盘牙湖泊：幽暗沼泽",
	["Coilfang - The Underbog Entrance"] = "盘牙 - 幽暗沼泽入口",
	["Coilskar Cistern"] = "库斯卡水池",
	["Coilskar Point"] = "库斯卡岗哨",
	Coldarra = "考达拉",
	["Coldarra Ledge"] = "考达拉台地",
	["Coldbite Burrow"] = "寒噬地穴",
	["Cold Hearth Manor"] = "炉灰庄园",
	["Coldridge Pass"] = "寒脊山小径",
	["Coldridge Valley"] = "寒脊山谷",
	["Coldrock Quarry"] = "冷石采掘场",
	["Coldtooth Mine"] = "冷齿矿洞",
	["Coldwind Heights"] = "冷风高地",
	["Coldwind Pass"] = "冷风小径",
	["Collin's Test"] = "Collin's Test",
	["Command Center"] = "指挥中心",
	["Commons Hall"] = "平民大厅",
	["Condemned Halls"] = "定罪大厅",
	["Conqueror's Terrace"] = "征服者平台",
	["Conquest Hold"] = "征服堡",
	["Containment Core"] = "密封核心",
	["Cooper Residence"] = "桶屋",
	["Coral Garden"] = "珊瑚花园",
	["Cordell's Enchanting"] = "考迪尔的附魔店",
	["Corin's Crossing"] = "考林路口",
	["Corp'rethar: The Horror Gate"] = "恐惧之门科雷萨",
	["Corrahn's Dagger"] = "考兰之匕",
	Cosmowrench = "扳钳镇",
	["Court of Bones"] = "白骨庭院",
	["Court of the Highborne"] = "上层精灵庭院",
	["Court of the Sun"] = "逐日王庭",
	["Courtyard of Lights"] = "光之庭院",
	["Courtyard of the Ancients"] = "远古庭院",
	["Cradle of Chi-Ji"] = "赤精栖木",
	["Cradle of the Ancients"] = "远古的摇篮",
	["Craftsmen's Terrace"] = "工匠区",
	["Crag of the Everliving"] = "永生峭壁",
	["Cragpool Lake"] = "峭壁湖",
	["Crane Wing Refuge"] = "鹤翼庇护所",
	["Crash Site"] = "坠毁点",
	["Crescent Hall"] = "新月大厅",
	["Crimson Assembly Hall"] = "赤红议事厅",
	["Crimson Expanse"] = "赤红岩床",
	["Crimson Watch"] = "火红岗哨",
	Crossroads = "十字路口",
	["Crowley Orchard"] = "克罗雷果园",
	["Crowley Stable Grounds"] = "克罗雷马厩场",
	["Crown Guard Tower"] = "皇冠哨塔",
	["Crucible of Carnage"] = "杀戮熔炉竞技场",
	["Crumbling Depths"] = "碎岩之渊",
	["Crumbling Stones"] = "崩裂之石",
	["Crusader Forward Camp"] = "北伐军前线营地",
	["Crusader Outpost"] = "十字军前哨",
	["Crusader's Armory"] = "十字军武器库",
	["Crusader's Chapel"] = "十字军礼拜堂",
	["Crusader's Landing"] = "十字军码头",
	["Crusader's Outpost"] = "十字军前哨",
	["Crusaders' Pinnacle"] = "北伐军之峰",
	["Crusader's Run"] = "十字军小径",
	["Crusader's Spire"] = "北伐军之巅",
	["Crusaders' Square"] = "十字军广场",
	Crushblow = "粉碎者据点",
	["Crushcog's Arsenal"] = "碎轮的军械库",
	["Crushridge Hold"] = "破碎岭城堡",
	Crypt = "墓穴",
	["Crypt of Forgotten Kings"] = "遗忘之王古墓",
	["Crypt of Remembrance"] = "追忆墓穴",
	["Crystal Lake"] = "水晶湖",
	["Crystalline Quarry"] = "水晶挖掘场",
	["Crystalsong Forest"] = "晶歌森林",
	["Crystal Spine"] = "水晶之脊",
	["Crystalvein Mine"] = "水晶矿洞",
	["Crystalweb Cavern"] = "水晶蛛网洞穴",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "摩尔珍品店",
	["Cursed Depths"] = "咒怨地牢",
	["Cursed Hollow"] = "诅咒洞窟",
	["Cut-Throat Alley"] = "割喉小巷",
	["Cyclone Summit"] = "气旋峰",
	["Dabyrie's Farmstead"] = "达比雷农场",
	["Daggercap Bay"] = "匕鞘湾",
	["Daggerfen Village"] = "匕潭村",
	["Dagger in the Dark"] = "黑暗中的匕首",
	["Daggermaw Canyon"] = "刃喉谷",
	["Dagger Pass"] = "匕首小径",
	["Dais of Conquerors"] = "征服者之台",
	Dalaran = "达拉然",
	["Dalaran Arena"] = "达拉然竞技场",
	["Dalaran City"] = "达拉然城",
	["Dalaran Crater"] = "达拉然巨坑",
	["Dalaran Floating Rocks"] = "达拉然浮石",
	["Dalaran Island"] = "达拉然岛",
	["Dalaran Merchant's Bank"] = "达拉然商业银行",
	["Dalaran Sewers"] = "达拉然下水道",
	["Dalaran Visitor Center"] = "达拉然访客中心",
	["Dalson's Farm"] = "达尔松农场",
	["Damplight Cavern"] = "潮光洞穴",
	["Damplight Chamber"] = "潮光大厅",
	["Dampsoil Burrow"] = "润泥藏身处",
	["Dandred's Fold"] = "达伦德农场",
	["Dargath's Demise"] = "达加斯的行刑场",
	["Darkbreak Cove"] = "驱暗海窟",
	["Darkcloud Pinnacle"] = "黑云峰",
	["Darkcrest Enclave"] = "暗潮营地",
	["Darkcrest Shore"] = "暗潮湖岸",
	["Dark Heart of Pandaria"] = "潘达利亚的黑暗之心",
	["Dark Iron Highway"] = "黑铁大道",
	["Darkmist Cavern"] = "黑雾洞穴",
	["Darkmist Ruins"] = "黑雾废墟",
	["Darkmoon Boardwalk"] = "暗月滨海步道",
	["Darkmoon Deathmatch"] = "暗月死斗场",
	["Darkmoon Deathmatch Pit (PH)"] = "Darkmoon Deathmatch Pit (PH)",
	["Darkmoon Faire"] = "暗月马戏团",
	["Darkmoon Island"] = "暗月岛",
	["Darkmoon Island Cave"] = "暗月岛洞穴",
	["Darkmoon Path"] = "暗月小径",
	["Darkmoon Pavilion"] = "暗月帐篷",
	Darkshire = "夜色镇",
	["Darkshire Town Hall"] = "夜色镇大厅",
	Darkshore = "黑海岸",
	["Darkspear Hold"] = "暗矛要塞",
	["Darkspear Isle"] = "暗矛岛",
	["Darkspear Shore"] = "暗矛海岸",
	["Darkspear Strand"] = "暗矛海滩",
	["Darkspear Training Grounds"] = "暗矛训练场",
	["Darkwhisper Gorge"] = "暗语峡谷",
	["Darkwhisper Pass"] = "暗语小径",
	["Darnassian Base Camp"] = "达纳希恩营地",
	Darnassus = "达纳苏斯",
	["Darrow Hill"] = "达隆山",
	["Darrowmere Lake"] = "达隆米尔湖",
	Darrowshire = "达隆郡",
	["Darrowshire Hunting Grounds"] = "达隆郡猎场",
	["Darsok's Outpost"] = "达索克前哨站",
	["Dawnchaser Retreat"] = "逐晨者营地",
	["Dawning Lane"] = "黎明之路",
	["Dawning Wood Catacombs"] = "晨光之林墓穴",
	["Dawnrise Expedition"] = "晨光远征队营地",
	["Dawn's Blossom"] = "晨芳园",
	["Dawnseeker Promontory"] = "寻晨者海角",
	["Dawnseeker's Promontory"] = "寻晨者海角",
	["Dawn's Reach"] = "黎明河滩",
	["Dawnstar Spire"] = "晨星之塔",
	["Dawnstar Village"] = "晨星村",
	["Daxil's Dig"] = "达克希尔挖掘场",
	["D-Block"] = "恶魔监狱",
	["Deadeye Shore"] = "死眼海岸",
	["Deadman's Crossing"] = "死者十字",
	["Dead Man's Hole"] = "亡者之穴",
	Deadmines = "死亡矿井",
	["Deadtalker's Plateau"] = "死语者高地",
	["Deadwind Pass"] = "逆风小径",
	["Deadwind Ravine"] = "逆风谷",
	["Deadwood Village"] = "死木村",
	["Deathbringer's Rise"] = "死亡使者的高台",
	["Death Cultist Base Camp"] = "死亡教徒营地",
	["Deathforge Tower"] = "死亡熔炉哨塔",
	Deathknell = "丧钟镇",
	["Deathmatch Pavilion"] = "死斗场帐篷",
	Deatholme = "戴索姆",
	["Death's Breach"] = "死亡裂口",
	["Death's Door"] = "死亡之门",
	["Death's Hand Encampment"] = "死亡之手营地",
	["Deathspeaker's Watch"] = "亡语者岗哨",
	["Death's Rise"] = "死亡高地",
	["Death's Stand"] = "死亡营地",
	["Death's Step"] = "死亡小径",
	["Death's Watch Waystation"] = "死亡观察站",
	Deathwing = "死亡之翼",
	["Deathwing's Fall"] = "死亡之翼陨落地",
	["Deep Blue Observatory"] = "深蓝瞭望台",
	["Deep Elem Mine"] = "埃利姆矿洞",
	["Deepfin Ridge"] = "深鳍海崖",
	Deepholm = "深岩之洲",
	["Deephome Ceiling"] = "深岩之洲天顶",
	["Deepmist Grotto"] = "重雾洞穴",
	["Deeprun Tram"] = "矿道地铁",
	["Deepwater Tavern"] = "深水旅店",
	["Deepwind Gorge"] = "深风峡谷",
	["Defense of the Alehouse"] = "保卫酒坊",
	["Defense Of The Ale House BG"] = "保卫酒坊战场",
	["Defias Hideout"] = "迪菲亚盗贼巢穴",
	["Defiler's Den"] = "污染者之穴",
	["D.E.H.T.A. Encampment"] = "仁德会营地",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "屠魔峡谷",
	["Demon Fall Ridge"] = "屠魔山",
	["Demont's Place"] = "迪蒙特荒野",
	["Den of Defiance"] = "反抗洞穴",
	["Den of Dying"] = "亡者之穴",
	["Den of Haal'esh"] = "哈尔什巢穴",
	["Den of Iniquity"] = "邪恶之巢",
	["Den of Mortal Delights"] = "欢愉之园",
	["Den of Sorrow"] = "悲伤之穴",
	["Den of Sseratus"] = "西莱图斯之穴",
	["Den of the Caller"] = "召唤者之穴",
	["Den of the Devourer"] = "吞噬者的巢穴",
	["Den of the Disciples"] = "信徒之穴",
	["Den of the Unholy"] = "邪恶洞穴",
	["Derelict Caravan"] = "被遗弃的篷车",
	["Derelict Manor"] = "荒弃的庄园",
	["Derelict Strand"] = "荒弃海岸",
	["Designer Island"] = "Designer Island",
	Desolace = "凄凉之地",
	["Desolation Hold"] = "凄凉要塞",
	["Detention Block"] = "禁闭室",
	["Development Land"] = "Development Land",
	["Diamondhead River"] = "钻石河",
	["Diamond Island"] = "钻石岛",
	["Dig One"] = "一号挖掘场",
	["Dig Three"] = "三号挖掘场",
	["Dig Two"] = "二号挖掘场",
	["Direforge Hill"] = "恶铁岭",
	["Direhorn Post"] = "恐角岗哨",
	["Dire Maul"] = "厄运之槌",
	["Dire Maul - Capital Gardens Entrance"] = "厄运之槌 - 中心花园入口",
	["Dire Maul - East"] = "厄运之槌 - 东",
	["Dire Maul - Gordok Commons Entrance"] = "厄运之槌 - 戈多克议会入口",
	["Dire Maul - North"] = "厄运之槌 - 北",
	["Dire Maul - Warpwood Quarter Entrance"] = "厄运之槌 - 扭木区入口",
	["Dire Maul - West"] = "厄运之槌 - 西",
	Diremoor = "阴惨泥沼",
	["Dire Strait"] = "险峻海峡",
	["Disciple's Enclave"] = "信徒营地",
	Docks = "码头",
	["Dojani River"] = "都阳河",
	Dolanaar = "多兰纳尔",
	["Dome Balrissa"] = "巴尔利萨圆顶",
	["Domination Point"] = "统御岗哨",
	["Donna's Kitty Shack"] = "冬娜的小猫乐园",
	["DO NOT USE"] = "DO NOT USE",
	["Dookin' Grounds"] = "顽猴旷野",
	["Doom's Vigil"] = "末日祷告祭坛",
	["Dorian's Outpost"] = "多里安哨站",
	["Draco'dar"] = "德拉考达尔",
	["Draenei Ruins"] = "德莱尼废墟",
	["Draenethyst Mine"] = "德拉诺晶矿",
	["Draenil'dur Village"] = "德莱尼村",
	Dragonblight = "龙骨荒野",
	["Dragonflayer Pens"] = "掠龙围栏",
	["Dragonmaw Base Camp"] = "龙喉营地",
	["Dragonmaw Flag Room"] = "龙喉军旗室",
	["Dragonmaw Forge"] = "龙喉铸炉",
	["Dragonmaw Fortress"] = "龙喉要塞",
	["Dragonmaw Garrison"] = "龙喉兵营",
	["Dragonmaw Gates"] = "龙喉大门",
	["Dragonmaw Pass"] = "龙喉小径",
	["Dragonmaw Port"] = "龙喉港",
	["Dragonmaw Skyway"] = "龙喉空港",
	["Dragonmaw Stronghold"] = "龙喉要塞",
	["Dragons' End"] = "巨龙之末",
	["Dragon's Fall"] = "猎龙营地",
	["Dragon's Mouth"] = "巨龙峡口",
	["Dragon Soul"] = "巨龙之魂",
	["Dragon Soul Raid - East Sarlac"] = "巨龙之魂 - 东部裂口",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "巨龙之魂 - 龙眠神殿基地",
	["Dragonspine Peaks"] = "龙脊之巅",
	["Dragonspine Ridge"] = "龙脊岭",
	["Dragonspine Tributary"] = "龙脊河",
	["Dragonspire Hall"] = "龙塔大厅",
	["Drak'Agal"] = "达克迦尔",
	["Draka's Fury"] = "德拉卡的狂怒号",
	["Drak'atal Passage"] = "达克阿塔小径",
	["Drakil'jin Ruins"] = "达基尔金废墟",
	["Drak'Mabwa"] = "达克玛瓦",
	["Drak'Mar Lake"] = "达克玛尔湖",
	["Draknid Lair"] = "达克尼尔虫巢",
	["Drak'Sotra"] = "达克索塔",
	["Drak'Sotra Fields"] = "达克索塔农田",
	["Drak'Tharon Keep"] = "达克萨隆要塞",
	["Drak'Tharon Keep Entrance"] = "达克萨隆要塞入口",
	["Drak'Tharon Overlook"] = "达克萨隆悬崖",
	["Drak'ural"] = "达克乌拉",
	["Dread Clutch"] = "畏惧之巢",
	["Dread Expanse"] = "恐惧之境",
	["Dreadmaul Furnace"] = "巨槌熔炉",
	["Dreadmaul Hold"] = "巨槌要塞",
	["Dreadmaul Post"] = "巨槌岗哨",
	["Dreadmaul Rock"] = "巨槌石",
	["Dreadmist Camp"] = "鬼雾营地",
	["Dreadmist Den"] = "鬼雾兽穴",
	["Dreadmist Peak"] = "鬼雾峰",
	["Dreadmurk Shore"] = "恐惧海岸",
	["Dread Terrace"] = "恐惧平台",
	["Dread Wastes"] = "恐惧废土",
	["Dreadwatch Outpost"] = "恐惧之卫哨所",
	["Dream Bough"] = "梦境之树",
	["Dreamer's Pavilion"] = "黄粱阁",
	["Dreamer's Rest"] = "梦游者栖地",
	["Dreamer's Rock"] = "美梦石",
	Drudgetown = "苦工镇",
	["Drygulch Ravine"] = "枯水谷",
	["Drywhisker Gorge"] = "枯须峡谷",
	["Dubra'Jin"] = "杜布拉金",
	["Dun Algaz"] = "丹奥加兹",
	["Dun Argol"] = "丹厄古尔",
	["Dun Baldar"] = "丹巴达尔",
	["Dun Baldar Pass"] = "丹巴达尔小径",
	["Dun Baldar Tunnel"] = "丹巴达尔隧道",
	["Dunemaul Compound"] = "砂槌营地",
	["Dunemaul Recruitment Camp"] = "沙槌新兵营",
	["Dun Garok"] = "丹加洛克",
	["Dun Mandarr"] = "丹曼达尔",
	["Dun Modr"] = "丹莫德",
	["Dun Morogh"] = "丹莫罗",
	["Dun Niffelem"] = "丹尼芬雷",
	["Dunwald Holdout"] = "顿沃德据点",
	["Dunwald Hovel"] = "顿沃德小屋",
	["Dunwald Market Row"] = "顿沃德市场",
	["Dunwald Ruins"] = "顿沃德废墟",
	["Dunwald Town Square"] = "顿沃德城镇广场",
	["Durnholde Keep"] = "敦霍尔德城堡",
	Durotar = "杜隆塔尔",
	Duskhaven = "暮湾镇",
	["Duskhowl Den"] = "暗嚎兽穴",
	["Dusklight Bridge"] = "黯光桥",
	["Dusklight Hollow"] = "黯光枯木",
	["Duskmist Shore"] = "暮霭海滩",
	["Duskroot Fen"] = "暮根沼泽",
	["Duskwither Grounds"] = "达斯维瑟广场",
	["Duskwither Spire"] = "达斯维瑟之塔",
	Duskwood = "暮色森林",
	["Dustback Gorge"] = "沙背峡谷",
	["Dustbelch Grotto"] = "火山洞穴",
	["Dustfire Valley"] = "尘火谷",
	["Dustquill Ravine"] = "尘羽峡谷",
	["Dustwallow Bay"] = "尘泥海湾",
	["Dustwallow Marsh"] = "尘泥沼泽",
	["Dustwind Cave"] = "尘风洞穴",
	["Dustwind Dig"] = "尘风挖掘场",
	["Dustwind Gulch"] = "尘风峡谷",
	["Dwarven District"] = "矮人区",
	["Eagle's Eye"] = "鹰眼之台",
	["Earthshatter Cavern"] = "碎地者洞穴",
	["Earth Song Falls"] = "地歌瀑布",
	["Earth Song Gate"] = "地歌之门",
	["Eastern Bridge"] = "东部桥梁",
	["Eastern Kingdoms"] = "东部王国",
	["Eastern Plaguelands"] = "东瘟疫之地",
	["Eastern Strand"] = "东部海滩",
	["East Garrison"] = "东区兵营",
	["Eastmoon Ruins"] = "东月废墟",
	["East Pavilion"] = "东部帐篷",
	["East Pillar"] = "东部石柱",
	["Eastpoint Tower"] = "东点哨塔",
	["East Sanctum"] = "东部圣殿",
	["Eastspark Workshop"] = "东部火花车间",
	["East Spire"] = "东部尖塔",
	["East Supply Caravan"] = "东补给车队",
	["Eastvale Logging Camp"] = "东谷伐木场",
	["Eastwall Gate"] = "东墙大门",
	["Eastwall Tower"] = "东墙哨塔",
	["Eastwind Rest"] = "东风之眠",
	["Eastwind Shore"] = "东风海岸",
	["Ebon Hold"] = "黑锋要塞",
	["Ebon Watch"] = "黑锋哨站",
	["Echo Cove"] = "回音湾",
	["Echo Isles"] = "回音群岛",
	["Echomok Cavern"] = "艾卡默克洞穴",
	["Echo Reach"] = "回音海滩",
	["Echo Ridge Mine"] = "回音山矿洞",
	["Eclipse Point"] = "日蚀岗哨",
	["Eclipsion Fields"] = "日蚀平原",
	["Eco-Dome Farfield"] = "边缘生态圆顶",
	["Eco-Dome Midrealm"] = "中央生态圆顶",
	["Eco-Dome Skyperch"] = "高空生态圆顶",
	["Eco-Dome Sutheron"] = "苏瑟伦生态圆顶",
	["Elder Rise"] = "长者高地",
	["Elders' Square"] = "长者广场",
	["Eldreth Row"] = "艾德雷斯区",
	["Eldritch Heights"] = "埃尔德齐断崖",
	["Elemental Plateau"] = "元素高地",
	["Elementium Depths"] = "源质深渊",
	Elevator = "升降梯",
	["Elrendar Crossing"] = "艾伦达尔桥",
	["Elrendar Falls"] = "艾伦达尔瀑布",
	["Elrendar River"] = "艾尔伦达河",
	["Elwynn Forest"] = "艾尔文森林",
	["Ember Clutch"] = "灰烬龙巢",
	Emberglade = "灰烬林地",
	["Ember Spear Tower"] = "灰烬长矛塔楼",
	["Emberstone Mine"] = "烬石矿脉",
	["Emberstone Village"] = "烬石村",
	["Emberstrife's Den"] = "埃博斯塔夫的巢穴",
	["Emerald Dragonshrine"] = "翡翠巨龙圣地",
	["Emerald Dream"] = "翡翠梦境",
	["Emerald Forest"] = "翠叶森林",
	["Emerald Sanctuary"] = "翡翠圣地",
	["Emperor Rikktik's Rest"] = "里克提克皇帝之墓",
	["Emperor's Omen"] = "皇帝的预言地",
	["Emperor's Reach"] = "帝皇之域",
	["End Time"] = "时光之末",
	["Engineering Labs"] = "工程实验室",
	["Engineering Labs "] = "工程实验室",
	["Engine of Nalak'sha"] = "纳拉克煞引擎",
	["Engine of the Makers"] = "造物者引擎",
	["Entryway of Time"] = "时光入口",
	["Ethel Rethor"] = "艾瑟雷索",
	["Ethereal Corridor"] = "天界回廊",
	["Ethereum Staging Grounds"] = "复仇军前沿基地",
	["Evergreen Trading Post"] = "常青商栈",
	Evergrove = "常青林",
	Everlook = "永望镇",
	["Eversong - Duskwither Teleport"] = "永歌森林 - 达斯维瑟",
	["Eversong Woods"] = "永歌森林",
	["Excavation Center"] = "挖掘中心",
	["Excavation Lift"] = "挖掘场升降梯",
	["Exclamation Point"] = "惊叹角",
	["Expedition Armory"] = "远征军物资库",
	["Expedition Base Camp"] = "远征军营地",
	["Expedition Point"] = "远征军岗哨",
	["Explorers' League Digsite"] = "探险者协会挖掘场",
	["Explorers' League Outpost"] = "探险者协会哨站",
	["Exposition Pavilion"] = "展览帐篷",
	["Eye of Eternity"] = "永恒之眼",
	["Eye of the Storm"] = "风暴之眼",
	["Fairbreeze Village"] = "晴风村",
	["Fairbridge Strand"] = "玉桥海滩",
	["Falcon Watch"] = "猎鹰岗哨",
	["Falconwing Inn"] = "鹰翼旅店",
	["Falconwing Square"] = "鹰翼广场",
	["Faldir's Cove"] = "法迪尔海湾",
	["Falfarren River"] = "弗伦河",
	["Fallen Sky Lake"] = "坠星湖",
	["Fallen Sky Ridge"] = "坠星山",
	["Fallen Temple of Ahn'kahet"] = "坍塌的安卡赫特神殿",
	["Fall of Return"] = "回归瀑布",
	["Fallowmere Inn"] = "法罗米尔旅店",
	["Fallow Sanctuary"] = "农田避难所",
	["Falls of Ymiron"] = "伊米隆瀑布",
	["Fallsong Village"] = "瀑歌村",
	["Falthrien Academy"] = "法瑟林学院",
	Familiars = "亲友团",
	["Faol's Rest"] = "法奥之墓",
	["Fargaze Mesa"] = "远眺台地",
	["Fargodeep Mine"] = "法戈第矿洞",
	Farm = "农场",
	Farshire = "致远郡",
	["Farshire Fields"] = "致远郡农场",
	["Farshire Lighthouse"] = "致远郡灯塔",
	["Farshire Mine"] = "致远郡矿洞",
	["Farson Hold"] = "法尔森要塞",
	["Farstrider Enclave"] = "远行者营地",
	["Farstrider Lodge"] = "旅行者营地",
	["Farstrider Retreat"] = "远行者居所",
	["Farstriders' Enclave"] = "远行者营地",
	["Farstriders' Square"] = "远行者广场",
	["Farwatcher's Glen"] = "远望角",
	["Farwatch Overlook"] = "远戍哨站",
	["Far Watch Post"] = "前沿哨所",
	["Fear Clutch"] = "恐惧之巢",
	["Featherbeard's Hovel"] = "羽须小屋",
	Feathermoon = "羽月要塞",
	["Feathermoon Stronghold"] = "羽月要塞",
	["Fe-Feng Village"] = "狒狒村",
	["Felfire Hill"] = "冥火岭",
	["Felpaw Village"] = "魔爪村",
	["Fel Reaver Ruins"] = "魔能机甲废墟",
	["Fel Rock"] = "地狱石",
	["Felspark Ravine"] = "魔火峡谷",
	["Felstone Field"] = "费尔斯通农场",
	Felwood = "费伍德森林",
	["Fenris Isle"] = "芬里斯岛",
	["Fenris Keep"] = "芬里斯城堡",
	Feralas = "菲拉斯",
	["Feralfen Village"] = "蛮沼村",
	["Feral Scar Vale"] = "深痕谷",
	["Festering Pools"] = "溃烂之池",
	["Festival Lane"] = "节日小道",
	["Feth's Way"] = "菲斯小径",
	["Field of Korja"] = "科夏平原",
	["Field of Strife"] = "征战平原",
	["Fields of Blood"] = "鲜血旷野",
	["Fields of Honor"] = "荣耀之地",
	["Fields of Niuzao"] = "砮皂旷野",
	Filming = "拍摄",
	["Final Gate - Mogu Island Progression Scenario"] = "Final Gate - Mogu Island Progression Scenario",
	["Firebeard Cemetery"] = "焰须墓地",
	["Firebeard's Patrol"] = "焰须巡逻营",
	["Firebough Nook"] = "火树村",
	["Fire Camp Bataar"] = "巴塔尔火营",
	["Fire Camp Gai-Cho"] = "铠胄火营",
	["Fire Camp Ordo"] = "斡耳朵火营",
	["Fire Camp Osul"] = "奥苏尔火营",
	["Fire Camp Ruqin"] = "卢秦火营",
	["Fire Camp Yongqi"] = "勇齐火营",
	["Firegut Furnace"] = "火腹熔炉",
	Firelands = "火焰之地",
	["Firelands Forgeworks"] = "火焰之地锻造厂",
	["Firelands Hatchery"] = "火焰之地孵化场",
	["Firelands Terrain 2"] = "火焰之地，地形2",
	["Fireplume Peak"] = "火羽峰",
	["Fire Plume Ridge"] = "火羽山",
	["Fireplume Trench"] = "火羽海沟",
	["Fire Scar Shrine"] = "火痕神殿",
	["Fire Stone Mesa"] = "火石台地",
	["Firestone Point"] = "火石岗哨",
	["Firewatch Ridge"] = "观火岭",
	["Firewing Point"] = "火翼岗哨",
	["First Bank of Kezan"] = "科赞第一银行",
	["First Legion Forward Camp"] = "第一军团前线营地",
	["First to Your Aid"] = "急你所急",
	["Fishing Village"] = "钓鱼村",
	["Fizzcrank Airstrip"] = "菲兹兰克机场",
	["Fizzcrank Pumping Station"] = "菲兹兰克泵站",
	["Fizzle & Pozzik's Speedbarge"] = "菲兹尔和普兹克的赛艇平台",
	["Fjorn's Anvil"] = "弗约恩之砧",
	Flamebreach = "火焰裂口",
	["Flame Crest"] = "烈焰峰",
	["Flamestar Post"] = "焰星哨站",
	["Flamewatch Tower"] = "火光塔楼",
	["Flavor - Stormwind Harbor - Stop"] = "Flavor - Stormwind Harbor - Stop",
	["Fleshrender's Workshop"] = "血肉撕裂者的车间",
	["Foothold Citadel"] = "塞拉摩堡垒",
	["Footman's Armory"] = "步兵武器库",
	["Force Interior"] = "内室",
	["Fordragon Hold"] = "弗塔根要塞",
	["Forest Heart"] = "翠林之心",
	["Forest's Edge"] = "林边空地",
	["Forest's Edge Post"] = "林边哨站",
	["Forest Song"] = "林歌神殿",
	["Forge Base: Gehenna"] = "铸魔基地：炼狱",
	["Forge Base: Oblivion"] = "铸魔基地：湮灭",
	["Forge Camp: Anger"] = "铸魔营地：怒火",
	["Forge Camp: Fear"] = "铸魔营地：畏惧",
	["Forge Camp: Hate"] = "铸魔营地：仇恨",
	["Forge Camp: Mageddon"] = "铸魔营地：暴虐",
	["Forge Camp: Rage"] = "铸魔营地：狂乱",
	["Forge Camp: Terror"] = "铸魔营地：恐怖",
	["Forge Camp: Wrath"] = "铸魔营地：天罚",
	["Forge of Fate"] = "命运熔炉",
	["Forge of the Endless"] = "无尽熔炉",
	["Forgewright's Tomb"] = "铸铁之墓",
	["Forgotten Depths"] = "被遗忘的深渊",
	["Forgotten Hill"] = "遗忘山丘",
	["Forgotten Mire"] = "遗忘泥沼",
	["Forgotten Passageway"] = "遗忘长廊",
	["Forlorn Cloister"] = "遗忘回廊",
	["Forlorn Hut"] = "荒弃小屋",
	["Forlorn Ridge"] = "凄凉山",
	["Forlorn Rowe"] = "荒弃鬼屋",
	["Forlorn Spire"] = "荒芜尖塔",
	["Forlorn Woods"] = "绝望之林",
	["Formation Grounds"] = "练兵场",
	["Forsaken Forward Command"] = "被遗忘者前线指挥部",
	["Forsaken High Command"] = "被遗忘者统帅部",
	["Forsaken Rear Guard"] = "被遗忘者后卫军",
	["Fort Livingston"] = "利文斯顿营地",
	["Fort Silverback"] = "银背堡垒",
	["Fort Triumph"] = "凯旋壁垒",
	["Fortune's Fist"] = "财富之拳",
	["Fort Wildervar"] = "维德瓦堡垒",
	["Forward Assault Camp"] = "前方突袭营",
	["Forward Command"] = "前线指挥站",
	["Foulspore Cavern"] = "毒孢洞穴",
	["Foulspore Pools"] = "毒菇洞穴",
	["Fountain of the Everseeing"] = "永视泉",
	["Fox Grove"] = "狐狸森林",
	["Fractured Front"] = "碎裂前线",
	["Frayfeather Highlands"] = "乱羽高地",
	["Fray Island"] = "勇士岛",
	["Frazzlecraz Motherlode"] = "弗兹卡勒的主矿脉",
	["Freewind Post"] = "乱风岗",
	["Frenzyheart Hill"] = "狂心岭",
	["Frenzyheart River"] = "狂心河",
	["Frigid Breach"] = "冰冷裂口",
	["Frostblade Pass"] = "霜刃小径",
	["Frostblade Peak"] = "霜刃峰",
	["Frostclaw Den"] = "霜爪兽穴",
	["Frost Dagger Pass"] = "霜刀小径",
	["Frostfield Lake"] = "霜原湖",
	["Frostfire Hot Springs"] = "冰火温泉",
	["Frostfloe Deep"] = "浮冰深渊",
	["Frostgrip's Hollow"] = "霜握的洞穴",
	Frosthold = "冰霜堡",
	["Frosthowl Cavern"] = "霜嚎洞穴",
	["Frostmane Front"] = "霜鬃前线",
	["Frostmane Hold"] = "霜鬃巨魔要塞",
	["Frostmane Hovel"] = "霜鬃洞穴",
	["Frostmane Retreat"] = "霜鬃营地",
	Frostmourne = "霜之哀伤",
	["Frostmourne Cavern"] = "霜之哀伤洞穴",
	["Frostsaber Rock"] = "霜刀石",
	["Frostwhisper Gorge"] = "霜语峡谷",
	["Frostwing Halls"] = "霜翼之巢",
	["Frostwolf Graveyard"] = "霜狼墓地",
	["Frostwolf Keep"] = "霜狼要塞",
	["Frostwolf Pass"] = "霜狼小径",
	["Frostwolf Tunnel"] = "霜狼隧道",
	["Frostwolf Village"] = "霜狼村",
	["Frozen Reach"] = "冰冻平原",
	["Fungal Deep"] = "真菌洞穴",
	["Fungal Rock"] = "蘑菇石",
	["Funggor Cavern"] = "蘑菇洞",
	["Furien's Post"] = "弗瑞恩的哨站",
	["Furlbrow's Pumpkin Farm"] = "法布隆南瓜农场",
	["Furnace of Hate"] = "仇恨熔炉",
	["Furywing's Perch"] = "弗雷文栖木",
	Fuselight = "熔光镇",
	["Fuselight-by-the-Sea"] = "熔光码头",
	["Fu's Pond"] = "福家小池",
	Gadgetzan = "加基森",
	["Gahrron's Withering"] = "盖罗恩农场",
	["Gai-Cho Battlefield"] = "铠胄战线",
	["Galak Hold"] = "加拉克城堡",
	["Galakrond's Rest"] = "迦拉克隆之墓",
	["Galardell Valley"] = "加拉德尔山谷",
	["Galen's Fall"] = "加林之陨",
	["Galerek's Remorse"] = "盖尔雷克的悔恨",
	["Galewatch Lighthouse"] = "风暴信标灯塔",
	["Gallery of Treasures"] = "珍宝陈列室",
	["Gallows' Corner"] = "绞刑场",
	["Gallows' End Tavern"] = "恐惧之末旅店",
	["Gallywix Docks"] = "加里维克斯码头",
	["Gallywix Labor Mine"] = "加里维克斯劳工矿井",
	["Gallywix Pleasure Palace"] = "加里维克斯忘忧宫",
	["Gallywix's Villa"] = "加里维克斯的别墅",
	["Gallywix's Yacht"] = "加里维克斯的游艇",
	["Galus' Chamber"] = "加鲁斯之厅",
	["Gamesman's Hall"] = "象棋大厅",
	Gammoth = "迦莫斯",
	["Gao-Ran Battlefront"] = "高岚阵",
	Garadar = "加拉达尔",
	["Gar'gol's Hovel"] = "伽格尔的营地",
	Garm = "加姆",
	["Garm's Bane"] = "加姆雷区",
	["Garm's Rise"] = "加姆高地",
	["Garren's Haunt"] = "加伦鬼屋",
	["Garrison Armory"] = "要塞军械库",
	["Garrosh'ar Advance"] = "加尔鲁什尔先锋营",
	["Garrosh'ar Point"] = "加尔鲁什尔前哨站",
	["Garrosh's Landing"] = "加尔鲁什码头",
	["Garvan's Reef"] = "加维暗礁",
	["Gate of Echoes"] = "回音之门",
	["Gate of Endless Spring"] = "永春之门",
	["Gate of Hamatep"] = "哈玛特普之门",
	["Gate of Lightning"] = "闪电之门",
	["Gate of the August Celestials"] = "天神之门",
	["Gate of the Blue Sapphire"] = "蓝玉之门",
	["Gate of the Green Emerald"] = "翡翠之门",
	["Gate of the Purple Amethyst"] = "紫晶之门",
	["Gate of the Red Sun"] = "红日之门",
	["Gate of the Setting Sun"] = "残阳关",
	["Gate of the Yellow Moon"] = "金月之门",
	["Gates of Ahn'Qiraj"] = "安其拉之门",
	["Gates of Ironforge"] = "铁炉堡大门",
	["Gates of Sothann"] = "索萨恩之门",
	["Gauntlet of Flame"] = "烈焰通道",
	["Gavin's Naze"] = "加文高地",
	["Geezle's Camp"] = "吉兹尔的营地",
	["Gelkis Village"] = "吉尔吉斯村",
	["General Goods"] = "杂货",
	["General's Terrace"] = "将军平台",
	["Ghostblade Post"] = "幽刃岗哨",
	Ghostlands = "幽魂之地",
	["Ghost Walker Post"] = "幽灵岗哨",
	["Giant's Run"] = "巨人平原",
	["Giants' Run"] = "巨人平原",
	["Gilded Fan"] = "金扇泽",
	["Gillijim's Isle"] = "吉利吉姆之岛",
	["Gilnean Coast"] = "吉尔尼恩海岸",
	["Gilnean Stronghold"] = "吉尔尼恩要塞",
	Gilneas = "吉尔尼斯",
	Gilneas2 = "吉尔尼斯2",
	["Gilneas City"] = "吉尔尼斯城",
	["Gilneas (Do Not Reuse)"] = "Gilneas (Do Not Reuse)",
	["Gilneas Liberation Front Base Camp"] = "吉尔尼斯解放阵线营地",
	GilneasPhase1 = "吉尔尼斯位面1",
	GilneasPhase2 = "吉尔尼斯位面2",
	["Gimorak's Den"] = "基莫拉克之巢",
	Gjalerbron = "亚勒伯龙",
	Gjalerhorn = "亚勒霍恩",
	["Glacial Falls"] = "冰川瀑布",
	["Glimmer Bay"] = "幽光海湾",
	["Glimmerdeep Gorge"] = "光渊峡谷",
	["Glittering Strand"] = "灿烂海岸",
	["Glopgut's Hollow"] = "黏肠峡谷",
	["Glorious Goods"] = "荣耀杂货店",
	Glory = "荣耀号",
	["GM Island"] = "GM Island",
	["Gnarlpine Hold"] = "瘤背堡",
	["Gnaws' Boneyard"] = "虎鲸坟场",
	Gnomeregan = "诺莫瑞根",
	["Gobline Mine"] = "地精矿洞",
	["Goblin Foundry"] = "地精锻造厂",
	["Goblin Mine"] = "地精矿洞",
	["Goblin Slums"] = "地精贫民窟",
	["Gokk'lok's Grotto"] = "古克罗克的洞穴",
	["Gokk'lok Shallows"] = "古克罗克浅滩",
	["Golakka Hot Springs"] = "葛拉卡温泉",
	["Gol'Bolar Quarry"] = "古博拉采掘场",
	["Gol'Bolar Quarry Mine"] = "古博拉采掘场",
	["Gold Coast Quarry"] = "金海岸矿洞",
	["Goldenbough Pass"] = "金枝小径",
	["Goldenmist Village"] = "金雾村",
	["Golden Strand"] = "金色沙滩",
	["Gold Mine"] = "矿洞",
	["Gold Road"] = "黄金之路",
	["Gold Rush BG"] = "夺金战场",
	Goldshire = "闪金镇",
	["Goldtooth's Den"] = "金牙的巢穴",
	["Goodgrub Smoking Pit"] = "精掘烟熏坑",
	["Gordok's Seat"] = "戈多克的王座",
	["Gordunni Outpost"] = "戈杜尼前哨站",
	["Gorefiend's Vigil"] = "血魔之厅",
	["Gor'gaz Outpost"] = "高加兹前哨",
	Gornia = "戈尼亚",
	["Gorrok's Lament"] = "格洛克的挽歌",
	["Gorshak War Camp"] = "哥沙克战争营地",
	["Go'Shek Farm"] = "格沙克农场",
	["Grain Cellar"] = "谷仓地窖",
	["Grand Courtyard"] = "大广场",
	["Grand Magister's Asylum"] = "大魔导师的圣堂",
	["Grand Overlook"] = "大露台",
	["Grand Promenade"] = "壮丽步道",
	["Grangol'var Village"] = "格兰戈瓦村",
	["Granite Springs"] = "岩石之泉",
	["Grassy Cline"] = "草海",
	["Greatwood Vale"] = "巨木谷",
	["Greengill Coast"] = "绿鳃海岸",
	["Greenpaw Village"] = "绿爪村",
	["Greenstone Dojo"] = "绿石道场",
	["Greenstone Inn"] = "绿石酒肆",
	["Greenstone Masons' Quarter"] = "绿石工匠区",
	["Greenstone Quarry"] = "绿石采掘场",
	["Greenstone Village"] = "绿石村",
	["Greenwarden's Grove"] = "绿色守卫者林地",
	["Greymane Court"] = "格雷迈恩皇家庭院",
	["Greymane Manor"] = "格雷迈恩庄园",
	["Greymist Firth"] = "灰雾海湾",
	["Grim Batol"] = "格瑞姆巴托",
	["Grim Batol Entrance"] = "格瑞姆巴托入口",
	["Grimesilt Dig Site"] = "煤渣挖掘场",
	["Grimtotem Compound"] = "恐怖图腾营地",
	["Grimtotem Post"] = "恐怖图腾岗哨",
	Grishnath = "格里施纳",
	Grizzlemaw = "灰喉堡",
	["Grizzlepaw Ridge"] = "灰爪山",
	["Grizzly Hills"] = "灰熊丘陵",
	["Grol'dom Farm"] = "格罗多姆农场",
	["Grolluk's Grave"] = "格洛鲁克之墓",
	["Grom'arsh Crash-Site"] = "格罗玛什坠毁点",
	["Grom'gol"] = "格罗姆高",
	["Grom'gol Base Camp"] = "格罗姆高营地",
	["Grommash Hold"] = "格罗玛什要塞",
	["Grookin Hill"] = "古鲁金猴山",
	["Grosh'gok Compound"] = "格罗高克营地",
	["Grove of Aessina"] = "艾森娜林地",
	["Grove of Falling Blossoms"] = "落英林",
	["Grove of the Ancients"] = "古树之林",
	["Growless Cave"] = "无草洞",
	["Gruul's Lair"] = "格鲁尔的巢穴",
	["Gryphon Roost"] = "狮鹫栖木",
	["Guardian's Library"] = "守护者的图书馆",
	Gundrak = "古达克",
	["Gundrak Entrance"] = "古达克入口",
	["Gunstan's Dig"] = "古斯坦的哨岗",
	["Gunstan's Post"] = "古斯坦的哨岗",
	["Gunther's Retreat"] = "冈瑟尔的居所",
	["Guo-Lai Halls"] = "郭莱古厅",
	["Guo-Lai Ritual Chamber"] = "郭莱仪祭密室",
	["Guo-Lai Vault"] = "郭莱宝库",
	["Gurboggle's Ledge"] = "戈博格海崖",
	["Gurubashi Arena"] = "古拉巴什竞技场",
	["Gyro-Plank Bridge"] = "机械桥",
	["Haal'eshi Gorge"] = "哈尔什峡谷",
	["Hadronox's Lair"] = "哈多诺克斯之巢",
	["Hailwood Marsh"] = "乱木沼泽",
	Halaa = "哈兰",
	["Halaani Basin"] = "哈兰盆地",
	["Halcyon Egress"] = "哈尔西恩法阵",
	["Haldarr Encampment"] = "哈达尔营地",
	Halfhill = "半山",
	Halgrind = "哈尔格林德",
	["Hall of Arms"] = "武器大厅",
	["Hall of Binding"] = "禁锢之厅",
	["Hall of Blackhand"] = "黑手大厅",
	["Hall of Blades"] = "剑刃大厅",
	["Hall of Bones"] = "白骨大厅",
	["Hall of Champions"] = "勇士大厅",
	["Hall of Command"] = "命令大厅",
	["Hall of Crafting"] = "工艺之厅",
	["Hall of Departure"] = "离别大厅",
	["Hall of Explorers"] = "探险者大厅",
	["Hall of Faces"] = "千面大厅",
	["Hall of Horrors"] = "恐惧大厅",
	["Hall of Illusions"] = "幻像大厅",
	["Hall of Kings"] = "先王殿",
	["Hall of Legends"] = "传说大厅",
	["Hall of Masks"] = "面具大厅",
	["Hall of Memories"] = "回忆大厅",
	["Hall of Mysteries"] = "秘法大厅",
	["Hall of Repose"] = "休眠大厅",
	["Hall of Return"] = "回归大厅",
	["Hall of Ritual"] = "仪式大厅",
	["Hall of Secrets"] = "密语之厅",
	["Hall of Serpents"] = "毒蛇大厅",
	["Hall of Shapers"] = "塑造者大厅",
	["Hall of Stasis"] = "停滞大厅",
	["Hall of the Brave"] = "勇者大厅",
	["Hall of the Conquered Kings"] = "败降王者之厅",
	["Hall of the Crafters"] = "工匠大厅",
	["Hall of the Crescent Moon"] = "新月大厅",
	["Hall of the Crusade"] = "征伐大厅",
	["Hall of the Cursed"] = "诅咒大厅",
	["Hall of the Damned"] = "谴责之厅",
	["Hall of the Defamed"] = "无颜殿",
	["Hall of the Exalted"] = "至尊殿",
	["Hall of the Fathers"] = "先辈大厅",
	["Hall of the Frostwolf"] = "霜狼大厅",
	["Hall of the Grand Imperion"] = "禁都卫统领大殿",
	["Hall of the High Father"] = "圣父之厅",
	["Hall of the Keepers"] = "守护者大厅",
	["Hall of the Shaper"] = "塑造者之厅",
	["Hall of the Stormpike"] = "雷矛大厅",
	["Hall of the Tortured"] = "刑罚大厅",
	["Hall of the Watchers"] = "观察者大厅",
	["Hall of the Wicked"] = "背德大厅",
	["Hall of Tombs"] = "古陵大厅",
	["Hall of Tranquility"] = "静思之厅",
	["Hall of Tranquillity"] = "静思之厅",
	["Hall of Twilight"] = "暮色大厅",
	["Halls of Anguish"] = "苦痛大厅",
	["Halls of Awakening"] = "觉醒大厅",
	["Halls of Binding"] = "束缚大厅",
	["Halls of Destruction"] = "毁灭大厅",
	["Halls of Flesh-Shaping"] = "修身殿",
	["Halls of Lightning"] = "闪电大厅",
	["Halls of Lightning Entrance"] = "闪电大厅入口",
	["Halls of Mourning"] = "哀悼大厅",
	["Halls of Origination"] = "起源大厅",
	["Halls of Origination Entrance"] = "起源大厅入口",
	["Halls of Reflection"] = "映像大厅",
	["Halls of Reflection Entrance"] = "映像大厅入口",
	["Halls of Silence"] = "沉默大厅",
	["Halls of Stone"] = "岩石大厅",
	["Halls of Stone Entrance"] = "岩石大厅入口",
	["Halls of Strife"] = "征战大厅",
	["Halls of the Ancestors"] = "先祖大厅",
	["Halls of the Hereafter"] = "转生大厅",
	["Halls of the Law"] = "秩序大厅",
	["Halls of Theory"] = "学术大厅",
	["Halycon's Lair"] = "哈雷肯之巢",
	Hammerfall = "落锤镇",
	["Hammertoe's Digsite"] = "铁趾挖掘场",
	["Hammond Farmstead"] = "哈蒙德农场",
	Hangar = "飞艇基地",
	["Hardknuckle Clearing"] = "硬皮旷野",
	["Hardwrench Hideaway"] = "硬钳避世乐园",
	["Harkor's Camp"] = "哈考尔营地",
	["Hatchet Hills"] = "战斧岭",
	["Hatescale Burrow"] = "恨鳞地穴",
	["Hatred's Vice"] = "仇恨之恶",
	Havenshire = "海文郡",
	["Havenshire Farms"] = "海文郡农场",
	["Havenshire Lumber Mill"] = "海文郡伐木场",
	["Havenshire Mine"] = "海文郡矿洞",
	["Havenshire Stables"] = "海文郡马厩",
	["Hayward Fishery"] = "海瓦尔德渔场",
	["Headmaster's Retreat"] = "院长的房间",
	["Headmaster's Study"] = "院长的书房",
	Hearthglen = "壁炉谷",
	["Heart of Destruction"] = "毁灭之心",
	["Heart of Fear"] = "恐惧之心",
	["Heart of the Old God Scenario"] = "古神之心场景战役",
	["Heart of Zan'vess"] = "扎尼维斯之心",
	["Heart's Blood Shrine"] = "心血神殿",
	["Heartwood Trading Post"] = "心木商栈",
	["Heb'Drakkar"] = "赫布达卡",
	["Heb'Valok"] = "赫布瓦罗",
	["Hellfire Basin"] = "地狱火盆地",
	["Hellfire Citadel"] = "地狱火堡垒",
	["Hellfire Citadel: Ramparts"] = "地狱火堡垒：城墙",
	["Hellfire Citadel - Ramparts Entrance"] = "地狱火堡垒 - 城墙入口",
	["Hellfire Citadel: The Blood Furnace"] = "地狱火堡垒：鲜血熔炉",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "地狱火堡垒 - 鲜血熔炉入口",
	["Hellfire Citadel: The Shattered Halls"] = "地狱火堡垒：破碎大厅",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "地狱火堡垒 - 破碎大厅入口",
	["Hellfire Peninsula"] = "地狱火半岛",
	["Hellfire Peninsula - Force Camp Beach Head"] = "地狱火半岛 - 前敌营地",
	["Hellfire Peninsula - Reaver's Fall"] = "地狱火半岛 - 机甲残骸",
	["Hellfire Ramparts"] = "地狱火城墙",
	["Hellscream Arena"] = "地狱咆哮竞技场",
	["Hellscream's Camp"] = "地狱咆哮营地",
	["Hellscream's Fist"] = "地狱咆哮之拳",
	["Hellscream's Grasp"] = "地狱咆哮之握",
	["Hellscream's Watch"] = "地狱咆哮岗哨",
	["Helm's Bed Lake"] = "盔枕湖",
	["Heroes' Vigil"] = "英雄哨岗",
	["Hetaera's Clutch"] = "赫塔拉的巢穴",
	["Hewn Bog"] = "菌杆沼泽",
	["Heyman's Hubris"] = "海曼之傲",
	["Hibernal Cavern"] = "冬眠洞穴",
	["Hidden Cell"] = "密室",
	["Hidden Path"] = "秘道",
	Highbank = "滩头堡",
	["High Bank"] = "滩头堡",
	["Highland Forest"] = "高地森林",
	Highperch = "风巢",
	["High Wilderness"] = "高原荒野",
	Hillsbrad = "希尔斯布莱德",
	["Hillsbrad Fields"] = "希尔斯布莱德农场",
	["Hillsbrad Foothills"] = "希尔斯布莱德丘陵",
	["Hiri'watha Research Station"] = "西利瓦萨研究站",
	["Hive'Ashi"] = "亚什虫巢",
	["Hive'Regal"] = "雷戈虫巢",
	["Hive'Zora"] = "佐拉虫巢",
	["Hogger Hill"] = "霍格山",
	["Hollowed Out Tree"] = "刳心巨树",
	["Hollowstone Mine"] = "空石矿洞",
	["Honeydew Farm"] = "蜜露农田",
	["Honeydew Glade"] = "蜜露林地",
	["Honeydew Village"] = "蜜露村",
	["Honor Hold"] = "荣耀堡",
	["Honor Hold Mine"] = "荣耀堡矿洞",
	["Honor Point"] = "荣耀岗哨",
	["Honor's Stand"] = "荣耀岗哨",
	["Honor's Tomb"] = "荣耀之墓",
	["Horde Base Camp"] = "部落营地",
	["Horde Beach Daily Area"] = "部落海滩日常区域",
	["Horde Encampment"] = "部落营地",
	["Horde Keep"] = "部落要塞",
	["Horde Landing"] = "部落登陆点",
	["Horde Landing Site"] = "部落登陆场",
	["Hordemar City"] = "霍德玛尔城",
	["Horde PVP Barracks"] = "部落PvP兵营",
	["Horror Clutch"] = "惊骇之巢",
	["Hour of Twilight"] = "暮光审判",
	["House of Edune"] = "埃杜恩的小屋",
	["Howling Fjord"] = "嚎风峡湾",
	["Howlingwind Cavern"] = "凛风洞",
	["Howlingwind Trail"] = "凛风小径",
	["Howling Ziggurat"] = "鬼嚎通灵塔",
	["Hrothgar's Landing"] = "洛斯加尔登陆点",
	["Huangtze Falls"] = "黄泽瀑布",
	["Hull of the Foebreaker"] = "荡寇号的船身",
	["Humboldt Conflagration"] = "洪堡焚烧峡谷",
	["Hunter Rise"] = "猎人高地",
	["Hunter's Hill"] = "猎手岭",
	["Huntress of the Sun"] = "太阳女猎手",
	["Huntsman's Cloister"] = "猎手回廊",
	Hyjal = "海加尔山",
	["Hyjal Barrow Dens"] = "海加尔兽穴",
	["Hyjal Past"] = "海加尔",
	["Hyjal Summit"] = "海加尔峰",
	["Iceblood Garrison"] = "冰血要塞",
	["Iceblood Graveyard"] = "冰血墓地",
	Icecrown = "冰冠冰川",
	["Icecrown Citadel"] = "冰冠堡垒",
	["Icecrown Dungeon - Gunships"] = "冰冠堡垒副本 - 炮艇",
	["Icecrown Glacier"] = "冰冠冰川",
	["Iceflow Lake"] = "涌冰湖",
	["Ice Heart Cavern"] = "冰心洞穴",
	["Icemist Falls"] = "冰雾瀑布",
	["Icemist Village"] = "冰雾村",
	["Ice Thistle Hills"] = "冰蓟岭",
	["Icewing Bunker"] = "冰翼碉堡",
	["Icewing Cavern"] = "冰翼洞穴",
	["Icewing Pass"] = "冰翼小径",
	["Idlewind Lake"] = "微风湖",
	["Igneous Depths"] = "火岩深渊",
	["Ihgaluk Crag"] = "伊瓜鲁克峭壁",
	["Ik'vess"] = "伊克维斯",
	["Ikz'ka Ridge"] = "伊卡兹卡山",
	["Illidari Point"] = "伊利达雷岗哨",
	["Illidari Training Grounds"] = "伊利达雷训练场",
	["Indu'le Village"] = "因度雷村",
	["Infiltrating the Shipyard"] = "潜入船坞",
	["Inkgill Mere"] = "墨鳃潭",
	Inn = "旅店",
	["Inner Sanctum"] = "内部圣殿",
	["Inner Veil"] = "内厅",
	["Insidion's Perch"] = "因斯迪安栖木",
	["Invasion Point: Annihilator"] = "登陆场：歼灭",
	["Invasion Point: Cataclysm"] = "登陆场：灾难",
	["Invasion Point: Destroyer"] = "登陆场：破坏",
	["Invasion Point: Overlord"] = "登陆场：霸王",
	["Ironband's Compound"] = "铁环营地",
	["Ironband's Excavation Site"] = "铁环挖掘场",
	["Ironbeard's Tomb"] = "铁须之墓",
	["Ironclad Cove"] = "铁甲湾",
	["Ironclad Garrison"] = "铁甲兵营",
	["Ironclad Prison"] = "铁栏监狱",
	["Iron Concourse"] = "钢铁广场",
	["Irondeep Mine"] = "深铁矿洞",
	Ironforge = "铁炉堡",
	["Ironforge Airfield"] = "铁炉堡飞行器机坪",
	["Ironstone Camp"] = "铁石营地",
	["Ironstone Plateau"] = "铁石高原",
	["Iron Summit"] = "铸铁峰",
	["Irontree Cavern"] = "铁木山洞",
	["Irontree Clearing"] = "铁木工程营",
	["Irontree Woods"] = "铁木森林",
	["Ironwall Dam"] = "铁墙大坝",
	["Ironwall Rampart"] = "铁墙壁垒",
	["Ironwing Cavern"] = "铁翼洞穴",
	Iskaal = "伊斯卡尔",
	["Island of Doctor Lapidis"] = "拉匹迪斯之岛",
	["Isle of Conquest"] = "征服之岛",
	["Isle of Conquest No Man's Land"] = "征服之岛（禁区）",
	["Isle of Dread"] = "恐怖之岛",
	["Isle of Giants"] = "巨兽岛",
	["Isle of Quel'Danas"] = "奎尔丹纳斯岛",
	["Isle of Reckoning"] = "末劫岛",
	["Isle of Thunder"] = "雷神岛",
	["Isle of Tribulations"] = "苦难岛",
	["Iso'rath"] = "厄索拉斯",
	["Itharius's Cave"] = "伊萨里奥斯洞穴",
	["Ivald's Ruin"] = "伊瓦尔德废墟",
	["Ix'lar's Domain"] = "埃克斯拉尔的领地",
	["Jadefire Glen"] = "碧火谷",
	["Jadefire Run"] = "碧火小径",
	["Jade Forest Alliance Hub Phase"] = "Jade Forest Alliance Hub Phase",
	["Jade Forest Battlefield Phase"] = "Jade Forest Battlefield Phase",
	["Jade Forest Horde Starting Area"] = "Jade Forest Horde Starting Area",
	["Jademir Lake"] = "加德米尔湖",
	["Jade Temple Grounds"] = "青龙寺庭院",
	Jaedenar = "加德纳尔",
	["Jagged Reef"] = "锯齿暗礁",
	["Jagged Ridge"] = "锯齿山",
	["Jaggedswine Farm"] = "野猪农场",
	["Jagged Wastes"] = "崎石废土",
	["Jaguero Isle"] = "哈圭罗岛",
	["Jaina Dalaran Scenario"] = "吉安娜达拉然场景",
	["Janeiro's Point"] = "加尼罗哨站",
	["Jangolode Mine"] = "詹戈洛德矿洞",
	["Jaquero Isle"] = "哈圭罗岛",
	["Jasperlode Mine"] = "玉石矿洞",
	["Jeff NE Quadrant Changed"] = "Jeff NE Quadrant",
	["Jeff NW Quadrant"] = "Jeff NW Quadrant",
	["Jeff SE Quadrant"] = "Jeff SE Quadrant",
	["Jeff SW Quadrant"] = "Jeff SW Quadrant",
	["Jerod's Landing"] = "杰罗德码头",
	["Jintha'Alor"] = "辛萨罗",
	["Jintha'kalar"] = "金萨卡拉",
	["Jintha'kalar Passage"] = "金萨卡拉小径",
	["Jin Yang Road"] = "锦阳大道",
	Jotunheim = "尤顿海姆",
	K3 = "K3",
	["Kaja'mine"] = "卡亚矿井",
	["Kaja'mite Cave"] = "卡亚矿洞穴",
	["Kaja'mite Cavern"] = "卡亚矿洞",
	["Kajaro Field"] = "卡亚罗运动场",
	["Kal'ai Ruins"] = "卡莱废墟",
	Kalimdor = "卡利姆多",
	Kamagua = "卡玛古",
	["Karabor Sewers"] = "卡拉波下水道",
	Karazhan = "卡拉赞",
	["Kargathia Keep"] = "卡加希亚要塞",
	["Karnum's Glade"] = "卡隆林地",
	["Kartak's Hold"] = "卡塔克要塞",
	Kaskala = "卡斯卡拉",
	["Kaw's Roost"] = "卡奥的营地",
	["Kea Krak"] = "奇亚卡拉克",
	["Keelen's Trustworthy Tailoring"] = "基伦的裁缝店",
	["Keel Harbor"] = "覆舟海湾",
	["Keeshan's Post"] = "基沙恩的哨站",
	["Kelp'thar Forest"] = "柯尔普萨之森",
	["Kel'Thuzad Chamber"] = "克尔苏加德的大厅",
	["Kel'Thuzad's Chamber"] = "克尔苏加德的大厅",
	["Keset Pass"] = "柯塞特小径",
	["Kessel's Crossing"] = "凯希尔路口",
	Kezan = "科赞",
	Kharanos = "卡拉诺斯",
	["Khardros' Anvil"] = "卡德罗斯的铁砧",
	["Khartut's Tomb"] = "卡塔图陵墓",
	["Khaz'goroth's Seat"] = "卡兹格罗斯之座",
	["Ki-Han Brewery"] = "祁翰酒坊",
	["Kili'ua's Atoll"] = "基利瓦的礁石",
	["Kil'sorrow Fortress"] = "基尔索罗堡垒",
	["King's Gate"] = "国王之门",
	["King's Harbor"] = "国王港",
	["King's Hoard"] = "国王的宝库",
	["King's Square"] = "国王广场",
	["Kirin'Var Village"] = "肯瑞瓦村",
	Kirthaven = "库斯海文",
	["Klaxxi'vess"] = "卡拉克西维斯",
	["Klik'vess"] = "奇里克维斯",
	["Knucklethump Hole"] = "肘锤洞窟",
	["Kodo Graveyard"] = "科多兽坟场",
	["Kodo Rock"] = "科多石",
	["Kolkar Village"] = "科尔卡村",
	Kolramas = "科尔拉玛斯",
	["Kor'kron Vanguard"] = "库卡隆先锋营地",
	["Kormek's Hut"] = "考米克小屋",
	["Koroth's Den"] = "克洛斯的巢穴",
	["Korthun's End"] = "库图恩之末",
	["Kor'vess"] = "库尔维斯",
	["Kota Basecamp"] = "寇塔营地",
	["Kota Peak"] = "寇塔峰",
	["Krasarang Cove"] = "卡桑琅海湾",
	["Krasarang River"] = "卡桑琅河",
	["Krasarang Wilds"] = "卡桑琅丛林",
	["Krasari Falls"] = "卡桑利瀑布",
	["Krasus' Landing"] = "克拉苏斯平台",
	["Krazzworks Attack Zeppelin"] = "卡拉兹工坊攻击艇",
	["Kril'Mandar Point"] = "科里曼达前哨站",
	["Kri'vess"] = "科里维斯",
	["Krolg's Hut"] = "克罗尔格的小屋",
	["Krom'gar Fortress"] = "克罗姆加壁垒",
	["Krom's Landing"] = "克罗姆的码头",
	["KTC Headquarters"] = "卡亚罗贸易公司总部",
	["KTC Oil Platform"] = "卡亚罗贸易公司钻井平台",
	["Kul'galar Keep"] = "库尔加拉要塞",
	["Kul Tiras"] = "库尔提拉斯",
	["Kun-Lai Pass"] = "昆莱小径",
	["Kun-Lai Summit"] = "昆莱山",
	["Kunzen Cave"] = "昆森洞窟",
	["Kunzen Village"] = "昆森村",
	["Kurzen's Compound"] = "库尔森的营地",
	["Kypari Ik"] = "凯帕圣树·伊克",
	["Kyparite Quarry"] = "凯帕琥珀采掘场",
	["Kypari Vor"] = "凯帕圣树·沃尔",
	["Kypari Zar"] = "凯帕圣树·扎尔",
	["Kzzok Warcamp"] = "科佐克战争营地",
	["Lair of Skiggit"] = "斯基奇特的巢穴",
	["Lair of the Beast"] = "野兽之巢",
	["Lair of the Chosen"] = "天选者之巢",
	["Lair of the Jade Witch"] = "青玉巫婆藏身处",
	["Lair of Tortos"] = "托多斯之巢",
	["Lake Al'Ameth"] = "奥拉密斯湖",
	["Lake Cauldros"] = "考杜斯湖",
	["Lake Dumont"] = "达蒙特湖",
	["Lake Edunel"] = "伊度尼尔湖",
	["Lake Elrendar"] = "艾伦达尔湖",
	["Lake Elune'ara"] = "月神湖",
	["Lake Ere'Noru"] = "艾雷诺湖",
	["Lake Everstill"] = "止水湖",
	["Lake Falathim"] = "法拉希姆湖",
	["Lake Indu'le"] = "因度雷湖",
	["Lake Jorune"] = "尤鲁恩湖",
	["Lake Kel'Theril"] = "凯斯利尔湖",
	["Lake Kittitata"] = "玉盘湖",
	["Lake Kum'uya"] = "库姆亚湖",
	["Lake Mennar"] = "门纳尔湖",
	["Lake Mereldar"] = "米雷达尔湖",
	["Lake Nazferiti"] = "纳菲瑞提湖",
	["Lake of Stars"] = "群星湖",
	["Lakeridge Highway"] = "湖边大道",
	Lakeshire = "湖畔镇",
	["Lakeshire Inn"] = "湖畔镇旅店",
	["Lakeshire Town Hall"] = "湖畔镇大厅",
	["Lakeside Landing"] = "湖边着陆场",
	["Lake Sunspring"] = "日泉湖",
	["Lakkari Tar Pits"] = "拉卡利油沼",
	["Landing Beach"] = "登陆海滩",
	["Landing Site"] = "降落点",
	["Land's End Beach"] = "天涯海滩",
	["Langrom's Leather & Links"] = "兰格鲁的皮加锁",
	["Lao & Son's Yakwash"] = "父子洗牛站",
	["Largo's Overlook"] = "拉尔戈的瞭望台",
	["Largo's Overlook Tower"] = "拉尔戈的瞭望台",
	["Lariss Pavilion"] = "拉瑞斯小亭",
	["Laughing Skull Courtyard"] = "嘲颅营地",
	["Laughing Skull Ruins"] = "嘲颅废墟",
	["Launch Bay"] = "发射台",
	["Legash Encampment"] = "雷加什营地",
	["Legendary Leathers"] = "传说皮甲",
	["Legion Hold"] = "军团要塞",
	["Legion's Fate"] = "军团之劫",
	["Legion's Rest"] = "军团营地",
	["Lethlor Ravine"] = "莱瑟罗峡谷",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "莱雅娜的哀伤",
	["L'ghorek"] = "拉葛雷克",
	["Liang's Retreat"] = "梁家小宅",
	["Library Wing"] = "藏书房",
	Lighthouse = "灯塔",
	["Lightning Ascent"] = "闪电阶梯",
	["Lightning Forge - Mogu Island Progression Scenario"] = "Lightning Forge - Mogu Island Progression Scenario",
	["Lightning Ledge"] = "闪电崖",
	["Lightning Promenade"] = "闪电长廊",
	["Lightning Vein Mine"] = "闪电矿脉",
	["Light's Breach"] = "圣光据点",
	["Light's Dawn Cathedral"] = "圣光黎明大教堂",
	["Light's Hammer"] = "圣光之锤",
	["Light's Hope Chapel"] = "圣光之愿礼拜堂",
	["Light's Point"] = "圣光哨站",
	["Light's Point Tower"] = "圣光哨塔",
	["Light's Shield Tower"] = "圣光之盾哨塔",
	["Light's Trust"] = "圣光之望礼拜堂",
	["Like Clockwork"] = "精密仪器",
	["Lion's Landing"] = "雄狮港",
	["Lion's Pride Inn"] = "狮王之傲旅店",
	["Livery Outpost"] = "利维里前哨站",
	["Livery Stables"] = "马厩",
	["Livery Stables "] = "马厩",
	["Llane's Oath"] = "莱恩之誓",
	["Loading Room"] = "装载室",
	["Loch Modan"] = "洛克莫丹",
	["Loch Verrall"] = "瓦拉尔湖",
	["Loken's Bargain"] = "洛肯的宝库",
	["Lonesome Cove"] = "荒寂海湾",
	Longshore = "长滩",
	["Longying Outpost"] = "龙影岗哨",
	["Lordamere Internment Camp"] = "洛丹米尔收容所",
	["Lordamere Lake"] = "洛丹米尔湖",
	["Lor'danel"] = "洛达内尔",
	["Lorthuna's Gate"] = "洛苏娜之门",
	["Lost Caldera"] = "失落火山口",
	["Lost City of the Tol'vir"] = "托维尔失落之城",
	["Lost City of the Tol'vir Entrance"] = "托维尔失落之城入口",
	LostIsles = "失落群岛",
	["Lost Isles Town in a Box"] = "失落群岛胶囊镇",
	["Lost Isles Volcano Eruption"] = "失落群岛火山爆发",
	["Lost Peak"] = "失落峰",
	["Lost Point"] = "废弃哨塔",
	["Lost Rigger Cove"] = "落帆海湾",
	["Lothalor Woodlands"] = "罗萨洛尔森林",
	["Lower City"] = "贫民窟",
	["Lower Silvermarsh"] = "下层银沼",
	["Lower Sumprushes"] = "下激流潭",
	["Lower Veil Shil'ak"] = "下层夏尔克鸦巢",
	["Lower Wilds"] = "低地荒野",
	["Lumber Mill"] = "伐木场",
	["Lushwater Oasis"] = "甜水绿洲",
	["Lydell's Ambush"] = "林德尔的伏击点",
	["M.A.C. Diver"] = "M.A.C. 深潜者",
	["Maelstrom Deathwing Fight"] = "大漩涡 - 死亡之翼之战",
	["Maelstrom Zone"] = "大漩涡区域",
	["Maestra's Post"] = "梅伊瑟娜岗哨",
	["Maexxna's Nest"] = "迈克斯纳之巢",
	["Mage Quarter"] = "法师区",
	["Mage Tower"] = "法师塔",
	["Mag'har Grounds"] = "玛格汉台地",
	["Mag'hari Procession"] = "玛格汉车队",
	["Mag'har Post"] = "玛格汉岗哨",
	["Magical Menagerie"] = "魔法动物店",
	["Magic Quarter"] = "魔法区",
	["Magisters Gate"] = "魔导师之门",
	["Magister's Terrace"] = "魔导师平台",
	["Magisters' Terrace"] = "魔导师平台",
	["Magisters' Terrace Entrance"] = "魔导师平台入口",
	["Magmadar Cavern"] = "玛格曼达洞穴",
	["Magma Fields"] = "熔岩平原",
	["Magma Springs"] = "熔岩之泉",
	["Magmaw's Fissure"] = "熔喉裂口",
	Magmoth = "犸格莫斯",
	["Magnamoth Caverns"] = "猛犸人洞穴",
	["Magram Territory"] = "玛格拉姆领地",
	["Magtheridon's Lair"] = "玛瑟里顿的巢穴",
	["Magus Commerce Exchange"] = "魔法商业区",
	["Main Chamber"] = "主厅",
	["Main Gate"] = "主门",
	["Main Hall"] = "主厅",
	["Maker's Ascent"] = "造物主高地",
	["Maker's Overlook"] = "造物者悬台",
	["Maker's Overlook "] = "造物者悬台",
	["Makers' Overlook"] = "造物者悬台",
	["Maker's Perch"] = "造物者之座",
	["Makers' Perch"] = "造物者之座",
	["Malaka'jin"] = "玛拉卡金",
	["Malden's Orchard"] = "玛尔丁果园",
	Maldraz = "玛尔卓斯",
	["Malfurion's Breach"] = "玛法里奥突破口",
	["Malicia's Outpost"] = "玛丽希亚的哨站",
	["Malykriss: The Vile Hold"] = "玛雷卡里斯：邪恶城堡",
	["Mama's Pantry"] = "老妈饭堂",
	["Mam'toth Crater"] = "犸托斯巨坑",
	["Manaforge Ara"] = "法力熔炉：艾拉",
	["Manaforge B'naar"] = "法力熔炉：布纳尔",
	["Manaforge Coruu"] = "法力熔炉：库鲁恩",
	["Manaforge Duro"] = "法力熔炉：杜隆",
	["Manaforge Ultris"] = "法力熔炉：乌提斯",
	["Mana Tombs"] = "法力陵墓",
	["Mana-Tombs"] = "法力陵墓",
	["Mandokir's Domain"] = "曼多基尔领地",
	["Mandori Village"] = "绿野村",
	["Mannoroc Coven"] = "玛诺洛克集会所",
	["Manor Mistmantle"] = "密斯特曼托庄园",
	["Mantle Rock"] = "披肩石",
	["Map Chamber"] = "地图厅",
	["Mar'at"] = "玛莱特",
	Maraudon = "玛拉顿",
	["Maraudon - Earth Song Falls Entrance"] = "马拉顿 - 地歌瀑布入口",
	["Maraudon - Foulspore Cavern Entrance"] = "马拉顿 - 毒菇洞穴入口",
	["Maraudon - The Wicked Grotto Entrance"] = "马拉顿 - 邪恶洞穴入口",
	["Mardenholde Keep"] = "玛登霍尔德城堡",
	Marista = "马里斯塔",
	["Marista's Bait & Brew"] = "马里斯塔鱼饵和啤酒",
	["Market Row"] = "市场区",
	["Marshal's Refuge"] = "马绍尔营地",
	["Marshal's Stand"] = "马绍尔哨站",
	["Marshlight Lake"] = "沼光湖",
	["Marshtide Watch"] = "沼泽之潮哨站",
	["Maruadon - The Wicked Grotto Entrance"] = "马拉顿 - 邪恶洞穴入口",
	["Mason's Folly"] = "石匠之愚",
	["Masters' Gate"] = "真主之门",
	["Master's Terrace"] = "主宰的露台",
	["Mast Room"] = "船桅室",
	["Maw of Destruction"] = "毁灭之口",
	["Maw of Go'rath"] = "苟拉斯之口",
	["Maw of Lycanthoth"] = "莱坎索斯之喉",
	["Maw of Neltharion"] = "奈萨里奥之喉",
	["Maw of Shu'ma"] = "舒玛之口",
	["Maw of the Void"] = "虚空深渊",
	["Mazra'Alor"] = "玛兹拉罗",
	Mazthoril = "麦索瑞尔",
	["Mazu's Overlook"] = "玛祖台地",
	["Medivh's Chambers"] = "麦迪文的房间",
	["Menagerie Wreckage"] = "兽笼残骸",
	["Menethil Bay"] = "米奈希尔海湾",
	["Menethil Harbor"] = "米奈希尔港",
	["Menethil Keep"] = "米奈希尔城堡",
	["Merchant Square"] = "商人广场",
	Middenvale = "废墟谷",
	["Mid Point Station"] = "中部哨站",
	["Midrealm Post"] = "中央圆顶哨站",
	["Midwall Lift"] = "中墙升降梯",
	["Mightstone Quarry"] = "巨石采掘场",
	["Military District"] = "军事区",
	["Mimir's Workshop"] = "米米尔的车间",
	Mine = "矿洞",
	Mines = "矿洞",
	["Mirage Abyss"] = "闪光巨湖",
	["Mirage Flats"] = "雾气平原",
	["Mirage Raceway"] = "沙漠赛道",
	["Mirkfallon Lake"] = "暗色湖",
	["Mirkfallon Post"] = "暗色哨站",
	["Mirror Lake"] = "明镜湖",
	["Mirror Lake Orchard"] = "明镜湖果园",
	["Mistblade Den"] = "雾刃之巢",
	["Mistcaller's Cave"] = "唤雾者的洞穴",
	["Mistfall Village"] = "雾临村",
	["Mist's Edge"] = "薄雾海",
	["Mistvale Valley"] = "薄雾谷",
	["Mistveil Sea"] = "纱雾海",
	["Mistwhisper Refuge"] = "雾语村",
	["Misty Pine Refuge"] = "雾松避难所",
	["Misty Reed Post"] = "芦苇哨岗",
	["Misty Reed Strand"] = "芦苇海滩",
	["Misty Ridge"] = "薄雾山",
	["Misty Shore"] = "雾气湖岸",
	["Misty Shores"] = "迷雾海岸",
	["Misty Valley"] = "迷雾谷",
	["Miwana's Longhouse"] = "米瓦娜的长屋",
	["Mizjah Ruins"] = "米扎废墟",
	["Moa'ki"] = "莫亚基",
	["Moa'ki Harbor"] = "莫亚基港口",
	["Moggle Point"] = "摩戈尔哨塔",
	["Mo'grosh Stronghold"] = "莫格罗什要塞",
	["Mogu Island Daily Area"] = "魔古岛日常区域",
	["Mogu Island Events - Alliance Base"] = "魔古岛事件——联盟营地",
	["Mogu Island Events - Horde Base"] = "魔古岛事件——部落营地",
	["Mogu Island Loot Room"] = "魔古岛藏宝室",
	["Mogu Island Progression Events"] = "魔古岛进度事件",
	Mogujia = "魔古岬",
	["Mogu'shan Palace"] = "魔古山宫殿",
	["Mogu'shan Terrace"] = "魔古山圣台",
	["Mogu'shan Vaults"] = "魔古山宝库",
	["Mok'Doom"] = "摩多姆",
	["Mok'Gordun"] = "莫克高顿",
	["Mok'Nathal Village"] = "莫克纳萨村",
	["Mold Foundry"] = "浇铸间",
	["Molten Core"] = "熔火之心",
	["Molten Front"] = "熔火前线",
	Moonbrook = "月溪镇",
	Moonglade = "月光林地",
	["Moongraze Woods"] = "月痕林地",
	["Moon Horror Den"] = "惨月洞穴",
	["Moonrest Gardens"] = "眠月花园",
	["Moonshrine Ruins"] = "月神圣地废墟",
	["Moonshrine Sanctum"] = "月神圣地密室",
	["Moontouched Den"] = "沐月兽穴",
	["Moonwater Retreat"] = "月水庄",
	["Moonwell of Cleansing"] = "净化月亮井",
	["Moonwell of Purity"] = "纯净月亮井",
	["Moonwing Den"] = "月翼洞穴",
	["Mord'rethar: The Death Gate"] = "死亡之门莫德雷萨",
	["Morgan's Plot"] = "摩根墓场",
	["Morgan's Vigil"] = "摩根的岗哨",
	["Morlos'Aran"] = "摩罗萨兰",
	["Morning Breeze Lake"] = "晨息湖",
	["Morning Breeze Village"] = "晨息村",
	Morrowchamber = "破晓大厅",
	["Mor'shan Base Camp"] = "莫尔杉营地",
	["Mortal's Demise"] = "尘世之劫",
	["Mortbreath Grotto"] = "死息岩穴",
	["Mortwake's Tower"] = "摩特维克之塔",
	["Mosh'Ogg Ogre Mound"] = "莫什奥格食人魔山",
	["Mosshide Fen"] = "藓皮沼泽",
	["Mosswalker Village"] = "苔行村",
	["Mossy Pile"] = "覆苔营地",
	["Motherseed Pit"] = "母种之坑",
	["Mountainfoot Strip Mine"] = "山麓矿场",
	["Mount Akher"] = "埃卡赫尔山",
	["Mount Hyjal"] = "海加尔山",
	["Mount Hyjal Phase 1"] = "海加尔山位面1",
	["Mount Neverest"] = "不息山",
	["Muckscale Grotto"] = "泥鳞窟",
	["Muckscale Shallows"] = "泥鳞滩",
	["Mudmug's Place"] = "泥盏营地",
	Mudsprocket = "泥链镇",
	Mulgore = "莫高雷",
	["Murder Row"] = "谋杀小径",
	["Murkdeep Cavern"] = "深暗洞穴",
	["Murky Bank"] = "浊水河岸",
	["Muskpaw Ranch"] = "麝香爪牧场",
	["Mystral Lake"] = "密斯特拉湖",
	Mystwood = "神木林",
	Nagrand = "纳格兰",
	["Nagrand Arena"] = "纳格兰竞技场",
	Nahom = "纳奥姆",
	["Nar'shola Terrace"] = "纳舒拉平台",
	["Narsong Spires"] = "纳松峰",
	["Narsong Trench"] = "纳松海沟",
	["Narvir's Cradle"] = "纳维尔支架",
	["Nasam's Talon"] = "纳萨姆之爪",
	["Nat's Landing"] = "纳特的码头",
	["Naval Battle Scenario"] = "海战场景",
	Naxxanar = "纳克萨纳尔",
	Naxxramas = "纳克萨玛斯",
	["Nayeli Lagoon"] = "纳耶里海礁",
	["Naz'anak: The Forgotten Depths"] = "纳扎纳克：遗忘深渊",
	["Nazj'vel"] = "纳兹维尔",
	Nazzivian = "纳兹维安",
	["Nectarbreeze Orchard"] = "蜜风果园",
	["Needlerock Chasm"] = "针石裂口",
	["Needlerock Slag"] = "针石熔渣场",
	["Nefarian's Lair"] = "奈法利安的巢穴",
	["Nefarian�s Lair"] = "奈法利安的巢穴",
	["Neferset City"] = "尼斐塞特城",
	["Neferset City Outskirts"] = "尼斐塞特城郊",
	["Nek'mani Wellspring"] = "纳克迈尼圣泉",
	["Neptulon's Rise"] = "耐普图隆之台",
	["Nesingwary Base Camp"] = "奈辛瓦里营地",
	["Nesingwary Safari"] = "奈辛瓦里狩猎队营地",
	["Nesingwary's Expedition"] = "奈辛瓦里远征队营地",
	["Nesingwary's Safari"] = "奈辛瓦里狩猎队营地",
	Nespirah = "奈瑟匹拉",
	["Nestlewood Hills"] = "木巢山",
	["Nestlewood Thicket"] = "木巢林地",
	["Nethander Stead"] = "奈杉德哨岗",
	["Nethergarde Keep"] = "守望堡",
	["Nethergarde Mines"] = "守望堡矿井",
	["Nethergarde Supply Camps"] = "守望堡补给营",
	Netherspace = "虚空异界",
	Netherstone = "虚空石",
	Netherstorm = "虚空风暴",
	["Netherweb Ridge"] = "灵网山脊",
	["Netherwing Fields"] = "灵翼平原",
	["Netherwing Ledge"] = "灵翼浮岛",
	["Netherwing Mines"] = "灵翼矿洞",
	["Netherwing Pass"] = "灵翼小径",
	["Neverest Basecamp"] = "不息营地",
	["Neverest Pinnacle"] = "不息峰",
	["New Agamand"] = "新阿加曼德",
	["New Agamand Inn"] = "新阿加曼德旅店",
	["New Avalon"] = "新阿瓦隆",
	["New Avalon Fields"] = "新阿瓦隆农田",
	["New Avalon Forge"] = "新阿瓦隆熔炉",
	["New Avalon Orchard"] = "新阿瓦隆果园",
	["New Avalon Town Hall"] = "新阿瓦隆市政厅",
	["New Cifera"] = "新希菲拉",
	["New Hearthglen"] = "新壁炉谷",
	["New Kargath"] = "新卡加斯",
	["New Thalanaar"] = "新萨兰纳尔",
	["New Tinkertown"] = "新工匠镇",
	["Nexus Legendary"] = "传奇武器任务：魔枢",
	Nidavelir = "尼达维里尔",
	["Nidvar Stair"] = "尼德瓦阶梯",
	Nifflevar = "尼弗莱瓦",
	["Night Elf Village"] = "暗夜精灵村庄",
	Nighthaven = "永夜港",
	["Nightingale Lounge"] = "夜莺旅馆",
	["Nightmare Depths"] = "梦魇深渊",
	["Nightmare Scar"] = "噩梦之痕",
	["Nightmare Vale"] = "噩梦谷",
	["Night Run"] = "夜道谷",
	["Nightsong Woods"] = "夜歌森林",
	["Night Web's Hollow"] = "夜行蜘蛛洞穴",
	["Nijel's Point"] = "尼耶尔前哨站",
	["Nimbus Rise"] = "灵气岭",
	Nine = "Nine",
	["Niuzao Catacombs"] = "砮皂陵",
	["Niuzao Temple"] = "砮皂寺",
	["Njord's Breath Bay"] = "尼约德海湾",
	["Njorndar Village"] = "约尔达村",
	["Njorn Stair"] = "约尔阶梯",
	["Nook of Konk"] = "空克石洞",
	["Noonshade Ruins"] = "热影废墟",
	Nordrassil = "诺达希尔",
	["Nordrassil Inn"] = "诺达希尔旅店",
	["Nordune Ridge"] = "诺尔度之脊",
	["North Common Hall"] = "北会议厅",
	Northdale = "北谷",
	["Northern Barrens"] = "北贫瘠之地",
	["Northern Elwynn Mountains"] = "艾尔文北部山脉",
	["Northern Headlands"] = "北岸海角",
	["Northern Rampart"] = "北部城墙",
	["Northern Rocketway"] = "北方火箭车换乘站",
	["Northern Rocketway Exchange"] = "北方火箭车换乘站",
	["Northern Stranglethorn"] = "北荆棘谷",
	["Northfold Manor"] = "诺斯弗德农场",
	["Northgate Breach"] = "北门缺口",
	["North Gate Outpost"] = "北门哨岗",
	["North Gate Pass"] = "北门小径",
	["Northgate River"] = "北门河",
	["Northgate Woods"] = "北门树林",
	["Northmaul Tower"] = "北槌哨塔",
	["Northpass Tower"] = "北地哨塔",
	["North Point Station"] = "北部哨站",
	["North Point Tower"] = "北点哨塔",
	Northrend = "诺森德",
	["Northridge Lumber Camp"] = "北山伐木场",
	["North Sanctum"] = "北部圣殿",
	Northshire = "北郡",
	["Northshire Abbey"] = "北郡修道院",
	["Northshire River"] = "北郡河",
	["Northshire Valley"] = "北郡山谷",
	["Northshire Vineyards"] = "北郡农场",
	["North Spear Tower"] = "北部长矛塔楼",
	["North Tide's Beachhead"] = "北海滩头",
	["North Tide's Run"] = "北流海岸",
	["Northwatch Expedition Base Camp"] = "北卫远征军营地",
	["Northwatch Expedition Base Camp Inn"] = "北卫远征军营地酒馆",
	["Northwatch Foothold"] = "北卫军根据地",
	["Northwatch Hold"] = "北方城堡",
	["Northwind Cleft"] = "北风裂谷",
	["North Wind Tavern"] = "北风酒馆",
	["Nozzlepot's Outpost"] = "诺兹波特的哨站",
	["Nozzlerust Post"] = "诺兹拉斯哨站",
	["Oasis of the Fallen Prophet"] = "堕落先知绿洲",
	["Oasis of Vir'sar"] = "维尔萨尔绿洲",
	["Obelisk of the Moon"] = "月亮方尖碑",
	["Obelisk of the Stars"] = "群星方尖碑",
	["Obelisk of the Sun"] = "太阳方尖碑",
	["O'Breen's Camp"] = "奥布瑞恩营地",
	["Observance Hall"] = "祭典大厅",
	["Observation Grounds"] = "观测台",
	["Obsidian Breakers"] = "黑曜石海滩",
	["Obsidian Dragonshrine"] = "黑曜石巨龙圣地",
	["Obsidian Forest"] = "黑曜石森林",
	["Obsidian Lair"] = "黑曜石巢穴",
	["Obsidia's Perch"] = "欧比斯迪栖木",
	["Odesyus' Landing"] = "奥德修斯营地",
	["Ogri'la"] = "奥格瑞拉",
	["Ogri'La"] = "奥格瑞拉",
	["Old Hillsbrad Foothills"] = "旧希尔斯布莱德丘陵",
	["Old Ironforge"] = "旧铁炉堡",
	["Old Town"] = "旧城区",
	Olembas = "欧雷巴斯",
	["Olivia's Pond"] = "奥莉维亚的水池",
	["Olsen's Farthing"] = "奥森农场",
	Oneiros = "奥奈罗斯",
	["One Keg"] = "酒坛集",
	["One More Glass"] = "再来一杯",
	["Onslaught Base Camp"] = "先锋军营地",
	["Onslaught Harbor"] = "先锋军港口",
	["Onyxia's Lair"] = "奥妮克希亚的巢穴",
	["Oomlot Village"] = "乌姆洛特村",
	["Oona Kagu"] = "乌拿猴洞",
	Oostan = "乌司坦",
	["Oostan Nord"] = "乌司坦诺德村",
	["Oostan Ost"] = "乌司坦欧司特村",
	["Oostan Sor"] = "乌司坦索尔村",
	["Opening of the Dark Portal"] = "开启黑暗之门",
	["Opening of the Dark Portal Entrance"] = "开启黑暗之门入口",
	["Oratorium of the Voice"] = "声之神剧厅",
	["Oratory of the Damned"] = "诅咒祷堂",
	["Orchid Hollow"] = "兰花谷",
	["Orebor Harborage"] = "奥雷柏尔营地",
	["Oregrind's Dig"] = "奥格林德挖掘场",
	["Orendil's Retreat"] = "奥雷迪尔的居所",
	Orgrimmar = "奥格瑞玛",
	["Orgrimmar Gunship Pandaria Start"] = "Orgrimmar Gunship Pandaria Start",
	["Orgrimmar Rear Gate"] = "奥格瑞玛后门",
	["Orgrimmar Rocketway Exchange"] = "奥格瑞玛火箭车换乘站",
	["Orgrim's Hammer"] = "奥格瑞姆之锤",
	["Oronok's Farm"] = "欧鲁诺克农场",
	Orsis = "奥西斯",
	["Ortell's Hideout"] = "奥泰尔藏身处",
	["Oshu'gun"] = "沃舒古",
	["Outdoor Ruins"] = "露天遗迹",
	Outland = "外域",
	["Overgrown Camp"] = "茂草营地",
	["Overgrown Statuary"] = "蔓草废殿",
	["Owen's Wishing Well"] = "欧文的许愿井",
	["Owl Wing Thicket"] = "枭翼树丛",
	["Palace Antechamber"] = "皇宫前厅",
	["Pal'ea"] = "帕尔依",
	["Palemane Rock"] = "白鬃石",
	["Pandaren Mine"] = "熊猫人矿洞",
	Pandaria = "潘达利亚",
	["Pang's Stead"] = "庞家农场",
	["Panic Clutch"] = "恐慌之巢",
	["Paoquan Hollow"] = "抱拳林",
	["Parhelion Plaza"] = "幻日广场",
	["Passage of Lost Fiends"] = "迷失恶魔之路",
	["Path of a Hundred Steps"] = "百阶小径",
	["Path of Conquerors"] = "征服者之路",
	["Path of Enlightenment"] = "启迪之路",
	["Path of Serenity"] = "静心走廊",
	["Path of the Titans"] = "泰坦之路",
	["Path of Uther"] = "乌瑟尔之路",
	["Pattymack Land"] = "聚会岛",
	["Pauper's Walk"] = "乞丐行道",
	["Paur's Pub"] = "保尔的酒馆",
	["Paw'don Glade"] = "坡东林",
	["Paw'don Village"] = "坡东村",
	["Paw'Don Village"] = "坡东村",
	["Peak of Serenity"] = "晴日峰",
	["Pearlfin Village"] = "珠鳍村",
	["Pearl Lake"] = "珍珠湖",
	["Pedestal of Hope"] = "希冀台",
	["Pei-Wu Forest"] = "悲雾林",
	["Pestilent Scar"] = "瘟疫之痕",
	["Pet Battle - Jade Forest"] = "Pet Battle - Jade Forest",
	["Petitioner's Chamber"] = "祈愿室",
	["Pilgrim's Precipice"] = "朝圣崖",
	["Pincer X2"] = "扳钳X2号",
	["Pinnacle of Storms"] = "风暴之巅",
	["Pit of Fangs"] = "毒牙深渊",
	["Pit of Saron"] = "萨隆矿坑",
	["Pit of Saron Entrance"] = "萨隆矿坑入口",
	["Plaguelands: The Scarlet Enclave"] = "东瘟疫之地：血色领地",
	["Plaguemist Ravine"] = "毒雾峡谷",
	Plaguewood = "病木林",
	["Plaguewood Tower"] = "病木林哨塔",
	["Plain of Echoes"] = "回音平原",
	["Plain of Shards"] = "碎片平原",
	["Plain of Thieves"] = "盗贼平原",
	["Plains of Nasam"] = "纳萨姆平原",
	["Pod Cluster"] = "完整的逃生舱",
	["Pod Wreckage"] = "残破的逃生舱",
	["Poison Falls"] = "毒水瀑布",
	["Pool of Reflection"] = "倒影之池",
	["Pool of Tears"] = "泪水之池",
	["Pool of the Paw"] = "爪之池",
	["Pool of Twisted Reflections"] = "扭曲映像之池",
	["Pools of Aggonar"] = "阿苟纳之池",
	["Pools of Arlithrien"] = "阿里斯瑞恩之池",
	["Pools of Jin'Alai"] = "金亚莱之池",
	["Pools of Purity"] = "纯净之池",
	["Pools of Youth"] = "青春之池",
	["Pools of Zha'Jin"] = "扎尔金之池",
	["Portal Clearing"] = "荒弃传送门",
	["Pranksters' Hollow"] = "顽灵洞",
	["Predator's Perch"] = "掠食者栖地",
	["Prison of Immol'thar"] = "伊莫塔尔的牢笼",
	["Programmer Isle"] = "Programmer Isle",
	["Promontory Point"] = "海角岗哨",
	["Prospector's Point"] = "勘探员哨站",
	["Protectorate Watch Post"] = "维序派哨站",
	["Proving Grounds"] = "试炼场",
	["Purespring Cavern"] = "纯粹之泉洞穴",
	["Purgation Isle"] = "赎罪岛",
	["Pursuing the Black Harvest"] = "追踪黑暗收割议会",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "普崔赛德的恐怖和娱乐化学实验室",
	["Pyrewood Chapel"] = "焚木礼拜堂",
	["Pyrewood Inn"] = "焚木旅店",
	["Pyrewood Town Hall"] = "焚木城镇大厅",
	["Pyrewood Village"] = "焚木村",
	["Pyrox Flats"] = "漫火平原",
	["QA and DVD"] = "QA and DVD",
	["Quagg Ridge"] = "泥泞山",
	Quarry = "采石场",
	["Quartzite Basin"] = "石英盆地",
	["Queen's Gate"] = "王后之门",
	["Quel'Danil Lodge"] = "奎尔丹尼小屋",
	["Quel'Delar's Rest"] = "奎尔德拉之冢",
	["Quel'Dormir Gardens"] = "奎尔多米尔花园",
	["Quel'Dormir Temple"] = "奎尔多米尔神殿",
	["Quel'Dormir Terrace"] = "奎尔多米尔平台",
	["Quel'Lithien Lodge"] = "奎尔林斯小屋",
	["Quel'thalas"] = "奎尔萨拉斯",
	["Quickchop's Lumber Farm"] = "快锯伐木场",
	["Raastok Glade"] = "拉斯托克林地",
	["Raceway Ruins"] = "赛道废墟",
	["Rageclaw Den"] = "怒爪巢穴",
	["Rageclaw Lake"] = "怒爪湖",
	["Rage Fang Shrine"] = "怒牙神殿",
	["Ragefeather Ridge"] = "怒羽山",
	["Ragefire Caverns"] = "怒焰洞穴",
	["Ragefire Chasm"] = "怒焰裂谷",
	["Ragefire Core"] = "怒焰之核",
	["Rage Scar Hold"] = "怒痕堡",
	["Ragnaros' Lair"] = "拉格纳罗斯之巢",
	["Ragnaros' Reach"] = "拉格纳罗斯的领域",
	["Rainspeaker Canopy"] = "雨声树屋",
	["Rainspeaker Rapids"] = "雨声河",
	Ramkahen = "拉穆卡恒",
	["Ramkahen Legion Outpost"] = "拉穆卡恒军团前哨",
	["Rampart of Skulls"] = "颅骨之墙",
	["Ranazjar Isle"] = "拉纳加尔岛",
	["Raptor Pens"] = "迅猛龙围栏",
	["Raptor Ridge"] = "恐龙岭",
	["Raptor Rise"] = "迅猛龙高地",
	Ratchet = "棘齿城",
	["Rated Eye of the Storm"] = "评级风暴之眼",
	["Ravaged Caravan"] = "被破坏的货车",
	["Ravaged Crypt"] = "被毁坏的地穴",
	["Ravaged Twilight Camp"] = "暮光营地废墟",
	["Ravencrest Monument"] = "拉文凯斯雕像",
	["Raven Hill"] = "乌鸦岭",
	["Raven Hill Cemetery"] = "乌鸦岭墓地",
	["Ravenholdt Manor"] = "拉文霍德庄园",
	["Raven's Watch"] = "乌鸦平台",
	["Raven's Wood"] = "乌鸦林",
	["Raynewood Retreat"] = "林中树居",
	["Raynewood Tower"] = "林中树塔",
	["Razaan's Landing"] = "拉扎安码头",
	["Razorfen Downs"] = "剃刀高地",
	["Razorfen Downs Entrance"] = "剃刀高地入口",
	["Razorfen Kraul"] = "剃刀沼泽",
	["Razorfen Kraul Entrance"] = "剃刀沼泽入口",
	["Razor Hill"] = "剃刀岭",
	["Razor Hill Barracks"] = "剃刀岭兵营",
	["Razor Hill Outskirts"] = "剃刀岭外围",
	["Razor Hill Watchtower"] = "剃刀岭瞭望塔",
	["Razormane Grounds"] = "钢鬃营地",
	["Razor Ridge"] = "剃刀山",
	["Razorscale's Aerie"] = "锋鳞之巢",
	["Razorthorn Rise"] = "荆刺高地",
	["Razorthorn Shelf"] = "荆刺岩地",
	["Razorthorn Trail"] = "荆刺小径",
	["Razorwind Canyon"] = "烈风峡谷",
	["Rear Staging Area"] = "后方集结区",
	["Reaver's Fall"] = "机甲残骸",
	["Reavers' Hall"] = "劫掠者之厅",
	["Rebel Camp"] = "反抗军营地",
	["Red Cloud Mesa"] = "红云台地",
	["Redpine Dell"] = "赤松山谷",
	["Redridge - Bridge Phase One"] = "赤脊山——桥上位面一",
	["Redridge - Bridge Phase Two"] = "赤脊山——桥上位面二",
	["Redridge Canyons"] = "赤脊峡谷",
	["Redridge Mountains"] = "赤脊山",
	["Redridge - Orc Bomb"] = "赤脊山——兽人炸弹",
	["Red Rocks"] = "赤色石",
	["Redwood Trading Post"] = "红木商栈",
	Refinery = "油料精炼厂",
	["Refugee Caravan"] = "难民车队",
	["Refuge Pointe"] = "避难谷地",
	["Refuse Disposal"] = "废料处置场",
	["Reliquary of Agony"] = "折磨之匣",
	["Reliquary of Pain"] = "痛苦之匣",
	["Remains of Iris Lake"] = "伊瑞斯湖",
	["Remains of the Fleet"] = "残存的舰队",
	["Remtravel's Excavation"] = "雷姆塔维尔挖掘场",
	["Render's Camp"] = "撕裂者营地",
	["Render's Crater"] = "撕裂者巨坑",
	["Render's Rock"] = "撕裂者之石",
	["Render's Valley"] = "撕裂者山谷",
	["Rensai's Watchpost"] = "任塞道口",
	["Rethban Caverns"] = "瑞斯班洞穴",
	["Rethress Sanctum"] = "雷瑟斯圣所",
	Reuse = "Reuse",
	["Reuse Me 7"] = "7号营救点",
	["Revantusk Village"] = "恶齿村",
	["Rhea's Camp"] = "瑞亚的营地",
	["Rhonin's Beard"] = "罗宁之须号",
	["Rhyolith Plateau"] = "雷奥利斯高台",
	["Ricket's Folly"] = "莉吉特爆炸坑",
	["Ridge of Laughing Winds"] = "笑风山",
	["Ridge of Madness"] = "疯狂之脊",
	["Ridgepoint Tower"] = "山巅之塔",
	Rikkilea = "里基利亚",
	["Rikkitun Village"] = "里基屯村",
	["Rim of the World"] = "世界之脊",
	["Ring of Judgement"] = "审判竞技场",
	["Ring of Observance"] = "仪式广场",
	["Ring of the Elements"] = "元素法阵",
	["Ring of the Law"] = "秩序竞技场",
	["Riplash Ruins"] = "裂鞭废墟",
	["Riplash Strand"] = "裂鞭海岸",
	["Rise of Suffering"] = "苦难高地",
	["Rise of the Defiler"] = "污染者高地",
	["Ritual Chamber of Akali"] = "阿卡里的仪祭大厅",
	["Rivendark's Perch"] = "雷文达克栖木",
	Rivenwood = "裂木森林",
	["River's Heart"] = "河流之心",
	["Rock of Durotan"] = "杜隆坦之石",
	["Rockpool Village"] = "岩池村",
	["Rocktusk Farm"] = "石牙农场",
	["Roguefeather Den"] = "飞羽洞穴",
	["Rogues' Quarter"] = "盗贼区",
	["Rohemdal Pass"] = "洛希达尔小径",
	["Roland's Doom"] = "罗兰之墓",
	["Room of Hidden Secrets"] = "隐秘之间",
	["Roost of Ji-Kun"] = "季鹍栖木",
	["Rotbrain Encampment"] = "腐脑营地",
	["Royal Amphitheater"] = "皇家校场",
	["Royal Approach"] = "皇家走廊",
	["Royal Exchange Auction House"] = "皇家贸易区拍卖行",
	["Royal Exchange Bank"] = "皇家贸易区银行",
	["Royal Gallery"] = "皇家画廊",
	["Royal Library"] = "皇家图书馆",
	["Royal Quarter"] = "皇家区",
	["Ruby Dragonshrine"] = "红玉巨龙圣地",
	["Ruined Approach"] = "废弃过道",
	["Ruined City Post 01"] = "Ruined City Post 01",
	["Ruined Court"] = "废弃之厅",
	["Ruins of Aboraz"] = "阿博拉兹废墟",
	["Ruins of Ahmtul"] = "阿胡图尔遗迹",
	["Ruins of Ahn'Qiraj"] = "安其拉废墟",
	["Ruins of Alterac"] = "奥特兰克废墟",
	["Ruins of Ammon"] = "阿蒙遗迹",
	["Ruins of Arkkoran"] = "亚考兰神殿废墟",
	["Ruins of Auberdine"] = "奥伯丁废墟",
	["Ruins of Baa'ri"] = "巴尔里废墟",
	["Ruins of Constellas"] = "克斯特拉斯废墟",
	["Ruins of Dojan"] = "都阳废墟",
	["Ruins of Drakgor"] = "德拉卡戈废墟",
	["Ruins of Drak'Zin"] = "达克辛废墟",
	["Ruins of Eldarath"] = "埃达拉斯废墟",
	["Ruins of Eldarath "] = "埃达拉斯废墟",
	["Ruins of Eldra'nath"] = "埃德拉纳斯废墟",
	["Ruins of Eldre'thar"] = "埃德雷萨废墟",
	["Ruins of Enkaat"] = "恩卡特废墟",
	["Ruins of Farahlon"] = "法兰伦废墟",
	["Ruins of Feathermoon"] = "羽月废墟",
	["Ruins of Gilneas"] = "吉尔尼斯废墟",
	["Ruins of Gilneas City"] = "吉尔尼斯城废墟",
	["Ruins of Guo-Lai"] = "郭莱遗迹",
	["Ruins of Isildien"] = "伊斯迪尔废墟",
	["Ruins of Jubuwal"] = "朱布瓦尔废墟",
	["Ruins of Karabor"] = "卡拉波废墟",
	["Ruins of Kargath"] = "卡加斯废墟",
	["Ruins of Khintaset"] = "辛塔希特遗迹",
	["Ruins of Korja"] = "科夏废墟",
	["Ruins of Korune"] = "寇茹废墟",
	["Ruins of Lar'donir"] = "拉多尼尔遗迹",
	["Ruins of Lordaeron"] = "洛丹伦废墟",
	["Ruins of Loreth'Aran"] = "洛雷萨兰废墟",
	["Ruins of Lornesta"] = "洛雷斯塔废墟",
	["Ruins of Mathystra"] = "玛塞斯特拉废墟",
	["Ruins of Nordressa"] = "诺德雷萨废墟",
	["Ruins of Ogudei"] = "敖骨打废墟",
	["Ruins of Ravenwind"] = "鸦风废墟",
	["Ruins of Sha'naar"] = "沙纳尔废墟",
	["Ruins of Shandaral"] = "杉达拉废墟",
	["Ruins of Silvermoon"] = "银月城废墟",
	["Ruins of Solarsal"] = "索兰萨尔废墟",
	["Ruins of Southshore"] = "南海镇废墟",
	["Ruins of Taurajo"] = "陶拉祖废墟",
	["Ruins of Tethys"] = "泰塞斯废墟",
	["Ruins of Thaurissan"] = "索瑞森废墟",
	["Ruins of Thelserai Temple"] = "瑟尔萨莱神殿废墟",
	["Ruins of Theramore"] = "塞拉摩废墟",
	["Ruins of the Scarlet Enclave"] = "血色领地废墟",
	["Ruins of Uldum"] = "奥丹姆遗迹",
	["Ruins of Vashj'elan"] = "瓦丝耶兰废墟",
	["Ruins of Vashj'ir"] = "瓦丝琪尔废墟",
	["Ruins of Zul'Kunda"] = "祖昆达废墟",
	["Ruins of Zul'Mamwe"] = "祖玛维废墟",
	["Ruins Rise"] = "遗迹高地",
	["Rumbling Terrace"] = "滚雷台",
	["Runestone Falithas"] = "法利萨斯符文石",
	["Runestone Shan'dor"] = "杉多尔符文石",
	["Runeweaver Square"] = "鲁因广场",
	["Rustberg Village"] = "洛斯贝格村",
	["Rustmaul Dive Site"] = "锈锤潜水点",
	["Rutsak's Guard"] = "拉特萨克营地",
	["Rut'theran Village"] = "鲁瑟兰村",
	["Ruuan Weald"] = "卢安荒野",
	["Ruuna's Camp"] = "卢娜的营地",
	["Ruuzel's Isle"] = "卢泽尔岛",
	["Rygna's Lair"] = "雷格纳的巢穴",
	["Sable Ridge"] = "漆黑山脊",
	["Sacrificial Altar"] = "牺牲祭坛",
	["Sahket Wastes"] = "沙赫柯特荒原",
	Salabria = "萨拉布里亚号",
	["Saldean's Farm"] = "萨丁农场",
	["Saltheril's Haven"] = "萨瑟利尔庄园",
	["Saltspray Glen"] = "盐沫沼泽",
	["Sanctuary of Malorne"] = "玛洛恩庇护所",
	["Sanctuary of Shadows"] = "暗影圣殿",
	["Sanctum of Reanimation"] = "复生密室",
	["Sanctum of Shadows"] = "暗影圣殿",
	["Sanctum of the Ascended"] = "升腾者圣殿",
	["Sanctum of the Fallen God"] = "堕神圣地",
	["Sanctum of the Moon"] = "月亮圣殿",
	["Sanctum of the Prophets"] = "先知圣殿",
	["Sanctum of the South Wind"] = "南风圣殿",
	["Sanctum of the Stars"] = "群星圣殿",
	["Sanctum of the Sun"] = "太阳圣殿",
	["Sands of Nasam"] = "纳萨姆沙地",
	["Sandsorrow Watch"] = "流沙岗哨",
	["Sandy Beach"] = "沙滩",
	["Sandy Shallows"] = "浅沙湾",
	["Sanguine Chamber"] = "血染之厅",
	["Sapphire Hive"] = "蓝玉虫巢",
	["Sapphiron's Lair"] = "萨菲隆之巢",
	["Saragosa's Landing"] = "莎拉苟萨平台",
	Sarahland = "沙拉兰",
	["Sardor Isle"] = "萨尔多岛",
	Sargeron = "萨格隆",
	["Sarjun Depths"] = "刹允深渊",
	["Saronite Mines"] = "萨隆邪铁矿洞",
	["Sar'theris Strand"] = "萨瑟里斯海岸",
	Satyrnaar = "萨提纳尔",
	["Saurok Creation Pit"] = "蜥蜴人孵化坑",
	["Savage Ledge"] = "野蛮之台",
	["Scalawag Point"] = "无赖港",
	["Scalding Pools"] = "滚烫熔池",
	["Scalebeard's Cave"] = "鳞须海龟洞穴",
	["Scalewing Shelf"] = "鳞翼岩床",
	["Scarab Terrace"] = "甲虫平台",
	["Scarlet Encampment"] = "血色营地",
	["Scarlet Halls"] = "血色大厅",
	["Scarlet Hold"] = "血色城堡",
	["Scarlet Monastery"] = "血色修道院",
	["Scarlet Monastery Entrance"] = "血色修道院入口",
	["Scarlet Overlook"] = "血色悬崖",
	["Scarlet Palisade"] = "血色关哨",
	["Scarlet Point"] = "血色哨站",
	["Scarlet Raven Tavern"] = "血鸦旅店",
	["Scarlet Tavern"] = "血色旅店",
	["Scarlet Tower"] = "血色哨塔",
	["Scarlet Watch Post"] = "血色十字军哨岗",
	["Scarlet Watchtower"] = "血色观察塔",
	["Scar of the Worldbreaker"] = "灭世者之痕",
	["Scarred Terrace"] = "焰痕平台",
	["Scenario: Alcaz Island"] = "章节：奥卡兹岛",
	["Scenario - Black Ox Temple"] = "场景战役——玄牛寺",
	["Scenario - Mogu Ruins"] = "场景战役——魔古遗迹",
	["Scenic Overlook"] = "观景台",
	["Schnottz's Frigate"] = "司克诺兹的护卫舰",
	["Schnottz's Hostel"] = "司克诺兹的宿舍",
	["Schnottz's Landing"] = "司克诺兹登陆点",
	Scholomance = "通灵学院",
	["Scholomance Entrance"] = "通灵学院入口",
	ScholomanceOLD = "通灵学院",
	["School of Necromancy"] = "通灵术学校",
	["Scorched Gully"] = "焦痕深谷",
	["Scott's Spooky Area"] = "斯考特的恐怖地带",
	["Scoured Reach"] = "蚀沙荒漠",
	Scourgehold = "瘟疫要塞",
	Scourgeholme = "天灾城",
	["Scourgelord's Command"] = "天灾领主的指挥站",
	["Scrabblescrew's Camp"] = "瑟卡布斯库的营地",
	["Screaming Gully"] = "激流溪谷",
	["Scryer's Tier"] = "占星者之台",
	["Scuttle Coast"] = "流亡海岸",
	Sea = "大海",
	Seabrush = "画笔海岭",
	["Seafarer's Tomb"] = "航海者之墓",
	["Sealed Chambers"] = "封印之厅",
	["Seal of the Sun King"] = "太阳王封印",
	["Sea Mist Ridge"] = "海雾岭",
	["Searing Gorge"] = "灼热峡谷",
	["Seaspittle Cove"] = "海沫洞窟",
	["Seaspittle Nook"] = "海沫秘境",
	["Seat of Destruction"] = "毁灭之座",
	["Seat of Knowledge"] = "闻道之座",
	["Seat of Life"] = "生命之座",
	["Seat of Magic"] = "魔法之座",
	["Seat of Radiance"] = "光辉之座",
	["Seat of the Chosen"] = "天选者之座",
	["Seat of the Naaru"] = "纳鲁之座",
	["Seat of the Spirit Waker"] = "唤魂者之座",
	["Seeker's Folly"] = "探索者末路",
	["Seeker's Point"] = "探索者营地",
	["Sen'jin Village"] = "森金村",
	["Sen'jin Village Outskirts"] = "森金村外围",
	["Sentinel Basecamp"] = "哨兵营地",
	["Sentinel Hill"] = "哨兵岭",
	["Sentinel Tower"] = "哨兵塔",
	["Sentry Point"] = "警戒哨岗",
	Seradane = "瑟拉丹",
	["Serenity Falls"] = "静寂瀑布",
	["Serpent Lake"] = "毒蛇湖",
	["Serpent's Coil"] = "盘蛇谷",
	["Serpent's Heart"] = "神龙之心",
	["Serpentshrine Cavern"] = "毒蛇神殿",
	["Serpent's Overlook"] = "青龙瞭望台",
	["Serpent's Spine"] = "蟠龙脊",
	["Servants' Quarters"] = "仆役宿舍",
	["Service Entrance"] = "仆从入口",
	["Sethekk Halls"] = "塞泰克大厅",
	["Sethria's Roost"] = "塞西莉亚的栖地",
	["Setting Sun Garrison"] = "残阳关卫戍营",
	["Set'vess"] = "赛特维斯",
	["Sewer Access Point"] = "下水道入口",
	["Sewer Exit Pipe"] = "下水道排水管",
	Sewers = "下水道",
	Shadebough = "蔽日林",
	["Shadewood Thicket"] = "影木林",
	["Shado-Li Basin"] = "影踪谷",
	["Shado-Pan Fallback"] = "影踪别院",
	["Shado-Pan Garrison"] = "影踪卫戍营",
	["Shado-Pan Monastery"] = "影踪禅院",
	["Shadowbreak Ravine"] = "破影峡谷",
	["Shadowfang Keep"] = "影牙城堡",
	["Shadowfang Keep Entrance"] = "影牙城堡入口",
	["Shadowfang Tower"] = "影牙之塔",
	["Shadowforge City"] = "暗炉城",
	Shadowglen = "幽影谷",
	["Shadow Grave"] = "灰影墓穴",
	["Shadow Hold"] = "暗影堡",
	["Shadow Labyrinth"] = "暗影迷宫",
	["Shadowlurk Ridge"] = "匿影山",
	["Shadowmoon Valley"] = "影月谷",
	["Shadowmoon Village"] = "影月村",
	["Shadow-Pan Monastery"] = "影踪禅院",
	["Shadowprey Village"] = "葬影村",
	["Shadow Ridge"] = "暗影山",
	["Shadowshard Cavern"] = "暗影碎片洞穴",
	["Shadowsight Tower"] = "影目塔楼",
	["Shadowsong Shrine"] = "影歌神殿",
	["Shadowthread Cave"] = "黑丝洞",
	["Shadow Tomb"] = "暗影墓穴",
	["Shadow Wing Lair"] = "影翼巢穴",
	["Shadra'Alor"] = "沙德拉洛",
	["Shadybranch Pocket"] = "影枝坳",
	["Shady Rest Inn"] = "树荫旅店",
	["Shalandis Isle"] = "沙兰蒂斯岛",
	["Shalewind Canyon"] = "岩页峡谷",
	["Shallow's End"] = "海蕈石",
	["Shallowstep Pass"] = "浅足小径",
	["Shalzaru's Lair"] = "沙尔扎鲁的巢穴",
	Shamanar = "萨满纳尔",
	["Sha'naari Wastes"] = "沙纳尔荒地",
	["Shang's Stead"] = "尚家院子",
	["Shang's Valley"] = "尚家谷",
	["Shang Xi Training Grounds"] = "尚喜习武场",
	["Shan'ze Dao"] = "山泽岛",
	["Shaol'mara"] = "绍尔马拉",
	["Shaol'watha"] = "沙尔瓦萨",
	["Shaper's Terrace"] = "塑造者之台",
	["Shaper's Terrace "] = "塑造者之台",
	["Shartuul's Transporter"] = "沙图尔的传送器",
	["Sha'tari Base Camp"] = "沙塔尔营地",
	["Sha'tari Outpost"] = "沙塔尔前哨站",
	["Shattered Convoy"] = "护卫队覆灭之地",
	["Shattered Plains"] = "破碎平原",
	["Shattered Straits"] = "碎裂海峡",
	["Shattered Sun Staging Area"] = "破碎残阳基地",
	["Shatter Point"] = "破碎岗哨",
	["Shatter Scar Vale"] = "碎痕谷",
	Shattershore = "破碎海滩",
	["Shatterspear Pass"] = "碎矛小径",
	["Shatterspear Vale"] = "碎矛谷",
	["Shatterspear War Camp"] = "碎矛战争营地",
	Shatterstone = "破碎之石",
	Shattrath = "沙塔斯",
	["Shattrath City"] = "沙塔斯城",
	["Shelf of Mazu"] = "玛祖海床",
	["Shell Beach"] = "贝壳海滩",
	["Shield Hill"] = "盾牌岭",
	["Shields of Silver"] = "银色盾牌",
	["Shimmering Bog"] = "闪光泥沼",
	["Shimmering Expanse"] = "烁光海床",
	["Shimmering Grotto"] = "闪光洞室",
	["Shimmer Ridge"] = "闪光岭",
	["Shindigger's Camp"] = "拉普索迪营地",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "前往瓦丝琪尔的船只（奥格瑞玛->瓦丝琪尔）",
	["Shipwreck Shore"] = "船难海岸",
	Shipyard = "船坞",
	["Shipyard - Mogu Island Progression Scenario"] = "Shipyard - Mogu Island Progression Scenario",
	["Shok'Thokar"] = "夏克索卡",
	["Sholazar Basin"] = "索拉查盆地",
	["Shores of the Well"] = "恒井之滨",
	["Shrine of Aessina"] = "艾森娜神殿",
	["Shrine of Aviana"] = "艾维娜圣殿",
	["Shrine of Dath'Remar"] = "达斯雷玛的神龛",
	["Shrine of Dreaming Stones"] = "梦石神龛",
	["Shrine of Eck"] = "伊克的神殿",
	["Shrine of Fellowship"] = "结义坛",
	["Shrine of Five Dawns"] = "五晨神龛",
	["Shrine of Goldrinn"] = "戈德林圣殿",
	["Shrine of Inner-Light"] = "心光神龛",
	["Shrine of Lost Souls"] = "失落灵魂神殿",
	["Shrine of Nala'shi"] = "纳拉什神殿",
	["Shrine of Remembrance"] = "悼念神龛",
	["Shrine of Remulos"] = "雷姆洛斯神殿",
	["Shrine of Scales"] = "蛇鳞神殿",
	["Shrine of Seven Stars"] = "七星殿",
	["Shrine of Thaurissan"] = "索瑞森神殿",
	["Shrine of the Dawn"] = "黎明神龛",
	["Shrine of the Deceiver"] = "欺诈者神祠",
	["Shrine of the Dormant Flame"] = "眠炎圣殿",
	["Shrine of the Eclipse"] = "日蚀神殿",
	["Shrine of the Elements"] = "元素圣殿",
	["Shrine of the Fallen Warrior"] = "战士之魂神殿",
	["Shrine of the Five Khans"] = "五可汗神殿",
	["Shrine of the Merciless One"] = "无悯者神龛",
	["Shrine of the Ox"] = "玄牛神龛",
	["Shrine of Twin Serpents"] = "双龙神龛",
	["Shrine of Two Moons"] = "双月殿",
	["Shrine of Unending Light"] = "永恒圣光神殿",
	["Shriveled Oasis"] = "干枯的绿洲",
	["Shuddering Spires"] = "颤石塔林",
	["SI:7"] = "军情七处",
	["Siege of Niuzao Temple"] = "围攻砮皂寺",
	["Siege Vise"] = "天灾攻城营",
	["Siege Workshop"] = "攻城车间",
	["Sifreldar Village"] = "希弗列尔达村",
	["Sik'vess"] = "希克维斯",
	["Sik'vess Lair"] = "希克维斯虫巢",
	["Silent Vigil"] = "沉默墓地",
	Silithus = "希利苏斯",
	["Silken Fields"] = "丝纱工坊",
	["Silken Shore"] = "柔沙海滩",
	["Silmyr Lake"] = "希尔米耶湖",
	["Silting Shore"] = "淤泥海岸",
	Silverbrook = "银溪镇",
	["Silverbrook Hills"] = "银溪丘陵",
	["Silver Covenant Pavilion"] = "银色盟约大帐",
	["Silverlight Cavern"] = "银光洞穴",
	["Silverline Lake"] = "银链湖",
	["Silvermoon City"] = "银月城",
	["Silvermoon City Inn"] = "银月城旅店",
	["Silvermoon Finery"] = "银月城服装店",
	["Silvermoon Jewelery"] = "银月城首饰店",
	["Silvermoon Registry"] = "银月城登记处",
	["Silvermoon's Pride"] = "银月之傲",
	["Silvermyst Isle"] = "秘银岛",
	["Silverpine Forest"] = "银松森林",
	["Silvershard Mines"] = "碎银矿脉",
	["Silver Stream Mine"] = "银泉矿洞",
	["Silver Tide Hollow"] = "银潮谷",
	["Silver Tide Trench"] = "银潮海沟",
	["Silverwind Refuge"] = "银风避难所",
	["Silverwing Flag Room"] = "银翼军旗室",
	["Silverwing Grove"] = "银翼树林",
	["Silverwing Hold"] = "银翼要塞",
	["Silverwing Outpost"] = "银翼哨站",
	["Simply Enchanting"] = "简单附魔",
	["Sindragosa's Fall"] = "辛达苟萨之墓",
	["Sindweller's Rise"] = "罪行者高地",
	["Singing Marshes"] = "轻歌沼泽",
	["Singing Ridge"] = "晶歌山脉",
	["Sinner's Folly"] = "罪人的愚行",
	["Sira'kess Front"] = "希拉柯丝前哨",
	["Sishir Canyon"] = "希塞尔山谷",
	["Sisters Sorcerous"] = "巫术姐妹",
	Skald = "焦火荒野",
	["Sketh'lon Base Camp"] = "斯克瑟隆营地",
	["Sketh'lon Wreckage"] = "斯克瑟隆废墟",
	["Skethyl Mountains"] = "鸦羽山",
	Skettis = "斯克提斯",
	["Skitterweb Tunnels"] = "蛛网隧道",
	Skorn = "斯克恩",
	["Skulking Row"] = "匿影小径",
	["Skulk Rock"] = "隐匿石",
	["Skull Rock"] = "骷髅石",
	["Sky Falls"] = "天坠瀑布",
	["Skyguard Outpost"] = "天空卫队哨站",
	["Skyline Ridge"] = "冲天岭",
	Skyrange = "摩天山脊",
	["Skysong Lake"] = "天歌湖",
	["Slabchisel's Survey"] = "硬凿勘测营",
	["Slag Watch"] = "熔渣哨塔",
	Slagworks = "熔渣车间",
	["Slaughter Hollow"] = "屠杀谷",
	["Slaughter Square"] = "屠杀广场",
	["Sleeping Gorge"] = "沉睡峡谷",
	["Slicky Stream"] = "滑水溪",
	["Slingtail Pits"] = "吊尾围栏",
	["Slitherblade Shore"] = "滑刃海岸",
	["Slithering Cove"] = "爬蛇海湾",
	["Slither Rock"] = "滑石",
	["Sludgeguard Tower"] = "药渣卫塔",
	["Smuggler's Scar"] = "走私者洞穴",
	["Snicklefritz Mine"] = "斯尼克弗里兹矿脉",
	["Snowblind Hills"] = "雪盲岭",
	["Snowblind Terrace"] = "雪盲台地",
	["Snowden Chalet"] = "雪山小屋",
	["Snowdrift Dojo"] = "雪流道场",
	["Snowdrift Plains"] = "雪流平原",
	["Snowfall Glade"] = "飘雪林地",
	["Snowfall Graveyard"] = "雪落墓地",
	["Socrethar's Seat"] = "索克雷萨之座",
	["Sofera's Naze"] = "索菲亚高地",
	["Soggy's Gamble"] = "闷水壶的冒险码头",
	["Solace Glade"] = "慰藉之林",
	["Solliden Farmstead"] = "索利丹农场",
	["Solstice Village"] = "冬至村",
	["Sorlof's Strand"] = "索罗夫海岸",
	["Sorrow Hill"] = "悔恨岭",
	["Sorrow Hill Crypt"] = "悔恨岭墓穴",
	Sorrowmurk = "忧伤湿地",
	["Sorrow Wing Point"] = "悲翼之地",
	["Soulgrinder's Barrow"] = "磨魂者之穴",
	["Southbreak Shore"] = "塔纳利斯南海",
	["South Common Hall"] = "南会议厅",
	["Southern Barrens"] = "南贫瘠之地",
	["Southern Gold Road"] = "南黄金之路",
	["Southern Rampart"] = "南部城墙",
	["Southern Rocketway"] = "南部火箭车终点站",
	["Southern Rocketway Terminus"] = "南部火箭车终点站",
	["Southern Savage Coast"] = "南野人海岸",
	["Southfury River"] = "怒水河",
	["Southfury Watershed"] = "怒水河流域盆地",
	["South Gate Outpost"] = "南门哨岗",
	["South Gate Pass"] = "南门小径",
	["Southmaul Tower"] = "南槌哨塔",
	["Southmoon Ruins"] = "南月废墟",
	["South Pavilion"] = "南部帐篷",
	["Southpoint Gate"] = "南点大门",
	["South Point Station"] = "南部哨站",
	["Southpoint Tower"] = "南点哨塔",
	["Southridge Beach"] = "南山海滩",
	["Southsea Holdfast"] = "南海据点",
	["South Seas"] = "南海",
	Southshore = "南海镇",
	["Southshore Town Hall"] = "南海镇大厅",
	["South Spire"] = "南部尖塔",
	["South Tide's Run"] = "南流海岸",
	["Southwind Cleft"] = "南风裂谷",
	["Southwind Village"] = "南风村",
	["Sparkrocket Outpost"] = "火箭岗哨",
	["Sparksocket Minefield"] = "斯巴索克雷区",
	["Sparktouched Haven"] = "灵鳍湾",
	["Sparring Hall"] = "斗技厅",
	["Spearborn Encampment"] = "锐矛营地",
	Spearhead = "锐矛村",
	["Speedbarge Bar"] = "高速驳船酒吧",
	Spellsails = "魔帆号",
	["Spinebreaker Mountains"] = "断背山",
	["Spinebreaker Pass"] = "断背小径",
	["Spinebreaker Post"] = "断背岗哨",
	["Spinebreaker Ridge"] = "断背山",
	["Spiral of Thorns"] = "荆棘螺旋",
	["Spire of Blood"] = "鲜血尖塔",
	["Spire of Decay"] = "凋零尖塔",
	["Spire of Pain"] = "苦痛尖塔",
	["Spire of Solitude"] = "孤寂塔",
	["Spire Throne"] = "尖塔王座",
	["Spirit Den"] = "灵魂之穴",
	["Spirit Fields"] = "灵魂平原",
	["Spirit Rise"] = "灵魂高地",
	["Spirit Rock"] = "灵魂石地",
	["Spiritsong River"] = "灵歌河",
	["Spiritsong's Rest"] = "灵歌之栖",
	["Spitescale Cavern"] = "恶鳞洞穴",
	["Spitescale Cove"] = "恶鳞海湾",
	["Splinterspear Junction"] = "断矛路口",
	Splintertree = "碎木岗哨",
	["Splintertree Mine"] = "碎木矿井",
	["Splintertree Post"] = "碎木岗哨",
	["Splithoof Crag"] = "裂蹄峭壁",
	["Splithoof Heights"] = "裂蹄高地",
	["Splithoof Hold"] = "裂蹄堡",
	Sporeggar = "孢子村",
	["Sporewind Lake"] = "孢子湖",
	["Springtail Crag"] = "弹尾峭壁",
	["Springtail Warren"] = "弹尾密径",
	["Spruce Point Post"] = "云杉哨站",
	["Sra'thik Incursion"] = "瑟拉提克入侵地",
	["Sra'thik Swarmdock"] = "瑟拉提克虫坞",
	["Sra'vess"] = "瑟拉维斯",
	["Sra'vess Rootchamber"] = "瑟拉维斯根室",
	["Sri-La Inn"] = "香里拉酒馆",
	["Sri-La Village"] = "香里拉村",
	Stables = "兽栏",
	Stagalbog = "雄鹿沼泽",
	["Stagalbog Cave"] = "雄鹿沼泽洞穴",
	["Stagecoach Crash Site"] = "马车事故现场",
	["Staghelm Point"] = "鹿盔岗哨",
	["Staging Balcony"] = "表演之台",
	["Stairway to Honor"] = "荣誉阶梯",
	["Starbreeze Village"] = "星风村",
	["Stardust Spire"] = "星尘塔",
	["Starfall Village"] = "坠星村",
	["Stars' Rest"] = "群星之墓",
	["Stasis Block: Maximus"] = "静止隔间：玛克希姆",
	["Stasis Block: Trion"] = "静止隔间：特雷奥",
	["Steam Springs"] = "蒸汽之泉",
	["Steamwheedle Port"] = "热砂港",
	["Steel Gate"] = "钢铁之门",
	["Steelgrill's Depot"] = "钢架补给站",
	["Steeljaw's Caravan"] = "钢腭的车队",
	["Steelspark Station"] = "钢烁哨站",
	["Stendel's Pond"] = "斯特登的池塘",
	["Stillpine Hold"] = "止松要塞",
	["Stillwater Pond"] = "静水池",
	["Stillwhisper Pond"] = "萦语水池",
	Stonard = "斯通纳德",
	["Stonebreaker Camp"] = "裂石营地",
	["Stonebreaker Hold"] = "裂石堡",
	["Stonebull Lake"] = "石牛湖",
	["Stone Cairn Lake"] = "石碑湖",
	Stonehearth = "巨石之炉",
	["Stonehearth Bunker"] = "石炉碉堡",
	["Stonehearth Graveyard"] = "石炉墓地",
	["Stonehearth Outpost"] = "石炉哨站",
	["Stonemaul Hold"] = "石槌要塞",
	["Stonemaul Ruins"] = "石槌废墟",
	["Stone Mug Tavern"] = "石盏酒家",
	Stoneplow = "石犁村",
	["Stoneplow Fields"] = "石犁平原",
	["Stone Sentinel's Overlook"] = "石头哨兵的瞭望台",
	["Stonesplinter Valley"] = "碎石怪之谷",
	["Stonetalon Bomb"] = "石爪山脉炸弹",
	["Stonetalon Mountains"] = "石爪山脉",
	["Stonetalon Pass"] = "石爪小径",
	["Stonetalon Peak"] = "石爪峰",
	["Stonewall Canyon"] = "石墙峡谷",
	["Stonewall Lift"] = "石墙升降梯",
	["Stoneward Prison"] = "斯通沃德监狱",
	Stonewatch = "石堡",
	["Stonewatch Falls"] = "石堡瀑布",
	["Stonewatch Keep"] = "石堡要塞",
	["Stonewatch Tower"] = "石堡高塔",
	["Stonewrought Dam"] = "巨石水坝",
	["Stonewrought Pass"] = "石坝小径",
	["Storm Cliffs"] = "风暴悬崖",
	Stormcrest = "雷羽峰",
	["Stormfeather Outpost"] = "风暴之羽哨站",
	["Stormglen Village"] = "风谷村",
	["Storm Peaks"] = "风暴峭壁",
	["Stormpike Graveyard"] = "雷矛墓地",
	["Stormrage Barrow Dens"] = "怒风兽穴",
	["Stormsea Landing"] = "风暴之海码头",
	["Storm's Fury Wreckage"] = "风暴之怒号残骸",
	["Stormstout Brewery"] = "风暴烈酒酿造厂",
	["Stormstout Brewery Interior"] = "风暴烈酒酿造厂内庭",
	["Stormstout Brewhall"] = "风暴烈酒酿造厅",
	Stormwind = "暴风城",
	["Stormwind City"] = "暴风城",
	["Stormwind City Cemetery"] = "暴风城公墓",
	["Stormwind City Outskirts"] = "暴风城郊外",
	["Stormwind Gunship Pandaria Start Area"] = "Stormwind Gunship Pandaria Start Area",
	["Stormwind Harbor"] = "暴风城港口",
	["Stormwind Keep"] = "暴风要塞",
	["Stormwind Lake"] = "暴风湖",
	["Stormwind Mountains"] = "暴风山脉",
	["Stormwind Stockade"] = "暴风城监狱",
	["Stormwind Vault"] = "暴风城地窖",
	["Stoutlager Inn"] = "烈酒旅店",
	Strahnbrad = "斯坦恩布莱德",
	["Strand of the Ancients"] = "远古海滩",
	["Stranglethorn Vale"] = "荆棘谷",
	Stratholme = "斯坦索姆",
	["Stratholme Entrance"] = "斯坦索姆入口",
	["Stratholme - Main Gate"] = "斯坦索姆 - 正门",
	["Stratholme - Service Entrance"] = "斯坦索姆 - 仆从入口",
	["Stratholme Service Entrance"] = "斯坦索姆仆从之门入口",
	["Stromgarde Keep"] = "激流堡",
	["Strongarm Airstrip"] = "铁腕机坪",
	["STV Diamond Mine BG"] = "STV钻石矿战场",
	["Stygian Bounty"] = "冥河恩赐号",
	["Sub zone"] = "Sub zone",
	["Sulfuron Keep"] = "萨弗隆城堡",
	["Sulfuron Keep Courtyard"] = "萨弗隆城堡庭院",
	["Sulfuron Span"] = "萨弗隆大桥",
	["Sulfuron Spire"] = "萨弗隆尖塔",
	["Sullah's Sideshow"] = "苏拉赫的表演场",
	["Summer's Rest"] = "夏之眠",
	["Summoners' Tomb"] = "召唤者之墓",
	["Sunblossom Hill"] = "日花山",
	["Suncrown Village"] = "日冕村",
	["Sundown Marsh"] = "日落沼泽",
	["Sunfire Point"] = "阳炎岗哨",
	["Sunfury Hold"] = "日怒堡",
	["Sunfury Spire"] = "日怒之塔",
	["Sungraze Peak"] = "阳痕峰",
	["Sunken Dig Site"] = "沉没的挖掘场",
	["Sunken Temple"] = "沉没的神庙",
	["Sunken Temple Entrance"] = "沉没的神庙入口",
	["Sunreaver Pavilion"] = "夺日者大帐",
	["Sunreaver's Command"] = "夺日者指挥站",
	["Sunreaver's Sanctuary"] = "夺日者圣殿",
	["Sun Rock Retreat"] = "烈日石居",
	["Sunsail Anchorage"] = "阳帆港",
	["Sunsoaked Meadow"] = "沐日草地",
	["Sunsong Ranch"] = "日歌农场",
	["Sunspring Post"] = "日泉岗哨",
	["Sun's Reach Armory"] = "阳湾军械库",
	["Sun's Reach Harbor"] = "阳湾港口",
	["Sun's Reach Sanctum"] = "阳湾圣殿",
	["Sunstone Terrace"] = "太阳之石平台",
	["Sunstrider Isle"] = "逐日岛",
	["Sunveil Excursion"] = "日纱考察营地",
	["Sunwatcher's Ridge"] = "观日者山岭",
	["Sunwell Plateau"] = "太阳之井高地",
	["Supply Caravan"] = "补给车队",
	["Surge Needle"] = "湍流之针",
	["Surveyors' Outpost"] = "勘测员前哨",
	Surwich = "瑟维奇",
	["Svarnos' Cell"] = "斯瓦诺斯的牢房",
	["Swamplight Manor"] = "水光庄园",
	["Swamp of Sorrows"] = "悲伤沼泽",
	["Swamprat Post"] = "沼泽鼠岗哨",
	["Swiftgear Station"] = "飞轮工作站",
	["Swindlegrin's Dig"] = "斯温迪格林挖掘场",
	["Swindle Street"] = "奸商街",
	["Sword's Rest"] = "剑冢",
	Sylvanaar = "希尔瓦纳",
	["Tabetha's Farm"] = "塔贝萨的农场",
	["Taelan's Tower"] = "泰兰之塔",
	["Tahonda Ruins"] = "塔霍达废墟",
	["Tahret Grounds"] = "塔卡赫特平原",
	["Tal'doren"] = "塔多伦",
	["Talismanic Textiles"] = "避邪纺织店",
	["Tallmug's Camp"] = "高酒盏的营地",
	["Talonbranch Glade"] = "刺枝林地",
	["Talonbranch Glade "] = "刺枝林地",
	["Talondeep Pass"] = "石爪小径",
	["Talondeep Vale"] = "石爪山谷",
	["Talon Stand"] = "龙爪丘陵",
	Talramas = "塔尔拉玛斯",
	["Talrendis Point"] = "塔伦迪斯营地",
	Tanaris = "塔纳利斯",
	["Tanaris Desert"] = "塔纳利斯",
	["Tanks for Everything"] = "坦克用品店",
	["Tanner Camp"] = "制皮匠营地",
	["Tarren Mill"] = "塔伦米尔",
	["Tasters' Arena"] = "品酒台",
	["Taunka'le Village"] = "牦牛村",
	["Tavern in the Mists"] = "迷雾酒肆",
	["Tazz'Alaor"] = "塔萨洛尔",
	["Tear Down This Wall!"] = "摧毁城墙！",
	["Teegan's Expedition"] = "缇甘远征军营地",
	["Teeming Burrow"] = "喧嚣地穴",
	Telaar = "塔拉",
	["Telaari Basin"] = "塔拉盆地",
	["Tel'athion's Camp"] = "塔希恩的营地",
	Teldrassil = "泰达希尔",
	Telredor = "泰雷多尔",
	["Tempest Bridge"] = "风暴之桥",
	["Tempest Keep"] = "风暴要塞",
	["Tempest Keep: The Arcatraz"] = "风暴要塞：禁魔监狱",
	["Tempest Keep - The Arcatraz Entrance"] = "风暴要塞 - 禁魔监狱入口",
	["Tempest Keep: The Botanica"] = "风暴要塞：生态船",
	["Tempest Keep - The Botanica Entrance"] = "风暴要塞 - 生态船入口",
	["Tempest Keep: The Mechanar"] = "风暴要塞：能源舰",
	["Tempest Keep - The Mechanar Entrance"] = "风暴要塞 - 能源舰入口",
	["Tempest's Reach"] = "风暴海崖",
	["Temple City of En'kilah"] = "圣城恩其拉",
	["Temple Hall"] = "神殿大厅",
	["Temple of Ahn'Qiraj"] = "安其拉神殿",
	["Temple of Arkkoran"] = "亚考兰神殿",
	["Temple of Asaad"] = "阿萨德神殿",
	["Temple of Bethekk"] = "贝瑟克神殿",
	["Temple of Earth"] = "大地神殿",
	["Temple of Five Dawns"] = "五晨寺",
	["Temple of Invention"] = "创世神殿",
	["Temple of Kotmogu"] = "寇魔古寺",
	["Temple of Life"] = "生命神殿",
	["Temple of Order"] = "秩序神殿",
	["Temple of Storms"] = "风暴神殿",
	["Temple of Telhamat"] = "塔哈玛特神殿",
	["Temple of the Forgotten"] = "遗忘神殿",
	["Temple of the Jade Serpent"] = "青龙寺",
	["Temple of the Moon"] = "月神殿",
	["Temple of the Red Crane"] = "朱鹤寺",
	["Temple of the White Tiger"] = "白虎寺",
	["Temple of Uldum"] = "奥丹姆神殿",
	["Temple of Winter"] = "寒冬神殿",
	["Temple of Wisdom"] = "智慧神殿",
	["Temple of Zin-Malor"] = "辛玛洛神殿",
	["Temple Summit"] = "神殿之巅",
	["Tenebrous Cavern"] = "阴暗洞穴",
	["Terokkar Forest"] = "泰罗卡森林",
	["Terokk's Rest"] = "泰罗克之墓",
	["Terrace of Endless Spring"] = "永春台",
	["Terrace of Gurthan"] = "格尔桑平台",
	["Terrace of Light"] = "圣光广场",
	["Terrace of Repose"] = "休息区",
	["Terrace of Ten Thunders"] = "十雷台",
	["Terrace of the Augurs"] = "占卜师平台",
	["Terrace of the Makers"] = "造物者圣台",
	["Terrace of the Sun"] = "太阳平台",
	["Terrace of the Tiger"] = "猛虎台",
	["Terrace of the Twin Dragons"] = "双龙台",
	Terrordale = "恐惧谷",
	["Terror Run"] = "恐惧小道",
	["Terrorweb Tunnel"] = "恶蛛隧道",
	["Terror Wing Path"] = "龙翼小径",
	["Tethris Aran"] = "塔迪萨兰",
	Thalanaar = "萨兰纳尔",
	["Thalassian Pass"] = "萨拉斯小径",
	["Thalassian Range"] = "萨拉斯山脉",
	["Thal'darah Grove"] = "萨达拉树林",
	["Thal'darah Overlook"] = "萨达拉瞭望台",
	["Thandol Span"] = "萨多尔大桥",
	["Thargad's Camp"] = "萨加德营地",
	["The Abandoned Reach"] = "遗弃海岸",
	["The Abyssal Maw"] = "深渊之喉",
	["The Abyssal Shelf"] = "地狱岩床",
	["The Admiral's Den"] = "将军洞",
	["The Agronomical Apothecary"] = "农艺炼金房",
	["The Alliance Valiants' Ring"] = "联盟勇士赛场",
	["The Altar of Damnation"] = "诅咒祭坛",
	["The Altar of Shadows"] = "暗影祭坛",
	["The Altar of Zul"] = "祖尔祭坛",
	["The Amber Hibernal"] = "琥珀休眠室",
	["The Amber Vault"] = "琥珀穹顶",
	["The Amber Womb"] = "琥珀孵育室",
	["The Ancient Grove"] = "上古树林",
	["The Ancient Lift"] = "上古升降梯",
	["The Ancient Passage"] = "远古之路",
	["The Antechamber"] = "前厅",
	["The Anvil of Conflagration"] = "厄火铁砧",
	["The Anvil of Flame"] = "烈焰铁砧",
	["The Apothecarium"] = "炼金房",
	["The Arachnid Quarter"] = "蜘蛛区",
	["The Arboretum"] = "百木园",
	["The Arcanium"] = "奥法大厅",
	["The Arcanium "] = "奥法大厅",
	["The Arcatraz"] = "禁魔监狱",
	["The Archivum"] = "档案馆",
	["The Argent Stand"] = "银色前沿",
	["The Argent Valiants' Ring"] = "银色勇士赛场",
	["The Argent Vanguard"] = "银色前线基地",
	["The Arsenal Absolute"] = "神兵利器",
	["The Aspirants' Ring"] = "候选者赛场",
	["The Assembly Chamber"] = "集结之厅",
	["The Assembly of Iron"] = "钢铁议会",
	["The Athenaeum"] = "图书馆",
	["The Autumn Plains"] = "秋之原",
	["The Avalanche"] = "雪崩山麓",
	["The Azure Front"] = "碧蓝前线",
	["The Bamboo Wilds"] = "翠竹旷野",
	["The Bank of Dalaran"] = "达拉然银行",
	["The Bank of Silvermoon"] = "银月城银行",
	["The Banquet Hall"] = "宴会厅",
	["The Barrier Hills"] = "壁垒山",
	["The Bastion of Twilight"] = "暮光堡垒",
	["The Battleboar Pen"] = "斗猪围栏",
	["The Battle for Gilneas"] = "吉尔尼斯城",
	["The Battle for Gilneas (Old City Map)"] = "吉尔尼斯之战",
	["The Battle for Mount Hyjal"] = "海加尔山之战",
	["The Battlefront"] = "战斗前线",
	["The Bazaar"] = "花园街市",
	["The Beast Pens"] = "兽栏",
	["The Beer Garden"] = "啤酒花园",
	["The Bite"] = "血盆大口海湾",
	["The Black Breach"] = "黑色裂口",
	["The Black Market"] = "黑市",
	["The Black Morass"] = "黑色沼泽",
	["The Black Temple"] = "黑暗神殿",
	["The Black Vault"] = "黑色宝库",
	["The Blackwald"] = "黑瘴林",
	["The Blazing Strand"] = "炽热海岸",
	["The Blighted Pool"] = "枯萎之池",
	["The Blight Line"] = "荒芜边界",
	["The Bloodcursed Reef"] = "血咒暗礁",
	["The Blood Furnace"] = "鲜血熔炉",
	["The Bloodmire"] = "浴血泥潭",
	["The Bloodoath"] = "血誓号",
	["The Blood Trail"] = "鲜血之痕",
	["The Bloodwash"] = "血浪海滩",
	["The Boiling Crustacean"] = "水煮虾蟹",
	["The Bombardment"] = "轰炸场",
	["The Bonefields"] = "埋骨地",
	["The Bone Pile"] = "白骨堆",
	["The Bones of Nozronn"] = "诺兹隆之骨",
	["The Bone Wastes"] = "白骨荒野",
	["The Boneyard"] = "坟场",
	["The Borean Wall"] = "北风之墙",
	["The Botanica"] = "生态船",
	["The Bradshaw Mill"] = "布莱德肖磨坊",
	["The Breach"] = "突破口",
	["The Briny Cutter"] = "破浪号",
	["The Briny Muck"] = "盐碱泥滩",
	["The Briny Pinnacle"] = "海洋之巅",
	["The Broken Bluffs"] = "裂崖",
	["The Broken Front"] = "破碎前线",
	["The Broken Hall"] = "破坏大厅",
	["The Broken Hills"] = "碎石岭",
	["The Broken Stair"] = "破碎阶梯",
	["The Broken Temple"] = "破碎神殿",
	["The Broodmother's Nest"] = "母龙之巢",
	["The Brood Pit"] = "孵化深渊",
	["The Bulwark"] = "亡灵壁垒",
	["The Burlap Trail"] = "粗麻小径",
	["The Burlap Valley"] = "粗麻山谷",
	["The Burlap Waystation"] = "粗麻驿站",
	["The Burning Corridor"] = "燃烧回廊",
	["The Butchery"] = "屠宰房",
	["The Cache of Madness"] = "疯狂之缘",
	["The Caller's Chamber"] = "召唤者之厅",
	["The Canals"] = "运河",
	["The Cape of Stranglethorn"] = "荆棘谷海角",
	["The Carrion Fields"] = "腐臭平原",
	["The Catacombs"] = "墓穴",
	["The Cauldron"] = "大熔炉",
	["The Cauldron of Flames"] = "烈焰之坑",
	["The Cave"] = "洞穴",
	["The Celestial Planetarium"] = "天文台",
	["The Celestial Vault"] = "天神宝库",
	["The Celestial Watch"] = "观星大厅",
	["The Cemetary"] = "大墓地",
	["The Cerebrillum"] = "脑室",
	["The Charred Vale"] = "焦炭谷",
	["The Chilled Quagmire"] = "冰冷湿地",
	["The Chum Bucket"] = "鱼饵满筐",
	["The Circle of Cinders"] = "燃烬法阵",
	["The Circle of Life"] = "生命法阵",
	["The Circle of Suffering"] = "受难之环",
	["The Clarion Bell"] = "澈明钟",
	["The Clash of Thunder"] = "雷霆角斗场",
	["The Clean Zone"] = "清洁区",
	["The Cleft"] = "大断崖",
	["The Clockwerk Run"] = "发条小径",
	["The Clutch"] = "关押所",
	["The Clutches of Shek'zeer"] = "夏柯希尔之巢",
	["The Coil"] = "毒蛇小径",
	["The Colossal Forge"] = "巨人熔炉",
	["The Comb"] = "蜂巢",
	["The Commons"] = "平民区",
	["The Conflagration"] = "战火平原",
	["The Conquest Pit"] = "征服斗兽场",
	["The Conservatory"] = "温室",
	["The Conservatory of Life"] = "生命温室",
	["The Construct Quarter"] = "构造区",
	["The Cooper Residence"] = "桶屋",
	["The Corridors of Ingenuity"] = "发明回廊",
	["The Court of Bones"] = "白骨之庭",
	["The Court of Skulls"] = "颅骨之庭",
	["The Coven"] = "巫师会所",
	["The Coven "] = "巫师会所",
	["The Creeping Ruin"] = "爬虫废墟",
	["The Crimson Assembly Hall"] = "赤红议事厅",
	["The Crimson Cathedral"] = "赤色大教堂",
	["The Crimson Dawn"] = "血色黎明号",
	["The Crimson Hall"] = "血色厅堂",
	["The Crimson Reach"] = "红砂海滩",
	["The Crimson Throne"] = "图书馆",
	["The Crimson Treader"] = "深红踏浪者号",
	["The Crimson Veil"] = "红雾号",
	["The Crossroads"] = "十字路口",
	["The Crucible"] = "熔炉",
	["The Crucible of Flame"] = "烈焰熔炉",
	["The Crumbling Waste"] = "碎裂废土",
	["The Cryo-Core"] = "冷却核心",
	["The Crystal Hall"] = "水晶大厅",
	["The Crystal Shore"] = "水晶海岸",
	["The Crystal Vale"] = "水晶谷",
	["The Crystal Vice"] = "水晶裂痕",
	["The Culling of Stratholme"] = "净化斯坦索姆",
	["The Culling of Stratholme Entrance"] = "净化斯坦索姆入口",
	["The Cursed Landing"] = "被诅咒的登陆点",
	["The Dagger Hills"] = "匕首岭",
	["The Dai-Lo Farmstead"] = "大箩农场",
	["The Damsel's Luck"] = "少女之运号",
	["The Dancing Serpent"] = "龙舞楼",
	["The Dark Approach"] = "黑暗小径",
	["The Dark Defiance"] = "黑暗挑战",
	["The Darkened Bank"] = "暗色河滩",
	["The Dark Hollow"] = "黑暗谷",
	["The Darkmoon Faire"] = "暗月马戏团",
	["The Dark Portal"] = "黑暗之门",
	["The Dark Rookery"] = "黑暗孵化间",
	["The Darkwood"] = "黑暗森林",
	["The Dawnchaser"] = "曙光追寻者号",
	["The Dawning Isles"] = "黎明岛",
	["The Dawning Span"] = "晨之桥",
	["The Dawning Square"] = "黎明广场",
	["The Dawning Stair"] = "晨之阶",
	["The Dawning Valley"] = "晨之谷",
	["The Dead Acre"] = "死亡农地",
	["The Dead Field"] = "亡者农场",
	["The Dead Fields"] = "死亡旷野",
	["The Deadmines"] = "死亡矿井",
	["The Dead Mire"] = "死亡泥潭",
	["The Dead Scar"] = "死亡之痕",
	["The Deathforge"] = "死亡熔炉",
	["The Deathknell Graves"] = "丧钟镇墓地",
	["The Decrepit Fields"] = "破败原野",
	["The Decrepit Flow"] = "衰弱之河",
	["The Deeper"] = "深石窟",
	["The Deep Reaches"] = "幽暗曲径",
	["The Deepwild"] = "深渊荒野",
	["The Defiant"] = "挑战号",
	["The Defiled Chapel"] = "被污染的礼拜堂",
	["The Den"] = "大兽穴",
	["The Den of Flame"] = "火焰洞穴",
	["The Dens of Dying"] = "亡者之穴",
	["The Dens of the Dying"] = "亡者之穴",
	["The Descent into Madness"] = "疯狂阶梯",
	["The Desecrated Altar"] = "被亵渎的祭坛",
	["The Devil's Terrace"] = "恶魔之台",
	["The Devouring Breach"] = "吞噬裂口",
	["The Domicile"] = "住宅区",
	["The Domicile "] = "住宅区",
	["The Dooker Dome"] = "暴徒末路",
	["The Dor'Danil Barrow Den"] = "朵丹尼尔兽穴",
	["The Dormitory"] = "宿舍",
	["The Drag"] = "暗巷区",
	["The Dragonmurk"] = "黑龙谷",
	["The Dragon Wastes"] = "巨龙废土",
	["The Drain"] = "排水泵",
	["The Dranosh'ar Blockade"] = "德拉诺什尔封锁线",
	["The Drowned Reef"] = "水下暗礁",
	["The Drowned Sacellum"] = "水下庙宇",
	["The Drunken Hozen"] = "醉猴楼",
	["The Dry Hills"] = "无水岭",
	["The Dustbowl"] = "漫尘盆地",
	["The Dust Plains"] = "尘埃平原",
	["The Eastern Earthshrine"] = "东部大地神殿",
	["The Elders' Path"] = "长者之路",
	["The Emerald Summit"] = "翡翠峰",
	["The Emperor's Approach"] = "帝皇之疆",
	["The Emperor's Gate"] = "帝王之门",
	["The Emperor's Reach"] = "帝皇之域",
	["The Emperor's Step"] = "帝皇之阶",
	["The Escape From Durnholde"] = "逃离敦霍尔德",
	["The Escape from Durnholde Entrance"] = "逃出敦霍尔德入口",
	["The Eventide"] = "日暮广场",
	["The Exodar"] = "埃索达",
	["The Eye"] = "风暴要塞",
	["The Eye of Eternity"] = "永恒之眼",
	["The Eye of the Vortex"] = "漩涡之眼",
	["The Fall of Shan Bu"] = "山怖之死",
	["The Farstrider Lodge"] = "旅行者营地",
	["The Feeding Pits"] = "饲料洞",
	["The Fel Pits"] = "魔能熔池",
	["The Fertile Copse"] = "丰饶树林",
	["The Fetid Pool"] = "恶臭之池",
	["The Filthy Animal"] = "肮脏的野兽",
	["The Firehawk"] = "炎鹰号",
	["The Five Sisters"] = "五姝林",
	["The Flamewake"] = "烈焰之痕",
	["The Fleshwerks"] = "缝合场",
	["The Flood Plains"] = "洪荒平原",
	["The Fold"] = "皱石岗",
	["The Foothill Caverns"] = "丘陵洞穴",
	["The Foot of Lei Shen"] = "雷神之基",
	["The Foot Steppes"] = "山底平原",
	["The Forbidden Jungle"] = "禁忌之林",
	["The Forbidding Sea"] = "禁忌之海",
	["The Forest of Shadows"] = "阴影森林",
	["The Forge of Souls"] = "灵魂洪炉",
	["The Forge of Souls Entrance"] = "灵魂洪炉入口",
	["The Forge of Supplication"] = "哀求熔炉",
	["The Forge of Wills"] = "意志熔炉",
	["The Forgotten Coast"] = "被遗忘的海岸",
	["The Forgotten Overlook"] = "遗忘峭壁",
	["The Forgotten Pool"] = "遗忘之池",
	["The Forgotten Pools"] = "遗忘之池",
	["The Forgotten Shore"] = "遗忘海岸",
	["The Forlorn Cavern"] = "荒弃的洞穴",
	["The Forlorn Mine"] = "荒弃矿洞",
	["The Forsaken Front"] = "被遗忘者先锋军",
	["The Foul Pool"] = "污淤之池",
	["The Frigid Tomb"] = "严寒墓穴",
	["The Frost Queen's Lair"] = "冰霜女王的巢穴",
	["The Frostwing Halls"] = "霜翼大厅",
	["The Frozen Glade"] = "冰雪林地",
	["The Frozen Halls"] = "冰封大殿",
	["The Frozen Mine"] = "冰霜矿洞",
	["The Frozen Sea"] = "冰冻之海",
	["The Frozen Throne"] = "冰封王座",
	["The Fungal Vale"] = "蘑菇谷",
	["The Furnace"] = "熔炉",
	["The Gaping Chasm"] = "大裂口",
	["The Gatehouse"] = "门房",
	["The Gatehouse "] = "门房",
	["The Gate of Unending Cycles"] = "无尽轮回之门",
	["The Gauntlet"] = "街巷",
	["The Geyser Fields"] = "喷泉平原",
	["The Ghastly Confines"] = "阴森鬼域",
	["The Gilded Foyer"] = "镶金殿",
	["The Gilded Gate"] = "镀金之门",
	["The Gilding Stream"] = "金辉溪",
	["The Glimmering Pillar"] = "光芒之柱",
	["The Golden Gateway"] = "金色大门",
	["The Golden Hall"] = "金色大厅",
	["The Golden Lantern"] = "金色神灯",
	["The Golden Pagoda"] = "鎏金亭",
	["The Golden Plains"] = "金色平原",
	["The Golden Rose"] = "金玫瑰",
	["The Golden Stair"] = "金色阶梯",
	["The Golden Terrace"] = "金色平台",
	["The Gong of Hope"] = "希望之锣",
	["The Grand Ballroom"] = "舞厅",
	["The Grand Vestibule"] = "大门廊",
	["The Great Arena"] = "大竞技场",
	["The Great Divide"] = "大裂谷",
	["The Great Fissure"] = "大裂隙",
	["The Great Forge"] = "大锻炉",
	["The Great Gate"] = "莫高雷巨门",
	["The Great Lift"] = "升降梯",
	["The Great Ossuary"] = "尸骨储藏所",
	["The Great Sea"] = "无尽之海",
	["The Great Tree"] = "符印巨树",
	["The Great Wheel"] = "大水车",
	["The Green Belt"] = "绿带草地",
	["The Greymane Wall"] = "格雷迈恩之墙",
	["The Grim Guzzler"] = "黑铁酒吧",
	["The Grinding Quarry"] = "碾石场",
	["The Grizzled Den"] = "灰色洞穴",
	["The Grummle Bazaar"] = "土地精集市",
	["The Guardhouse"] = "警卫室",
	["The Guest Chambers"] = "会客间",
	["The Gullet"] = "咽喉洞",
	["The Halfhill Market"] = "半山市集",
	["The Half Shell"] = "半壳龟",
	["The Hall of Blood"] = "鲜血大厅",
	["The Hall of Gears"] = "齿轮大厅",
	["The Hall of Lights"] = "珍宝陈列室",
	["The Hall of Respite"] = "安息大厅",
	["The Hall of Statues"] = "雕像大厅",
	["The Hall of the Serpent"] = "翔龙大厅",
	["The Hall of Tiles"] = "砖瓦大厅",
	["The Halls of Reanimation"] = "复活大厅",
	["The Halls of Winter"] = "寒冬大厅",
	["The Hand of Gul'dan"] = "古尔丹之手",
	["The Harborage"] = "避难营",
	["The Hatchery"] = "孵化场",
	["The Headland"] = "山头营地",
	["The Headlands"] = "大海岬",
	["The Heap"] = "机甲废场",
	["The Heartland"] = "汇风岭",
	["The Heart of Acherus"] = "阿彻鲁斯之心",
	["The Heart of Jade"] = "青玉之心",
	["The Hidden Clutch"] = "隐藏的龙巢",
	["The Hidden Grove"] = "隐秘小林",
	["The Hidden Hollow"] = "隐蔽山洞",
	["The Hidden Passage"] = "隐秘小径",
	["The Hidden Reach"] = "密径",
	["The Hidden Reef"] = "藏帆暗礁",
	["The High Path"] = "高原小径",
	["The High Road"] = "高地之路",
	["The High Seat"] = "王座厅",
	["The Hinterlands"] = "辛特兰",
	["The Hoard"] = "步兵武器库",
	["The Hole"] = "矿渣洞",
	["The Horde Valiants' Ring"] = "部落勇士赛场",
	["The Horrid March"] = "恐惧先遣站",
	["The Horsemen's Assembly"] = "骑士议会厅",
	["The Howling Hollow"] = "凛风洞窟",
	["The Howling Oak"] = "风嚎橡树",
	["The Howling Vale"] = "狼嚎谷",
	["The Hunter's Reach"] = "猎人用品店",
	["The Hushed Bank"] = "寂静河岸",
	["The Icy Depths"] = "寒冰深渊",
	["The Immortal Coil"] = "永不沉没号",
	["The Imperial Exchange"] = "帝皇商站",
	["The Imperial Granary"] = "帝皇粮仓",
	["The Imperial Mercantile"] = "皇家贸易区",
	["The Imperial Seat"] = "帝王之座",
	["The Incursion"] = "先遣营地",
	["The Infectis Scar"] = "魔刃之痕",
	["The Inferno"] = "炼狱火海",
	["The Inner Spire"] = "内层尖塔",
	["The Intrepid"] = "无畏号",
	["The Inventor's Library"] = "创世者的图书馆",
	["The Iron Crucible"] = "钢铁熔炉",
	["The Iron Hall"] = "钢铁大厅",
	["The Iron Reaper"] = "铁之收割者",
	["The Isle of Spears"] = "长矛岛",
	["The Ivar Patch"] = "伊瓦南瓜田",
	["The Jade Forest"] = "翡翠林",
	["The Jade Vaults"] = "青龙宝库",
	["The Jansen Stead"] = "贾森农场",
	["The Keggary"] = "烈酒窖",
	["The Kennel"] = "狗舍",
	["The Krasari Ruins"] = "卡桑利废墟",
	["The Krazzworks"] = "卡拉兹工坊",
	["The Laboratory"] = "实验室",
	["The Lady Mehley"] = "梅蕾女士号",
	["The Lagoon"] = "环礁湖",
	["The Laughing Stand"] = "欢笑之台",
	["The Lazy Turnip"] = "懒惰的芜菁",
	["The Legerdemain Lounge"] = "魔术旅馆",
	["The Legion Front"] = "军团前线",
	["Thelgen Rock"] = "瑟根石",
	["The Librarium"] = "图书馆",
	["The Library"] = "图书馆",
	["The Lifebinder's Cell"] = "生命缚誓者的牢笼",
	["The Lifeblood Pillar"] = "源血之柱",
	["The Lightless Reaches"] = "湮光海谷",
	["The Lion's Redoubt"] = "狮王庇护所",
	["The Living Grove"] = "活木林",
	["The Living Wood"] = "生命森林",
	["The LMS Mark II"] = "LMS-II型地铁",
	["The Loch"] = "洛克湖",
	["The Long Wash"] = "长桥码头",
	["The Lost Fleet"] = "失落的舰队",
	["The Lost Fold"] = "损坏的兽笼",
	["The Lost Isles"] = "失落群岛",
	["The Lost Lands"] = "迷失之地",
	["The Lost Passage"] = "失落小径",
	["The Low Path"] = "山谷小径",
	Thelsamar = "塞尔萨玛",
	["The Lucky Traveller"] = "好运旅行者",
	["The Lyceum"] = "讲学厅",
	["The Maclure Vineyards"] = "马科伦农场",
	["The Maelstrom"] = "大漩涡",
	["The Maker's Overlook"] = "造物者悬台",
	["The Makers' Overlook"] = "造物者眺望台",
	["The Makers' Perch"] = "造物者之座",
	["The Maker's Rise"] = "造物主之阶",
	["The Maker's Terrace"] = "造物者遗迹",
	["The Manufactory"] = "制造厂",
	["The Marris Stead"] = "玛瑞斯农场",
	["The Marshlands"] = "沼泽地",
	["The Masonary"] = "石匠区",
	["The Master's Cellar"] = "麦迪文的酒窖",
	["The Master's Glaive"] = "主宰之剑",
	["The Maul"] = "巨槌竞技场",
	["The Maw of Madness"] = "疯狂之喉",
	["The Mechanar"] = "能源舰",
	["The Menagerie"] = "展览馆",
	["The Menders' Stead"] = "治愈者营地",
	["The Merchant Coast"] = "商旅海岸",
	["The Militant Mystic"] = "好战的秘法师",
	["The Military Quarter"] = "军事区",
	["The Military Ward"] = "军事区",
	["The Mind's Eye"] = "心灵之眼",
	["The Mirror of Dawn"] = "黎明之镜",
	["The Mirror of Twilight"] = "暮色之镜",
	["The Molsen Farm"] = "摩尔森农场",
	["The Molten Bridge"] = "熔火之桥",
	["The Molten Core"] = "熔火之心",
	["The Molten Fields"] = "熔火旷野",
	["The Molten Flow"] = "熔火激流",
	["The Molten Span"] = "熔岩之桥",
	["The Mor'shan Rampart"] = "莫尔杉农场",
	["The Mor'Shan Ramparts"] = "莫尔杉农场",
	["The Mosslight Pillar"] = "苔光之柱",
	["The Mountain Den"] = "山岭兽穴",
	["The Murder Pens"] = "谋杀者围栏",
	["The Mystic Ward"] = "秘法区",
	["The Necrotic Vault"] = "死灵穹顶",
	["The Nexus"] = "魔枢",
	["The Nexus Entrance"] = "魔枢入口",
	["The Nightmare Scar"] = "噩梦之痕",
	["The North Coast"] = "北部海岸",
	["The North Sea"] = "北海",
	["The Nosebleeds"] = "诺斯布利兹",
	["The Noxious Glade"] = "剧毒林地",
	["The Noxious Hollow"] = "毒气洞穴",
	["The Noxious Lair"] = "腐化之巢",
	["The Noxious Pass"] = "剧毒小径",
	["The Oblivion"] = "湮灭号",
	["The Observation Ring"] = "观测场",
	["The Obsidian Sanctum"] = "黑曜石圣殿",
	["The Oculus"] = "魔环",
	["The Oculus Entrance"] = "魔环入口",
	["The Old Barracks"] = "旧兵营",
	["The Old Dormitory"] = "旧宿舍",
	["The Old Port Authority"] = "港务局",
	["The Opera Hall"] = "歌剧院",
	["The Oracle Glade"] = "神谕林地",
	["The Outer Ring"] = "外环",
	["The Overgrowth"] = "蔓生绿洲",
	["The Overlook"] = "瞭望台",
	["The Overlook Cliffs"] = "望海崖",
	["The Overlook Inn"] = "观山酒馆",
	["The Ox Gate"] = "玄牛关",
	["The Pale Roost"] = "苍白栖地",
	["The Park"] = "花园",
	["The Path of Anguish"] = "苦痛之路",
	["The Path of Conquest"] = "征服之路",
	["The Path of Corruption"] = "腐蚀小径",
	["The Path of Glory"] = "荣耀之路",
	["The Path of Iron"] = "铁铸之路",
	["The Path of the Lifewarden"] = "生命守卫者之路",
	["The Phoenix Hall"] = "凤凰大厅",
	["The Pillar of Ash"] = "灰烬之柱",
	["The Pipe"] = "管道",
	["The Pit of Criminals"] = "罪恶之池",
	["The Pit of Fiends"] = "邪魔之坑",
	["The Pit of Narjun"] = "纳尔苏深渊",
	["The Pit of Refuse"] = "抛弃之池",
	["The Pit of Sacrifice"] = "牺牲之池",
	["The Pit of Scales"] = "邪鳞地穴",
	["The Pit of the Fang"] = "利齿之坑",
	["The Plague Quarter"] = "瘟疫区",
	["The Plagueworks"] = "天灾工厂",
	["The Pool of Ask'ar"] = "阿斯卡之池",
	["The Pools of Vision"] = "预见之池",
	["The Prison of Yogg-Saron"] = "尤格-萨隆的监狱",
	["The Proving Grounds"] = "实验场",
	["The Purple Parlor"] = "紫色天台",
	["The Quagmire"] = "泥潭沼泽",
	["The Quaking Fields"] = "地震旷野",
	["The Queen's Reprisal"] = "女王的复仇号",
	["The Raging Chasm"] = "地怒裂口",
	Theramore = "塞拉摩",
	["Theramore Isle"] = "塞拉摩岛",
	["Theramore's Fall"] = "塞拉摩的沦陷",
	["Theramore's Fall (A)"] = "塞拉摩的沦陷",
	["Theramore's Fall (H)"] = "塞拉摩的沦陷",
	["Theramore's Fall Phase"] = "Theramore's Fall Phase",
	["The Rangers' Lodge"] = "游侠小屋",
	["Therazane's Throne"] = "塞拉赞恩的王座",
	["The Red Reaches"] = "赤色海岸",
	["The Refectory"] = "餐厅",
	["The Regrowth"] = "复苏之地",
	["The Reliquary"] = "神圣遗物学会",
	["The Repository"] = "藏书馆",
	["The Reservoir"] = "蓄水池",
	["The Restless Front"] = "不眠前线",
	["The Ridge of Ancient Flame"] = "上古烈焰群山",
	["The Rift"] = "裂隙",
	["The Ring of Balance"] = "平衡之环",
	["The Ring of Blood"] = "鲜血竞技场",
	["The Ring of Champions"] = "冠军赛场",
	["The Ring of Inner Focus"] = "心灵专注之环",
	["The Ring of Trials"] = "试炼竞技场",
	["The Ring of Valor"] = "勇气竞技场",
	["The Riptide"] = "斩浪号",
	["The Riverblade Den"] = "河刃之巢",
	["Thermal Vents"] = "散热口",
	["The Roiling Gardens"] = "异生花园",
	["The Rolling Gardens"] = "异生花园",
	["The Rolling Plains"] = "草海平原",
	["The Rookery"] = "孵化间",
	["The Rotting Orchard"] = "烂果园",
	["The Rows"] = "阡陌",
	["The Royal Exchange"] = "皇家贸易区",
	["The Ruby Sanctum"] = "红玉圣殿",
	["The Ruined Reaches"] = "废墟海岸",
	["The Ruins of Kel'Theril"] = "凯斯利尔废墟",
	["The Ruins of Ordil'Aran"] = "奥迪拉兰废墟",
	["The Ruins of Stardust"] = "星尘废墟",
	["The Rumble Cage"] = "加基森竞技场",
	["The Rustmaul Dig Site"] = "锈锤挖掘场",
	["The Sacred Grove"] = "元素圣谷",
	["The Salty Sailor Tavern"] = "水手之家旅店",
	["The Sanctum"] = "密室",
	["The Sanctum of Blood"] = "鲜血秘室",
	["The Savage Coast"] = "野人海岸",
	["The Savage Glen"] = "蛮人谷",
	["The Savage Thicket"] = "蛮荒树林",
	["The Scalding Chasm"] = "火烟海沟",
	["The Scalding Pools"] = "滚烫熔池",
	["The Scarab Dais"] = "甲虫之台",
	["The Scarab Wall"] = "甲虫之墙",
	["The Scarlet Basilica"] = "血色十字军教堂",
	["The Scarlet Bastion"] = "血色十字军堡垒",
	["The Scorched Grove"] = "焦痕谷",
	["The Scorched Plain"] = "焦痕平原",
	["The Scrap Field"] = "废料场",
	["The Scrapyard"] = "废料场",
	["The Screaming Hall"] = "尖啸大厅",
	["The Screaming Reaches"] = "尖啸河滩",
	["The Screeching Canyon"] = "尖啸峡谷",
	["The Scribe of Stormwind"] = "暴风城铭文设计店",
	["The Scribes' Sacellum"] = "铭文师的殿堂",
	["The Scrollkeeper's Sanctum"] = "藏卷人密室",
	["The Scullery"] = "厨房",
	["The Scullery "] = "厨房",
	["The Seabolt"] = "海箭号",
	["The Seabreach Flow"] = "碎浪河",
	["The Sealed Hall"] = "封印大厅",
	["The Sea of Cinders"] = "灰烬之海",
	["The Sea Reaver's Run"] = "破海者航道",
	["The Searing Gateway"] = "灼热大门",
	["The Sea Wolf"] = "海狼号",
	["The Secret Aerie"] = "秘密鹰巢",
	["The Secret Lab"] = "秘密实验室",
	["The Secrets of Ragefire"] = "怒焰之谜",
	["The Seer's Library"] = "先知的图书馆",
	["The Sepulcher"] = "瑟伯切尔",
	["The Severed Span"] = "断桥",
	["The Sewer"] = "下水道",
	["The Shadow Stair"] = "暗影阶梯",
	["The Shadow Throne"] = "暗影王座",
	["The Shadow Vault"] = "暗影拱顶",
	["The Shady Nook"] = "林荫小径",
	["The Shaper's Terrace"] = "塑造者之台",
	["The Shattered Halls"] = "破碎大厅",
	["The Shattered Strand"] = "破碎海岸",
	["The Shattered Walkway"] = "破碎通道",
	["The Shepherd's Gate"] = "牧羊人之门",
	["The Shifting Mire"] = "流沙泥潭",
	["The Shimmering Deep"] = "闪光深渊",
	["The Shimmering Flats"] = "闪光平原",
	["The Shining Strand"] = "闪光湖岸",
	["The Shrine of Aessina"] = "艾森娜神殿",
	["The Shrine of Eldretharr"] = "艾德雷斯神殿",
	["The Silent Sanctuary"] = "缄默圣地",
	["The Silkwood"] = "丝木林",
	["The Silver Blade"] = "银锋号",
	["The Silver Enclave"] = "银色领地",
	["The Singing Grove"] = "轻歌之林",
	["The Singing Pools"] = "咏之池",
	["The Sin'loren"] = "辛洛雷号",
	["The Skeletal Reef"] = "骸骨珊瑚礁",
	["The Skittering Dark"] = "粘丝洞",
	["The Skull Warren"] = "颅骨密径",
	["The Skunkworks"] = "研发部",
	["The Skybreaker"] = "破天号",
	["The Skyfire"] = "天火号",
	["The Skyreach Pillar"] = "通天之柱",
	["The Slag Pit"] = "熔渣之池",
	["The Slaughtered Lamb"] = "已宰的羔羊",
	["The Slaughter House"] = "屠宰房",
	["The Slave Pens"] = "奴隶围栏",
	["The Slave Pits"] = "奴隶营",
	["The Slick"] = "覆油海",
	["The Slithering Scar"] = "巨痕谷",
	["The Slough of Dispair"] = "绝望泥沼",
	["The Sludge Fen"] = "淤泥沼泽",
	["The Sludge Fields"] = "药渣农场",
	["The Sludgewerks"] = "油污潭",
	["The Solarium"] = "日晷台",
	["The Solar Vigil"] = "观日台",
	["The Southern Isles"] = "南部岛屿",
	["The Southern Wall"] = "南部城墙",
	["The Sparkling Crawl"] = "耀晶幽径",
	["The Spark of Imagination"] = "思想火花",
	["The Spawning Glen"] = "孢殖林",
	["The Spire"] = "冰冠之塔",
	["The Splintered Path"] = "碎石小径",
	["The Spring Road"] = "春之路",
	["The Stadium"] = "竞赛场",
	["The Stagnant Oasis"] = "死水绿洲",
	["The Staidridge"] = "顽石岭",
	["The Stair of Destiny"] = "命运阶梯",
	["The Stair of Doom"] = "末日阶梯",
	["The Starchaser"] = "逐星者号",
	["The Star's Bazaar"] = "星辰集市",
	["The Steam Pools"] = "蒸汽之池",
	["The Steamvault"] = "蒸汽地窟",
	["The Steppe of Life"] = "生命草原",
	["The Steps of Fate"] = "天命阶梯",
	["The Stinging Trail"] = "刺芒小径",
	["The Stockade"] = "监狱",
	["The Stockpile"] = "物资储藏点",
	["The Stonecore"] = "巨石之核",
	["The Stonecore Entrance"] = "巨石之核入口",
	["The Stonefield Farm"] = "斯通菲尔德农场",
	["The Stone Vault"] = "石窖",
	["The Storehouse"] = "仓库",
	["The Stormbreaker"] = "斩雷号",
	["The Stormbridge"] = "风暴之桥",
	["The Storm Foundry"] = "风暴铸造场",
	["The Storm Peaks"] = "风暴峭壁",
	["The Stormspire"] = "风暴尖塔",
	["The Stormwright's Shelf"] = "雷暴台地",
	["The Summer Fields"] = "仲夏原",
	["The Summer Terrace"] = "夏之台",
	["The Sundered Shard"] = "崩裂碎片",
	["The Sundering"] = "地陷裂口",
	["The Sun Forge"] = "太阳熔炉",
	["The Sunken Ring"] = "沉降之环",
	["The Sunset Brewgarden"] = "落日酒坊",
	["The Sunspire"] = "太阳之塔",
	["The Suntouched Pillar"] = "日灼之柱",
	["The Sunwell"] = "太阳之井",
	["The Swarming Pillar"] = "虫群之柱",
	["The Swollen Vault"] = "浮华宝库",
	["The Tainted Forest"] = "腐烂森林",
	["The Tainted Scar"] = "腐烂之痕",
	["The Talondeep Path"] = "石爪小径",
	["The Talon Den"] = "猛禽洞穴",
	["The Tasting Room"] = "品酒间",
	["The Tempest Rift"] = "风暴裂隙",
	["The Temple Gardens"] = "神殿花园",
	["The Temple of Atal'Hakkar"] = "阿塔哈卡神庙",
	["The Temple of the Jade Serpent"] = "青龙寺",
	["The Terrestrial Watchtower"] = "大地瞭望塔",
	["The Thornsnarl"] = "纠棘荒地",
	["The Threads of Fate"] = "命运丝线",
	["The Threshold"] = "起源界限",
	["The Throne of Flame"] = "烈焰王座",
	["The Thunder Forge"] = "雷霆熔炉",
	["The Thunder Forges"] = "雷霆熔炉",
	["The Thundering Run"] = "雷霆小径",
	["The Thundering Spire"] = "雷鸣之塔",
	["The Thunderspire"] = "雷霆之塔",
	["The Thunderwood"] = "雷木林",
	["The Tidebreaker"] = "破潮者号",
	["The Tidus Stair"] = "提度斯阶梯",
	["The Tiger's Peak"] = "虎踞峰",
	["The Torjari Pit"] = "托加尼洼地",
	["The Tower of Arathor"] = "阿拉索之塔",
	["The Toxic Airfield"] = "剧毒机场",
	["The Trail of Devastation"] = "毁灭的试炼",
	["The Tranquil Grove"] = "宁静林地",
	["The Transitus Stair"] = "永生之阶",
	["The Trapper's Enclave"] = "诱捕者营地",
	["The Tribunal of Ages"] = "远古法庭",
	["The Tundrid Hills"] = "冻土岭",
	["The Twilight Breach"] = "暮光裂口",
	["The Twilight Caverns"] = "暮光之穴",
	["The Twilight Citadel"] = "暮光堡垒",
	["The Twilight Enclave"] = "暮光教区",
	["The Twilight Gate"] = "暮光之门",
	["The Twilight Gauntlet"] = "暮光试炼营",
	["The Twilight Ridge"] = "暮光岭",
	["The Twilight Rivulet"] = "暮色小溪",
	["The Twilight Withering"] = "暮光凋零法阵",
	["The Twin Colossals"] = "双塔山",
	["The Twisted Glade"] = "扭曲之林",
	["The Twisted Warren"] = "扭曲密径",
	["The Two Fisted Brew"] = "阴阳酒楼",
	["The Unbound Thicket"] = "自由之林",
	["The Underbelly"] = "达拉然下水道",
	["The Underbog"] = "幽暗沼泽",
	["The Underbough"] = "地下繁枝",
	["The Undercroft"] = "墓室",
	["The Underhalls"] = "地下大厅",
	["The Undershell"] = "海底巨蚌",
	["The Uplands"] = "高地",
	["The Upside-down Sinners"] = "倒吊深渊",
	["The Valley of Fallen Heroes"] = "陨落英雄之谷",
	["The Valley of Lost Hope"] = "失落希望之谷",
	["The Vault of Lights"] = "光明穹顶",
	["The Vector Coil"] = "矢量感应器",
	["The Veiled Cleft"] = "迷雾裂隙",
	["The Veiled Sea"] = "迷雾之海",
	["The Veiled Stair"] = "雾纱栈道",
	["The Venture Co. Mine"] = "风险投资公司矿洞",
	["The Verdant Fields"] = "青草平原",
	["The Verdant Thicket"] = "葱郁林地",
	["The Verne"] = "凡尔纳号",
	["The Verne - Bridge"] = "凡尔纳 - 舰桥",
	["The Verne - Entryway"] = "凡尔纳号入口",
	["The Vibrant Glade"] = "活力之林",
	["The Vice"] = "罪恶谷",
	["The Vicious Vale"] = "恶花谷",
	["The Viewing Room"] = "观察室",
	["The Vile Reef"] = "暗礁海",
	["The Violet Citadel"] = "紫罗兰城堡",
	["The Violet Citadel Spire"] = "紫罗兰塔",
	["The Violet Gate"] = "紫罗兰之门",
	["The Violet Hold"] = "紫罗兰监狱",
	["The Violet Spire"] = "紫罗兰高塔",
	["The Violet Tower"] = "紫罗兰之塔",
	["The Vortex Fields"] = "漩涡平原",
	["The Vortex Pinnacle"] = "旋云之巅",
	["The Vortex Pinnacle Entrance"] = "旋云之巅入口",
	["The Wailing Caverns"] = "哀嚎洞穴",
	["The Wailing Ziggurat"] = "悲叹通灵塔",
	["The Waking Halls"] = "苏醒之厅",
	["The Wandering Isle"] = "迷踪岛",
	["The Warlord's Garrison"] = "督军要塞",
	["The Warlord's Terrace"] = "督军的平台",
	["The Warp Fields"] = "迁跃平原",
	["The Warp Piston"] = "跳跃引擎",
	["The Wavecrest"] = "浪巅号",
	["The Weathered Nook"] = "老屋",
	["The Weeping Cave"] = "哭泣之洞",
	["The Western Earthshrine"] = "西部大地神殿",
	["The Westrift"] = "西部裂谷",
	["The Whelping Downs"] = "雏龙丘陵",
	["The Whipple Estate"] = "维普尔庄园",
	["The Wicked Coil"] = "邪恶之旋",
	["The Wicked Grotto"] = "邪恶洞穴",
	["The Wicked Tunnels"] = "邪恶通道",
	["The Widening Deep"] = "地渊谷",
	["The Widow's Clutch"] = "寡妇之巢",
	["The Widow's Wail"] = "蛛泣洞穴",
	["The Wild Plains"] = "莽林平原",
	["The Wild Shore"] = "蛮荒海岸",
	["The Winding Halls"] = "曲径大厅",
	["The Windrunner"] = "风行者号",
	["The Windspire"] = "风之塔",
	["The Wollerton Stead"] = "沃勒顿农场",
	["The Wonderworks"] = "奇妙玩具店",
	["The Wood of Staves"] = "禅杖林",
	["The World Tree"] = "世界之树",
	["The Writhing Deep"] = "痛苦深渊",
	["The Writhing Haunt"] = "嚎哭鬼屋",
	["The Yaungol Advance"] = "野牛人前线",
	["The Yorgen Farmstead"] = "约根农场",
	["The Zandalari Vanguard"] = "赞达拉先锋军驻地",
	["The Zoram Strand"] = "佐拉姆海岸",
	["Thieves Camp"] = "盗贼营地",
	["Thirsty Alley"] = "渴酒谷",
	["Thistlefur Hold"] = "蓟皮要塞",
	["Thistlefur Village"] = "蓟皮村",
	["Thistleshrub Valley"] = "灌木谷",
	["Thondroril River"] = "索多里尔河",
	["Thoradin's Wall"] = "索拉丁之墙",
	["Thorium Advance"] = "瑟银前哨",
	["Thorium Point"] = "瑟银哨塔",
	["Thor Modan"] = "索尔莫丹",
	["Thornfang Hill"] = "棘牙岭",
	["Thorn Hill"] = "荆棘岭",
	["Thornmantle's Hideout"] = "刺鬃藏身处",
	["Thorson's Post"] = "索尔森的岗哨",
	["Thorvald's Camp"] = "托尔瓦德的营地",
	["Thousand Needles"] = "千针石林",
	Thrallmar = "萨尔玛",
	["Thrallmar Mine"] = "萨尔玛矿洞",
	["Three Corners"] = "三角路口",
	["Throne of Ancient Conquerors"] = "上古征服者王座",
	["Throne of Kil'jaeden"] = "基尔加丹王座",
	["Throne of Neptulon"] = "耐普图隆的王座",
	["Throne of the Apocalypse"] = "末世王座",
	["Throne of the Damned"] = "诅咒王座",
	["Throne of the Elements"] = "元素王座",
	["Throne of the Four Winds"] = "风神王座",
	["Throne of the Tides"] = "潮汐王座",
	["Throne of the Tides Entrance"] = "潮汐王座入口",
	["Throne of Thunder"] = "雷电王座",
	["Throne of Tides"] = "潮汐王座",
	["Thrym's End"] = "塞穆之末",
	["Thunder Axe Fortress"] = "雷斧堡垒",
	Thunderbluff = "雷霆崖",
	["Thunder Bluff"] = "雷霆崖",
	["Thunderbrew Distillery"] = "雷酒酿制厂",
	["Thunder Cleft"] = "雷霆裂口",
	Thunderfall = "落雷谷",
	["Thunder Falls"] = "雷霆瀑布",
	["Thunderfoot Farm"] = "雷脚农田",
	["Thunderfoot Fields"] = "雷脚农场",
	["Thunderfoot Inn"] = "雷脚酒馆",
	["Thunderfoot Ranch"] = "雷脚牧场",
	["Thunder Hold"] = "雷霆要塞",
	["Thunderhorn Water Well"] = "雷角水井",
	["Thundering Overlook"] = "雷鸣峭壁",
	["Thunder Island Alliance Hub"] = "紫罗兰高地",
	["Thunder King Horde Hub"] = "寻晨者海角",
	["Thunder King's Citadel"] = "雷电堡",
	["Thunderlord Stronghold"] = "雷神要塞",
	Thundermar = "桑德玛尔",
	["Thundermar Ruins"] = "桑德玛尔废墟",
	["Thunderpaw Overlook"] = "雷掌台",
	["Thunderpaw Refuge"] = "雷掌阁",
	["Thunder Peak"] = "雷鸣峰",
	["Thunder Ridge"] = "雷霆山",
	["Thunder's Call"] = "雷电的呼唤",
	["Thunderstrike Mountain"] = "落雷山",
	["Thunk's Abode"] = "桑克的住所",
	["Thuron's Livery"] = "苏伦的养殖场",
	["Tian Monastery"] = "天禅院",
	["Tidefury Cove"] = "狂潮湾",
	["Tides' Hollow"] = "海潮洞窟",
	["Tideview Thicket"] = "观海听涛林",
	["Tigers' Wood"] = "猛虎林",
	["Timbermaw Hold"] = "木喉要塞",
	["Timbermaw Post"] = "木喉岗哨",
	["Tinkers' Court"] = "工匠议会",
	["Tinker Town"] = "侏儒区",
	["Tiragarde Keep"] = "提拉加德城堡",
	["Tirisfal Glades"] = "提瑞斯法林地",
	["Tirth's Haunt"] = "提尔希的法阵",
	["Tkashi Ruins"] = "伽什废墟",
	["Tol Barad"] = "托尔巴拉德",
	["Tol Barad Peninsula"] = "托尔巴拉德半岛",
	["Tol'Vir Arena"] = "托维尔竞技场",
	["Tol'viron Arena"] = "托维尔隆竞技场",
	["Tol'Viron Arena"] = "托维尔隆竞技场",
	["Tomb of Conquerors"] = "征服者陵墓",
	["Tomb of Lights"] = "圣光之墓",
	["Tomb of Secrets"] = "隐秘古陵",
	["Tomb of Shadows"] = "暗影古陵",
	["Tomb of the Ancients"] = "远古墓穴",
	["Tomb of the Earthrager"] = "地怒者的陵墓",
	["Tomb of the Lost Kings"] = "失落王者之墓",
	["Tomb of the Sun King"] = "太阳王陵墓",
	["Tomb of the Watchers"] = "观察者的陵墓",
	["Tombs of the Precursors"] = "先贤陵墓",
	["Tome of the Unrepentant"] = "无悔者之书",
	["Tome of the Unrepentant "] = "无悔者之书",
	["Tor'kren Farm"] = "托克伦农场",
	["Torp's Farm"] = "托普的农场",
	["Torseg's Rest"] = "托塞格的营地",
	["Tor'Watha"] = "托尔瓦萨",
	["Toryl Estate"] = "托尔里公馆",
	["Toshley's Station"] = "托什雷的基地",
	["To the Skies!"] = "直冲云霄！",
	["To The Skies!"] = "直冲云霄！",
	["Tower of Althalaxx"] = "奥萨拉克斯之塔",
	["Tower of Azora"] = "阿祖拉之塔",
	["Tower of Eldara"] = "埃达拉之塔",
	["Tower of Estulan"] = "埃斯图兰之塔",
	["Tower of Ilgalar"] = "伊尔加拉之塔",
	["Tower of the Damned"] = "诅咒之塔",
	["Tower Point"] = "哨塔高地",
	["Tower Watch"] = "瞭望塔",
	["Town-In-A-Box"] = "胶囊镇",
	["Townlong Steppes"] = "螳螂高原",
	["Town Square"] = "城镇广场",
	["Trade District"] = "贸易区",
	["Trade Quarter"] = "贸易区",
	["Trader's Tier"] = "贸易阶梯",
	["Tradesmen's Terrace"] = "贸易区",
	["Train Depot"] = "地铁站",
	["Training Grounds"] = "训练场",
	["Training Quarters"] = "训练大厅",
	["Traitor's Cove"] = "叛徒湾",
	["Tranquil Coast"] = "静谧湾岸",
	["Tranquil Gardens Cemetery"] = "静谧花园墓场",
	["Tranquil Grotto"] = "宁静神龛",
	Tranquillien = "塔奎林",
	["Tranquil Shore"] = "静谧海岸",
	["Tranquil Wash"] = "静谧海滩",
	Transborea = "横贯冰原",
	["Transitus Shield"] = "永生之盾",
	["Transport: Alliance Gunship"] = "交通工具：联盟炮艇",
	["Transport: Alliance Gunship (IGB)"] = "Transport: Alliance Gunship (IGB)",
	["Transport: Horde Gunship"] = "交通工具：部落炮艇",
	["Transport: Horde Gunship (IGB)"] = "Transport: Horde Gunship (IGB)",
	["Transport: Onyxia/Nefarian Elevator"] = "运输工具：奥尼克西亚/奈法利安电梯",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "Trasnport: The Mighty Wind (Icecrown Citadel Raid)",
	["Trelleum Mine"] = "特雷卢姆矿井",
	["Trial of Fire"] = "火焰试炼场",
	["Trial of Frost"] = "冰霜试炼场",
	["Trial of Shadow"] = "暗影试炼场",
	["Trial of the Champion"] = "冠军的试炼",
	["Trial of the Champion Entrance"] = "冠军的试炼入口",
	["Trial of the Crusader"] = "十字军的试炼",
	["Trickling Passage"] = "滴酒道",
	["Trogma's Claim"] = "托格玛洞穴",
	["Trollbane Hall"] = "托尔贝恩大厅",
	["Troll War Camp Outskirts"] = "巨魔战争营地外围",
	["Trophy Hall"] = "战利品陈列厅",
	["Troves of the Thunder King"] = "雷电之王的藏宝库",
	["Trueshot Point"] = "强击哨站",
	["Tuluman's Landing"] = "图鲁曼的营地",
	["Turtle Beach"] = "海龟沙滩",
	["Tu Shen Burial Ground"] = "徒圣陵园",
	Tuurem = "图雷姆",
	["Twilight Aerie"] = "暮光之巢",
	["Twilight Altar of Storms"] = "暮光风暴祭坛",
	["Twilight Base Camp"] = "暮光营地",
	["Twilight Bulwark"] = "暮光壁垒",
	["Twilight Camp"] = "暮光营地",
	["Twilight Command Post"] = "暮光封锁线",
	["Twilight Crossing"] = "暮光路口",
	["Twilight Forge"] = "暮光铸炉",
	["Twilight Grove"] = "黎明森林",
	["Twilight Highlands"] = "暮光高地",
	["Twilight Highlands Dragonmaw Phase"] = "暮光高地龙喉位面",
	["Twilight Highlands Phased Entrance"] = "暮光高地位面入口",
	["Twilight Highlands Zeppelin 1"] = "暮光高地飞艇1",
	["Twilight Highlands Zeppelin 2"] = "暮光高地飞艇2",
	["Twilight Outpost"] = "暮光前哨站",
	["Twilight Overlook"] = "暮光瞭望台",
	["Twilight Post"] = "暮光岗哨",
	["Twilight Precipice"] = "暮光绝壁",
	["Twilight Shore"] = "暮光海滩",
	["Twilight's Run"] = "暮光小径",
	["Twilight Terrace"] = "暮光平台",
	["Twilight Vale"] = "暮光谷",
	["Twinbraid's Patrol"] = "双辫将军的巡逻岗",
	["Twin Peaks"] = "双子峰",
	["Twin Shores"] = "双子海岸",
	["Twinspire Keep"] = "双塔堡垒",
	["Twinspire Keep Interior"] = "双塔堡垒内部",
	["Twin Spire Ruins"] = "双塔废墟",
	["Twisting Nether"] = "扭曲虚空",
	["Tyr's Hand"] = "提尔之手",
	["Tyr's Hand Abbey"] = "提尔之手修道院",
	["Tyr's Terrace"] = "提尔之台",
	["Ufrang's Hall"] = "乌弗朗之厅",
	Uldaman = "奥达曼",
	["Uldaman Entrance"] = "奥达曼入口",
	Uldis = "奥迪斯",
	Ulduar = "奥杜尔",
	["Ulduar Raid - Interior - Insertion Point"] = "Ulduar Raid - Interior - Insertion Point",
	["Ulduar Raid - Iron Concourse"] = "Ulduar Raid - Iron Concourse",
	Uldum = "奥丹姆",
	["Uldum Phased Entrance"] = "奥丹姆入口位面",
	["Uldum Phase Oasis"] = "奥丹姆绿洲位面",
	["Uldum - Phase Wrecked Camp"] = "奥丹姆——失事营地位面",
	["Umbrafen Lake"] = "暗泽湖",
	["Umbrafen Village"] = "暗泽村",
	["Uncharted Sea"] = "神秘海域",
	Undercity = "幽暗城",
	["Underlight Canyon"] = "光渊海峡",
	["Underlight Mines"] = "幽光矿洞",
	["Unearthed Grounds"] = "不毛之地",
	["Unga Ingoo"] = "盎迦猴岛",
	["Un'Goro Crater"] = "安戈洛环形山",
	["Unu'pe"] = "乌努比",
	["Unyielding Garrison"] = "坚韧军营",
	["Upper Silvermarsh"] = "上层银沼",
	["Upper Sumprushes"] = "上激流潭",
	["Upper Veil Shil'ak"] = "上层夏尔克鸦巢",
	["Ursoc's Den"] = "乌索克之巢",
	Ursolan = "乌索兰",
	["Utgarde Catacombs"] = "乌特加德墓穴",
	["Utgarde Keep"] = "乌特加德城堡",
	["Utgarde Keep Entrance"] = "乌特加德城堡入口",
	["Utgarde Pinnacle"] = "乌特加德之巅",
	["Utgarde Pinnacle Entrance"] = "乌特加德之巅入口",
	["Uther's Tomb"] = "乌瑟尔之墓",
	["Valaar's Berth"] = "瓦拉尔港口",
	["Vale of Eternal Blossoms"] = "锦绣谷",
	["Valgan's Field"] = "瓦尔甘农场",
	Valgarde = "瓦加德",
	["Valgarde Port"] = "瓦加德港口",
	Valhalas = "瓦哈拉斯",
	["Valiance Keep"] = "无畏要塞",
	["Valiance Landing Camp"] = "无畏远征军营地",
	["Valiant Rest"] = "勇士之眠",
	Valkyrion = "瓦基里安",
	["Valley of Ancient Winters"] = "上古寒冬山谷",
	["Valley of Ashes"] = "燃灰谷",
	["Valley of Bones"] = "白骨之谷",
	["Valley of Echoes"] = "回音谷",
	["Valley of Emperors"] = "皇帝谷",
	["Valley of Fangs"] = "巨牙谷",
	["Valley of Heroes"] = "英雄谷",
	["Valley Of Heroes"] = "英雄谷",
	["Valley of Honor"] = "荣誉谷",
	["Valley of Kings"] = "国王谷",
	["Valley of Power"] = "能量谷",
	["Valley Of Power - Scenario"] = "能量谷 - 场景战役",
	["Valley of Spears"] = "长矛谷",
	["Valley of Spirits"] = "精神谷",
	["Valley of Strength"] = "力量谷",
	["Valley of the Bloodfuries"] = "血怒峡谷",
	["Valley of the Four Winds"] = "四风谷",
	["Valley of the Watchers"] = "观察者之谷",
	["Valley of Trials"] = "试炼谷",
	["Valley of Wisdom"] = "智慧谷",
	Valormok = "瓦罗莫克",
	["Valor's Edge"] = "无畏界限号",
	["Valor's Rest"] = "勇士之墓",
	["Valorwind Lake"] = "瓦罗温湖",
	["Vanguard Infirmary"] = "前线基地医护所",
	["Vanndir Encampment"] = "范迪尔营地",
	["Vargoth's Retreat"] = "瓦格斯的居所",
	["Vashj'elan Spawning Pool"] = "瓦丝耶兰孵化池",
	["Vashj'ir"] = "瓦丝琪尔",
	["Vashj'ir Sub - Alliance"] = "瓦丝琪尔水下——联盟",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "瓦丝琪尔水下——联盟深渊之喉外环",
	["Vashj'ir Sub - Horde"] = "瓦丝琪尔水下——部落",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "瓦丝琪尔水下——部落深渊之喉外环",
	["Vault of Archavon"] = "阿尔卡冯的宝库",
	["Vault of Ironforge"] = "铁炉堡银行",
	["Vault of Kings Past"] = "古王陵墓",
	["Vault of the Ravenian"] = "拉文尼亚的灵堂",
	["Vault of the Shadowflame"] = "暗影烈焰穹顶",
	["Vault of Y'Shaarj"] = "亚煞极地窟",
	["Veil Ala'rak"] = "奥拉克鸦巢",
	["Veil Harr'ik"] = "哈雷克鸦巢",
	["Veil Lashh"] = "拉什鸦巢",
	["Veil Lithic"] = "雷希鸦巢",
	["Veil Reskk"] = "里斯克鸦巢",
	["Veil Rhaze"] = "哈兹鸦巢",
	["Veil Ruuan"] = "卢安鸦巢",
	["Veil Sethekk"] = "塞泰克鸦巢",
	["Veil Shalas"] = "沙拉斯鸦巢",
	["Veil Shienor"] = "西诺鸦巢",
	["Veil Skith"] = "基斯鸦巢",
	["Veil Vekh"] = "维克鸦巢",
	["Vekhaar Stand"] = "维克哈营地",
	["Velaani's Arcane Goods"] = "维兰尼的魔法用品店",
	["Vendetta Point"] = "世仇哨站",
	["Vengeance Landing"] = "复仇港",
	["Vengeance Landing Inn"] = "复仇港旅店",
	["Vengeance Landing Inn, Howling Fjord"] = "复仇港旅店",
	["Vengeance Lift"] = "复仇升降梯",
	["Vengeance Pass"] = "复仇小径",
	["Vengeance Wake"] = "复仇觉醒号",
	["Venomous Ledge"] = "毒水崖",
	Venomspite = "怨毒镇",
	["Venomsting Pits"] = "毒刺蝎巢",
	["Venomweb Vale"] = "毒蛛峡谷",
	["Venture Bay"] = "风险湾",
	["Venture Co. Base Camp"] = "风险投资公司营地",
	["Venture Co. Operations Center"] = "风险投资公司工作中心",
	["Verdant Belt"] = "翠绿草场",
	["Verdant Highlands"] = "青草高地",
	["Verdantis River"] = "沃丹提斯河",
	["Veridian Point"] = "绿龙尖岬",
	["Verlok Stand"] = "维罗克岩台",
	["Vermillion Redoubt"] = "朱红庇护所",
	["Verming Tunnels Micro"] = "小型兔妖隧道",
	["Verrall Delta"] = "瓦拉尔三角洲",
	["Verrall River"] = "瓦拉尔河",
	["Victor's Point"] = "胜利者岗哨",
	["Vileprey Village"] = "邪猎村",
	["Vim'gol's Circle"] = "维姆高尔的法阵",
	["Vindicator's Rest"] = "守备官营地",
	["Violet Citadel Balcony"] = "紫罗兰城堡阳台",
	["Violet Hold"] = "紫罗兰监狱",
	["Violet Hold Entrance"] = "紫罗兰监狱入口",
	["Violet Rise"] = "紫罗兰高地",
	["Violet Stand"] = "紫罗兰哨站",
	["Virmen Grotto"] = "兔妖洞",
	["Virmen Nest"] = "兔妖巢",
	["Vir'naal Dam"] = "维尔纳尔水坝",
	["Vir'naal Lake"] = "维尔纳尔湖",
	["Vir'naal Oasis"] = "维尔纳尔绿洲",
	["Vir'naal River"] = "维尔纳尔河",
	["Vir'naal River Delta"] = "维尔纳尔三角洲",
	["Void Ridge"] = "虚空山脉",
	["Voidwind Plateau"] = "虚风高原",
	["Volcanoth's Lair"] = "沃卡洛斯的巢穴",
	["Voldrin's Hold"] = "沃德林之拥号",
	Voldrune = "沃德伦",
	["Voldrune Dwelling"] = "沃德伦民居",
	Voltarus = "沃尔塔鲁斯",
	["Vordrassil Pass"] = "沃达希尔小径",
	["Vordrassil's Heart"] = "沃达希尔之心",
	["Vordrassil's Limb"] = "沃达希尔之臂",
	["Vordrassil's Tears"] = "沃达希尔之泪",
	["Vortex Pinnacle"] = "漩涡峰",
	["Vortex Summit"] = "漩涡峰",
	["Vul'Gol Ogre Mound"] = "沃古尔食人魔山",
	["Vyletongue Seat"] = "维利塔恩之座",
	["Wahl Cottage"] = "薇儿小屋",
	["Wailing Caverns"] = "哀嚎洞穴",
	["Walk of Elders"] = "长者步道",
	["Warbringer's Ring"] = "战争使者之环",
	["Warchief's Lookout"] = "酋长瞭望台",
	["Warden's Cage"] = "守望者牢笼",
	["Warden's Chambers"] = "典狱官之厅",
	["Warden's Vigil"] = "典狱官岗哨",
	["Warlock Area"] = "术士区域",
	["Warmaul Hill"] = "战槌山",
	["Warpwood Quarter"] = "扭木广场",
	["War Quarter"] = "军事区",
	["Warrior's Terrace"] = "战士区",
	["War Room"] = "指挥室",
	Warship = "战船",
	["Warsong Camp"] = "战歌营地",
	["Warsong Farms Outpost"] = "战歌农场哨站",
	["Warsong Flag Room"] = "战歌军旗室",
	["Warsong Granary"] = "战歌粮仓",
	["Warsong Gulch"] = "战歌峡谷",
	["Warsong Hold"] = "战歌要塞",
	["Warsong Jetty"] = "战歌防波堤",
	["Warsong Labor Camp"] = "战歌劳工营地",
	["Warsong Lumber Camp"] = "战歌伐木营地",
	["Warsong Lumber Mill"] = "战歌伐木场",
	["Warsong Slaughterhouse"] = "战歌屠宰场",
	["Watcher's Sanctum"] = "监视者秘所",
	["Watchers' Terrace"] = "守望平台",
	["Waterspeaker's Sanctuary"] = "水语者圣所",
	["Waterspring Field"] = "清泉平原",
	Waterworks = "磨坊",
	["Wavestrider Beach"] = "破浪海滩",
	Waxwood = "红烛林",
	["Wayfarer's Rest"] = "旅者的梦乡",
	Waygate = "界门",
	["Wayne's Refuge"] = "韦恩的避难所",
	["Weazel's Crater"] = "维吉尔之坑",
	["Webwinder Hollow"] = "蛛网盆地",
	["Webwinder Path"] = "蛛网小径",
	["Weeping Quarry"] = "哭泣采掘场",
	["Well of Eternity"] = "永恒之井",
	["Well of the Forgotten"] = "遗忘之井",
	["Wellson Shipyard"] = "维尔松船坞",
	["Wellspring Hovel"] = "清泉小屋",
	["Wellspring Lake"] = "涌泉湖",
	["Wellspring River"] = "涌泉河",
	["Westbrook Garrison"] = "西泉要塞",
	["Western Bridge"] = "西部桥梁",
	["Western Plaguelands"] = "西瘟疫之地",
	["Western Strand"] = "西部海岸",
	Westersea = "西部之海",
	Westfall = "西部荒野",
	["Westfall Brigade"] = "Westfall Brigade, Grizzly Hills (Quest)",
	["Westfall Brigade Encampment"] = "月溪旅营地",
	["Westfall Lighthouse"] = "西部荒野灯塔",
	["West Garrison"] = "西区兵营",
	["Westguard Inn"] = "西部卫戍要塞旅店",
	["Westguard Keep"] = "西部卫戍要塞",
	["Westguard Turret"] = "西部卫戍要塞塔楼",
	["West Pavilion"] = "西部帐篷",
	["West Pillar"] = "西部石柱",
	["West Point Station"] = "西部哨站",
	["West Point Tower"] = "西点哨塔",
	["Westreach Summit"] = "西岸峰",
	["West Sanctum"] = "西部圣殿",
	["Westspark Workshop"] = "西部火花车间",
	["West Spear Tower"] = "西部长矛塔楼",
	["West Spire"] = "西部尖塔",
	["Westwind Lift"] = "西风升降梯",
	["Westwind Refugee Camp"] = "西风避难营",
	["Westwind Rest"] = "西风之息",
	Wetlands = "湿地",
	Wheelhouse = "水车房",
	["Whelgar's Excavation Site"] = "维尔加挖掘场",
	["Whelgar's Retreat"] = "维尔加居所",
	["Whispercloud Rise"] = "语云山",
	["Whisper Gulch"] = "低语峡谷",
	["Whispering Forest"] = "耳语森林",
	["Whispering Gardens"] = "耳语花园",
	["Whispering Inlet"] = "低语海口",
	["Whispering Shore"] = "耳语海岸",
	["Whispering Stones"] = "低语之石",
	["Whisperwind Grove"] = "语风林地",
	["Whistling Grove"] = "呼啸林地",
	["Whitebeard's Encampment"] = "白须营地",
	["Whitepetal Lake"] = "琼花湖",
	["White Pine Trading Post"] = "白松商栈",
	["Whitereach Post"] = "白沙岗哨",
	["Wildbend River"] = "急弯河",
	["Wildervar Mine"] = "维德瓦矿洞",
	["Wildflame Point"] = "野火哨站",
	["Wildgrowth Mangal"] = "蛮藤谷",
	["Wildhammer Flag Room"] = "蛮锤军旗室",
	["Wildhammer Keep"] = "蛮锤城堡",
	["Wildhammer Stronghold"] = "蛮锤要塞",
	["Wildheart Point"] = "野性之心哨站",
	["Wildmane Water Well"] = "蛮鬃水井",
	["Wild Overlook"] = "荒野瞭望台",
	["Wildpaw Cavern"] = "蛮爪洞穴",
	["Wildpaw Ridge"] = "蛮爪岭",
	["Wilds' Edge Inn"] = "荒野之崖酒馆",
	["Wild Shore"] = "蛮荒海岸",
	["Wildvine Marsh"] = "野藤沼泽",
	["Wildwind Lake"] = "狂风湖",
	["Wildwind Path"] = "狂风小径",
	["Wildwind Peak"] = "狂风山",
	["Windbreak Canyon"] = "风裂峡谷",
	["Windfury Ridge"] = "风怒山",
	["Windrunner's Overlook"] = "风行者观察站",
	["Windrunner Spire"] = "风行者之塔",
	["Windrunner Village"] = "风行村",
	["Winds' Edge"] = "风之崖",
	["Windshear Crag"] = "狂风峭壁",
	["Windshear Heights"] = "风剪高地",
	["Windshear Hold"] = "风剪要塞",
	["Windshear Mine"] = "狂风矿洞",
	["Windshear Valley"] = "风剪山谷",
	["Windspire Bridge"] = "风塔桥",
	["Windward Isle"] = "临风岛",
	["Windy Bluffs"] = "狂风崖",
	["Windyreed Pass"] = "风茅小径",
	["Windyreed Village"] = "风茅村",
	["Winterax Hold"] = "冰斧要塞",
	["Winterbough Glade"] = "冬花林地",
	["Winterfall Village"] = "寒水村",
	["Winterfin Caverns"] = "冬鳞洞穴",
	["Winterfin Retreat"] = "冬鳞避难所",
	["Winterfin Village"] = "冬鳞村",
	["Wintergarde Crypt"] = "暮冬地穴",
	["Wintergarde Keep"] = "暮冬要塞",
	["Wintergarde Mausoleum"] = "暮冬陵园",
	["Wintergarde Mine"] = "暮冬矿洞",
	Wintergrasp = "冬拥湖",
	["Wintergrasp Fortress"] = "冬拥堡垒",
	["Wintergrasp River"] = "冬拥河",
	["Winterhoof Water Well"] = "冰蹄水井",
	["Winter's Blossom"] = "冬花营",
	["Winter's Breath Lake"] = "冬息湖",
	["Winter's Edge Tower"] = "冬缘塔楼",
	["Winter's Heart"] = "寒冬之心",
	Winterspring = "冬泉谷",
	["Winter's Terrace"] = "寒冬大厅",
	["Witch Hill"] = "女巫岭",
	["Witch's Sanctum"] = "巫女密室",
	["Witherbark Caverns"] = "枯木洞穴",
	["Witherbark Village"] = "枯木村",
	["Withering Thicket"] = "枯萎林地",
	["Wizard Row"] = "巫师街",
	["Wizard's Sanctum"] = "巫师圣殿",
	["Wolf's Run"] = "狼神小径",
	["Woodpaw Den"] = "木爪巢穴",
	["Woodpaw Hills"] = "木爪岭",
	["Wood's End Cabin"] = "林中小屋",
	["Woods of the Lost"] = "失落林地",
	Workshop = "车间",
	["Workshop Entrance"] = "车间入口",
	["World's End Tavern"] = "天涯旅店",
	["Wrathscale Lair"] = "怒鳞巢穴",
	["Wrathscale Point"] = "怒鳞岗哨",
	["Wreckage of the Silver Dawning"] = "银色清晨号的船骸",
	["Wreck of Hellscream's Fist"] = "地狱咆哮之拳的残骸",
	["Wreck of the Mist-Hopper"] = "雾海飞跃者的残骸",
	["Wreck of the Skyseeker"] = "寻天号船骸",
	["Wreck of the Vanguard"] = "先锋号船骸",
	["Writhing Mound"] = "痛苦之丘",
	Writhingwood = "盘绕古木",
	["Wu-Song Village"] = "武松村",
	Wyrmbog = "巨龙沼泽",
	["Wyrmbreaker's Rookery"] = "碎龙者的孵化间",
	["Wyrmrest Summit"] = "龙眠神殿顶层",
	["Wyrmrest Temple"] = "龙眠神殿",
	-- ["Wyrmrest Temple - bottom to middle"] = "",
	-- ["Wyrmrest Temple - bottom to top"] = "",
	-- ["Wyrmrest Temple - middle to bottom"] = "",
	-- ["Wyrmrest Temple - middle to top"] = "",
	-- ["Wyrmrest Temple - top to bottom"] = "",
	-- ["Wyrmrest Temple - top to middle"] = "",
	["Wyrms' Bend"] = "巨龙曲径",
	["Wyrmscar Island"] = "龙痕岛",
	["Wyrmskull Bridge"] = "龙颅之桥",
	["Wyrmskull Tunnel"] = "龙颅小径",
	["Wyrmskull Village"] = "龙颅村",
	["X-2 Pincer"] = "扳钳X-2号",
	Xavian = "萨维亚",
	["Yan-Zhe River"] = "炎子江",
	["Yeti Mountain Basecamp"] = "雪人山营地",
	["Yinying Village"] = "银影村",
	Ymirheim = "伊米海姆",
	["Ymiron's Seat"] = "伊米隆之座",
	["Yojamba Isle"] = "尤亚姆巴岛",
	["Yowler's Den"] = "犹勒之巢",
	["Zabra'jin"] = "萨布拉金",
	["Zaetar's Choice"] = "扎尔塔的选择",
	["Zaetar's Grave"] = "扎尔塔之墓",
	["Zalashji's Den"] = "萨拉辛之穴",
	["Zalazane's Fall"] = "扎拉赞恩之墓",
	["Zane's Eye Crater"] = "赞恩之眼",
	Zangarmarsh = "赞加沼泽",
	["Zangar Ridge"] = "赞加山",
	["Zan'vess"] = "扎尼维斯",
	["Za'Tual"] = "赞图尔",
	["Zeb'Halak"] = "塞布哈拉克",
	["Zeb'Nowa"] = "塞布努瓦",
	["Zeb'Sora"] = "塞布索雷",
	["Zeb'Tela"] = "塞布提拉",
	["Zeb'tula"] = "赞布图拉",
	["Zeb'Watha"] = "塞布瓦萨",
	["Zeppelin Crash"] = "飞艇坠毁点",
	Zeramas = "泽尔拉玛斯",
	["Zeth'Gor"] = "塞斯高",
	["Zhu Province"] = "朱家界",
	["Zhu's Descent"] = "朱家洼地",
	["Zhu's Watch"] = "朱家堡",
	["Ziata'jai Ruins"] = "赞塔加废墟",
	["Zim'Abwa"] = "希姆埃巴",
	["Zim'bo's Hideout"] = "希姆波的藏身处",
	["Zim'Rhuk"] = "希姆鲁克",
	["Zim'Torga"] = "希姆托加",
	["Zol'Heb"] = "佐尔赫布",
	["Zol'Maz Stronghold"] = "佐尔玛兹要塞",
	["Zoram'gar Outpost"] = "佐拉姆加前哨站",
	["Zouchin Province"] = "卓金界",
	["Zouchin Strand"] = "卓金海滩",
	["Zouchin Village"] = "卓金村",
	["Zul'Aman"] = "祖阿曼",
	["Zul'Drak"] = "祖达克",
	["Zul'Farrak"] = "祖尔法拉克",
	["Zul'Farrak Entrance"] = "祖尔法拉克入口",
	["Zul'Gurub"] = "祖尔格拉布",
	["Zul'Mashar"] = "祖玛沙尔",
	["Zun'watha"] = "祖瓦沙",
	["Zuuldaia Ruins"] = "祖丹亚废墟",
}

elseif GAME_LOCALE == "zhTW" then
	lib:SetCurrentTranslations 
{
	["7th Legion Base Camp"] = "第七軍團營地",
	["7th Legion Front"] = "第七軍團前線",
	["7th Legion Submarine"] = "第七軍團潛水艇",
	["Abandoned Armory"] = "被遺棄的軍械庫",
	["Abandoned Camp"] = "廢棄營地",
	["Abandoned Mine"] = "棄置礦坑",
	["Abandoned Reef"] = "廢棄的暗礁",
	["Above the Frozen Sea"] = "冰凍之海上方",
	["A Brewing Storm"] = "雷電佳釀",
	["Abyssal Breach"] = "深淵止境",
	["Abyssal Depths"] = "地獄深淵",
	["Abyssal Halls"] = "深淵大廳",
	["Abyssal Maw"] = "深淵之喉",
	["Abyssal Maw Exterior"] = "深淵之喉外部",
	["Abyssal Sands"] = "深沙平原",
	["Abyssion's Lair"] = "艾碧希翁的巢穴",
	["Access Shaft Zeon"] = "礦井之路通道",
	["Acherus: The Ebon Hold"] = "亞榭洛:黯黑堡",
	["Addle's Stead"] = "腐草農場",
	["Aderic's Repose"] = "艾德瑞克之憩",
	["Aerie Peak"] = "鷹巢山",
	["Aeris Landing"] = "艾瑞斯平臺",
	["Agamand Family Crypt"] = "阿加曼德家族墓穴",
	["Agamand Mills"] = "阿加曼德磨坊",
	["Agmar's Hammer"] = "阿格瑪之錘",
	["Agmond's End"] = "埃格蒙德的營地",
	["Agol'watha"] = "亞戈瓦薩",
	["A Hero's Welcome"] = "英雄光臨",
	["Ahn'kahet: The Old Kingdom"] = "安卡罕特:古王國",
	["Ahn'kahet: The Old Kingdom Entrance"] = "安卡罕特:古王國入口",
	["Ahn Qiraj"] = "安其拉",
	["Ahn'Qiraj"] = "安其拉",
	["Ahn'Qiraj Temple"] = "安其拉神廟",
	["Ahn'Qiraj Terrace"] = "安其拉殿堂",
	["Ahn'Qiraj: The Fallen Kingdom"] = "安其拉: 沒落的王朝",
	["Akhenet Fields"] = "雅奇涅特原野",
	["Aku'mai's Lair"] = "阿庫麥爾的巢穴",
	["Alabaster Shelf"] = "雪白岩架",
	["Alcaz Island"] = "奧卡茲島",
	["Aldor Rise"] = "奧多爾高地",
	Aldrassil = "奧達希爾",
	["Aldur'thar: The Desolation Gate"] = "奧多薩:荒寂之門",
	["Alexston Farmstead"] = "艾力克斯頓農莊",
	["Algaz Gate"] = "奧加茲隘口",
	["Algaz Station"] = "奧加茲崗哨",
	["A Little Patience"] = "耐心試煉",
	["Allen Farmstead"] = "艾倫農莊",
	["Allerian Post"] = "艾蘭里哨站",
	["Allerian Stronghold"] = "艾蘭里堡壘",
	["Alliance Base"] = "聯盟營地",
	["Alliance Beach Daily Area"] = "聯盟海灘每日任務區域",
	["Alliance Beachhead"] = "聯盟灘頭",
	["Alliance Hub - Mogu Island Progression Scenario"] = "聯盟中心 - 魔古島發展事件",
	["Alliance Keep"] = "聯盟要塞",
	["Alliance Mercenary Ship to Vashj'ir"] = "前往瓦許伊爾的聯盟傭兵船隻",
	["Alliance PVP Barracks"] = "聯盟PVP兵營",
	["All That Glitters Prospecting Co."] = "亮晶晶探勘公司",
	["Alonsus Chapel"] = "阿隆索斯教堂",
	["Altar of Ascension"] = "飛升祭壇",
	["Altar of Har'koa"] = "哈寇亞祭壇",
	["Altar of Mam'toth"] = "瑪姆托司祭壇",
	["Altar of Quetz'lun"] = "奎茲倫祭壇",
	["Altar of Rhunok"] = "魯諾克祭壇",
	["Altar of Sha'tar"] = "薩塔祭壇",
	["Altar of Sseratus"] = "司瑟拉圖斯祭壇",
	["Altar of Storms"] = "暴風祭壇",
	["Altar of the Blood God"] = "血神祭壇",
	["Altar of Twilight"] = "暮光祭壇",
	["Alterac Mountains"] = "奧特蘭克山脈",
	["Alterac Valley"] = "奧特蘭克山谷",
	["Alther's Mill"] = "奧瑟爾伐木場",
	["Amani Catacombs"] = "阿曼尼地下墓穴",
	["Amani Mountains"] = "阿曼尼山脈",
	["Amani Pass"] = "阿曼尼小徑",
	["Amberfly Bog"] = "琥珀飛蠅泥沼",
	["Amberglow Hollow"] = "珀光洞穴",
	["Amber Ledge"] = "琥珀岩臺",
	Ambermarsh = "琥珀沼澤",
	Ambermill = "安伯米爾",
	["Amberpine Lodge"] = "琥珀松小屋",
	["Amber Quarry"] = "琥珀礦場",
	["Amber Research Sanctum"] = "琥珀研究聖所",
	["Ambershard Cavern"] = "琥珀裂片洞穴",
	["Amberstill Ranch"] = "凍石農場",
	["Amberweb Pass"] = "琥珀網小徑",
	["Ameth'Aran"] = "亞米薩蘭",
	["Ammen Fields"] = "安曼原野",
	["Ammen Ford"] = "安曼淺灘",
	["Ammen Vale"] = "安曼谷",
	["Amphitheater of Anguish"] = "苦痛露天競技場",
	["Ampitheater of Anguish"] = "苦痛露天競技場",
	["Ancestral Grounds"] = "先祖之地",
	["Ancestral Rise"] = "先祖高地",
	["Ancient Courtyard"] = "古庭",
	["Ancient Zul'Gurub"] = "古祖爾格拉布",
	["An'daroth"] = "安都拉斯",
	["Andilien Estate"] = "安狄里安莊園",
	Andorhal = "安多哈爾",
	Andruk = "安德魯克",
	["Angerfang Encampment"] = "怒牙營地",
	["Angkhal Pavilion"] = "安格寇亭閣",
	["Anglers Expedition"] = "釣手遠征隊",
	["Anglers Wharf"] = "釣手泊船處",
	["Angor Fortress"] = "苦痛堡壘",
	["Ango'rosh Grounds"] = "安格拉斯營地",
	["Ango'rosh Stronghold"] = "安格拉斯要塞",
	["Angrathar the Wrathgate"] = "『憤怒之門』安格拉薩",
	["Angrathar the Wrath Gate"] = "『憤怒之門』安格拉薩",
	["An'owyn"] = "安歐恩",
	["An'telas"] = "安泰拉斯",
	["Antonidas Memorial"] = "安東尼達斯紀念碑",
	Anvilmar = "安威瑪",
	["Anvil of Conflagration"] = "焚焰鐵砧",
	["Apex Point"] = "頂尖崗哨",
	["Apocryphan's Rest"] = "聖者之陵",
	["Apothecary Camp"] = "藥劑師營地",
	["Applebloom Tavern"] = "蘋卉客棧",
	["Arathi Basin"] = "阿拉希盆地",
	["Arathi Highlands"] = "阿拉希高地",
	["Arcane Pinnacle"] = "秘法之巔",
	["Archmage Vargoth's Retreat"] = "大法師瓦戈斯居所",
	["Area 52"] = "52區",
	["Arena Floor"] = "競技場地面",
	["Arena of Annihilation"] = "殲滅競技場",
	["Argent Pavilion"] = "銀白亭閣",
	["Argent Stand"] = "銀白看臺",
	["Argent Tournament Grounds"] = "銀白聯賽場地",
	["Argent Vanguard"] = "銀白先鋒駐地",
	["Ariden's Camp"] = "埃瑞丁營地",
	["Arikara's Needle"] = "阿利卡拉尖岩",
	["Arklonis Ridge"] = "阿卡隆斯山脊",
	["Arklon Ruins"] = "阿克隆廢墟",
	["Arriga Footbridge"] = "艾瑞加之橋",
	["Arsad Trade Post"] = "阿爾沙德交易站",
	["Ascendant's Rise"] = "卓越者高崗",
	["Ascent of Swirling Winds"] = "旋風坡",
	["Ashen Fields"] = "灰燼之地",
	["Ashen Lake"] = "梣湖",
	Ashenvale = "梣谷",
	["Ashwood Lake"] = "灰木湖",
	["Ashwood Post"] = "灰木崗哨",
	["Aspen Grove Post"] = "白楊崗哨",
	["Assault on Shaol'mara"] = "襲擊韶嘛喇",
	["Assault on Zan'vess"] = "襲擊贊斐斯",
	["Assault on Zeb'tula"] = "襲擊札布圖拉",
	Astranaar = "阿斯特蘭納",
	["Ata'mal Terrace"] = "阿塔莫露臺",
	Athenaeum = "圖書館",
	["Atrium of the Heart"] = "心之前庭",
	["Atulhet's Tomb"] = "阿圖爾西特之墓",
	["Auberdine Refugee Camp"] = "奧伯丁難民營",
	["Auburn Bluffs"] = "赤褐崖",
	["Auchenai Crypts"] = "奧奇奈地穴",
	["Auchenai Grounds"] = "奧奇奈營地",
	Auchindoun = "奧齊頓",
	["Auchindoun: Auchenai Crypts"] = "奧齊頓:奧奇奈地穴",
	["Auchindoun - Auchenai Crypts Entrance"] = "奧齊頓 - 奧奇奈地穴入口",
	["Auchindoun: Mana-Tombs"] = "奧齊頓:法力之墓",
	["Auchindoun - Mana-Tombs Entrance"] = "奧齊頓 - 法力墓穴入口",
	["Auchindoun: Sethekk Halls"] = "奧齊頓:塞司克大廳",
	["Auchindoun - Sethekk Halls Entrance"] = "奧齊頓 - 塞司克大廳入口",
	["Auchindoun: Shadow Labyrinth"] = "奧齊頓:暗影迷宮",
	["Auchindoun - Shadow Labyrinth Entrance"] = "奧齊頓 - 暗影迷宮入口",
	["Auren Falls"] = "奧倫瀑布",
	["Auren Ridge"] = "奧倫山脊",
	["Autumnshade Ridge"] = "秋蔭山脊",
	["Avalanchion's Vault"] = "阿瓦蘭奇奧穹殿",
	Aviary = "禽舍",
	["Axis of Alignment"] = "化合之軸",
	Axxarien = "艾克薩瑞安",
	["Azjol-Nerub"] = "阿茲歐-奈幽",
	["Azjol-Nerub Entrance"] = "阿茲歐-奈幽入口",
	Azshara = "艾薩拉",
	["Azshara Crater"] = "艾薩拉盆地",
	["Azshara's Palace"] = "艾薩拉的皇宮",
	["Azurebreeze Coast"] = "蔚藍海岸",
	["Azure Dragonshrine"] = "蒼藍龍殿",
	["Azurelode Mine"] = "碧玉礦坑",
	["Azuremyst Isle"] = "藍謎島",
	["Azure Watch"] = "藍色守望",
	["Backbreaker Bay"] = "斷脊海灣",
	Badlands = "荒蕪之地",
	["Bael'dun Digsite"] = "巴爾丹挖掘場",
	["Bael'dun Keep"] = "巴爾丹城堡",
	["Baelgun's Excavation Site"] = "巴爾古恩挖掘場",
	["Bael Modan"] = "巴爾莫丹",
	["Bael Modan Excavation"] = "巴爾莫丹挖掘場",
	["Bahrum's Post"] = "巴盧姆崗哨",
	["Balargarde Fortress"] = "巴拉加德堡壘",
	Baleheim = "貝爾海姆",
	["Balejar Watch"] = "貝爾亞守望",
	["Balia'mah Ruins"] = "巴里亞曼廢墟",
	["Bal'lal Ruins"] = "巴拉爾廢墟",
	["Balnir Farmstead"] = "巴尼爾農莊",
	Bambala = "班姆巴拉",
	["Band of Acceleration"] = "加速之環",
	["Band of Alignment"] = "化合之環",
	["Band of Transmutation"] = "轉化之環",
	["Band of Variance"] = "變化之環",
	["Ban'ethil Barrow Den"] = "班奈希爾獸穴",
	["Ban'ethil Barrow Descent"] = "班奈希爾獸穴斜坡",
	["Ban'ethil Hollow"] = "班尼希爾谷地",
	Bank = "銀行",
	["Banquet Grounds"] = "筵席場地",
	["Ban'Thallow Barrow Den"] = "班薩羅獸穴",
	["Baradin Base Camp"] = "巴拉丁營地",
	["Baradin Bay"] = "巴拉丁海灣",
	["Baradin Hold"] = "巴拉丁堡",
	Barbershop = "美容沙龍",
	["Barov Family Vault"] = "巴羅夫家族寶庫",
	["Bashal'Aran"] = "巴莎蘭",
	["Bashal'Aran Collapse"] = "巴莎蘭崩陷",
	["Bash'ir Landing"] = "貝許爾平臺",
	["Bastion Antechamber"] = "堡壘前廳",
	["Bathran's Haunt"] = "巴斯蘭鬼屋",
	["Battlefront Provisions"] = "前線補給",
	["Battle on the High Seas"] = "怒海之戰",
	["Battle Ring"] = "競技場",
	Battlescar = "戰痕",
	["Battlescar Spire"] = "戰痕尖塔",
	["Battlescar Valley"] = "戰痕山谷",
	["Bay of Echoes"] = "回聲海灣",
	["Bay of Storms"] = "風暴海灣",
	["Bear's Head"] = "熊頭",
	["Beauty's Lair"] = "美麗的巢穴",
	["Beeble's Wreck"] = "嗶啵的墜毀點",
	["Beezil's Wreck"] = "比吉爾的飛艇殘骸",
	["Befouled Terrace"] = "玷污殿堂",
	["Beggar's Haunt"] = "乞丐鬼屋",
	["Beneath The Double Rainbow"] = "雙虹號之下",
	["Beneath the Pit"] = "深淵之底",
	["Beren's Peril"] = "博倫的巢穴",
	["Bernau's Happy Fun Land"] = "博諾的快樂之地",
	["Beryl Coast"] = "碧晶海岸",
	["Beryl Egress"] = "綠寶石洞口",
	["Beryl Point"] = "碧晶哨點",
	["Beth'mora Ridge"] = "貝斯摩拉山",
	["Beth'tilac's Lair"] = "貝絲堤拉克巢穴",
	["Biel'aran Ridge"] = "畢耶拉蘭山脊",
	["Big Beach Brew Bash"] = "大海灘釀酒攻擊",
	["Big Blossom Excavation"] = "繁花挖掘場",
	["Big Blossom Mine"] = "繁花礦坑",
	["Bilgewater Beach"] = "污水灘",
	["Bilgewater Harbor"] = "污水碼頭",
	["Bilgewater Lumber Yard"] = "污水伐木場",
	["Bilgewater Port"] = "污水港",
	["Binan Brew & Stew"] = "濱南酒館",
	["Binan Village"] = "濱南村",
	["Bitter Reaches"] = "痛苦海岸",
	["Bittertide Lake"] = "惡潮湖",
	["Bizmo's Brawlpub"] = "畢茲摩鬥陣俱樂部",
	["Black Channel Marsh"] = "黑水沼澤",
	["Blackchar Cave"] = "黑炭谷",
	["Black Drake Roost"] = "黑龍棲息處",
	["Blackfathom Camp"] = "黑澗營地",
	["Blackfathom Deeps"] = "黑澗深淵",
	["Blackfathom Deeps Entrance"] = "黑澗深淵入口",
	["Blackhoof Village"] = "黑蹄村",
	["Blackhorn's Penance"] = "黑角之贖",
	["Blackmaw Hold"] = "黑喉要塞",
	["Black Ox Temple"] = "玄牛寺",
	["Blackriver Logging Camp"] = "黑河伐木營地",
	["Blackrock Caverns"] = "黑石洞穴",
	["Blackrock Caverns Entrance"] = "黑石洞穴入口",
	["Blackrock Depths"] = "黑石深淵",
	["Blackrock Depths Entrance"] = "黑石深淵入口",
	["Blackrock Mountain"] = "黑石山",
	["Blackrock Pass"] = "黑石小徑",
	["Blackrock Spire"] = "黑石塔",
	["Blackrock Spire Entrance"] = "黑石塔入口",
	["Blackrock Stadium"] = "黑石競技場",
	["Blackrock Stronghold"] = "黑石要塞",
	["Blacksand Spillway"] = "黑沙疏洪道",
	["Blacksilt Shore"] = "黑泥沙海岸",
	Blacksmith = "鐵匠舖",
	["Blackstone Span"] = "黑石大橋",
	["Black Temple"] = "黑暗神廟",
	["Black Tooth Hovel"] = "黑齒小屋",
	Blackwatch = "黑色守望",
	["Blackwater Cove"] = "黑水灣",
	["Blackwater Shipwrecks"] = "黑水灣沉船",
	["Blackwind Lake"] = "黑風湖",
	["Blackwind Landing"] = "黑風平臺",
	["Blackwind Valley"] = "黑風谷",
	["Blackwing Coven"] = "黑翼集會所",
	["Blackwing Descent"] = "黑翼陷窟",
	["Blackwing Lair"] = "黑翼之巢",
	["Blackwolf River"] = "黑狼河",
	["Blackwood Camp"] = "黑木營地",
	["Blackwood Den"] = "黑木洞穴",
	["Blackwood Lake"] = "黑木湖",
	["Bladed Gulch"] = "刀刃峽谷",
	["Bladefist Bay"] = "刃拳海灣",
	["Bladelord's Retreat"] = "刃王居所",
	["Blades & Axes"] = "刀刃與斧頭",
	["Blade's Edge Arena"] = "劍刃競技場",
	["Blade's Edge Mountains"] = "劍刃山脈",
	["Bladespire Grounds"] = "劍刃庭園",
	["Bladespire Hold"] = "劍刃要塞",
	["Bladespire Outpost"] = "劍刃崗哨",
	["Blades' Run"] = "劍之小道",
	["Blade Tooth Canyon"] = "劍齒峽谷",
	Bladewood = "劍木林",
	["Blasted Lands"] = "詛咒之地",
	["Bleak Hollow"] = "淒荒裂谷",
	["Bleeding Hollow Ruins"] = "血之谷廢墟",
	["Bleeding Vale"] = "浴血谷",
	["Bleeding Ziggurat"] = "血色通靈塔",
	["Blistering Pool"] = "極熱之池",
	["Bloodcurse Isle"] = "血咒島",
	["Blood Elf Tower"] = "血精靈哨塔",
	["Bloodfen Burrow"] = "血沼墓穴",
	Bloodgulch = "鮮血峽谷",
	["Bloodhoof Village"] = "血蹄村",
	["Bloodied Crossing"] = "染血路口",
	["Blood in the Snow"] = "血染滄雪",
	["Bloodmaul Camp"] = "血槌營地",
	["Bloodmaul Outpost"] = "血槌前哨站",
	["Bloodmaul Ravine"] = "血槌深谷",
	["Bloodmoon Isle"] = "血月島",
	["Bloodmyst Isle"] = "血謎島",
	["Bloodscale Enclave"] = "血鱗領地",
	["Bloodscale Grounds"] = "血鱗營地",
	["Bloodspore Plains"] = "血孢平原",
	["Bloodtalon Shore"] = "血爪海岸",
	["Bloodtooth Camp"] = "血牙營地",
	["Bloodvenom Falls"] = "血毒瀑布",
	["Bloodvenom Post"] = "血毒河",
	["Bloodvenom Post "] = "血毒崗哨",
	["Bloodvenom River"] = "血毒河",
	["Bloodwash Cavern"] = "血浴洞穴",
	["Bloodwash Fighting Pits"] = "血浴鬥坑",
	["Bloodwash Shrine"] = "血浴聖壇",
	["Blood Watch"] = "血色守望",
	["Bloodwatcher Point"] = "血腥看守者之尖",
	Bluefen = "藍色沼地",
	["Bluegill Marsh"] = "藍鰓沼澤",
	["Blue Sky Logging Grounds"] = "藍天伐木地",
	["Bluff of the South Wind"] = "南風崖",
	["Bogen's Ledge"] = "伯根的棚屋",
	Bogpaddle = "沼槳",
	["Boha'mu Ruins"] = "波哈姆廢墟",
	["Bolgan's Hole"] = "波爾甘的洞穴",
	["Bolyun's Camp"] = "波爾溫營地",
	["Bonechewer Ruins"] = "噬骨者廢墟",
	["Bonesnap's Camp"] = "斷骨營地",
	["Bones of Grakkarond"] = "格拉卡隆之骨",
	["Bootlegger Outpost"] = "私酒商哨站",
	["Booty Bay"] = "藏寶海灣",
	["Borean Tundra"] = "北風凍原",
	["Bor'gorok Outpost"] = "博格洛克前哨",
	["Bor's Breath"] = "伯爾之息",
	["Bor's Breath River"] = "伯爾之息河谷",
	["Bor's Fall"] = "伯爾瀑布",
	["Bor's Fury"] = "博爾之怒",
	["Borune Ruins"] = "伯盧恩廢墟",
	["Bough Shadow"] = "大樹蔭",
	["Bouldercrag's Refuge"] = "石崖避難所",
	["Boulderfist Hall"] = "石拳大廳",
	["Boulderfist Outpost"] = "石拳崗哨",
	["Boulder'gor"] = "博多戈爾",
	["Boulder Hills"] = "巨礫之丘",
	["Boulder Lode Mine"] = "石礦坑",
	["Boulder'mok"] = "圓面之地",
	["Boulderslide Cavern"] = "滾岩洞穴",
	["Boulderslide Ravine"] = "滾岩峽谷",
	["Bozzle's Wreck"] = "波索的墜毀點",
	["Brackenwall Village"] = "蕨牆村",
	["Brackwell Pumpkin Patch"] = "布萊克威爾南瓜田",
	["Brambleblade Ravine"] = "刺刃峽谷",
	Bramblescar = "棘痕平原",
	["Brann's Base-Camp"] = "布萊恩營地",
	["Brashtide Attack Fleet"] = "驟潮攻擊艦隊",
	["Brashtide Attack Fleet (Force Outdoors)"] = "驟潮攻擊艦隊(戶外部隊)",
	["Brave Wind Mesa"] = "強風台地",
	["Brawl'gar Arena"] = "鬥陣競技場",
	["Brazie Farmstead"] = "布瑞奇農莊",
	["Brewmoon Festival"] = "酒月節",
	["Brewnall Village"] = "烈酒村",
	["Bridge of Souls"] = "靈魂大橋",
	["Brightwater Lake"] = "澈水湖",
	["Brightwood Grove"] = "亮木樹林",
	Brill = "布瑞爾",
	["Brill Town Hall"] = "布瑞爾城鎮大廳",
	["Bristlelimb Enclave"] = "鬚肢營地",
	["Bristlelimb Village"] = "鬚肢村",
	["Broken Commons"] = "平民區廢墟",
	["Broken Hill"] = "破碎之丘",
	["Broken Pillar"] = "破碎石柱",
	["Broken Spear Village"] = "斷矛村",
	["Broken Wilds"] = "破碎荒野",
	["Broketooth Outpost"] = "斷齒哨站",
	["Bronzebeard Encampment"] = "銅鬚營地",
	["Bronze Dragonshrine"] = "青銅龍殿",
	["Browman Mill"] = "布洛米爾",
	["Brunnhildar Village"] = "布倫希爾達村",
	["Bucklebree Farm"] = "巴克布雷農場",
	["Budd's Dig"] = "霸德挖掘場",
	["Burning Blade Coven"] = "燃刃集會所",
	["Burning Blade Ruins"] = "燃刃廢墟",
	["Burning Steppes"] = "燃燒平原",
	["Butcher's Sanctum"] = "屠宰室",
	["Butcher's Stand"] = "屠夫之台",
	["Caer Darrow"] = "凱爾達隆",
	["Caldemere Lake"] = "凱德米爾湖",
	["Calston Estate"] = "考斯頓莊園",
	["Camp Aparaje"] = "阿帕拉耶營地",
	["Camp Ataya"] = "阿塔亞營地",
	["Camp Boff"] = "博夫營地",
	["Camp Broketooth"] = "斷齒營地",
	["Camp Cagg"] = "卡格營地",
	["Camp E'thok"] = "伊索克營地",
	["Camp Everstill"] = "止水營地",
	["Camp Gormal"] = "戈爾莫營地",
	["Camp Kosh"] = "柯什營地",
	["Camp Mojache"] = "莫沙徹營地",
	["Camp Mojache Longhouse"] = "莫沙徹營地長屋",
	["Camp Narache"] = "納拉其營地",
	["Camp Nooka Nooka"] = "努卡努卡營地",
	["Camp of Boom"] = "布姆營地",
	["Camp Onequah"] = "歐尼克瓦營地",
	["Camp Oneqwah"] = "歐尼克瓦營地",
	["Camp Sungraze"] = "日牧營地",
	["Camp Tunka'lo"] = "坦卡羅營地",
	["Camp Una'fe"] = "烏納非營地",
	["Camp Winterhoof"] = "冬蹄營地",
	["Camp Wurg"] = "瓦格營地",
	Canals = "運河",
	["Cannon's Inferno"] = "加農煉獄",
	["Cantrips & Crows"] = "咒語與烏鴉",
	["Cape of Lost Hope"] = "逝望角",
	["Cape of Stranglethorn"] = "荊棘谷海角",
	["Capital Gardens"] = "中心花園",
	["Carrion Hill"] = "腐蝕嶺",
	["Cartier & Co. Fine Jewelry"] = "卡地亞珠寶公司",
	Cataclysm = "浩劫與重生",
	["Cathedral of Darkness"] = "黑暗大教堂",
	["Cathedral of Light"] = "聖光大教堂",
	["Cathedral Quarter"] = "大教堂區",
	["Cathedral Square"] = "教堂廣場",
	["Cattail Lake"] = "香蒲湖",
	["Cauldros Isle"] = "科德洛斯島",
	["Cave of Mam'toth"] = "瑪姆托司洞穴",
	["Cave of Meditation"] = "冥思洞",
	["Cave of the Crane"] = "鶴之洞穴",
	["Cave of Words"] = "箴言之穴",
	["Cavern of Endless Echoes"] = "無盡回聲洞穴",
	["Cavern of Mists"] = "迷霧洞穴",
	["Caverns of Time"] = "時光之穴",
	["Celestial Enclave"] = "天尊宮",
	["Celestial Ridge"] = "天國山脈",
	["Cenarion Enclave"] = "塞納里奧區",
	["Cenarion Hold"] = "塞納里奧城堡",
	["Cenarion Post"] = "塞納里奧前哨",
	["Cenarion Refuge"] = "塞納里奧避難所",
	["Cenarion Thicket"] = "塞納里奧灌木林",
	["Cenarion Watchpost"] = "塞納里奧看守站",
	["Cenarion Wildlands"] = "塞納里奧曠野",
	["Central Bridge"] = "中央橋樑",
	["Chamber of Ancient Relics"] = "遠古聖物之間",
	["Chamber of Atonement"] = "懺悔之廳",
	["Chamber of Battle"] = "戰鬥之廳",
	["Chamber of Blood"] = "鮮血之廳",
	["Chamber of Command"] = "指揮之廳",
	["Chamber of Enchantment"] = "魔法之廳",
	["Chamber of Enlightenment"] = "啟迪之間",
	["Chamber of Fanatics"] = "狂熱者之室",
	["Chamber of Incineration"] = "焚化之廳",
	["Chamber of Masters"] = "師匠之間",
	["Chamber of Prophecy"] = "預言之廳",
	["Chamber of Reflection"] = "反省之間",
	["Chamber of Respite"] = "緩刑室",
	["Chamber of Summoning"] = "召喚之廳",
	["Chamber of Test Namesets"] = "測試名組大廳",
	["Chamber of the Aspects"] = "守護巨龍之間",
	["Chamber of the Dreamer"] = "沉睡者之廳",
	["Chamber of the Moon"] = "月之大廳",
	["Chamber of the Restless"] = "焦躁者之廳",
	["Chamber of the Stars"] = "眾星之間",
	["Chamber of the Sun"] = "日陽之間",
	["Chamber of Whispers"] = "輕語廳",
	["Chamber of Wisdom"] = "智慧之廳",
	["Champion's Hall"] = "勇士大廳",
	["Champions' Hall"] = "勇士大廳",
	["Chapel Gardens"] = "教堂花園",
	["Chapel of the Crimson Flame"] = "赤紅之焰禮拜堂",
	["Chapel Yard"] = "教堂庭院",
	["Charred Outpost"] = "焦炭哨站",
	["Charred Rise"] = "焦炭高崗",
	["Chill Breeze Valley"] = "寒風峽谷",
	["Chillmere Coast"] = "寒凜海岸",
	["Chillwind Camp"] = "冰風營地",
	["Chillwind Point"] = "冰風崗哨",
	Chiselgrip = "鑿柄",
	["Chittering Coast"] = "裂紋海岸",
	["Chow Farmstead"] = "周家莊",
	["Churning Gulch"] = "翻騰峽谷",
	["Circle of Blood"] = "血之環",
	["Circle of Blood Arena"] = "血之環競技場",
	["Circle of Bone"] = "白骨之環",
	["Circle of East Binding"] = "東部禁錮法陣",
	["Circle of Inner Binding"] = "內禁錮法陣",
	["Circle of Outer Binding"] = "外禁錮法陣",
	["Circle of Scale"] = "鱗之環",
	["Circle of Stone"] = "石之環",
	["Circle of Thorns"] = "荊棘之環",
	["Circle of West Binding"] = "西部禁錮法陣",
	["Circle of Wills"] = "意志之環",
	City = "城鎮",
	["City of Ironforge"] = "鐵爐堡",
	["City Siege - Mogu Island Progression Scenario"] = "圍城 - 魔古島發展事件",
	["Clan Watch"] = "氏族守望",
	["Class Quest"] = "職業任務",
	["Claytön's WoWEdit Land"] = "克雷頓的WoW編輯地",
	["Cleft of Shadow"] = "暗影裂口",
	["Cliffspring Falls"] = "壁泉瀑布",
	["Cliffspring Hollow"] = "壁泉瀑布",
	["Cliffspring River"] = "壁泉河",
	["Cliffwalker Post"] = "崖行者崗哨",
	["Cloudstrike Dojo"] = "雲擊道場",
	["Cloudtop Terrace"] = "雲端露臺",
	["Coast of Echoes"] = "回聲海岸",
	["Coast of Idols"] = "巨像海岸",
	["Coilfang Reservoir"] = "盤牙蓄湖",
	["Coilfang: Serpentshrine Cavern"] = "盤牙:毒蛇神殿洞穴",
	["Coilfang: The Slave Pens"] = "盤牙:奴隸監獄",
	["Coilfang - The Slave Pens Entrance"] = "盤牙 - 奴隸監獄入口",
	["Coilfang: The Steamvault"] = "盤牙:蒸汽洞窟",
	["Coilfang - The Steamvault Entrance"] = "盤牙 - 蒸汽洞窟入口",
	["Coilfang: The Underbog"] = "盤牙:深幽泥沼",
	["Coilfang - The Underbog Entrance"] = "盤牙 - 深幽泥沼入口",
	["Coilskar Cistern"] = "考斯卡水池",
	["Coilskar Point"] = "考斯卡崗哨",
	Coldarra = "凜懼島",
	["Coldarra Ledge"] = "凜懼島岩臺",
	["Coldbite Burrow"] = "冰蝕墓穴",
	["Cold Hearth Manor"] = "爐灰莊園",
	["Coldridge Pass"] = "寒脊山小徑",
	["Coldridge Valley"] = "寒脊山谷",
	["Coldrock Quarry"] = "冷岩礦場",
	["Coldtooth Mine"] = "冷齒礦坑",
	["Coldwind Heights"] = "冷風陵地",
	["Coldwind Pass"] = "冷風小徑",
	["Collin's Test"] = "科林的考驗",
	["Command Center"] = "指揮所",
	["Commons Hall"] = "平民大廳",
	["Condemned Halls"] = "死囚大廳",
	["Conqueror's Terrace"] = "征戍台",
	["Conquest Hold"] = "征服堡",
	["Containment Core"] = "阻礙中心",
	["Cooper Residence"] = "庫珀的住所",
	["Coral Garden"] = "珊瑚花園",
	["Cordell's Enchanting"] = "考迪爾附魔店",
	["Corin's Crossing"] = "考林路口",
	["Corp'rethar: The Horror Gate"] = "寇普雷薩:驚怖之門",
	["Corrahn's Dagger"] = "考蘭之匕",
	Cosmowrench = "扭曲太空",
	["Court of Bones"] = "白骨之廷",
	["Court of the Highborne"] = "精靈貴族庭院",
	["Court of the Sun"] = "陽光庭院",
	["Courtyard of Lights"] = "光明庭院",
	["Courtyard of the Ancients"] = "遠祖庭院",
	["Cradle of Chi-Ji"] = "赤吉搖籃",
	["Cradle of the Ancients"] = "先祖育床",
	["Craftsmen's Terrace"] = "工匠區",
	["Crag of the Everliving"] = "永生峭壁",
	["Cragpool Lake"] = "峭壁湖",
	["Crane Wing Refuge"] = "鶴翼避難所",
	["Crash Site"] = "失事地點",
	["Crescent Hall"] = "新月大廳",
	["Crimson Assembly Hall"] = "赤紅議事堂",
	["Crimson Expanse"] = "赤紅瀚洋",
	["Crimson Watch"] = "赤紅守望",
	Crossroads = "十字路口",
	["Crowley Orchard"] = "克羅雷果園",
	["Crowley Stable Grounds"] = "克羅雷馬廄營區",
	["Crown Guard Tower"] = "皇冠哨塔",
	["Crucible of Carnage"] = "兇殘之爐",
	["Crumbling Depths"] = "破碎深淵",
	["Crumbling Stones"] = "破碎石堆",
	["Crusader Forward Camp"] = "十字軍前進營地",
	["Crusader Outpost"] = "十字軍前哨",
	["Crusader's Armory"] = "十字軍軍械庫",
	["Crusader's Chapel"] = "十字軍禮拜堂",
	["Crusader's Landing"] = "十字軍臺地",
	["Crusader's Outpost"] = "十字軍前哨",
	["Crusaders' Pinnacle"] = "十字軍之巔",
	["Crusader's Run"] = "十字軍小徑",
	["Crusader's Spire"] = "十字軍尖塔",
	["Crusaders' Square"] = "十字軍廣場",
	Crushblow = "碎擊之地",
	["Crushcog's Arsenal"] = "碾輪兵工廠",
	["Crushridge Hold"] = "破碎嶺城堡",
	Crypt = "墓穴",
	["Crypt of Forgotten Kings"] = "遺忘諸王墓穴",
	["Crypt of Remembrance"] = "緬懷墓穴",
	["Crystal Lake"] = "水晶湖",
	["Crystalline Quarry"] = "結晶礦場",
	["Crystalsong Forest"] = "水晶之歌森林",
	["Crystal Spine"] = "水晶背脊",
	["Crystalvein Mine"] = "水晶礦坑",
	["Crystalweb Cavern"] = "晶網洞窟",
	CTF3 = "CTF3",
	["Curiosities & Moore"] = "不只是配件",
	["Cursed Depths"] = "詛咒深淵",
	["Cursed Hollow"] = "詛咒谷地",
	["Cut-Throat Alley"] = "割喉小巷",
	["Cyclone Summit"] = "颶風之巔",
	["Dabyrie's Farmstead"] = "達比雷農莊",
	["Daggercap Bay"] = "匕鞘海灣",
	["Daggerfen Village"] = "匕首沼地村",
	["Dagger in the Dark"] = "暗箭難防",
	["Daggermaw Canyon"] = "匕爪峽谷",
	["Dagger Pass"] = "匕首小徑",
	["Dais of Conquerors"] = "征服者之座",
	Dalaran = "達拉然",
	["Dalaran Arena"] = "達拉然競技場",
	["Dalaran City"] = "達拉然城",
	["Dalaran Crater"] = "達拉然陷坑",
	["Dalaran Floating Rocks"] = "達拉然漂浮岩",
	["Dalaran Island"] = "達拉然島",
	["Dalaran Merchant's Bank"] = "達拉然商業銀行",
	["Dalaran Sewers"] = "達拉然下水道",
	["Dalaran Visitor Center"] = "達拉然旅客中心",
	["Dalson's Farm"] = "達爾松農場",
	["Damplight Cavern"] = "霧光洞穴",
	["Damplight Chamber"] = "霧光之間",
	["Dampsoil Burrow"] = "濕土陷坑",
	["Dandred's Fold"] = "達倫德農場",
	["Dargath's Demise"] = "達加希的終點",
	["Darkbreak Cove"] = "黑裂灣",
	["Darkcloud Pinnacle"] = "暗雲峰",
	["Darkcrest Enclave"] = "暗羽營地",
	["Darkcrest Shore"] = "暗羽陸地",
	["Dark Heart of Pandaria"] = "潘達利亞的黑暗之心",
	["Dark Iron Highway"] = "黑鐵大道",
	["Darkmist Cavern"] = "暗霧洞穴",
	["Darkmist Ruins"] = "黑霧廢墟",
	["Darkmoon Boardwalk"] = "暗月木板道",
	["Darkmoon Deathmatch"] = "暗月死鬥場",
	["Darkmoon Deathmatch Pit (PH)"] = "暗月死鬥場",
	["Darkmoon Faire"] = "暗月馬戲團",
	["Darkmoon Island"] = "暗月島",
	["Darkmoon Island Cave"] = "暗月島洞穴",
	["Darkmoon Path"] = "暗月之徑",
	["Darkmoon Pavilion"] = "暗月亭閣",
	Darkshire = "夜色鎮",
	["Darkshire Town Hall"] = "夜色鎮大廳",
	Darkshore = "黑海岸",
	["Darkspear Hold"] = "暗矛要塞",
	["Darkspear Isle"] = "暗矛島",
	["Darkspear Shore"] = "暗矛海岸",
	["Darkspear Strand"] = "暗矛海灘",
	["Darkspear Training Grounds"] = "暗矛訓練場",
	["Darkwhisper Gorge"] = "暗語峽谷",
	["Darkwhisper Pass"] = "暗語小徑",
	["Darnassian Base Camp"] = "達納蘇斯營地",
	Darnassus = "達納蘇斯",
	["Darrow Hill"] = "達隆山",
	["Darrowmere Lake"] = "達隆米爾湖",
	Darrowshire = "達隆郡",
	["Darrowshire Hunting Grounds"] = "達隆郡狩獵場",
	["Darsok's Outpost"] = "達索克哨站",
	["Dawnchaser Retreat"] = "曦逐者居所",
	["Dawning Lane"] = "黎明小路",
	["Dawning Wood Catacombs"] = "黎明墓穴",
	["Dawnrise Expedition"] = "曦揚遠征隊",
	["Dawn's Blossom"] = "晨綻",
	["Dawnseeker Promontory"] = "曦尋者之岬",
	["Dawnseeker's Promontory"] = "曦尋者之岬",
	["Dawn's Reach"] = "黎明之境",
	["Dawnstar Spire"] = "晨星尖塔",
	["Dawnstar Village"] = "晨星村",
	["Daxil's Dig"] = "達西爾挖掘場",
	["D-Block"] = "D區",
	["Deadeye Shore"] = "亡眼海岸",
	["Deadman's Crossing"] = "亡者路口",
	["Dead Man's Hole"] = "亡者之穴",
	Deadmines = "死亡礦坑",
	["Deadtalker's Plateau"] = "死語者高地",
	["Deadwind Pass"] = "逆風小徑",
	["Deadwind Ravine"] = "逆風谷",
	["Deadwood Village"] = "死木村",
	["Deathbringer's Rise"] = "死亡使者高崗",
	["Death Cultist Base Camp"] = "死亡教徒營地",
	["Deathforge Tower"] = "死亡熔爐哨塔",
	Deathknell = "喪鐘鎮",
	["Deathmatch Pavilion"] = "死鬥場亭閣",
	Deatholme = "死亡之域",
	["Death's Breach"] = "死亡止境",
	["Death's Door"] = "死亡之門",
	["Death's Hand Encampment"] = "死亡之手駐營",
	["Deathspeaker's Watch"] = "亡頌者之望",
	["Death's Rise"] = "死亡高崗",
	["Death's Stand"] = "死亡看臺",
	["Death's Step"] = "死亡足音",
	["Death's Watch Waystation"] = "死亡看守小站",
	Deathwing = "死亡之翼",
	["Deathwing's Fall"] = "死翼之殞",
	["Deep Blue Observatory"] = "深藍觀測所",
	["Deep Elem Mine"] = "深埃連礦坑",
	["Deepfin Ridge"] = "深鰭山",
	Deepholm = "地深之源",
	["Deephome Ceiling"] = "地深之源屋頂",
	["Deepmist Grotto"] = "深霧岩洞",
	["Deeprun Tram"] = "礦道地鐵",
	["Deepwater Tavern"] = "深水旅店",
	["Deepwind Gorge"] = "深風峽谷",
	["Defense of the Alehouse"] = "酒館保衛戰",
	["Defense Of The Ale House BG"] = "酒館保衛戰戰場",
	["Defias Hideout"] = "迪菲亞盜賊巢穴",
	["Defiler's Den"] = "污染者之穴",
	["D.E.H.T.A. Encampment"] = "D.E.H.T.A.駐營",
	["Delete ME"] = "Delete ME",
	["Demon Fall Canyon"] = "屠魔峽谷",
	["Demon Fall Ridge"] = "屠魔山",
	["Demont's Place"] = "迪蒙特荒野",
	["Den of Defiance"] = "藐視之穴",
	["Den of Dying"] = "垂死獸穴",
	["Den of Haal'esh"] = "海艾斯洞穴",
	["Den of Iniquity"] = "極惡之穴",
	["Den of Mortal Delights"] = "凡慾邪窟",
	["Den of Sorrow"] = "悲愁洞府",
	["Den of Sseratus"] = "司瑟拉圖斯之穴",
	["Den of the Caller"] = "召喚者洞穴",
	["Den of the Devourer"] = "吞噬者洞穴",
	["Den of the Disciples"] = "侍徒藏匿處",
	["Den of the Unholy"] = "邪惡洞穴",
	["Derelict Caravan"] = "被遺棄的商隊",
	["Derelict Manor"] = "遺棄的莊園",
	["Derelict Strand"] = "遺棄水岸",
	["Designer Island"] = "設計者之島",
	Desolace = "淒涼之地",
	["Desolation Hold"] = "荒寂堡",
	["Detention Block"] = "禁閉室",
	["Development Land"] = "開發之地",
	["Diamondhead River"] = "鑽石河",
	["Diamond Island"] = "鑽石島",
	["Dig One"] = "一號挖掘場",
	["Dig Three"] = "三號挖掘場",
	["Dig Two"] = "二號挖掘場",
	["Direforge Hill"] = "厄爐嶺",
	["Direhorn Post"] = "恐角崗哨",
	["Dire Maul"] = "厄運之槌",
	["Dire Maul - Capital Gardens Entrance"] = "厄運之槌 - 中心花園入口",
	["Dire Maul - East"] = "厄運之槌 - 東方",
	["Dire Maul - Gordok Commons Entrance"] = "厄運之槌 - 戈多克平民區入口",
	["Dire Maul - North"] = "厄運之槌 - 北方",
	["Dire Maul - Warpwood Quarter Entrance"] = "厄運之槌 - 扭木廣場入口",
	["Dire Maul - West"] = "厄運之槌 - 西方",
	Diremoor = "厄運沼澤",
	["Dire Strait"] = "恐怖海峽",
	["Disciple's Enclave"] = "侍徒營地",
	Docks = "碼頭",
	["Dojani River"] = "朵迦河",
	Dolanaar = "多蘭納爾",
	["Dome Balrissa"] = "巴爾里莎圓頂",
	["Domination Point"] = "制霸岬",
	["Donna's Kitty Shack"] = "多娜的小貓樂園",
	["DO NOT USE"] = "DO NOT USE",
	["Dookin' Grounds"] = "猴屍地",
	["Doom's Vigil"] = "末日崗哨",
	["Dorian's Outpost"] = "多里安前哨",
	["Draco'dar"] = "德拉考達爾",
	["Draenei Ruins"] = "德萊尼廢墟",
	["Draenethyst Mine"] = "德萊尼礦坑",
	["Draenil'dur Village"] = "德萊尼村",
	Dragonblight = "龍骨荒野",
	["Dragonflayer Pens"] = "掠龍圍欄",
	["Dragonmaw Base Camp"] = "龍喉營地",
	["Dragonmaw Flag Room"] = "龍喉戰旗廳",
	["Dragonmaw Forge"] = "龍喉熔爐",
	["Dragonmaw Fortress"] = "龍喉堡壘",
	["Dragonmaw Garrison"] = "龍喉兵營",
	["Dragonmaw Gates"] = "龍喉大門",
	["Dragonmaw Pass"] = "龍喉小徑",
	["Dragonmaw Port"] = "龍喉港",
	["Dragonmaw Skyway"] = "龍喉航線",
	["Dragonmaw Stronghold"] = "龍喉要塞",
	["Dragons' End"] = "飛龍之末",
	["Dragon's Fall"] = "龍殞營地",
	["Dragon's Mouth"] = "龍之口",
	["Dragon Soul"] = "巨龍之魂",
	["Dragon Soul Raid - East Sarlac"] = "巨龍之魂團隊 - 什拉克",
	["Dragon Soul Raid - Wyrmrest Temple Base"] = "巨龍之魂團隊 - 龍眠神殿基地",
	["Dragonspine Peaks"] = "龍脊群山",
	["Dragonspine Ridge"] = "龍脊山脊",
	["Dragonspine Tributary"] = "龍脊支流",
	["Dragonspire Hall"] = "龍塔大廳",
	["Drak'Agal"] = "德拉克亞苟",
	["Draka's Fury"] = "德拉卡之怒",
	["Drak'atal Passage"] = "德拉克托通道",
	["Drakil'jin Ruins"] = "德拉齊金遺跡",
	["Drak'Mabwa"] = "德拉克瑪布瓦",
	["Drak'Mar Lake"] = "德拉克瑪湖",
	["Draknid Lair"] = "龍蛛之巢",
	["Drak'Sotra"] = "德拉克索璀",
	["Drak'Sotra Fields"] = "德拉克索璀原野",
	["Drak'Tharon Keep"] = "德拉克薩隆要塞",
	["Drak'Tharon Keep Entrance"] = "德拉克薩隆要塞入口",
	["Drak'Tharon Overlook"] = "德拉克薩隆瞰臺",
	["Drak'ural"] = "德拉克烏洛",
	["Dread Clutch"] = "恐怖窩巢",
	["Dread Expanse"] = "恐怖瀚洋",
	["Dreadmaul Furnace"] = "巨槌熔爐",
	["Dreadmaul Hold"] = "巨槌要塞",
	["Dreadmaul Post"] = "巨槌崗哨",
	["Dreadmaul Rock"] = "巨槌石",
	["Dreadmist Camp"] = "鬼霧營地",
	["Dreadmist Den"] = "鬼霧獸穴",
	["Dreadmist Peak"] = "鬼霧峰",
	["Dreadmurk Shore"] = "恐懼海岸",
	["Dread Terrace"] = "悚然露臺",
	["Dread Wastes"] = "悚然荒野",
	["Dreadwatch Outpost"] = "恐懼守望哨站",
	["Dream Bough"] = "夢境之樹",
	["Dreamer's Pavilion"] = "夢旅者亭閣",
	["Dreamer's Rest"] = "夢旅者之眠",
	["Dreamer's Rock"] = "美夢石",
	Drudgetown = "苦工鎮",
	["Drygulch Ravine"] = "枯水谷",
	["Drywhisker Gorge"] = "枯鬚峽谷",
	["Dubra'Jin"] = "杜布拉金",
	["Dun Algaz"] = "丹奧加茲",
	["Dun Argol"] = "丹亞戈",
	["Dun Baldar"] = "丹巴達爾",
	["Dun Baldar Pass"] = "丹巴達爾小徑",
	["Dun Baldar Tunnel"] = "丹巴達爾隧道",
	["Dunemaul Compound"] = "砂槌營地",
	["Dunemaul Recruitment Camp"] = "砂槌招募營地",
	["Dun Garok"] = "丹加洛克",
	["Dun Mandarr"] = "丹曼達爾",
	["Dun Modr"] = "丹莫德",
	["Dun Morogh"] = "丹莫洛",
	["Dun Niffelem"] = "丹尼弗蘭",
	["Dunwald Holdout"] = "登瓦德陣地",
	["Dunwald Hovel"] = "登瓦德小屋",
	["Dunwald Market Row"] = "登瓦德市場區",
	["Dunwald Ruins"] = "登瓦德廢墟",
	["Dunwald Town Square"] = "登瓦德城鎮廣場",
	["Durnholde Keep"] = "敦霍爾德城堡",
	Durotar = "杜洛塔",
	Duskhaven = "暮色港",
	["Duskhowl Den"] = "暮嚎之穴",
	["Dusklight Bridge"] = "夕光橋",
	["Dusklight Hollow"] = "夕光谷地",
	["Duskmist Shore"] = "暮霧海岸",
	["Duskroot Fen"] = "暮根沼地",
	["Duskwither Grounds"] = "暮萎營地",
	["Duskwither Spire"] = "暮萎尖塔",
	Duskwood = "暮色森林",
	["Dustback Gorge"] = "塵背峽谷",
	["Dustbelch Grotto"] = "火山洞穴",
	["Dustfire Valley"] = "塵火谷",
	["Dustquill Ravine"] = "塵羽峽谷",
	["Dustwallow Bay"] = "塵泥灣",
	["Dustwallow Marsh"] = "塵泥沼澤",
	["Dustwind Cave"] = "塵風洞穴",
	["Dustwind Dig"] = "塵風挖掘場",
	["Dustwind Gulch"] = "塵風峽谷",
	["Dwarven District"] = "矮人區",
	["Eagle's Eye"] = "雄鷹之眼",
	["Earthshatter Cavern"] = "碎地者洞窟",
	["Earth Song Falls"] = "地歌瀑布",
	["Earth Song Gate"] = "地歌之門",
	["Eastern Bridge"] = "東部橋樑",
	["Eastern Kingdoms"] = "東部王國",
	["Eastern Plaguelands"] = "東瘟疫之地",
	["Eastern Strand"] = "東部海灘",
	["East Garrison"] = "東部兵營",
	["Eastmoon Ruins"] = "東月廢墟",
	["East Pavilion"] = "東亭閣",
	["East Pillar"] = "東部石柱",
	["Eastpoint Tower"] = "東點哨塔",
	["East Sanctum"] = "東部聖所",
	["Eastspark Workshop"] = "東炫工坊",
	["East Spire"] = "東部尖塔",
	["East Supply Caravan"] = "東部補給營地",
	["Eastvale Logging Camp"] = "東谷伐木場",
	["Eastwall Gate"] = "東牆大門",
	["Eastwall Tower"] = "東牆之塔",
	["Eastwind Rest"] = "東風之眠",
	["Eastwind Shore"] = "東風水濱",
	["Ebon Hold"] = "黯黑堡",
	["Ebon Watch"] = "黯黑守望",
	["Echo Cove"] = "回音灣",
	["Echo Isles"] = "回音群島",
	["Echomok Cavern"] = "艾卡莫克洞穴",
	["Echo Reach"] = "回音之境",
	["Echo Ridge Mine"] = "回音山礦坑",
	["Eclipse Point"] = "日蝕崗哨",
	["Eclipsion Fields"] = "伊克利普森農場",
	["Eco-Dome Farfield"] = "秘境原野",
	["Eco-Dome Midrealm"] = "秘境領地",
	["Eco-Dome Skyperch"] = "秘境棲木",
	["Eco-Dome Sutheron"] = "桑什倫秘境",
	["Elder Rise"] = "長者高地",
	["Elders' Square"] = "長者廣場",
	["Eldreth Row"] = "艾德雷斯區",
	["Eldritch Heights"] = "異法陵地",
	["Elemental Plateau"] = "元素高原",
	["Elementium Depths"] = "源質深淵",
	Elevator = "升降梯",
	["Elrendar Crossing"] = "艾蘭達路口",
	["Elrendar Falls"] = "艾蘭達瀑布",
	["Elrendar River"] = "艾蘭達之河",
	["Elwynn Forest"] = "艾爾文森林",
	["Ember Clutch"] = "餘燼窩巢",
	Emberglade = "餘燼林地",
	["Ember Spear Tower"] = "餘燼矛塔",
	["Emberstone Mine"] = "燼石礦坑",
	["Emberstone Village"] = "燼石村",
	["Emberstrife's Den"] = "艾博斯塔夫的巢穴",
	["Emerald Dragonshrine"] = "翡翠龍殿",
	["Emerald Dream"] = "翡翠夢境",
	["Emerald Forest"] = "翠葉森林",
	["Emerald Sanctuary"] = "翡翠聖地",
	["Emperor Rikktik's Rest"] = "黎克堤大帝之眠",
	["Emperor's Omen"] = "帝王之兆",
	["Emperor's Reach"] = "帝王之境",
	["End Time"] = "終焉之刻",
	["Engineering Labs"] = "工程實驗室",
	["Engineering Labs "] = "工程實驗室",
	["Engine of Nalak'sha"] = "納拉卡煞引擎",
	["Engine of the Makers"] = "造物者動力核心",
	["Entryway of Time"] = "時光入口",
	["Ethel Rethor"] = "艾瑟雷索",
	["Ethereal Corridor"] = "以太迴廊",
	["Ethereum Staging Grounds"] = "以太皇族軍事要塞",
	["Evergreen Trading Post"] = "常青貿易站",
	Evergrove = "永恆樹林",
	Everlook = "永望鎮",
	["Eversong - Duskwither Teleport"] = "永歌 - 暗木傳送",
	["Eversong Woods"] = "永歌森林",
	["Excavation Center"] = "挖掘中心",
	["Excavation Lift"] = "挖掘升降梯",
	["Exclamation Point"] = "驚嘆頂",
	["Expedition Armory"] = "遠征隊軍械庫",
	["Expedition Base Camp"] = "遠征隊營地",
	["Expedition Point"] = "遠征隊哨塔",
	["Explorers' League Digsite"] = "探險者協會挖掘場",
	["Explorers' League Outpost"] = "探險者協會前哨",
	["Exposition Pavilion"] = "展覽會館",
	["Eye of Eternity"] = "永恆之眼",
	["Eye of the Storm"] = "暴風之眼",
	["Fairbreeze Village"] = "晴風村",
	["Fairbridge Strand"] = "美橋海岸",
	["Falcon Watch"] = "獵鷹哨站",
	["Falconwing Inn"] = "獵鷹之翼旅店",
	["Falconwing Square"] = "獵鷹之翼廣場",
	["Faldir's Cove"] = "法迪爾海灣",
	["Falfarren River"] = "弗倫河",
	["Fallen Sky Lake"] = "墜星湖",
	["Fallen Sky Ridge"] = "墜天山脈",
	["Fallen Temple of Ahn'kahet"] = "安卡罕特墮落神殿",
	["Fall of Return"] = "回歸之殞",
	["Fallowmere Inn"] = "法洛梅爾旅店",
	["Fallow Sanctuary"] = "農田避難所",
	["Falls of Ymiron"] = "依米倫瀑布",
	["Fallsong Village"] = "秋歌村",
	["Falthrien Academy"] = "法薩瑞安學院",
	Familiars = "魔寵們",
	["Faol's Rest"] = "法奧之墓",
	["Fargaze Mesa"] = "遠凝台地",
	["Fargodeep Mine"] = "法戈第礦坑",
	Farm = "農場",
	Farshire = "遠郡",
	["Farshire Fields"] = "遠郡原野",
	["Farshire Lighthouse"] = "遠郡燈塔",
	["Farshire Mine"] = "遠郡礦坑",
	["Farson Hold"] = "法森堡",
	["Farstrider Enclave"] = "旅行者營地",
	["Farstrider Lodge"] = "遠行者小屋",
	["Farstrider Retreat"] = "遠行者居所",
	["Farstriders' Enclave"] = "遠行者營地",
	["Farstriders' Square"] = "遠行者廣場",
	["Farwatcher's Glen"] = "遠眺者谷地",
	["Farwatch Overlook"] = "遠眺者瞰臺",
	["Far Watch Post"] = "前沿哨所",
	["Fear Clutch"] = "恐懼窩巢",
	["Featherbeard's Hovel"] = "羽鬚屋舍",
	Feathermoon = "羽月要塞",
	["Feathermoon Stronghold"] = "羽月要塞",
	["Fe-Feng Village"] = "非凡村",
	["Felfire Hill"] = "冥火嶺",
	["Felpaw Village"] = "魔爪村",
	["Fel Reaver Ruins"] = "惡魔劫奪者廢墟",
	["Fel Rock"] = "惡魔石",
	["Felspark Ravine"] = "魔焰深谷",
	["Felstone Field"] = "費爾斯通農場",
	Felwood = "費伍德森林",
	["Fenris Isle"] = "芬里斯島",
	["Fenris Keep"] = "芬里斯城堡",
	Feralas = "菲拉斯",
	["Feralfen Village"] = "菲拉芬村",
	["Feral Scar Vale"] = "深痕谷",
	["Festering Pools"] = "膿瘡之池",
	["Festival Lane"] = "節慶巷道",
	["Feth's Way"] = "費司之路",
	["Field of Korja"] = "廓亞平原",
	["Field of Strife"] = "征戰平原",
	["Fields of Blood"] = "鮮血草原",
	["Fields of Honor"] = "榮譽原野",
	["Fields of Niuzao"] = "怒兆原野",
	Filming = "薄霧之地",
	["Final Gate - Mogu Island Progression Scenario"] = "終末之門 - 魔古島發展事件",
	["Firebeard Cemetery"] = "火鬍墓園",
	["Firebeard's Patrol"] = "火鬍巡防地",
	["Firebough Nook"] = "火枝望角",
	["Fire Camp Bataar"] = "巴塔火焰營地",
	["Fire Camp Gai-Cho"] = "蓋州火焰營地",
	["Fire Camp Ordo"] = "歐朵火焰營地",
	["Fire Camp Osul"] = "歐索火焰營地",
	["Fire Camp Ruqin"] = "魯秦火焰營地",
	["Fire Camp Yongqi"] = "揚旗火焰營地",
	["Firegut Furnace"] = "火腹熔爐",
	Firelands = "火源之界",
	["Firelands Forgeworks"] = "火源之界鍛造區",
	["Firelands Hatchery"] = "火源之界孵化室",
	["Firelands Terrain 2"] = "火源之界地形2",
	["Fireplume Peak"] = "火羽峰",
	["Fire Plume Ridge"] = "火羽山",
	["Fireplume Trench"] = "火羽溝",
	["Fire Scar Shrine"] = "火痕神殿",
	["Fire Stone Mesa"] = "火石台地",
	["Firestone Point"] = "火石崗哨",
	["Firewatch Ridge"] = "觀火嶺",
	["Firewing Point"] = "火翼崗哨",
	["First Bank of Kezan"] = "凱贊第一銀行",
	["First Legion Forward Camp"] = "第一軍團前進營地",
	["First to Your Aid"] = "急救你優先",
	["Fishing Village"] = "釣魚村",
	["Fizzcrank Airstrip"] = "嘶軸簡易機場",
	["Fizzcrank Pumping Station"] = "嘶軸幫浦站",
	["Fizzle & Pozzik's Speedbarge"] = "菲茲爾與普茲克的高速駁船",
	["Fjorn's Anvil"] = "斐雍之砧",
	Flamebreach = "火焰裂層",
	["Flame Crest"] = "烈焰峰",
	["Flamestar Post"] = "燎星崗哨",
	["Flamewatch Tower"] = "焰望哨塔",
	["Flavor - Stormwind Harbor - Stop"] = "樣式 - 暴風港 - 終點",
	["Fleshrender's Workshop"] = "血肉撕裂者工坊",
	["Foothold Citadel"] = "據點城塞",
	["Footman's Armory"] = "步卒軍械庫",
	["Force Interior"] = "力場內部",
	["Fordragon Hold"] = "弗塔根堡",
	["Forest Heart"] = "森林之心",
	["Forest's Edge"] = "森林邊界",
	["Forest's Edge Post"] = "林邊崗哨",
	["Forest Song"] = "林歌神殿",
	["Forge Base: Gehenna"] = "熔爐基地:苦難",
	["Forge Base: Oblivion"] = "熔爐基地:遺忘",
	["Forge Camp: Anger"] = "煉冶場:怒氣",
	["Forge Camp: Fear"] = "煉冶場:恐懼",
	["Forge Camp: Hate"] = "煉冶場:仇恨",
	["Forge Camp: Mageddon"] = "煉冶場:黑色祭壇",
	["Forge Camp: Rage"] = "煉冶場:狂怒",
	["Forge Camp: Terror"] = "煉冶場:驚駭",
	["Forge Camp: Wrath"] = "煉冶場:憤怒",
	["Forge of Fate"] = "命運熔爐",
	["Forge of the Endless"] = "無盡熔爐",
	["Forgewright's Tomb"] = "鑄鐵之墓",
	["Forgotten Depths"] = "遺忘深淵",
	["Forgotten Hill"] = "遺忘之丘",
	["Forgotten Mire"] = "遺忘泥潭",
	["Forgotten Passageway"] = "被遺忘的密道",
	["Forlorn Cloister"] = "孤寂迴廊",
	["Forlorn Hut"] = "荒廢小屋",
	["Forlorn Ridge"] = "淒涼山",
	["Forlorn Rowe"] = "荒棄鬼屋",
	["Forlorn Spire"] = "荒棄尖塔",
	["Forlorn Woods"] = "凋落樹林",
	["Formation Grounds"] = "構築之地",
	["Forsaken Forward Command"] = "被遺忘者前線指揮營地",
	["Forsaken High Command"] = "被遺忘者高階指揮所",
	["Forsaken Rear Guard"] = "被遺忘者後衛部隊",
	["Fort Livingston"] = "李文斯頓堡壘",
	["Fort Silverback"] = "銀背堡壘",
	["Fort Triumph"] = "凱旋堡壘",
	["Fortune's Fist"] = "命運之拳",
	["Fort Wildervar"] = "威德瓦堡壘",
	["Forward Assault Camp"] = "前方攻擊營地",
	["Forward Command"] = "前線指揮營地",
	["Foulspore Cavern"] = "毒菇洞穴",
	["Foulspore Pools"] = "毒菇之池",
	["Fountain of the Everseeing"] = "恆望泉",
	["Fox Grove"] = "狐林",
	["Fractured Front"] = "崩裂的前線",
	["Frayfeather Highlands"] = "亂羽高地",
	["Fray Island"] = "勇士島",
	["Frazzlecraz Motherlode"] = "弗雷卓克雷茲母礦",
	["Freewind Post"] = "亂風崗",
	["Frenzyheart Hill"] = "狂心之丘",
	["Frenzyheart River"] = "狂心之河",
	["Frigid Breach"] = "嚴寒止境",
	["Frostblade Pass"] = "霜刃隘口",
	["Frostblade Peak"] = "霜刃峰",
	["Frostclaw Den"] = "霜爪獸穴",
	["Frost Dagger Pass"] = "霜刀小徑",
	["Frostfield Lake"] = "霜域湖",
	["Frostfire Hot Springs"] = "冰火溫泉",
	["Frostfloe Deep"] = "浮冰霜淵",
	["Frostgrip's Hollow"] = "霜握谷地",
	Frosthold = "霜堡",
	["Frosthowl Cavern"] = "霜嚎洞窟",
	["Frostmane Front"] = "霜鬃前線",
	["Frostmane Hold"] = "霜鬃要塞",
	["Frostmane Hovel"] = "霜鬃小屋",
	["Frostmane Retreat"] = "霜鬃居所",
	Frostmourne = "霜之哀傷",
	["Frostmourne Cavern"] = "霜之哀傷洞窟",
	["Frostsaber Rock"] = "霜刀石",
	["Frostwhisper Gorge"] = "霜語峽谷",
	["Frostwing Halls"] = "霜翼大廳",
	["Frostwolf Graveyard"] = "霜狼墓地",
	["Frostwolf Keep"] = "霜狼要塞",
	["Frostwolf Pass"] = "霜狼小徑",
	["Frostwolf Tunnel"] = "霜狼隧道",
	["Frostwolf Village"] = "霜狼村",
	["Frozen Reach"] = "冰凍之境",
	["Fungal Deep"] = "蘑菇縱谷",
	["Fungal Rock"] = "蘑菇石",
	["Funggor Cavern"] = "方格洞穴",
	["Furien's Post"] = "弗里安崗哨",
	["Furlbrow's Pumpkin Farm"] = "法布隆南瓜農場",
	["Furnace of Hate"] = "仇恨火爐",
	["Furywing's Perch"] = "狂怒之翼棲所",
	Fuselight = "熔絲火光山間營地",
	["Fuselight-by-the-Sea"] = "熔絲火光海邊營地",
	["Fu's Pond"] = "福池",
	Gadgetzan = "加基森",
	["Gahrron's Withering"] = "蓋羅恩農場",
	["Gai-Cho Battlefield"] = "蓋州戰場",
	["Galak Hold"] = "加拉克城堡",
	["Galakrond's Rest"] = "葛拉克朗安息地",
	["Galardell Valley"] = "加拉德爾山谷",
	["Galen's Fall"] = "加林之殞",
	["Galerek's Remorse"] = "加勒雷克之痛",
	["Galewatch Lighthouse"] = "颯望燈塔",
	["Gallery of Treasures"] = "珍寶陳列室",
	["Gallows' Corner"] = "絞刑場",
	["Gallows' End Tavern"] = "恐懼之末旅店",
	["Gallywix Docks"] = "加里維克斯碼頭",
	["Gallywix Labor Mine"] = "加里維克斯的勞工礦坑",
	["Gallywix Pleasure Palace"] = "加里維克斯歡樂宮殿",
	["Gallywix's Villa"] = "加里維克斯的別墅",
	["Gallywix's Yacht"] = "加里維克斯的遊艇",
	["Galus' Chamber"] = "加魯斯的房間",
	["Gamesman's Hall"] = "投機者大廳",
	Gammoth = "甘默斯",
	["Gao-Ran Battlefront"] = "高仁前線",
	Garadar = "卡拉達爾",
	["Gar'gol's Hovel"] = "加爾勾的小屋",
	Garm = "迦姆",
	["Garm's Bane"] = "迦姆之禍",
	["Garm's Rise"] = "迦姆高崗",
	["Garren's Haunt"] = "加倫鬼屋",
	["Garrison Armory"] = "要塞軍械庫",
	["Garrosh'ar Advance"] = "卡爾洛夏先遣營地",
	["Garrosh'ar Point"] = "卡爾洛夏海岬",
	["Garrosh's Landing"] = "卡爾洛斯臺地",
	["Garvan's Reef"] = "加爾文暗礁",
	["Gate of Echoes"] = "回聲之門",
	["Gate of Endless Spring"] = "豐泉之門",
	["Gate of Hamatep"] = "哈瑪泰普之門",
	["Gate of Lightning"] = "雷光之門",
	["Gate of the August Celestials"] = "聖獸天尊之門",
	["Gate of the Blue Sapphire"] = "藍晶之門",
	["Gate of the Green Emerald"] = "碧翠之門",
	["Gate of the Purple Amethyst"] = "紫晶之門",
	["Gate of the Red Sun"] = "紅日之門",
	["Gate of the Setting Sun"] = "落陽關",
	["Gate of the Yellow Moon"] = "黃月之門",
	["Gates of Ahn'Qiraj"] = "安其拉之門",
	["Gates of Ironforge"] = "鐵爐堡大門",
	["Gates of Sothann"] = "索桑恩之門",
	["Gauntlet of Flame"] = "火焰戰巷",
	["Gavin's Naze"] = "加文高地",
	["Geezle's Camp"] = "吉索的營地",
	["Gelkis Village"] = "吉爾吉斯村",
	["General Goods"] = "雜貨商",
	["General's Terrace"] = "將軍露臺",
	["Ghostblade Post"] = "鬼刃崗哨",
	Ghostlands = "鬼魂之地",
	["Ghost Walker Post"] = "鬼旅崗哨",
	["Giant's Run"] = "巨人奔印",
	["Giants' Run"] = "巨人小徑",
	["Gilded Fan"] = "金扇澤",
	["Gillijim's Isle"] = "吉利吉姆之島",
	["Gilnean Coast"] = "吉爾尼斯海岸",
	["Gilnean Stronghold"] = "吉爾尼斯要塞",
	Gilneas = "吉爾尼斯",
	Gilneas2 = "吉爾尼斯2",
	["Gilneas City"] = "吉爾尼斯城",
	["Gilneas (Do Not Reuse)"] = "吉爾尼斯(Do Not Reuse)",
	["Gilneas Liberation Front Base Camp"] = "吉爾尼斯解放戰線營地",
	GilneasPhase1 = "吉爾尼斯階段1",
	GilneasPhase2 = "吉爾尼斯階段2",
	["Gimorak's Den"] = "吉摩拉克獸穴",
	Gjalerbron = "夏勒布隆",
	Gjalerhorn = "夏勒宏恩",
	["Glacial Falls"] = "冰川瀑布",
	["Glimmer Bay"] = "微光海灣",
	["Glimmerdeep Gorge"] = "深光峽谷",
	["Glittering Strand"] = "閃耀水岸",
	["Glopgut's Hollow"] = "噁腸巨魔谷地",
	["Glorious Goods"] = "輝煌商品",
	Glory = "榮耀",
	["GM Island"] = "GM島",
	["Gnarlpine Hold"] = "脊骨堡",
	["Gnaws' Boneyard"] = "囓咬骨墳",
	Gnomeregan = "諾姆瑞根",
	["Gobline Mine"] = "哥布林礦坑",
	["Goblin Foundry"] = "哥布林鍛造廠",
	["Goblin Mine"] = "哥布林礦坑",
	["Goblin Slums"] = "哥布林貧民窟",
	["Gokk'lok's Grotto"] = "苟克拉克洞穴",
	["Gokk'lok Shallows"] = "苟克拉克淺灘",
	["Golakka Hot Springs"] = "葛拉卡溫泉",
	["Gol'Bolar Quarry"] = "古博拉採掘場",
	["Gol'Bolar Quarry Mine"] = "古博拉礦場",
	["Gold Coast Quarry"] = "金海岸礦坑",
	["Goldenbough Pass"] = "金枝小徑",
	["Goldenmist Village"] = "金霧村",
	["Golden Strand"] = "金色湖岸",
	["Gold Mine"] = "金礦",
	["Gold Road"] = "黃金之路",
	["Gold Rush BG"] = "淘金熱戰場",
	Goldshire = "閃金鎮",
	["Goldtooth's Den"] = "金牙的巢穴",
	["Goodgrub Smoking Pit"] = "古德古瑞伯煙坑",
	["Gordok's Seat"] = "戈多克的王座",
	["Gordunni Outpost"] = "戈杜尼前哨站",
	["Gorefiend's Vigil"] = "血魔禁地",
	["Gor'gaz Outpost"] = "葛卡茲哨站",
	Gornia = "戈尼亞",
	["Gorrok's Lament"] = "哥羅克之悼",
	["Gorshak War Camp"] = "戈沙克戰營",
	["Go'Shek Farm"] = "格沙克農場",
	["Grain Cellar"] = "穀物地窖",
	["Grand Courtyard"] = "御宏場",
	["Grand Magister's Asylum"] = "大博學者的庇護所",
	["Grand Overlook"] = "御宏臺",
	["Grand Promenade"] = "華麗漫步庭園",
	["Grangol'var Village"] = "葛蘭戈瓦村",
	["Granite Springs"] = "花崗岩之泉",
	["Grassy Cline"] = "草生群",
	["Greatwood Vale"] = "巨木谷",
	["Greengill Coast"] = "綠鰓海岸",
	["Greenpaw Village"] = "綠爪村",
	["Greenstone Dojo"] = "綠石道場",
	["Greenstone Inn"] = "綠石客棧",
	["Greenstone Masons' Quarter"] = "綠石石匠區",
	["Greenstone Quarry"] = "綠石採石場",
	["Greenstone Village"] = "綠石村",
	["Greenwarden's Grove"] = "綠意守望者之林",
	["Greymane Court"] = "葛雷邁恩宮廷",
	["Greymane Manor"] = "葛雷邁恩莊園",
	["Greymist Firth"] = "灰霧海灣",
	["Grim Batol"] = "格瑞姆巴托",
	["Grim Batol Entrance"] = "格瑞姆巴托入口",
	["Grimesilt Dig Site"] = "煤渣挖掘場",
	["Grimtotem Compound"] = "恐怖圖騰營地",
	["Grimtotem Post"] = "恐怖圖騰崗哨",
	Grishnath = "葛瑞許納什",
	Grizzlemaw = "灰喉鎮",
	["Grizzlepaw Ridge"] = "灰爪山",
	["Grizzly Hills"] = "灰白之丘",
	["Grol'dom Farm"] = "格羅多姆農場",
	["Grolluk's Grave"] = "葛羅路克之墓",
	["Grom'arsh Crash-Site"] = "葛羅姆亞什失事地",
	["Grom'gol"] = "格羅姆高",
	["Grom'gol Base Camp"] = "格羅姆高營地",
	["Grommash Hold"] = "葛羅瑪許堡",
	["Grookin Hill"] = "葛魯山丘",
	["Grosh'gok Compound"] = "格羅高克營地",
	["Grove of Aessina"] = "艾森娜之林",
	["Grove of Falling Blossoms"] = "落花林",
	["Grove of the Ancients"] = "古樹之林",
	["Growless Cave"] = "無草洞",
	["Gruul's Lair"] = "戈魯爾之巢",
	["Gryphon Roost"] = "獅鷲獸棲息處",
	["Guardian's Library"] = "守護者圖書館",
	Gundrak = "剛德拉克",
	["Gundrak Entrance"] = "剛德拉克入口",
	["Gunstan's Dig"] = "古斯坦挖掘場",
	["Gunstan's Post"] = "古斯坦崗哨",
	["Gunther's Retreat"] = "岡瑟爾的居所",
	["Guo-Lai Halls"] = "郭萊院",
	["Guo-Lai Ritual Chamber"] = "郭萊儀式寶殿",
	["Guo-Lai Vault"] = "郭萊墓穴",
	["Gurboggle's Ledge"] = "葛爾巴果的岩礁",
	["Gurubashi Arena"] = "古拉巴什競技場",
	["Gyro-Plank Bridge"] = "環木橋",
	["Haal'eshi Gorge"] = "海艾斯峽谷",
	["Hadronox's Lair"] = "哈卓諾克斯之巢",
	["Hailwood Marsh"] = "雹木沼澤",
	Halaa = "哈剌",
	["Halaani Basin"] = "哈剌尼盆地",
	["Halcyon Egress"] = "翠鳥出口",
	["Haldarr Encampment"] = "哈達爾營地",
	Halfhill = "半丘",
	Halgrind = "霍葛萊",
	["Hall of Arms"] = "武器大廳",
	["Hall of Binding"] = "禁錮大廳",
	["Hall of Blackhand"] = "黑手大廳",
	["Hall of Blades"] = "刀刃大廳",
	["Hall of Bones"] = "白骨大廳",
	["Hall of Champions"] = "勇士大廳",
	["Hall of Command"] = "指揮大廳",
	["Hall of Crafting"] = "工匠大廳",
	["Hall of Departure"] = "起程大廳",
	["Hall of Explorers"] = "探險者大廳",
	["Hall of Faces"] = "盜賊大廳",
	["Hall of Horrors"] = "驚怖大廳",
	["Hall of Illusions"] = "幻術之廳",
	["Hall of Kings"] = "王者大廳",
	["Hall of Legends"] = "傳說大廳",
	["Hall of Masks"] = "面具大廳",
	["Hall of Memories"] = "回憶之廳",
	["Hall of Mysteries"] = "秘法大廳",
	["Hall of Repose"] = "安詳大廳",
	["Hall of Return"] = "回歸大廳",
	["Hall of Ritual"] = "儀式大廳",
	["Hall of Secrets"] = "秘密大廳",
	["Hall of Serpents"] = "毒蛇大廳",
	["Hall of Shapers"] = "雕塑者大廳",
	["Hall of Stasis"] = "靜止大廳",
	["Hall of the Brave"] = "勇者大廳",
	["Hall of the Conquered Kings"] = "征服諸王大廳",
	["Hall of the Crafters"] = "工匠大廳",
	["Hall of the Crescent Moon"] = "新月大廳",
	["Hall of the Crusade"] = "十字軍大廳",
	["Hall of the Cursed"] = "詛咒大廳",
	["Hall of the Damned"] = "譴責大廳",
	["Hall of the Defamed"] = "謗者大廳",
	["Hall of the Exalted"] = "崇者大廳",
	["Hall of the Fathers"] = "眾父大廳",
	["Hall of the Frostwolf"] = "霜狼大廳",
	["Hall of the Grand Imperion"] = "御林大廳",
	["Hall of the High Father"] = "至高之父大廳",
	["Hall of the Keepers"] = "守衛者大廳",
	["Hall of the Shaper"] = "塑造者大廳",
	["Hall of the Stormpike"] = "雷矛大廳",
	["Hall of the Tortured"] = "受苦者大廳",
	["Hall of the Watchers"] = "看守者大廳",
	["Hall of the Wicked"] = "邪惡者大廳",
	["Hall of Tombs"] = "墓穴大廳",
	["Hall of Tranquility"] = "寧靜大廳",
	["Hall of Tranquillity"] = "寧靜大廳",
	["Hall of Twilight"] = "暮光大廳",
	["Halls of Anguish"] = "苦痛大廳",
	["Halls of Awakening"] = "甦醒大廳",
	["Halls of Binding"] = "束縛大廳",
	["Halls of Destruction"] = "毀滅大廳",
	["Halls of Flesh-Shaping"] = "血肉塑形大廳",
	["Halls of Lightning"] = "雷光大廳",
	["Halls of Lightning Entrance"] = "雷光大廳入口",
	["Halls of Mourning"] = "悲傷大廳",
	["Halls of Origination"] = "起源大廳",
	["Halls of Origination Entrance"] = "起源大廳入口",
	["Halls of Reflection"] = "倒影大廳",
	["Halls of Reflection Entrance"] = "倒影大廳入口",
	["Halls of Silence"] = "沉默大廳",
	["Halls of Stone"] = "石之大廳",
	["Halls of Stone Entrance"] = "石之大廳入口",
	["Halls of Strife"] = "征戰大廳",
	["Halls of the Ancestors"] = "先祖大廳",
	["Halls of the Hereafter"] = "來世大廳",
	["Halls of the Law"] = "秩序大廳",
	["Halls of Theory"] = "學術大廳",
	["Halycon's Lair"] = "哈雷肯之巢",
	Hammerfall = "落錘鎮",
	["Hammertoe's Digsite"] = "鐵趾挖掘場",
	["Hammond Farmstead"] = "漢孟德農莊",
	Hangar = "機棚",
	["Hardknuckle Clearing"] = "硬拳空地",
	["Hardwrench Hideaway"] = "硬心藏匿處",
	["Harkor's Camp"] = "哈克爾營地",
	["Hatchet Hills"] = "戰斧嶺",
	["Hatescale Burrow"] = "憎鱗地穴",
	["Hatred's Vice"] = "仇恨之惡",
	Havenshire = "避風郡",
	["Havenshire Farms"] = "避風郡農場",
	["Havenshire Lumber Mill"] = "避風郡伐木場",
	["Havenshire Mine"] = "避風郡礦坑",
	["Havenshire Stables"] = "避風郡獸欄",
	["Hayward Fishery"] = "海華德漁場",
	["Headmaster's Retreat"] = "院長的居所",
	["Headmaster's Study"] = "院長的書房",
	Hearthglen = "壁爐谷",
	["Heart of Destruction"] = "毀滅之心",
	["Heart of Fear"] = "恐懼之心",
	["Heart of the Old God Scenario"] = "古神之心事件",
	["Heart of Zan'vess"] = "贊斐斯之心",
	["Heart's Blood Shrine"] = "心之血聖壇",
	["Heartwood Trading Post"] = "心材貿易站",
	["Heb'Drakkar"] = "希伯德拉卡",
	["Heb'Valok"] = "希伯伐洛克",
	["Hellfire Basin"] = "地獄火盆地",
	["Hellfire Citadel"] = "地獄火堡壘",
	["Hellfire Citadel: Ramparts"] = "地獄火堡壘:地獄火壁壘",
	["Hellfire Citadel - Ramparts Entrance"] = "地獄火堡壘 - 地獄火壁壘入口",
	["Hellfire Citadel: The Blood Furnace"] = "地獄火堡壘:血熔爐",
	["Hellfire Citadel - The Blood Furnace Entrance"] = "地獄火堡壘 - 血熔爐入口",
	["Hellfire Citadel: The Shattered Halls"] = "地獄火堡壘:破碎大廳",
	["Hellfire Citadel - The Shattered Halls Entrance"] = "地獄火堡壘 - 破碎大廳入口",
	["Hellfire Peninsula"] = "地獄火半島",
	["Hellfire Peninsula - Force Camp Beach Head"] = "地獄火半島 - 軍隊營地海角",
	["Hellfire Peninsula - Reaver's Fall"] = "地獄火半島 - 劫奪者荒野",
	["Hellfire Ramparts"] = "地獄火壁壘",
	["Hellscream Arena"] = "地獄吼競技場",
	["Hellscream's Camp"] = "地獄吼營地",
	["Hellscream's Fist"] = "地獄吼之拳",
	["Hellscream's Grasp"] = "地獄吼之握",
	["Hellscream's Watch"] = "地獄吼守望",
	["Helm's Bed Lake"] = "盔枕湖",
	["Heroes' Vigil"] = "英雄崗哨",
	["Hetaera's Clutch"] = "赫塔拉的巢穴",
	["Hewn Bog"] = "開闢泥沼",
	["Heyman's Hubris"] = "賀曼的狂妄",
	["Hibernal Cavern"] = "凜冬洞窟",
	["Hidden Cell"] = "秘密牢房",
	["Hidden Path"] = "秘道",
	Highbank = "高岸堡",
	["High Bank"] = "高岸堡",
	["Highland Forest"] = "高地森林",
	Highperch = "風巢",
	["High Wilderness"] = "高原荒野",
	Hillsbrad = "希爾斯布萊德",
	["Hillsbrad Fields"] = "希爾斯布萊德農場",
	["Hillsbrad Foothills"] = "希爾斯布萊德丘陵",
	["Hiri'watha Research Station"] = "西利瓦薩研究站",
	["Hive'Ashi"] = "亞什蟲巢",
	["Hive'Regal"] = "雷戈蟲巢",
	["Hive'Zora"] = "佐拉蟲巢",
	["Hogger Hill"] = "霍格嶺",
	["Hollowed Out Tree"] = "中空樹",
	["Hollowstone Mine"] = "穴石礦坑",
	["Honeydew Farm"] = "甘露農田",
	["Honeydew Glade"] = "甘露林地",
	["Honeydew Village"] = "甘露村",
	["Honor Hold"] = "榮譽堡",
	["Honor Hold Mine"] = "榮譽堡礦坑",
	["Honor Point"] = "榮譽崗哨",
	["Honor's Stand"] = "榮譽看臺",
	["Honor's Tomb"] = "榮耀之墓",
	["Horde Base Camp"] = "部落營地",
	["Horde Beach Daily Area"] = "部落海灘每日任務區域",
	["Horde Encampment"] = "部落營地",
	["Horde Keep"] = "部落要塞",
	["Horde Landing"] = "部落登陸營地",
	["Horde Landing Site"] = "部落登陸點",
	["Hordemar City"] = "霍德瑪爾城",
	["Horde PVP Barracks"] = "部落PVP兵營",
	["Horror Clutch"] = "驚恐窩巢",
	["Hour of Twilight"] = "暮光之時",
	["House of Edune"] = "伊度大宅",
	["Howling Fjord"] = "凜風峽灣",
	["Howlingwind Cavern"] = "嚎風洞穴",
	["Howlingwind Trail"] = "嚎風小徑",
	["Howling Ziggurat"] = "哀嚎通靈塔",
	["Hrothgar's Landing"] = "赫魯斯加臺地",
	["Huangtze Falls"] = "皇澤瀑布",
	["Hull of the Foebreaker"] = "破敵者號的船體",
	["Humboldt Conflagration"] = "杭伯特焚焰地",
	["Hunter Rise"] = "獵人高地",
	["Hunter's Hill"] = "獵人嶺",
	["Huntress of the Sun"] = "太陽女獵師",
	["Huntsman's Cloister"] = "獵手迴廊",
	Hyjal = "海加爾",
	["Hyjal Barrow Dens"] = "海加爾獸穴",
	["Hyjal Past"] = "過往的海加爾山",
	["Hyjal Summit"] = "海加爾山之巔",
	["Iceblood Garrison"] = "冰血要塞",
	["Iceblood Graveyard"] = "冰血墓地",
	Icecrown = "寒冰皇冠",
	["Icecrown Citadel"] = "冰冠城塞",
	["Icecrown Dungeon - Gunships"] = "冰冠地城 - 砲艇",
	["Icecrown Glacier"] = "寒冰皇冠",
	["Iceflow Lake"] = "湧冰湖",
	["Ice Heart Cavern"] = "冰心洞窟",
	["Icemist Falls"] = "冰霧瀑布",
	["Icemist Village"] = "冰霧村",
	["Ice Thistle Hills"] = "冰薊嶺",
	["Icewing Bunker"] = "冰翼碉堡",
	["Icewing Cavern"] = "冰翼洞穴",
	["Icewing Pass"] = "冰翼小徑",
	["Idlewind Lake"] = "微風湖",
	["Igneous Depths"] = "火成深淵",
	["Ihgaluk Crag"] = "伊加路克峭壁",
	["Ik'vess"] = "伊克斐斯",
	["Ikz'ka Ridge"] = "伊茲卡山脊",
	["Illidari Point"] = "伊利達瑞崗哨",
	["Illidari Training Grounds"] = "伊利達瑞訓練場",
	["Indu'le Village"] = "因度雷村",
	["Infiltrating the Shipyard"] = "潛入船塢",
	["Inkgill Mere"] = "墨鰓湖",
	Inn = "旅店",
	["Inner Sanctum"] = "城市內環",
	["Inner Veil"] = "內裡之霧",
	["Insidion's Perch"] = "印希迪恩棲所",
	["Invasion Point: Annihilator"] = "侵略點:殲滅者",
	["Invasion Point: Cataclysm"] = "侵略點:災難",
	["Invasion Point: Destroyer"] = "侵略點:摧毀者",
	["Invasion Point: Overlord"] = "侵略點:主宰者",
	["Ironband's Compound"] = "鐵環營地",
	["Ironband's Excavation Site"] = "鐵環挖掘場",
	["Ironbeard's Tomb"] = "鐵鬚之墓",
	["Ironclad Cove"] = "鐵甲灣",
	["Ironclad Garrison"] = "鐵甲要塞",
	["Ironclad Prison"] = "鐵欄監獄",
	["Iron Concourse"] = "鐵之集合場",
	["Irondeep Mine"] = "深鐵礦坑",
	Ironforge = "鐵爐堡",
	["Ironforge Airfield"] = "鐵爐堡機場",
	["Ironstone Camp"] = "鐵石營地",
	["Ironstone Plateau"] = "鐵石高原",
	["Iron Summit"] = "黑鐵峰",
	["Irontree Cavern"] = "鐵木山洞",
	["Irontree Clearing"] = "鐵木空地",
	["Irontree Woods"] = "鐵木森林",
	["Ironwall Dam"] = "鐵牆水壩",
	["Ironwall Rampart"] = "鐵牆壁壘",
	["Ironwing Cavern"] = "鐵翼洞穴",
	Iskaal = "伊斯考",
	["Island of Doctor Lapidis"] = "拉匹迪斯之島",
	["Isle of Conquest"] = "征服之島",
	["Isle of Conquest No Man's Land"] = "無人登陸的征服之島",
	["Isle of Dread"] = "恐怖之島",
	["Isle of Giants"] = "巨獸島",
	["Isle of Quel'Danas"] = "奎爾達納斯之島",
	["Isle of Reckoning"] = "清算之島",
	["Isle of Thunder"] = "雷王島",
	["Isle of Tribulations"] = "磨難之島",
	["Iso'rath"] = "伊索拉斯",
	["Itharius's Cave"] = "伊薩里奧斯的洞穴",
	["Ivald's Ruin"] = "伊瓦德遺跡",
	["Ix'lar's Domain"] = "伊克斯拉爾的領域",
	["Jadefire Glen"] = "碧火谷",
	["Jadefire Run"] = "碧火小徑",
	["Jade Forest Alliance Hub Phase"] = "翠玉林聯盟中心階段",
	["Jade Forest Battlefield Phase"] = "翠玉林戰場階段",
	["Jade Forest Horde Starting Area"] = "翠玉林部落起始區域",
	["Jademir Lake"] = "加德米爾湖",
	["Jade Temple Grounds"] = "玉廟庭",
	Jaedenar = "加德納爾",
	["Jagged Reef"] = "鋸齒暗礁",
	["Jagged Ridge"] = "鋸齒山脊",
	["Jaggedswine Farm"] = "野豬農場",
	["Jagged Wastes"] = "鋸齒荒地",
	["Jaguero Isle"] = "哈圭羅島",
	["Jaina Dalaran Scenario"] = "珍娜達拉然事件",
	["Janeiro's Point"] = "加尼祿哨站",
	["Jangolode Mine"] = "詹戈洛德礦坑",
	["Jaquero Isle"] = "賈圭羅島",
	["Jasperlode Mine"] = "玉石礦坑",
	["Jeff NE Quadrant Changed"] = "Jeff NE Quadrant Changed",
	["Jeff NW Quadrant"] = "Jeff NW Quadrant",
	["Jeff SE Quadrant"] = "Jeff SE Quadrant",
	["Jeff SW Quadrant"] = "Jeff SW Quadrant",
	["Jerod's Landing"] = "傑羅德碼頭",
	["Jintha'Alor"] = "辛薩羅",
	["Jintha'kalar"] = "辛薩卡拉",
	["Jintha'kalar Passage"] = "辛薩卡拉通道",
	["Jin Yang Road"] = "晉陽路",
	Jotunheim = "卓頓海姆",
	K3 = "K3",
	["Kaja'mine"] = "卡迦石礦區",
	["Kaja'mite Cave"] = "卡迦邁洞穴",
	["Kaja'mite Cavern"] = "卡迦邁洞窟",
	["Kajaro Field"] = "卡亞羅賽場",
	["Kal'ai Ruins"] = "卡萊廢墟",
	Kalimdor = "卡林多",
	Kamagua = "卡瑪廓",
	["Karabor Sewers"] = "卡拉伯爾下水道",
	Karazhan = "卡拉贊",
	["Kargathia Keep"] = "卡加希亞要塞",
	["Karnum's Glade"] = "卡努姆林地",
	["Kartak's Hold"] = "卡爾塔克堡",
	Kaskala = "卡斯卡拉",
	["Kaw's Roost"] = "卡烏的棲息地",
	["Kea Krak"] = "齊克拉克",
	["Keelen's Trustworthy Tailoring"] = "奇蘭的可靠裁縫",
	["Keel Harbor"] = "龍骨港",
	["Keeshan's Post"] = "基沙恩崗哨",
	["Kelp'thar Forest"] = "凱波薩爾森林",
	["Kel'Thuzad Chamber"] = "科爾蘇加德之間",
	["Kel'Thuzad's Chamber"] = "科爾蘇加德之間",
	["Keset Pass"] = "奇瑟小徑",
	["Kessel's Crossing"] = "凱索十字路",
	Kezan = "凱贊",
	Kharanos = "卡拉諾斯",
	["Khardros' Anvil"] = "卡德羅斯的鐵砧",
	["Khartut's Tomb"] = "卡爾吐特之墓",
	["Khaz'goroth's Seat"] = "卡茲格羅斯的王座",
	["Ki-Han Brewery"] = "祁漢酒坊",
	["Kili'ua's Atoll"] = "齊里厄雅環礁",
	["Kil'sorrow Fortress"] = "吉爾索洛堡壘",
	["King's Gate"] = "國王大門",
	["King's Harbor"] = "國王港",
	["King's Hoard"] = "王之庫藏",
	["King's Square"] = "國王廣場",
	["Kirin'Var Village"] = "肯瑞瓦村莊",
	Kirthaven = "柯特海文",
	["Klaxxi'vess"] = "卡拉西斐斯",
	["Klik'vess"] = "克里克斐斯",
	["Knucklethump Hole"] = "骨捶洞穴",
	["Kodo Graveyard"] = "科多獸墳場",
	["Kodo Rock"] = "科多石",
	["Kolkar Village"] = "科卡爾村",
	Kolramas = "科爾拉瑪斯",
	["Kor'kron Vanguard"] = "柯爾克隆先鋒駐地",
	["Kormek's Hut"] = "考米克小屋",
	["Koroth's Den"] = "寇羅斯之穴",
	["Korthun's End"] = "寇爾蘇恩之歿",
	["Kor'vess"] = "柯爾斐斯",
	["Kota Basecamp"] = "柯沓營地",
	["Kota Peak"] = "柯沓峰",
	["Krasarang Cove"] = "喀撒朗海灣",
	["Krasarang River"] = "喀撒朗河",
	["Krasarang Wilds"] = "喀撒朗蠻荒",
	["Krasari Falls"] = "喀撒利瀑布",
	["Krasus' Landing"] = "卡薩斯平臺",
	["Krazzworks Attack Zeppelin"] = "克拉茲工坊攻擊飛艇",
	["Kril'Mandar Point"] = "克里曼達海岬",
	["Kri'vess"] = "克里斐斯",
	["Krolg's Hut"] = "庫羅格小屋",
	["Krom'gar Fortress"] = "克羅姆加堡壘",
	["Krom's Landing"] = "克羅姆臺地",
	["KTC Headquarters"] = "卡亞羅貿易公司總部",
	["KTC Oil Platform"] = "卡亞羅貿易公司石油平台",
	["Kul'galar Keep"] = "庫爾加拉要塞",
	["Kul Tiras"] = "庫爾提拉斯",
	["Kun-Lai Pass"] = "崑萊小徑",
	["Kun-Lai Summit"] = "崑萊峰",
	["Kunzen Cave"] = "崑真洞",
	["Kunzen Village"] = "崑真村",
	["Kurzen's Compound"] = "庫爾森的營地",
	["Kypari Ik"] = "奇帕利依科",
	["Kyparite Quarry"] = "奇帕利礦場",
	["Kypari Vor"] = "奇帕利沃爾",
	["Kypari Zar"] = "奇帕利札爾",
	["Kzzok Warcamp"] = "喀薩克戰營",
	["Lair of Skiggit"] = "思基吉巢穴",
	["Lair of the Beast"] = "野獸巢穴",
	["Lair of the Chosen"] = "天選者之巢",
	["Lair of the Jade Witch"] = "玉巫婆巢穴",
	["Lair of Tortos"] = "托爾托斯巢穴",
	["Lake Al'Ameth"] = "奧拉密斯湖",
	["Lake Cauldros"] = "科德洛斯湖",
	["Lake Dumont"] = "都蒙特湖",
	["Lake Edunel"] = "伊度涅爾湖",
	["Lake Elrendar"] = "艾蘭達之湖",
	["Lake Elune'ara"] = "月神湖",
	["Lake Ere'Noru"] = "艾利諾魯湖",
	["Lake Everstill"] = "止水湖",
	["Lake Falathim"] = "法拉希姆湖",
	["Lake Indu'le"] = "因度雷湖",
	["Lake Jorune"] = "佐魯湖",
	["Lake Kel'Theril"] = "凱斯利爾湖",
	["Lake Kittitata"] = "奇提塔塔湖",
	["Lake Kum'uya"] = "庫姆亞湖",
	["Lake Mennar"] = "門納爾湖",
	["Lake Mereldar"] = "米雷達爾湖",
	["Lake Nazferiti"] = "納菲瑞提湖",
	["Lake of Stars"] = "星辰湖",
	["Lakeridge Highway"] = "湖邊大道",
	Lakeshire = "湖畔鎮",
	["Lakeshire Inn"] = "湖畔鎮旅店",
	["Lakeshire Town Hall"] = "湖畔鎮大廳",
	["Lakeside Landing"] = "湖畔起降場",
	["Lake Sunspring"] = "日春湖",
	["Lakkari Tar Pits"] = "拉卡利油沼",
	["Landing Beach"] = "起降海灘",
	["Landing Site"] = "降落地點",
	["Land's End Beach"] = "天涯海灘",
	["Langrom's Leather & Links"] = "朗格姆的皮甲與鍊甲",
	["Lao & Son's Yakwash"] = "勞記犛牛清洗場",
	["Largo's Overlook"] = "拉爾戈瞰臺",
	["Largo's Overlook Tower"] = "拉爾戈瞰臺哨塔",
	["Lariss Pavilion"] = "拉瑞斯小亭",
	["Laughing Skull Courtyard"] = "獰笑骷髏庭院",
	["Laughing Skull Ruins"] = "獰笑骷髏廢墟",
	["Launch Bay"] = "發射台",
	["Legash Encampment"] = "雷加什營地",
	["Legendary Leathers"] = "傳奇皮革",
	["Legion Hold"] = "軍團要塞",
	["Legion's Fate"] = "軍團的命運",
	["Legion's Rest"] = "軍團之眠",
	["Lethlor Ravine"] = "萊瑟羅峽谷",
	["Level Design Land - Dev Only"] = "Level Design Land - Dev Only",
	["Leyara's Sorrow"] = "雷亞拉的憂傷",
	["L'ghorek"] = "勒苟雷克",
	["Liang's Retreat"] = "梁的居所",
	["Library Wing"] = "藏書房",
	Lighthouse = "燈塔",
	["Lightning Ascent"] = "疾電階",
	["Lightning Forge - Mogu Island Progression Scenario"] = "雷霆熔爐 - 魔古島發展事件",
	["Lightning Ledge"] = "閃電高地",
	["Lightning Promenade"] = "電光漫步庭園",
	["Lightning Vein Mine"] = "電光礦脈",
	["Light's Breach"] = "聖光止境",
	["Light's Dawn Cathedral"] = "聖光黎明大教堂",
	["Light's Hammer"] = "聖光之錘",
	["Light's Hope Chapel"] = "聖光之願禮拜堂",
	["Light's Point"] = "聖光之尖",
	["Light's Point Tower"] = "聖光之尖哨塔",
	["Light's Shield Tower"] = "光盾哨塔",
	["Light's Trust"] = "聖光之託",
	["Like Clockwork"] = "精準如錶發條舖",
	["Lion's Landing"] = "雄獅灘",
	["Lion's Pride Inn"] = "獅王之傲旅店",
	["Livery Outpost"] = "馬廄崗哨",
	["Livery Stables"] = "獸欄",
	["Livery Stables "] = "獸欄",
	["Llane's Oath"] = "萊恩之誓",
	["Loading Room"] = "裝載室",
	["Loch Modan"] = "洛克莫丹",
	["Loch Verrall"] = "洛克維羅",
	["Loken's Bargain"] = "洛肯的交易地",
	["Lonesome Cove"] = "寂寞灣",
	Longshore = "長灘",
	["Longying Outpost"] = "長陰哨站",
	["Lordamere Internment Camp"] = "洛丹米爾收容所",
	["Lordamere Lake"] = "洛丹米爾湖",
	["Lor'danel"] = "洛丹諾",
	["Lorthuna's Gate"] = "洛舒娜之門",
	["Lost Caldera"] = "失落火山口",
	["Lost City of the Tol'vir"] = "托維爾的失落之城",
	["Lost City of the Tol'vir Entrance"] = "托維爾的失落之城入口",
	LostIsles = "失落群島",
	["Lost Isles Town in a Box"] = "失落群島盒中鎮",
	["Lost Isles Volcano Eruption"] = "失落群島火山爆發",
	["Lost Peak"] = "失落山峰",
	["Lost Point"] = "迷失哨塔",
	["Lost Rigger Cove"] = "落帆海灣",
	["Lothalor Woodlands"] = "洛薩羅林地",
	["Lower City"] = "陰鬱城",
	["Lower Silvermarsh"] = "銀之沼澤下層",
	["Lower Sumprushes"] = "泥沼窪地",
	["Lower Veil Shil'ak"] = "迷霧希拉克下層",
	["Lower Wilds"] = "低地荒野",
	["Lumber Mill"] = "伐木場",
	["Lushwater Oasis"] = "甜水綠洲",
	["Lydell's Ambush"] = "黎戴爾的埋伏處",
	["M.A.C. Diver"] = "M.A.C.潛砂機",
	["Maelstrom Deathwing Fight"] = "大漩渦",
	["Maelstrom Zone"] = "大漩渦區域",
	["Maestra's Post"] = "邁斯特拉崗哨",
	["Maexxna's Nest"] = "梅克絲娜之巢",
	["Mage Quarter"] = "法師區",
	["Mage Tower"] = "法師塔",
	["Mag'har Grounds"] = "瑪格哈營地",
	["Mag'hari Procession"] = "瑪格哈利隊伍",
	["Mag'har Post"] = "瑪格哈崗哨",
	["Magical Menagerie"] = "魔法動物園",
	["Magic Quarter"] = "魔法區",
	["Magisters Gate"] = "博學者之門",
	["Magister's Terrace"] = "博學者殿堂",
	["Magisters' Terrace"] = "博學者殿堂",
	["Magisters' Terrace Entrance"] = "博學者殿堂入口",
	["Magmadar Cavern"] = "瑪格曼達洞穴",
	["Magma Fields"] = "岩漿平原",
	["Magma Springs"] = "熔岩泉",
	["Magmaw's Fissure"] = "熔喉裂縫",
	Magmoth = "瑪格默斯",
	["Magnamoth Caverns"] = "瑪格納默斯洞窟",
	["Magram Territory"] = "瑪格拉姆領地",
	["Magtheridon's Lair"] = "瑪瑟里頓的巢穴",
	["Magus Commerce Exchange"] = "魔導師貿易區",
	["Main Chamber"] = "主房間",
	["Main Gate"] = "主門",
	["Main Hall"] = "主廳",
	["Maker's Ascent"] = "造物者高地",
	["Maker's Overlook"] = "造物者瞰臺",
	["Maker's Overlook "] = "造物者瞰臺",
	["Makers' Overlook"] = "造物者瞰臺",
	["Maker's Perch"] = "造物者棲所",
	["Makers' Perch"] = "造物者棲所",
	["Malaka'jin"] = "瑪拉卡金",
	["Malden's Orchard"] = "瑪爾丁果園",
	Maldraz = "瑪爾德拉茲",
	["Malfurion's Breach"] = "瑪法里恩突破口",
	["Malicia's Outpost"] = "瑪麗希亞的哨站",
	["Malykriss: The Vile Hold"] = "瑪里庫立斯:邪鄙堡",
	["Mama's Pantry"] = "大娘的儲藏室",
	["Mam'toth Crater"] = "瑪姆托司爆坑",
	["Manaforge Ara"] = "法力熔爐艾拉",
	["Manaforge B'naar"] = "法力熔爐巴納爾",
	["Manaforge Coruu"] = "法力熔爐寇魯",
	["Manaforge Duro"] = "法力熔爐杜羅",
	["Manaforge Ultris"] = "法力熔爐奧崔斯",
	["Mana Tombs"] = "法力墓地",
	["Mana-Tombs"] = "法力墓地",
	["Mandokir's Domain"] = "曼多基爾領域",
	["Mandori Village"] = "滿朵黎村",
	["Mannoroc Coven"] = "瑪諾洛克集會所",
	["Manor Mistmantle"] = "密斯特曼托莊園",
	["Mantle Rock"] = "披肩石",
	["Map Chamber"] = "地圖室",
	["Mar'at"] = "瑪拉特",
	Maraudon = "瑪拉頓",
	["Maraudon - Earth Song Falls Entrance"] = "瑪拉頓 - 地歌瀑布入口",
	["Maraudon - Foulspore Cavern Entrance"] = "瑪拉頓 - 毒菇洞穴入口",
	["Maraudon - The Wicked Grotto Entrance"] = "瑪拉頓 - 邪惡洞穴入口",
	["Mardenholde Keep"] = "瑪登霍爾德城堡",
	Marista = "瑪里斯塔",
	["Marista's Bait & Brew"] = "瑪里斯塔釣具酒館",
	["Market Row"] = "市場區",
	["Marshal's Refuge"] = "馬紹爾營地",
	["Marshal's Stand"] = "馬紹爾觀測站",
	["Marshlight Lake"] = "沼澤光之湖",
	["Marshtide Watch"] = "沼潮哨站",
	["Maruadon - The Wicked Grotto Entrance"] = "瑪拉頓 - 邪惡洞穴入口",
	["Mason's Folly"] = "巧匠之愚",
	["Masters' Gate"] = "主宰之門",
	["Master's Terrace"] = "大師的露臺",
	["Mast Room"] = "船桅室",
	["Maw of Destruction"] = "毀滅之顎",
	["Maw of Go'rath"] = "苟拉斯之顎",
	["Maw of Lycanthoth"] = "狼狂索斯之喉",
	["Maw of Neltharion"] = "奈薩里奧之喉",
	["Maw of Shu'ma"] = "鬚瑪之顎",
	["Maw of the Void"] = "虛空之喉",
	["Mazra'Alor"] = "瑪茲拉羅",
	Mazthoril = "麥索瑞爾",
	["Mazu's Overlook"] = "瑪祖海角",
	["Medivh's Chambers"] = "麥迪文的房間",
	["Menagerie Wreckage"] = "獸欄殘骸",
	["Menethil Bay"] = "米奈希爾海灣",
	["Menethil Harbor"] = "米奈希爾港",
	["Menethil Keep"] = "米奈希爾城堡",
	["Merchant Square"] = "商業廣場",
	Middenvale = "廢棄谷",
	["Mid Point Station"] = "中點抽水站",
	["Midrealm Post"] = "領地崗哨",
	["Midwall Lift"] = "中牆升降梯",
	["Mightstone Quarry"] = "力石礦場",
	["Military District"] = "軍事區",
	["Mimir's Workshop"] = "彌米爾工坊",
	Mine = "礦坑",
	Mines = "礦坑",
	["Mirage Abyss"] = "幻象深淵",
	["Mirage Flats"] = "幻象平地",
	["Mirage Raceway"] = "沙漠賽道",
	["Mirkfallon Lake"] = "暗色湖",
	["Mirkfallon Post"] = "暗色崗哨",
	["Mirror Lake"] = "明鏡湖",
	["Mirror Lake Orchard"] = "明鏡湖果園",
	["Mistblade Den"] = "霧刃之巢",
	["Mistcaller's Cave"] = "喚霧者的洞穴",
	["Mistfall Village"] = "霧臨村",
	["Mist's Edge"] = "薄霧海",
	["Mistvale Valley"] = "薄霧山谷",
	["Mistveil Sea"] = "霧紗海",
	["Mistwhisper Refuge"] = "霧語避難所",
	["Misty Pine Refuge"] = "霧松避難所",
	["Misty Reed Post"] = "蘆葦崗哨",
	["Misty Reed Strand"] = "蘆葦海灘",
	["Misty Ridge"] = "多霧山脊",
	["Misty Shore"] = "霧氣湖岸",
	["Misty Shores"] = "霧氣之濱",
	["Misty Valley"] = "迷霧谷",
	["Miwana's Longhouse"] = "米瓦納長屋",
	["Mizjah Ruins"] = "米扎廢墟",
	["Moa'ki"] = "默亞基",
	["Moa'ki Harbor"] = "默亞基港",
	["Moggle Point"] = "摩戈爾哨塔",
	["Mo'grosh Stronghold"] = "莫格羅什要塞",
	["Mogu Island Daily Area"] = "魔古島每日任務區域",
	["Mogu Island Events - Alliance Base"] = "魔古島活動 - 聯盟基地",
	["Mogu Island Events - Horde Base"] = "魔古島活動 - 部落基地",
	["Mogu Island Loot Room"] = "魔古島藏寶間",
	["Mogu Island Progression Events"] = "魔古島發展活動",
	Mogujia = "魔古岬",
	["Mogu'shan Palace"] = "魔古山宮",
	["Mogu'shan Terrace"] = "魔古山露臺",
	["Mogu'shan Vaults"] = "魔古山寶庫",
	["Mok'Doom"] = "摩多姆",
	["Mok'Gordun"] = "莫克高頓",
	["Mok'Nathal Village"] = "摩克納薩爾村",
	["Mold Foundry"] = "澆鑄間",
	["Molten Core"] = "熔火之心",
	["Molten Front"] = "熔岩前線",
	Moonbrook = "月溪鎮",
	Moonglade = "月光林地",
	["Moongraze Woods"] = "牧月森林",
	["Moon Horror Den"] = "慘月洞穴",
	["Moonrest Gardens"] = "月眠花園",
	["Moonshrine Ruins"] = "月光神殿廢墟",
	["Moonshrine Sanctum"] = "月光神殿密室",
	["Moontouched Den"] = "月觸之穴",
	["Moonwater Retreat"] = "月水居",
	["Moonwell of Cleansing"] = "淨化月井",
	["Moonwell of Purity"] = "純淨月井",
	["Moonwing Den"] = "月翼獸窟",
	["Mord'rethar: The Death Gate"] = "默德雷薩:死亡之門",
	["Morgan's Plot"] = "摩根墓場",
	["Morgan's Vigil"] = "摩根的崗哨",
	["Morlos'Aran"] = "莫洛亞藍",
	["Morning Breeze Lake"] = "晨風湖",
	["Morning Breeze Village"] = "晨風村",
	Morrowchamber = "珀光密殿",
	["Mor'shan Base Camp"] = "莫爾杉營地",
	["Mortal's Demise"] = "凡人逝亡",
	["Mortbreath Grotto"] = "號角之息洞穴",
	["Mortwake's Tower"] = "摩特維克之塔",
	["Mosh'Ogg Ogre Mound"] = "莫什奧格巨魔山",
	["Mosshide Fen"] = "蘚皮沼地",
	["Mosswalker Village"] = "苔行者村",
	["Mossy Pile"] = "苔蘚堆",
	["Motherseed Pit"] = "慈母之種窪坑",
	["Mountainfoot Strip Mine"] = "山腳露天礦場",
	["Mount Akher"] = "艾克爾山",
	["Mount Hyjal"] = "海加爾山",
	["Mount Hyjal Phase 1"] = "海加爾山第一階段",
	["Mount Neverest"] = "奈佛勒斯山",
	["Muckscale Grotto"] = "泥鱗洞穴",
	["Muckscale Shallows"] = "泥鱗淺灘",
	["Mudmug's Place"] = "泥杯宅邸",
	Mudsprocket = "泥鏈營地",
	Mulgore = "莫高雷",
	["Murder Row"] = "兇殺路",
	["Murkdeep Cavern"] = "莫克迪普山洞",
	["Murky Bank"] = "莫奇河岸",
	["Muskpaw Ranch"] = "麝爪牧場",
	["Mystral Lake"] = "密斯特拉湖",
	Mystwood = "神秘森林",
	Nagrand = "納葛蘭",
	["Nagrand Arena"] = "納葛蘭競技場",
	Nahom = "納候姆",
	["Nar'shola Terrace"] = "納爾朔拉殿堂",
	["Narsong Spires"] = "納松尖塔",
	["Narsong Trench"] = "納松海溝",
	["Narvir's Cradle"] = "那維爾搖籃",
	["Nasam's Talon"] = "納森之爪",
	["Nat's Landing"] = "納特的平臺",
	["Naval Battle Scenario"] = "海戰事件",
	Naxxanar = "納克薩爾",
	Naxxramas = "納克薩瑪斯",
	["Nayeli Lagoon"] = "納耶里潟湖",
	["Naz'anak: The Forgotten Depths"] = "納茲安那克:遺忘深淵",
	["Nazj'vel"] = "納傑韋爾",
	Nazzivian = "納茲維恩",
	["Nectarbreeze Orchard"] = "蜜風果園",
	["Needlerock Chasm"] = "針岩裂谷",
	["Needlerock Slag"] = "針岩熔渣",
	["Nefarian's Lair"] = "奈法利安的巢穴",
	["Nefarian�s Lair"] = "奈法利安的巢穴",
	["Neferset City"] = "奈斐賽特城",
	["Neferset City Outskirts"] = "奈斐賽特城郊區",
	["Nek'mani Wellspring"] = "納克邁尼聖泉",
	["Neptulon's Rise"] = "奈普圖隆高地",
	["Nesingwary Base Camp"] = "奈辛瓦里營地",
	["Nesingwary Safari"] = "奈辛瓦里狩旅團",
	["Nesingwary's Expedition"] = "奈辛瓦里遠征隊營地",
	["Nesingwary's Safari"] = "奈辛瓦里狩旅團",
	Nespirah = "奈斯畢拉",
	["Nestlewood Hills"] = "奈斯特山丘",
	["Nestlewood Thicket"] = "奈斯特灌木林",
	["Nethander Stead"] = "奈杉德崗哨",
	["Nethergarde Keep"] = "守望堡",
	["Nethergarde Mines"] = "守望礦坑",
	["Nethergarde Supply Camps"] = "守望堡補給營地",
	Netherspace = "虛空空間",
	Netherstone = "虛空石",
	Netherstorm = "虛空風暴",
	["Netherweb Ridge"] = "幽網山脊",
	["Netherwing Fields"] = "虛空之翼農場",
	["Netherwing Ledge"] = "虛空之翼岩架",
	["Netherwing Mines"] = "虛空之翼礦坑",
	["Netherwing Pass"] = "虛空之翼小徑",
	["Neverest Basecamp"] = "奈佛勒斯營地",
	["Neverest Pinnacle"] = "奈佛勒斯之巔",
	["New Agamand"] = "新阿加曼德",
	["New Agamand Inn"] = "新阿加曼德旅店",
	["New Avalon"] = "新亞法隆",
	["New Avalon Fields"] = "新亞法隆農地",
	["New Avalon Forge"] = "新亞法隆熔爐",
	["New Avalon Orchard"] = "新亞法隆果林",
	["New Avalon Town Hall"] = "新亞法隆市政廳",
	["New Cifera"] = "新席非拉",
	["New Hearthglen"] = "新壁爐谷",
	["New Kargath"] = "新卡加斯",
	["New Thalanaar"] = "新薩蘭納爾",
	["New Tinkertown"] = "新地精區",
	["Nexus Legendary"] = "奧核之心傳奇任務",
	Nidavelir = "尼達維里爾",
	["Nidvar Stair"] = "尼德瓦階梯",
	Nifflevar = "尼弗瓦",
	["Night Elf Village"] = "夜精靈村",
	Nighthaven = "永夜港",
	["Nightingale Lounge"] = "夜鶯迎賓廳",
	["Nightmare Depths"] = "夢魘深淵",
	["Nightmare Scar"] = "惡夢之痕",
	["Nightmare Vale"] = "夢魘谷",
	["Night Run"] = "夜道谷",
	["Nightsong Woods"] = "夜歌森林",
	["Night Web's Hollow"] = "夜行蜘蛛洞穴",
	["Nijel's Point"] = "尼耶爾前哨站",
	["Nimbus Rise"] = "雲光高地",
	Nine = "Nine",
	["Niuzao Catacombs"] = "怒兆地下墓穴",
	["Niuzao Temple"] = "怒兆寺",
	["Njord's Breath Bay"] = "尼約德之息海灣",
	["Njorndar Village"] = "尼約達村",
	["Njorn Stair"] = "尼約階梯",
	["Nook of Konk"] = "剛克的藏身處",
	["Noonshade Ruins"] = "熱影廢墟",
	Nordrassil = "諾達希爾",
	["Nordrassil Inn"] = "諾達希爾旅店",
	["Nordune Ridge"] = "北砂山",
	["North Common Hall"] = "北會議廳",
	Northdale = "北谷",
	["Northern Barrens"] = "北貧瘠之地",
	["Northern Elwynn Mountains"] = "北艾爾文山脈",
	["Northern Headlands"] = "北岬",
	["Northern Rampart"] = "北方堡壘",
	["Northern Rocketway"] = "北方火箭道",
	["Northern Rocketway Exchange"] = "北方火箭道交會點",
	["Northern Stranglethorn"] = "北荊棘谷",
	["Northfold Manor"] = "諾斯弗德農場",
	["Northgate Breach"] = "北門止境",
	["North Gate Outpost"] = "北門崗哨",
	["North Gate Pass"] = "北門小徑",
	["Northgate River"] = "北門河",
	["Northgate Woods"] = "北門森林",
	["Northmaul Tower"] = "北槌哨塔",
	["Northpass Tower"] = "北地哨塔",
	["North Point Station"] = "北點抽水站",
	["North Point Tower"] = "北點哨塔",
	Northrend = "北裂境",
	["Northridge Lumber Camp"] = "北山伐木場",
	["North Sanctum"] = "北部聖所",
	Northshire = "北郡",
	["Northshire Abbey"] = "北郡修道院",
	["Northshire River"] = "北郡河",
	["Northshire Valley"] = "北郡山谷",
	["Northshire Vineyards"] = "北郡農場",
	["North Spear Tower"] = "北矛哨塔",
	["North Tide's Beachhead"] = "北潮谷地",
	["North Tide's Run"] = "北潮海岸",
	["Northwatch Expedition Base Camp"] = "北方遠征隊營地",
	["Northwatch Expedition Base Camp Inn"] = "北方遠征隊營地旅館",
	["Northwatch Foothold"] = "北方根據地",
	["Northwatch Hold"] = "北方城堡",
	["Northwind Cleft"] = "北風斷崖",
	["North Wind Tavern"] = "北風客棧",
	["Nozzlepot's Outpost"] = "管壺前哨",
	["Nozzlerust Post"] = "鏽鼻崗哨",
	["Oasis of the Fallen Prophet"] = "墮落先知綠洲",
	["Oasis of Vir'sar"] = "韋爾薩爾綠洲",
	["Obelisk of the Moon"] = "月亮方尖碑",
	["Obelisk of the Stars"] = "眾星方尖碑",
	["Obelisk of the Sun"] = "日陽方尖碑",
	["O'Breen's Camp"] = "奧布里營地",
	["Observance Hall"] = "儀祝大廳",
	["Observation Grounds"] = "觀測之地",
	["Obsidian Breakers"] = "黑曜破碎",
	["Obsidian Dragonshrine"] = "黑曜龍殿",
	["Obsidian Forest"] = "黑曜森林",
	["Obsidian Lair"] = "黑曜龍穴",
	["Obsidia's Perch"] = "歐比希迪亞棲所",
	["Odesyus' Landing"] = "奧迪席斯平臺",
	["Ogri'la"] = "歐格利拉",
	["Ogri'La"] = "歐格利拉",
	["Old Hillsbrad Foothills"] = "希爾斯布萊德丘陵舊址",
	["Old Ironforge"] = "舊鐵爐堡",
	["Old Town"] = "舊城區",
	Olembas = "奧萊姆貝斯",
	["Olivia's Pond"] = "奧利維亞的池塘",
	["Olsen's Farthing"] = "奧森農場",
	Oneiros = "奧奈羅斯",
	["One Keg"] = "獨罈集",
	["One More Glass"] = "勸君更進一杯酒",
	["Onslaught Base Camp"] = "突襲營地",
	["Onslaught Harbor"] = "突襲軍港口",
	["Onyxia's Lair"] = "奧妮克希亞的巢穴",
	["Oomlot Village"] = "烏姆拉村",
	["Oona Kagu"] = "烏納卡古",
	Oostan = "兀斯坦",
	["Oostan Nord"] = "北兀斯坦",
	["Oostan Ost"] = "東兀斯坦",
	["Oostan Sor"] = "南兀斯坦",
	["Opening of the Dark Portal"] = "開啟黑暗之門",
	["Opening of the Dark Portal Entrance"] = "開啟黑暗之門入口",
	["Oratorium of the Voice"] = "聖言殿",
	["Oratory of the Damned"] = "詛咒祈願室",
	["Orchid Hollow"] = "蘭谷",
	["Orebor Harborage"] = "奧雷伯爾港",
	["Oregrind's Dig"] = "歐樂格林挖掘場",
	["Orendil's Retreat"] = "奧蘭迪爾居所",
	Orgrimmar = "奧格瑪",
	["Orgrimmar Gunship Pandaria Start"] = "奧格瑪砲艇潘達利亞起始",
	["Orgrimmar Rear Gate"] = "奧格瑪後門",
	["Orgrimmar Rocketway Exchange"] = "奧格瑪火箭道交會點",
	["Orgrim's Hammer"] = "奧格林之錘",
	["Oronok's Farm"] = "歐朗諾克的農場",
	Orsis = "奧爾希斯",
	["Ortell's Hideout"] = "奧泰爾的隱居處",
	["Oshu'gun"] = "歐夏剛",
	["Outdoor Ruins"] = "戶外廢墟",
	Outland = "外域",
	["Overgrown Camp"] = "雜草營地",
	["Overgrown Statuary"] = "廢棄的神像殿",
	["Owen's Wishing Well"] = "歐文的許願池",
	["Owl Wing Thicket"] = "梟翼樹叢",
	["Palace Antechamber"] = "宮殿前廳",
	["Pal'ea"] = "帕雷亞",
	["Palemane Rock"] = "白鬃石",
	["Pandaren Mine"] = "熊貓人礦坑",
	Pandaria = "潘達利亞",
	["Pang's Stead"] = "潘家莊",
	["Panic Clutch"] = "驚慌窩巢",
	["Paoquan Hollow"] = "泡泉谷",
	["Parhelion Plaza"] = "幻日廣場",
	["Passage of Lost Fiends"] = "失落惡魔通道",
	["Path of a Hundred Steps"] = "好漢坡",
	["Path of Conquerors"] = "征服者之路",
	["Path of Enlightenment"] = "啟迪之道",
	["Path of Serenity"] = "寧靜迴廊",
	["Path of the Titans"] = "泰坦之途",
	["Path of Uther"] = "烏瑟之途",
	["Pattymack Land"] = "餅皮老兄之地",
	["Pauper's Walk"] = "乞丐步道",
	["Paur's Pub"] = "博雅酒樓",
	["Paw'don Glade"] = "坡東林地",
	["Paw'don Village"] = "坡東村",
	["Paw'Don Village"] = "坡東村",
	["Peak of Serenity"] = "寂靜峰",
	["Pearlfin Village"] = "珠鰭村",
	["Pearl Lake"] = "珍珠湖",
	["Pedestal of Hope"] = "希望石臺",
	["Pei-Wu Forest"] = "培武林",
	["Pestilent Scar"] = "瘟疫之痕",
	["Pet Battle - Jade Forest"] = "寵物對戰 - 翠玉林",
	["Petitioner's Chamber"] = "祈願室",
	["Pilgrim's Precipice"] = "旅人絕壁",
	["Pincer X2"] = "鉗手X2",
	["Pinnacle of Storms"] = "風暴之巔",
	["Pit of Fangs"] = "毒牙深淵",
	["Pit of Saron"] = "薩倫之淵",
	["Pit of Saron Entrance"] = "薩倫之淵入口",
	["Plaguelands: The Scarlet Enclave"] = "東瘟疫之地:血色領區",
	["Plaguemist Ravine"] = "疫霧深谷",
	Plaguewood = "病木林",
	["Plaguewood Tower"] = "病木林哨塔",
	["Plain of Echoes"] = "回聲平原",
	["Plain of Shards"] = "裂片曠野",
	["Plain of Thieves"] = "大盜平原",
	["Plains of Nasam"] = "納森平原",
	["Pod Cluster"] = "機艙群骸",
	["Pod Wreckage"] = "機艙殘骸",
	["Poison Falls"] = "毒水瀑布",
	["Pool of Reflection"] = "倒影池",
	["Pool of Tears"] = "淚水之池",
	["Pool of the Paw"] = "獸爪之池",
	["Pool of Twisted Reflections"] = "扭曲反射水池",
	["Pools of Aggonar"] = "阿葛納爾之池",
	["Pools of Arlithrien"] = "亞里斯瑞恩之池",
	["Pools of Jin'Alai"] = "金阿萊之池",
	["Pools of Purity"] = "純淨之池",
	["Pools of Youth"] = "青春之池",
	["Pools of Zha'Jin"] = "薩金之池",
	["Portal Clearing"] = "暮光之門",
	["Pranksters' Hollow"] = "頑童洞穴",
	["Predator's Perch"] = "掠食者棲所",
	["Prison of Immol'thar"] = "伊莫塔爾的牢籠",
	["Programmer Isle"] = "工程師島",
	["Promontory Point"] = "岬點",
	["Prospector's Point"] = "勘察員崗哨",
	["Protectorate Watch Post"] = "護國者哨站",
	["Proving Grounds"] = "試煉場",
	["Purespring Cavern"] = "純淨泉水洞穴",
	["Purgation Isle"] = "贖罪島",
	["Pursuing the Black Harvest"] = "追擊黑穫議會",
	["Putricide's Laboratory of Alchemical Horrors and Fun"] = "普崔希德的恐懼與歡樂鍊金實驗室",
	["Pyrewood Chapel"] = "焚木禮拜堂",
	["Pyrewood Inn"] = "焚木旅店",
	["Pyrewood Town Hall"] = "焚木市政廳",
	["Pyrewood Village"] = "焚木村",
	["Pyrox Flats"] = "派洛克斯平原",
	["QA and DVD"] = "QA and DVD",
	["Quagg Ridge"] = "跨格山脊",
	Quarry = "礦場",
	["Quartzite Basin"] = "石英盆地",
	["Queen's Gate"] = "皇后大門",
	["Quel'Danil Lodge"] = "奎爾丹尼小屋",
	["Quel'Delar's Rest"] = "奎爾德拉之眠",
	["Quel'Dormir Gardens"] = "奎多米爾花園",
	["Quel'Dormir Temple"] = "奎多米爾神殿",
	["Quel'Dormir Terrace"] = "奎多米爾殿堂",
	["Quel'Lithien Lodge"] = "奎爾林斯小屋",
	["Quel'thalas"] = "奎爾薩拉斯",
	["Quickchop's Lumber Farm"] = "快斧木材場",
	["Raastok Glade"] = "羅史達克林地",
	["Raceway Ruins"] = "賽道廢墟",
	["Rageclaw Den"] = "怒爪巢穴",
	["Rageclaw Lake"] = "怒爪湖",
	["Rage Fang Shrine"] = "怒牙聖壇",
	["Ragefeather Ridge"] = "怒羽山脊",
	["Ragefire Caverns"] = "怒焰洞穴",
	["Ragefire Chasm"] = "怒焰裂谷",
	["Ragefire Core"] = "怒焰之核",
	["Rage Scar Hold"] = "怒痕堡",
	["Ragnaros' Lair"] = "拉格納羅斯的巢穴",
	["Ragnaros' Reach"] = "拉格納羅斯之境",
	["Rainspeaker Canopy"] = "雨頌者之篷",
	["Rainspeaker Rapids"] = "雨頌者急湍",
	Ramkahen = "蘭姆卡韓",
	["Ramkahen Legion Outpost"] = "蘭姆卡韓軍團哨站",
	["Rampart of Skulls"] = "骸顱壁壘",
	["Ranazjar Isle"] = "拉納加爾島",
	["Raptor Pens"] = "迅猛龍圍欄",
	["Raptor Ridge"] = "恐龍嶺",
	["Raptor Rise"] = "迅猛龍高地",
	Ratchet = "棘齒城",
	["Rated Eye of the Storm"] = "暴風之眼積分戰場",
	["Ravaged Caravan"] = "被破壞的貨車",
	["Ravaged Crypt"] = "毀滅土窖",
	["Ravaged Twilight Camp"] = "暮光營地廢墟",
	["Ravencrest Monument"] = "黑羽紀念碑",
	["Raven Hill"] = "烏鴉嶺",
	["Raven Hill Cemetery"] = "烏鴉嶺墓園",
	["Ravenholdt Manor"] = "拉文霍德莊園",
	["Raven's Watch"] = "鴉之守望",
	["Raven's Wood"] = "烏鴉林",
	["Raynewood Retreat"] = "林中樹居",
	["Raynewood Tower"] = "林中塔",
	["Razaan's Landing"] = "雷森平臺",
	["Razorfen Downs"] = "剃刀高地",
	["Razorfen Downs Entrance"] = "剃刀高地入口",
	["Razorfen Kraul"] = "剃刀沼澤",
	["Razorfen Kraul Entrance"] = "剃刀沼澤入口",
	["Razor Hill"] = "剃刀嶺",
	["Razor Hill Barracks"] = "剃刀嶺兵營",
	["Razor Hill Outskirts"] = "剃刀嶺外圍 ",
	["Razor Hill Watchtower"] = "剃刀嶺瞭望塔",
	["Razormane Grounds"] = "剃鬃營地",
	["Razor Ridge"] = "剃刀山脊",
	["Razorscale's Aerie"] = "銳鱗之巢",
	["Razorthorn Rise"] = "刺棘高地",
	["Razorthorn Shelf"] = "刺棘沙洲",
	["Razorthorn Trail"] = "刺棘蔓",
	["Razorwind Canyon"] = "烈風峽谷",
	["Rear Staging Area"] = "後方整備區",
	["Reaver's Fall"] = "劫奪者荒野",
	["Reavers' Hall"] = "劫奪者大廳",
	["Rebel Camp"] = "反抗軍營地",
	["Red Cloud Mesa"] = "紅雲台地",
	["Redpine Dell"] = "紅松谷林",
	["Redridge - Bridge Phase One"] = "赤脊山 - 小橋階段1",
	["Redridge - Bridge Phase Two"] = "赤脊山 - 小橋階段2",
	["Redridge Canyons"] = "赤脊峽谷",
	["Redridge Mountains"] = "赤脊山",
	["Redridge - Orc Bomb"] = "赤脊山 - 獸人炸彈",
	["Red Rocks"] = "赤色石",
	["Redwood Trading Post"] = "紅木貿易站",
	Refinery = "精鍊場",
	["Refugee Caravan"] = "難民商隊",
	["Refuge Pointe"] = "避難谷地",
	["Refuse Disposal"] = "棄穢地",
	["Reliquary of Agony"] = "苦楚聖匣",
	["Reliquary of Pain"] = "痛苦聖匣",
	["Remains of Iris Lake"] = "伊瑞斯湖遺址",
	["Remains of the Fleet"] = "艦隊殘骸",
	["Remtravel's Excavation"] = "雷姆塔維爾挖掘場",
	["Render's Camp"] = "撕裂者營地",
	["Render's Crater"] = "撕裂者盆地",
	["Render's Rock"] = "撕裂者之石",
	["Render's Valley"] = "撕裂者山谷",
	["Rensai's Watchpost"] = "任賽看守站",
	["Rethban Caverns"] = "瑞斯班洞穴",
	["Rethress Sanctum"] = "雷瑟斯聖所",
	Reuse = "Reuse",
	["Reuse Me 7"] = "Reuse Me 7",
	["Revantusk Village"] = "惡齒村",
	["Rhea's Camp"] = "莉雅營地",
	["Rhonin's Beard"] = "羅甯之鬚",
	["Rhyolith Plateau"] = "萊爾利斯高原",
	["Ricket's Folly"] = "瑞基特異所",
	["Ridge of Laughing Winds"] = "笑風嶺",
	["Ridge of Madness"] = "瘋狂山脊",
	["Ridgepoint Tower"] = "山巔之塔",
	Rikkilea = "雷基利亞",
	["Rikkitun Village"] = "雷基頓村",
	["Rim of the World"] = "世界之邊緣",
	["Ring of Judgement"] = "審判之環",
	["Ring of Observance"] = "儀式競技場",
	["Ring of the Elements"] = "元素之環",
	["Ring of the Law"] = "秩序競技場",
	["Riplash Ruins"] = "裂鞭遺跡",
	["Riplash Strand"] = "裂鞭水岸",
	["Rise of Suffering"] = "苦難高崗",
	["Rise of the Defiler"] = "污染者高地",
	["Ritual Chamber of Akali"] = "阿卡利儀式之間",
	["Rivendark's Perch"] = "瑞文達科棲所",
	Rivenwood = "裂木森林",
	["River's Heart"] = "大河之心",
	["Rock of Durotan"] = "杜洛坦之石",
	["Rockpool Village"] = "石塘村",
	["Rocktusk Farm"] = "石牙農場",
	["Roguefeather Den"] = "飛羽洞穴",
	["Rogues' Quarter"] = "盜賊區",
	["Rohemdal Pass"] = "洛罕達之徑",
	["Roland's Doom"] = "羅蘭之墓",
	["Room of Hidden Secrets"] = "隱藏秘密的房間",
	["Roost of Ji-Kun"] = "稷坤的窩巢",
	["Rotbrain Encampment"] = "腐腦營地",
	["Royal Amphitheater"] = "御尊試武場",
	["Royal Approach"] = "王廳入口",
	["Royal Exchange Auction House"] = "皇家交易所拍賣場",
	["Royal Exchange Bank"] = "皇家交易所銀行",
	["Royal Gallery"] = "皇家畫廊",
	["Royal Library"] = "皇家圖書館",
	["Royal Quarter"] = "皇家區",
	["Ruby Dragonshrine"] = "晶紅龍殿",
	["Ruined Approach"] = "大道遺跡",
	["Ruined City Post 01"] = "廢墟之城崗哨 01",
	["Ruined Court"] = "毀壞之廷",
	["Ruins of Aboraz"] = "阿博拉茲廢墟",
	["Ruins of Ahmtul"] = "阿姆圖爾廢墟",
	["Ruins of Ahn'Qiraj"] = "安其拉廢墟",
	["Ruins of Alterac"] = "奧特蘭克廢墟",
	["Ruins of Ammon"] = "亞蒙廢墟",
	["Ruins of Arkkoran"] = "亞考蘭廢墟",
	["Ruins of Auberdine"] = "奧伯丁廢墟",
	["Ruins of Baa'ri"] = "巴瑞廢墟",
	["Ruins of Constellas"] = "克斯特拉斯廢墟",
	["Ruins of Dojan"] = "朵迦廢墟",
	["Ruins of Drakgor"] = "德拉克戈廢墟",
	["Ruins of Drak'Zin"] = "德拉克辛遺跡",
	["Ruins of Eldarath"] = "埃達拉斯廢墟",
	["Ruins of Eldarath "] = "埃達拉斯廢墟",
	["Ruins of Eldra'nath"] = "艾卓納斯遺跡",
	["Ruins of Eldre'thar"] = "艾爾德雷薩廢墟",
	["Ruins of Enkaat"] = "安卡特廢墟",
	["Ruins of Farahlon"] = "法拉隆廢墟",
	["Ruins of Feathermoon"] = "羽月廢墟",
	["Ruins of Gilneas"] = "吉爾尼斯廢墟",
	["Ruins of Gilneas City"] = "吉爾尼斯城廢墟",
	["Ruins of Guo-Lai"] = "郭萊廢墟",
	["Ruins of Isildien"] = "伊斯迪爾廢墟",
	["Ruins of Jubuwal"] = "朱布瓦爾廢墟",
	["Ruins of Karabor"] = "卡拉伯爾廢墟",
	["Ruins of Kargath"] = "卡加斯廢墟",
	["Ruins of Khintaset"] = "克因塔賽廢墟",
	["Ruins of Korja"] = "廓亞廢墟",
	["Ruins of Korune"] = "考倫廢墟",
	["Ruins of Lar'donir"] = "拉多尼爾廢墟",
	["Ruins of Lordaeron"] = "羅德隆廢墟",
	["Ruins of Loreth'Aran"] = "羅薩倫廢墟",
	["Ruins of Lornesta"] = "洛奈斯塔遺跡",
	["Ruins of Mathystra"] = "瑪塞斯特拉廢墟",
	["Ruins of Nordressa"] = "諾德雷沙廢墟",
	["Ruins of Ogudei"] = "歐古戴遺蹟",
	["Ruins of Ravenwind"] = "鴉風廢墟",
	["Ruins of Sha'naar"] = "夏納廢墟",
	["Ruins of Shandaral"] = "珊達拉遺跡",
	["Ruins of Silvermoon"] = "銀月廢墟",
	["Ruins of Solarsal"] = "索蘭薩爾廢墟",
	["Ruins of Southshore"] = "南海鎮廢墟",
	["Ruins of Taurajo"] = "陶拉祖廢墟",
	["Ruins of Tethys"] = "瑟希斯遺跡",
	["Ruins of Thaurissan"] = "索瑞森廢墟",
	["Ruins of Thelserai Temple"] = "特爾瑟雷神殿廢墟",
	["Ruins of Theramore"] = "塞拉摩遺跡",
	["Ruins of the Scarlet Enclave"] = "血色領區廢墟",
	["Ruins of Uldum"] = "奧丹姆廢墟",
	["Ruins of Vashj'elan"] = "瓦許伊蘭廢墟",
	["Ruins of Vashj'ir"] = "瓦許伊爾廢墟",
	["Ruins of Zul'Kunda"] = "祖昆達廢墟",
	["Ruins of Zul'Mamwe"] = "祖瑪維廢墟",
	["Ruins Rise"] = "廢墟高地",
	["Rumbling Terrace"] = "巨響露台",
	["Runestone Falithas"] = "符石菲薩斯",
	["Runestone Shan'dor"] = "符石夏納多爾",
	["Runeweaver Square"] = "織符者廣場",
	["Rustberg Village"] = "鏽堡村",
	["Rustmaul Dive Site"] = "鏽槌挖掘場",
	["Rutsak's Guard"] = "路特沙克之衛",
	["Rut'theran Village"] = "魯瑟蘭村",
	["Ruuan Weald"] = "魯安曠野",
	["Ruuna's Camp"] = "魯巫娜的營地",
	["Ruuzel's Isle"] = "盧澤爾之島",
	["Rygna's Lair"] = "黎格娜的巢穴",
	["Sable Ridge"] = "黑角嶺",
	["Sacrificial Altar"] = "犧牲祭壇",
	["Sahket Wastes"] = "薩克特荒原",
	Salabria = "薩拉布瑞亞",
	["Saldean's Farm"] = "薩丁農場",
	["Saltheril's Haven"] = "薩瑟里的避風港",
	["Saltspray Glen"] = "鹽沫沼澤",
	["Sanctuary of Malorne"] = "瑪洛尼聖地",
	["Sanctuary of Shadows"] = "暗影聖堂",
	["Sanctum of Reanimation"] = "再活化聖所",
	["Sanctum of Shadows"] = "暗影聖所",
	["Sanctum of the Ascended"] = "飛升聖所",
	["Sanctum of the Fallen God"] = "墮神聖地",
	["Sanctum of the Moon"] = "明月聖所",
	["Sanctum of the Prophets"] = "預言者聖域",
	["Sanctum of the South Wind"] = "南風聖所",
	["Sanctum of the Stars"] = "星光聖所",
	["Sanctum of the Sun"] = "太陽聖所",
	["Sands of Nasam"] = "納森沙地",
	["Sandsorrow Watch"] = "流沙崗哨",
	["Sandy Beach"] = "沙灘",
	["Sandy Shallows"] = "沙塵淺灘",
	["Sanguine Chamber"] = "血紅之廳",
	["Sapphire Hive"] = "天藍蜂巢",
	["Sapphiron's Lair"] = "薩菲隆的巢穴",
	["Saragosa's Landing"] = "薩拉苟莎臺地",
	Sarahland = "莎拉之地",
	["Sardor Isle"] = "薩爾多島",
	Sargeron = "薩格隆",
	["Sarjun Depths"] = "薩鍾深淵",
	["Saronite Mines"] = "薩鋼礦坑",
	["Sar'theris Strand"] = "薩瑟里斯海岸",
	Satyrnaar = "薩提納爾",
	["Saurok Creation Pit"] = "薩烏洛克誕生坑",
	["Savage Ledge"] = "蠻荒岩臺",
	["Scalawag Point"] = "無賴角",
	["Scalding Pools"] = "沸水之池",
	["Scalebeard's Cave"] = "鱗鬚洞穴",
	["Scalewing Shelf"] = "鱗翼沙洲",
	["Scarab Terrace"] = "甲蟲露臺",
	["Scarlet Encampment"] = "血色駐營",
	["Scarlet Halls"] = "血色大廳",
	["Scarlet Hold"] = "血色堡",
	["Scarlet Monastery"] = "血色修道院",
	["Scarlet Monastery Entrance"] = "血色修道院入口",
	["Scarlet Overlook"] = "血色瞰臺",
	["Scarlet Palisade"] = "血色護欄",
	["Scarlet Point"] = "血色哨點",
	["Scarlet Raven Tavern"] = "血鴉旅店",
	["Scarlet Tavern"] = "血色旅店",
	["Scarlet Tower"] = "血色哨塔",
	["Scarlet Watch Post"] = "血色十字軍崗哨",
	["Scarlet Watchtower"] = "血色瞭望塔",
	["Scar of the Worldbreaker"] = "碎界者之痕",
	["Scarred Terrace"] = "傷痕殿堂",
	["Scenario: Alcaz Island"] = "劇情:奧卡茲島",
	["Scenario - Black Ox Temple"] = "事件 - 玄牛寺",
	["Scenario - Mogu Ruins"] = "事件 - 魔古廢墟",
	["Scenic Overlook"] = "觀景台",
	["Schnottz's Frigate"] = "舒諾茲護衛艦",
	["Schnottz's Hostel"] = "舒諾茲旅舍",
	["Schnottz's Landing"] = "舒諾茲營地",
	Scholomance = "通靈學院",
	["Scholomance Entrance"] = "通靈學院入口",
	ScholomanceOLD = "通靈學院OLD",
	["School of Necromancy"] = "通靈術學校",
	["Scorched Gully"] = "烈焰山谷",
	["Scott's Spooky Area"] = "史考特陰森區域",
	["Scoured Reach"] = "沖蝕之境",
	Scourgehold = "瘟疫要塞",
	Scourgeholme = "天譴岸地",
	["Scourgelord's Command"] = "天譴領主指揮所",
	["Scrabblescrew's Camp"] = "瑟卡布斯庫的營地",
	["Screaming Gully"] = "激流溪谷",
	["Scryer's Tier"] = "占卜者階梯",
	["Scuttle Coast"] = "流亡海岸",
	Sea = "海洋",
	Seabrush = "盛海林",
	["Seafarer's Tomb"] = "海員之墓",
	["Sealed Chambers"] = "封印的房間",
	["Seal of the Sun King"] = "太陽之王封印",
	["Sea Mist Ridge"] = "海霧嶺",
	["Searing Gorge"] = "灼熱峽谷",
	["Seaspittle Cove"] = "海唾灣",
	["Seaspittle Nook"] = "海唾小徑",
	["Seat of Destruction"] = "毀滅之座",
	["Seat of Knowledge"] = "知識之座",
	["Seat of Life"] = "生命之座",
	["Seat of Magic"] = "魔法之座",
	["Seat of Radiance"] = "光輝之座",
	["Seat of the Chosen"] = "受選者之座",
	["Seat of the Naaru"] = "那魯之座",
	["Seat of the Spirit Waker"] = "喚魂者之座",
	["Seeker's Folly"] = "追尋者之愚行",
	["Seeker's Point"] = "追尋者聖壇",
	["Sen'jin Village"] = "森金村",
	["Sen'jin Village Outskirts"] = "森金村外圍 ",
	["Sentinel Basecamp"] = "哨兵營地",
	["Sentinel Hill"] = "哨兵嶺",
	["Sentinel Tower"] = "哨兵塔",
	["Sentry Point"] = "警戒崗哨",
	Seradane = "瑟拉丹",
	["Serenity Falls"] = "寂靜瀑布",
	["Serpent Lake"] = "毒蛇之湖",
	["Serpent's Coil"] = "盤蛇谷",
	["Serpent's Heart"] = "蟠龍之心",
	["Serpentshrine Cavern"] = "毒蛇神殿洞穴",
	["Serpent's Overlook"] = "蟠龍之望",
	["Serpent's Spine"] = "蟠龍脊",
	["Servants' Quarters"] = "佣人區",
	["Service Entrance"] = "僕從入口",
	["Sethekk Halls"] = "塞司克大廳",
	["Sethria's Roost"] = "賽瑟莉亞的棲息處",
	["Setting Sun Garrison"] = "落陽要塞",
	["Set'vess"] = "塞特斐斯",
	["Sewer Access Point"] = "下水道出入口",
	["Sewer Exit Pipe"] = "下水道出口管道",
	Sewers = "下水道",
	Shadebough = "蔭枝林",
	["Shadewood Thicket"] = "影木灌木林",
	["Shado-Li Basin"] = "影籬盆地",
	["Shado-Pan Fallback"] = "影潘後援地",
	["Shado-Pan Garrison"] = "影潘要塞",
	["Shado-Pan Monastery"] = "影潘僧院",
	["Shadowbreak Ravine"] = "破影峽谷",
	["Shadowfang Keep"] = "影牙城堡",
	["Shadowfang Keep Entrance"] = "影牙城堡入口",
	["Shadowfang Tower"] = "影牙塔",
	["Shadowforge City"] = "影爐城",
	Shadowglen = "幽影谷",
	["Shadow Grave"] = "灰影墓穴",
	["Shadow Hold"] = "暗影堡",
	["Shadow Labyrinth"] = "暗影迷宮",
	["Shadowlurk Ridge"] = "潛影山脊",
	["Shadowmoon Valley"] = "影月谷",
	["Shadowmoon Village"] = "影月村",
	["Shadow-Pan Monastery"] = "影潘僧院",
	["Shadowprey Village"] = "葬影村",
	["Shadow Ridge"] = "暗影山脊",
	["Shadowshard Cavern"] = "裂影洞穴",
	["Shadowsight Tower"] = "影景哨塔",
	["Shadowsong Shrine"] = "影歌神殿",
	["Shadowthread Cave"] = "影絲洞",
	["Shadow Tomb"] = "暗影之墓",
	["Shadow Wing Lair"] = "影翼巢穴",
	["Shadra'Alor"] = "沙德拉洛",
	["Shadybranch Pocket"] = "蔭枝區",
	["Shady Rest Inn"] = "樹蔭旅店",
	["Shalandis Isle"] = "薩藍迪斯島",
	["Shalewind Canyon"] = "岩風峽谷",
	["Shallow's End"] = "淺灘之末",
	["Shallowstep Pass"] = "淺階小徑",
	["Shalzaru's Lair"] = "沙爾札魯的巢穴",
	Shamanar = "夏瑪那",
	["Sha'naari Wastes"] = "夏納瑞荒地",
	["Shang's Stead"] = "尚家莊",
	["Shang's Valley"] = "尚家谷",
	["Shang Xi Training Grounds"] = "尚羲訓練營",
	["Shan'ze Dao"] = "衫織島",
	["Shaol'mara"] = "韶嘛喇",
	["Shaol'watha"] = "沙爾瓦薩",
	["Shaper's Terrace"] = "塑造者殿堂",
	["Shaper's Terrace "] = "塑造者殿堂",
	["Shartuul's Transporter"] = "夏圖歐的傳送門",
	["Sha'tari Base Camp"] = "薩塔營地",
	["Sha'tari Outpost"] = "薩塔前哨",
	["Shattered Convoy"] = "破滅車隊",
	["Shattered Plains"] = "破碎平原",
	["Shattered Straits"] = "破碎海峽",
	["Shattered Sun Staging Area"] = "破碎之日會所",
	["Shatter Point"] = "破碎崗哨",
	["Shatter Scar Vale"] = "碎痕谷",
	Shattershore = "破碎海岸",
	["Shatterspear Pass"] = "碎矛小徑",
	["Shatterspear Vale"] = "碎矛谷",
	["Shatterspear War Camp"] = "碎矛戰營",
	Shatterstone = "碎石",
	Shattrath = "撒塔斯",
	["Shattrath City"] = "撒塔斯城",
	["Shelf of Mazu"] = "瑪祖海棚",
	["Shell Beach"] = "貝殼海灘",
	["Shield Hill"] = "盾丘",
	["Shields of Silver"] = "銀質盾牌",
	["Shimmering Bog"] = "幻光泥沼",
	["Shimmering Expanse"] = "閃光瀚洋",
	["Shimmering Grotto"] = "閃光岩洞",
	["Shimmer Ridge"] = "閃光嶺",
	["Shindigger's Camp"] = "拉普索迪營地",
	["Ship to Vashj'ir (Orgrimmar -> Vashj'ir)"] = "前往瓦許伊爾的船(奧格瑪 -> 瓦許伊爾)",
	["Shipwreck Shore"] = "船骸海岸",
	Shipyard = "船塢",
	["Shipyard - Mogu Island Progression Scenario"] = "船廠 - 魔古島發展事件",
	["Shok'Thokar"] = "修克托卡",
	["Sholazar Basin"] = "休拉薩盆地",
	["Shores of the Well"] = "井的岸邊",
	["Shrine of Aessina"] = "艾森娜神殿",
	["Shrine of Aviana"] = "艾維娜聖壇",
	["Shrine of Dath'Remar"] = "達斯雷瑪神殿",
	["Shrine of Dreaming Stones"] = "夢石廟",
	["Shrine of Eck"] = "埃克聖壇",
	["Shrine of Fellowship"] = "結義聖壇",
	["Shrine of Five Dawns"] = "五晨廟",
	["Shrine of Goldrinn"] = "戈德林聖壇",
	["Shrine of Inner-Light"] = "心光廟",
	["Shrine of Lost Souls"] = "失落靈魂神殿",
	["Shrine of Nala'shi"] = "那拉希聖壇",
	["Shrine of Remembrance"] = "聖壇紀念館",
	["Shrine of Remulos"] = "雷姆洛斯神殿",
	["Shrine of Scales"] = "群鱗聖壇",
	["Shrine of Seven Stars"] = "七星廟",
	["Shrine of Thaurissan"] = "索瑞森神殿",
	["Shrine of the Dawn"] = "曙光廟",
	["Shrine of the Deceiver"] = "欺詐者神殿",
	["Shrine of the Dormant Flame"] = "眠炎聖殿",
	["Shrine of the Eclipse"] = "日蝕神殿",
	["Shrine of the Elements"] = "元素廟",
	["Shrine of the Fallen Warrior"] = "戰士之魂神殿",
	["Shrine of the Five Khans"] = "五可汗神殿",
	["Shrine of the Merciless One"] = "殘暴王聖壇",
	["Shrine of the Ox"] = "玄牛神殿",
	["Shrine of Twin Serpents"] = "雙蛟神殿",
	["Shrine of Two Moons"] = "雙月廟",
	["Shrine of Unending Light"] = "永恆聖光神殿",
	["Shriveled Oasis"] = "乾枯綠洲",
	["Shuddering Spires"] = "戰慄尖柱",
	["SI:7"] = "軍情七處",
	["Siege of Niuzao Temple"] = "圍攻怒兆寺",
	["Siege Vise"] = "攻城鉗",
	["Siege Workshop"] = "攻城工坊",
	["Sifreldar Village"] = "希弗爾達村",
	["Sik'vess"] = "席克斐斯",
	["Sik'vess Lair"] = "席克斐斯之巢",
	["Silent Vigil"] = "靜默警戒",
	Silithus = "希利蘇斯",
	["Silken Fields"] = "絲綢場",
	["Silken Shore"] = "絲綢海濱",
	["Silmyr Lake"] = "泥濘湖",
	["Silting Shore"] = "淤塞海岸",
	Silverbrook = "銀溪鎮",
	["Silverbrook Hills"] = "銀溪丘",
	["Silver Covenant Pavilion"] = "白銀誓盟亭閣",
	["Silverlight Cavern"] = "銀光洞窟",
	["Silverline Lake"] = "銀線湖",
	["Silvermoon City"] = "銀月城",
	["Silvermoon City Inn"] = "銀月城旅店",
	["Silvermoon Finery"] = "銀月城華服",
	["Silvermoon Jewelery"] = "銀月城珠寶店",
	["Silvermoon Registry"] = "銀月城登記處",
	["Silvermoon's Pride"] = "銀月之驕",
	["Silvermyst Isle"] = "銀謎小島",
	["Silverpine Forest"] = "銀松森林",
	["Silvershard Mines"] = "碎銀礦坑",
	["Silver Stream Mine"] = "銀泉礦坑",
	["Silver Tide Hollow"] = "銀浪谷地",
	["Silver Tide Trench"] = "銀浪海溝",
	["Silverwind Refuge"] = "銀風避難所",
	["Silverwing Flag Room"] = "銀翼戰旗廳",
	["Silverwing Grove"] = "銀翼樹林",
	["Silverwing Hold"] = "銀翼要塞",
	["Silverwing Outpost"] = "銀翼哨站",
	["Simply Enchanting"] = "完全附魔商店",
	["Sindragosa's Fall"] = "辛德拉苟莎之殞",
	["Sindweller's Rise"] = "辛德爾勒高崗",
	["Singing Marshes"] = "歌頌沼澤",
	["Singing Ridge"] = "美聲山脊",
	["Sinner's Folly"] = "罪人愚行號",
	["Sira'kess Front"] = "席拉克斯前線",
	["Sishir Canyon"] = "希塞爾山谷",
	["Sisters Sorcerous"] = "巫術姊妹",
	Skald = "斯卡德",
	["Sketh'lon Base Camp"] = "史凱瑟隆營地",
	["Sketh'lon Wreckage"] = "史凱瑟隆殘骸",
	["Skethyl Mountains"] = "斯其索山脈",
	Skettis = "司凱堤斯",
	["Skitterweb Tunnels"] = "蛛網隧道",
	Skorn = "斯考恩",
	["Skulking Row"] = "潛隱路",
	["Skulk Rock"] = "隱匿石",
	["Skull Rock"] = "骷髏石",
	["Sky Falls"] = "天空瀑布",
	["Skyguard Outpost"] = "禦天者前哨",
	["Skyline Ridge"] = "沖天嶺",
	Skyrange = "擎天嶺",
	["Skysong Lake"] = "天歌湖",
	["Slabchisel's Survey"] = "斯拉奇索勘察地",
	["Slag Watch"] = "爐熔守望",
	Slagworks = "熔渣處理場",
	["Slaughter Hollow"] = "屠殺谷地",
	["Slaughter Square"] = "屠殺廣場",
	["Sleeping Gorge"] = "沉睡峽谷",
	["Slicky Stream"] = "滑石溪",
	["Slingtail Pits"] = "彈尾坑",
	["Slitherblade Shore"] = "滑刃水濱",
	["Slithering Cove"] = "巨痕灣",
	["Slither Rock"] = "滑石",
	["Sludgeguard Tower"] = "泥衛哨塔",
	["Smuggler's Scar"] = "走私者之痕",
	["Snicklefritz Mine"] = "斯尼克菲茲礦坑",
	["Snowblind Hills"] = "雪盲丘",
	["Snowblind Terrace"] = "雪盲殿堂",
	["Snowden Chalet"] = "雪山農舍",
	["Snowdrift Dojo"] = "雪迅道場",
	["Snowdrift Plains"] = "雪迅平原",
	["Snowfall Glade"] = "落雪林地",
	["Snowfall Graveyard"] = "落雪墓地",
	["Socrethar's Seat"] = "索奎薩爾的領地",
	["Sofera's Naze"] = "索菲亞高地",
	["Soggy's Gamble"] = "濕佬的賭注",
	["Solace Glade"] = "慰藉之林",
	["Solliden Farmstead"] = "索利丹農莊",
	["Solstice Village"] = "季至村",
	["Sorlof's Strand"] = "索洛夫水岸",
	["Sorrow Hill"] = "悔恨嶺",
	["Sorrow Hill Crypt"] = "悔恨嶺墓穴",
	Sorrowmurk = "憂傷濕地",
	["Sorrow Wing Point"] = "憂傷之翼哨站",
	["Soulgrinder's Barrow"] = "靈魂研磨者獸穴",
	["Southbreak Shore"] = "塔納利斯南海",
	["South Common Hall"] = "南會議廳",
	["Southern Barrens"] = "南貧瘠之地",
	["Southern Gold Road"] = "南黃金之路",
	["Southern Rampart"] = "南方堡壘",
	["Southern Rocketway"] = "南方火箭道",
	["Southern Rocketway Terminus"] = "南方火箭道終點",
	["Southern Savage Coast"] = "南野人海岸",
	["Southfury River"] = "怒水河",
	["Southfury Watershed"] = "怒水河氾濫平原",
	["South Gate Outpost"] = "南門崗哨",
	["South Gate Pass"] = "南門小徑",
	["Southmaul Tower"] = "南槌哨塔",
	["Southmoon Ruins"] = "南月廢墟",
	["South Pavilion"] = "南亭閣",
	["Southpoint Gate"] = "南點大門",
	["South Point Station"] = "南點抽水站",
	["Southpoint Tower"] = "南點哨塔",
	["Southridge Beach"] = "南山海灘",
	["Southsea Holdfast"] = "南海營地",
	["South Seas"] = "南海",
	Southshore = "南海鎮",
	["Southshore Town Hall"] = "南海鎮大廳",
	["South Spire"] = "南部尖塔",
	["South Tide's Run"] = "南流海岸",
	["Southwind Cleft"] = "南風斷崖",
	["Southwind Village"] = "南風村",
	["Sparkrocket Outpost"] = "閃亮火箭哨站",
	["Sparksocket Minefield"] = "炫臼礦區",
	["Sparktouched Haven"] = "炫觸避風港",
	["Sparring Hall"] = "爭吵大廳",
	["Spearborn Encampment"] = "矛生駐營",
	Spearhead = "矛頭",
	["Speedbarge Bar"] = "高速駁船酒吧",
	Spellsails = "魔帆號",
	["Spinebreaker Mountains"] = "斷脊氏族山脈",
	["Spinebreaker Pass"] = "斷脊氏族小徑",
	["Spinebreaker Post"] = "斷脊氏族崗哨",
	["Spinebreaker Ridge"] = "斷脊山脈",
	["Spiral of Thorns"] = "荊棘螺旋",
	["Spire of Blood"] = "鮮血尖塔",
	["Spire of Decay"] = "凋零尖塔",
	["Spire of Pain"] = "苦痛尖塔",
	["Spire of Solitude"] = "孤寂尖塔",
	["Spire Throne"] = "尖塔王座",
	["Spirit Den"] = "靈魂之穴",
	["Spirit Fields"] = "靈魂原野",
	["Spirit Rise"] = "靈魂高地",
	["Spirit Rock"] = "靈魂石地",
	["Spiritsong River"] = "靈歌川",
	["Spiritsong's Rest"] = "靈歌之眠",
	["Spitescale Cavern"] = "惡鱗山洞",
	["Spitescale Cove"] = "惡鱗灣",
	["Splinterspear Junction"] = "斷矛路口",
	Splintertree = "碎木崗哨",
	["Splintertree Mine"] = "碎木礦坑",
	["Splintertree Post"] = "碎木崗哨",
	["Splithoof Crag"] = "裂蹄峭壁",
	["Splithoof Heights"] = "裂蹄陵地",
	["Splithoof Hold"] = "裂蹄堡",
	Sporeggar = "斯博格爾",
	["Sporewind Lake"] = "孢子風之湖",
	["Springtail Crag"] = "簧尾洞穴",
	["Springtail Warren"] = "簧尾地穴",
	["Spruce Point Post"] = "雲杉峰崗哨",
	["Sra'thik Incursion"] = "斯拉席克侵略哨站",
	["Sra'thik Swarmdock"] = "斯拉席克蟲群碼頭",
	["Sra'vess"] = "斯拉斐斯",
	["Sra'vess Rootchamber"] = "斯拉斐斯深根密室",
	["Sri-La Inn"] = "斯里拉客棧",
	["Sri-La Village"] = "斯里拉村",
	Stables = "獸欄",
	Stagalbog = "雄鹿泥沼",
	["Stagalbog Cave"] = "雄鹿泥沼洞穴",
	["Stagecoach Crash Site"] = "驛馬失事點",
	["Staghelm Point"] = "鹿盔崗哨",
	["Staging Balcony"] = "閱兵臺",
	["Stairway to Honor"] = "榮耀之階",
	["Starbreeze Village"] = "星風村",
	["Stardust Spire"] = "星塵尖塔",
	["Starfall Village"] = "墜星村",
	["Stars' Rest"] = "繁星之眠",
	["Stasis Block: Maximus"] = "停滯區:麥希莫斯",
	["Stasis Block: Trion"] = "停滯區:提恩",
	["Steam Springs"] = "蒸汽之泉",
	["Steamwheedle Port"] = "熱砂港",
	["Steel Gate"] = "鋼鐵之門",
	["Steelgrill's Depot"] = "鋼架補給站",
	["Steeljaw's Caravan"] = "鋼顎商隊",
	["Steelspark Station"] = "鋼火崗哨",
	["Stendel's Pond"] = "斯特登的池塘",
	["Stillpine Hold"] = "靜松要塞",
	["Stillwater Pond"] = "靜水池",
	["Stillwhisper Pond"] = "靜語池",
	Stonard = "斯通納德",
	["Stonebreaker Camp"] = "碎石營地",
	["Stonebreaker Hold"] = "碎石堡",
	["Stonebull Lake"] = "石牛湖",
	["Stone Cairn Lake"] = "石碑湖",
	Stonehearth = "石爐",
	["Stonehearth Bunker"] = "石爐碉堡",
	["Stonehearth Graveyard"] = "石爐墓地",
	["Stonehearth Outpost"] = "石爐哨站",
	["Stonemaul Hold"] = "石槌堡",
	["Stonemaul Ruins"] = "石槌廢墟",
	["Stone Mug Tavern"] = "石杯客棧",
	Stoneplow = "石犁村",
	["Stoneplow Fields"] = "石犁原",
	["Stone Sentinel's Overlook"] = "石頭哨兵瞰臺",
	["Stonesplinter Valley"] = "石裂之谷",
	["Stonetalon Bomb"] = "石爪炸彈",
	["Stonetalon Mountains"] = "石爪山脈",
	["Stonetalon Pass"] = "石爪小徑",
	["Stonetalon Peak"] = "石爪峰",
	["Stonewall Canyon"] = "石鐮峽谷",
	["Stonewall Lift"] = "石牆升降梯",
	["Stoneward Prison"] = "石衛監獄",
	Stonewatch = "石望",
	["Stonewatch Falls"] = "石望瀑布",
	["Stonewatch Keep"] = "石望要塞",
	["Stonewatch Tower"] = "石望哨塔",
	["Stonewrought Dam"] = "巨石水壩",
	["Stonewrought Pass"] = "石壩小徑",
	["Storm Cliffs"] = "暴風崖",
	Stormcrest = "風暴頂",
	["Stormfeather Outpost"] = "風暴之羽崗哨",
	["Stormglen Village"] = "颶谷村",
	["Storm Peaks"] = "風暴群山",
	["Stormpike Graveyard"] = "雷矛墓地",
	["Stormrage Barrow Dens"] = "怒風獸穴",
	["Stormsea Landing"] = "狂濤港",
	["Storm's Fury Wreckage"] = "風暴之怒殘骸",
	["Stormstout Brewery"] = "風暴烈酒酒坊",
	["Stormstout Brewery Interior"] = "風暴烈酒酒坊內部",
	["Stormstout Brewhall"] = "風暴烈酒釀酒場",
	Stormwind = "暴風城",
	["Stormwind City"] = "暴風城",
	["Stormwind City Cemetery"] = "暴風城墓園",
	["Stormwind City Outskirts"] = "暴風城郊區",
	["Stormwind Gunship Pandaria Start Area"] = "暴風城砲艇潘達利亞起始區域",
	["Stormwind Harbor"] = "暴風港",
	["Stormwind Keep"] = "暴風要塞",
	["Stormwind Lake"] = "暴風湖",
	["Stormwind Mountains"] = "暴風山脈",
	["Stormwind Stockade"] = "暴風城監獄",
	["Stormwind Vault"] = "暴風城地窖",
	["Stoutlager Inn"] = "烈酒旅店",
	Strahnbrad = "斯坦恩布萊德",
	["Strand of the Ancients"] = "遠祖灘頭",
	["Stranglethorn Vale"] = "荊棘谷",
	Stratholme = "斯坦索姆",
	["Stratholme Entrance"] = "斯坦索姆入口",
	["Stratholme - Main Gate"] = "斯坦索姆 - 主門",
	["Stratholme - Service Entrance"] = "斯坦索姆 - 僕從入口",
	["Stratholme Service Entrance"] = "斯坦索姆僕從入口",
	["Stromgarde Keep"] = "激流堡",
	["Strongarm Airstrip"] = "強臂簡易機場",
	["STV Diamond Mine BG"] = "荊棘谷鑽石礦戰場",
	["Stygian Bounty"] = "冥河賞金號",
	["Sub zone"] = "子區域",
	["Sulfuron Keep"] = "薩弗隆要塞",
	["Sulfuron Keep Courtyard"] = "薩弗隆要塞中庭",
	["Sulfuron Span"] = "薩弗隆大橋",
	["Sulfuron Spire"] = "薩弗隆之塔",
	["Sullah's Sideshow"] = "蘇拉的雜耍帳篷",
	["Summer's Rest"] = "盛夏之眠",
	["Summoners' Tomb"] = "召喚師之墓",
	["Sunblossom Hill"] = "日綻山丘",
	["Suncrown Village"] = "日冠村",
	["Sundown Marsh"] = "日落沼澤",
	["Sunfire Point"] = "烈日火焰崗哨",
	["Sunfury Hold"] = "日怒要塞",
	["Sunfury Spire"] = "日怒尖塔",
	["Sungraze Peak"] = "日牧山峰",
	["Sunken Dig Site"] = "沉沒的挖掘場",
	["Sunken Temple"] = "沉沒的神廟",
	["Sunken Temple Entrance"] = "沉沒的神廟入口",
	["Sunreaver Pavilion"] = "奪日者亭閣",
	["Sunreaver's Command"] = "奪日者指揮所",
	["Sunreaver's Sanctuary"] = "奪日者聖堂",
	["Sun Rock Retreat"] = "烈日石居",
	["Sunsail Anchorage"] = "日帆泊地",
	["Sunsoaked Meadow"] = "沐日牧原",
	["Sunsong Ranch"] = "日歌農莊",
	["Sunspring Post"] = "日春崗哨",
	["Sun's Reach Armory"] = "日境軍械庫",
	["Sun's Reach Harbor"] = "日境港",
	["Sun's Reach Sanctum"] = "日境聖所",
	["Sunstone Terrace"] = "日長石露台",
	["Sunstrider Isle"] = "逐日者之島",
	["Sunveil Excursion"] = "蔽日旅團",
	["Sunwatcher's Ridge"] = "日衛者山脊",
	["Sunwell Plateau"] = "太陽之井高地",
	["Supply Caravan"] = "補給商隊",
	["Surge Needle"] = "極濤磁針",
	["Surveyors' Outpost"] = "勘查員哨站",
	Surwich = "瑟威奇",
	["Svarnos' Cell"] = "斯瓦爾諾斯的牢籠",
	["Swamplight Manor"] = "水光莊園",
	["Swamp of Sorrows"] = "悲傷沼澤",
	["Swamprat Post"] = "斯溫派特崗哨",
	["Swiftgear Station"] = "迅輪崗哨",
	["Swindlegrin's Dig"] = "詐咧挖掘場",
	["Swindle Street"] = "騙你錢商店街",
	["Sword's Rest"] = "劍息之地",
	Sylvanaar = "希爾瓦納",
	["Tabetha's Farm"] = "塔貝薩的農場",
	["Taelan's Tower"] = "泰蘭之塔",
	["Tahonda Ruins"] = "塔霍達廢墟",
	["Tahret Grounds"] = "塔雷特營地",
	["Tal'doren"] = "塔爾多倫",
	["Talismanic Textiles"] = "咒符織品店",
	["Tallmug's Camp"] = "高杯營地",
	["Talonbranch Glade"] = "刺枝林地",
	["Talonbranch Glade "] = "刺枝林地",
	["Talondeep Pass"] = "深爪小徑",
	["Talondeep Vale"] = "深爪谷",
	["Talon Stand"] = "魔爪看臺",
	Talramas = "塔爾拉瑪斯",
	["Talrendis Point"] = "塔倫迪斯營地",
	Tanaris = "塔納利斯",
	["Tanaris Desert"] = "塔納利斯沙漠",
	["Tanks for Everything"] = "萬物皆可坦",
	["Tanner Camp"] = "製皮匠營地",
	["Tarren Mill"] = "塔倫米爾",
	["Tasters' Arena"] = "品酒師競技場",
	["Taunka'le Village"] = "坦卡雷村",
	["Tavern in the Mists"] = "霧隱客棧",
	["Tazz'Alaor"] = "塔薩洛爾",
	["Tear Down This Wall!"] = "突破城牆!",
	["Teegan's Expedition"] = "提根遠征隊",
	["Teeming Burrow"] = "繁殖地穴",
	Telaar = "泰拉",
	["Telaari Basin"] = "泰拉蕊盆地",
	["Tel'athion's Camp"] = "泰勒希歐營地",
	Teldrassil = "泰達希爾",
	Telredor = "泰倫多爾",
	["Tempest Bridge"] = "風暴橋",
	["Tempest Keep"] = "風暴要塞",
	["Tempest Keep: The Arcatraz"] = "風暴要塞:亞克崔茲",
	["Tempest Keep - The Arcatraz Entrance"] = "風暴要塞 - 亞克崔茲入口",
	["Tempest Keep: The Botanica"] = "風暴要塞:波塔尼卡",
	["Tempest Keep - The Botanica Entrance"] = "風暴要塞 - 波塔尼卡入口",
	["Tempest Keep: The Mechanar"] = "風暴要塞:麥克納爾",
	["Tempest Keep - The Mechanar Entrance"] = "風暴要塞 - 麥克納爾入口",
	["Tempest's Reach"] = "暴風雨之境",
	["Temple City of En'kilah"] = "恩吉拉聖城",
	["Temple Hall"] = "神殿大廳",
	["Temple of Ahn'Qiraj"] = "安其拉神廟",
	["Temple of Arkkoran"] = "亞考蘭神殿",
	["Temple of Asaad"] = "亞沙德神廟",
	["Temple of Bethekk"] = "比塞克神廟",
	["Temple of Earth"] = "大地神殿",
	["Temple of Five Dawns"] = "五晨寺",
	["Temple of Invention"] = "發明神殿",
	["Temple of Kotmogu"] = "科特魔古神廟",
	["Temple of Life"] = "生命神殿",
	["Temple of Order"] = "秩序神殿",
	["Temple of Storms"] = "風暴神殿",
	["Temple of Telhamat"] = "特爾哈曼神廟",
	["Temple of the Forgotten"] = "遺忘神殿",
	["Temple of the Jade Serpent"] = "玉蛟寺",
	["Temple of the Moon"] = "月神殿",
	["Temple of the Red Crane"] = "紅鶴寺",
	["Temple of the White Tiger"] = "白虎寺",
	["Temple of Uldum"] = "奧丹姆神廟",
	["Temple of Winter"] = "凜冬神殿",
	["Temple of Wisdom"] = "智慧神殿",
	["Temple of Zin-Malor"] = "辛瑪洛神殿",
	["Temple Summit"] = "神廟頂層",
	["Tenebrous Cavern"] = "陰暗洞穴",
	["Terokkar Forest"] = "泰洛卡森林",
	["Terokk's Rest"] = "泰洛克之墓",
	["Terrace of Endless Spring"] = "豐泉台",
	["Terrace of Gurthan"] = "葛薩恩臺地",
	["Terrace of Light"] = "聖光露臺",
	["Terrace of Repose"] = "休息區",
	["Terrace of Ten Thunders"] = "十方雷殿",
	["Terrace of the Augurs"] = "占兆師殿堂",
	["Terrace of the Makers"] = "造物者殿堂",
	["Terrace of the Sun"] = "太陽露臺",
	["Terrace of the Tiger"] = "白虎台",
	["Terrace of the Twin Dragons"] = "雙龍台",
	Terrordale = "恐懼谷",
	["Terror Run"] = "恐懼小道",
	["Terrorweb Tunnel"] = "惡蛛隧道",
	["Terror Wing Path"] = "龍翼小徑",
	["Tethris Aran"] = "塔迪薩蘭",
	Thalanaar = "薩蘭納爾",
	["Thalassian Pass"] = "薩拉斯小徑",
	["Thalassian Range"] = "薩拉斯海脊",
	["Thal'darah Grove"] = "薩歐達拉樹林",
	["Thal'darah Overlook"] = "薩歐達拉瞰臺",
	["Thandol Span"] = "薩多爾大橋",
	["Thargad's Camp"] = "薩爾加德營地",
	["The Abandoned Reach"] = "被遺棄之境",
	["The Abyssal Maw"] = "深淵之喉",
	["The Abyssal Shelf"] = "深淵沙洲",
	["The Admiral's Den"] = "上將之穴",
	["The Agronomical Apothecary"] = "農藝藥材行",
	["The Alliance Valiants' Ring"] = "聯盟驍士競技場",
	["The Altar of Damnation"] = "詛咒祭壇",
	["The Altar of Shadows"] = "暗影祭壇",
	["The Altar of Zul"] = "祖爾祭壇",
	["The Amber Hibernal"] = "琥珀之冬",
	["The Amber Vault"] = "琥珀墓穴",
	["The Amber Womb"] = "琥珀發源地",
	["The Ancient Grove"] = "遠古樹林",
	["The Ancient Lift"] = "遠古升降梯",
	["The Ancient Passage"] = "上古通道",
	["The Antechamber"] = "前廳",
	["The Anvil of Conflagration"] = "焚焰鐵砧",
	["The Anvil of Flame"] = "烈焰鐵砧",
	["The Apothecarium"] = "鍊金房",
	["The Arachnid Quarter"] = "蜘蛛區",
	["The Arboretum"] = "落英園",
	["The Arcanium"] = "奧金區",
	["The Arcanium "] = "奧金區",
	["The Arcatraz"] = "亞克崔茲",
	["The Archivum"] = "大資料庫",
	["The Argent Stand"] = "銀白看臺",
	["The Argent Valiants' Ring"] = "銀白驍士競技場",
	["The Argent Vanguard"] = "銀白先鋒駐地",
	["The Arsenal Absolute"] = "完全軍械庫",
	["The Aspirants' Ring"] = "志士競技場",
	["The Assembly Chamber"] = "集會之廳",
	["The Assembly of Iron"] = "鐵之集會所",
	["The Athenaeum"] = "圖書館",
	["The Autumn Plains"] = "秋意原",
	["The Avalanche"] = "雪崩地",
	["The Azure Front"] = "蒼藍前線",
	["The Bamboo Wilds"] = "竹林原",
	["The Bank of Dalaran"] = "達拉然銀行",
	["The Bank of Silvermoon"] = "銀月城銀行",
	["The Banquet Hall"] = "宴會大廳",
	["The Barrier Hills"] = "阻礙之丘",
	["The Bastion of Twilight"] = "暮光堡壘",
	["The Battleboar Pen"] = "鬥豬圍欄",
	["The Battle for Gilneas"] = "吉爾尼斯之戰",
	["The Battle for Gilneas (Old City Map)"] = "吉爾尼斯之戰(舊城地圖)",
	["The Battle for Mount Hyjal"] = "海加爾山之戰",
	["The Battlefront"] = "前線",
	["The Bazaar"] = "商店街",
	["The Beast Pens"] = "獸園",
	["The Beer Garden"] = "啤酒廣場",
	["The Bite"] = "咬地",
	["The Black Breach"] = "黑色裂層",
	["The Black Market"] = "黑市",
	["The Black Morass"] = "黑色沼澤",
	["The Black Temple"] = "黑暗神廟",
	["The Black Vault"] = "黑色寶庫",
	["The Blackwald"] = "黑森林",
	["The Blazing Strand"] = "熾炎水岸",
	["The Blighted Pool"] = "荒疫之池",
	["The Blight Line"] = "荒萎線",
	["The Bloodcursed Reef"] = "血咒沙洲",
	["The Blood Furnace"] = "血熔爐",
	["The Bloodmire"] = "血腥泥潭",
	["The Bloodoath"] = "血之誓約",
	["The Blood Trail"] = "血腥崎道",
	["The Bloodwash"] = "血浴之地",
	["The Boiling Crustacean"] = "翻騰甲殼",
	["The Bombardment"] = "轟炸地",
	["The Bonefields"] = "白骨原野",
	["The Bone Pile"] = "白骨之堆",
	["The Bones of Nozronn"] = "諾茲朗之骨",
	["The Bone Wastes"] = "白骨荒野",
	["The Boneyard"] = "骨墳",
	["The Borean Wall"] = "北風之牆",
	["The Botanica"] = "波塔尼卡",
	["The Bradshaw Mill"] = "布萊德蕭磨坊",
	["The Breach"] = "缺口",
	["The Briny Cutter"] = "分水號",
	["The Briny Muck"] = "潮間帶",
	["The Briny Pinnacle"] = "海水之巔",
	["The Broken Bluffs"] = "破碎崖",
	["The Broken Front"] = "破碎前線",
	["The Broken Hall"] = "破碎之廳",
	["The Broken Hills"] = "破碎之丘",
	["The Broken Stair"] = "破碎樓梯",
	["The Broken Temple"] = "破碎神殿",
	["The Broodmother's Nest"] = "育母之巢",
	["The Brood Pit"] = "孵育之淵",
	["The Bulwark"] = "亡靈壁壘",
	["The Burlap Trail"] = "粗麻小徑",
	["The Burlap Valley"] = "粗麻谷",
	["The Burlap Waystation"] = "粗麻小站",
	["The Burning Corridor"] = "燃燒迴廊",
	["The Butchery"] = "屠宰房",
	["The Cache of Madness"] = "狂性儲納所",
	["The Caller's Chamber"] = "召喚者之廳",
	["The Canals"] = "運河",
	["The Cape of Stranglethorn"] = "荊棘谷海角",
	["The Carrion Fields"] = "腐屍農地",
	["The Catacombs"] = "地下墓穴",
	["The Cauldron"] = "大熔爐",
	["The Cauldron of Flames"] = "火焰熔爐",
	["The Cave"] = "洞穴",
	["The Celestial Planetarium"] = "星穹渾天儀",
	["The Celestial Vault"] = "天尊寶庫",
	["The Celestial Watch"] = "天文觀測台",
	["The Cemetary"] = "陵墓",
	["The Cerebrillum"] = "腦室",
	["The Charred Vale"] = "焦炭谷",
	["The Chilled Quagmire"] = "寒冽泥淖",
	["The Chum Bucket"] = "魚餌之甕",
	["The Circle of Cinders"] = "灰燼之環",
	["The Circle of Life"] = "生命之環",
	["The Circle of Suffering"] = "苦難之環",
	["The Clarion Bell"] = "號角之鐘",
	["The Clash of Thunder"] = "雷鳴之廳",
	["The Clean Zone"] = "清潔區",
	["The Cleft"] = "大斷崖",
	["The Clockwerk Run"] = "發條小徑",
	["The Clutch"] = "窩巢",
	["The Clutches of Shek'zeer"] = "杉齊爾窩巢",
	["The Coil"] = "毒蛇小徑",
	["The Colossal Forge"] = "巨熔爐",
	["The Comb"] = "蜂巢",
	["The Commons"] = "平民大廳",
	["The Conflagration"] = "焚焰地",
	["The Conquest Pit"] = "征服之淵",
	["The Conservatory"] = "大溫室",
	["The Conservatory of Life"] = "生命溫室",
	["The Construct Quarter"] = "傀儡區",
	["The Cooper Residence"] = "庫珀的住所",
	["The Corridors of Ingenuity"] = "巧思迴廊",
	["The Court of Bones"] = "白骨之廷",
	["The Court of Skulls"] = "骸骨之廷",
	["The Coven"] = "集會所",
	["The Coven "] = "巫師會所",
	["The Creeping Ruin"] = "爬蟲廢墟",
	["The Crimson Assembly Hall"] = "赤紅議事堂",
	["The Crimson Cathedral"] = "赤紅大教堂",
	["The Crimson Dawn"] = "赤曦號",
	["The Crimson Hall"] = "赤紅大廳",
	["The Crimson Reach"] = "赤紅地帶",
	["The Crimson Throne"] = "赤色王座",
	["The Crimson Treader"] = "赤紅行者",
	["The Crimson Veil"] = "赤紅之霧",
	["The Crossroads"] = "十字路口",
	["The Crucible"] = "大爐缸",
	["The Crucible of Flame"] = "大爐缸",
	["The Crumbling Waste"] = "破碎荒地",
	["The Cryo-Core"] = "冬眠核心",
	["The Crystal Hall"] = "水晶大廳",
	["The Crystal Shore"] = "水晶海岸",
	["The Crystal Vale"] = "水晶谷",
	["The Crystal Vice"] = "水晶之鉗",
	["The Culling of Stratholme"] = "斯坦索姆的抉擇",
	["The Culling of Stratholme Entrance"] = "斯坦索姆的抉擇入口",
	["The Cursed Landing"] = "詛咒臺地",
	["The Dagger Hills"] = "匕首嶺",
	["The Dai-Lo Farmstead"] = "戴洛農莊",
	["The Damsel's Luck"] = "少女的好運",
	["The Dancing Serpent"] = "舞龍客棧",
	["The Dark Approach"] = "黑暗路徑",
	["The Dark Defiance"] = "黑暗挑釁",
	["The Darkened Bank"] = "暗色河灘",
	["The Dark Hollow"] = "黑暗谷地",
	["The Darkmoon Faire"] = "暗月馬戲團",
	["The Dark Portal"] = "黑暗之門",
	["The Dark Rookery"] = "黑暗孵化間",
	["The Darkwood"] = "暗木森林",
	["The Dawnchaser"] = "曦逐者",
	["The Dawning Isles"] = "黎明島",
	["The Dawning Span"] = "晨曦橋",
	["The Dawning Square"] = "曙光廣場",
	["The Dawning Stair"] = "晨曦階",
	["The Dawning Valley"] = "晨曦谷",
	["The Dead Acre"] = "死亡農地",
	["The Dead Field"] = "亡者農場",
	["The Dead Fields"] = "亡者原野",
	["The Deadmines"] = "死亡礦坑",
	["The Dead Mire"] = "死亡污泥",
	["The Dead Scar"] = "死亡之痕",
	["The Deathforge"] = "死亡熔爐",
	["The Deathknell Graves"] = "喪鐘鎮墓地",
	["The Decrepit Fields"] = "荒廢的農場",
	["The Decrepit Flow"] = "衰舊之流",
	["The Deeper"] = "斷齒深淵",
	["The Deep Reaches"] = "礦坑深層",
	["The Deepwild"] = "深野蠻荒",
	["The Defiant"] = "不屈號",
	["The Defiled Chapel"] = "遭褻瀆的禮拜堂",
	["The Den"] = "大獸穴",
	["The Den of Flame"] = "火焰洞穴",
	["The Dens of Dying"] = "垂死獸穴",
	["The Dens of the Dying"] = "垂死獸穴",
	["The Descent into Madness"] = "驟狂斜廊",
	["The Desecrated Altar"] = "褻瀆祭壇",
	["The Devil's Terrace"] = "惡魔殿堂",
	["The Devouring Breach"] = "吞噬裂層",
	["The Domicile"] = "住宅區",
	["The Domicile "] = "住宅區",
	["The Dooker Dome"] = "廢渣園地",
	["The Dor'Danil Barrow Den"] = "朵丹尼爾獸穴",
	["The Dormitory"] = "宿舍",
	["The Drag"] = "暗巷區",
	["The Dragonmurk"] = "黑龍谷",
	["The Dragon Wastes"] = "龍墳荒原",
	["The Drain"] = "排水之地",
	["The Dranosh'ar Blockade"] = "薩魯法爾防線",
	["The Drowned Reef"] = "水下暗礁",
	["The Drowned Sacellum"] = "水下廟宇",
	["The Drunken Hozen"] = "醉猴樓",
	["The Dry Hills"] = "無水嶺",
	["The Dustbowl"] = "漫塵盆地",
	["The Dust Plains"] = "塵埃平原",
	["The Eastern Earthshrine"] = "東大地神殿",
	["The Elders' Path"] = "長者之路",
	["The Emerald Summit"] = "翡翠峰",
	["The Emperor's Approach"] = "帝迎大道",
	["The Emperor's Gate"] = "帝王之門",
	["The Emperor's Reach"] = "帝王之境",
	["The Emperor's Step"] = "帝王之階",
	["The Escape From Durnholde"] = "逃離敦霍爾德",
	["The Escape from Durnholde Entrance"] = "逃離敦霍爾德入口",
	["The Eventide"] = "日暮區",
	["The Exodar"] = "艾克索達",
	["The Eye"] = "風暴要塞",
	["The Eye of Eternity"] = "永恆之眼",
	["The Eye of the Vortex"] = "巨旋風之眼",
	["The Fall of Shan Bu"] = "衫布敗亡",
	["The Farstrider Lodge"] = "遠行者小屋",
	["The Feeding Pits"] = "飼養之淵",
	["The Fel Pits"] = "惡魔深淵",
	["The Fertile Copse"] = "沃土林",
	["The Fetid Pool"] = "惡臭水池",
	["The Filthy Animal"] = "下流畜生酒店",
	["The Firehawk"] = "火鷹號",
	["The Five Sisters"] = "五仙石",
	["The Flamewake"] = "烈焰之甦",
	["The Fleshwerks"] = "血肉作坊",
	["The Flood Plains"] = "氾濫平原",
	["The Fold"] = "山間營地",
	["The Foothill Caverns"] = "丘陵洞穴",
	["The Foot of Lei Shen"] = "雷神之足",
	["The Foot Steppes"] = "足跡冷原",
	["The Forbidden Jungle"] = "禁忌叢林",
	["The Forbidding Sea"] = "禁忌之海",
	["The Forest of Shadows"] = "暗影森林",
	["The Forge of Souls"] = "眾魂熔爐",
	["The Forge of Souls Entrance"] = "眾魂熔爐入口",
	["The Forge of Supplication"] = "哀求熔爐",
	["The Forge of Wills"] = "意志熔爐",
	["The Forgotten Coast"] = "被遺忘的海岸",
	["The Forgotten Overlook"] = "遺忘瞰臺",
	["The Forgotten Pool"] = "遺忘之池",
	["The Forgotten Pools"] = "遺忘之池",
	["The Forgotten Shore"] = "遺民之濱",
	["The Forlorn Cavern"] = "荒棄的洞穴",
	["The Forlorn Mine"] = "凋落礦坑",
	["The Forsaken Front"] = "被遺忘者戰事前線",
	["The Foul Pool"] = "邪惡池塘",
	["The Frigid Tomb"] = "嚴寒陵寢",
	["The Frost Queen's Lair"] = "冰霜之后的巢穴",
	["The Frostwing Halls"] = "霜翼大廳",
	["The Frozen Glade"] = "冰凍林地",
	["The Frozen Halls"] = "冰封大廳",
	["The Frozen Mine"] = "冰凍礦坑",
	["The Frozen Sea"] = "冰凍之海",
	["The Frozen Throne"] = "冰封王座",
	["The Fungal Vale"] = "蘑菇谷",
	["The Furnace"] = "熔爐",
	["The Gaping Chasm"] = "大裂口",
	["The Gatehouse"] = "警衛站",
	["The Gatehouse "] = "警衛站",
	["The Gate of Unending Cycles"] = "無盡輪迴之門",
	["The Gauntlet"] = "街巷",
	["The Geyser Fields"] = "水泉原野",
	["The Ghastly Confines"] = "恐怖的監禁",
	["The Gilded Foyer"] = "金飾門廳",
	["The Gilded Gate"] = "鑲飾之門",
	["The Gilding Stream"] = "金箔溪",
	["The Glimmering Pillar"] = "微光之柱",
	["The Golden Gateway"] = "黃金門",
	["The Golden Hall"] = "黃金大廳",
	["The Golden Lantern"] = "金燈籠",
	["The Golden Pagoda"] = "黃金寶塔",
	["The Golden Plains"] = "金色平原",
	["The Golden Rose"] = "金玫樓",
	["The Golden Stair"] = "黃金階梯",
	["The Golden Terrace"] = "金輝臺",
	["The Gong of Hope"] = "希望之鑼",
	["The Grand Ballroom"] = "華麗的跳舞大廳",
	["The Grand Vestibule"] = "大門廊",
	["The Great Arena"] = "大競技場",
	["The Great Divide"] = "大分水嶺",
	["The Great Fissure"] = "大裂縫",
	["The Great Forge"] = "大鍛爐",
	["The Great Gate"] = "雄偉之門",
	["The Great Lift"] = "升降梯",
	["The Great Ossuary"] = "屍骨儲藏所",
	["The Great Sea"] = "無盡之海",
	["The Great Tree"] = "巨偉之樹",
	["The Great Wheel"] = "巨大水車",
	["The Green Belt"] = "綠帶草地",
	["The Greymane Wall"] = "葛雷邁恩之牆",
	["The Grim Guzzler"] = "黑鐵酒吧",
	["The Grinding Quarry"] = "碾石場",
	["The Grizzled Den"] = "灰色洞穴",
	["The Grummle Bazaar"] = "咕嚕摩市集",
	["The Guardhouse"] = "守衛室",
	["The Guest Chambers"] = "客房",
	["The Gullet"] = "水道",
	["The Halfhill Market"] = "半丘市集",
	["The Half Shell"] = "半殼號",
	["The Hall of Blood"] = "血之大廳",
	["The Hall of Gears"] = "齒輪大廳",
	["The Hall of Lights"] = "聖光大廳",
	["The Hall of Respite"] = "緩刑大廳",
	["The Hall of Statues"] = "雕像廳",
	["The Hall of the Serpent"] = "蛟龍廳",
	["The Hall of Tiles"] = "磚瓦廳",
	["The Halls of Reanimation"] = "再活化大廳",
	["The Halls of Winter"] = "凜冬之廳",
	["The Hand of Gul'dan"] = "古爾丹火山",
	["The Harborage"] = "避難營",
	["The Hatchery"] = "孵化室",
	["The Headland"] = "山頭營地",
	["The Headlands"] = "西岬",
	["The Heap"] = "聚集之地",
	["The Heartland"] = "中央平原",
	["The Heart of Acherus"] = "亞榭洛之心",
	["The Heart of Jade"] = "玉之心",
	["The Hidden Clutch"] = "隱秘窩巢",
	["The Hidden Grove"] = "隱秘小林",
	["The Hidden Hollow"] = "隱匿谷地",
	["The Hidden Passage"] = "隱藏通道",
	["The Hidden Reach"] = "密徑",
	["The Hidden Reef"] = "隱秘沙洲",
	["The High Path"] = "險惡之地",
	["The High Road"] = "高地小道",
	["The High Seat"] = "王座廳",
	["The Hinterlands"] = "辛特蘭",
	["The Hoard"] = "物資庫",
	["The Hole"] = "大坑",
	["The Horde Valiants' Ring"] = "部落驍士競技場",
	["The Horrid March"] = "恐怖之界",
	["The Horsemen's Assembly"] = "騎士聚所",
	["The Howling Hollow"] = "嚎風谷地",
	["The Howling Oak"] = "咆哮橡樹",
	["The Howling Vale"] = "狼嚎谷",
	["The Hunter's Reach"] = "獵人地帶",
	["The Hushed Bank"] = "寂靜河岸",
	["The Icy Depths"] = "冰結深淵",
	["The Immortal Coil"] = "不朽之環號",
	["The Imperial Exchange"] = "帝國交易所",
	["The Imperial Granary"] = "皇家糧倉",
	["The Imperial Mercantile"] = "帝國商貿所",
	["The Imperial Seat"] = "帝王之座",
	["The Incursion"] = "侵略哨站",
	["The Infectis Scar"] = "魔刃之痕",
	["The Inferno"] = "火焰煉獄",
	["The Inner Spire"] = "內塔",
	["The Intrepid"] = "無畏號",
	["The Inventor's Library"] = "發明者圖書館",
	["The Iron Crucible"] = "鐵之爐缸",
	["The Iron Hall"] = "鐵之大廳",
	["The Iron Reaper"] = "鋼鐵收割者",
	["The Isle of Spears"] = "群矛之島",
	["The Ivar Patch"] = "伊瓦農場",
	["The Jade Forest"] = "翠玉林",
	["The Jade Vaults"] = "翠玉寶庫",
	["The Jansen Stead"] = "傑生農場",
	["The Keggary"] = "酒罈之廳",
	["The Kennel"] = "狗舍",
	["The Krasari Ruins"] = "喀撒利廢墟",
	["The Krazzworks"] = "克拉茲工坊",
	["The Laboratory"] = "實驗室",
	["The Lady Mehley"] = "梅利女士號",
	["The Lagoon"] = "瀉湖",
	["The Laughing Stand"] = "可笑的看臺",
	["The Lazy Turnip"] = "懶菁客棧",
	["The Legerdemain Lounge"] = "戲法旅舍",
	["The Legion Front"] = "軍團前線",
	["Thelgen Rock"] = "瑟根石",
	["The Librarium"] = "藏書所",
	["The Library"] = "圖書館",
	["The Lifebinder's Cell"] = "生命守縛者的牢房",
	["The Lifeblood Pillar"] = "活血之柱",
	["The Lightless Reaches"] = "無光深淵",
	["The Lion's Redoubt"] = "雄獅壁壘",
	["The Living Grove"] = "生命之林",
	["The Living Wood"] = "活木森林",
	["The LMS Mark II"] = "LMS-II號",
	["The Loch"] = "洛克湖",
	["The Long Wash"] = "長橋碼頭",
	["The Lost Fleet"] = "失落的艦隊",
	["The Lost Fold"] = "遺忘農場",
	["The Lost Isles"] = "失落群島",
	["The Lost Lands"] = "失落之地",
	["The Lost Passage"] = "失落通道",
	["The Low Path"] = "粗劣之地",
	Thelsamar = "塞爾薩瑪",
	["The Lucky Traveller"] = "祥客樓",
	["The Lyceum"] = "講學廳",
	["The Maclure Vineyards"] = "馬科倫農場",
	["The Maelstrom"] = "大漩渦",
	["The Maker's Overlook"] = "造物者瞰臺",
	["The Makers' Overlook"] = "造物者瞰臺",
	["The Makers' Perch"] = "造物者棲所",
	["The Maker's Rise"] = "造物者高地",
	["The Maker's Terrace"] = "造物者遺跡",
	["The Manufactory"] = "製造廠",
	["The Marris Stead"] = "瑪瑞斯農場",
	["The Marshlands"] = "沼澤地",
	["The Masonary"] = "石匠區",
	["The Master's Cellar"] = "大師的地窖",
	["The Master's Glaive"] = "主宰之劍",
	["The Maul"] = "巨槌競技場",
	["The Maw of Madness"] = "瘋狂之口",
	["The Mechanar"] = "麥克納爾",
	["The Menagerie"] = "展示廳",
	["The Menders' Stead"] = "治癒者崗哨",
	["The Merchant Coast"] = "商旅海岸",
	["The Militant Mystic"] = "軍事狂秘術店",
	["The Military Quarter"] = "軍事區",
	["The Military Ward"] = "軍事區",
	["The Mind's Eye"] = "心靈之眼",
	["The Mirror of Dawn"] = "黎明之鏡",
	["The Mirror of Twilight"] = "曦光之鏡",
	["The Molsen Farm"] = "摩爾森農場",
	["The Molten Bridge"] = "熔火之橋",
	["The Molten Core"] = "熔火之心",
	["The Molten Fields"] = "熔岩原野",
	["The Molten Flow"] = "熔岩之流",
	["The Molten Span"] = "熔岩之橋",
	["The Mor'shan Rampart"] = "莫爾杉壁壘",
	["The Mor'Shan Ramparts"] = "莫爾杉壁壘",
	["The Mosslight Pillar"] = "苔光之柱",
	["The Mountain Den"] = "山中獸穴",
	["The Murder Pens"] = "謀殺者圍欄",
	["The Mystic Ward"] = "秘法區",
	["The Necrotic Vault"] = "死靈穹殿",
	["The Nexus"] = "奧核之心",
	["The Nexus Entrance"] = "奧核之心入口",
	["The Nightmare Scar"] = "惡夢之痕",
	["The North Coast"] = "北部海岸",
	["The North Sea"] = "北海",
	["The Nosebleeds"] = "鼻血之地",
	["The Noxious Glade"] = "劇毒林地",
	["The Noxious Hollow"] = "毒水谷",
	["The Noxious Lair"] = "腐化之巢",
	["The Noxious Pass"] = "腐毒小徑",
	["The Oblivion"] = "忘卻號",
	["The Observation Ring"] = "觀察之環",
	["The Obsidian Sanctum"] = "黑曜聖所",
	["The Oculus"] = "奧核之眼",
	["The Oculus Entrance"] = "奧核之眼入口",
	["The Old Barracks"] = "舊兵營",
	["The Old Dormitory"] = "舊宿舍",
	["The Old Port Authority"] = "舊港務局",
	["The Opera Hall"] = "歌劇大廳",
	["The Oracle Glade"] = "神諭林地",
	["The Outer Ring"] = "外環區",
	["The Overgrowth"] = "蔓生之地",
	["The Overlook"] = "瞰臺",
	["The Overlook Cliffs"] = "望海崖",
	["The Overlook Inn"] = "瞰臺客棧",
	["The Ox Gate"] = "玄牛關",
	["The Pale Roost"] = "蒼白棲息地",
	["The Park"] = "花園",
	["The Path of Anguish"] = "苦痛之路",
	["The Path of Conquest"] = "征服之路",
	["The Path of Corruption"] = "腐化之路",
	["The Path of Glory"] = "光榮之路",
	["The Path of Iron"] = "鐵之途",
	["The Path of the Lifewarden"] = "生命守望者之路",
	["The Phoenix Hall"] = "鳳凰大廳",
	["The Pillar of Ash"] = "灰燼之柱",
	["The Pipe"] = "大管道",
	["The Pit of Criminals"] = "罪惡之池",
	["The Pit of Fiends"] = "魔鬼之淵",
	["The Pit of Narjun"] = "那金之淵",
	["The Pit of Refuse"] = "拋棄之池",
	["The Pit of Sacrifice"] = "獻祭坑",
	["The Pit of Scales"] = "鱗片之淵",
	["The Pit of the Fang"] = "尖牙之淵",
	["The Plague Quarter"] = "瘟疫區",
	["The Plagueworks"] = "瘟疫工坊",
	["The Pool of Ask'ar"] = "阿斯卡之池",
	["The Pools of Vision"] = "預見之池",
	["The Prison of Yogg-Saron"] = "尤格薩倫之獄",
	["The Proving Grounds"] = "試煉場",
	["The Purple Parlor"] = "紫羅蘭頂閣",
	["The Quagmire"] = "泥潭沼澤",
	["The Quaking Fields"] = "破碎曠野",
	["The Queen's Reprisal"] = "女王的報復",
	["The Raging Chasm"] = "狂怒裂谷",
	Theramore = "塞拉摩",
	["Theramore Isle"] = "塞拉摩島",
	["Theramore's Fall"] = "塞拉摩攻防戰",
	["Theramore's Fall (A)"] = "塞拉摩攻防戰(聯盟)",
	["Theramore's Fall (H)"] = "塞拉摩攻防戰(部落)",
	["Theramore's Fall Phase"] = "塞拉摩攻防戰階段",
	["The Rangers' Lodge"] = "遊俠小屋",
	["Therazane's Throne"] = "瑟拉贊恩王座",
	["The Red Reaches"] = "紅色海岸",
	["The Refectory"] = "聖殿膳所",
	["The Regrowth"] = "癒合之地",
	["The Reliquary"] = "聖骨室",
	["The Repository"] = "帝祠",
	["The Reservoir"] = "蓄水池",
	["The Restless Front"] = "無寧前線",
	["The Ridge of Ancient Flame"] = "上古烈焰山脊",
	["The Rift"] = "裂隙",
	["The Ring of Balance"] = "平衡競技場",
	["The Ring of Blood"] = "血色競技場",
	["The Ring of Champions"] = "勇士競技場",
	["The Ring of Inner Focus"] = "心靈專注競技場",
	["The Ring of Trials"] = "試煉競技場",
	["The Ring of Valor"] = "勇武競技場",
	["The Riptide"] = "斬浪號",
	["The Riverblade Den"] = "川刃獸穴",
	["Thermal Vents"] = "熱能噴口",
	["The Roiling Gardens"] = "混濁之園",
	["The Rolling Gardens"] = "翻轉花園",
	["The Rolling Plains"] = "草海平原",
	["The Rookery"] = "孵化間",
	["The Rotting Orchard"] = "爛果園",
	["The Rows"] = "阡陌",
	["The Royal Exchange"] = "皇家交易所",
	["The Ruby Sanctum"] = "晶紅聖所",
	["The Ruined Reaches"] = "廢墟海岸",
	["The Ruins of Kel'Theril"] = "凱斯利爾廢墟",
	["The Ruins of Ordil'Aran"] = "奧迪拉蘭廢墟",
	["The Ruins of Stardust"] = "星塵廢墟",
	["The Rumble Cage"] = "加基森競技場",
	["The Rustmaul Dig Site"] = "鏽槌挖掘場",
	["The Sacred Grove"] = "神聖樹林",
	["The Salty Sailor Tavern"] = "水手之家旅店",
	["The Sanctum"] = "聖所",
	["The Sanctum of Blood"] = "血之聖所",
	["The Savage Coast"] = "野人海岸",
	["The Savage Glen"] = "蠻荒谷",
	["The Savage Thicket"] = "蠻荒灌木林",
	["The Scalding Chasm"] = "滾燙裂口",
	["The Scalding Pools"] = "沸水池",
	["The Scarab Dais"] = "甲蟲之台",
	["The Scarab Wall"] = "甲蟲之牆",
	["The Scarlet Basilica"] = "血色十字軍教堂",
	["The Scarlet Bastion"] = "血色十字軍堡壘",
	["The Scorched Grove"] = "烈焰邊境",
	["The Scorched Plain"] = "烈焰平原",
	["The Scrap Field"] = "廢棄農場",
	["The Scrapyard"] = "廢料場",
	["The Screaming Hall"] = "尖嘯大廳",
	["The Screaming Reaches"] = "尖嘯河岸",
	["The Screeching Canyon"] = "尖嘯峽谷",
	["The Scribe of Stormwind"] = "暴風城銘文抄寫",
	["The Scribes' Sacellum"] = "雕銘師禮拜堂",
	["The Scrollkeeper's Sanctum"] = "藏卷閣",
	["The Scullery"] = "貯藏室",
	["The Scullery "] = "貯藏室",
	["The Seabolt"] = "海矢號",
	["The Seabreach Flow"] = "海裂之湧",
	["The Sealed Hall"] = "封印大廳",
	["The Sea of Cinders"] = "灰燼之海",
	["The Sea Reaver's Run"] = "海劫者航道",
	["The Searing Gateway"] = "灼熱閘道",
	["The Sea Wolf"] = "海狼號",
	["The Secret Aerie"] = "秘密鷹巢",
	["The Secret Lab"] = "秘密實驗室",
	["The Secrets of Ragefire"] = "怒焰之秘",
	["The Seer's Library"] = "先知書庫",
	["The Sepulcher"] = "瑟伯切爾",
	["The Severed Span"] = "切裂的大橋",
	["The Sewer"] = "下水道",
	["The Shadow Stair"] = "暗影階梯",
	["The Shadow Throne"] = "暗影王座",
	["The Shadow Vault"] = "暗影穹殿",
	["The Shady Nook"] = "林蔭小徑",
	["The Shaper's Terrace"] = "塑造者殿堂",
	["The Shattered Halls"] = "破碎大廳",
	["The Shattered Strand"] = "碎裂水岸",
	["The Shattered Walkway"] = "破碎走道",
	["The Shepherd's Gate"] = "牧羊人之門",
	["The Shifting Mire"] = "流沙泥潭",
	["The Shimmering Deep"] = "閃耀深淵",
	["The Shimmering Flats"] = "閃光平原",
	["The Shining Strand"] = "閃光湖岸",
	["The Shrine of Aessina"] = "艾森娜神殿",
	["The Shrine of Eldretharr"] = "艾德雷斯神殿",
	["The Silent Sanctuary"] = "靜默聖地",
	["The Silkwood"] = "絲林",
	["The Silver Blade"] = "銀刃號",
	["The Silver Enclave"] = "白銀領區",
	["The Singing Grove"] = "歌唱林地",
	["The Singing Pools"] = "頌唱之池",
	["The Sin'loren"] = "辛洛倫",
	["The Skeletal Reef"] = "骸骨沙洲",
	["The Skittering Dark"] = "粘絲洞",
	["The Skull Warren"] = "顱骨區",
	["The Skunkworks"] = "臭鼬工坊",
	["The Skybreaker"] = "破天者號",
	["The Skyfire"] = "天火號",
	["The Skyreach Pillar"] = "擎天之柱",
	["The Slag Pit"] = "熔渣之池",
	["The Slaughtered Lamb"] = "已宰的羔羊",
	["The Slaughter House"] = "屠宰房",
	["The Slave Pens"] = "奴隸監獄",
	["The Slave Pits"] = "奴隸之坑",
	["The Slick"] = "巧滑",
	["The Slithering Scar"] = "巨痕谷",
	["The Slough of Dispair"] = "絕望泥沼",
	["The Sludge Fen"] = "淤泥沼澤",
	["The Sludge Fields"] = "淤泥農場",
	["The Sludgewerks"] = "淤泥作坊",
	["The Solarium"] = "日光之室",
	["The Solar Vigil"] = "日光崗哨",
	["The Southern Isles"] = "南方之島",
	["The Southern Wall"] = "南牆",
	["The Sparkling Crawl"] = "閃亮圍欄",
	["The Spark of Imagination"] = "創思之廳",
	["The Spawning Glen"] = "重生峽谷",
	["The Spire"] = "冰冠尖塔",
	["The Splintered Path"] = "殘破之路",
	["The Spring Road"] = "春之道",
	["The Stadium"] = "競技場",
	["The Stagnant Oasis"] = "死水綠洲",
	["The Staidridge"] = "穩固山脊",
	["The Stair of Destiny"] = "命運階梯",
	["The Stair of Doom"] = "厄運階梯",
	["The Starchaser"] = "逐星號",
	["The Star's Bazaar"] = "星之市集",
	["The Steam Pools"] = "蒸汽之池",
	["The Steamvault"] = "蒸汽洞窟",
	["The Steppe of Life"] = "生命冷原",
	["The Steps of Fate"] = "天命之階",
	["The Stinging Trail"] = "尖刺小徑",
	["The Stockade"] = "監獄",
	["The Stockpile"] = "儲藏室",
	["The Stonecore"] = "石岩之心",
	["The Stonecore Entrance"] = "石岩之心入口",
	["The Stonefield Farm"] = "斯通菲爾德農場",
	["The Stone Vault"] = "石窖",
	["The Storehouse"] = "倉庫",
	["The Stormbreaker"] = "風暴破碎者",
	["The Stormbridge"] = "風暴之橋",
	["The Storm Foundry"] = "風暴鑄造場",
	["The Storm Peaks"] = "風暴群山",
	["The Stormspire"] = "風暴之尖",
	["The Stormwright's Shelf"] = "風暴工匠沙洲",
	["The Summer Fields"] = "夏之原",
	["The Summer Terrace"] = "夏日露臺",
	["The Sundered Shard"] = "破碎裂片",
	["The Sundering"] = "大裂層",
	["The Sun Forge"] = "太陽熔爐",
	["The Sunken Ring"] = "沉沒之環",
	["The Sunset Brewgarden"] = "日落釀酒園",
	["The Sunspire"] = "日尖塔",
	["The Suntouched Pillar"] = "日觸之柱",
	["The Sunwell"] = "太陽之井",
	["The Swarming Pillar"] = "蟲群之柱",
	["The Swollen Vault"] = "天驕寶庫",
	["The Tainted Forest"] = "腐化之森",
	["The Tainted Scar"] = "腐化之痕",
	["The Talondeep Path"] = "深爪小徑",
	["The Talon Den"] = "猛禽洞穴",
	["The Tasting Room"] = "品酒室",
	["The Tempest Rift"] = "風暴裂口",
	["The Temple Gardens"] = "神殿花園",
	["The Temple of Atal'Hakkar"] = "阿塔哈卡神廟",
	["The Temple of the Jade Serpent"] = "玉蛟寺",
	["The Terrestrial Watchtower"] = "地疆瞭望塔",
	["The Thornsnarl"] = "纏結荊棘地",
	["The Threads of Fate"] = "命運織坊",
	["The Threshold"] = "臨界之線",
	["The Throne of Flame"] = "烈焰王座",
	["The Thunder Forge"] = "雷霆熔爐",
	["The Thunder Forges"] = "雷霆熔爐",
	["The Thundering Run"] = "奔雷之地",
	["The Thundering Spire"] = "雷霆尖塔",
	["The Thunderspire"] = "雷霆尖塔",
	["The Thunderwood"] = "雷林",
	["The Tidebreaker"] = "破潮者",
	["The Tidus Stair"] = "提度斯階梯",
	["The Tiger's Peak"] = "猛虎峰",
	["The Torjari Pit"] = "托加利坑",
	["The Tower of Arathor"] = "阿拉索之塔",
	["The Toxic Airfield"] = "劇毒機場",
	["The Trail of Devastation"] = "毀滅跡徑",
	["The Tranquil Grove"] = "靜謐林地",
	["The Transitus Stair"] = "隘境梯臺",
	["The Trapper's Enclave"] = "陷捕者營地",
	["The Tribunal of Ages"] = "歲月議庭",
	["The Tundrid Hills"] = "凍土嶺",
	["The Twilight Breach"] = "暮光裂層",
	["The Twilight Caverns"] = "暮光洞穴",
	["The Twilight Citadel"] = "暮光城塞",
	["The Twilight Enclave"] = "暮光領區",
	["The Twilight Gate"] = "暮光之門",
	["The Twilight Gauntlet"] = "暮光試煉",
	["The Twilight Ridge"] = "暮光山脊",
	["The Twilight Rivulet"] = "曦光之溪",
	["The Twilight Withering"] = "暮光枯萎之地",
	["The Twin Colossals"] = "雙塔山",
	["The Twisted Glade"] = "扭曲林地",
	["The Twisted Warren"] = "蜿蜒地穴",
	["The Two Fisted Brew"] = "雙拳酒坊",
	["The Unbound Thicket"] = "無縛灌木林",
	["The Underbelly"] = "城底區",
	["The Underbog"] = "深幽泥沼",
	["The Underbough"] = "榕枝崖",
	["The Undercroft"] = "墓室",
	["The Underhalls"] = "地下大廳",
	["The Undershell"] = "海殼床",
	["The Uplands"] = "高地",
	["The Upside-down Sinners"] = "倒吊深淵",
	["The Valley of Fallen Heroes"] = "逝往英雄山谷",
	["The Valley of Lost Hope"] = "逝望山谷",
	["The Vault of Lights"] = "聖光地窖",
	["The Vector Coil"] = "旋繞導航器",
	["The Veiled Cleft"] = "迷霧裂隙",
	["The Veiled Sea"] = "迷霧之海",
	["The Veiled Stair"] = "朦朧天梯",
	["The Venture Co. Mine"] = "風險投資公司礦坑",
	["The Verdant Fields"] = "青草平原",
	["The Verdant Thicket"] = "青草灌木林",
	["The Verne"] = "維恩號",
	["The Verne - Bridge"] = "維恩號－艦橋",
	["The Verne - Entryway"] = "維恩號－入口通道",
	["The Vibrant Glade"] = "鮮亮林地",
	["The Vice"] = "罪惡谷",
	["The Vicious Vale"] = "致命叢林",
	["The Viewing Room"] = "觀察室",
	["The Vile Reef"] = "暗礁海",
	["The Violet Citadel"] = "紫羅蘭城塞",
	["The Violet Citadel Spire"] = "紫羅蘭城塞尖塔",
	["The Violet Gate"] = "紫羅蘭之門",
	["The Violet Hold"] = "紫羅蘭堡",
	["The Violet Spire"] = "紫羅蘭尖塔",
	["The Violet Tower"] = "紫羅蘭之塔",
	["The Vortex Fields"] = "漩渦農場",
	["The Vortex Pinnacle"] = "漩渦尖塔",
	["The Vortex Pinnacle Entrance"] = "漩渦尖塔入口",
	["The Wailing Caverns"] = "哀嚎洞穴",
	["The Wailing Ziggurat"] = "悲嘯通靈塔",
	["The Waking Halls"] = "喚醒之廳",
	["The Wandering Isle"] = "漂流島",
	["The Warlord's Garrison"] = "督軍要塞",
	["The Warlord's Terrace"] = "督軍殿堂",
	["The Warp Fields"] = "扭曲原野",
	["The Warp Piston"] = "星移活塞",
	["The Wavecrest"] = "浪峰號",
	["The Weathered Nook"] = "老屋",
	["The Weeping Cave"] = "哭泣之洞",
	["The Western Earthshrine"] = "西大地神殿",
	["The Westrift"] = "西裂峽",
	["The Whelping Downs"] = "幼龍丘陵",
	["The Whipple Estate"] = "維普爾莊園",
	["The Wicked Coil"] = "敗德螺旋",
	["The Wicked Grotto"] = "邪惡洞穴",
	["The Wicked Tunnels"] = "邪惡隧道",
	["The Widening Deep"] = "漸展裂谷",
	["The Widow's Clutch"] = "寡婦之攫",
	["The Widow's Wail"] = "寡婦之嚎",
	["The Wild Plains"] = "野生原",
	["The Wild Shore"] = "蠻荒海岸",
	["The Winding Halls"] = "蜿蜒大廳",
	["The Windrunner"] = "風行者號",
	["The Windspire"] = "風旋之地",
	["The Wollerton Stead"] = "沃勒頓農場",
	["The Wonderworks"] = "神奇玩具屋",
	["The Wood of Staves"] = "杖木林",
	["The World Tree"] = "世界之樹",
	["The Writhing Deep"] = "痛苦深淵",
	["The Writhing Haunt"] = "苦痛鬼屋",
	["The Yaungol Advance"] = "揚古先遣營地",
	["The Yorgen Farmstead"] = "猶根農場",
	["The Zandalari Vanguard"] = "贊達拉先鋒駐地",
	["The Zoram Strand"] = "佐拉姆海岸",
	["Thieves Camp"] = "盜賊營地",
	["Thirsty Alley"] = "渴酒巷",
	["Thistlefur Hold"] = "薊皮堡",
	["Thistlefur Village"] = "薊皮村",
	["Thistleshrub Valley"] = "灌木谷",
	["Thondroril River"] = "索多里爾河",
	["Thoradin's Wall"] = "索拉丁之牆",
	["Thorium Advance"] = "瑟銀先遣營地",
	["Thorium Point"] = "瑟銀哨塔",
	["Thor Modan"] = "鐸爾莫丹",
	["Thornfang Hill"] = "棘牙丘陵",
	["Thorn Hill"] = "荊棘嶺",
	["Thornmantle's Hideout"] = "刺鬃的藏身處",
	["Thorson's Post"] = "托爾森崗哨",
	["Thorvald's Camp"] = "索瓦爾德營地",
	["Thousand Needles"] = "千針石林",
	Thrallmar = "索爾瑪",
	["Thrallmar Mine"] = "索爾瑪礦坑",
	["Three Corners"] = "三角路口",
	["Throne of Ancient Conquerors"] = "古代征服者王座",
	["Throne of Kil'jaeden"] = "基爾加丹王座",
	["Throne of Neptulon"] = "奈普圖隆王座",
	["Throne of the Apocalypse"] = "天啟王座",
	["Throne of the Damned"] = "被詛咒的王座",
	["Throne of the Elements"] = "元素王座",
	["Throne of the Four Winds"] = "四風王座",
	["Throne of the Tides"] = "海潮王座",
	["Throne of the Tides Entrance"] = "海潮王座入口",
	["Throne of Thunder"] = "雷霆王座",
	["Throne of Tides"] = "海潮王座",
	["Thrym's End"] = "瑟瑞姆之歿",
	["Thunder Axe Fortress"] = "雷斧堡壘",
	Thunderbluff = "雷霆崖",
	["Thunder Bluff"] = "雷霆崖",
	["Thunderbrew Distillery"] = "雷酒釀酒廠",
	["Thunder Cleft"] = "雷霆斷崖",
	Thunderfall = "雷殞之地",
	["Thunder Falls"] = "雷霆瀑布",
	["Thunderfoot Farm"] = "雷足田地",
	["Thunderfoot Fields"] = "雷足牧地",
	["Thunderfoot Inn"] = "雷足客棧",
	["Thunderfoot Ranch"] = "雷足農莊",
	["Thunder Hold"] = "雷鳴要塞",
	["Thunderhorn Water Well"] = "雷角水井",
	["Thundering Overlook"] = "雷電瞰臺",
	["Thunder Island Alliance Hub"] = "雷王島聯盟中心",
	["Thunder King Horde Hub"] = "雷王部落中心",
	["Thunder King's Citadel"] = "雷王城塞",
	["Thunderlord Stronghold"] = "雷霆王村",
	Thundermar = "桑德瑪",
	["Thundermar Ruins"] = "桑德瑪遺跡",
	["Thunderpaw Overlook"] = "雷爪崖",
	["Thunderpaw Refuge"] = "雷爪靜修居",
	["Thunder Peak"] = "雷霆峰",
	["Thunder Ridge"] = "雷霆山",
	["Thunder's Call"] = "雷霆之召",
	["Thunderstrike Mountain"] = "雷擊山",
	["Thunk's Abode"] = "桑克的居所",
	["Thuron's Livery"] = "薩爾倫的出租商行",
	["Tian Monastery"] = "天僧寺",
	["Tidefury Cove"] = "狂潮灣",
	["Tides' Hollow"] = "海潮洞穴",
	["Tideview Thicket"] = "潮景灌木林",
	["Tigers' Wood"] = "老虎林",
	["Timbermaw Hold"] = "木喉要塞",
	["Timbermaw Post"] = "木喉崗哨",
	["Tinkers' Court"] = "技工議會",
	["Tinker Town"] = "地精區",
	["Tiragarde Keep"] = "提拉加德城堡",
	["Tirisfal Glades"] = "提里斯法林地",
	["Tirth's Haunt"] = "提爾斯鬼屋",
	["Tkashi Ruins"] = "伽什廢墟",
	["Tol Barad"] = "托巴拉德",
	["Tol Barad Peninsula"] = "托巴拉德半島",
	["Tol'Vir Arena"] = "托維爾競技場",
	["Tol'viron Arena"] = "托維恩競技場",
	["Tol'Viron Arena"] = "托維恩競技場",
	["Tomb of Conquerors"] = "征服者之墓",
	["Tomb of Lights"] = "聖光之墓",
	["Tomb of Secrets"] = "秘密之墓",
	["Tomb of Shadows"] = "暗影之墓",
	["Tomb of the Ancients"] = "先祖陵寢",
	["Tomb of the Earthrager"] = "地怒者之墓",
	["Tomb of the Lost Kings"] = "逝王陵墓",
	["Tomb of the Sun King"] = "太陽之王陵墓",
	["Tomb of the Watchers"] = "看守者之墓",
	["Tombs of the Precursors"] = "先驅者之墓",
	["Tome of the Unrepentant"] = "無悔者之書",
	["Tome of the Unrepentant "] = "無悔者之書",
	["Tor'kren Farm"] = "托克雷農場",
	["Torp's Farm"] = "托普的農場",
	["Torseg's Rest"] = "托賽格安息地",
	["Tor'Watha"] = "托爾瓦薩",
	["Toryl Estate"] = "托爾莊園",
	["Toshley's Station"] = "托斯利基地",
	["To the Skies!"] = "飛上天吧!",
	["To The Skies!"] = "飛上天吧!",
	["Tower of Althalaxx"] = "奧薩拉克斯之塔",
	["Tower of Azora"] = "阿祖拉之塔",
	["Tower of Eldara"] = "艾達拉之塔",
	["Tower of Estulan"] = "艾斯圖蘭之塔",
	["Tower of Ilgalar"] = "伊爾加拉之塔",
	["Tower of the Damned"] = "詛咒神教之塔",
	["Tower Point"] = "哨塔高地",
	["Tower Watch"] = "警戒塔",
	["Town-In-A-Box"] = "盒中鎮",
	["Townlong Steppes"] = "螳螂荒原",
	["Town Square"] = "小鎮廣場",
	["Trade District"] = "貿易區",
	["Trade Quarter"] = "貿易區",
	["Trader's Tier"] = "貿易區",
	["Tradesmen's Terrace"] = "貿易區",
	["Train Depot"] = "地鐵站",
	["Training Grounds"] = "訓練場",
	["Training Quarters"] = "鍛鍊之間",
	["Traitor's Cove"] = "背叛者海灣",
	["Tranquil Coast"] = "寧靜海岸",
	["Tranquil Gardens Cemetery"] = "靜謐花園墓場",
	["Tranquil Grotto"] = "寧靜窟",
	Tranquillien = "安寧地",
	["Tranquil Shore"] = "寧靜海岸",
	["Tranquil Wash"] = "寧靜港灣",
	Transborea = "越風之地",
	["Transitus Shield"] = "隘境之盾",
	["Transport: Alliance Gunship"] = "傳送:聯盟砲艇",
	["Transport: Alliance Gunship (IGB)"] = "傳送:聯盟砲艇(IGB)",
	["Transport: Horde Gunship"] = "傳送:部落砲艇",
	["Transport: Horde Gunship (IGB)"] = "傳送:部落砲艇(IGB)",
	["Transport: Onyxia/Nefarian Elevator"] = "傳送: 奧妮克希亞/奈法利安升降梯",
	["Trasnport: The Mighty Wind (Icecrown Citadel Raid)"] = "傳送:強風號(冰冠城塞團隊)",
	["Trelleum Mine"] = "崔爾曼礦坑",
	["Trial of Fire"] = "火之試煉",
	["Trial of Frost"] = "霜之試煉",
	["Trial of Shadow"] = "暗影試煉",
	["Trial of the Champion"] = "勇士試煉",
	["Trial of the Champion Entrance"] = "勇士試煉入口",
	["Trial of the Crusader"] = "十字軍試煉",
	["Trickling Passage"] = "涓流通道",
	["Trogma's Claim"] = "索格瑪領土",
	["Trollbane Hall"] = "托爾貝恩大廳",
	["Troll War Camp Outskirts"] = "食人妖戰營外圍 ",
	["Trophy Hall"] = "勝利紀念大廳",
	["Troves of the Thunder King"] = "雷王的珍寶",
	["Trueshot Point"] = "強擊崗哨",
	["Tuluman's Landing"] = "吐魯曼平臺",
	["Turtle Beach"] = "海龜海灘",
	["Tu Shen Burial Ground"] = "土神墓穴",
	Tuurem = "杜瑞",
	["Twilight Aerie"] = "暮光高巢",
	["Twilight Altar of Storms"] = "暮光暴風祭壇",
	["Twilight Base Camp"] = "暮光營地",
	["Twilight Bulwark"] = "暮光壁壘",
	["Twilight Camp"] = "暮光營地",
	["Twilight Command Post"] = "暮光指揮站",
	["Twilight Crossing"] = "暮光路口",
	["Twilight Forge"] = "暮光熔爐",
	["Twilight Grove"] = "暮光森林",
	["Twilight Highlands"] = "暮光高地",
	["Twilight Highlands Dragonmaw Phase"] = "暮光高地龍喉階段",
	["Twilight Highlands Phased Entrance"] = "暮光高地定相入口",
	["Twilight Highlands Zeppelin 1"] = "暮光高地飛艇 1",
	["Twilight Highlands Zeppelin 2"] = "暮光高地飛艇 2",
	["Twilight Outpost"] = "暮光前哨站",
	["Twilight Overlook"] = "暮光瞰臺",
	["Twilight Post"] = "暮光崗哨",
	["Twilight Precipice"] = "暮光絕壁",
	["Twilight Shore"] = "暮光海岸",
	["Twilight's Run"] = "暮光小徑",
	["Twilight Terrace"] = "暮光殿堂",
	["Twilight Vale"] = "暮光谷",
	["Twinbraid's Patrol"] = "塔文布萊德巡防地",
	["Twin Peaks"] = "雙子峰",
	["Twin Shores"] = "雙水之濱",
	["Twinspire Keep"] = "雙石要塞",
	["Twinspire Keep Interior"] = "雙石要塞內部",
	["Twin Spire Ruins"] = "雙塔廢墟",
	["Twisting Nether"] = "扭曲虛空",
	["Tyr's Hand"] = "提爾之手",
	["Tyr's Hand Abbey"] = "提爾之手修道院",
	["Tyr's Terrace"] = "提爾露臺",
	["Ufrang's Hall"] = "烏弗蘭大廳",
	Uldaman = "奧達曼",
	["Uldaman Entrance"] = "奧達曼",
	Uldis = "奧迪斯",
	Ulduar = "奧杜亞",
	["Ulduar Raid - Interior - Insertion Point"] = "奧杜亞團隊 - 內部 - 嵌入點",
	["Ulduar Raid - Iron Concourse"] = "奧杜亞團隊 - 鐵之集合場",
	Uldum = "奧丹姆",
	["Uldum Phased Entrance"] = "奧丹姆定相入口",
	["Uldum Phase Oasis"] = "奧丹姆階段綠洲",
	["Uldum - Phase Wrecked Camp"] = "奧丹姆 - 被破壞的營帳階段",
	["Umbrafen Lake"] = "昂布拉凡湖",
	["Umbrafen Village"] = "昂布拉凡村",
	["Uncharted Sea"] = "未知海域",
	Undercity = "幽暗城",
	["Underlight Canyon"] = "光底峽谷",
	["Underlight Mines"] = "光底礦坑",
	["Unearthed Grounds"] = "掘出的遺址",
	["Unga Ingoo"] = "仰加印古",
	["Un'Goro Crater"] = "安戈洛環形山",
	["Unu'pe"] = "昂紐沛",
	["Unyielding Garrison"] = "不屈要塞",
	["Upper Silvermarsh"] = "銀之沼澤上層",
	["Upper Sumprushes"] = "泥沼高地",
	["Upper Veil Shil'ak"] = "迷霧希拉克上層",
	["Ursoc's Den"] = "厄索克之穴",
	Ursolan = "厄索蘭",
	["Utgarde Catacombs"] = "俄特加德墓窖",
	["Utgarde Keep"] = "俄特加德要塞",
	["Utgarde Keep Entrance"] = "俄特加德要塞入口",
	["Utgarde Pinnacle"] = "俄特加德之巔",
	["Utgarde Pinnacle Entrance"] = "俄特加德之巔入口",
	["Uther's Tomb"] = "烏瑟之墓",
	["Valaar's Berth"] = "瓦拉船台",
	["Vale of Eternal Blossoms"] = "恆春谷",
	["Valgan's Field"] = "瓦爾甘牧場",
	Valgarde = "瓦爾加德",
	["Valgarde Port"] = "瓦爾加德港口",
	Valhalas = "英靈殿",
	["Valiance Keep"] = "驍勇要塞",
	["Valiance Landing Camp"] = "驍勇臺地營地",
	["Valiant Rest"] = "驍士之眠",
	Valkyrion = "華爾基倫",
	["Valley of Ancient Winters"] = "遠古寒冬山谷",
	["Valley of Ashes"] = "灰燼谷",
	["Valley of Bones"] = "白骨之谷",
	["Valley of Echoes"] = "回聲山谷",
	["Valley of Emperors"] = "帝王谷",
	["Valley of Fangs"] = "巨牙谷",
	["Valley of Heroes"] = "英雄谷",
	["Valley Of Heroes"] = "英雄谷",
	["Valley of Honor"] = "榮譽谷",
	["Valley of Kings"] = "國王谷",
	["Valley of Power"] = "異能山谷",
	["Valley Of Power - Scenario"] = "異能山谷 - 事件",
	["Valley of Spears"] = "長矛谷",
	["Valley of Spirits"] = "精神谷",
	["Valley of Strength"] = "力量谷",
	["Valley of the Bloodfuries"] = "血怒峽谷",
	["Valley of the Four Winds"] = "四風峽",
	["Valley of the Watchers"] = "守衛之谷",
	["Valley of Trials"] = "試煉谷",
	["Valley of Wisdom"] = "智慧谷",
	Valormok = "瓦羅莫克",
	["Valor's Edge"] = "勇氣之鋒",
	["Valor's Rest"] = "勇士之墓",
	["Valorwind Lake"] = "瓦羅溫湖",
	["Vanguard Infirmary"] = "先鋒醫護站",
	["Vanndir Encampment"] = "范迪爾營地",
	["Vargoth's Retreat"] = "瓦戈斯居所",
	["Vashj'elan Spawning Pool"] = "瓦許伊蘭孵化池",
	["Vashj'ir"] = "瓦許伊爾",
	["Vashj'ir Sub - Alliance"] = "瓦許伊爾子區域 - 聯盟",
	["Vashj'ir Sub - Alliance circling Abyssal Maw"] = "瓦許伊爾 - 聯盟 - 深淵之喉附近",
	["Vashj'ir Sub - Horde"] = "瓦許伊爾子區域 - 部落",
	["Vashj'ir Sub - Horde - Circling Abyssal Maw"] = "瓦許伊爾 - 部落 - 深淵之喉附近",
	["Vault of Archavon"] = "亞夏梵穹殿",
	["Vault of Ironforge"] = "鐵爐堡銀行",
	["Vault of Kings Past"] = "古代諸王墓穴",
	["Vault of the Ravenian"] = "拉文尼亞之廳",
	["Vault of the Shadowflame"] = "暗影之焰穹殿",
	["Vault of Y'Shaarj"] = "亞煞拉懼穹殿",
	["Veil Ala'rak"] = "迷霧亞拉芮克",
	["Veil Harr'ik"] = "迷霧哈瑞克",
	["Veil Lashh"] = "迷霧拉斯",
	["Veil Lithic"] = "迷霧里斯克",
	["Veil Reskk"] = "迷霧瑞斯克",
	["Veil Rhaze"] = "迷霧瑞漢茲",
	["Veil Ruuan"] = "迷霧魯安",
	["Veil Sethekk"] = "迷霧塞司克",
	["Veil Shalas"] = "迷霧撒拉斯",
	["Veil Shienor"] = "迷霧辛諾",
	["Veil Skith"] = "迷霧斯奇司",
	["Veil Vekh"] = "迷霧維克",
	["Vekhaar Stand"] = "維克哈爾看臺",
	["Velaani's Arcane Goods"] = "瓦拉尼的秘法物品",
	["Vendetta Point"] = "血仇崗哨",
	["Vengeance Landing"] = "復仇臺地",
	["Vengeance Landing Inn"] = "復仇臺地旅店",
	["Vengeance Landing Inn, Howling Fjord"] = "復仇臺地旅店，凜風峽灣",
	["Vengeance Lift"] = "復仇升降梯",
	["Vengeance Pass"] = "復仇隘口",
	["Vengeance Wake"] = "復仇之醒",
	["Venomous Ledge"] = "毒蛇岩礁",
	Venomspite = "毒怨之地",
	["Venomsting Pits"] = "毒針之坑",
	["Venomweb Vale"] = "毒蛛峽谷",
	["Venture Bay"] = "風險海灣",
	["Venture Co. Base Camp"] = "風險投資公司營地",
	["Venture Co. Operations Center"] = "風險投資公司工作中心",
	["Verdant Belt"] = "蒼翠牧場",
	["Verdant Highlands"] = "青草高原",
	["Verdantis River"] = "沃丹提斯河",
	["Veridian Point"] = "翠綠崗哨",
	["Verlok Stand"] = "維洛克看臺",
	["Vermillion Redoubt"] = "朱紅壁壘",
	["Verming Tunnels Micro"] = "兔妖隧道微型",
	["Verrall Delta"] = "維羅河三角洲",
	["Verrall River"] = "維羅河",
	["Victor's Point"] = "勝利者崗哨",
	["Vileprey Village"] = "鄙掠村",
	["Vim'gol's Circle"] = "梵戈之環",
	["Vindicator's Rest"] = "復仇者之陵",
	["Violet Citadel Balcony"] = "紫羅蘭城塞露台",
	["Violet Hold"] = "紫羅蘭堡",
	["Violet Hold Entrance"] = "紫羅蘭堡入口",
	["Violet Rise"] = "紫羅蘭高崗",
	["Violet Stand"] = "紫羅蘭看臺",
	["Virmen Grotto"] = "兔妖岩洞",
	["Virmen Nest"] = "兔妖之巢",
	["Vir'naal Dam"] = "維爾納爾水壩",
	["Vir'naal Lake"] = "維爾納爾湖",
	["Vir'naal Oasis"] = "維爾納爾綠洲",
	["Vir'naal River"] = "維爾納爾河",
	["Vir'naal River Delta"] = "維爾納爾三角洲",
	["Void Ridge"] = "虛無之脊",
	["Voidwind Plateau"] = "裂風高原",
	["Volcanoth's Lair"] = "火岩諾斯的巢穴",
	["Voldrin's Hold"] = "佛德林堡號",
	Voldrune = "沃德盧恩",
	["Voldrune Dwelling"] = "沃德盧恩居所",
	Voltarus = "沃塔魯斯",
	["Vordrassil Pass"] = "沃達希爾小徑",
	["Vordrassil's Heart"] = "沃達希爾之心",
	["Vordrassil's Limb"] = "沃達希爾之枝",
	["Vordrassil's Tears"] = "沃達希爾之淚",
	["Vortex Pinnacle"] = "漩渦尖塔",
	["Vortex Summit"] = "漩渦之巔",
	["Vul'Gol Ogre Mound"] = "沃古爾巨魔山",
	["Vyletongue Seat"] = "維利塔恩之座",
	["Wahl Cottage"] = "瓦爾小屋",
	["Wailing Caverns"] = "哀嚎洞穴",
	["Walk of Elders"] = "長者步道",
	["Warbringer's Ring"] = "戰爭使者的競技場",
	["Warchief's Lookout"] = "大酋長守望",
	["Warden's Cage"] = "典獄官監牢",
	["Warden's Chambers"] = "衛兵之間",
	["Warden's Vigil"] = "看守者崗哨",
	["Warlock Area"] = "術士區域",
	["Warmaul Hill"] = "戰槌山丘",
	["Warpwood Quarter"] = "扭木廣場",
	["War Quarter"] = "軍事區",
	["Warrior's Terrace"] = "戰士區",
	["War Room"] = "指揮室",
	Warship = "戰艦",
	["Warsong Camp"] = "戰歌營地",
	["Warsong Farms Outpost"] = "戰歌農場前哨",
	["Warsong Flag Room"] = "戰歌戰旗廳",
	["Warsong Granary"] = "戰歌穀倉",
	["Warsong Gulch"] = "戰歌峽谷",
	["Warsong Hold"] = "戰歌堡",
	["Warsong Jetty"] = "戰歌碼頭",
	["Warsong Labor Camp"] = "戰歌勞工營地",
	["Warsong Lumber Camp"] = "戰歌伐木營地",
	["Warsong Lumber Mill"] = "戰歌伐木場",
	["Warsong Slaughterhouse"] = "戰歌屠宰場",
	["Watcher's Sanctum"] = "看守者聖所",
	["Watchers' Terrace"] = "守衛露臺",
	["Waterspeaker's Sanctuary"] = "水語者聖堂",
	["Waterspring Field"] = "清泉平原",
	Waterworks = "供水設備",
	["Wavestrider Beach"] = "破浪海灘",
	Waxwood = "蠟林",
	["Wayfarer's Rest"] = "旅人休憩",
	Waygate = "甬道之門",
	["Wayne's Refuge"] = "韋恩的避難所",
	["Weazel's Crater"] = "維吉爾之坑",
	["Webwinder Hollow"] = "蛛網谷",
	["Webwinder Path"] = "蛛網小徑",
	["Weeping Quarry"] = "哀泣礦場",
	["Well of Eternity"] = "永恆之井",
	["Well of the Forgotten"] = "遺忘之井",
	["Wellson Shipyard"] = "維爾森船廠",
	["Wellspring Hovel"] = "湧泉屋舍",
	["Wellspring Lake"] = "湧泉湖",
	["Wellspring River"] = "湧泉河",
	["Westbrook Garrison"] = "西泉要塞",
	["Western Bridge"] = "西部橋樑",
	["Western Plaguelands"] = "西瘟疫之地",
	["Western Strand"] = "西部海岸",
	Westersea = "西方之海",
	Westfall = "西部荒野",
	["Westfall Brigade"] = "西荒兵團",
	["Westfall Brigade Encampment"] = "西荒兵團駐營",
	["Westfall Lighthouse"] = "西部荒野燈塔",
	["West Garrison"] = "西部兵營",
	["Westguard Inn"] = "鎮西旅店",
	["Westguard Keep"] = "鎮西要塞",
	["Westguard Turret"] = "鎮西砲塔",
	["West Pavilion"] = "西亭閣",
	["West Pillar"] = "西部石柱",
	["West Point Station"] = "西點抽水站",
	["West Point Tower"] = "西點哨塔",
	["Westreach Summit"] = "西聯峰",
	["West Sanctum"] = "西部聖所",
	["Westspark Workshop"] = "西炫工坊",
	["West Spear Tower"] = "西矛哨塔",
	["West Spire"] = "西部尖塔",
	["Westwind Lift"] = "西風升降梯",
	["Westwind Refugee Camp"] = "西風難民營",
	["Westwind Rest"] = "西風之眠",
	Wetlands = "濕地",
	Wheelhouse = "駕駛室",
	["Whelgar's Excavation Site"] = "維爾加挖掘場",
	["Whelgar's Retreat"] = "維爾加的避難所",
	["Whispercloud Rise"] = "雲語高地",
	["Whisper Gulch"] = "低語峽谷",
	["Whispering Forest"] = "低語森林",
	["Whispering Gardens"] = "耳語花園",
	["Whispering Inlet"] = "低語水灣",
	["Whispering Shore"] = "耳語海岸",
	["Whispering Stones"] = "低語石",
	["Whisperwind Grove"] = "語風林地",
	["Whistling Grove"] = "哨嘯樹林",
	["Whitebeard's Encampment"] = "白鬚營地",
	["Whitepetal Lake"] = "白瓣湖",
	["White Pine Trading Post"] = "白松貿易站",
	["Whitereach Post"] = "白沙崗哨",
	["Wildbend River"] = "急彎河",
	["Wildervar Mine"] = "威德瓦礦坑",
	["Wildflame Point"] = "野火哨點",
	["Wildgrowth Mangal"] = "叢生沼林",
	["Wildhammer Flag Room"] = "蠻錘戰旗廳",
	["Wildhammer Keep"] = "蠻錘城堡",
	["Wildhammer Stronghold"] = "蠻錘要塞",
	["Wildheart Point"] = "野性之心營地",
	["Wildmane Water Well"] = "蠻鬃水井",
	["Wild Overlook"] = "野生眺望",
	["Wildpaw Cavern"] = "蠻爪洞穴",
	["Wildpaw Ridge"] = "蠻爪嶺",
	["Wilds' Edge Inn"] = "野性之界客棧",
	["Wild Shore"] = "蠻荒海岸",
	["Wildvine Marsh"] = "野藤沼澤",
	["Wildwind Lake"] = "狂風湖",
	["Wildwind Path"] = "狂風小徑",
	["Wildwind Peak"] = "狂風山尖",
	["Windbreak Canyon"] = "風裂峽谷",
	["Windfury Ridge"] = "狂風山",
	["Windrunner's Overlook"] = "風行者瞰臺",
	["Windrunner Spire"] = "風行者塔",
	["Windrunner Village"] = "風行者村",
	["Winds' Edge"] = "風之緣",
	["Windshear Crag"] = "狂風峭壁",
	["Windshear Heights"] = "狂風陵地",
	["Windshear Hold"] = "狂風堡",
	["Windshear Mine"] = "狂風礦坑",
	["Windshear Valley"] = "狂風谷",
	["Windspire Bridge"] = "風旋橋",
	["Windward Isle"] = "嘯風島",
	["Windy Bluffs"] = "群風崖",
	["Windyreed Pass"] = "風蘆小徑",
	["Windyreed Village"] = "風蘆村",
	["Winterax Hold"] = "冰斧要塞",
	["Winterbough Glade"] = "冬枝林地",
	["Winterfall Village"] = "寒水村",
	["Winterfin Caverns"] = "冬鰭洞窟",
	["Winterfin Retreat"] = "冬鰭避居地",
	["Winterfin Village"] = "冬鰭村",
	["Wintergarde Crypt"] = "溫特加德墓穴",
	["Wintergarde Keep"] = "溫特加德要塞",
	["Wintergarde Mausoleum"] = "溫特加德墓塚",
	["Wintergarde Mine"] = "溫特加德礦坑",
	Wintergrasp = "冬握湖",
	["Wintergrasp Fortress"] = "冬握堡壘",
	["Wintergrasp River"] = "冬握河",
	["Winterhoof Water Well"] = "冬蹄水井",
	["Winter's Blossom"] = "冬綻",
	["Winter's Breath Lake"] = "冬息湖",
	["Winter's Edge Tower"] = "冬際哨塔",
	["Winter's Heart"] = "寒冬之心",
	Winterspring = "冬泉谷",
	["Winter's Terrace"] = "冬之殿堂",
	["Witch Hill"] = "女巫嶺",
	["Witch's Sanctum"] = "女巫聖所",
	["Witherbark Caverns"] = "枯木洞穴",
	["Witherbark Village"] = "枯木村",
	["Withering Thicket"] = "枯萎灌木林",
	["Wizard Row"] = "巫師街",
	["Wizard's Sanctum"] = "巫師聖所",
	["Wolf's Run"] = "狼之小徑",
	["Woodpaw Den"] = "木爪巢穴",
	["Woodpaw Hills"] = "木爪嶺",
	["Wood's End Cabin"] = "林終小屋",
	["Woods of the Lost"] = "迷失者之林",
	Workshop = "工坊",
	["Workshop Entrance"] = "工作室入口",
	["World's End Tavern"] = "世界的盡頭小酒館",
	["Wrathscale Lair"] = "怒鱗巢穴",
	["Wrathscale Point"] = "怒鱗崗哨",
	["Wreckage of the Silver Dawning"] = "銀色清晨號沉沒之地",
	["Wreck of Hellscream's Fist"] = "地獄吼之拳殘骸",
	["Wreck of the Mist-Hopper"] = "躍霧者的殘骸",
	["Wreck of the Skyseeker"] = "尋天號的殘骸",
	["Wreck of the Vanguard"] = "先鋒號殘骸",
	["Writhing Mound"] = "苦痛山丘",
	Writhingwood = "扭曲之木",
	["Wu-Song Village"] = "武松村",
	Wyrmbog = "巨龍泥沼",
	["Wyrmbreaker's Rookery"] = "破龍者的孵化間",
	["Wyrmrest Summit"] = "龍眠議會",
	["Wyrmrest Temple"] = "龍眠神殿",
	["Wyrmrest Temple - bottom to middle"] = "龍眠神殿 - 下層到中層",
	["Wyrmrest Temple - bottom to top"] = "龍眠神殿 - 下層到上層",
	["Wyrmrest Temple - middle to bottom"] = "龍眠神殿 - 中層到下層",
	["Wyrmrest Temple - middle to top"] = "龍眠神殿 - 中層到上層",
	["Wyrmrest Temple - top to bottom"] = "龍眠神殿 - 上層到下層",
	["Wyrmrest Temple - top to middle"] = "龍眠神殿 - 上層到中層",
	["Wyrms' Bend"] = "巨龍之彎",
	["Wyrmscar Island"] = "龍痕島",
	["Wyrmskull Bridge"] = "龍骨橋",
	["Wyrmskull Tunnel"] = "龍骨隧道",
	["Wyrmskull Village"] = "龍顱村",
	["X-2 Pincer"] = "X-2鉗手號",
	Xavian = "薩維亞",
	["Yan-Zhe River"] = "延哲河",
	["Yeti Mountain Basecamp"] = "雪人山營地",
	["Yinying Village"] = "陰影村",
	Ymirheim = "依米海姆",
	["Ymiron's Seat"] = "依米倫之座",
	["Yojamba Isle"] = "尤亞姆巴島",
	["Yowler's Den"] = "猶勒的巢穴",
	["Zabra'jin"] = "薩布拉金",
	["Zaetar's Choice"] = "札爾塔的選擇",
	["Zaetar's Grave"] = "札爾塔之墓",
	["Zalashji's Den"] = "薩拉辛之穴",
	["Zalazane's Fall"] = "札拉贊恩之殞",
	["Zane's Eye Crater"] = "贊恩之眼",
	Zangarmarsh = "贊格沼澤",
	["Zangar Ridge"] = "贊格山脊",
	["Zan'vess"] = "贊斐斯",
	["Za'Tual"] = "札突爾",
	["Zeb'Halak"] = "札布哈拉克",
	["Zeb'Nowa"] = "札布諾瓦",
	["Zeb'Sora"] = "札布索拉",
	["Zeb'Tela"] = "札布泰拉",
	["Zeb'tula"] = "札布圖拉",
	["Zeb'Watha"] = "拉伯瓦薩",
	["Zeppelin Crash"] = "飛艇失事地",
	Zeramas = "賽拉瑪斯",
	["Zeth'Gor"] = "薩斯葛爾",
	["Zhu Province"] = "祝家界",
	["Zhu's Descent"] = "祝家坡",
	["Zhu's Watch"] = "祝家守望站",
	["Ziata'jai Ruins"] = "贊塔加廢墟",
	["Zim'Abwa"] = "辛阿布瓦",
	["Zim'bo's Hideout"] = "辛波的藏身所",
	["Zim'Rhuk"] = "辛茹克",
	["Zim'Torga"] = "辛托加",
	["Zol'Heb"] = "佐爾希伯",
	["Zol'Maz Stronghold"] = "佐爾馬茲堡砦",
	["Zoram'gar Outpost"] = "佐拉姆加前哨站",
	["Zouchin Province"] = "驟晴縣",
	["Zouchin Strand"] = "驟晴海岸",
	["Zouchin Village"] = "驟晴村",
	["Zul'Aman"] = "祖阿曼",
	["Zul'Drak"] = "祖爾德拉克",
	["Zul'Farrak"] = "祖爾法拉克",
	["Zul'Farrak Entrance"] = "祖爾法拉克入口",
	["Zul'Gurub"] = "祖爾格拉布",
	["Zul'Mashar"] = "祖爾瑪夏",
	["Zun'watha"] = "祖瓦沙",
	["Zuuldaia Ruins"] = "祖丹亞廢墟",
}

else
	error(("%s: Locale %q not supported"):format(MAJOR_VERSION, GAME_LOCALE))
end
